/**
 * 程序入口配置读取
 * 项目开发时需要的自定义配置
 */
/**
 * 存放对 hsea 的 config，需在 zepto 之后 hsea 之前加载
 *
 * 2016-4-12 10:15:09
 */
define(function(require, exports, module) {
	$.config = {
	    // 路由功能开关过滤器，返回 false 表示当前点击链接不使用路由
	    routerFilter: function($link) {
	        // 某个区域的 a 链接不想使用路由功能
	        if ($link.is('.disable-router a')) {
	            return false;
	        }

	        return true;
	    },
	    /*
	     * 配置默认document.titles标题
	     */
	    documentTitle: "股票交易",
	    /**
		 * hSea根路径，项目中的文件uri最终会在项目访问的web路径后添加
		 */
	    seaBaseUrl: "/m/",
		//项目名，默认为project
		projName: "trade", //一般为“project”，对应的项目目录名字
		//项目的css目录
		cssPathName: "css",
		//项目的images目录
		imagesPathName: "images",
		//项目的scripts目录
		scriptsPathName: "scripts",
		//项目的views目录
		viewsPathName: "views",
		//壳子文件scripts文件路径
		shellScriptPath: "/shellFunction/msgFunction.js",
		//默认点击事件
		triggerEventName: "tap",
		/**
		 * 后端接口返回过滤
		 */
		executeFilter: {
	    	executeFilterFunc: function(data)
	    	{
				// data.error_no = '-999';
	    		if(data.error_no == '-999' || data.errorNo == '-999' || data.error_no == '-919')//未登录
	    		{
	    			require.async("common",function(module){
					 	module.filterLoginOut();
			        });
	    			return false;
	    		}else
	    		{
//					data.error_no = -1;

					// data.results = [{}];
					//
					// if(data.results){
					// 	results = data.results[0];
					// 	if(results){
					// 		for(var i = 0; i < 20; i++){
					// 			data.results = data.results.concat(results);
					// 		}
					// 	}
					// }

	    			return true;
	    		}

	    	}
		},
		//引导页
		guidePage: {"pageCode": "", "jsonParam":{}},
		//项目中公用模块的别名配置(根目录为seaBaseUrl)
		pAlias: {
			"hIscroll": "2.0.0/js/plugins/iscroll/scripts/hIscroll.js",
			"vIscroll": "2.0.0/js/plugins/iscroll/scripts/vIscroll.js",
			"svIscroll": "2.0.0/js/plugins/iscroll/scripts/svIscroll.js",
			"iscroll5": "2.0.0/js/plugins/iscroll5/scripts/iscroll5.js",// iscroll5上下拉刷新
			"iscrollUtils": "2.0.0/js/plugins/iscroll5/scripts/iscrollUtils.js",
			"mobiscrollUtils": "2.0.0/js/plugins/mobiscroll/scripts/mobiscrollUtils.js",
			"aes":"2.0.0/js/plugins/endecrypt/scripts/aes.js",
			"des":"2.0.0/js/plugins/endecrypt/scripts/des.js",
			"dayjs":"2.0.0/lib/dayjs.min.js",
			"base64":"2.0.0/js/plugins/endecrypt/scripts/base64.js",
			"rsa":"2.0.0/js/plugins/endecrypt/scripts/rsa.js",
			"ssoUtils":"2.0.0/js/plugins/sso/scripts/ssoUtils.js",
			"md5": "2.0.0/js/plugins/endecrypt/scripts/md5.js",
			"endecryptUtils":"2.0.0/js/plugins/endecrypt/scripts/endecryptUtils.js",
			"validatorUtils": "2.0.0/js/plugins/validator/scripts/validatorUtils.js",
			"keyPanel": "2.0.0/js/plugins/keypanel/scripts/keyPanel.js",
			"com":"trade/scripts/common/com.js", //首次加载方法
			"tradeSso": "trade/scripts/common/tradeSso.js", //统一账号的方法
			"tradeSsoLogin": "trade/scripts/common/tradeSsoLogin.js", //统一账号的方法
			"common":"trade/scripts/common/common.js", //交易工具公共方法
			"keyboard":"trade/scripts/common/keyboard.js",
			"keyboardCredit":"trade/scripts/common/keyboardCredit.js",
			"keyboard1":"trade/scripts/option/keyboard1.js",
			"keyboardUtils": "trade/scripts/common/keyboardUtils.js",
//			"service":"trade/service/scripts/base/service.js",
			"zeptoExtend":"trade/scripts/common/zeptoExtend.js",
			"commonFunc":"trade/scripts/common/commonFunc.js", //交易业务公共方法
			"commonOrder":"trade/scripts/common/commonOrder.js", //下单公共方法
			"sockOrder":"trade/scripts/common/sockOrder.js", //普通交易下单公共方法
			"ggtOrder":'trade/scripts/common/ggtOrder.js',// 港股通下单公共方法
			"creditOrder":"trade/scripts/common/creditOrder.js", //融资融券下单公共方法
			"bjsOrder":"trade/scripts/bjs/bjsOrder.js", //北交所下单公共方法
			"bondOrder":"trade/scripts/bond/order/bondOrder.js", //债券现券下单公共方法
			"blockOrder":"trade/scripts/blockTrade/blockOrder.js", //大宗交易下单公共方法
			"bjsBlockOrder":"trade/scripts/blockTrade/bjsBlockTrade/bjsBlockOrder.js", //北交所大宗交易下单公共方法
			"consultOrder":"trade/scripts/bond/order/consultOrder.js", //债券现券协商成交下单公共方法
			"bjsConsultOrder":"trade/scripts/bond/order/bjsConsultOrder.js", //北交所债券现券协商成交下单公共方法
			"optionOrder": "trade/scripts/common/optionOrder.js",
			"fundInsidePurchase":"trade/scripts/common/fundInsidePurchase.js",
			"fundInsideRedeem":"trade/scripts/common/fundInsideRedeem.js",
			"nativePluginService": "trade/shellFunction/nativePluginService.js",
			"msgFunction": "trade/shellFunction/msgFunction.js",
			"service":"trade/service/scripts/trade/service.js",
			"service_sso":"trade/service/scripts/trade/service_sso.js",
			"service_common":"trade/service/scripts/trade/service_common.js",
			"service_stock":"trade/service/scripts/trade/service_stock.js",
			"service_hq":"trade/service/scripts/trade/service_hq.js",
			"service_ysyy":"trade/service/scripts/trade/service_ysyy.js",
			"service_fund":"trade/service/scripts/trade/service_fund.js",
			"service_fundETF": "trade/service/scripts/trade/service_fundETF.js",//ETF基金的接口方法
			"service_option": "trade/service/scripts/trade/service_option.js",//股票期权的接口方法
			"service_ggt":"trade/service/scripts/trade/service_ggt.js",
			"service_otc":"trade/service/scripts/trade/service_otc.js",
			"service_credit":"trade/service/scripts/trade/service_credit.js",
			"service_added":"trade/service/scripts/trade/service_added.js",
			"appropriate":"trade/scripts/account/appropriate.js",
			"service_appropr":"trade/service/scripts/trade/service_appropr.js",
			"service_third":"trade/service/scripts/trade/service_third.js",
			"service_native_sync":"trade/service/scripts/trade/service_native_sync.js",
			"service_hqTrade":"trade/service/scripts/trade/service_hqTrade.js",
			"service_zhyw":"trade/service/scripts/trade/service_zhyw.js",
			"service_xkj":"trade/service/scripts/trade/service_xkj.js",

			"service_gemAfter": "trade/service/scripts/trade/service_gemAfter.js", //创业板盘后的接口方法
			"gemStockOrder": "trade/scripts/gemAfter/gemStockOrder.js", //创业板盘后下单公共方法

			"publicCancel": "trade/scripts/common/publicCancel.js",//公共的撤单方法
			"publicCancel2": "trade/scripts/common/publicCancel2.js",
			"publicQuery": "trade/scripts/common/publicQuery.js",
			"publicQuery2": "trade/scripts/common/publicQuery2.js",
			//交易业务公共方法
			"commonHq": "trade/scripts/common/commonHq.js", //行情交易接口公共方法
			"commonTimer": "trade/scripts/common/commonTimer.js",
			"downslide": "trade/scripts/common/downslide.js",
			"thirdOrder": "trade/scripts/third/thirdOrder.js",
			"limitPriceOrder": "trade/scripts/third/limitPriceOrder.js", //股转限价下单逻辑
			"agreementOrder": "trade/scripts/bjs/order/agreementOrder.js", //北交所大宗交易下单公共方法
			"thirdAgreementOrder": "trade/scripts/third/agreementOrder.js", //股转大宗交易下单公共方法
			"service_debt": "trade/service/scripts/trade/service_debt.js",//可转债配售等的接口方法

			"cdrProtocolSign": "trade/scripts/common/cdrProtocolSign.js",
			//期权行情图
			"canvasJs": "trade/scripts/hq/chart/canvas.js",
			"hqCommon": "trade/scripts/hq/chart/hqCommon.js",
			"minLines": "trade/scripts/hq/chart/minLines.js",
			"chartservice_hq": "trade/scripts/hq/chart/service_hq.js",

			"kcbStockOrder": "trade/scripts/kcb/kcbStockOrder.js", //普通交易科创板下单公共方法
			"kcbPHStockOrder": "trade/scripts/kcb/kcbPHStockOrder.js", //普通交易科创板下单公共方法
			"service_stockKcb": "trade/service/scripts/trade/service_stockKcb.js", //普通交易科创板的接口方法
			"creditKcbOrder": "trade/scripts/credit/creditKcbOrder.js", //两融科创板下单公共方法
			"service_creditKcb": "trade/service/scripts/trade/service_creditKcb.js", //两融科创板的接口方法
			"publicKcbCancel": "trade/scripts/kcb/com/publicKcbCancel.js",//公共的撤单方法
			"publicKcbQuery": "trade/scripts/kcb/com/publicKcbQuery.js",
			"publicOfferingQuery":"trade/scripts/bjs/publicOffering/publicOfferingQuery.js",
			"noticeToInvestors":"trade/scripts/common/noticeToInvestors.js",
			"indexOption":"trade/scripts/account/indexOption.js",
			"indexCredit":"trade/scripts/account/indexCredit.js",
			"tradeIndex":"trade/scripts/account/index.js",
			"bScroll":"trade/scripts/common/better-scroll.min.js",
			"echarts":"trade/scripts/common/echarts-5.4.1.min.js",
			"etfLineChart":"trade/scripts/fund/etfFund/etfLineChart.js",
			"vBscroll":"trade/scripts/common/vBscroll.js",
            "swiper":"2.0.0/js/plugins/swiper-bundle/swiper-bundle.min.js",
			"indexPort":"trade/scripts/account/indexPort.js",
			"stringUtils": "trade/scripts/common/stringUtils.js",
			"project": "trade/scripts/common/project.js"
		},
		//登录检测(一个模块里面登录只要一个)
		loginCheck: {
			isAsynch: false,//是否异步,默认同步(区别在于如果设置为true，需要等当前异步操作完毕后才会执行后续操作(比如页面跳转))
			//不需要登录需要在这里配置（如果配置在页面，需要拉取页面后才能做判断）页面配置ID
			//pageFilters这里必须写绝对路径，即/开头
		    "pageFilters" : [
				['account/precondition','account/index','account/login',"account/activePhone","shares/oneKeyPurchase","purchaseNewDebt/newPurchase",
				'retrieveAccount/accountShow','retrieveAccount/personalInfo',"third/thirdJurisdiction","account/optionPermissionOpening","account/optionPermissionOpening"
				,"nsb/calendar","nsb/detail","nsb/help","nsb/index","nsb/commonPro","bjs/publicOffering/bidHelp","account/permissionOpening","account/optionPermissionOpening"],[]
		    ], //过滤的pageCode,可以绕过登录
		    "checkFunc" : function(url, noAnimation, replace, reload,param,pagecode,prePageCode,_callback,direct){
		    	//常规登录判断
		    	var a = false;
				var _isLoginIn = $.getSStorageInfo("_isLoginIn");//是否登录的标志
				if(_isLoginIn){
					if(pagecode.indexOf("stock/") == 0){
						if(_isLoginIn.indexOf("_stock") != -1){
							a = true;
						}
					}
					else if(pagecode.indexOf("credit/") == 0){
						if(_isLoginIn.indexOf("_credit") != -1){
							a = true;
						}
					}
					else if(pagecode.indexOf("option/") == 0){
						if(_isLoginIn.indexOf("_option") != -1){
							a = true;
						}
					}
					else if(pagecode.indexOf("financial/") == 0){
						if(_isLoginIn.indexOf("_financial") != -1){
							a = true;
						}
					}
					else{
						a = true;
					}
				}
				if(!a){
					require.async("com",function(module){
					 	module.checkFunc(url, noAnimation, replace, reload,param,pagecode,prePageCode,_callback,direct);
			        });
				}
				return a;

				//异步验证,需要在异步返回后执行callback方法
				/*var urls = $.config.global.server;
				var params = {'version': 1,'funcno': 29999};
				var callback = function(data)
				 {
				 if(data.errorNo == '0')//已结登录
				 {
				 _callback(_prePages,_url, _param,_ignoreCaches);

				 }else{//未登录
				 $.pageInit(null,'./views/login/',param);
				 }

				 }
				$.service.ajax.request(urls, params, $.proxy(callback,this));*/
			}
	   },
		/**
		 * 跳转页面时做的权限校验，提供在外面的方法,每次跳转页面都会先执行此方法
		 * moduleAlias为项目通用模块配置的别名，moduleFuncName方法里面写校验规则，返回true或者false，避免写异步的代码
		 * 不配默认为：{}
		 */
		checkPermission: {"moduleAlias":"com", "moduleFuncName":"checkPermission"},
		/**
		 * 第一次加载第一个业务模块前所需要的处理，即启动之后提供给外界初始化的接口，
		 * 这个方法中避免写异步操作，或者保证异步影响其他代码逻辑
		 * moduleAlias为项目通用模块配置的别名，moduleFuncName为执行的方法
		 * 这个配置可以做很多事情，当你从业务模块逻辑上不好实现时，可以考虑这里！！
		 * 是否异步，默认为true,为异步
		 */
		firstLoadIntf: {"moduleAlias": "com", "moduleFuncName":"firstLoadFunc","isAsynch": true},
		/**
		 * 项目中需要调用到的常量、变量这里配置，调用方式，通过$.config.global.*来调用
		 * 不配默认为：{}
		 */
		global: {
			"HqUrl": "https://up.huajinsc.cn:15040/market/json",   // 华金测试行情环境
			"serverPathTrade": "https://dev-tradehttp.huajinsc.cn:14010/servlet/json",
			"validateimg" : "https://trade.huajinsc.cn:11443/servlet/NewImage",//华金生产交易
		    "unifyUrl" : "https://trade.huajinsc.cn:448/servlet/json",//综合业务，生产：
		    "xkjUrl" : "https://gw.huajinsc.cn/api/servlet/json",//新框架接口地址
            "newshareUrl": "https://up.huajinsc.cn:15040/market/json",//新股列表  生产地址
			"riskAppraisalUrl":"https://wsyyttest.wxzqgs.com:7072/wsyyt/mobile/third/login",
			"jumpHqUrl": "https://info1.thinkive.com:8443/h5/hq-bjs/cloudServer/#/", //行情股转发行等跳转地址


			"nsbUrl_test": "http://119.23.143.58:40008/servlet/json",//新股新债行情资讯接口地址[思迪]
			"nsbGGHQ_test":"http://140.207.41.22:15040/market/json",//新股新债个股行情【思迪】
			"nsbUrl": "https://huajinsc-info.thinkive.com:40300/servlet/json",//新股新债行情资讯接口地址[华金生产]
			"nsbGGHQ":"https://mall.huajinsc.cn:15040/market/json",//新股新债个股行情【华金生产】
			"newFrameUrl":"https://static.huajinsc.cn/",//新框架地址
			"zntjd":"https://zntjd.huajinsc.cn:8443",//智能条件单地址
			"nsb_isProd":true,//新股新债是否是生产 true生产 false 测试

			"serverPath":"", //统一登录地址
            "jsessionid":false,//是否拼接jsessionid
			"logoutTimeNum" : 10,//锁定屏幕设置时间，单位分钟
			"activationTime": 168,//手机激活失效时间，单位小时
			"phoneActivation" : false, // 是否启动手机激活
			"channel": "", // 渠道配置
			"pagingNum": 0, //分页条数
			"refreshType": 4, //下拉刷新的框架类型
			"typeDigit": [0,1,2,7,8,9,14,15,17,18,25,26,64,66],//股票类别显示小数位数 0.01的
			"stockType": [],// 交易行情查询股票类型，为空是所有的类型
			"shareCookie": false, // 登录信息是否共享  true 可以多个页面 ，false 只能在一个页面
			"hqCallInterface": 0, //用调用行情接口，0 行情服务器 1 交易服务器
			"refreshTime": 5000,// 毫秒 五档刷新时间
			"announcementTips": 0, // 登录页面的公告提示  提示内容  0：不提示，1：提示 配置在prompt.txt文件中，2：调用工作平台的提示内容
			"startJSkeyboard": false ,// 是否启用js自绘键盘
			"callNative": true,// 是否调用原生插件
			"isSso":true,
			"syncServerTime": 30,// 多久同步一次服务器时间  单位分钟
			"checkTradeTime": 3,// 检查交易时间，是否是交易时间  单位分钟
			"positionRefreshTime": 3000,//持仓刷新时间，配置0就不刷新  类型数字，单位毫秒
			"indexRefreshTime": 10000,//首页资产刷新时间，配置0就不刷新  类型数字，单位毫秒
			"requestLocation": 1,// 0 是在init发接口请求 1，在load发接口请求
			"isSign": 0,//请求加密模式(0:不加密不加签，1:加签不加密，2：加密不加签，3：加密加签)
			"isTradeSign": 6,//请求加密模式(0:不加密不加签，1:加签不加密，2：加密不加签，3：加密加签 4:Socket加密，5：Socket压缩，6：Socket压缩加密)
			"ssoSignKey": "BDmmrGbedzrcRHI4e2Ri7I6hNPLJ4CHylqlkpoylueqAP/Zs0a4kPfgFscjv3epJdI15U2dlGYOCxrfjru26+A4CZaq3sB0L",
			"encryptKey": "959844D021FD7B2E3B5172BB836DFE6C",
			"encryMode": "des",
			"fileterFuncs":"",
			"entrust_way" : "5",//委托方式
			"serverConfig":"2",   //柜台选择  1.金证win 2.恒生T2 3.顶点 4.金证mid 5.恒生T1
			"loginModule":"",//登录模块名
			"app_object_id":"tk.app.trade",//object模块id
			"app_action_id1":"tk.app.0",//action模块（通用型无业务意义点击）
			"app_action_id2":"tk.app.trade",//action模块id
			"mallUrl":"https://m.huajinsc.cn",//跳转商城的地址
			"ygtUrl":"https://online.huajinsc.cn",//业务办理的地址
			"intelligenceUrl":"http://hjtjd.huajinsc.cn:7071",//人工智能（账单分析）
			"reservationUrl":"http://hjzd.huajinsc.cn:6071",//人工智能（预约打新）
            "f10Url":"https://eksb2d5tn.lightyy.com", //场内基金F10页面
			"account_kcbJurisdiction":true,//科创板是否权限校验
			"stockTimeout":2000//普通交易、股转系统接口请求超时时间
		},
		/**
		 * Android手机返回键处理，退出应用还是返回上级页面，true-退出应用，false-返回页面，默认为true
		 * 如果需要返回上一级页面，并最终提示退出应用，需要改为false，并且在一级页面的html上设置“data-pageLevel="1"”
		 * 不配默认为：true
		 */
		isDirectExit: false,
		/**
		 * ajax请求超时时间设置，默认为20秒之后超时
		 * 不配默认为：20秒
		 *
		 */
		ajaxTimeout: {
			time: 20,
			//请求超时处理方法
			ajaxTimeoutFunc: function(xhr, textStatus, errorMessage){
				$.alert('数据超时了');

			},
			//断网，跨域或者网络请求错误等
			execErrorFunc: function(xhr, textStatus, errorMessage)
			{
				if(textStatus == 'abort')//跨域或者被主动阻断
			    {
			    	$.alert('服务器错误，或者网络异常!');
			    }else{
			    	$.alert('未知错误,请联系开发人员!');
			    }

			}
		},
		/**
		 * 缓存扫描器的扫描间隔时间，单位秒
		 * @time 缓存扫描时间
		 * @cacheFuncNoKey用于缓存功能号保存的key--缓存数据接口会用到
		 * @cacheFuncCallbackKey用于返回参数成功标志位的key--缓存数据接口会用到
		 */
		cacheScanInterval: {
			time:10,
			cacheFuncNoKey:['funcno','funcNo'],
			cacheFuncCallbackKey:['errorNo','error_no']
		},
		/*
		 * 是否启用调试模式，1启用，0不启用
		 * */
		isDebug: 0,
		/*
		 * 是否将http请求转发给原生去发送,0是否，1是，默认为否,如果为是需要原生支持（交易）
		 *
		 **/
		isFordHttpReq: 1,
		/*
		 * 是否将行情http请求转发给原生去发送,0是否，1是，默认为否,如果为是需要原生支持
		 *
		 **/
		isHQFordHttpReq: 1,
		/**
		 * 是否通过mainfest文件管理版本号
		 * */
		isMainfest:"0",
		/**
		 * 是否启用页面切换动画设置,默认启用设置为1
		 */
		isUsePageEffest: 0,
		/**
		 * 是否开启vconsole调式模式
		 */
		isVConsole: false,
		/**
		 * 数据存储前锥
		 */
		storagePrefix: 'trade',
		/**
		 * 缓存值是否需要同步原生，1需要0不需要
		 */
		isSaveSessionToApp: 1,
		/**
		 * 需要同步的key以|分割 需要开启同步原生生效
		 */
		appSStorageKey: ["stock_userInfo","credit_userInfo","option_userInfo","_jurisdiction","_isLoginIn","thirdgd","userInfos","operationInfo"],
	};
	var a = require("../globalConfig.js");
	for(var i in a){
		$.config[i] = a[i];
	}
	if(window._sysVersion){
		$.config["sysVersion"] = window._sysVersion;
	}
	module.exports = $.config;
});
