/**
 * 密码修改
 */
define('trade/scripts/account/changePassword.js', function (require, exports, module) {
    require("validatorUtils");// 验证组件
    require("rsa");
    require("endecryptUtils");// 加密组件
    var validator = $.validatorUtils;
    var gconfig = $.config;
    var global = gconfig.global;
    var service_common = require("service_common");
    var common = require("common");
    var commonFunc = require("commonFunc");
    var _pageId = "#account_changePassword ";
    var userInfo = null;
    var password_new = "";
    var _password_type = "1";
    var endecryptUtils = $.endecryptUtils;
    var witchAccount = "";
    var keyboard = require("keyboard");
    var _param_logout = null;

    /**
     * 初始化
     */
    function init() {
        if (keyboard) {
            keyboard.keyInit();
        }
        userInfo = common.getCurUserInfo();
        witchAccount = "account/index";
        if (userInfo._loginClass == "1") {
            witchAccount = "credit/asset/asset";
        }
        if (userInfo._loginClass == "2") {
            $(_pageId + ".toggle_nav").hide();
            $(_pageId + "#oldPassword").setPlaceholder("请输入原资金密码");
            $(_pageId + "#newPassword").setPlaceholder("请输入新资金密码");
            $(_pageId + "#confirmPassword").setPlaceholder("再次输入资金密码");
            _password_type = "0";
        } else {
			$(_pageId + " .toggle_nav li").removeClass("active").eq(0).addClass("active");
            $(_pageId + ".toggle_nav").show();
            $(_pageId + "#oldPassword").setPlaceholder("请输入原交易密码");
            $(_pageId + "#newPassword").setPlaceholder("请输入新交易密码");
            $(_pageId + "#confirmPassword").setPlaceholder("再次输入交易密码");
            _password_type = "1";
        }
        //获取普通和两融都登入而且客户号相同时的标识参数
        _param_logout = $.getPageParam("param");
        if (userInfo._loginClass == "2") {
            common.pageBuryingPoint("107322");
        } else if (userInfo._loginClass == "1") {
            if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                common.pageBuryingPoint("105586");
            } else {
                common.pageBuryingPoint("105595");
            }
        } else {
            if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                common.pageBuryingPoint("100390");
            } else {
                common.pageBuryingPoint("100400");
            }
        }
    }

    function load() {
        common.setMainHeight(_pageId, false);
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                //埋点
                if (userInfo._loginClass == "2") {//期权
                    common.comStat(107323, 2, 103, true, {"i_group_name": "返回"});
                } else if (userInfo._loginClass == "1") {//两融
                    if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                        common.comStat(105587, 2, 103, true, {"i_group_name": "返回"});
                    } else {
                        common.comStat(105596, 2, 103, true, {"i_group_name": "返回"});
                    }
                } else {
                    if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                        common.comStat(100391, 2, 103, true, {"i_group_name": "返回"});
                    } else {
                        common.comStat(100401, 2, 103, true, {"i_group_name": "返回"});
                    }
                }
                $.pageBack("account/index", "left");
                e.preventDefault();
                e.stopPropagation(); // 阻止冒泡
            }, 300);
        });

        //密码修改
        $.bindEvent($(_pageId + " .ce_btn"), function (e) {
            //埋点
            if (userInfo._loginClass == "2") {//期权
                common.comStat(107324, 2, 103, true, {"i_group_name": "修改交易密码提交"});
            } else if (userInfo._loginClass == "1") {//两融
                if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                    common.comStat(105590, 2, 103, true, {"i_group_name": "修改交易密码提交"});
                } else {
                    common.comStat(105597, 2, 103, true, {"i_group_name": "修改资金密码提交"});
                }
            } else {
                if ($(_pageId + ".toggle_nav li.active").index() == 0) {
                    common.comStat(100394, 2, 103, true, {"i_group_name": "修改交易密码提交"});
                } else {
                    common.comStat(100402, 2, 103, true, {"i_group_name": "修改资金密码提交"});
                }
            }
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            //密码修改校验
            if (!checkInput()) {
                return false;
            }
            ;
            common.iConfirm("修改密码", "<div>您是否确认修改密码?</div>", changePassword);
        });

        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (e.target !== document.activeElement) {
                document.activeElement.blur();
            }
        });
        $.bindEvent($(_pageId + " .toggle_nav li"), function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            clearBuyMsg();
            common.pageBuryingPoint();
            if ($(this).index() == 0) {
                $(_pageId + "#oldPassword").setPlaceholder("请输入原交易密码");
                $(_pageId + "#newPassword").setPlaceholder("请输入新交易密码");
                $(_pageId + "#confirmPassword").setPlaceholder("再次输入交易密码");
                _password_type = "1";
                //埋点
                if (userInfo._loginClass == "1") {//两融
                    common.comStat(105588, 2, 103, true, {"i_group_name": "修改交易密码"});
                    common.pageBuryingPoint("105586");
                } else {
                    common.comStat(100392, 2, 103, true, {"i_group_name": "修改交易密码"});
                    common.pageBuryingPoint("100390");
                }

            } else {
                $(_pageId + "#oldPassword").setPlaceholder("请输入原资金密码");
                $(_pageId + "#newPassword").setPlaceholder("请输入新资金密码");
                $(_pageId + "#confirmPassword").setPlaceholder("再次输入资金密码");
                _password_type = "0";
                //埋点
                if (userInfo._loginClass == "1") {//两融
                    common.comStat(105589, 2, 103, true, {"i_group_name": "修改资金密码"});
                    common.pageBuryingPoint("105595");
                } else {
                    common.comStat(100393, 2, 103, true, {"i_group_name": "修改资金密码"});
                    common.pageBuryingPoint("100400");
                }
            }

            e.stopPropagation();
        });
    }

    /**
     * 密码修改校验
     */
    function checkInput() {

        var password_old = $(_pageId + "#oldPassword").val();
        password_new = $(_pageId + "#newPassword").val();
        var password_confirm = $(_pageId + "#confirmPassword").val();
        if (validator.isEmpty(password_old)) {
            $.alert("原密码不能为空 ");
            return false;
        }
        if (validator.isEmpty(password_new)) {
            $.alert("新密码不能为空 ");
            return false;
        }
        if (validator.isEmpty(password_confirm)) {
            $.alert("确认密码不能为空 ");
            return false;
        }
//		if(!/^[0-9]{6}$/.test(password_old)){
//			$.alert("原密码只允许输入6位数字");
//			return false;
//		}
        if (!/^[0-9]{6}$/.test(password_new)) {
            $.alert("新密码只允许输入6位数字");
            return false;
        }
        if (!/^[0-9]{6}$/.test(password_confirm)) {
            $.alert("确认密码只允许输入6位数字");
            return false;
        }
//		if(password_old.length != 6 || password_new.length != 6 || password_confirm.length != 6){
//			$.alert("密码长度必须为6位 ");
//			return false;
//		}
        if (password_new == password_old) {
            $.alert("新密码与原密码不能相同 ");
            return false;
        }
        if (password_new != password_confirm) {
            $.alert("新密码与确认密码请保持一致 ");
            return false;
        }
        if (!common.checkWeakPwd(password_new)) {
            $.alert("请不要输入弱密码");
            return false;
        }
        return true;
    }


    /**
     * 密码修改
     */
    function changePassword() {
        //获得旧密码和新密码
        var password_old = $(_pageId + "#oldPassword").val();
        password_new = $(_pageId + "#newPassword").val();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var password_type = _password_type;//交易密码
        var password = userInfo.password;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
            "password_new": password_new,
            "password_old": password_old,
            "passowrd_type": password_type,
            "account_type": userInfo._loginClass
        };
        //发送修改密码请求
        service_common.updatePassword(param, updatePasswordCallBack, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }

    function updateFlag(password_new, password_old) {
    }

    function updatePasswordCallBack(data) {
        $.hidePreloader();
        if (data.error_no == 0) {
            //需求:当客户点击确定时,才跳转到登录页面,注意:此处的reSetting不可写为reSetting() 否则会立刻执行
            if ($(_pageId + " .toggle_nav li:eq(0)").hasClass("active")) {
                $.alert("密码修改成功,请重新登录", reSetting, "确定");
            } else {
                $.alert("资金密码修改成功",clearBuyMsg);
            }
        } else {
            $.alert(data.error_info);
            clearBuyMsg();
        }

    }

    /**
     * 重置session
     */
    function reSetting() {
        var acct_type = "";
        var paramMap = {};
        if (userInfo._loginClass == "2") {//期权
            paramMap.switchUserInfo = "2";
            common.clearUserInfo("2");
        } else if (userInfo._loginClass == "1") {//两融
            paramMap.switchUserInfo = "1";
            common.clearUserInfo("1");
        } else {
            paramMap.switchUserInfo = "0";
            common.clearUserInfo("0");
        }
        commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {"topage": witchAccount}, {
            "topage": "",
            "param": paramMap
        }, function () {
            $.pageInit("account/changePassword", "account/index", {}, "", true);
        }, "", true);
    }

    /**
     * 重置页面数据
     */
    function clearBuyMsg() {
        $(_pageId + "#oldPassword").quzhi("");
        $(_pageId + "#newPassword").quzhi("");
        $(_pageId + "#confirmPassword").quzhi("");
    }

    function destroy() {
        common.pageBuryingPoint();
        clearBuyMsg();
        if (keyboard) {
            keyboard.keyDestroy();
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
