/**
 * 交易主界面
 */
define('trade/scripts/account/index.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#account_index ";
    var common = require("common");
    var publicService = require("service_common");
    var service_stock = require("service_stock");
    var service_hq = require("service_hq");
    var nativePluginService = require("nativePluginService");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var wHeight = $.callMessage({
        "funcNo": "50041",
        "key": "HJ_TRADE_HOME_WEB_HEIGHT",
    }).results[0].value;
    $.setSStorageInfo("az_height", wHeight);
    var commonFunc = require("commonFunc");
    var loadingTimes = 0;
    var action = null;
    var indexOption = require("indexOption");
    var indexCredit = require("indexCredit");
    var indexPort = require("indexPort");
    var userInfo = null;
    var accountType = {"0": "普通账户", "1": "信用账户", "2": "期权账户", "3": "理财账户"};
    var _param_flag = null;

    // var iscrollUtils = require("iscrollUtils");
    // var myScroller = null; // 滑动组件对象

    var VIscroll = require("vIscroll");
    var vIscroll = {"scroll":null,"_init":false};		//上下滑动

    /**
     * 初始化
     */
    function init() {
        var mainHeight = common.setMainHeightNew(_pageId, false);
        // if ($.device.iPad || $.device.iPhone || $.device.ios) {
        //     $(_pageId + ".main").css("-webkit-overflow-scrolling", "touch");
        // }
        initMainPage();
    }

    function load() {
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
        commonFunc.getLiquidationInfo(_pageId, true); //获取清算状态和清算提示信息
    }

    /*
     * 查询接口
     */
    function backgroundInterface() {
        var type = $(_pageId + ".header_tab_list a.active").attr("type");
        queryIndexInfo();
        if (type == "0") {//普通
            // queryNumberNewDebts();
            // queryListingShares();
        } else if (type == "1") {//信用
            // queryListingShares();
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //头部标题切换
        $.bindEvent($(_pageId + ".header_tab_list a"), function () {

            var type = $(this).attr("type");
            var names = {"0": "普通", "1": "信用", "2": "期权"};
            switchPage(type);
            common.pageBuryingPoint();
            if (type == "2") {//期权
                common.pageBuryingPoint("107000");
                pointCallNative({
                    parent_page_name: '交易-期权交易首页',
                    parent_page_id: 'PageOptionTradeHome',
                    object_name: '点击顶部“期权”tab按钮',
                    object_id: 'ButtonTradeTab.option',
                });
            } else if (type == "1") {//信用
                common.pageBuryingPoint("107478");
                pointCallNative({
                    parent_page_name: '交易-信用交易首页',
                    parent_page_id: 'PageCreditTradeHome',
                    object_name: '点击顶部“信用”tab按钮',
                    object_id: 'ButtonTradeTab.credit',
                });
            } else {
                common.pageBuryingPoint("100000");
                pointCallNative({
                    object_name: '点击顶部“普通”tab按钮',
                    object_id: 'ButtonTradeTab.custom',
                });
            }
            setTimeout(function () {
                // if(null!=myScroller){
                //     myScroller.refresh();
                // }

                if(!vIscroll._init){
                    initVIScroll();
                }else{
                  vIscroll.scroll.getWrapperObj() && vIscroll.scroll.refresh();
                }
            },300)
        });

        //智能客服
        $.bindEvent($(_pageId + ".header_inner .ai_customer_service"), function (e) {
            pointCallNative({
                object_name: '点击顶部“在线客服”按钮',
                object_id: 'ButtonOnlineService.top',
            });
            $.callMessage({
                "funcNo": "50500",
                "msgNo": "305",
                "sourceModule": "trade",
                "targetModule": "appDispatcher",
                "action": "4",
                "param": {}
            });
            e.stopPropagation();
        });

        // 跳转开户
        $.bindEvent($(_pageId + " .n_text_btn"), function (e) {
            if (global.callNative && global.isSso) {
                $.callMessage({"moduleName": "trade", "funcNo": "80010", "targetModule": "trade"});
            } else {
                window.location.href = "https://csh5.huajinsc.cn:8808/m/openAccount/views/account/index.html";
            }
            //埋点
            var type = $(_pageId + ".header_tab_list a.active").attr("type");
            if (type == "1") {//信用
                common.comStat(105005, 2, 103, true, {"i_group_name": "立即开户"});
            } else if (type == "2") {//期权
                common.comStat(107009, 2, 103, true, {"i_group_name": "立即开户"});
            } else {//普通
                common.comStat(100005, 2, 103, true, {"i_group_name": "立即开户"});//埋点
            }
            pointCallNative({
                object_name: '点击普通交易首页-立即开户按钮',
                object_id: 'ButtonOpenAccount',
            });
            e.stopPropagation();
        });

        //跳转到行情自选股
        $.bindEvent($(_pageId + ".footer .ft_nav li").eq(0), function () {
            window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/zxgList.html";
        });

        //注销的点击事件
        $.bindEvent($(_pageId + " .n_sign_out"), function (e) {
            var tipStr = "<div class=\"pop_main\" style=\"height: 35px;font-size:0.15rem\"><div>确定退出当前登录的账号?</div></div>";
            common.iConfirm("退出账户", tipStr, function success(html) {
                common.clearUserInfo();
                var type = $(_pageId + ".header_tab_list a.active").attr("type");
                switchPage(type);
                //埋点
                if (type == "1") {//信用
                    common.comStat(107480, 2, 103, true, {"i_group_name": "退出"});
                    pointCallNative({
                        parent_page_name: '交易-信用交易首页',
                        parent_page_id: 'PageCreditTradeHome',
                        object_name: '点击信用交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                } else if (type == "2") {//期权
                    common.comStat(107002, 2, 103, true, {"i_group_name": "退出"});
                    pointCallNative({
                        parent_page_name: '交易-期权交易首页',
                        parent_page_id: 'PageOptionTradeHome',
                        object_name: '点击期权交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                } else {//普通
                    common.comStat(100002, 2, 103, true, {"i_group_name": "退出"});
                    pointCallNative({
                        object_name: '点击普通交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                }
            }, function fail() {
            });
            e.stopPropagation();
        });

        // 刷新
        $.bindEvent($(_pageId + ".refresh_btn"), function (e) {
           // $.showRightTopPreloaders();
            var type = $(_pageId + ".header_tab_list a.active").attr("type");
            switchPage(type);
            //埋点
            if (type == "1") {//信用
                common.comStat(107481, 2, 103, true, {"i_group_name": "手动刷新"});
                // queryListingShares();
            } else if (type == "2") {//期权
                common.comStat(107003, 2, 103, true, {"i_group_name": "手动刷新"});
            } else {//普通
                // queryNumberNewDebts();
                // queryListingShares();
                common.comStat(100003, 2, 103, true, {"i_group_name": "手动刷新"});//埋点
            }
            queryIndexInfo();
            e.stopPropagation();
        });

        // 两融、期权权限开通跳转
        $.bindEvent($(_pageId + " .openTips"), function (e) {
            var type = $(this).attr("type");
            if (type == "2") {//期权
                $.pageInit("account/index", "account/optionPermissionOpening", {"type": type});
            } else {
                $.pageInit("account/index", "account/permissionOpening", {"type": type});
            }
            e.stopPropagation();
        });
    }

    function switchPage(type) {
        $(_pageId + ".header_tab_list a").removeClass("active");
        $(_pageId + ".header_tab_list a").eq(type).addClass("active");
        // if(null!=myScroller){
        //     myScroller.scrollTo(0,0,0);
        // }
        if(null!=vIscroll.scroll){
            vIscroll.scroll.getWrapperObj().scrollTo(0,0,0);
        }
        if (type == "1") {//信用
            common.switchingCurUser("1");
            indexCredit.init();
            indexCredit.jumpPageEvent();
        } else if (type == "2") {//期权
            common.switchingCurUser("2");
            indexOption.init();
            indexOption.jumpPageEvent();
        } else {//普通
            common.switchingCurUser("0");
            indexPort.into();
        }
        $(_pageId + ".stock .n_trade_info span").each(function (idx, item) {
            var zoom = $.getTransformScaleFontSize($(item).text(), 12, $(item).width())
            $(item).css({"font-size": zoom + 'px'});
        });
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: wHeight - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                //callsQuery();//下拉获取上一页数据方法

               // $.showRightTopPreloaders();
                var type = $(_pageId + ".header_tab_list a.active").attr("type");
                switchPage(type);
                //埋点
                if (type == "1") {//信用
                    common.comStat(107481, 2, 103, true, {"i_group_name": "手动刷新"});
                    // queryListingShares();
                } else if (type == "2") {//期权
                    common.comStat(107003, 2, 103, true, {"i_group_name": "手动刷新"});
                } else {//普通
                    // queryNumberNewDebts();
                    // queryListingShares();
                    common.comStat(100003, 2, 103, true, {"i_group_name": "手动刷新"});//埋点
                }

                queryIndexInfo();
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 初始化上下滑动组件
     */
    function initVIScroll(){
        if(!vIscroll._init){
            var visibleHeight = $(window).height()-48;
            if(isIphone()){
                visibleHeight = wHeight - $(_pageId + "header").height();
            }
            var config = {
                "isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
                "visibleHeight": visibleHeight, // 滚动组件的高度
                "container": $(_pageId+" #v_container_funds_jj"),
                "wrapper":$(_pageId+" #v_wrapper_funds_jj"),
                "downHandle": function() {
                    var type = $(_pageId + ".header_tab_list a.active").attr("type");
                    switchPage(type);
                    //埋点
                    if (type == "1") {//信用
                        common.comStat(107481, 2, 103, true, {"i_group_name": "手动刷新"});
                        pointCallNative({
                            parent_page_name: '交易-信用交易首页',
                            parent_page_id: 'PageCreditTradeHome',
                            object_name: '点击信用交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                        // queryListingShares();
                    } else if (type == "2") {//期权
                        common.comStat(107003, 2, 103, true, {"i_group_name": "手动刷新"});
                        pointCallNative({
                            parent_page_name: '交易-期权交易首页',
                            parent_page_id: 'PageOptionTradeHome',
                            object_name: '点击期权交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                    } else {//普通
                        // queryNumberNewDebts();
                        // queryListingShares();
                        common.comStat(100003, 2, 103, true, {"i_group_name": "手动刷新"});//埋点
                        pointCallNative({
                            object_name: '点击普通交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                    }
                    //下拉获取上一页数据方法
                    queryIndexInfo(); // 模拟查询接口数据操作
                },
                "upHandle": function() {
                },
                "wrapperObj": null
            };
            vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
            vIscroll._init = true; 						//尽量只初始化一次，保持性能

        }else{
          vIscroll.scroll.getWrapperObj() && vIscroll.scroll.refresh();
        }
        $(_pageId + ".visc_pullUp").css("display","none");
    }


    /*
     * 初始化首页
     */
    function initMainPage() {
        // common.pageChangeHeight();
        window.onresize= function(){};
        var type = $.getPageParam("_loginClass") || $(_pageId + ".header_tab_list a.active").attr("type");
        switchPage(type);
        changeValue();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
        if (type == "2") {//期权
            common.pageBuryingPoint("107000");
        } else if (type == "1") {//信用
            common.pageBuryingPoint("107480");
        } else {
            common.pageBuryingPoint("100000");
        }
    }

    /*
     * 改变从登录传过来的_loginClass值
     * 如果不改变，点击进子页面，再返回，这个值依旧存在，所以要清空
     */
    function changeValue() {
        var paramMap = sessionStorage.getItem("_curPage");
        if (paramMap) {
            if (typeof paramMap == 'string') {
                paramMap = JSON.parse(paramMap);
            }
            if (paramMap.params) {
                paramMap.params._loginClass = "";
                sessionStorage.setItem("_curPage", JSON.stringify(paramMap));
            }
        }

    }


    /**
     * 查询首页展示
     */
    function queryIndexInfo() {
        setTimeout(queryListAmount, 17);
    }

    /**
     * 查询首页新股，新债数量
     */
    function queryListAmount() {
        var userInfo = common.getCurUserInfo();
        var param = {};
        param.funcNo = "310300";
        param.entrust_way = global.entrust_way;
        param.branch_no = userInfo.branch_no;
        param.fund_account = userInfo.fund_account;
        param.cust_code = userInfo.cust_code;
        param.password = userInfo.password;
        param.session_id = userInfo.session_id;
        param.new_bond_flag = "1"; //是否查询新债 0.不查询 1.查询
        param.new_stock_flag = "1"; //是否查询新股
        param.new_gz_stock_flag = "1"; //是否查询股转新股
        param.loan_flag = "1";

        $(_pageId + "#newShare1").html("--");
        $(_pageId + "#newPurchase").html("--");
        $(_pageId + "#crdeitNewShare").html("--");
        $(_pageId + "#crdeitNewPurchase").html("--");
        $(_pageId + "#newShareGZ").html("今日有--只新股");
        $(_pageId + "#mallInfo").html('--天期 <em class="fontRed">--%</em>');
        $(_pageId + ".stock .n_trade_info span").each(function (idx, item) {
            var zoom = $.getTransformScaleFontSize($(item).text(), 12, $(item).width())
            $(item).css({"font-size": zoom + 'px'});
        });
        publicService.serviceCommonInvoke(param, function (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    var stocks = 0;
                    var bjs = 0;
                    if (results && results.length) {
                        for (var i = 0; i < results.length; i++) {
                            var numberText = "";
                            if (+results[i].number) numberText = '<em class="fontRed">' + results[i].number + '</em>';
                            else numberText = results[i].number;
                            if (results[i].module_name == "0") {
                              stocks = parseInt(results[i].number);
                            } else if (results[i].module_name == "1") {
                                $(_pageId + "#newPurchase").html(numberText);
                                $(_pageId + "#crdeitNewPurchase").html(numberText);
                            } else if (results[i].module_name == "2") {
                                $(_pageId + "#mallInfo").html(results[i].module_info + " <em class='fontRed'>" + numberText + "</em>");
                            } else if (results[i].module_name == "3") {
                                $(_pageId + "#newShareGZ").html("今日有" + numberText + "只新股");
                                bjs = parseInt(results[i].number);
                            }
                        }
                        // 新股数量= 北交所新股+沪深新股
                        $(_pageId + "#newShare1").html('<em class="fontRed">' + (stocks + bjs) + '</em>');
                        $(_pageId + "#crdeitNewShare").html('<em class="fontRed">' + stocks + '</em>');

                        $(_pageId + ".stock .n_trade_info span").each(function (idx, item) {
                            var zoom = $.getTransformScaleFontSize($(item).text(), 12, $(item).width())
                            $(item).css({"font-size": zoom + 'px'});
                        });
                    }
                } else {
                    $.alert(data.error_info);
                }
                // if (!myScroller) {
                //     initScroller();
                // } else {
                //     myScroller.refresh();
                // }

                if(!vIscroll._init){
                    initVIScroll();
                }else{
                  vIscroll.scroll.getWrapperObj() && vIscroll.scroll.refresh();
                }
                $.hidePreloader();
            },
            {
                "isLastReq": true,
                "isShowWait": false,
                "isShowOverLay": false,
                "isGlobal": true,
                "errorFunc": function () { // 超时调用方法
                    $.hidePreloader();
                },
                "timeOutFunc": function () { // 超时调用方法
                    if(!vIscroll._init){
                        initVIScroll();
                    }else{
                      vIscroll.scroll.getWrapperObj() && vIscroll.scroll.refresh();
                    }
                }
                // "timeOutFunc": function () { // 超时调用方法
                //     $.hidePreloader();
                // }
            });
    }

    /*
     * 查询今日可申购的新股
     */
    function queryListingShares() {
        userInfo = common.getCurUserInfo(0);
        var is_login = null;
        if (userInfo && common.isEmptyObject(userInfo)) {//登录的情况
            is_login = "1";
        } else {
            is_login = "0";
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "account_type": userInfo._loginClass,
            "is_login": is_login,
        };
        $(_pageId + "#newShare1").html("0");
        $(_pageId + "#crdeitNewShare").html("0");
        service_stock.queryListingShares(param, function (data) {
            if (data.error_no == 0) {
                if (data.results) {
                    if (data.results.length > 0) {
                        $(_pageId + "#newShare1").html(data.results.length);
                        $(_pageId + "#crdeitNewShare").html(data.results.length);
                    } else {
                        $(_pageId + "#newShare1").html(0);
                        $(_pageId + "#crdeitNewShare").html("0");
                    }
                } else {
                    $(_pageId + "#newShare1").html(0);
                    $(_pageId + "#crdeitNewShare").html("0");
                }
            } else {
                $.alert(data.error_info);
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
            }
        });
    }

    /*
     * 查询今日可申购的新债
     */
    function queryNumberNewDebts() {
        userInfo = common.getCurUserInfo(0);
        var is_login = null;
        if (userInfo && common.isEmptyObject(userInfo)) {//登录的情况
            is_login = "1";
        } else {
            is_login = "0";
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "account_type": userInfo._loginClass,
            "is_login": is_login,
        };
        $(_pageId + "#newPurchase").html("今日有0只新债");
        $(_pageId + "#crdeitNewPurchase").html("0");
        service_stock.queryNumberNewDebts(param, function (data) {
            if (data.error_no == 0) {
                if (data.results) {
                    if (data.results.length > 0) {
                        $(_pageId + "#newPurchase").html("今日有<em>" + data.results.length + "</em>只新债");
                        $(_pageId + "#crdeitNewPurchase").html(data.results.length);
                    } else {
                        $(_pageId + "#newPurchase").html("今日有0只新债");
                        $(_pageId + "#crdeitNewPurchase").html("0");
                    }
                } else {
                    $(_pageId + "#newPurchase").html("今日有0只新债");
                    $(_pageId + "#crdeitNewPurchase").html("0");
                }
            } else {
                $.alert(data.error_info);
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
            }
        });
    }

    /*
     * 清空页面数据
     */
    function clearPageInfo() {
        $(_pageId + ".stock .j-stock-data .j-position-box p").html("");//普通账号展示
        $(_pageId + ".stock .j-stock-data .j-data-info .exhibition").html("--");//普通交易资产
        $(_pageId + ".stock .j-stock-data .j-data-info .exhibition").css("zoom", "1");//普通交易资产
        $(_pageId + ".stock .j-stock-data .j-data-info .exhibition:eq(2)").removeClass("ared").removeClass("agreen");
        $(_pageId + "#newShare1").html("--");
        $(_pageId + "#newPurchase").html("--");
        $(_pageId + "#crdeitNewShare").html("--");
        $(_pageId + "#crdeitNewPurchase").html("--");
        $(_pageId + "#newShareGZ").html("今日有--只新股");
        $(_pageId+"#byckyk ul li").html('<p>--月参考盈亏<span style="color: #333333;font-size: 0.2rem">--</span></p><span class="n-sel-text">资产分析</span>');
        $(_pageId + "#credit_byckyk ul li").html('<p>--月参考盈亏<span style="color: #333333;font-size: 0.2rem">--</span></p><span class="n-sel-text">资产分析</span>');

        $(_pageId + ".credit .j-stock-data .j-position-box p").html("");//两融账号展示
        $(_pageId + ".credit .j-stock-data .j-data-info .exhibition").html("--");//两融资产
        $(_pageId + ".credit .j-stock-data .j-data-info .exhibition").css("zoom", "1");//两融资产

        $(_pageId + ".option .j-stock-data .j-position-box p").html("");//期权账号展示
        $(_pageId + ".option .j-stock-data .j-data-info .exhibition").html("--");//期权资产
        $(_pageId + ".option .j-stock-data .j-data-info .exhibition").css("zoom", "1");//期权资产
        $(_pageId + ".option .j-stock-data .j-data-info .exhibition:eq(1)").removeClass("ared").removeClass("agreen");
        $(_pageId + "#optionExercise").html("");//期权行权数
    }

    /*
     * 退出登录后改变页面标志的方法
     */
    function clearCache() {
        clearPageInfo();
        //还原期权资产隐藏显示的效果
        $(_pageId + ".stock .j-stock-data .switch_btn").removeClass("hide").addClass("show");
        $(_pageId + ".stock .j-stock-data .j-data-info .exhibition").show();
        $(_pageId + ".stock .j-stock-data .j-data-info .conceal").hide();

        $(_pageId + ".credit .j-stock-data .switch_btn").removeClass("hide").addClass("show");
        $(_pageId + ".credit .j-stock-data .j-data-info .exhibition").show();
        $(_pageId + ".credit .j-stock-data .j-data-info .conceal").hide();

        $(_pageId + ".option .j-stock-data .switch_btn").removeClass("hide").addClass("show");
        $(_pageId + ".option .j-stock-data .switch_btn .exhibition").show();
        $(_pageId + ".option .j-stock-data .switch_btn .conceal").hide();
        $(_pageId + ".n_sign_out").hide();//"退出登录的按钮"
       // $(_pageId + " .main").scrollTop(0);
    }

    /******
     * scroll不显示的高度
     * @returns {number}
     */
    function getUnshowHeight() {
        if ($.device.iPad || $.device.iPhone || $.device.ios) {
            if(isIphoneX()){
                return 120;
            }else{
                return 85;
            }
        }else{
            return 48;

        }
    }

    function isIphone(){
        if ($.device.iPad || $.device.iPhone || $.device.ios) {
            return true;
        }else{
            return false;

        }
    }


    function isIphoneX() {
        var resu = nativePluginService.function50001();
        if (resu && null != resu) {
            if (resu.error_no == 0) {
                var devicePlatform = resu.results[0].devicePlatform.replace(/\s+/g, "").toLocaleLowerCase();//去空格转小写
                if (devicePlatform.indexOf("iphonex") != -1
                    || devicePlatform.indexOf("iphone11") != -1
                    || devicePlatform.indexOf("iphone12") != -1) {
                    return true;
                }
            }
        }
        return false;
    }
    /**
     * @description 埋点   
     * @author cfx   
     * @date 2021-06-22 13:44:14   
     * @modifyContent 修改点描述...   
     */
    function pointCallNative(point){
        common.pointCallNative({
            module_name: '交易',
            module_id: 'yjapp.trade',
            parent_page_name: point.parent_page_name || '交易-普通交易首页',
            parent_page_id: point.parent_page_id || 'PageOrdinaryTradeHome',
            actionType: point.actionType || 'click' ,
            object_name: point.object_name || '',
            object_id: point.object_id || '',
        });
    }

    /**
     * 销毁
     */
    function destroy() {
        $.clearRequest();
        clearPageInfo();
        common.pageBuryingPoint();
        if (indexCredit) {
            indexCredit.destroy();
        }
        if (indexOption) {
            indexOption.destroy();
        }
        if (indexPort) {
            indexPort.destroy();
        }
        if(vIscroll._init){
          vIscroll.scroll.getWrapperObj() && vIscroll.scroll.refresh();
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "clearCache": clearCache,
    };
    module.exports = base;
});
