/**
 * 交易主界面
 */
define('trade/scripts/account/index.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#account_index_new ";
    var common = require("common");
    var service_xkj = require("service_xkj");
    var service_common = require("service_common");
    var service_stock = require("service_stock");
    var service_third = require("service_third");
    var service_credit = require("service_credit");
    var service_fund = require("service_fund");
    var service_hq = require("service_hq");
    var service_xkj = require("service_xkj");
    require("validatorUtils");
    var validata = $.validatorUtils;
    var keyboard = require("keyboard");
    var nativePluginService = require("nativePluginService");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var commonFunc = require("commonFunc");
    var userInfo = {};

    var new_stocks = 0; // 新股数量
    var new_bjs = 0; // 北交所新股数量
    var new_bond = 0; // 新债数量
    var picData = null; // 开户banner数据
    var msgNum = 0; // 未读消息数量
    var isOldMan = false;
    var notice = null;
    /**
     * 开户断点跳转路由
     */
    var openaccount_break_link_url = '';

    var vBscroll = require("vBscroll");
    var vIscroll = { "scroll": null, "_init": false };		//上下滑动

    // 客户端切换tab，交易首页回调函数
    window.tradePageCallBack = function(){
        getOpenAccountBreakPoint(true);
    }
    /**
     * 初始化
     */
    function init() {
        common.setMainHeight(_pageId, false);
        initMainPage();
    }

    function load() {
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    /*
     * 查询接口
     */
    function backgroundInterface() {
        if(vIscroll.y !== undefined && vBscroll.getBScroll()){
            var scroll = vBscroll.getBScroll();
            scroll && scroll.scrollTo(0, vIscroll.y, 0);
        }
        noLoginData();
    }
    /*
     * 与交易登录无关的接口统一这里发起请求
     */
    function noLoginData(){
        //获取清算状态和清算提示信息
        commonFunc.getLiquidationInfo(_pageId, true, function () {
            initVIScroll();
        });
        getMsgNum();
        queryListAmount();
        require1001014();
        require3001044();
        getAdPicData();
        getOpenAccountBreakPoint();
        getTradeNotices();
    }

    /**
     * 初始化上下滑动组件
     */
    function initVIScroll() {
        changeOldMan();
        if (!vIscroll._init) {
            $(_pageId + " #v_container_funds_jj").height($(window).height() - $(_pageId + 'header').height());
            $(_pageId + " #v_wrapper_funds_jj").height($(window).height() - $(_pageId + 'header').height());
            $(_pageId + ".openAccount").height($(window).height() - $(_pageId + 'header').height());
            vBscroll.init({
                warpId: _pageId + '#v_wrapper_funds_jj',
                pulldown: true,
                pageId: _pageId,
                pullingDownCallback:function(){
                    var type = $(_pageId + ".header_nav .active").attr("type");
                    noLoginData();
                    switchPage(type);
                    //埋点
                    if (type == "1") {//信用
                        pointCallNative({
                            object_name: '点击信用交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                    } else if (type == "2") {//期权
                        pointCallNative({
                            object_name: '点击期权交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                    } else if (type == "2") {//普通
                        pointCallNative({
                            object_name: '点击普通交易首页-下拉刷新按钮',
                            object_id: 'ButtonRefresh',
                        });
                    }
                }
            });
            window.vBscroll = vBscroll;
            vIscroll._init = true; 						//尽量只初始化一次，保持性能
        } else {
            vBscroll.refresh();
        }
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //头部标题切换
        $.bindEvent($(_pageId + ".header_nav a"), function () {
            var type = $(this).attr('type');
            switchPage(type);

            if (vBscroll.getBScroll()) {
                var scroll = vBscroll.getBScroll();
                scroll && scroll.scrollTo(0, scroll.minScrollY, 0);
                vIscroll.y = scroll.minScrollY;
            }
            getAdPicData();
            $.callMessage({"moduleName": "trade", "funcNo": "50108", "flag": "1"});
        });

        // 一级导航
        $.bindEvent($(_pageId + ".first-nav li"), nextPage);
        // 二级导航
        $.bindEvent($(_pageId + ".second-nav li"), nextPage);
        // 资产分析
        $.bindEvent($(_pageId + ".zcfx"), nextPage);
        // 智能客服
        $.bindEvent($(_pageId + ".ai_customer_service"), nextPage);
        // 消息推送
        $.bindEvent($(_pageId + ".message_btn"), nextPage);
        // 拨打电话|智能客服
        $.bindEvent($(_pageId + ".blue-btn"), nextPage);
        // ETF交易专区
        $.bindEvent($(_pageId + ".etf"), nextPage);
        // 国债逆回购
        $.bindEvent($(_pageId + ".gznhg"), nextPage);
        // 智能打新
        $.bindEvent($(_pageId + ".j_xgxz"), nextPage,'tap');
        // 智能打新-新债tab
        $.bindEvent($(_pageId + ".j_xgxz_xz"), nextPage,'tap');
        //点击跳转到持仓
        $.bindEvent($(_pageId + ".ccxq"), nextPage);
        //期权行情
        $.bindEvent($(_pageId + ".qqhq div"), nextPage);
        // 跳转开户
        $.bindEvent($(_pageId + " .openAccount"), function (e) {
            vIscroll.y = vBscroll.getBsPos().y;
            if(picData != null){
                picData.funcNo = "80037";
                $.callMessage(picData);
            }
        });
        // 关闭通知按钮
        $.bindEvent($(_pageId + " .close"), function (e) {
            vIscroll.y = vBscroll.getBsPos().y;
            $(_pageId + ".notice").hide();
            $.setSStorageInfo("account_index_notice", "1");
        });
        // 公共跑马灯动画事件
        $.bindEvent($(_pageId + ".notice-content p"), function (e) {
            resetNoticesAnimation();
        },"transitionend");
        // 通知内容点击
        $.bindEvent($(_pageId + " .notice-content"), function (e) {
            vIscroll.y = vBscroll.getBsPos().y;
            nativePluginService.function501152({
                "url": global.newFrameUrl + "fintechpages/synthetical/index.html#/tradeNoticeDetail?id=" + notice.id,
                "uniqueCode":"synthetical-tradeNoticeDetail",
            });
        });
        // 开户断点banner
        $.bindEvent($(_pageId + ".openaccount_breakpoint"), function (e) {
            vIscroll.y = vBscroll.getBsPos().y;
            $.callMessage({
                "funcNo": "5011512",
                h5Url: openaccount_break_link_url
            });
        });
        // 登录
        $.bindEvent($(_pageId + ".no-login button"), function (e) {
            var type = $(_pageId + ".header_nav .active").attr('type');
            vIscroll.y = vBscroll.getBsPos().y;
            if ($(_pageId + ".credit .no-login button").html() == "查看条件" && type == '1') { // 信用页面 查看条件 按钮
                pointCallNative({
                    object_name: '点击信用交易首页-查看条件按钮',
                    object_id: 'ButtonCreditCommonProblem.top',
                });
                $.pageInit("account/index", "account/permissionOpening", { "type": 1 });
                return;
            } else if ($(_pageId + ".option .no-login button").html() == "了解更多" && type == '2') { // 期权页面 了解更多 按钮
                $.pageInit("account/index", "account/optionPermissionOpening", { "type": 2 });
                pointCallNative({
                    object_name: '点击期权交易首页-了解更多按钮',
                    object_id: 'ButtonOptionCommonProblem',
                });
                return;
            }
            commonFunc.login($.getCurrentPageObj().pageCode, "account/login", { "_loginClass": type }, {
                "topage": "",
                "param": { "switchUserInfo": type }
            });
            if (type == '0') {
                pointCallNative({
                    object_name: '点击普通交易首页-立即登录按钮',
                    object_id: 'ButtonTradeLogin',
                });
            } else if (type == '1') {
                pointCallNative({
                    object_name: '点击信用交易首页-立即登录按钮',
                    object_id: 'ButtonTradeLogin',
                });
            } else if (type == '2') {
                pointCallNative({
                    object_name: '点击期权交易首页-立即登录按钮',
                    object_id: 'ButtonTradeLogin',
                });
            }
        });
        //退出登录
        $.bindEvent($(_pageId + " .sign_out"), function (e) {
            var type = $(_pageId + ".header_nav .active").attr("type");
            var tipStr = "<div class=\"pop_main\" style=\"height: 35px;font-size:0.15rem\"><div>确定退出当前登录的账号?</div></div>";
            common.iConfirm("退出账户", tipStr, function success(html) {
                common.clearUserInfo();
                if (vBscroll.getBScroll()) {
                    var scroll = vBscroll.getBScroll();
                    scroll && scroll.scrollTo(0, scroll.minScrollY, 0);
                    vIscroll.y = scroll.minScrollY;
                }
                //埋点
                if (type == "1") {//信用
                    pointCallNative({
                        object_name: '点击信用交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                } else if (type == "2") {//期权
                    pointCallNative({
                        object_name: '点击期权交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                } else if (type == "2") {//普通
                    pointCallNative({
                        object_name: '点击普通交易首页-退出账号按钮',
                        object_id: 'ButtonExitFundAccount',
                    });
                }
            }, function fail() {
            });
            e.stopPropagation();
        });
        //资产的隐藏显示
        $.bindEvent($(_pageId + ".eye"), function (e) {
            var i_change_to = "";
            var type = $(_pageId + ".header_nav .active").attr("type");
            var map = {
                '0': '.stock',
                '1': '.credit',
                '2': '.option',
            };
            if ($(this).hasClass("eye-close")) {
                $(this).removeClass("eye-close").addClass("eye-open");
                $(_pageId + map[type] + " .assets .value").show();
                $(_pageId + map[type] + " .assets .conceal").hide();
                i_change_to = "展示";
            } else {
                $(this).removeClass("eye-open").addClass("eye-close");
                $(_pageId + map[type] + " .assets .value").hide();
                $(_pageId + map[type] + " .assets .conceal").show();
                i_change_to = "屏蔽";
            }
            //埋点
            if (type == "1") {//信用
                pointCallNative({
                    object_name: '点击信用交易首页-资产隐藏按钮-' + i_change_to,
                    object_id: 'ButtonCreditAssetHide',
                });
            } else if (type == "2") {//期权
                pointCallNative({
                    object_name: '点击期权交易首页-资产隐藏按钮-' + i_change_to,
                    object_id: 'ButtonOptionAssetHide',
                });
            } else if (type == "2") {//普通
                pointCallNative({
                    object_name: '点击普通交易首页-资产隐藏按钮-' + i_change_to,
                    object_id: 'ButtonOrdinaryAssetHide',
                });
            }
            e.stopPropagation();
        });
        // 全景
        $.bindEvent($(_pageId + ".all-btn"), function (e) {
            var type = $(_pageId + ".header_nav .active").attr('type');
            vIscroll.y = vBscroll.getBsPos().y;
            if (global.callNative && global.isSso) {
                var tabid = {
                    "0": "pt",
                    "1": "xy",
                    "2": "qq",
                };
                var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=" + tabid[type];
                var param = {
                    "funcNo": "50500",
                    "msgNo": "601",
                    "targetModule": "mallDispatcher",
                    "action": 3,
                    "param": {
                        "business_type": type,//普通0  两融1
                        "event": "15",//打开风险警示权限开通页面
                        "title": "",
                        "toPage": toPage,
                    }
                }
                $.callMessage(param);
            }
            e.stopPropagation();
        });
        // 今日参考盈亏提示框
        $.bindEvent($(_pageId + ".j-tip-btn"), function (e) {
            var type = $(_pageId + ".header_nav .active").attr('type');
            vIscroll.y = vBscroll.getBsPos().y;
            if (type == "2") {//期权
                var msg = '';
                msg += '<p>1. 交易日仅9:15-16:00期间显示,不参与晚间清算,仅供盘中参考;</p>';
                msg += '<p>2. 非交易日不显示;</p>';
                msg += '<p>3. 已计入交易手续费,但不包括理财产品收益;</p>';
                msg += '<p>4. 若昨日有股票分红、配股等情况,可能导致今日参考盈亏计算不准确;</p>';
                msg += '<p>5. 今日参考盈亏仅为参考值,不作为具体的投资参考意见,请以账户实际收益为准。</p>';
                common.singleIConfirmNew("今日参考盈亏", msg, null, "我知道了");
                pointCallNative({
                    object_name: '点击期权交易首页-今日参考盈亏注释按钮',
                    object_id: 'ButtonTodayProfitAndLossComment',
                });
            } else if (type == '1') { // 信用
                nativePluginService.function501152({
                    "url":global.newFrameUrl + "fintechpages/synthetical/index.html#/public/description?defaultPage=1&switchUserInfo=1",
                    "uniqueCode":"PalmHall-public/description",
                    "isShowTitleBar":"0",
                    "isUseFullScreenH5":"1"
                });
                pointCallNative({
                    object_name: '点击信用交易首页-今日参考盈亏注释按钮',
                    object_id: 'ButtonTodayProfitAndLossComment',
                });
            } else if (type == '0') { // 普通
                nativePluginService.function501152({
                    "url":global.newFrameUrl + "fintechpages/synthetical/index.html#/public/description?defaultPage=1&switchUserInfo=0",
                    "uniqueCode":"PalmHall-public/description",
                    "isShowTitleBar":"0",
                    "isUseFullScreenH5":"1"
                });
                pointCallNative({
                    object_name: '点击普通交易首页-今日参考盈亏注释按钮',
                    object_id: 'ButtonTodayProfitAndLossComment',
                });
            }
            e.stopPropagation();
        });
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            common.setMainHeight(_pageId, false);
            $(_pageId + " #v_container_funds_jj").height($(window).height() - $(_pageId + 'header').height());
            $(_pageId + " #v_wrapper_funds_jj").height($(window).height() - $(_pageId + 'header').height());
            $(_pageId + ".openAccount").height($(window).height() - $(_pageId + 'header').height());
            initVIScroll();
        };
    }
    // 跳转公用事件
    function nextPage(e) {
        vIscroll.y = vBscroll.getBsPos().y;
        var type = $(_pageId + ".header_nav .active").attr('type');
        var pointDict = {
            "0": {
                object_name: "点击普通交易首页",
                switchUserInfo: "0",
            },
            "1": {
                object_name: "点击信用交易首页",
                switchUserInfo: "1",
            },
            "2": {
                object_name: "点击期权交易首页",
                switchUserInfo: "2",
            },
            "3": {
                object_name: "点击交易首页开户tab",
                switchUserInfo: "0",
            },
        };
        // 设置公共埋点
        var object_id = $(this).attr("object_id");
        if (object_id) {
            var name = $(this).attr("name");
            pointCallNative({
                object_name: pointDict[type].object_name + '-' + name + '按钮',
                object_id: object_id,
            });
        }
        // 跳转类型 1 $.pageInit; 2 新框架; 3 打开思迪webview ; 4 调用特定功能号;
        var jumptype = $(this).attr("jumptype");
        if (jumptype === '1') {
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param") || undefined; // 获取跳转页面参数
            var paramMap = {
                switchUserInfo: pointDict[type].switchUserInfo,
            };
            if (param) {
                paramMap.param = param;
            }
            //智能打新 无需登录
            if (topage == "nsb/index") {
                // console.log('nsb/index',paramMap.param);
                // 普通跳转新股新债有北交所，信用没有
                if (type == '0') {
                    if (Number(new_stocks) > 0) {
                        paramMap.isStocks = true;
                        paramMap.isBjs = false;
                    } else if (Number(new_bjs) > 0) {
                        paramMap.isStocks = true;
                        paramMap.isBjs = true;
                    } else {
                        paramMap.isStocks = true;
                    }
                } else if (type == '1') {
                    if (Number(new_stocks) > 0) {
                        paramMap.isStocks = true;
                    } else {
                        if (Number(new_bond) > 0) {
                            paramMap.isStocks = false;
                        } else {
                            paramMap.isStocks = true;
                        }
                    }
                }
                //判断传参，如果有传参要求，优先按传参跳转
                if(paramMap.param === 'newStock'){
                    paramMap.isStocks = true;
                    paramMap.isBjs = false;
                }else if(paramMap.param === 'newBond'){
                    paramMap.isStocks = false;
                    paramMap.isBjs = false;
                }
                $.setSStorageInfo("stockFlag", "", true);
                $.setSStorageInfo("bjsFlag", "", true);
                $.pageInit("account/index", topage, { "param": paramMap });
                e.stopPropagation();
                return ;
            } else if(topage === "account/permissionOpening" || topage === "account/optionPermissionOpening"){
                $.pageInit("account/index", topage, { "type": paramMap.switchUserInfo });
                e.stopPropagation();
                return ;
            } else if (topage == "credit/transferred/collateralTransferIn") {//担保品划转
                //没有登录的情况
                if (!common.isTradeLogin(type)) {
                    commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                        "_loginClass": type,
                        "topage": $.getCurrentPageObj().pageCode,
                        "param": param
                    }, { "topage": $.getCurrentPageObj().pageCode, "param": paramMap });
                } else {
                    $.showPreloader("请等待...");
                    if (!param) {
                        param = "";
                    }
                    if (isAStockLogin()) {
                        loginGeneralAccount(function () {
                            $.pageInit("account/index", topage, { "param": param });
                        });
                    } else {
                        $.pageInit("account/index", topage, { "param": param });
                    }
                }
                return;
            }
            //登录的情况
            if (common.isTradeLogin(type)) {
                //加入检查港股通权限
                if (!common.checkGgtPermission(userInfo.fund_account) && topage.indexOf("ggt") > -1) {
                    $.pageInit("account/index", 'ggt/noRight', { "param": paramMap });
                    return;
                } else if (topage.indexOf("third") > -1) { //添加股转权限（新三板）
                    var _jurisdiction = commonFunc.getJurisdiction();
                    //本地没有缓存权限，则同步查询一次
                    if (!_jurisdiction.IsQuerySuccess) {
                        commonFunc.setJurisdiction(null, function (data) {
                            if (data.IsQuerySuccess != false && data.three_board_rights != "1") {//有返回、无权限
                                topage = "third/thirdJurisdiction"
                            }
                            $.pageInit("account/index", topage, { "param": paramMap });
                        });
                        return;
                    } else if (_jurisdiction.three_board_rights != "1") { //无权限
                        topage = "third/thirdJurisdiction"
                    }
                } else if (global.account_kcbJurisdiction && $(this).attr("kcbCheck")) { //科创板权限
                    commonFunc.kcbJurisdiction(type, userInfo, function (_rights) {
                        if (_rights != "0") {//科创板权限（1无权限，0有权限）
                            topage = "kcb/kcbDistrict";
                        }
                        $.pageInit("account/index", topage, { "param": paramMap });
                    });
                    return;
                }
                $.pageInit("account/index", topage, { "param": paramMap });
            } else {//没有登录的情况
                commonFunc.login($.getCurrentPageObj().pageCode, topage, { "param": paramMap }, {
                    "topage": topage,
                    "param": paramMap
                });
            }
        } else if (jumptype === '2') {
            var url = $(this).attr("url"); // 获取跳转页面参数
            var uniqueCode = $(this).attr("uniqueCode"); // 获取跳转页面参数
            var isUseFullScreenH5 = $(this).attr("isUseFullScreenH5"); // 是否启用h5自带标题栏
            var jump_url = {
                "url": global.newFrameUrl + url,
                "uniqueCode": uniqueCode,
                "isSupportPullDownRefresh": "1"
            };
            // 是否启用h5自带标题栏
            if(isUseFullScreenH5 === "1"){
                jump_url.isUseFullScreenH5 = "1";
                jump_url.isShowTitleBar = "0";
            }
            nativePluginService.function501152(jump_url);
        } else if (jumptype === '4') {
            var btnname = $(this).attr("btnname"); // 获取跳转页面参数
            var needlogin = $(this).attr("needlogin"); // 是否需要先登录
            if (needlogin === 'true' && !common.isTradeLogin(type)) {
                commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                    "_loginClass": type,
                    "topage": $.getCurrentPageObj().pageCode,
                    "param": param
                }, { "topage": $.getCurrentPageObj().pageCode, "param": { switchUserInfo: type } });
                return;
            }
            if (btnname === "zntjd"){
                
                nativePluginService.function501152({
                    "url":global.newFrameUrl + "fintechpages/synthetical/index.html#/intelligentCondition",
                    "uniqueCode":"PalmHall-intelligentCondition",
                    "isShowTitleBar":"0",
                    "isUseFullScreenH5":"1"
                });
                // nativePluginService.function501152({
                //     "url": global.zntjd + "/h5-web",
                //     "uniqueCode":"",
                //     "isShowTitleBar": "0",
                //     "isUseFullScreenH5": "1",
                //     "loginMode":"2"
                // });
            }else if (btnname === 'zcfx') { 
                // 资产分析跳转
                var toPage = "";
                if(type == 0){
                    toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&pageto=znzh-index&moneytype=0";
                }else{
                    toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&pageto=znzh-index_red&moneytype=0";
                }
                $.callMessage({
                    "msgNo": "601",
                    "targetModule": "mallDispatcher",
                    "action": 3,
                    "param": {
                        "toPage": toPage,
                        "needlogin": "true"
                    },
                    "funcNo":"50500"
                });
            } else if (btnname === 'call') { // 拨打电话
                nativePluginService.function50220({
                    telNo: "956011"
                });
            } else if (btnname === 'zxkf') { // 在线客服
                $.callMessage({
                    "funcNo": "50500",
                    "msgNo": "305",
                    "sourceModule": "trade",
                    "targetModule": "appDispatcher",
                    "action": "4",
                    "param": {}
                });
            } else if (btnname === 'mall') { // 跳转理财bar
                $.callMessage({
                    "funcNo": "50500",
                    "msgNo": "304",
                    "targetModule": "appDispatcher",
                    "sourceModule": "trade",
                    "action": "3",
                    "param": {
                        "moduleLoginType": "0",
                        "index": "3"
                    }
                });
            } else if (btnname === 'gznhg') { // 打开国债逆回购
                $.callMessage({
                    "funcNo": "50115",
                    "loadModuleName": "mall",
                    "moduleName": "mall",
                    statusStyle: "0",
                    isUseFullScreenH5:'1',
                    "url": global.mallUrl + "/lcsm/mall/reverserepolist",
                    "targetModule": "mallDispatcher"
                });
            } else if (btnname === 'shqq') { // 上证期权行情
                var param = {
                    "mdInfo": 1654,
                    "title": "上证期权",
                    "request_type": "60:61"
                }
                nativePluginService.function501153(param);
            } else if (btnname === 'szqq') { // 深圳期权行情
                var param = {
                    "mdInfo": 1655,
                    "title": "深证期权",
                    "request_type": "62:63"
                }
                nativePluginService.function501153(param);
            } else if (btnname === 'xxts') { // 未读消息推送
                //跳转消息推送
                $.callMessage({
                    "funcNo": "70009"
                });
            } else if (btnname === 'ygt') { // 业务办理
                $.callMessage({
                    "funcNo": "50115",
                    "moduleName": "ygt",
                    "url": global.ygtUrl + "/new/ygt/index.html#!/account/addIndex.html",
                    "statusColor": "#EE4034",//状态栏颜色
                    "isShowLoading": "1"
                });
            }
        }
        e.stopPropagation();
    }
    // 切换账号
    function switchPage(type) {
        // 切换每个标题组中的小图标
        $(_pageId + ".header_nav a").removeClass("active");
        $(_pageId + ".header_nav a[type='" + type + "']").addClass("active");
        // 切换标题组
        $(_pageId + ".header_nav").hide();
        $(_pageId + ".header_nav[type='" + type + "']").show();
        if (type == "1") {//信用
            common.switchingCurUser("1");
            $(_pageId + ".stock").hide();
            $(_pageId + ".credit").show();
            $(_pageId + ".option").hide();
            $(_pageId + ".trade").show();
            $(_pageId + ".openAccount").hide();
            changePage(type);
            stockAssetsInquiry(type);
            queryZCFX(type);
        } else if (type == "2") {//期权
            common.switchingCurUser("2");
            $(_pageId + ".stock").hide();
            $(_pageId + ".credit").hide();
            $(_pageId + ".option").show();
            $(_pageId + ".trade").show();
            $(_pageId + ".openAccount").hide();
            changePage(type);
            stockAssetsInquiry(type);
        } else if (type == "0") {//普通
            common.switchingCurUser("0");
            $(_pageId + ".stock").show();
            $(_pageId + ".credit").hide();
            $(_pageId + ".option").hide();
            $(_pageId + ".trade").show();
            $(_pageId + ".openAccount").hide();
            changePage(type);
            inquiryRemind();
            stockAssetsInquiry(type);
            queryZCFX(type);
            getTradeNotices();
            resetNoticesAnimation();
        } else if (type == "3") {//开户
            $(_pageId + ".trade").hide();
            $(_pageId + ".openAccount").show();
        }
        getMsgNum();
        initVIScroll();
    }
    /*
     * 初始化首页
     */
    function initMainPage() {
        var type = $.getPageParam("_loginClass") || $(_pageId + ".header_nav .active").attr("type");
        switchPage(type);
        changeValue();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }
    /*
     * 改变从登录传过来的_loginClass值
     * 如果不改变，点击进子页面，再返回，这个值依旧存在，所以要清空
     */
    function changeValue() {
        var paramMap = sessionStorage.getItem("_curPage");
        if (paramMap) {
            if (typeof paramMap == 'string') {
                paramMap = JSON.parse(paramMap);
            }
            if (paramMap.params) {
                paramMap.params._loginClass = "";
                sessionStorage.setItem("_curPage", JSON.stringify(paramMap));
            }
        }

    }
    // 获取开户tab广告图片
    function getAdPicData(){
        if(picData != null){
            return;
        }
        commonFunc.getAdPicData({ "group_no": "trade_openaccount" }, function (data) {
            if (data.length > 0) {
                var imgUrl = global.unifyUrl;
                picData = data[0];
                if (imgUrl.indexOf("/servlet/") != -1) {
                    imgUrl = imgUrl.substring(0, imgUrl.indexOf("/servlet/"));
                }
                var image_url = data[0].image_url;
                if (image_url.indexOf("http") == 0) {
                    image_url = data[0].image_url;
                } else {
                    image_url = imgUrl + data[0].image_url;
                }
                $(_pageId + ".openAccount").html('<img src="' + image_url + '" />');
                $(_pageId + ".openAccount").css('background','linear-gradient(to bottom, #e32816 0%, #e61b0d 100%)');
            }
        });
    }
    // 获取首页公告
    function getTradeNotices(){
        var account_index_notice = $.getSStorageInfo("account_index_notice");
        // 消息通知，当前会话只显示一次
        if(account_index_notice === "1"){
            return;
        }
        var channelNo = "0",activePhone = "",appInfo;
        if($.device.android){   //通道编号   0： pc网页,  1： PC客户端   ，2： 安卓  ，3： IOS ，9：其他  
            channelNo = "2";
        }else if($.device.iPad || $.device.iPhone || $.device.ios){
            channelNo = "3";
        }else if($.device.pc){
            channelNo = "0"; 
        }
        appInfo = $.callMessage({"funcNo": "50001"}).results[0];
        activePhone = $.callMessage({"funcNo":"50043","key":"activePhone"}).results[0].value || "";
        var parem = {
            "soft_no": appInfo.softIdentifier,
            "channel": channelNo,
            "sync_module": "TRADE",
            "device_os_version": appInfo.deviceSysVersion,
            "device_model": appInfo.devicePlatform,
            "device_network_type": "3G",
            "mobile": activePhone,
            "version_code": appInfo.nativeVersionSn
        };
        service_xkj.require2001041(parem, function (oData) {
            // console.log(oData);
            var results = oData.results || [];
            if(results.length > 0){
                if(notice !== null && results[0].id === notice.id){
                    return;
                }
                notice = null;
                $(_pageId + ".notice").show();
                notice = results[0];
                resetNoticesAnimation();
            }else{
                $(_pageId + ".notice").hide();
            }
            initVIScroll();
        }, { "isShowWait": false, });
    }
    // 重置跑马灯
    function resetNoticesAnimation(){
        if(notice === null){
            return;
        }
        var shtml = "<span>" + notice.title + "</span>";
        $(_pageId + ".notice-content p").html(shtml);
        var speed = 25;
        var warpWidth = $(_pageId + ".notice-content").width();
        var contentWidth = $(_pageId + ".notice-content p").width();
        // 清除滚动动画
        $(_pageId + ".notice-content p").css("transition-duration","0s");
        $(_pageId + ".notice-content p").css("transform","translate3d(0px,0,0)");
        // 如果通知长度超出，自动滚动 
        if(contentWidth > warpWidth){
            // 添加两条，形成头尾相连的循环轮播
            $(_pageId + ".notice-content p").html(shtml + shtml);
            contentWidth = $(_pageId + ".notice-content p").width() / 2 + 50;
            var duration = contentWidth / speed;
            
            setTimeout(function(){
                // 下一帧把动画重复滚动
                $(_pageId + ".notice-content p").css("transition-duration",duration + "s");
                $(_pageId + ".notice-content p").css("transform","translate3d(-" + contentWidth + "px,0,0)");
            },0);
        }
    }
    /**
     * 从原生获取手机号
     */
    function getPhoneNumberFromApp(){
        var u = navigator.userAgent;
        var isiOS = !!u.match(/\(i[^;]+;( U;)? CPU.+Mac OS X/); //ios终端
        var oParam = {
            "funcNo": "99919",
            "targetModule": "sso",
        };
        if (isiOS) {
            oParam.funcNo = '99913';
        }
        var result = $.callMessage(oParam);
        var phoneNum = ((result.results || [])[0] || {}).activePhone || '';
        if (isiOS) {
            phoneNum = ((result.results || [])[0] || {}).phoneNum || '';
        }
        return phoneNum || '';
    }
    /**
     * 获取开户断点数据
     */
    function getOpenAccountBreakPoint(isAppCallBack) {
        // 该功能在5.0.7以后才展示
        if(common.compareVersion('5.0.7')) {
            var data = $.callMessage({ "funcNo": "50043", "key": "FileCache_Home_MenusAllways_Login" });
            if (data.error_no == '0' && data.results.length > 0) {
                var value = data.results[0].value;
                // 未登陆过资金账号
                if (value != '1') {
                    // 从原生获取手机号
                    var phoneNum = getPhoneNumberFromApp();
                    if (phoneNum) {
                        service_xkj.require4001103({ mobile_no: phoneNum }, function (oData) {
                            var results = oData.results || {};
                            var is_break_point = results.is_break_point || '0';
                            openaccount_break_link_url = results.link_url || '/huajin-open-hvue2/views/index.html#/queryProgress';
                            // 是否存在开户断点，1：存在、2：不存在
                            if (is_break_point == '1') {
                                $(_pageId + ".stock .no-login ").hide();
                                $(_pageId + ".openaccount_breakpoint").show();
                            } else {
                                $(_pageId + ".stock .no-login ").show();
                                $(_pageId + ".openaccount_breakpoint").hide();
                            }
                            initVIScroll();
                        }, { "isShowWait": false, });
                    } else {
                        $(_pageId + ".stock .no-login ").show();
                        $(_pageId + ".openaccount_breakpoint").hide();
                    }
                }else{
                    // 未登录的情况
                    var isLoginIn = $.getSStorageInfo("_isLoginIn");
                    if(!isLoginIn || isLoginIn == 'false'){
                        $(_pageId + ".stock .no-login ").show();
                    }
                    $(_pageId + ".openaccount_breakpoint").hide();
                }
            }
        }else{
            // app登录或者退出回调是需要执行这个
            if(isAppCallBack == true){
                $(_pageId + ".stock .no-login ").show();
            }
        }
        initVIScroll();
    }
        
    /*
    * 判断当前账户登录和未登录显示的内容
    */
    function changePage(type) {
        userInfo = common.getCurUserInfo();
        var isLoginIn = $.getSStorageInfo("_isLoginIn");
        var activeLogin = $.callMessage({
            "moduleName": "trade",
            "funcNo": "99919",
            "sourceModule": "trade"
        }).results[0].activePhone;
        $(_pageId + ".sign_out").hide();
        if (isLoginIn && isLoginIn != "false") { // 账号登陆
            // 普通账号登陆
            if (isLoginIn.indexOf("stock") != -1) {
                $(_pageId + ".stock .no-login ").hide();
                $(_pageId + ".stock .logined").show();
                $(_pageId + ".stock .fundaccount").html(common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
                if (type == '0') {
                    //"退出登录的按钮"
                    $(_pageId + ".sign_out").show();
                }
            } else {
                $(_pageId + ".stock .no-login ").show();
                $(_pageId + ".stock .logined").hide();
                //判断首页提示语
                if (global.callNative && global.isSso) {
                    if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                        $(_pageId + ".stock .no-login p").html("您尚未登录普通账号");
                        $(_pageId + ".stock .no-login button").html("立即登录");
                    } else {
                        $(_pageId + ".stock .no-login p").html("您尚未登录手机号码");
                        $(_pageId + ".stock .no-login button").html("立即登录");
                    }
                }
            }
            // 信用账号登陆
            if (isLoginIn.indexOf("credit") != -1) {
                $(_pageId + ".credit .no-login ").hide();
                $(_pageId + ".credit .logined").show();
                $(_pageId + ".credit .fundaccount").html(common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
                if (type == '1') {
                    //"退出登录的按钮"
                    $(_pageId + ".sign_out").show();
                }
            } else {
                $(_pageId + ".credit .no-login ").show();
                $(_pageId + ".credit .logined").hide();
                //判断首页提示语
                if (global.callNative && global.isSso) {
                    if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                        //其他模块登录
                        if (common.isTradeLogin("0") || common.isTradeLogin("2")) {
                            $(_pageId + ".credit .no-login p").html("您还没有两融账号？点击查看开通条件");
                            $(_pageId + ".credit .no-login button").html("查看条件");
                        } else {//未登录
                            $(_pageId + ".credit .no-login p").html("您尚未登录信用账号");
                            $(_pageId + ".credit .no-login button").html("立即登录");
                        }
                    } else {
                        $(_pageId + ".credit .no-login p").html("您尚未登录手机号码");
                        $(_pageId + ".credit .no-login button").html("立即登录");
                    }
                }
            }
            // 期权账号登陆
            if (isLoginIn.indexOf("option") != -1) {
                $(_pageId + ".option .no-login ").hide();
                $(_pageId + ".option .logined").show();
                $(_pageId + ".option .fundaccount").html(common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
                if (type == '2') {
                    //"退出登录的按钮"
                    $(_pageId + ".sign_out").show();
                }
            } else {
                $(_pageId + ".option .no-login ").show();
                $(_pageId + ".option .logined").hide();
                //判断首页提示语
                if (global.callNative && global.isSso) {
                    if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                        if (common.isTradeLogin("0") || common.isTradeLogin("1")) {
                            $(_pageId + ".option .no-login p").html("您尚未开通期权账户？了解更多期权业务");
                            $(_pageId + ".option .no-login button").html("了解更多");
                        } else {
                            $(_pageId + ".option .no-login p").html("您尚未登录期权账号");
                            $(_pageId + ".option .no-login button").html("立即登录");
                        }
                    } else {
                        $(_pageId + ".option .no-login p").html("您尚未登录手机号码");
                        $(_pageId + ".option .no-login button").html("立即登录");
                    }
                }
            }
        } else {
            userInfo = {};
        }
    }
    /**
     * 查询未读消息数量
     */
    function getMsgNum() {
        var data = $.callMessage({ "funcNo": "70015"});
        window.msgNumCallBack = function(param){
            msgNum = param.num || 0;
            if (msgNum > 0) {
                $(_pageId + '.unread').show();
            } else {
                $(_pageId + '.unread').hide();
            }
        }
        if($.device.android){
            if (data.error_no == '0') {
                msgNum = data.results.length > 0?parseInt(data.results[0].num):0;
            }
            if (msgNum > 0) {
                $(_pageId + '.unread').show();
            } else {
                $(_pageId + '.unread').hide();
            }
        }
    }
    /**
     * 查询是否有账号登录过
     */
    function getAccountCache(loginaccount,param) {
        var type = $(_pageId + ".header_nav .active").attr("type");
        var data = $.callMessage({"funcNo":"50043","key":"FileCache_Home_MenusAllways_Login"});
        if (data.error_no == '0' && data.results.length > 0) {
            var value = data.results[0].value;
            if(value === '1'){
                $(_pageId + ".header_nav .tab_item[type='3']").hide();
                $(_pageId + ".trade").show();
                $(_pageId + ".openAccount").hide();

                // 判断登录成功后是否需要自动跳转，如果需要，则自动切换到要跳转页面对应的tab
                if(param && param.topage && param.topage.indexOf("account/index") < 0 && param.param.switchUserInfo){
                    var user = common.getCurUserInfo(param.param.switchUserInfo);
                    // 如果统一登录的账号有对应的账号信息，就切换到对应的信息
                    if(user.fund_account){
                        switchPage(param.param.switchUserInfo);
                        return;
                    }
                }
                if(loginaccount && loginaccount.length === 8){  //判断登录账号是否为普通
                    switchPage('0');
                }else if(loginaccount && loginaccount.length > 8 && /^8\d*/.test(loginaccount)){  //判断登录账号是否为信用
                    switchPage('1');
                }else if(loginaccount && loginaccount.length > 8  && /^9\d*/.test(loginaccount)){  //判断登录账号是否为期权
                    switchPage('2');
                }else{
                    switchPage(type);
                }
            }else{
                $(_pageId + ".header_nav .tab_item[type='3']").show();
                switchPage('3');
            }
        }
    }
    /**
     * 查询首页新股，新债数量
     */
    function queryListAmount() {
        var param = {};
        param.funcNo = "310300";
        param.entrust_way = global.entrust_way;
        param.branch_no = userInfo.branch_no;
        param.fund_account = userInfo.fund_account;
        param.cust_code = userInfo.cust_code;
        param.password = userInfo.password;
        param.session_id = userInfo.session_id;
        param.new_bond_flag = "1"; //是否查询新债 0.不查询 1.查询
        param.new_stock_flag = "1"; //是否查询新股
        param.new_gz_stock_flag = "1"; //是否查询股转新股
        param.loan_flag = "1";
        // 判断行情源版本， 1 上证云行情 501159，2思迪行情 50118
        var is_trade_hq_use_by_szy = $.getSStorageInfo("is_trade_hq_use_by_szy");
        if(is_trade_hq_use_by_szy === "1"){
            service_hq.getGZNowPrice({},function(data){
                // console.log(data);
                var results = data.results;
                // 如果国债逆回购有多条数据，倒序排列，取第一条数据
                if(results.length > 1){
                    results = results.sort(function(a,b){
                        return b.now - a.now;
                    });
                    // console.log(results);
                    $(_pageId + "#gzrq").html(results[0].name?results[0].name + '天期':'--');
                    $(_pageId + "#gzll").html(results[0].now?parseFloat(results[0].now).toFixed(3) + '%':'--');
                }
            },{
                "isShowOverLay":false,
                "isShowWait":false,
                "timeOutFunc":function(){},
                "errorFunc":function(){}
            })
        }
        // 北交所新股
        // $(_pageId + ".bjszq .right-label").html("今日有--只新股");
        service_common.serviceCommonInvoke(param, function (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length) {
                    for (var i = 0; i < results.length; i++) {
                        var numberText = results[i].number;
                        if (results[i].module_name == "0") {
                            new_stocks = parseInt(results[i].number);
                        } else if (results[i].module_name == "1") {
                            $(_pageId + "#xzsl").html(numberText);
                            new_bond = parseInt(results[i].number);
                        } else if (results[i].module_name == "2" && is_trade_hq_use_by_szy !== "1") {
                            $(_pageId + "#gzrq").html(results[i].module_info);
                            $(_pageId + "#gzll").html(numberText);
                        } else if (results[i].module_name == "3") {
                            new_bjs = parseInt(results[i].number);
                            // $(_pageId + ".bjszq .right-label").html("今日有" + numberText + "只新股");
                        }
                    }
                    // 新股数量= 北交所新股+沪深新股
                    $(_pageId + "#xgsl").html(new_stocks + new_bjs);
                    $(_pageId + ".xy-xgxz .right-label").html("<span class='ared'>" + new_stocks + "</span>只新股、<span class='ared'>" + new_bond + "</span>只新债");
                }
            } else {
                $.alert(data.error_info);
                // 新股数量
                $(_pageId + "#xgsl").html("--");
                // 新债数量
                $(_pageId + "#xzsl").html("--");
                // 国债逆回购 日期
                $(_pageId + "#gzrq").html("--");
                // 国债逆回购 利率
                $(_pageId + "#gzll").html("--");
            }
            $.hidePreloader();
            initVIScroll();
        },
            {
                "isLastReq": true,
                "isShowWait": false,
                "isShowOverLay": false,
                "isGlobal": true,
                "errorFunc": function () { // 超时调用方法
                    $.hidePreloader();
                },
                "timeOutFunc": function () { // 超时调用方法
                    initVIScroll();
                }
            });
    }
    /*
     * 新发ETF数量查询
     */
    function require3001044() {
        // subscribeStatus 需要几个传几个，返回几个数据，0-待募集（即将发售），1-募集中（正在发售），2-待上市，3-已上市，4-今日上市
        service_xkj.require3001044({
            subscribeStatus: "0,1"
        }, function (data) {
            // console.log(data);
            $(_pageId + "#etfcount").html("");
            if (data.error_no == "0") {
                var results = data.results;
                if (results["1"] > 0) {
                    $(_pageId + "#etfcount").html("正在发售 <span class='ared'>" + results["1"] + "</span> 只");
                }else if(results["0"] > 0){
                    $(_pageId + "#etfcount").html("即将发售 <span class='ared'>" + results["0"] + "</span> 只");
                }else if(results["1"] === 0 && results["0"] === 0){
                    $(_pageId + "#etfcount").html("正在发售 0 ");
                }
            }
        }, {
            "isLastReq": false,
            "isShowWait": false,
            "errorFunc": function () {
            },
            "timeOutFunc": function () {
            }
        });
    }
    /*
     * 条件单数据查询
     */
    function require1001014() {
        service_xkj.require1001014({}, function (data) {
            // console.log(data);
            $(_pageId + "#zntjd-triggerred").html("--");
            $(_pageId + "#zntjd-opened").html("--");
            if (data.error_no == "0") {
                var results = data.results;
                if (results["triggers_total"] > 0) {
                    $(_pageId + "#zntjd-triggerred").html(results["triggers_total"]);
                }
                if(results["users_total"] > 0){
                    $(_pageId + "#zntjd-opened").html(results["users_total"]);
                }
            }
        }, {
            "isLastReq": false,
            "isShowWait": false,
            "errorFunc": function () {
            },
            "timeOutFunc": function () {
            }
        });
    }
    /*
     * 询价确认提醒
     */
    function inquiryRemind() {
        if (userInfo && userInfo.fund_account && '0' == userInfo._loginClass) {
            var inquiryRemindFlag = $.getLStorageInfo("inquiryRemindFlag");
            if (inquiryRemindFlag) { //有时间表示当前交易日"不需要提醒"，所以需要判断
                var dateTime = new Date().format("yyyyMMdd");
                if (dateTime == inquiryRemindFlag) {
                    return false;
                }
            }
            var param = {
                "entrust_way": global.entrust_way,
                "branch_no": userInfo.branch_no,
                "fund_account": userInfo.fund_account,
                "cust_code": userInfo.cust_code,
                "session_id": userInfo.session_id,
                "password": userInfo.password,
                "cust_name": userInfo.client_name
            };
            service_third.inquiryRemind(param, function (data) {
                if (data.error_no == "0") {
                    var results = data.results;
                    if (results.length > 0) {
                        var htmlEle = '';
                        htmlEle += '<p class="a02">尊敬的' + userInfo.client_name + '，您好！您参与的询价结果已确认。</p>';
                        htmlEle += '<dl class="a03" style="max-height: 60px;overflow: auto;">';
                        for (var i = 0; i < results.length; i++) {
                            htmlEle += '<dd><span style="color:#666666">' + results[i].issue_name + '，</span>已确认成功' + results[i].confirm_amount + '股</dd>';
                        }
                        htmlEle += '</dl>';
                        var tips = '<span style="padding:0">温馨提示：请在申购日当天按询价确认结果，履行申购义务。</span>';
                        common.waitForConfirm("询价确认提醒", htmlEle, tips, function () {
                            $.setLStorageInfo("inquiryRemindFlag", new Date().format("yyyyMMdd"));//当前交易日不在提醒
                        }, function () {
                        }, "我知道了", null, false);
                    }
                }
            }, {
                "isLastReq": false,
                "isShowWait": false,
                "errorFunc": function () {
                },
                "timeOutFunc": function () {
                }
            });
        }
    }
    /**
    * 查询普通资产信息
    */
    function stockAssetsInquiry(type) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "password": password,
            "fund_account": fund_account,
            "cust_code": cust_code,
        };
        if (userInfo && userInfo.fund_account && '0' == type) {
            param.money_type = '0'; //  0：人民币，1：美元，2：港币
            param.is_homepage = '';
            service_stock.queryFundSelect(param, function (data) {
                $(_pageId + ".stock .assets .value").css("transform", "scale(1)");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results.length > 0) {
                            for (var i = 0; i < results.length; i++) {
                                if (results[i].money_type == "0") {
                                    //总资产
                                    var assert_val = common.numToMoneyType(results[i].assert_val, 2);
                                    $(_pageId + '.stock .assets .value:eq(0)').html(assert_val);

                                    //持仓市值（没有查基金市值）
                                    var market_val = common.numToMoneyType(results[i].market_val, 2);
                                    $(_pageId + '.stock .assets .value:eq(3)').html(market_val);

                                    //总浮动盈亏
                                    var float_yks = results[i].float_yk || results[i].total_income_balance;
                                    var css = "", sign = "";
                                    //当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
                                    if (float_yks > 0) {
                                        css = "ared";
                                    } else if (float_yks < 0) {
                                        css = "agreen";
                                    }
                                    var fas = sign + common.numToMoneyType(float_yks, 2);
                                    $(_pageId + ".stock .assets .value:eq(4)").html(fas);
                                    $(_pageId + ".stock .assets .value:eq(4)").removeClass("ared").removeClass("agreen");
                                    $(_pageId + ".stock .assets .value:eq(4)").addClass(css);

                                    //现金资产（可用资金）
                                    var enable_balance = common.numToMoneyType(results[i].enable_balance, 2);
                                    $(_pageId + ".stock .kyzj_div .value").html(enable_balance);

                                    //当日参考盈亏
                                    if (results[i].dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                        var daily_income_balance = results[i].daily_income_balance;
                                        fas = $.formatMoney(daily_income_balance, 2) || daily_income_balance;
                                        $(_pageId + ".stock .jrckyk_div .value").html(fas).removeClass().addClass('value ' + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                        $(_pageId + ".stock .jrckyk_div").show();
                                        $(_pageId + ".stock .kyzj_div").hide();
                                    } else {
                                        $(_pageId + ".stock .jrckyk_div").hide();
                                        $(_pageId + ".stock .kyzj_div").show();
                                    }

                                    //字体缩放
                                    var fs = isOldMan?22:18;
                                    $(_pageId + ".stock .assets .value").each(function (idx, item) {
                                        item = $(item);
                                        item.css("transform-origin", "left");
                                        item.css("transform", "scale(" + $.getTransformScale(item.html(), fs, item.width()) + ")");
                                    });
                                }
                            }
                        } else {
                            $(_pageId + ".stock .assets .value").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
                initVIScroll();
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                }
            });
        } else if (userInfo && userInfo.fund_account && '1' == type) {
            param.money_type = ''; //  0：人民币，1：美元，2：港币
            param.is_homepage = '1';
            //最后一个为超时处理函数
            service_credit.rzrq_fundQuery(param, function (data) {
                $(_pageId + ".credit .assets .value").css("transform", "scale(1)");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results != "undefined" && results.length > 0) {
                            var data = results[0];
                            var per_assurescale_value = data.per_assurescale_value; //维持担保比例
                            $(_pageId + ".credit .assets .value:eq(3)").html(per_assurescale_value);

                            var float_yks = data.total_income_balance;
                            var fas = $.formatMoney(float_yks, 2);
                            $(_pageId + ".credit .assets .value:eq(4)").html(fas).removeClass().addClass("value " + (float_yks > 0 ? "ared" : float_yks < 0 ? "agreen" : ""));

                            var assert_val = $.formatMoney(data.assert_val, 2) || data.assert_val;  //总资产
                            $(_pageId + " .credit .assets .value:eq(0)").html(assert_val);

                            var total_debit = $.formatMoney(data.total_debit, 2) || data.total_debit; //总负债
                            $(_pageId + " .credit .zfz_div .value").html(total_debit);

                            //当日参考盈亏
                            if (data.dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                var daily_income_balance = data.daily_income_balance;
                                var daily_income_balance_show = $.formatMoney(daily_income_balance, 2) || daily_income_balance;
                                $(_pageId + ".credit .jrckyk_div .value").html(daily_income_balance_show).removeClass().addClass("value " + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                $(_pageId + ".credit .jrckyk_div").show();
                                $(_pageId + ".credit .zfz_div").hide();
                            } else {
                                $(_pageId + ".credit .jrckyk_div").hide();
                                $(_pageId + ".credit .zfz_div").show();
                            }
                            //字体缩放
                            var fs = isOldMan?22:18;
                            $(_pageId + ".credit .assets .value").each(function (idx, item) {
                                item = $(item);
                                item.css("transform-origin", "left");
                                item.css("transform", "scale(" + $.getTransformScale(item.html(), fs, item.width()) + ")");
                            });
                        } else {
                            $(_pageId + ".credit .assets .value").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
                initVIScroll();
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                }
            });
        } else if (userInfo && userInfo.fund_account && '2' == type) {
            param.money_type = '0'; //  0：人民币，1：美元，2：港币
            param.is_homepage = '1';
            param.flag = '0';
            param.account_type = '2';
            service_common.queryFundSelect(param, function (data) {
                $(_pageId + ".option .assets .value").css("transform", "scale(1)");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results.length > 0) {
                            var assert_val = $.formatMoney(results[0].total_asset, 2);
                            //总资产
                            $(_pageId + " .option .assets .value:eq(0)").html(assert_val);
                            //添加总浮动盈亏
                            //当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
                            var float_yk = results[0].income_balance || results[0].total_income_balance;
                            var css = "";
                            if (float_yk > 0) {
                                css = "ared";
                            } else if (float_yk < 0) {
                                css = "agreen";
                            }
                            var fas = $.formatMoney(float_yk, 2);
                            $(_pageId + " .option .assets .value:eq(4)").html(fas).addClass(css);
                            var marketValue = $.formatMoney(results[0].market_value, 2);
                            $(_pageId + " .option .ccsz_div .value").html(marketValue);//持仓市值

                            var total_debit = results[0].risk_degree;
                            var total = $.formatMoney(total_debit, 2);
                            $(_pageId + " .option .assets .value:eq(3)").html(total_debit);//风险度

                            //当日参考盈亏
                            if (results[0].dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                var daily_income_balance = results[0].daily_income_balance;
                                fas = $.formatMoney(daily_income_balance, 2) || daily_income_balance;
                                $(_pageId + ".option .jrckyk_div .value").html(fas).removeClass().addClass("value " + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                $(_pageId + ".option .jrckyk_div").show();
                                $(_pageId + ".option .ccsz_div").hide();
                            } else {
                                $(_pageId + ".option .jrckyk_div").hide();
                                $(_pageId + ".option .ccsz_div").show();
                            }

                            //字体缩放
                            var fs = isOldMan?22:18;
                            $(_pageId + ".option .assets .value").each(function (idx, item) {
                                item = $(item);
                                item.css("transform-origin", "left");
                                item.css("transform", "scale(" + $.getTransformScale(item.html(), fs, item.width()) + ")");
                            });
                        } else {
                            $(_pageId + ".option .assets .value").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
                initVIScroll();
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                }
            });
        }
    }
    /**
     * 查询资产分析
     */
    function queryZCFX(type) {
        var fund_account = userInfo.fund_account;
        var clientid = userInfo.cust_code;//客户编号（信用）
        var param = {
            "client_id": clientid,
            "fund_account": fund_account,
            "money_type": "0",
            "query_type": "0"
        };
        if (userInfo && userInfo.fund_account && '0' == type) {
            $(_pageId + '.stock .zcfx_no_login').hide();
            $(_pageId + '.stock .zcfx_login').show();
            service_fund.function815400(param, function (data) {
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results != null && results.length > 0) {
                            var gain_or_loss = results[0].gain_or_loss;//盈亏
                            var trade_date = results[0].trade_date.substring(4, 6);//日期
                            var gain_or_loss_int = Number(gain_or_loss).toFixed(2);
                            var trade_date_int = Number(trade_date);
                            var gain_date_str = common.numToMoneyType(gain_or_loss, 2);
                            $(_pageId + ".stock .zcfx_login .label").removeClass("ared").removeClass("agreen");
                            if (gain_or_loss_int > 0) {
                                $(_pageId + '.stock .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.stock .zcfx_login .label').html(gain_date_str);
                                $(_pageId + '.stock .zcfx_login .label').addClass('ared');
                            } else if (gain_or_loss_int < 0) {
                                $(_pageId + '.stock .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.stock .zcfx_login .label').html(gain_date_str);
                                $(_pageId + '.stock .zcfx_login .label').addClass('agreen');
                            } else {
                                $(_pageId + '.stock .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.stock .zcfx_login .label').html(gain_or_loss_int);
                                $(_pageId + '.stock .zcfx_login .label').addClass('c3');
                            }
                        } else {
                            $(_pageId + '.stock .zcfx_login .text').html('-月参考盈亏');
                            $(_pageId + '.stock .zcfx_login .label').html('--');
                        }
                    }
                }
                initVIScroll();
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                }
            });
        } else {
            $(_pageId + '.stock .zcfx_no_login').show();
            $(_pageId + '.stock .zcfx_login').hide();
            initVIScroll();
        }
        if (userInfo && userInfo.fund_account && '1' == type) {
            $(_pageId + '.credit .zcfx_no_login').hide();
            $(_pageId + '.credit .zcfx_login').show();
            service_fund.function815400(param, function (data) {
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results != null && results.length > 0) {
                            var gain_or_loss = results[0].gain_or_loss;//盈亏
                            var trade_date = results[0].trade_date.substring(4, 6);//日期
                            var gain_or_loss_int = Number(gain_or_loss).toFixed(2);
                            var trade_date_int = Number(trade_date);
                            var gain_date_str = common.numToMoneyType(gain_or_loss, 2);

                            $(_pageId + ".credit .zcfx_login .label").removeClass("ared").removeClass("agreen");
                            if (gain_or_loss_int > 0) {
                                $(_pageId + '.credit .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.credit .zcfx_login .label').html(gain_date_str);
                                $(_pageId + '.credit .zcfx_login .label').addClass('ared');
                            } else if (gain_or_loss_int < 0) {
                                $(_pageId + '.credit .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.credit .zcfx_login .label').html(gain_date_str);
                                $(_pageId + '.credit .zcfx_login .label').addClass('agreen');
                            } else {
                                $(_pageId + '.credit .zcfx_login .text').html(trade_date_int + '月参考盈亏');
                                $(_pageId + '.credit .zcfx_login .label').html(gain_or_loss_int);
                                $(_pageId + '.credit .zcfx_login .label').addClass('c3');
                            }
                        }
                    }
                }
                initVIScroll();
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                    initVIScroll();
                }
            });
        } else {
            $(_pageId + '.credit .zcfx_no_login').show();
            $(_pageId + '.credit .zcfx_login').hide();
            initVIScroll();
        }
    }
    /**
     * 点击划转获取客户登录信息
     */
    function isAStockLogin() {
        var isLogin = false;
        if (global.serverConfig == "1") {
            isLogin = false;
            $.hidePreloader();
        } else {
            var stock_userInfo = common.getCurUserInfo("0");
            var stockIonfo = common.getTransferInfo();
            if (common.isValue(stockIonfo)) {
                isLogin = false;
                $.hidePreloader();
            } else if (stock_userInfo && userInfo && stock_userInfo.cust_code === userInfo.cust_code) {
                isLogin = false;
                $.hidePreloader();
                saveInfo(stock_userInfo);
            } else {
                if (popUpLayer()) {
                    isLogin = true;
                }
            }
        }
        return isLogin;
    }
    function saveInfo(data, callback) {
        var params = {
            entrust_way: global.entrust_way, // 委托方式  在configuration配置
            branch_no: data.branch_no, // 分支机构
            cust_code: data.client_id || data.cust_code, // 客户编号
            fund_account: data.fund_account,//资金账号（普通）
            password: data.password, // 交易密码
            sessionid: data.session_id, // 会话号
            stock_account: data.stock_account, // 证券账号
            exchange_type: data.exchange_type,
            password_c: userInfo.password,// 会话号
            stockAccounts: data.stockAccounts
        };
        var type = data.fund_account + "|";
        type = type + (data._loginClass ? data._loginClass : userInfo.fund_account);
        common.setTransferInfo(type, params);
        if (callback) callback();
    }
    function popUpLayer() {
        var isLogin = false;
        if (global.serverConfig == "2") {
            isLogin = true;
            $.hidePreloader();
        } else {
            var param = {
                entrust_way: global.entrust_way, // 委托方式  在configuration配置
                branch_no: userInfo.branch_no, // 分支机构
                cust_code: userInfo.cust_code, // 客户编号
                fund_account: userInfo.fund_account,//资金账号（普通）
                password: userInfo.password, // 交易密码
                sessionid: userInfo.session_id, // 会话号
            };
            service_credit.queryStockAccount(param, function (data) {
                if (data.error_no == "0") {
                    isLogin = false;
                    $.hidePreloader();
                    var stockAccounts = $.cloneFun(data.results);
                    var datas = data.results[0];
                    if (common.isValue(datas)) {
                        datas["stockAccounts"] = stockAccounts;
                        saveInfo(datas);
                    }
                } else {
                    isLogin = false;
                    $.hidePreloader();
                    $.alert(data.error_info);
                }
            });
        }
        return isLogin;
    }
    function loginGeneralAccount(callback) {
        var pdwBox = "";
        pdwBox += '<div class="pop_main">';
        pdwBox += '<div class="input_box">';
        pdwBox += '<input type="text" id="custNo" class="text user" readonly value="' + userInfo.cust_code + '"/>';
        pdwBox += '</div><div class="input_box">';
        pdwBox += '<input js-key="password2" type="password" id="pwd" class="text pass" />';
        pdwBox += '</div></div>';
        common.iConfirm("请登录普通股票资金账户", pdwBox, function ($html) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var pwd = $html.find("input#pwd").val();
            stockALogin(pwd, callback);
        }, function () {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
        }, "登录", "取消", function ($html) {
            var pwd = $html.find("input#pwd").val();
            if (validata.isEmpty($html.find("input#custNo").val())) {
                $.alert("登录账号不能为空");
                return false;
            } else if (validata.isEmpty(pwd)) {
                $.alert("密码不能为空");
                return false;
            } else {
                return true;
            }
        });
        if (keyboard) {
            keyboard.keyInit();
        }
    }
    /**
     * 普通A股登录
     */
    function stockALogin(pwd, callback) {
        var loginParam = {
            "entrust_way": global.entrust_way, // 委托方式  在configuration配置   // 委托方式
            "branch_no": "",  // 营业部编号
            "input_type": "0",  // 账号类型
            "input_content": userInfo.cust_code,  // 登录账号
            "password": pwd,  // 交易密码
            "ticket": '',  // 图片验证码
            "mobileKey": '',  // 验证码的 mobileKey
            "ticketFlag": "0", // 0 不需要验证码 1 需要验证码
            "content_type": ""  // 客户标识类型
        };
        service_credit.goodsSwitchTradeLogin(loginParam, function (data) {
            $.hidePreloader();
            if (data.error_no != 0) {
                $.alert(data.error_info);
            } else {
                if (data.results[0]) {
                    var stockAccounts = $.cloneFun(data.results);
                    var userInfo = data.results[0];
                    userInfo["stockAccounts"] = stockAccounts;
                    userInfo.password = pwd; // 保存交易密码
                    saveInfo(userInfo, callback);
                } else {
                    $.alert("账户信息不足");
                    return false;
                }
            }
        }, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
    }
    function changeOldMan(){
        isOldMan = common.switchOldMan();
        // 切换老年版图标
        if(isOldMan){
            $(_pageId + '.first-item img').each(function(index,item){
                var _src = $(item).attr('src');
                if(_src.indexOf('-old') < 0){
                    _src = _src.replace('.png','-old.png');
                    $(item).attr('src',_src);
                }
            });
        }else{
            $(_pageId + '.first-item img').each(function(index,item){
                var _src = $(item).attr('src');
                if(_src.indexOf('-old') >= 0){
                    _src = _src.replace('-old.png','.png');
                    $(item).attr('src',_src);
                }
            });
        }
    }
    /*
     * 清空页面数据
     */
    function clearPageInfo() {
        $(_pageId + ".stock .fundaccount").html("");//普通账号展示
        $(_pageId + ".stock .assets .value").html("--");//普通交易资产
        $(_pageId + ".stock .assets .value").css("transform", "scale(1)");//普通交易资产
        $(_pageId + ".stock .assets .value").removeClass("ared").removeClass("agreen");

        $(_pageId + '.stock .zcfx_login .text').html('--月参考盈亏');
        $(_pageId + '.stock .zcfx_login .label').html("--");
        $(_pageId + '.stock .zcfx_login .label').removeClass("ared").removeClass("agreen").removeClass("c3");

        $(_pageId + '.credit .zcfx_login .text').html('--月参考盈亏');
        $(_pageId + '.credit .zcfx_login .label').html("--");
        $(_pageId + '.credit .zcfx_login .label').removeClass("ared").removeClass("agreen").removeClass("c3");

        $(_pageId + ".credit .fundaccount").html("");//两融账号展示
        $(_pageId + ".credit .assets .value").html("--");//两融资产
        $(_pageId + ".credit .assets .value").css("transform", "scale(1)");//两融资产
        $(_pageId + ".credit .assets .value").removeClass("ared").removeClass("agreen");

        $(_pageId + ".option .fundaccount").html("");//期权账号展示
        $(_pageId + ".option .assets .value").html("--");//期权资产
        $(_pageId + ".option .assets .value").css("transform", "scale(1)");//期权资产
        $(_pageId + ".option .assets .value").removeClass("ared").removeClass("agreen");
    }

    /*
     * 退出登录后改变页面标志的方法
     */
    function clearCache() {
        clearPageInfo();
        // 默认显示资产
        $(_pageId + ".eye").removeClass("eye-close").addClass("eye-open");

        $(_pageId + ".stock .assets .value").show();
        $(_pageId + ".stock .assets .conceal").hide();

        $(_pageId + ".credit .assets .value").show();
        $(_pageId + ".credit .assets .conceal").hide();

        $(_pageId + ".option .assets .value").show();
        $(_pageId + ".option .assets .conceal").hide();

        //"退出登录的按钮"
        $(_pageId + ".sign_out").hide();
    }
    /**
     * @description 埋点
     * @author cfx
     * @date 2021-06-22 13:44:14
     * @modifyContent 修改点描述...
     */
    function pointCallNative(point) {
        var parent_page_name = '';
        var parent_page_id = '';
        var type = $(_pageId + ".header_nav .active").attr("type");
        if (type == '0') {
            parent_page_name = '交易-普通交易首页';
            parent_page_id = 'PageOrdinaryTradeHome';
        } else if (type == '1') {
            parent_page_name = '交易-信用交易首页';
            parent_page_id = 'PageCreditTradeHome';
        } else if (type == '2') {
            parent_page_name = '交易-期权交易首页';
            parent_page_id = 'PageOptionTradeHome';
        }
        common.pointCallNative({
            module_name: '交易',
            module_id: 'yjapp.trade',
            parent_page_name: parent_page_name,
            parent_page_id: parent_page_name,
            actionType: point.actionType || 'click',
            object_name: point.object_name || '',
            object_id: point.object_id || '',
        });
    }

    /**
     * 销毁
     */
    function destroy() {
        $.clearRequest();
        clearPageInfo();
        initVIScroll();
    }
    function takeScreenshot(){
        var type = $(_pageId + ".header_nav .active").attr('type');
        if (type !== "3" && common.isTradeLogin(type)) {
            nativePluginService.function50106({
                content: "您的手机正在进行截屏，请注意信息保护"
            });
        }
    }

    setTimeout(function (){
        getAccountCache();
    },30);
    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "getAccountCache": getAccountCache,
        "initVIScroll": initVIScroll,
        "takeScreenshot": takeScreenshot,
        "noLoginData": noLoginData,
        "destroy": destroy,
        "clearCache": clearCache,
    };
    module.exports = base;
});
