/**
 * 两融交易模块 js
 */
define('trade/scripts/account/indexCredit.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#account_index ";
    var indexPort = null;
    var loadingTimes = 0;
    var _idType = "1";
    var commonTimer = require("commonTimer");
    var commonFunc = require("commonFunc");
    var common = require("common");
    var commonHq = require("commonHq");
    var service_common = require("service_common");
    var service_credit = require("service_credit");

    var service_fund = require("service_fund");
    require("validatorUtils");
    var validata = $.validatorUtils;
    var keyboard = require("keyboard");
    var userInfo = null;
    var adPicOpts = {};
    var _initVIScroll = null;

    /**
     * 初始化
     */
    function init() {
        pointCallNative({
            actionType: 'view',
            parent_page_name:'交易-信用交易首页',
        });
        _idType = "1";
        $(_pageId + ".stock").hide();
        $(_pageId + ".credit").show();
        $(_pageId + ".option").hide();
        common.switchingCurUser(_idType);
        userInfo = common.getCurUserInfo();
        var isLoginIn = $.getSStorageInfo("_isLoginIn");
        if (isLoginIn && isLoginIn != "false" && isLoginIn.indexOf("credit") != -1) {
            creditQueryData();
            changePage(common.isTradeLogin(_idType));
            // commonFunc.setJurisdiction(userInfo); // 更新权限
        } else {
            userInfo = null;
            changePage(false);
        }
        queryAdPic();

    }

    function queryAdPic() {
        commonFunc.getAdPicData({"group_no": "credit"}, function (data) {
            if (!data || data.length == 0) {
                $(_pageId + ".credit #group").css("padding-bottom", "0rem");
                $(_pageId + ".credit .credit_nav_list:eq(1)").addClass("mt10");
            } else {
                $(_pageId + ".credit #group").css("padding-bottom", "0.1rem");
                $(_pageId + ".credit .credit_nav_list:eq(1)").addClass("mt10");
                // $(_pageId + ".credit .credit_nav_list:eq(1)").removeClass("mt10");
            }
            if (!$(_pageId + ".credit").height()) {
                return;
            }
            adPicOpts.divFrame = $(_pageId + ".credit #group");
            adPicOpts.height = 60;
            common.createAdPicGroup(adPicOpts, data);
        });
    }

    function creditQueryData() {
        queryCapital(_idType);
        queryZCFX();
    }

    /**
     * 查询信用资产信息
     */
    function queryCapital(id) {
        if (userInfo && userInfo.fund_account && id == userInfo._loginClass) {
            changePage(true);
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var password = userInfo.password;
            var cust_code = userInfo.cust_code;//关联资产账户标志
            var money_type = "";  //  0：人民币，1：美元，2：港币
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "password": password,
                "cust_code": cust_code,
                "money_type": money_type,
                "is_homepage": "1"
            };
            //最后一个为超时处理函数
            service_credit.rzrq_fundQuery(param, function (data) {
                $(_pageId + ".credit .j-data-item .j-data-info .exhibition").css("zoom", "1");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results != "undefined" && results.length > 0) {
                            var data = results[0];
                            var per_assurescale_value = data.per_assurescale_value; //维持担保比例
                            $(_pageId + " .credit .j-data-item .j-data-info .exhibition:eq(0)").html(per_assurescale_value);

                            var float_yks = data.total_income_balance;
                            var fas = $.formatMoney(float_yks, 2);
                            $(_pageId + ".credit #cczyk").html(fas).removeClass().addClass("exhibition " + (float_yks > 0 ? "ared" : float_yks < 0 ? "agreen" : ""));

                            var assert_val = $.formatMoney(data.assert_val, 2) || data.assert_val;  //总资产
                            $(_pageId + " .credit .j-data-item .j-data-info .exhibition:eq(2)").html(assert_val);

                            var total_debit = $.formatMoney(data.total_debit, 2) || data.total_debit; //总负债
                            $(_pageId + " .credit .j-data-item .j-data-info #zfz").html(total_debit);

                            //当日参考盈亏
                            if (data.dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                var daily_income_balance = data.daily_income_balance;
                                var daily_income_balance_show = $.formatMoney(daily_income_balance, 2)||daily_income_balance;
                                $(_pageId + ".credit #jrckyk").html(daily_income_balance_show).removeClass().addClass("exhibition " + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                $(_pageId + ".credit #jrckyk_div").show();
                                $(_pageId + ".credit #zfz_div").hide();
                            } else {
                                $(_pageId + ".credit #jrckyk_div").hide();
                                $(_pageId + ".credit #zfz_div").show();
                            }

                            //字体缩放
                            var fontNarrow = function ($div) {
                                return common.getMaxFontSize($div);
                            }
                            $(_pageId + ".credit .j-data-item .j-data-info .exhibition").each(function (idx, item) {
                                item = $(item);
                                item.css("zoom", fontNarrow(item));
                            });
                        } else {
                            $(_pageId + " .credit .j-data-item .j-data-info .exhibition").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
        } else {
            changePage(false);
        }
    }

    /**
     * 查询资产分析
     */
    function queryZCFX() {
        if (userInfo && userInfo.fund_account) {
            changePage(true);
            var fund_account = userInfo.fund_account;
            var clientid = userInfo.cust_code;//客户编号（信用）
            var param = {
                "client_id": clientid,
                "fund_account": fund_account,
                "money_type": "0",
                "query_type": "0"
            };
            //最后一个为超时处理函数
            service_fund.function815400(param, function (data) {
                console.log(data);
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results =data.results;
                        if(results!=null&&results.length>0){
                            var gain_or_loss =results[0].gain_or_loss;//盈亏
                            var trade_date = results[0].trade_date.substring(4,6);//日期
                            var gain_or_loss_int=Number(gain_or_loss).toFixed(2);
                            var trade_date_int = Number(trade_date);
                            var html='';

                            var gain_date_str = common.numToMoneyType(gain_or_loss, 2);
                            if(gain_or_loss_int>0){
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: #EE4034;font-size: 0.2rem">'+gain_date_str+'</span></p><span class="n-sel-text">资产分析</span>'
                            }else if(gain_or_loss_int<0){
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: green;font-size: 0.2rem">'+gain_date_str+'</span></p><span class="n-sel-text">资产分析</span>'
                            }else{
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: #333333;font-size: 0.2rem">'+gain_or_loss_int+'</span></p><span class="n-sel-text">资产分析</span>'
                            }
                            $(_pageId+"#credit_byckyk ul li").html(html);
                        }
                    }
                }
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
        } else {
            changePage(false);
        }
    }

    /*
     * 判断当前账户登录和未登录显示的内容
     */
    function changePage(login) {
        if (login) {
            $(_pageId + ".credit .n_not_login ").hide();
            $(_pageId + ".credit .j-stock-data").show();
            $(_pageId + ".credit #zfz_div").hide();
            $(_pageId + ".n_sign_out").show();
            $(_pageId + "#credit_byckyk").show();
            $(_pageId + ".credit .j-stock-data .j-position-box p").html("资金账号：" + common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
        } else {
            $(_pageId + ".credit .n_not_login ").show();
            $(_pageId + ".credit .j-stock-data").hide();
            $(_pageId + ".n_sign_out").hide();
            $(_pageId + "#credit_byckyk").hide();
            $(_pageId + ".credit .j-stock-data .j-position-box p").html("");
            //判断首页提示语
            if (global.callNative && global.isSso) {
                var activeLogin = $.callMessage({
                    "moduleName": "trade",
                    "funcNo": "99919",
                    "sourceModule": "trade"
                }).results[0].activePhone;
                if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                    //其他模块登录
                    if (!login && (common.isTradeLogin("0") || common.isTradeLogin("2"))) {
                        $(_pageId + ".credit .n_not_login .n_box_con h3").html("您还没有两融账号？点击查看开通条件");
                        $(_pageId + ".credit .n_not_login .n_box_con .n_btn_box").html("查看条件");
                    } else {//未登录
                        $(_pageId + ".credit .n_not_login .n_box_con h3").html("您尚未登录信用账号");
                        $(_pageId + ".credit .n_not_login .n_box_con .n_btn_box").html("立即登录");
                    }
                } else {
                    $(_pageId + ".credit .n_not_login .n_box_con h3").html("您尚未登录手机号码");
                    $(_pageId + ".credit .n_not_login .n_box_con .n_btn_box").html("立即登录");
                }
            } else {
                //其他模块登录
                if (!login && (common.isTradeLogin("0") || common.isTradeLogin("2"))) {
                    $(_pageId + ".credit .n_not_login .n_box_con h3").html("您还没有两融账号？点击查看开通条件");
                    $(_pageId + ".credit .n_not_login .n_box_con .n_btn_box").html("查看条件");
                } else {//未登录
                    $(_pageId + ".credit .n_not_login .n_box_con h3").html("您尚未登录信用账号");
                    $(_pageId + ".credit .n_not_login .n_box_con .n_btn_box").html("立即登录");
                }
            }
        }
    }

    /**
     * 事件绑定
     */
    function jumpPageEvent() {

        //资产分析
        $.bindEvent($(_pageId+"#credit_byckyk ul li"), function (e) {
            pointCallNative({
                object_name: '点击信用交易首页-历史资产分析按钮',
                object_id: 'ButtonHistoricalAssetAnalysis',
            });
            if (global.callNative && global.isSso) {
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "14",//打开风险警示权限开通页面
                        "title": "",
                    }
                }
                $.callMessage(param);
            }
            e.stopPropagation();
        });

        //资产的隐藏显示
        $.bindEvent($(_pageId + ".credit .j-position-box .switch_btn"), function (e) {
            var i_change_to = "";
            if ($(this).hasClass("hide")) {
                $(this).removeClass("hide").addClass("show");
                $(_pageId + ".credit .j-data-item .j-data-info .exhibition").show();
                $(_pageId + ".credit .j-data-item .j-data-info .conceal").hide();
                i_change_to = "展示";
            } else {
                $(this).addClass("hide").removeClass("show");
                $(_pageId + ".credit .j-data-item .j-data-info .exhibition").hide();
                $(_pageId + ".credit .j-data-item .j-data-info .conceal").show();
                i_change_to = "屏蔽";
            }
            common.comStat(100006, 2, 104, true, {"i_change_name": "屏蔽资产", "i_change_to": i_change_to});//埋点
            pointCallNative({
                object_name: '点击信用交易首页-资产隐藏按钮-' + i_change_to,
                object_id: 'ButtonCreditAssetHide',
            });
            e.stopPropagation();
        });

        //今日参考盈亏说明
        $.bindEvent($(_pageId + " #jrckyk_div").find("a"), function (e) {
            var msg = '';
            msg += '<p>1.交易日仅9:25-16:00期间显示,不参与晚间清算,仅供盘中参考;</p>';
            msg += '<p>2.非交易日不显示;</p>';
            msg += '<p>3.已计入交易手续费,但不包括理财产品收益;</p>';
            msg += '<p>4.若昨日有股票分红、配股等情况,可能导致今日参考盈亏计算不准确;</p>';
            msg += '<p>5.今日参考盈亏仅为参考值,不作为具体的投资参考意见,请以账户实际收益为准。</p>';
            common.singleIConfirmNew("今日参考盈亏", msg, null, "我知道了");
            pointCallNative({
                object_name: '点击信用交易首页-今日参考盈亏注释按钮',
                object_id: 'ButtonTodayProfitAndLossComment',
            });
            e.preventDefault();
            e.stopPropagation();
        });

        // 登录
        $.bindEvent($(_pageId + ".credit .n_not_login .n_btn_box"), function (e) {
            common.switchingCurUser("1");
            if ($(this).html() == "查看条件") {
                pointCallNative({
                    object_name: '点击信用交易首页-查看条件按钮',
                    object_id: 'ButtonCreditCommonProblem.top',
                });
                $.pageInit("account/index", "account/permissionOpening", {"type": 1});
            } else {
                commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {"_loginClass": _idType}, {
                    "topage": "",
                    "param": {"switchUserInfo": "1"}
                });
                common.comStat(107479, 2, 103, true, {"i_group_name": "登录信用交易"});//埋点
                pointCallNative({
                    object_name: '点击信用交易首页-立即登录按钮',
                    object_id: 'ButtonTradeLogin',
                });
            }
            e.stopPropagation();
        });


        // 主页菜单事件绑定（图标）
        $.bindEvent($(_pageId + ".credit .credit_nav_list a"), function (e) {
            common.switchingCurUser("1");
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param") || {}; // 获取跳转页面参数
            var paramMap = {"switchUserInfo": "1"};
            if (param) {
                paramMap.param = param;
            }
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            pointCallNative({
                object_name: '点击信用交易首页-' + name + '按钮',
                object_id: object_id,
            });
            $.pageInit("account/index", topage, {"param": paramMap});
            e.stopPropagation();
            e.preventDefault();
        });


        // 主页菜单事件绑定（tab）
        $.bindEvent($(_pageId + ".credit .credit_link_list .list_con li"), function (e) {
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param"); // 获取跳转页面参数
            var type = $(this).attr("type");
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});//埋点
            pointCallNative({
                object_name: '点击信用交易首页-' + name + '按钮',
                object_id: object_id,
            });
            if (['banking/transfer','banking/transferNew'].indexOf(topage) > -1) {//当普通登录，信用没有登录的时候，跳转银证转账就有问题
                param = param || {}; // 获取跳转页面参数
                common.switchingCurUser("1");
                var paramMap = {"switchUserInfo": "1"};
                if (param) {
                    paramMap.param = param;
                }
                //没有登录的情况
                if (!common.isTradeLogin(1)) {
                    commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                        "_loginClass": _idType,
                        "topage": topage,
                        "param": param
                    }, {"topage": topage, "param": paramMap});
                } else {//登录的情况
                    $.pageInit("account/index", topage, {"param": paramMap});
                }
            } else if (topage == "credit/transferred/collateralTransferIn") {//担保品划转
                common.switchingCurUser("1");
                //没有登录的情况
                if (!common.isTradeLogin(type)) {
                    commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                        "_loginClass": _idType,
                        "topage": $.getCurrentPageObj().pageCode,
                        "param": param
                    }, {"topage": $.getCurrentPageObj().pageCode, "param": paramMap});
                } else {
                    $.showPreloader("请等待...");
                    if (!param) {
                        param = "";
                    }
                    if (isAStockLogin()) {
                        loginGeneralAccount(function () {
                            $.pageInit("account/index", topage, {"param": param});
                        });
                    } else {
                        $.pageInit("account/index", topage, {"param": param});
                    }
                }
            } else if (topage == "nsb/index") {
                var paramMap = {"switchUserInfo": "1", "newStockType": "1"};
                $.setSStorageInfo("stockFlag", "", true);
                $.setSStorageInfo("bjsFlag", "", true);
                //新股申购
                if (param == "newStock") {//智能打新
                    var newShareCount=$(_pageId+'#crdeitNewShare').html().replace(/\D+/g,"");//新股数量
                    var newStockCount=$(_pageId+'#crdeitNewPurchase').html().replace(/\D+/g,"");//新债数量
                    if(null!=newShareCount&&""!=newShareCount&&"-"!=newShareCount&&Number(newShareCount)>0){
                        paramMap.isStocks = true;
                    }else{
                        if(null!=newStockCount&&""!=newStockCount&&"-"!=newStockCount&&Number(newStockCount)>0){
                            paramMap.isStocks = false;
                        }else{
                            paramMap.isStocks = true;
                        }
                    }
                    //paramMap.isStocks = true;
                    $.pageInit("account/index", topage, {"param": paramMap});
                } else {//可转债
                    paramMap.isStocks = false;
                    $.pageInit("account/index", topage, {"param": paramMap});
                }
            } else {
                common.switchingCurUser("1");
                var paramMap = {"switchUserInfo": "1"};
                //没有登录的情况
                if (!common.isTradeLogin(type)) {
                    commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                        "_loginClass": _idType,
                        "topage": topage,
                        "param": param
                    }, {"topage": topage, "param": paramMap});
                } else {//登录的情况
                    //两融以及普通科创板权限校验
                    if (global.account_kcbJurisdiction && $(this).attr("kcbCheck")) {
                        commonFunc.kcbJurisdiction(1, userInfo, function (_rights) {
                            if (_rights != "0") {//科创板权限（1无权限，0有权限）
                                topage = "kcb/kcbDistrict";
                            }
                            $.pageInit("account/index", topage, {"param": paramMap});
                        });
                    } else {
                        $.pageInit("account/index", topage, {"param": paramMap});
                    }
                }
            }
            e.stopPropagation();
            e.preventDefault();
        });

        //点击跳转到持仓
        $.bindEvent($(_pageId + ".credit .j-stock-data .j-data-item"), function (e) {
            pointCallNative({
                object_name: '点击信用交易首页-进入持仓按钮',
                object_id: 'ButtonCreditHolding',
            });
            $.pageInit("account/index", "credit/asset/asset", {"param": ""});
            e.stopPropagation();
        });
    }

    /**
     * 点击划转获取客户登录信息
     */
    function isAStockLogin() {
        var isLogin = false;
        if (global.serverConfig == "1") {
            isLogin = false;
            $.hidePreloader();
        } else {
            var stock_userInfo = common.getCurUserInfo("0");
            var stockIonfo = common.getTransferInfo();
            if (common.isValue(stockIonfo)) {
                isLogin = false;
                $.hidePreloader();
            } else if (stock_userInfo && userInfo && stock_userInfo.cust_code === userInfo.cust_code) {
                isLogin = false;
                $.hidePreloader();
                saveInfo(stock_userInfo);
            } else {
                if (popUpLayer()) {
                    isLogin = true;
                }
            }
        }
        return isLogin;
    }

    function saveInfo(data, callback) {
        var params = {
            entrust_way: global.entrust_way, // 委托方式  在configuration配置
            branch_no: data.branch_no, // 分支机构
            cust_code: data.client_id || data.cust_code, // 客户编号
            fund_account: data.fund_account,//资金账号（普通）
            password: data.password, // 交易密码
            sessionid: data.session_id, // 会话号
            stock_account: data.stock_account, // 证券账号
            exchange_type: data.exchange_type,
            password_c: userInfo.password,// 会话号
            stockAccounts: data.stockAccounts
        };
        var type = data.fund_account + "|";
        type = type + (data._loginClass ? data._loginClass : userInfo.fund_account);
        common.setTransferInfo(type, params);
        if (callback) callback();
    }

    function popUpLayer() {
        var isLogin = false;
        if (global.serverConfig == "2") {
            isLogin = true;
            $.hidePreloader();
        } else {
            var param = {
                entrust_way: global.entrust_way, // 委托方式  在configuration配置
                branch_no: userInfo.branch_no, // 分支机构
                cust_code: userInfo.cust_code, // 客户编号
                fund_account: userInfo.fund_account,//资金账号（普通）
                password: userInfo.password, // 交易密码
                sessionid: userInfo.session_id, // 会话号
            };
            service_credit.queryStockAccount(param, function (data) {
                if (data.error_no == "0") {
                    isLogin = false;
                    $.hidePreloader();
                    var stockAccounts = $.cloneFun(data.results);
                    var datas = data.results[0];
                    if (common.isValue(datas)) {
                        datas["stockAccounts"] = stockAccounts;
                        saveInfo(datas);
                    }
                } else {
                    isLogin = false;
                    $.hidePreloader();
                    $.alert(data.error_info);
                }
            });
        }
        return isLogin;
    }

    function loginGeneralAccount(callback) {
        var pdwBox = "";
        pdwBox += '<div class="pop_main">';
        pdwBox += '<div class="input_box">';
        pdwBox += '<input type="text" id="custNo" class="text user" readonly value="' + userInfo.cust_code + '"/>';
        pdwBox += '</div><div class="input_box">';
        pdwBox += '<input js-key="password2" type="password" id="pwd" class="text pass" />';
        pdwBox += '</div></div>';
        common.iConfirm("请登录普通股票资金账户", pdwBox, function ($html) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var pwd = $html.find("input#pwd").val();
            stockALogin(pwd, callback);
        }, function () {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
        }, "登录", "取消", function ($html) {
            var pwd = $html.find("input#pwd").val();
            if (validata.isEmpty($html.find("input#custNo").val())) {
                $.alert("登录账号不能为空");
                return false;
            } else if (validata.isEmpty(pwd)) {
                $.alert("密码不能为空");
                return false;
            } else {
                return true;
            }
        });
        if (keyboard) {
            keyboard.keyInit();
        }
    }

    /**
     * 普通A股登录
     */
    function stockALogin(pwd, callback) {
        var loginParam = {
            "entrust_way": global.entrust_way, // 委托方式  在configuration配置   // 委托方式
            "branch_no": "",  // 营业部编号
            "input_type": "0",  // 账号类型
            "input_content": userInfo.cust_code,  // 登录账号
            "password": pwd,  // 交易密码
            "ticket": '',  // 图片验证码
            "mobileKey": '',  // 验证码的 mobileKey
            "ticketFlag": "0", // 0 不需要验证码 1 需要验证码
            "content_type": ""  // 客户标识类型
        };
        service_credit.goodsSwitchTradeLogin(loginParam, function (data) {
            $.hidePreloader();
            if (data.error_no != 0) {
                $.alert(data.error_info);
            } else {
                if (data.results[0]) {
                    var stockAccounts = $.cloneFun(data.results);
                    var userInfo = data.results[0];
                    userInfo["stockAccounts"] = stockAccounts;
                    userInfo.password = pwd; // 保存交易密码
                    saveInfo(userInfo, callback);
                } else {
                    $.alert("账户信息不足");
                    return false;
                }
            }
        }, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
    }
    
    /**
     * @description 埋点   
     * @author cfx   
     * @date 2021-06-22 13:44:14   
     * @modifyContent 修改点描述...   
     */
    function pointCallNative(point){
        common.pointCallNative({
            module_name: '交易',
            module_id: 'yjapp.trade',
            parent_page_name: point.parent_page_name || '交易-信用交易首页',
            parent_page_id: point.parent_page_id || 'PageCreditTradeHome',
            actionType: point.actionType || 'click' ,
            object_name: point.object_name,
            object_id: point.object_id,
        });
    }

    /**
     * 销毁
     */
    function destroy() {
        commonTimer.clearTimer(_pageId);
        adPicOpts.scrollDestroy && adPicOpts.scrollDestroy();
    }

    var base = {
        "init": init,
        "jumpPageEvent": jumpPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
