/**
 * 期权交易模块 js
 */
define('trade/scripts/account/indexOption.js', function (require, exports, module) {
    var nativePluginService = require("nativePluginService");
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#account_index ";
    var indexPort = null;
    var loadingTimes = 0;
    var _idType = "2";
    var commonTimer = require("commonTimer");
    var common = require("common");
    var commonHq = require("commonHq");
    var commonFunc = require("commonFunc");
    var service_common = require("service_common");
    var service_option = require("service_option");
    var userInfo = null;
    var _initVIScroll = null;

    /**
     * 初始化
     */
    function init() {
        pointCallNative({
            actionType: 'view',
            parent_page_name:'交易-信用交易首页',
        });
        _idType = "2";
        common.switchingCurUser(_idType);
        userInfo = common.getCurUserInfo();
        $(_pageId + ".stock").hide();
        $(_pageId + ".credit").hide();
        $(_pageId + ".option").show();
        var isLoginIn = $.getSStorageInfo("_isLoginIn");
        if (isLoginIn && isLoginIn != "false" && isLoginIn.indexOf("option") != -1) {
            changePage(common.isTradeLogin(_idType));
            queryData();
        } else {
            userInfo = null;
            changePage(false);
            $.hidePreloader();
        }
        setShortcutToHQ();
    }

    /**
     * 设置是否展示跳转到上证/深证期权的入口
     * 如果高于等于3.9.0版本则展示 否则隐藏
     */
    function setShortcutToHQ(){
        var appVersion = nativePluginService.function50001();
        if (appVersion && appVersion.results && appVersion.results.length > 0) {
            var currentVersion = appVersion.results[0].nativeVersion || "";
            if (common.compareLimitVersion("3.9.0", currentVersion)) {
                $(_pageId+ ".option .n-option-info").show();
            }else {
                $(_pageId+ ".option .n-option-info").hide();
            }
        }
    }

    /*
     * 查询接口
     */
    function queryData() {
        queryFundSelect(_idType);
        rightAssignmentQuery(_idType);
    }

    /*
     * 查询资产
     */
    function queryFundSelect(id) {
        if (userInfo && userInfo.fund_account && id == userInfo._loginClass) {
            changePage(true);
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var cust_code = userInfo.cust_code;//关联资产账户标志
            var money_type = "0";  //  0：人民币，1：美元，2：港币
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "money_type": money_type,
                "flag": "0",
                "account_type": "2"
            };
            service_common.queryFundSelect(param, function (data) {
                $(_pageId + ".option .j-stock-data .j-data-info .exhibition").css("zoom", "1");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results.length > 0) {
                            if (userInfo && userInfo._loginClass == "2" && _idType == "2") {
                                var assert_val = $.formatMoney(results[0].total_asset, 2);
                                //总资产
                                $(_pageId + " .option .j-stock-data .j-data-info .exhibition:eq(0)").html(assert_val.substring(0, assert_val.length - 2) + "<span>" + assert_val.substr(-2) + "</span>");
                                //添加总浮动盈亏
                                //当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
                                var float_yk = results[0].income_balance || results[0].total_income_balance;
                                var css = "";
                                if (float_yk > 0) {
                                    css = "ared";
                                } else if (float_yk < 0) {
                                    css = "agreen";
                                }
                                var fas = $.formatMoney(float_yk, 2);
                                $(_pageId + " .option .j-stock-data .j-data-info .exhibition:eq(1)").html(fas.substring(0, fas.length - 2) + "<span>" + fas.substr(-2) + "</span>").addClass(css);
                                var marketValue = $.formatMoney(results[0].market_value, 2);
                                $(_pageId + " .option .j-stock-data .j-data-info #ccsz").html(marketValue);//持仓市值

                                var total_debit = results[0].risk_degree;
                                var total = $.formatMoney(total_debit, 2);
                                $(_pageId + " .option .j-stock-data .j-data-info .exhibition:eq(2)").html(total_debit);//风险度

                                //当日参考盈亏
                                if (results[0].dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                    var daily_income_balance = results[0].daily_income_balance;
                                    fas = $.formatMoney(daily_income_balance, 2) || daily_income_balance;
                                    $(_pageId + ".option #jrckyk").html(fas).removeClass().addClass("exhibition " + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                    $(_pageId + ".option #jrckyk_div").show();
                                    $(_pageId + ".option #ccsz_div").hide();
                                } else {
                                    $(_pageId + ".option #jrckyk_div").hide();
                                    $(_pageId + ".option #kyzj_div").show();
                                    $(_pageId + ".option #jrckyk").parent().hide().siblings().show();
                                }

                                //字体缩放
                                var fontNarrow = function ($div) {
                                    return common.getMaxFontSize($div);
                                }
                                $(_pageId + ".option .j-data-item .j-data-info .exhibition").each(function (idx, item) {
                                    item = $(item);
                                    item.css("zoom", fontNarrow(item));
                                });
                            }
                        } else {
                            $(_pageId + " .option .j-data-item .j-data-info .exhibition").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
        } else {
            changePage(false);
        }
    }


    /*
     * 查询行权和指派的条数
     */
    function rightAssignmentQuery(id) {
        if (userInfo && userInfo.fund_account && id == userInfo._loginClass) {
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var cust_code = userInfo.cust_code;
            var password = userInfo.password;
            var session_id = userInfo.session_id;
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "password": password,
                "session_id": session_id
            };
            service_option.rightAssignmentQuery(param, function (data) {
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results.length > 0) {
                            $(_pageId + "#optionExercise").html(results[0].DRXQ + "张行权   " + results[0].XQZP + "张指派");
                        } else {
                            $(_pageId + "#optionExercise").html("");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
            });
        }
    }

    /**
     * 事件绑定
     */
    function jumpPageEvent() {
        //资产的隐藏显示
        $.bindEvent($(_pageId + ".option .j-position-box .switch_btn"), function (e) {
            var i_change_to = "";
            if ($(this).hasClass("hide")) {
                $(this).removeClass("hide").addClass("show");
                $(_pageId + ".option .j-data-item .j-data-info .exhibition").show();
                $(_pageId + ".option .j-data-item .j-data-info .conceal").hide();
                i_change_to = "展示";
            } else {
                $(this).addClass("hide").removeClass("show");
                $(_pageId + ".option .j-data-item .j-data-info .exhibition").hide();
                $(_pageId + ".option .j-data-item .j-data-info .conceal").show();
                i_change_to = "屏蔽";
            }
            common.comStat(100006, 2, 104, true, {"i_change_name": "屏蔽资产", "i_change_to": i_change_to});//埋点
            pointCallNative({
                object_name: '点击期权交易首页-资产隐藏按钮-' + i_change_to,
                object_id: 'ButtonOptionAssetHide',
            });
            e.stopPropagation();
        });

        // 登录
        $.bindEvent($(_pageId + ".option .n_not_login .n_btn_box"), function (e) {
            common.switchingCurUser("2");
            if ($(this).html() == "了解更多") {
                $.pageInit("account/index", "account/optionPermissionOpening", {"type": 2});
                pointCallNative({
                    object_name: '点击期权交易首页-了解更多按钮',
                    object_id: 'ButtonOptionCommonProblem',
                });
            } else {
                commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {"_loginClass": _idType}, {
                    "topage": "",
                    "param": {"switchUserInfo": "2"}
                });
                common.comStat(107001, 2, 103, true, {"i_group_name": "登录个股期权交易"});//埋点
                pointCallNative({
                    object_name: '点击期权交易首页-立即登录按钮',
                    object_id: 'ButtonTradeLogin',
                });
            }
            e.stopPropagation();
        });


        // 主页菜单事件绑定（图标）
        $.bindEvent($(_pageId + " .option .n_nav_box .n_nav_list li"), function (e) {
            common.switchingCurUser("2");
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param"); // 获取跳转页面参数
            var paramMap = {"switchUserInfo": "2"};
            if (topage == "option/query/queryToday") { //当日委托/当日历史
                paramMap = param;
            }
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            objectId && common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            pointCallNative({
                object_name: '点击期权交易首页-' + name + '按钮',
                object_id: object_id,
            });
            if (userInfo && userInfo.fund_account) {
                $.pageInit("account/index", topage, {"param": paramMap});
                $(this).unbind(e.type);
                this[e.type] = null;
            }else {
                commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                    "topage": topage,
                    "param": paramMap,
                    "_loginClass": _idType
                }, {
                    "topage": topage,
                    "param": paramMap
                });
            }
            e.stopPropagation();
            e.preventDefault();
        });

        // 主页菜单事件绑定（上证期权、深证期权）
        $.bindEvent($(_pageId + ".n-option-info li"), function (e) {
            e.stopPropagation();
            e.preventDefault();
            var topage = $(this).attr("to-page"); // 获取跳转的页面
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            pointCallNative({
                object_name: '点击期权交易首页-' + name + '按钮',
                object_id: object_id,
            });
            var title="上证期权";
            var mdInfo=1654;
            var request_type="60:61";
            if (topage == "SZ" ) { //深证期权
                title="深证期权";
                mdInfo=1655;
                request_type="62:63"
            }
            var param = {
                "mdInfo":mdInfo,
                "title":title,
                "request_type":request_type
            }
            nativePluginService.function501153(param);
        });

        // 主页菜单事件绑定
        $.bindEvent($(_pageId + " .option .n_sel_list .n_list_con li"), function (e) {
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param"); // 获取跳转页面参数
            var paramMap = {"switchUserInfo": "2"};
            common.switchingCurUser("2");
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            objectId && common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            pointCallNative({
                object_name: '点击期权交易首页-' + name + '按钮',
                object_id: object_id,
            });
            if ((userInfo && userInfo.fund_account) ||  topage == "account/optionPermissionOpening") {
                $.pageInit("account/index", topage, {"param": paramMap});
                $(this).unbind(e.type);
                this[e.type] = null;
            } else {
                commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {
                    "topage": topage,
                    "param": paramMap,
                    "_loginClass": _idType
                }, {
                    "topage": topage,
                    "param": paramMap
                });
            }
            e.stopPropagation();
            e.preventDefault();
        });

        //点击跳转到持仓
        $.bindEvent($(_pageId + ".option .j-stock-data .j-data-info").add($(_pageId + ".option .j-stock-data .entrance_btn")), function (e) {
            // common.comStat(100661, 2, 103, true, {"i_group_name": "资产跳转"});//埋点
            pointCallNative({
                object_name: '点击期权交易首页-进入持仓按钮',
                object_id: 'ButtonOptionHolding',
            });
            $.pageInit("account/index", "option/position/holdingsQuery", {"param": ""});
            e.stopPropagation();
        });

    }

    /*
     * 判断当前账户登录和未登录显示的内容
     */
    function changePage(login) {
        if (login) {
            $(_pageId + ".option .n_not_login ").hide();
            $(_pageId + ".option .j-stock-data").show();
            $(_pageId + ".n_sign_out").show();
            $(_pageId + ".option .j-stock-data .j-position-box p").html("资金账号：" + common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
        } else {
            $(_pageId + ".option .n_not_login ").show();
            $(_pageId + ".option .j-stock-data").hide();
            $(_pageId + ".n_sign_out").hide();
            $(_pageId + ".option .j-stock-data .j-position-box p").html("");
            //判断首页提示语
            if (global.callNative && global.isSso) {
                var activeLogin = $.callMessage({
                    "moduleName": "trade",
                    "funcNo": "99919",
                    "sourceModule": "trade"
                }).results[0].activePhone;
                if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                    if (!login && (common.isTradeLogin("0") || common.isTradeLogin("1"))) {
                        $(_pageId + ".option .n_not_login .n_box_con h3").html("您尚未开通期权账户？了解更多期权业务");
                        $(_pageId + ".option .n_not_login .n_box_con .n_btn_box").html("了解更多");
                    } else {
                        $(_pageId + ".option .n_not_login .n_box_con h3").html("您尚未登录期权账号");
                        $(_pageId + ".option .n_not_login .n_box_con .n_btn_box").html("立即登录");
                    }
                } else {
                    $(_pageId + ".option .n_not_login .n_box_con h3").html("您尚未登录手机号码");
                    $(_pageId + ".option .n_not_login .n_box_con .n_btn_box").html("立即登录");
                }
            } else {
                if (!login && (common.isTradeLogin("0") || common.isTradeLogin("1"))) {
                    $(_pageId + ".option .n_not_login .n_box_con h3").html("您尚未开通期权账户？了解更多期权业务");
                    $(_pageId + ".option .n_not_login .n_box_con .n_btn_box").html("了解更多");
                } else {
                    $(_pageId + ".option .n_not_login .n_box_con h3").html("您尚未登录期权账号");
                    $(_pageId + ".option .n_not_login .n_box_con .n_btn_box").html("立即登录");
                }
            }
        }
    }
    
    /**
     * @description 埋点   
     * @author cfx   
     * @date 2021-06-22 13:44:14   
     * @modifyContent 修改点描述...   
     */
    function pointCallNative(point){
        common.pointCallNative({
            module_name: '交易',
            module_id: 'yjapp.trade',
            parent_page_name: point.parent_page_name || '交易-期权交易首页',
            parent_page_id: point.parent_page_id || 'PageOptionTradeHome',
            actionType: point.actionType || 'click' ,
            object_name: point.object_name,
            object_id: point.object_id,
        });
    }

    /**
     * 销毁
     */
    function destroy() {
        commonTimer.clearTimer(_pageId);
        $(_pageId + "#optionExercise .a01").html("");
    }

    var base = {
        "init": init,
        "jumpPageEvent": jumpPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
