/**
 * 普通交易模块 js
 */
define('trade/scripts/account/indexPort.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var service_stock = require("service_stock");
    var service_third = require("service_third");
    var service_fund = require("service_fund");
    var _pageId = "#account_index ";
    var userInfo = null;
    var accountType = {"0": "普通账户", "1": "信用账户", "2": "期权账户", "3": "理财账户"};
    var _param_flag = null;
    var _idType = "0";
    var indexOption = require("trade/scripts/account/indexOption.js");
    var adPicOpts = {};

    /**
     * 每个页面校验
     */
    function into(pageId) {
        _idType = "0";
        pointCallNative({
            actionType: 'view',
            parent_page_name:'交易-普通交易首页',
        });
        common.switchingCurUser(_idType);
        userInfo = common.getCurUserInfo();
        $(_pageId + ".stock").show();
        $(_pageId + ".credit").hide();
        $(_pageId + ".option").hide();
        //退出账户按钮的控制
        var isLoginIn = $.getSStorageInfo("_isLoginIn");
        if (isLoginIn && isLoginIn != "false" && isLoginIn.indexOf("stock") != -1) {
            queryData();

            changePage(common.isTradeLogin(_idType));
            // commonFunc.setJurisdiction(userInfo); // 更新权限
        } else {
            userInfo = null;
            changePage(false);
        }

        jumpPageEvent();
        queryAdPic();
        //字体缩放
        $(_pageId + ".stock .n_trade_info p").each(function (idx, item) {
            var zoom = $.getTransformScaleFontSize($(item).text(), 16, $(item).width());
            $(item).css({"font-size": zoom + "px"});
        });
        return true;
    }


    function queryData() {
        stockAssetsInquiry(_idType);//普通资产查询
        inquiryRemind();//询价确认弹框
        queryZCFX();
    }

    function queryAdPic() {
        // commonFunc.getAdPicData({"group_no": "trade"}, function (data) {
        //     if (!$(_pageId + ".stock").height()) {
        //         return;
        //     }
        //     adPicOpts.divFrame = $(_pageId + ".stock #group");
        //     adPicOpts.height = 60;
        //     common.createAdPicGroup(adPicOpts, data);
        //     if (data && data.length) $(_pageId + ".stock .n_trade_info").css({"padding-bottom": "0.1rem"});
        //     else {
        //         $(_pageId + ".stock #group").css("display", "none");
        //         $(_pageId + ".stock .n_trade_info").css({"padding-bottom": "0rem"});
        //     }
        // });
        commonFunc.getAdPicData({"group_no": "trade"}, function (data) {
            if (!data || data.length == 0) {
                $(_pageId + ".stock #group").css("padding-bottom", "0rem");
                $(_pageId + ".stock .n_trade_info").css("padding-bottom", "0rem");
            } else {
                $(_pageId + ".stock .n_trade_info").css("padding-bottom", "0.1rem");
                $(_pageId + ".stock #group").css("padding-bottom", "0.1rem");
            }
            if (!$(_pageId + ".stock").height()) {
                return;
            }
            adPicOpts.divFrame = $(_pageId + ".stock #group");
            adPicOpts.height = 60;
            common.createAdPicGroup(adPicOpts, data);
        });
    }

    /**
     * 查询资产分析
     */
    function queryZCFX() {
        if (userInfo && userInfo.fund_account) {
            var fund_account = userInfo.fund_account;
            var clientid = userInfo.cust_code;//客户编号（信用）
            var param = {
                "client_id": clientid,
                "fund_account": fund_account,
                "money_type": "0",
                "query_type": "0"
            };
            //最后一个为超时处理函数
            service_fund.function815400(param, function (data) {
                console.log(data);
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results =data.results;
                        if(results!=null&&results.length>0){
                            var gain_or_loss =results[0].gain_or_loss;//盈亏
                            var trade_date = results[0].trade_date.substring(4,6);//日期
                            var gain_or_loss_int=Number(gain_or_loss).toFixed(2);
                            var trade_date_int = Number(trade_date);
                            var html='';
                            var gain_date_str = common.numToMoneyType(gain_or_loss, 2);
                            if(gain_or_loss_int>0){
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: #EE4034;font-size: 0.2rem">'+gain_date_str+'</span></p><span class="n-sel-text">资产分析</span>'
                            }else if(gain_or_loss_int<0){
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: green;font-size: 0.2rem">'+gain_date_str+'</span></p><span class="n-sel-text">资产分析</span>'
                            }else{
                                html = '<p>'+trade_date_int+'月参考盈亏<span style="color: #333333;font-size: 0.2rem">'+gain_or_loss_int+'</span></p><span class="n-sel-text">资产分析</span>'
                            }
                            $(_pageId+"#byckyk ul li").html(html);
                        }
                    }
                }
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
        } else {
            changePage(false);
        }
    }

    /*
     * 判断当前账户登录和未登录显示的内容
     */
    function changePage(login) {
        if (login) {
            $(_pageId + ".stock .n_not_login ").hide();
            $(_pageId + ".stock .j-stock-data").show();
            $(_pageId + ".stock #kyzj_div").hide();
            $(_pageId + ".n_sign_out").show();
            $(_pageId + "#byckyk").show();
            $(_pageId + ".stock .j-stock-data .j-position-box p").html("资金账号：" + common.setAsteriskHide(userInfo.fund_account, 3, 3, 3));
        } else {
            $(_pageId + ".stock .j-stock-data").hide();
            $(_pageId + ".n_sign_out").hide();
            $(_pageId + ".stock .j-stock-data .j-position-box p").html("");
            $(_pageId + ".stock .n_not_login ").show();
            $(_pageId + "#byckyk").hide();
            //判断首页提示语
            if (global.callNative && global.isSso) {
                var activeLogin = $.callMessage({
                    "moduleName": "trade",
                    "funcNo": "99919",
                    "sourceModule": "trade"
                }).results[0].activePhone;
                if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                    $(_pageId + ".stock .n_not_login .n_box_con h3").html("您尚未登录普通账号");
                    $(_pageId + ".stock .n_not_login .n_box_con .n_btn_box").html("立即登录");
                } else {
                    $(_pageId + ".stock .n_not_login .n_box_con h3").html("您尚未登录手机号码");
                    $(_pageId + ".stock .n_not_login .n_box_con .n_btn_box").html("立即登录");
                }
            } else {
                $(_pageId + ".stock .n_not_login .n_box_con h3").html("您尚未登录普通账号");
                $(_pageId + ".stock .n_not_login .n_box_con .n_btn_box").html("立即登录");
            }
        }
    }

    /**
     * 查询普通资产信息
     */
    function stockAssetsInquiry(id) {
        if (userInfo && userInfo.fund_account && id == userInfo._loginClass) {
            changePage(true);
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var cust_code = userInfo.cust_code;//关联资产账户标志
            var money_type = "0";  //  0：人民币，1：美元，2：港币
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "money_type": money_type,
                "is_homepage": ''
            };
            service_stock.queryFundSelect(param, function (data) {
                $(_pageId + ".stock .j-stock-data .j-data-info .exhibition").css("zoom", "1");
                if (data && data != "undefined") {
                    if (data.error_no == 0) {
                        var results = data.results;
                        if (results && results.length > 0) {
                            for (var i = 0; i < results.length; i++) {
                                if (results[i].money_type == "0") {
                                    //总资产
                                    var assert_val = common.numToMoneyType(results[i].assert_val, 2);
                                    $(_pageId + ".stock .j-data-item .j-data-info .exhibition:eq(0)").html(assert_val);

                                    //持仓市值（没有查基金市值）
                                    var market_val = common.numToMoneyType(results[i].market_val, 2);
                                    $(_pageId + ".stock .j-data-item .j-data-info #cczsz").html(market_val);

                                    //总浮动盈亏
                                    var float_yks = results[i].float_yk || results[i].total_income_balance;
                                    var css = "", sign = "";
                                    //当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
                                    if (float_yks > 0) {
                                        css = "ared";
                                    } else if (float_yks < 0) {
                                        css = "agreen";
                                    }
                                    var fas = sign + common.numToMoneyType(float_yks, 2);
                                    $(_pageId + ".stock .j-data-item .j-data-info #cczyk").html(fas);
                                    $(_pageId + ".stock .j-data-item .j-data-info #cczyk").removeClass("ared").removeClass("agreen");
                                    $(_pageId + ".stock .j-data-item .j-data-info #cczyk").addClass(css);

                                    //现金资产（可用资金）
                                    var enable_balance = common.numToMoneyType(results[i].enable_balance, 2);
                                    $(_pageId + ".stock .j-data-item .j-data-info #kyzj").html(enable_balance);

                                    //当日参考盈亏
                                    if (results[i].dailyIncomeBalance_flag == 1) { // 是否显示当日参考盈亏1显示
                                        var daily_income_balance = results[i].daily_income_balance;
                                        fas = $.formatMoney(daily_income_balance, 2) || daily_income_balance;
                                        $(_pageId + ".stock #jrckyk").html(fas).removeClass().addClass("exhibition " + (daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : ""));
                                        $(_pageId + ".stock #jrckyk_div").show();
                                        $(_pageId + ".stock #kyzj_div").hide();
                                    } else {
                                        $(_pageId + ".stock #jrckyk_div").hide();
                                        $(_pageId + ".stock #kyzj_div").show();
                                    }

                                    //字体缩放
                                    var fontNarrow = function ($div) {
                                        return common.getMaxFontSize($div);
                                    }
                                    $(_pageId + ".stock .j-data-item .j-data-info .exhibition").each(function (idx, item) {
                                        item = $(item);
                                        item.css("zoom", fontNarrow(item));
                                    });
                                }
                            }
                        } else {
                            $(_pageId + ".stock .j-data-item .j-data-info .exhibition").html("--");
                        }
                    } else {
                        $.alert(data.error_info);
                    }
                }
            }, {
                "isLastReq": true,
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
        } else {
            changePage(false);
        }
    }

    /*
     * 询价确认提醒
     */
    function inquiryRemind() {
        if (userInfo && userInfo.fund_account && _idType == userInfo._loginClass) {
            var inquiryRemindFlag = $.getLStorageInfo("inquiryRemindFlag");
            if (inquiryRemindFlag) { //有时间表示当前交易日"不需要提醒"，所以需要判断
                var dateTime = new Date().format("yyyyMMdd");
                if (dateTime == inquiryRemindFlag) {
                    return false;
                }
            }
            var param = {
                "entrust_way": global.entrust_way,
                "branch_no": userInfo.branch_no,
                "fund_account": userInfo.fund_account,
                "cust_code": userInfo.cust_code,
                "session_id": userInfo.session_id,
                "password": userInfo.password,
                "cust_name": userInfo.client_name
            };
            service_third.inquiryRemind(param, function (data) {
                if (data.error_no == "0") {
                    var results = data.results;
                    if (results.length > 0) {
                        var htmlEle = '';
                        htmlEle += '<p class="a02">尊敬的' + userInfo.client_name + '，您好！您参与的询价结果已确认。</p>';
                        htmlEle += '<dl class="a03" style="max-height: 60px;overflow: auto;">';
                        for (var i = 0; i < results.length; i++) {
                            htmlEle += '<dd><span style="color:#666666">' + results[i].issue_name + '，</span>已确认成功' + results[i].confirm_amount + '股</dd>';
                        }
                        htmlEle += '</dl>';
                        var tips = '<span style="padding:0">温馨提示：请在申购日当天按询价确认结果，履行申购义务。</span>';
                        common.waitForConfirm("询价确认提醒", htmlEle, tips, function () {
                            $.setLStorageInfo("inquiryRemindFlag", new Date().format("yyyyMMdd"));//当前交易日不在提醒
                        }, function () {
                        }, "我知道了", null, false);
                    }
                }
            }, {
                "isLastReq": false,
                "isShowWait": false,
                "errorFunc": function () {
                },
                "timeOutFunc": function () {
                }
            });
        }
    }

    /**
     * 跳转页面事件
     */
    function jumpPageEvent() {
        //资产分析
        $.bindEvent($(_pageId+"#byckyk ul li"), function (e) {
            pointCallNative({
                object_name: '点击普通交易首页-历史资产分析按钮',
                object_id: 'ButtonHistoricalAssetAnalysis',
            });
            if (global.callNative && global.isSso) {
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "13",//打开风险警示权限开通页面
                        "title": "",
                    }
                }
                $.callMessage(param);
            }
            e.stopPropagation();
        });


        //资产的隐藏显示
        $.bindEvent($(_pageId + ".stock .j-position-box .switch_btn"), function (e) {
            var i_change_to = "";
            if ($(this).hasClass("hide")) {
                $(this).removeClass("hide").addClass("show");
                $(_pageId + ".stock .j-data-item .j-data-info .exhibition").show();
                $(_pageId + ".stock .j-data-item .j-data-info .conceal").hide();
                i_change_to = "展示";
            } else {
                $(this).addClass("hide").removeClass("show");
                $(_pageId + ".stock .j-data-item .j-data-info .exhibition").hide();
                $(_pageId + ".stock .j-data-item .j-data-info .conceal").show();
                i_change_to = "屏蔽";
            }
            pointCallNative({
                object_name: '点击普通交易首页-资产隐藏按钮-' + i_change_to,
                object_id: 'ButtonOrdinaryAssetHide',
            });
            common.comStat(100006, 2, 104, true, {"i_change_name": "屏蔽资产", "i_change_to": i_change_to});//埋点
            e.stopPropagation();
        });

        // 登录
        $.bindEvent($(_pageId + ".stock .n_not_login .n_btn_box"), function (e) {
            common.switchingCurUser("0");
            commonFunc.login($.getCurrentPageObj().pageCode, "account/login", {"_loginClass": _idType}, {
                "topage": "",
                "param": {"switchUserInfo": "0"}
            });
            common.comStat(100001, 2, 103, true, {"i_group_name": "登录普通交易"});//埋点
            pointCallNative({
                object_name: '点击普通交易首页-立即登录按钮',
                object_id: 'ButtonTradeLogin',
            });
            e.stopPropagation();
        });


        // 主页菜单1事件绑定（图标）
        $.bindEvent($(_pageId + ".stock .n_nav_box .n_nav_list li"), function (e) {
            common.switchingCurUser("0");
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var param = $(this).attr("param"); // 获取跳转页面参数
            var paramMap = {"switchUserInfo": "0"};
            if (param) {
                paramMap.param = param;
            }
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            pointCallNative({
                object_name: '点击普通交易首页-' + name + '按钮',
                object_id: object_id,
            });
            //跳转
            $.pageInit("account/index", topage, {"param": paramMap});
            e.stopPropagation();
            e.preventDefault();
        });

        // 主页菜单2事件绑定（图标）
        $.bindEvent($(_pageId + ".stock .n_trade_info ul li"), function (e) {
            common.switchingCurUser("0");
            userInfo = common.getCurUserInfo(0);
            var param = $(this).attr("param"); // 获取跳转页面参数
            var type = $(this).attr("type");
            var paramMap = {"switchUserInfo": "0"};
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            var dataFlag = $(this).attr("data-flag");
            var loginToWebURL = "", module_name = "", isShowLoading = "";//地址和模块名(国债逆回购)
            if (dataFlag == "1") {//国债逆回购
                loginToWebURL = global.mallUrl + "/" + topage;//在URL后面拼个标识,让他关闭页面,不然你打开一个新的页面, 然后返回到首页了
                // module_name="mall";
                // isShowLoading="1";
            }
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var object_id = $(this).attr("object_id");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            pointCallNative({
                object_name: '点击普通交易首页-' + name + '按钮',
                object_id: object_id,
            });

            //国债逆回购
            if (global.callNative && global.isSso) {
                if (dataFlag == "1") {
                    $.callMessage({
                        "funcNo": "50500",
                        "msgNo": "601",
                        "targetModule": "mallDispatcher",
                        "sourceModule": "trade",
                        "action": "4",
                        "param": {
                            "toPage": topage,
                        }
                    });
                    return true;
                }
            } else {
                if (dataFlag == "1") {//国债逆回购
                    window.location.href = loginToWebURL;
                    return true;
                }
            }
            //新股申购
            if (topage == "shares/oneKeyPurchase") {
                $.pageInit("account/index", topage, {"param": paramMap});
                return true;
            }
            //新债申购
            if (topage == "purchaseNewDebt/newPurchase") {
                $.pageInit("account/index", topage, {"param": paramMap});
                return true;
            }

            //智能打新
            if (topage == "nsb/index" && param == "newStock") {
              var newShareCount = $(_pageId + '#newShare1').html().replace(/\D+/g, "");//新股数量
              var newStockCount = $(_pageId + '#newPurchase').html().replace(/\D+/g, "");//新债数量
              var newBjsCount = $(_pageId + '#newShareGZ').html().replace(/\D+/g, "");//北证数量
              // 新股数量包含了北证的数量，这里要减去
              newShareCount = parseInt(newShareCount) - parseInt(newBjsCount);
              if (Number(newShareCount) > 0) {
                paramMap.isStocks = true;
                paramMap.isBjs = false;
              } else if (Number(newBjsCount) > 0) {
                paramMap.isStocks = true;
                paramMap.isBjs = true;
              } else if(Number(newStockCount) > 0){
                paramMap.isStocks = false;
                paramMap.isBjs = false;
              }else {
                paramMap.isStocks = true;
              }
              $.setSStorageInfo("stockFlag", "", true);
              $.setSStorageInfo("bjsFlag", "", true);
              setTimeout(function(){
                  $.pageInit("account/index", topage, { "param": paramMap });
              },0);
              return true;
            }

            //登录的情况
            if (common.isTradeLogin(type)) {
                //两融以及普通科创板权限校验
                if (global.account_kcbJurisdiction && $(this).attr("kcbCheck")) {
                    commonFunc.kcbJurisdiction(0, userInfo, function (_rights) {
                        if (_rights != "0") {//科创板权限（1无权限，0有权限）
                            topage = "kcb/kcbDistrict";
                        }
                        $.pageInit("account/index", topage, {"param": paramMap});
                    });
                } else {
                    $.pageInit("account/index", topage, {"param": paramMap});
                }
            } else {//没有登录的情况
                commonFunc.login($.getCurrentPageObj().pageCode, topage, {"param": paramMap}, {
                    "topage": topage,
                    "param": paramMap
                });
            }
            e.stopPropagation();
            e.preventDefault();
        });

        // 主页菜单事件绑定
        $.bindEvent($(_pageId + ".stock .n_sel_list .n_list_con li"), function (e) {
            common.switchingCurUser("0");
            userInfo = common.getCurUserInfo(0);
            var param = $(this).attr("param"); // 获取跳转页面参数
            var type = $(this).attr("type");
            var frame_mark = $(this).attr("framemark"); //0-旧框架 1-新框架
            var jump_url = $(this).attr("jump_url"); 
            var paramMap = {"switchUserInfo": "0"};
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            if(objectId){
              common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            }
            var object_id = $(this).attr("object_id");
            pointCallNative({
                object_name: '点击普通交易首页-' + name + '按钮',
                object_id: object_id,
            });
            //智能打新
            if (topage == "nsb/index") {
              $.setSStorageInfo("stockFlag", "", true);
              $.setSStorageInfo("bjsFlag", "", true);
                if (param == "newStock") {
                    paramMap.isStocks = true;
                    $.pageInit("account/index", topage, {"param": paramMap});
                    return true;
                } else {
                    paramMap.isStocks = false;
                    $.pageInit("account/index", topage, {"param": paramMap});
                    return true;
                }
            }
            if(frame_mark === '1'){
              var jump_url = '';
              if(object_id === 'ButtonConvertibleBondTrade'){
                // 可转债专区
                jump_url = {
                  "url": global.newFrameUrl + "fintechpages/synthetical/index.html#/conversionBond?switchUserInfo=0",
                  "uniqueCode":"synthetical-conversionBond",
                  "isSupportPullDownRefresh":"1"
                };
              }else if(object_id === 'ButtonSystemNotice'){
                // 交易通知
                jump_url = {
                  "url": global.newFrameUrl + "fintechpages/synthetical/index.html#/tradeNotice",
                  "uniqueCode":"synthetical-tradeNotice",
                  "isSupportPullDownRefresh":"1"
                };
              }else if(object_id === 'ButtonEtfFundTrade'){
                // ETF基金专区
                jump_url = {
                    "url": global.newFrameUrl + "fintechpages/synthetical/index.html#/trade/etfSection",
                    "uniqueCode":"synthetical-trade/etfSection",
                    "isSupportPullDownRefresh":"1"
                  };
              }
              $.callMessage($.extend({
                moduleName: "trade", 
                funcNo: "501152",
                openLoadBar:'0',  //是否显示加载等待层 1显示  0不显示 默认不显示
                isShowTitleBar:'1',   // 是否显示标题栏 1:显示；0:不显示 默认显示
                titleBgColor: '#EE4034',  //状态栏颜色&标题栏颜色
                isSaveCache:'1',  //是否启用缓存 1启用 0不启用 默认启用
                isSupportPullDownRefresh:'0',  //是否启用自带的下拉刷新1 启用 0 不启用 默认不启用
                reloadCallback: 'subMessagingCallBack', // 跨模块页面刷新调用
                bgColor:'#FFFFFF',  //webView 背景颜色 
                isFullScreen:'1',  //是否开启沉浸式状态栏 1启用 0不启用 默认启用
              },jump_url));
              return true;
            }

            //登录的情况
            if (common.isTradeLogin(type)) {
                //加入检查港股通权限
                if (!common.checkGgtPermission(userInfo.fund_account) && topage.indexOf("ggt") > -1) {
                    $(_pageId + ".notOpen .test_box").html("未开通港股通");
                    $(_pageId + ".notOpen").show().css("top", "40%");
                    ggt_thirdJurisdiction();
                }
                //添加股转权限（新三板）
                else if (topage.indexOf("third") > -1) {
                    var _jurisdiction = commonFunc.getJurisdiction();
                    //本地没有缓存权限，则同步查询一次
                    if (!_jurisdiction.IsQuerySuccess) {
                        commonFunc.setJurisdiction(null, function (data) {
                            if (data.IsQuerySuccess != false && data.three_board_rights != "1") {//有返回、无权限
                                $.pageInit("account/index", "third/thirdJurisdiction");
                            } else {
                                $.pageInit("account/index", topage, {"param": paramMap});
                            }
                        })
                    }
                    //无权限
                    else if (_jurisdiction.three_board_rights != "1") {
                        $.pageInit("account/index", "third/thirdJurisdiction");
                    } else {
                        $.pageInit("account/index", topage, {"param": paramMap});
                    }
                } else if (global.account_kcbJurisdiction && $(this).attr("kcbCheck")) {
                    commonFunc.kcbJurisdiction(0, userInfo, function (_rights) {
                        if (_rights != "0") {//科创板权限（1无权限，0有权限）
                            topage = "kcb/kcbDistrict";
                        }
                        $.pageInit("account/index", topage, {"param": paramMap});
                    });
                }
                    // //加入检查新三板的权限
                    // else if(!common.checkThirdPermission(userInfo.fund_account)&&topage.indexOf("third")>-1){
                    // 	$(_pageId + ".notOpen .test_box").html("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	$(_pageId + ".notOpen").show().css("top","30%");
                    // 	ggt_thirdJurisdiction();
                // }
                else {
                    $.pageInit("account/index", topage, {"param": paramMap});
                }
            } else {//没有登录的情况
                commonFunc.login($.getCurrentPageObj().pageCode, topage, {"param": paramMap}, {
                    "topage": topage,
                    "param": paramMap
                });
            }
            e.stopPropagation();
            e.preventDefault();
        });

        //点击跳转到持仓
        $.bindEvent($(_pageId + ".stock .j-stock-data .j-data-info").add($(_pageId + ".stock .j-stock-data .entrance_btn")), function (e) {
            common.comStat(100661, 2, 103, true, {"i_group_name": "资产跳转"});//埋点
            pointCallNative({
                object_name: '点击普通交易首页-进入持仓按钮',
                object_id: 'ButtonOrdinaryHolding',
            });
            $.pageInit("account/index", "stock/stockHolding", {"param": ""});
            e.stopPropagation();
        });

        //总资产说明
        $.bindEvent($(_pageId + ".stock #assetsClick").find("a"), function (e) {
            var msg = '';
            msg += '<p style="padding: 0 0.05rem;">总资产：普通交易账户人民币总资产，包括持仓证券总市值、理财市值和现金资产。<br/><br/>';
            msg += '参考市值：当前持仓证券总市值；包括股票、债券、场内基金、港股通、新三板等，不包括理财产品；根据行情市价波动。<br/><br/>';
            msg += '持仓参考盈亏：当前持仓证券累计总盈亏；包括股票、债券、场内基金、港股通、新三板等，不包括理财产品；根据行情市价波动。<br/><br/>';
            if ($(_pageId + ".stock #jrckyk").parent().siblings().isShow()) {
                msg += '可用资金: 当前可用于交易的资金。<br/><br/>';
            }
            msg += '每个交易日收盘后，清算期间至下个交易日开盘前，数据可能不准确。</p>';
            common.singleIConfirmNew("资产显示规则", msg, null, "我知道了");
            pointCallNative({
                object_name: '点击普通交易首页-总资产注释按钮',
                object_id: 'ButtonAssetsComment',
            });
            e.preventDefault();
            e.stopPropagation();
        });

        //今日参考盈亏说明
        $.bindEvent($(_pageId + " #jrckykClick").find("a"), function (e) {
            var msg = '';
            msg += '<p>1. 交易日仅9:25-16:00期间显示,不参与晚间清算,仅供盘中参考;</p>';
            msg += '<p>2. 非交易日不显示;</p>';
            msg += '<p>3. 已计入交易手续费,但不包括理财产品收益;</p>';
            msg += '<p>4. 若昨日有股票分红、配股等情况,可能导致今日参考盈亏计算不准确;</p>';
            msg += '<p>5. 今日参考盈亏仅为参考值,不作为具体的投资参考意见,请以账户实际收益为准。</p>';
            common.singleIConfirmNew("今日参考盈亏", msg, null, "我知道了");
            var type = $(_pageId + ".header_tab_list a.active").attr("type");
            if (type == "2") {//期权
                pointCallNative({
                    parent_page_name: '交易-期权交易首页',
                    parent_page_id: 'PageOptionTradeHome',
                    object_name: '点击期权交易首页-今日参考盈亏注释按钮',
                    object_id: 'ButtonTodayProfitAndLossComment',
                });
            }else if(type == '0'){ // 普通
                pointCallNative({
                    object_name: '点击普通交易首页-今日参考盈亏注释按钮',
                    object_id: 'ButtonTodayProfitAndLossComment',
                });
            }
            e.preventDefault();
            e.stopPropagation();
        });

        indexOption.jumpPageEvent();
    }

    /*
     * 港股通、新三板权限弹框的方法
     */
    function ggt_thirdJurisdiction() {
        $(_pageId + ".backdrop").show();
        $("._jump_layer_mask").show();
        window.setTimeout(function () {
            $("._jump_layer_mask").hide();
        }, 300);
        $.bindEvent($(_pageId + ".notOpen #notOpenBtn"), function (e) {
            $("._jump_layer_mask").hide();
            $(_pageId + ".notOpen .test_box").html("");
            $(_pageId + ".backdrop").hide();
            $(_pageId + ".notOpen").hide();
            $("._jump_layer_mask").hide();
            e.stopPropagation();
        });
        return false;
    }
    /**
     * @description 埋点   
     * @author cfx   
     * @date 2021-06-22 13:44:14   
     * @modifyContent 修改点描述...   
     */
    function pointCallNative(point){
        common.pointCallNative({
            module_name: '交易',
            module_id: 'yjapp.trade',
            parent_page_name: point.parent_page_name || '交易-普通交易首页',
            parent_page_id: point.parent_page_id || 'PageOrdinaryTradeHome',
            actionType: point.actionType || 'click' ,
            object_name: point.object_name,
            object_id: point.object_id,
        });
    }

    function destroy() {
        adPicOpts.scrollDestroy && adPicOpts.scrollDestroy();
    }

    var base = {
        "into": into,
        "destroy": destroy
    };

    module.exports = base;
});
