/**
 * 交易模块公用 js
 */
define('trade/scripts/account/loginPort.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var service_common = require("service_common");
	require("validatorUtils");
	var validata = $.validatorUtils;
	require("rsa");
	require("endecryptUtils");
	var common = require("common");
	var _pageId = "#account_login ";
	var mobilekey = null;
	var topage = "";
	var loginClass = "0";
	var remember_account = {};
	var appropriate = require("appropriate");
    var commonFunc = require("commonFunc");
	/**
	 * 每个页面校验
	 */
	function into(_topage,_loginClass){
		topage = _topage;
		loginClass = _loginClass;
		getTicketImg();
		getAccount(loginClass);
		if($.getPageParam("param") && $.getPageParam("param")["account"]){
			$(_pageId+" #saveAcc .c1").removeAttr("checked");
			$(_pageId + "#account").val($.getPageParam("param")["account"]); // 华龙311700014065  华安170010779
		}
		return true;
	}
	
	/**
	 * 获取验证码
	 */
	function getTicketImg(){
		var ticket_key = getRndNum(10);
		mobilekey = ticket_key;
		var randomImg = gconfig.global.validateimg +"?r="+ ticket_key+"&mobileKey="+ticket_key;
		$(_pageId+" #randomImg").attr("src", randomImg);
	}
	
	/**
	 * 获取随机数
	 */
	function getRndNum(n){
	    var rnd = "";
	    for(var i = 0; i < n; i++){
		  	rnd += Math.floor(Math.random() * 10);
	    }
	    return rnd;
	}

	
	/**
	 * 校验登录账号,交易密码,手机验证码
	 */
	function checkInput(){
		if(validata.isEmpty($(_pageId + "#account").val())){
			$.hidePreloader();
			$.alert("登录账号不能为空");
			return false;
		}
		if(validata.isEmpty($(_pageId + "#password").val())){
			$.hidePreloader();
			$.alert("密码不能为空");
			return false;
//		}else if(!/^[0-9a-zA-Z]{6,12}$/.test($(_pageId+"#password").val())){
//			$.hidePreloader();
//			$.alert("密码只允许输入0-9、a-z、A-Z且长度为6-12位");
			return false;
		}
		if($(_pageId + "#ticket").parent().css("display") != "none" && validata.isEmpty($(_pageId + "#ticket").val())){
			$.hidePreloader();
			$.alert("验证码不能为空");
			return false;
		}
		return true;
	}
	
	/**
	 * 通过短信验证,或者格式校验后登录
	 */
	function submitLogin(){
		$.showPreloader("请等待...");
		// 登录时获取页面手机号码
		var account = $(_pageId + "#account").val();
		var password = $(_pageId + "#password").val();
		var ticket = $(_pageId + "#ticket").val();
		var input_type = $(_pageId + "#loginKind p").attr("id");  
		
		
		var loginFuc = function(){
			// 调用登录接口实现接口
			var param = {
					"entrust_way": global.entrust_way,	// 委托方式  在configuration配置 
					"input_type": input_type,		    // 手机登录
					"input_content": account,			// 手机号码
					"password": password,
					"ticket":ticket,
					"content_type" : "",                // 客户标识类型
					"mobilekey":mobilekey,
					"ticketFlag": ticket ? "" : 0,
					"account_type":loginClass,
					"login_type": loginClass
			};
			service_common.login(param,function(data){
				$.hidePreloader();
				//当前账号没有开通手机委托权限，所以调转到业务办理
				if(data.error_no=="-30010015"){
					$.alert(data.error_info);
//					common.iConfirm("温馨提示",data.error_info,function(){
//						var login_url=global.ygtUrl+"ygt/views/account/login.html?isFromApp=true&from=app";//在URL后面拼个标识,让他关闭页面,不然你打开一个新的页面, 然后返回到首页了
//						if($.device.iPad || $.device.iPhone || $.device.ios){//ios需要判断登录
//							module_name="ygt";
//						}else {
//							module_name="trade";
//						}
//						if(global.callNative && global.isSso){
//							$.callMessage({
//								"funcNo": "50115",
//								"moduleName":module_name,
//								"url":login_url,
//								"statusColor":"#2A315B",//状态栏颜色
//								"isShowLoading":"1"
//							});
//						}else{
//							window.location.href =  login_url;
//						}
//					},function(){},"确认","取消");
				}else if(data.error_no != 0){
					$(_pageId + "#ticket").quzhi("");
					getTicketImg(); // 获取验证码
					$.hidePreloader();
					$.alert(data.error_info);
					if(data.error_no == 3){
						var pwd_error = Number($.getSStorageInfo("pwd_error"));
						pwd_error++;
						if(pwd_error > 3){
							$(_pageId + "#ticket").parent().show()
						}
						// else{
						// 	$(_pageId + "#ticket").parent().hide();
						// }
						$.setSStorageInfo("pwd_error",pwd_error);
						$(_pageId + "#password").quzhi("");
					}
					else if(data.error_no == 11){
						$(_pageId + "#ticket").parent().show()
						$.setSStorageInfo("pwd_error","4");
					}
					return false;
				}else{
					var results = ""; // 适配单结果集和多结果集
                    if(data.DataSet){
                    	results = data.DataSet;
                    }else if(data.results){
                    	results = data.results;
                    }
					if(results && results.length > 0){
							if(results[0].liquidation_flag == '1' && $.isValue(results[0].liquidation_txt)){ // 清算提醒 
								common.singleIConfirm("",results[0].liquidation_txt || '系统正在清算',function(){},"确定", '','', {pageId: 'body',contentStyle: 'text-align:left;'});
							}
							$.setSStorageInfo("pwd_error","0");
							results[0].password = password; // 保存交易密码
							results[0].loginType = input_type; //保存登录类型
							var acct_type=results[0].acct_type;//服务器判断类型
							$("#account_index  header.header .noicon_text").html("注销");
							if(acct_type=="201"){
								results[0]._loginClass = "0";
								results[0]._acct_type = "201";
							}else if(acct_type=="202"){
								results[0]._loginClass = "1";
								results[0]._acct_type = "202";
							}else if(loginClass=="2"){
								results[0]._loginClass = loginClass;
								results[0]._acct_type = "204";
							}
							results[0]._uniqueness = results[0].cust_code + "|" + results[0].fund_account;
							common.setAccountInfos(results);
							if(loginClass == "0"){//查询股转股东账号
								commonFunc.setNewStockAccount(results[0]);
							}
		                    //此处为保存账号逻辑
							var saveAcc = $(_pageId + "#account").val();
							var isChecked = $(_pageId + "#saveAcc input").attr("checked");
							if(isChecked && (isChecked == "true" || isChecked == "checked")){
								isChecked = false;
							}
							else{
								isChecked = true;
							}
							common.setCurUserInfo(results[0]);
							setAccount(loginClass, saveAcc, input_type, isChecked); // 保存登录成功并且选择记住的账号
							if(data.DataSet3){
								global.trade_flag = data.DataSet3[0].trade_flag; // 是否统一登录标识
							}
						    $.hidePreloader();
						var flogin = function(){
							if(topage && topage.indexOf("credit/transferred/") == 0){
								$.pageInit("account/login","credit/transferred/collateralTransfer",$.getPageParam("param"),null,true);
							}
							else{
								var pa = $.getPageParam("param") || {};
								pa._loginClass = results[0]._loginClass;
								common.switchingCurUser(loginClass);
								var userInfo=common.getCurUserInfo();
								if(userInfo&&common.isEmptyObject(userInfo)){
									jurisdiction(userInfo.fund_account,pa);
								}else{
									$.pageInit("account/login","account/index",pa,null,true);
								}
							}
						}
						appropriate.login(results[0],flogin);
					}else{
						$.hidePreloader();
						getTicketImg(); // 获取验证码
						$(_pageId + "#ticket").quzhi("");
						$.alert("登录失败！");
					}
				}
			},{"isLastReq":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
	    };
	    
		if(global.callNative&&global.isSso){//C接入没有获取加密参数的接口
			loginFuc(); // 调用登录接口
		}
		else{
			// 密码加密
			service_common.getKey({},function(data){
				if(data.error_no != "0"){
					$.hidePreloader();
					$.alert(data.error_info);
					return false;
				}else{
					// 参数固定,是密码加密的参数
					var modulus = data.results[0].modulus;
					var publicExponent = data.results[0].publicExponent;
					var endecryptUtils = $.endecryptUtils;
					if(password){
						password = endecryptUtils.rsaEncrypt(modulus,publicExponent,$.trim(password));
					}
					loginFuc(); // 调用登录接口
				}
			},{"isLastReq":false,"isShowWait":false,
					"timeOutFunc":function(){
						$.hidePreloader();
					},"errorFunc":function(){
						$.hidePreloader();
					}});
				$.showPreloaders("请等待...");
			
		}
    }
	
	function jurisdiction(fund_account,paramMap){
		var prePageCode = $.getCurrentPageObj().prePageCode || '';
		//加入检查港股通权限
		if(topage.indexOf("ggt")>-1){
			if(!common.checkGgtPermission(fund_account)){
                $.pageInit("account/index", 'ggt/noRight');
				return false;
			}else{
				$.pageInit("account/login",topage,paramMap,null,true);
			}
		}
		//添加股转权限（新三板）
		else if(topage.indexOf("third")>-1){
			var _jurisdiction = commonFunc.getJurisdiction();
			//本地没有缓存权限，则同步查询一次
			if(!_jurisdiction.IsQuerySuccess){
				commonFunc.setJurisdiction(null,function(data){
					if(data.IsQuerySuccess != false && data.three_board_rights != "1"){//有返回、无权限
						$.pageInit("account/index","third/thirdJurisdiction");
					}else{
						$.pageInit("account/login",topage,paramMap,null,true);
					}
				})
			}
			//无权限
			else if(_jurisdiction.three_board_rights != "1"){
				$.pageInit("account/index","third/thirdJurisdiction");
			}else{
				$.pageInit("account/login",topage,paramMap,null,true);
			}
		}
		// else if(topage.indexOf("third")>-1){
		// 	if(!common.checkThirdPermission(fund_account)){
		// 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
		// 		$.pageInit("account/login","account/index",paramMap,null,true);
		// 		return false;
		// 	}else{
		// 		$.pageInit("account/login",topage,paramMap,null,true);
		// 	}
		// }
		else if(prePageCode=="shares/oneKeyPurchase"&&topage=="shares/oneKeyPurchase"){
			$.pageBack();	
		}
		else{
			//普通科创板权限校验
			if(global.account_kcbJurisdiction && (topage.indexOf("kcb/stock/") == 0 || topage.indexOf("credit/kcb/") == 0)){
				var	userInfo = common.getCurUserInfo();
				commonFunc.kcbJurisdiction(paramMap._loginClass,userInfo,function(_rights){
					if(_rights!="0"){//科创板权限（1无权限，0有权限）
						topage = "kcb/kcbDistrict";
					}
					$.pageInit("account/login",topage,paramMap,null,true);
				});
			}else{
				$.pageInit("account/login",topage,paramMap,null,true);
			}
		}
	}
	
	/**
	 * 保存登录的账号
	 */
	function setAccount(type,saveAcc,accType,isChecked){
		var remember = $.getLStorageInfo("remember_account");
		if(global.callNative){
			remember = $.callMessage({"moduleName":"trade","funcNo": "50043","key":"remember_account"}).results[0].value;
		}
		if(remember && remember != "null" && remember != "0"){
			if(typeof(remember) == "string"){
				remember = JSON.parse(remember);
			}
			if(remember){
				remember_account = remember;
			}
			else{
				remember_account = {};
			}
		}
		var accounts = remember_account[common.dealType(type)];
		if(!accounts){
			accounts = [];
		}
		accounts = common.unshiftDeleteSame(accounts, saveAcc+"||"+accType, isChecked);
		remember_account[common.dealType(type)] = accounts;
		$.setLStorageInfo("remember_account",JSON.stringify(remember_account));
		if(global.callNative){
			$.callMessage({"moduleName":"trade","funcNo": "50042","key":"remember_account","value":JSON.stringify(remember_account),"time":"0"});
		}
	}
	
	/**
	 * 获取保存的账号
	 */
	function getAccount(type){
		// 获取保存在缓存中的账号
		var remember = $.getLStorageInfo("remember_account");
		if(global.callNative){
			remember = $.callMessage({"moduleName":"trade","funcNo": "50043","key":"remember_account"}).results[0].value;
		}
		if(remember && remember != "null" && remember != "0"){
			if(typeof(remember) == "string"){
				remember = JSON.parse(remember);
			}
			if(remember){
				remember_account = remember;
			}
			else{
				remember_account = {};
			}
		}
		if(remember_account && remember_account[common.dealType(type)] && remember_account[common.dealType(type)][0]){
			var account = remember_account[common.dealType(type)][0].split("||");
			$(_pageId+"#saveAcc .c1").attr("checked",true);
			$(_pageId+"#account").quzhi(account[0]);
			if(account[1]){
				var txt = $(_pageId + "#loginKind ul li[type=\""+type+"\"][id=\""+account[1]+"\"]").text();
				if(txt){
					$(_pageId + "#loginKind p").attr("id",account[1]);
					$(_pageId + "#loginKind p").text(txt);
				}
			}
		}else{
			$(_pageId+" #saveAcc .c1").removeAttr("checked");
		}
	}
	
	var base = {
    	"into": into,
    	"checkInput": checkInput,
    	"submitLogin": submitLogin,
    	"getTicketImg": getTicketImg,
    	"getAccount": getAccount,
    	"remember_account": remember_account
    };

    module.exports = base;
});
