/**
 * 交易开通条件说明
 */
define('trade/scripts/account/optionPermissionOpening.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#account_optionPermissionOpening ";
    var common = require("common");
	var service_zhyw = require("service_zhyw");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var VIScrollHeight=null;
    
    /**
     * 初始化
     */
	function init(){
		var type=$.getPageParam("type");
		var mianHeight = common.setMainHeight(_pageId, false);
		VIScrollHeight=mianHeight;
		queryPermissionPrompt();
	}
	
	function load(){}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
//			$.pageBack();
//			$.pageInit("account/optionPermissionOpening","account/index");
			setTimeout(function () {
				$.pageBack("account/index", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
	}
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight:  VIScrollHeight - parseFloat($(_pageId + ".main").css("margin-top").slice(0, -2)), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: false, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
		
	}
	   
	/*
	 * 查询信息
	 */
	function queryPermissionPrompt(){
		var channelNo="",version_code="",soft_no="";
		if($.device.android){
			channelNo = "1";
		}else if($.device.iPad || $.device.iPhone || $.device.ios){
			channelNo = "2";
		}else if($.device.pc){
			channelNo = "0"; 
		}
		if(global.callNative && global.isSso){
			var applicationInfo = $.callMessage({"funcNo": "50001"});
			if (applicationInfo.error_no == 0) {
				version_code = applicationInfo.results[0].nativeVersionSn || " ";//原生应用内部版本序号
				soft_no = applicationInfo.results[0].softIdentifier||" ";//软件包名
			}
		}
		
		var param={				
				"soft_no":soft_no,	//	所属应用
				"version_code":version_code,	//	App内部版本号
				"channel":channelNo,	//	渠道（见数据字典），区分发起请求的前端设备。
				"problem_column_no":"option_02",	//	问题栏目标识
		};
		service_zhyw.queryOptionPermissionPrompt(param,function(data){
			$(_pageId+".no_data").show();
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						$(_pageId+".no_data").hide();
						var _html="";
						for (var i=0;i<results.length;i++) {
							var data_info=results[i].problem_info;
							if(data_info && typeof(data_info) == "string"){
								data_info = JSON.parse(data_info);
							}
							if(results[i].problem_column_no=="option_01"){
								_html+='<div class="part">';
									_html+='<div class="h5_title"><h5>'+results[i].problem_column_name+'</h5></div>';
									_html+='<ul>';
									    for (var j=0,jLenght=data_info.length;j<jLenght;j++) {
											_html+='<li class="option_data" style="display: ;"><div>&nbsp&nbsp&nbsp&nbsp'+data_info[j].problem_answer+'</div></li>';
									    }
									_html+='</ul>';
								_html+='</div>';
							}
							else{
								var _css="mt10";
								if(i==0){
									_css="";
								}
					            _html+='<div class="part '+_css+'">';
					            	_html+='<div class="h5_title"><h5>'+results[i].problem_column_name+'</h5></div>';
					                _html+='<ul>';
									    for (var j=0,jLenght=data_info.length;j<jLenght;j++) {
						                    _html+='<li class="_title"><a href="javascript:void(0);">'+data_info[j].problem_name+'</a></li>';
						                    _html+='<li class="option_data" style="display: none;"><div>&nbsp&nbsp&nbsp&nbsp'+data_info[j].problem_answer+'</div></li>';
					         		    }
					                _html+='</ul>';
					            _html+='</div>';
							}
						}
						$(_pageId+".search_nav_title").html(_html);
						//伸缩样式
						$.bindEvent($(_pageId + "._title "), function(e){
							if($(this).find("a").hasClass("open_show")){
								$(this).find("a").removeClass("open_show");
								$(this).next(".option_data").hide();
								if(!myScroller){
									initScroller();
								}else{
									myScroller.refresh();
								}
							}else{
								$(this).find("a").addClass("open_show");
								$(this).next(".option_data").show();
								if(!myScroller){
									initScroller();
								}else{
									myScroller.refresh();
								}
							}
							e.stopPropagation();
						});
					}
				}
				else{
					$.alert(data.error_info);
				}
			}
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".search_nav_title").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});