/**
 * 持仓详情
 */
define('trade/scripts/account/positionDetails.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#account_positionDetails ";
    var service_appropr = require("service_appropr");
    var common = require("common");
    var userInfo = null;
    var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		positionAdequacy();
	}
	
	/**
	 * 当日资金流水查询
	 */
	function positionAdequacy(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid = userInfo.session_id;
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		$(_pageId+".fund_tran_table").html("");
		service_appropr.positionAdequacy(param,moneyFlowQueryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 *  当日资金流水查询回调
	 */
	function moneyFlowQueryCallback(data){
		var html = "<table border=\"0\" cellpadding=\"0\" cellspacing=\"0\" width=\"100%\"><tr><th>证券/代码</th><th>产品风险等级</th><th>用户风险等级</th><th>备注</th></tr>";
		if (typeof(data) != "undefined" && data) {
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					for (var i=0;i<results.length;i++){
						html += queryEntrustHTML(results[i]);
					}
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		html += "</table>";
		$(_pageId+".fund_tran_table").html(html);
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
        var eleHtml = "";
        eleHtml += "<tr>";
		eleHtml += "<td>";
		eleHtml += "<span>"+element.stock_name+"</span>";
		eleHtml += "<span>"+element.stock_code+"</span>";
		eleHtml += "</td>";
		eleHtml += "<td>"+element.busi_risk_level+"</td>";
		eleHtml += "<td>"+element.corp_risk_level+"</td>";
		eleHtml += "<td>"+element.risk_remind_info+"</td>";
		eleHtml += "</tr>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height(), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				positionAdequacy(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	function bindPageEvent(){
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$.pageBack("account/index", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
	}
	
	function destroy(){
		$(_pageId+".fund_tran_table").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});