/**
 * 交易转账
 */
define('trade/scripts/banking/transfer.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	require("validatorUtils");
	var commonFunc = require("commonFunc");
	var validatorUtil = $.validatorUtils;
	var service_common = require("service_common");
    var _pageId = "#banking_transfer ";
    var action = "#transferIn "; // tab节点选择  转入转出
    var balance_pwd = false;
	var userInfo = null;
	var money_types = {"0":"人民币","1":"美元","2":"港币"};
	var money_typef = {"0":"元","1":"美元","2":"港币"};
	var bankInfos = {};
	var bankInfo = {};
	var RMBMainAccount = {};
	var RMBMainHTML="";
	var keyboard = require("keyboard");
	var color=$(_pageId+".toggle_nav li.active").index();
	// var _bankAvalibleFund="0";
	
    /**
     * 初始化
     */
	function init(){
		var paramMap=$.getPageParam("param");
		if(paramMap && Object.getOwnPropertyNames(paramMap).length != 0){
			if(paramMap && typeof(paramMap) == "string"){
				paramMap = JSON.parse(paramMap);
			}
			if(paramMap.switchUserInfo){
				common.switchingCurUser(paramMap.switchUserInfo);
			}
		}
		if(global.startJSkeyboard || global.callNative){
			$(_pageId + "#bank_password").attr('placeholder','请输入<span style="color:#EE4034;">银行</span>密码')
		}	
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		jumpPageEvent();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		
		//页面埋点
		if(userInfo._loginClass&&userInfo._loginClass=="2"){
			if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
				common.pageBuryingPoint("107223");
			}else{
				common.pageBuryingPoint("107235");
			}
		}else if(userInfo._loginClass&&userInfo._loginClass=="1"){
			if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
				common.pageBuryingPoint("105541");
			}else{
				common.pageBuryingPoint("105558");
			}
		}else{
			if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
				common.pageBuryingPoint("100355");
			}else{
				common.pageBuryingPoint("100370");
			}
		}
    }
	
	function load(){
		if(global.startJSkeyboard || global.callNative){
			$(_pageId + "#bank_password").attr('placeholder','请输入<span style="color:#EE4034;">银行</span>密码')
		}	
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		common.setMainHeight(_pageId, false);
	}
	
	function backgroundInterface(){
		queryAccount(); // 查询存管银行
	}
	
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(107224,2,103,true,{"i_group_name": "返回" });
				}else{
					common.comStat(107236,2,103,true,{"i_group_name": "返回" });
				}    
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(105542,2,103,true,{"i_group_name": "返回" });
				}else{
					common.comStat(105559,2,103,true,{"i_group_name": "返回" });
				}    
			}else{
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(100356,2,103,true,{"i_group_name": "返回" });
				}else{
					common.comStat(100371,2,103,true,{"i_group_name": "返回" });
				}
			}
			// 键盘未关闭，返回50212报错
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			commonFunc.appThirdBack('banking_transfer', function(){
				$.pageBack("account/index","left");
			});			
			e.preventDefault();
			e.stopPropagation(); // 阻止冒泡
		});
		// 流水查询
		$.bindEvent($(_pageId +".top_title .noicon_text"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(107227,2,103,true,{"i_group_name": "流水" });
				}else{
					common.comStat(107237,2,103,true,{"i_group_name": "流水" });
				}    
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(105545,2,103,true,{"i_group_name": "流水" });
				}else{
					common.comStat(105560,2,103,true,{"i_group_name": "流水" });
				}
			}else{
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(100359,2,103,true,{"i_group_name": "流水" });
				}else{
					common.comStat(100372,2,103,true,{"i_group_name": "流水" });
				}
			}
			$.pageInit("banking/transfer","banking/transferHistory");
			e.stopPropagation(); // 阻止冒泡
		});
		
		// 页面切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			resetBuyForm();
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".input_forms").hide();
			common.pageBuryingPoint();
			if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
				action = "#transferIn ";
				$(_pageId + ".input_forms").eq(0).show();
				//埋点
				if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
					common.comStat(107225,2,103,true,{"i_group_name": "资金转入" });
					common.pageBuryingPoint("107223");
				}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
					common.comStat(105543,2,103,true,{"i_group_name": "资金转入" });
					common.pageBuryingPoint("105541");
				}else{
					common.comStat(100357,2,103,true,{"i_group_name": "资金转入" });
					common.pageBuryingPoint("100355");
				}
			}else{
				//埋点
				if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
					common.comStat(107226,2,103,true,{"i_group_name": "资金转出" });
					common.pageBuryingPoint("107235");
				}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
					common.comStat(105544,2,103,true,{"i_group_name": "资金转出" });
					common.pageBuryingPoint("105558");
				}else{
					common.comStat(100358,2,103,true,{"i_group_name": "资金转出" });
					common.pageBuryingPoint("100370");
				}
//				queryBalance();
				action = "#transferOut ";
				$(_pageId + ".input_forms").eq(1).show();
			}
//			$(_pageId+".listSelection .list li").eq(0).triggerFastTap();
			
			color=$(_pageId+".toggle_nav li.active").index();
			queryAccount();
			e.stopPropagation(); // 阻止冒泡
		});
		
		//入金指引跳转
		$.bindEvent($(_pageId + ".goldEntryTips"), function(e){
			if($(this).attr("type")=="1"){//招商
				$.pageInit("banking/transfer","banking/zsGoldEntryGuide");
			}else if($(this).attr("type")=="2"){//平安
				$.pageInit("banking/transfer","banking/paGoldEntryGuide");
			}else if($(this).attr("type")=="3"){//浦发
				$.pageInit("banking/transfer","banking/pfGoldEntryGuide");
			}
			e.preventDefault();
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/**
	 * 事件绑定 
	 */
	function bindPageEvent(){
		// 提交转账
		$.bindEvent($(_pageId + ".ce_btn a"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			transferSubmit(); // 提交转账
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(107229,2,103,true,{"i_group_name":"资金转入提交"});
				}else{
					common.comStat(107238,2,103,true,{"i_group_name":"资金转出提交"});
				}
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(105547,2,103,true,{"i_group_name":"资金转入提交"});
				}else{
					common.comStat(105561,2,103,true,{"i_group_name":"资金转出提交"});
				}
			}else{
				if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
					common.comStat(100361,2,103,true,{"i_group_name":"资金转入提交"});
				}else{
					common.comStat(100373,2,103,true,{"i_group_name":"资金转出提交"});
				}
			}
			e.stopPropagation(); // 阻止冒泡
		});
		
		$.bindEvent($(_pageId), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
			e.stopPropagation();
		}, "click");
		
		$.bindEvent($(_pageId+"#moneyNum"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var _value=$(this).val();
			var input_value=$(this).val();
			if(_value&&_value!=""&&_value!=null&&_value!=undefined){
				_value=_value.split(".");
				if(_value[1]&&_value[1].length>2){
					$(this).val(input_value.substring(0,input_value.length-1));
				}else{
					if(_value.length>2){
						$(this).val(input_value.substring(0,_value[2].length+1));
					}else{
						$(this).val(input_value);
					}
				}
			}
			e.stopPropagation();
		}, "input");
	}
	
    /**
     * 获取开通转账银行账号
     */
	function queryAccount(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account; //资产账户
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var bank_code = "";
		var money_type = "";
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"account_type":userInfo._loginClass
		};
		service_common.queryAccounts(param,function(data){
			$.hidePreloader();
			queryAccountCallBack(data,param);
		},{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				clickFunc();
				$.hidePreloader();
			},"errorFunc":function(){
				clickFunc();
				$.hidePreloader();
			}});
//			$.showPreloaders("请等待...");
	}
	function queryAccountCallBack(data,param){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				var listHtml = "<div class='bank_list'><ul>";
				for(var i = 0;i < results.length; i++) {
					bankInfos[i+""] = results[i];
					var bank_accounts = results[i].bank_account || "";
					if(bank_accounts.length>0){
						bank_accounts = " ****"+bank_accounts.substring(bank_accounts.length-4,bank_accounts.length);
					}
					var fundseq = results[i].main_flag || "";
					if(fundseq == "1"){
						fundseq = "(主)";
					}
					else if(fundseq == "0"){
						fundseq = "(辅)";
					}
					
					var money_name = "";
					if(results[i].money_type=="0"){
						money_name="人民币";
					}
					else if(results[i].money_type=="1"){
						money_name="美元";
					}
					else if(results[i].money_type=="2"){
						money_name="港币";
					}
					bank_accounts = "<span class='span1'>"+fundseq+"</span><span>"+"保证金号:"+bank_accounts+"</span> <small class='small1'>"+results[i].bank_name+"</small><small>("+money_name+")</small>";
					listHtml += "<li id='"+i+"'><a href=\"javascript:void(0);\"><i></i>"+bank_accounts+"</a></li>";
					
					if(results[i].main_flag == "2" && results[i].money_type=="0"){
						RMBMainHTML = bank_accounts;
						RMBMainAccount =results[i];
					}
				}
				listHtml += "</ul></div>";
				
				common.addChoiceList($(_pageId+" .select_box p"), "选择银行和币种",listHtml,function(data,div){
					var id = data.attr("id");
					bankInfo = bankInfos[id];
					if(action == "#transferIn "){
						queryBankInfo(2);
						queryBankInfo(0);
						var isNeedQueryBankMoney=bankInfo.forbid_flag;
						//根据后端返回数据确定需要银行查询余额的功能
						if(isNeedQueryBankMoney=="1"){
							$(_pageId+action+" #bankMoney").hide();
						}else {
							$(_pageId+action+" #bankMoney").show();
						}
					}
					else{
						queryBankInfo(1);
						queryBalance();
					}
					$(_pageId+action+" .select_box p").html(data.find("a").html());
					$(_pageId+action+"div.unit input").next("em").text(money_typef[bankInfo.money_type]);
					bankNameFun(bankInfo.bank_name);
					//埋点
					if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
						if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
							common.comStat(107230,2,104,true,{"i_change_name":"转入银行卡列表","i_change_to":data.find("a").html()});
						}else{
							common.comStat(107239,2,104,true,{"i_change_name":"转出银行卡列表","i_change_to":data.find("a").html()});
						}
					}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
						if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
							common.comStat(105548,2,104,true,{"i_change_name":"转入银行卡列表","i_change_to":data.find("a").html()});
						}else{
							common.comStat(105562,2,104,true,{"i_change_name":"转出银行卡列表","i_change_to":data.find("a").html()});
						}
					}else{
						if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
							common.comStat(100362,2,104,true,{"i_change_name":"转入银行卡列表","i_change_to":data.find("a").html()});
						}else{
							common.comStat(100374,2,104,true,{"i_change_name":"转出银行卡列表","i_change_to":data.find("a").html()});
						}
					}
				},null,null,keyboard);
				
				//没有主人民币就取第一条
				if(Object.keys(RMBMainAccount).length <= 0){
					RMBMainAccount =bankInfos[0];
					var bank_accounts = RMBMainAccount.bank_account || "";
					if(bank_accounts.length>0){
						bank_accounts = " ****"+bank_accounts.substring(bank_accounts.length-4,bank_accounts.length);
					}
					var fundseq = RMBMainAccount.main_flag || "";
					if(fundseq == "1"){
						fundseq = "(主)";
					}
					else if(fundseq == "0"){
						fundseq = "(辅)";
					}
					var money_name = "";
					if(RMBMainAccount.money_type=="0"){
						money_name="人民币";
					}
					else if(RMBMainAccount.money_type=="1"){
						money_name="美元";
					}
					else if(RMBMainAccount.money_type=="2"){
						money_name="港币";
					}
					RMBMainHTML = "<span class='span1'>"+fundseq+"</span><span>"+"保证金号:"+bank_accounts+"</span> <small class='small1'>"+RMBMainAccount.bank_name+"</small><small>("+money_name+")</small>";
					bankNameFun(RMBMainAccount.bank_name);
				}
				//初次进页面，默认取人民币主账户，没有人民币主账户，取第一条
				if(Object.keys(RMBMainAccount).length > 0){
					bankInfo = RMBMainAccount;
					if(action == "#transferIn "){
						queryBankInfo(2);
						queryBankInfo(0);
						var isNeedQueryBankMoney=RMBMainAccount.forbid_flag;
						//根据后端返回数据确定需要银行查询余额的功能
						if(isNeedQueryBankMoney=="1"){
							$(_pageId+action+" #bankMoney").hide();
						}else {
							$(_pageId+action+" #bankMoney").show();
						}
					}
					else{
						queryBankInfo(1);
						queryBalance();
					}
					$(_pageId+action+" .select_box p").html(RMBMainHTML);
					$(_pageId+action+"div.unit input").next("em").text(money_typef[RMBMainAccount.money_type]);
					bankNameFun(RMBMainAccount.bank_name);
					clickFunc();
				}else{
					clickFunc();
				}
//				$(_pageId+".listSelection .list li").eq(0).triggerFastTap();
			}
			else{
				$(_pageId+" .select_box p").text("暂无保证金账户");
				clickFunc();
			}
		}
		else {
		   $.alert(data.error_info);
		   clickFunc();
	  	}
	}
	
	/**
	 * 展示首次入金的判断
	 */
	function bankNameFun(name){
		if($(_pageId+".toggle_nav li.active").index()==0){//转入
			if(name.indexOf("招商") != -1 || name.indexOf("信用招行") != -1){
				$(_pageId+".goldEntryTips").show();
				$(_pageId+".goldEntryTips").attr("type","1");
			}else if(name.indexOf("平安") != -1){
				$(_pageId+".goldEntryTips").show();
				$(_pageId+".goldEntryTips").attr("type","2");
			}else if(name.indexOf("浦发") != -1 || name.indexOf("信用浦发") != -1){
				$(_pageId+".goldEntryTips").show();
				$(_pageId+".goldEntryTips").attr("type","3");
			}else{
				$(_pageId+".goldEntryTips").hide();
				$(_pageId+".goldEntryTips").attr("type","");
			}
		}
	}
	
	function clickFunc(){
		// 弹出密码输入框
		$.bindEvent($(_pageId + "#enblance"), function(e){
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				common.comStat(107228,2,103,true,{"i_group_name":"查询银行余额"});
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105546,2,103,true,{"i_group_name":"查询银行余额"});
			}else{
				common.comStat(100360,2,103,true,{"i_group_name":"查询银行余额"});
			}
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(common.isValue(bankInfo)){
				if(balance_pwd){
					$(_pageId).attr("key-panel-main","false");
					var bank_text = $(_pageId + " .select_box p span").text();
					var html = '<div class="pop_pass"><div class="pop_main" style="padding: 0;"><span class="icon"></span><h5>请输入银行密码</h5><p>';
					html += bank_text+'</p><div class="input_text bankBalance"><input js-key="password8" class="t1" id="balance_password" type="password" placeholder="请输入银行密码" maxLength="6" class="text"></div></div></div>';
					common.iConfirm('',html,function($div){
						checkEnblance($div.find("input").val());
						$(_pageId).attr("key-panel-main","true");
					},function(){
						// 取消事件键盘未关闭，点击其他地方关闭50212报错
						if(keyboard){
							keyboard.closeKeyPanel();
						}
						$(_pageId).attr("key-panel-main","true");
					},"确定","取消",function($html){
						var pwd = $html.find("input").val();
						var vai1 = /^[0-9]{6}$/;
						if(validatorUtil.isEmpty(pwd)){
							$.alert("密码不能为空");
							return false;
						}else if(!vai1.test(pwd)){
							$.alert("请输入6位数字密码");
							return false;
						}else{
							return true;
						}
					});
					//根据弹框是不是在原生app中弹出判断弹出框是否上移，是上移30px
					if(global.callNative){
						$(_pageId+"div.prompt_box2").css({"margin-top":"-163.5px"});
					}
					if(keyboard){
						keyboard.keyInit();
					}
				}
				else
				{
					checkEnblance();
				}
			}
			else{
				$.alert("请选择查询的银行卡");
			}
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	 /**
     * 保证金可转余额查询
     */
	function queryBalance(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account; // 货币 ""所有货币，0 人民币，1 港币，2 美元
		var asset_account = bankInfo.fund_account;
		var cust_code = userInfo.cust_code; // 关联资产账户标志
		var money_type = bankInfo.money_type; // 货币 ""所有货币，0 人民币，1 港币，2 美元
		var sessionid = userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"appoint_fund_account": asset_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"money_type":money_type,
				"account_type":userInfo._loginClass
		};
		service_common.queryFundSelect(param,queryBalanceCallBack,{"isLastReq":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
//			$.showPreloaders("请等待...");
	}
	function queryBalanceCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results[0];
			if(results){
				$(_pageId+action+" input.maxs").val(results.fetch_balance);
			}
				
		}
	}
	
	 /**
     * 查询转账银行业务信息 
     */
	function queryBankInfo(transfer_direction){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account; // 货币 ""所有货币，0 人民币，1 港币，2 美元
		var cust_code = userInfo.cust_code; // 关联资产账户标志
		var money_type = bankInfo.money_type;
		var bank_code = bankInfo.bank_code;
		var transfer_direction = transfer_direction;
		var sessionid = userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"transfer_direction":transfer_direction,
				"account_type":userInfo._loginClass
		};
		service_common.queryBankInfo(param, function(data){
			$.hidePreloader();
			if(data.error_no == 0){
				var results = data.results[0];
				if(results){
//					var transfer_direction = results.transfer_direction; // 转账方向
					var fund_password_flag = results.fund_password_flag; // 资金密码标志
					var bank_password_flag = results.bank_password_flag; // 银行密码标志
					// 银行转证券
					if(transfer_direction == 0){
						if(fund_password_flag == 1 || fund_password_flag == 3){
							$(_pageId+action + " #stock_password").parent().show();
						}
						else{
							$(_pageId+action + " #stock_password").parent().hide();
						}
						if(bank_password_flag == 1){
							$(_pageId+action + " #bank_password").parent().show();
						}
						else{
							$(_pageId+action + " #bank_password").parent().hide();
						}
					} 
					else if(transfer_direction == 1){ // 证券转银行
						if(fund_password_flag == 1 || fund_password_flag == 3){
							$(_pageId+action + " #stock_password").parent().show();
						}
						else{
							$(_pageId+action+" #stock_password").parent().hide();
						}
						if(bank_password_flag == 1){
							$(_pageId+action + " #bank_password").parent().show();
						}
						else{
							$(_pageId+action + " #bank_password").parent().hide();
						}
					}else if(transfer_direction == 2){
						if(bank_password_flag == 1){
							balance_pwd = true;
						}
					}
				}
			}
		},{"isLastReq":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
//			$.showPreloaders("请等待...");
	}
	
	 /**
     * 提交转账
     */
	function transferSubmit(){
		if(common.size(bankInfos) == 0){
			$.alert("暂无可转账银行卡");
			return false;
		}
		if(!common.isValue(bankInfo)){
			$.alert("请选择转账银行卡");
			return false;
		}
		var moneyNum = $(_pageId+action + "#moneyNum").val(); // 转账金额
		if(moneyNum == ""){
			$.alert("请输入转账金额");
			return false;
		}else if(!validatorUtil.isNumberFloat(moneyNum)){
			$.alert("转账金额请输入数字");
			return false;
		}
		if(action == "#transferOut "){
			var max_transfer=$(_pageId + action + " input.maxs").val(); // 可转金额
			if($.trim(max_transfer).length<=0||parseFloat(max_transfer)<parseFloat(moneyNum)){
				$.alert("转账金额不足");
				return false;
			}
		}
		var fund_password = "";
		var bank_password = "";
		var fund_passwords = $(_pageId+action + "#stock_password");
		var bank_passwords = $(_pageId+action + "#bank_password");
		if(fund_passwords.parent().css("display") != "none"){
			fund_password = fund_passwords.val();	
			if(fund_password == ""){
				$.alert("请输入资金密码");
				return false;
			}
		}
		if(bank_passwords.parent().css("display") != "none"){
			bank_password = bank_passwords.val();	
			if(bank_password == ""){
				$.alert("请输入银行密码");
				return false ;
			}else if(bank_password.length !=6){
				$.alert("银行密码长度为6位数");
				return false ;
			}
		}
		var pwd = {
			"bank_password":bank_password,
			"fund_password":fund_password
		};
		
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account;	// 资产账户
		var branch_no = userInfo.branch_no;	// 分支机构
		var sessionid = userInfo.sessionid;
		var bank_code = bankInfo.bank_code;
		var client_account = bankInfo.bank_account;
		var money_type = bankInfo.money_type;
		var transfer_direction = "0";
		if(action == "#transferOut "){
			transfer_direction = "1";
		}
		var tranamt=moneyNum;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"transfer_direction":transfer_direction,
				"tranamt":tranamt,
				"fund_password":fund_password,
				"bank_password":bank_password,
				"client_account":client_account,
				"account_type":userInfo._loginClass
		};
		service_common.transfer(param,transferCallBack,{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}});
	}
	
	function transferCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			$.alert("转账请求已发送，流水号为："+data.results[0].serial_no+"<br/>可在转账流水中查询转账结果!");
			resetBuyForm();
			queryBalance();
		}
		else{
			resetBuyForm();
//			queryBalance();
			$.alert(data.error_info);
		}
	}
	
	 /**
    * 查询银行余额
    */
	function checkEnblance(pwd){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var cust_code = userInfo.cust_code;	// 客户代码
		var fund_account = userInfo.fund_account; // 资产账户
		var branch_no  = userInfo.branch_no; // 分支机构
		var sessionid = userInfo.session_id;
		var bank_code = bankInfo.bank_code;
		var money_type = bankInfo.money_type;  //  0：人民币，1：美元，2：港币
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"bank_code":bank_code,
				"money_type":money_type,
				"bank_password":pwd,
				"account_type":userInfo._loginClass
		};
		service_common.bankBalance(param,function(data){
			$.hidePreloader();
			if(data.error_no == 0){
				var results = data.results[0];
				if(results){
					var fundeffect = 0.00;
					if(results.fundeffect){
						if(validatorUtil.isNumberFloat(results.fundeffect)){
							fundeffect = Number(results.fundeffect).toFixed(2);
						}
					}
					$(_pageId + "#enblance").prev("input").val(fundeffect);
					// _bankAvalibleFund=fundeffect;
				}
			}
			else{
				$.alert(data.error_info);
			}
		},{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}});
	}
	
	// 数据重置
	function resetBuyForm(){
		$(_pageId + "#moneyNum").quzhi("");
		$(_pageId + " #enblance").prev("input").val("");
		$(_pageId + " #bank_password").quzhi("");
		$(_pageId + " #stock_password").quzhi("");
		// $(_pageId + " #bank_password").parent().hide();
		// $(_pageId + " #stock_password").parent().hide();
		// $(_pageId + ".select_box p").html("请选择...");
		$(_pageId+".bank_list li").removeClass("active");
		// $(_pageId + " input.maxs").val("--");
		$(_pageId+"div.unit input").next("em").text('元');
		// _bankAvalibleFund="0";
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + "#enblance").unbind();
		bankInfo=[];
		RMBMainAccount = [];
		resetBuyForm();
		$(_pageId + " .listSelection").remove();
		action = "#transferIn ";
		$(_pageId + "#transferOut").hide();
		$(_pageId + "#transferIn").show();
		$(_pageId + ".select_box p").html("请选择...");
		$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
		g_need_bank_passwd = false; // 是否需要银行密码
		g_need_fund_passwd = false;// 是否需要资金密码
		$(_pageId+".goldEntryTips").hide();
		$(_pageId+".goldEntryTips").attr("type","");
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});