/**
 * 交易转账流水查询
 */
define('trade/scripts/banking/transferFlow.js', function(require, exports, module) {
    var service_common = require("service_common");
    var gconfig = $.config;
    var global = gconfig.global;
    var commonFunc = require("commonFunc");
    var nativePluginService = require("nativePluginService");
    var common = require("common");
    var _pageId = "#banking_transferFlow ";
    var money_typef = {"0":"元","1":"美元","2":"港币"};
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var userInfo = null;
    var stringUtils = require("stringUtils"); // 字符串工具类
    var pageGlobal = {
        "tabType": 0,
        "screen_type": 0,
        "screen_status": 0,
        "search_type": "1",
        "trans_type": 0,
        "trans_status": 0
    };

    /**
     * 初始化
     */
    function init(){

    }

    function load(){
        userInfo = common.getCurUserInfo();
        if(userInfo._loginClass&&userInfo._loginClass=="2"){
            common.pageBuryingPoint("107244");
        }else if(userInfo._loginClass&&userInfo._loginClass=="1"){
            common.pageBuryingPoint("105563");
        }else{
            common.pageBuryingPoint("100380");
        }
        commonFunc.initTimeChoice(_pageId,30,true); //日历插件
        queryHistory();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent(){
        // 返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
            //埋点
            if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
                common.comStat(107245,2,103,true,{"i_group_name":"返回"});
            }else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
                common.comStat(105564,2,103,true,{"i_group_name":"返回"});
            }else{
                common.comStat(100381,2,103,true,{"i_group_name":"返回"});
            }
            $.pageInit("banking/transferFlow","banking/transferNew","","left");
            e.preventDefault();
        });

        // 近一周/近1月/近3月/自定义
        $.bindEvent($(_pageId + "#cycleTab li"),function(e){
            var maiEle = $(this);
            var isTrue = maiEle.hasClass("active");
            var index = maiEle.index();
            if(!isTrue) {
                pageGlobal.tabType = index;
                maiEle.toggleClass("active");
                maiEle.siblings("li").removeClass("active");
                switch(index) {
                    case 0:
                        pageGlobal.search_type = "1";
                        $(_pageId + ".subTit_tab .date_box").hide();
                        break;
                    case 1:
                        pageGlobal.search_type = "2";
                        $(_pageId + ".subTit_tab .date_box").hide();
                        break;
                    case 2:
                        pageGlobal.search_type = "3";
                        $(_pageId + ".subTit_tab .date_box").hide();
                        break;
                    case 3:
                        pageGlobal.search_type = "0";
                        $(_pageId + ".subTit_tab .date_box").show();
                        break;
                }
                queryHistory();
            }
        });

        // 转账流水-筛选
        $.bindEvent($(_pageId + ".icon_screen"),function(e){
            $(_pageId + ".maskFlow").toggle();
        });

        // 转账流水-筛选-交易类型/交易状态
        $.bindEvent($(_pageId + ".tab_screen li"),function(e){
            var maiEle = $(this);
            var type = maiEle.attr("type").split("_");
            var isTrue = maiEle.hasClass("active");
            if(!isTrue) {
                maiEle.siblings("li").removeClass("active");
                maiEle.addClass("active");
                if(type[0]=="t") {
                    pageGlobal.screen_type = type[1];
                } else {
                    pageGlobal.screen_status = type[1];
                }
            }
        });

        // 转账流水-筛选-重置/确定
        $.bindEvent($(_pageId + ".btn_okReset a"),function(e){
            var maiEle = $(this);
            var index = maiEle.index();
            maiEle.siblings("a").removeClass("active");
            maiEle.addClass("active");
            if(index===1) {
                pageGlobal.trans_type = pageGlobal.screen_type;
                pageGlobal.trans_status = pageGlobal.screen_status;
                $(_pageId + ".maskFlow").hide();
                queryHistory();
            } else {
                pageGlobal.screen_type = 0;
                pageGlobal.screen_status = 0;
                $(_pageId + ".tab_screen li").removeClass("active");
                $(_pageId + ".tab_screen li.ts0").addClass("active");
            }
        });

        // 净流入-?
        $.bindEvent($(_pageId + "#doubt"),function(e){
            $(_pageId + "#netIntoMask").show();
        });

        // 净流入-净流入说明-确定
        $.bindEvent($(_pageId + "#netIntoMask .btn_ok"),function(e){
            $(_pageId + "#netIntoMask").hide();
        });

        // 日历查询
        $.bindEvent($(_pageId + ".date_box a"),function(e){
            queryHistory();
            //埋点
            var end_time = $(_pageId + "#endDate").text();
            var begin_time = $(_pageId + "#startDate").text();
            var time1 = begin_time.replaceAll("-", "");
            var time2 = end_time.replaceAll("-", "");
            if(userInfo._loginClass&&userInfo._loginClass=="2"){ //期权交易
                common.comStat(107249,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
            }else if(userInfo._loginClass&&userInfo._loginClass=="1"){ //信用交易
                common.comStat(105567,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
            }else{
                common.comStat(100384,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
            }
        });

        // 转账流水-单条失败节点查看
        $.preBindEvent($(_pageId + ".record_list"),".owner_detail",function(e){
            var mainEle = $(this);
            var state = mainEle.attr("state");
            if(state=="fail") {
                mainEle.find(".ui2").toggle();
            }
        });
    }

    function queryHistory() {
        var end_time = "";
        var begin_time = "";
        if(pageGlobal.tabType==3) {  //根据指定日期查询
            end_time = $(_pageId + "#endDate").text();
            begin_time = $(_pageId + "#startDate").text();	//截止时间
            var endTime = new Date(end_time.replaceAll("-", "/"));
            var startTime = new Date(begin_time.replaceAll("-", "/"));
            if(endTime<startTime) {
                $.alert("开始日期不能大于截止日期");
                return false;
            }
        }
        var cust_code = userInfo.cust_code;	//客户代码
        var fund_account = userInfo.fund_account;	//资产账户
        var branch_no = userInfo.branch_no;	//分支机构
        var sessionid = userInfo.session_id;
        var param = {
            "search_type": pageGlobal.search_type,
            "trans_type": pageGlobal.trans_type,
            "trans_status": pageGlobal.trans_status,
            "entrust_way": global.entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "money_type": "",
            "begin_time": begin_time,
            "end_time": end_time,
            "transfer_direction": "",
            "account_type": userInfo._loginClass
        };
        service_common.transferHistoryFlow(param,function(data) {
            $.hidePreloader();
            if(data.error_no == 0) {
                var htmlStr = "";
                var results = data.results;
                if(results && results.length>0) {
                    var dataList = results[0].dataList;
                    var transfer_direction = "";
                    var tranamt = "";  //转账金额
                    var mark = "";
                    var bank_error_info = "";
                    var transfer_direction_name = ""; //转账类型
                    var money_type = "";  //金额单位类型 0:元  1:美元  2:港币
                    var business_date = "";  //转账日期
                    var business_time = "";  //转账时间
                    var bank_name = "";
                    var entrust_state_name = "";
                    var failA = "",failStr = "",state = "";
                    var classVal = "";

                    var netIn = results[0].netIn; //净流入
                    var transferIn = results[0].transferIn; //转入
                    var transferOut = results[0].transferOut; //转出
                    netIn = stringUtils.moneyFormat(netIn);
                    transferIn = stringUtils.moneyFormat(transferIn);
                    transferOut = stringUtils.moneyFormat(transferOut);
                    $(_pageId + "#totalInOut li").eq(0).find("em").html(transferIn);
                    $(_pageId + "#totalInOut li").eq(1).find("em").html(transferOut);
                    $(_pageId + "#totalInOut li").eq(2).find("em").html(netIn);

                    if(isJsonObj(dataList)) {
                        dataList = JSON.parse(dataList);

                        for(var i=0,len=dataList.length;i<len;i++) {
                            var item = dataList[i];
                            transfer_direction = item["transfer_direction"];
                            mark = item["mark"];
                            bank_error_info = item["bank_error_info"];
                            transfer_direction_name = item["transfer_direction_name"];
                            money_type = item["money_type"];
                            business_date = item["business_date"];
                            business_time = item["business_time"];
                            bank_name = item["bank_name"];
                            entrust_state_name = item["entrust_state_name"];
                            tranamt = item["tranamt"];

                            failA = "",failStr = "",state = "";
                            tranamt = stringUtils.moneyFormat(tranamt);
                            if(transfer_direction=="0") {  // +
                                classVal = "iconInto";
                                tranamt = "+" + tranamt;
                            } else if(transfer_direction=="1") { // -
                                classVal = "iconOut";
                                tranamt = "-" + tranamt;
                            } else {
                                classVal = "iconQuery";
                            }
                            if(mark.indexOf("失败") != "-1") {
                                state = "fail";
                                failA = '<a href="javascript:void(0);">失败</a>';
                                failStr = bank_error_info;
                            }
                            htmlStr += '<div class="owner_detail" state="'+state+'">\n' +
                                '                            <div class="ui1">\n' +
                                '                                <div class="row-1">\n' +
                                '                                    <em class="'+classVal+'"></em>\n' +
                                '                                    <p><label>'+transfer_direction_name+'</label><span>'+business_date+' '+business_time+'</span></p>\n' +
                                '                                </div>\n' +
                                '                                <div class="row-1">\n' +
                                '                                    <p>'+failA+'<label>'+tranamt+'</label><span>'+bank_name+'</span></p>\n' +
                                '                                </div>\n' +
                                '                            </div>\n' +
                                '                            <div class="ui2" style="display: none;">\n' +
                                '                                <p>'+failStr+'</p>\n' +
                                '                            </div>\n' +
                                '                        </div>';
                        }
                    }
                }
                $(_pageId + ".record_list .data_box").html(htmlStr);
                if(htmlStr) {
                    $(_pageId + ".record_list").show();
                    $(_pageId + ".list_end").show();
                    $(_pageId + ".nodata").hide();
                } else {
                    $(_pageId + ".record_list").hide();
                    $(_pageId + ".list_end").hide();
                    $(_pageId + ".nodata").show();
                }
            } else {
                $.alert(data.error_info);
            }
        },{"isLastReq":true,"isShowWait":true,"isShowOverLay":false,
            "timeOutFunc": function(){
                $.hidePreloader();
            },"errorFunc": function(){
                $.hidePreloader();
            }});
    }

    function isJsonObj(str) {
        if(typeof str == 'string') {
            try {
                var obj = JSON.parse(str);
                if(typeof obj == 'object' && obj ){
                    return true;
                } else {
                    return false;
                }
            } catch(e) {
                console.log('error: '+ str +':'+e);
                return false;
            }
        }
    }

    /**
     * 销毁
     */
    function destroy(){
        pageGlobal.tabType = 0;
        pageGlobal.screen_type = 0;
        pageGlobal.screen_status = 0;
        pageGlobal.search_type = "1";
        pageGlobal.trans_type = 0;
        pageGlobal.trans_status = 0;
        $(_pageId + ".tab_screen li").removeClass("active");
        $(_pageId + ".tab_screen li.ts0").addClass("active");
        $(_pageId + ".maskFlow").hide();
        $(_pageId + "#cycleTab li").removeClass("active");
        $(_pageId + "#cycleTab li").eq(0).addClass("active");
        $(_pageId + ".record_list .data_box").html("");
        $(_pageId + ".nodata").hide();
        $(_pageId + "#netIntoMask").hide();
        $(_pageId + ".list_end").hide();
        $(_pageId + ".subTit_tab .date_box").hide();
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }

    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
