/**
 * 交易转账流水查询
 */
define('trade/scripts/banking/transferHistory.js', function(require, exports, module) {
	var service_common = require("service_common");
	var gconfig = $.config;
	var global = gconfig.global;
	var commonFunc = require("commonFunc");
	var common = require("common");
    var _pageId = "#banking_transferHistory ";
    var money_typef = {"0":"元","1":"美元","2":"港币"};
    var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var userInfo = null;
    var witchAccount = "";  // 登录的账号类型
    
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		if(userInfo._loginClass&&userInfo._loginClass=="2"){
			common.pageBuryingPoint("107244");
		}else if(userInfo._loginClass&&userInfo._loginClass=="1"){
			common.pageBuryingPoint("105563");
		}else{
			common.pageBuryingPoint("100380");
		}
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		buryingPoint();
    }
	
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	
	function backgroundInterface(){
		commonFunc.initTimeChoice(_pageId,7);
		queryHistory();
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				common.comStat(107245,2,103,true,{"i_group_name":"返回"});
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105564,2,103,true,{"i_group_name":"返回"});
			}else{
				common.comStat(100381,2,103,true,{"i_group_name":"返回"});
			}
			$.pageBack("banking/transfer","left");
			e.preventDefault();
		});
		// 时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			queryHistory();
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
				common.comStat(107249,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
			}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105567,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
			}else{
				common.comStat(100384,2,104,true,{"i_change_name":"转账流水查询","i_change_to":time1+"-"+time2});
			}
		});
	}
    
    /*
     * 埋点参数
     */
    function buryingPoint(){
		if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
			$(_pageId+".date_filter").attr("startObjectId","107247");
			$(_pageId+".date_filter").attr("endObjectId","107248");
			$(_pageId+".date_filter").attr("actionId","104");
		}else if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
			$(_pageId+".date_filter").attr("startObjectId","105565");
			$(_pageId+".date_filter").attr("endObjectId","105566");
			$(_pageId+".date_filter").attr("actionId","104");
		}else{
			$(_pageId+".date_filter").attr("startObjectId","100382");
			$(_pageId+".date_filter").attr("endObjectId","100383");
			$(_pageId+".date_filter").attr("actionId","104");
		}
    }
	/**
	 * 转账转账  (300203)
	 */
	function queryHistory(){
		$(_pageId + ".bank_over ul").html("");
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	//截止时间
		var time1 = new Date(end_time.replaceAll("-", "/"));
		var time2 = new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
		    $.alert("开始日期大于截止日期");
		    return false;
		}
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var money_type = "";//货币 ""所有货币，0 人民币，1 港币，2 美元 
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var transfer_direction = "";	
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"money_type":money_type,
				"begin_time":begin_time,
				"end_time":end_time,
				"transfer_direction":transfer_direction,
				"account_type":userInfo._loginClass
		};
		service_common.transferQuery(param,function(data){
			if(data.error_no != 0){
				$.alert(data.error_info);
			}else{
				$(_pageId + ".no_data").hide();
				var results = data.results;
				if(results && results.length> 0 && typeof results != "undefined"){
					// 显示历史流水数据
					showHistory(results);
					$(_pageId + ".visc_pullUp").hide();
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
			}
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	/**
	 * 显示流水数据
	 */
	function showHistory(results){
		var strHtmls = "";
		for(var i=0 ;i<results.length;i++){
    		var css = "";
    		var tranamt = results[i].tranamt;
    		var transfer_direction = results[i].transfer_direction;
    		if(transfer_direction == "0"){
    			css = "ared";
    			tranamt = "+"+tranamt;
    		}else if(transfer_direction == "1"){
    			css = "agreen";
    			tranamt = "-"+tranamt;
    		}
    		else if(transfer_direction == "2"){
//  			tranamt = results[i].fundbal;
    		}
    		var failedNote = "";
    		if(results[i].entrust_name){
    			failedNote = ": " + results[i].entrust_name;
    		}
    		if(results[i].entrust_name.indexOf("失败") != "-1"){
    			failedNote += " " + results[i].bank_error_info;
    		}
			strHtmls += "<li style=\"height: initial;line-height: initial;position: relative;\">";
			strHtmls += "<p style=\"position: absolute;padding-top: 0.02rem;clear: both;\">"+results[i].transfer_direction_name+"</p>";
			strHtmls += "<strong style=\"text-align: right;float: none;display: block;padding-left: 50%;\" class="+css+">"+tranamt+"<em style='font-size: 0.12rem;color: #777;padding-left: 0.02rem;'>"+money_typef[results[i].money_type]+"</em></strong>";
			strHtmls += "<span style=\"position: absolute;padding-top: 0.03rem;  white-space: nowrap;\" class=\"time\">"+results[i].business_date+" "+results[i].business_time+"</span>";
			strHtmls += "<em style=\"display: block;min-height: 0.16rem;text-align: right;padding-left: 40%;\">"+results[i].bank_name+failedNote+"</em>";
			// strHtmls += "<p style=\"position: absolute;  white-space: nowrap;\">"+results[i].entrust_name+"委托类型</p>";
			strHtmls += "<span style=\"position: absolute;padding-top: 0.03rem;  white-space: nowrap;\" class=\"time\">"+results[i].trans_name+"</span>";
			strHtmls += "<em style=\"display: block;min-height: 0.16rem;text-align: right;padding-left: 40%;\">"+results[i].entrust_state_name+"</em>";
			strHtmls += "</li>";
		}
		$(_pageId + ".bank_over ul").html(strHtmls);
		$(_pageId + ".visc_pullUp").hide();
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryHistory(); // 模拟查询接口数据操作
				if(userInfo._loginClass&&userInfo._loginClass=="2"){//期权交易
					common.comStat(107246,2,102,true,{"i_direct":"1","i_type":"1"});
				}
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		 $(_pageId + ".no_data").hide();
		 $(_pageId + ".top_title .top_nav").hide();
		 $(_pageId + ".bank_over ul").html("");
		 if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		 $(_pageId + " .top_title small").text("一周内");
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});