/**
 * 交易转账
 */
define('trade/scripts/banking/transferNew.js', function(require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var commonFunc = require("commonFunc");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var nativePluginService = require("nativePluginService");
    var _pageId = "#banking_transferNew ";
    var keyboardUtils = require("keyboardUtils");
    var keyboard = require("keyboard");
    var stringUtils = require("stringUtils"); // 字符串工具类
    require("../common/picker.min.js");
    var pageGlobal = {
        "userInfo": "",
        "tabType": 0,
        "bankArr1": [],
        "bankArr2": [],
        "bankInfo": {},
        "bondBalance": "", //证券可转金额
        "screen_type": "0",
        "screen_status": "0",
        "trans_type": "0",    //1:转入 2:转出 3:其他 0:全部
        "trans_status": "0",   //1:成功 2:失败 3:其他 0:全部
        "numArr": ['','','','','千','万','十万','百万','千万','亿','十亿','百亿','千亿','万亿','亿亿']
    };
    var bankSelectFunc = null;

        /**
     * 初始化
     */
    function init() {

    }

    function load() {
        window.onresize = null;
        if($.getSStorageInfo(_pageId+"subPageFlag")=="true") {
            $.clearSStorage(_pageId+"subPageFlag");
        } else {
            var paramObj = $.getPageParam();
            var paramMap = $.getPageParam("param");
            if(paramMap && Object.getOwnPropertyNames(paramMap).length != 0){
                if(paramMap && typeof(paramMap) == "string"){
                    paramMap = JSON.parse(paramMap);
                }
                paramMap.switchUserInfo = paramObj["switchUserInfo"] || paramMap.switchUserInfo;
                if(paramMap.switchUserInfo){
                    common.switchingCurUser(paramMap.switchUserInfo);
                }
            }
            /************** 初始化密码控件 begin*********/
            if(keyboard) {
                keyboard.keyInit(null,null,null,null,{"iptCallBack":checkInput,"pointNum":2});
            }
            // 查询银行余额密码框
            keyboardUtils.initPwdWindow(null,null,null,{"keyType": 8,"okFunc": queryBankBalance});
            /*************** 初始化密码控件 end************/
            pageGlobal.userInfo = common.getCurUserInfo();
            var lookTab = "0";
            if($.getPageParam("lookTab")){
                lookTab = $.getPageParam("lookTab");
            }else if($.getPageParam() && $.getPageParam().param && $.getPageParam().param.lookTab){
                lookTab = $.getPageParam().param.lookTab;
            }
            // console.log($.getPageParam("lookTab"),$.getCurrentPageObj(),$.getPageParam());
            pageGlobal.tabType = parseInt(lookTab);
            tabSwitch();
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回
        $.bindEvent($(_pageId + ".header .icon_back"),function(e){
            commonFunc.appThirdBack('banking_transferNew', function(){
                var prePage = $.getCurrentPageObj().prePageCode;
                var pageCodeArr = ["banking/transferFlow","banking/transferResult"];
                if(pageCodeArr.indexOf(prePage) > -1) {
                    $.pageInit("banking/transferNew","account/index","","left");
                } else {
                    $.pageBack("account/index","left");
                }
            });
        });

        // tab-银行转证券/证券转银行/转账流水
        $.bindEvent($(_pageId + ".subTit_tab li"),function(e){
            var maiEle = $(this);
            var isTrue = maiEle.hasClass("active");
            var index = maiEle.index();
            if(!isTrue) {
                pageGlobal.tabType = index;
                tabSwitch();
            }
        });

        // 查询银行余额
        $.bindEvent($(_pageId + ".balance_box a"),function(e){
            e.stopPropagation();
            if(keyboard) {
                keyboard.closeKeyPanel();
            }
            if(switchBank(true,"2")) {
                keyboardUtils.showPwdWindow({"keyType": 8,"okFunc": queryBankBalance});
            }
        });

        // 证券转银行-全部
        $.bindEvent($(_pageId + ".buy_input .all"),function(e){
            e.stopPropagation();
            if(pageGlobal.bondBalance) {
                $(_pageId + "#moneyNum").val(pageGlobal.bondBalance);
                $(_pageId + "div#moneyNum").find("div.key_place").hide();
                $(_pageId + "div#moneyNum").find("div.key_input div.key_text").html(pageGlobal.bondBalance);
                checkInput();
            }
        });

        // 转账按钮
        $.bindEvent($(_pageId + "#transferBtn"),function(e){
            var isTrue = $(this).hasClass("grayBtn");
            if(!isTrue) {
                $(_pageId + "#transfer #transferBtn").addClass("grayBtn");
                transferSubmit();
            }
        });

        // 银行提示按钮
        $.bindEvent($(_pageId + ".outInto1"),function(e){
            common.singleIConfirmNew("温馨提示", '部分存管银行（如建设银行、农业银行等）返回给证券公司的是银行内部存管账号、非客户真实的银行借记卡卡号，显示的尾号可能会出现不一致的情况，但不影响转账操作，请以实际转账结果为准。详细可咨询对应存管银行。', function () {
            }, "我知道了");
        });

        // 净流入-?
        $.bindEvent($(_pageId + "#doubt"),function(e){
            $(_pageId + "#netIntoMask").show();
        });

        // 净流入-净流入说明-确定
        $.bindEvent($(_pageId + "#netIntoMask .btn_ok"),function(e){
            $(_pageId + "#netIntoMask").hide();
        });

        // 转账流水-筛选
        $.bindEvent($(_pageId + ".tit_screen label"),function(e){
            $(_pageId + ".maskFlow").toggle();
        });

        // 转账流水-更多历史转账
        $.bindEvent($(_pageId + ".tit_screen span"),function(e){
            $.setSStorageInfo(_pageId+"subPageFlag","true");
            $.pageInit("banking/transferNew","banking/transferFlow");
        });

        // 转账流水-更多历史转账
        $.bindEvent($(_pageId + "#transferFlow .nodata #moreBtn"),function(e){
            $.setSStorageInfo(_pageId+"subPageFlag","true");
            $.pageInit("banking/transferNew","banking/transferFlow");
        });

        // 转账流水-筛选-交易类型/交易状态
        $.bindEvent($(_pageId + ".tab_screen li"),function(e){
            var maiEle = $(this);
            var type = $(this).attr("type").split("_");
            var isTrue = maiEle.hasClass("active");
            if(!isTrue) {
                maiEle.siblings("li").removeClass("active");
                maiEle.addClass("active");
                if(type[0]=="t") {
                    pageGlobal.screen_type = type[1];
                } else {
                    pageGlobal.screen_status = type[1];
                }
            }
        });

        // 转账流水-筛选-重置/确定
        $.bindEvent($(_pageId + ".btn_okReset a"),function(e){
            var maiEle = $(this);
            var index = maiEle.index();
            maiEle.siblings("a").removeClass("active");
            maiEle.addClass("active");
            if(index===1) {
                pageGlobal.trans_type = pageGlobal.screen_type;
                pageGlobal.trans_status = pageGlobal.screen_status;
                $(_pageId + ".maskFlow").hide();
                queryTodayRecords();
            } else {
                pageGlobal.screen_type = "0";
                pageGlobal.screen_status = "0";
                $(_pageId + "#transferFlow .tab_screen li").removeClass("active");
                $(_pageId + "#transferFlow .tab_screen li.ts0").addClass("active");
            }
        });

        // 转账流水-单条失败节点查看
        $.preBindEvent($(_pageId + "#transferFlow"),".owner_detail",function(e){
            var mainEle = $(this);
            var state = mainEle.attr("state");
            if(state=="fail") {
                mainEle.find(".ui2").toggle();
            }
        });

        // 转出银行/转入银行
        $.bindEvent($(_pageId + "#transfer #bankName"),function(e){
            if(!common.isValue(pageGlobal.bankArr2)) {
                $.alert("暂无可转账银行卡");
            } else {
                var titleStr = pageGlobal.tabType===0?'选择转出银行':'选择转入银行';
                bankSelectFunc && bankSelectFunc(function(data,vals){
                    if(data.status === "0"){
                        var num = vals[data.selectIndex];
                        pageGlobal.bankInfo = (pageGlobal.bankArr1)[num];
                        switchBank(false,"1");
                    }
                },titleStr);
                // var picker = new Picker({
                //     title: titleStr,
                //     data: [pageGlobal.bankArr2]
                // });
                // picker.on('picker.valuechange',function(selectedVal,selectedIndex) {
                //     var num = selectedVal[0];
                //     pageGlobal.bankInfo = (pageGlobal.bankArr1)[num];
                //     switchBank(false,"1");
                // });
                // picker.show();
            }
        });

        // 监听金额输入框
        $.bindEvent($(_pageId + "#transfer #moneyNum"),function(e){
            $(this).get(0).addEventListener("input",checkInput,false);
        },'focus');

        // 首次入金指引
        $.bindEvent($(_pageId + "#inGold span"),function(e){
            $.setSStorageInfo(_pageId+"subPageFlag","true");
            var type = $(this).parent().attr("type");
            if(type=="1") { //招商
                $.pageInit("banking/transferNew","banking/zsGoldEntryGuide");
            } else if(type=="2") { //平安
                $.pageInit("banking/transferNew","banking/paGoldEntryGuide");
            } else if(type=="3") { //浦发
                $.pageInit("banking/transferNew","banking/pfGoldEntryGuide");
            }
        });
    }

    /**
     * 获取开通转账银行账号
     */
    function queryAccount() {
        var cust_code = (pageGlobal.userInfo).cust_code;	//客户代码
        var fund_account = (pageGlobal.userInfo).fund_account; //资产账户
        var branch_no = (pageGlobal.userInfo).branch_no;	//分支机构
        var sessionid = (pageGlobal.userInfo).session_id;
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var bank_code = "";
        var money_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "bank_code": bank_code,
            "money_type": money_type,
            "account_type": (pageGlobal.userInfo)._loginClass
        };
        service_common.queryAccounts(param,function(data){
            $.hidePreloader();
            pageGlobal.bankArr1 = [];
            pageGlobal.bankArr2 = [];
            if(data.error_no == 0) {
                var results = data.results;
                if(results && results.length > 0) {
                    pageGlobal.bankArr1 = results;
                    var bank_name = "";
                    var account_long = "",account_short = "";
                    var main_flag = "";
                    var money_type = "";
                    var bankList = [],bankVals = [];
                    for(var i=0,len=results.length;i<len;i++) {
                        var item = results[i];
                        bank_name = item["bank_name"];
                        account_long = item["bank_account"];
                        main_flag = item["main_flag"]; //1:主  0:辅
                        money_type = item["money_type"]; //0:人民币 1:美元 2:港币

                        account_short = "";
                        if(account_long) {
                            account_short = account_long.substring((account_long.length)-4);
                            account_short = '(尾号 '+account_short+')';
                        }
                        var signStr = switchSign(3,money_type+"");
                        var text = bank_name + account_short + ' ' + signStr;
                        pageGlobal.bankArr2.push({
                            "text": text,
                            "value": i
                        });
                        bankList.push(text);
                        bankVals.push(i);

                        //默认取主人民币，没有就取第一条
                        if(main_flag=="2" && money_type=="0") {
                            pageGlobal.bankInfo = item;
                            switchBank(false,"1");
                        } else {
                            if(i===0) {
                                pageGlobal.bankInfo = item;
                                switchBank(false,"1");
                            }
                        }
                    }
                    bankSelectFunc = commonFunc.nativeSelect("选择转出银行",bankVals,bankList);
                    queryBankInfo();
                }
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function(){
                $.hidePreloader();
            },"errorFunc":function(){
                $.hidePreloader();
            }});
    }

    /**
     * 查询转账银行业务信息 303038、305024、300201
     */
    function queryBankInfo() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = (pageGlobal.userInfo).branch_no;
        var fund_account = (pageGlobal.userInfo).fund_account;
        var cust_code = (pageGlobal.userInfo).cust_code; // 关联资产账户标志
        var money_type = (pageGlobal.bankInfo).money_type; // 货币 ""所有货币，0 人民币，1 港币，2 美元
        var bank_code = (pageGlobal.bankInfo).bank_code;
        var transfer_direction = pageGlobal.tabType;
        var sessionid = (pageGlobal.userInfo).session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "bank_code": bank_code,
            "money_type": money_type,
            "transfer_direction": transfer_direction,
            "account_type": (pageGlobal.userInfo)._loginClass
        };
        service_common.queryBankInfo(param, function(data) {
            $.hidePreloader();
            if(data.error_no == 0) {
                var results = data.results;
                if(results && results.length>0) {
                    var item = results[0];
                    var fund_flag = item["fund_password_flag"]; // 资金密码标志
                    var bank_flag = item["bank_password_flag"]; // 银行密码标志

                    if(fund_flag=="1" || fund_flag=="3") {
                        $(_pageId + " #fundPwd").parent().show();
                    } else {
                        $(_pageId + " #fundPwd").parent().hide();
                    }
                    if(bank_flag=="1") {
                        $(_pageId + " #bankPwd").parent().show();
                    } else {
                        $(_pageId + " #bankPwd").parent().hide();
                    }
                }
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function() {
                $.hidePreloader();
            },"errorFunc": function(){
                $.hidePreloader();
            }});
    }

    /**
     * 保证金可转余额查询
     */
    function queryBalance() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = (pageGlobal.userInfo).branch_no;
        var fund_account = (pageGlobal.userInfo).fund_account;
        var asset_account = (pageGlobal.bankInfo).fund_account;
        var cust_code = (pageGlobal.userInfo).cust_code; // 关联资产账户标志
        var money_type = (pageGlobal.bankInfo).money_type; // 货币 ""所有货币，0 人民币，1 港币，2 美元
        var sessionid = (pageGlobal.userInfo).session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "appoint_fund_account": asset_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "money_type": money_type,
            "account_type": (pageGlobal.userInfo)._loginClass
        };
        service_common.queryFundSelect(param,function(data) {
            $.hidePreloader();
            var fetch_balance = 0;
            if(data.error_no == 0) {
                var results = data.results;
                if(results && results.length>0) {
                    fetch_balance = results[0].fetch_balance; //证券可转金额
                    pageGlobal.bondBalance = parseFloat(fetch_balance) || 0;

                    var unitStr = switchSign("2");
                    fetch_balance = stringUtils.moneyFormat(fetch_balance);
                    $(_pageId + "#bondBalance").html(fetch_balance +''+ unitStr);
                }
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function(){
                $.hidePreloader();
            },"errorFunc": function(){
                $.hidePreloader();
            }});
    }

    /**
     * 查询银行余额
     */
    function queryBankBalance(pwdObj) {
        var curPwd = pwdObj["pwdStr"];
        if(curPwd.length <= 0) {
            return false;
        }
        if(keyboardUtils) {
            keyboardUtils.hidePwdWindow();
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var cust_code = (pageGlobal.userInfo).cust_code;	// 客户代码
        var fund_account = (pageGlobal.userInfo).fund_account; // 资产账户
        var branch_no  = (pageGlobal.userInfo).branch_no; // 分支机构
        var sessionid = (pageGlobal.userInfo).session_id;
        var bank_code = (pageGlobal.bankInfo).bank_code;
        var money_type = (pageGlobal.bankInfo).money_type;  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "bank_code": bank_code,
            "money_type": money_type,
            "bank_password": pwdObj["pwdStr"],
            "account_type":(pageGlobal.userInfo)._loginClass
        };
        service_common.bankBalance(param,function(data) {
            $.hidePreloader();
            var fundeffect = 0;
            if(data.error_no == 0) {
                var results = data.results;
                if(results && results.length>0) {
                    fundeffect = results[0].fundeffect || 0;
                    var unitStr = switchSign("2");
                    fundeffect = stringUtils.moneyFormat(fundeffect);
                    $(_pageId + "#bankBalance").html(fundeffect +''+ unitStr);
                }
            } else {
                $.alert(data.error_info);
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function(){
                $.hidePreloader();
            },"errorFunc": function(){
                $.hidePreloader();
            }});
    }

    /**
     * 提交转账 303039、305025、300202
     */
    function transferSubmit() {
        var bankPwd = $(_pageId + "#bankPwd").val() || "";
        var fundPwd = $(_pageId + "#fundPwd").val() || "";
        var isShowBankPwd = $(_pageId + "#bankPwd").parent().is(":visible");
        var isShowFundPwd = $(_pageId + "#fundPwd").parent().is(":visible");
        var moneyNum = $(_pageId + "#moneyNum").val(); // 转账金额
        moneyNum = parseFloat(moneyNum);
        if(!common.isValue(pageGlobal.bankInfo)){
            $.alert("暂无可转账银行卡");
            return false;
        }
        if(!moneyNum || moneyNum<=0) {
            $.alert("请输入转账金额");
            return false;
        }
        if(pageGlobal.tabType=="1") { //证券转银行
            var num = parseFloat(pageGlobal.bondBalance);
            if(!num || num<=0 || num<moneyNum) {
                $.alert("转账金额不足");
                return false;
            }
        }
        if(isShowBankPwd) {
            if(!bankPwd) {
                $.alert("请输入银行密码");
                return false;
            } else if(bankPwd.length<1) {
                $.alert("银行密码长度不能小于1位数");
                return false;
            }
        }
        if(isShowFundPwd) {
            if(!fundPwd) {
                $.alert("请输入资金密码");
                return false;
            }
        }
        var cust_code = (pageGlobal.userInfo).cust_code;	// 客户代码
        var fund_account = (pageGlobal.userInfo).fund_account;	// 资产账户
        var branch_no = (pageGlobal.userInfo).branch_no;	// 分支机构
        var sessionid = (pageGlobal.userInfo).sessionid;
        var bank_code = (pageGlobal.bankInfo).bank_code;
        var client_account = (pageGlobal.bankInfo).bank_account;
        var money_type = (pageGlobal.bankInfo).money_type;
        var param = {
            "entrust_way": global.entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "bank_code": bank_code,
            "money_type": money_type,
            "transfer_direction": pageGlobal.tabType,
            "tranamt": moneyNum,
            "fund_password": fundPwd,
            "bank_password": bankPwd,
            "client_account": client_account,
            "account_type": (pageGlobal.userInfo)._loginClass
        };
        service_common.transfer(param,function(data) {
            $.hidePreloader();
            if(data.error_no == 0) {
                var results = data.results;
                if(results && results.length>0) {
                    var serial_no = results[0].serial_no;  //转账流水号
                    param["entrust_no"] = serial_no;
                    param["bank_account"] = (pageGlobal.bankInfo).bank_account;
                    var dataObj = {
                        "dataObj": JSON.stringify(param)
                    };
                    $.pageInit("banking/transferNew","banking/transferQuery",dataObj);
                } else {
                    $(_pageId + "#transfer #transferBtn").removeClass("grayBtn");
                }
            } else {
                $.alert(data.error_info);
                $(_pageId + "#transfer #transferBtn").removeClass("grayBtn");
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function(){
                $.hidePreloader();
                $(_pageId + "#transfer #transferBtn").removeClass("grayBtn");
            },"errorFunc": function(){
                $.hidePreloader();
                $(_pageId + "#transfer #transferBtn").removeClass("grayBtn");
            }});
    }

    /**
     * 转账流水
     */
    function queryTodayRecords() {
        var begin_time = "";
        var end_time = "";
        var cust_code = (pageGlobal.userInfo).cust_code;	//客户代码
        var fund_account = (pageGlobal.userInfo).fund_account;	//资产账户
        var branch_no = (pageGlobal.userInfo).branch_no;	//分支机构
        var sessionid = (pageGlobal.userInfo).session_id;
        var param = {
            "trans_type": pageGlobal.trans_type,
            "trans_status": pageGlobal.trans_status,
            "entrust_way": global.entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "money_type": "",
            "begin_time": begin_time,
            "end_time": end_time,
            "transfer_direction": "",
            "account_type": (pageGlobal.userInfo)._loginClass
        };
        service_common.transferQueryToday(param,function(data) {
            $.hidePreloader();
            if(data.error_no == 0) {
                var htmlStr = "";
                var results = data.results;
                if(results && results.length>0) {
                    var dataList = results[0].dataList;
                    var transfer_direction = "";
                    var tranamt = "";  //转账金额
                    var mark = "";
                    var bank_error_info = "";
                    var transfer_direction_name = ""; //转账类型
                    var money_type = "";  //金额单位类型 0:元  1:美元  2:港币
                    var business_date = "";  //转账日期
                    var business_time = "";  //转账时间
                    var bank_name = "";
                    var entrust_state_name = "";
                    var failA = "",failStr = "",state = "";
                    var classVal = "";

                    var netIn = results[0].netIn; //净流入
                    var transferIn = results[0].transferIn; //转入
                    var transferOut = results[0].transferOut; //转出
                    netIn = stringUtils.moneyFormat(netIn);
                    transferIn = stringUtils.moneyFormat(transferIn);
                    transferOut = stringUtils.moneyFormat(transferOut);
                    $(_pageId + "#transferFlow li").eq(0).find("em").html(transferIn);
                    $(_pageId + "#transferFlow li").eq(1).find("em").html(transferOut);
                    $(_pageId + "#transferFlow li").eq(2).find("em").html(netIn);

                    if(isJsonObj(dataList)) {
                        dataList = JSON.parse(dataList);
                        for(var i=0,len=dataList.length;i<len;i++) {
                            var item = dataList[i];
                            transfer_direction = item["transfer_direction"];
                            mark = item["mark"];
                            bank_error_info = item["bank_error_info"];
                            transfer_direction_name = item["transfer_direction_name"];
                            money_type = item["money_type"];
                            business_date = item["business_date"];
                            business_time = item["business_time"];
                            bank_name = item["bank_name"];
                            entrust_state_name = item["entrust_state_name"];
                            tranamt = item["tranamt"];

                            failA = "",failStr = "",state = "";
                            tranamt = stringUtils.moneyFormat(tranamt);
                            if(transfer_direction=="0") {  // +
                                classVal = "iconInto";
                                tranamt = "+" + tranamt;
                            } else if(transfer_direction=="1") { // -
                                classVal = "iconOut";
                                tranamt = "-" + tranamt;
                            } else {
                                classVal = "iconQuery";
                            }
                            if(mark.indexOf("失败") != "-1") {
                                state = "fail";
                                failA = '<a href="javascript:void(0);">失败</a>';
                                failStr = bank_error_info;
                            }
                            htmlStr += '<div class="owner_detail" state="'+state+'">\n' +
                                '                            <div class="ui1">\n' +
                                '                                <div class="row-1">\n' +
                                '                                    <em class="'+classVal+'"></em>\n' +
                                '                                    <p><label>'+transfer_direction_name+'</label><span>'+business_time+'</span></p>\n' +
                                '                                </div>\n' +
                                '                                <div class="row-1">\n' +
                                '                                    <p>'+failA+'<label>'+tranamt+'</label><span>'+bank_name+'</span></p>\n' +
                                '                                </div>\n' +
                                '                            </div>\n' +
                                '                            <div class="ui2" style="display: none;">\n' +
                                '                                <p>'+failStr+'</p>\n' +
                                '                            </div>\n' +
                                '                        </div>';
                        }
                    }
                }
                $(_pageId + "#transferFlow .record_list .data_box").html(htmlStr);
                if(htmlStr) {
                    $(_pageId + "#transferFlow .record_list").show();
                    $(_pageId + "#transferFlow .list_end").show();
                    $(_pageId + "#transferFlow .nodata").hide();
                } else {
                    if(pageGlobal.trans_type=="0" && pageGlobal.trans_status=="0") {
                        $(_pageId + "#transferFlow .record_list").hide();
                        $(_pageId + ".nodata #moreBtn").show();
                    } else {
                        $(_pageId + "#transferFlow .record_list .data_box").html("");
                        $(_pageId + ".nodata #moreBtn").hide();
                        $(_pageId + "#transferFlow .record_list").show();
                    }
                    $(_pageId + "#transferFlow .list_end").hide();
                    $(_pageId + "#transferFlow .nodata").show();
                }
            } else {
                if(pageGlobal.trans_type=="0" && pageGlobal.trans_status=="0") {
                    $(_pageId + "#transferFlow .record_list").hide();
                    $(_pageId + ".nodata #moreBtn").show();
                } else {
                    $(_pageId + "#transferFlow .record_list .data_box").html("");
                    $(_pageId + ".nodata #moreBtn").hide();
                    $(_pageId + "#transferFlow .record_list").show();
                }
                $(_pageId + "#transferFlow .list_end").hide();
                $(_pageId + "#transferFlow .nodata").show();
            }
        },{"isLastReq":false,"isShowWait":false,
            "timeOutFunc": function(){
                $.hidePreloader();
            },"errorFunc": function(){
                $.hidePreloader();
            }});
    }

    function tabSwitch() {
        $(_pageId + "#moneyNum").val("");
        $(_pageId + "#bankPwd").val("");
        $(_pageId + "#fundPwd").val("");
        $(_pageId + ".buy_input .unit").html("");
        $(_pageId + ".subTit_tab li").removeClass("active");
        keyboardStrClear();
        var num = pageGlobal.tabType;
        switch(num) {
            case 0:
                $(_pageId + ".subTit_tab li").eq(0).addClass("active");
                $(_pageId + ".outInto1").html("转出银行");
                $(_pageId + ".outInto2").html("转入金额");
                $(_pageId + ".outInto3").attr("placeholder","请输入转入金额");
                $(_pageId + "div#moneyNum .key_place").html("请输入转入金额");
                $(_pageId + ".outInto4").show();
                $(_pageId + ".outInto5").hide();
                $(_pageId + ".outInto6").html("转入到证券");
                $(_pageId + ".buy_cont .all").hide();
                $(_pageId + "#transferFlow").hide();
                $(_pageId + ".footer_tip").show();
                $(_pageId + "#transfer").show();
                var ingoldType = $(_pageId + "#inGold").attr("type");
                if(ingoldType) {
                    $(_pageId + ".outInto7").show();
                }
                if(!common.isValue(pageGlobal.bankInfo)) {
                    queryAccount();
                } else {
                    queryBankInfo();
                }
                checkInput();
                break;
            case 1:
                $(_pageId + ".subTit_tab li").eq(1).addClass("active");
                $(_pageId + ".outInto1").html("转入银行");
                $(_pageId + ".outInto2").html("转出金额");
                $(_pageId + ".outInto3").attr("placeholder","请输入转出金额");
                $(_pageId + "div#moneyNum .key_place").html("请输入转出金额");
                $(_pageId + ".outInto4").hide();
                $(_pageId + ".outInto5").show();
                $(_pageId + ".outInto6").html("转出到银行卡");
                $(_pageId + ".outInto7").hide();
                $(_pageId + ".buy_cont .all").show();
                $(_pageId + "#transferFlow").hide();
                $(_pageId + ".footer_tip").show();
                $(_pageId + "#transfer").show();
                if(!common.isValue(pageGlobal.bankInfo)) {
                    queryAccount();
                } else {
                    queryBankInfo();
                }
                queryBalance();
                checkInput();
                break;
            case 2:
                $(_pageId + ".subTit_tab li").eq(2).addClass("active");
                $(_pageId + "#transfer").hide();
                $(_pageId + ".maskFlow").hide();
                $(_pageId + ".footer_tip").hide();
                $(_pageId + "#transferFlow").show();
                pageGlobal.trans_type = "0";
                pageGlobal.trans_status = "0";
                queryTodayRecords();
                break;
            default: break;
        }
    }

    // 校验输入框值
    function checkInput() {
        var money = $.trim($(_pageId + "#moneyNum").val());
        var isNum = validatorUtil.isNumberFloat(money);
        money = parseFloat(money) ? parseFloat(money) : 0;
        var tabType = pageGlobal.tabType;
        var bondBalance = pageGlobal.bondBalance; //证券可取金额
        var bankInfo = pageGlobal.bankInfo;
        if(!common.isValue(bankInfo) || !isNum || money<=0 || !(checkPwd()) || (tabType==1 && money>bondBalance)) {
            $(_pageId + "#transfer #transferBtn").addClass("grayBtn");
        } else {
            $(_pageId + "#transfer #transferBtn").removeClass("grayBtn");
        }
        if(checkIsNum(money)) {
            var numStr = money.toString();
            numStr = numStr.split(".")[0];
            var len = numStr.length;
            $(_pageId + ".buy_input .unit").html(pageGlobal.numArr[len]);
        }
    }

    // 校验密码是否输入
    function checkPwd() {
        var yhInput = $(_pageId + " #bankPwd").parent();
        var zjInput = $(_pageId + " #fundPwd").parent();

        var yhPwd = $(_pageId + " #bankPwd").val();
        var zjPwd = $(_pageId + " #fundPwd").val();

        var isTrue = true;
        if(yhInput.is(':visible') && yhPwd.length <= 0) {
            isTrue = false;
        }
        if(zjInput.is(':visible') && (zjPwd.length) <= 0) {
            isTrue = false;
        }
        return isTrue;
    }

    function checkIsNum(val) {
        if(parseFloat(val).toString() == "NaN") {
            return false;
        } else {
            return true;
        }
    }

    function switchBank(isTip,htmlType) {
        var flag = false;
        var item = pageGlobal.bankInfo;
        if(!common.isValue(item)) {
            if(isTip) {
                $.alert("暂无可转账银行卡");
            }
        } else {
            flag = true;
            var bank_name = item["bank_name"];
            var account_long = item["bank_account"];
            var main_flag = item["main_flag"]; //1:主  0:辅
            var money_type = item["money_type"]; //0:人民币 1:美元 2:港币
            var htmlStr = "",subStr = "",account_short = "";

            if(main_flag=="1") {
                subStr = '<span class="sign">主</span>';
            } else if(main_flag==="0") {
                subStr = '<span class="sign">辅</span>';
            }
            if(account_long) {
                account_short = account_long.substring((account_long.length)-4);
                account_short = '(尾号'+account_short+')';
            }
            htmlStr = ''+subStr+'<span>'+bank_name+''+account_short+'</span>';
            if(htmlType=="1") {
                $(_pageId + "#bankName").html(htmlStr);
                $(_pageId + "#bankPwd").attr("placeholder",'请输入您的'+bank_name+'卡取款密码');
            } else {
                $("#payWindow p.card").html(htmlStr);
            }
            var signStr = switchSign("1");
            $(_pageId + "#transfer .symbol").html(signStr);
            inGoldCheck(bank_name);
        }
        return flag;
    }

    function switchSign(signType,moneyType) {
        var signStr1 = "¥",signStr2 = "元",signStr3 = "人民币";
        var item = pageGlobal.bankInfo;
        var money_type = moneyType || item["money_type"];
        switch(money_type) {
            case "0":
                signStr1 = '¥';
                signStr2 = '元';
                signStr3 = "人民币";
                break;
            case "1":
                signStr1 = '$';
                signStr2 = '美元';
                signStr3 = "美元";
                break;
            case "2":
                signStr1 = 'HK$';
                signStr2 = '港元';
                signStr3 = "港币";
                break;
        }
        if(signType=="1") {
            if(money_type=="2") {
                $(_pageId + "#transfer .buy_input").css({"padding-left":"0.72rem"});
            } else {
                $(_pageId + "#transfer .buy_input").css({"padding-left":"0.32rem"});
            }
            return signStr1;
        } else if(signType=="2") {
            return signStr2;
        } else {
            return signStr3;
        }
    }

    function isJsonObj(str) {
        if(typeof str == 'string') {
            try {
                var obj = JSON.parse(str);
                if(typeof obj == 'object' && obj ){
                    return true;
                } else {
                    return false;
                }
            } catch(e) {
                console.log('error: '+ str +':'+e);
                return false;
            }
        }
    }

    /**
     * 对应银行首次入金判断
     * @param bankName
     */
    function inGoldCheck(bankName) {
        if(pageGlobal.tabType===0) {
            if(bankName.indexOf("招商") != -1||bankName.indexOf("信用招行") != -1||
                bankName.indexOf("平安") != -1||bankName.indexOf("浦发") != -1||
                bankName.indexOf("信用浦发") != -1) {
                $(_pageId + "#inGold em").html('系统检测到您是'+bankName+'三方存管客户，首次入金需前往'+bankName+'APP端发起转账。');
                $(_pageId + "#inGold span").html(''+bankName+'首次入金指引');
                $(_pageId + "#inGold").show();
                if(bankName.indexOf("招商") != -1 || bankName.indexOf("信用招行") != -1) {
                    $(_pageId + "#inGold").attr("type","1");
                } else if(bankName.indexOf("平安") != -1) {
                    $(_pageId + "#inGold").attr("type","2");
                } else if(bankName.indexOf("浦发") != -1 || bankName.indexOf("信用浦发") != -1) {
                    $(_pageId + "#inGold").attr("type","3");
                }
            } else {
                $(_pageId + "#inGold").hide();
                $(_pageId + "#inGold").attr("type","");
            }
        }
    }

    /**
     * keyboard 键盘清除输入框内容
     */
    function keyboardStrClear() {
        $(_pageId + " div.jsKey").val("").attr("value", "");
        $(_pageId + " div.jsKey em").text("");
        $(_pageId + " div.jsKey").find("div.key_input div.key_text").html("");
        $(_pageId + " div.jsKey").find("div.key_place").show();
    }

    /**
     * 销毁
     */
    function destroy(){
        if($.getSStorageInfo(_pageId+"subPageFlag")!="true") {
            pageGlobal.tabType = 0;
            pageGlobal.bankInfo = {};
            pageGlobal.bondBalance = "";
            pageGlobal.screen_type = "0";
            pageGlobal.screen_status = "0";
            pageGlobal.trans_type = "0";
            pageGlobal.trans_status = "0";
            pageGlobal.bankArr1 = [];
            pageGlobal.bankArr2 = [];
            $(_pageId + ".subTit_tab li").removeClass("active");
            $(_pageId + ".subTit_tab li").eq(0).addClass("active");
            $(_pageId + "#moneyNum").val("");
            $(_pageId + "#bankPwd").val("");
            $(_pageId + "#fundPwd").val("");
            $(_pageId + "#bankBalance").html("");
            $(_pageId + "#bondBalance").html("");
            $(_pageId + "#bankName").html("");
            $(_pageId + "#transfer").show();
            $(_pageId + "#transferFlow").hide();
            $(_pageId + "#netIntoMask").hide();
            $(_pageId + ".maskFlow").hide();
            $(_pageId + "#transferFlow .tab_screen li").removeClass("active");
            $(_pageId + "#transferFlow .tab_screen li.ts0").addClass("active");
            $(_pageId + "#transfer #transferBtn").addClass("grayBtn");
            $(_pageId + ".buy_input .unit").html("");
            $(_pageId + "#transferFlow .record_list .data_box").html("");
            $(_pageId + "#transferFlow .nodata").hide();
            $(_pageId + "#inGold").hide();
            $(_pageId + "#inGold").attr("type","");
            $(_pageId + "#transferFlow .list_end").hide();
            if(keyboard) {
                keyboard.keyDestroy();
            }
        }
        bankSelectFunc = null;
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }


    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
