/**
 * 交易转账
 */
define('trade/scripts/banking/transferQuery.js', function(require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var commonFunc = require("commonFunc");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var _pageId = "#banking_transferQuery ";
    var pageGlobal = {
        "timer": "",
        "bktrans_status": "" //转账结果状态
    };

    /**
     * 初始化
     */
    function init() {

    }

    function load() {
        startTimer();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回
        $.bindEvent($(_pageId + ".header .icon_back"),function(e){
            $.pageBack();
        });
    }

    function queryResult() {
        var param = $.getPageParam("dataObj");
        if(param) {
            param = JSON.parse(param);
            service_common.querytransferResult(param,function(data) {
                $.hidePreloader();
                var bktrans_status = "";
                var stateArr = ["2","3","5"]; //2:成功 3:作废 5:撤销
                var item = {};
                if(data.error_no == 0) {
                    var results = data.results;
                    if(results && results.length>0) {
                        item = results[0];
                        bktrans_status = item["bktrans_status"];
                        pageGlobal.bktrans_status = bktrans_status;
                    }
                }
                if(stateArr.indexOf(bktrans_status)>-1) {
                    clearInterval(pageGlobal.timer);
                    jumpPage(item);
                } else {
                    queryResult();
                }
            },{"isLastReq":false,"isShowWait":false,
                "timeOutFunc": function(){
                    $.hidePreloader();
                },"errorFunc": function(){
                    $.hidePreloader();
                }});
        }
    }

    function startTimer() {
        queryResult();
        var num = 10;
        pageGlobal.timer = setInterval(function() {
            num--;
            if(num>=0) {
                $(_pageId + "#countdown em").html(num);
            } else {
                clearInterval(pageGlobal.timer);
                jumpPage({"bktrans_status": pageGlobal.bktrans_status});
            }
        },1000);
    }

    function jumpPage(item) {
        var dataObj = $.getPageParam("dataObj");
        dataObj = dataObj ? JSON.parse(dataObj) : {};
        item["bank_account"] = dataObj["bank_account"] || "";
        $.pageInit("banking/transferQuery","banking/transferResult",item);
    }

    /**
     * 销毁
     */
    function destroy(){
        pageGlobal.bktrans_status = "";
        $(_pageId + "#countdown em").html("10");
        clearInterval(pageGlobal.timer);
        pageGlobal.timer = null;
    }


    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});