/**
 * 交易转账
 */
define('trade/scripts/banking/transferResult.js', function(require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var commonFunc = require("commonFunc");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var nativePluginService = require("nativePluginService");
    var _pageId = "#banking_transferResult ";
    var stringUtils = require("stringUtils"); // 字符串工具类

    /**
     * 初始化
     */
    function init() {
    }

    function load() {
        noticeSetting();
        common.subscribeOn("50243",noticeSetting);
        $(_pageId + ".transfer_box").hide();
        var paramObj = $.getPageParam();
        var unitArr = ["元","美元","港元"];
        var state = paramObj["bktrans_status"];
        var money = paramObj["tranamt"];
        var transType = paramObj["transfer_direction"]; //0:银行转证券 1:证券转银行
        var errorInfo = paramObj["bank_error_info"] || "";
        var bankName = paramObj["bank_name"];
        var bankCard = paramObj["bank_account"] || "";
        var money_type = paramObj["money_type"];
        money = stringUtils.moneyFormat(money);
        money = money + unitArr[money_type];
        if(bankCard) {
            bankCard = bankCard.substring(bankCard.length-4);
            bankCard = '(尾号'+bankCard+')';
        }
        bankName = bankName + bankCard;
        // 转账请求标志 1 代表已经发送请求
        nativePluginService.function50040({
          key:'transferResultFlag',
          value:'1',
          time:'0'
        });
        switch(state) {
            case "2":
                var htmlStr = "",htmlStr2 = "";
                if(transType==="0") {
                    htmlStr = '成功转入'+money+'至证券账户';
                    htmlStr2 = '转入成功';
                } else if(transType=="1") {
                    htmlStr = '成功转出'+money+'至'+bankName+'';
                    htmlStr2 = '转出成功';
                }
                $(_pageId + "#successBox #money").html(htmlStr);
                $(_pageId + "#successBox .stateTip").html(htmlStr2);
                $(_pageId + "#successBox").show();
                break;
            case "3":case "5":
                var htmlStr = "";
                if(transType==="0") {
                    htmlStr = '转入失败';
                } else if(transType=="1") {
                    htmlStr = '转出失败';
                }
                $(_pageId + "#failBox #cause").html(errorInfo);
                $(_pageId + "#failBox .stateTip").html(htmlStr);
                $(_pageId + "#failBox").show();
                break;
            default:
                $(_pageId + "#noResultBox").show();
                break;
        }
    }
    function noticeSetting(){
        // 判断是否显示通知设置按钮
        commonFunc.showNoticeBtn(_pageId);
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回
        $.bindEvent($(_pageId + ".header .icon_back"),function(e){
            $.pageInit("banking/transferResult","banking/transferNew","","left");
        });

        // 查看转账流水
        $.bindEvent($(_pageId + ".transfer_box .transferFlow"),function(e){
            var param = {
                "lookTab": "2"
            };
            $.pageInit("banking/transferResult","banking/transferNew",param);
        });

        // 返回银证转账
        $.bindEvent($(_pageId + ".transfer_box .returnTransfer"),function(e){
            $.pageInit("banking/transferResult","banking/transferNew");
        });
    }

    /**
     * 销毁
     */
    function destroy(){
        common.subscribeOff("50243",noticeSetting);
        $(_pageId + ".transfer_box").hide();
        $(_pageId + "#successBox .stateTip").html('成功');
        $(_pageId + "#failBox .stateTip").html('失败');
    }


    var base = {
        "init" : init,
        "load" : load,
        "noticeSetting" : noticeSetting,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
