/**
 * 普通交易-买入
 */
define('trade/scripts/bjs/index.js', function (require, exports, module) {
  var gconfig = $.config;
  var global = gconfig.global;
  var common = require("common");
  var commonFunc = require("commonFunc");
  var service_stock = require("service_stock");
  var service_common = require("service_common");
  var _pageId = "#bjs_index ";
  var pagecode = "bjs/index";
  var userInfo = null;  // 账号信息
  var nativePluginService = require("nativePluginService");

  /**********
   * 初始化
   */
  function init() {
    userInfo = common.getCurUserInfo("0");
    bindPageEvent();
    window.onresize= function(){};
  }

  function load() {
    hasRight();
    queryListAmount();
    common.setMainHeight(_pageId, false);
    window.onresize= function(){
        common.setMainHeight(_pageId, false);
    };
  }

  /**
   * 事件绑定
   */
  function bindPageEvent() {
    // 头部导航点击事件
    $.bindEvent($(_pageId + ".n_nav_box .n_nav_list li"), function (e) {
      var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
      var param = $(this).attr("param"); // 获取跳转页面参数
      var paramMap = { "isGoBack": "1" };
      if (param) {
        paramMap.param = param;
      }
      //跳转
      $.pageInit("bjs/index", topage, { "param": paramMap });
      e.stopPropagation();
      e.preventDefault();
    });
    // 返回按钮事件
    $.bindEvent($(_pageId + "header .icon_back"), function () { 
      commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
          $.pageBack();
      });
    });
    // 交易须知
    $.bindEvent($(_pageId + "#readme"), function () { 
      goReadme();
    });
    // 右上角-交易须知
    $.bindEvent($(_pageId + ".bjs_dxxz"), function () { 
      goReadme();
    });

    // 开通权限功能
    $.bindEvent($(_pageId + ".bjs_sel_fixed_box"), function () { 
      var moduleName = + new Date();
      $.callMessage({
          "funcNo": "50115",
          "loadModuleName": "ygt",
          "moduleName": moduleName,
          "url": global.ygtUrl + "/new/ygt/index.html#!/bzjyOpen/index.html?isFromApp=true&moduleName=" + moduleName,
          "statusColor": "#EE4034",//状态栏颜色
          "isShowLoading": "1",
          "targetModule": "trade"
      });
    });
    // 主页菜单事件绑定
    $.bindEvent($(_pageId + ".n_list_con li"), function (e) {
      common.switchingCurUser("0");
      userInfo = common.getCurUserInfo(0);
      var bjhq = $(this).attr("bjhq");
      var fxjh = $(this).attr("fxjh");
      if (bjhq === 'true') {
        var serviceType = '8014';
        var request_type = '7';
        if(gconfig.platform === '2'){
          serviceType = '7011';
          request_type = '16';
        }
        nativePluginService.function501153({
          serviceType: serviceType,
          request_type: request_type,
          title: '北证A股'
        });
        return;
      }
      var type = $(this).attr("type");
      var paramMap = { "isGoBack": "1" };
      var param = $(this).attr("param"); // 获取跳转页面参数
      var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
      // 新股新债多加参数
      if(topage === 'nsb/index'){
        paramMap.isStocks = true;
        paramMap.isBjs = true;
        $.setSStorageInfo("stockFlag", "", true);
        $.setSStorageInfo("bjsFlag", "", true);
      }
      if (param) {
        if(param === "jrxj"){
            paramMap.param = {selectIndex:0};
        }else{
            paramMap.param = param;
        }
      }
      //登录的情况
      if (common.isTradeLogin(type)) {
        $.pageInit("bjs/index", topage, { "param": paramMap });
      } else {//没有登录的情况
        commonFunc.login($.getCurrentPageObj().pageCode, topage, { "param": paramMap }, {
          "topage": topage,
          "param": paramMap
        });
      }
      e.stopPropagation();
      e.preventDefault();
    });
  }
  function goReadme(){
    if (global.callNative && global.isSso) {
      $.callMessage({
          "funcNo": "50115",
          "loadModuleName": "ygt",
          "moduleName": "ygt",
          "url": global.mallUrl + '/lcsm/mall/ctemplate?page_code=scp_1567&share_title=%E3%80%90%E6%8E%98%E9%87%91%C2%B7%E5%8C%97%E4%BA%A4%E6%89%80%E3%80%91%E7%B3%BB%E5%88%97%E4%B8%93%E9%A2%98',
          "statusColor": "#EE4034",//状态栏颜色
          "isShowLoading": "1",
          "targetModule": "trade"
      });
    }
  }

  function hasRight() {
    // 判断是否有京A权限
    var param = {
      "entrust_way": global.entrust_way,
      "branch_no": userInfo.branch_no,
      "fund_account": userInfo.fund_account,
      "cust_code": userInfo.cust_code,
      "password": userInfo.password,
      "session_id": userInfo.session_id,
      "login_type": userInfo._loginClass
    };
    service_common.queryJurisdiction(param, function (data) {
      var right = data.results[0].bjs_rights;
      if (right === '1') {
        $('#hasRight').css('display', 'block');
        $('#noRight').css('display', 'none');
      } else {
        $('#hasRight').css('display', 'none');
        $('#noRight').css('display', 'block');
      }
    }, {
      "isShowWait": false,
      "isLastReq": false,
      "timeout": global.stockTimeout,
      "isShowOverLay": false,
      "isGlobal": true,
      "errorFunc": function () {
      },
      "timeOutFunc": function () {
      }
    });
  }

  /**
   * 查询首页新股，新债数量
   */
  function queryListAmount() {
    var userInfo = common.getCurUserInfo();
    var param = {};
    param.funcNo = "310300";
    param.entrust_way = global.entrust_way;
    param.branch_no = userInfo.branch_no;
    param.fund_account = userInfo.fund_account;
    param.cust_code = userInfo.cust_code;
    param.password = userInfo.password;
    param.session_id = userInfo.session_id;
    param.new_bond_flag = "1"; //是否查询新债 0.不查询 1.查询
    param.new_stock_flag = "1"; //是否查询新股
    param.new_gz_stock_flag = "1"; //是否查询股转新股
    param.loan_flag = "1";

    $(_pageId + "#newShareGZ").html("今日有--只新股");
    service_common.serviceCommonInvoke(param, function (data) {
      if (data.error_no == 0) {
        var results = data.results;
        if (results && results.length) {
          for (var i = 0; i < results.length; i++) {
            var numberText = "";
            if (+results[i].number) numberText = '<em style="color:#EE4034;">' + results[i].number + '</em>';
            else numberText = results[i].number;
            if (results[i].module_name == "3") {
              $(_pageId + "#newShareGZ").html("今日有" + numberText + "只新股");
            }
          }
        }
      } else {
        $.alert(data.error_info);
      }
      $.hidePreloader();
    },
      {
        "isLastReq": true,
        "isShowWait": false,
        "isShowOverLay": false,
        "isGlobal": true,
        "errorFunc": function () { // 超时调用方法
          $.hidePreloader();
        },
        "timeOutFunc": function () { // 超时调用方法
          $.hidePreloader();
        }
      });
  }

  /**
   * 数据重置
   */
  function destroy() {
    service_stock.destroy();
    $('#hasRight').css('display', 'none');
    $('#noRight').css('display', 'none');
  }

  var base = {
    "init": init,
    "load": load,
    "bindPageEvent": bindPageEvent,
    "destroy": destroy
  };
  module.exports = base;
}

);
