/**
 * 北交所系统公开发行询价确认
 */
define('trade/scripts/bjs/publicOffering/enquiryConfirm.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var _pageId = "#bjs_publicOffering_enquiryConfirm ";
    var downslide = new (require("downslide")).Downslide();
    var userInfo = null;
    var service_third = require("service_third");
    var publicOfferingQuery = require("publicOfferingQuery");

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("101890");
        //顶点不显示历史确认
        if (global.serverConfig == "3") {
            $(_pageId + ".xingutab li").eq(2).hide();
            $(_pageId + ".footer").hide();
        } else {
            $(_pageId + ".xingutab li").eq(2).show();
            $(_pageId + ".footer").show();
        }
        downslide.addSlide();
        common.bindStockEvent($(_pageId + '.tab_nav li a'), true);
        common.bindStockEvent($(_pageId + '.xingutab ul li'));
        userInfo = common.getCurUserInfo();
//		publicOfferingQuery.queryEnquiryConfirmTips(_pageId);
        publicOfferingQuery.queryTodayPurchaseTips(_pageId, function () {
            downslide.slideDestroy();
            var mainHeight = common.setMainHeight(_pageId, true);
            downslide.slideInit(mainHeight, backgroundInterface);
            $.bindEvent($(_pageId + ".notyeponed .close"), function (e) {
                $(_pageId + ".notyeponed").hide();
                downslide.slideDestroy();
                var mainHeight = common.setMainHeight(_pageId, true);
                downslide.slideInit(mainHeight, backgroundInterface);
                e.stopPropagation();
            });
        });
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mainHeight = common.setMainHeight(_pageId, true);
        downslide.slideInit(mainHeight, backgroundInterface);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        queryEnquiryConfirm();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                //埋点
                common.comStat(101891, 2, 103, true, {"i_group_name": "返回"});
                commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                    $.pageBack();
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //右上角刷新
        $.bindEvent($(_pageId + ".top_title .icon_refresh"), function (e) {
            $.showRightTopPreloaders();
            queryEnquiryConfirm();
            e.stopPropagation();
        });

        //北交所发行跳转
        $.bindEvent($(_pageId + ".xingutab .stockCalendar"), function (e) {
            //埋点
            common.comStat(101892, 2, 103, true, {"i_group_name": "发行日历"});
            common.jumpHpNewshare("1", {"isShowBack": "true", "moduleType": "2"});
            e.stopPropagation();
        });

        //历史确认查询
        $.bindEvent($(_pageId + ".onclikbtn"), function (e) {
            $.pageInit("bjs/publicOffering/enquiryConfirm", "bjs/publicOffering/historyConfirm");
            e.stopPropagation();
        });
    }

    /**
     * 询价确认查询
     */
    function queryEnquiryConfirm() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var end_time = $(_pageId + " #endDate").text();
        var begin_time = $(_pageId + " #startDate").text();
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "session_id": session_id,
            "account_type": userInfo._loginClass,
        };
        service_third.queryEnquiryConfirm(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        $(_pageId + ".tab_nav li").eq(3).find("i").show();
                        common.setNoData(false);
                        var html = "";
                        for (var i = 0; i < results.length; i++) {
                            html += queryEnquiryConfirmHTML(results[i]);
                        }
                        $(_pageId + ".third_cancel_order").html(html);
                    } else {
                        $(_pageId + ".third_cancel_order").html("");
                        common.setNoData(true);
                    }
                } else {
                    $(_pageId + ".third_cancel_order").html("");
                    common.setQueryFail(true);
                }
            }
            downslide.slideRefresh();
        }, {
            "isLastReq": true,
            "isShowWait": true,
//			"timeout": global.newsharesTimeout,
            "errorFunc": function () {
                $(_pageId + ".third_cancel_order").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            },
            "timeOutFunc": function () {
                $(_pageId + ".third_cancel_order").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            }
        });
    }

    /**
     * HTML生成
     */
    function queryEnquiryConfirmHTML(element) {
        var eleHtml = "<div class='conveible'>";
        eleHtml += "<div class='part'>";
        eleHtml += "<div class='title'>";
        eleHtml += "<strong>" + element.issue_name + "</strong><small>" + element.issue_code + "</small>";
        eleHtml += "<span class='time'>" + element.returnbusin_state_name + "</span>";
        eleHtml += "</div>";
        eleHtml += "<ul>";
        //恒生T2才显示
        if (global.serverConfig == "2") {
            eleHtml += "<li><span>成交价格</span><p>" + element.business_price + "</p></li>";
        }
        eleHtml += "<li><span>确认数量</span><p>" + element.confirm_amount + "</p></li>";
        //恒生T2才显示
        if (global.serverConfig == "2") {
            eleHtml += "<li><span>成交时间</span><p>" + element.business_time + "</p></li>";
        }
        eleHtml += "<li><span>最大申购数量</span><p>" + element.business_amount2 + "</p></li>";
        //顶点才显示
        if (global.serverConfig == "3") {
            eleHtml += "<li><span>上市日期</span><p>" + element.business_time + "</p></li>";
        }
        eleHtml += "</ul>";
        eleHtml += "</div>";
        eleHtml += "</div>";
        return eleHtml;
    }

    /**
     * 销毁
     */
    function destroy() {
        downslide.slideDestroy();
        $(_pageId + ".third_cancel_order").html("");
        common.pageBuryingPoint();
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
