/**
 * 北交所系统公开发行历史确认
 */
define('trade/scripts/bjs/publicOffering/historyConfirm.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
    var _pageId = "#bjs_publicOffering_historyConfirm ";
	var downslide = new (require("downslide")).Downslide();
	var userInfo=null;
	var service_third = require("service_third");
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102060");
		common.initTimeChoice(_pageId,7, true);
		downslide.addSlide();
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		//埋点数据
		$(_pageId+" .repurtime ").attr("startObjectId","102064");
		$(_pageId+" .repurtime ").attr("endObjectId","102065");
		$(_pageId+" .repurtime ").attr("actionId","104");
    }
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		mainHeight = mainHeight - $(_pageId+".repurtime").outerHeight(true);
		downslide.slideInit(mainHeight,backgroundInterface);
		queryHistoryConfirm();
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryHistoryConfirm();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102061, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//右上角刷新
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			//埋点
			common.comStat(102062,2,103,true,{"i_group_name":"点击刷新"});
			$.showRightTopPreloaders();
			queryHistoryConfirm();
			e.stopPropagation();
		});
		
		//时间选择
		$.bindEvent($(_pageId + ".repurtime .btn"), function(e){
			queryHistoryConfirm();
			var end_time = $(_pageId+" #endDate").text();
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = end_time.replaceAll("-", "");
			var time2 = begin_time.replaceAll("-", "");
			common.comStat(102066,2,104,true,{"i_change_name":"历史确认查询","i_change_to":time1+"——"+time2});//埋点
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/**
	 * 历史申报查询
	 */
	function queryHistoryConfirm(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var end_time = $(_pageId+" #endDate").text();
		var begin_time = $(_pageId+" #startDate").text();	
		var time1 = new Date(end_time.replaceAll("-", "/"));
		var time2 = new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
		    $.alert("开始日期大于截止日期");
		    downslide.slideRefresh();
		    downslide.hidePullUp();
		    return false;
		}//截止时间
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
				"begin_date":begin_time,
				"end_date":end_time,
			};
		service_third.queryHistoryConfirm(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						common.setNoData(false);
						var html = "";
						for (var i=0;i<results.length;i++){ 
							html += queryHistoryConfirmHTML(results[i]);
						}
						$(_pageId+".shengou").html(html);
					}else{
						$(_pageId+".shengou").html("");
						common.setNoData(true);
					}
				}
				else{
					$(_pageId+".shengou").html("");
					common.setQueryFail(true);
				}
			}
			downslide.slideRefresh();
		},{
			"isLastReq":true,
			"isShowWait":true,
			// "timeout": global.newsharesTimeout,
			"errorFunc":function(){
				$(_pageId+".shengou").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			},
			"timeOutFunc":function(){
				$(_pageId+".shengou").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			}
		});
	}
	
	/**
	 * HTML生成
	 */
	function queryHistoryConfirmHTML(element){
		var eleHtml = "<div class='part'>";
		eleHtml += "<div class='title'>";
		//恒生T2不显示发行简称
		if(global.serverConfig!="2"){
			eleHtml += "<strong>"+element.issue_name+"</strong>";
		}
		eleHtml += "<small>"+element.issue_code+"</small>";
		eleHtml += "<span class='time'>已报</span>";
		eleHtml += "</div>";
		eleHtml += "<ul>";
		eleHtml += "<li><span>成交价格 </span><p>"+element.business_price+"</p></li>";
		eleHtml += "<li><span>确认数量 </span><p>"+element.confirm_amount+"</p></li>";
		eleHtml += "<li><span>最大申购数量 </span><p>"+element.business_amount2+"</p></li>";
		eleHtml += "<li><span>成交时间  </span><p>"+element.business_time+"</p></li>";
		eleHtml += "<li><span>成交日期  </span><p>"+element.business_date+"</p></li>";
		eleHtml += "</ul>";
		eleHtml += "</div>";
		return eleHtml;
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		downslide.slideDestroy();
		$(_pageId+".shengou").html("");
		common.pageBuryingPoint();
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
