/**
 * 北交所系统公开发行近日询价
 */
define('trade/scripts/bjs/publicOffering/recentEnquiry.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var _pageId = "#bjs_publicOffering_recentEnquiry ";
    var downslide = new (require("downslide")).Downslide();
    var userInfo = null;
    var service_third = require("service_third");
    var publicOfferingQuery = require("publicOfferingQuery");
    var keyboard = require("keyboard");
    var commonFunc = require("commonFunc");
    var _noData = '<span class="icon"></span><p>近日无询价发行</p>';

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("101890");
        //顶点不显示历史确认
        if (global.serverConfig == "3") {
            $(_pageId + ".xingutab li").eq(2).hide();
        } else {
            $(_pageId + ".xingutab li").eq(2).show();
        }
        downslide.addSlide('', '5');
        common.bindStockEvent($(_pageId + '.tab_nav li a'), true);
        common.bindStockEvent($(_pageId + '.xingutab ul li.pageMenu'));
        userInfo = common.getCurUserInfo();
        publicOfferingQuery.queryEnquiryConfirmTips(_pageId);
        publicOfferingQuery.queryTodayPurchaseTips(_pageId, function () {
            downslide.slideDestroy();
            var mainHeight = common.setMainHeight(_pageId, true);
            downslide.slideInit(mainHeight, backgroundInterface);
            $.bindEvent($(_pageId + ".notyeponed .close"), function (e) {
                $(_pageId + ".notyeponed").hide();
                downslide.slideDestroy();
                var mainHeight = common.setMainHeight(_pageId, true);
                downslide.slideInit(mainHeight, backgroundInterface);
                e.stopPropagation();
            });
        });
        if (global.requestLocation == 0) {
            var mainHeight = common.setMainHeight(_pageId, true);
            downslide.slideInit(mainHeight, backgroundInterface);
            backgroundInterface();
        }
    }

    function load() {
        if (global.requestLocation == 1) {
            var mainHeight = common.setMainHeight(_pageId, true);
            downslide.slideInit(mainHeight, backgroundInterface);
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        setTimeout(function () {
            queryRecentEnquiry();
        }, 100)
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                //埋点
                common.comStat(101891, 2, 103, true, {"i_group_name": "返回"});
                commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                    $.pageBack();
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //北交所发行跳转
        $.bindEvent($(_pageId + ".xingutab .stockCalendar"), function (e) {
            //埋点
            common.comStat(101892, 2, 103, true, {"i_group_name": "发行日历"});

            common.jumpHpNewshare("1", {"isShowBack": "true", "moduleType": "2"});
            e.stopPropagation();
        });

        //全选
        $.bindEvent($(_pageId + ".sel_fixed_box .row-1 em"), function (e) {
            e.stopPropagation();
            if (!$(_pageId + ".conveible i.sel").length) return;
            $(this).toggleClass("act");
            $(_pageId + ".conveible i.sel").attr("class", "sel " + ($(this).hasClass("act") ? "act" : ""));
            $(_pageId + ".sel_fixed_box .btn").attr("class", "btn " + ($(this).hasClass("act") ? "" : "default"));
            var len = $(_pageId + ".conveible i.sel.act").length;
            $(_pageId + ".sel_fixed_box .row-1 span").html(len ? "（" + len + "）" : "");
        });

        //一键申购
        $.bindEvent($(_pageId + ".sel_fixed_box .btn"), function (e) {
            e.stopPropagation();
            if ($(this).hasClass("default")) return;
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var results = [];
            $(_pageId + ".conveible i.sel.act").each(function () {
                results.push(JSON.parse($(this).parents(".conveible").find(".sgoubtn").attr("element")));
            });
            common.inputConfirm(_pageId, results, "询价", submitOrder, keyboard);
        });
    }

    /**
     * 近日询价查询
     */
    function queryRecentEnquiry() {
        $(_pageId + ".sel_fixed_box .btn").attr("class", "btn default");
        $(_pageId + ".sel_fixed_box .row-1 span").html("");
        $(_pageId + ".sel_fixed_box .row-1 em").attr("class", "");

        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "session_id": session_id,
        };
        service_third.queryRecentEnquiry(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        common.setNoData(false);
                        var html = "";
                        for (var i = 0; i < results.length; i++) {
                            html += queryRecentEnquiryHTML(results[i], i);
                        }
                        $(_pageId + ".shengou").html(html);
                        if (keyboard) {
                            keyboard.keyInit();
                        }
                        bindHtmlEvent();
                    } else {
                        $(_pageId + ".shengou").html("");
                        common.setNoData(true, "", "", _noData, _noDataCallback);
                    }
                } else {
                    $(_pageId + ".shengou").html("");
                    common.setQueryFail(true);
                }
            }
            downslide.slideRefresh();
        }, {
            "isLastReq": true,
            "isShowWait": true,
//			"timeout": global.newsharesTimeout,
            "errorFunc": function () {
                $(_pageId + ".shengou").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            },
            "timeOutFunc": function () {
                $(_pageId + ".shengou").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            }
        });
    }

    /**
     * HTML生成
     */
    function queryRecentEnquiryHTML(element, i) {
        var eleHtml = "<div class='conveible'>";
        eleHtml += "<div class='row_01 lessp'>";
        eleHtml += "<i class='sel'></i><strong>" + element.issue_name + "</strong><span>" + element.issue_code + "</span>";
        eleHtml += "<div class='sgoubtn' element='" + JSON.stringify(element) + "'><a href='javascript:void(0);'>询价</a></div>";
        eleHtml += "</div>";
        eleHtml += "<ul class='row_02 clearfix' issue_name='" + element.issue_name + "' issue_code='" + element.issue_code + "' exchange_type='" + element.exchange_type + "' up_price='" + element.up_price + "'>";
        eleHtml += "<li><span>证券代码</span>" + element.stock_code + "</li>";
        eleHtml += "<li><span>发行数量</span>" + common.dgitConversion(Number(element.issue_amount)) + "股</li>";
        eleHtml += "<li><span>开始日期</span>" + element.start_date + "</li>";
        eleHtml += "<li><span>截止日期</span>" + element.end_date + "</li>";
        eleHtml += "<li><span>价格上限</span>" + element.up_price + "</li>";
        eleHtml += "<li><span>价格下限</span>" + element.down_price + "</li>";
        eleHtml += "<li><span>询价上限</span>" + common.dgitConversion(Number(element.high_amount)) + "股</li>";
        eleHtml += "<li><span>询价下限</span>" + common.dgitConversion(Number(element.low_amount)) + "股</li>";
        // eleHtml += "<li><span>询价价格</span><p><input class='recentPrice gz_input importPrice' js-key='number' type='number' maxlength='12' placeholder='输入价格' id='stockPrice"+i+"'/></p></li>";
        // eleHtml += "<li><span>询价数量</span><p><input class='recentAmount gz_input' js-key='telephone' type='telephone' maxlength='12' placeholder='输入数量' id='stockNum"+i+"'/></p></li>";
        eleHtml += "</ul>";
        eleHtml += "</div>";
        return eleHtml;
    }

    //生成的页面元素的事件
    function bindHtmlEvent() {

        //询价列表点击
        $.bindEvent($(_pageId + ".conveible .row_02"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var element = JSON.parse($(this).parent().find(".sgoubtn").attr("element"));
            //moduleType ，2=北交所发行，1=新债日历，0=新股日历（或不传）
            //详情类型：sampan_type = 1，1=询价详情，2=申购详情
            //申购代码：subscribe_code = 000001，股票代码和申购代码比传其一，都传则使用申购代码
            //股票代码：stock_code = 000001，股票代码和申购代码比传其一，都传则使用申购代码
            //是否外部应用直接访问：isOutVisit = true或不传 默认否
            common.jumpHpNewshare("3", {
                "isOutVisit": true,
                "moduleType": "2",
                "sampan_type": "1",
                "subscribe_code": element.issue_code,
                "stock_code": element.stock_code
            });
            e.stopPropagation();
        });

        //询价
        $.bindEvent($(_pageId + ".conveible .sgoubtn"), function (e) {
            e.stopPropagation();
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            //埋点
            common.comStat(101903, 2, 103, true, {"i_group_name": "询价确认"});
            var element = JSON.parse($(this).attr("element"));
            common.inputConfirm(_pageId, [element], "询价", submitOrder, keyboard);
        });

        //单行（取消）选中
        $.bindEvent($(_pageId + ".conveible i.sel"), function (e) {
            e.stopPropagation();
            $(this).toggleClass("act");
            var len = $(_pageId + ".conveible i.sel.act").length;
            $(_pageId + ".sel_fixed_box .btn").attr("class", "btn " + (len ? "" : "default"));
            $(_pageId + ".sel_fixed_box .row-1 span").html(len ? "（" + len + "）" : "");
            $(_pageId + ".sel_fixed_box .row-1 em").attr("class", len && len == $(_pageId + ".conveible i.sel").length ? "act" : "");
            return false;
        });

        // //数量框
        // $.bindEvent($(_pageId+"#stockNum"), function(e){
        // 	//埋点
        // 	common.comStat(101902,2,2,false,{
        // 		"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
        // 		"i_entrust_prop":"", // 委托属性
        // 		"i_exchange_type":$(this).parents("ul.row_02").attr("exchange_type"), // 交易市场
        // 		"i_stock_code":$(this).parents("ul.row_02").attr("issue_name"), // 股票代码
        // 		"i_stock_name":$(this).parents("ul.row_02").attr("issue_code"), // 股票名称
        // 		"i_price":$(_pageId+"#stockPrice").val(), // 选择后的价格
        // 		"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
        // 		"i_max_cnt":$(this).parents("ul.row_02").attr("up_price"), // 最大数量
        // 		"i_target_cnt":$(this).val(), // 调整之后的数量
        // 		"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
        // 	});
        // 	e.stopPropagation();
        // },"blur");

        // //价格框
        // $.bindEvent($(_pageId+"#stockPrice"), function(e){
        // 	common.comStat(101901,2,1,false,{
        // 		"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
        // 		"i_entrust_prop":"", // 委托属性
        // 		"i_exchange_type":$(this).parents("ul.row_02").attr("exchange_type"), // 交易市场
        // 		"i_stock_code":$(this).parents("ul.row_02").attr("issue_code"), // 股票代码
        // 		"i_stock_name":$(this).parents("ul.row_02").attr("issue_name"), // 股票名称
        // 		"i_price":$(this).val(), // 选择后的价格
        // 		"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
        // 	});
        // 	e.stopPropagation();
        // },"blur");
    }

    /**
     * "暂无数据"后的回调
     * */
    function _noDataCallback() {
        //北交所发行跳转
        $.bindEvent($(_pageId + ".nodeatabox a"), function (e) {
            common.jumpHpNewshare("1", {"isShowBack": "true", "moduleType": "2"});
            e.stopPropagation();
        });
    }

    //询价提交
    function submitOrder(results) {
        var tipStr = "<p class='titleBox'>" + userInfo.client_name + "(" + userInfo.fund_account + ")</p>";
        var tipStrArray = [];
        var batch_data = [];
        for (var i = 0; i < results.length; i++) {
            var element = results[i];
            tipStrArray.push(["发行代码", element.issue_code]);
            tipStrArray.push(["证券名称", element.issue_name]);
            tipStrArray.push(["询价价格", element.entrust_price]);
            tipStrArray.push(["询价数量", element.entrust_amount]);
            tipStrArray.push([]);// 多条之间的空隙
            batch_data.push([element.issue_code, element.exchange_type, element.entrust_price, element.entrust_amount, element.issue_name].join(":"));
        }
        tipStr += common.generatePrompt(tipStrArray, '', "thirdCss");
        var ts = "温馨提示:(1)多次询价时，以最后一笔有效近日询价作为其最终近日询价。<br>(2)投资者参与询价即视为授权全国北交所公司向本次发行股票的发行人和相应主承销商提供其报价信息及必要的身份信息。<br>(3)投资者参与询价，入围后必须按询价数量参与申购。";
        if (ts) {
            tipStr += "<div class='_reminder_gz'><span class='w'>" + ts + "</span></div>";
        }
        // var stock_account = ""
        // commonFunc.getNewStockAccount([element.exchange_type], userInfo, function(data){
        // 	stock_account = data[0].stock_account;
        // });
        var comStatRequest = function (results, i_oper) {
            for (var i = 0; i < results.length; i++) {
                var element = results[i];
                //埋点数据
                var comStatParam = {
                    "i_oper": i_oper,
                    "i_entrust_bs": "1", // 交易方向( 1,买入 2,卖出)
                    "i_stock_code": element.issue_code, // 股票代码
                    "i_stock_name": element.issue_name, // 股票名称
                    "i_entrust_prop": "", // 委托属性
                    "i_exchange_type": element.exchange_type, // 交易市场
                    "i_entrust_price": element.entrust_price, // 选择后的价格
                    "i_entrust_amount": element.entrust_amount, // 委托数量
                }
                common.comStat(101904, 2, 3, false, comStatParam);
            }
        }
        common.thirdIConfirm("询价确认", tipStr, function success() {
            var param = {
                "entrust_way": global.entrust_way,// 委托方式  在configuration配置
                "branch_no": userInfo.branch_no,//分支机构
                "fund_account": userInfo.fund_account,//资产账户
                "cust_code": userInfo.cust_code,//客户代码
                "password": userInfo.password,
                "session_id": userInfo.session_id,
                "batch_flag": results.length > 1 ? 1 : 0,
                "batch_data": batch_data.join("|")
            };
            service_third.enquiry(param, succesCallback, {
                "isShowOverLay": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            $.showPreloaders("请等待...");
            comStatRequest(results, '1') // 动作（1确定 2取消）
        }, function fail() {
            comStatRequest(results, '2') // 动作（1确定 2取消）
        }, "确定", "取消", null, "tap");
    }

    function succesCallback(data) {
        $.hidePreloader();
        if (data && data.error_no == "0") {
            if (data.results.length > 0) {
                common.entrustResultsConfirm(data.results, function () {
                    queryRecentEnquiry();
                });
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        downslide.slideDestroy();
        $(_pageId + ".shengou").html("");
        $(_pageId + ".sel_fixed_box .btn").attr("class", "btn default");
        $(_pageId + ".sel_fixed_box .row-1 span").html("");
        $(_pageId + ".sel_fixed_box .row-1 em").attr("class", "");
        common.pageBuryingPoint();
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
