/**
 * 北交所-债券现券交易-撤单
 */
define('trade/scripts/blockTrade/bjsBlockTrade/blockCancel.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var vIscrollHeight = null;
    var service_stock = require("service_stock");
    var _pageId = "#blockTrade_bjsBlockTrade_blockCancel ";
    var userInfo = null;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        userInfo = common.getCurUserInfo();
        $(_pageId + ".no_more_data").hide();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mianHeight - $(_pageId + ".tab_nav").height();
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }
    function backgroundInterface() {
        queryCancellation(); // 可撤单查询
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });
    }

    /**
     * 可撤单查询
     */
    function queryCancellation() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        // 每次查询前,先将暂无数据隐藏
        $(_pageId + ".no_data").hide();
        $(_pageId + ".c-no-more-data").hide();
        // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
        service_stock.queryBJBlockTrustData(param, queryBlockTrustDataCallback,
            { // 传给接口的json格式数据            
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /**
     * 可撤单查询回调
     */
    function queryBlockTrustDataCallback(data) {
        console.log(data);
        if (typeof (data) != undefined && typeof (data) != null) {
            //			$(_pageId + ".search_table .ce_table").html("");
            $(_pageId + ".c-no-search-data-box").hide();
            $(_pageId + ".c-no-more-data").hide();
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var data = "";

                    var html = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryConsultTrustHTML(results[i], i);
                    }
                    $(_pageId + ".c-list").html(html);
                    $(_pageId + ".c-no-more-data").show();
                    $(_pageId + ".c-no-search-data-box").hide();
                    // 撤单事件
                    $.bindEvent($(_pageId + ".c-list .c-list-item"), function (e) {
                        var $this = $(this);
                        var dataIndex = $this.attr("data-index");
                        var data = results[dataIndex];
                        if (data == null || data == "") {
                            $.alert("数据异常");
                        }
                        var tipStrArray = [];
                        tipStrArray.push(["证券名称", "<em style='font-size:" + $.getTransformScaleFontSize(data.stock_name, 16, $(window).width() * 0.48) + "px;'>" + data.stock_name + "</em>"]);
                        tipStrArray.push(["证券代码", data.stock_code]);
                        tipStrArray.push(["委托价格", data.entrust_price]);
                        tipStrArray.push(["委托数量", data.entrust_amount]);
                        tipStrArray.push(["委托方向", data.entrust_name]);
                        tipStrArray.push(["约定号", "<em style='font-size:" + $.getTransformScaleFontSize(data.confer_no, 16, $(window).width() * 0.48) + "px;'>" + data.confer_no + "</em>"]);
                        tipStrArray.push(["对方席位号", "<em style='font-size:" + $.getTransformScaleFontSize(data.oppo_seatno, 16, $(window).width() * 0.48) + "px;'>" + data.oppo_seatno + "</em>"]);
                        
                        var tipStr = "<div >";
                        tipStr += common.generatePrompt(tipStrArray);
                        tipStr += "</div>";
                        common.iConfirm("撤单确认", tipStr, function () {
                            var entrust_no = data.entrust_no;
                            cancellation(entrust_no); // 确认撤单
                        }, function () {
                        });
                        e.stopPropagation();
                    }, "tap");
                } else {
                    $(_pageId + ".c-list").html("");
                    $(_pageId + ".c-no-more-data").hide();
                    $(_pageId + ".c-no-search-data-box").show();
                    $(_pageId + ".visc_pullUp").hide();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 撤单HTML生成
     */
    function queryConsultTrustHTML(element, i) {
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_type_name;
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "c-icon-red";
            entrust_name = "买";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "c-icon-blue";
            entrust_name = "卖";
        } else {
            css = "";
        }

        var eleHtml = "";
        eleHtml += '<li class="c-list-item mt10" data-index="' + i + '">\
                        <p class="c-title border-bottom c-flex c-aic">\
                            <span class="' + css + ' c-mr-6">' + common.getShowStr(entrust_name,'--',0,0) + '</span>\
                            <span class="c-item-label c-mr-6" style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 14, 150) + 'px">' + common.getShowStr(element.stock_name,'--',0,0) + '</span>\
                            <span class="c-item-value">' + common.getShowStr(element.stock_code,'--',0,0) + '</span>\
                        </p>\
                        <div class="c-content">\
                            <div class="c-flex c-mb-6">\
                                <div class="c-flex c-f-1 c-mr-30">\
                                    <span class="c-item-label">委托价</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(parseFloat(element.entrust_price).toFixed(4),'--',0,0) + '</span>\
                                </div>\
                                <div class="c-flex c-f-1">\
                                    <span class="c-item-label">委托量</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_amount,'--',0,0) + '</span>\
                                </div>\
                            </div>\
                            <div class="c-flex c-mb-6">\
                                <div class="c-flex c-f-1 c-mr-30">\
                                    <span class="c-item-label">委托金额</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(parseFloat(element.entrust_balance).toFixed(2),'--',0,0) + '</span>\
                                </div>\
                                <div class="c-flex c-f-1">\
                                    <span class="c-item-label">委托状态</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_state_name,'--',0,0) + '</span>\
                                </div>\
                            </div>\
                            <div class="c-flex c-mb-6">\
                                <div class="c-flex c-f-1 c-mr-30">\
                                    <span class="c-item-label">委托编号</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_no,'--',0,0) + '</span>\
                                </div>\
                                <div class="c-flex c-f-1">\
                                    <span class="c-item-label">委托时间</span>\
                                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_time,'--',0,0) + '</span>\
                                </div>\
                            </div>\
                            <div class="c-flex">\
                                <span class="c-item-label">约定号</span>\
                                <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.confer_no,'--',0,0) + '</span>\
                            </div>\
                            <div class="c-flex">\
                                <span class="c-item-label">对方席位号</span>\
                                <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.oppo_seatno,'--',0,0) + '</span>\
                            </div>\
                        </div></li>';
        return eleHtml;
    }

    /**
     * 确定撤单
     */
    function cancellation(entrustNo) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code; // 关联资产账户标志
        var sessionid = userInfo.session_id;
        var entrust_no = entrustNo;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
        };
        service_stock.postCancelOrder(param, postCancelOrderCallback, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }
    //确定撤单回调
    function postCancelOrderCallback(data) {
        $.hidePreloader();
        if (typeof data != "undefined" && data != null) {
            var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
            if (data.error_no == 0) {
                if (typeof data.results[0] != "undefined" && data.results[0] != null) {
                    $.alert(tipStr, function () {
                        queryCancellation(); //刷新页面重新加载数据
                    });
                }
            } else {
                $.alert(tipStr, function () { queryCancellation(); });
            }
        } else {
            $.alert("<span class='wt-tips-title'>委托结果</span><br>撤单失败", function () { queryCancellation(); });
        }
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryCancellation(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
                $(_pageId + " .c-no-search-data-box").height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        stock_code = "";
        stock_num = "";
        stock_direction = "";
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".c-list").html("");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
