/**
 * 大宗交易下单
 */
define('trade/scripts/blockTrade/blockOrder.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var appropriate = require("appropriate");
    var nativePluginService = require("nativePluginService");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var service_hq = require("service_hq");
    var service_stock = require("service_stock");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var keyboard = require("keyboard");
    var project = require("project");
    var service_third = require("service_third");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var position_timer = null;
    var _pageId = null;
    var _market = null;
    var fifthOrder_timer = null;//五档行情定时器
    var _orderType = null;
    var entrust_bs = null;
    var entrust_prop = null;
    var clearMaxNumber = false;
    // 一级债券类型
    var bondTypeArr = [6, 14, 21, 22, 23, 24, 25, 26, 27, 30];
    var bondTypeSecond = project.constants.bondTypeSecond;
    // 新规债券上海市场二级类型
    var secondTypeArrBySH = project.constants.secondTypeArrBySH;
    // 新规债券深圳市场二级类型
    var secondTypeArrBySZ = project.constants.secondTypeArrBySZ;
    var reductionTypeFunc = null;
    var _PageParam = {};
    //0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
    var _exchange = {
        "0": "0", "2": "0", "3": "0", "4": "0", "5": "0", "6": "0", "7": "0", "8": "0",
        "1": "1",
        "9": "2", "11": "2", "12": "2", "13": "2", "14": "2", "15": "2", "16": "2",
        "10": "3",
        "17": "4",
        "18": "0", "19": "0", "21": "0", "22": "0", "23": "0", "24": "0", "64": "0",
        "20": "2", "25": "2", "26": "2", "27": "2", "30": "2", "65": "2", "66": "2",
        "K": "2"//科创板
    };
    var _stockCode = null;
    var _callback = true;
    var _fifthCallback = true;
    var bond_repurchase_flag = null;//国债回购标志
    var fund_used_days = null;//实际占款天数
    var is_delisting = null;  //退市整理期股票标志  为1是为退市整理期股票
    var delisting_msg = null;  //退市提示语
    var notice_no = null;//系统提示信息 为4时，显示弹框
    var notice_info = null;//系统提示信息
    var cdrProtocolSign = require("cdrProtocolSign");
    var hqKt = require("minLines");
    var canvasJs = require("canvasJs");
    var stockAccountList = [];
    var pageGlobal = {
        "stockType26100": ["3", "6", "8", "14", "19", "21", "22", "23", "24", "25", "26", "27", "30"]
    };

    /**
     * 设置股票对象是信息参数
     */
    function ioitStock() {
        var stockInfo = {
            "isHq": false,
            "stockCode": "", // 股票代码
            "stockName": "", // 股票名称
            "stockPrice": "",// 股票价格
            "stockNum": "",
            "reductionType": "",//股份类别
            "upStop": 0, //涨停价
            "downStop": 0,//跌停价
            "yesProfit": 0,//昨收价
            "stockMaxAmount": 0,//股票最大数
            "price_step": 0.01, // 步长
            "price_digit": 3, // 小数点位数
            "lot_size": 100, //每手数量
            "stock_type": "",//股票类型
            "stock_market": "",//市场代码
            "exchange_type": "",//交易市场（交易后台）
            "stock_account": "",// 股东账号
            "delist_info": "",// 退市提示语
            "delist_flag": "",//是否提示标示
            "relationName": "",//联系人姓名
            "relationTel": "",//联系电话
            "propSeatNo": "",//席位号
            "cbpconferId": "",//约定号
            "stockType": "",//类型
        };
        return stockInfo;
    }

    function initHtml() {
        stock_html = {
            "stockCode": $(_pageId + " #stockCode"), // 股票
            "stockName": $(_pageId + " #stockCode").next("span"), // 股票名称
            "stockPrice": $(_pageId + " #stockPrice"),// 股票价格
            "stockNum": $(_pageId + " #stockNum"), // 股票数量
            "stockMaxAmount": $(_pageId + "#maxNumber"),//最大可用
            "enable_balance": $(_pageId + "#enable_balance"),//可用资金
            "upStop": $(_pageId + " #up_stop"), //涨停价
            "downStop": $(_pageId + " #down_stop"), //涨停价
            "reductionType": $(_pageId + " #reductionType"),//跌停价
            "yesProfit": $(_pageId + " #yesProfit"),//跌停价
            "hqCanvas": $(_pageId + " .kcb_timeshare"),
            "hqxltb": $(_pageId + " .hqxltb i"),
            "stockList": $(_pageId + " #stock_list"),// 股票下拉列表
            "relationName": $(_pageId + " #relationName"),// 联系人姓名
            "relationTel": $(_pageId + " #relationTel"),// 联系电话
            "propSeatNo": $(_pageId + " #propSeatNo"),// 席位号
            "cbpconferId": $(_pageId + " #cbpconferId"),// 约定号
            "stockMarketType": $(_pageId + " .ipt_market")
        }
    }


    /**
     * 数据初始化
     */
    function dataInit(pageId, orderType, _prop) {
        var block_account_type = $.getSStorageInfo("block_account_type");
        if(block_account_type === "1"){
            common.switchingCurUser("1");
        }else{
            common.switchingCurUser("0");
        }
        commonFunc.initCheckTradeTimer();
        _pageId = pageId;
        _PageParam = $.getPageParam() || {};
        if (keyboard) {
            keyboard.keyInit(null, function () {
                $(_pageId + " input#stockPrice").triggerFastBlur();
            });
        }
        userInfo = common.getCurUserInfo();
        stock_info = ioitStock();
        _orderType = orderType;
        entrust_bs = orderType;
        entrust_prop = _prop;
        initHtml();
        reductionTypeFunc = commonFunc.nativeSelect("请选择股份类别", ["0", "1"], ["非受限股份", "受限股份"], 0);//0-非受限股份委托,1-受限股份委托
        _stockCode = null;
        var stockCode = $.getPageParam("code");
        // 查询个股行情
        if (stockCode) {
            $(_pageId + " #stockCode").addClass("wato");
            $(_pageId + " #stockCode").quzhi(stockCode);
            var market = $.getPageParam("market");
            var exchange_type = $.getPageParam("exchange_type");
            stock_info.stock_account = $.getPageParam("stock_account");
            stock_info.exchange_type = exchange_type;
            getStockList(stockCode, market, exchange_type);
        } else {
            hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10, 160);
            canvasJs.minLineFunc([{}], {});
        }
        queryStockAccountList();
    }

    function isBuy() {
        if (_orderType == "0") {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 获取股票信息
     * @param {Object} param 对应id名的值
     * @param {Object} newest 是否不同步
     */
    function getStockInfo(param, newest) {
        if (stock_html) {
            var data = stock_html[param].quzhi();
            //		var data = stock_html[param].val() || stock_html[param].text();
            if (newest && stock_info) {
                if (!data || data == "--") {
                    stock_info[param] = 0;
                } else {
                    stock_info[param] = data;
                }
            }
            return data;
        } else {
            return '';
        }
    }

    /**
     * 设置股票信息的值 可以为对象
     * @param {Object} key 输入字符串支持单个，输入对象支持全部
     * @param {Object} value 只支持单个字符串的值
     * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
     */
    function setStockInfo(key, value, newest) {
        if (stock_html) {
            stock_html[key].quzhi(value);
            if (key == "stockName") {
                //股票名称长度过长缩放
                var fontSize = $.getTransformScaleFontSize(value, 16, 150);
                stock_html[key].css({
                    "font-size": fontSize + "px",
                    "margin-left": "10px",
                });
            }
            if (key == "stockPrice" || key == "stockNum") {
                stock_info[key] = value;
            }
            if (newest && stock_info) {
                if (value == "--") {
                    value = 0;
                }
                stock_info[key] = value;
            }
        }
    }

    /*
     * 关于债券的判断
     */
    function bondJudgment() {
        //对债券做提示
        switch (stock_info.stockType) {
            case 6:
            case 21:
            case 22:
            case 23:
            case 24:
            case 14:
            case 25:
            case 26:
            case 27:
            case 30:
                // $.alert("债券品种不支持市价委托");
                stock_info.isBond = true;
                break;
        }
    }


    /**
     *
     * @param {Object} stockPrice
     */
    function isQueryMax(stockPrice) {
        clearMaxNumber = false;
        if (stock_info && (isBuy() || !stock_info.exchange_type) && stock_info.stockCode && stockPrice && Number(stockPrice) != 0) {
            queryMaxAmount(stock_info.stockCode, true);
        }
    }

    /**
     * 事件绑定
     */
    function elementBindEvent() {

        // 返回按钮
        $.bindEvent($(_pageId + " .top_title .icon_back"), function (e) {
            $.pageBack();
        });

        //关闭ios键盘
        $.bindEvent($(_pageId), function (e) {
            if (e.target !== document.activeElement) {
                document.activeElement.blur();
            }
        }, "click");

        if (!keyboard) {
            $.bindEvent($(_pageId + " #stockCode"), function (e) {
                stock_html.stockList.show();
                e.stopPropagation();
            });
        }
        $.bindEvent($(_pageId + " .select-box"), function (e) {//输入时股票代码调键盘
            var click = e.type || "click";
            if (keyboard) {
                $(_pageId + " div#stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            } else {
                $(_pageId + " #stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            }
            e.stopPropagation();
        });

        // 股票代码输入框监听
        $.bindEvent($(_pageId + " #stockCode"), function (e) { // 该监听方法是为了适配浏览器
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                var stockCode = $(this).val();
                stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
                stockCode = $.trim(stockCode);
                $(this).val(stockCode);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode.length > 4) {
                var vai1 = /^[0-9]+$/;
                if (!vai1.test(stockCode)) {
                    stockCode = stockCode.substring(0, 4);
                    $(_pageId + " #stockCode").quzhi(stockCode);
                }
            }
            if (stockCode.length == 0) {
                clearBuyMsg();
                $(_pageId + " #stockCode").removeClass("wato");
            } else {
                $(_pageId + " #stockCode").addClass("wato");
            }
            if (stockCode) {
                if (stockCode != _stockCode) {
                    _stockCode = stockCode;
                    clearBuyMsg();
                    handleInput();
                    var vai0 = /^[A-Za-z]+$/;
                    var vai1 = /^[\u4e00-\u9fa5]+$/;
                    if (stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))) { // 当输入的长度大于1 并且为字母的时候
                        getStockList(stockCode, null, null, true); // 查询股票列表
                    } else if (stockCode.length > 2) { // 当输入的长度大于3的时候
                        getStockList(stockCode, null, null, true); // 查询股票列表
                    }
                }
            }
            e.stopPropagation();
        }, "input");

        //数量输入
        $.bindEvent($(_pageId + " #stockNum"), function (e) {
            if (keyboard) {
                var key = "";
                if (!global.callNative) {
                    key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
                } else {
                    key = $(this).attr("keyDiv");
                }
                // 禁止输入数字之外的字符
                var stockNum = $(_pageId + " #stockNum").val();
                if (stockNum.length > 1) {
                    var vai1 = /^[0-9]+$/;
                    if (!vai1.test(stockNum)) {
                        stockNum = stockNum.substring(0, stockNum.length - 1);
                        $(_pageId + " #stockNum").quzhi(stockNum);
                    }
                }
                if (key == "d4" || key == "-11") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d3" || key == "-12") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d2" || key == "-13") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d1" || key == "-14") {
                    var num = stock_info.stockMaxAmount;
                    setStockInfo("stockNum", num + "");
                } else {
                    keyboard.popUpKeyboard($(this), e);
                }
                setStockInfo("stockNum", $(this).val());
                handleInput();
            }
            e.stopPropagation();
        }, "input");

        // 限价价格输入框
        $.bindEvent($(_pageId + " #stockPrice"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var stockPrice = $(_pageId + " #stockPrice").val();
            var stockNum = getStockInfo("stockNum");

            if (stock_info) {
                var stockPrice = $(_pageId + " #stockPrice").val();
                if (stockPrice == "" || Number(stockPrice) == 0) {
                    if (isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    isQueryMax(stockPrice);
                }
                handleInput();
            }
            e.stopPropagation();
        }, "input");

        // 增加价格
        $.bindEvent($(_pageId + " .price-warp .add"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                stockPrice = Number(stockPrice);
                var price_step = stock_info.price_step;
                if (stockPrice >= 0 && stockPrice < 999999999) {
                    stockPrice = (parseFloat(stockPrice) + parseFloat(stock_info.price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    isQueryMax(stockPrice);
                }
                handleInput();
            } else {
                $.alert("请先输入股票代码");
            }

        });

        // 减少价格
        $.bindEvent($(_pageId + " .price-warp .less"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                var price_step = stock_info.price_step;
                stockPrice = Number(stockPrice);
                if (stockPrice - price_step >= 0) {
                    stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    isQueryMax(stockPrice);
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                }
                handleInput();
            } else {
                $.alert("请先输入股票代码");
            }
            e.stopPropagation();
        });


        // 下单
        $.bindEvent($(_pageId + " #submitOrder"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            vailSubmitOrder();
        });

        // 点击其他位置去掉五档点击效果
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + "#account_list").hide();
            if (stock_html) {
                stock_html.stockList.hide();
            }
            e.stopPropagation();
        });

        // 增加数量
        $.bindEvent($(_pageId + " .num-warp .add"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockPrice = getStockInfo("stockPrice");
                var stockNum = getStockInfo("stockNum") || "0";
                if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
                    setStockInfo("stockNum", 0);
                    return false;
                }
                stockNum = Number(stockNum) + stock_info.lot_size;
                setStockInfo("stockNum", stockNum);
                handleInput();
            } else {
                $.alert("请输入正确的证券代码/简拼");
            }
            e.stopPropagation();
        });

        // 减少数量
        $.bindEvent($(_pageId + " .num-warp .less"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockPrice = getStockInfo("stockPrice");
                var stockNum = getStockInfo("stockNum");
                if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
                    setStockInfo("stockNum", 0);
                    return false;
                }
                stockNum = Number(stockNum) - stock_info.lot_size;
                if (stockNum < 0) stockNum = 0;
                setStockInfo("stockNum", stockNum);
                handleInput();
            } else {
                $.alert("请输入正确的证券代码/简拼");
            }
            e.stopPropagation();
        });


        $.bindEvent($(_pageId + " .hqxltb"), function (e) {
            var flag = $(this).find("i").hasClass("xl");
            showChart(flag);
            e.stopPropagation();
        });

        // 联系人 输入框监听
        $.bindEvent($(_pageId + " #relationName"), function (e) {
            var val = $(this).val();
            // 去除空格
            stock_info.relationName = val.replace(/ /g,"");
            $(this).val(stock_info.relationName);
            handleInput();
        }, "input");

        // 联系人 输入框监听
        $.bindEvent($(_pageId + " .bowerKeyboard"), function (e) {
            $(_pageId + " #relationName").focus();
        },);
        
        common.listenKeybord($(_pageId + " #relationName")[0],_pageId,function(){
            // $.closeModal(".picker-modal.modal-in");
            // if (keyboard) {
            //     keyboard.closeKeyPanel();
            // }
        },function(){ })

        // 联系电话 输入框监听
        $.bindEvent($(_pageId + " #relationTel"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.relationTel = val;
            handleInput();
        }, "input");

        // 席位号 输入框监听
        $.bindEvent($(_pageId + " #propSeatNo"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.propSeatNo = val;
            handleInput();
        }, "input");

        // 约定号 输入框监听
        $.bindEvent($(_pageId + " #cbpconferId"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.cbpconferId = val;
            handleInput();
        }, "input");
        // 股份类别
        $.bindEvent($(_pageId + "#reductionType"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            reductionTypeFunc && reductionTypeFunc(function (data, vals, list) {
                if (data.status === "0") {
                    stock_info.reductionType = vals[data.selectIndex];
                    setStockInfo("reductionType", data.dateStr);
                    handleInput();
                }
            });
        });

        //点击分时图
        $.bindEvent($(_pageId + " #hqt"), function (e) {
            if (!stock_info.stockCode) {
                return;
            }
            if (stock_info.stockCode && stock_info.stock_market) {
                var pageCode = $.getCurrentPageObj().pageCode || '';
                if (global.callNative) {
                    var param = {
                        "funcNo": "50500",
                        "msgNo": "201",
                        "targetModule": "hqDispatcher",
                        "sourceModule": "trade",
                        "action": "0",
                        "param": {
                            "stockMarket": stock_info.stock_market,
                            "stockCode": stock_info.stockCode,
                            "stockName": stock_info.stockName,
                        }
                    }
                    $.setSStorageInfo("go_hq_" + pageCode, true);
                    $.callMessage(param);
                } else {
                    var stockInfo = {
                        "market": stock_info.stock_market,
                        "stockCode": stock_info.stockName,
                        "stockName": stock_info.stockCode,
                        "moduleName": "trade"
                    }
                    window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                }
            } else {
                $.alert("在行情服务器中没有查询到该只股票的信息");
            }
        });
    }

    function showChart(flag) {
        $.closeModal(".picker-modal.modal-in");
        if (flag) {
            stock_html.hqxltb.attr("class", "sl");
            stock_html.hqCanvas.show();
        } else {
            stock_html.hqxltb.attr("class", "xl");
            stock_html.hqCanvas.hide();
        }
    }

    //行情列表接口有问题是，输入股票是6位数时直接调用交易接口
    function queryData(stockCode, exchange_type) {
        var vai1 = /^[0-9]{6}$/;
        if (vai1.test(stockCode)) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            queryMaxAmount(stockCode, false, exchange_type);
        }
    }

    //对行情接口返回数据进行处理
    function ListData(data) {
        stock_info.isHq = true;
        var price = data[2] ? data[2] : data[6];
        var stockVal = data[0]; //股票代码
        var stkType = data[10];
        var stkkcbType = data[18];//是否为科创板
        // 146	chaVentureFlag	风险警示股票标识	1:深圳风险警示 2:上海风险警示  空:非风险警示股票	
        stock_info.chaVentureFlag = data[22];
        // 注册制 退市整理，交易上证云新增field 700 ；1：是 0：不是 其他：未知
        stock_info.issuspend = data[23];
        stock_info.yesProfit = data[6]; // 昨收价
        var price_digit = null;
        var price_step = null;
        var lotsOf = null;
        // 二级类型
        var second_type = data[21];
        stock_info.stockType = stkType;
        stock_info.second_type = second_type;

        /*--------- 2 ，设置证券价格加减步长 ------------*/
        //		var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //0.001
        //		var price_step_const = [1,3,4,5,6,10,11,12,13,14,16,19,20,21,22,23,24,30];//0.001
        var price_step_const = [0, 1, 2, 7, 9, 14, 15, 17, 18, 25, 26, 66];//0.01
        if (global.typeDigit && global.typeDigit instanceof Array && global.typeDigit.length != 0) {
            price_step_const = global.typeDigit;
        }
        var step_flag = $.inArray(stkType, price_step_const);
        // 判断是否为债券
        // stkType == 30 上海国债逆回购
        // stkType == 24 深圳国债逆回购
        // 2022.5.19 交易所新规，深圳国债逆回购 单位改为0.005 , 1000 起购
        if (stkType == 30 || stkType == 24) {
            price_digit = 3;
            price_step = 0.005;
            lotsOf = 1000;
        }
        // 否则浮动为0.01
        else if (step_flag != -1) {
            price_digit = 2;
            price_step = 0.01;
            lotsOf = 100;
        }
        // 变动价格为0.001
        else {
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 100;
        }
        var num_step_const = [6, 14, 21, 22, 23, 24, 25, 26, 27];//10张
        if ($.inArray(stkType, num_step_const) != -1 || stockVal.substring(0, 3) == "131") {
            lotsOf = 10;
        }
        var typeStr = project.functionBody.getStockType(data);
        if (typeStr == "三板") {
            price_digit = 2;
            price_step = 0.01;
            lotsOf = 100;
        }
        // 二级分类中的债券分类
        if($.inArray(stock_info.second_type,bondTypeSecond) != -1){
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 100;
        }
        // 上海市场新规债券默认配置
        if (secondTypeArrBySH.indexOf(stock_info.second_type) > -1) {
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 1000;
        }
        // 深圳市场新规债券默认配置
        if (secondTypeArrBySZ.indexOf(stock_info.second_type) > -1) {
            price_digit = 4;
            price_step = 0.001;
            lotsOf = 1000;
        }
        stock_info.price_step = price_step;
        stock_info.price_digit = price_digit;
        $(_pageId + " #stockCode").addClass("wato");
        setStockInfo("stockCode", stockVal, true);
        _stockCode = stockVal;
        setStockInfo("stockName", data[1], true); // 股票现价

        if (typeStr) {
            setStockInfo("stockMarketType", typeStr, true); // 股票市场类型
        }

        if (stkkcbType == "K") {
            cdrFlag(stkkcbType, true);
            stock_info.stock_type = stkkcbType;
            //联动返回了，会重新赋值，此设置，是为联动不返回的容错处理
            stock_info.lot_size = 1;//科创板步数为1
            if (stkType == "16") {
                stock_info.price_step = 0.01;
                stock_info.price_digit = 2;
            }
        } else {
            cdrFlag(stkType, true);//CDR
            // stock_info.stock_type=stkType; 交易类型 由联动接口赋值
            stock_info.lot_size = lotsOf;
        }
        bondJudgment();
        stock_info.stock_market = data[9];
        var p_price = $.getPageParam("price");
        if (p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
            price = Number(p_price);
        }
        setStockInfo("stockPrice", price.toFixed(stock_info.price_digit)); // 股票现价
        // 涨跌停允许可转债显示
        if ($.inArray(stkType, bondTypeArr) != -1 || $.inArray(stock_info.second_type,bondTypeSecond) != -1) {
            //可转债显示涨跌停价格
            if (stkType == 27 || stkType == 23) {
                setStockInfo("upStop", common.transferText(data[13], stock_info.price_digit), true); // 股票现价
                setStockInfo("downStop", common.transferText(data[14], stock_info.price_digit), true); // 股票现价
                setStockInfo("yesProfit", common.transferText(data[6], stock_info.price_digit), true); // 昨收价
            }
        } else {
            //为国债是不显示涨跌停
            setStockInfo("upStop", common.transferText(data[13], stock_info.price_digit), true); // 股票现价
            setStockInfo("downStop", common.transferText(data[14], stock_info.price_digit), true); // 股票现价
            setStockInfo("yesProfit", common.transferText(data[6], stock_info.price_digit), true); // 昨收价
        }

        var list = stock_info.stock_market + ":" + stock_info.stockCode;
        hqKt.minLineFunc(_pageId, _pageId + " #hqt", list, $(_pageId).width() - 10, 160);
        if (fifthOrder_timer != null) {
            window.clearInterval(fifthOrder_timer);
        }
        setFifthOrder();
        _fifthCallback = false;
        fifthOrder_timer = window.setInterval(function () {
            if (commonFunc.getTradingTime() && _fifthCallback && common.isAppFlag()) {
                setFifthOrder();
                _fifthCallback = false;
            }
        }, (global.refreshTime || 5000));//定时刷新

        queryMaxAmount(stock_info.stockCode);


        //股票联动,查询股票信息，最大可买
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
    }

    /**
     * 通过输入的字符查询出对应的股票列表
     * @param {Object} stockCode 输入的字符
     */
    function getStockList(stockCode, market, exchange_type, isNotQueryHold) {
        if (stockCode != "") {
            var type = "";
            if (global.stockType && global.stockType instanceof Array && global.stockType.length != 0) {
                type = global.stockType.join(":");
            }
            var stockStrParam = {
                "q": stockCode,
                "type": type
            };
            stock_html.stockList.html("");
            var vai1 = /^[0-9]{6}$/;
            if (vai1.test(stockCode)) {
                $.showPreloader("请等待...");
            }
            //			setTimeout(function(){
            //				if(queryStockHqFlowNo && queryStockHqFlowNo.length > 0){
            //					window.clearNativeRequestCallback(queryStockHqFlowNo);
            //				}
            //				queryStockHqFlowNo = service_hq.getStockList(stockStrParam,function(data){
            $.clearRequest();
            service_hq.getStockList(stockStrParam, function (data) {
                getStockListCallBack(data, stockCode, market, exchange_type, isNotQueryHold);
            },
                {
                    "isLastReq": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        queryData(stockCode, exchange_type);
                    }, "errorFunc": function () {
                        queryData(stockCode, exchange_type);
                    }
                });
            //			},0);
        }
    }


    function getStockListCallBack(data, stockCode, market, exchange_type, isNotQueryHold) {
        isNotQueryHold = !isBuy() ? false : isNotQueryHold;
        var StockList = {};
        var vai1 = /^[0-9]{6}$/;
        stock_html.stockList.html("");
        if (data.errorNo == 0) {
            var results = data.results;
            // 显示股票列表
            if (results && results.length > 0) {
                // 如果从行情中查回来的代码跟选中的代码市场不一样，说明行情中没有这只代码
                if (results.length == 1 && vai1.test(stockCode) && (market && market != results[0][9])) {
                    setStockInfo("stockPrice", '');// 股票价格
                    setStockInfo("stockName", stock_info.stockName || $.getPageParam('name'));
                    setStockInfo("stockCode", stockCode);
                    setStockInfo("stockMaxAmount", '');
                    setStockInfo("enable_balance", "");
                    queryData(stockCode, exchange_type);
                } else if (results.length == 1 && vai1.test(stockCode)) {
                    if ($.isValue(results[0][19])) results[0][1] = results[0][19]; // 长名称赋值原名称
                    ListData(results[0]);
                    stock_html.stockList.html("");
                } else {
                    $.hidePreloader();
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    // var emWidth = ($(window).width() - 30) * 0.6;
                    var emWidth = 80;
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i][19])) results[i][1] = results[i][19]; // 长名称赋值原名称
                        if (market && market == results[i][9] && results[i][0] == stockCode) {
                            ListData(results[i]);
                            return false;
                        }
                        StockList[(results[i][9] + ":" + results[i][0])] = results[i];
                        var typeStr = project.functionBody.getStockType(results[i]);
                        var subStr = typeStr ? '<dd class="market_type">' + typeStr + '</dd>' : "";
                        var nameText = '<em style="transform-origin: left;white-space: nowrap;transform:scale(' + $.getTransformScale(results[i][1], 14, emWidth) + ')">' + results[i][1] + '</em>';
                        listHtml += "<li type26100='" + results[i][10] + "' typeStr26100='" + typeStr + "'><a href=\"javascript:void(0);\" style=\"line-height: inherit;display: flex;align-items: center;text-align: center;\">" + subStr + "<strong style=\"font-size:0.15rem\" stock_name=" + results[i][1] + ">" + results[i][0] + "</strong>" + nameText + "</a>";
                        listHtml += "<span style=\"display:none;\">" + results[i][9] + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .select_box ul li"), function (e) {
                        var market1 = $(this).find("span").text();
                        var stockCode = $(this).find("strong").text();
                        if (stockCode.length == 6) {
                            var type = $(this).attr("type26100");
                            if ((pageGlobal.stockType26100).indexOf(type) > -1) {
                                var exchangeType = "";
                                var typeStr = $(this).attr("typeStr26100");
                                if (typeStr.indexOf("沪") > -1) {
                                    exchangeType = typeStr.indexOf("沪B") > -1 ? "3" : "2";
                                } else if (typeStr.indexOf("深") > -1 || type == "8") {
                                    exchangeType = typeStr.indexOf("深B") > -1 ? "1" : "0";
                                }
                                stock_info.exchange_type = exchangeType;
                            }
                        }
                        ListData(StockList[market1 + ":" + stockCode]);
                        stock_html.stockList.html("");
                        StockList = {};

                        e.stopPropagation();
                    });
                }
            } else {
                //输入是股票代码时行情没查到回去联动查询
                if (vai1.test(stockCode)) {
                    queryData(stockCode, exchange_type);
                    //					$.alert("没有查询到此股票信息");
                    //					$.hidePreloader();
                }
                //输入时股票简拼没查到提示
                var regx = /^[a-zA-Z0-9]{4}$/;
                if (regx.test(stockCode)) {
                    $.alert("没有查询到此股票信息");
                }
            }
        } else {
            queryData(stockCode, exchange_type);
        }
    }


    //五档买卖盘
    function setFifthOrder() {
        var market = stock_info.stock_market, stockCode = stock_info.stockCode;
        if (market && stockCode) {
            var fifthOrder = {
                "stock_list": market + ":" + stockCode
            };
            service_hq.getStockFiveStep(fifthOrder, function(data){
              callbackFifthOrder(data,stockCode);
            }, {
                "isShowWait": false, "errorFunc": function () {
                    _fifthCallback = true;
                }
            });
        }
    }

    //回调五档买卖盘
    function callbackFifthOrder(data) {
        _fifthCallback = true;
        if (data.errorNo == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                var price_digit = stock_info.price_digit;

                var kcb_timeshareEm = $(_pageId + ".kcb_timeshare .row_01 em");
                var r35 = results[0][35];
                if (results[0][35]) {
                    r35 = (Number(results[0][35])).toFixed(price_digit);//内盘
                }
                kcb_timeshareEm.text((Number(results[0][30])).toFixed(price_digit) + " " + r35 + " " + (Number(results[0][36]) * 100).toFixed(2) + "%");
                if (r35 > 0) {
                    kcb_timeshareEm.attr("class", "ared");
                } else if (r35 < 0) {
                    kcb_timeshareEm.attr("class", "agreen");
                } else {
                    kcb_timeshareEm.attr("class", "");
                }
            }
        }
    }




    /**
     * 查询买入可用资金最大可买可卖数量
     * */
    function queryMaxAmount(stockCode, isMax, exchange) {
        stock_html.stockList.html("");
        $.hidePreloader();
        var stock_price = getStockInfo("stockPrice");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var stock_code = stockCode;
        var entrust_price = stock_price;
        var stock_account = stock_info.stock_account || $(_pageId + "#account p").attr("stock_account");
        var exchange_type = exchange || stock_info.exchange_type || $(_pageId + "#account p").attr("exchange_type") || _exchange[stock_info.stock_type + ""];
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "entrust_prop": entrust_prop,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "stock_account": stock_account,
            "newstock_flag": "",
            "exchange_type": exchange_type
        };
        if (param.stock_code == '' || param.stock_code == null) {
            return false;
        }
        service_stock.queryBlockMaxBuy(param, function (data) {
            $.hidePreloader();
            if (isMax) {
                queryMaxAmountCallBackMax(data);
            } else {
                queryMaxAmountCallBack(data);
            }
            _PageParam = {};
        }, { "isLastReq": true, "isShowWait": !isMax });

    }

    function queryMaxAmountCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                if (results.length == 1) {
                    stock_info.bond_cash = results[0].bond_cash; // 是否是债券现券交易支持的债券分类
                    var bjs_block_trade_rights = results[0].bjs_block_trade_rights; // =1 大宗交易权限
                    if(bjs_block_trade_rights !== '1'){
                        $.alert("<p style='text-align: left;'>您尚未开通大宗交易权限，交易可能失败。如需开通权限，可前往附近营业部临柜办理，详情请咨询在线客服或拨打服务热线956011。</p>","温馨提示",function(){},"我知道了");
                    }
                    // 如果是新规债券（上海和深债两个市场）
                    if (isBondCash()) {
                        stock_info.price_step = ((+results[0].price_step) / 1000);
                    }
                    // 沪深国债逆回购 价差以柜台接口为准
                    // 可转债新规 数量以柜台为准
                    if (stock_info.stockType == 30 || stock_info.stockType == 24 || stock_info.stockType == 27 || stock_info.stockType == 23) {
                        stock_info.price_step = ((+results[0].price_step) / 1000);
                    }
                    if ($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
                    stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
                    var price_digit = stock_info.price_digit;
                    setStockInfo("stockMaxAmount", Number(results[0].stock_max_amount), true);
                    setStockInfo("enable_balance", common.numToMoneyType(results[0].enable_balance, 2), true);
                    var exchange_type = results[0].exchange_type;
                    stock_info.exchange_type = exchange_type;
                    stock_info.stock_account = results[0].stock_account;


                    //勾选筛选出的股东账号
                    $(_pageId + "#account p").html(stock_info.stock_account + " " + results[0].exchange_type_name);
                    $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
                    $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
                    stockAccountListCallBack(stockAccountList, stock_info.exchange_type, stock_info.stock_account);

                    var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
                    var sell_unit = results[0].sell_unit ? Number(results[0].sell_unit) : 0;
                    if (buy_unit != 0 && isBuy()) {
                        stock_info.lot_size = buy_unit;
                    }else if (sell_unit != 0 && !isBuy()) {
                        stock_info.lot_size = sell_unit;
                    }
                    stock_info.delist_flag = results[0].delist_flag;
                    stock_info.delist_info = results[0].delist_info;
                    var stock_code = results[0].stock_code;
                    if (!stock_info.isHq) {
                        var stock_type = results[0].stock_type;
                        stock_info.stock_type = stock_type;
                        cdrFlag(results[0].stock_type);//CDR、科创板、沪伦通
                        if (exchange_type == 0 || exchange_type == 1) {
                            stock_info.stock_market = "SZ";
                        } else if (exchange_type == 2 || exchange_type == 3) {
                            stock_info.stock_market = "SH";
                            if (global.serverConfig == "3" && stock_type && stock_type.indexOf("Z") == 0) {
                                stock_info.lot_size = 1;
                            }

                        }
                    }
                    // 注释调行情接口stock_type赋值
                    if (!stock_info.stock_type) stock_info.stock_type = results[0].stock_type;
                    if (isKCB()) {//科创板的价差取交易
                        var point = results[0].point ? Number(results[0].point) : 0;
                        if (point != 0) {
                            var price_step = Math.pow(10, 0 - point);
                            if (stock_code.substring(0, 3) == "204") {
                                price_step = 0.005;
                            }
                            stock_info.price_digit = point;
                            price_digit = point;
                            stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
                        }
                    }
                    //名称以联动为准
                    setStockInfo("stockName", results[0].stock_name, true);
                    $(_pageId + ".kcb_timeshare .row_01 strong").text(results[0].stock_name);
                    if (!stock_info.stockCode) {
                        var stock_type = results[0].stock_type;
                        stock_info.stock_type = stock_type;
                        $(_pageId + " #stockCode").addClass("wato");
                        setStockInfo("stockCode", results[0].stock_code, true);
                        setStockInfo("stockName", results[0].stock_name, true);

                        var point = results[0].point ? Number(results[0].point) : 0;
                        if (point != 0) {
                            var price_step = Math.pow(10, 0 - point);
                            if (stock_code.substring(0, 3) == "204") {
                                price_step = 0.005;
                            }
                            stock_info.price_step = price_step;
                            price_digit = point;
                            if (isKCB()) {//科创板的价差取交易
                                stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
                            } else {
                                stock_info.price_digit = point;
                            }
                        }
                        // 如果是新规债券（上海和深债两个市场）
                        if (isBondCash()) {
                            stock_info.price_step = ((+results[0].price_step) / 1000);
                            stock_info.price_digit = 3;
                            price_digit = 3;
                        }

                        var p_price = $.getPageParam("price");
                        if (p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
                            results[0].price = p_price
                        }
                        setStockInfo("stockPrice", Number(results[0].price).toFixed(price_digit));

                        if ((stock_info.stockType && $.inArray(stock_info.stockType, bondTypeArr) == -1) || $.inArray(stock_info.second_type,bondTypeSecond) != -1) {
                            if (results[0].up_limit != 0) {
                                setStockInfo("upStop", Number(results[0].up_limit).toFixed(price_digit), true);
                            }
                            if (results[0].down_limit != 0) {
                                setStockInfo("downStop", Number(results[0].down_limit).toFixed(price_digit), true);
                            }
                        }
                    }

                    var p_num = $.getPageParam("num");
                    if (p_num && p_num != 0 && validatorUtil.isNumeric(p_num)) {
                        setStockInfo("stockNum", p_num, true);
                    }
                    bond_repurchase_flag = results[0].bond_repurchase_flag;//保存国债逆回购标志
                    is_delisting = results[0].is_delisting;//退市标识
                    delisting_msg = results[0].delisting_msg;//退市提示语
                    fund_used_days = results[0].fund_used_days;//实际占款天数
                    notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
                    notice_info = results[0].notice_info;//系统提示信息
                    // if(isBuy()){
                    //   // 风险警示权限 0 表示 没权限，1表示有权限
                    //     isST(stock_info.stockCode,results[0].fxjs_rights);
                    // }

                } else if (results.length > 1) {
                    $.hidePreloader();
                    var stock_results = results;
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\" stock_name=" + results[i].name + ">" + results[i].stock_code + "</strong><em>" + results[i].stock_name + "</em></a>";
                        listHtml += "<span style=\"display:none;\">" + results[i].exchange_type + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .select_box ul li"), function (e) {
                        var info = stock_results[$(this).index()];
                        var exchange_type = info.exchange_type;
                        var stockCode = $(this).find("strong").text();
                        stock_html.stockList.html("");
                        $(_pageId + " #stockCode").addClass("wato");
                        // 如果柜台有多条，选择了行情中没有的股票，则清空数据
                        if (commonHq.getHqMarket(exchange_type) !== stock_info.stock_market) {
                            clearBuyMsg();// 清除数据
                            setStockInfo("stockPrice", info.price);// 股票价格
                            setStockInfo("stockMaxAmount", Number(info.stock_max_amount), true);
                            setStockInfo("enable_balance", common.numToMoneyType(info.enable_balance, 2), true);
                            stock_info.stockName = $(this).find("em").text();
                        }
                        queryData(stockCode, exchange_type);
                        setStockInfo("stockName", $(this).find("em").text(), true);
                        notice_no = info.notice_no;//系统提示信息 为4时，显示弹框
                        notice_info = info.notice_info;//系统提示信息
                        bond_repurchase_flag = info.bond_repurchase_flag;//保存国债逆回购标志
                        is_delisting = info.is_delisting;//退市标识
                        delisting_msg = info.delisting_msg;//退市提示语
                        fund_used_days = info.fund_used_days;//实际占款天数
                        e.stopPropagation();
                    });
                }
                showChart(true);
            }
        } else {
            $.alert(data.error_info);
        }
    }

    function queryMaxAmountCallBackMax(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                var price_digit = stock_info.price_digit;
                if (!clearMaxNumber) {
                    setStockInfo("stockMaxAmount", Number(results[0].stock_max_amount), true);
                    setStockInfo("enable_balance", common.numToMoneyType(results[0].enable_balance, 2), true);
                }
                var exchange_type = results[0].exchange_type;
                stock_info.exchange_type = exchange_type;
                stock_info.stock_account = results[0].stock_account;
                // 如果行情中没有查到数据，则使用柜台返回的数据,使用柜台的stock_type字段 ，isHq要设置false
                if (!stock_info.stock_type) {
                    stock_info.stock_type = results[0].stock_type || stock_info.stock_type;
                    stock_info.isHq = false;
                }
                stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示

                //勾选筛选出的股东账号
                $(_pageId + "#account p").html(stock_info.stock_account + " " + results[0].exchange_type_name);
                $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
                $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
                stockAccountListCallBack(stockAccountList, stock_info.exchange_type, stock_info.stock_account);

                var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
                if (buy_unit != 0) {
                    stock_info.lot_size = buy_unit;
                }
                stock_info.delist_flag = results[0].delist_flag;
                stock_info.delist_info = results[0].delist_info;
                bond_repurchase_flag = results[0].bond_repurchase_flag;//保存国债逆回购标志
                is_delisting = results[0].is_delisting;//退市标识
                delisting_msg = results[0].delisting_msg;//退市提示语
                fund_used_days = results[0].fund_used_days;//实际占款天数
                notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
                notice_info = results[0].notice_info;//系统提示信息
                showChart(true);
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /*******
     * 判断当前股票是否是风险警示的
     */
    function isST(stockCode, fxjs_rights) {

        var param = {
            "stock_code": stockCode,
        }
        service_hq.getIsST(param, function (data) {
            console.log(data);
            if (data.errorNo == "0") {
                if (data.results != null && data.results.length > 0) {
                    var status = data.results[0][0];
                    if (status == "1" || status == "2") {//1深圳风险警示 2上海风险警示 空：非风险警示
                        if (fxjs_rights == "1") {//已开通
                            showSTMessage();
                        } else {
                            var titleTips = "";
                            if (status == "1") {
                                titleTips = "您尚未开通深市风险警示股票购买权限，如需进行交易，请到业务办理完成对应权限开通。";
                            } else if (status == "2") {
                                titleTips = "您尚未开通沪市风险警示股票购买权限，如需进行交易，请到业务办理完成对应权限开通。";
                            }
                            common.iConfirmNew("温馨提示", titleTips, function success() {
                                if (global.callNative && global.isSso) {
                                    var param = {
                                        "funcNo": "50500",
                                        "msgNo": "123",
                                        "sourceModule": "",
                                        "targetModule": "tradeDispatcher",
                                        "action": "1",
                                        "param": {
                                            "business_type": userInfo._loginClass,//普通0  两融1
                                            "event": "12",//打开风险警示权限开通页面
                                            "title": "",
                                        }
                                    }
                                    $.callMessage(param);
                                }
                            }, function fail() {
                                showSTMessage();
                            }, "开通权限", "取消");
                        }
                    } else {
                        showMessage();
                    }
                } else {
                    showMessage();
                }
            } else {
                showMessage();
            }
            function showSTMessage() {
                if (notice_no === "4") {
                    common.singleIConfirmNew("温馨提示", notice_info, function () { }, "我知道了", undefined, undefined, undefined, 'notice_info');
                } else {
                    common.singleIConfirmNew("温馨提示", '该股票是风险警示类股票，请注意风险，谨慎投资！', function () { }, "我知道了", undefined, undefined, undefined, 'notice_info');
                }
            }
            function showMessage() {
                if (notice_no === "4") {
                    common.singleIConfirmNew("温馨提示", notice_info, function () { }, "我知道了", undefined, undefined, undefined, 'notice_info');
                }
            }
        });
    }


    //CDR标志
    function cdrFlag(stock_type, isHq) {
        var flag = true;
        var CDRArray = [];
        var CQArray = [];
        var hlCDRArray = [11];
        var KCBArray = [];
        if (isHq) {
            CDRArray = [43, 44];
            CQArray = [45, 46];
            KCBArray = ["K"];
        } else {
            CDRArray = [10];
            //			CQArray = [0];
            KCBArray = [15, 16];
        }

        if (CDRArray.indexOf(stock_type) != -1) { //CDR
            $(_pageId + ".input_text .logoStyle").show();
            $(_pageId + ".input_text .logoStyle").addClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("CDR");
            flag = false;
        } else if (CQArray.indexOf(stock_type) != -1) { //创企
            $(_pageId + ".input_text .logoStyle").show();
            $(_pageId + ".input_text .logoStyle").addClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("创企");
            flag = false;
        }
        //		else if(hlCDRArray.indexOf(stock_type)!=-1){ //沪伦通
        //			$(_pageId + ".input_text .cdrCss").text("沪伦");
        //			$(_pageId + ".input_text .cdrCss").show();
        //		}
        else if (KCBArray.indexOf(stock_type) != -1) { //科创板
            // $(_pageId + ".input_text .logoStyle").show();
            // $(_pageId + ".input_text .logoStyle").addClass("kcbCss");
            // $(_pageId + ".input_text .logoStyle").text("科创");
        } else {
            $(_pageId + ".input_text .logoStyle").hide();
            $(_pageId + ".input_text .logoStyle").removeClass("kcbCss").removeClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("");
        }
        if (flag && stock_html.stockMarketType.html()) {
            stock_html.stockMarketType.show();
        }
    }





    /*
     * 为科创板的代码判断
     */
    function isKCB() {
        var KCBArray = [];
        if (stock_info.isHq) {
            KCBArray = ["K"];
        } else {
            KCBArray = [15, 16];
        }
        if (KCBArray.indexOf(stock_info.stock_type) != -1) { //科创板
            return true;
        } else {
            return false;
        }
    }
    /**
     * @description 判断是否是债券现券
     * @author cfx
     * @date 2021-09-23 14:56:07
     * @modifyContent 修改点描述...
     */
    function isBondCash() {
        // 如果柜台返回的bond_cash === '1' 说明是债券现券，以柜台为准
        if (stock_info.bond_cash !== null) {
            if (stock_info.bond_cash === '1') {
                return true;
            } else {
                return false;
            }
        }
        if (secondTypeArrBySH.indexOf(stock_info.second_type) > -1 || secondTypeArrBySZ.indexOf(stock_info.second_type) > -1) {
            return true;
        } else {
            return false;
        }
    }

    // 校验输入数据
    function verificationInput() {
        var ruls = [
            "stockCode",
            "stock_account",
            "stockPrice",
            "stockNum",
            "reductionType",
        ];
        // 确认委托，约定号|席位号必填 ，意向委托、定价委托 联系人姓名|联系电话必填
        if (entrust_prop === "2") {
            ruls.push("propSeatNo");
            ruls.push("cbpconferId");
        } else if (entrust_prop === "0" || entrust_prop === "1") {
            ruls.push("relationName");
            ruls.push("relationTel");
        }
        var flag = true;
        for (var i = 0; i < ruls.length; i++) {
            if (stock_info[ruls[i]] === "") {
                flag = false;
                break;
            }
        }
        return flag;
    }
    function handleInput() {
        if (verificationInput()) {
            $(_pageId + " #submitOrder").removeClass("btn-disable");
        } else {
            $(_pageId + " #submitOrder").addClass("btn-disable");
        }
    }


    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        if($(_pageId + " #submitOrder").hasClass("btn-disable")){
            return;
        }
        var typeText = "买入";
        if (!isBuy()) {
            typeText = "卖出";
        }
        //验证股票代码输入是否正确
        var stockCode = stock_info.stockCode;
        if (stockCode.length == 0) {
            $.alert("请输入股票代码");
            return false;
        }
        var vai1 = /^[0-9]{6}$/;
        if (!vai1.test(stockCode)) {
            $.alert("股票代码输入错误");
            return false;
        }
        //验证股票价格输入是否正确
        var stockPrice = getStockInfo("stockPrice");
        if (!validatorUtil.isNumberFloat(stockPrice)) {
            $.alert("请正确输入价格");
            return false;
        }
        var stockMaxAmount = stock_info.stockMaxAmount + "";
        //验证买入数量
        var stockNum = getStockInfo("stockNum");
        if ($.trim(stockNum).length <= 0) {
            $.alert("请输入" + typeText + "数量");
            return false;
        } else if (!validatorUtil.isNumberFloat(stockNum)) {
            $.alert("请正确输入数量");
            return false;
        } else if (parseFloat(stockNum) <= 0) {
            $.alert("数量必须大于0");
            return false;
        }
        if (entrust_prop === "0" || entrust_prop === "1") {
            if (!/^[\u4E00-\u9FA5|a-zA-Z]+([·•]?[\u4E00-\u9FA5|a-zA-Z]+)*$/.test(stock_info.relationName)) {
                nativePluginService.function50106({
                    content: "姓名输入格式不正确"
                });
                return;
            }
            if (!/^\d{11}$/.test(stock_info.relationTel)) {
                nativePluginService.function50106({
                    content: "手机号码输入格式不正确"
                });
                return;
            }
        }

        buy(typeText, stockMaxAmount, stockNum, stockPrice, stockCode);
    }

    /******
     * 购买
     * @returns {boolean}
     */
    function buy(typeText, stockMaxAmount, stockNum, stockPrice, stockCode) {
        var ts = [];
        //验证最大可用
        if (!isBuy() && parseFloat(stockMaxAmount) < parseFloat(stockNum)) {
            ts.push("<em>最大可" + typeText + "数量不足；</em>");
        }

        var up_stop = null;
        var down_stop = null;
        var tipStrArray = [];
        var tipStr = "<div >";
        tipStrArray.push(["证券代码", stockCode]);
        tipStrArray.push(["证券名称", "<em style='font-size:" + $.getTransformScaleFontSize(stock_info.stockName, 16, $(window).width() * 0.48) + "px;'>" + stock_info.stockName + "</em>"]);
        tipStrArray.push(["股份类别", $(_pageId + "#reductionType").text()]);
        tipStrArray.push(["委托价格", stockPrice]);
        tipStrArray.push(["委托数量", stockNum]);
        // 确认委托，约定号|席位号必填 ，意向委托、定价委托 联系人姓名|联系电话必填
        if (entrust_prop === "2") {
            tipStrArray.push(["约定号", stock_info.cbpconferId]);
            tipStrArray.push(["席位号", stock_info.propSeatNo]);
        } else if (entrust_prop === "0" || entrust_prop === "1") {
            tipStrArray.push(["联系人", stock_info.relationName]);
            tipStrArray.push(["联系电话", stock_info.relationTel]);
        }
        var msg = "";
        if (up_stop && up_stop != "--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)) {
            ts.push("<em>委托价格超过涨停价；</em>");
        } else if (down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)) {
            ts.push("<em>委托价格低于跌停价；</em>");
        }
        tipStr += common.generatePrompt(tipStrArray, msg);
        tipStr += "</div>";
        if (ts.length) {
            if (ts.length > 1) {
                for (var i = 0; i < ts.length; i++) {
                    ts[i] = '<p>' + (i + 1) + '.' + ts[i] + '</p>';
                }
            } else {
                ts[0] = '<p>' + ts[0] + '</p>';
            }
            tipStr += "<div class='pop_reminder_text'><h4>温馨提示</h4>" + ts.join("") + "</div>";
        }


        //埋点数据
        var comStatParam = {
            "objectId": isBuy() ? "100077" : "100109",
            "actionId": "3",
            "i_entrust_bs": isBuy() ? "1" : "2", // 交易方向( 1,买入 2,卖出)
            "i_stock_code": stockCode, // 股票代码
            "i_stock_name": stock_info.stockName, // 股票名称
            "i_entrust_prop": "", // 委托属性
            "i_exchange_type": stock_info.exchange_type, // 交易市场
            "i_entrust_price": stockPrice, // 选择后的价格
            "i_entrust_amount": stockNum, // 委托数量
        }

        var cust_code = userInfo.cust_code;	//客户代码
        var fund_account = userInfo.fund_account;	//资产账户
        var branch_no = userInfo.branch_no;	//分支机构
        var sessionid = userInfo.session_id;
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var exchange_type = stock_info.exchange_type;
        var stock_account = stock_info.stock_account;
        var stock_code = stockCode;
        var entrust_price = stockPrice;
        var entrust_amount = stockNum;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "entrust_prop": entrust_prop,
            "exchange_type": exchange_type,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "entrust_amount": entrust_amount,
            "relation_name": stock_info.relationName,
            "relation_tel": stock_info.relationTel,
            "prop_seat_no": stock_info.propSeatNo,
            "cbpconfer_id": stock_info.cbpconferId,
            "reduction_type": stock_info.reductionType,
            "isSellOrder":!isBuy(),
        };
        appropriate.placeOrder(comStatParam, param, tipStr, function (instr_batch_no) {
            service_stock.blockTradeBuy(param, getStockBuyCallBack, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            if (isBuy()) {
                stock_info.create_by = stock_info.create_by || $.getUUID();
                appropriate.function399932(stock_info)
            }
            $.showPreloaders("请等待...");
        }, !isBuy(), "委托确认");
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        $.hidePreloader();
        var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                $.alert(tipStr);
                stock_info.entrust_no = results[0].entrust_no;
                if (isBuy()) {
                    appropriate.function399932(stock_info)
                }
                clearBuyMsg();
                // 隐藏分时图
                stock_html.hqxltb.removeClass("sl").addClass("xl");
                stock_html.hqCanvas.hide();
                setStockInfo("stockCode", "");// 股票价格
                $(_pageId + " #stockCode").removeClass("wato");
            }
        } else {
            $.alert(tipStr);
            clearBuyMsg();
            // 隐藏分时图
            stock_html.hqxltb.removeClass("sl").addClass("xl");
            stock_html.hqCanvas.hide();
            setStockInfo("stockCode", "");// 股票价格
            $(_pageId + " #stockCode").removeClass("wato");
        }
    }

    /**
     * 查询股东账号
     */
    function queryStockAccountList() {
        stockAccountList = [];
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
            "account_type": userInfo._loginClass,
        };
        service_common.queryStockAccountList(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        stockAccountListCallBack(results);
                        stockAccountList = results;
                    } else {
                        $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                    }
                } else {
                    $.alert(data.error_info);
                    $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                }
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }, "errorFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }
        });
    }

    /*
     * 股东账号查询回调、联动后筛选出对应市场的股东账号回调
     */
    function stockAccountListCallBack(results, type, typeAccount) {
        var html = "";
        if (type) {
            for (var i = 0; i < results.length; i++) {
                if (results[i].exchange_type == type) {
                    var mainFlag = results[i].main_flag;
                    mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                    html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                    html += '<a href="javascript:void(0);" style="padding-left:0.20rem;">';
                    html += '' + results[i].exchange_type_name + '<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                    html += '</li>';
                }
            }
        } else {
            for (var i = 0; i < results.length; i++) {
                var mainFlag = results[i].main_flag;
                mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                html += '<a href="javascript:void(0);" style="padding-left:0.20rem;">';
                html += '' + results[i].exchange_type_name + '<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                html += '</li>';
            }
        }
        $(_pageId + " #account_list").html(html);
        if ($(_pageId + " #account_list li").length > 5) {
            $(_pageId + " #account_list").css({ "height": "2.2rem", "overflow-y": "scroll" });
        } else {
            $(_pageId + " #account_list").css({ "height": (($(_pageId + " #account_list li").length) * 0.44) + "rem" });
        }
        //输入代码后，默认筛选出对应的股东账号，并勾选
        if (type && typeAccount) {
            $(_pageId + "#account_list li").forEach(function (item, index) {
                var stockAccount = $(item).attr("stock_account");
                var exchangeType = $(item).attr("exchange_type");
                if (typeAccount == stockAccount && type == exchangeType) {
                    $(item).addClass("active");
                }
            });
        }
        // 显示隐藏股东账号选择框
        $.bindEvent($(_pageId + " #account"), function (e) {
            if ($(_pageId + "#account_list li") && $(_pageId + "#account_list li").length > 0) {
                $(_pageId + "#account_list").slideToggle();
            } else {
                $(_pageId + "#account_list").hide();
            }
            e.stopPropagation();
        });
        // 股东账号选择
        $.bindEvent($(_pageId + "#account_list li"), function (e) {
            $(_pageId + "#account_list li").removeClass("active");
            $(this).addClass("active");
            var name = $(this).attr("stock_account") + " " + $(this).attr("exchange_type_name");
            $(_pageId + "#account p").html(name);
            stock_info.stock_account = $(this).attr("stock_account");
            stock_info.exchange_type = $(this).attr("exchange_type");
            $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
            $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
            $(_pageId + "#account_list").hide();
            if (stock_info.stockCode) {
                // getStockList(stock_info.stockCode);
                queryMaxAmount(stock_info.stockCode);
            }
            handleInput();
            e.stopPropagation();
        });
    }


    /**
     *
     */
    function clearBuyMsg() {
        clearMaxNumber = false;
        _PageParam = {};
        stock_info = ioitStock();
        if (stock_html) {
            //清空canvas图
            $(_pageId + ".kcb_timeshare .row_01 strong").text("");
            $(_pageId + ".kcb_timeshare .row_01 em").text("--").removeClass("agreen").removeClass("ared");
            $(_pageId + "#hqt").html("");
            hqKt.clearCanvasFunc(_pageId);
            hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10, 160);
            canvasJs.minLineFunc([{}], {});
            stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 股票名称
            stock_html.stockMarketType.html("");
            stock_html.stockMarketType.hide();
            setStockInfo("stockPrice", "");// 股票价格
            setStockInfo("stockNum", ""); // 股票数量
            setStockInfo("stockMaxAmount", "--");
            stock_html.upStop.text("--"); //涨停价
            stock_html.downStop.text("--");//跌停价
            stock_html.yesProfit.text("--");//昨收价
            stock_html.stockList.html("");
            stock_html.relationName.quzhi("");
            stock_html.relationTel.quzhi("");
            stock_html.propSeatNo.quzhi("");
            stock_html.cbpconferId.quzhi("");
            stock_html.stockPrice = $(_pageId + " #stockPrice");//还原科创板的价格框
            stock_html.stockMaxAmount = $(_pageId + " #maxNumber");
        }
        if (fifthOrder_timer != null) {
            window.clearInterval(fifthOrder_timer);
        }
        _fifthCallback = true;
        $(_pageId + "#reductionType").html('<em>请选择股份类别</em>');
        $(_pageId + "#account_list li").removeClass("active");
        $(_pageId + "#account p").attr("stock_account", "");
        $(_pageId + "#account p").attr("exchange_type", "");
        $(_pageId + "#account p").html('<em style="color: #ccc;">请选择股东账号</em>');
        stockAccountListCallBack(stockAccountList);
        $(_pageId + " .xj .input_value").show();
        $(_pageId + " .xj").show();
        $(_pageId + " #maxNumber").show();
        $(_pageId + " #maxNumber").quzhi("--");//清空限价的数量框
        $(_pageId + " #stockPrice").quzhi("");//清空限价的价格框
        $(_pageId + "#enable_balance").html("--");
        $(_pageId + ".input_text .logoStyle").hide();
        $(_pageId + ".input_text .logoStyle").removeClass("kcbCss").removeClass("cdrCss");
        $(_pageId + ".input_text .logoStyle").text("");
        stock_info.isHq = false;
        stock_info.chaVentureFlag = "";
        stock_info.issuspend = "";
        $(_pageId + " #submitOrder").addClass("btn-disable");
        $.closeModal(".picker-modal.modal-in");
        // 清除个股详情页面带过来的参数
        var paramMap = sessionStorage.getItem("_curPage");
        if (paramMap) {
            if (typeof paramMap == 'string') {
                paramMap = JSON.parse(paramMap);
            }
            if (paramMap.params) {
                delete paramMap.params.code;
                delete paramMap.params.market;
                delete paramMap.params.exchange_type;
                delete paramMap.params.stock_account;
                delete paramMap.params.price;
                delete paramMap.params.name;
                delete paramMap.params.num;
                delete paramMap.params.entrust_bs;
                delete paramMap.params.isHold;
                sessionStorage.setItem("_curPage", JSON.stringify(paramMap));
            }
        }
    }

    function dataDestroy() {
        common.removeKeybord($(_pageId + " #relationName")[0]);
        commonFunc.clearCheckTradeTimer();
        reductionTypeFunc = null;
        stockAccountList = [];
        entrust_bs = null;
        entrust_prop = null;
        _orderType = null;
        $(_pageId + "#account_list").html("");
        $(_pageId + "#account_list").hide();
        $(_pageId + " #stockCode").quzhi("");
        $(_pageId + " #stockCode").removeClass("wato");
        _stockCode = "";
        clearBuyMsg();
        if (position_timer != null) {
            window.clearInterval(position_timer);
        }
        if (stock_html) {
            stock_html.hqxltb.removeClass("sl").addClass("xl");
            stock_html.hqCanvas.hide();
        }
        position_timer = null;
        stock_info = null;
        stock_html = null;
        if (keyboard) {
            keyboard.keyDestroy();
        }
        // 退出页面后，销毁弹框
        $("#singleIConfirmNew").remove();
        $("#newTradingTipsBox2").remove();

    }


    var base = {
        "dataInit": dataInit,
        "elementBindEvent": elementBindEvent,
        "clearBuyMsg": clearBuyMsg,
        "dataDestroy": dataDestroy,
    };
    module.exports = base;
});
