/**
 * 债券现券交易-历史委托
 */
define('trade/scripts/blockTrade/blockQueryToday.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var _pageId = "#blockTrade_blockQueryToday ";
    var userInfo = null;
    var VIscroll = require("vIscroll");
    var vIscroll = { "scroll": null, "_init": false };		//上下滑动
    var queryType = 'entrust'; //查询内容
    var isGoDetail = false;
    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        var paramMap = $.getPageParam("param");
        if (paramMap && typeof (paramMap) == "object") {
            if (Object.keys(paramMap).length > 0) {
                queryType = paramMap.param;
            }
        } else {
            queryType = paramMap;
        }
        var trade_query_nav_type = $.getSStorageInfo("block_trade_query_nav_type");
        if (trade_query_nav_type) {
            queryType = trade_query_nav_type;
        }
        if (queryType === "entrust") {
            $(_pageId + ".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
        } else {
            $(_pageId + ".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }
    function load() {
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
        var mianHeight = common.setMainHeight(_pageId, false);
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh && vIscroll.scroll.refresh();
        }
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            setTimeout(function () {
                $(_pageId + '.main').height(document.body.clientHeight - $(_pageId + ".header").height());
                $(_pageId + "#v_container_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height());
                $(_pageId + "#v_wrapper_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height());
                if (!vIscroll._init) {
                    initVIScroll();
                } else {
                    vIscroll.scroll.refresh && vIscroll.scroll.refresh();
                }
            }, 20);
        };
    }
    function backgroundInterface() {
        callsQuery();
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });

        //页面切换
        $.bindEvent($(_pageId + ".toggle_nav ul li"), function (e) {
            setTimeData();
            $.clearRequest();
            $(this).addClass("active").siblings().removeClass("active");
            // 设置tab切换
            if ($(_pageId + ".toggle_nav ul li").eq(0).hasClass('active')) {
                queryType = 'entrust';
            } else {
                queryType = 'deal';
            }
            $.setSStorageInfo("block_trade_query_nav_type", queryType);
            callsQuery();
        });
        //更多按钮
        $.bindEvent($(_pageId + ".nsb_sel_fixed_box"), function (e) {
            $.setSStorageInfo("block_trade_query_nav_type", queryType);
            isGoDetail = true;
            if (queryType === 'entrust') {//委托
                $.pageInit($.getCurrentPageObj().pageCode, "blockTrade/blockWTQueryHistory");
            }
        });
    }
    /**
     * 调用查询
     */
    function callsQuery() {
        $(_pageId + ".j-position-table").html("");
        setScrollHeight();
        $(_pageId + ".hasdatamore").hide();
        if (queryType === "entrust") {
            $(_pageId + ".btnSub3").html("更多历史委托记录");
            $(_pageId + ".btnSub4").html("更多历史委托记录");
            $(_pageId + ".nsb_sel_fixed_box").show();
            queryEntrust();
        } else {
            $(_pageId + ".nsb_sel_fixed_box").hide();
            queryDeal();
        }
    }
    function setScrollHeight() {
        // 设置滚动容器的高度
        $(_pageId + '.main').height(document.body.clientHeight - $(_pageId + ".header").height());
        $(_pageId + "#v_container_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height());
        $(_pageId + "#v_wrapper_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height());
    }
    /**
     * 委托查询
     */
    function queryEntrust() {
        $(_pageId + ".j-position-table").html("");
        $(_pageId + ".j-position-table").hide();
        $(_pageId + ".no_data_box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;

        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        service_stock.queryBlockTodayTrust(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "errorFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data_box").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh && vIscroll.scroll.refresh();
                    }
                },
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data_box").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh && vIscroll.scroll.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        $(_pageId + ".hasdatamore").hide();
        if (typeof (data) != "undefined" && data) {
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var html = "<table width='100%' border='0' cellspacing='0' cellpadding='0' class='fixed'><thead><tr><th>证券/时间</th><th>委托/成交价</th><th>委托/成交量</th><th>类型/状态</th></tr></thead><tbody>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i], i);
                    }
                    html += '</table>';
                    $(_pageId + ".main .j-position-table").html(html);
                    $(_pageId + ".hasdatamore").show();
                    $(_pageId + ".j-position-table").show();
                    $(_pageId + ".no_data_box").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .j-position-table tr"), function (e) {
                        setTimeData();
                        var selectIndex = $(this).attr("data-index");
                        var _loginClass = userInfo._loginClass || "0";//普通0  两融1
                        var toPage = "stock/stockDetails";
                        var param = {
                            'titleName': '委托详情',
                            'flag': '18',
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        if(_loginClass === "1"){
                            toPage = "credit/query/stockDetails";
                        }
                        $.pageInit("blockTrade/blockQueryToday", toPage, param);
                    });
                } else {
                    $(_pageId + ".hasdatamore").hide();
                    $(_pageId + ".no_data_box").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh && vIscroll.scroll.refresh();
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element, i) {
        var css = "";
        var css1 = "";
        var entrust_name = element.entrust_type_trans_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_red"
            }
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_blue"
            }
        } else {
            css = "";
        }
        if (element.entrust_type_name == "撤单") {
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "' class='" + css1 + "' id='" + element.entrust_no + "' stock_name='" + element.stock_name + "' stock_code='" + element.stock_code + "' entrust_price='" + element.entrust_price + "' entrust_amount='" + element.entrust_amount + "' business_amount='" + element.business_amount + "' cancel_flag='" + element.cancel_flag + "' entrust_name='" + entrust_name + "' exchange_type='" + element.exchange_type + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25 - 30) + ")'>" + element.stock_name + "</p>";
        eleHtml += "<p  style='font-size: 0.12rem!important;'>" + element.curr_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.entrust_price + "</p>";
        eleHtml += "<p>" + element.business_price + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.entrust_amount + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + common.getShowStr((element.entrust_name_new || entrust_name), '--', 1, 4) + "</p>";
        eleHtml += "<p>" + element.entrust_state_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal(search_type) {
        $(_pageId + ".j-position-table").html("");
        $(_pageId + ".j-position-table").hide();
        $(_pageId + ".no_data_box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        service_stock.queryBlockTodayTrade(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data_box").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh && vIscroll.scroll.refresh();
                    }
                }
            });

    }
    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        // $(_pageId + ".hasdatamore").hide();
        if (typeof (data) != "undefined" && data != null) {
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var html = "<table width='100%' border='0' cellspacing='0' cellpadding='0' class='fixed'><tr><th>证券/时间</th><th>成交价/成交量</th><th>成交金额</th><th>类型/状态</th></tr>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    html += '</table>';
                    $(_pageId + ".main .j-position-table").html(html);
                    // $(_pageId + ".hasdatamore").show();
                    $(_pageId + ".j-position-table").show();
                    $(_pageId + ".no_data_box").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .j-position-table tr"), function (e) {
                        setTimeData();
                        var selectIndex = $(this).attr("data-index");
                        var param = {
                            'titleName': '成交详情',
                            'flag': '19',
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        $.pageInit("blockTrade/blockQueryToday", "stock/stockDetails", param);
                    });
                } else {
                    // $(_pageId + ".hasdatamore").hide();
                    $(_pageId + ".no_data_box").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh && vIscroll.scroll.refresh();
        }
    }
    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element, i) {
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_type_trans_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
        } else {
            css = "";
        }
        if (element.real_type_name == "撤单") {
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25 - 30) + ")'>" + element.stock_name + "</p>";
        eleHtml += "<p>" + (element.business_time === "0"?"--":element.business_time)+ "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.business_price + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.business_balance + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + common.getShowStr((element.entrust_name_new || entrust_name), '--', 1, 4) + "</p>";
        eleHtml += "<p>" + element.real_status_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }
    /**
     * 初始化上下滑动组件
     */
    function initVIScroll() {
        if (!vIscroll._init) {
            var config = {
                "isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
                "visibleHeight": $(window).height() - $(_pageId + ".header").height(), // 滚动组件的高度
                "container": $(_pageId + " #v_container_funds_jj"),
                "wrapper": $(_pageId + " #v_wrapper_funds_jj"),
                "downHandle": function () {				//下拉获取上一页数据方法
                    callsQuery(); // 模拟查询接口数据操作
                },
                "upHandle": function () {
                },
                "wrapperObj": null
            };
            $(_pageId + ".no_data_box").height($(window).height() - $(_pageId + ".header").height());
            vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
            vIscroll._init = true; 						//尽量只初始化一次，保持性能
            setTimeout(function () {
                // 绑定截长屏分享
                $.bindEvent($(_pageId + ".share_customer"), function (e) {
                    var scroll = vIscroll.scroll.getWrapperObj();
                    var topFixedHeight = $(_pageId + 'header').height() + $(_pageId + '.date_filter').height();
                    commonFunc.longScreenShot({
                        scroll: scroll,
                        topFixedHeight: topFixedHeight,
                        offsetHeight: Math.max(scroll.scrollerH, $(_pageId + '.main').height()) + topFixedHeight,
                        // 最大可滚动距离
                        maxScrollY: scroll.maxScrollY > 0 ? 0 : -(scroll.maxScrollY - scroll.minScrollY),
                    });
                });
            }, 200);

        } else {
            vIscroll.scroll.refresh && vIscroll.scroll.refresh();
        }
        $(_pageId + ".visc_pullUp").css("display", "none");
    }
    // 保持日期控件数据
    function setTimeData() {
        $.setSStorageInfo("block_trade_query_nav_type", queryType);
    }
    /**
     * 销毁
     */
    function destroy() {
        if (isGoDetail) {
            isGoDetail = false;
        } else {
            $(_pageId + ".j-position-table").html("");
            $(_pageId + ".top_title .top_nav").hide();
            $.setSStorageInfo("block_trade_query_nav_type", '');
            if (vIscroll._init) {
                vIscroll.scroll.refresh && vIscroll.scroll.refresh();
            }
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
