/**
 * 大宗交易首页
 */
define('trade/scripts/blockTrade/index.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var service_stock = require("service_stock");
    var _pageId = "#blockTrade_index ";
    var pagecode = "blockTrade/index";

    /**********
     * 初始化
     */
    function init() {
        window.onresize = function () {
            common.setMainHeight(_pageId, false);
        };
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        // 信用页面过来时，不展示提示信息
        var pageParam = $.getPageParam() || {};
        if(pageParam.param === "credit" || (pageParam.param && pageParam.param.param === "credit")){
            $(_pageId + ".block-trade-readme").hide();
            $.setSStorageInfo("block_account_type",'1');
            common.switchingCurUser("1");
        }else{
            $(_pageId + ".block-trade-readme").show();
            $.setSStorageInfo("block_account_type",'0');
            common.switchingCurUser("0");
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + "header .icon_back"), function () {
            commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                $.pageBack();
            });
        });
        // 主页菜单事件绑定
        $.bindEvent($(_pageId + ".n_sel_list .n_list_con li"), function (e) {
            var type = $.getSStorageInfo("block_account_type");;
            var paramMap = {};
            var param = $(this).attr("param"); // 获取跳转页面参数
            var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
            if (param) {
                paramMap.param = param;
            }
            //登录的情况
            if (common.isTradeLogin(type)) {
                $.pageInit("blockTrade/index", topage, { "param": paramMap });
            } else {//没有登录的情况
                commonFunc.login($.getCurrentPageObj().pageCode, topage, { "param": paramMap }, {
                    "topage": topage,
                    "param": paramMap
                });
            }
            e.stopPropagation();
            e.preventDefault();
        });
        // 跳转 北交所
        $.bindEvent($(_pageId + "#go_bjs"), function () {
            $.pageInit("blockTrade/index", "bjs/index");
        });
        // 跳转 新三板
        $.bindEvent($(_pageId + "#go_thrid"), function () {
            var _jurisdiction = commonFunc.getJurisdiction();
            var topage = "third/order/order";
            var param = {
                isGoBack:'1'
            };
            //本地没有缓存权限，则同步查询一次
            if (!_jurisdiction.IsQuerySuccess) {
                commonFunc.setJurisdiction(null, function (data) {
                    if (data.IsQuerySuccess != false && data.three_board_rights != "1") {//有返回、无权限
                        topage = "third/thirdJurisdiction";
                    }
                    $.pageInit("account/index", topage,param);
                });
                return;
            } else if (_jurisdiction.three_board_rights != "1") { //无权限
                topage = "third/thirdJurisdiction";
            }else{
                topage = "third/order/order";
            }
            $.pageInit("blockTrade/index", topage, param);
        });
        // 跳转 债券现券
        $.bindEvent($(_pageId + "#go_bond"), function () {
            $.pageInit("blockTrade/index", "bond/index");
        });
    }

    /**
     * 数据重置
     */
    function destroy() {
        service_stock.destroy();
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
}

);
