/**
 * 债券现券交易-匹配买入
 */
define('trade/scripts/blockTrade/intentionSell.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var blockOrder = require("blockOrder");
    var common = require("common");
    var _pageId = "#blockTrade_intentionSell ";
    var _pageCode = "blockTrade/intentionSell";
    var iscrollUtils = require("iscrollUtils");
    var mainHeight = null;
    var _load = false;
    var height_table = null;
    /**
     * 初始化
     */
    function init() {
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        mainHeight = common.setMainHeight(_pageId, false);
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        _load = true;
        height_table = mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".lr").outerHeight(true);
        heightChange();
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }
    function backgroundInterface() {
        var entrust_prop = $(_pageId + ".toggle_nav .active").attr("entrust-prop");
        var entrust_bs = $(_pageId + ".toggle_nav .active").attr("entrust-bs");
        blockOrder.dataInit(_pageId, entrust_bs, entrust_prop);
        blockOrder.elementBindEvent();
    }

    /*
     * 进入二级菜单隐藏tabbar有时不是同步导致高度获取不对
     */
    function heightChange() {
        $(_pageId + ".ce_btn div.order").css({ "padding-top": "3px", "line-height": "14px", "width": $(_pageId + ".ce_btn a").width(), "display": "inline-block" });
        $(_pageId + ".ce_btn #total").css("display", "inline-block");
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //页面切换
        $.bindEvent($(_pageId + ".toggle_nav ul li"), function (e) {
            $.clearRequest();
            if(!$(this).hasClass('active')){
                var page = $(this).attr("to-page").replaceAll("_", "/");
                $.pageInit(_pageCode,page,{"history":true},"left",true);
            }
        });
    }

    /**
     * 数据重置
     */
    function destroy() {
        blockOrder.dataDestroy();
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
