/**
 * 债券现券交易-回复
 */
define('trade/scripts/bond/consult/consultQueryDeclare.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var vIscrollHeight = null;
    var service_stock = require("service_stock");
    var keyboard = require("keyboard");
    var _pageId = "#bond_consult_consultQueryDeclare ";
    var userInfo = null;
    var stock_code = "";
    var stock_num = "";
    var stock_direction = "";
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var isGoDetail = false;

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        if (keyboard) {
            keyboard.keyInit();
        }
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        userInfo = common.getCurUserInfo();
        $(_pageId + ".no_more_data").hide();
        var cbpconfer_id = $.getSStorageInfo("consultDeclare_cbpconfer_id");
        if(cbpconfer_id){
            $(_pageId + "#stockCode").quzhi(cbpconfer_id);
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mianHeight - $(_pageId + ".tab_nav").height() - $(_pageId + ".netVote_box2").height();
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }
    function backgroundInterface() {
        queryReply(); // 查询
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        $.bindEvent($(_pageId + " #search"), function (e) {
            queryReply();
        });
        $.bindEvent($(_pageId + " #queryDeclare"), function (e) {
            $.pageInit("bond/consult/consultReply", "bond/consult/consultQueryDeclare");
        });
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });
        // 点击其他位置关闭键盘
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + "#account_list").hide();
            e.stopPropagation();
        });
    }

    /**
     * 查询
     */
    function queryReply() {
        $(_pageId + ".c-list").html("");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var cbpconfer_id = $(_pageId + "#stockCode").val();
        $.setSStorageInfo("consultDeclare_cbpconfer_id", cbpconfer_id);
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cbpconfer_id": cbpconfer_id,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        // 每次查询前,先将暂无数据隐藏
        $(_pageId + ".no_data").hide();
        // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
        service_stock.queryBondReply(param, queryBondReplyCallback,
            { // 传给接口的json格式数据            
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /**
     * 查询回调
     */
    function queryBondReplyCallback(data) {
        console.log(data);
        if (typeof (data) != undefined && typeof (data) != null) {
            $(_pageId + ".c-no-more-data").hide();
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var html = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryReplyHTML(results[i], i);
                    }
                    $(_pageId + ".c-list").html(html);
                    $(_pageId + ".c-no-more-data").show();
                    $(_pageId + ".c-no-data-box").hide();
                    $(_pageId + ".c-no-search-data-box").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".c-list .c-list-item"), function (e) {
                        var selectIndex = $(this).attr("data-index");
                        var _loginClass = userInfo._loginClass || "0";//普通0  两融1
                        var toPage = "stock/stockDetails";
                        var param = {
                            'titleName': '申报信息详情',
                            'flag': '17',
                            "cbpconfer_id": $(_pageId + "#stockCode").val(),
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        if(_loginClass === "1"){
                            toPage = "credit/query/stockDetails";
                        }
                        $.pageInit("bond/consult/consultReply", toPage, param);
                    });
                } else {
                    $(_pageId + ".c-list").html("");
                    $(_pageId + ".c-no-more-data").hide();
                    $(_pageId + ".visc_pullUp").hide();

                    var _stock = $(_pageId + "#stockCode").val();
                    if(_stock.trim().length <= 0){
                        $(_pageId + ".c-no-data-box").show();
                        $(_pageId + ".c-no-search-data-box").hide();
                    }else{
                        $(_pageId + ".c-no-data-box").hide();
                        $(_pageId + ".c-no-search-data-box").show();
                    }
                }
            }
            else {
                $.alert(data.error_info);
            }
        }else {
            $.alert("查询失败");
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 查询HTML生成
     */
    function queryReplyHTML(element, i) {
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_bs_name;
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "c-icon-red";
            entrust_name = "买";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "c-icon-blue";
            entrust_name = "卖";
        } else {
            css = "";
        }
        var eleHtml = '<li class="c-list-item ' + (i !== 0?'mt10':'') + '" data-index=' + i + '>\
            <p class="c-title border-bottom c-flex c-aic">\
                <span class="' + css + ' c-mr-6">' + common.getShowStr(entrust_name,'--',0,0) + '</span>\
                <span class="c-item-label c-mr-6">约定号</span>\
                <span class="c-item-value">' + common.getShowStr(element.cbpconfer_id,'--',0,0) + '</span>\
            </p>\
            <div class="c-content">\
                <div class="c-flex c-mb-6">\
                    <div class="c-flex c-f-1 c-mr-50">\
                        <span class="c-item-label">证券名称</span>\
                        <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.stock_name,'--',0,0) + '</span>\
                    </div>\
                    <div class="c-flex c-f-1">\
                        <span class="c-item-label">证券代码</span>\
                        <span class="c-item-value c-f-1 c-tar" style="font-size:"' + $.getTransformScaleFontSize(element.stock_name, 14, 80) + 'px">' + common.getShowStr(element.stock_name,'--',0,0) + '</span>\
                    </div>\
                </div>\
                <div class="c-flex c-mb-6">\
                    <div class="c-flex c-f-1 c-mr-50">\
                        <span class="c-item-label">委托价格</span>\
                        <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_price,'--',0,0) + '</span>\
                    </div>\
                    <div class="c-flex c-f-1">\
                        <span class="c-item-label">委托数量</span>\
                        <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.entrust_amount,'--',0,0) + '</span>\
                    </div>\
                </div>\
                <div class="c-flex">\
                    <span class="c-item-label">交易所执行编号</span>\
                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.exec_id,'--',0,0) + '</span>\
                </div>\
                <div class="c-flex">\
                    <span class="c-item-label">转发信息状态</span>\
                    <span class="c-item-value c-f-1 c-tar">' + common.getShowStr(element.bondtrade_trans_status_name,'--',0,0) + '</span>\
                </div>\
            </div>\
        </li>';
        return eleHtml;
    }
    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryReply()
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
                $(_pageId + " .c-no-data-box").height(scrollOptions.scrollerHeight + 1);
                $(_pageId + " .c-no-search-data-box").height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        if(isGoDetail){
            isGoDetail = false;
        }else{
            $(_pageId + "#stockCode").quzhi("");
            $.setSStorageInfo("consultDeclare_cbpconfer_id", "");
        }
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
        $(_pageId + ".c-list").html("");
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".main .cancel_order").html("");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
