/**
 * 债券现券专区首页
 */
define('trade/scripts/bond/index.js', function (require, exports, module) {
  var gconfig = $.config;
  var global = gconfig.global;
  var common = require("common");
  var commonFunc = require("commonFunc");
  var service_stock = require("service_stock");
  var service_common = require("service_common");
  var _pageId = "#bond_index ";
  var pagecode = "bond/index";
  var nativePluginService = require("nativePluginService");

  /**********
   * 初始化
   */
  function init() {
    common.switchingCurUser("0");
    window.onresize= function(){
        setTimeout(function(){
            common.setMainHeight(_pageId, false);
        },30);
    };
  }

  function load() {
    var mianHeight = common.setMainHeight(_pageId, false);
  }

  /**
   * 事件绑定
   */
  function bindPageEvent() {
    // 返回按钮事件
    $.bindEvent($(_pageId + "header .icon_back"), function () { 
      commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
          $.pageBack();
      });
    });
    // 收起展开按钮
    $.bindEvent($(_pageId + ".arrow"), function () { 
        var aniClass = $(this).attr("animation");
        var isOpen = $(this).hasClass("open");
        if(isOpen){
            $(_pageId + aniClass).hide();
            $(this).removeClass("open").addClass("close");
        }else{
            $(_pageId + aniClass).show();
            $(this).removeClass("close").addClass("open");
        }
    });

    $.bindEvent($(_pageId + ".icon"), function () { 
        var type = $(this).attr("type");
        var msg = '';
        if(type === "xscj"){
            msg += "<p style='text-indent: 0.32rem;text-align:left;'>协商成交是指债券投资者之间通过协商等方式达成债券交易意向，并向交易系统申报，经交易系统确认成交的交易方式。交易一方将协商一致的交易要素通过交易系统发送给交易对手方，经交易对手方确认后，由交易系统确认成交。</p>";
            msg += "<p style='text-indent: 0.32rem;text-align:left;'>协商成交的交易时间为每个交易日的9:00至11:30、13:00至15:30。</p>";
        }else{
            msg += "<p style='text-indent: 0.32rem;text-align:left;'>匹配成交是指交易系统按照价格优先、时间优先的原则以及交易所债券交易新规，对债券交易申报自动匹配成交并实行多边净额结算的交易方式。</p>";
            msg += "<p style='text-indent: 0.32rem;text-align:left;'>匹配成交采用集合匹配和连续匹配两种方式。集合匹配是对规定时间内接受的交易申报一次性集中匹配的成交方式。连续匹配是对接受的交易申报逐笔连续匹配的成交方式。</p>";
            msg += "<p style='text-indent: 0.32rem;text-align:left;'>每个交易日的 9:15 至 9:25 为开盘集合匹配时间，9:30 至 11:30、13:00 至 15:30 为连续匹配时间。</p>";
        }
        common.singleIConfirm("解释说明",msg,function(){ },"我知道了");
      });
    // 主页菜单事件绑定
    $.bindEvent($(_pageId + ".n_sel_list .n_list_con li"), function (e) {
      var type = $(this).attr("type");
      var paramMap = {};
      var param = $(this).attr("param"); // 获取跳转页面参数
      var topage = $(this).attr("to-page").replaceAll("_", "/"); // 获取跳转的页面
      if (param) {
        paramMap.param = param;
      }
      //登录的情况
      if (common.isTradeLogin(type)) {
        $.pageInit("bond/index", topage, { "param": paramMap });
      } else {//没有登录的情况
        commonFunc.login($.getCurrentPageObj().pageCode, topage, { "param": paramMap }, {
          "topage": topage,
          "param": paramMap
        });
      }
      e.stopPropagation();
      e.preventDefault();
    });
  }

  /**
   * 数据重置
   */
  function destroy() {
    service_stock.destroy();
  }

  var base = {
    "init": init,
    "load": load,
    "bindPageEvent": bindPageEvent,
    "destroy": destroy
  };
  module.exports = base;
}

);
