/**
 * 债券现券交易下单
 */
define('trade/scripts/bond/order/bondOrder.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var appropriate = require("appropriate");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var service_hq = require("service_hq");
    var service_stock=require("service_stock");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var keyboard = require("keyboard");
    var project = require("project");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var fifthOrder_timer = null;//五档行情定时器
    var position_timer = null;
    var _pageId = null;
    var _market = null;
    var _orderType = null;
    var clearMaxNumber = false;
    // 一级债券类型
    var bondTypeArr = [6, 14, 21, 22, 23, 24, 25, 26, 27, 30];
    var bondTypeSecond = project.constants.bondTypeSecond;
    // 新规债券上海市场二级类型
    var secondTypeArrBySH = project.constants.secondTypeArrBySH;
    // 新规债券深圳市场二级类型
    var secondTypeArrBySZ = project.constants.secondTypeArrBySZ;
    //市价委托的数据
    var market_html_data = {
        "SH": [
            {"name": "限价委托", "id": "0"},
            {"name": "对手方最优价格", "id": "70"},
            {"name": "本方最优价格", "id": "68"},
            {"name": "最优五档即时成交剩余撤销", "id": "64"},
            {"name": "最优五档即时成交剩余转限价", "id": "62"},
        ],
        "SZ": [
            {"name": "限价委托", "id": "0"},
            {"name": "对手方最优价格", "id": "70"},
            {"name": "本方最优价格", "id": "68"},
            {"name": "即时成交剩余撤销", "id": "4"},
            {"name": "最优五档即时成交剩余撤销", "id": "64"},
            {"name": "全额成交或撤销委托", "id": "66"},
        ]
    };
    var _PageParam = {};
    var orderName = { // 委托名称
        "1": "委托买入",
        "2": "委托卖出"
    };
    //0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
    var _exchange = {
        "0": "0", "2": "0", "3": "0", "4": "0", "5": "0", "6": "0", "7": "0", "8": "0",
        "1": "1",
        "9": "2", "11": "2", "12": "2", "13": "2", "14": "2", "15": "2", "16": "2",
        "10": "3",
        "17": "4",
        "18": "0", "19": "0", "21": "0", "22": "0", "23": "0", "24": "0", "64": "0",
        "20": "2", "25": "2", "26": "2", "27": "2", "30": "2", "65": "2", "66": "2",
        "K": "2"//科创板
    };
    var _stockCode = null;
    var _callback = true;
    var _fifthCallback = true;
    var _queryHolding = false;
    var _initScroller = null;
    var bond_repurchase_flag = null;//国债回购标志
    var fund_used_days = null;//实际占款天数
    var is_delisting = null;  //退市整理期股票标志  为1是为退市整理期股票
    var delisting_msg = null;  //退市提示语
    var notice_no = null;//系统提示信息 为4时，显示弹框
    var notice_info = null;//系统提示信息
    var cdrProtocolSign = require("cdrProtocolSign");
    var hqKt = require("minLines");
    var canvasJs = require("canvasJs");
    var stockAccountList = [];
    var entrustWayFunc = null;
    //  var queryStockHqFlowNo;

    var stockcode_entrust_info = {// 下单股票委托信息
        hight_amount: 0,// 限价委托数量上限 默认0 无上限
        market_high_amount: 0// 市价委托数量上限 默认0 无上限
    };
    var pageGlobal = {
        "holdData": "",
        "stockType26100": ["6","8","14","19","21","22","23","24","25","26","27","30"]
    };

    /**
     * 设置股票对象是信息参数
     */
    function ioitStock() {
        var stockInfo = {
            "isHq": false,
            "stockCode": "", // 股票代码
            "stockName": "", // 股票名称
            "stockPrice": "",// 股票价格
            "stockNum": "",
            "upStop": 0, //涨停价
            "downStop": 0,//跌停价
            "stockMaxAmount": 0,//股票最大数
            "price_step": 0.01, // 步长
            "price_digit": 3, // 小数点位数
            "lot_size": 100, //每手数量
            "stock_type": "",//股票类型
            "stock_market": "",//市场代码
            "gear_one": false,//是否启动五档
            "exchange_type": "",//交易市场（交易后台）
            "stock_account": "",// 股东账号
            "market_price": false, // 是否市价委托
            "delist_info": "",// 退市提示语
            "delist_flag": "",//是否提示标示
            "stockType": "",//类型
            "isBond": false,//是否为债券
            "isThirdBoard": false, //是否为三板股票
            "bond_cash": null, // 是否是债券现券交易支持的债券分类
            "isQueryMaxAmount": true
        };
        return stockInfo;
    }

    function initHtml() {
        stock_html = {
            "stockCode": $(_pageId + " #stockCode"), // 股票
            "stockName": $(_pageId + " #stockCode").next("span"), // 股票名称
            "stockPrice": $(_pageId + " #stockPrice"),// 股票价格
            "stockNum": $(_pageId + " #stockNum"), // 股票数量
            "upStop": $(_pageId + " #up_stop"), //涨停价
            "downStop": $(_pageId + " #down_stop"),//跌停价
            "stockMaxAmount": $(_pageId + "#maxNumber"),//股票最大数
            "buyGear": $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
            "sellGear": $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
            "total": $(_pageId + " #total"),// 计算金额显示
            "market_div": $(_pageId + " #entrustWay"), // 委托方式
            "market_p": $(_pageId + " #entrustWay p"),
            "hqCanvas": $(_pageId + " .kcb_timeshare"),
            "hqxltb": $(_pageId + " .hqxltb i"),
            "stockList": $(_pageId + " #stock_list"),// 股票下拉列表
            "stockMarketType": $(_pageId + " .ipt_market")
        }
    }


    /**
     * 数据初始化
     */
    function dataInit(pageId, orderType, market, initScroller) {
        $(pageId + ".position_div thead th").each(function (idx, item) {
            var zoom = 1;
            $(item).css({"zoom": zoom, "line-height": 0.2 / zoom + "rem;"});
        });
        $(pageId + ".position_div thead th").each(function (idx, item) {
            var zoom = $.getTransformScale($(item).text(), 14, ($(window).width()) * 0.25 - 15)
            $(item).css({"zoom": zoom, "line-height": 0.2 / zoom + "rem;"});
        });
        _initScroller = initScroller;
        _pageId = pageId;
        _PageParam = $.getPageParam() || {};
        if (keyboard) {
            keyboard.keyInit(null, function () {
                $(_pageId + " input#kcbStockPrice").triggerFastBlur();
                $(_pageId + " input#stockPrice").triggerFastBlur();
            });
        }
        userInfo = common.getCurUserInfo();
        _orderType = orderType;
        stock_info = ioitStock();
        initHtml();
        _market = market;
        _stockCode = null;
        commonFunc.initCheckTradeTimer();
        var stockCode = $.getPageParam("code");
        // 查询个股行情
        if (stockCode) {
            $(_pageId + " #stockCode").removeClass("C100");
            $(_pageId + " #stockCode").quzhi(stockCode);
            var market = $.getPageParam("market");
            var exchange_type = $.getPageParam("exchange_type");
            stock_info.stock_account = $.getPageParam("stock_account");
            stock_info.exchange_type = exchange_type;
            getStockList(stockCode, market, exchange_type);
        } else {
            hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10, 160);
            canvasJs.minLineFunc([{}], {});
        }
        // if (_market) marketPrice();
        queryHolding();
        if (!isBuy()) {
            queryStockAccountList();
        }
    }

    function isBuy() {
        if (_orderType == "1") {
            return true;
        } else {
            return false;
        }
    }

    /**
     * 获取股票信息
     * @param {Object} param 对应id名的值
     * @param {Object} newest 是否不同步
     */
    function getStockInfo(param, newest) {
        if (stock_html) {
            var data = stock_html[param].quzhi();
            //		var data = stock_html[param].val() || stock_html[param].text();
            if (newest && stock_info) {
                if (!data || data == "--") {
                    stock_info[param] = 0;
                } else {
                    stock_info[param] = data;
                }
            }
            return data;
        } else {
            return '';
        }
    }

    /**
     * 设置股票信息的值 可以为对象
     * @param {Object} key 输入字符串支持单个，输入对象支持全部
     * @param {Object} value 只支持单个字符串的值
     * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
     */
    function setStockInfo(key, value, newest) {
        if (stock_html) {
             // 对新规深债限价显示特殊处理,小数点三位,不四舍五入
             if(key == 'stockPrice'){
                if(secondTypeArrBySZ.indexOf(stock_info.second_type) >-1){
                    value = (parseInt((+value)*1000) / 1000).toFixed(3) ;
                }
            }
            stock_html[key].quzhi(value);
            if (key == "stockName") {
                //股票名称长度过长缩放
                var maxWidth = (stock_html[key].parent().width() / 2) - 6;
                var zoomValue = $.getMaxFontSize(value, "0.16rem", maxWidth);
                stock_html[key].css({
                    "transform": "scale(" + zoomValue + ")",
                    "white-space": "nowrap",
                    "transform-origin": "left center"
                });
            }
            //		stock_html[key].val(value);
            //		stock_html[key].text(value);
            if (newest && stock_info) {
                if (value == "--") {
                    value = 0;
                }
                stock_info[key] = value;
            }
        }
    }


    /**
     * 市价委托
     */
    function marketPrice() {
        var xj_input = $(_pageId + ".xj .input_value");//限价文本框
        var sj_input = $(_pageId + ".sj");//科创板市价文本框
        var market_list = $(_pageId + " #market_list");
        $.bindEvent($(_pageId + " .trade_form .value_btn a"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var _type = "";
            if ($(this).attr("class") != "current") {
                $(this).addClass("current").siblings().removeClass("current");
                if ($(this).text() == "限价委托") {
                    if (isKCB()) {
                        sj_input.hide();
                        stock_html.stockPrice = $(_pageId + " #stockPrice");
                        if (isBuy()) {//买入的时候需要切换最大可买
                            $(_pageId + " #maxNumber").show();
                            $(_pageId + " #kcbMaxNumber").hide();
                            stock_html.stockMaxAmount = $(_pageId + " #maxNumber");
                        }
                    }
                    _type = "限价";
                    xj_input.show();
                    market_list.hide();
                    stock_html.total.show();
                    stock_info.market_price = false;
                    var stockPrice = getStockInfo("stockPrice");
                    var stockNum = $(_pageId + " #stockNum").val();
                    isQueryMax(stockPrice);
                    totalValue(stockPrice, stockNum);
                } else {
                    if (isKCB()) {
                        sj_input.show();
                        stock_html.stockPrice = $(_pageId + " #kcbStockPrice");
                        if (isBuy()) {//买入的时候需要切换最大可买
                            $(_pageId + " #maxNumber").hide();
                            $(_pageId + " #kcbMaxNumber").show();
                            stock_html.stockMaxAmount = $(_pageId + " #kcbMaxNumber");
                        }
                    }
                    _type = "市价";
                    xj_input.hide();
                    market_list.show();
                    stock_info.market_price = true;
                    var id = stock_html.market_p.attr("id");
                    stock_html.market_div.attr("value", id);
                    bondJudgment();
                    if (stock_html) {
                        stock_html.total.text("");
                    }
                    if (!id) {
                        stock_html.market_p.html("<em style='color: #ccc;'>请选择委托方式</em>");
                        if (stock_info.isBond) {
                            stock_html.market_ul.hide();
                        } else {
                            stock_html.market_ul.show();
                        }
                    } else {
                        var stockNum = $(_pageId + " #stockNum").val();
                        if (isKCB()) {
                            stock_html.total.show();
                            var _price = getStockInfo("stockPrice");
                            isQueryMax(_price);
                            totalValue(_price, stockNum);
                        } else {
                            stock_html.total.hide();
                            isQueryMax(0.01);
                        }
                    }
                }

                //埋点
                var objectId = "", actionId = "";
                if (isBuy()) {
                    objectId = 100079;
                    actionId = 104;
                } else {
                    objectId = 100111;
                    actionId = 104;
                }
                common.comStat(objectId, 2, actionId, true, {"i_change_name": "委托类型", "i_change_to": _type});
            }
            slidingChange();
            e.stopPropagation();
        });

        $.bindEvent($(_pageId + " #market_list"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(this).find("ul").toggle();
            e.stopPropagation();
        });
    }

    /*
	 * 页面滑动组件高度变化
	 * 因为科创板的市价页面需要多展示一个限价价格
	 */
    function slidingChange() {
        var isflag = $(_pageId + ".sj").css("display") == "none" ? false : true;
        var _mainHeight = null;
        var _fundTableHeight = null;
        var mainHeight = common.setMainHeight(_pageId, false);
        height_table = mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".trade_main").outerHeight(true) - $(_pageId + ".fund_table2").css("margin-top").slice(0, -2);
        if (isflag) {
            _mainHeight = mainHeight + $(_pageId + ".sj").outerHeight(true);
            _fundTableHeight = height_table;
        }
        $(_pageId + " section.main").height(_mainHeight).css("overflow", "auto");
        if (_initScroller) {
            _initScroller(_fundTableHeight);
        }
    }

    /*
	 * 关于债券的判断
	 */
    function bondJudgment() {
        // if (stock_info.market_price) {
        //对债券做提示
        switch (stock_info.stockType) {
            case 6:
            case 21:
            case 22:
            case 23:
            case 24:
            case 14:
            case 25:
            case 26:
            case 27:
            case 30:
                // $.alert("债券品种不支持市价委托");
                stock_info.isBond = true;
                break;
        }
        //		if(stock_info.stockType == 6||stock_info.stockType == 21||stock_info.stockType == 22||stock_info.stockType == 23||stock_info.stockType == 24||stock_info.stockType == 14||stock_info.stockType == 25||stock_info.stockType == 26||stock_info.stockType == 27||stock_info.stockType == 30){
        //			$.alert("债券品种不支持市价委托");
        //		}
        // }
    }
    /*
	 * 关于沪市的股票或者基金判断
	 */
    function isSHstockOrFund() {
        var stocktypes = [9,10,11,12,16,20];
        if(stocktypes.indexOf(stock_info.stockType) > -1){
            return true;
        }
        return false;
    }


    /**
     *
     * @param {Object} stockPrice
     */
    function isQueryMax(stockPrice) {
        clearMaxNumber = false;
        if (stock_info && (isBuy() || !stock_info.exchange_type) && stock_info.stockCode && stockPrice && Number(stockPrice) != 0) {
            queryMaxAmount(stock_info.stockCode, true);
        }
    }

    /**
     * 事件绑定
     */
    function elementBindEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
            commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                $.pageBack();
            });
          });
        //关闭ios键盘
        $.bindEvent($(_pageId), function (e) {
            if (e.target !== document.activeElement) {
                document.activeElement.blur();
            }
        }, "click");

        $.bindEvent($(_pageId + " .trade_form .input_code .input_text"), function (e) {
            var click = e.type || "click";
            //			if(keyboard){//避免连续点击报错，导致页面卡死，所以注释
            //				$(_pageId + " div#stockCode").triggerFastClick();
            //			}
            //			else{
            //				$(_pageId + " #stockCode").triggerFastClick();
            //				$(_pageId + " #stockCode").focus();
            //			}
            e.stopPropagation();
        });

        if (!keyboard) {
            $.bindEvent($(_pageId + " #stockCode"), function (e) {
                stock_html.stockList.show();
                e.stopPropagation();
            });
        }
        $.bindEvent($(_pageId + " .trade_form .input_code .input_text span"), function (e) {//输入时股票代码调键盘
            var click = e.type || "click";
            if (keyboard) {
                $(_pageId + " div#stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            } else {
                $(_pageId + " #stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            }
            e.stopPropagation();
        });
        // else{
        // 	if(global.callNative){ // 同步原生的自选股
        // 		$.bindEvent($(_pageId + " div#stockCode"), function(e){
        // 			stock_html.market_ul.hide();
        // 			var data = $.callMessage({"moduleName":"self-stock","funcNo": "60100", "searchKey":""});
        // 			getStockListcallMessage(data); // 显示股票列表
        // 			var $this = $(this);
        // 			$(_pageId + " div.jsKey").removeClass("active")
        // 		    $this.addClass("active");
        // 			window.customKeyboardEvent = {
        // 				keyBoardFinishFunction: function(){},
        // 				keyBoardInputFunction: function(keyCode){
        // 					$this.prev("input").attr("keyDiv",keyCode);
        // 					$this.prev("input").triggerHandler("input");
        // 				}
        // 			};
        // 			var pageId = _pageId.substring(1,_pageId.length);
        // 			var eleId = $this.attr("id");
        // 			$.callMessage({"moduleName":"trade","funcNo": "50210", "pageId":pageId, "eleId":eleId, "doneLable":"done", "keyboardType":"2"});
        // 		    e.stopPropagation();
        // 		});
        // 	}
        // }

        // 股票代码输入框监听
        $.bindEvent($(_pageId + " #stockCode"), function (e) { // 该监听方法是为了适配浏览器
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                var stockCode = $(this).val();
                stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
                stockCode = $.trim(stockCode);
                $(this).val(stockCode);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode.length > 4) {
                var vai1 = /^[0-9]+$/;
                if (!vai1.test(stockCode)) {
                    stockCode = stockCode.substring(0, 4);
                    $(_pageId + " #stockCode").quzhi(stockCode);
                }
            }
            if (stockCode.length == 0) {
                clearBuyMsg();
                $(_pageId + " #stockCode").addClass("C100");
            } else {
                $(_pageId + " #stockCode").removeClass("C100");
            }
            if (stockCode) {
                if (stockCode != _stockCode) {
                    _stockCode = stockCode;
                    clearBuyMsg();
                    var vai0 = /^[A-Za-z]+$/;
                    var vai1 = /^[\u4e00-\u9fa5]+$/;
                    if (stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))) { // 当输入的长度大于1 并且为字母的时候
                        getStockList(stockCode,null,null,true); // 查询股票列表
                    } else if (stockCode.length > 2) { // 当输入的长度大于3的时候
                        getStockList(stockCode,null,null,true); // 查询股票列表
                    }
                    $(_pageId + " .kcb_trade_form #entrustWay").removeClass("unBind");
                }
            }
            e.stopPropagation();
        }, "input");

        //数量输入
        $.bindEvent($(_pageId + " #stockNum"), function (e) {
            if (keyboard) {
                var key = "";
                if (!global.callNative) {
                    key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
                } else {
                    key = $(this).attr("keyDiv");
                }
                if (key == "d4" || key == "-11") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d3" || key == "-12") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d2" || key == "-13") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "d1" || key == "-14") {
                    var num = stock_info.stockMaxAmount;
                    setStockInfo("stockNum", num + "");
                } else {
                    keyboard.popUpKeyboard($(this), e);
                }
            }
            var stockNum = $(_pageId + " #stockNum").val();
            var stockPrice = getStockInfo("stockPrice");
            totalValue(stockPrice, stockNum);
            $(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
            e.stopPropagation();
        }, "input");

        //数量输入埋点
        $.bindEvent($(_pageId + "#stockNum"), function (e) {
            var stockNum = $(_pageId + " #stockNum").val();
            var stockPrice = getStockInfo("stockPrice");
            if (stock_info && stock_info.stockCode && stockPrice && stockPrice != "0") {
                var objectId = "", actionId = "", entrust_bs = "";
                if (isBuy()) {
                    objectId = 100076;
                    actionId = 2;
                    entrust_bs = 1;
                } else {
                    objectId = 100108;
                    actionId = 2;
                    entrust_bs = 2;
                }
                common.comStat(objectId, 2, actionId, false, {
                    "i_entrust_bs": entrust_bs, // 交易方向( 1,买入 2,卖出)
                    "i_entrust_prop": "", // 委托属性
                    "i_exchange_type": stock_info.exchange_type, // 交易市场
                    "i_stock_code": stock_info.stockCode, // 股票代码
                    "i_stock_name": stock_info.stockName, // 股票名称
                    "i_price": stockPrice, // 选择后的价格
                    "i_adjust_type": "5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
                    "i_max_cnt": stock_info.stockMaxAmount, // 最大数量
                    "i_target_cnt": stockNum, // 调整之后的数量
                    "i_fast_btn": "", // 快捷键（全仓，1/2，1/4 ....（可留空））
                });
            }
            e.stopPropagation();
        }, "blur");

        // 限价价格输入框
        $.bindEvent($(_pageId + " #stockPrice"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var stockPrice = $(_pageId + " #stockPrice").val();
            var stockNum = getStockInfo("stockNum");
            // limitingDigit($(this));

            if (stock_info) {
                var stockPrice = $(_pageId + " #stockPrice").val();
                if (stockPrice == "" || Number(stockPrice) == 0) {
                    if (isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                }
            }
            e.stopPropagation();
        }, "input");

        // 限价价格输入框-失去焦点
        $.bindEvent($(_pageId + " #stockPrice"), function (e) {
            var stockNum = getStockInfo("stockNum");
            var stockPrice = $(_pageId + " #stockPrice").val();
            //埋点
            if (stock_info && stock_info.stockCode && stockPrice && stockPrice != "0") {
                var objectId = "", actionId = "", entrust_bs = "";
                if (isBuy()) {
                    objectId = 100073;
                    actionId = 1;
                    entrust_bs = 1;
                } else {
                    objectId = 100105;
                    actionId = 1;
                    entrust_bs = 2;
                }
                common.comStat(objectId, 2, actionId, false, {
                    "i_entrust_bs": entrust_bs, // 交易方向( 1,买入 2,卖出)
                    "i_entrust_prop": "", // 委托属性
                    "i_exchange_type": stock_info.exchange_type, // 交易市场
                    "i_stock_code": stock_info.stockCode, // 股票代码
                    "i_stock_name": stock_info.stockName, // 股票名称
                    "i_price": stockPrice, // 选择后的价格
                    "i_adjust_type": "5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
                });
            }
            e.stopPropagation();
        }, "blur");

        // 科创板市价价格输入框
        $.bindEvent($(_pageId + " #kcbStockPrice"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var kcbPrice = $(_pageId + " #kcbStockPrice").val();
            var stockNum = getStockInfo("stockNum");
            kcbPrice = Number(kcbPrice);
            if(isKCB()){
                if (kcbPrice > 10000) {//限制最大输入值为10000
                    var strPrice = kcbPrice.toString();
                    kcbPrice = strPrice.substr(0, strPrice.length - 1);
                    setStockInfo("stockPrice", kcbPrice);
                }
            }
            // limitingDigit($(this));

            if (stock_info) {
                if (kcbPrice == "" || Number(kcbPrice) == 0) {
                    if (isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    totalValue(kcbPrice, stockNum);
                    isQueryMax(kcbPrice);
                }
            }
            e.stopPropagation();
        }, "input");

        // // 科创板市价价格输入框-失去焦点
        // $.bindEvent($(_pageId + " #kcbStockPrice"), function(e) {
        // 	if(stock_info) {
        // 		var stockNum = getStockInfo("stockNum");
        // 		var stockPrice = $(_pageId + " #kcbStockPrice").val();
        // 		if(stockPrice != "" && stockPrice != 0) {
        // 			// stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
        // 			setStockInfo("stockPrice",stockPrice);
        // 		}else{
        // 			if(isBuy()){//买入的时候价格为空清空最大可买
        // 				$.clearRequest();
        // 				setStockInfo("stockMaxAmount","--",true);
        // 			}
        // 		}
        // 		totalValue(stockPrice,stockNum);
        // 		isQueryMax(stockPrice);
        // 	}
        // 	e.stopPropagation();
        // }, "blur");

        // 增加价格
        $.bindEvent($(_pageId + " .kcb_trade_main .input_select.xj .add"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                stockPrice = Number(stockPrice);
                var price_step = stock_info.price_step;
                if (stockPrice >= 0 && stockPrice < 999999999) {
                    stockPrice = (parseFloat(stockPrice) + parseFloat(stock_info.price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                }
            } else {
                $.alert("请先输入股票代码");
            }

            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": "增加价格"});
            e.stopPropagation();
        });

        // 减少价格
        $.bindEvent($(_pageId + " .kcb_trade_main .input_select.xj .less"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                var price_step = stock_info.price_step;
                stockPrice = Number(stockPrice);
                if (stockPrice - price_step >= 0) {
                    stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                }
            } else {
                $.alert("请先输入股票代码");
            }

            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": "减少价格"});
            e.stopPropagation();
        });

        // 增加价格——保护限价
        $.bindEvent($(_pageId + " .kcb_trade_main .input_select.sj .add"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                stockPrice = Number(stockPrice);
                if (stockPrice >= 0 && stockPrice < 10000) {
                    stockPrice = (parseFloat(stockPrice) + parseFloat(stock_info.price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                }
            } else {
                $.alert("请先输入股票代码");
            }
            e.stopPropagation();
        });

        // 减少价格——保护限价
        $.bindEvent($(_pageId + " .kcb_trade_main .input_select.sj .less"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockNum = getStockInfo("stockNum");
                var stockPrice = getStockInfo("stockPrice");
                if (!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
                    setStockInfo("stockPrice", 0);
                    return false;
                }
                var price_step = stock_info.price_step;
                stockPrice = Number(stockPrice);
                if (stockPrice - price_step >= 0) {
                    stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", stockPrice);
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                } else {
                    if (Number(stockPrice) == 0 && isBuy()) {//买入的时候价格为空清空最大可买
                        $.clearRequest();
                        clearMaxNumber = true;
                        setStockInfo("stockMaxAmount", "--", true);
                    }
                }
            } else {
                $.alert("请先输入股票代码");
            }
            e.stopPropagation();
        });

        // 五档买卖盘联动
        $.bindEvent($(_pageId + " .five_box ul li"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var curPrice = $(this).find("span").text();
            if (curPrice && curPrice != "--") {
                $(this).siblings().removeClass("active");
                $(this).parent().siblings().find("li").removeClass("active");
                $(this).addClass("active");
                curPrice = Number(curPrice).toFixed(stock_info.price_digit);
                setStockInfo("stockPrice", curPrice);
                var stockNum = getStockInfo("stockNum");
                totalValue(curPrice, stockNum);
                isQueryMax(stockPrice);

                //埋点
                if (stock_info && stock_info.stockCode) {
                    var objectId = "", actionId = "", entrust_bs = "", adjust_type = "";
                    if (isBuy()) {
                        objectId = 100075;
                        actionId = 1;
                        entrust_bs = 1;
                        adjust_type = 3;
                    } else {
                        objectId = 100107;
                        actionId = 1;
                        entrust_bs = 2;
                        adjust_type = 4;
                    }
                    common.comStat(objectId, 2, actionId, false, {
                        "i_entrust_bs": entrust_bs, // 交易方向( 1,买入 2,卖出)
                        "i_entrust_prop": "", // 委托属性
                        "i_exchange_type": stock_info.exchange_type, // 交易市场
                        "i_stock_code": stock_info.stockCode, // 股票代码
                        "i_stock_name": stock_info.stockName, // 股票名称
                        "i_price": curPrice, // 选择后的价格
                        "i_adjust_type": adjust_type, // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
                    });
                }
            }
            e.stopPropagation();
        });

        // 下单
        $.bindEvent($(_pageId + " #submitOrder"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            vailSubmitOrder();

            //埋点
            var objectId = "", actionId = "", name = "";
            if (isBuy()) {
                objectId = 100074;
                actionId = 103;
                name = "买入提交";
            } else {
                objectId = 100106;
                actionId = 103;
                name = "卖出提交";
            }
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
        });

        // 点击其他位置去掉五档点击效果
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + "#account_list").hide();
            $(_pageId + " .five_box ul li").removeClass("active");
            if (stock_html) {
                stock_html.stockList.hide();
            }
            e.stopPropagation();
        });

        // 增加数量
        $.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".add"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockPrice = getStockInfo("stockPrice");
                var stockNum = getStockInfo("stockNum") || "0";
                if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
                    setStockInfo("stockNum", 0);
                    return false;
                }
                stockNum = Number(stockNum) + stock_info.lot_size;
                setStockInfo("stockNum", stockNum);
                totalValue(stockPrice, stockNum);
                $(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
            } else {
                $.alert("请输入正确的证券代码/简拼");
            }
            e.stopPropagation();
        });

        // 减少数量
        $.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".less"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                var stockPrice = getStockInfo("stockPrice");
                var stockNum = getStockInfo("stockNum");
                if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
                    setStockInfo("stockNum", 0);
                    return false;
                }
                stockNum = Number(stockNum) - stock_info.lot_size;
                if (stockNum < 0) stockNum = 0;
                setStockInfo("stockNum", stockNum);
                totalValue(stockPrice, stockNum);
                $(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
            } else {
                $.alert("请输入正确的证券代码/简拼");
            }
            e.stopPropagation();
        });


        // 仓位选择
        $.bindEvent($(_pageId + " .kcb_trade_main .row_04 p"), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if (stock_info && stock_info.stockCode) {
                $(this).addClass("check").siblings().removeClass("check");
                var key = $(this).attr("type");
                if (key == "4") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "3") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "2") {
                    var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
                    setStockInfo("stockNum", num + "");
                } else if (key == "1") {
                    var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
                    if (isBuy()) {
                        num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
                    }
                    setStockInfo("stockNum", num + "");
                }
                common.changeFontSize($(_pageId + " #stockNum"), "0.14rem");
                var stockNum = $(_pageId + " #stockNum").val();
                var stockPrice = getStockInfo("stockPrice");
                totalValue(stockPrice, stockNum);
            } else {
                $.alert("请输入正确的证券代码/简拼");
            }
            e.stopPropagation();
        });

        $.bindEvent($(_pageId + " .hqxltb"), function (e) {
            var flag = $(this).find("i").hasClass("xl");
            showChart(flag);
            e.stopPropagation();
        });

        //点击分时图
        $.bindEvent($(_pageId + " #hqt"), function (e) {
            if (stock_info.stockCode && stock_info.stock_market) {
                var pageCode = $.getCurrentPageObj().pageCode || '';
                if (global.callNative) {
                    var param = {
                        "funcNo": "50500",
                        "msgNo": "201",
                        "targetModule": "hqDispatcher",
                        "sourceModule": "trade",
                        "action": "0",
                        "param": {
                            "stockMarket": stock_info.stock_market,
                            "stockCode": stock_info.stockCode,
                            "stockName": stock_info.stockName,
                        }
                    }
                    $.setSStorageInfo("go_hq_" + pageCode, true);
                    $.callMessage(param);
                } else {
                    var stockInfo = {
                        "market": stock_info.stock_market,
                        "stockCode": stock_info.stockName,
                        "stockName": stock_info.stockCode,
                        "moduleName": "trade"
                    }
                    window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                }
            }
        });

        // 点击涨跌停价
        $.bindEvent($(_pageId + " #up_stop").add($(_pageId + " #down_stop")), function (e) {
            $.closeModal(".picker-modal.modal-in");
            if (stock_info) {
                var stockNum = getStockInfo("stockNum");
                var inputVal = $(this).html();
                if (inputVal && validatorUtil.isNumberFloat(inputVal) && inputVal != 0) {
                    inputVal = Number(inputVal).toFixed(stock_info.price_digit);
                    setStockInfo("stockPrice", inputVal);
                    common.changeFontSize($(_pageId + " #stockPrice"), "0.14rem");
                    totalValue(inputVal, stockNum);
                    isQueryMax(inputVal);
                }
            }
            e.stopPropagation();
        });
    }

    function showChart(flag) {
        $.closeModal(".picker-modal.modal-in");
        if (flag) {
            stock_html.hqxltb.attr("class", "sl");
            stock_html.hqCanvas.show();
            if (_initScroller) {
                _initScroller();
            }
        } else {
            stock_html.hqxltb.attr("class", "xl");
            stock_html.hqCanvas.hide();
            if (_initScroller) {
                _initScroller();
            }
        }
    }

    /**
     * 限制小数点位数
     * @param {Object} price
     */
    function limitingDigit($this) {
        var price_digit = stock_info.price_digit;
        var price = getStockInfo("stockPrice");
        if (price && validatorUtil.isNumberFloat(price)) {
            var cur_arr = (price + "").split(".");
            if (cur_arr.length == 2) {
                if (cur_arr[1].length > price_digit) {
                    var price = cur_arr[0] + "." + cur_arr[1].substring(0, price_digit);
                    setStockInfo("stockPrice", price)
                }
            }
        }
    }

    //行情列表接口有问题是，输入股票是6位数时直接调用交易接口
    function queryData(stockCode, exchange_type) {
        var vai1 = /^[0-9]{6}$/;
        if (vai1.test(stockCode)) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            queryMaxAmount(stockCode, false, exchange_type);
        }
    }

    //对行情接口返回数据进行处理
    function ListData(data) {
        stock_info.isHq = true;
        var price = data[2] ? data[2] : data[6];
        var stockVal = data[0]; //股票代码
        var stkType = data[10];
        var stkkcbType = data[18];//是否为科创板
        // 146	chaVentureFlag	风险警示股票标识	1:深圳风险警示 2:上海风险警示  空:非风险警示股票	
        stock_info.chaVentureFlag = data[22];
        // 注册制 退市整理，交易上证云新增field 700 ；1：是 0：不是 其他：未知
        stock_info.issuspend = data[23];
        var price_digit = null;
        var price_step = null;
        var lotsOf = null;
        // 二级类型
        var second_type = data[21];
        stock_info.stockType = stkType;
        stock_info.second_type = second_type;

        /*--------- 2 ，设置证券价格加减步长 ------------*/
        //		var price_step_const = [10,12,13,4,6,19,20,3,11,16];  //0.001
        //		var price_step_const = [1,3,4,5,6,10,11,12,13,14,16,19,20,21,22,23,24,30];//0.001
        var price_step_const = [0, 1, 2, 7, 9, 14, 15, 17, 18, 25, 26, 66];//0.01
        if (global.typeDigit && global.typeDigit instanceof Array && global.typeDigit.length != 0) {
            price_step_const = global.typeDigit;
        }
        var step_flag = $.inArray(stkType, price_step_const);
        // 判断是否为债券
        // stkType == 30 上海国债逆回购
        // stkType == 24 深圳国债逆回购
        // 2022.5.19 交易所新规，深圳国债逆回购 单位改为0.005 , 1000 起购
        if (stkType == 30 || stkType == 24) {
            price_digit = 3;
            price_step = 0.005;
            lotsOf = 1000;
        }
        // 否则浮动为0.01
        else if (step_flag != -1) {
            price_digit = 2;
            price_step = 0.01;
            lotsOf = 100;
        }
        // 变动价格为0.001
        else {
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 100;
        }
        var num_step_const = [6, 14, 21, 22, 23, 24, 25, 26, 27];//10张
        if ($.inArray(stkType, num_step_const) != -1 || stockVal.substring(0, 3) == "131") {
            lotsOf = 10;
        }
        var typeStr = project.functionBody.getStockType(data);
        if(typeStr == "三板") {
            price_digit = 2;
            price_step = 0.01;
            lotsOf = 100;
        }
        // 二级分类中的债券分类
        if($.inArray(stock_info.second_type,bondTypeSecond) != -1){
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 100;
        }
        // 上海市场新规债券默认配置
        if(secondTypeArrBySH.indexOf(stock_info.second_type) > -1){
            price_digit = 3;
            price_step = 0.001;
            lotsOf = 1000;
        }
        // 深圳市场新规债券默认配置
        if(secondTypeArrBySZ.indexOf(stock_info.second_type) > -1){
            price_digit = 4;
            price_step = 0.001;
            lotsOf = 1000;
        }
        stock_info.price_step = price_step;
        stock_info.price_digit = price_digit;
        $(_pageId + " #stockCode").removeClass("C100");
        setStockInfo("stockCode", stockVal, true);
        _stockCode = stockVal;
        setStockInfo("stockName", data[1], true); // 股票现价
        var typeObj = commonHq.getHqtypeData(stockVal, stkType);

        if(typeStr) {
            setStockInfo("stockMarketType", typeStr, true); // 股票市场类型
        }

        if (stkkcbType == "K") {
            cdrFlag(stkkcbType, true);
            stock_info.stock_type = stkkcbType;
            //联动返回了，会重新赋值，此设置，是为联动不返回的容错处理
            stock_info.lot_size = 1;//科创板步数为1
            if (stkType == "16") {
                stock_info.price_step = 0.01;
                stock_info.price_digit = 2;
            }
        } else {
            cdrFlag(stkType, true);//CDR
            // stock_info.stock_type=stkType; 交易类型 由联动接口赋值
            stock_info.lot_size = lotsOf;
        }
        if (data[15] == "1") {
            //			stock_info.stockCode = "";
            // 			$.hidePreloader();
            // 			$.alert("该股票已停牌");
            //			return false;
        }
        entrustMode();
        bondJudgment();
        stock_info.stock_market = data[9];
        changeMarketEntrust(true);//科创板更改市价委托
        var p_price = $.getPageParam("price");
        if (p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
            price = Number(p_price);
        }
        setStockInfo("stockPrice", price.toFixed(stock_info.price_digit)); // 股票现价
        // 涨跌停允许可转债显示
        if ($.inArray(stkType, bondTypeArr) != -1 || $.inArray(stock_info.second_type,bondTypeSecond) != -1) {
            $(_pageId + " .cdw").text("张");
            //可转债显示涨跌停价格
            if(stkType == 27 || stkType == 23){
                setStockInfo("upStop", common.transferText(data[13], stock_info.price_digit), true); // 股票现价
                setStockInfo("downStop", common.transferText(data[14], stock_info.price_digit), true); // 股票现价
            }
        } else {
            //为国债是不显示涨跌停
            setStockInfo("upStop", common.transferText(data[13], stock_info.price_digit), true); // 股票现价
            setStockInfo("downStop", common.transferText(data[14], stock_info.price_digit), true); // 股票现价
            $(_pageId + " .cdw").text("股");
        }
        if (data[1].indexOf("N") == 0) {
            $(_pageId + " .cdw").text("股");
        }
        if (fifthOrder_timer != null) {
            window.clearInterval(fifthOrder_timer);
        }

        var list = stock_info.stock_market + ":" + stock_info.stockCode;
        hqKt.minLineFunc(_pageId, _pageId + " #hqt", list, $(_pageId).width() - 10, 160);

        stock_info.isQueryMaxAmount = true;
        stock_info.gear_one = true;
        setFifthOrder();
        _fifthCallback = false;
        fifthOrder_timer = window.setInterval(function () {
            if (commonFunc.getTradingTime() && _fifthCallback && common.isAppFlag()) {
                setFifthOrder();
                _fifthCallback = false;
            }
        }, (global.refreshTime || 5000));//定时刷新

        var Obj = [];
        if (stock_info.stock_market == "SH" && market_html_data && market_html_data.SH) {
            if (stock_html.market_p.attr("category") != "SH") {
                stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
            }
            stock_html.market_p.attr("category", "SH");
            Obj = market_html_data.SH;
        } else if (stock_info.stock_market == "SZ" && market_html_data && market_html_data.SZ) {
            if (stock_html.market_p.attr("category") != "SZ") {
                stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
            }
            //				if(global.serverConfig == "3"){
            //					market_html_data.SZ = market_html_data.SZ.replace("64","95");
            //				}
            Obj = market_html_data.SZ;
            stock_html.market_p.attr("category", "SZ");
        }
        //委托方式点击事件
        var entrustList = [],entrustVals = [];
        Obj.forEach(function(item){
            entrustList.push(item.name);
            entrustVals.push(item.id);
        });
        entrustWayFunc = commonFunc.nativeSelect("选择委托方式",entrustVals,entrustList,1);
        $.bindEvent($(stock_html.market_div), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            entrustWayFunc(function(data,vals){
                if(data.status === "0"){
                    stock_html.market_p.text(data.dateStr).attr("id", vals[data.selectIndex]);
                    stock_html.market_p.attr("type", vals[data.selectIndex]);
                    stock_html.market_div.attr("value", vals[data.selectIndex]);
                    if (vals[data.selectIndex] == "0") {//限价委托
                        UIchange(true);
                    } else {
                        UIchange();
                    }
                    var stockPrice = getStockInfo("stockPrice");
                    var stockNum = getStockInfo("stockNum");
                    totalValue(stockPrice, stockNum);
                    isQueryMax(stockPrice);
                }else if(data.status === "2"){
                    var page = _pageId.replaceAll("_", "/").replaceAll("#", "").replaceAll(" ", "");
                    // $.pageInit(page, "stock/stockExplain");
                    $.setSStorageInfo("go_hq_" + page, true);
                    $.callMessage({
                        "funcNo": "50115",
                        "loadModuleName": "trade",
                        "moduleName": "trade",
                        "url": "www/m/trade/views/stock/stockExplain.html?app_third=mall&switchUserInfo=0",
                        "statusColor": "#EE4034",//状态栏颜色
                        "isShowLoading": "1",
                        "targetModule": "trade"
                    });
                }
            });
            e.stopPropagation();
        });
        entrustChange();
        stock_info.isThirdBoard = false;
        isThirdStock("",stock_info.stockType);
        //股票联动,查询股票信息，最大可买
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
    }

    /**
     * 通过输入的字符查询出对应的股票列表
     * @param {Object} stockCode 输入的字符
     */
    function getStockList(stockCode, market, exchange_type,isNotQueryHold) {
        if (stockCode != "") {
            var type = "";
            if (global.stockType && global.stockType instanceof Array && global.stockType.length != 0) {
                type = global.stockType.join(":");
            }
            var stockStrParam = {
                "q": stockCode,
                "type": type
            };
            stock_html.stockList.html("");
            var vai1 = /^[0-9]{6}$/;
            if (vai1.test(stockCode)) {
                $.showPreloader("请等待...");
            }
            //			setTimeout(function(){
            //				if(queryStockHqFlowNo && queryStockHqFlowNo.length > 0){
            //					window.clearNativeRequestCallback(queryStockHqFlowNo);
            //				}
            //				queryStockHqFlowNo = service_hq.getStockList(stockStrParam,function(data){
            $.clearRequest();
            service_hq.getStockList(stockStrParam, function (data) {
                    getStockListCallBack(data, stockCode, market, exchange_type,isNotQueryHold);
                },
                {
                    "isLastReq": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        queryData(stockCode, exchange_type);
                    }, "errorFunc": function () {
                        queryData(stockCode, exchange_type);
                    }
                });
            //			},0);
        }
    }

    function getStockListcallMessage(data) {
        stock_html.stockList.html("");
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                var selectHeight = 0.44 * results.length;
                if (results.length >= 5) {
                    selectHeight = 5 * 0.44;
                }
                var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                for (var i = 0; i < results.length; i++) {
                    listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\" stock_name=" + results[i].name + ">" + results[i].code + "</strong>" + results[i].name + "</a>";
                    listHtml += "<span style=\"display:none;\">" + results[i].market + "</span></li>";
                }
                ;
                listHtml += "</ul>";
                stock_html.stockList.html(listHtml).show();
                $.bindEvent($(_pageId + " .trade_form .select_box ul li"), function (e) {
                    var market = $(this).find("span").text();
                    var stockCode = $(this).find("strong").text();
                    var stock_list = market + ":" + stockCode;
                    service_hq.getStockNowPrice({"stock_list": stock_list}, function (data) {
                        getStockListCallBack(data, stockCode);
                    });
                    stock_html.stockList.html("");

                    //埋点
                    var name = $(this).find("strong").attr("stock_name");
                    var objectId = stock_html.stockList.attr("objectId");
                    var actionId = stock_html.stockList.attr("actionId");
                    common.comStat(objectId, 2, actionId, true, {"i_change_name": "股票输入", "i_change_to": name});
                    e.stopPropagation();
                });
            }
        }
    }

    function getStockListCallBack(data, stockCode, market, exchange_type,isNotQueryHold) {
        isNotQueryHold = !isBuy() ? false : isNotQueryHold;
        var StockList = {};
        var vai1 = /^[0-9]{6}$/;
        stock_html.stockList.html("");
        if (data.errorNo == 0) {
            var results = data.results;
            // 显示股票列表
            if (results && results.length > 0) {
                if(stockCode.length==6 && (stock_info.stock_account && stock_info.exchange_type)) {
                    results = stockListCheck(results);
                }
                // 如果从行情中查回来的代码跟选中的代码市场不一样，说明行情中没有这只代码
                if (results.length == 1 && vai1.test(stockCode) && (market && market != results[0][9])){
                  setStockInfo("stockPrice", '');// 股票价格
                  setStockInfo("stockName", stock_info.stockName || $.getPageParam('name'));
                  setStockInfo("stockCode", stockCode);
                  setStockInfo("stockMaxAmount", '');
                  queryData(stockCode, exchange_type);
                }else if (results.length == 1 && vai1.test(stockCode)) {
                    if ($.isValue(results[0][19])) results[0][1] = results[0][19]; // 长名称赋值原名称
                    ListData(results[0]);
                    stock_html.stockList.html("");
                } else {
                    $.hidePreloader();
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    // var emWidth = ($(window).width() - 30) * 0.6;
                    var emWidth = 80;
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i][19])) results[i][1] = results[i][19]; // 长名称赋值原名称
                        if (market && market == results[i][9] && results[i][0] == stockCode) {
                            ListData(results[i]);
                            return false;
                        }
                        StockList[(results[i][9] + ":" + results[i][0])] = results[i];
                        var typeStr = project.functionBody.getStockType(results[i]);
                        var subStr = typeStr ? '<dd class="market_type">'+typeStr+'</dd>' : "";
                        var nameText = '<em style="zoom:' + $.getTransformScale(results[i][1], 14, emWidth)+ '">' + results[i][1] + '</em>';
                        listHtml += "<li type26100='"+results[i][10]+"' typeStr26100='"+typeStr+"'><a href=\"javascript:void(0);\" style=\"line-height: inherit;display: flex;align-items: center;text-align: center;\">"+subStr+"<strong style=\"font-size:0.15rem\" stock_name=" + results[i][1] + ">" + results[i][0] + "</strong>" + nameText + "</a>";
                        listHtml += "<span style=\"display:none;\">" + results[i][9] + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .trade_form  .select_box ul li"), function (e) {
                        var market1 = $(this).find("span").text();
                        var stockCode = $(this).find("strong").text();
                        if(stockCode.length==6) {
                            var type = $(this).attr("type26100");
                            if((pageGlobal.stockType26100).indexOf(type)>-1) {
                                var exchangeType = "";
                                var typeStr = $(this).attr("typeStr26100");
                                if(typeStr.indexOf("沪")>-1) {
                                    exchangeType = typeStr.indexOf("沪B")>-1 ? "3" : "2";
                                } else if(typeStr.indexOf("深")>-1 || type=="8") {
                                    exchangeType = typeStr.indexOf("深B")>-1 ? "1" : "0";
                                }
                                stock_info.exchange_type = exchangeType;
                            }
                        }
                        ListData(StockList[market1 + ":" + stockCode]);
                        stock_html.stockList.html("");
                        StockList = {};

                        //埋点
                        var name = $(this).find("strong").attr("stock_name");
                        var objectId = stock_html.stockList.attr("objectId");
                        var actionId = stock_html.stockList.attr("actionId");
                        common.comStat(objectId, 2, actionId, true, {"i_change_name": "股票输入", "i_change_to": name});
                        e.stopPropagation();
                    });
                }
            } else {
                //输入是股票代码时行情没查到回去联动查询
                if (vai1.test(stockCode)) {
                    queryData(stockCode, exchange_type);
                    //					$.alert("没有查询到此股票信息");
                    //					$.hidePreloader();
                }
                //输入时股票简拼没查到提示
                var regx = /^[a-zA-Z0-9]{4}$/;
                if (regx.test(stockCode)) {
                    $.alert("没有查询到此股票信息");
                }
            }
        } else {
            queryData(stockCode, exchange_type);
        }
    }

    /**
     *用户持仓有数据就以持仓数据为主
     */
    function stockListCheck(listData) {
        var dataArr = [];
        var stock_account = "",exchange_type = "";
        if(listData.length>1) {
            var szArr = ["SZ","0","1"];        //深圳
            var shArr = ["SH","2","3","F3"];  //上海
            var holdData = pageGlobal.holdData;
            if(holdData) {
                if(holdData.error_no == 0) {
                    var holdResults = holdData.results;
                    if(holdResults && holdResults.length > 0) {
                        for(var i=0,len1=listData.length;i<len1;i++) {
                            var listCode = listData[i][1];
                            var listType = listData[i][9];
                            for(var j=0,len2=holdResults.length;j<len2;j++) {
                                var item = holdResults[j];
                                var holdCode = item["stock_code"];
                                var holdType = item["exchange_type"];
                                if(listCode==holdCode) {
                                    if(szArr.indexOf(holdType)>-1 && szArr.indexOf(listType)>-1) {
                                        dataArr.push(listData[i]);
                                        // 当输入的股票代码在持仓里面只有一条相同，就赋值
                                        stock_account = !stock_account ? item["stock_account"] : "";
                                        exchange_type = !exchange_type ? item["exchange_type"] : "";
                                    } else if(shArr.indexOf(holdType)>-1 && shArr.indexOf(listType)>-1) {
                                        dataArr.push(listData[i]);
                                        // 当输入的股票代码在持仓里面只有一条相同，就赋值
                                        stock_account = !stock_account ? item["stock_account"] : "";
                                        exchange_type = !exchange_type ? item["exchange_type"] : "";
                                    }
                                }
                            }
                        }
                    }
                }
            }
        }
        if(dataArr.length>0) {
            return dataArr
        } else {
            return listData
        }
    }

    //五档买卖盘
    function setFifthOrder() {
        var market = stock_info.stock_market, stockCode = stock_info.stockCode;
        if (market && stockCode) {
            var fifthOrder = {
                "stock_list": market + ":" + stockCode
            };
            service_hq.getStockFiveStep(fifthOrder, function(data){
              callbackFifthOrder(data,stockCode);
            }, {
                "isShowWait": false, "errorFunc": function () {
                    _fifthCallback = true;
                    if(stock_info.isQueryMaxAmount) {
                        stock_info.isQueryMaxAmount = false;
                        queryMaxAmount(stockCode);
                    }
                }
            });
        }
    }

    //回调五档买卖盘
    function callbackFifthOrder(data,stockcode) {
        _fifthCallback = true;
        if (data.errorNo == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                var yesProfit = results[0][26];
                var price_digit = stock_info.price_digit;

                // $(_pageId + ".kcb_timeshare .row_01 strong").text(results[0][1]);
                var kcb_timeshareEm = $(_pageId + ".kcb_timeshare .row_01 em");
                var r35 = results[0][35];
                if (results[0][35]) {
                    r35 = (Number(results[0][35])).toFixed(price_digit);//内盘
                }
                kcb_timeshareEm.text((Number(results[0][30])).toFixed(price_digit) + " " + r35 + " " + (Number(results[0][36]) * 100).toFixed(2) + "%");
                if (r35 > 0) {
                    kcb_timeshareEm.attr("class", "ared");
                } else if (r35 < 0) {
                    kcb_timeshareEm.attr("class", "agreen");
                } else {
                    kcb_timeshareEm.attr("class", "");
                }

                if (stock_info.gear_one) {
                    var fifthOne = "";
                    var presentPrice = results[0][30];
                    if (isBuy()) {
                        fifthOne = results[0][10] || results[0][16];
                    } else {
                        fifthOne = results[0][16] || results[0][10];
                    }
                    if (presentPrice != 0 && (fifthOne == "0" || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)) {
                        fifthOne = presentPrice;
                    }
                    fifthOne = Number(fifthOne).toFixed(price_digit);
                    var p_price = $.getPageParam("price");
                    if (p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
                        fifthOne = Number(p_price).toFixed(price_digit);
                    }
                    setStockInfo("stockPrice", fifthOne); // 股票现价
                    stock_info.gear_one = false;
                }
                //卖五档盘颜色集合
                for (var i = 0; i < 5; i++) {
                    addColor(stock_html.buyGear.eq(i), results[0][16 + i], yesProfit, results[0][21 + i], price_digit);
                    addColor(stock_html.sellGear.eq(i), results[0][6 + i], yesProfit, results[0][11 + i], price_digit);
                }
                $(_pageId + ".five_box span").each(function (idx, item) {
                    var zoom = $.getTransformScale($(item).text(), 12, $(_pageId + ".five_box").getContentWidth() * 0.28)
                    $(item).css({"zoom": zoom});
                });
                $(_pageId + ".five_box em").each(function (idx, item) {
                    var zoom = $.getTransformScale($(item).text(), 12, $(_pageId + ".five_box").getContentWidth() * 0.28)
                    $(item).css({"zoom": zoom});
                });
            }
        } else {
            //			$.alert(data.error_info);
        }
        if(stock_info.isQueryMaxAmount) {
            stock_info.isQueryMaxAmount = false;
            queryMaxAmount(stockcode);
        }
    }


    //根据昨收改动价格颜色 , 没有价格的地方显示“--”
    function addColor(div, price, yesProfit, num, price_digit) {
        var prices = div.find("span");
        var nums = div.find("em");
        yesProfit = yesProfit.toFixed(price_digit);
        price = price.toFixed(price_digit);
        if (Number(price) == 0) {
            prices.text("--").attr("class", "");
        } else if (Number(price) > Number(yesProfit)) {
            prices.text(price).attr("class", "ared");
        } else if (Number(price) < Number(yesProfit)) {
            prices.text(price).attr("class", "agreen");
        } else {
            prices.text(price).attr("class", "");
        }
        if (num == 0) {
            // num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
        } else if (num >= 100000) {
            nums.text((num / 10000).toFixed(2) + "万");
        } else {
            nums.text(num);
        }
    }


    /**
     * 查询买入可用资金最大可买可卖数量
     * */
    function queryMaxAmount(stockCode, isMax, exchange) {
        stock_html.stockList.html("");
        $.hidePreloader();
        var stock_price = getStockInfo("stockPrice");
        var entrust_bs = "0";
        if (stock_info.market_price) {
            if (stock_html.market_p.attr("id")) {
                entrust_bs = stock_html.market_p.attr("type");
                // if (!isKCB()) {//非科创板市价委托用0.01
                //     stock_price = "0.01";
                // }
            } else {
                // if (stock_info.isBond) {
                // 	stock_html.market_ul.hide();
                // } else {
                // 	stock_html.market_ul.show();
                // }
            }
        }
        if (!isBuy()) {
            entrust_bs = (Number(entrust_bs) + 1) + "";
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var stock_code = stockCode;
        var entrust_price = stock_price;
        var stock_account = stock_info.stock_account || $(_pageId + "#account p").attr("stock_account");
        var exchange_type = exchange || stock_info.exchange_type || $(_pageId + "#account p").attr("exchange_type") || _exchange[stock_info.stock_type + ""];
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "stock_account": stock_account,
            "newstock_flag": "",
            "exchange_type": exchange_type
        };
        if(param.stock_code == '' || param.stock_code == null){
          return false;
        }
        service_stock.queryBondMaxBuy(param, function (data) {
            $.hidePreloader();
            if (isMax) {
                queryMaxAmountCallBackMax(data);
            } else {
                queryMaxAmountCallBack(data);
            }
            _PageParam = {};
        }, {"isLastReq": true, "isShowWait": !isMax});

    }

    function queryMaxAmountCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                if (results.length == 1) {
                    stock_info.bond_cash = results[0].bond_cash; // 是否是债券现券交易支持的债券分类
                    stock_info.bond_cash_bjs = results[0].bond_cash_bjs; // 是否是北交所债券现券交易支持的债券分类
                    var en_trade_type = results[0].en_trade_type || "";
                    // 如果是新规债券（上海和深债两个市场）
                    if(isBondCash()){
                        stock_info.price_step = ((+results[0].price_step) / 1000);
                    }
                    // 沪深国债逆回购 价差以柜台接口为准
                    // 可转债新规 数量以柜台为准
                    if (stock_info.stockType == 30 || stock_info.stockType == 24 || stock_info.stockType == 27 || stock_info.stockType == 23) {
                        stock_info.price_step = ((+results[0].price_step) / 1000);
                    }
                    if ($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
                    stockcode_entrust_info = {// 下单股票委托信息
                        hight_amount: results[0].hight_amount,// 限价委托数量上限
                        market_high_amount: results[0].market_high_amount// 市价委托数量上限
                    };
                    stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
                    var price_digit = stock_info.price_digit;
                    setStockInfo("stockMaxAmount", Number(results[0].stock_max_amount), true);
                    var exchange_type = results[0].exchange_type;
                    stock_info.exchange_type = exchange_type;
                    stock_info.stock_account = results[0].stock_account;
                    if (!isBuy()) {
                        //勾选筛选出的股东账号
                        $(_pageId + "#account p").html(stock_info.stock_account + " " + results[0].exchange_type_name);
                        $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
                        $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
                        stockAccountListCallBack(stockAccountList, stock_info.exchange_type, stock_info.stock_account);
                    }
                    var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
                    if (buy_unit != 0) {
                        stock_info.lot_size = buy_unit;
                    }
                    stock_info.delist_flag = results[0].delist_flag;
                    stock_info.delist_info = results[0].delist_info;
                    var stock_code = results[0].stock_code;
                    if (!stock_info.isHq) {
                        entrustMode();
                        var stock_type = results[0].stock_type;
                        stock_info.stock_type = stock_type;
                        cdrFlag(results[0].stock_type);//CDR、科创板、沪伦通
                        if (exchange_type == 0 || exchange_type == 1) {
                            stock_info.stock_market = "SZ";
                        } else if (exchange_type == 2 || exchange_type == 3) {
                            stock_info.stock_market = "SH";
                            if (global.serverConfig == "3" && stock_type && stock_type.indexOf("Z") == 0) {
                                $(_pageId + " .cdw").text("手");
                                stock_info.lot_size = 1;
                            }

                        }
                        changeMarketEntrust();//科创板更改市价委托

                        var Obj = [];
                        if (stock_info.stock_market == "SH" && market_html_data && market_html_data.SH) {
                            if (stock_html.market_p.attr("category") != "SH") {
                                stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
                            }
                            Obj = market_html_data.SH;
                            stock_html.market_p.attr("category", "SH");
                        } else if (stock_info.stock_market == "SZ" && market_html_data && market_html_data.SZ) {
                            if (stock_html.market_p.attr("category") != "SZ") {
                                stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
                            }
                            //								if(global.serverConfig == "3"){
                            //									market_html_data.SZ = market_html_data.SZ.replace("64","95");
                            //								}
                            Obj = market_html_data.SZ;
                            stock_html.market_p.attr("category", "SZ");
                        }

                        //委托方式点击事件
                        var entrustList = [],entrustVals = [];
                        Obj.forEach(function(item){
                            entrustList.push(item.name);
                            entrustVals.push(item.id);
                        });
                        entrustWayFunc = commonFunc.nativeSelect("选择委托方式",entrustVals,entrustList,1);
                        $.bindEvent($(stock_html.market_div), function (e) {
                            if (keyboard) {
                                keyboard.closeKeyPanel();
                            }
                            entrustWayFunc(function(data,vals){
                                if(data.status === "0"){
                                    stock_html.market_p.text(data.dateStr).attr("id", vals[data.selectIndex]);
                                    stock_html.market_p.attr("type", vals[data.selectIndex]);
                                    stock_html.market_div.attr("value", vals[data.selectIndex]);
                                    if (vals[data.selectIndex] == "0") {//限价委托
                                        UIchange(true);
                                    } else {
                                        UIchange();
                                    }
                                    var stockPrice = getStockInfo("stockPrice");
                                    var stockNum = getStockInfo("stockNum");
                                    totalValue(stockPrice, stockNum);
                                    isQueryMax(stockPrice);
                                }else if(data.status === "2"){
                                    var page = _pageId.replaceAll("_", "/").replaceAll("#", "").replaceAll(" ", "");
                                    // $.pageInit(page, "stock/stockExplain");
                                    $.setSStorageInfo("go_hq_" + page, true);
                                    $.callMessage({
                                        "funcNo": "50115",
                                        "loadModuleName": "trade",
                                        "moduleName": "trade",
                                        "url": "www/m/trade/views/stock/stockExplain.html?app_third=mall&switchUserInfo=0",
                                        "statusColor": "#EE4034",//状态栏颜色
                                        "isShowLoading": "1",
                                        "targetModule": "trade"
                                    });
                                }
                            });
                            e.stopPropagation();
                        });
                        entrustChange();
                    }
                    // 注释调行情接口stock_type赋值
                    if (!stock_info.stock_type) stock_info.stock_type = results[0].stock_type;
                    if (isKCB()) {//科创板的价差取交易
                        var point = results[0].point ? Number(results[0].point) : 0;
                        if (point != 0) {
                            var price_step = Math.pow(10, 0 - point);
                            if (stock_code.substring(0, 3) == "204") {
                                price_step = 0.005;
                            }
                            stock_info.price_digit = point;
                            price_digit = point;
                            stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
                        }
                    }
                    //名称以联动为准
                    setStockInfo("stockName", results[0].stock_name, true);
                    $(_pageId + ".kcb_timeshare .row_01 strong").text(results[0].stock_name);
                    if (!stock_info.stockCode) {
                        var stock_type = results[0].stock_type;
                        stock_info.stock_type = stock_type;
                        $(_pageId + " #stockCode").removeClass("C100");
                        setStockInfo("stockCode", results[0].stock_code, true);
                        setStockInfo("stockName", results[0].stock_name, true);

                        var point = results[0].point ? Number(results[0].point) : 0;
                        if (point != 0) {
                            var price_step = Math.pow(10, 0 - point);
                            if (stock_code.substring(0, 3) == "204") {
                                price_step = 0.005;
                            }
                            stock_info.price_step = price_step;
                            price_digit = point;
                            if (isKCB()) {//科创板的价差取交易
                                stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
                            } else {
                                stock_info.price_digit = point;
                            }
                        }
                        // 如果是新规债券（上海和深债两个市场）
                        if(isBondCash()){
                            stock_info.price_step = ((+results[0].price_step) / 1000);
                            stock_info.price_digit = 3;
                            price_digit = 3;
                        }

                        var p_price = $.getPageParam("price");
                        if (p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
                            results[0].price = p_price
                        }
                        setStockInfo("stockPrice", Number(results[0].price).toFixed(price_digit));

                        if ((stock_info.stockType && $.inArray(stock_info.stockType, bondTypeArr) == -1) || $.inArray(stock_info.second_type,bondTypeSecond) != -1) {
                            if (results[0].up_limit != 0) {
                                setStockInfo("upStop", Number(results[0].up_limit).toFixed(price_digit), true);
                            }
                            if (results[0].down_limit != 0) {
                                setStockInfo("downStop", Number(results[0].down_limit).toFixed(price_digit), true);
                            }
                        }
                    }
                    if (results[0].stock_type && results[0].stock_type == "17") {//配股单位要显示股
                        $(_pageId + " .cdw").text("股");
                    }

                    //沪伦通
                    //					hltConfirm(results[0].hlt_receipt_rights);
                    var p_num = $.getPageParam("num");
                    if (p_num && p_num != 0 && validatorUtil.isNumeric(p_num)) {
                        setStockInfo("stockNum", p_num, true);
                    }
                    //CDR
                    if (results[0].cdr_rights == "1" || results[0].innovate_rights == "1") {
                        cdrStock(results[0]);
                    }
                    bond_repurchase_flag = results[0].bond_repurchase_flag;//保存国债逆回购标志
                    is_delisting = results[0].is_delisting;//退市标识
                    delisting_msg = results[0].delisting_msg;//退市提示语
                    fund_used_days = results[0].fund_used_days;//实际占款天数
                    notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
                    notice_info = results[0].notice_info;//系统提示信息
                    //权限弹框
                    if (_orderType == 1) {
                        //科创板权限开通
                        kcbConfirm(results[0].stock_type, results[0].technology_innovation_rights, results[0].technologyInnovation_cdr_rights);
                        commonFunc.popupRightsConfirm(results[0], {checkCyb: true, checkKzz: true,ckeckReits:true,registerUser:true});
                    }
                    // 判断是否是债券现券
                    if(!isBondCash()){
                        $.alert("非债券现券，不支持债券现券匹配成交，请前往普通交易模块进行买卖委托");
                    }else if(en_trade_type.indexOf("1") < 0){
                        $.alert("该证券不允许匹配成交委托，交易有可能会失败，请确认输入的代码是否正确");
                    }
                    if(isBuy()){
                      // 风险警示权限 0 表示 没权限，1表示有权限
                        isST(stock_info.stockCode,results[0].fxjs_rights);
                        // 判断是否京A股票，京A股票提示文本
                        isBJ(results[0]);
                    }

                    stock_info.isThirdBoard = false;
                    isThirdStock(results[0].exchange_type);
                } else if (results.length > 1) {
                    $.hidePreloader();
                    var stock_results = results;
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var nameText = '<em style="zoom:' + $.getTransformScale(results[i].stock_name, 14, 80)+ '">' + results[i].stock_name + '</em>';
                        listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\" stock_name=" + results[i].name + ">" + results[i].stock_code + "</strong>" + nameText + "</a>";
                        listHtml += "<span style=\"display:none;\">" + results[i].exchange_type + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .trade_form .select_box ul li"), function (e) {
                        var info = stock_results[$(this).index()];
                        var exchange_type = info.exchange_type;
                        var stockCode = $(this).find("strong").text();
                        stock_html.stockList.html("");
                        $(_pageId + " #stockCode").removeClass("C100");
                        // 如果柜台有多条，选择了行情中没有的股票，则清空数据
                        if(commonHq.getHqMarket(exchange_type) !== stock_info.stock_market){
                          clearBuyMsg();// 清除数据
                          setStockInfo("stockPrice", info.price);// 股票价格
                          setStockInfo("stockMaxAmount", Number(info.stock_max_amount), true);
                          stock_info.stockName = $(this).find("em").text();
                        }
                        queryData(stockCode, exchange_type);
                        setStockInfo("stockName", $(this).find("em").text(), true);
                        notice_no = info.notice_no;//系统提示信息 为4时，显示弹框
                        notice_info = info.notice_info;//系统提示信息
                        bond_repurchase_flag = info.bond_repurchase_flag;//保存国债逆回购标志
                        is_delisting = info.is_delisting;//退市标识
                        delisting_msg = info.delisting_msg;//退市提示语
                        fund_used_days = info.fund_used_days;//实际占款天数
                        //埋点
                        var name = $(this).find("strong").attr("stock_name");
                        var objectId = stock_html.stockList.attr("objectId");
                        var actionId = stock_html.stockList.attr("actionId");
                        common.comStat(objectId, 2, actionId, true, {"i_change_name": "股票输入", "i_change_to": name});
                        e.stopPropagation();
                    });
                }
                showChart(true);
            }
        } else {
            $.alert(data.error_info);
        }
    }

    function queryMaxAmountCallBackMax(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                var price_digit = stock_info.price_digit;
                if (!clearMaxNumber) {
                    setStockInfo("stockMaxAmount", Number(results[0].stock_max_amount), true);
                }
                var exchange_type = results[0].exchange_type;
                stock_info.exchange_type = exchange_type;
                stock_info.stock_account = results[0].stock_account;
                // 如果行情中没有查到数据，则使用柜台返回的数据,使用柜台的stock_type字段 ，isHq要设置false
                if(!stock_info.stock_type){
                    stock_info.stock_type = results[0].stock_type || stock_info.stock_type;
                    stock_info.isHq = false;
                }
                stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
                if (!isBuy()) {
                    //勾选筛选出的股东账号
                    $(_pageId + "#account p").html(stock_info.stock_account + " " + results[0].exchange_type_name);
                    $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
                    $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
                    stockAccountListCallBack(stockAccountList, stock_info.exchange_type, stock_info.stock_account);
                }
                var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
                if (buy_unit != 0) {
                    stock_info.lot_size = buy_unit;
                }
                stock_info.delist_flag = results[0].delist_flag;
                stock_info.delist_info = results[0].delist_info;
                bond_repurchase_flag = results[0].bond_repurchase_flag;//保存国债逆回购标志
                is_delisting = results[0].is_delisting;//退市标识
                delisting_msg = results[0].delisting_msg;//退市提示语
                fund_used_days = results[0].fund_used_days;//实际占款天数
                notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
                notice_info = results[0].notice_info;//系统提示信息
                //CDR
                if (results[0].cdr_rights == "1" || results[0].innovate_rights == "1") {
                    cdrStock(results[0]);
                }
                stock_info.isThirdBoard = false;
                isThirdStock(results[0].exchange_type);
                showChart(true);
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /*
	 * 沪伦通权限提示
	 */
    function hltConfirm(hlt_receipt_rights) {
        if (hlt_receipt_rights == 1 || hlt_receipt_rights == "1") {
            common.iConfirm("温馨提示", "您尚未开通沪伦通股东账号权限，如需进行交易，请到业务办理完成对应权限开通。", function success(html) {
                if (global.callNative && global.isSso) {
                    $.callMessage({
                        "funcNo": "50115",
                        "loadModuleName": "ygt",
                        "moduleName": "ygt",
                        "url": global.ygtUrl + "/m/ygt/index.html#!/hlt/index.html?isFromApp=true",
                        "statusColor": "#2A315B",//状态栏颜色
                        "isShowLoading": "1",
                        "targetModule": "trade"
                    });
                } else {
                    window.location.href = "http://140.207.41.22:8807/m/ygt/index.html#!/hlt/index.html";
                }
            }, function fail() {
            }, "开通权限", "取消");
        }
    }

    /*******
     * 判断当前股票是否是风险警示的
     */
    function isST(stockCode,fxjs_rights) {

        var param={
            "stock_code":stockCode,
        }
        service_hq.getIsST(param, function (data) {
            // console.log(data);
            if (data.errorNo=="0"){
                if(data.results!=null&&data.results.length>0){
                    var status =data.results[0][0];
                    if(status=="1"||status=="2"){//1深圳风险警示 2上海风险警示 空：非风险警示
                      if (fxjs_rights == "1") {//已开通
                        showSTMessage();
                      } else {
                        var titleTips = "";
                        if (status == "1") {
                          titleTips = "您尚未开通深市风险警示股票购买权限，如需进行交易，请到业务办理完成对应权限开通。";
                        } else if (status == "2") {
                          titleTips = "您尚未开通沪市风险警示股票购买权限，如需进行交易，请到业务办理完成对应权限开通。";
                        }
                        common.iConfirmNew("温馨提示", titleTips, function success() {
                          if (global.callNative && global.isSso) {
                            var param = {
                              "funcNo": "50500",
                              "msgNo": "123",
                              "sourceModule": "",
                              "targetModule": "tradeDispatcher",
                              "action": "1",
                              "param": {
                                "business_type": userInfo._loginClass,//普通0  两融1
                                "event": "12",//打开风险警示权限开通页面
                                "title": "",
                              }
                            }
                            $.callMessage(param);
                          }
                        }, function fail() {
                          showSTMessage();
                        }, "开通权限", "取消");
                      }
                    }else{
                        showMessage();
                    }
                }else{
                    showMessage();
                }
            }else{
                showMessage();
            }
            function showSTMessage(){
              if (notice_no === "4") {
                common.singleIConfirmNew("温馨提示", notice_info, function () { }, "我知道了",undefined,undefined,undefined,'notice_info');
              } else {
                common.singleIConfirmNew("温馨提示", '该股票是风险警示类股票，请注意风险，谨慎投资！', function () { }, "我知道了",undefined,undefined,undefined,'notice_info');
              }
            }
            function showMessage(){
              if(notice_no === "4"){
                common.singleIConfirmNew("温馨提示",notice_info,function(){ },"我知道了",undefined,undefined,undefined,'notice_info');
              }
            }
        });
    }


    //CDR标志
    function cdrFlag(stock_type, isHq) {
        var flag = true;
        var CDRArray = [];
        var CQArray = [];
        var hlCDRArray = [11];
        var KCBArray = [];
        if (isHq) {
            CDRArray = [43, 44];
            CQArray = [45, 46];
            KCBArray = ["K"];
        } else {
            CDRArray = [10];
            //			CQArray = [0];
            KCBArray = [15, 16];
        }

        if (CDRArray.indexOf(stock_type) != -1) { //CDR
            $(_pageId + ".input_text .logoStyle").show();
            $(_pageId + ".input_text .logoStyle").addClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("CDR");
            flag = false;
        } else if (CQArray.indexOf(stock_type) != -1) { //创企
            $(_pageId + ".input_text .logoStyle").show();
            $(_pageId + ".input_text .logoStyle").addClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("创企");
            flag = false;
        }
            //		else if(hlCDRArray.indexOf(stock_type)!=-1){ //沪伦通
            //			$(_pageId + ".input_text .cdrCss").text("沪伦");
            //			$(_pageId + ".input_text .cdrCss").show();
        //		}
        else if (KCBArray.indexOf(stock_type) != -1) { //科创板
            // $(_pageId + ".input_text .logoStyle").show();
            // $(_pageId + ".input_text .logoStyle").addClass("kcbCss");
            // $(_pageId + ".input_text .logoStyle").text("科创");
        } else {
            $(_pageId + ".input_text .logoStyle").hide();
            $(_pageId + ".input_text .logoStyle").removeClass("kcbCss").removeClass("cdrCss");
            $(_pageId + ".input_text .logoStyle").text("");
        }
        if(flag && stock_html.stockMarketType.html()) {
            stock_html.stockMarketType.show();
        }
    }

    function cdrStock(data) {
        var cdr_type = "";
        var tipStr = "";
        if (data.cdr_rights == "1") {
            cdr_type = "1";
            tipStr = "您尚未开通存托凭证股东账号权限，如需进行交易，请开通对应市场的交易权限。";
        } else if (data.innovate_rights == "1") {
            cdr_type = "2";
            tipStr = "您尚未开通创新企业股东账号权限，如需进行交易，请开通对应市场的交易权限。";
        } else {
            return;
        }
        var cdr_stock_account = data.stock_account; //股东账号
        var cdr_exchange_type = data.exchange_type; // 市场
        var cdr_info = [];
        cdr_info.push(cdr_exchange_type + ":" + cdr_stock_account);
        var paramMap = data;
        common.iConfirm("温馨提示", tipStr, function success(html) {
            cdrProtocolSign.cdrProtocolMatch(cdr_type, "1", cdr_info, paramMap);
        }, function fail() {
        }, "开通权限", "取消");
    }


    // 计算当前总值
    function totalValue(stockPrice, stockNum) {
        if (stock_html) {
            stock_html.total.text("").hide();
        }
        var resTotal;
        if (validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)) {
            if (bond_repurchase_flag == "1") {//逆回购在普通交易特殊处理：沪深逆回购品种的委托金额=委托数量*100，币种统一为人民币
                resTotal = common.numToMoneyType("" + (100 * stockNum).toFixed(2));
                stock_html.total.text("(¥" + resTotal + ")").show();
            } else {
                resTotal = common.numToMoneyType("" + (stockPrice * stockNum).toFixed(2));
                stock_html.total.text("(¥" + resTotal + ")").show();
            }
        }
        stock_info.transResTotal = resTotal;
    }

    /*
	 * 为科创板的代码需要更改市价委托
	 */
    function changeMarketEntrust(isHq) {
        var KCBArray = [];
        if (isHq) {
            KCBArray = ["K"];
        } else {
            KCBArray = [15, 16];
        }
        market_html_data.SZ = [
            {"name": "限价委托", "id": "0"},
            {"name": "对手方最优价格", "id": "70"},
            {"name": "本方最优价格", "id": "68"},
            {"name": "即时成交剩余撤销", "id": "4"},
            {"name": "最优五档即时成交剩余撤销", "id": "64"},
            {"name": "全额成交或撤销委托", "id": "66"}
        ];
        // 146	chaVentureFlag	风险警示股票标识	1:深圳风险警示 2:上海风险警示  空:非风险警示股票	
        // issuspend 注册制 退市整理，交易上证云新增field 700 ；1：是 0：不是 其他：未知
        
        // 上海风险警示 或者 上海退市整理 只能限价委托
        if (stock_info.chaVentureFlag === "2" || (stock_info.issuspend === "1" && stock_info.stock_market === "SH")) {
            market_html_data.SH = [{"name": "限价委托", "id": "0"}];
        } else if (KCBArray.indexOf(stock_info.stock_type) != -1 || isSHstockOrFund()) { //科创板 | 沪市的股票或者基金
            market_html_data.SH = [
                {"name": "限价委托", "id": "0"},
                {"name": "对手方最优价格", "id": "70"},
                {"name": "本方最优价格", "id": "68"},
                {"name": "最优五档即时成交剩余撤销", "id": "64"},
                {"name": "最优五档即时成交剩余转限价", "id": "62"},
            ];
            // market_html_data.SH = "<li id=\"70\"><a href=\"javascript:void(0);\">对手方最优价格</a></li><li id=\"68\"><a href=\"javascript:void(0);\">本方最优价格</a></li><li id=\"64\"><a href=\"javascript:void(0);\">五档即成剩撤</a></li><li id=\"62\"><a href=\"javascript:void(0);\">五档即成转限价</a></li>";
        } else if (stock_info.isBond) {
            market_html_data.SH = [{"name": "限价委托", "id": "0"}];
            market_html_data.SZ = [{"name": "限价委托", "id": "0"}]
        } else {
            market_html_data.SH = [
                {"name": "限价委托", "id": "0"},
                {"name": "最优五档即时成交剩余撤销", "id": "64"},
                {"name": "最优五档即时成交剩余转限价", "id": "62"},
            ];
            // market_html_data.SH = "<li id=\"64\"><a href=\"javascript:void(0);\">五档即成剩撤</a></li><li id=\"62\"><a href=\"javascript:void(0);\">五档即成转限价</a></li>";
        }
    }

    /*
	 * 带入委托方式的时候，改变价格下拉框
	 */
    function entrustMode() {
        var entrustBs = _PageParam["entrust_bs"];
        if (entrustBs) {
            if (entrustBs == "0" || entrustBs == "1") {//限价委托方式
                UIchange(true);
            } else {//市价委托方式
                UIchange();
            }
        }
    }

    /*
	 * 委托方式带入到下单页面填充
	 */
    function entrustChange() {
        var entrustBs = _PageParam["entrust_bs"];
        if (entrustBs) {
            var entrustName = null;
            if (!isBuy()) {
                entrustBs = Number(entrustBs) - 1;
            }
            entrustName = {
                "0": "限价委托",
                "70": "对手方最优价格",
                "68": "本方最优价格",
                "64": "最优五档即时成交剩余撤销",
                "62": "最优五档即时成交剩余转限价",
                "4": "即时成交剩余撤销",
                "66": "全额成交或撤销委托"
            };
            stock_html.market_p.text(entrustName[entrustBs]).attr("id", entrustBs);
            stock_html.market_p.attr("type", entrustBs);
        } else {
            stock_html.market_p.text("限价委托").attr("id", "0");
            stock_html.market_p.attr("type", "0");
            stock_html.market_div.attr("value", "0");
        }
    }

    /*
	 * 页面UI切换的时候
	 */
    function UIchange(isFixedPrice) {
        $(_pageId + ".row_04 p").removeClass("check");
        if (isFixedPrice) {//限价
            $(_pageId + ".sj").hide();
            $(_pageId + ".xj").show();
            stock_html.stockPrice = $(_pageId + " #stockPrice");
            stock_info.market_price = false;
            if (isBuy()) {//买入的时候需要切换最大可买
                $(_pageId + " #maxNumber").show();
                $(_pageId + " #kcbMaxNumber").hide();
                stock_html.stockMaxAmount = $(_pageId + " #maxNumber");
                setStockInfo("stockMaxAmount", $(_pageId + " #maxNumber").text(), true);
            }
        } else {//市价
            $(_pageId + ".sj").show();
            $(_pageId + ".xj").hide();
            if (isKCB() || isSHstockOrFund()) {
                $(_pageId + " #kcbStockPrice").attr("placeholder", "请输入保护限价").removeAttr("readonly");
                $(_pageId + " .sj").find(".key_place").text("请输入保护限价");
                $(_pageId + " .sj .input_shade").remove();
                stock_html.stockPrice = $(_pageId + " #kcbStockPrice");
            } else {
                $(_pageId + " #kcbStockPrice").attr("placeholder", "市价").attr("readonly", "readonly");
                $(_pageId + " .sj").find(".key_place").text("市价");
                $(_pageId + " .sj").append('<div class="input_shade" style="width:100%;height:100%;position:absolute;z-index:1;"></div>');
            }
            stock_info.market_price = true;
            if (isBuy()) {//买入的时候需要切换最大可买
                $(_pageId + " #maxNumber").hide();
                $(_pageId + " #kcbMaxNumber").show();
                stock_html.stockMaxAmount = $(_pageId + " #kcbMaxNumber");
                setStockInfo("stockMaxAmount", $(_pageId + " #kcbMaxNumber").text(), true);
            }
        }
    }

    /*
	 * 为科创板的代码判断
	 */
    function isKCB() {
        var KCBArray = [];
        if (stock_info.isHq) {
            KCBArray = ["K"];
        } else {
            KCBArray = [15, 16];
        }
        if (KCBArray.indexOf(stock_info.stock_type) != -1) { //科创板
            return true;
        } else {
            return false;
        }
    }
    /**
     * @description 判断是否是债券现券
     * @author cfx
     * @date 2021-09-23 14:56:07
     * @modifyContent 修改点描述...
     */
    function isBondCash(){
        // 如果柜台返回的 bond_cash === '1' 说明是债券现券，以柜台为准
        // 如果柜台返回的 bond_cash_bjs === '1' 说明是北交所债券现券，以柜台为准
        if(stock_info.bond_cash !== null || stock_info.bond_cash_bjs !== null ){
            if(stock_info.bond_cash === '1' || stock_info.bond_cash_bjs === '1'){
                return true;
            }else{
                return false;
            }
        }
        if(secondTypeArrBySH.indexOf(stock_info.second_type) > -1 || secondTypeArrBySZ.indexOf(stock_info.second_type) > -1){
            return true;
        }else{
            return false;
        }
    }
    /**
     * @description 判断是否是京A股票
     * @author cfx
     * @date 2021-09-23 14:56:07
     * @modifyContent 修改点描述...
     */
    function isBJ(result){
      if(result.stock_type === '22' && result.bjs_rights === '0'){
        common.iConfirm("温馨提示", result.bjs_rights_prompt, function success() {
          if (global.callNative && global.isSso) {
            var moduleName = + new Date();
            $.callMessage({
                "funcNo": "50115",
                "loadModuleName": "ygt",
                "moduleName": moduleName,
                "url": global.ygtUrl + "/new/ygt/index.html#!/bzjyOpen/index.html?isFromApp=true&moduleName=" + moduleName,
                "statusColor": "#EE4034",//状态栏颜色
                "isShowLoading": "1",
                "targetModule": "trade"
            });
          }
        }, function fail() {
        }, "开通权限", "取消");
      }
    }

    // 北证、三板，下拉框有展示不支持下拉
    function isThirdStock(exchange_type,stockType){
        // 行情返回的stockType列表
        var type_map = [17,31,32,33,34,35,36,37,38,39,40,41,42];
        if(exchange_type == "9" || exchange_type == "A" || type_map.indexOf(stockType) >= 0) {
            $(_pageId + " .kcb_trade_form #entrustWay").unbind("click");
            $(_pageId + " .kcb_trade_form #entrustWay").addClass("unBind");
            stock_info.isThirdBoard = true;
        }else{
            $(_pageId + " .kcb_trade_form #entrustWay").removeClass("unBind");
        }
    }
    /*
	 * 科创板权限提示
	 */
    function kcbConfirm(stock_type, kcb_receipt_rights1, kcb_receipt_rights2) {
        //科创板权限
        if (kcb_receipt_rights1 != "0" && (stock_type == "15" || stock_type == "16")) {
            common.iConfirm("温馨提示", "您尚未开通普通交易账户科创板权限，如需进行交易，请到业务办理完成对应权限开通。", function success(html) {
                if (global.callNative && global.isSso) {
                    var param = {
                        "funcNo": "50500",
                        "msgNo": "123",
                        "sourceModule": "",
                        "targetModule": "tradeDispatcher",
                        "action": "1",
                        "param": {
                            "business_type": "0",//普通0  两融1
                            "event": "2",//打开权限开通页面
                            "title": "",
                        }
                    }
                    $.callMessage(param);
                }
            }, function fail() {
            }, "开通权限", "取消");
        }
        //科创板存托凭证权限
        else if (kcb_receipt_rights2 != "0" && stock_type == "16") {
            $.alert("您尚未开通科创板存托凭证股东账号权限，如需进行交易，请到业务办理完成对应权限开通。");
        }
    }


    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        var typeText = "买入";
        if (!isBuy()) {
            typeText = "卖出";
        }
        //验证股票代码输入是否正确
        var stockCode = stock_info.stockCode;
        if (stockCode.length == 0) {
            $.alert("请输入股票代码");
            return false;
        }
        var vai1 = /^[0-9]{6}$/;
        if (!vai1.test(stockCode)) {
            $.alert("股票代码输入错误");
            return false;
        }
        //验证股票价格输入是否正确
        var stockPrice = getStockInfo("stockPrice");
        if ($.trim(stockPrice).length <= 0) {
            if (stock_info.market_price && (isKCB() || isSHstockOrFund())) {//科创板市价委托 | 沪市的股票或者基金
                $.alert("请输入保护限价");
            } else {
                $.alert("请输入" + typeText + "价格");
            }
            return false;
        } else if (!validatorUtil.isNumberFloat(stockPrice)) {
            $.alert("请正确输入价格");
            return false;
        }
        var stockMaxAmount = stock_info.stockMaxAmount + "";
        //验证买入数量
        var stockNum = getStockInfo("stockNum");
        if ($.trim(stockNum).length <= 0) {
            $.alert("请输入" + typeText + "数量");
            return false;
        } else if (!validatorUtil.isNumberFloat(stockNum)) {
            $.alert("请正确输入数量");
            return false;
        } else if (parseFloat(stockNum) <= 0) {
            $.alert("数量必须大于0");
            return false;
        }

        // if(isBuy()){
        //     isST(stockCode,typeText,stockMaxAmount,stockNum,stockPrice);
        // }else{
        //     buy(typeText,stockMaxAmount,stockNum,stockPrice,stockCode);
        // }
        buy(typeText,stockMaxAmount,stockNum,stockPrice,stockCode);
    }

    /******
     * 购买
     * @returns {boolean}
     */
    function buy(typeText,stockMaxAmount,stockNum,stockPrice,stockCode) {
        var ts = [];
        //验证最大可买
        if ($.trim(stockMaxAmount).length <= 0 || parseFloat(stockMaxAmount) <= 0) {
            ts.push("<em>最大可" + typeText + "为0；</em>");
        }
        else if (parseFloat(stockMaxAmount) < parseFloat(stockNum)) {
            ts.push("<em>最大可" + typeText + "数量不足；</em>");
        }
        if(!isBondCash(stock_info)){
            $.alert("非债券现券，不支持债券现券匹配成交，请前往普通交易模块进行买卖委托");
            return ;
        }

        var isMax = false;// 是否满足最大可委托数的提示
        var lots_of = stock_info.lot_size;
        if (isBuy()) {
            if (isKCB()) {//为科创板代码的判断
                if (stock_info.market_price) {//买入市价委托
                    if (stockNum > 50000) {
                        ts.push("<em>市价买入超过5万股；</em>");
                        isMax = true;
                    }
                    else if (stockNum < 200) {
                        ts.push("<em>市价买入低于200股；</em>");
                    }
                } else {
                    if (stockNum > 100000) {
                        ts.push("<em>限价买入超过10万股；</em>");
                        isMax = true;
                    }
                    else if (stockNum < 200) {
                        ts.push("<em>限价买入低于200股；</em>");
                    }
                }
            } else {
                if (stockNum % Number(lots_of) != 0) {
                    // 新规债券
                    if(isBondCash()){
                        ts.push("<em>债券交易面额应为10万元或其整数倍，对应委托数量应为1000张或其整数倍</em>");
                    }else{
                        ts.push("<em>买入数量应为" + lots_of + "的整数倍；</em>");
                    }
                }
                else if (stockNum > 1000000) {
                    // 新规债券
                    if(isBondCash()){
                        if( stockNum >= 100000000){
                            ts.push("<em>债券交易面额不能超过100亿元，对应的委托数量必须小于1亿张；</em>");
                            isMax = true;
                        }
                    }else{
                        ts.push("<em>买入数量必须小于或等于100万股；</em>");
                        isMax = true;
                    }
                }
            }
        } else {
            if (isKCB()) {//为科创板代码的判断
                if (($.trim(stockMaxAmount).length <= 0 || parseFloat(stockMaxAmount) < 200) && (stockNum < stockMaxAmount)) {
                    ts.push("<em>可卖数不足200股，需一次性委托卖出；</em>");
                }
                if (stock_info.market_price) {//卖出市价委托
                    if (stockNum > 50000) {
                        ts.push("<em>市价卖出超过5万股；</em>");
                        isMax = true;
                    }
                } else {
                    if (stockNum > 100000) {
                        ts.push("<em>限价卖出超过10万股；</em>");
                        isMax = true;
                    }
                }
            } else {
                if (stockNum != stockMaxAmount && stockNum % Number(lots_of) != 0) {
                    // 新规债券
                    if(isBondCash()){
                        ts.push("<em>债券交易面额应为10万元或其整数倍，对应委托数量应为1000张或其整数倍</em>");
                    }else{
                        ts.push("<em>卖出数量应为" + lots_of + "的整数倍；</em>");
                    }
                }
            }
        }

        if (["f", "p"].indexOf(stock_info.stock_type) >= 0) {// 创业板改革下单股票统一判断
            if (!isMax && !stock_info.market_price && Number(stockcode_entrust_info.hight_amount) && Number(stockNum) > Number(stockcode_entrust_info.hight_amount)) {// 限价委托
                ts.push("<li class='ared'>创业板股票限价买卖单笔不得超过" + Number(stockcode_entrust_info.hight_amount) / 10000 + "万股，强制委托可能失败</li>");
            }
            if (!isMax && stock_info.market_price && Number(stockcode_entrust_info.market_high_amount) && Number(stockNum) > Number(stockcode_entrust_info.market_high_amount)) {// 市价委托
                ts.push("<li class='ared'>创业板股票市价买卖单笔不得超过" + Number(stockcode_entrust_info.market_high_amount) / 10000 + "万股，强制委托可能失败</li>");
            }
        }

        if (isBuy() && ["7","18", "19"].indexOf(stock_info.stock_type) >= 0 && stock_info.convertible_bonds_prompt) {// 18科创板可转债、19科创板CDR可转债
            ts.push(stock_info.convertible_bonds_prompt)
        }

        var up_stop = null;
        var down_stop = null;
        if (!stock_info.market_price || isKCB()) {
            up_stop = stock_info.upStop;
            down_stop = stock_info.downStop;
        }
        var entrust_bs = "0";
        var tipStrArray = [];
        var tipStr = "<div >";
        tipStrArray.push(["<span style='font-size:" + $.getTransformScaleFontSize(stock_info.stockName, 16, $(window).width() * 0.48) + "px;'>" + stock_info.stockName +  "</span>", stockCode]);
        tipStrArray.push(["买卖方向", orderName[_orderType]]);
        if (stock_info.market_price) {
            if (!stock_html.market_p.attr("id")) {
                $.alert("请选择委托方式", function () {

                });
                return false;
            }
            entrust_bs = stock_html.market_p.attr("type");

            tipStrArray.push(["委托方式", "<em style='font-size:" + $.getTransformScaleFontSize(stock_html.market_p.text(), 16, $(window).width() * 0.48) + "px;'>" + stock_html.market_p.text() +  "</em>"]);
            if (isKCB() || isSHstockOrFund()) {
                tipStrArray.push(["保护限价", stockPrice]);
            } else {
                stock_price = "0.01";
            }
            // //选择市价委托的时候委托价格买是涨停，卖是跌停
            // if(isBuy()){
            // 	stockPrice=stock_info.upStop;
            // }else{
            // 	stockPrice=stock_info.downStop;
            // }
        } else {
            if (bond_repurchase_flag == "0") {//国债回购标志：bond_repurchase_flag
                tipStrArray.push(["委托价格", stockPrice]);
            } else if (bond_repurchase_flag == "1") {
                tipStrArray.push(["年化收益", stockPrice]);
                tipStrArray.push(["实际占款天数", fund_used_days]);
            }
        }
        // 判断是否是债券
        var stockNumUnit = '';
        if ($.inArray(stock_info.stockType, bondTypeArr) != -1 || $.inArray(stock_info.second_type,bondTypeSecond) != -1) {
            stockNumUnit = ' 张';
        }
        tipStrArray.push(["委托数量", stockNum + stockNumUnit]);
        // 如果是新规债券
        if(isBondCash() || stock_info.stockType === 27 || stock_info.stockType === 23){
            tipStrArray.push(["委托金额", stock_info.transResTotal]);
            tipStrArray.push(["债券面额", common.numToMoneyType(stockNum * 100)]);
        }
        var msg = "";
        // 2021.12.28 个股的交易风险提示需求屏蔽这里的提示
        // if (isBuy()) {
        //     if (is_delisting == "1") {//退市股票
        //         msg = delisting_msg;
        //     }
        // }
        if (up_stop && up_stop != "--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)) {
            ts.push("<em>委托价格超过涨停价；</em>");
        } else if (down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)) {
            ts.push("<em>委托价格低于跌停价；</em>");
        }
        //		if(up_stop && up_stop !="--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)){
        //			tipStr += "<div><span style=\"font-size: 15px;margin: 0 20px;color: #D93335;display: inline-block;line-height: 18px;\">委托价格超过涨停价，交易可能不会成功</span><br><span>确定"+orderName[_orderType]+"该证券？</span></div>";
        //		}else if(down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)){
        //			tipStr += "<div><span style=\"font-size: 15px;margin: 0 20px;color: #D93335;display: inline-block;line-height: 18px;\">委托价格低于跌停价，交易可能不会成功</span><br><span>确定"+orderName[_orderType]+"该证券？</span></div>";
        //		}
        tipStr += common.generatePrompt(tipStrArray, msg);
        tipStr += "</div>";
        if (ts.length) {
            if(ts.length > 1){
                for(var i = 0; i < ts.length; i++){
                    ts[i] = '<p>'+(i+1) + '.' + ts[i] + '</p>';
                }
            }else{
                ts[0] = '<p>' + ts[0] + '</p>';
            }
            tipStr += "<div class='pop_reminder_text'><h4>温馨提示</h4>" + ts.join("") + "</div>";
        }


        //埋点数据
        var comStatParam = {
            "objectId": isBuy() ? "100077" : "100109",
            "actionId": "3",
            "i_entrust_bs": isBuy() ? "1" : "2", // 交易方向( 1,买入 2,卖出)
            "i_stock_code": stockCode, // 股票代码
            "i_stock_name": stock_info.stockName, // 股票名称
            "i_entrust_prop": "", // 委托属性
            "i_exchange_type": stock_info.exchange_type, // 交易市场
            "i_entrust_price": stockPrice, // 选择后的价格
            "i_entrust_amount": stockNum, // 委托数量
        }

        // 2021.12.28 个股的交易风险提示需求屏蔽这里的提示 stock_info.delist_flag == "1" && stock_info.delist_info
        if (!isBuy()) {
            entrust_bs = (Number(entrust_bs) + 1) + "";
        }
        var cust_code = userInfo.cust_code;	//客户代码
        var fund_account = userInfo.fund_account;	//资产账户
        var branch_no = userInfo.branch_no;	//分支机构
        var sessionid = userInfo.session_id;
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var exchange_type = stock_info.exchange_type;
        var stock_account = stock_info.stock_account;
        var stock_code = stockCode;
        var entrust_price = stockPrice;
        var entrust_amount = stockNum;
        var business_type = "0";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "exchange_type": exchange_type,
            "fund_name": stock_info.stockName,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "entrust_amount": entrust_amount,
            "business_type": business_type,
            "leavesTraceFlag": true,//基金协议是否留痕，true不留痕
            "isSellOrder":!isBuy(),
            "stock_type_reits":stock_info.stock_type
        };
        appropriate.placeOrder(comStatParam, param, tipStr, function (instr_batch_no) {
            param.instr_batch_no = instr_batch_no;
            service_stock.getBondBuy(param, getStockBuyCallBack, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            if (isBuy()) {
                stock_info.create_by = stock_info.create_by || $.getUUID();
                appropriate.function399932(stock_info)
            }
            $.showPreloaders("请等待...");
        }, !isBuy());
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        $.hidePreloader();
        var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                $.alert(tipStr);
                stock_info.entrust_no = results[0].entrust_no;
                if (isBuy()) {
                    appropriate.function399932(stock_info)
                }
                clearBuyMsg();
                setStockInfo("stockCode", "");// 股票价格
                $(_pageId + " #stockCode").addClass("C100");
            }
        } else {
            $.alert(tipStr);
            clearBuyMsg();
            setStockInfo("stockCode", "");// 股票价格
            $(_pageId + " #stockCode").addClass("C100");
        }
        queryHolding();
    }

    /**
     * 查询持仓数据
     */
    function queryHolding() {
        pageGlobal.holdData = "";
        queryHoldings();
        _callback = false;
        if (position_timer == null && global.positionRefreshTime) {
            position_timer = window.setInterval(function () {
                if (commonFunc.getTradingTime() && _callback && common.isAppFlag()) {
                    queryHoldings(true);
                    _callback = false;
                }
            }, global.positionRefreshTime);//定时刷新
        }
    }

    /**
     * 查询持仓数据
     */
    function queryHoldings(isShowWait) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
        };
        service_stock.queryBondData(param, queryHoldingCallback, {
            "isLastReq": true,
            "isShowWait": isShowWait ? false : true,
            "isShowOverLay": false,
        });
    }


    function queryHoldingCallback(data) {
        pageGlobal.holdData = data;
        _callback = true;
        // var html = '<tr><th>证券/市值</th><th>盈亏/比例</th><th>持仓/可用</th><th>成本/现价</th></tr>';
        // $(_pageId + " .fund_table2 div.ce_table thead").html(html);
        $(_pageId + " .no_data").show();
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                html = "";
                if (results && results.length > 0) {
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryHoldingHTML_stock(results[i], i);
                    }
                    $(_pageId + " .fund_table2 div.ce_table tbody").html(html);
                    $(_pageId + " .no_data").hide();
                    //卖出事件
                    $.bindEvent($(_pageId + " .fund_table2 .ce_table tbody tr"), function (e) {
                        clearBuyMsg();// 清楚数据
                        var stockCode = $(this).attr("id");
                        _stockCode = stockCode;
                        $(_pageId + " #stockCode").removeClass("C100");
                        $(_pageId + " #stockCode").quzhi(stockCode);
                        var stock_account = $(this).attr("stock_account");
                        var stockName = $(this).attr("stock_name");
                        var stockCode = $(this).attr("id");
                        var exchange_type = $(this).attr("exchange_type");
                        var exchange_type_name = $(this).attr("exchange_type_name");
                        stock_info.stock_account = stock_account;
                        stock_info.exchange_type = exchange_type;
                        stock_info.stockName = stockName;
                        getStockList(stockCode,commonHq.getHqMarket(exchange_type),exchange_type);
                        $(_pageId + " .main").scrollTop(0);
                        //埋点
                        var stockName = $(this).find("strong").html();
                        var objectId = "", actionId = "";
                        if (isBuy()) {
                            objectId = 100078;
                            actionId = 104;
                        } else {
                            objectId = 100110;
                            actionId = 104;
                        }
                        common.comStat(objectId, 2, actionId, true, {
                            "i_change_name": "持仓列表",
                            "i_change_to": stockName
                        });
                        e.stopPropagation();

                    }, "tap");
                }
            } else {
                $.alert(data.error_info);
            }
        }
        _queryHolding = true;
        if (_initScroller) {
            _initScroller();
        }
    }


    /**
     * 证券持仓HTML生成
     */
    function queryHoldingHTML_stock(element) {
        var price_digit = 3;
        var css = "";
        var float_yk = Number(element.float_yk);//浮动盈亏
        if (float_yk > 0) {
            css = "ared";
        } else if (float_yk < 0) {
            css = "agreen";
        }
        //浮动盈亏比例
        var css1 = "";
        if (Number(element.float_yk_per) > 0) {
            css1 = "ared";
        } else if (Number(element.float_yk_per) < 0) {
            css1 = "agreen";
        }
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;

        float_yk = float_yk.toFixed(price_digit);
        var eleHtml = "";
        var marketValue = Number(element.market_value).toFixed(price_digit),
            stockName = element.stock_name,
            float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
            cost_amount = Number(element.cost_amount),
            enable_amount = Number(element.enable_amount),
            cost_price = Number(element.cost_price).toFixed(price_digit),
            last_price = Number(element.last_price).toFixed(price_digit);
        eleHtml += "<tr stock_account=\"" + element.stock_account + "\" exchange_type=\"" + element.exchange_type + "\" id=\"" + element.stock_code+"\" stock_name=\""+element.stock_name+"\">";
        eleHtml += '<td><p style="transform-origin: left;transform:scale('+$.getTransformScale(stockName, 16, maxWidth + 5)+')">' + stockName + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(marketValue, 16, maxWidth) + 'px;">' + marketValue + '</p></td>';
        eleHtml += '<td><p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(float_yk, 16, maxWidth) + 'px;">' + float_yk + '</p>';
        eleHtml += '<p class="' + css1 + '" style="font-size:' + $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) + 'px;">' + float_yk_per + '</p></td>';
        eleHtml += '<td><p style="font-size:' + $.getTransformScaleFontSize(cost_amount, 16, maxWidth) + 'px;">' + cost_amount + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(enable_amount, 16, maxWidth) + 'px;">' + enable_amount + '</p></td>';
        eleHtml += '<td><p style="font-size:' + $.getTransformScaleFontSize(cost_price, 16, maxWidth) + 'px;">' + cost_price + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(last_price, 16, maxWidth) + 'px;">' + last_price + '</p></td>';
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 查询股东账号
     */
    function queryStockAccountList() {
        stockAccountList = [];
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
            "account_type": userInfo._loginClass,
            "buy_flag": "1"
        };
        service_common.queryStockAccountList(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        stockAccountListCallBack(results);
                        stockAccountList = results;
                    } else {
                        $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                    }
                } else {
                    $.alert(data.error_info);
                    $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                }
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }, "errorFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }
        });
    }

    /*
	 * 股东账号查询回调、联动后筛选出对应市场的股东账号回调
	 */
    function stockAccountListCallBack(results, type, typeAccount) {
        var html = "";
        if (type) {
            for (var i = 0; i < results.length; i++) {
                if (results[i].exchange_type == type) {
                    var mainFlag = results[i].main_flag;
                    mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                    html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                    html += '<a href="javascript:void(0);" style="padding-left:0.20rem;">';
                    html += ''+results[i].exchange_type_name+'<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                    html += '</li>';
                }
            }
        } else {
            for (var i = 0; i < results.length; i++) {
                var mainFlag = results[i].main_flag;
                mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                html += '<a href="javascript:void(0);" style="padding-left:0.20rem;">';
                html += ''+results[i].exchange_type_name+'<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                html += '</li>';
            }
        }
        $(_pageId + " #account_list").html(html);
        if ($(_pageId + " #account_list li").length > 5) {
            $(_pageId + " #account_list").css({"height": "2.2rem", "overflow-y": "scroll"});
        } else {
            $(_pageId + " #account_list").css({"height": (($(_pageId + " #account_list li").length) * 0.44) + "rem"});
        }
        //输入代码后，默认筛选出对应的股东账号，并勾选
        if (type && typeAccount) {
            $(_pageId + "#account_list li").forEach(function (item, index) {
                var stockAccount = $(item).attr("stock_account");
                var exchangeType = $(item).attr("exchange_type");
                if (typeAccount == stockAccount && type == exchangeType) {
                    $(item).addClass("active");
                }
            });
        }
        // 显示隐藏股东账号选择框
        $.bindEvent($(_pageId + " #account"), function (e) {
            if ($(_pageId + "#account_list li") && $(_pageId + "#account_list li").length > 0) {
                $(_pageId + "#account_list").slideToggle();
            } else {
                $(_pageId + "#account_list").hide();
            }
            e.stopPropagation();
        });
        // 股东账号选择
        $.bindEvent($(_pageId + "#account_list li"), function (e) {
            $(_pageId + "#account_list li").removeClass("active");
            $(this).addClass("active");
            var name = $(this).attr("stock_account") + " " + $(this).attr("exchange_type_name");
            $(_pageId + "#account p").html(name);
            stock_info.stock_account = $(this).attr("stock_account");
            stock_info.exchange_type = $(this).attr("exchange_type");
            $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
            $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
            $(_pageId + "#account_list").hide();
            if (stock_info.stockCode) {
                getStockList(stock_info.stockCode);
            }
            e.stopPropagation();
        });
    }


    /**
     *
     */
    function clearBuyMsg() {
        clearMaxNumber = false;
        _PageParam = {};
        entrustWayFunc = null;
        stock_info = ioitStock();
        if (stock_html) {
            //清空canvas图
            $(_pageId + ".kcb_timeshare .row_01 strong").text("");
            $(_pageId + ".kcb_timeshare .row_01 em").text("--").removeClass("agreen").removeClass("ared");
            $(_pageId + "#hqt").html("");
            hqKt.clearCanvasFunc(_pageId);
            hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10, 160);
            canvasJs.minLineFunc([{}], {});
            //		   	if(stock_html.market_div.find("a.current").text() == "市价委托"){
            //			   	stock_info.market_price = true;
            //		   	}
            stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 股票名称
            stock_html.stockMarketType.html("");
            stock_html.stockMarketType.hide();
            setStockInfo("stockPrice", "");// 股票价格
            setStockInfo("stockNum", ""); // 股票数量
            setStockInfo("stockMaxAmount", "--");
            stock_html.upStop.text("--"); //涨停价
            stock_html.downStop.text("--");//跌停价
            stock_html.total.text("").hide();
            stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
            stock_html.buyGear.find("em").text("--");
            stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
            stock_html.sellGear.find("em").text("--");
            stock_html.stockList.html("");
            stock_html.stockPrice = $(_pageId + " #stockPrice");//还原科创板的价格框
            stock_html.stockMaxAmount = $(_pageId + " #maxNumber");
            stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
            stock_html.market_div.show();
        }
        if (fifthOrder_timer != null) {
            window.clearInterval(fifthOrder_timer);
        }
        _fifthCallback = true;
        $(_pageId + " .five_box ul li").removeClass("active");
        $(_pageId + " .cdw").text("股");
        $(_pageId + "#account_list li").removeClass("active");
        $(_pageId + "#account p").attr("stock_account", "");
        $(_pageId + "#account p").attr("exchange_type", "");
        $(_pageId + "#account p").html('<em style="color: #ccc;">请选择股东账号</em>');
        stockAccountListCallBack(stockAccountList);
        //还原限价
        $(_pageId + " .kcb_trade_form #entrustWay").unbind("click");
        $(_pageId + " .trade_form .value_btn a:eq(0)").addClass("current").siblings().removeClass("current");
        $(_pageId + " .xj .input_value").show();
        $(_pageId + " .xj").show();
        $(_pageId + " .sj").hide();//屏蔽科创板的价格框
        $(_pageId + " #kcbMaxNumber").hide();
        $(_pageId + " #maxNumber").show();
        $(_pageId + " #maxNumber").quzhi("--");//清空限价的数量框
        $(_pageId + " #kcbMaxNumber").quzhi("--");//清空科创板的数量框
        $(_pageId + " #kcbStockPrice").quzhi("");//清空科创板的价格框
        $(_pageId + " #stockPrice").quzhi("");//清空限价的价格框
        $(_pageId + " #market_list").hide();
        $(_pageId + ".input_text .logoStyle").hide();
        $(_pageId + ".input_text .logoStyle").removeClass("kcbCss").removeClass("cdrCss");
        $(_pageId + ".input_text .logoStyle").text("");
        stock_info.market_price = false;
        stock_info.isHq = false;
        stock_info.chaVentureFlag = "";
        stock_info.issuspend = "";
        $(_pageId + ".row_04 p").removeClass("check");
        $.closeModal(".picker-modal.modal-in");
        stockcode_entrust_info = {// 下单股票委托信息
            hight_amount: 0,
            market_high_amount: 0
        };
        // 清除个股详情页面带过来的参数
        var paramMap = sessionStorage.getItem("_curPage");
        if (paramMap) {
            if (typeof paramMap == 'string') {
                paramMap = JSON.parse(paramMap);
            }
            if (paramMap.params) {
                delete paramMap.params.code;
                delete paramMap.params.market;
                delete paramMap.params.exchange_type;
                delete paramMap.params.stock_account;
                delete paramMap.params.price;
                delete paramMap.params.name;
                delete paramMap.params.num;
                delete paramMap.params.entrust_bs;
                delete paramMap.params.isHold;
                if(paramMap.param){
                    delete paramMap.param.code;
                    delete paramMap.param.exchange_type;
                    delete paramMap.param.market;
                    delete paramMap.param.name;
                    delete paramMap.param.stock_account;
                }
                sessionStorage.setItem("_curPage", JSON.stringify(paramMap));
            }
        }
    }

    function dataDestroy() {
        commonFunc.clearCheckTradeTimer();
        stockAccountList = [];
        $(_pageId + "#account_list").html("");
        $(_pageId + "#account_list").hide();
        $(_pageId + " #stockCode").quzhi("");
        $(_pageId + " #stockCode").addClass("C100");
        _stockCode = "";
        // $(_pageId + " .fund_table2 .ce_table thead").html("");
        $(_pageId + " .fund_table2 .ce_table tbody").html("");
        clearBuyMsg();
        if (position_timer != null) {
            window.clearInterval(position_timer);
        }
        if (stock_html) {
            stock_html.market_div.removeClass("unBind");
            stock_html.hqxltb.removeClass("sl").addClass("xl");
            stock_html.hqCanvas.hide();
        }
        position_timer = null;
        stock_info = null;
        stock_html = null;
        if (keyboard) {
            keyboard.keyDestroy();
        }
        // 退出页面后，销毁弹框
        $("#singleIConfirmNew").remove();
        $("#newTradingTipsBox2").remove();
        
        // 兼容交易页面返回时，委托方式选择不消失的bug
        $(".picker-modal.modal-out").remove();
        $(".modal-overlay").remove();
    }

    function getQueryHolding() {
        return _queryHolding;
    }

    var base = {
        "dataInit": dataInit,
        "elementBindEvent": elementBindEvent,
        "dataDestroy": dataDestroy,
        "getQueryHolding": getQueryHolding
    };
    module.exports = base;
});
