/**
 * 债券现券交易下单
 */
define('trade/scripts/bond/order/consultOrder.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var appropriate = require("appropriate");
    var gconfig = $.config;
    var global = gconfig.global;
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var service_common = require("service_common");
    var service_hq = require("service_hq");
    var service_stock = require("service_stock");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var keyboard = require("keyboard");
    var project = require("project");
    var service_third = require("service_third");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var _pageId = null;
    var _stockCode = null;
    var _orderType = "0";
    // 新规债券上海市场二级类型
    var secondTypeArrBySH = project.constants.secondTypeArrBySH;
    // 新规债券深圳市场二级类型
    var secondTypeArrBySZ = project.constants.secondTypeArrBySZ;
    var settleTypeFunc = null;
    var oppoBondInvestorType = null;
    var myInvestor = null;
    var pageGlobal = {
        "holdData": "",
        "stockType26100": ["6","8","14","19","21","22","23","24","25","26","27","30"]
    };
    /**
     * 数据初始化
     */
    function dataInit(pageId, orderType, market, initScroller) {
        userInfo = common.getCurUserInfo();
        _pageId = pageId;
        _orderType = orderType;
        _stockCode = null;
        stock_info = ioitStock();
        queryStockAccountList();
        queryBondInvestor();
        initHtml();
        settleTypeFunc = commonFunc.nativeSelect("请选择结算方式",["103","104"],["多边净额","逐笔全额"],0);
        oppoBondInvestorType = commonFunc.nativeSelect("请选择对手方交易主体类型",["01","02","03","04"],["自营","资管","机构经纪","个人经纪"],0);
    }


    /**
     * 设置股票对象是信息参数
     */
     function ioitStock() {
        var stockInfo = {
            "isHq": false,
            "stockCode": "", // 债券代码
            "stockName": "", // 债券名称
            "stockPrice": "",// 买入价格
            "stockNum": "",// 买入数量
            "stock_type": "",//债券类型
            "stock_market": "",//市场代码
            "exchange_type": "",//交易市场（交易后台）
            "stock_account": "",// 股东账号
            "cbpconferId": "",// 约定号
            "settleType": "",// 结算方式
            "oppoBondInvestorId": "",// 对方交易主体代码
            "oppoBondInvestorType": "",// 对方交易主体类型
            "traderId": "",// 对方交易员代码
            "oppoBondId": "",// 对方交易商代码
            "stockType": "",//行情类型
            "second_type": "",//行情二级类型
            "bond_cash": null, // 是否是债券现券交易支持的债券分类
            "isBond": false,//是否为债券
        };
        return stockInfo;
    }
    function isBuy() {
        // 1 ，买入  2，卖出
        if(_orderType === "1"){
            return true;
        }else{
            return false;
        }
    }
    function initHtml() {
        stock_html = {
            "stockCode": $(_pageId + " #stockCode"), // 股票
            "stockName": $(_pageId + " #stockCode").next("span"), // 股票名称
            "stockPrice": $(_pageId + " #stockPrice"),// 股票价格
            "stockNum": $(_pageId + " #stockNum"), // 股票数量
            "stockList": $(_pageId + " #stock_list"),// 股票下拉列表
            "cbpconferId": $(_pageId + " #cbpconferId"),// 约定号
            "settleType": $(_pageId + " #settleType"),// 结算方式
            "oppoBondInvestorId": $(_pageId + " #oppoBondInvestorId"),// 对方交易主体代码
            "oppoBondInvestorType": $(_pageId + " #oppoBondInvestorType"),// 对方交易主体类型
            "traderId": $(_pageId + " #traderId"),// 对方交易员代码
            "oppoBondId": $(_pageId + " #oppoBondId"),// 对方交易商代码
            "stockMarketType": $(_pageId + " .ipt_market")
        }
    }

    /*
     * 关于债券的判断
     */
    function bondJudgment() {
        //对债券做提示
        switch (stock_info.stockType) {
            case 6:
            case 21:
            case 22:
            case 23:
            case 24:
            case 14:
            case 25:
            case 26:
            case 27:
            case 30:
                // $.alert("债券品种不支持市价委托");
                stock_info.isBond = true;
                break;
        }
    }

    /**
     * 事件绑定
     */
    function elementBindEvent() {

        //关闭ios键盘
        $.bindEvent($(_pageId), function (e) {
            if (e.target !== document.activeElement) {
                document.activeElement.blur();
            }
        }, "click");

        if (!keyboard) {
            $.bindEvent($(_pageId + " #stockCode"), function (e) {
                stock_html.stockList.show();
                e.stopPropagation();
            });
        }
        //输入时股票代码调键盘
        $.bindEvent($(_pageId + " .select-box"), function (e) {
            var click = e.type || "click";
            if (keyboard) {
                $(_pageId + " div#stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            } else {
                $(_pageId + " #stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            }
            e.stopPropagation();
        });
        // 股票代码输入框监听
        $.bindEvent($(_pageId + " #stockCode"), function (e) { // 该监听方法是为了适配浏览器
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                var stockCode = $(this).val();
                stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
                stockCode = $.trim(stockCode);
                $(this).val(stockCode);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode.length > 4) {
                var vai1 = /^[0-9]+$/;
                if (!vai1.test(stockCode)) {
                    stockCode = stockCode.substring(0, 4);
                    $(_pageId + " #stockCode").quzhi(stockCode);
                }
            }
            if (stockCode.length == 0) {
                clearBuyMsg();
                $(_pageId + ".select-box .jsKey").removeClass("wato");
            } else {
                $(_pageId + ".select-box .jsKey").addClass("wato");
            }
            if (stockCode) {
                if (stockCode != _stockCode) {
                    _stockCode = stockCode;
                    clearBuyMsg();
                    var vai0 = /^[A-Za-z]+$/;
                    var vai1 = /^[\u4e00-\u9fa5]+$/;
                    setStockInfo("stockCode", stockCode, true);
                    if (stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))) { // 当输入的长度大于1 并且为字母的时候
                        getStockList(stockCode); // 查询股票列表
                    } else if (stockCode.length > 2) { // 当输入的长度大于3的时候
                        getStockList(stockCode); // 查询股票列表
                    }
                    $(_pageId + " .kcb_trade_form #entrustWay").removeClass("unBind");
                    handleInput();
                }
            }
            e.stopPropagation();
        }, "input");

        // 下单
        $.bindEvent($(_pageId + " #submitOrder"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            vailSubmitOrder();
        });
        // 买入价格 输入框监听
        $.bindEvent($(_pageId + " #stockPrice"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.stockPrice = val;
            handleInput();
        }, "input");
        // 买入数量(张） 输入框监听
        $.bindEvent($(_pageId + " #stockNum"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            val = val.replaceAll(/([^0-9])/g, "");
            $(_pageId + " #stockNum").quzhi(val);
            stock_info.stockNum = val;
            handleInput();
        }, "input");
        // 约定号 输入框监听
        $.bindEvent($(_pageId + " #cbpconferId"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.cbpconferId = val;
            handleInput();
        }, "input");
        // 对方交易主体代码 输入框监听
        $.bindEvent($(_pageId + " #oppoBondInvestorId"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.oppoBondInvestorId = val;
            handleInput();
        }, "input");
        // 对方交易商代码 输入框监听
        $.bindEvent($(_pageId + " #oppoBondId"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.oppoBondId = val;
            handleInput();
        }, "input");
        // 对手方交易员代码 输入框监听
        $.bindEvent($(_pageId + " #traderId"), function (e) {
            var val = $(this).val();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                val = $.trim(val);
                $(this).val(val);
            }
            stock_info.traderId = val;
            handleInput();
        }, "input");
        // 结算方式
        $.bindEvent($(_pageId + "#settleType"),function(e){
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            settleTypeFunc && settleTypeFunc(function(data,vals,list){
                if(data.status === "0"){
                    stock_info.settleType = vals[data.selectIndex];
                    setStockInfo("settleType", data.dateStr);
                    handleInput();
                }
            });
        });
        // 对方交易主体类型
        $.bindEvent($(_pageId + "#oppoBondInvestorType"),function(e){
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            oppoBondInvestorType && oppoBondInvestorType(function(data,vals,list){
                if(data.status === "0"){
                    stock_info.oppoBondInvestorType = vals[data.selectIndex];
                    setStockInfo("oppoBondInvestorType", data.dateStr);
                    handleInput();
                }
            });
        });
        // 提示
        $.bindEvent($(_pageId + ".icon"), function () { 
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var type = $(this).attr("type");
            var msg = '';
            if(type === "ydh"){
                msg += "<p style='text-indent: 0.32rem;text-align:left;'>当对手方交易主体类型是资管或自营时，约定号非必填；若是个人经纪或机构经纪，约定号需必填，且不允许超过8位。</p>";
            }else{
                msg += "<p style='text-indent: 0.32rem;text-align:left;'>当深市债券现券支持匹配成交时，支持选择多边净额或逐笔全额任一方式结算；若不支持匹配成交，只能选择逐笔全额方式结算。</p>";
            }
            common.singleIConfirm("温馨提示",msg,function(){ },"我知道了");
        });
        // 点击其他位置关闭键盘，隐藏股东账户列表
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + "#account_list").hide();
            e.stopPropagation();
        });

    }
    //行情列表接口有问题是，输入股票是6位数时直接调用交易接口
    function queryData(stockCode,exchangeType) {
        var vai1 = /^[0-9]{6}$/;
        if (vai1.test(stockCode)) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            queryMaxAmount(stockCode,exchangeType);
        }
    }

    //对行情接口返回数据进行处理
    function ListData(data) {
        stock_info.isHq = true;
        var stockVal = data[0]; //股票代码
        stock_info.stockType = data[10];
        stock_info.stock_market = data[9];// 行情中的市场类型
        stock_info.second_type = data[21];// 二级类型
        setStockInfo("stockCode", stockVal, true);
        _stockCode = stockVal;
        setStockInfo("stockName", data[1], true); 
        var typeStr = project.functionBody.getStockType(data);
        if (typeStr) {
            setStockInfo("stockMarketType", typeStr, true); // 股票市场类型
            stock_html.stockMarketType.show();
        }
        bondJudgment();
        //股票联动,查询股票信息，最大可买
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
        queryMaxAmount(stockVal);
    }

    /**
     * 通过输入的字符查询出对应的股票列表
     * @param {Object} stockCode 输入的字符
     */
    function getStockList(stockCode) {
        if (stockCode != "") {
            var type = "";
            if (global.stockType && global.stockType instanceof Array && global.stockType.length != 0) {
                type = global.stockType.join(":");
            }
            var stockStrParam = {
                "q": stockCode,
                "type": type
            };
            stock_html.stockList.html("");
            var vai1 = /^[0-9]{6}$/;
            if (vai1.test(stockCode)) {
                $.showPreloader("请等待...");
            }
            $.clearRequest();
            service_hq.getStockList(stockStrParam, function (data) {
                getStockListCallBack(data, stockCode);
            },
                {
                    "isLastReq": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        queryData(stockCode);
                    }, "errorFunc": function () {
                        queryData(stockCode);
                    }
                });
        }
    }

    function getStockListCallBack(data, stockCode) {
        var StockList = {};
        var vai1 = /^[0-9]{6}$/;
        stock_html.stockList.html("");
        if (data.errorNo == 0) {
            var results = data.results;
            // 显示股票列表
            if (results && results.length > 0) {
                if (results.length == 1 && vai1.test(stockCode)) {
                    if ($.isValue(results[0][19])) results[0][1] = results[0][19]; // 长名称赋值原名称
                    ListData(results[0]);
                    stock_html.stockList.html("");
                } else {
                    $.hidePreloader();
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    var emWidth = 80;
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i][19])) results[i][1] = results[i][19]; // 长名称赋值原名称
                        StockList[(results[i][9] + ":" + results[i][0])] = results[i];
                        var typeStr = project.functionBody.getStockType(results[i]);
                        var subStr = typeStr ? '<dd class="market_type">' + typeStr + '</dd>' : "";
                        var nameText = '<em style="zoom:' + $.getTransformScale(results[i][1], 14, emWidth) + '">' + results[i][1] + '</em>';
                        listHtml += "<li type26100='" + results[i][10] + "' typeStr26100='" + typeStr + "'><a href=\"javascript:void(0);\" style=\"line-height: inherit;display: flex;align-items: center;text-align: center;\">" + subStr + "<strong style=\"font-size:0.15rem\" stock_name=" + results[i][1] + ">" + results[i][0] + "</strong>" + nameText + "</a>";
                        listHtml += "<span style=\"display:none;\">" + results[i][9] + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .select_box ul li"), function (e) {
                        var market1 = $(this).find("span").text();
                        var stockCode = $(this).find("strong").text();
                        if (stockCode.length == 6) {
                            var type = $(this).attr("type26100");
                            if ((pageGlobal.stockType26100).indexOf(type) > -1) {
                                var exchangeType = "";
                                var typeStr = $(this).attr("typeStr26100");
                                if (typeStr.indexOf("沪") > -1) {
                                    exchangeType = typeStr.indexOf("沪B") > -1 ? "3" : "2";
                                } else if (typeStr.indexOf("深") > -1 || type == "8") {
                                    exchangeType = typeStr.indexOf("深B") > -1 ? "1" : "0";
                                }
                                stock_info.exchange_type = exchangeType;
                            }
                        }
                        ListData(StockList[market1 + ":" + stockCode]);
                        stock_html.stockList.html("");
                        StockList = {};
                        e.stopPropagation();
                    });
                }
            } else {
                //输入是股票代码时行情没查到回去联动查询
                if (vai1.test(stockCode)) {
                    queryData(stockCode);
                }
                //输入时股票简拼没查到提示
                var regx = /^[a-zA-Z0-9]{4}$/;
                if (regx.test(stockCode)) {
                    $.alert("没有查询到此股票信息");
                }
            }
        } else {
            queryData(stockCode);
        }
    }


    /**
     * 查询买入可用资金最大可买可卖数量
     * */
    function queryMaxAmount(stockCode,exchangeType) {
        stock_html.stockList.html("");
        $.hidePreloader();
        var stock_price = stock_html.stockPrice.val();
        var entrust_bs = "0";
        if (!isBuy()) {
            entrust_bs = (Number(entrust_bs) + 1) + "";
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var stock_code = stockCode;
        var entrust_price = stock_price;
        var stock_account = stock_info.stock_account || "";
        var exchange_type = stock_info.exchange_type || exchangeType || "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "stock_account": stock_account,
            "newstock_flag": "",
            "exchange_type": exchange_type
        };
        if (param.stock_code == '' || param.stock_code == null) {
            return false;
        }
        service_stock.queryBondConsultMax(param, function (data) {
            $.hidePreloader();
            queryMaxAmountCallBack(data);
            _PageParam = {};
        }, { "isLastReq": true, "isShowWait": true });

    }

    function queryMaxAmountCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                if (results.length == 1) {
                    stock_info.bond_cash = results[0].bond_cash; // 是否是债券现券交易支持的债券分类
                    var en_trade_type = results[0].en_trade_type;
                    if(results[0].stock_code){
                        setStockInfo("stockCode", results[0].stock_code, true);
                    }
                    // 新增获取出参en_trade_type“允许交易方式”：1-匹配成交  2-协商成交  3-点击成交  4-询价成交  5-竞买成交。
                    // 1）若非债券现券，拦截提示：非债券现券，不支持债券现券交易，请确认输入的代码是否正确
                    // 2）若是债券现券但允许交易方式中不包括2，则弹窗提示（仅提示不拦截）：该证券不允许协商成交委托，交易有可能会失败，请确认输入的代码是否正确
                    if(!isBondCash()){
                        $.alert("非债券现券，不支持债券现券协商成交，请前往普通交易模块进行买卖委托");
                    }else if(en_trade_type.indexOf("2") < 0){
                        $.alert("该证券不允许协商成交委托，交易有可能会失败，请确认输入的代码是否正确");
                    }
                    var exchange_type = results[0].exchange_type;
                    stock_info.exchange_type = exchange_type;
                    stock_info.stock_account = results[0].stock_account;
                    if (!stock_info.isHq) {
                        var stock_type = results[0].stock_type;
                        stock_info.stock_type = stock_type;
                    }
                    if (!stock_info.stock_type) stock_info.stock_type = results[0].stock_type;
                    if(stock_info.stock_account){
                        //勾选筛选出的股东账号
                        $(_pageId + "#account p").html(results[0].exchange_type_name + " " + stock_info.stock_account);
                        $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
                        $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
                    }else{
                        $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                    }
                    stockAccountListCallBack(stockAccountList, stock_info.exchange_type, stock_info.stock_account);
                    //名称以联动为准
                    setStockInfo("stockName", results[0].stock_name, true);
                    notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
                    notice_info = results[0].notice_info;//系统提示信息
                } else if (results.length > 1) {
                    $.hidePreloader();
                    var stock_results = results;
                    var selectHeight = 0.44 * results.length;
                    if (results.length >= 5) {
                        selectHeight = 5 * 0.44;
                    }
                    var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var nameText = '<em style="zoom:' + $.getTransformScale(results[i].stock_name, 14, 80) + '">' + results[i].stock_name + '</em>';
                        listHtml += "<li><a href=\"javascript:void(0);\"><strong style=\"font-size:0.15rem\" stock_name=" + results[i].name + ">" + results[i].stock_code + "</strong>" + nameText + "</a>";
                        listHtml += "<span style=\"display:none;\">" + results[i].exchange_type + "</span></li>";
                    }
                    ;
                    listHtml += "</ul>";
                    stock_html.stockList.html(listHtml).show();
                    $.bindEvent($(_pageId + " .select_box ul li"), function (e) {
                        var info = stock_results[$(this).index()];
                        var exchange_type = info.exchange_type;
                        var stockCode = $(this).find("strong").text();
                        stock_html.stockList.html("");
                        // 如果柜台有多条，选择了行情中没有的股票，则清空数据
                        if(commonHq.getHqMarket(exchange_type) !== stock_info.stock_market){
                          clearBuyMsg();// 清除数据
                          stock_info.stockName = $(this).find("em").text();
                        }
                        queryData(stockCode, exchange_type);
                        setStockInfo("stockName", info.stock_name, true);
                        notice_no = info.notice_no;//系统提示信息 为4时，显示弹框
                        notice_info = info.notice_info;//系统提示信息
                        e.stopPropagation();
                    });
                }
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * @description 判断是否是债券现券
     * @author cfx
     * @date 2021-09-23 14:56:07
     * @modifyContent 修改点描述...
     */
    function isBondCash(){
        // 如果柜台返回的bond_cash === '1' 说明是债券现券，以柜台为准
        if(stock_info.bond_cash !== null){
            if(stock_info.bond_cash === '1'){
                return true;
            }else{
                return false;
            }
        }
        if(secondTypeArrBySH.indexOf(stock_info.second_type) > -1 || secondTypeArrBySZ.indexOf(stock_info.second_type) > -1){
            return true;
        }else{
            return false;
        }
    }
    // 校验输入数据
    function verificationInput(){
        var ruls = [
            "stockCode",
            "stock_account",
            "stockPrice",
            "stockNum",
            "settleType",
            "oppoBondInvestorId",
            "oppoBondInvestorType",
            "traderId",
            "oppoBondId"
        ];
        // 当输入内容均不为空时（若对手方是资管或自营时，允许约定号为空），买入/卖出按钮高亮可点击
        if(stock_info.oppoBondInvestorType === "03" || stock_info.oppoBondInvestorType === "04"){
            ruls.push("cbpconferId");
        }
        var flag = true;
        for(var i = 0 ; i < ruls.length;i++){
            if(stock_info[ruls[i]] === ""){
                flag = false;
                break;
            }
        }
        return flag;
    }
    function handleInput(){
        if(verificationInput()){
            $(_pageId + " #submitOrder").removeClass("c-btn-disabled");
        }else{
            $(_pageId + " #submitOrder").addClass("c-btn-disabled");
        }
    }

    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        if($(_pageId + " #submitOrder").hasClass("c-btn-disabled")){
            return;
        }
        //验证股票代码输入是否正确
        var stockCode = stock_info.stockCode;
        if (stockCode.length == 0) {
            $.alert("请输入股票代码");
            return false;
        }
        var vai1 = /^[0-9]{6}$/;
        if (!vai1.test(stockCode)) {
            $.alert("股票代码输入错误");
            return false;
        }
        //验证股票价格输入是否正确
        var stockPrice = getStockInfo("stockPrice");
        if ($.trim(stockPrice).length <= 0) {
            return false;
        } else if (!validatorUtil.isNumberFloat(stockPrice)) {
            $.alert("请正确输入价格");
            return false;
        }
        buy();
    }

    /******
     * 购买
     * @returns {boolean}
     */
    function buy() {
        var entrust_bs = "0";
        var tipStrArray = [];
        var tipStr = "<div >";
        tipStrArray.push(["债券代码", stock_info.stockCode]);
        tipStrArray.push(["债券名称", "<em style='font-size:" + $.getTransformScaleFontSize(stock_info.stockName, 16, $(window).width() * 0.48) + "px;'>" + stock_info.stockName + "</em>"]);
        tipStrArray.push(["申报价格", stock_info.stockPrice]);
        tipStrArray.push(["申报数量", stock_info.stockNum + "张"]);
        tipStrArray.push(["约定号", stock_info.cbpconferId || "--"]);
        tipStrArray.push(["对方交易主体代码", stock_info.oppoBondInvestorId]);
        tipStrArray.push(["对方交易主体类型", $(_pageId + "#oppoBondInvestorType").text()]);
        tipStrArray.push(["对方交易商代码", stock_info.oppoBondId]);
        tipStrArray.push(["对方交易员代码", stock_info.traderId]);
        tipStr += common.generatePrompt(tipStrArray, "");
        tipStr += "</div>";


        //埋点数据
        var comStatParam = {
            "objectId": isBuy() ? "100077" : "100109",
            "actionId": "3",
            "i_entrust_bs": isBuy() ? "1" : "2", // 交易方向( 1,买入 2,卖出)
            "i_stock_code": stockCode, // 股票代码
            "i_stock_name": stock_info.stockName, // 股票名称
            "i_entrust_prop": "", // 委托属性
            "i_exchange_type": stock_info.exchange_type, // 交易市场
            "i_entrust_price": stockPrice, // 选择后的价格
            "i_entrust_amount": stockNum, // 委托数量
        }

        var typeText = "买入申报确认";
        if (!isBuy()) {
            entrust_bs = (Number(entrust_bs) + 1) + "";
            typeText = "卖出申报确认";
        }
        var cust_code = userInfo.cust_code;	//客户代码
        var fund_account = userInfo.fund_account;	//资产账户
        var branch_no = userInfo.branch_no;	//分支机构
        var sessionid = userInfo.session_id;
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var exchange_type = stock_info.exchange_type;
        var stock_account = stock_info.stock_account;
        var stock_code = stock_info.stockCode;
        var entrust_price = stock_info.stockPrice;
        var entrust_amount = stock_info.stockNum;
        var business_type = "0";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_bs": entrust_bs,
            "exchange_type": exchange_type,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "entrust_amount": entrust_amount,
            "business_type": business_type,
            "oppo_trader_id": stock_info.traderId,
            "oppo_bond_investor_id": stock_info.oppoBondInvestorId,
            "cbpconfer_id": stock_info.cbpconferId,
            "settle_type": stock_info.settleType,
            "isSellOrder":!isBuy(),

        };
        appropriate.placeOrder(comStatParam, param, tipStr, function (instr_batch_no) {
            param.instr_batch_no = instr_batch_no;
            service_stock.getBondConsultBuy(param, getStockBuyCallBack, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            if (isBuy()) {
                stock_info.create_by = stock_info.create_by || $.getUUID();
                appropriate.function399932(stock_info)
            }
            $.showPreloaders("请等待...");
        }, !isBuy(),typeText);
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        $.hidePreloader();
        var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                $.alert(tipStr);
                stock_info.entrust_no = results[0].entrust_no;
                if (isBuy()) {
                    appropriate.function399932(stock_info)
                }
                clearBuyMsg();
                setStockInfo("stockCode", "");// 股票价格
            }
        } else {
            $.alert(tipStr);
            clearBuyMsg();
            setStockInfo("stockCode", "");// 股票价格
        }
    }


    /**
     * 查询股东账号
     */
    function queryStockAccountList() {
        stockAccountList = [];
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
            "account_type": userInfo._loginClass,
            "buy_flag": "1"
        };
        service_common.queryStockAccountList(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        var accounts = [];
                        // 沪A深A交易状态正常的股东户 不限制主副
                        results.forEach(function(item){
                            if((item.holder_kind === "0" || item.holder_kind === "4") && item.holder_status === "0" && (item.exchange_type === "2" || item.exchange_type === "0")){
                                accounts.push(item);
                            }
                        });
                        stockAccountListCallBack(accounts);
                        stockAccountList = accounts;
                    } else {
                        $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                    }
                } else {
                    $.alert(data.error_info);
                    $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                }
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }, "errorFunc": function () {
                $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
                $.hidePreloader();
            }
        });
    }

    /**
     * 交易商/交易员信息查询
     */
    function queryBondInvestor(){
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
        };
        service_stock.queryBondInvestor(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results[0];
                    var investorDict = {
                        "01": "自营",
                        "02": "资管",
                        "03": "机构经纪",
                        "04": "个人经纪",
                    };
                    myInvestor = results;
                    $(_pageId + "#bond_investor_id").html(results.bond_investor_id);
                    $(_pageId + "#bond_investor_type").html(investorDict[results.bond_investor_type]);
                    $(_pageId + "#agency_no").html(results.agency_no);
                    $(_pageId + "#trader_id").html(results.trader_id);
                } else {
                    $.alert(data.error_info);
                }
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
    }

    /*
     * 股东账号查询回调、联动后筛选出对应市场的股东账号回调
     */
    function stockAccountListCallBack(results, type, typeAccount) {
        var html = "";
        if (type) {
            for (var i = 0; i < results.length; i++) {
                if (results[i].exchange_type == type) {
                    var mainFlag = results[i].main_flag;
                    mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                    html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                    html += '<a href="javascript:void(0);">';
                    html += '' + results[i].exchange_type_name + '<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                    html += '</li>';
                }
            }
        } else {
            for (var i = 0; i < results.length; i++) {
                var mainFlag = results[i].main_flag;
                mainFlag = mainFlag == "1" ? "(主)" : "(副)";
                html += '<li stock_account="' + results[i].stock_account + '" exchange_type="' + results[i].exchange_type + '" exchange_type_name="' + results[i].exchange_type_name + '">';
                html += '<a href="javascript:void(0);"">';
                html += '' + results[i].exchange_type_name + '<strong style="font-size:0.15rem;margin-left: 0.1rem;">' + results[i].stock_account + '</strong>' + mainFlag + '</a>';
                html += '</li>';
            }
        }
        $(_pageId + " #account_list").html(html);
        if ($(_pageId + " #account_list li").length > 5) {
            $(_pageId + " #account_list").css({ "height": "2.2rem", "overflow-y": "scroll" });
        } else {
            $(_pageId + " #account_list").css({ "height": (($(_pageId + " #account_list li").length) * 0.44) + "rem" });
        }
        //输入代码后，默认筛选出对应的股东账号，并勾选
        if (type && typeAccount) {
            $(_pageId + "#account_list li").forEach(function (item, index) {
                var stockAccount = $(item).attr("stock_account");
                var exchangeType = $(item).attr("exchange_type");
                if (typeAccount == stockAccount && type == exchangeType) {
                    $(item).addClass("active");
                }
            });
        }
        // 显示隐藏股东账号选择框
        $.bindEvent($(_pageId + " #account"), function (e) {
            if ($(_pageId + "#account_list li") && $(_pageId + "#account_list li").length > 0) {
                $(_pageId + "#account_list").slideToggle();
            } else {
                $(_pageId + "#account_list").hide();
            }
            e.stopPropagation();
        });
        // 股东账号选择
        $.bindEvent($(_pageId + "#account_list li"), function (e) {
            $(_pageId + "#account_list li").removeClass("active");
            $(this).addClass("active");
            var name = $(this).attr("exchange_type_name") + " " + $(this).attr("stock_account");
            $(_pageId + "#account p").html(name);
            stock_info.stock_account = $(this).attr("stock_account");
            stock_info.exchange_type = $(this).attr("exchange_type");
            $(_pageId + "#account p").attr("stock_account", stock_info.stock_account);
            $(_pageId + "#account p").attr("exchange_type", stock_info.exchange_type);
            $(_pageId + "#account_list").hide();
            e.stopPropagation();
        });
    }

    /**
     * 获取股票信息
     * @param {Object} param 对应id名的值
     * @param {Object} newest 是否不同步
     */
     function getStockInfo(param, newest) {
        if (stock_html) {
            var data = stock_html[param].quzhi();
            //		var data = stock_html[param].val() || stock_html[param].text();
            if (newest && stock_info) {
                if (!data || data == "--") {
                    stock_info[param] = 0;
                } else {
                    stock_info[param] = data;
                }
            }
            return data;
        } else {
            return '';
        }
    }

    /**
     * 设置股票信息的值 可以为对象
     * @param {Object} key 输入字符串支持单个，输入对象支持全部
     * @param {Object} value 只支持单个字符串的值
     * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
     */
    function setStockInfo(key, value, newest) {
        if (stock_html) {
            stock_html[key].quzhi(value);
            if (key == "stockName") {
                //股票名称长度过长缩放
                var fontSize = $.getTransformScaleFontSize(value, 16, 150);
                stock_html[key].css({
                    "font-size": fontSize + "px",
                    "margin-left": "10px",
                });
                $(_pageId + ".select-box .jsKey").addClass("wato");
            }
            if (newest && stock_info) {
                if (value == "--") {
                    value = 0;
                }
                stock_info[key] = value;
            }
        }
    }

    /**
     *
     */
    function clearBuyMsg() {
        stock_info = ioitStock();
        setStockInfo("stockName", "", true);
        setStockInfo("stockMarketType", "", true);
        if(stockAccountList.length > 0){
            $(_pageId + "#account p").html('<em style="color: #ccc;">请选择股东账号</em>');
        }else{
            $(_pageId + "#account p").html('<em style="color: #ccc;">没有对应的股东账号</em>');
        }
        $(_pageId + "#account p").attr("stock_account", "");
        $(_pageId + "#account p").attr("exchange_type", "");
        $(_pageId + ".select-box .jsKey").removeClass("wato");
        $(_pageId + "#settleType").html('<em>请选择结算方式</em>');
        $(_pageId + "#oppoBondInvestorType").html('<em>请选择对手方交易主体类型</em>');
        $(_pageId + "#account_list").hide();
        $(_pageId + " #submitOrder").addClass("c-btn-disabled");
        stock_html.stockMarketType.hide();
        stock_html.stockList.hide();
        stock_html.stockPrice.quzhi("");
        stock_html.stockNum.quzhi("");
        stock_html.cbpconferId.quzhi("");
        stock_html.oppoBondInvestorId.quzhi("");
        stock_html.oppoBondId.quzhi("");
        stock_html.traderId.quzhi("");
    }

    function dataDestroy() {
        clearBuyMsg();
        stock_info = null;
        $(_pageId + "#account p").html('<em style="color: #ccc;">请选择股东账号</em>');
        stock_html = null;
        myInvestor = null;
        settleTypeFunc = null;
        oppoBondInvestorType = null;
        _stockCode = "";
        $(_pageId + " #account_list").html("");
        $(_pageId + " #stockCode").quzhi("");
        if (keyboard) {
            keyboard.keyDestroy();
        }
        // 退出页面后，销毁弹框
        $("#singleIConfirmNew").remove();
        $("#newTradingTipsBox2").remove();
    }

    var base = {
        "dataInit": dataInit,
        "elementBindEvent": elementBindEvent,
        "dataDestroy": dataDestroy,
    };
    module.exports = base;
});
