/**
 * 债券现券交易-匹配买入
 */
define('trade/scripts/bond/stockBuy.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var bondOrder = require("bondOrder");
	var common = require("common");
	var _pageId = "#bond_stockBuy ";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var mainHeight = null;
	var _load = false;
	var height_table = null;
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight(function(){
			if(myScroller)
			{
				myScroller.destroy();
				myScroller = null;
			}
		});
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),function(pageCode,topage){
			$.pageInit(pageCode,topage,$.getPageParam(),'',true);
		});
		mainHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
        _load = true;
        height_table = mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".lr").outerHeight(true) - $(_pageId + ".fund_table2").css("margin-top").slice(0, -2);
        heightChange();
        if(bondOrder.getQueryHolding()){
	        initScroller();
        }
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		var orderType = "1"; // 1 ，买入  2，卖出
		bondOrder.dataInit(_pageId,orderType,true,initScroller);
		bondOrder.elementBindEvent();
	}
	
	/*
	 * 进入二级菜单隐藏tabbar有时不是同步导致高度获取不对
	 */
	function heightChange(){
		$(_pageId + ".ce_btn div.order").css({"padding-top": "3px","line-height":"14px","width":$(_pageId + ".ce_btn a").width(),"display":"inline-block"});
		$(_pageId + ".ce_btn #total").css("display","inline-block");
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		height_table = mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".lr").outerHeight(true) - $(_pageId + ".fund_table2").css("margin-top").slice(0, -2);
		$(_pageId + " #wrapper").height(height_table);
		if(_load){
			var scrollOptions = {
				scrollerHeight: height_table, // 滚动组件的高度
				$wrapper: $(_pageId + " #wrapper"),
				scrollbars: true, // 隐藏滚动条
				hasPullDown: false, // 是否显示下拉提示，默认 true
				hasPullUp: false, // 是否显示上拉提示，默认 true
				bounceTime: 300 // 回弹的动画时间
			};
			if(!myScroller)
			{
				myScroller = iscrollUtils.vScroller(scrollOptions);
			}
			else
			{
				myScroller.refresh();
			}
		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		bondOrder.dataDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
