/**
 * 债券现券交易-撤单
 */
define('trade/scripts/bond/stockCancel.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var vIscrollHeight = null;
    var service_stock = require("service_stock");
    var _pageId = "#bond_stockCancel ";
    var userInfo = null;
    var stock_code = "";
    var stock_num = "";
    var stock_direction = "";
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        userInfo = common.getCurUserInfo();
        $(_pageId + ".no_more_data").hide();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mianHeight - $(_pageId + ".tab_nav").height();
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }
    function backgroundInterface() {
        queryCancellation(); // 可撤单查询
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });
    }

    /**
     * 可撤单查询
     */
    function queryCancellation() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        // 每次查询前,先将暂无数据隐藏
        $(_pageId + ".no_data").hide();
        // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
        service_stock.queryBondTrustData(param, queryTrustDataCallback,
            { // 传给接口的json格式数据            
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /**
     * 可撤单查询回调
     */
    function queryTrustDataCallback(data) {
        if (typeof (data) != undefined && typeof (data) != null) {
            //			$(_pageId + ".search_table .ce_table").html("");
            $(_pageId + ".main .cancel_order").html("");
            $(_pageId + ".no_more_data").hide();
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var data = "";

                    var html = "<tr><th>证券/时间</th><th>委托/成交价</th><th>委托/成交量</th><th>类型/状态</th></tr>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    $(_pageId + ".j-position-table table").html(html);
                    $(_pageId + ".no_more_data").show();
                    // for (var i=0;i<results.length;i++){
                    // 	if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                    // 	data += queryTrustDataHTML(results[i],i);
                    // }
                    // $(_pageId + ".main .cancel_order").html(data);
                    $(_pageId + ".no_data_box").hide();
                    // 撤单事件
                    //$.bindEvent($(_pageId+".cancel_order .part"), function(e){
                    $.bindEvent($(_pageId + ".j-position-table table tr"), function (e) {
                        var $this = $(this);
                        var dataIndex = $this.attr("data-index");
                        var data = results[dataIndex];
                        if (data == null || data == "") {
                            $.alert("数据异常");
                        }
                        var entrust_name = data.entrust_name;
                        var entrustBs = data.entrust_bs, _entrustBs = "";
                        if ($.inArray(entrustBs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
                            _entrustBs = "1";
                            entrust_name = "买入";
                        } else if ($.inArray(entrustBs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
                            _entrustBs = "2";
                            entrust_name = "卖出";
                        }

                        var tipStrArray = [];
                        tipStrArray.push([data.stock_name, data.stock_code]);
                        tipStrArray.push(["买卖方向 ", (data.entrust_name_new || entrust_name)]);
                        tipStrArray.push(["委托价格 ", Number(data.entrust_price).toFixed(3)]);
                        tipStrArray.push(["委托数量 ", data.entrust_amount]);
                        tipStrArray.push(["成交数量 ", data.business_amount]);
                        var tipStr = "<div >";
                        tipStr += common.generatePrompt(tipStrArray);
                        tipStr += "</div>";
                        //埋点
                        common.comStat(100140, 2, 103, true, { "i_group_name": "撤单提交" });

                        //埋点参数
                        var comStatParam = {
                            "i_entrust_bs": _entrustBs,//交易方向（1,买入 2,卖出）
                            "i_exchange_type": data.exchange_type,// 交易市场
                            "i_stock_code": data.stock_code,// 股票代码
                            "i_stock_name": data.stock_name,// 股票名称
                            "i_entrust_prop": "",// 委托属性名称
                            "i_entrust_price": Number(data.entrust_price).toFixed(3),// 委托价格
                            "i_entrust_amount": data.entrust_amount,// 委托数量
                        }
                        common.iConfirm("确认撤单", tipStr, function () {
                            var entrust_no = data.entrust_no;
                            var exchange_type = data.exchange_type;
                            cancellation(entrust_no, exchange_type); // 确认撤单
                            //埋点
                            comStatParam.i_oper = "1";  //动作（1确定 2取消）
                            common.comStat(100141, 2, 3, false, comStatParam);
                        }, function () {
                            //埋点
                            comStatParam.i_oper = "2";  //动作（1确定 2取消）
                            common.comStat(100141, 2, 3, false, comStatParam);
                        });
                        e.stopPropagation();
                    }, "tap");
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_more_data").hide();
                    $(_pageId + ".no_data_box").show();
                    $(_pageId + ".visc_pullUp").hide();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 撤单HTML生成
     */
    function queryDealHTML(element, i) {
        var price_digit = 3;
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            entrust_name = "买入";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            entrust_name = "卖出";
        } else {
            css = "";
        }
        // if (element.real_status_name == "成交") {
        //     css1 = "color:green;";
        // } else if (element.real_status_name == "确认") {
        //     css1 = "color:black;";
        // } else if (element.real_status_name == "废单") {
        //     css1 = "color:gray;";
        // }
        if (element.real_type_name == "撤单") {
            entrust_name = "撤单";
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width() / 4 - 25) + ")'>" + element.stock_name + "</p>";
        eleHtml += "<p>" + element.entrust_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.entrust_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + element.business_price + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.entrust_amount).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + common.getShowStr((element.entrust_name_new || entrust_name), '--', 1, 4) + "</p>";
        eleHtml += "<p>" + element.entrust_state_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }
    /**
     * 可撤单查询HTML生成
     */
    function queryTrustDataHTML(element) {
        var price_digit = 3;
        var css = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "n1";
            entrust_name = "买入";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "n2";
            entrust_name = "卖出";
        } else {
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<div class=\"part\" data-id=" + element.entrust_no + " data-type=" + element.exchange_type + ">";
        eleHtml += "<div class=\"title\"><span class=\"tag " + css + "\" entrust_bs='" + element.entrust_bs + "'>" + (element.entrust_name_new || entrust_name) + "</span><strong>" + element.stock_name + "</strong><small>" + element.stock_code + "</small>";
        eleHtml += "<span class=\"time\" style='margin-left: 0.3rem;right: auto;'>" + element.entrust_time + "</span>";
        eleHtml += "<a href=\"javascript:void(0);\" style='position: absolute;right: 0.05rem;border:1px solid #CCCCCC;border-color:#EE4034;' class='tag n2'>撤单</a></div><ul>";
        eleHtml += "<li><span>委托价 </span><p>" + Number(element.entrust_price).toFixed(price_digit) + "</p></li>";
        eleHtml += "<li><span>委托数 </span><p>" + element.entrust_amount + "</p></li>";
        eleHtml += "<li><span>成交价 </span><p>" + Number(element.business_price).toFixed(price_digit) + "</p></li>";
        eleHtml += "<li><span>成交数 </span><p>" + element.business_amount + "</p></li>";
        eleHtml += "</ul></div>";
        return eleHtml;
    }

    /**
     * 确定撤单
     */
    function cancellation(entrustNo, exchangeType) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code; // 关联资产账户标志
        var sessionid = userInfo.session_id;
        var batch_flag = "0";
        var entrust_no = entrustNo;
        var exchange_type = exchangeType;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
            "batch_flag": batch_flag,
            "exchange_type": exchange_type
        };
        service_stock.postCancelOrder(param, postCancelOrderCallback, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }
    //确定撤单回调
    function postCancelOrderCallback(data) {
        $.hidePreloader();
        if (typeof data != "undefined" && data != null) {
            var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
            if (data.error_no == 0) {
                if (typeof data.results[0] != "undefined" && data.results[0] != null) {
                    $.alert(tipStr, function () {
                        queryCancellation(); //刷新页面重新加载数据
                    });
                }
            } else {
                $.alert(tipStr, function () { queryCancellation(); });
            }
        } else {
            $.alert("<span class='wt-tips-title'>委托结果</span><br>撤单失败", function () { queryCancellation(); });
        }
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                //埋点 
                common.comStat(100139, 2, 102, true, { "i_direct": "1", "i_type": "1" });
                queryCancellation(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
                $(_pageId + " .no_data_box").height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        stock_code = "";
        stock_num = "";
        stock_direction = "";
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".main .cancel_order").html("");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
