/**
 * 债券现券交易-持仓
 */
define('trade/scripts/bond/stockHolding.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var service_hq = require("service_hq");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var iscrollUtils = require("iscrollUtils");
    var keyboard = require("keyboard");
    var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
    var market_val = 0;//市值
    var _pageId = "#bond_stockHolding ";
    var userInfo = null;
    var position_Timer = null;
    var _callback = true;
    var float_yks = 0;
    var _openStock = {};
    var isDestroy = true;

    /**
     * 初始化
     */
    function init() {
        sessionStorage.setItem("isScroller", "");
        _openStock = {};
        $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
        common.pageChangeHeight();
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        userInfo = common.getCurUserInfo();
        jumpPageEvent();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
        isDestroy = true;
    }

    function load() {
        if ($.device.android) { //安卓图标兼容性处理
            $(_pageId + ".j-tran-btn").addClass("android");
        }
        // initHScroller();
        pageContentChange();
        var mianHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mianHeight - $(_pageId + ".tab_nav").outerHeight(true) - 2;
        $(_pageId + " #wrapper").height(vIscrollHeight);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }
    function backgroundInterface() {
        queryData();//查询持仓

    }

    function pageContentChange() {
        $(_pageId + ".position_div thead th").each(function (idx, item) {
            var zoom = $.getTransformScaleFontSize($(item).text(), 14, ($(window).width()) * 0.25 - 15)
            $(item).css({ "font-size": zoom + "px" });
        });
        $(_pageId + ".j-data-info p").each(function (idx, item) {
            var zoom = $.getTransformScaleFontSize($(item).text(), 14, $(item).width() - 18);
            $(item).css({ "font-size": zoom + "px" });
        });
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() { }

    /**
     * 事件绑定
     */
    function jumpPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });
        //转账
        $.bindEvent($(_pageId + "#transfer"), function (e) {
            $(this).unbind(e.type);
            this[e.type] = null;
            //埋点
            common.comStat(100168, 2, 103, true, { "i_group_name": "银证转账" });
            $.setSStorageInfo("return_page", "bond/stockHolding");
            isDestroy = false;
            $.pageInit("bond/stockHolding", "banking/transferNew", {});
            e.preventDefault();
            e.stopPropagation();
        });

        //理财
        $.bindEvent($(_pageId + "#financial"), function (e) {
            $(this).unbind(e.type);
            this[e.type] = null;
            $.callMessage({
                "funcNo": "50500",
                "msgNo": "304",
                "targetModule": "appDispatcher",
                "sourceModule": "trade",
                "action": "3",
                "param": {
                    "moduleLoginType": "0",
                    "index": "3"
                }
            });
            e.preventDefault();
            e.stopPropagation();
        });

        //成本价输入框
        $.bindEvent($(_pageId + "#costPrice"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            e.stopPropagation();
        }, "input");

        $.bindEvent($(_pageId), function (e) {
            sessionStorage.setItem("isScroller", "");
        }, "touchstart");

        $.bindEvent($(_pageId + ".j-exp-icon"), function (e) {
            var msg = '';
            msg += '<p>1. 交易日仅9:25-16:00期间显示,不参与晚间清算,仅供盘中参考;</p>';
            msg += '<p>2. 非交易日不显示;</p>';
            msg += '<p>3. 已计入交易手续费,但不包括理财产品收益;</p>';
            msg += '<p>4. 若昨日有股票分红、配股等情况,可能导致今日参考盈亏计算不准确;</p>';
            msg += '<p>5. 今日参考盈亏仅为参考值,不作为具体的投资参考意见,请以账户实际收益为准。</p>';
            common.singleIConfirmNew("今日参考盈亏", msg, null, "我知道了");
            e.stopPropagation();
        });

        //全景
        $.bindEvent($(_pageId + "#zcqj"), function (e) {
            if (global.callNative && global.isSso) {
                var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=pt";
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "15",//打开风险警示权限开通页面
                        "title": "",
                        "toPage": toPage,
                    }
                }
                $.callMessage(param);
            }
            e.stopPropagation();
        });


    }

    /**
     * 查询
     */
    function queryData() {
        clearPositionTimer();
        //查询资金账户
        queryCapital();
        _callback = false;
        if (position_Timer == null && global.positionRefreshTime) {
            commonFunc.initCheckTradeTimer();
            position_Timer = window.setInterval(function () {
                if (commonFunc.getTradingTime() && _callback && common.isAppFlag()) {
                    queryCapital(true);
                    _callback = false;
                }
            }, global.positionRefreshTime);//定时刷新
        }
    }
    /**
     * 资金账户查询
     */
    function queryCapital(isShowWait) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var password = userInfo.password;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "money_type": money_type,
            "is_homepage": ""
        };
        //最后一个为超时处理函数
        service_stock.queryBandHoldingData(param, queryCapitalCallback,
            {  //传给接口的json格式数据
                "isLastReq": true,
                "isShowWait": isShowWait ? false : true,
                "isShowOverLay": false
            });
    }

    /**
     * 资金账户查询回调
     */
    function queryCapitalCallback(data) {
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results != "undefined" && results.length > 0) {
                    var assert_val = Number(results[0].assert_val).toFixed(2) + "";
                    $("#RMB #zzc").html(assert_val.substring(0, assert_val.length - 2) + "" + assert_val.substr(-2) + "");//总资产

                    //持仓市值
                    var market_val = Number(results[0].total_market || "0").toFixed(2) + "";
                    $("#RMB #ccsz").html(market_val.substring(0, market_val.length - 2) + "" + market_val.substr(-2) + "");

                    //添加总浮动盈亏
                    var css = "";
                    var float_yks = results[0].float_yk || results[0].total_income;
                    //当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
                    if (float_yks > 0) {
                        css = "ared";
                    } else if (float_yks < 0) {
                        css = "agreen";
                    }
                    var fas = Number(float_yks).toFixed(2);
                    $("#RMB #ccckyk").html(fas.substring(0, fas.length - 2) + "" + fas.substr(-2) + "").removeClass().addClass(css);//持仓盈亏
                    //字体缩放
                    $(_pageId + ".j-data-info strong").each(function (idx, item) {
                        item = $(item);
                        item.setTransformScale($.getTransformScale(item.text(), 18, item.parent().width() - 36));
                    });
                    //仓位
                    var stock_position = results[0].stock_position
                    $("#RMB  #cwbox").html('<span style="width:' + stock_position + ';"></span>仓位 ' + stock_position);
                } else {
                    $(_pageId + ".hold_main2 .j-stock-data strong").text("--");
                    $(_pageId + " #cwbox").html('<span style="width:0%;"></span>仓位 --');
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        queryPositionCallback(data);
    }
    function queryPositionCallback(data) {
        _callback = true;
        $(_pageId + '.position_div tr.tools').remove();
        $(_pageId + '.position_div tr.add').remove();
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = JSON.parse(data.results[0].stock_list);
                if (results && results.length > 0) {
                    float_yks = 0; //浮动盈亏
                    var htmlTop = "";
                    _openStock = $.getSStorageInfo("openStock", false) || {};
                    if (_openStock && typeof (_openStock) == "string") {
                        _openStock = JSON.parse(_openStock);
                    }
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var type = ""
                        var exchange_type = results[i].exchange_type
                        if (exchange_type == 0 || exchange_type == 1) {
                            type = "SZ:" + results[i].stock_code;
                        }
                        else if (exchange_type == 2 || exchange_type == 3) {
                            type = "SH:" + results[i].stock_code;
                        }
                        var isLast = "";
                        if (i == (results.length - 1)) {
                            isLast = "true";
                        }
                        float_yks += Number(results[i].float_yk);//计数总浮动盈亏
                        htmlTop += queryPositionHTML_stock(results[i], type, isLast);
                    }
                    $(_pageId + ".position_div tbody").html(htmlTop);
                    $(_pageId + ".no_data").hide();
                    //卖出事件
                    $.bindEvent($(_pageId + '.position_div tr.add'), function (e) {
                        var inv = $(_pageId + ".position_div .tools._last").is(':visible') ? 0 : 34;
                        var isLast = $(this).attr("islast");
                        if (($(_pageId + ".vertical_list").height() + inv) > $(_pageId + " #wrapper").height()) {
                            var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
                            if (isLast == "true" || isNeedScroll) {
                                if ($(this).next().height() > 0) {
                                    abc = $(this).next().height();
                                }
                                var a = $(this).next().css("display") == "none" ? true : false;
                                $(_pageId + ".position_div .tools").hide();
                                if (a) {
                                    $(this).next().show();
                                    //保存展开的股票
                                    var openStock = {
                                        "stock_code": $(this).attr("id"),
                                        "exchange_type": $(this).attr("exchange_type"),
                                        "stock_account": $(this).attr("stock_account"),
                                    }
                                    $.setSStorageInfo("openStock", JSON.stringify(openStock), false);
                                } else {
                                    _openStock = {};
                                    $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                                }
                                $(this).addClass("active").siblings().removeClass("active");
                                if (myScroller) {
                                    if ($(this).next().height() > 0) {
                                        abc = $(this).next().height();
                                    }
                                    var maxScrollY = 0;
                                    var _height = myScroller.y;
                                    var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
                                    if ($(this).next().is(':visible')) {
                                        sessionStorage.setItem("isScroller", "true");
                                        _height -= abc;
                                        maxScrollY = _height;
                                        _height -= temph;
                                    } else {
                                        _height += abc;
                                        maxScrollY = _height;
                                        sessionStorage.setItem("isScroller", "");
                                    }
                                    myScroller.scrollTo(0, _height);
                                    myScroller.y = _height;
                                    myScroller.refresh();
                                    if (isLast == "true") {
                                        myScroller.maxScrollY = maxScrollY;
                                    }
                                }
                            } else {
                                var a = $(this).next().css("display") == "none" ? true : false;
                                $(_pageId + ".position_div .tools").hide();
                                if (a) {
                                    $(this).next().show();
                                    //保存展开的股票
                                    var openStock = {
                                        "stock_code": $(this).attr("id"),
                                        "exchange_type": $(this).attr("exchange_type"),
                                        "stock_account": $(this).attr("stock_account"),
                                    }
                                    $.setSStorageInfo("openStock", JSON.stringify(openStock), false);
                                } else {
                                    _openStock = {};
                                    $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                                }
                                $(this).addClass("active").siblings().removeClass("active");
                                if (myScroller) {
                                    myScroller.refresh();
                                }
                            }
                        }
                        else {
                            var a = $(this).next().css("display") == "none" ? true : false;
                            $(_pageId + ".position_div .tools").hide();
                            if (a) {
                                $(this).next().show();
                                //保存展开的股票
                                var openStock = {
                                    "stock_code": $(this).attr("id"),
                                    "exchange_type": $(this).attr("exchange_type"),
                                    "stock_account": $(this).attr("stock_account"),
                                }
                                $.setSStorageInfo("openStock", JSON.stringify(openStock), false);
                            } else {
                                _openStock = {};
                                $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                            }
                            $(this).addClass("active").siblings().removeClass("active");
                            if (myScroller) {
                                myScroller.refresh();
                            }
                        }
                        e.stopPropagation();
                    });

                    //卖出事件
                    $.bindEvent($(_pageId + ".position_div tr.tools a"), function (e) {
                        _openStock = {};
                        $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                        $(_pageId + ".position_div tr.tools").hide();
                        $(this).siblings().removeClass("active");
                        var stock = $(this).parents("tr.tools").prev();
                        var stock_code = stock.attr("id");
                        var id = $(this).attr("id");
                        var exchange_type = stock.attr("exchange_type");
                        var stock_account = stock.attr("stock_account");
                        var market = commonHq.getHqMarket(exchange_type);
                        var stock_name = stock.attr("stock_name");
                        if (id == "buy") {
                            $.pageInit("bond/stockHolding", "bond/stockBuy", { "code": stock_code, "exchange_type": exchange_type, "market": market, "stock_account": stock_account, param: { "isGoBack": "1" } }, "", true);
                        }
                        else if (id == "sell") {
                            $.pageInit("bond/stockHolding", "bond/stockSell", { "code": stock_code, "exchange_type": exchange_type, "market": market, "stock_account": stock_account, param: { "isGoBack": "1" } }, "", true);
                        }
                        else if (id == "hq") {
                            if (global.callNative) {
                                var pageCode = $.getCurrentPageObj().pageCode || '';
                                $.setSStorageInfo("go_hq_" + pageCode, true);
                                if (gconfig.platform == "2") {
                                    var param = {
                                        "stockMarket": market,
                                        "stockCode": stock_code,
                                        "stockName": stock_name,
                                        "moduleName": "self-stock",
                                        "funcNo": "60105"
                                    };
                                    $.callMessage(param);
                                }
                                else {
                                    var param = {
                                        "funcNo": "50500",
                                        "msgNo": "201",
                                        "targetModule": "hqDispatcher",
                                        "sourceModule": "trade",
                                        "action": "0",
                                        "param": {
                                            "stockMarket": market,
                                            "stockCode": stock_code,
                                            "stockName": stock_name,
                                        }
                                    }
                                    $.callMessage(param);
                                }
                            } else {
                                var stockInfo = {
                                    "market": market,
                                    "stockCode": stock_code,
                                    "stockName": stock_name,
                                    "moduleName": "trade"
                                }
                                window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                            }
                        }
                        else if (id == "cbj") {
                            var content = "<li><p>证券代码</p>" + stock_code + "</li>" +
                                "<li><p>修改前</p>" + stock.find("td").eq(3).find("p").eq(0).text() + "</li>" +
                                "<li><p>币种</p>人民币</li>" +
                                "<li>" +
                                "<div class='CBJinput_box' style='border: 1px solid #dddddd;border-radius: 0.03rem;width: 0.9rem;height: 0.28rem;'><p>修改后</p>" +
                                "<input type='number' js-key='number' class='t1' id='costPrice' custom_keybord='0'/>" +
                                "</div></li>";
                            common.costPriceiConfirm("成本价修改", content, function success() {
                                var costPrice = $(_pageId + "#costPrice").val();
                                if (!costPrice) {
                                    $.alert("请输入修改后成本价！");
                                    return false;
                                }
                                if (costPrice <= 0.000) {
                                    $.alert("成本价格必须大于0.000。");
                                    return false;
                                }
                                if (costPrice > 1000000000.000) {
                                    $.alert("成本价格必须小于1000000000.000。");
                                    return false;
                                }
                                var reg = /^(-?\d*)\.?\d{1,3}$/;
                                if (!reg.test(costPrice)) {
                                    $.alert("成本价格只能精确到小数点后3位。");
                                    return false;
                                }
                                var param = {
                                    "entrust_way": global.entrust_way, // 委托方式  在configuration配置
                                    "branch_no": userInfo.branch_no,
                                    "fund_account": userInfo.fund_account,
                                    "cust_code": userInfo.cust_code,
                                    "stock_account": stock_account,//股东代码
                                    "exchange_type": exchange_type,//市场
                                    "stock_code": stock_code,//股票代码
                                    "cost_price": costPrice,//修改后的成本价
                                    "password": userInfo.password
                                };
                                costModification(param);
                            }, function fail() {
                                if (keyboard) {
                                    keyboard.closeKeyPanel();
                                }
                            });
                            if (keyboard) {
                                keyboard.keyInit();
                            }
                        }
                        e.stopPropagation();
                    });
                }
                else {
                    $(_pageId + ".no_data").show();
                }
            } else {
                $.alert(data.error_info);
            }
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    function clearPositionTimer() {
        if (position_Timer != null) {
            window.clearInterval(position_Timer);
        }
        position_Timer = null;
    }
    /**
     * 证券持仓HTML生成
     */
    function queryPositionHTML_stock(element, type, isLast) {
        var price_digit = 3;
        var eleHtml = "";
        var css = "", css1 = "";
        var float_yk = Number(element.float_yk);//浮动盈亏
        if (float_yk > 0) {
            css = "ared";
        } else if (float_yk < 0) {
            css = "agreen";
        }
        //浮动盈亏比例
        if (Number(element.float_yk_per) > 0) {
            css1 = "ared";
        } else if (Number(element.float_yk_per) < 0) {
            css1 = "agreen";
        }
        var active_css1 = "", active_css2 = " style='display:none'";
        if (_openStock && _openStock.stock_code) {
            if (element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account) {
                active_css1 = "active";
                active_css2 = "";
            }
        }
        var css3 = "";
        if (isLast == "true") {
            css3 = "_last";
        } else {
            css3 = "_nolast";
        }
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        var marketValue = Number(element.market_value).toFixed(price_digit),
            float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
            cost_amount = Number(element.cost_amount),
            enable_amount = Number(element.enable_amount),
            cost_price = Number(element.cost_price).toFixed(price_digit),
            last_price = Number(element.last_price).toFixed(price_digit);
        float_yk = float_yk.toFixed(price_digit);
        eleHtml += "<tr class='add " + active_css1 + "' stock_account=\"" + element.stock_account + "\" type=\"" + type + "\" exchange_type=\"" + element.exchange_type + "\" stock_name=\"" + element.stock_name + "\"  type=\"" + type + "\" id='" + element.stock_code + "'  isLast='" + isLast + "'>";
        eleHtml += '<td><p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(marketValue, 16, maxWidth) + 'px;">' + marketValue + '</p></td>';
        eleHtml += '<td><p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(float_yk, 16, maxWidth) + 'px;">' + float_yk + '</p>';
        eleHtml += '<p class="' + css1 + '" style="font-size:' + $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) + 'px;">' + float_yk_per + '</p></td>';
        eleHtml += '<td><p style="font-size:' + $.getTransformScaleFontSize(cost_amount, 16, maxWidth) + 'px;">' + cost_amount + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(enable_amount, 16, maxWidth) + 'px;">' + enable_amount + '</p></td>';
        eleHtml += '<td><p style="font-size:' + $.getTransformScaleFontSize(cost_price, 16, maxWidth) + 'px;">' + cost_price + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(last_price, 16, maxWidth) + 'px;">' + last_price + '</p></td>';
        eleHtml += "</tr>";
        eleHtml += "<tr class='j-table-btns tools " + css3 + "' " + active_css2 + ">";
        eleHtml += "<td colspan=\"4\">";
        eleHtml += "<ul class='ui layout j-btns-list'>";
        eleHtml += "<a id=\"buy\" class=\"row-1 border-right\" href=\"javascript:void(0);\">买入</a>";
        eleHtml += "<a id=\"sell\" class=\"row-1 border-right\" href=\"javascript:void(0);\">卖出</a>";
        eleHtml += "<a id=\"hq\" class=\"row-1 border-right\" href=\"javascript:void(0);\">行情</a>";
        eleHtml += "<a id=\"cbj\" class=\"row-1\" href=\"javascript:void(0);\">成本价</a>";
        // eleHtml+="<a id=\"mx\" class=\"row-1\" class=\"row-1\" href=\"javascript:void(0);\">明细</a>";
        eleHtml += "</ul>";
        eleHtml += "</td>";
        eleHtml += "</tr>";

        // eleHtml+="<dl class='position_data "+active_css1+"' exchange_type=\""+element.exchange_type+"\"  type=\""+type+"\" id='"+element.stock_code +"' stock_account='"+element.stock_account +"' stock_name='"+element.stock_name +"' cost_price='"+Number(element.cost_price).toFixed(price_digit) +"' isLast='"+isLast+"'>";
        // eleHtml+="<dd><p><strong>"+element.stock_name +"</strong></p><p><small>"+Number(element.market_value).toFixed(price_digit) +"</small></p></dd>";
        // eleHtml+="<dd><p><span class=\""+css+"\">"+float_yk+"</span></p><p><span class=\""+css+"\">"+Number(element.float_yk_per).toFixed(price_digit)+"%</span></p></dd>";
        // eleHtml+="<dd><p>"+Number(element.cost_amount)+"</p><p>"+Number(element.enable_amount)+"</p></dd>";
        // eleHtml+="<dd><p>"+Number(element.cost_price).toFixed(price_digit)+"</p><p>"+Number(element.last_price).toFixed(price_digit)+"</p></dd>";
        // eleHtml+="</dl>";
        // eleHtml+="<dd class='toolstwo "+css3+"'  "+active_css2+"><ul>";
        // eleHtml+="<li><a id=\"buy\" href=\"javascript:void(0);\"><span>买入</span></a></li>";
        // eleHtml+="<li><a id=\"sell\" href=\"javascript:void(0);\"><span>卖出</span></a></li>";
        // eleHtml+="<li><a id=\"hq\" href=\"javascript:void(0);\"><span>行情</span></a></li>";
        // eleHtml+="<li><a id=\"cbj\" href=\"javascript:void(0);\"><span>成本价</span></a></li>";
        // eleHtml+="</ul></dd>";
        return eleHtml;
    }

    //成本价修改
    function costModification(param) {
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
        service_stock.costModification(param, function (data) {
            if (data.error_no == 0) {
                queryCapital();//刷新持仓
            } else {
                $.alert(data.error_info);
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                $.hidePreloader();
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            }
        });
    }
    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryData(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else {
            myScroller.refresh();
        }
    }


    function destroy() {
        if (isDestroy) {
            commonFunc.clearCheckTradeTimer();
            destroy2();
        }
    }


    /**
     * 销毁
     */
    function destroy2() {
        if (keyboard) {
            keyboard.keyDestroy();
        }
        clearPositionTimer();
        _callback = true;
        market_val = 0;//市值
        $(_pageId + ".hold_main2 .j-stock-data strong").text("--");
        $(_pageId + " #cwbox").html('<span style="width:0%;"></span>仓位 --');
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        $(_pageId + '.position_div tr.tools').remove();
        $(_pageId + '.position_div tr.add').remove();
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
