/**
 * 债券现券交易-历史委托
 */
define('trade/scripts/bond/stockQueryHistoryNew.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var _pageId = "#bond_stockQueryHistoryNew ";
    var userInfo = null;
    var VIscroll = require("vIscroll");
    var vIscroll = { "scroll": null, "_init": false };		//上下滑动
    var search_type = 1;//默认近一周
    var queryType = 'entrust'; //查询内容
    var isGoDetail = false;
    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        var paramMap = $.getPageParam("param");
        if (paramMap && typeof (paramMap) == "object") {
            if (Object.keys(paramMap).length > 0) {
                queryType = paramMap.param;
            }
        } else {
            queryType = paramMap;
        }
        var trade_query_nav_type = $.getSStorageInfo("trade_query_nav_type");
        if (trade_query_nav_type) {
            queryType = trade_query_nav_type;
        }
        if (queryType === "entrust") {
            $(_pageId + ".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
        } else {
            $(_pageId + ".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }
    function load() {
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
        var mianHeight = common.setMainHeight(_pageId, false);
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh();
        }
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            setTimeout(function(){
                setScrollHeight();
                if (!vIscroll._init) {
                    initVIScroll();
                } else {
                    vIscroll.scroll.refresh();
                }
            },20);
        };
    }
    function backgroundInterface() {
        commonFunc.initNativeTimeChoice(_pageId, 30, false);
        // 成交和委托的日期控件数据独立
        var wt_query_begin_time = $.getSStorageInfo("wt_query_begin_time");
        var wt_query_end_time = $.getSStorageInfo("wt_query_end_time");
        var cj_query_begin_time = $.getSStorageInfo("cj_query_begin_time");
        var cj_query_end_time = $.getSStorageInfo("cj_query_end_time");
        var start = $(_pageId + " #startDate").text();
        var end = $(_pageId + " #endDate").text();
        // 初始化委托控件数据
        if(!wt_query_begin_time){
            $.setSStorageInfo("wt_query_begin_time", start);
            $.setSStorageInfo("wt_query_end_time", end);
        }
        // 初始化成交控件数据
        if(!cj_query_begin_time){
            $.setSStorageInfo("cj_query_begin_time", start);
            $.setSStorageInfo("cj_query_end_time", end);
        }
        if (queryType === "entrust") {
            if (wt_query_begin_time != "" && wt_query_begin_time != undefined) {
                $(_pageId + " #startDate").quzhi(wt_query_begin_time);
            }
            if (wt_query_end_time != "" && wt_query_end_time != undefined) {
                $(_pageId + " #endDate").quzhi(wt_query_end_time);
            }
        } else {
            if (cj_query_begin_time != "" && cj_query_begin_time != undefined) {
                $(_pageId + " #startDate").quzhi(cj_query_begin_time);
            }
            if (cj_query_end_time != "" && cj_query_end_time != undefined) {
                $(_pageId + " #endDate").quzhi(cj_query_end_time);
            }
        }
        var trade_query_search_type = $.getSStorageInfo("trade_query_search_type");
        if (trade_query_search_type != '' && trade_query_search_type != undefined || trade_query_search_type == "0") {
            search_type = trade_query_search_type;
        }
        if (search_type == 2) {
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").addClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active");
            $(_pageId + ".time").hide();
        } else if (search_type == 3) {
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").addClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active");
            $(_pageId + ".time").hide();
        } else if (search_type == 0) {
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").addClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active");
            $(_pageId + ".time").show();
        } else {
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").addClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active");
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active");
            $(_pageId + ".time").hide();
        }
        callsQuery(search_type);
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });

        //页面切换
        $.bindEvent($(_pageId + ".toggle_nav ul li"), function (e) {
            setTimeData();
            $.clearRequest();
            $(this).addClass("active").siblings().removeClass("active");
            // 设置tab切换
            if ($(_pageId + ".toggle_nav ul li").eq(0).hasClass('active')) {
                queryType = 'entrust';
                $(_pageId + " #startDate").quzhi($.getSStorageInfo("wt_query_begin_time"));
                $(_pageId + " #endDate").quzhi($.getSStorageInfo("wt_query_end_time"));
            } else {
                queryType = 'deal';
                $(_pageId + " #startDate").quzhi($.getSStorageInfo("cj_query_begin_time"));
                $(_pageId + " #endDate").quzhi($.getSStorageInfo("cj_query_end_time"));
            }
            $.setSStorageInfo("trade_query_nav_type", queryType);
            callsQuery(search_type);
        });

        //时间选择
        $.bindEvent($(_pageId + ".date_filter .btn"), function (e) {
            if (!vIscroll._init) {
                initVIScroll();
            } else {
                vIscroll.scroll.refresh();
            }
            callsQuery(search_type);
            //埋点
            var end_time = $(_pageId + " #endDate").text();
            var begin_time = $(_pageId + " #startDate").text();
            var time1 = begin_time.replaceAll("-", "");
            var time2 = end_time.replaceAll("-", "");
            // common.comStat(100215, 2, 104, true, { "i_change_name": "历史委托查询", "i_change_to": time1 + "-" + time2 });
        });
        //页面切换
        $.bindEvent($(_pageId + ".nsb_tab_nav ul li"), function (e) {
            if (null != vIscroll.scroll) {
                vIscroll.scroll.getWrapperObj().scrollTo(0, 0, 0);
            }
            //在页面切换时清掉请求
            $.clearRequest();
            //切换页面时时间控件初始化
            commonFunc.initNativeTimeChoice(_pageId, 30, false);
            if (!vIscroll._init) {
                initVIScroll();
            } else {
                vIscroll.scroll.refresh();
            }
            $(this).addClass("active").siblings().removeClass("active");

            //页面埋点
            var index = $(_pageId + ".nsb_tab_nav ul li.active").index();
            if (index == 3) {
                index = 0;
                $(_pageId + ".time").show();
            } else {
                index = index + 1;
                $(_pageId + ".time").hide();
            }
            search_type = index;
            callsQuery(search_type);
        });
    }
    /**
     * 调用查询
     */
    function callsQuery(search_type) {
        $(_pageId + ".j-position-table").html("");
        setScrollHeight();
        if (queryType === "entrust") {
            queryEntrust(search_type);
        } else {
            queryDeal(search_type);
        }
    }
    function setScrollHeight(){
        // 设置滚动容器的高度
        $(_pageId + '.main').height(document.body.clientHeight - $(_pageId + ".header").height() - $(_pageId + ".date_filter").height() - 1);
        $(_pageId + "#v_container_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height() - $(_pageId + ".date_filter").height() - 1);
        $(_pageId + "#v_wrapper_funds_jj").height(document.body.clientHeight - $(_pageId + ".header").height() - $(_pageId + ".date_filter").height() - 1);
        $(_pageId + ".no_data").height(document.body.clientHeight - $(_pageId + ".header").height() - $(_pageId + ".date_filter").height() - 1);
    }
    /**
     * 委托查询
     */
    function queryEntrust(search_type) {
        $(_pageId + ".j-position-table").html("");
        $(_pageId + ".j-position-table").hide();
        $(_pageId + ".no_more_data").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var end_time = $(_pageId + " #endDate").text();
        var begin_time = $(_pageId + " #startDate").text();
        var time1 = new Date(end_time.replaceAll("-", "/"));
        var time2 = new Date(begin_time.replaceAll("-", "/"));
        if (search_type == 0) {
            if (time1 < time2) {
                $.alert("开始日期不得大于截止日期");
                return false;
            }//截止时间
        }

        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "search_type": search_type,
            "begin_time": search_type == 0 ? begin_time : "",
            "end_time": search_type == 0 ? end_time : ""
        };
        $(_pageId + ".no_data").hide();
        service_stock.queryBondHistoryTrust(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "errorFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh();
                    }
                },
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        if (typeof (data) != "undefined" && data) {
            if (data.error_no == 0) {
                $(_pageId + ".no_data").hide();
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var html = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="fixed"><tr><th scope="col">证券/时间</th><th scope="col">委托/成交</th><th scope="col">委托量/成交量</th><th style="width: 25%;" scope="col">类型/状态</th></tr>';
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i], i);
                    }
                    html += '</table>';
                    $(_pageId + ".main .j-position-table").html(html);
                    $(_pageId + ".j-position-table").show();
                    $(_pageId + ".no_more_data").show();
                    $(_pageId + ".no_data").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .j-position-table tr"), function (e) {
                        var end_time = $(_pageId + " #endDate").text();
                        var begin_time = $(_pageId + " #startDate").text();
                        var selectIndex = $(this).attr("data-index");
                        var param = {
                            'titleName': '委托详情',
                            'flag': '10',
                            'search_type': search_type,
                            "begin_time": begin_time,
                            "end_time": end_time,
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        setTimeData();
                        $.pageInit("bond/stockQueryHistoryNew", "stock/stockDetails", param);
                    });
                } else {
                    $(_pageId + ".no_data").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh();
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element, i) {
		var price_digit = 3;
		var css = "";
		var entrust_name = element.entrust_type_name;
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
		if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
			css = "trans_color_02";
			entrust_name ="买入";
		}else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
			css = "trans_color_01";
			entrust_name ="卖出";
		}else{
			css = "";
		}
		var eleHtml = "";
        eleHtml+="<tr data-index='"+i+"'>";
        eleHtml+="<td style='padding-left: 0.06rem'><p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 16, $(window).width() / 4-16)+")'>"+element.stock_name+"</p><p  style='font-size: 0.12rem!important;'>"+element.entrust_date.substr(5,10)+" "+element.entrust_time+"</p></td>";
        eleHtml+="<td><p>"+Number(element.entrust_price).toFixed(price_digit)+"</p><p>"+Number(element.business_price).toFixed(price_digit)+"</p></td>";
        eleHtml+="<td><p>"+element.entrust_amount+"</p><p>"+element.business_amount+"</p></td>";
        eleHtml+="<td><p class=\""+css+"\">"+(element.entrust_name_new || entrust_name)+"</p><p>"+element.entrust_state_name+"</p></td>";
      	eleHtml+="</tr>";
		return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal(search_type) {
        $(_pageId + ".j-position-table").html("");
        $(_pageId + ".j-position-table").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var end_time = $(_pageId + " #endDate").text();
        var begin_time = $(_pageId + " #startDate").text();
        var time1 = new Date(end_time.replaceAll("-", "/"));
        var time2 = new Date(begin_time.replaceAll("-", "/"));
        $(_pageId + ".no_more_data").hide();
        if (search_type == 0) {
            if (time1 < time2) {
                $.alert("开始日期不得大于截止日期");
                return false;
            }//截止时间
        }
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "search_type": search_type,
            "begin_time": search_type == 0 ? begin_time : "",
            "end_time": search_type == 0 ? end_time : ""
        };
        $(_pageId + ".no_data").hide();
        service_stock.queryBondHistoryTrade(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".no_data").show();
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh();
                    }
                }
            });

    }
    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        if (typeof (data) != "undefined" && data != null) {
            $(_pageId + " .tarde_hit").html("");
            if (data.error_no == 0) {
                $(_pageId + ".no_data").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var html = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="fixed"><tr><th scope="col">证券/时间</th><th scope="col">价格/数量</th><th scope="col">成交金额</th><th style="width: 25%;" scope="col">业务名称</th></tr>';
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    html += '</table>';
                    $(_pageId + ".main .j-position-table").html(html);
                    $(_pageId + ".j-position-table").show();
                    $(_pageId + ".no_more_data").show();
                    $(_pageId + ".no_data").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .j-position-table tr"), function (e) {

                        var end_time = $(_pageId + " #endDate").text();
                        var begin_time = $(_pageId + " #startDate").text();
                        var selectIndex = $(this).attr("data-index");

                        var param = {
                            'titleName': '成交详情',
                            'flag': '11',
                            'search_type': search_type,
                            "begin_time": begin_time,
                            "end_time": end_time,
                            "selectIndex": selectIndex
                        };
                        setTimeData();
                        isGoDetail = true;
                        $.pageInit("bond/stockQueryHistoryNew", "stock/stockDetails", param);
                    });
                } else {
                    $(_pageId + ".no_data").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        // if(!myScroller){
        // 	initScroller();
        // }else{
        // 	myScroller.refresh();
        // }
        if (!vIscroll._init) {
            initVIScroll();
        } else {
            vIscroll.scroll.refresh();
        }
    }
    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element, i) {
        var price_digit = 3;
        var css = "";
        var entrust_name = element.entrust_type_name;
        if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
            entrust_name = element.entrust_name;
        }
        if($.inArray(element.entrust_bs, ["0"]) != -1){
            css = "trans_color_02";
            // entrust_name ="买入";
        }else if($.inArray(element.entrust_bs, ["1"]) != -1){
            css = "trans_color_01";
            // entrust_name ="卖出";
        }else{
            css = "";
        }
        var eleHtml = "";
        eleHtml+="<tr data-index='"+i+"'>";
        eleHtml+="<td  style='padding-left: 0.06rem'><p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 16, $(window).width()/4-16)+")'>"+element.stock_name+"</p><p  style='font-size: 0.12rem!important;'>"+element.business_date.substr(5,10)+" "+element.business_time+"</p></td>";
        eleHtml+="<td><p>"+Number(element.business_price).toFixed(price_digit)+"</p><p>"+element.business_amount+"</p></td>";
        eleHtml+="<td><p style='line-height: 0.4rem!important;'>"+Number(element.business_balance).toFixed(2)+"</p></td>";
        eleHtml+="<td><p style='line-height: 0.4rem!important;overflow: hidden;text-overflow: ellipsis;white-space: nowrap;font-size: 0.14rem;text-align: right;' class='"+css+"'>"+common.getShowStr(element.business_name,'--',0,6)+"</p></td>";
        eleHtml+="</tr>";
        return eleHtml;
    }
    /**
     * 初始化上下滑动组件
     */
    function initVIScroll() {
        if (!vIscroll._init) {
            var config = {
                "isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
                "visibleHeight": $(window).height() - $(_pageId + ".header").height() - $(_pageId + ".date_filter").height(), // 滚动组件的高度
                "container": $(_pageId + " #v_container_funds_jj"),
                "wrapper": $(_pageId + " #v_wrapper_funds_jj"),
                "downHandle": function () {				//下拉获取上一页数据方法
                    callsQuery(search_type); // 模拟查询接口数据操作
                },
                "upHandle": function () {
                },
                "wrapperObj": null
            };
            vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
            vIscroll._init = true; 						//尽量只初始化一次，保持性能
            setTimeout(function(){
                // 绑定截长屏分享
                $.bindEvent($(_pageId + ".share_customer"), function (e) {
                    var scroll = vIscroll.scroll.getWrapperObj();
                    var topFixedHeight = $(_pageId + 'header').height() + $(_pageId + '.date_filter').height();
                    commonFunc.longScreenShot({
                        scroll: scroll,
                        topFixedHeight:topFixedHeight,
                        offsetHeight:Math.max(scroll.scrollerH,$(_pageId + '.main').height()) + topFixedHeight,
                        // 最大可滚动距离
                        maxScrollY: scroll.maxScrollY > 0?0:-(scroll.maxScrollY - scroll.minScrollY),
                    });
                });
            },200);

        } else {
            vIscroll.scroll.refresh();
        }
        $(_pageId + ".visc_pullUp").css("display", "none");
    }
    // 保持日期控件数据
    function setTimeData(){
        var end_time = $(_pageId + " #endDate").text();
        var begin_time = $(_pageId + " #startDate").text();
        if (queryType === "entrust") {
            $.setSStorageInfo("wt_query_begin_time", begin_time);
            $.setSStorageInfo("wt_query_end_time", end_time);
        } else {
            $.setSStorageInfo("cj_query_begin_time", begin_time);
            $.setSStorageInfo("cj_query_end_time", end_time);
        }
        $.setSStorageInfo("trade_query_search_type", search_type);
        $.setSStorageInfo("trade_query_nav_type", queryType);
    }
    /**
     * 销毁
     */
    function destroy() {
        if(isGoDetail){
            isGoDetail = false;
        }else{
            $(_pageId + ".j-position-table").html("");
            $(_pageId + ".top_title .top_nav").hide();
            $.setSStorageInfo("wt_query_begin_time", '');
            $.setSStorageInfo("wt_query_end_time", '');
            $.setSStorageInfo("cj_query_begin_time", '');
            $.setSStorageInfo("cj_query_end_time", '');
            $.setSStorageInfo("trade_query_search_type", '');
            $.setSStorageInfo("trade_query_nav_type", '');
            search_type = 1;
            if (vIscroll._init) {
                vIscroll.scroll.refresh();
            }
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
