/**
 * 普通交易-今日查询
 */
define('trade/scripts/bond/stockQueryToday.js', function (require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var service_ggt = require("service_ggt");
    var _pageId = "#bond_stockQueryToday ";
    var userInfo = null;
    var queryType = null; //查询内容
    var VIscroll = require("vIscroll");
    var vIscroll = { "scroll": null, "_init": false };		//上下滑动
    var commonFunc = require("commonFunc");
    var pageCode = "bond/stockQueryToday";
    var isGoDetail = false;

    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        var paramMap = $.getPageParam("param");
        if (paramMap && typeof (paramMap) == "object") {
            if (Object.keys(paramMap).length > 0) {
                queryType = paramMap.param;
            }
        } else {
            queryType = paramMap;
        }
        var trade_query_nav_type = $.getSStorageInfo("bond_trade_query_nav_type");
        if (trade_query_nav_type) {
            queryType = trade_query_nav_type;
        }
        if (queryType == "deal") {
            $(_pageId + ".tab_list li").eq(1).addClass("current").siblings().removeClass("current");
            $(_pageId + ".btnSub3").html("更多历史成交记录");
            $(_pageId + ".btnSub4").html("更多历史成交记录");
        } else {
            $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
            $(_pageId + ".btnSub3").html("更多历史委托记录");
            $(_pageId + ".btnSub4").html("更多历史委托记录");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        callsQuery();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                //埋点
                if ($(_pageId + ".tab_list ul li.current").index() == 0) {
                    common.comStat(100201, 2, 103, true, { "i_group_name": "返回" });
                } else {
                    common.comStat(100206, 2, 103, true, { "i_group_name": "返回" });
                }
                $.pageBack("stock/stockQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //页面切换
        $.bindEvent($(_pageId + ".tab_list ul li"), function (e) {
            //在页面切换时清掉请求
            $.clearRequest();
            $(this).addClass("current").siblings().removeClass("current");
            $(_pageId + ".j-position-table table").html("");
            //页面埋点
            var index = $(_pageId + ".tab_list ul li.current").index();
            if(index === 0){
                queryType = "entrust";
            }else{
                queryType = "deal";
            }
            setTimeData();
            callsQuery();
        });

        //更多按钮
        $.bindEvent($(_pageId + ".nsb_sel_fixed_box"), function (e) {
            if ($(_pageId + ".tab_list ul li").eq(0).hasClass("current")) {//委托
                $.pageInit(pageCode, "bond/stockQueryHistoryNew", { "param": "entrust" });
            } else {//成交
                $.pageInit(pageCode, "bond/stockQueryHistoryNew", { "param": "deal" });
            }
            isGoDetail = true;
            setTimeData();
        });
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            common.setMainHeight(_pageId, false);
            $(_pageId + '#v_container_funds_jj').height($(_pageId + '.main').height());
            if (vIscroll._init) {
                vIscroll.scroll.refresh();
            }
        };
    }

    /**
     * 调用查询
     */
    function callsQuery() {
        if ($(_pageId + ".tab_list ul li").eq(0).hasClass("current")) {
            $(_pageId + ".btnSub3").html("更多历史委托记录");
            $(_pageId + ".btnSub4").html("更多历史委托记录");
            $(_pageId + ".hasdatamore").hide();
            queryEntrust();
        } else {
            $(_pageId + ".hasdatamore").hide();
            $(_pageId + ".btnSub3").html("更多历史成交记录");
            $(_pageId + ".btnSub4").html("更多历史成交记录");
            queryDeal();
        }
    }
    // 保持日期控件数据
    function setTimeData() {
        $.setSStorageInfo("bond_trade_query_nav_type", queryType);
    }

    /**
     * 委托查询
     */
    function queryEntrust() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_stock.queryBondTodayTrust(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh();
                    }
                }
            });
    }

    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        if (typeof (data) != "undefined" && data) {
            $(_pageId + ".hasdatamore").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var html = "<thead><tr><th>证券/时间</th><th>委托/成交价</th><th>委托/成交量</th><th>类型/状态</th></tr></thead><tbody>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i], i);
                    }
                    $(_pageId + ".j-position-table table").html(html + "</tbody>");
                    $(_pageId + ".hasdatamore").show();
                    $.bindEvent($(_pageId + ".j-position-table table tbody tr"), function (e) {
                        var cancel_flag = $(this).attr("cancel_flag");
                        if (cancel_flag == "0") {
                            var tipStrArray = [];
                            tipStrArray.push(["证券名称 ", "<span style='font-size:" + $.getTransformScaleFontSize($(this).attr("stock_name"), 16, $(window).width() * 0.48) + "px;'>" + $(this).attr("stock_name") + "</span>"]);
                            tipStrArray.push(["证券代码 ", $(this).attr("stock_code")]);
                            tipStrArray.push(["买卖方向 ", $(this).attr("entrust_name")]);
                            tipStrArray.push(["委托价格 ", $(this).attr("entrust_price")]);
                            tipStrArray.push(["委托数量 ", $(this).attr("entrust_amount")]);
                            tipStrArray.push(["成交数量 ", $(this).attr("business_amount")]);
                            var tipStr = "<div>";
                            tipStr += common.generatePrompt(tipStrArray);
                            tipStr += "</div>";
                            var entrust_no = $(this).attr("id");
                            var exchange_type = $(this).attr("exchange_type");
                            common.iConfirm("确认撤单", tipStr, function () {
                                cancellation(entrust_no, exchange_type); // 确认撤单
                            }, null, "确定", "取消");
                        }
                        e.stopPropagation();
                    });
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!vIscroll._init) {
                    initVIScroll();
                } else {
                    vIscroll.scroll.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 确定撤单
     */
    function cancellation(entrustNo, exchangeType) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code; // 关联资产账户标志
        var sessionid = userInfo.session_id;
        var batch_flag = "0";
        var entrust_no = entrustNo;
        var exchange_type = exchangeType;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
            "batch_flag": batch_flag,
            "exchange_type": exchange_type
        };
        if (exchange_type === "G" || exchange_type === "S") {
            service_ggt.postCancelOrder_ggt(
                param,
                postCancelOrderCallback,
                {
                    "isLastReq": false,
                    "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    },
                    "errorFunc": function () {
                        $.hidePreloader();
                    }
                }
            );
        } else {
            service_stock.postCancelOrder(
                param,
                postCancelOrderCallback,
                {
                    "isLastReq": false,
                    "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    },
                    "errorFunc": function () {
                        $.hidePreloader();
                    }
                }
            );
        }
        $.showPreloaders("请等待...");
    }

    /**
     * 委托撤单回调方法
     * @param {Object} data 返回数据
     */
    function postCancelOrderCallback(data) {
        $.hidePreloader();
        var tipStr = "<span  class='wt-tips-title'>委托结果</span><br>" + data.error_info;
        if (data.error_no == "0") {
            $.alert(tipStr, function () {
                queryEntrust();
            });
        } else {
            $.alert(tipStr);
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element, i) {
        var price_digit = 3;
        var css = "";
        var css1 = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            entrust_name = "买入";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_red"
            }
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            entrust_name = "卖出";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_blue"
            }
        } else {
            css = "";
        }
        if (element.entrust_type_name == "撤单") {
            entrust_name = "撤单";
            css = "";
        }
        var hgtFlag = "";
        if (element.exchange_type === "G") {
            hgtFlag = "<em class='ggt'>沪</em>";
        } else if (element.exchange_type === "S") {
            hgtFlag = "<em class='sgt'>深</em>";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "' class='" + css1 + "' id='" + element.entrust_no + "' stock_name='" + element.stock_name + "' stock_code='" + element.stock_code + "' entrust_price='" + Number(element.entrust_price).toFixed(price_digit) + "' entrust_amount='" + element.entrust_amount + "' business_amount='" + element.business_amount + "' cancel_flag='" + element.cancel_flag + "' entrust_name='" + entrust_name + "' exchange_type='" + element.exchange_type + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25 - 30) + ")'>" + hgtFlag + element.stock_name + "</p>";
        eleHtml += "<p  style='font-size: 0.12rem!important;'>" + element.entrust_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.entrust_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.entrust_amount + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + common.getShowStr((element.entrust_name_new || entrust_name), '--', 1, 4) + "</p>";
        eleHtml += "<p>" + element.entrust_state_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_stock.queryBondTodayTrade(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    if (!vIscroll._init) {
                        initVIScroll();
                    } else {
                        vIscroll.scroll.refresh();
                    }
                }
            });

    }

    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        if (typeof (data) != "undefined" && data != null) {
            $(_pageId + ".hasdatamore").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var html = "<tr><th>证券/时间</th><th>成交价/成交量</th><th>成交金额</th><th>类型/状态</th></tr>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    $(_pageId + ".j-position-table table").html(html);
                    $(_pageId + ".hasdatamore").show();
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!vIscroll._init) {
                    initVIScroll();
                } else {
                    vIscroll.scroll.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element, i) {
        var price_digit = 3;
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            entrust_name = "买入";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            entrust_name = "卖出";
        } else {
            css = "";
        }
        // if (element.real_status_name == "成交") {
        //     css1 = "color:green;";
        // } else if (element.real_status_name == "确认") {
        //     css1 = "color:black;";
        // } else if (element.real_status_name == "废单") {
        //     css1 = "color:gray;";
        // }
        if (element.real_type_name == "撤单") {
            entrust_name = "撤单";
            css = "";
        }
        var hgtFlag = "";
        if (element.exchange_type === "G") {
            hgtFlag = "<em class='ggt'>沪</em>";
        } else if (element.exchange_type === "S") {
            hgtFlag = "<em class='sgt'>深</em>";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25 - 30) + ")'>" + hgtFlag + element.stock_name + "</p>";
        eleHtml += "<p>" + element.business_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_balance).toFixed(2) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + entrust_name + "</p>";
        eleHtml += "<p>" + element.real_status_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 初始化上下滑动组件
     */
    function initVIScroll() {
        if (!vIscroll._init) {
            var config = {
                "isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
                "visibleHeight": $(window).height() - $(_pageId + "header").height(), // 滚动组件的高度
                "container": $(_pageId + " #v_container_funds_jj"),
                "wrapper": $(_pageId + " #v_wrapper_funds_jj"),
                "downHandle": function () {
                    callsQuery();//下拉获取上一页数据方法
                },
                "upHandle": function () {
                },
                "wrapperObj": null
            };
            vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
            vIscroll._init = true; 						//尽量只初始化一次，保持性能
            setTimeout(function () {
                // 绑定截长屏分享
                $.bindEvent($(_pageId + ".share_customer"), function (e) {
                    var scroll = vIscroll.scroll.getWrapperObj();
                    var topFixedHeight = $(_pageId + 'header').height();
                    commonFunc.longScreenShot({
                        scroll: scroll,
                        topFixedHeight: topFixedHeight,
                        offsetHeight: Math.max(scroll.scrollerH, $(_pageId + '.main').height()) + topFixedHeight,
                        // 最大可滚动距离
                        maxScrollY: scroll.maxScrollY > 0 ? 0 : -(scroll.maxScrollY - scroll.minScrollY),
                    });
                });
            }, 200);
        } else {
            vIscroll.scroll.refresh();
        }
        $(_pageId + ".visc_pullUp").css("display", "none");
    }
    /**
     * 销毁
     */
    function destroy() {
        if (isGoDetail) {
            isGoDetail = false;
        } else {
            $(_pageId + ".j-position-table table").html("");
            $(_pageId + ".hasdatamore").hide();
            $(_pageId + ".no_data_box").hide();
            $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
            if (vIscroll._init) {
                vIscroll.scroll.refresh();
            }
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
