/**
 * CDR签署协议并开通权限
 */

define('trade/scripts/common/cdrProtocolSign.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var cdrType = "";
	var orderType = "";
	var paraMap = "";
	var cdrInfo = "";
	var ueserInfo = null;
	var service_stock = require("service_stock");

	//交易适当性绑定事件
	function bindCDRMatchEvent() {

		$.bindEvent($("body #diagMatchBox .top_title a"), function(e) {
			$("#diagMatchBox").remove();
			e.stopPropagation();
		});

		$.bindEvent($("body #diagMatchBox .openbox p"), function(e) {
			$(this).toggleClass("active")
			e.stopPropagation();
		});

		$.bindEvent($("body #diagMatchBox .openbox a.ok"), function(e) {
			if($("body #diagMatchBox .openbox p").hasClass("active")) {
				var param = {
					"fund_account": userInfo.fund_account,
					"password": userInfo.password,
					"cust_code": userInfo.cust_code,
					"entrust_way": global.entrust_way,
					"branch_no": userInfo.branch_no,
					"password": userInfo.password
				};
				if(orderType == "1") {
					param.remark = "普通交易买入签署协议";
					param.exchange_type = cdrInfo[0].split(":")[0];
					param.stock_account = cdrInfo[0].split(":")[1];
				} else if(orderType == "2") {
					param.remark = "新股申购签署协议";
					param.accounts_list = cdrInfo.join("");
				}
				if(cdrType == "1") {
					service_stock.signCDRrights(param, signRightsCallback, {//301558
						"isShowOverLay": false,
						"isShowWait": false,
						"timeOutFunc": function() {
							$.hidePreloader();
						},
						"errorFunc": function() {
							$.hidePreloader();
						}
					});
				} else if(cdrType == "2") {
					service_stock.signInnovateRights(param, signRightsCallback, {//301559
						"isShowOverLay": false,
						"isShowWait": false,
						"timeOutFunc": function() {
							$.hidePreloader();
						},
						"errorFunc": function() {
							$.hidePreloader();
						}
					});
				} else if(cdrType == "3") {
					service_stock.signCDRInnovateRights(param, signRightsCallback, {//301560
						"isShowOverLay": false,
						"isShowWait": false,
						"timeOutFunc": function() {
							$.hidePreloader();
						},
						"errorFunc": function() {
							$.hidePreloader();
						}
					});
				}
				$.showPreloaders("请等待...");
			} else {
				$.alert("请认真阅读并勾选签署协议");
			}
			e.stopPropagation();
		});

	}

	function signRightsCallback(data) {
		$.hidePreloader();
		if(data.error_no == "0") {
			if(data.results && data.results.length > 0) {
				var headerHtml = "";
				var cdrRightsAccount = [];
				var cqRightsAccount = [];
				for(var i = 0; i < data.results.length; i++) {
					var right_type = data.results[i].right_type;
					stock_account = data.results[i].stock_account;
					exchange_type_name = data.results[i].exchange_type_name;
					var error_info = data.results[i].error_info;
					var error_no = data.results[i].error_no;
					if(right_type == "0") {
						if(error_no == "0") {
							cdrRightsAccount.push("<div>" + exchange_type_name + " " + stock_account + " <span class=\"a01\">开通成功</span></div>");
						} else {
							cdrRightsAccount.push("<div>" + exchange_type_name + " " + stock_account + " <span class=\"a02\">开通失败</span></div><p>" + error_info + "</p>");
						}
					} else if(right_type == "1") {
						if(error_no == "0") {
							cqRightsAccount.push("<div>" + exchange_type_name + " " + stock_account + " <span class=\"a01\">开通成功</span></div>");
						} else {
							cqRightsAccount.push("<div>" + exchange_type_name + " " + stock_account + " <span class=\"a02\">开通失败</span></div><p>" + error_info + "</p>");
						}
					}
				}
				if(cdrRightsAccount.length > 0) {
					headerHtml += "<dl><dt><i></i>存托凭证交易权限：</dt><dd>";
					headerHtml += cdrRightsAccount.join("");
					headerHtml += "</dd></dl>";
				}
				if(cqRightsAccount.length > 0) {
					headerHtml += "<dl><dt><i></i>创新企业股票交易权限：</dt><dd>";
					headerHtml += cqRightsAccount.join("");
					headerHtml += "</dd></dl>";
				}

				//标题
				$("#diagMatchBox .header .top_title h3").text("权限开通结果");
				$("#diagMatchBox .innovative").hide();
				var eleHtml = [];
				eleHtml += '<div class="receipt"><img src="../../images/ykt.png">';
				eleHtml += '<div class="row_01">';
				eleHtml += headerHtml;
				eleHtml += '</div><a href="javascript:void(0);" class="ok">确定</a></div>';
				$("#diagMatchBox .main").append(eleHtml);
				var height = ($.config.appHeight || window.currentHeight) - $("#diagMatchBox .top_title").height() - $("#diagMatchBox footer").height();
				$("#diagMatchBox .main").css({
					"height": height,
					"overflow": "auto"
				});
				$.bindEvent($("body #diagMatchBox .receipt a.ok"), function(e) {
					$("#diagMatchBox").remove();
					e.stopPropagation();
				});
			}
		} else {
			$.alert(data.error_info);
		}
	}

	/**
	 * 清空页面缓存
	 */
	function clearMatchInfo() {
		$("#diagMatchBox").remove();
		cdrType = "";
		orderType = "";
		paraMap = "";
		cdrInfo = "";
		userInfo = null;
	}

	/**
	 * 下单适当性匹配
	 * @param {Object} cdr_type 1 cdr   2 创企   3 混合
	 * @param {Object} _orderType 1普通交易 2新股
	 * @param {Object} cdr_info 市场:待开通股东账号|市场:待开通股东账号  cdr_exchange_type:cdr_stock_account
	 * @param {Object} _paraMap	预留
	 */
	function cdrProtocolMatch(cdr_type, _orderType, cdr_info, _paraMap) {
		clearMatchInfo();
		userInfo = common.getCurUserInfo();
		cdrType = cdr_type; // 1 CDR    2 : 创企    3 : 多种(新股)
		orderType = _orderType;
		paraMap = _paraMap; //暂未用到
		cdrInfo = cdr_info; //传入一个数组 (普通交易格式 exchange_type|stock_account)
		//             两融格式  301535 的出参
		if(!cdrInfo || !(cdrInfo instanceof Array)) {
			$.alert("签署协议账号获取失败！");
			return;
		}
		var param = {
			"fund_account": userInfo.fund_account,
			"password": userInfo.password,
			"cust_code": userInfo.cust_code,
			"entrust_way": global.entrust_way,
			"branch_no": userInfo.branch_no,
			"password": userInfo.password
		}
		if(cdrType == "1") {
			param.query_type = "0";
		} else if(cdrType == "2") {
			param.query_type = "1";
		} else if(cdrType == "3") {
			param.query_type = "2";
		}
		service_stock.queryCDRProtocol(param, function(data) {
			if(data.error_no == 0) {
				var results = data.results;
				if(results && results.length > 0) {
					matchResults = results[0];
					creatMatchElement(matchResults);
					bindCDRMatchEvent();
				}
			} else {
				$.alert(data.error_info || "查询交易CDR存管协议出错");
			}
		});
		//		matchResults = [];
		//		creatMatchElement(matchResults);
		//		bindCDRMatchEvent();

	}

	/**
	 * 根据适当性结果集展示界面
	 * @param {Object} result
	 */
	function creatMatchElement(result) {
		var titleHtml = result.titleHtml || "协议签署",
			headerHtml = result.title || "--",
			investorHtml = result.text_content || "--",
			elementHtml = [];
		elementHtml.push("<div id='diagMatchBox' style='width:100%;height:100%;background: #F5F5F4;z-index:3000;top:0;position:absolute;'>");
		elementHtml.push('<header class="header"><div class="top_title">');
		//标题文字
		elementHtml.push('<a href="javascript:void(0);" class="icon_back text"></a><h3>' + titleHtml + '</h3>');

		elementHtml.push('</div></header><section class="main" style="background: #F5F5F5;">');
		elementHtml.push('<div class="innovative"><h3>' + headerHtml + '</h3><p style="text-indent:2em;">' + investorHtml + '</p>');
		//底部按钮文字
		elementHtml.push('<footer class="cdr"><div class="openbox"><p class="active"><i></i>本人已阅读并同意上述风险揭示书</p><a href="javascript:void(0);" class="ok">确认开通交易权限</a></div></footer>');
		$("body").append(elementHtml.join(""));
		var height = ($.config.appHeight || window.currentHeight) - $("#diagMatchBox .top_title").height() - $("#diagMatchBox footer").height();
		$("#diagMatchBox .main").css({
			"height": height,
			"overflow": "auto"
		});
	}

	var cdrProtocolSign = {
		"cdrProtocolMatch": cdrProtocolMatch,
		"clearMatchInfo": clearMatchInfo
	}
	module.exports = cdrProtocolSign;
});