/**
 * 交易模块公用 js
 */
define('trade/scripts/common/common.js', function (require, exports, module) {
    var nativePluginService = require("nativePluginService");
    var gconfig = $.config;
    var global = gconfig.global;
    var wHeight = $("html").height() || gconfig.appHeight;
//  var logoutTimer = null; // 定时器
    var accountInfos = {};
    var operationInfo = [];
    var curUserInfo = {};
    var transferInfo = {};
    var keybordResize = null;
    var keybordShowCallback = null;
    var keybordHideCallback = null;
    var subscribe_map = {};
    var iscrollUtils = require("iscrollUtils");
    var keyboard = require("keyboard");
    var commonDiv = require("trade/scripts/common/commonDiv.js");


    /**
     * 绑定列表型菜单事件跳转
     * @param {Object} _divId 完整div位置
     * @param {Object} callback 自定义执行方法
     */
    function bindStockEvent(_divId, callback, eliminate, eType, dataParam) {
        eType = eType || "click";
        $.bindEvent(_divId, function (e) {
            if (!eliminate) {
//				e.type
                $(this).unbind(eType);
                this[eType] = null;
            }
            var pageCode = $.getCurrentPageObj().pageCode || '';
            var topage = $(this).attr("to-page").replaceAll("_", "/"); //获取跳转的页面
            var param = $(this).attr("param");
            var type = $(this).attr("type");
            //设置新股申购的类型，用于判断是普通还是两融
            if (pageCode == "credit/order/mainOrder" && topage == "shares/oneKeyPurchase") {
                param = {"switchUserInfo": "1"};
            }
            if (!param) {
                param = "";
            }
            if(param=="znzd_qcgg"){

                if (global.callNative && global.isSso) {
                    var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=pt&pageto=sszd1-qcgg&moneytype=0";
                    var param = {
                        "funcNo": "50500",
                        "msgNo": "123",
                        "sourceModule": "",
                        "targetModule": "tradeDispatcher",
                        "action": "1",
                        "param": {
                            "business_type": curUserInfo._loginClass,//普通0  两融1
                            "event": "15",//打开风险警示权限开通页面
                            "title": "",
                            "toPage":toPage,
                        }
                    }
                    $.callMessage(param);
                }
                //埋点
                var objectId = $(this).attr("objectId");
                var actionId = $(this).attr("actionId");
                var name = $(this).attr("name");
                if (objectId && actionId && name) {
                    comStat(objectId, 2, actionId, true, {"i_group_name": name});
                }
                return;
            }
            if (callback && typeof callback == "function") {
                callback(pageCode, topage, param);
            } else {
                if (pageCode != topage) {
                    if (callback && typeof callback == "boolean") {
                        $.pageInit(pageCode, topage, {"param": param}, "", true);
                    } else {
                        $.pageInit(pageCode, topage, {"param": param});
                    }
                }
            }
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            if (objectId && actionId && name) {
                comStat(objectId, 2, actionId, true, {"i_group_name": name});
            }
            e.stopPropagation();
        }, eType);
    }

    /**
     * 将数字转换为金钱格式
     * @param {Object} str 数字字符串或者数字
     * @param {Object} digit 保存的位数
     */
    function numToMoneyType(str, digit) {
        str = str + "";  //强制转换成字符串
        if (digit) {
            str = Number(str).toFixed(digit);
        }
        var sign = "";
        if (str < 0) {
            sign = str.substring(0, 1);
            str = str.substring(1, str.length);
        }
        var index = str.indexOf(".");
        var afterStr = "";
        if (index != -1) {
            afterStr = str.substring(index, str.length);
            str = str.substring(0, index);
        }
        var len = str.length,
            lastIndex,
            arr = [];
        while (len > 0) {
            lastIndex = len;
            len -= 3;
            arr.unshift(str.substring(len, lastIndex));
        }
        return "" + sign + arr.join(',') + afterStr;
    }

    /**
     * 得到证券类型
     */
    function getStockType(stkType) {
        var typeName = "股票";
        var bondType = [6, 14, 21, 22, 23, 24, 25, 26, 27, 30]; // 债券
        var fundType = [3, 4, 11, 12, 19, 20]; // 基金
        var warrantType = [5, 13]; // 权证
        if ($.inArray(stkType, bondType) != -1) {
            typeName = "债券";
        } else if ($.inArray(stkType, fundType) != -1) {
            typeName = "基金";
        } else if ($.inArray(stkType, warrantType) != -1) {
            typeName = "权证";
        } else {
            typeName = "股票";
        }
        return typeName;
    }


    /**
     * 设置页面高度 显示隐藏底部
     * @param {Object} _pageId 页面id
     * @param {Object} choice true 显示/false 隐藏
     * return (Number) 返回main的高度
     */
    function setMainHeight(_pageId, choice) {
        var mainHeight = $("html").height() || $(window).height();

        if (choice) {
            $(_pageId + " footer.footer").show();//显示底部
            mainHeight = mainHeight - $(_pageId + " header.header").height() - $(_pageId + " footer.footer").height();
        } else {
            mainHeight = mainHeight - $(_pageId + " header.header").height();
            $(_pageId + " footer.footer").hide();//隐藏底部
        }
        $(_pageId + " section.main").height(mainHeight).css("overflow", "auto");
        return mainHeight;
    }

    /**
     * 设置页面高度 显示隐藏底部
     * @param {Object} _pageId 页面id
     * @param {Object} choice true 显示/false 隐藏
     * return (Number) 返回main的高度
     */
    function setMainHeightNew(_pageId, choice, isAutoOverflow) {
        var mainHeight = $("html").height() || $(window).height();
        if (choice) {
            $(_pageId + " footer.footer").show();//显示底部
            mainHeight = mainHeight - $(_pageId + " header").height() - $(_pageId + " footer.footer").height();
        } else {
            mainHeight = mainHeight - $(_pageId + " header").height();
            $(_pageId + " footer.footer").hide();//隐藏底部
        }
        if (isAutoOverflow) {
            $(_pageId + " .content").height(mainHeight).css("overflow", "auto");
        }
        return mainHeight;
    }

    /**
     * 将不规则文本转换为 "--"
     */
    function transferText(str, num) {
        var outText = "--";
        if (str && str != 0 && !isNaN(Number(str))) {
            if (num) {
                outText = Number(str).toFixed(num);
            } else {
                outText = str;
            }
        }
        return outText;
    }

    //数量过万改以万为单位
    function overAMillion(num) {
        num = Number(num);
        if (num >= 10000) {
            num = (num / 10000).toFixed(2) + "万";
        }
        if (num == 0) {
            num = "--";
        }
        return num;
    }

    /**
     * 获取数据的长度，和对象的属性个数
     * @param {Object} obj
     */
    function size(obj) {
        if (obj) {
            if (typeof (obj) == "string" || obj instanceof Array) {
                return obj.length;
            } else if (typeof (obj) == "object") {
                return Object.getOwnPropertyNames(obj).length
            }
        } else {
            return 0;
        }
    }

    /**
     * 判断数据的值是否有用的值
     */
    function isValue(v) {
        if (v) {
            if (v instanceof Array && v.length == 0) {
                return false;
            } else if (typeof (v) == "string") {
                v = $.trim(v);
                if (v == "" || v == "null" || v == "undefined" || v == "false") {
                    return false;
                } else {
                    return true;
                }
            } else if (typeof (v) == "object" && Object.getOwnPropertyNames(v).length == 0) {
                return false;
            } else {
                return true;
            }
        } else {
            return false;
        }
    }


    /*******************关于登录账号信息**********************/

    /**
     * 用户登录超时，后台返回-999时 调用方法
     */
    function filterLoginOut() {
        $.callMessage({//登录超时,给原生发消息,原生在其他页面也同时登录下线
            "funcNo": "50500",
            "msgNo": "401",
            "targetModule": "user_center",
            "sourceModule": "trade",
            "action": "4",
            "param": {}
        });
        var tipStr = "<div class=\"pop_main\" style=\"height: 35px;font-size:0.15rem\"><div>登录超时,是否重新登录?</div></div>";
        iConfirm("登录超时", tipStr, function () {
            require.async("trade/scripts/account/index.js", function (module) {
                module.clearCache();
            });
            var pageCode = $.getCurrentPageObj().pageCode;
            var _loginClass = getCurUserInfo()._loginClass;
            var _param = $.getPageParam() || {};
            _param._loginClass = _loginClass;
            $(".top_title .logout").hide();
            clearUserInfo(_loginClass);
            if (global.callNative && global.isSso) {
                if (pageCode.indexOf("credit/") == 0) {
                    _param.switchUserInfo = "1";
                } else if (pageCode.indexOf("option/") == 0) {
                    _param.switchUserInfo = "2";
                } else {
                    _param.switchUserInfo = "0";
                }
            }
            require.async("commonFunc", function (module) {
                module.login(pageCode, "account/login", _param, {
                    "topage": pageCode,
                    "param": _param
                }, null, "", true);
            });
        }, function () {
            var _loginClass = getCurUserInfo()._loginClass;
            var pageCode = $.getCurrentPageObj().pageCode;
            var param = {
                "topage": pageCode,
                "param": $.getPageParam() || {},
                "_loginClass": _loginClass,
            };
            $(".top_title .logout").hide();
            clearUserInfo(_loginClass);
            if (global.callNative && global.isSso) {
                if (pageCode == "account/index") {
                    $.pageRefresh();
                } else {
                    $.pageInit(pageCode, "account/index", param, "", true);
                }
            } else {
                $.pageInit(pageCode, "account/index", param, "", true);
            }
        }, "登录", "退出");
    }

    /**
     * 设置或修改登录用户信息
     * @param {Object} data 登录数据
     */
    function setCurUserInfo(data, type) {
        curUserInfo = data;
        if (!type) {
            type = data._loginClass;
        }
        recordType(type);
        var userInfo = JSON.stringify(data);
        $.setSStorageInfo(dealType(type) + "_userInfo", userInfo, false, {
            "shareCookie": global.shareCookie,
            "isEncrypt": global.shareCookie,
            "isSaveSession": !global.shareCookie
        });// 信用普通
        if (global.jsessionid) {
            $.setSStorageInfo("jsessionid", data.jsessionid, false, {
                "shareCookie": global.shareCookie,
                "isSaveSession": !global.shareCookie
            });
        }
        if (global.callNative && global.isSso) {
            if (type == "0") {//普通交易
                $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "trade_user_info", "value": userInfo});
            } else if (type == "1") {//信用交易
                $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "credit_user_info", "value": userInfo});
            } else if (type == "2") {
                $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "option_user_info", "value": userInfo});
            }
            $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "userInfo_flag", "value": userInfo});
            $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "userLogin_flag", "value": true});
        }
        var isLoginIn = $.getSStorageInfo("_isLoginIn", false, {"isDecrypt": global.shareCookie}) || "";
        $.setSStorageInfo("_isLoginIn", isLoginIn + "_" + dealType(type), false, {
            "shareCookie": global.shareCookie,
            "isSaveSession": !global.shareCookie
        }); // 保存登录成功状态
        $.setSStorageInfo("clientid", global.activePhone, true);
        $.setSStorageInfo("_lastDoTime", new Date().getTime());
    }

    /**
     * 获取登录用户信息
     */
    function getCurUserInfo(type) {
        if (!type) {
            if (!isValue(operationInfo)) {
                if (isValue($.getSStorageInfo("operationInfo"))) {
                    operationInfo = JSON.parse($.getSStorageInfo("operationInfo"));
                } else {
                    operationInfo = [];
                }
            }
            if (!isValue(curUserInfo) || curUserInfo._loginClass != operationInfo[0]) {
                var _userInfo = $.getSStorageInfo(dealType(operationInfo[0]) + "_userInfo", false, {"isDecrypt": global.shareCookie});
                if (isValue(_userInfo)) {
                    curUserInfo = JSON.parse(_userInfo);
                } else {
                    curUserInfo = {};
                }
            }
            return curUserInfo;
        } else {
            var _userInfo = $.getSStorageInfo(dealType(type) + "_userInfo", false, {"isDecrypt": global.shareCookie});
            if (isValue(_userInfo)) {
                return JSON.parse(_userInfo);
            } else {
                return {};
            }
        }
    }


    /**
     * 切换账号
     * @param {String} type 登录账号+类型   1234|0  N
     */
    function switchingCurUser(type, account) {
        if (curUserInfo._loginClass != type) {//如果要取的type的值不是等于loginclass
            curUserInfo = getCurUserInfo(type);//那么就获取两融的登录信息
            recordType(type);
            if (global.jsessionid) {
                $.setSStorageInfo("jsessionid", curUserInfo.jsessionid, false, {
                    "shareCookie": global.shareCookie,
                    "isSaveSession": !global.shareCookie
                });//然后再将两融的用户信息存进去
            }
        }
    }

    /**
     * 操作类型
     * @param {Object} type 登录类型
     * @param {Object} isDelete 是否是删除  N
     */
    function recordType(type, isDelete) {
        operationInfo = unshiftDeleteSame(operationInfo, type, isDelete);
        $.setSStorageInfo("operationInfo", JSON.stringify(operationInfo), false, {
            "shareCookie": global.shareCookie,
            "isSaveSession": !global.shareCookie
        });// 信用普通
    }

    /**
     * 退出登录的账号类型
     * @param {Object} type
     */
    function clearUserInfo(type, account, flag, souce) {
        $.clearRequest();
        var isLoginIn = $.getSStorageInfo("_isLoginIn");
        if (isLoginIn && isLoginIn != "false") {
            if (type) {
                if (isLoginIn.indexOf("_" + dealType(type)) != -1) {
                    if (account) {
                        var info = getCurUserInfo(type);
                        if (info.fund_account == account) {
                            recordType(type, true);
                            if (type == "1") {
                                clearTransferInfo(account);
                            }
                            if (curUserInfo._loginClass == type && curUserInfo.fund_account == account) {
                                curUserInfo = {};
                            }
                            //如果原生发的退出就不需要再发904了
                            if (!flag && global.callNative && global.isSso) {
                                var account_type = info._acct_type;
                                var _account_type = "";
                                if (account_type == "204") {
                                    _account_type = "C";
                                } else if (account_type == "202") {
                                    _account_type = "B";
                                } else {
                                    _account_type = "A";
                                }
                                $.callMessage({
                                    "funcNo": "50500",
                                    "msgNo": "904",
                                    "sourceModule": "trade",
                                    "targetModule": "sso",
                                    "action": "4",
                                    "param": {
                                        "login_type": "1",
                                        "account": "",
                                        "account_type": _account_type
                                    }
                                });
                            }
                            $.clearSStorage("gd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股东数据
                            $.clearSStorage("qx|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空权限数据
                            $.clearSStorage("thirdgd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股转——股东账号数据
                            var isLoginIn = $.getSStorageInfo("_isLoginIn", false, {"isDecrypt": global.shareCookie}) || "";
                            isLoginIn = isLoginIn.replaceAll("_" + dealType(type), "");
                            $.setSStorageInfo("_isLoginIn", isLoginIn, false, {
                                "shareCookie": global.shareCookie,
                                "isSaveSession": !global.shareCookie
                            }); // 保存登录成功状态
                            $.clearSStorage(dealType(type) + "_userInfo", false, {"shareCookie": global.shareCookie});
                            $.clearLikeSStorage("go_hq_");
                            require.async("trade/scripts/account/index.js", function (module) {
                                module.clearCache();
                            });
                        }
                    } else {
                        recordType(type, true);
                        if (type == "1") {
                            clearTransferInfo();
                        }
                        if (curUserInfo._loginClass == type) {
                            curUserInfo = {};
                        }
                        var info = getCurUserInfo(type);

                        //如果原生发的退出就不需要再发904了
                        if (!flag && global.callNative && global.isSso) {
                            var account_type = info._acct_type;
                            var _account_type = "";
                            if (account_type == "204") {
                                _account_type = "C";
                            } else if (account_type == "202") {
                                _account_type = "B";
                            } else {
                                _account_type = "A";
                            }
                            $.callMessage({
                                "funcNo": "50500",
                                "msgNo": "904",
                                "sourceModule": "trade",
                                "targetModule": "sso",
                                "action": "4",
                                "param": {
                                    "login_type": "1",
                                    "account": "",
                                    "account_type": _account_type
                                }
                            });
                        }
                        $.clearSStorage("gd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股东数据
                        $.clearSStorage("qx|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空权限数据
                        $.clearSStorage("thirdgd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股转——股东账号数据
                        var isLoginIn = $.getSStorageInfo("_isLoginIn", false, {"isDecrypt": global.shareCookie}) || "";
                        isLoginIn = isLoginIn.replaceAll("_" + dealType(type), "");
                        $.setSStorageInfo("_isLoginIn", isLoginIn, false, {
                            "shareCookie": global.shareCookie,
                            "isSaveSession": !global.shareCookie
                        }); // 保存登录成功状态
                        $.clearSStorage(dealType(type) + "_userInfo", false, {"shareCookie": global.shareCookie});
                        $.clearLikeSStorage("go_hq_");
                        require.async("trade/scripts/account/index.js", function (module) {
                            module.clearCache();
                        });
                    }
                }
            } else {
                $.clearSStorage("_isLoginIn", false, {"shareCookie": global.shareCookie});
                $.clearSStorage("jsessionid", false, {"shareCookie": global.shareCookie});
                $.clearSStorage("clientid", true);
                for (var i = 0, operLength = operationInfo.length; i < operLength; i++) {
                    var info = getCurUserInfo(operationInfo[i]);
                    if (global.callNative && global.isSso) {
                        //如果原生发的退出就不需要再发904了
                        if (!flag && global.callNative && global.isSso) {
                            var account_type = info._acct_type;
                            var _account_type = "";
                            if (account_type == "204") {
                                _account_type = "C";
                            } else if (account_type == "202") {
                                _account_type = "B";
                            } else {
                                _account_type = "A";
                            }
                            $.callMessage({
                                "funcNo": "50500",
                                "msgNo": "904",
                                "sourceModule": "trade",
                                "targetModule": "sso",
                                "action": "4",
                                "param": {
                                    "login_type": "1",
                                    "account": "",
                                    "account_type": _account_type
                                }
                            });
                        }
                    }
                    $.clearSStorage("gd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股东数据
                    $.clearSStorage("qx|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空权限数据
                    $.clearSStorage("gd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股东数据
                    $.clearSStorage("thirdgd|" + info._loginClass + "|" + info._uniqueness, false, {"shareCookie": global.shareCookie});//清空股转——股东账号数据
                    $.clearSStorage(dealType(operationInfo[i]) + "_userInfo", false, {"shareCookie": global.shareCookie});
                }
                $.clearSStorage("operationInfo", false, {"shareCookie": global.shareCookie});
                $.clearLikeSStorage("go_hq_");
                clearTransferInfo();//清除页面定时器
                clearAccountInfos();//删除登录用户信息
                operationInfo = [];
                curUserInfo = {};
                require.async("commonFunc", function (module) {
                    module.clearCheckTradeTimer();//清空定时器
                });
                require.async("trade/scripts/account/index.js", function (module) {
                    module.clearCache();//重置首页
                });

            }
            if (global.callNative && global.isSso) {
                if (type == "1") {//信用交易
                    $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "credit_user_info", "value": ""});
                } else if (type == "2") {
                    $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "option_user_info", "value": ""});
                } else {//普通交易外面的退出
                    $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "trade_user_info", "value": ""});
                    $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "credit_user_info", "value": ""});
                    //$.callMessage({"moduleName":"trade","funcNo": "50040","key":"option_user_info","value":""});
                }
                $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "userInfo_flag", "value": ""});
                $.callMessage({"moduleName": "trade", "funcNo": "50040", "key": "userLogin_flag", "value": ""});
            }

            changeTips();//重置首页
            if (souce == 'login') {

            } else {
                var pageCode = $.getCurrentPageObj().pageCode || '';
                if (pageCode != "account/index") {
                    $.pageInit(pageCode, "account/index", {"history": true}, "left", true);
                } else if ($.getCurrentPageObj().pageCode == "account/index") {
                    $.pageRefresh();
                }
                sessionStorage.setItem("currentMainAccount", "");
            }

            // //清空三板的股东账户
            // var userInfo = getCurUserInfo();
            // var key = "gd|"+userInfo._loginClass+"|"+userInfo._uniqueness;
            // $.setSStorageInfo(key,"", false, {"shareCookie": global.shareCookie,"isEncrypt": global.shareCookie,"isSaveSession":!global.shareCookie});// 信用普通
        }
    }


    /**
     * 是否已交易登录
     * @param {Object} type 登录类型,信息类型 默认是普通交易信息 1：融资融券信息 N
     */
    function isTradeLogin(type) {
//		if(type){
        return isValue(getCurUserInfo(type));
//		}
//		else{
//			return isValue(operationInfo);//不需要这个,因为切换账号的时候会保存值,所以根本判断不了是否登录
//		}
    }

    /**
     * 类型字段转换
     * @param {Object} type 登录类型
     */
    function dealType(type) {
        type = (type || "") + "";
        switch (type) {
            case "1":
                return "credit";
            case "2":
                return "option";
            case "3":
                return "financial";
            default:
                return "stock";
        }
    }


    /**
     * 数组去除相同的数据，添加或者删除数组
     * @param {Array} arrays 要操作的数组
     * @param {Object} account 添加或者删除
     * @param {Object} isDelete 是否是删除  N
     */
    function unshiftDeleteSame(arrays, account, isDelete) {
        var as = [];
        if (!isDelete) {
            as.push(account);
        }
        for (var i = 0; i < arrays.length; i++) {
            if (arrays[i] != account) {
                as.push(arrays[i]);
            }
        }
        return as;
    }


    /**
     * 存储登录用户信息
     * @param {Array} data 登录数据
     * @param {String} type 登录账号+类型   1234|0  N
     */
    function setAccountInfos(data, type, account) {
        if (data) {
            getAccountInfos();
            if (!accountInfos) {
                accountInfos = {};
            }
            if (!type) {
                type = data[0]._loginClass;
            }
            if (!account) {
                account = data[0].cust_code;
            }
            if (accountInfos[dealType(type)]) {
                accountInfos[dealType(type)][account] = data;
            } else {
                accountInfos[dealType(type)] = {};
                accountInfos[dealType(type)][account] = data;
            }
            var userInfo = JSON.stringify(accountInfos);
            $.setSStorageInfo("userInfos", userInfo, false, {
                "shareCookie": global.shareCookie,
                "isEncrypt": global.shareCookie,
                "isSaveSession": !global.shareCookie
            });// 信用普通
        }
    }


    /**
     * 获取登录用户信息
     * @param {String} type 登录账号+类型   1234|0  N
     */
    function getAccountInfos(type, account) {
        if (!isValue(accountInfos)) {
            var userInfo = $.getSStorageInfo("userInfos", false, {"isDecrypt": global.shareCookie});
            if (userInfo && typeof (userInfo) == "string" && userInfo != "null" && userInfo != "0") {
                accountInfos = JSON.parse(userInfo);
            }
        }
        if (type && isValue(accountInfos)) {
            if (account) {
                if (accountInfos[dealType(type)]) {
                    return accountInfos[dealType(type)][account];
                }
            } else {
                return accountInfos[dealType(type)];
            }
        } else {
            return accountInfos;
        }
    }


    /**
     * 删除登录用户信息
     */
    function clearAccountInfos() {
        clearUserInfo();
        accountInfos = {};
        $.clearSStorage("userInfos", false, {"shareCookie": global.shareCookie});
    }


    /**
     * 获取主铺账户信息
     * @param {Object} type
     */
    function getMainAuxiliaryAccount(type, account) {
        var accounts = getAccountList(type, account);
        if (isValue(accounts)) {
            var m = {};
            for (var i = 0; i < accounts.length; i++) {
                var a = accounts[i].fund_account + "|" + accounts[i].main_flag;
                var s = m[a] || [];
                s.push(accounts[i]);
                m[a] = s;
            }
            return m;
        } else {
            return null;
        }
    }

    /**
     * 获取股东列表
     * @param {Object} type
     * @param {Object} account
     */
    function getAccountList(type, account) {
        getAccountInfos(type, account);
        var accounts = [];
        if (type) {
            if (account) {
                if (accountInfos[dealType(type)]) {
                    accounts = accountInfos[dealType(type)][account];
                }
            } else {
                var b = accountInfos[dealType(type)];
                $.each(b, function (k, v) {
                    if (v) {
                        for (var i = 0; i < v.length; i++) {
                            accounts.push(v[i]);
                        }
                    }
                });
            }
        } else {
            getCurUserInfo();
            if (curUserInfo) {
                var type = curUserInfo._loginClass;
                if (accountInfos[dealType(type)]) {
                    accounts = accountInfos[dealType(type)][curUserInfo.cust_code];
                }
            }
        }
        return accounts
    }

    /***
     * 获取资产账号的对应的股东账号
     * @param {Object} types 市场|类别|资金账号
     * @param {Object} fund_account
     */
    function getShareholderAccount(types, type, account) {
        var shareholder = [];
        if (types) {
            types = types.split("|");
            var accounts = getAccountList(type, account);
            if (isValue(accounts)) {
                for (var i = 0; i < accounts.length; i++) {
                    var acc = accounts[i];
                    if (types[2]) {
                        if (acc.fund_account == types[2]) {
                            if (types[1]) {
//								if(acc.holder_kind == types[1]){
                                if (types[0]) {
                                    if (acc.exchange_type == types[0]) {
                                        var a = acc.stock_account;
                                        if (a) {
                                            shareholder.push(a);
                                        }
                                    }
                                } else {
                                    var a = acc.stock_account;
                                    if (a) {
                                        shareholder.push(a);
                                    }
                                }
//								}
                            } else if (types[0]) {
                                if (acc.exchange_type == types[0]) {
                                    var a = acc.stock_account;
                                    if (a) {
                                        shareholder.push(a);
                                    }
                                }
                            } else {
                                var a = acc.stock_account;
                                if (a) {
                                    shareholder.push(a);
                                }
                            }
                        }
                    } else if (types[1]) {
//						if(acc.holder_kind == types[1]){
                        if (types[0]) {
                            if (acc.exchange_type == types[0]) {
                                var a = acc.stock_account;
                                if (a) {
                                    shareholder.push(a);
                                }
                            }
                        } else {
                            var a = acc.stock_account;
                            if (a) {
                                shareholder.push(a);
                            }
                        }
//						}
                    } else {
                        if (acc.exchange_type == types[0]) {
                            var a = acc.stock_account;
                            if (a) {
                                shareholder.push(a);
                            }
                        }
                    }
                }
            }
        }
        return shareholder;
    }

    /**
     * 启动用户登录超时定时检测
     * */
//	function initLogoutTime(){
//		//启动账户登录检测定时器
//		clearLogoutTime();
//		logoutTimer = window.setInterval(function(){
//			var lastDoTime = $.getSStorageInfo("_lastDoTime") || "";
//			if(global.logoutTimeNum && new Date().getTime() - Number(lastDoTime) > 1000*60*global.logoutTimeNum){
//				var pageCode = $.getCurrentPageObj().pageCode;
//				var param = {
//					"topage": pageCode,
//					"param": $.getPageParam() || {}
//					};
//				clearUserInfo();
//				$.hidePreloader();
//				$(".top_title .logout").hide();
//				clearLogoutTime();
//				if(global.callNative && global.isSso){
//					if(pageCode == "account/index"){
//						$.pageRefresh();
//					}
//					else{
//						$.pageInit(pageCode,"account/index",param,"",true);
//					}
//				}
//				else{
//					$.pageInit(pageCode,"account/login",param,"",true);
//				}
//				$.alert("长时间没有操作,交易登录已退出");
//			}
//		},5000); // 5秒检测一次
//	}

    /**
     * 清除定时器
     */
//	function clearLogoutTime(){
//		if(logoutTimer != null){
//			window.clearInterval(logoutTimer);
//			logoutTimer = null;
//		}
//	}

    /**
     * 获取划转普通信息
     * @param {Object} type
     */
    function getTransferInfo(type) {
        if (!isValue(transferInfo)) {
            var userInfo = $.getSStorageInfo("transferInfo");
            if (userInfo && typeof (userInfo) == "string" && userInfo != "null" && userInfo != "0") {
                transferInfo = JSON.parse(userInfo);
            }
        }
        return transferInfo;
    }

    /**
     * 设置划转普通信息
     * @param {Object} type
     */
    function setTransferInfo(type, data) {
        getTransferInfo();
        transferInfo = data;
        $.setSStorageInfo("transferInfo", JSON.stringify(transferInfo), false, {
            "shareCookie": global.shareCookie,
            "isSaveSession": !global.shareCookie
        });// 信用普通
    }

    /**
     * 删除划转普通信息
     * @param {Object} type
     */
    function clearTransferInfo(type) {
        transferInfo = null;
        $.clearSStorage("transferInfo", false, {"shareCookie": global.shareCookie});
    }

    /*******************关于登录账号信息**********************/

    function loginTypeSize() {
        return operationInfo.length;
    }


    /**
     * 双按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} cancelFunction 点击取消执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} cancel 取消按钮语
     */
    function iConfirm(theme, content, determineFunction, cancelFunction, determine, cancel, prompt, clickType, btnClass) {
        $("#newTradingTipsBox2").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        if (typeof (cancel) == "undefined") {
            cancel = "取消";
        }
        var div = '<div id="newTradingTipsBox2" style="position: fixed"><div key-panel-main="true" class="prompt_box2 prompt_box_x">' + theme + '<div style="height:100%;overflow:hidden;"><div class="_content">' + content +
            '</div></div><div class="btn"><div><a href="javascript:void(0)" id="cancel" class="' + btnClass + '">' + cancel +
            '</a></div><div><a class="needsclick ' + btnClass + '" href="javascript:void(0)" id="determine">' + determine +
            '</a>';
        if (prompt) {
            div += '<div class="prompt_shade"></div>';
        }
        div += '</div></div></div><div class="shade"></div></div>';
        $(pageId).append(div);
        var $content = $(pageId + " #newTradingTipsBox2 .prompt_box2 ._content");
        if ($content.height() < 30) {
            $content.height(30);
        }
        var $prompt = $(pageId + " #newTradingTipsBox2 .prompt_box2");
        var wHeight = Number(wHeight) * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        $prompt.css("margin-top", 0 - topHeight);
        $(pageId + " #newTradingTipsBox2").css("position", "static");
        setTimeout(function () {
            $.bindEvent($(pageId + " #newTradingTipsBox2 .prompt_box2 .prompt_shade"), function (e) {
                if (prompt && typeof prompt == "function") {
                    if (prompt($content)) {
                        $(pageId + " #newTradingTipsBox2 #determine").trigger(clickType ? clickType : "touchstart");
                    }
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
                evt.preventDefault();
            });
            $.bindEvent($(pageId + " #newTradingTipsBox2 #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
                evt.preventDefault();
            }, clickType ? clickType : "touchstart");
            $.bindEvent($(pageId + " #newTradingTipsBox2 #cancel"), function (e) {
                setTimeout(function () {
                    $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                    $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                }, 100);
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (cancelFunction) {
                    setTimeout(function () {
                        cancelFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
                evt.preventDefault();
            }, clickType ? clickType : "touchstart");
        }, 0);
    }


    /**
     * 单按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} styleJudge 按钮样式变化
     */
    function singleIConfirm(theme, content, determineFunction, determine, prompt, styleJudge, paramMap) {
        $("#newTradingTipsBox2").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        var contentStyle = "";
        if (paramMap) {
            pageId = paramMap.pageId || pageId;
            contentStyle = paramMap.contentStyle || contentStyle;
        }
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        var div = '<div id="newTradingTipsBox2" style="position: fixed"><div key-panel-main="true" class="prompt_box2">' + theme + '<div class="_content" style="' + contentStyle + '">' + content + '</div>';
        if (styleJudge == "1") {//科创板盘后委托框样式
            div += '<div class="btn1"><div><a class="needsclick" href="javascript:void(0)" id="determine">' + determine + '</a></div></div>';
        } else {
            div += '<div class="singleBtn"><div><a class="needsclick" href="javascript:void(0)" id="determine">' + determine + '</a></div></div>';
        }
        if (prompt) {
            div += '<div class="prompt_shade"></div>';
        }
        div += '</div><div class="shade"></div></div>';
        $(pageId).append(div);
        var $content = $(pageId + " #newTradingTipsBox2 .prompt_box2 ._content");
        if ($content.height() < 30) {
            $content.height(30);
        }
        var $prompt = $(pageId + " #newTradingTipsBox2 .prompt_box2");
        var wHeight = Number(wHeight) * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        $prompt.css("margin-top", 0 - topHeight);
        $(pageId + " #newTradingTipsBox2").css("position", "static");
        $.bindEvent($(pageId + " #newTradingTipsBox2 .prompt_box2 .prompt_shade"), function (e) {
            if (prompt && typeof prompt == "function") {
                if (prompt($content)) {
                    $(pageId + " #newTradingTipsBox2 #determine").trigger("touchstart");
                }
            }
            var evt = e || window.event;
            evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
        });
        $.bindEvent($(pageId + " #newTradingTipsBox2 #determine"), function (e) {
            $(this).unbind();
            this.touchstart = null;
            $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
            $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
            setTimeout(function () {
                var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                if (opacity == 0) {
                    $("#newTradingTipsBox2").remove();
                }
            }, 500);
            if (determineFunction) {
                setTimeout(function () {
                    determineFunction($content);
                }, 300);
            }
            var evt = e || window.event;
            evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
        }, "touchstart");
    }

    /**
     * 单按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} styleJudge 按钮样式变化
     * @param {Object} otherClass 弹框额外样式添加
     */
    function singleIConfirmNew(theme, content, determineFunction, determine, prompt, styleJudge, paramMap,otherClass) {
        $("#singleIConfirmNew").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (paramMap) {
            pageId = paramMap.pageId || pageId;
        }
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        var div = '<div id="singleIConfirmNew" class="' + (otherClass || "") + '">';
        div += '<div class="ui dialog-overlay" style="display: block;"></div>';
        div += '<div class="prompt_dialog_pop">';
        div += '<div class="pop_tit">' + theme + '</div>';
        div += '<div class="pop_cet" style="min-height: 50px;">' + content + '</div>';
        div += '<div class="pop_btn"><a class="btn_text" href="javascript:void(0)" id="determine">' + determine + '</a></div>';
        if (prompt) {
            div += '<div class="prompt_shade"></div>';
        }
        div += '</div>';
        $(pageId).append(div);
        var $content = $(pageId + " #singleIConfirmNew .pop_cet");
        var $prompt = $(pageId + " #singleIConfirmNew .prompt_dialog_pop");
        var wHeight = $(window).height() * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 262, "overflow": "auto"});
        }
        setTimeout(function () {
            $.bindEvent($(pageId + " #singleIConfirmNew .prompt_shade"), function (e) {
                if (prompt && typeof prompt == "function") {
                    if (prompt($content)) {
                        $(pageId + " #singleIConfirmNew #determine").trigger("touchstart");
                    }
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            });
            $.bindEvent($(pageId + " #singleIConfirmNew #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #singleIConfirmNew .dialog-overlay").css("opacity", "0");
                $(pageId + " #singleIConfirmNew .prompt_dialog_pop").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #singleIConfirmNew .dialog-overlay").css("opacity");
                    if (opacity == 0) {
                        $("#singleIConfirmNew").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
        }, 500);
    }

	function generatePrompt111(data,msg,css){
//		var tipStr = [];
//		tipStr.push("<ul class='tips_list'>");
//		for(var i = 0; i < data.length; i++){
//			tipStr.push("<li><span><em>")
//			tipStr.push(data[i][0]);
//			tipStr.push("</em></span><span><em>");
//			tipStr.push(data[i][1]);
//			tipStr.push("</em></span></li>");
//		}
//		tipStr.push("</ul>");
//		return tipStr.join("");
        var tipStr = [];
        tipStr.push("<table class='table_tips_list " + (css || "list") + "' width=\"100%\" border=\"0\" cellspacing=\"0\" cellpadding=\"0\"><tbody>");
        for (var i = 0; i < data.length; i++) {
            if (data[i]) {
                tipStr.push("<tr><td><nobr><em>")
                tipStr.push(data[i][0]);
                tipStr.push("</nobr></em></td><td><em>");
                tipStr.push(data[i][1]);
                tipStr.push("</em></td></tr>");
            } else {
                tipStr.push("<tr></tr>");
            }
        }
        tipStr.push("</tbody></table>");
        tipStr.push("<div class='delisting'>");
        tipStr.push(msg);
        tipStr.push("</div>");
        return tipStr.join("");
    }

	function generatePrompt(data,msg,css){
		var tipStr = [];
		tipStr.push('<ul class="order_confirm_list">');
		for(var i = 0; i < data.length; i++){
			if(data[i]) {
				tipStr.push("<li><span>")
				tipStr.push(data[i][0]);
				tipStr.push("</span><p>");
				tipStr.push(data[i][1]);
				tipStr.push("</p></li>");
			}else {
				tipStr.push("<li></li>");
			}
		}
		tipStr.push("</ul>");
		tipStr.push("<div class='delisting'>");
		tipStr.push(msg);
		tipStr.push("</div>");
		return tipStr.join("");
	}
    function addChoiceList(div, title, liHtml, determine, type, id, keyboard, buriedPointParam) {
        var myHScroller = null;
        var scrollFun = function () {
            var scrollOptions = {
                scrollerHeight: $(window).height() - $(_pageId + " .listSelection .top_title").height(), // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                bounceTime: 300 // 回弹的动画时间
            };
            myHScroller = iscrollUtils.vScroller(scrollOptions);
        }
        var _pageId = '#' + $.getCurrentPageObj().pageId + " ";

        var divID = "";
        var pageId = _pageId;
        if (id) {
            divID = ' id="list_' + id + '"';
            pageId = pageId + "#list_" + id;
        }
        var html = [];
        if (type) {
            $(pageId + ".listSelection.multi").remove();
            html.push('<div' + divID + ' class="listSelection multi" style="z-index: 1000;">');
            $.bindEvent(div, function (e) {
                div = $(this);
                $(_pageId + ".add").css("z-index", "0");
                $(_pageId + ".less").css("z-index", "0");
                $(_pageId + ".fund_table").hide();
                $(pageId + ".listSelection.multi").showLeft();
                scrollFun();//加载滑动组件
                if (!global.startJSkeyboard) {
                    e.stopPropagation(); // 阻止冒泡
                }
                //页面埋点
                if (buriedPointParam && buriedPointParam.pageObjectId2) {
                    pageBuryingPoint();
                    pageBuryingPoint(buriedPointParam.pageObjectId2);
                }
            });
        } else {
            $(pageId + ".listSelection.radio").remove();
            html.push('<div' + divID + ' class="listSelection radio">');
            $.bindEvent(div, function (e) {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                $(_pageId + ".big_select").css("display", "none");//取消场外赎回的巨额选项
                div = $(this);
                $(_pageId + ".add").css("z-index", "0");
                $(_pageId + ".less").css("z-index", "0");
                $(_pageId + ".fund_table").hide();
                $(pageId + ".listSelection.radio").showLeft();
                scrollFun();//加载滑动组件
                if (!global.startJSkeyboard) {
                    e.stopPropagation(); // 阻止冒泡
                }
                //页面埋点
                if (buriedPointParam && buriedPointParam.pageObjectId2) {
                    pageBuryingPoint();
                    pageBuryingPoint(buriedPointParam.pageObjectId2);
                }
            });
        }
        html.push('<div class="top_title">');
        html.push('<a href="javascript:void(0);" class="cancel icon_back text"></a>');
        html.push('<h3>');
        html.push(title);
        html.push('</h3>');
        if (type) {
            html.push('<a href="javascript:void(0);" class="save">保存</a>');
        }
        html.push('</div><div class="list">');
        html.push('<div class="iscroll_vWrapper" id="wrapper" style="position: relative;">');
        html.push('<div class="iscroll_vScroller">');
        html.push('<div class="vertical_list" data-is-content="true" style="padding: 10px;background: #ffffff;">');
        html.push(liHtml);
        html.push('</div>');
        html.push('</div>');
        html.push('</div>');
        html.push('</div>');
        html.push('</div>');
        $(_pageId).append(html.join(""));
        $(pageId + ".listSelection .list").height(wHeight - $(pageId + ".listSelection .top_title").height())
        $.bindEvent(pageId + ".listSelection.radio .list li", function (e) {
            $(this).addClass("active").siblings().removeClass("active");
            if (determine) {
                determine($(this), div);
            }
            if (myHScroller) {
                myHScroller.destroy();
                myHScroller = null;
            }
            $(pageId + ".listSelection").hideLeft();
            window.setTimeout(function () {
                $(_pageId + ".add").css("z-index", "100");
                $(_pageId + ".less").css("z-index", "100");
                $(_pageId + ".fund_table").show();
            }, "100")
            if (buriedPointParam && buriedPointParam.clickObjectId) {
                var paramList = buriedPointParam.clickParamMap;
                paramList.i_change_to = $(this).attr("id");
                comStat(buriedPointParam.clickObjectId, 2, buriedPointParam.clickActionId, true, buriedPointParam.clickParamMap);//埋点
            }
            //页面埋点
            if (buriedPointParam && buriedPointParam.pageObjectId1) {
                pageBuryingPoint();
                pageBuryingPoint(buriedPointParam.pageObjectId1);
            }
            e.stopPropagation(); // 阻止冒泡
        }, "tap");
        $.bindEvent(pageId + ".listSelection.multi .list li", function (e) {
            $(this).toggleClass("active");
            if (myHScroller) {
                myHScroller.destroy();
                myHScroller = null;
            }
            //页面埋点
            if (buriedPointParam && buriedPointParam.pageObjectId1) {
                pageBuryingPoint();
                pageBuryingPoint(buriedPointParam.pageObjectId1);
            }
            e.stopPropagation(); // 阻止冒泡
        }, "tap");
        $.bindEvent(pageId + ".listSelection .cancel", function (e) {
            $(pageId + ".listSelection").hideLeft();
            if (myHScroller) {
                myHScroller.destroy();
                myHScroller = null;
            }
            window.setTimeout(function () {
                $(_pageId + ".add").css("z-index", "100");
                $(_pageId + ".less").css("z-index", "100");
                $(_pageId + ".fund_table").show();
            }, "100")
            if (buriedPointParam && buriedPointParam.backObjectId) {
                comStat(buriedPointParam.backObjectId, 2, buriedPointParam.backActionId, true, buriedPointParam.backParamMap);//埋点
            }
            //页面埋点
            if (buriedPointParam && buriedPointParam.pageObjectId1) {
                pageBuryingPoint();
                pageBuryingPoint(buriedPointParam.pageObjectId1);
            }
            e.stopPropagation(); // 阻止冒泡
        }, "tap");
        $.bindEvent(pageId + ".listSelection.multi .save", function (e) {
            if (determine) {
                determine($(pageId + ".listSelection li.active"), div);
            }
            if (myHScroller) {
                myHScroller.destroy();
                myHScroller = null;
            }
            $(pageId + ".listSelection").hideLeft();
            window.setTimeout(function () {
                $(_pageId + ".add").css("z-index", "100");
                $(_pageId + ".less").css("z-index", "100");
                $(_pageId + ".fund_table").show();

            }, "100")
            //页面埋点
            if (buriedPointParam && buriedPointParam.pageObjectId1) {
                pageBuryingPoint();
                pageBuryingPoint(buriedPointParam.pageObjectId1);
            }
            e.stopPropagation(); // 阻止冒泡
        }, "tap");
    }


    /**
     * 加载显示协议页面
     * @param {Object} paraMap 参数
     * @param {Object} qdCallback 确定回调方法
     * @param {Object} qxCallback 取消回调方法
     */
    function Agreement(paraMap, qdCallback, qxCallback) {
        var _pageId = paraMap.pageId || "#" + $.getCurrentPageObj().pageId;
        $(_pageId + " .agreement").remove();
        var para = {
            "top": typeof (paraMap.top) == "undefined" ? true : paraMap.top,//是否显示头部返回按钮
            "topTxt": paraMap.topTxt || "", // 头部返回的文字
            "title": paraMap.title || "签署协议",// 头部显示文字 ，可以为数组
            "class": paraMap.class || "", // 添加样式名
            "height": paraMap.height || $(window).height(), // 高度
            "width": paraMap.width || $(window).width(), // 宽度
            "src": paraMap.src || "", // iframe 的 引用地址，可以为数组
            "checkbox": typeof (paraMap.checkbox) == "undefined" ? true : paraMap.checkbox, // 是否显示协议勾选按钮
            "checkboxTxt": paraMap.checkboxTxt || "同意并签署上述协议", // 协议勾选按钮文字
            "checkboxDefault": typeof (paraMap.checkboxDefault) == "undefined" ? false : paraMap.checkboxDefault,//协议勾选按钮是否默认勾上
            "twoButton": typeof (paraMap.twoButton) == "undefined" ? false : paraMap.twoButton, // 是否有下面的返回按钮
            "back": paraMap.cancel || "返回", // 下面的返回按钮的文字
            "sure": paraMap.sure || "已阅读并同意", // 确定按钮的文字
            "isShowWait": typeof (paraMap.isShowWait) == "undefined" ? true : paraMap.isShowWait, // 是否有加载提示
            "lastStep": paraMap.lastStep || "上一个", // 多个地址 上一个的文字提示
            "nextStep": paraMap.nextStep || "下一个", // 多个地址 下一个的文字提示
            "iAlertTxt": paraMap.iAlertTxt || "请先同意勾选协议", // 协议勾选按钮没有勾上的提示文字
            "first": true,
            "srcList": false,
            "srcLengln": 0,
            "iframePosi": 1,
            "load_in": true,
            "id": "Agreement"
        };
        var html = [];
        if (para.src && para.src instanceof Array) {
            para.srcLengln = para.src.length;
            if (para.srcLengln > 0) {
                para.srcList = true;
                para.twoButton = true;
            }
        }
        if (para.title && typeof (para.title) == "string") {
            para.title = [para.title];
        }
        html.push('<div class="agreement ' + para.class + '" id="' + para.id + '">');
        html.push('<header class="header">');
        html.push('<div class="top_title">');
        if (para.top) {
            html.push('<a href="javascript:void(0);" class="icon_back text">');
            html.push(para.topText);
            html.push('</a>');
        }
        html.push('<h3>');
        html.push(para.title[0]);
        html.push('</h3></div></header>');
        html.push('<div class="sr_entry" style="overflow:auto;-webkit-overflow-scrolling:touch;">');
        if (para.srcList) {
            for (var i = 0; i < para.srcLengln; i++) {
                html.push('<iframe src="' + para.src[i] + '"></iframe>');
            }
        } else {
            html.push('<iframe src="' + para.src + '"></iframe>');
        }
        html.push('</div><div class="sr_but">');
        if (para.checkbox) {
            html.push('<div class="sr_check"><span class="icon_check">');
            if (para.checkboxDefault) {
                html.push('<input type="checkbox" class="c1" checked="checked"/><label>');
            } else {
                html.push('<input type="checkbox" class="c1" /><label>');
            }
            html.push(para.checkboxTxt);
            html.push('</label></span></div>');
        }
        html.push('<div class="ce_btn">');
        if (para.twoButton) {
            html.push('<a class="back" href="javascript:void(0)">' + para.back + '</a>');
        }
        html.push('<a class="sure" href="javascript:void(0)">' + para.sure + '</a>');
        html.push('</div></div></div>');
        $(_pageId).append(html.join(""));
        var agre = $(_pageId + " #" + para.id);
        var divs = {
            "iframe": agre.find("iframe"),
            "icon_back": agre.find(".top_title .icon_back"),
            "back": agre.find(".ce_btn .back"),
            "icon_check": agre.find(".sr_check .icon_check"),
            "sure": agre.find(" .ce_btn .sure"),
            "icon_input": agre.find(" .sr_check .icon_check input")
        }
        divs.iframe[0].onload = function () {
            para.load_in = false;
            $.hidePreloader();
            divs.iframe.eq(0).show();
            agre.find(" .sr_but").show();
        };

        // top返回
        $.bindEvent(divs.icon_back, function (e) {
            agre.hide();
            e.stopPropagation(); // 阻止冒泡
        });
        // 下面返回按钮
        $.bindEvent(divs.back, function (e) {
            if (para.srcList) {
                if (para.iframePosi == 1) {
                    agre.hide();
                    if (qxCallback) {
                        qxCallback();
                    }
                } else {
                    para.iframePosi--;
                    divs.iframe.hide();
                    if (para.checkbox) {
                        divs.icon_input.attr("checked", true);
                    }
                    agre.find("h3").html(para.title[para.iframePosi - 1]);
                    divs.iframe.eq(para.iframePosi - 1).show();
                    divs.sure.html(para.nextStep);
                    if (para.iframePosi == 1) {
                        divs.back.html(para.back);
                    } else {
                        divs.back.html(para.lastStep);
                    }
                }
            } else {
                agre.hide();
                if (qxCallback) {
                    qxCallback();
                }
            }
            e.stopPropagation(); // 阻止冒泡
        });
        //勾选协议
        $.bindEvent(divs.icon_check, function (e) {
            var isChecked = $(this).find("input").attr("checked");
            if (isChecked) {
                $(this).find("input").attr("checked", false);
            } else {
                $(this).find("input").attr("checked", true);
            }
            e.stopPropagation();
        });
        //确定
        $.bindEvent(divs.sure, function (e) {
            if (para.srcList) {
                if (para.checkbox) {
                    var isChecked = divs.icon_input.attr("checked");  // 是否勾选协议
                    if (!isChecked)  // 未勾选协议时
                    {
                        $.alert(para.iAlertTxt);
                    } else {
                        if (para.iframePosi == para.srcLengln) {
                            para.iframePosi = 1;
                            if (qdCallback) {
                                qdCallback();
                            }
                        } else {
                            divs.iframe.hide();
                            divs.icon_input.attr("checked", false);
                            agre.find("h3").html(para.title[para.iframePosi]);
                            divs.iframe.eq(para.iframePosi).show();
                            para.iframePosi++;
                            divs.back.html(para.lastStep);
                            if (para.iframePosi == para.srcLengln) {
                                divs.sure.html(para.sure);
                            } else {
                                divs.sure.html(para.nextStep);
                            }
                        }
                    }
                } else {
                    if (para.iframePosi == para.srcLengln) {
                        para.iframePosi = 1;
                        if (qdCallback) {
                            qdCallback();
                        }
                    } else {
                        divs.iframe.hide();
                        agre.find("h3").html(para.title[para.iframePosi]);
                        divs.iframe.eq(para.iframePosi).show();
                        para.iframePosi++;
                        divs.back.html(para.lastStep);
                        if (para.iframePosi == para.srcLengln) {
                            divs.sure.html(para.sure);
                        } else {
                            divs.sure.html(para.nextStep);
                        }
                    }
                }
            } else {
                if (para.checkbox) {
                    var isChecked = divs.icon_input.attr("checked");  // 是否勾选协议
                    if (!isChecked)  // 未勾选协议时
                    {
                        $.alert(para.iAlertTxt);
                    } else {
                        if (qdCallback) {
                            qdCallback();
                        }
                    }
                } else {
                    if (qdCallback) {
                        qdCallback();
                    }
                }
            }
            e.stopPropagation(); // 阻止冒泡
        });
        //显示
        var show = function () {
            agre.showLeft();
            if (para.first) {
                var iframeHeight = para.height - agre.find("header").height() - agre.find(".sr_but").height();
                agre.find(".sr_entry").height(iframeHeight);
                divs.iframe.height(iframeHeight - 24);
                agre.css({"opacity": "1", "z-index": "1000000"});
                if (para.load_in && para.isShowWait) {
                    $.showPreloader("请等待...");
                }
            }
            para.iframePosi = 1;
            divs.iframe.hide();
            if (para.checkbox) {
                divs.icon_input.attr("checked", false);
            }
            agre.find("h3").html(para.title[0]);
            divs.back.html(para.back);
            if (para.srcList) {
                divs.sure.html(para.nextStep)
            }
            divs.iframe.eq(0).show();
        };
        //隐藏
        var hide = function () {
            agre.hideLeft();
        }
        //消除
        var destroy = function () {
            agre.remove();
            para = {};
            divs = {};
        }
        return {"show": show, "hide": hide, "destroy": destroy};
    }

    /**
     * 获取文本的宽度
     * @param {Object} $div
     * @param {Object} text
     * @param {Object} fontSize
     */
    function getWidth($div, text, fontSize) {
        $("body>._getWidth_").remove();
        var localName = $div[0].localName;
        if (!fontSize) {
            fontSize = $div.css("font-size");
        } else {
            fontSize += "px";
        }
        var html = "<" + localName + " class=\"_getWidth_\" style=\"font-size:" + fontSize + ";\">" + text + "</" + localName + ">";
        $("body").append(html);
        var w = $("body>._getWidth_")[0].offsetWidth;
        $("body>._getWidth_").remove();
        return w;
    }

    /**
     * 对文字的处理
     * @param {Object} $div
     * @param {Object} text
     * @param {Object} type
     */
    function fontOutOf($div, text, type) {
        var fontSize = $div.css("font-size").replace("px", "");
        fontSize = Number(fontSize);
        var width = $div.parent().width();
        var $div_width = getWidth($div, text);
        if ($div_width > width) {
            // 用省略号表示
            if (type == "1") {
                $div.parent().addClass("_ellipsis_");
                $div.html(text);
            }
            // 用跑马灯
            else if (type == "2") {
                $div.html("<marquee>" + text + "</marquee>");
            }
            // 用缩小字体
            else if (type == "3") {
                var size = fontSize - 1;
                for (var i = size; i >= 12; i--) {
                    var w = getWidth($div, text, i);
                    if (w <= width || i == 12) {
                        size = i;
                        break;
                    }
                }
                $div.html(text).css("font-size", (size) + "px");
            }
            // 换行
            else if (type == "4") {
                $div.addClass("_beyondWrap_ggt");
                $div.html(text);
            }
        }
    }

    /**
     * 弹出选择
     * @param {Object} $div 要绑定弹出的元素
     * @param {Object} callback 点击单个的回调
     * @param {Object} title 标题
     * @param {Object} tyep 点击事件类型
     */
    function addSelectEject($div, callback, title, tyep) {
        tyep = tyep || "click";
        $.bindEvent($div, function (e) {
            var lis = $div.find("div.select_list ul li");
            if (lis && lis.length != 0) {
                var id = $div.children("p").attr("id");
                var buttons = [];
                if (title) {
                    buttons = [
                        {
                            text: title,
                            bg: 'danger'
                        }
                    ];
                }
                var buttons1 = [];
                for (var i = 0; i < lis.length; i++) {
                    var a = {};
                    var b = lis.eq(i);
                    a.text = b.text();
                    a.id = b.attr("id");
                    if (b.attr("id") == id) {
                        a.color = 'danger';
                    }
                    a.onClick = function () {
                        $div.children("p").attr("id", this.id);
                        if (callback) {
                            callback(this)
                        }
                    };
                    buttons1.push(a);
                }
                var buttons2 = [
                    {
                        text: '取消',
                        bg: 'danger'
                    }
                ];
                var groups = [buttons, buttons1, buttons2];
                $.actions(groups);
                var height = $(".actions-modal-group").eq(1).height();
                if (height > wHeight / 2) {
                    $(".actions-modal-group").eq(1).css({
                        "height": wHeight / 2 + "px",
                        "overflow": "auto"
                    });
                }
            }
            e.stopPropagation(); // 阻止冒泡
        }, tyep);
    }

    /**
     * 检查账号是是否有港股通权限
     * account 检查的普通交易账号
     */
    function checkGgtPermission(account) {
//		var stock_account_type="G|0|"+account;
//		var stock_account=getShareholderAccount(stock_account_type,0,account);
//		var stock_account_type1="S|0|"+account;
//		var stock_account1=getShareholderAccount(stock_account_type1,0,account);
        var getInfoData = [];
        var getInfo = getAccountInfos();
        if (getInfo && Object.keys(getInfo).length > 0) {
            var getInfo1 = getInfo["stock"];
            if (getInfo1 && Object.keys(getInfo1).length > 0) {
                var getInfo2 = getInfo1[account];
                if (getInfo2 && Object.keys(getInfo2).length > 0) {
                    for (var i = 0; i < getInfo2.length; i++) {
                        if (getInfo2[i].exchange_type == "G" || getInfo2[i].exchange_type == "S") {
                            getInfoData.push(getInfo2[i].stock_account);
                        }
                    }
                }
            }
        }
        if (getInfoData && getInfoData.length <= 0) {
            return false;
        }
        return true;
    }

    /**
     * 检查账号是是否有权限
     * account 检查的普通交易账号
     */
    function checkThirdPermission(account) {
        var stock_account_type = "9|0|" + account;
        var stock_account = getShareholderAccount(stock_account_type);
        var stock_account_type1 = "A|0|" + account;
        var stock_account1 = getShareholderAccount(stock_account_type1);
        if (stock_account.length == 0 && stock_account1.length == 0) {
            return false;
        }
        return true;
    }


    //弱密码校验   false  是弱密码    true 不是
    function checkWeakPwd(password) {
        // 判断某一字符出现的次数
        password += "";
        for (var i = 0; i < password.length; i++) {
            var oneChar = password.charAt(i),
                count = 0;
            for (var j = 0; j < password.length; j++) {
                if (oneChar == password.charAt(j)) {
                    count++;
                }
            }
            if (count >= 4) {
                return false;
            }

        }
        // 判断顺序递增或者递减
        var orderArray = ["012345", "123456", "234567", "345678", "456789", "987654", "876543", "765432", "654321", "543210"];
        if (orderArray.indexOf(password) != -1) {
            return false;
        }
        return true;
    }

    //add-jw
    function getType(obj) {
        if (obj === null) return 'null';
        if (obj !== obj) return 'nan';
        if (typeof obj == 'undefined') return 'undefined';
        if (typeof obj != 'object') {
            return typeof obj;
        } else {
            if (obj instanceof Array) return 'array';
            else return 'object'
        }
    }

    /**
     * 成本价双按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} cancelFunction 点击取消执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} cancel 取消按钮语
     */
    function costPriceiConfirm(theme, content, determineFunction, cancelFunction, determine, cancel, prompt) {
        $("#newTradingTipsBox3").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        if (typeof (cancel) == "undefined") {
            cancel = "取消";
        }
        var div = '<div id="newTradingTipsBox3" style="position: fixed"><div class="masklayer"></div><div class="costprice"><div class="topbox">' +
            '<p class="row_01">成本价修改</p><ul class="row_02">' + content + '</ul></div>' +
            '<div class="footbox"><a href="javascript:void(0);" id="cancel">' + cancel + '</a>' +
            '<a href="javascript:void(0);" id="determine">' + determine + '</a></div></div></div>';

        $(pageId).append(div);
        var $content = $(pageId + " #newTradingTipsBox3 .prompt_box2 ._content");
        if ($content.height() < 30) {
            $content.height(30);
        }
        var $prompt = $(pageId + " #newTradingTipsBox3 .prompt_box2");
        var wHeight = Number(wHeight) * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        $prompt.css("margin-top", 0 - topHeight);
        $(pageId + " #newTradingTipsBox3").css("position", "static");


        setTimeout(function () {
            $.bindEvent($(pageId + " #newTradingTipsBox3 #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #newTradingTipsBox3 .masklayer").css("opacity", "0");
                $(pageId + " #newTradingTipsBox3 .costprice").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox3 .masklayer").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox3").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
            $.bindEvent($(pageId + " #newTradingTipsBox3 #cancel"), function (e) {
                setTimeout(function () {
                    $(pageId + " #newTradingTipsBox3 .masklayer").css("opacity", "0");
                    $(pageId + " #newTradingTipsBox3 .costprice").hide();
                }, 100);
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox3 .masklayer").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox3").remove();
                    }
                }, 500);
                if (cancelFunction) {
                    setTimeout(function () {
                        cancelFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
        }, 500);
    }

    /**
     * 事件埋点
     * objectId    object_id
     * eventType   对象类型
     * actionId    action_id
     * attributes  参数
     * isCurrency  是否为通用型action
     */
    function comStat(objectId, eventType, actionId, isCurrency, attributes) {
        if (objectId && actionId) {
            if ($.stat && $.stat.event) {
                var appAction = global.app_action_id1;
                if (!isCurrency) {
                    appAction = global.app_action_id2;
                }
                var objectId = global.app_object_id + "." + objectId;
                var actionId = appAction + "." + actionId;
                var eventType = eventType;
                var attributes = attributes;
                // console.log(objectId + "——" + actionId + "——" + JSON.stringify(attributes));
                $.stat.event(objectId, eventType, actionId, attributes);
            }
        }
    }
    /**
	 * 公用
	 * 新版埋点功能
	 * @param funcNo 10000001 Y
	 */
	function pointCallNative(paramMap) {
		var result = null;
		var param = Object.create(null);
		param["funcNo"] = "10000001";
		param["moduleId"] = paramMap.module_id || paramMap.moduleId || '';  //模块id
		param["pageName"] = paramMap.parent_page_name || paramMap.pageName || '';
		param["eventName"] = paramMap.object_name || paramMap.eventName || '';
		param["pageId"] = paramMap.parent_page_id || paramMap.pageId || '';
		param["eventId"] = paramMap.object_id || paramMap.eventId || '';
		param["actionType"] = paramMap.actionType || 'click';
        param["eventParam"] = paramMap.eventParam || '';  //事件参数
        param["pageDomain"] = paramMap.pageDomain || '';  //域名
        param["pagePath"] = paramMap.pagePath || '';  // 路径
        param["pageQuery"] = paramMap.pageQuery || '';  //页面参数
        param["formData"] = paramMap.formData || '';  //表单内容
        param["stayTime"] = paramMap.stayTime || '';  //页面停留时长
        param["osType"] = paramMap.osType || '';
		result = $.callMessage(param);
		return result;
	};

    /**
     * 页面埋点init
     * objectId    object_id
     */
    function pageBuryingPoint(objectId) {
        if ($.stat && $.stat.visitPage) {
            if (objectId) {
                var objectId = global.app_object_id + "." + objectId;
                $.stat.visitPage(objectId);//开始访问
                // console.log("开始"+objectId);
            } else {
                $.stat.visitPage();//结束访问
                // console.log("结束");
            }
        }
    }

    /**
     * 判断单位
     * val 值
     * */
    function judgeValue(val) {
        var value = val;
        if (val) {
            if (val.indexOf("-") != -1) {
                value = -val;
            }
            if (value && Number(value).toFixed(0).length > 12) {
                return (Number(val) * 0.000000000001).toFixed(0) + "万亿";
            } else if (value && Number(value).toFixed(0).length > 8) {
                return (Number(val) * 0.00000001).toFixed(0) + "亿";
            } else {
                return val;
            }

        }
    }

    // /**
    //  * 设置暂无数据
    //  * @param {Button} is true 显示 false 隐藏
    //  * @param {Object} text 提示文本
    //  * @param {Object} id 提示的id的位置
    //  * @param {Object} divText 提示内容是html替换默认的
    //  * @param {Object} each 是否每次都设置值 is-each
    //  */
    // function setNoData(is, text, id, divText, each){
    // 	var _pageId = "#"+$.getCurrentPageObj().pageId;
    // 	var $div = $(_pageId + " .no_data");
    // 	if(id && id.length > 0){
    // 		$div = id;
    // 	}
    // 	if(is){
    // 		if($div.attr("is-each") && !each){
    // 			$div.show();
    // 		}
    // 		else{
    // 			var html = divText || '<span class="icon"></span><p>'+(text || '暂无记录')+'</p>';
    // 			$div.html(html).show().attr("is-each","true");
    // 		}
    // 	}
    // 	else{
    // 		$div.hide();
    // 	}
    // 	return $div;
    // }

    /**
     * 设置暂无数据
     * @param {Button} is true 显示 false 隐藏
     * @param {Object} text 提示文本
     * @param {Object} id 提示的id的位置
     * @param {Object} divText 提示内容是html替换默认的
     * @param {Object} callback 回调
     */
    function setNoData(is, text, id, divText, callback) {
        var _pageId = "#" + $.getCurrentPageObj().pageId;
        var $div = $(_pageId + " .no_data");
        if (id && id.length > 0) {
            $div = id;
        }
        if (is) {
            var html = divText || '<span class="icon"></span><p>' + (text || '暂无记录') + '</p>';
            $div.html(html).show().attr("is-each", "true");
        } else {
            $div.hide();
        }
        if (callback) {
            callback();
        }
        return $div;
    }

    /**
     * 设置查询失败处理
     * @param {Button} is true 显示 false 隐藏
     * @param {Object} text 提示文本
     * @param {Object} id 提示的id的位置
     * @param {Object} divText 提示内容是html替换默认的
     * @param {Object} callback 回调
     */
    function setQueryFail(is, text, id, divText, callback) {
        var _pageId = "#" + $.getCurrentPageObj().pageId;
        var $div = $(_pageId + " .no_data");
        if (id && id.length > 0) {
            $div = id;
        }
        if (is) {
            var html = divText || '<span class="icon"></span><p>' + (text || '没有成功获取数据') + '</p>';
            $div.html(html).show().attr("is-each", "true");
        } else {
            $div.hide();
        }
        if (callback) {
            callback();
        }
        return $div;
    }

    /*
	 * 改变字体大小
	 */
    function changeFontSize($div, deaultSize) {
        var deaultSize = deaultSize || "0.16rem";
        $div.css("font-size", "0.2rem");
        $div.animate({
            "font-size": deaultSize
        }, "fast");
//		$div.removeClass("changeFont");
//		$div.addClass("changeFont");
    }

    /**
     * 设置显示*****
     * @param {Object} text 要处理的字符串
     * @param {Object} gs 显示*的个数
     * @param {Object} ks 从头部向后位数 显示的字符串
     * @param {Object} js 从尾部向前位数 显示的字符串
     */
    function setAsteriskHide(text, gs, ks, js) {
        text = text + "";
        var rt = "";
        var l = text.length;
        if (l > 0 && gs && gs > 0) {
            var xgs = "";
            for (var i = 0; i < gs; i++) {
                xgs += "*";
            }
            if (ks) {
                if (ks + js >= l) {
                    ks = 0;
                }
                if (ks > 0) {
                    rt = text.substring(0, ks);
                    rt += xgs;
                    if (js && js > 0) {
                        rt += text.substr(0 - js);
                    }
                } else if (ks < 0) {
                    rt += xgs;
                    rt += text.substr(ks);
                } else {
                    rt += xgs;
                    if (js && js > 0) {
                        rt += text.substr(0 - js);
                    }
                }
            } else {
                rt = xgs;
            }
        } else {
            rt = text;
        }
        return rt;
    }

    function returnNative() {
        if (global.callNative && global.isFromApp) {
            var param = {};
            param["moduleName"] = global.nativeModuleName;
            param["funcNo"] = "50114";
            $.callMessage(param);
        }
    }

    /**
     * 判断json对象是否有数据
     * @param {Object} e json对象
     */
    function isEmptyObject(e) {
        var t;
        for (t in e)
            return !0;
        return !1;
    }

    //更改首页提示
    function changeTips() {
        //判断首页提示语
        $("#account_index_new .trade_second_page.credit .no-login ").show();
        $("#account_index_new .trade_second_page.option .no-login ").show();
        $("#account_index_new .logined").hide();
        if (global.callNative && global.isSso) {
            setTimeout(function(){
                var activeLogin = $.callMessage({
                    "moduleName": "trade",
                    "funcNo": "99919",
                    "sourceModule": "trade"
                }).results[0].activePhone;
                if (activeLogin && activeLogin != "" && activeLogin != undefined && activeLogin != null) {
                    $("#account_index_new .stock .no-login p").html("您尚未登录普通账号");
                    $("#account_index_new .stock .no-login button").html("立即登录");

                    $("#account_index_new .credit .no-login p").html("您尚未登录信用账号");
                    $("#account_index_new .credit .no-login button").html("立即登录");

                    $("#account_index_new .option .no-login p").html("您尚未登录期权账号");
                    $("#account_index_new .option .no-login button").html("立即登录");
                } else {
                    $("#account_index_new .no-login p").html("您尚未登录手机号码");
                    $("#account_index_new .no-login button").html("立即登录");
                }
            },0);
        } else {
            $("#account_index_new .stock .no-login p").html("您尚未登录普通账号");
            $("#account_index_new .stock .no-login button").html("立即登录");


            $("#account_index_new .credit .no-login p").html("您尚未登录信用账号");
            $("#account_index_new .credit .no-login button").html("立即登录");

            $("#account_index_new .option .no-login p").html("您尚未登录期权账号");
            $("#account_index_new .option .no-login button").html("立即登录");
        }
        // 客户端切换tab，交易首页回调函数
        window.tradePageCallBack && window.tradePageCallBack();
    }

    //安卓需要判断app是否在前台
    function isAppFlag() {
        if (global.callNative && global.isSso && $.device.android) {
            var dataInfo = $.callMessage({"funcNo": "50124"});
            if (dataInfo.error_no == "0") {
                if (dataInfo.results[0].appToBackFlag == "1") {
                    return false;//标识已经在后台
                } else {
                    return true;//标识已经运行在前台
                }
            }
        } else {
            return true;//不是在app里面,就一直刷新
        }
    }
    // 判断当前 tabbar 是否在交易模块
    function isTradeTabbar() {
        if (global.callNative) {
            var dataInfo = $.callMessage({
                "funcNo": "50601",
                "msgNo": "305",
                "sourceModule": "trade",
                "targetModule": "appDispatcher",
                "action": "4",
                "param": {}
            });
            if (dataInfo.error_no == "0") {
                if (dataInfo.results && dataInfo.results.length > 0 && dataInfo.results[0].tabIndex == "2") {
                    return true;
                } else {
                    return false;
                }
            }else{ // 兼容老app处理
                return true;
            }
        } else {
            return false;
        }
    }


    /*
	 * 位数转换
	 */
    function dgitConversion(num) {
        if (num >= 10000) {
            return (num * 0.0001).toFixed(2) + "万";
        } else {
            return num;
        }
    }

    /*
     * 倒计时天数
     */
    function timeDifference(faultDate) {
        var stime = Date.parse(new Date(faultDate));
        var etime = Date.parse(new Date());
        var usedTime = etime - stime;  //两个时间戳相差的毫秒数
        var days = Math.floor(usedTime / (24 * 3600 * 1000));
        return Math.abs(days);
    }

    /*
     * 页面改变高度
     */
    function pageChangeHeight(_callback) {
        var preHeight = $("html").height() || $(window).height() || gconfig.appHeight;
        window.onresize = function () {//防止从首页跳转到具体页面的时候，隐藏底部的高度发生改变的时候会刷新一下该页面
            gconfig.appHeight = $("html").height() || $(window).height() || gconfig.appHeight;
            var _height = Math.abs(Number(gconfig.appHeight) - Number(preHeight));
            if (_height > 30) {
//				$.pageRefresh();
                setTimeout(function () {
                    var curPageObj = $.getCurrentPageObj();
                    if (curPageObj && curPageObj.scriptUrl) {
                        seajs.use(curPageObj.scriptUrl, function (module) {
                            if (_callback) {
                                _callback();
                            }
                            module && module.init && module.init();
                            module && module.bindEvent && module.bindEvent();
                            module && module.load && module.load();
                        })
                    }
                }, 300);
            }
        };
    }

    /**
     * 得到指定宽度最大fontsize值
     * @param {Object} width 屏幕中宽度
     */
    function getMaxFontSize($div) {
        var size = 1;
        if ($div) {
            var _width = $div.width();
            var _textWidth = $div[0].scrollWidth;
            if (_textWidth > _width) size = _width / (_textWidth + 20);
        }
        return size;
    }

    /**
     * 添加页面选项卡
     * @param {Object} div 点击的id
     * @param {Object} title 标题
     * @param {Object} liHtml 要显示的内容
     * @param {Object} determine 选中的回调方法
     * @param {Object} type 选择框的类型，true 是多选，默认单选
     * @param {Object} id 弹出框的id唯一标示
     * @param {Object} keyboard 键盘
     */
    function addPageTabList(div, title, liHtml, determine, type, id, keyboard) {
        var downslide = new (require("downslide")).Downslide();
        var _pageId = '#' + $.getCurrentPageObj().pageId + " ";
        var pageId = _pageId;
        var divID = "";
        if (id) {
            divID = ' id="choice_' + id + '"';
            pageId = pageId + "#choice_" + id;
        }
        var html = [];
        var click_btn = "";
        if (type) {//多选
            $(pageId + ".multiple").remove();
            click_btn = " .multiple ";
            html.push('<div' + divID + ' class="listSelect multiple" style="display:none">');
        } else {
            $(pageId + ".radio").remove();
            click_btn = " .radio ";
            html.push('<div' + divID + ' class="listSelect radio" style="display:none">');
        }
        html.push('<div class="ui dialog-overlay" style="display: block;"></div>');
        html.push('<div class="allacout">');
        html.push('<div class="poustop">');
        html.push('<a id="cancel" class="left" href="javascript:void(0);">取消</a>');
        html.push(title);
        if (type) {
            html.push('<a id="save" class="right" href="javascript:void(0);">保存</a>');
        }
        html.push('</div>');
        html.push('<div class="row_01 listData">' + downslide.rollDiv.replaceAll("</div>", ""));
        if (liHtml.indexOf("pull_down_roll") == -1) {
            liHtml = "<div id='pull_down_roll'>" + liHtml;
            liHtml = liHtml + "</div>";
        }
        html.push(liHtml);
        html.push('</div>');
        html.push('</div>');
        html.push('</div>');
        $(_pageId).append(html.join(""));
        //显示
        $.bindEvent($(div), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            div = $(this);
            $(pageId + click_btn).show();
            //弹框的最大高度是屏幕的二分之一，超过就添加滑动组件
            var h = $(pageId).height() / 2;
            if ($(pageId + " .listData").height() > h) {
                downslide.rollInit(h, pageId + ".listData ");
                $(pageId + " .listData #wrapper").css("position", "relative");
                $(pageId + " .listData #pull_down_roll").css("position", "relative");
            } else {
                downslide = null;//如果高度没有超过，就不添加滑动组件
            }
            if (!global.startJSkeyboard) {
                e.stopPropagation(); // 阻止冒泡
            }
        }, downslide ? downslide.clickType() : undefined);
        // 点击阴影部分
        $.bindEvent($(pageId + click_btn + " .dialog-overlay"), function (e) {
            $(pageId + click_btn).hide();
            e.preventDefault();
            e.stopPropagation(); // 阻止冒泡
        });
        // 取消
        $.bindEvent($(pageId + click_btn + " #cancel"), function (e) {
            $(pageId + click_btn).hide();
            e.preventDefault();
            e.stopPropagation(); // 阻止冒泡
        }, downslide ? downslide.clickType() : undefined);

        // 单选
        $.bindEvent($(pageId + ".radio .listData li"), function (e) {
            $(this).addClass("check").siblings().removeClass("check");
            if (determine) {
                determine($(this), div);
            }
            $(pageId + click_btn).hide();
            e.preventDefault();
            e.stopPropagation(); // 阻止冒泡
        }, downslide ? downslide.clickType() : undefined);

        // 多选
        $.bindEvent($(pageId + ".multiple .listData li"), function (e) {
            $(this).addClass("check").siblings().removeClass("check");
            e.preventDefault();
            e.stopPropagation(); // 阻止冒泡
        }, downslide ? downslide.clickType() : undefined);

        // 保存(多选)
        $.bindEvent($(pageId + ".multiple #save"), function (e) {
            if (determine) {
                determine($(pageId + ".listData li.check"), div);
            }
            $(pageId + click_btn).hide();
            e.preventDefault();
            e.stopPropagation(); // 阻止冒泡
        }, downslide ? downslide.clickType() : undefined);
    }


    /**
     * 跳转行情新股的方法
     * @param {Object} t
     */
    function jumpHpNewshare(type, param) {
        var pc = "";
        switch (type) {
            case "1"://新股日历、股转发行
                pc = "pages/newStockCalendar/index";
                break;
            case "2"://新股详情
                pc = "pages/newStockCalendar/calendarInfo";
                break;
            case "3"://发行详情
                pc = "pages/newStockCalendar/sampanInfo";
                break;
        }
        //主题色themeType:black_theme(黑)、blue_theme(蓝)、red_theme(红)
        var _channel = 0;//网页
        if ($.device.android) {
            _channel = 1;//思迪安卓
        } else if ($.device.iPad || $.device.iPhone || $.device.ios) {
            _channel = 2;//思迪IOS
        }
        var ps = "?moduleName=webCommon&themeType=red_theme&clientid=" + (global.activePhone || "") + "&channel=" + _channel;
        if ($.isValue(param)) {
            ps += "&" + $.setUrlParam(param);
        }
        if (global.callNative && global.isSso) {
            $.callMessage({
                "funcNo": "50115",
                "moduleName": "webCommon",
                "url": (global.jumpHqUrl || gconfig.seaBaseUrl) + pc + ps,
                "statusColor": "#EE4034",//状态栏颜色
                "isShowLoading": "1",
                "isSupportReInitH5": "1",
                "isUseCache": "0"
            });
        } else {
            window.location.href = (global.jumpHqUrl || gconfig.seaBaseUrl) + pc + ps;
        }
    }

    /**
     * 待确认弹框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} determine 正确按钮语
     */
    function waitForConfirm(theme, content, tips, determineFunction, cancelFunction, determine, cancel, clickMask) {
        $("#waitForConfirm").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (typeof (theme) == "undefined") theme = "";
        if (typeof (content) == "undefined") content = "";
        if (typeof (determine) == "undefined") determine = "";
        if (typeof (cancel) == "undefined") cancel = "";
        var div = '';
        div += '<div id="waitForConfirm">';
        div += '<div class="ui dialog-overlay" style="display: block;"></div>';
        div += '<div class="missconfirm" style="overflow: auto;">';
        div += '<div class="row_05">';
        div += '<p class="a01">' + theme + '</p>';
        div += content;
        div += '<p class="a04">';
        div += tips;
        div += '</p>';
        div += '</div>';
        div += '<div class="row_02 clearfix">';
        if (determine && cancel) {
            div += '<a href="javascript:void(0);" id="cancel">' + cancel + '</a><a href="javascript:void(0);" id="determine">' + determine + '</a>';
        } else {
            div += '<a href="javascript:void(0);" id="determine" style="width:100%;color:#E15953">' + determine + '</a>';
        }
        div += '</div>';
        div += '</div>';
        div += '</div>';
        $(pageId).append(div);
        setTimeout(function () {
            $.bindEvent($(pageId + " #waitForConfirm .dialog-overlay"), function (e) {
                if (clickMask) {
                    $(pageId + " #bulletBoxPrompt #determine").trigger("touchstart");
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            });

            //确定
            $.bindEvent($(pageId + " #waitForConfirm #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                if (determineFunction) {
                    determineFunction();
                }
                setTimeout(function () {
                    $(" #waitForConfirm").remove();
                }, 300);
                var evt = e || window.event;
                evt.preventDefault();
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");

            //关闭
            $.bindEvent($(pageId + " #waitForConfirm #cancel"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                if (cancelFunction) {
                    cancelFunction();
                }
                setTimeout(function () {
                    $(" #waitForConfirm").remove();
                }, 300);
                var evt = e || window.event;
                evt.preventDefault();
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");

            //下次不再提醒
            $.bindEvent($(pageId + " #waitForConfirm .missconfirm .a04"), function (e) {
                $(this).find("span").toggleClass("active");
                e.stopPropagation();
            });
        }, 500);
    }

    /**
     * 公开发行价格数量输入弹窗
     * @param {Object} pageId    页面id
     * @param {Object} results    数据集
     * @param {Object} businessName    业务名
     * @param {Object} callback    回调函数
     */
    function inputConfirm(pageId, results, businessName, callback, keyboard) {
        $("#publicOfferingInputConfirm").remove();
        var html = "<div id='publicOfferingInputConfirm' class='inquiry_Popup myConfirm' style='position: static;'>";
        html += "<div class='prompt_frame'>";
        html += "<h3>" + businessName + "</h3>";
        html += "<div class='_content collateralCss'>";
        html += "<div class='inquiry_form' style='max-height: 4rem; overflow: auto;'>";
        for (var i = 0; i < results.length; i++) {
            var element = results[i];
            html += "<div class='input_bar' idx='" + i + "'>";
            html += "<div class='tit'>" + element.issue_name + ": " + element.issue_code + "</div>";
            html += "<div class='input_box'>";
            var inputName = businessName != "询价" ? "申购" : "询价";
            var value = "";
            var css = "";
            if (Number(element.up_price) == Number(element.down_price)) {
                value = element.up_price;
                //			if(inputName!="询价"){
                css = "not";
                //			}
            }
            html += "<label>" + inputName + "价格</label><input value='" + value + "' js-key='number' id='recentPrice" + i + "' type='text' class='t1 recentPrice " + css + "' maxlength='12' placeholder='价格" + element.down_price + "~" + element.up_price + "'>";
            html += "</div>";
            html += "<div class='input_box mt10'>";
            html += "<label>" + inputName + "数量</label><input js-key='number' id='recentAmount" + i + "' type='text' class='t1' maxlength='12' placeholder='数量" + dgitConversion(Number(element.low_amount)) + "~" + dgitConversion(Number(element.high_amount)) + "'>";
            html += "</div>";
            html += "</div>";
        }
        html += "</div>";
        html += "</div>";
        html += "<div class='promptTips' style='padding-left: 0.25rem;'>";
        html += "<span style='display:none'>提示：修改价格后可能导致" + inputName + "失败。</span>";
        html += "</div>";

        html += "<div class='btn'>";
        html += "<div><a id='clickCancel' href='javascript:void(0)' id='cancel'>取消</a><a id='clickOk' class='needsclick' href='javascript:void(0)' id='determine'>确定</a></div>";
        // html +="<div><a id='clickOk' class='needsclick' href='javascript:void(0)' id='determine'>确定</a></div>";
        html += "</div>";
        html += "</div>";
        // html +="<div class='shade'></div>";
        html += "<div class='backdrop' style='display:block;'></div></div>";

        if ("#" + $.getCurrentPageObj().pageId == pageId.replaceAll(" ", "")) {
            $(pageId).append(html);
            var frameDom = $(pageId + "#publicOfferingInputConfirm .prompt_frame")
            frameDom.css("margin-top", -frameDom.height() / 2 + "px");
            if (keyboard) {
                keyboard.keyInit();
            }

            //数量框输入
            $.bindEvent($(pageId + ".recentAmount"), function (e) {
                if (keyboard) {
                    keyboard.popUpKeyboard($(this), e);
                }
                var inputVal = $(this).val();
                if (inputVal.indexOf(".") != -1) {
                    inputVal = inputVal.replaceAll(".", "");
                }
                $(this).val(inputVal);
                e.stopPropagation();
            }, "input");

            //数量框
            $.bindEvent($(pageId + ".recentAmount"), function (e) {
                var idx = $(this).parents('.input_bar').attr('idx');
                var element = results[idx];
                if (!element) return;
                var objectId = (businessName == "申购" ? 101907 : 101902);
                //埋点
                comStat(objectId, 2, 2, false, {
                    "i_entrust_bs": "1", // 交易方向( 1,买入 2,卖出)
                    "i_entrust_prop": "", // 委托属性
                    "i_exchange_type": element.exchange_type, // 交易市场
                    "i_stock_code": element.issue_name, // 股票代码
                    "i_stock_name": element.issue_code, // 股票名称
                    "i_price": $(pageId + "#recentPrice").val(), // 选择后的价格
                    "i_adjust_type": "5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
                    "i_max_cnt": element.up_price, // 最大数量
                    "i_target_cnt": $(this).val(), // 调整之后的数量
                    "i_fast_btn": "", // 快捷键（全仓，1/2，1/4 ....（可留空））
                });
                e.stopPropagation();
            }, "blur");

            //价格框
            $.bindEvent($(pageId + " .recentPrice"), function (e) {
                var idx = $(this).parents('.input_bar').attr('idx');
                var element = results[idx];
                if (!element) return;
                var objectId = (businessName == "申购" ? 101906 : 101901);
                comStat(objectId, 2, 1, false, {
                    "i_entrust_bs": "1", // 交易方向( 1,买入 2,卖出)
                    "i_entrust_prop": "", // 委托属性
                    "i_exchange_type": element.exchange_type, // 交易市场
                    "i_stock_code": element.issue_code, // 股票代码
                    "i_stock_name": element.issue_name, // 股票名称
                    "i_price": $(this).val(), // 选择后的价格
                    "i_adjust_type": "5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
                });
                e.stopPropagation();
            }, "blur");


            if (global.callNative) {
                $.bindEvent($(pageId + " .recentPrice"), function (e) {
                    var keyField = {
                        CLEAR: -2,
                        DONE: -3,
                        HIDE: -4,
                        DEL: -5
                    }
                    var $input = $(this);
                    var $div = $(this).parent().find(".key_text");
                    var keyCode = $(this).attr("keyDiv");
                    var keyText = $div.text();

                    if (($input.attr("value") || $input.val()).length == 0) {
                        $input.parent().find("div.key_place").show();
                    } else {
                        $input.parent().find("div.key_place").hide();
                    }

                    var maxlength = $input.attr("maxlength");
                    if (maxlength < keyText.length || keyField.HIDE == keyCode) return;
                    var keyText = $div.quzhi();
                    if (keyCode == keyField.CLEAR) {
                        $input.quzhi("");
                        $div.quzhi("");
                    } else if (keyCode == keyField.DEL) {
                        $input.quzhi($input.quzhi());
                        $div.quzhi($input.quzhi());
                    } else {
                        $input.quzhi(keyText + keyCode);
                        $div.quzhi(keyText + keyCode);
                    }
                    e.stopPropagation();
                }, "input");
            }
        }

        $.bindEvent($(pageId + "#publicOfferingInputConfirm #clickOk"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var isNull = false;
            for (var i = 0; i < results.length; i++) {
                var recentPrice = $(this).parents().find("#recentPrice" + i).val() || $(this).parents().find("#recentPrice" + i).quzhi();
                var recentAmount = $(this).parents().find("#recentAmount" + i).quzhi();
                if (recentPrice == "" || Number(recentPrice) == 0) {
                    $.alert("请输入价格");
                    isNull = true;
                    break;
                }
                if (recentAmount == "" || Number(recentAmount) == 0) {
                    $.alert("请输入数量");
                    isNull = true;
                    break;
                }
                results[i].entrust_price = recentPrice;
                results[i].entrust_amount = recentAmount;
            }

            if (isNull) return;
            $(this).unbind();
            setTimeout(function(){
                $("#publicOfferingInputConfirm").remove();
            }, 300);
            if (callback) {
                callback(results);
            }
            e.stopPropagation();
        });

        $.bindEvent($(pageId + "#publicOfferingInputConfirm #clickCancel"), function (e) {
            $(this).unbind();
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            setTimeout(function(){
                $("#publicOfferingInputConfirm").remove();
            }, 300);
            e.stopPropagation();
        });

        $.bindEvent($(pageId + "#publicOfferingInputConfirm .recentPrice.jsKey"), function (e) {// 重写价格框点击事件，给出修改价格提示语
            if (keyboard) {
                keyboard.clickOpenKeyboard($(this), pageId);
                if ($(this).hasClass("not")) {
                    $(pageId + " #publicOfferingInputConfirm .promptTips span").show();
                }
            }
            e.stopPropagation();
        });
    }

    /**
     * 计算当前div的高度，从而得到页面要上提多少
     * @param {Object} n 当前要计算的div，$() 对象
     * @param {Object} h 高度
     */
    function liftingHeight(n, h) {
        var a = n.parents('[key-panel-main="true"]');
        a.css("margin-top", "0px");
        $("#rewriteWaitingLayer").show();
        if (a && a.length > 0) {
            var b = n.offset().top;
            var c = n.height();
            var d = gconfig.appHeight - h;
            var e = b + c - d;
            var f = a.css("margin-top").slice(0, -2);
            if (e > 0) {
                a.css("margin-top", +f - e + "px");
                if (f - e < 0) {
                    $("#rewriteWaitingLayer").hide();
                }
            }
        }
    }

    /**
     * 初始化日期选择组件
     * @param {Object} pageId
     * @param {Object} timeLimit 默认查询天数
     * @param {Boolean} notContainToday 不包含今天
     */
    function initTimeChoice(pageId, timeLimit, notContainToday, startDate, endDate) {
        if (!timeLimit) {
            timeLimit = 0;
        }
        var begin_time = "";	//截止时间
        var end_time = "";
        if (notContainToday) {
            begin_time = $.getTradingDay(0 - timeLimit, "yyyy-MM-dd");
            end_time = $.getTradingDay(-1, "yyyy-MM-dd");
        } else {
            var begin_time = $.getTradingDay(1 - timeLimit, "yyyy-MM-dd");	//截止时间
            var end_time = new Date().format("yyyy-MM-dd");
        }
        /****************输入框形式的时间选择(历史查询页面那种不用传)可参考 开放式基金 - 基金定投 - 下单页面******************/
        if (startDate) {
            begin_time = startDate;
            if ($(pageId + " #startInput").data("picker")) {
                var d = begin_time.split("-");
                $(pageId + " #startInput").data("picker").value = d;
                $(pageId + " #startInput").data("picker").params.value = d;
            }
        }
        if (endDate) {
            end_time = endDate;
            if ($(pageId + " #endInput").data("picker")) {//已经初始化过
                var d = end_time.split("-");
                $(pageId + " #endInput").data("picker").value = d;
                $(pageId + " #endInput").data("picker").params.value = d;
            }
        }
        /****************************************** modify in 20180626 *************************************/
        $(pageId + " #startDate").html(begin_time);
        $(pageId + " #endDate").html(end_time);
        $(pageId + " #startInput").val(begin_time);
        $(pageId + " #endInput").val(end_time);
        //初始化时间控件
        $(pageId + " #startInput").datetimePicker({
            "toolbarTemplate": '<header class="bar bar-nav"><button class="button button-link pull-right close-picker">确定</button><div class="titlehsea">选择日期开始日期</div></header>',
            "onOpen": function () {
                $(pageId).css("margin-top", "0px");
                $("#rewriteWaitingLayer").show();
                liftingHeight($(pageId + " #startInput"), 280);
            },
            "onClose": function () {
                $(pageId).css("margin-top", "0px");
                $("#rewriteWaitingLayer").show();
                //埋点
                var objectId = $(pageId + " .repurtime ").attr("startObjectId");
                var actionId = $(pageId + " .repurtime ").attr("actionId");
                var thisVal = $(pageId + " #startDate").html();
                if (objectId && actionId) {
                    thisVal = thisVal.toString();
                    comStat(objectId, 2, actionId, true, {
                        "i_change_name": "开始日期选择",
                        "i_change_to": thisVal ? (thisVal.replaceAll("-", "")) : thisVal
                    });
                }
            },
            "cssClass": "date_Picker"
        });
        $(pageId + " #endInput").datetimePicker({
            toolbarTemplate: '<header class="bar bar-nav"><button class="button button-link pull-right close-picker">确定</button><div class="titlehsea">选择日期截止日期</div></header>',
            "onOpen": function () {
                $(pageId).css("margin-top", "0px");
                $("#rewriteWaitingLayer").show();
                liftingHeight($(pageId + " #endInput"), 280);
            },
            "onClose": function () {
                $(pageId).css("margin-top", "0px");
                $("#rewriteWaitingLayer").show();
                //埋点
                var objectId = $(pageId + " .repurtime ").attr("endObjectId");
                var actionId = $(pageId + " .repurtime ").attr("actionId");
                var thisVal = $(pageId + " #endDate").html();
                if (objectId && actionId) {
                    thisVal = thisVal.toString();
                    comStat(objectId, 2, actionId, true, {
                        "i_change_name": "结束日期选择",
                        "i_change_to": thisVal ? (thisVal.replaceAll("-", "")) : thisVal
                    });
                }
            },
            "cssClass": "date_Picker"
        });


        //设置开始日期
        $.bindEvent($(pageId + " #setStart"), function (e) {
            var d = $(pageId + " #startInput").val().split("-");
            $(pageId + " #startInput").data("picker").value = d;
            $(pageId + " #startInput").data("picker").params.value = d;
            $(pageId + " #startInput").picker("open");
//			$(pageId + " #startInput").focus();
            e.stopPropagation();
        });

        //设置截止日期
        $.bindEvent($(pageId + " #setEnd"), function (e) {
            var d = $(pageId + " #endInput").val().split("-");
            $(pageId + " #endInput").data("picker").value = d;
            $(pageId + " #endInput").data("picker").params.value = d;
            $(pageId + " #endInput").picker("open");
            e.stopPropagation();
        });


        $.bindEvent($(pageId + " #startInput"), function (e) {
            var reg = /^\d{4}-\d{2}-\d{2}$/,
                thisVal = $(this).val().replaceAll("/", "-");
            if (reg.test(thisVal)) {
                $(pageId + " #startDate").html(thisVal);
            }
            e.stopPropagation();
        }, "change");

        $.bindEvent($(pageId + " #endInput"), function (e) {
            var reg = /^\d{4}-\d{2}-\d{2}$/,
                thisVal = $(this).val().replaceAll("/", "-");
            if (reg.test(thisVal)) {
                $(pageId + " #endDate").html(thisVal);
            }
            e.stopPropagation();
        }, "change");
    }

    /**
     * 双按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} cancelFunction 点击取消执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} cancel 取消按钮语
     */
    function thirdIConfirm(theme, content, determineFunction, cancelFunction, determine, cancel, prompt, clickType) {
        $("#newTradingTipsBox2").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        if (typeof (cancel) == "undefined") {
            cancel = "取消";
        }
        var div = '<div id="newTradingTipsBox2" class="thirdIConfirmBox myConfirm" style="position: fixed"><div key-panel-main="true" class="prompt_box2" style="width: 80%;left: 10%;">' + theme + '<div class="_content"style="margin: 0px;padding:10px 20px;">' + content +
            '</div><div class="btn2 mt10"><a id="cancel" href="javascript:void(0)">' + cancel + '</a><a id="determine" class="needsclick" href="javascript:void(0)">' + determine + '</a>';
        div += '</div></div><div class="shade"></div></div>';
        $(pageId).append(div);
        var $content = $(pageId + " #newTradingTipsBox2 .prompt_box2 ._content");
        if ($content.height() < 30) {
            $content.height(30);
        }
        var $prompt = $(pageId + " #newTradingTipsBox2 .prompt_box2");
        var wHeight = Number(gconfig.appHeight) * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        $prompt.css("margin-top", 0 - topHeight);
        $(pageId + " #newTradingTipsBox2").css("position", "static");
        setTimeout(function () {
            $.bindEvent($(pageId + " #newTradingTipsBox2 .prompt_box2 .prompt_shade"), function (e) {
                if (prompt && typeof prompt == "function") {
                    if (prompt($content)) {
                        $(pageId + " #newTradingTipsBox2 #determine").trigger(clickType ? clickType : "touchstart");
                    }
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            });
            $.bindEvent($(pageId + " #newTradingTipsBox2 #determine"), function (e) {
//	    		$(this).unbind();
                this.touchstart = null;
                $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, clickType ? clickType : "touchstart");
            $.bindEvent($(pageId + " #newTradingTipsBox2 #cancel"), function (e) {
                setTimeout(function () {
                    $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                    $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                }, 100);
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (cancelFunction) {
                    setTimeout(function () {
                        cancelFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, clickType ? clickType : "touchstart");
        }, 500);
    }


    function entrustResultsConfirm(results, yesFunc) {// 委托结果弹窗
        var viewContent = "<div id='entrustResults_confirm' class='myConfirm'>";
        viewContent += "<div class='overlay-layer'></div>";
        viewContent += "<div class='overlay-cont01'>";
        viewContent += "<h2>委托结果</h2>";
        viewContent += "	<ul class='overlay-reason' style='max-height: 3rem; overflow: auto;'>";
        for (var i = 0; i < results.length; i++) {
            viewContent += ("<li><p class='p1'>" + results[i].stock_name + " " + results[i].stock_code + " " + (results[i].entrust_amount || '') + "股" +
                "<span class='" + (results[i].error_no == 0 ? "blue" : "red") + "'>" + (results[i].error_no == 0 ? "委托成功" : "委托失败") + "</span></p>" +
                (results[i].error_no == 0 ? "" : "<p class='p2'>失败原因：" + results[i].error_info + "</p>") +
                "</li>");
        }
        viewContent += "	</ul>";
        viewContent += " <div class='overlay-btn'><a href='javascript:void(0);' class='row-1 act'>确定</a></div>";
        $("body").append(viewContent);
        var frameDom = $("#entrustResults_confirm .overlay-cont01")
        frameDom.css("margin-top", -frameDom.height() / 2 + "px");

        $.bindEvent($("body #entrustResults_confirm .overlay-btn a"), function (e) {
            $(this).unbind();
            $("#entrustResults_confirm").remove();
            if (yesFunc) {
                yesFunc();
            }
            e.stopPropagation();
        });
    }

    /**
     * 双按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} cancelFunction 点击取消执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} cancel 取消按钮语
     */
    function iConfirmNew(theme, content, determineFunction, cancelFunction, determine, cancel, prompt, clickType, btnClass) {
        $("#iConfirmNew").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        if (typeof (cancel) == "undefined") {
            cancel = "取消";
        }
        var div = '<div id="iConfirmNew">';
        div += '<div class="ui dialog-overlay" style="display: block;"></div>';
        div += '<div class="prompt_dialog_pop">';
        div += '<div class="pop_tit">' + theme + '</div>';
        div += '<div class="pop_cet" style="min-height: 50px;">' + content + '</div>';
        div += '<div class="pop_btn"><a class="btn_text cancel" href="javascript:void(0)" id="cancel">' + cancel + '</a><a class="btn_text" href="javascript:void(0)" id="determine">' + determine + '</a></div>';
        if (prompt) {
            div += '<div class="prompt_shade"></div>';
        }
        div += '</div>';
        $(pageId).append(div);
        var $content = $(pageId + " #iConfirmNew .pop_cet");
        var $prompt = $(pageId + " #iConfirmNew .prompt_dialog_pop");
        var wHeight = $(window).height() * 0.4;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight) {
            topHeight = wHeight;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        setTimeout(function () {
            $.bindEvent($(pageId + " #iConfirmNew .prompt_shade"), function (e) {
                if (prompt && typeof prompt == "function") {
                    if (prompt($content)) {
                        $(pageId + " #iConfirmNew #determine").trigger("touchstart");
                    }
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            });
            $.bindEvent($(pageId + " #iConfirmNew #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #iConfirmNew .dialog-overlay").css("opacity", "0");
                $(pageId + " #iConfirmNew .prompt_dialog_pop").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #iConfirmNew .dialog-overlay").css("opacity");
                    if (opacity == 0) {
                        $("#iConfirmNew").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
            $.bindEvent($(pageId + " #iConfirmNew #cancel"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #iConfirmNew .dialog-overlay").css("opacity", "0");
                $(pageId + " #iConfirmNew .prompt_dialog_pop").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #iConfirmNew .dialog-overlay").css("opacity");
                    if (opacity == 0) {
                        $("#iConfirmNew").remove();
                    }
                }, 500);
                if (cancelFunction) {
                    setTimeout(function () {
                        cancelFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
        }, 500);
    }

    /*********
     * 字符串显示
     * @param str 传入的字符串
     * @param defaultStr 默认显示字符串
     * @param flag 0、普通字符串 1、需要加... 2、保留小数位的字符串 3、价格等需要加，显示的
     * @maxLength 最大长度 flag==0，1的时候表示字符串最大长度 flag==2，3的时候表示小数点的位数
     */
    function getShowStr(str,defaultStr,flag,maxLength) {
        var showStr=str;
        if(str==""||str==undefined||str=="undefined"||str==" "||str.length==0){
            showStr =defaultStr;
        }else{
            if((flag==0||flag==1)&&maxLength!=0){
                var strLength=str.length;
                if(strLength>maxLength){
                    showStr = str.substr(0,maxLength);
                    if(flag==1){
                        showStr=showStr+"...";
                    }
                }
            }else if(flag==2||flag==3){
                var numStr = Number(str);
                if(maxLength!=0){
                    showStr=numStr.toFixed(maxLength);
                }
                if(flag==3){
                    showStr=numToMoneyType(showStr, maxLength);
                }
            }
        }
        return showStr;
    }

    /**
     * 切换老年版本
     */
    function switchOldMan(){
        // 老年版状态开启状态获取用50041  key : "HJ_AgedSwitcher_SwitchOn_Flag" 返回：1-开启；0-未开启
        var data = $.callMessage({"funcNo": "50043",key : "HJ_AgedSwitcher_SwitchOn_Flag"});
        if(data.results && data.results.length > 0 && data.results[0].value == '1'){
            $('body').addClass('old-man');
            return true;
        }else{
            $('body').removeClass('old-man');
            return false;
        }
    }
    /**
     * 文字占据宽度
     * @param text 文字
     * @param fontSize 字体大小
     * @returns {number}
     */
    function measureText(text, fontSize) {
        fontSize = fontSize || 10;
        text = String(text);
        var text = text.split('');
        var width = 0;
        text.forEach(function (item) {
            if (/[a-zA-Z]/.test(item)) {
                width += 7;
            } else if (/[0-9]/.test(item)) {
                width += 5.5;
            } else if (/\./.test(item)) {
                width += 2.7;
            } else if (/-/.test(item)) {
                width += 4;
            } else if (/\(|\)/.test(item)) {
                width += 3.73;
            } else if (/\s/.test(item)) {
                width += 2.5;
            } else if (/%/.test(item)) {
                width += 8;
            } else if (/,/.test(item)) {
                width += 4;
            } else {
                width += 11;
            }
        });
        return width * fontSize * 0.1
    }

    /********
     * 根据字体大下和最大宽度得到字体大小
     * @param text
     * @param fontSize
     * @param proWidth
     * @param space
     * @returns {string}
     */
    function setAjustFontSize(text, fontSize, proWidth, space) {
        var maxWidth = window.innerWidth * 0.92 / proWidth - (space || 0) - 12;
        var value = Math.min(1, maxWidth / measureText(text, fontSize)) || 1;
        if (value == 1) {
            return 'font-size:' + fontSize / 100 + 'rem';
        } else {
            return 'font-size:' + value * fontSize + 'px';
        }
    }

    /**
     * 判断sysV是否高于等于指定版本号limitV
     * 比较外部版本号
     * @param limitV 指定版本号
     * @param sysV 系统版本号
     */
    function compareLimitVersion(limitV, sysV) {
        limitV = limitV.split(".");
        sysV = sysV.split(".");
        for (var i = 0; i < sysV.length; i++) {
            var lv = parseInt(limitV[i] || 0);
            var sv = parseInt(sysV[i] || 0);
            if (sv > lv) { //当前版本号高于指定版本号
                return  true;
            } else if (sv < lv) { //当前版本号低于指定版本号
                return false
            }
        }
        return true;
    }

    /**
     * 判断版本号
     * @param version 版本号，是否小于等于当前系统版本
     */
    function compareVersion(version){
        var appVersion = nativePluginService.function50001();
        if (appVersion && appVersion.results && appVersion.results.length > 0) {
            var currentVersion = appVersion.results[0].nativeVersion || "";
            if(compareLimitVersion(version,currentVersion)){
                return true;
            }
            return false;
        }
        return false;
    }
    // 监听输入框的软键盘弹起和收起事件
    function listenKeybord($input,page_id,showCallback,hideCallback) {
        if(!$input){
            return;
        }
        keybordShowCallback = function(e){
            // ios 键盘唤起，防止覆盖输入框，主动显示
            if($.device.ios){
                setTimeout(function(){
                    $input.scrollIntoView();
                },100);
            }
            showCallback && showCallback(e);
        };
        keybordHideCallback = function(e){
            // ios 键盘收起，需要主动恢复页面，不然页面会卡住
            if($.device.ios){
                window.scrollTo(0, Math.max(document.body.clientHeight, document.documentElement.clientHeight));
            }
            // 安卓部分机型收起键盘时页面不会恢复，这里重置一下属性可以恢复
            if($.device.android){
                setTimeout(function(){
                    var top = parseInt($(page_id).css("margin-top"));
                    // 如果是点击其他输入框，则重置一下页面高度
                    if(top < 0){
                        keyboard.keyBoardPageScroll($(page_id + ".jsKey.active"));
                        return;
                    }
                    $(page_id).css("margin-top","-1px");
                },0);
                setTimeout(function(){
                    var top = parseInt($(page_id).css("margin-top"));
                    // 如果是点击其他输入框，则重置一下页面高度
                    if(top < 0){
                        keyboard.keyBoardPageScroll($(page_id + ".jsKey.active"));
                        return;
                    }
                    $(page_id).css("margin-top","0px");
                },1);
            }
            hideCallback && hideCallback(e);
        };
        if ($.device.ios) {
            // IOS 键盘弹起：IOS 和 Android 输入框获取焦点键盘弹起
            $input.addEventListener('focus', keybordShowCallback, false)
        
            // IOS 键盘收起：IOS 点击输入框以外区域或点击收起按钮，输入框都会失去焦点，键盘会收起，
            $input.addEventListener('blur', keybordHideCallback)
        }
    
        // Andriod 键盘收起：Andriod 键盘弹起或收起页面高度会发生变化，以此为依据获知键盘收起
        if ($.device.android) {
            var originHeight = document.documentElement.clientHeight || document.body.clientHeight;

            keybordResize = function(){
                var resizeHeight = document.documentElement.clientHeight || document.body.clientHeight;
                if (originHeight < resizeHeight) {
                    // console.log('Android 键盘收起啦！');
                    // Android 键盘收起后操作
                    keybordHideCallback && keybordHideCallback();
                } else {
                    // console.log('Android 键盘弹起啦！');
                    // Android 键盘弹起后操作
                    keybordShowCallback && keybordShowCallback();
                }
                originHeight = resizeHeight;
            }
            window.addEventListener('resize', keybordResize, false)
        }
    }
    function removeKeybord($input){
        if(!$input){
            return;
        }
        if ($.device.ios) {
            $input.removeEventListener('focus', keybordShowCallback, false)
            $input.removeEventListener('blur', keybordHideCallback)
        }
        if ($.device.android) {
            window.removeEventListener('resize', keybordResize, false)
            keybordResize = null;
        }
    }
    /**
     * 公用订阅方法
     */
    function subscribeOn(type,cb){
        var cbs = subscribe_map[type] || [];
        cbs.push(cb);
        subscribe_map[type] = cbs;
        // console.log("subscribeOn" + type + "订阅成功");
    }
    /**
     * 公用发布订阅方法
     */
    function subscribeEmit(type){
        var _arg = arguments;
        _arg = Array.prototype.splice.call(arguments,1,arguments.length-1);
        var cbs = subscribe_map[type] || [];
        cbs.forEach(function(cb){
            cb && cb(_arg);
        })
        // console.log("subscribeEmit" + type + "发布成功");
    }

    /**
     * 公用取消订阅方法
     */
    function subscribeOff(type,cb){
        var cbs = subscribe_map[type] || [];
        var _cbs = cbs.filter(function(fn){
            fn != cb;
        });
        subscribe_map[type] = _cbs;
        // console.log("subscribeOff" + type + "取消成功");
    }

    var base = {
        "compareVersion": compareVersion,
        "size": size,
        "bindStockEvent": bindStockEvent,
        "numToMoneyType": numToMoneyType,
        "getStockType": getStockType,
        "setMainHeight": setMainHeight,
        "transferText": transferText,
        "filterLoginOut": filterLoginOut,
        "getCurUserInfo": getCurUserInfo,
        "setCurUserInfo": setCurUserInfo,
        "clearUserInfo": clearUserInfo,
        "switchingCurUser": switchingCurUser,
        "setAccountInfos": setAccountInfos,
        "getAccountInfos": getAccountInfos,
        "setTransferInfo": setTransferInfo,
        "getTransferInfo": getTransferInfo,
        "clearTransferInfo": clearTransferInfo,
        "getMainAuxiliaryAccount": getMainAuxiliaryAccount,
        "isTradeLogin": isTradeLogin,
        "unshiftDeleteSame": unshiftDeleteSame,
        "dealType": dealType,
        "isValue": isValue,
        "loginTypeSize": loginTypeSize,
        "iConfirm": iConfirm,
        "generatePrompt": generatePrompt,
        "addChoiceList": addChoiceList,
        "Agreement": Agreement,
        "fontOutOf": fontOutOf,
        "getWidth": getWidth,
        "getShareholderAccount": getShareholderAccount,
        "addSelectEject": addSelectEject,
        "checkGgtPermission": checkGgtPermission,
        "checkThirdPermission": checkThirdPermission,
        "checkWeakPwd": checkWeakPwd,
        "costPriceiConfirm": costPriceiConfirm,
        "comStat": comStat,
        "pointCallNative": pointCallNative,
        "judgeValue": judgeValue,
        "setNoData": setNoData,
        "setQueryFail": setQueryFail,
        "setAsteriskHide": setAsteriskHide,
        "singleIConfirm": singleIConfirm,
        "returnNative": returnNative,
        "isEmptyObject": isEmptyObject,
        "changeTips": changeTips,
        "isAppFlag": isAppFlag,
        "isTradeTabbar":isTradeTabbar,
        "timeDifference": timeDifference,
        "dgitConversion": dgitConversion,
        "pageChangeHeight": pageChangeHeight,
        "pageBuryingPoint": pageBuryingPoint,
        "getMaxFontSize": getMaxFontSize,
        "changeFontSize": changeFontSize,
        "addPageTabList": addPageTabList,
        "jumpHpNewshare": jumpHpNewshare,
        "waitForConfirm": waitForConfirm,
        "inputConfirm": inputConfirm,
        "initTimeChoice": initTimeChoice,
        "thirdIConfirm": thirdIConfirm,
        "entrustResultsConfirm": entrustResultsConfirm,
        "setMainHeightNew": setMainHeightNew,
        "singleIConfirmNew": singleIConfirmNew,
        "iConfirmNew": iConfirmNew,
        "getShowStr":getShowStr,
        "setAjustFontSize":setAjustFontSize,
        "switchOldMan":switchOldMan,
        "listenKeybord":listenKeybord,
        "removeKeybord":removeKeybord,
        "compareLimitVersion": compareLimitVersion,
        "subscribeOn":subscribeOn,
        "subscribeEmit":subscribeEmit,
        "subscribeOff":subscribeOff,
    };

    base = $.extend(false, base, commonDiv);
    module.exports = base;
});
