/**
 * 交易模块公用 js
 */
define('trade/scripts/common/commonDiv.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var indexHScroller = null;
    var dateUtils = require("mobiscrollUtils");


    /**
     * 绑定密码输入框的显示隐藏密码功能
     * @param {Object} bDiv 要绑定的点击的div地址
     * @param {Object} keyboard 是否启动了div键盘
     */
    function displayPassword(bDiv, keyboard) {
        // 密码显示隐藏功能
        // 点击登录下拉框选择
        $.bindEvent(bDiv, function (e) {
            if ($(this).hasClass("hide_psw")) {
                $(this).removeClass("hide_psw").addClass("show_psw");
                if (keyboard) {
                    var type = $(this).prevAll("div.jsKey").attr("key-type");
                    type = type.replace("m", "");
                    $(this).prevAll("div.jsKey").find(" .key_input .key_text").html($(this).prevAll("input").val());
                    $(this).prevAll("div.jsKey").attr("key-type", type);
                } else {
                    $(this).prevAll("input").attr("type", "text");
                }
            } else {
                $(this).removeClass("show_psw").addClass("hide_psw");
                if (keyboard) {
                    var type = $(this).prevAll("div.jsKey").attr("key-type");
                    type = "m" + type;
                    var val = $(this).prevAll("input").val() + "";
                    var key_text = "";
                    for (var i = 0; i < val.length; i++) {
                        key_text += "<b></b>";
                    }
                    $(this).prevAll("div.jsKey").find(" .key_input .key_text").html(key_text);
                    $(this).prevAll("div.jsKey").attr("key-type", type);
                } else {
                    $(this).prevAll("input").attr("type", "password");
                }
            }
            e.stopPropagation(); // 阻止冒泡
        });
//		$.bindEvent(bDiv,function(e){
//			if($(this).hasClass("hide_psw")){
//				$(this).removeClass("hide_psw").addClass("show_psw");
//				if(keyboard){
//					var type = dDiv.attr("key-type");
//					type = type.replace("m","");
//					dDiv.find(".key_input .key_text").html(inDiv.val());
//					dDiv.attr("key-type",type);
//				}
//				else{
//					inDiv.attr("type","text");
//				}
//			}
//			else{
//				$(this).removeClass("show_psw").addClass("hide_psw");
//				if(keyboard){
//					var type = dDiv.attr("key-type");
//					type = "m"+type;
//					var val = inDiv.val()+"";
//					var key_text = "";
//					for(var i = 0; i < val.length; i++){
//						key_text += "<b></b>";
//					}
//					dDiv.find(".key_input .key_text").html(key_text);
//					dDiv.attr("key-type",type);
//				}
//				else{
//					inDiv.attr("type","password");
//				}
//			}
//			e.stopPropagation(); // 阻止冒泡
//		});
    }

    /**
     * 初始化日期选择组件
     * @param {Object} pageId
     * @param {Object} timeLimit 默认查询天数
     * @param {Boolean} notContainToday 不包含今天
     */
//	function initTimeChoice(pageId,timeLimit,notContainToday){
//		if(!timeLimit){
//			timeLimit = 0;
//		}
//		var begin_time = $.getTradingDay(0-timeLimit, "yyyy-MM-dd");	//截止时间
//		var end_time = new Date().format("yyyy-MM-dd");  
//		if(notContainToday){
//			begin_time = $.getTradingDay(0-timeLimit-1, "yyyy-MM-dd");
//			end_time = $.getTradingDay(-1, "yyyy-MM-dd");  
//		}
//		$(pageId + " #startDate").html(begin_time);
//		$(pageId + " #endDate").html(end_time);
//		$(pageId + " #startInput").val(begin_time);
//		$(pageId + " #endInput").val(end_time);
//		//初始化时间控件
////		
//		dateUtils.initDateUI($(pageId + " .time input"), {
//			"preset": "date",
//			"theme": 'android-ics',
//		});
//		
//		
//		//设置开始日期
//		$.bindEvent($(pageId + " #setStart"), function(e){
//			if($.device.android){
//				$(pageId + " #startInput").triggerHandler("click");
//			}
//			else{
//				$(pageId + " #startInput").triggerFastClick();
//			}
////			$(pageId + " #startInput").focus();
//			e.stopPropagation();
//		});
//		$.bindEvent($(pageId + " #startInput"), function(e){
//			var reg = /^\d{4}-\d{2}-\d{2}$/,
//			thisVal = $(this).val().replaceAll("/","-");
//			if (reg.test(thisVal)){
//				$(pageId + " #startDate").html(thisVal);
//			}
//			e.stopPropagation();
//		}, "change");
//		
//		//设置截止日期
//		$.bindEvent($(pageId + " #setEnd"), function(e){
//			if($.device.android){
//				$(pageId + " #endInput").triggerHandler("click");
//			}
//			else{
//				$(pageId + " #endInput").triggerFastClick();
//			}
////			$(pageId + " #endInput").focus();
//			e.stopPropagation();
//		});
//		$.bindEvent($(pageId + " #endInput"), function(e){
//			var reg = /^\d{4}-\d{2}-\d{2}$/,
//			thisVal = $(this).val().replaceAll("/","-");
//			if (reg.test(thisVal)){
//				$(pageId + " #endDate").html(thisVal);
//			}
//			e.stopPropagation();
//		}, "change");
//	}

    /**
     *
     * @param {Object} div 点击显示
     * @param {Object} title 标题
     * @param {Object} liHtml 数据老板
     * @param {Object} determine 确认回调
     * @param {Object} titleBined 点击控件触发的函数
     * @param {Object} cssClass 控件颜色
     * @param {Object} cancelFun 取消回调
     */
    function selectList(div, title, liHtml, determine, titleBined, cssClass, cancelFun) {
        var headerDiv = '';
        headerDiv += '<header id="selectList" class="bar bar-nav">';
        headerDiv += '<button class="button button-link pull-left close-picker">取消</button>';
        headerDiv += '<button class="button button-link pull-right">确定</button>';
        headerDiv += '<h1 class="titlehsea">' + title + '</h1>';
        headerDiv += '</header>';
        var values = [];
        var dataObj = {};
        if (liHtml) {
            for (var i = 0; i < liHtml.length; i++) {
                if (typeof (liHtml[i]) == "object") {
                    values.push(liHtml[i].name);
                    dataObj[liHtml[i].name] = liHtml[i];
                } else {
                    values.push(liHtml[i]);
                    dataObj[liHtml[i]] = liHtml[i];
                }
            }
        }
        if ($.isValue(values)) {
            var bindButton = function () {
                if (titleBined) {
                    titleBined();
                }
                $.bindEvent($("#selectList button.pull-right"), function (e) {
                    div.picker("close");
                    var id = div.val() || div.attr("value");
                    if (determine) {
                        determine(dataObj[id]);
                    }
                    e.stopPropagation();
                });
                $.bindEvent($("#selectList button.pull-left"), function (e) {
                    if (cancelFun) {
                        cancelFun();
                    }
                });
            };
            var selectObj = {
                "toolbarTemplate": headerDiv,
                "cols": [{"textAlign": 'center', "values": values}],
                "onOpen": bindButton,
                "cssClass": (cssClass || "option"),
            };
            div.unbind("click");
            div.data("picker", null);
            div.picker(selectObj);
//			div.data("picker").params.cols[0].values = values;
//			div.data("picker").params.onOpen = bindButton;
            div.val("");
            div.attr("value", "");
            div.data("picker").params.value = "";
            div.data("picker").value = "";
            div.show();
        } else {
            div.hide();
        }
    }

    /**
     * 三按钮提示框
     * @param {Object} theme 提示标题
     * @param {Object} content 提示内容
     * @param {Object} determineFunction 点击正确执行函数
     * @param {Object} cancelFunction 点击取消执行函数
     * @param {Object} determine 正确按钮语
     * @param {Object} cancel 取消按钮语
     */
    function iConfirm3(theme, content, determineFunction, cancelFunction, determine, cancel, qrjxFunction, qrjxName) {
        $("#newTradingTipsBox2").remove();
        var pageId = '#' + $.getCurrentPageObj().pageId;
        if (theme && typeof (theme) == "string") {
            theme = "<h3>" + theme + "</h3>";
        }
        if (typeof (content) == "undefined") {
            content = "";
        }
        if (typeof (determine) == "undefined") {
            determine = "确定";
        }
        if (typeof (cancel) == "undefined") {
            cancel = "取消";
        }
        var div = '<div id="newTradingTipsBox2" style="position: fixed"><div key-panel-main="true" class="prompt_box2">' + theme + '<div class="_content">' + content +
            '</div><div class="btn3"><div><a href="javascript:void(0)" id="determine">' + determine +
            '</a></div>';
        if (qrjxName) {
            div += '<div><a href="javascript:void(0)" id="qrjx">' + qrjxName + '</a></div>';
        }
        div += '<div><a class="needsclick" href="javascript:void(0)" id="cancel">' + cancel +
            '</a></div></div></div><div class="shade"></div></div>';
        $(pageId).append(div);
        var $content = $(pageId + " #newTradingTipsBox2 .prompt_box2 ._content");
        if ($content.height() < 30) {
            $content.height(30);
        }
        var $prompt = $(pageId + " #newTradingTipsBox2 .prompt_box2");
        var wHeight4 = gconfig.appHeight * 0.39;
        var topHeight = $prompt.height() / 2;
        if (topHeight >= wHeight4) {
            topHeight = wHeight4;
            $content.css({"height": topHeight * 2 - 131, "overflow": "auto"});
        }
        var table_tips_list = $(pageId + " #newTradingTipsBox2 ._content .table_tips_list");
        if (table_tips_list && table_tips_list.length == 1) {
            var tr = table_tips_list.find("tr").eq(0).width();
            var td = table_tips_list.find("td").eq(0).width();
            if (td / tr < 0.3) {
                $(pageId + " #newTradingTipsBox2 ._content .table_tips_list").addClass("w30");
            } else if (td / tr > 0.5) {
                $(pageId + " #newTradingTipsBox2 ._content .table_tips_list").addClass("w50");
            }
        }
        $prompt.css("margin-top", 0 - topHeight);
        $(pageId + " #newTradingTipsBox2").css("position", "static");
        setTimeout(function () {
            $.bindEvent($(pageId + " #newTradingTipsBox2 #determine"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (determineFunction) {
                    setTimeout(function () {
                        determineFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
            $.bindEvent($(pageId + " #newTradingTipsBox2 #cancel"), function (e) {
                setTimeout(function () {
                    $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                    $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                }, 100);
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (cancelFunction) {
                    setTimeout(function () {
                        cancelFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");

            $.bindEvent($(pageId + " #newTradingTipsBox2 #qrjx"), function (e) {
                $(this).unbind();
                this.touchstart = null;
                $(pageId + " #newTradingTipsBox2 .shade").css("opacity", "0");
                $(pageId + " #newTradingTipsBox2 .prompt_box2").hide();
                setTimeout(function () {
                    var opacity = $(pageId + " #newTradingTipsBox2 .shade").css("opacity");
                    if (opacity == 0) {
                        $("#newTradingTipsBox2").remove();
                    }
                }, 500);
                if (qrjxFunction) {
                    setTimeout(function () {
                        qrjxFunction($content);
                    }, 300);
                }
                var evt = e || window.event;
                evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
            }, "touchstart");
        }, 500);
    }

    /***
     * 获取隐藏的元素的高度
     * @param {Object} $div $对象
     */
    function getHideHeight($div) {
        var h = 0;
        if ($div.isShow()) {
            h = $div.height();
        } else {
            var ifdg = function ($d) {
                var st = $d.attr("style");
                if (typeof (st) != "string") {
                    st = "";
                }
                var sz = ";display: block; position:absolute; visibility: hidden;";
                $d.attr("style", st + sz);
                if ($d.isShow()) {
                    h = $div.height();
                    $d.attr("style", st);
                    return h;
                } else {
                    $d.attr("style", st);
                    ifdg($d.parent());
                }
            }
            ifdg($div);
            return h;
        }
    }

    /**
     * <div style="height: 443px; overflow: auto;"> 绑定事件的元素
     <div> 绑定事件子的元素
     <div></div> 分页列表的元素
     <div></div> 分页列表的元素
     <div></div> 分页列表的元素
     </div>
     </div>
     * @param {Object} $div
     * @param {Object} callback
     */
    function scrollPaging($div, callback) {
        $.bindEvent($div, function (e) {
            var st = $(this).scrollTop();
            var sh = $(this).height();
            var gh = $(this).children().height();
            if (st >= (gh - sh + 10)) {
                //你要加的动画效果div
                var div = '<div class="_scroll"><div class="visc_pullDown" style=""><span class="visc_pullDownIcon"></span><div class="visc_pullDownDiv"><span class="visc_pullDownLabel">正在加载下一页数据...</span><br>时间更新于：<span class="visc_pullDownTime">' + (new Date().format("HH:mm:ss")) + '</span></div></div></div>';
                $(this).children().append(div);
                gh = $(this).children().height();
//				$div.animate({scrollTop:gh}, 800);
//				$div.scrollTop(gh);
                $(this).off("scroll"); // 取消滚动事件
                $div.scrollTop = gh - 10;
                window.setTimeout(function () {
                    $div.scrollTop = gh;
                }, 400);
//				console.log("正在加载下一页数据...");
                var remove = function () {
                    $div.find("div._scroll").remove();
                }
                if (callback) {
                    window.setTimeout(function () {
                        callback(remove);
                        remove();
                    }, 3000);
                }
//				layerUtils.iLoading(true, "正在加载下一页数据...");
//				$(this).off("scroll"); // 取消滚动事件
            }
            e.stopPropagation();
        }, "scroll");
    }

    /**
     * 气泡提示框
     * @param {Object} div 输入框
     * @param {Object} title 提示语
     * @param {Object} time 提示时间 毫秒
     * @param {Object} c 样式
     */
    function bubbleBombBox(div, title, time, c) {
        if (div && div.length > 1) {
            for (var i = 0; i < div.length; i++) {
                if (div.eq(i).isShow()) {
                    div = div.eq(i);
                }
            }
        }
        removeBubbleBox(div);
        if (title) {
            if (typeof (c) != "string") {
                c = "";
            }
            var d = "<div id='_bubbleBox' class='bubbleBox " + c + "'>" + title + "</div>";
            var w = div.getWidth();
            var ol = div[0].offsetLeft;
            div.after(d);
            var db = div.next("div#_bubbleBox");
            var wb = db.getWidth();
            db.css("left", (ol + (w - wb) / 2) + "px");
            if (time) {
                window.setTimeout(function () {
                    db.remove();
                }, time);
            }
        }
    }

    function removeBubbleBox(div) {
        if (div) {
            div.nextAll("div#_bubbleBox").remove();
        }
    }

    function createAdPicGroup(opts, groupData) {
        if (opts && groupData && groupData.length) {
            var isLoop = true;
            var divFrame = $(opts.divFrame),
                width = opts.width || $(window).width(),
                height = opts.height || 60;
            var imgUrl = global.unifyUrl;
            if (imgUrl.indexOf("/servlet/") != -1) {
                imgUrl = imgUrl.substring(0, imgUrl.indexOf("/servlet/"));
            }

            var getWrapper = function (groupData) {
                var element = "";
                for (var i = 0; i < groupData.length; i++) {
                    var image_url = groupData[i].image_url;
                    if (image_url.indexOf("http") == 0) {
                        image_url = groupData[i].image_url;
                    } else {
                        image_url = imgUrl + groupData[i].image_url;
                    }
                    element += '<div class="j-stock-data imgData" style="width: 100%;height:100%;overflow:hidden;">';
                    element += '<img widht="100%" border="0" height="' + height + '" style="width:100%;border:0;" src="' + image_url + '"/>'
                    // element += groupData[i].image_name
                    element += '</div>'
                }

                return element;
            }

            var bindEvent = function () {
                $.bindEvent(divFrame.find(".imgData"), function (e) {
                    var data = groupData[$(this).index()] || {};
                    data.funcNo = "80037";
                    $.callMessage(data)
                });
            }

            var scrollDestroy = function () {
                if (indexHScroller) {
                    try {
                        indexHScroller.destroy();
                    } catch (error) {
                        console.log(error);
                    }
                    indexHScroller = null;
                }
            }


            var divHtml = "";
            divHtml += '<div class="iscroll_hWrapper" id="adhwrapper" style="width: 100%;height:100%;">';
            divHtml += '<div class="iscroll_hScroller" id="adhscroller">';
            divHtml += getWrapper(groupData);
            divHtml += '</div>';
            divHtml += '</div>';
            if (groupData.length > 1) {
                divHtml += '<div class="j-dot-list index">';
                for (var j = 0; j < groupData.length; j++) {
                    divHtml += '<em class="' + (0 == j ? "on" : "") + '"></em>';
                }
                divHtml += "</div>";
            }
            divFrame.css({"width": width, "height": height, "position": "relative"}).html(divHtml);
            divFrame.find("img").each(function (idx, item) {
                item.onerror = function () {
                    this.src = seajs._platRootUrl + gconfig.seaBaseUrl + gconfig.projName + "/" + gconfig.imagesPathName + "/img_no_data.png";
                    this.onerror = null;
                }
            });
            bindEvent();
            var scrollOptions = {
                autoScroll: isLoop,
                autoTime: 3e3,
                $wrapper: divFrame.find(" #adhwrapper"),
                scrollEndHandler: function () {//滚动结束时的处理函数
                    var pagex = indexHScroller.getCurPageIdx();
                    divFrame.find(".j-dot-list em").removeClass("on").eq(pagex).addClass("on");
                }
            };
            // 设置滚动内容的宽度
            // 显示左右滑动内容，防止页面闪动
            divFrame.find(" .iscroll_hScroller>div").width(width).height(height).css("background", "none").show();
            // 设置 scroller 的宽度
            divFrame.find(" #adhscroller").width(width * groupData.length);
            scrollDestroy();
            indexHScroller = iscrollUtils.hScroller(scrollOptions);
            opts.scrollDestroy = scrollDestroy;
        }
        return opts;
    }

    var base = {
        "displayPassword": displayPassword,
        "iConfirm3": iConfirm3,
        "getHideHeight": getHideHeight,
        "selectList": selectList,
        "scrollPaging": scrollPaging,
        "bubbleBombBox": bubbleBombBox,
        "removeBubbleBox": removeBubbleBox,
        "createAdPicGroup": createAdPicGroup
    };
    module.exports = base;
});
