/**
 * 交易模块公用方法js  （涉及到业务接口的调用）
 */
define('trade/scripts/common/commonHq.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var service_hq = require("service_hq");
	if(global.hqCallInterface == 1){
		service_hq = require("service_hqTrade");
	}
    var service_stock = require("service_stock");
	var tradingTime = true;
//	var checkTradeTimer = null;
	var commonTimer = require("commonTimer");
	var common = require("common");
	
	
	/**
	 * 取行情服务器时间
	 * @param {Object} isAsync 是否异步请求
	 * @param {Object} callback 回调
	 */
	function getServerTime(isAsync,callback){
		isAsync = isAsync ? false : true;
		var dates = {};
		var localDate = new Date();
		dates["dateTime"] = localDate.format("yyyy-MM-dd HH:mm:ss");
		dates["date"] = localDate.format("yyyy-MM-dd");
		dates["time"] = localDate.format("HH:mm:ss");
		dates["Date"] = localDate;
		service_stock.getHqState({},function(data){
			if(data){
				var results = data.results;
				if(results && results[0]){
					var s = results[0].date_time+"" || "";
					var date = "";
					var time = "";
					if(s.length > 7){
						date = s.slice(0,4)+"-"+s.slice(4,6)+"-"+s.slice(6,8);
					}
					if(s.length == 14){
						time = s.slice(8,10)+":"+s.slice(10,12)+":"+s.slice(12);
					}
					var dateTime = date+" "+time;
					dates["dateTime"] = dateTime;
					dates["date"] = date;
					dates["time"] = time;
					
					var serverDate = dateTime.replace(/-/g,"/");
					$.setSStorageInfo("_simulationTime",localDate.getTime()+"|"+serverDate);
					
					dates["Date"] = new Date(serverDate);
					
					isTradingTime(dates);
					dates["tradingF"] = true;
					
					if(callback){
						callback(dates);
					}
				}
				else{
					if(callback){
						callback(dates);
					}
				}
			}
			else{
				if(callback){
					callback(dates);
				}
			}
		},{
			"isAsync":isAsync,
			"isShowWait":false,
			"isShowOverLay":false,
			"isGlobal":true,
			"timeOutFunc":function(){
				if(callback){
					callback(dates);
				}
			},"errorFunc":function(){
				if(callback){
					callback(dates);
				}
			}
		});
		return dates;
	}
	
	
	/**
	 * 取行模拟计算的时间
	 * @param {Object} isAsync 是否异步请求
	 * @param {Object} callback 回调
	 */
	function simulationTime(isAsync,callback){
		var s = new Date().getTime();
		var simulation = $.getSStorageInfo("_simulationTime") || "";
		simulation = simulation.split("|");
		var lastDoTime = s - Number(simulation[0]);
		if(global.syncServerTime && lastDoTime > 60000 * global.syncServerTime){
			return getServerTime(isAsync,callback);
		}
		else{
			var serverDate = new Date(simulation[1]).getTime();
			var localDate = new Date(serverDate + lastDoTime);
			var dates = {};
			dates["dateTime"] = localDate.format("yyyy-MM-dd HH:mm:ss");
			dates["date"] = localDate.format("yyyy-MM-dd");
			dates["time"] = localDate.format("HH:mm:ss");
			dates["Date"] = localDate;
			if(callback){
				callback(dates);
			}
			return dates;
		}
	}
	
	function initCheckTradeTimer(){
//		if(checkTradeTimer == null){
			simulationTime(false,isTradingTime);
			//启动是否是交易时间检查定时器
			commonTimer.setTimer("commonHq", function(){
				simulationTime(false,isTradingTime);
			}, global.checkTradeTime * 60000);
//			checkTradeTimer = window.setInterval(function(){
//				simulationTime(false,isTradingTime);
//			}, global.checkTradeTime * 60000); // 5秒检测一次
//		}
	}
	
	function clearCheckTradeTimer(){
		commonTimer.clearTimer("commonHq");
//		if(checkTradeTimer != null){
//			window.clearInterval(checkTradeTimer);
//			checkTradeTimer = null;
//		}
	}
	
	function getTradingTime(){
		return tradingTime;
	}
	
	/***
	 * 判断是否是交易时间
	 * @param {Object} type
	 */
	function isTradingTime(dates){
		dates = dates || simulationTime();
		if(!dates.tradingF){
			var xq = dates.Date.getDay();
			if(xq == 6 || xq == 0){
				tradingTime = false;
			}
			else{
				var time = dates.time;
				if(timeComparison(time, "08:50") >= 0 && timeComparison(time, "15:40") <= 0){
					tradingTime = true;
				}
				else{
					tradingTime = false;
				}
			}
		}
		return tradingTime;
	}
	
		
	/***
	 * 判断是否是交易时间
	 * @param {Object} type
	 */
	function isTradingTimes(type, dates){
		if(!type && !dates){
			return isTradingTime();
		}
		else{
			dates = dates || simulationTime();
			if(dates["Date"]){
				var xq = dates.Date.getDay();
				if(xq == 6 || xq == 0){
					return false;
				}
				if(!dates["time"]){
					dates["time"] = dates["Date"].format("HH:mm:ss");
				}
			}
			else{
				type = type + "";
				var time = dates.time;
				var isTrading = false;
				var tradingtimes = [['09:00',"15:00"]];
				switch(type){
					case "0":
						tradingtimes = [['09:00',"12:00"],['13:00',"15:00"]];
						break;
					case "1":
						tradingtimes = [['09:00:00',"12:00:00"],['13:00:00',"16:00:00"]];
						break;
				}
				for(var i = 0; i < tradingtimes.length; i++){
					if(timeComparison(time, tradingtimes[i][0]) >= 0 && timeComparison(time, tradingtimes[i][1]) <= 0){
						isTrading = true;
						break;
					}
				}
				return isTrading;
			}
		}
	}
	
	function timeComparison(a,b){
		a = (a || '').split(":");
		b = (b || '').split(":");
		a = Number(a[0] || 0)*60*60 + Number(a[1] || 0)*60 + Number(a[2] || 0);
		b = Number(b[0] || 0)*60*60 + Number(b[1] || 0)*60 + Number(b[2] || 0);
		return a - b;
	}
	
	function getCurrentDate(){
		
	}
	
	/**
	 * 得到证券类型
	 * @param {Object} stkType 证券类型
	 */
	function getStockType(stkType){
		var map = {
					"0":{
						"id":"0",
						"name":"股票",
						"unit_name":"股"
					},
					"1":{
						"id":"1",
						"name":"基金",
						"unit_name":"股"
					},
					"2":{
						"id":"2",
						"name":"债券",
						"unit_name":"张"
					},
					"3":{
						"id":"3",
						"name":"权证",
						"unit_name":""
					},
				};
		var type = "0";
		var bondType = [6,14,21,22,23,24,25,26,27,30]; // 债券
		var fundType = [3,4,11,12,19,20]; // 基金
		var warrantType = [5,13]; // 权证
		if($.inArray(stkType, bondType)!=-1){
			type = "2";
		}else if($.inArray(stkType, fundType)!=-1){
			type = "1";
		}else if($.inArray(stkType, warrantType)!=-1){
			type = "3";
		}
		return map[type];
	}
	
	/**
	 * 判断股票的小数位数，变动单位
	 * @param {Object} stockVal 股票代码
	 * @param {Object} stkType 股票类型
	 */
	function getHqtypeData(stockVal,stkType){
		var price_digit = null;
		var price_step = null;
		var lots_of = null;

		var types = getStockType(stkType);
		var unit_name = types.unit_name;//
		var price_step_const = [0,1,2,7,8,9,14,15,17,18,25,26,27,43,44,45,46,66];//0.01
		if(global.typeDigit && global.typeDigit instanceof Array && global.typeDigit.length != 0){
			price_step_const = global.typeDigit;
		}
		var step_flag = $.inArray(stkType, price_step_const);
		
		// 上海国债逆回购
		if(stockVal.substring(0,3) == "204"){
			price_digit = 3;
			price_step = 0.005;
			lots_of = 1000;
			if(global.serverConfig == "3"){
				lots_of = 100;
				unit_name = "手";
			}
		}
		// 否则浮动为0.01
		else if(step_flag != -1){
			price_digit = 2;
			price_step = 0.01;
			lots_of = 100;
		}
		// 变动价格为0.001
		else{
			price_digit = 3;
			price_step = 0.001;
			lots_of = 100;
		}
		var num_step_const = [6,14,21,22,23,24,25,26,27];//10张
		if($.inArray(stkType, num_step_const) != -1 || stockVal.substring(0,3) == "131"){
			lots_of = 10;
		}
		if(global.serverConfig == "3" && $.inArray(stkType, [14,25,26,27]) != -1){
			lots_of = 1;
			unit_name = "手";
		}
		var stock_info = {};
		stock_info.stock_code = stockVal;
		stock_info.lot_size = lots_of;
		stock_info.price_step = price_step;
		stock_info.price_digit = price_digit;
		stock_info.stock_type = stkType;
		
		stock_info.unit_name = unit_name;
		return stock_info;
	}
	
	/**
	 * 股票小数保留位数
	 */
	function decimalKeep(stockCode,callback){  //小数保留
		var keep_two = 3;
		var param = {
				"code_list" : stockCode
		};
		service_hq.getStockInfo(param,function(data){
			if(data.errorNo == "0"){
				var results = data.results;
				if(results && results.length>0){
					var stkType = results[0][2];  // 行情类别
					var stockVal = results[0][0];
					var obj = getHqtypeData(stockVal,stkType);
					keep_two = obj.price_digit;
					callback(keep_two, results[0]);
				}
				else{
					callback(keep_two, [stockCode]);
				}
			}else{
				callback(keep_two, [stockCode]);
	    		$.alert("获取股票信息失败");
	    	}	
		},{"timeOutFunc":function(){
			callback(keep_two, [stockCode]);
		},"errorFunc":function(){
			callback(keep_two, [stockCode]);
		}});
	}
	
	
	/**
	 * 股票小数保留位数
	 */
	function getThirdStockInfo(stockCode,callback, type){  //小数保留
		var hqData = {};
		var param = {
				"code_list" : stockCode,
				"type": type,
		};
		service_hq.getThirdStockInfo(param,function(data){
			if(data.errorNo == 0){
					var results = data.results;
					if(results.length>0){
						for (var i=0;i<results.length;i++){
							hqData[""+results[i][0]] = results[i];
						}
					}
				}
				if(callback){
					callback(hqData);
				}
			},
			{
				"isShowOverLay":false,
				"isShowWait":false,
				"timeOutFunc":function(){},
				"errorFunc":function(){}
			}
		);
	}
	
	
	/**
	 * 查询股票信息
	 * @param {Object} stock_list 入参
	 * @param {Object} callback 成功回调
	 */
	function getStockNowPrice(stock_list, callback){
		var hqData = {};
		var param = {
				"stock_list":stock_list,
			};
		service_hq.getStockNowPrice(param,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results.length>0){
						for (var i=0;i<results.length;i++){
							hqData[results[i][9]+":"+results[i][1]] = results[i];
						}
					}
				}
				if(callback){
					callback(hqData);
				}
			},
			{
				"isShowOverLay":false,
				"isShowWait":false,
				"timeOutFunc":function(){},
				"errorFunc":function(){}
			}
		);
	}
	
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(param,stock_html,callback,failCallback,keyboard){
		
		var stockCode = param.stockCode, market = param.market, exchange_type = param.exchange_type, type = param.type;
		var stockStrParam = {
		  "q" : stockCode,
		  "type" : type,
		}; 
		stock_html.html("");
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			$.showPreloader("请等待...");
		}
		service_hq.getStockList(stockStrParam, function(data) {
				var StockList = {};
				stock_html.html("");
				if(data.errorNo == 0){
					var results = data.results;
					// 显示证券列表
					if(results && results.length > 0){
						if(results.length == 1 && vai1.test(stockCode)){
							callback(results[0]);
							stock_html.html("");
						}else{
							$.hidePreloader();
							var selectHeight = 0.4*results.length;
							if(results.length >= 7){
								selectHeight = 7 * 0.4;
							}
							var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
							for(var i = 0;i < results.length; i++) {
								if(market && market == results[i][9] && results[i][0] == stockCode){
									callback(results[i]);
									return false;
								}
								StockList[(results[i][9]+":"+results[i][0])] = results[i];
								listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i][0]+"</strong>"+results[i][1]+"</a>";
								listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
							};
							listHtml+="</ul>";
							stock_html.html(listHtml).show();
							$.bindEvent(stock_html.find("ul li"),function(e){
								if(keyboard){
									keyboard.closeKeyPanel();
								}
								var market1 = $(this).find("span").text();
								var stockCode = $(this).find("strong").text();
								callback(StockList[market1+":"+stockCode]);
								stock_html.html("");
								StockList={};
								e.stopPropagation();
							});
						}
					}
					else{
						if(vai1.test(stockCode)){
							failCallback(param);
						}
					}
				}else{
					failCallback(param);
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback(param);
				},
				"errorFunc": function() {
					failCallback(param);
				}
			}
		);
	
	}
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getkcbStockList(param,stock_html,callback,failCallback){
		var stockCode = param.stockCode, market = param.market, exchange_type = param.exchange_type, type = param.type;
		var stockStrParam = {
		  "q" : stockCode,
		  "type" : type,
		  "marketType": param.marketType,
		  "count": param.count
		}; 
		stock_html.html("");
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			$.showPreloader("请等待...");
		}
		service_hq.getkcbStockList(stockStrParam, function(data) {
				var StockList = {};
				stock_html.html("");
				if(data.errorNo == 0){
					var results= data.results;
					// 显示证券列表
					if(results && results.length > 0){
						if(results.length == 1 && vai1.test(stockCode)){
							if($.isValue(results[0][13])) results[0][1] = results[0][13]; // 长名称赋值原名称
							callback(results[0]);
							stock_html.html("");
						}else{
							$.hidePreloader();
							var selectHeight = 0.4*results.length;
							if(results.length >= 7){
								selectHeight = 7 * 0.4;
							}
							var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
							for(var i = 0;i < results.length; i++) {
								if($.isValue(results[i][13])) results[i][1] = results[i][13]; // 长名称赋值原名称
								if(market && market == results[i][3] && results[i][0] == stockCode){
									callback(results[i]);
									return false;
								}
								StockList[(results[i][3]+":"+results[i][0])] = results[i];
								var nameText = '<em style="font-size:' + $.getTransformScaleFontSize(results[i][1], 14, $(window).width() * 0.3) + 'px">' + results[i][1] + '</em>';
								listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i][0]+"</strong>"+nameText+"</a>";
								listHtml +=	"<span style=\"display:none;\">"+results[i][3]+"</span></li>";
							};
							listHtml+="</ul>";
							stock_html.html(listHtml).show();
							$.bindEvent(stock_html.find("ul li"),function(e){
								var market1 = $(this).find("span").text();
								var stockCode = $(this).find("strong").text();
								callback(StockList[market1+":"+stockCode]);
								stock_html.html("");
								StockList={};
								e.stopPropagation();
							});
						}
					}
					else{
						if(vai1.test(stockCode)){
							failCallback(param);
						}
					}
				}else{
					failCallback(param);
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback(param);
				},
				"errorFunc": function() {
					failCallback(param);
				}
			}
		);
	}
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getThirdStockList(param,stock_html,callback,failCallback){
		
		var stockCode = param.stockCode, market = param.market, exchange_type = param.exchange_type, type = param.type;
		var stockStrParam = {
		  "q" : stockCode,
		  "type" : type,
		}; 
		stock_html.html("");
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			$.showPreloader();
		}
		service_hq.getThirdStockList(stockStrParam, function(data) {
				var StockList = {};
				stock_html.html("");
				if(data.errorNo == 0){
					var results = data.results;
					// 显示证券列表
					if(results && results.length > 0){
						if(results.length == 1 && vai1.test(stockCode)){
							callback(results[0]);
							stock_html.html("");
						}else{
							$.hidePreloader();
							var selectHeight = 0.4*results.length;
							if(results.length >= 7){
								selectHeight = 7 * 0.4;
							}
							var listHtml = "<ul style=\"position:relative;display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
							for(var i = 0;i < results.length; i++) {
								if(market && market == results[i][3] && results[i][0] == stockCode){
									callback(results[i]);
									return false;
								}
								StockList[(results[i][3]+":"+results[i][0])] = results[i];
								listHtml += "<li stock_name='"+results[i][1]+"'><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i][0]+"</strong>"+results[i][1]+"</a>";
								listHtml +=	"<span style=\"display:none;\">"+results[i][3]+"</span></li>";
							};
							listHtml+="</ul>";
							stock_html.html(listHtml).show();
							$.bindEvent(stock_html.find("ul li"),function(e){
								//埋点
								var objectId = stock_html.attr("objectId")
								var actionId = stock_html.attr("actionId");
								common.comStat(objectId,2,actionId,true,{"i_change_name":"股票输入","i_change_to":$(this).attr("stock_name")});
								
								var market1 = $(this).find("span").text();
								var stockCode = $(this).find("strong").text();
								callback(StockList[market1+":"+stockCode]);
								stock_html.html("");
								StockList={};
								e.stopPropagation();
							});
						}
					}
					else{
						if(vai1.test(stockCode)){
							failCallback(param);
						}
					}
				}else{
					failCallback(param);
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback(param);
				},
				"errorFunc": function() {
					failCallback(param);
				}
			}
		);
	}
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockListGgt(param,stock_html,callback,failCallback){
		var stockCode = param.stockCode, market = param.market, exchange_type = param.exchange_type, type = param.type;
		var stockStrParam = {
		  "q" : stockCode,
		  "type" : "98:99",
		}; 
		if(global.ggtExchangeType == "G"){
			stockStrParam["type"] = "99";
		}
		else if(global.ggtExchangeType == "S"){
			stockStrParam["type"] = "98";
		}
		stock_html.html("");
		var vai1 = /^[0-9]{5}$/;
		if(vai1.test(stockCode)){
			$.showPreloader("请等待...");
		}
		service_hq.getStockList_ggt(stockStrParam, function(data) {
				var StockList = {};
				stock_html.html("");
				if(data.errorNo == 0){
					var results = data.results;
					// 显示证券列表
					if(results && results.length > 0){
						if(results.length == 1 && vai1.test(stockCode)){
							callback(results[0]);
							stock_html.html("");
						}else{
							$.hidePreloader();
							var selectHeight = 0.4*results.length;
							if(results.length >= 7){
								selectHeight = 7 * 0.4;
							}
							var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
							for(var i = 0;i < results.length; i++) {
								if(market && market == results[i][3] && results[i][0] == stockCode){
									callback(results[i]);
									return false;
								}
								StockList[(results[i][3]+":"+results[i][0])] = results[i];
								listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.25rem;\"><i class=\"li_g "+results[i][3]+"\"></i><strong style=\"font-size:0.15rem\">"+results[i][0]+"</strong>"+results[i][1]+"</a>";
								listHtml +=	"<span style=\"display:none;\">"+results[i][3]+"</span></li>";
							};
							listHtml+="</ul>";
							stock_html.html(listHtml).show();
							$.bindEvent(stock_html.find("ul li"),function(e){
								var market1 = $(this).find("span").text();
								var stockCode = $(this).find("strong").text();
								callback(StockList[market1+":"+stockCode]);
								stock_html.html("");
								StockList={};
								e.stopPropagation();
							});
						}
					}
					else{
						if(vai1.test(stockCode)){
							failCallback(param);
						}
					}
				}else{
					failCallback(param);
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback(param);
				},
				"errorFunc": function() {
					failCallback(param);
				}
			}
		);
	}
	
	/**
	 * 五档买卖盘
	 * @param {Object} stock_list 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getFifthOrder(stock_list,callback,failCallback){
		var fifthOrder = {
			"stock_list" : stock_list
		};
		service_hq.getStockFiveStep(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results[0]);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeout": global.stockTimeout,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	/**
	 * 五档买卖盘
	 * @param {Object} stock_list 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getThirdNowPrice(stock_list,callback,failCallback){
		var fifthOrder = {
			"stock_list" : stock_list
		};
		service_hq.getThirdNowPrice(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results[0]);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	/**
	 * 计算股票的金额
	 * @param {Object} price 价格  Y
	 * @param {Object} num 数量  Y
	 * @param {Object} type 类型   Y
	 * @param {Object} code 股票代码 
	 */
	function calculateStockAmount(price,num,type,code){
		price ? price = Number(price) : 0;
		num ? num = Number(num) : 0;
		if(getStockType(type).id == "2"){
			return (price * num * 100).toFixed(2);
		}
		else{
			return (price * num).toFixed(2);
		}
	}
	
	/**
	 * 五档买卖盘
	 * @param {Object} stock_list 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getOptionsFifthOrder(stock_list,callback,failCallback){
		var fifthOrder = {
			"stock_list" : stock_list
		};
		service_hq.queryOptions(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results[0]);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	/**
	 * 回购排序
	 * @param {Object} type 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getBuybackList(type,callback,failCallback){
		var fifthOrder = {
			"type" : type
		};
		service_hq.getBuybackList(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	/**
	 * 回购相关日期
	 * @param {Object} type 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getRepurchaseDate(stock_list,callback,failCallback){
		var fifthOrder = {
			"stock_list" : stock_list
		};
		service_hq.getRepurchaseDate(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results[0]);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	
	/**
	 * 回购相关日期
	 * @param {Object} type 入参
	 * @param {Object} callback 成功回调
	 * @param {Object} failCallback 失败回调
	 */
	function getRepurchaseDates(stock_list,callback,failCallback){
		var fifthOrder = {
			"stock_list" : stock_list
		};
		service_hq.getRepurchaseDate(fifthOrder,function(data){
				if(data.errorNo == 0){
					var results = data.results;
					if(results && results.length>0){
						if(callback){
							callback(results);
						}
					}
					else{
						if(failCallback){
							failCallback();
						}
					}
				}
				else{
					if(failCallback){
						failCallback();
					}
				}
			},
			{
				"isShowOverLay": false,
				"isShowWait": false,
				"timeOutFunc": function() {
					failCallback();
				},
				"errorFunc": function() {
					failCallback();
				}
			}
		);
	}
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getNewThirdStockList(param,stock_html,callback,failCallback, serviceType){
		var stockCode = param.stockCode, market = param.market, type = param.type;
		var stockStrParam = {
		  "q" : stockCode,
		  "type" : type,
		};
		var vai1 = /^[0-9]{6}$/;
		// if(vai1.test(stockCode)){
		// 	$.showPreloader();
		// }
		service_hq.getNewThirdStockList(stockStrParam, function(data) {
				var StockList = {};
				if(data.errorNo == 0){
					var results = data.results;
					// 显示证券列表
					if(results && results.length > 0){
						if(results.length == 1 && vai1.test(stockCode)){
							callback(results[0]);
							stock_html.html("");
						}else{
							$.hidePreloader();
							var selectHeight = 0.4*results.length;
							if(results.length >= 5){
								selectHeight = 5 * 0.4;
							}
							var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
							for(var i = 0;i < results.length; i++) {
								if(market && market == results[i][3] && results[i][0] == stockCode){
									callback(results[i]);
									return false;
								}
								StockList[(results[i][3]+":"+results[i][0])] = results[i];
								listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\" stock_name='"+results[i][1]+"'>"+results[i][0]+"</strong>"+results[i][1]+"</a>";
								listHtml +=	"<span style=\"display:none;\">"+results[i][3]+"</span></li>";
							};
							listHtml+="</ul>";
							stock_html.html(listHtml).show();
							$.bindEvent(stock_html.find("ul li"),function(e){
								$(this).unbind(e.type);
								this[e.type] = null;
								e.preventDefault();
								var market1 = $(this).find("span").text();
								var stockCode = $(this).find("strong").text();
								callback(StockList[market1+":"+stockCode]);
								stock_html.html("");
								StockList={};
								//埋点
								var name = $(this).find("strong").attr("stock_name");
								var objectId = stock_html.attr("objectId");
								var actionId = stock_html.attr("actionId");
								common.comStat(objectId,2,actionId,true,{"i_change_name":"股票输入","i_change_to":name});
								e.stopPropagation();
							},"tap");
							// //阻止滑动事件冒泡
							$.bindEvent(stock_html.find("ul li"),function(e){
								e.stopPropagation();
							},"touchmove");
							// //阻止滑动事件冒泡
							// $.bindEvent(stock_html.find("ul"),function(e){
							// 	e.stopPropagation();
							// },"touchmove");
							// $.bindEvent(stock_html.find("ul"),function(e){
							// 	e.stopPropagation();
							// },"touchend");
						}
					}
					else{
						stock_html.html("");
						if(vai1.test(stockCode)){
							failCallback(param);
						}else{
							$.hidePreloader();
						}
					}
				}else{
					stock_html.html("");
					if(vai1.test(stockCode)){
						failCallback(param);
					}else{
						$.hidePreloader();
					}
				}
			},
			{
				"isLastReq":false,
				"isShowOverLay": false,
				"isShowWait": true,
				"timeout": global.stockTimeout,
				"timeOutFunc": function() {
					stock_html.html("");
					if(vai1.test(stockCode)){
						failCallback(param);
					}else{
						$.hidePreloader();
					}
				},
				"errorFunc": function() {
					stock_html.html("");
					if(vai1.test(stockCode)){
						failCallback(param);
					}else{
						$.hidePreloader();
					}
				}
			}
		);
	}
	
	/**
	 * 判断股票的小数位数，变动单位
	 * @param {Object} stockVal 股票代码
	 * @param {Object} stkType 股票类型
	 */
	function getNewHqtypeData(stockVal,stkType){
		var types = getStockType(stkType);
		var unit_name = types.unit_name;//单位
		// 上海国债逆回购
		if(stockVal.substring(0,3) == "204"){
			if(global.serverConfig == "3"){
				unit_name = "手";
			}
		}
		if(global.serverConfig == "3" && $.inArray(stkType, [14,25,26,27,30]) != -1){
			unit_name = "手";
		}
		var stock_info = {};
		stock_info.stock_code = stockVal;
		stock_info.exchange_type = getExchangeTypeByHq(stkType);
		stock_info.unit_name = unit_name;
		return stock_info;
	}
	
	/**
	 * @description 通过行情类型得到交易市场
	 * @param {Object} stkType
	 */
	function getExchangeTypeByHq(stkType){
		var exchange_type = "";
		if($.inArray(stkType, [9,11,12,13,14,15,20,25,26,27,30])!=-1) exchange_type = 2; //沪A
		else if($.inArray(stkType, [10])!=-1) exchange_type = 3; //沪B
		else if($.inArray(stkType, [0,2,3,4,5,6,7,18,19,21,22,23,24])!=-1) exchange_type = 0; //深A
		else if($.inArray(stkType, [1])!=-1) exchange_type = 1; //深B
		else if($.inArray(stkType, [31,32,33,34,35,36,37,38,39,40])!=-1) exchange_type = 9; //特转A
		else if($.inArray(stkType, [41])!=-1) exchange_type = "A"; //特转B
		else if($.inArray(stkType, [98])!=-1) exchange_type = "S"; //深港通
		else if($.inArray(stkType, [99])!=-1) exchange_type = "G"; //沪港通
		else if($.inArray(stkType, [62])!=-1) exchange_type = 5; //深圳股票期权
		else if($.inArray(stkType, [60,61])!=-1) exchange_type = 6; //上海股票期权
		return exchange_type;
	}
	
	/**
	 * 计算股票的金额
	 * @param {Object} price 价格  Y
	 * @param {Object} num 数量  Y
	 * @param {Object} code 股票代码 
	 */
	function calculateStockAmountNew(price,num,code){
		price ? price = Number(price) : 0;
		num ? num = Number(num) : 0;
		// 上海国债逆回购（顶点）
		if(global.serverConfig == "3" && (code.substring(0,3) == "204")){
			return (price * num * 10).toFixed0(2);
		}
		else{
			var m = 0, s1 = price.toString(), s2 = num.toString();
		    try { m += s1.split(".")[1].length } catch (e) { }
		    try { m += s2.split(".")[1].length } catch (e) { }
		    return (Number(s1.replace(".", "")) * Number(s2.replace(".", "")) / Math.pow(10, m)).toFixed0(2)
//			return (price * num).toFixed0(2);
		}
	}
	
	/**
	 * 根据交易市场，转换成行情对应的市场
	 * @param {Object} type 市场
	 */
	function getHqMarket(type){
		var SZ = ["0","1","9","A","5"];//深A、深B、特A、特B、深圳股票期权
		var SH = ["2","3","6"];//沪A、沪B、上海股票期权
		var SZhk = ["S"];
		var SHhk = ["G"];
		if(SZ.indexOf(type)!=-1){//深市
			return "SZ";
		}else if(SH.indexOf(type)!=-1){//沪市
			return "SH";
		}else if(SZhk.indexOf(type)!=-1){//深港
			return "SK";
		}else if(SHhk.indexOf(type)!=-1){//沪港
			return "HK";
		}
	}
	/**
	 * 根据交易市场，转换成上证云行情对应的市场
	 * @param {Object} type 市场
	 */
	function getSZTHqMarket(type,stock_type){
		var SZ = ["0","1","9","A","5"];//深A、深B、特A、特B、深圳股票期权
		var SH = ["2","3","6"];//沪A、沪B、上海股票期权
		var SZhk = ["S"];
		var SHhk = ["G"];
		if(stock_type === "24"){
            return "bj"; // 新三板
        }else if(stock_type === "22"){
            return "bz"; // 北交所
        }else if(SZ.indexOf(type)!=-1){//深市
			return "sz";
		}else if(SH.indexOf(type)!=-1){//沪市
			return "sh";
		}else if(SZhk.indexOf(type)!=-1){//深港
			return "hk";
		}else if(SHhk.indexOf(type)!=-1){//沪港
			return "hk";
		}
	}
		/**
	 * 根据柜台交易市场，转换成思迪内部交易市场
	 * @param {Object} type 市场
	 */
     function getThinkiveMarket(type){
      var exchangeTypeMap = {
        '0':'2',// 深A
        '1':'H',// 深B
        '2':'1',// 沪A
        '3':'D',// 沪B
        '4':'', // 3板
        '9':'9',// 特转A
        'A':'A',// 特转B
        'F1':'F1',// 郑州交易所
        'F2':'F2',// 大连交易所
        'F3':'F3',// 上海交易所
        'F4':'F4',// 金融交易所
        'G':'G',  // 沪HK  沪港通
        'S':'S',  // 深HK  深港通
      };
      return exchangeTypeMap[type];
    }
    var base = {
    	"getCurrentDate": getCurrentDate,
    	"getServerTime": getServerTime,
    	"simulationTime": simulationTime,
    	"isTradingTimes": isTradingTimes,
    	"getTradingTime": getTradingTime,
    	"initCheckTradeTimer": initCheckTradeTimer,
    	"clearCheckTradeTimer": clearCheckTradeTimer,
    	"decimalKeep": decimalKeep,
    	"getThirdStockInfo": getThirdStockInfo,
    	"getThirdNowPrice": getThirdNowPrice,
    	"getHqtypeData": getHqtypeData,
    	"getStockNowPrice" : getStockNowPrice,
    	"getStockList": getStockList,
    	"getkcbStockList":getkcbStockList,
    	"getStockListGgt": getStockListGgt,
    	"getThirdStockList":getThirdStockList,
    	"getFifthOrder": getFifthOrder,
    	"calculateStockAmount": calculateStockAmount,
    	"getOptionsFifthOrder": getOptionsFifthOrder,
    	"getBuybackList": getBuybackList,
    	"getRepurchaseDate": getRepurchaseDate,
    	"getRepurchaseDates": getRepurchaseDates,
    	"getNewThirdStockList":getNewThirdStockList,
      "getNewHqtypeData":getNewHqtypeData,
      "calculateStockAmountNew":calculateStockAmountNew,
      "getHqMarket":getHqMarket,
      "getSZTHqMarket":getSZTHqMarket,
      "getThinkiveMarket":getThinkiveMarket,
    };

    module.exports = base;
});
