/**
 * 交易模块公用 js
 */
define('trade/scripts/common/commonPosition.js', function(require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require('common');
    var service_stock = require("service_stock");
    var service_credit = require("service_credit");
    var service_option = require("service_option");
	//查询持仓的成本价
	function getPosition(paramMap, callback){
		var callParam={
			"funcNo": "80514",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("0");
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code && paramMap && paramMap.code && paramMap.market){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "password":password,
			    "stock_code":paramMap.code
			};
			service_stock.queryStockData(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
					var cost_price = "";
					for (var i = 0; i < results.length; i++){ 
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						var exchange_type = results[i].exchange_type
						if(exchange_type == 0 || exchange_type == 1)
						{
							if("SZ" == paramMap.market && results[i].stock_code == paramMap.code){
								cost_price = results[i].cost_price;
								break;
							}
						}
						else if(exchange_type == 2 || exchange_type == 3)
						{
							if("SH" == paramMap.market && results[i].stock_code == paramMap.code){
								cost_price = results[i].cost_price;
								break;
							}
						}
					}
					if(paramMap.needCallback=="true"||paramMap.needCallback==true){
						if(callback){
							callback({"cost_price":cost_price});
						}
					}else{
						callParam.cost_price=cost_price;
						$.callMessage(callParam);
					}
				}
				else{
					if(paramMap.needCallback=="true"||paramMap.needCallback==true){
						if(callback){
							callback({"cost_price":""});
						}
					}else{
						callParam.cost_price="";
						$.callMessage(callParam);
					}
				}
			},
			{"isLastReq":false,"isShowWait":false,"isGlobal":true,
			"timeOutFunc":function(){
				if(paramMap.needCallback=="true"||paramMap.needCallback==true){
					if(callback){
						callback({"cost_price":""});
					}
				}else{
					callParam.cost_price="";
					$.callMessage(callParam);
				}
			},"errorFunc":function(){
				if(paramMap.needCallback=="true"||paramMap.needCallback==true){
					if(callback){
						callback({"cost_price":""});
					}
				}else{
					callParam.cost_price="";
					$.callMessage(callParam);
				}
			}});
		}
		else{
			if(paramMap.needCallback=="true"||paramMap.needCallback==true){
				if(callback){
					callback({"cost_price":""});
				}
			}else{
				callParam.cost_price="";
				$.callMessage(callParam);
			}
		}
	}
	
	//账户总览
	function getAccountOverview(paramMap, callback){
//		common.switchingCurUser("0");
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password
			};
			service_stock.getAccountOverview(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
					optionQueryCapital(paramMap, callback , results);
				}
				else{
					optionQueryCapital(paramMap, callback , "");
				}
			},
			{"isLastReq":false,"isShowWait":false,"isGlobal":true,
			"timeOutFunc":function(){
				optionQueryCapital(paramMap, callback , "");
			},"errorFunc":function(){
				optionQueryCapital(paramMap, callback , "");
			}});
		}else{
			optionQueryCapital(paramMap, callback , "");
		}
	}
		
	/**
	 * 期权资金账户查询
	 */
	function optionQueryCapital(paramMap, callback,overviewResults){
		var callParam={
			"funcNo": "80515",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
		var callbackData={};
		//有结果
		if(overviewResults!=""&&overviewResults.length>0){
			callbackData={
				"stockResults":overviewResults,
				"optionResults":""
			}
		}else{
			callbackData={
				"stockResults":"",
				"optionResults":""
			}
		}
//		common.switchingCurUser("2");
		var userInfo = common.getCurUserInfo("2");
		if(userInfo && userInfo.cust_code){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var password = userInfo.password;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var money_type = "";  //  0：人民币，1：美元，2：港币
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "password":password,
				    "cust_code":cust_code,
				    "money_type":money_type,
				    "is_homepage":""
			};
			//最后一个为超时处理函数
			service_option.queryAssets(param,function(data){
					if(data && data.error_no == 0 && data.results && data.results.length > 0){
						var results = data.results;
						callbackData.optionResults=results;
//						if(callback){
//							callback({"data":callbackData});
//						}
						callParam.data=callbackData;
						$.callMessage(callParam);
					}
					else{
//						if(callback){
//							callback({"data":callbackData});
//						}
						callParam.data=callbackData;
						$.callMessage(callParam);
					}
				},{
				"isLastReq":true,
				"isShowWait":false,
				"isShowOverLay":false,
				"timeOutFunc":function(){//请求超时处理方法
//					if(callback){
//						callback({"data":callbackData});
//					}
					callParam.data=callbackData;
					$.callMessage(callParam);
				},"errorFunc":function(){ //断网，跨域或者网络请求错误等
//					if(callback){
//						callback({"data":callbackData});
//					}
					callParam.data=callbackData;
					$.callMessage(callParam);
			}});
		}
		else{
//			if(callback){
//				callback({"data":callbackData});
//			}
			callParam.data=callbackData;
			$.callMessage(callParam);
		}
	}

	//股基总览
	function getStockOverview(paramMap, callback){
		var callParam={
			"funcNo": "80516",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("0");
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password
			};
			service_stock.getStockOverview(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
//					if(callback){
//						callback({"data":results});
//					}
					callParam.data=results;
					$.callMessage(callParam);
				}
				else{
//					if(callback){
//						callback({"data":""});
//					}
					callParam.data="";
					$.callMessage(callParam);
				}
			},
			{"isLastReq":false,"isShowWait":false,"isGlobal":true,
			"timeOutFunc":function(){ 
				callParam.data="";
				$.callMessage(callParam);
			},"errorFunc":function(){
				callParam.data="";
				$.callMessage(callParam);
			}});
		}else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}
	
	//理财总览查询
	function getFinancialOverview(paramMap, callback){
		var callParam={
			"funcNo": "80517",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("0");
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password
			};
			service_stock.getFinancialOverview(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
//					if(callback){
//						callback({"data":results});
//					}
					callParam.data=results;
					$.callMessage(callParam);
				}
				else{
//					if(callback){
//						callback({"data":""});
//					}
					callParam.data="";
					$.callMessage(callParam);
				}
			},
			{"isLastReq":false,"isShowWait":false,"isGlobal":true,
			"timeOutFunc":function(){
				callParam.data="";
				$.callMessage(callParam);
			},"errorFunc":function(){
				callParam.data="";
				$.callMessage(callParam);
			}});
		}
		else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}
	
	
	/**
	 * 普通资金账户查询
	 */
	function getCapitalAccount(paramMap, callback){
		var callParam={
			"funcNo": "80518",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("0");
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code){//要登录之后才能请求
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var money_type = "0";  //  0：人民币，1：美元，2：港币
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
				    "money_type":money_type,
				    "is_homepage":''
			};
			
			service_stock.queryFundSelect(param,function(data){
				if (data && data!= "undefined"){
					if(data.error_no == 0){
						var results = data.results;
						if(results && results.length >0){
//							if(callback){
//								callback({"data":results});
//							}
							callParam.data=results;
							$.callMessage(callParam);
						}
					}
					else{
//						if(callback){
//							callback({"data":""});
//						}
						callParam.data="";
						$.callMessage(callParam);
					}
				}
			},{
				"isLastReq":true,
				"isShowWait":false,
				"isShowOverLay":false,
				"timeOutFunc":function(){//请求超时处理方法
					callParam.data="";
					$.callMessage(callParam);
				},"errorFunc":function(){ //断网，跨域或者网络请求错误等
					callParam.data="";
					$.callMessage(callParam);
			}});
		}else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}
	
	/**
	 * 两融资金账户查询
	 */
	function queryCapital(paramMap, callback){
		var callParam={
			"funcNo": "80519",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("1");
		var userInfo = common.getCurUserInfo("1");
		if(userInfo && userInfo.cust_code){//要登录之后才能请求
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var password = userInfo.password;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var money_type = "";  //  0：人民币，1：美元，2：港币
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "password":password,
				    "cust_code":cust_code,
				    "money_type":money_type,
				    "is_homepage":"1"
			};
			//最后一个为超时处理函数
			service_credit.liabilitiesQuery(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
//					if(callback){
//						callback({"data":results});
//					}
					callParam.data=results;
					$.callMessage(callParam);
				}
				else{
//					if(callback){
//						callback({"data":""});
//					}
					callParam.data="";
					$.callMessage(callParam);
				}
			},{  //传给接口的json格式数据            
				"isLastReq":true,"isShowWait":false,"isShowOverLay":false,
				"timeOutFunc":function(){//请求超时处理方法
					callParam.data="";
					$.callMessage(callParam);
				},"errorFunc":function(){ //断网，跨域或者网络请求错误等
					callParam.data="";
					$.callMessage(callParam);
			}});
		}else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}
	
	//	两融持仓查询
	function queryPosition(paramMap, callback){
		var callParam={
			"funcNo": "80520",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("1");
		var userInfo = common.getCurUserInfo("1");
		if(userInfo && userInfo.cust_code){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "password":password
			};
			service_credit.cc_queryPosition(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
//					if(callback){
//						callback({"data":results});
//					}
					callParam.data=results;
					$.callMessage(callParam);
				}
				else{
//					if(callback){
//						callback({"data":""});
//					}
					callParam.data="";
					$.callMessage(callParam);
				}
			},{
				"isLastReq":true,
				"isShowWait":false,
				"isShowOverLay":false,
				"timeOutFunc":function(){//请求超时处理方法
					callParam.data="";
					$.callMessage(callParam);
				},"errorFunc":function(){ //断网，跨域或者网络请求错误等
					callParam.data="";
					$.callMessage(callParam);
			}});
		}else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}


	/**
	 * 期权账户信息查询
	 */
	function queryOptionAccount(paramMap, callback){
		var callParam={
			"funcNo": "80521",
			"targetModule":"user_center",
			"sourceModule":"trade",
		}
//		common.switchingCurUser("2");
		var userInfo = common.getCurUserInfo("2");
		if(userInfo && userInfo.cust_code){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var password = userInfo.password;
			var session_id = userInfo.session_id;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "password":password,
				    "cust_code":cust_code,
				    "session_id":session_id
			};
			//最后一个为超时处理函数
			service_option.queryOptionAccount(param,function(data){
					if(data && data.error_no == 0 && data.results && data.results.length > 0){
						var results = data.results;
//						if(callback){
//							callback({"data":results});
//						}
						callParam.data=results;
						$.callMessage(callParam);
					}
					else{
//						if(callback){
//							callback({"data":""});
//						}
						callParam.data="";
						$.callMessage(callParam);
					}
				},{
				"isLastReq":true,
				"isShowWait":false,
				"isShowOverLay":false,
				"timeOutFunc":function(){//请求超时处理方法
					callParam.data="";
					$.callMessage(callParam);
				},"errorFunc":function(){ //断网，跨域或者网络请求错误等
					callParam.data="";
					$.callMessage(callParam);
			}});
		}
		else{
			callParam.data="";
			$.callMessage(callParam);
		}
	}
	
	/**
	 * 普通交易成交查询
	 */
	function stockQueryDeal(paramMap, callback){
		var userInfo = common.getCurUserInfo("0");
		if(userInfo && userInfo.cust_code){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;//
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var begin_time= paramMap.begin_date;     
			var end_time= paramMap.end_date;
//			var time1 = new Date(end_time.replaceAll("-", "/"));
//			var time2 = new Date(begin_time.replaceAll("-", "/"));
//			if(time1 < time2)
//			{
//			    $.alert("开始日期大于截止日期");
//			    return false;
//			}//截止时间
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid,
			    "stock_code":paramMap.stock_code,
			    "begin_time":begin_time,
			    "end_time":end_time
			};
			service_stock.queryHistoryTrade(param,function(data){
				if(data && data.error_no == 0 && data.results && data.results.length > 0){
					var results = data.results;
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						var buySellFlag="";
						if($.inArray(results[i].entrust_bs, ["0"]) != -1){//买入
							buySellFlag="0";
						}else if($.inArray(results[i].entrust_bs, ["1"]) != -1){//卖出
							buySellFlag="1";
						}
						results[i].buySellFlag=buySellFlag;
					}
					if(callback){
						callback(results);
					}
				}else{
					if(callback){
						callback("");
					}
				}
			},{"isLastReq":false,"isShowWait":false,"isGlobal":true,
				"timeOutFunc":function(){
					if(callback){
						callback("");
					}
		        },"errorFunc":function(){
					if(callback){
						callback("");
					}
		        }
			});
		}else{
			if(callback){
				callback("");
			}
		}
	}
	
	var base = {
    	"getPosition": getPosition,
    	"getAccountOverview":getAccountOverview,
    	"getStockOverview":getStockOverview,
    	"getFinancialOverview":getFinancialOverview,
    	"getCapitalAccount":getCapitalAccount,
    	"queryPosition":queryPosition,
    	"queryCapital":queryCapital,
    	"queryOptionAccount":queryOptionAccount,
    	"stockQueryDeal":stockQueryDeal
    };

    module.exports = base;
});