/**
 * Created by sizhe on 2016/11/25.
 */
define('trade/scripts/common/fundInsidePurchase.js', function (require, exports, module) {
    var common = require("common");
    var appropriate = require("appropriate");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_fund = require("service_fund");
    var service_stock = require("service_stock");
    var service_xkj = require("service_xkj");
    var keyboard = require("keyboard");
    require("validatorUtils");
    var validata = $.validatorUtils;
    var cacheData = {};
    var pageDomEle = {};
    var userInfo = null;
    var fundcode = null;
    var exchange_type = null;
    var _pageId = "";
    var userInfo = null;
    var operateType = 0;

    function initCashData() {
        cacheData = {
            "stockCode": "",
            "exchange_type": "",
            "price": "",
            "isSubscribe": "", // 是否在认购期
            "purchaseNum": "",
            "stock_account": "",
            "maxPurchase": "",
            "minPurchase": ""
        };
    }

    //初始化统一的页面dom节点
    function initDomEle() {
        pageDomEle = {
            "fundCode": $(_pageId + "#fundCode"),
            "fundName": $(_pageId + "#fundName"),
            "purchaseMax": $(_pageId + "#purchaseMax"),
            "purchaseNum": $(_pageId + "#purchaseNum"),
            "enableLimit": $(_pageId + ".limit em"),
            "submitBtn": $(_pageId + ".fund_form2 .ce_btn"),
            "purchasePrice": $(_pageId + "#purchasePrice"),
            "purchaseMin": $(_pageId + "#purchaseMin"),
        }
    }

    //关联对应的页面，获取初始化数据
    /**
     *
     * @param pageId
     * @param type  1 货币基金申购 2 深市lof基金申购 3沪市的场内基金
     */
    function initData(pageId, type) {
        userInfo = common.getCurUserInfo();
        _pageId = pageId;
        if (keyboard) {
            keyboard.keyInit();
        }
        initCashData();
        initDomEle();
        operateType = type;
        queryCapital();
        // 接收外链传参
        var param = $.getPageParam("param");
        fundcode = param && param.fundcode;
        exchange_type = param && param.exchange_type;
        if(fundcode){
            pageDomEle.fundCode.quzhi(fundcode);//基金名称
            getFundList(fundcode,exchange_type || '');
        }
    }

    /**
     * 资金账户查询
     */
    function queryCapital() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "0";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "money_type": money_type,
        };
        //最后一个为超时处理函数
        service_fund.queryFundSelect(param, queryCapitalCallback, {"isShowWait": false, "isShowOverLay": false});
    }

    /**
     * 查询基金是否是在认购期
     */
    function getFundBaseInfo(subscribeCode){
        var param = {
            "subscribeCode": subscribeCode,
        };
        //最后一个为超时处理函数
        service_xkj.getFundBaseInfo(param, function(data){
            var results = data.results;
            if( data.error_no == 0 && results.fundStatus === '2'){
                cacheData.isSubscribe = true;
            }else{
                cacheData.isSubscribe = false;
            }
        }, {"isShowWait": false, "isShowOverLay": false});
    }

    /**
     * 资金账户查询回调
     */
    function queryCapitalCallback(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results[0]) {
                    pageDomEle.enableLimit.text(Number(results[0].enable_balance).toFixed(2));//可用
                } else {
                    pageDomEle.enableLimit.text("--");//可用
                }
            } else {
                $.alert(data.error_info);
            }
        }
    }

    //页面事件绑定
    function bindEvent() {
        //股票代码输入框监听
        $.bindEvent(pageDomEle.fundCode, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var fundCode = $.trim($(this).val());
            if (fundCode.length == 6) {
                getFundList(fundCode);
            } else {
                clearMsg();
            }
            e.stopPropagation();
        }, "input");

        //申购数量输入
        $.bindEvent(pageDomEle.purchaseNum, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            e.stopPropagation();
        }, 'input');

        //申购
        $.bindEvent(pageDomEle.submitBtn, function (e) {
            //埋点
            var objectId = $(_pageId + "#submit").attr("objectId");
            var actionId = $(_pageId + "#submit").attr("actionId");
            var name = $(_pageId + "#submit").attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            cacheData.purchaseNum = pageDomEle.purchaseNum.val();
            vailSubmitOrder();
            // e.stopPropagation();
        });
    }

    function getFundList(fundStr, exchangeType) {
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
        if (fundStr != "" && fundStr.length == 6) {
            clearMsg();
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var stock_code = fundStr;
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var cust_code = userInfo.cust_code;//关联资产账户标志
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "stock_code": stock_code,
                "entrust_bs": "0",
                "exchange_type": exchangeType,
            };
            service_stock.queryStockMaxBuy(param, getFundInfoBack);
        }
    }

    function getFundInfoBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length == 1) {
                if ($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
                $(_pageId + "#fund_stock_list").html("");
                //限制深市沪市基金买入
                // if(operateType==2){
                //     if(results[0].exchange_type!="0"&&results[0].exchange_type!="1"){
                //         $.alert("选择股票市场类型不对");
                //         return false;
                //     }
                // }
                // if(operateType==3){
                //     if(results[0].exchange_type!="2"&&results[0].exchange_type!="3"){
                //         $.alert("选择股票市场类型不对");
                //         return false;
                //     }
                // }
                cacheData.exchange_type = results[0].exchange_type;
                cacheData.price = results[0].price;
                cacheData.fundCode = results[0].stock_code;
                cacheData.stock_account = results[0].stock_account;
                cacheData.maxPurchase = Number(results[0].stock_max_amount);
                cacheData.minPurchase = Number(results[0].low_amout);

                pageDomEle.fundName.val(results[0].stock_name);
                pageDomEle.purchaseMax.val(results[0].stock_max_amount);
                if (results[0].low_amount == "0.00") {
                    pageDomEle.purchaseMin.val("--");
                } else {
                    pageDomEle.purchaseMin.val(results[0].low_amount || "--");
                }

                pageDomEle.purchasePrice.val(results[0].price);

                getFundBaseInfo(cacheData.fundCode);

                // $(_pageId+"#fundMarketVal").val(nav);
            } else if (results && results.length > 0) {
                var selectHeight = 0.44 * results.length;
                if (results.length >= 5) {
                    selectHeight = 5 * 0.44;
                }
                var html = '<ul style="height:' + selectHeight + 'rem">';
                for (var i = 0; i < results.length; i++) {
                    if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                    html += '<li>';
                    html += '<a href="javascript:void(0);">';
                    html += '<strong>' + results[i].stock_code + '</strong>' + results[i].stock_name + '</a>';
                    html += '<span style="display:none;">' + results[i].exchange_type + '</span>';
                    html += '</li>';
                }
                html += '</ul>';
                $(_pageId + "#fund_stock_list").html(html);
                $.bindEvent($(_pageId + "#fund_stock_list ul li"), function (e) {
                    var exchangeType = $(this).find("span").text();
                    var fundCode = $(this).find("strong").text();
                    getFundList(fundCode, exchangeType);
                    e.stopPropagation();
                });
            } else {
                $.alert("没有查询到对应的基金");
            }
        } else {
            $.alert(data.error_info);
        }
    }


    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        //验证基金代码输入是否正确
        var buy_stockCode = $.trim(pageDomEle.fundCode.val());
        if (!buy_stockCode || buy_stockCode.length == 0) {
            $.alert("请输入基金代码");
            return false;
        }
        if (buy_stockCode && buy_stockCode.length != 6) {
            $.alert("基金代码输入错误");
            return false;
        }
        //验证基金申购数量输入是否正确
        var now_price = cacheData.purchaseNum;
        if (now_price && $.trim(now_price).length <= 0) {
            $.alert("请输入申购数量");
            return false;
        } else if (now_price == "0") {
            $.alert("申购数量不能为0");
            return false;
        } else if (!validata.isNumberFloat(now_price) || parseFloat(now_price) < 0) {
            $.alert("请正确输入申购数量");
            return false;
        }
        // else if(Number(now_price)>Number(cacheData.maxPurchase)){
        //     $.alert("申购数量超过可用数量");
        //     return false;
        // }
        var tipStrArray = [];
        tipStrArray.push(["基金名称", $(_pageId + " #fundName").val()]);
        tipStrArray.push(["基金代码 ", buy_stockCode]);
        if(cacheData.isSubscribe){
            tipStrArray.push(["认购数量 ", now_price]);
        }else{
            tipStrArray.push(["申购数量 ", now_price]);
        }
        var tipStr = "<div >";
        tipStr += common.generatePrompt(tipStrArray, "", "list");
        tipStr += "</div>";

        //埋点数据
        var comStatParam = {
            "objectId": $(_pageId + ".ce_btn").attr("objectId"),
            "actionId": $(_pageId + ".ce_btn").attr("actionId"),
            "i_entrust_bs": "", // 交易方向( 1,买入 2,卖出)
            "i_stock_code": buy_stockCode, // 股票代码
            "i_stock_name": $(_pageId + " #fundName").val(), // 股票名称
            "i_entrust_prop": "", // 委托属性
            "i_exchange_type": cacheData.exchange_type, // 交易市场
            "i_entrust_price": price, // 选择后的价格
            "i_entrust_amount": balance, // 委托数量
        }
//      common.iConfirm("下单确定",tipStr,function success(){
        var cust_code = userInfo.cust_code;	//客户代码
        var fund_account = userInfo.fund_account;	//资产账户
        var branch_no = userInfo.branch_no;	//分支机构
        var sessionid = userInfo.sessionid;
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var stock_code = buy_stockCode;
        var stock_account = cacheData.stock_account;
        var balance = now_price;
        var price = cacheData.price;
        var business_type = "1";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_code": stock_code,
            "fund_name": $(_pageId + " #fundName").val(),
            "entrust_amount": balance,
            "exchange_type": cacheData.exchange_type,
            "entrust_price": price,
            "business_type": business_type,
            "stock_account": stock_account
        };
        if(cacheData.isSubscribe){
            param.entrust_prop = '0';
        }
        appropriate.placeOrder(comStatParam, param, tipStr, function (instr_batch_no) {
            param.instr_batch_no = instr_batch_no;
            if (operateType == 1) {
                service_fund.venueMonetaryPurchase(param, getBuyCallBack, {
                    "isLastReq": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    }, "errorFunc": function () {
                        $.hidePreloader();
                    }
                });
                $.showPreloaders("请等待...");
            } else {
                service_fund.insideLofFundPurchase(param, getBuyCallBack, {
                    "isLastReq": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    }, "errorFunc": function () {
                        $.hidePreloader();
                    }
                });
                $.showPreloaders("请等待...");
            }
        });
        // }else if(operateType==2){
        //     service_fund.insideLofFundPurchase(param,getBuyCallBack);
        // }else if(operateType==3){
        //     service_fund.insideLofFundPurchase(param,getBuyCallBack);
        // }
//      },function fail(){
//      });
        $(_pageId + "#newTradingTipsBox2 ._content .table_tips_list tr td:eq(0)").css({"min-width": "25%"});
    }

    //申购回调
    function getBuyCallBack(data, param) {
        $.hidePreloader();
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                if(cacheData.isSubscribe){
                    $.alert("认购成功，合同号：" + results[0].entrust_no);
                }else{
                    $.alert("申购成功，合同号：" + results[0].entrust_no);
                }
                clearMsg();
                pageDomEle.fundCode.quzhi("");
                queryCapital();
                appropriate.function399931({serial_no: results[0].entrust_no});
            }
        } else {
            $.alert(data.error_info);
        }
    }


    function clearMsg() {
        $(_pageId + "#fund_stock_list").html("");
        initCashData();
        pageDomEle.fundName.val("");
        pageDomEle.purchaseMax.val("");
        pageDomEle.purchasePrice.val("");
        pageDomEle.purchaseNum.quzhi("");
        pageDomEle.purchaseMin.quzhi("");
    }

    function destoryData() {
        //IOS休眠后唤起pageDomEle为空
        initDomEle();
        clearMsg();
        pageDomEle.fundCode.quzhi("");
        if (keyboard) {
            keyboard.keyDestroy();
        }
        userInfo = null;
        operateType = 0;
    }

    var base = {
        "initData": initData,
        "bindEvent": bindEvent,
        "destoryData": destoryData
    }

    module.exports = base;
});
