/**
 * Created by sizhe on 2016/11/25.
 */
define('trade/scripts/common/fundInsideRedeem.js', function (require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_fund = require("service_fund");
    var service_stock = require("service_stock");
    var keyboard = require("keyboard");
    require("validatorUtils");
    var validata = $.validatorUtils;
    var cacheData = {};
    var pageDomEle = {};
    var _pageId = "";
    var userInfo = null;
    var operateType = 0;
    var listData = null;
    var price_digit = 3;
    var result;

    function initCashData() {
        cacheData = {
            //           "stockCode":"",
            "selectFund": "",
            "exchange_type": "",
            "price": "",
            "redeemNum": "",
            "stock_account": "",
            "maxRedeem": "",
            "fundCode": ""
        };
    }

    //初始化统一的页面dom节点
    function initDomEle() {
        pageDomEle = {
            //           "stockCode":$(_pageId+" .select_box p"),
            "selectFund": $(_pageId + ".select_fund"),
            "fundName": $(_pageId + "#fundName"),
            "redeemMax": $(_pageId + "#redeemMax"),
            "redeemNum": $(_pageId + "#redeemNum"),
            "fundPrice": $(_pageId + "#fundPrice"),
            "submitBtn": $(_pageId + ".fund_form2 .ce_btn"),
            "fundCode": $(_pageId + "#fundCode")
        }
    }

    //关联对应的页面，获取初始化数据
    /**
     *
     * @param pageId
     * @param type  1 货币基金赎回 2 深市lof基金赎回 3沪市的场内基金
     */
    function initData(pageId, type) {
        userInfo = common.getCurUserInfo();
        _pageId = pageId;
        if (keyboard) {
            keyboard.keyInit();
        }
        initCashData();
        initDomEle();
        $(_pageId + ".select_fund").css("display", "none");
        operateType = type;
        queryHoldingsQuery();
    }

    function queryHoldingsQuery() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = "";
        var fund_company = "";
        var fund_code = "";
        var exchange_type = "";
        var filt_flag = "1";
        // if(operateType==2){
        //     exchange_type="0";
        //     filt_flag="1";
        // }
        // else if(operateType==3){
        //     exchange_type="2";
        //     filt_flag="1";
        // }
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "fund_company": fund_company,
            "fund_code": fund_code,
            "exchange_type": exchange_type,
            "filt_flag": filt_flag
        };
        service_stock.queryStockData(param, queryFundDataCallback, {
            "timeOutFunc": bindGetEnableRedeemList,
            "errorFunc": bindGetEnableRedeemList
        });
    }

    //持仓查询回调方法
    function queryFundDataCallback(data) {
        if (data) {
            if (data.error_no == 0) {
                $(pageDomEle.selectFund).css("display", "block");
                results = data.results;
                if (results && results.length > 0) {
                    listData = {};
                    var listDiv = "<div class='bank_list center1 multi_list'>";
                    listDiv += "<div class='top'><p style='width:25%;font-size: 0.14rem;'>证券代码</p><p style='width:25%;font-size: 0.14rem;'>证券名称</p><p style='width:25%;font-size: 0.14rem;'>证券数量</p><p style='width:25%;font-size: 0.14rem;'>可卖数量</p></div>";
                    listDiv += "<ul>";
//					listDiv += "<li ><a href=\"javascript:void(0);\" style='display:table;width:100%'><em style='width:25%;display:table-cell'>证券代码</em><em style='width:25%;display:table-cell'>证券名称</em><em style='width:25%;display:table-cell'>证券数量</em><em style='width:25%;display:table-cell'>可卖数量</em></a></li>"
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        listData[results[i].stock_code + "" + results[i].exchange_type] = results[i];
                        listDiv += "<li id='" + results[i].stock_code + "" + results[i].exchange_type + "'><a href=\"javascript:void(0);\"style='display:table;width:100%'><em style=width:25%;display:table-cell>" + results[i].stock_code + "</em><span style='width:25%;display:table-cell;zoom:" + $.getTransformScale(results[i].stock_name, 16, $(window).width() * 0.23) + ";'>" + results[i].stock_name + "</span><span style='width:25%;display:table-cell'>" + results[i].cost_amount + "</span><span style='width:25%;display:table-cell'>" + results[i].enable_amount + "</span></a></li>";
                    }
                    listDiv += "</ul></div>";
                    //埋点参数
                    var buriedPointParam = {
                        "backObjectId": pageDomEle.selectFund.attr("backObjectId"),
                        "backActionId": pageDomEle.selectFund.attr("backActionId"),
                        "backParamMap": {
                            "i_group_name": pageDomEle.selectFund.attr("backName"),
                        },
                        "pageObjectId2": $(_pageId).attr("pageObjectId2"),
                        "pageObjectId1": $(_pageId).attr("pageObjectId1"),
                    }
                    common.addChoiceList(pageDomEle.selectFund, "选择赎回基金代码", listDiv, function (data, div) {
                        //       div.html(data.find("a small").text());
                        //埋点
                        var objectId = pageDomEle.selectFund.attr("objectId");
                        var actionId = pageDomEle.selectFund.attr("actionId");
                        common.comStat(objectId, 2, actionId, true, {"i_group_name": "选择可赎回基金"});
                        var id = data.attr("id");
                        var fundInfo = listData[id];
                        cacheData.fundCode = fundInfo.stock_code;
                        cacheData.stock_account = fundInfo.stock_account;
                        cacheData.exchange_type = fundInfo.exchange_type;
                        cacheData.price = fundInfo.last_price;
                        cacheData.maxRedeem = Number(fundInfo.enable_amount);
                        pageDomEle.fundCode.quzhi(fundInfo.stock_code);
                        pageDomEle.fundName.val(fundInfo.stock_name);
                        pageDomEle.fundPrice.val(Number(fundInfo.last_price || 0).toFixed(price_digit));
                        pageDomEle.redeemMax.val(Number(fundInfo.enable_amount));
                    }, null, null, keyboard, buriedPointParam);
                } else {
                    pageDomEle.fundCode.quzhi("暂无可赎回基金");
                }
            } else {
                $.alert(data.error_info);
                //重新绑定事件
                bindGetEnableRedeemList();
                $(_pageId + ".select_fund").css("display", "block");
            }
        }
    }

    function bindGetEnableRedeemList() {
        $.bindEvent($(_pageId + "#fund_code"), function (e) {
            $(this).unbind();
            queryHoldingsQuery();
            e.stopPropagation();
        });
    }

    //查询基金信息通过基金代码
    function queryFundInfoByCode(fundCode) {
        if (keyboard) {
            keyboard.closeKeyPanel();
        }
        var i;
        for (i = 0; i < results.length; i++) {
            if (results[i].stock_code == fundCode) {
                cacheData.fundCode = results[i].stock_code;
                cacheData.stock_account = results[i].stock_account;
                cacheData.exchange_type = results[i].exchange_type;
                cacheData.price = results[i].last_price;
                cacheData.maxRedeem = Number(results[i].enable_amount);
                pageDomEle.fundCode.quzhi(results[i].stock_code);
                pageDomEle.fundName.val(results[i].stock_name);
                pageDomEle.fundPrice.val(Number(results[i].last_price || 0).toFixed(price_digit));
                pageDomEle.redeemMax.val(Number(results[i].enable_amount));
                break;
            }
        }
        if (i == results.length) {
            pageDomEle.fundCode.quzhi("");
            common.singleIConfirm("温馨提示","无该基金可赎回份额");
            // $.alert("无该基金可赎回份额");
            return false;
        }

    }

    //页面事件绑定
    function bindEvent() {
        //代码框输入
        $.bindEvent(pageDomEle.fundCode, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var fundCode = $.trim($(this).val());
            if (fundCode.length == 6) {
                queryFundInfoByCode(fundCode);
            } else {
                pageDomEle.fundName.quzhi("");
                pageDomEle.fundPrice.val("");
                pageDomEle.redeemMax.val("");
                pageDomEle.redeemNum.val("");
            }

            e.stopPropagation();
        }, "input");
        //赎回数量输入
        $.bindEvent(pageDomEle.redeemNum, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            e.stopPropagation();
        }, 'input');

        //申购
        $.bindEvent(pageDomEle.submitBtn, function (e) {
            //埋点
            var objectId = $(_pageId + "#submit").attr("objectId");
            var actionId = $(_pageId + "#submit").attr("actionId");
            var name = $(_pageId + "#submit").attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            cacheData.redeemNum = pageDomEle.redeemNum.val();
            vailSubmitOrder();
            // e.stopPropagation();
        });
    }

    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        //验证基金代码输入是否正确
        var buy_stockCode = $.trim(pageDomEle.fundCode.val());
        if (!buy_stockCode || buy_stockCode.length == 0) {
            $.alert("请选择基金代码");
            return false;
        }
        if (buy_stockCode.length != 6) {
            $.alert("基金代码错误");
            return false;
        }
        //验证基金份额输入是否正确
        var now_price = pageDomEle.redeemNum.val();
        var can_buy = pageDomEle.redeemMax.val();
        if ($.trim(now_price).length <= 0) {
            $.alert("请输入赎回数量");
            return false;
        } else if (now_price == "0") {
            $.alert("赎回数量不能为0");
            return false;
        } else if (!validata.isNumberFloat(now_price) || parseFloat(now_price) < 0) {
            $.alert("请正确输入赎回数量");
            return false;
        }
        // else if(Number(now_price) > Number(can_buy)) {
        // 	$.alert("赎回数量超过可赎回数量");
        // 	return false;
        // }
        var tipStrArray = [];
        tipStrArray.push(["基金名称", $(_pageId + " #fundName").val()]);
        tipStrArray.push(["基金代码 ", buy_stockCode]);
        tipStrArray.push(["赎回数量 ", now_price]);
        var tipStr = "<div >";
        tipStr += common.generatePrompt(tipStrArray);
        tipStr += "</div>";
        //埋点数据
        var comStatParam = {
            "i_entrust_bs": "", // 交易方向( 1,买入 2,卖出)
            "i_stock_code": buy_stockCode, // 股票代码
            "i_stock_name": $(_pageId + " #fundName").val(), // 股票名称
            "i_entrust_prop": "", // 委托属性
            "i_exchange_type": cacheData.exchange_type, // 交易市场
            "i_entrust_price": cacheData.price, // 选择后的价格
            "i_entrust_amount": now_price, // 委托数量
        }
        var objectId = $(_pageId + ".ce_btn").attr("objectId");
        var actionId = $(_pageId + ".ce_btn").attr("actionId");
        common.iConfirm("下单确定", tipStr, function success() {
            var cust_code = userInfo.cust_code; //客户代码
            var fund_account = userInfo.fund_account; //资产账户
            var branch_no = userInfo.branch_no; //分支机构
            var sessionid = userInfo.sessionid;
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var stock_code = buy_stockCode;
            var entrust_amount = now_price;
            var exchange_type = cacheData.exchange_type;
            var stock_account = cacheData.stock_account;
            var entrust_price = cacheData.price;
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "sessionid": sessionid,
                "stock_code": stock_code,
                "exchange_type": exchange_type,
                "entrust_amount": entrust_amount,
                "stock_account": stock_account,
                "entrust_price": entrust_price
            };
            if (operateType == 1) {
                service_fund.venueMonetaryRedemption(param, getBuyCallBack);
                comStatParam.i_oper = "1"; // 动作（1确定 2取消）
                common.comStat(objectId, 2, actionId, false, comStatParam);
            } else {
                service_fund.insideLofFundRedeem(param, getBuyCallBack);
                comStatParam.i_oper = "2"; // 动作（1确定 2取消）
                common.comStat(objectId, 2, actionId, false, comStatParam);
            }
            // }else if(operateType==2){
            //     service_fund.insideLofFundRedeem(param,getBuyCallBack);
            // }else if(operateType==3){
            //     service_fund.insideLofFundRedeem(param,getBuyCallBack);
            // }

        }, function fail() {

        });
        //添加弹出框样式适应此处基金名称过长的情况
        $(_pageId + "#newTradingTipsBox2 ._content .table_tips_list tr td:eq(0)").css({"min-width": "25%"});
    }

    //赎回回调
    function getBuyCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                $.alert("赎回成功，合同号：" + results[0].entrust_no);
            }

        } else {
            $.alert(data.error_info);
        }
        clearMsg();
        queryHoldingsQuery();
    }

    function clearMsg() {
        initCashData();
        pageDomEle.fundName.val("");
        pageDomEle.redeemMax.val("");
        pageDomEle.fundPrice.val("");
        pageDomEle.redeemNum.quzhi("");
        pageDomEle.fundCode.quzhi("")
        pageDomEle.selectFund.text("选择");

    }

    function destoryData() {
        clearMsg();
        initDomEle();
        if (keyboard) {
            keyboard.keyDestroy();
        }
        userInfo = null;
        operateType = 0;
        listData = null;
        pageDomEle.selectFund.unbind();
    }

    var base = {
        "initData": initData,
        "bindEvent": bindEvent,
        "destoryData": destoryData
    }

    module.exports = base;
});