/**
 * 交易下单
 */
define('trade/scripts/common/ggtOrder.js',function(require, exports, module) {
	var common = require("common");
	var appropriate = require("appropriate");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var service_ggt = require("service_ggt");
	var service_hq = require("service_hq");
	if(global.hqCallInterface == 1){
		service_hq = require("service_hqTrade");
	}
	var keyboard = require("keyboard");
	var hqKt = require("minLines");
	var canvasJs = require("canvasJs");

    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var fifthOrder_timer = null;//五档行情定时器
    var position_timer = null;
    var _pageId = null;
    var _orderType = null;
    var comStatParam={};
    var isHold = "0"; // 是否从持仓点击进入买卖界面 1代表是
	var orderName = { // 委托名称
		"1":"委托买入",
		"2":"委托卖出",
		"3":"零股卖出",
	};
	var market_html_data = [
		{"name":"增强限价盘","id":"0"},
		{"name":"竞价限价盘","id":"1"}
	]
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _initScroller = null;
	var _myScroller = null;
	var jsonMarket = {"G": "HK","S":"SK"};
	var typeList = {"G":"99","S":"98"};
    var queryStockHqFlowNo;
    var pageGlobal = {
    	"holdData": ""
	};

	/**
	 * 设置股票对象是信息参数
	 */
	function ioitStock(){
		var stockInfo = {
	    	"stockCode" : "", // 股票代码
	    	"stockName" : "", // 股票名称
	    	"stockPrice" : "",// 股票价格
	    	"stockNum" : "",
	    	"exchange_rate": "",//汇率
	    	"up_price" : 0, //加价
	    	"down_price" : 0,//减价
	    	"stockMaxAmount" : 0,//股票最大数
	    	"surplus_quota" : 0,
			"price_digit" : 3, // 小数点位数
			"lot_size" : 100, //每手数量
			"stock_type" : "",//股票类型
			"stock_market" : "",//市场代码
			"gear_one" : false,//是否启动五档
			"exchange_type" : "",//交易市场（交易后台）
			"stock_account" : "",// 股东账号 
	    };
	    return stockInfo;
	}
	
	function initHtml(){
		stock_html = {
	    	"stockCode" : $(_pageId + " #stockCode"), // 股票
	    	"stockList" : $(_pageId+" #stock_list"),
	    	"stockName" : $(_pageId + " #stockCode").next("span"), // 股票名称
	    	"stockPrice" : $(_pageId + " #stockPrice"),// 股票价格
	    	"stockNum" : $(_pageId + " #stockNum"), // 股票数量
	    	"exchange_rate" : $(_pageId + " #exchange_rate"), //汇率
	    	"surplus_quota": $(_pageId + " #surplus_quota"),
	    	"lot_size" : $(_pageId + " #each_hand"),//每手数量
	    	"stockMaxAmount": $(_pageId + " #maxNumber"),//股票最大数
	    	"buyGear" : $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
		   	"sellGear" : $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
		   	"total" : $(_pageId + " #total"),// 计算金额显示
			"market_div" : $(_pageId+" .trade_form .value_btn"), // 委托方式
			"market_div": $(_pageId + " #entrustWay"), // 委托方式
			"market_p": $(_pageId + " #entrustWay p"),
			"hqCanvas": $(_pageId + " .kcb_timeshare"),
			"hqxltb": $(_pageId + " .hqxltb i"),
			"label_g": $(_pageId + " .select_box .label_g"),
		}
	}
	

    /**
     * 数据初始化
     */
	function dataInit(pageId,orderType,initScroller,myScroller){
		$(pageId+".position_div thead th").each(function(idx, item){
			var zoom = 1;
			$(item).css({"zoom": zoom, "line-height": 0.2/zoom + "rem;" });
		});
		$(pageId+".position_div thead th").each(function(idx, item){
			var zoom = $.getTransformScale($(item).text(), 14, ($(window).width()) * 0.25 - 15)
			$(item).css({"zoom": zoom, "line-height": 0.2/zoom + "rem;" });
		});
		_initScroller = initScroller;
		_myScroller = myScroller
		_pageId = pageId;
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		_orderType = orderType;
		stock_info = ioitStock();
		initHtml();
		_stockCode = null;
		commonFunc.initCheckTradeTimer();
		var stockCode = $.getPageParam("code");
		isHold = $.getPageParam("isHold");
		// 查询个股行情
		if(stockCode){
			$(_pageId + " #stockCode").removeClass("C100");
			$(_pageId + " #stockCode").quzhi(stockCode);
			var market = $.getPageParam("market");
			var stock_account = $.getPageParam("stock_account");
			var exchange_type = $.getPageParam("exchange_type");
			stock_info.exchange_type=exchange_type;
			stock_info.stock_account=stock_account;
			getStockList(stockCode,market,exchange_type,stock_account);
		}else{
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});
		}
		queryHolding();
		
    }
	
	function isBuy(){
		if(_orderType == "1"){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * 获取股票信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			var data = stock_html[param].quzhi();
	//		var data = stock_html[param].val() || stock_html[param].text();
			if(newest && stock_info){
				if(!data || data == "--"){
					stock_info[param] = 0;
				}
				else
				{
					stock_info[param] = data;
				}
			}
			return data;
		}
		else{
			return '';
		}
	}
	
	/**
	 * 设置股票信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest){
		if(stock_html){
		stock_html[key].quzhi(value);
		if(key == "stockName"){
			//股票名称长度过长缩放
			var maxWidth = (stock_html[key].parent().width() / 2)-6;
			var zoomValue = $.getMaxFontSize(value,"0.16rem", maxWidth);
			stock_html[key].css({"transform":"scale(" + zoomValue + ")","white-space": "nowrap","transform-origin":"left center"});
		}
//		stock_html[key].val(value);
//		stock_html[key].text(value);
			if(newest && stock_info){
				if(value == "--"){
					value = 0;
				}
				stock_info[key] = value;
			}
		}
	}
	
	
	/**
	 * 
	 * @param {Object} stockPrice
	 */
	function isQueryMax(stockPrice){
//		if((isBuy() || !stock_info.exchange_type) && stock_info.stockCode && stockPrice && stockPrice != "0"){
		if(stock_info.stockCode && stockPrice && stockPrice != "0"){
			queryMaxAmount(stock_info.stockCode,true);
		}
	}
	/**
	 * 事件绑定
	 */
	function elementBindEvent(){
		//jw-add 返回行情
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			var objectId=$(this).attr("objectId");
			var actionId=$(this).attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_group_name":"返回"});
			var pageCode = $.getCurrentPageObj().pageCode || '';
			if(global.callNative){
				if($.getPageParam("isFromApp")){
//					var param = $.getPageParam();
					//ios切换行情
					$.callMessage({
						"funcNo": "50500",
						"msgNo": "205",
						"sourceModule":"trade",
						"targetModule":"app",
						"action":"4",
						"param":{}
					});
					$.pageInit(pageCode,"account/index",{"history":true},"left",true);
				}else{
					if(pageCode == "ggt/ggtZero"){
						$.pageBack();
					}else{
						$.pageInit(pageCode,"account/index",{"history":true},"left",true);
					}			
				}
			}else{
				if(pageCode == "ggt/ggtZero"){
					$.pageBack();
				}else{
					$.pageInit(pageCode,"account/index",{"history":true},"left",true);
				}				
			}
			e.stopPropagation();
			e.preventDefault();
		});
		
		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");
		
		$.bindEvent($(_pageId+" .trade_form .input_code .input_text"), function(e){
			var click = e.type || "click";
//			if(keyboard){
//				$(_pageId + " div#stockCode").triggerFastClick();
//			}
//			else{
//				$(_pageId + " #stockCode").triggerFastClick();
//				$(_pageId + " #stockCode").focus();
//			}
			e.stopPropagation();
		});
		$.bindEvent($(_pageId+" .trade_form .input_code .input_text span"), function(e){//输入时股票代码调键盘
			var click = e.type || "click";
			if(keyboard){
				$(_pageId + " div#stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			else{
				$(_pageId + " #stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			e.stopPropagation();
		});
		
		if(!keyboard){
			$.bindEvent($(_pageId + "#stockCode"), function(e){
				e.stopPropagation();
			});
		}
		
		// 股票代码输入框监听
		$.bindEvent($(_pageId + " #stockCode"), function(e){ // 该监听方法是为了适配浏览器
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			else{
				var stockCode = $(this).val();
				stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g,"");
				stockCode = $.trim(stockCode);
				$(this).val(stockCode);
			}
			var stockCode = $(_pageId + " #stockCode").val();
			//控制股票代码输入，字母控制4位，数字6位
			if(stockCode.length > 4){
				var vai1 = /^[0-9]+$/;
				if(!vai1.test(stockCode)){
					stockCode = stockCode.substring(0,4);
					$(_pageId + " #stockCode").quzhi(stockCode);
				}
			}
			if(stockCode.length == 0){
				clearBuyMsg();
				$(_pageId + " #stockCode").addClass("C100");
			}
			else{
				$(_pageId + " #stockCode").removeClass("C100");
			}
			if(stockCode){
				if(stockCode != _stockCode){
					_stockCode = stockCode;
					clearBuyMsg();
					var vai0 = /^[A-Za-z]+$/;
					var vai1 = /^[\u4e00-\u9fa5]+$/;
					if(stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))){ // 当输入的长度大于1 并且为字母的时候
						getStockList(stockCode); // 查询股票列表
					}else if(stockCode.length > 2){ // 当输入的长度大于3的时候
						getStockList(stockCode); // 查询股票列表
					}
				}
			}
			e.stopPropagation();
		},"input");
		
		//数量输入
		$.bindEvent($(_pageId + " #stockNum"),function(e){
			if(keyboard){
				var key = "";
				if(!global.callNative){
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d3" || key == "-12"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d2" || key == "-13"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d1" || key == "-14"){
					var num = stock_info.stockMaxAmount;
					setStockInfo("stockNum",num+"");
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
            $(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			e.stopPropagation();
		},"input");
		
		//数量输入埋点
		$.bindEvent($(_pageId + "#stockNum"),function(e){
			var stockNum = $(_pageId + "#stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			if(stock_info && stock_info.stockCode && stockPrice && stockPrice != "0"){
				var objectId = $(this).attr("objectId") ;
				var actionId = $(this).attr("actionId") ;
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":(isBuy() ? "1" : "2"), // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":"", // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"blur");
		
		// 价格输入框
		$.bindEvent($(_pageId + " #stockPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			limitingDigit($(this));
			e.stopPropagation();
		},"input");
		
		// 价格输入框失去焦点
		$.bindEvent($(_pageId + " #stockPrice"), function(e){
			var stockNum = getStockInfo("stockNum");
			var stockPrice = $(_pageId + " #stockPrice").val();
			if(stock_info && stockPrice && stockPrice != "0"){
				totalValue(stockPrice,stockNum);
				isQueryMax(stockPrice);
				
				//埋点
				if(stock_info.stockCode && stockPrice && stockPrice != "0"){
					var objectId = $(this).attr('objectId') ;
					var actionId = $(this).attr('actionId');
					common.comStat(objectId,2,actionId,false,{
						"i_entrust_bs":(isBuy() ? "1" : "2"), // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":"", // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}
			e.stopPropagation();
		},"blur");
		
		// 增加价格
		$.bindEvent($(_pageId + " .kcb_trade_main .input_select .add"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",0);
					return false;
				}
				stockPrice = Number(stockPrice);  
				if(stockPrice >= 0 && stockPrice < 999999999){
					stockPrice = (parseFloat(stockPrice)+parseFloat(stock_info.up_price)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请先输入股票代码");
			}
			
			//埋点
			var objectId = $(this).attr("objectId");
			var actionId = $(this).attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_group_name": "增加价格" });
			e.stopPropagation();
		});
		
		// 减少价格
		$.bindEvent($(_pageId + " .kcb_trade_main .input_select .less"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",0);
					return false;
				}
				var price_step = stock_info.down_price;
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0){
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请先输入股票代码");
			}
			//埋点
			var objectId = $(this).attr("objectId");
			var actionId = $(this).attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_group_name": "减少价格" });
			e.stopPropagation();
		});
		
		// 五档买卖盘联动
		$.bindEvent($(_pageId + " .five_box ul li"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).find("span").text();
			if(curPrice && curPrice != "--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",curPrice);			
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice,stockNum);
				isQueryMax(stockPrice);
				
				//埋点
				if(stock_info && stock_info.stockCode){
					var objectId = $(_pageId + ".five_box").attr("objectId");
					var actionId = $(_pageId + ".five_box").attr("actionId"); 
					common.comStat(objectId,2,actionId,false,{
						"i_entrust_bs":(isBuy() ? "1" : "2"), // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":"", // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":curPrice, // 选择后的价格
						"i_adjust_type":(isBuy() ? "3" : "4"), // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}
			e.stopPropagation();
		});
		// 下单
		$.bindEvent($(_pageId + " #submitOrder"),function(e){
			//埋点
			var objectId = $(this).attr("objectId");
			var actionId = $(this).attr("actionId");
			var name = $(this).attr("name");
			common.comStat(objectId,2,actionId,true,{"i_group_name": name });
			vailSubmitOrder();
		});
		
		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " .five_box ul li").removeClass("active");
			if(stock_html){
				stock_html.stockList.hide();
			}
			e.stopPropagation();
		});
		
		//委托类型绑定事件
		$.bindEvent($(_pageId+" .value_btn a"),function(e){
			$(this).addClass("current").siblings().removeClass("current");
			var id = $(this).attr("id");
			if(stock_html){
				stock_html.market_div.attr("value",id);
			}
			
			//埋点
			var objectId = $(this).attr("objectId");
			var actionId = $(this).attr("actionId");
			var name = $(this).html();
			common.comStat(objectId,2,actionId,true,{"i_group_name": name });
			e.stopPropagation();
		})
		
		// 刷新
		$.bindEvent($(_pageId + ".icon_refresh"), function(e){
			$.showRightTopPreloaders();
			setFifthOrder();
			queryHolding();
			e.stopPropagation();
		});

		// 增加数量
		$.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".add"), function (e) {
			$.closeModal(".picker-modal.modal-in");
			if (keyboard) {
				keyboard.closeKeyPanel();
			}
			if (stock_info && stock_info.stockCode) {
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum") || "0";
				if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
					setStockInfo("stockNum", 0);
					return false;
				}
				stockNum = Number(stockNum) + stock_info.lot_size;
				setStockInfo("stockNum", stockNum);
				totalValue(stockPrice, stockNum);
				$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			} else {
				$.alert("请输入正确的证券代码/简称");
			}
			e.stopPropagation();
		});

		// 减少数量
		$.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".less"), function (e) {
			$.closeModal(".picker-modal.modal-in");
			if (keyboard) {
				keyboard.closeKeyPanel();
			}
			if (stock_info && stock_info.stockCode) {
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum");
				if (!stockNum || !validatorUtil.isNumberFloat(stockNum)) {
					setStockInfo("stockNum", 0);
					return false;
				}
				stockNum = Number(stockNum) - stock_info.lot_size;
				if (stockNum < 0) stockNum = 0;
				setStockInfo("stockNum", stockNum);
				totalValue(stockPrice, stockNum);
				$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			} else {
				$.alert("请输入正确的证券代码/简称");
			}
			e.stopPropagation();
		});


		// 仓位选择
		$.bindEvent($(_pageId + " .kcb_trade_main .row_04 p"), function (e) {
			$.closeModal(".picker-modal.modal-in");
			if (keyboard) {
				keyboard.closeKeyPanel();
			}
			if (stock_info && stock_info.stockCode) {
				$(this).addClass("check").siblings().removeClass("check");
				var key = $(this).attr("type");
				if (key == "4") {
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum", num + "");
				}
				else if (key == "3") {
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum", num + "");
				}
				else if (key == "2") {
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum", num + "");
				}
				else if (key == "1") {
					var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
					if (isBuy()) {
						num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					}
					setStockInfo("stockNum", num + "");
				}
				common.changeFontSize($(_pageId + " #stockNum"), "0.14rem");
				var stockNum = $(_pageId + " #stockNum").val();
				var stockPrice = getStockInfo("stockPrice");
				totalValue(stockPrice, stockNum);
			} else {
				$.alert("请输入正确的证券代码/简称");
			}
			e.stopPropagation();
		});

		$.bindEvent($(_pageId + " .hqxltb"),function(e){
			$.closeModal(".picker-modal.modal-in");
			if($(this).find("i").hasClass("xl")){
				stock_html.hqxltb.attr("class","sl");
				stock_html.hqCanvas.show();
				if(_initScroller){
					_initScroller();
				}
			}
			else{
				stock_html.hqxltb.attr("class","xl");
				stock_html.hqCanvas.hide();
				if(_initScroller){
					_initScroller();
				}
			}
			e.stopPropagation();
		});
		
        //点击分时图
		$.bindEvent($(_pageId + " #hqt"),function(e){
			if(stock_info.stockCode && stock_info.stock_market){
				var stockIndex = stock_info.stock_market + ":" + stock_info.stockCode;
				var pageCode = $.getCurrentPageObj().pageCode || '';
				if(global.callNative){
                    $.setSStorageInfo("go_hq_" + pageCode, true);
                    var param = {
                        "funcNo": "50500",
                        "msgNo": "201",
                        "targetModule":"hqDispatcher",
                        "sourceModule":"trade",
                        "action":"0",
                        "param":{
                            "stockMarket": stock_info.stock_market,
                            "stockCode": stock_info.stockCode,
                            "stockName": stock_info.stockName,
                        }
                    }
                    $.callMessage(param);
                }else{
                    var stockInfo = {
                        "market":stock_info.stock_market,
                        "stockCode":stock_info.stockCode,
                        "stockName":stock_info.stockName,
                        "moduleName" : "trade"
                    }
                    window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                }
			} else{
                $.alert(stock[1]+"在行情服务器中没有查询到该只股票的信息");
            }
		});
		
	}
	
	/**
	 * 限制小数点位数
	 * @param {Object} price
	 */
	function limitingDigit($this){
		var price_digit = stock_info.price_digit;
		var price = getStockInfo("stockPrice");
		if(price && validatorUtil.isNumberFloat(price)){
			var cur_arr = (price+"").split(".");
			if(cur_arr.length == 2){
				if(cur_arr[1].length > price_digit){
					var price = cur_arr[0]+"."+cur_arr[1].substring(0,price_digit);
					setStockInfo("stockPrice",price)
				}
			}
		}
	}
	
	//行情列表接口有问题是，输入股票是6位数时直接调用交易接口
	function queryData(stockCode){
		var vai1 = /^[0-9]{5}$/;
		if(vai1.test(stockCode)){
			queryMaxAmount(stockCode);
		}
	}
	
	//对行情接口返回数据进行处理
	function ListData(data){
		var price = data[2] ? data[2]:data[6];
		var stockVal = data[1]; //股票代码
		$(_pageId + " #stockCode").removeClass("C100");
		setStockInfo("stockCode",stockVal,true);
		_stockCode = stockVal;
		if(data[0].length>5){
			// common.fontOutOf($(_pageId + " #stockName"),data[0],"3");
			// $(_pageId + " #stockCode").next("span").css("font-size","0.14rem");
			// $(_pageId + " #stockName").addClass("_beyondWrap_ggt");
		}else{
			// $(_pageId + " #stockCode").next("span").css("font-size","0.16rem");
			// $(_pageId + " #stockName").removeClass("_beyondWrap_ggt");
		}
		setStockInfo("stockName",data[0],true); // 股票现价
		if(data[15] == "1"){
//			stock_info.stockCode = "";
// 			$.hidePreloader();
// 			$.alert("该股票即将退市，不进入三板，谨慎委托");
//			return false;
		}
		setStockInfo("stockPrice",price.toFixed(stock_info.price_digit)); // 股票现价
		stock_info.stock_market = data[9];
		if(stock_info.stock_market=="HK"){
			stock_info.exchange_type="G";
		}else if(stock_info.stock_market=="SK"){
			stock_info.exchange_type="S";
		}
		stock_html.label_g.addClass(stock_info.stock_market);
		if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
		stock_info.gear_one = true;
		setFifthOrder();

		common.selectList($(stock_html.market_div), '<span>选择委托方式</span>', market_html_data, function (obj) {
			stock_html.market_p.text(obj.name).attr("id", obj.id);
			stock_html.market_p.attr("type", obj.id);
			// var stockPrice = getStockInfo("stockPrice");
			// var stockNum = getStockInfo("stockNum");
			// totalValue(stockPrice, stockNum);
			// isQueryMax(stockPrice);
		}, function () {
			$.bindEvent($("#selectList h1.titlehsea span.a03"), function (e) {
				var page = _pageId.replaceAll("_", "/").replaceAll("#", "").replaceAll(" ", "");
				$.pageInit(page, "stock/stockExplain");
				e.stopPropagation();
			});
		});
		entrustChange();
		var list = stock_info.stock_market + ":" + stock_info.stockCode;
		hqKt.minLineFunc(_pageId, _pageId + " #hqt", list,$(_pageId).width() - 10,160);
		
		_fifthCallback = false;
		fifthOrder_timer =  window.setInterval(function(){
			if(commonFunc.getTradingTime() && _fifthCallback && common.isAppFlag()){
				setFifthOrder();
				_fifthCallback = false;
			}
		}, (global.refreshTime || 5000));//定时刷新

		//股票联动,查询股票信息，最大可买
		queryMaxAmount(stockVal);
	}
	
	/**
	 * 通过输入的字符查询出对应的股票列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(stockCode,market,exchange_type,stock_account){
		if(stockCode != ""){
			var type = "";
			var stockStrParam = {
			  "q" : stockCode,
			  "type" : "98:99",
			  "marketType":"3"
			}; 
			if(market == "HK"){
				stockStrParam["type"] = "99";
			}
			else if(market == "SK"){
				stockStrParam["type"] = "98";
			}
			if(exchange_type == "G"){
				stockStrParam["type"] = "99";
			}
			else if(exchange_type == "S"){
				stockStrParam["type"] = "98";
			}
			stock_html.stockList.html("");
			var vai1 = /^[0-9]{5}$/;
			if(vai1.test(stockCode)){
				$.showPreloader("请等待...");
			}
            if(isHold === "1"){
                stockStrParam.IsQueryHK = "1";
            }
//			setTimeout(function(){
//				if(queryStockHqFlowNo && queryStockHqFlowNo.length > 0){
//					window.clearNativeRequestCallback(queryStockHqFlowNo);
//				}
				service_hq.getStockList_ggt(stockStrParam,function(data){
						getStockListCallBack(data,stockCode);
					},
					{"isLastReq":false,"isShowWait":false,
					"timeOutFunc":function(){
						queryData(stockCode);
					},"errorFunc":function(){
						queryData(stockCode);
					}});
//			},0);
		}
	}
	
	function getStockListCallBack(data,stockCode){
		var StockList = {};
		var vai1 = /^[0-9]{5}$/;
		stock_html.stockList.html("");
		if(data.errorNo == 0){
			var results = data.results;
			// 显示股票列表
			if(results && results.length > 0){
				if(stockCode.length==5) {
					var dataFlag = isBuy() ? "1" : "2";
					results = stockListCheck(results,dataFlag);
				}
				if(results.length == 1 && vai1.test(stockCode)){
					ListData(results[0]);
					stock_html.stockList.html("");
				}else{
					$.hidePreloader();
					var selectHeight = 0.44*results.length;
					if(results.length >= 5){
						selectHeight = 5 * 0.44;
					}
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						var img="";
						if(results[i][9] == "SK" ){
//							img = 'tg_icon_sa'
							img = "SK";
						}else if(results[i][9] == "HK" ){
//							img = 'tg_icon_ha';
							img = "HK";
						}
						StockList[(results[i][9]+":"+results[i][1])] = results[i];
						listHtml += "<li><a href=\"javascript:void(0);\" style=\"line-height: inherit;display: flex;align-items: center;text-align: center;\"><i style='float: left;'  class='position_g "+img+"' ></i><strong style=\"font-size:0.15rem;margin-left: 0.1rem;\">"+results[i][1]+"</strong>"+results[i][0]+"</a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i][9]+"</span></li>";
					};
					listHtml+="</ul>";
					stock_html.stockList.html(listHtml).show();
					$.bindEvent($(_pageId + " .trade_form .select_box ul li"),function(e){
						//埋点
						var objectId = stock_html.stockList.attr("objectId")
						var actionId = stock_html.stockList.attr("actionId");
						common.comStat(objectId,2,actionId,true,{"i_change_name":"股票输入","i_change_to":$(this).attr("stock_name")});
						
						var market = $(this).find("span").text();
						var stockCode = $(this).find("strong").text();
						ListData(StockList[market+":"+stockCode]);
						stock_html.stockList.html("");
						StockList={};
						e.stopPropagation();
					});
				}
			}
			else{
				if(vai1.test(stockCode)){
					queryData(stockCode);
//					$.alert("没有查询到此股票信息");
//					$.hidePreloader();
				}
			}
		}else{
			queryData(stockCode);
		}
	}
	
	//五档买卖盘
	function setFifthOrder(){
		var market = stock_info.stock_market, stockCode = stock_info.stockCode;
		if(market && stockCode){
			var fifthOrder = {
				"stock_list" : market+":"+stockCode
			};
			service_hq.getStockFiveStep(fifthOrder,callbackFifthOrder,{"isShowWait":false,"errorFunc":function(){_fifthCallback = true;}});
		}
	}
	
	//回调五档买卖盘
	function callbackFifthOrder(data){
		_fifthCallback = true;
		if(data.errorNo == 0){
			var results = data.results;
			if(results && results.length>0){
				var yesProfit = results[0][26];
				var price_digit = stock_info.price_digit;

				$(_pageId + ".kcb_timeshare .row_01 strong").text(results[0][1]);
				var kcb_timeshareEm = $(_pageId + ".kcb_timeshare .row_01 em");
				var r35=results[0][35];
				if(results[0][35]){
					r35 = (Number(results[0][35])).toFixed(price_digit);//内盘
				}
				kcb_timeshareEm.text((Number(results[0][30])).toFixed(price_digit)+ " " + r35 + " " + (Number(results[0][36])*100).toFixed(2)+"%");
				if(r35 > 0){
					kcb_timeshareEm.attr("class","ared");
				}
				else if(r35 < 0){
					kcb_timeshareEm.attr("class","agreen");
				}
				else{
					kcb_timeshareEm.attr("class","");
				}

				if(stock_info.gear_one){
					var fifthOne = "";
					var presentPrice = results[0][30];
					if(isBuy()){
						fifthOne = results[0][10] || results[0][16];
					}else{
						fifthOne = results[0][16] || results[0][10];
					}
					if(presentPrice != 0 && (fifthOne == "0" || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)){
						fifthOne = presentPrice;
					}
					fifthOne = Number(fifthOne).toFixed(price_digit);
					var p_price = $.getPageParam("price");
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						fifthOne  = Number(p_price).toFixed(price_digit);
					}
					setStockInfo("stockPrice",fifthOne); // 股票现价
					stock_info.gear_one = false;
				}
				//卖五档盘颜色集合
				for(var i = 0 ; i < 5 ; i ++){
					addColor(stock_html.buyGear.eq(i),results[0][16+i],yesProfit,results[0][21+i],price_digit);
					addColor(stock_html.sellGear.eq(i),results[0][6+i],yesProfit,results[0][11+i],price_digit);
				}
				$(_pageId+".five_box span").each(function(idx, item){
					var zoom = $.getTransformScale($(item).text(), 12, $(_pageId + ".five_box").getContentWidth() * 0.3)
					$(item).css({"zoom": zoom });
				});
				$(_pageId+".five_box em").each(function(idx, item){
					var zoom = $.getTransformScale($(item).text(), 12, $(_pageId + ".five_box").getContentWidth() * 0.3)
					$(item).css({"zoom": zoom });
				});
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div,price,yesProfit,num,price_digit){
		var prices = div.find("span");
		var nums = div.find("em");
		yesProfit = yesProfit.toFixed(price_digit);
		price = price.toFixed(price_digit);
		if(Number(price) == 0){
			prices.text("--").attr("class","");
		}
		else if(Number(price) > Number(yesProfit)){
			prices.text(price).attr("class","ared");
		}
		else if(Number(price) < Number(yesProfit))
		{
			prices.text(price).attr("class","agreen");
		}
		else
		{
			prices.text(price).attr("class","");
		}
		if(num == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(num >= 100000){
			nums.text((num/10000).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}

	/*
	 * 委托方式带入到下单页面填充
	 */
	function entrustChange(){
		var entrustBs = $.getPageParam("entrust_bs");
		if(entrustBs){
			var entrustName=null;
			if(!isBuy()){
				entrustBs=Number(entrustBs)-1;
			}
			entrustName ={"0":"增强限价盘","1":"竞价限价盘"};
			stock_html.market_p.text(entrustName[entrustBs]).attr("id",entrustBs);
			stock_html.market_p.attr("type",entrustBs);
		}else{
			stock_html.market_p.text("增强限价盘").attr("id","0");
			stock_html.market_p.attr("type","0");
		}
	}
	
	
	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(stockCode,isMax){
		stock_html.stockList.html("");
		$.hidePreloader();
		var stock_price = getStockInfo("stockPrice");
		var entrust_bs = "0";
		if(!isBuy()){
			entrust_bs = (Number(entrust_bs)+1) + "";
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var stock_code = stockCode;
		var entrust_price = stock_price;
		var stock_account = stock_info.stock_account;
		var single_flag = "0";//是否为零股申报，默认为0
		if(_orderType == "3"){
			single_flag = "1";
		}
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"stock_account": stock_account,
	            "single_flag":single_flag,
				"exchange_type":stock_info.exchange_type
			};
  	  	service_ggt.queryInformation_ggt(param,function(data){
	  	  	if(isMax){
		  	  	queryMaxAmountCallBackMax(data);
	  	  	}else{
	  	  		queryMaxAmountCallBack(data);
	  	  	}
	  	  },{"isLastReq":true,"isShowWait":false});
	}
	function queryMaxAmountCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				var price_digit = stock_info.price_digit;
				setStockInfo("stockMaxAmount",Number(results[0].stock_max_amount),true);
				setStockInfo("stockName",results[0].stock_name,true);
				if(results[0].stock_name.length>5){
					// $(_pageId + " #stockCode").next("span").css("font-size","0.14rem");
					// $(_pageId + " #stockName").addClass("_beyondWrap_ggt");
				}else{
					// $(_pageId + " #stockCode").next("span").css("font-size","0.16rem");
					// $(_pageId + " #stockName").removeClass("_beyondWrap_ggt");
				}
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
				stock_info.up_price = Number(results[0].up); // 现价+
				stock_info.down_price = Number(results[0].down); // 现价-
				setStockInfo("lot_size", Number(results[0].buy_unit),true); // 每手股数
				exchange_rate = results[0].buy_exchange_rate;
				if (!isBuy()) {
					var exchange_rate = results[0].sell_exchange_rate;
				}
				exchange_rate = Number(exchange_rate).toFixed(5);
				setStockInfo("exchange_rate",exchange_rate); //参考汇率
				stock_info.exchange_rate = exchange_rate;
				if(!stock_info.stockCode){
					stock_info.stockCode = results[0].stock_code;
					setStockInfo("stockPrice",Number(results[0].price).toFixed(price_digit));
				}
				var img = "";
				if(results[0].exchange_type == "S" || results[0].exchange_type == "s"){
					img = "SK ";
				}else if(results[0].exchange_type == "G" || results[0].exchange_type == "g"){
					img = "HK ";
				}
				stock_html.label_g.addClass(img);

				common.selectList($(stock_html.market_div), '<span>选择委托方式</span>', market_html_data, function (obj) {
					stock_html.market_p.text(obj.name).attr("id", obj.id);
					stock_html.market_p.attr("type", obj.id);
					// var stockPrice = getStockInfo("stockPrice");
					// var stockNum = getStockInfo("stockNum");
					// totalValue(stockPrice, stockNum);
					// isQueryMax(stockPrice);
				}, function () {
					$.bindEvent($("#selectList h1.titlehsea span.a03"), function (e) {
						var page = _pageId.replaceAll("_", "/").replaceAll("#", "").replaceAll(" ", "");
						$.pageInit(page, "stock/stockExplain");
						e.stopPropagation();
					});
				});
				entrustChange();
//				queryAvailable(exchange_type);
			}
		}else{
			$.alert(data.error_info);
		}
	}
	function queryMaxAmountCallBackMax(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				var price_digit = stock_info.price_digit;
				setStockInfo("stockMaxAmount",Number(results[0].stock_max_amount),true);
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
				stock_info.up_price = Number(results[0].up); // 现价+
				stock_info.down_price = Number(results[0].down); // 现价-
				setStockInfo("lot_size", Number(results[0].buy_unit)); // 每手股数-
//				exchange_rate = Number(results[0].sell_exchange_rate);
//				if (!isBuy()) {
//					var exchange_rate = results[0].buy_exchange_rate;
//				}
//				setStockInfo("exchange_rate",exchange_rate); //参考汇率
				
				exchange_rate = results[0].buy_exchange_rate;
				if (!isBuy()) {
					var exchange_rate = results[0].sell_exchange_rate;
				}
				exchange_rate = Number(exchange_rate).toFixed(5);
				setStockInfo("exchange_rate",exchange_rate); //参考汇率
				stock_info.exchange_rate = exchange_rate;
				
//				queryAvailable(exchange_type);
			}
		}
		else{
			$.alert(data.error_info);
		}
	}
	
	// 计算当前总值
	function totalValue(stockPrice,stockNum){
		if(stock_html){
			stock_html.total.text("").hide();
			if(validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)&&validatorUtil.isNumberFloat(stock_info.exchange_rate)){
				var exch_rate = stock_info.exchange_rate;
				var amount = (stockPrice*stockNum*stock_info.exchange_rate).toFixed(3);
				stock_html.total.text("(¥"+common.numToMoneyType(""+amount)+")").attr("vlaue",amount).show();
			}
		}
	}
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		
		var typeText = "买入";
		if(!isBuy()){
			typeText = "卖出";
		}
		//验证股票代码输入是否正确
		var stockCode = stock_info.stockCode;
		if(stockCode.length == 0){
			$.alert("请输入股票代码");
			return false;
		}	
		var vai1 = /^[0-9]{5}$/;
		if(!vai1.test(stockCode)){
			$.alert("股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length<=0){
			$.alert("请输入"+typeText+"价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockPrice)){
			$.alert("请正确输入价格");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount+"";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length<=0){
			$.alert("请输入"+typeText+"数量");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockNum)){
			$.alert("请正确输入数量");
			return false;
		}else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
		
		var ts = "";
		if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
			ts += "最大可"+typeText+"数量不足";
		}
//		验证最大可买
		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
			ts += "最大可"+typeText+"为0";
		}
		var lots_of = stock_info.lot_size;
		if(isBuy()){
			if(stockNum % Number(lots_of) != 0){
				ts += "买入数量应为" + lots_of + "的倍数";
			}else if(stockNum > 1000000){
				ts += "买入数量必须小于或等于100万股";
			}
		}else{
			if(stockNum != stockMaxAmount && stockNum % Number(lots_of) != 0 && _orderType == "2"){
				ts += "卖出数量应为" + lots_of + "的倍数";
			}
		}
		
		var	up_stop = null;
		var	down_stop = null;
		var entrust_bs = "0";
		var tipStrArray = [];
		var tipStr ="<div>";

		tipStrArray.push([stock_info.stockName,stockCode]);
		tipStrArray.push(["委托价格",stockPrice+"(港币)"]);
		tipStrArray.push(["委托数量",stockNum]);
		tipStrArray.push(["参考汇率",stock_info.exchange_rate]);
		tipStrArray.push(["委托金额",$(_pageId+" #total").attr("vlaue")+"(元)"]);
		tipStr += common.generatePrompt(tipStrArray);
		if(ts){
			tipStr += "<div class='_reminder'><span class='b'>温馨提示：</span><span class='w'>"+ts+"</span></div>";
		}
		tipStr+="</div>";
		if(!isBuy()){
			entrust_bs = (Number(entrust_bs)+1) + "";
		}
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no = userInfo.branch_no;	//分支机构
		var sessionid = userInfo.session_id;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var exchange_type = stock_info.exchange_type;
		var stock_account = stock_info.stock_account;
		var stock_code = stockCode;
		var entrust_price = stockPrice;
		var entrust_amount = stockNum;
		// var max_price_levels = $(_pageId + " .value_btn .current").attr("id");
		var max_price_levels = $(_pageId + " #entrustWay p").attr("id");
		var single_flag = "0";
		if(_orderType == "3"){
			single_flag = "1";
		}
		var business_type = "4";
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"entrust_bs":entrust_bs,
				"exchange_type":exchange_type,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"entrust_amount":entrust_amount,
				"single_flag": single_flag,
				"business_type":business_type,
				"max_price_levels": max_price_levels
			};
		
		//埋点数据
		var comStatParam={
			"objectId":$(_pageId+".ce_btn").attr("objectId"),
			"actionId":$(_pageId+".ce_btn").attr("actionId"),
			"i_entrust_bs":entrust_bs, // 交易方向( 1,买入 2,卖出)
			"i_stock_code":stock_code, // 股票代码
			"i_stock_name":stock_info.stockName, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":exchange_type, // 交易市场
			"i_entrust_price":entrust_price, // 选择后的价格
			"i_entrust_amount":entrust_amount, // 委托数量
            "isSellOrder":!isBuy(),
		}
		appropriate.placeOrder(comStatParam,param,tipStr,function(instr_batch_no){
			param.instr_batch_no = instr_batch_no;
			service_ggt.queryTrustSure_ggt(param,getStockBuyCallBack,{"isLastReq":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
			$.showPreloaders("请等待...");
		},!isBuy());
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				$.alert(tipStr);
				clearBuyMsg();
				setStockInfo("stockCode","");// 股票价格
				$(_pageId + " #stockCode").addClass("C100");
			}
		}else{
			$.alert(data.error_info);
			clearBuyMsg();
			setStockInfo("stockCode","");// 股票价格
			$(_pageId + " #stockCode").addClass("C100");
		}
		$(_pageId + "#stockCode").val("");
		$(_pageId+".key_text").text("");
		$(_pageId+".jsKey em").text("");
		queryHoldings();
	}
	
	function queryHolding(){
		pageGlobal.holdData = "";
		queryHoldings();
		_callback = false;
		if(position_timer == null && global.positionRefreshTime){
			position_timer = window.setInterval(function(){
				if(commonFunc.getTradingTime() && _callback && common.isAppFlag()){
					queryHoldings(true);
					_callback = false;
				}
			}, global.positionRefreshTime);//定时刷新
		}
	}
	
	/**
	 * 查询持仓数据
	 */
	function queryHoldings(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var stock_account ="";
		var stock_code = "";
		var exchange_type = "";
		var position=position;
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"exchange_type":exchange_type,
		};
		$(_pageId+".fund_table .ce_table").html("");
		service_ggt.queryHolding_ggt(param,queryHoldingCallback,{
            "isLastReq":true,
            "isShowWait":isShowWait?false:true,
            "isShowOverLay":false,
            "timeOutFunc":function(){
            	$(_pageId+ ".no_data").show();
                if(!_myScroller){
                    _initScroller();
                }else{
                    _myScroller.refresh();
                }
            }
        });
	}
	
	function queryHoldingCallback(data){
		pageGlobal.holdData = data;
		_callback = true;
		// var html = '<tr><th>证券/市值</th><th>盈亏/比例</th><th>持仓/可用</th><th style="padding-right:0;">成本/现价</th><th style="width: 0.32rem;"><span class="j-tag border">HKD</span></th></tr>';
		// $(_pageId + " .fund_table2 div.ce_table thead").html(html);
		$(_pageId+" .no_data").show();
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				var dataHtml="";
				// dataHtml +="<div class='top'><p style='width: 10%'><span scope=\"col\">市场</span></p><p style='width: 25%'><span scope=\"col\">证券/市值</span></p><p style='width: 25%'><span scope=\"col\">盈亏</span></p><p style='width: 20%'><span scope=\"col\">持仓/可用</span></p><p style='width: 20%'><span scope=\"col\">成本/现价</span></p></div>";
				if(results && results.length>0){
					for (var i=0;i<results.length;i++){ 
						dataHtml += queryHoldingHTML_stock(results[i],i);
					}
					$(_pageId+".fund_table2 .ce_table tbody").html(dataHtml);
					$(_pageId+".no_data").hide();
					//卖出事件
					holdClickEvent();
				}else{
					$(_pageId+".fund_table2 .ce_table tbody").html(dataHtml);
					$(_pageId+".no_data").show();
				}
			}else{
				$.alert(data.error_info);
			}
		}
		if(!_myScroller){
			_initScroller();
		}else{
			_myScroller.refresh();
		}
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHoldingHTML_stock(element){
		var price_digit = 3;
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk > 0){
			css = "ared";
		}else if(float_yk < 0){
			css = "agreen";
		}
		//浮动盈亏比例
		var css1 = "";
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		var img = "";
		var market = "",lable = "";
		if(element.exchange_type == "S" || element.exchange_type == "s"){
			img = "SK ";
			lable = "j-label-02";
			market="深";
		}else if(element.exchange_type == "G" || element.exchange_type == "g"){
			img = "HK ";
			lable="j-label-01";
			market="沪"
		}
		// float_yk = float_yk.toFixed(2);

		var maxWidth = ($(window).width() - 25 - 35 - 30 - 15) / 4;
		var setTranslateX = function(value){
			if(value != 1){
				return 'translateX('+ (value - 1) * maxWidth +'px)';
			}
			return '';
		}
		var eleHtml = "";
		
		var marketValue = Number(element.market_value).toFixed(price_digit),
		float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
		hold_amount = Number(element.hold_amount),
		enable_amount = Number(element.enable_amount),
		cost_price = Number(element.cost_price).toFixed(price_digit),
		last_price = Number(element.last_price).toFixed(price_digit);
		float_yk = float_yk.toFixed(2);
		eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\"  id='"+element.stock_code +"'>";
		eleHtml+='<td><label class="j-label '+lable+'">'+market+'</label>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) +'px;">'+element.stock_name +'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p></td>';
        eleHtml+='<td><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>';
        eleHtml+='<p class="'+css1+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+float_yk_per+'</p></td>';
		eleHtml+='<td><p style="font-size:'+$.getTransformScaleFontSize(hold_amount, 16, maxWidth) +'px;">'+hold_amount+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></td>';
		eleHtml+='<td><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></td>';
        eleHtml+="</tr>";
		return eleHtml;

	   	var eleHtml = "";
        eleHtml+="<dl id='"+element.stock_code +"' exchange_type='"+element.exchange_type +"' stock_account='"+element.stock_account +"'>";
		eleHtml+="<dd style='width: 10%'><i style='float: left;' class='position_g "+img+"' ></i></dd>";
        eleHtml+="<dd style='width: 25%'><p><strong>"+element.stock_name +"</strong></p><p><small>"+Number(element.market_value).toFixed(2) +"</small></p></dd>";
        eleHtml+="<dd style='width: 25%'><p><span class=\""+css+"\">"+float_yk+"</span></p><p><span class=\""+css+"\">"+element.float_yk_per+"</span></p></dd>";
        eleHtml+="<dd style='width: 20%'><p>"+Number(element.hold_amount)+"</p><p>"+Number(element.enable_amount)+"</p></dd>";
        eleHtml+="<dd style='width: 20%'><p>"+Number(element.cost_price).toFixed(price_digit)+"</p><p>"+Number(element.last_price).toFixed(price_digit)+"</p></dd>";
        eleHtml+="</dl>";
        return eleHtml;
	}
	
		
	//持仓点击事件
	function holdClickEvent(){
		//卖出事件
		$.bindEvent($(_pageId+" .fund_table2 .ce_table tr.add"), function(e){
			clearBuyMsg();// 清楚数据
			var stockCode = $(this).attr("id");
			var stock_account = $(this).attr("stock_account");
			$(_pageId + " #stockCode").removeClass("C100");
			$(_pageId + " #stockCode").quzhi(stockCode);
			_stockCode = stockCode;
			var exchangeType= $(this).attr("exchange_type");
			stock_info.exchange_type=exchangeType;
			stock_info.stock_account=stock_account;
            isHold = "1";
			getStockList(stockCode,"",exchangeType,stock_account);
			$(_pageId + " .main").scrollTop(0);
			
			//埋点
			var stockName = $(this).attr("stock_name"); 
			var exchange_type_name= $(this).attr("exchange_type_name"); 
			var objectId = $(_pageId+" .fund_table2 .ce_table").attr("objectId");
			var actionId = $(_pageId+" .fund_table2 .ce_table").attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_change_name":"持仓列表","i_change_to":exchange_type_name+"."+stockName});
			e.stopPropagation();
		}, "tap");
	}
	
	
	/**
	 * 额度查询
	 * */
	function queryAvailable(exchange_type){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"exchange_type":exchange_type
		};
		service_ggt.queryAvailable_ggt(param,function(data){
			if(data.error_no == 0){
				var results = data.results[0];
				if(results){
					setStockInfo("surplus_quota",Number(results.surplus_quota),true);
				}
			}else{
				$.alert(data.error_info);
			}
		},{"isShowWait":false});
	}
	

	/**
	 * 
	 */
	function clearBuyMsg(){
		stock_info = ioitStock();
		if(stock_html){
			//清空canvas图
			$(_pageId + ".kcb_timeshare .row_01 strong").text("");
			$(_pageId + ".kcb_timeshare .row_01 em").text("--").removeClass("agreen").removeClass("ared");
			$(_pageId+"#hqt").html("");
			hqKt.clearCanvasFunc(_pageId);
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});

		   	if(stock_html.market_div.find("a.current").text() == "市价委托"){
			   	stock_info.market_price = true;
		   	}
	    	stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 股票名称
	    	setStockInfo("stockPrice","");// 股票价格
	    	setStockInfo("stockNum",""); // 股票数量
	    	stock_html.lot_size.text("--");
	    	stock_html.surplus_quota.text("--");//跌停价
	    	stock_html.exchange_rate.text("--");//跌停价
	    	stock_html.stockMaxAmount.text("--");//股票最大数
		   	stock_html.total.text("").attr("vlaue", "").hide();
		   	stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
			stock_html.label_g.removeClass("SK").removeClass("HK");
			stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
		}
	   	if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
	   	_fifthCallback = true;
        isHold = "0";
		$(_pageId + " .five_box ul li").removeClass("active");
		$(_pageId + "#stock_list").html("");
		//针对调用了js键盘后清除输入数据
		$(_pageId+"#stockPrice .key_text").text("");
		$(_pageId+"#stockPrice .jsKey em").text("");
		$(_pageId+"#stockNum .key_text").text("");
		$(_pageId+"#stockNum .jsKey em").text("");

		$(_pageId+".row_04 p").removeClass("check");
		$.closeModal(".picker-modal.modal-in");
	}
	/**
	 * 重写框架里面的pageBack方法
	 */
	function orderPageBack(){
		var curPageCode = $.getSStorageInfo("_curPageCode");
		var nextPageCode = "ggt/ggtOrder";
		$.pageInit(curPageCode,nextPageCode,{},true);
	}
	
	function dataDestroy(){
        commonFunc.clearCheckTradeTimer();
		$.clearRequest();
		// $(_pageId+".fund_table .ce_table").html("");
		$(_pageId + " #stockCode").quzhi("");
		$(_pageId + " #stockCode").addClass("C100");
		_stockCode = "";
		// $(_pageId + " .position_div .ce_table thead").html("");
		$(_pageId + " .position_div .ce_table tbody").html("");
		clearBuyMsg();
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		position_timer = null;
		stock_info = null;
		stock_html = null;
		$(_pageId+ ".no_data p").text("暂无持仓记录");
		$(_pageId+" .search_scroll").hide();
		$(_pageId+" .toggle_nav li:eq(0)").click();
		if(keyboard){
			keyboard.keyDestroy();
		}
		// $(_pageId + " #stockCode").next("span").css("font-size","0.16rem");
		$(_pageId + " #stockName").removeClass("_beyondWrap_ggt");
	}

	function stockListCheck(listData,dataFlag) {
		var dataArr = [];
		var outDataArr = [];  //需要卖出的数据
		if(listData.length>1) {
			for(var i=0,len=listData.length;i<len;i++) {
				var listType = listData[i][9];
				var flag = queryUserPowerTypes(listType);
				if(flag) {
					dataArr.push(listData[i]);
					// 只能卖出持仓已有数据
					if(dataFlag=="2") {
						var listStockType = listType.replace("HK","G").replace("SK","S");
						var holdData = pageGlobal.holdData;
						if(holdData && holdData.error_no == 0) {
							var holdResults = holdData.results;
							if(holdResults && holdResults.length > 0) {
								var listCode = listData[i][1];
								for(var j=0,len2=holdResults.length;j<len2;j++) {
									var item = holdResults[j];
									var holdCode = item["stock_code"];
									var holdType = item["exchange_type"];
									if((listCode==holdCode) && (listStockType==holdType)) {
										outDataArr.push(listData[i]);
									}
								}
							}
						}
					}
				}
			}
		}
		if(dataFlag=="2") {
			if(outDataArr.length>0) {
				return outDataArr;
			} else {
				// 如果用户没有持仓，就返回对应权限类型的股票
				if(dataArr.length>0) {
					return dataArr;
				} else {
					return listData;
				}
			}
		} else {
			if(dataArr.length>0) {
				return dataArr;
			} else {
				return listData;
			}
		}
	}

	function queryUserPowerTypes(stockType) {
		var flag = true;
		stockType = stockType.replace("HK","G").replace("SK","S");
		var fund_account = userInfo.fund_account;	//资产账户
		var getInfoData = [];
		var getInfo = common.getAccountInfos();
		if (getInfo && Object.keys(getInfo).length > 0) {
			var getInfo1 = getInfo["stock"];
			if (getInfo1 && Object.keys(getInfo1).length > 0) {
				var getInfo2 = getInfo1[fund_account];
				if (getInfo2 && Object.keys(getInfo2).length > 0) {
					for (var i = 0; i < getInfo2.length; i++) {
						getInfoData.push(getInfo2[i].exchange_type);
					}
					if(getInfoData.indexOf(stockType)==-1) {
						flag = false;
					}
				}
			}
		}
		return flag;
	}

	var base = {
		"dataInit" : dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy,
		"queryHoldings":queryHoldings
	};
	module.exports = base;
});
