/**
 * 键盘js
 */
define('trade/scripts/common/keyboardCredit.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    require('keyPanel'); // 首先引入 keyPanel 插件
    var myKeyPanel = new $.KeyPanel(); // 创建与当前页面对应的 keyPanel 对象
    var _eleId = null;

    /**
     * 每个页面校验
     */
    function keyInit(inputValue, clickCallBack, clickType, page_Id) {
        keyDestroy();
        keypanel(inputValue, clickCallBack, clickType, page_Id);
    }

    function setDiv(_pageId) {
        var jpMap = {
            "telephone": "1",
            "number": "6",
            "tel": "7",
            "tel2": "2",
            "tel8": "8",
            "english": "4",
            "shares": "5",
            "password2": "m2",
            "password8": "m8",
            "password9": "m9",
            "password10": "m10",
            "thirdKeyboard": "12"
        };
        var inputKey = $(_pageId + ' input[js-key]');
        inputKey.attr("readonly", "readonly");
        inputKey.attr("type", "password");
        for (var i = 0; i < inputKey.length; i++) {
            var inp = inputKey.eq(i);
            if (inp.next("div.jsKey").length == 0) {
                var typeName = inp.attr("js-key");
                var type = jpMap[typeName];
                var id = inp.attr("id");
                var css = inp.attr("class");
                var val = inp.val();
                var placeholder = inp.attr("placeholder");
                var maxlength = inp.attr("maxlength");
                var div = [];
                if (type == "5") {
                    div.push("<div is-stock-input='true' id='");
                } else {
                    div.push("<div id='");
                }
                div.push(id);
                div.push("' class='");
                div.push(css);
                div.push(" jsKey' key-type='");
                div.push(type);
                div.push("' maxlength='");
                div.push(maxlength);
                var valem = val;
                var key_text = val;
                var key_pwd = "";
                if (type.indexOf("m") != -1) {
                    key_pwd = " key_pwd";
                    val = val + "";
                    key_text = "";
                    valem = "";
                    for (var i = 0; i < val.length; i++) {
                        key_text += "<b></b>";
                        valem += "*";
                    }
                }
                div.push("'><em style='display: none;'>" + valem + "</em><div ");
                if (inp.css("text-align") == "right") {
                    div.push("style='right: 5px;' ");
                }
                div.push("class='key_input");
                div.push(key_pwd + "'><div class='key_text'>" + key_text + "</div>");
                div.push("<div class='key_cursor_credit'></div></div>");
                if (placeholder) {
                    var di = "";
                    if (val) {
                        di = "style=\"display: none;\"";
                    }
                    div.push("<div " + di + " class='" + css + " key_place'>" + placeholder + "</div>");
                }
                div.push("</div>");
                inp.hide();
                inp.after(div.join(""));
                if (val) {
                    inp.next("div.jsKey").val(val);
                }
            }
        }
    }

    //处理一些输入框过低时键盘挡住输入框的情况。
    function keyBoardPageScroll(n) {
        var a = n.parents('[key-panel-main="true"]');
        a.css("margin-top", "0px");
        if (a && a.length > 0) {
            var b = n.offset().top;
            var c = n.height();
            var d = gconfig.appHeight - 300;
            var e = b + c + 20 - d;
            var f = a.css("margin-top").slice(0, -2);
            if (e > 0) {
                a.css("margin-top", +f - e + "px");
            }
        }
    }

    /**
     * 设置键盘公共方法
     * @param {Object} data
     */
    function keypanel(inputValue, clickCallBack, clickType, page_Id) {
        var _pageId = page_Id || "#" + $.getCurrentPageObj().pageId;
        setDiv(_pageId);

        /**
         * 点击页面其他地方隐藏键盘
         */
        $.bindEvent($(_pageId), function (e) {
            if (global.callNative) {
                $(_pageId).css("margin-top", "0px");
                $.callMessage({"moduleName": "trade", "funcNo": "50211"});
            }
            $(_pageId + " div.jsKey.active").triggerHandler("blur");
            $(_pageId + " div.jsKey.active").removeClass("active");
            myKeyPanel.close();
        });

        /**
         * 点击输入框
         */
        $.bindEvent($(_pageId + " div.jsKey"), function (e) {
            if (clickCallBack) {
                clickCallBack();
            }
            clickOpenKeyboard(this, _pageId, inputValue);
            e.preventDefault();
            e.stopPropagation();
        }, clickType ? clickType : null);


        if (!global.callNative) {
            $.bindEvent($(_pageId + " div.jsKey"), function (e) {
                var a = e.detail;
                popUpKeyboard($(this), e);
                e.stopPropagation();
            }, "input");
        } else {
            $.bindEvent($(_pageId + " input[js-key]"), function (e) {
                var a = e.detail;
                popUpKeyboard($(this), e);
                e.stopPropagation();
            }, "input");
        }

    }

    function clickOpenKeyboard(t, _pageId, inputValue) {
        var appMap = {
            "1": "3",
            "6": "3",
            "7": "6",
            "8": "3",
            "2": "7",
            "4": "1",
            "5": "2",
            "m2": "5",
            "m8": "4",
            "12": "8"
        };
        var $this = $(t);
        _eleId = $this.attr("id");
        // if(!$this.hasClass("active")){
        var keyPanelType = $this.attr("key-type");
        $(_pageId + " div.jsKey.active").triggerHandler("blur");
        $(_pageId + " div.jsKey.active").removeClass("active");
        $this.addClass("active");
        if (!global.callNative) {
            var isPassword = false;
            var keyPanelConfig = {
                beforeInitFunc: function () {

                },
                afterInitFunc: function () {
                    var height = $this.parents("div").height();
                    if (height) {
                        $(_pageId + " div.jsKey.active").find(".key_input").css("height", height + "px");
                        $(_pageId + " div.jsKey.active").find(".key_input .key_text").css("height", height + "px !important;");
                        $(_pageId + " div.jsKey.active").find(".key_input .key_text").css("line-height", height + "px !important;");
                        $(_pageId + " div.jsKey.active").find(".key_input .key_cursor_credit").css("top", ((height - 18) / 2) + "px;");
                    }
                },
                beforeCloseFunc: function () {

                },
                afterCloseFunc: function () {

                },
                isSaveDom: true, // 是否保存键盘 DOM 在页面中
                skinName: 'default2',//目前皮肤包括black，white,default,default2,缺省是default
                okFunc: function () { // 点击键盘确定按钮绑定的方法
                    if (inputValue) {
                        inputValue();
                    }// 根据值搜索对应股票
                    //点击确定触发价格库框的失焦事件
                    var triggerBlurList = ["stockPrice", "stockNum", "kcbStockPrice"];
                    if (_eleId && triggerBlurList.indexOf(_eleId) != -1) {
                        $(_pageId + " #" + _eleId).triggerHandler("blur");
                    }
                }
            };
            if (keyPanelType.indexOf("m") != -1) {
                keyPanelType = keyPanelType.replace("m", "");
                isPassword = true;
                keyPanelConfig.isSaveDom = false;
            }
            myKeyPanel.init(t, keyPanelType, isPassword, keyPanelConfig); // 执行初始化
        } else {
            window.customKeyboardEvent = {
                keyBoardFinishFunction: function () {
                    $(_pageId).css("margin-top", "0px");
                    $(_pageId + " div.jsKey.active").removeClass("active");
                    //点击确定触发价格库框的失焦事件
                    var triggerBlurList = ["stockPrice", "stockNum", "kcbStockPrice"];
                    if (_eleId && triggerBlurList.indexOf(_eleId) != -1) {
                        $(_pageId + " #" + _eleId).triggerHandler("blur");
                    }
                },
                keyBoardInputFunction: function (keyCode) {
                    $this.prev("input").attr("keyDiv", keyCode);
                    if (keyCode == -4) {
                        $(_pageId).css("margin-top", "0px");
                        $(_pageId + " div.jsKey.active").removeClass("active");
                        return false;
                    }
                    var pageId = $.getCurrentPageObj().pageId;
                    if (["credit_transferred_collateralTransferIn", "credit_transferred_collateralTransferOut"].indexOf(pageId) > -1) {
                        $(_pageId + " #" + _eleId).triggerHandler("input");
                    } else {
                        $this.prev("input").triggerHandler("input");
                    }
                }
            };
            var pageId = _pageId.substring(1, _pageId.length);
            var eleId = $this.attr("id");
            var keyboardType = appMap[keyPanelType];
            keyBoardPageScroll($this);
            $.callMessage({
                "moduleName": "trade",
                "funcNo": "50210",
                "pageId": pageId,
                "eleId": eleId,
                "doneLable": "确定",
                "keyboardType": keyboardType
            });
            var height = $this.parents("div").height();
            if (height) {
                $(_pageId + " div.jsKey.active").find(".key_input").css("height", height + "px");
                $(_pageId + " div.jsKey.active").find(".key_input .key_text").css("height", height + "px !important;");
                $(_pageId + " div.jsKey.active").find(".key_input .key_text").css("line-height", height + "px !important;");
                $(_pageId + " div.jsKey.active").find(".key_input .key_cursor_credit").css("top", ((height - 18) / 2) + "px;");
            }
        }
    }

    function popUpKeyboard(jsKey, e) {
        if (!global.callNative) {
            var type = jsKey.attr("key-type") || "";
            var op_str = jsKey.attr("value") || jsKey.val();
            jsKey.val(op_str);
            var key_text = jsKey.find("div.key_input div.key_text");
            var inp = jsKey.prev("input");
            if (op_str.length == 0) {
                jsKey.find("div.key_place").show();
            } else {
                jsKey.find("div.key_place").hide();
            }
            if (type.indexOf("m") != -1) {
                var pwdDiv = '';
                for (var i = 0; i < op_str.length; i++) {
                    pwdDiv += "<b></b>";
                }
                key_text.html(pwdDiv);
            } else {
                key_text.html(op_str);
            }
            jsKey.attr("value", "");
            inp.val(op_str);
        } else {
            var op_str = jsKey.val();
            jsKey = jsKey.next("div.jsKey");
            var type = jsKey.attr("key-type") || "";
            var key_text = jsKey.find("div.key_input div.key_text");
            var inp = jsKey.prev("input");
            if (op_str.length == 0) {
                jsKey.find("div.key_place").show();
            } else {
                jsKey.find("div.key_place").hide();
            }
            if (type.indexOf("m") != -1) {
                var pwdDiv = '';
                for (var i = 0; i < op_str.length; i++) {
                    pwdDiv += "<b></b>";
                }
                key_text.html(pwdDiv);
            } else {
                key_text.html(op_str);
            }
        }
    }

    function keyDestroy() {
        if (global.callNative) {
            $(_pageId).css("margin-top", "0px");
            $.callMessage({"moduleName": "trade", "funcNo": "50211"});
            $(_pageId + " div.jsKey").prev("input").attr("keyDiv", "");
        }
        var _pageId = "#" + $.getCurrentPageObj().pageId;
        $(_pageId + " div.jsKey.active").triggerHandler("blur");
        $(_pageId + " div.jsKey.active").removeClass("active");
        $(_pageId + " div.jsKey").val("").attr("value", "");
        $(_pageId + " div.jsKey em").text("");
        $(_pageId + " div.jsKey").find("div.key_input div.key_text").html("");
        $(_pageId + " div.jsKey").find("div.key_place").show();
        myKeyPanel.close();
    }

    function closeKeyPanel() {
        var _pageId = "#" + $.getCurrentPageObj().pageId;
        if (global.callNative) {
            $(_pageId).css("margin-top", "0px");
            $.callMessage({"moduleName": "trade", "funcNo": "50211"});
        }
        $(_pageId + " div.jsKey.active").triggerHandler("blur");
        $(_pageId + " div.jsKey.active").removeClass("active");
        myKeyPanel.close();
    }

    var base = {
        "keyInit": keyInit,
        "closeKeyPanel": closeKeyPanel,
        "popUpKeyboard": popUpKeyboard,
        "clickOpenKeyboard": clickOpenKeyboard,
        "keyDestroy": keyDestroy
    };
    if (!global.startJSkeyboard && !global.callNative) {
        base = null;
    }

    module.exports = base;
});