/**
 * 投资者权益须知书查询签署
 */
define('trade/scripts/common/noticeToInvestors.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
    var service_fund = require("service_fund");
	var service_common = require("service_common");
	
	/**
	 * 基金开户和协议状态查询
	 * @paramMap {Object} content 提示内容
	 */
	function function399901(paramMap,orderCallBack){
		// 查询是否开户
		service_fund.function399901(paramMap, function(data){
			if(data.error_no == 0) {
				var results = data.results;
				if(results && results.length > 0){
					
					//未签署协议、未开户
					if(results[0].isProtocol=="false" && results[0].isFundAccount=="false"){
						var msg='';
						msg +='<p>该基金您暂未开通权限，您是否现在开通？</p>';
						msg +='<a class="x-notice-text">《证券投资基金投资者权益须知书》</a>';
						msg +='<div class="x-check-text"><i class="x-checkbox"></i>本人已知晓并同意上述协议</div>';
						accountOpenConfirm("基金开户",msg,function(paramList,data) {
							paramList.sign_version=data.agreement_version;//签署接口需要协议版本的入参
							function399902(paramList,orderCallBack,true);
						},function(){},"确认","取消",paramMap,results[0]);
					}
					
					//已签署协议、未开户
					else if(results[0].isProtocol=="true" && results[0].isFundAccount=="false"){
						accountOpenConfirm("基金开户",'<p>该基金您暂未开通权限，您是否现在开通？</p>',function(paramList,data) {
							fundOpenAccount(paramList,orderCallBack);
						},function(){},"确认","取消",paramMap,results[0],true);
					}
					
					//未签署协议、已开户
					else if(results[0].isProtocol=="false" && results[0].isFundAccount=="true"){
						investorAgreementTips(results[0],paramMap,function(paramList,data) {
							function399902(paramList,orderCallBack);
						});
					}
					
					//已签署协议、已开户
					else{
						if(orderCallBack){
							orderCallBack();
						}
					}
				}else{
					if(orderCallBack){
						orderCallBack();
					}
				}
			} else {
				$.alert(data.error_info,function(){
					if(orderCallBack){
						orderCallBack();
					}
				});
			}
		},{"isLastReq":true,"isShowWait":true,
			"timeOutFunc":function(){
				$.hidePreloader();
				if(orderCallBack){
					orderCallBack();
				}
			},"errorFunc":function(){
				$.hidePreloader();
				if(orderCallBack){
					orderCallBack();
				}
			},
		});
	}
	
	/*
	*  签署协议
	* paramList 入参
	* orderCallBack	下单方法
	* isOpenAccount true为需要开户
	* */
	function function399902(paramList,orderCallBack,isOpenAccount){
		service_fund.function399902(paramList, function(data){//签署协议
			if(data.error_no == 0) {
				if(isOpenAccount){
					fundOpenAccount(paramList,orderCallBack);//开户
				}else{
					if(orderCallBack){
						orderCallBack();//下单
					}
				}
			}else{
				//签署失败不能下单
				$.alert(data.error_info);
			}
		},{"isLastReq":true,"isShowWait":true,
			"timeOutFunc":function(){//签署失败不能下单
				$.hidePreloader();
			},"errorFunc":function(){//签署失败不能下单
				$.hidePreloader();
			},
		});
	}
	
	/*
	*  开户
	* paramList 入参
	* orderCallBack	下单方法
	* */
	function fundOpenAccount(paramList,orderCallBack){
		service_fund.fundOpenAccount(paramList, function(data){//签署协议
			if(data.error_no == 0) {
				accountOpenSuccessBox(orderCallBack);//展示开户弹框，并下单
			}else{
				$.alert(data.error_info);
			}
		},{"isLastReq":true,"isShowWait":true,
			"timeOutFunc":function(){
				$.hidePreloader();//开户失败不能下单
			},"errorFunc":function(){
				$.hidePreloader();//开户失败不能下单
			},
		});
	}
	
	/**
	 * 基金开户确认提示框
	 * @param {Object} theme 提示标题
	 * @param {Object} content 提示内容
	 * @param {Object} determineFunction 点击正确执行函数
	 * @param {Object} cancelFunction 点击取消执行函数
	 * @param {Object} determine 正确按钮语
	 * @param {Object} cancel 取消按钮语
	 * @param {Object} agreementList 协议内容
	 * @param {Object} isShowBtn 设置为灰色
	 */
	function accountOpenConfirm(theme, content, determineFunction, cancelFunction, determine, cancel,param,agreementList,isShowBtn){
		$("#accountOpenTipsBox").remove();
		var pageId = '#'+$.getCurrentPageObj().pageId+" ";
		if(theme && typeof(theme) == "string"){
			theme ="<h3>" +theme+"</h3>";
		}
		if(typeof(content) == "undefined"){
			content = "";
		}
		if(!determine){
			determine = "确认";
		}
		if(!cancel){
			cancel = "取消";
		}
		var css="";
		if(!isShowBtn){
			css="disabled";
		}
		var div='';
		div +='<div id="accountOpenTipsBox" style="position: fixed">';
			div +='<div class="ui dialog-overlay" style="display: block;z-index: 10;"></div>';
			div +='<div class="ui dialog x-dialog-pop" style="z-index: 10;">';
				div +='<div class="dialog-cet">';
					div +='<h3>'+theme+'</h3>' + content ;
				div +='</div>';
				div +='<div class="ui layout dialog-btn">';
					div +='<div class="row-1">';
						div +='<a class="x-btn border cancel" id="cancel">'+ cancel +'</a>';
					div +='</div>';
					div +='<div class="row-1">';
						div +='<a class="x-btn '+css+'" id="determine">'+ determine+'</a>';
					div +='</div>';
				div +='</div>';
			div +='</div>';
		div +='</div>';
		$(pageId).append(div);
		var $content = $(pageId+" #accountOpenTipsBox .x-dialog-pop ._content");
		if($content.height() < 30){
			$content.height(30);
		}
		var $prompt = $(pageId+" #accountOpenTipsBox .dialog-overlay");
		var wHeight = Number($(pageId).height()) * 0.4;
		var topHeight = $prompt.height()/2;
		if(topHeight >= wHeight){
			topHeight = wHeight;
			$content.css({"height": topHeight*2 - 131, "overflow": "auto"});
		}
		$(pageId+" #accountOpenTipsBox").css("position", "static");
		//点击遮罩层
		$.bindEvent($(pageId+" #accountOpenTipsBox .dialog-overlay"), function(e) {
			$("#accountOpenTipsBox").remove();
			var evt = e || window.event;
			evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			evt.preventDefault();
		});
		//确定
		$.bindEvent($(pageId+" #accountOpenTipsBox #determine"), function(e) {
			if(!$(this).hasClass("disabled")){
				$("#accountOpenTipsBox").remove();
				if(determineFunction){
					setTimeout(function(){
						determineFunction(param,agreementList);
					},300);
				}
			}
			var evt = e || window.event;
			evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			evt.preventDefault();
		});
		//取消
		$.bindEvent($(pageId+" #accountOpenTipsBox #cancel"), function(e) {
			$("#accountOpenTipsBox").remove();
			if(cancelFunction){
				setTimeout(function(){
					cancelFunction($content);
				},300);
			}
			var evt = e || window.event;
			evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			evt.preventDefault();
		});
		//查看《证券投资基金投资者权益须知书》
		$.bindEvent($(pageId+" #accountOpenTipsBox .x-notice-text"), function(e) {
			investorAgreementTips(agreementList);
		});
		//本人已知晓并同意上述协议
		$.bindEvent($(pageId+" #accountOpenTipsBox .x-check-text"), function(e) {
			$(this).find(".x-checkbox").toggleClass("checked");
			if($(this).find(".x-checkbox").hasClass("checked")){
				$(pageId + "#determine").removeClass("disabled");
			}else{
				$(pageId + "#determine").addClass("disabled");
			}
		});
	}
	
	/**
	 * 开户成功的弹框
	 */
	function accountOpenSuccessBox(callBack){
		$("#accountOpenSuccessBox").remove();
		var pageId = '#'+$.getCurrentPageObj().pageId;
		var div='';
		div='<div id="accountOpenSuccessBox">';
		div +='<div class="ui dialog-overlay" style="display: block;z-index: 10;"></div>';
		div +='<div class="ui dialog x-dialog-pop x-success-pop" style="z-index: 10;">';
			div +='<div class="dialog-cet mt20">';
				div +='<strong>基金户开通成功</strong>';
			div +='</div>';
			div +='<div class="dialog-btn">';
				div +='<a class="x-btn">确认</a>';
			div +='</div>';
		div +='</div>';
		div +='</div>';
		$(pageId).append(div);
		//确定
		$.bindEvent($(pageId+" #accountOpenSuccessBox .x-btn"), function(e) {
			if(!$(this).hasClass("disabled")){
				$("#accountOpenSuccessBox").remove();
				if(callBack){
					callBack();
				}
			}
			var evt = e || window.event;
			evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			evt.preventDefault();
		});
	}
	
	/**
	 * 证券投资基金投资者权益须知书
	 */
	function investorAgreementTips(agreementList,param,callBack){
		$(pageId+" #investorQuery").remove();
		var pageId = '#'+$.getCurrentPageObj().pageId+" ";
		var div='';
		if(!agreementList){
			agreementList = {};
		}
		div+='<div class="appropriate" id="investorQuery" style="display:block">';
		div+='<header class="header"><div class="top_title"><a href="javascript:void(0);" class="icon_back"></a>';
		div+='<h3>'+agreementList.agreement_title+'</h3>';
		div+='</div></header>';
		div+='<section class="main"><div class="x-notice-page">';
		div+=agreementList.agreement_content;
		div+='</div></section>';
		div+='<div class="x-footer-btn border-top">';
		div+='<a class="x-define-btn">确定</a>';
		div+='</div></div>';
		$(pageId).append(div);
		var mianHeight = $(pageId).height() - $(pageId+" .header").outerHeight(true) - $(pageId+".x-footer-btn").outerHeight(true);
		$(pageId + " section.main .x-notice-page").height(mianHeight).css({"overflow":"auto","-webkit-overflow-scrolling":"touch"});
		setTimeout(function(){
			$.bindEvent($(pageId+" #investorQuery .header .icon_back"), function(e) {
				$(pageId+" #investorQuery").remove();
				var evt = e || window.event;
				evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			});
			$.bindEvent($(pageId+" #investorQuery .x-define-btn"), function(e) {
				$(pageId+" #investorQuery").remove();
				//签署协议，并下单
				if(callBack){
					var paramArr=param||{};
					paramArr.sign_version=agreementList.agreement_version;//签署接口需要协议版本的入参
					callBack(paramArr);
				}
				var evt = e || window.event;
				evt.stopPropagation ? evt.stopPropagation() : (evt.cancelBubble = true);
			});
		},500);
	}
	
    var base = {
		"function399901":function399901,
		"investorAgreementTips":investorAgreementTips,
    };
    module.exports = base;
});