/**
 * 项目相关的公共方法定义在此处
 */
define('trade/scripts/common/project.js',function(require, exports, module) {

    /**
     * 不变的常量配置
     */
    var constants = {
        // 新规债券上海市场二级类型
        "secondTypeArrBySH": ['GBF',/*'DST','DVP',*/'CBF',/*'CCF',*/'CPF'/*,'WIT','TCB'*/],
        // 新规债券深圳市场二级类型
        "secondTypeArrBySZ": ['5','6','7','9','10','11','13','34','35',"BZZQXQ"],
        // 二级证券分类中债券分类
        "bondTypeSecond": ["BKZ","GKZ","BZZQXQ"],
    };

    /**
     * 函数方法
     */
    var functionBody = {
        "getStockType": function(result) {
            var stockType = result[10];
            var type = result[18];
            stockType = stockType + "";
            type = type + "";
            var second_type = result[21];
            var str = "";
            if(second_type && second_type === 'BJS'){
              return '京A';
            }else if(second_type === "BKZ" || second_type === "BZZQXQ"){
                return '京债';
            }else if(second_type === "GKZ"){
                return '股转';
            }
            switch(stockType) {
                case "0":case "2":
                    str = "深A";
                    break;
                case "1":
                    str = "深B";
                    break;
                case "3":case "4":case "19":
                    str = "深基";
                    break;
                case "5":case "8":case "13":case "16":
                    str = "其他";
                    break;
                case "6":case "21":case "22":case "23":case "24":
                    str = "深债";
                    break;
                case "14":case "25":case "26":case "27":case "30":
                    str = "沪债";
                    break;
                case "9":case "66":
                    str = "沪A";
                    if(type=="K") {
                        str = "科创";
                    }
                    break;
                case "10":
                    str = "沪B";
                    break;
                case "11":case "12":case "20":
                    str = "沪基";
                    break;
                case "17":case "31":case "32":case "33":case "34":
                case "35":case "36":case "37":case "38":
                case "39":case "40":case "41":case "42":
                    str = "三板";
                    break;
                case "18":
                    str = "创业";
                    break;
                case "64":case "65":
                    str = "退市";
                    break;
            }
            return str;
        }
    };

    var project = {
        "constants": constants,
        "functionBody": functionBody,
    };
    //暴露对外的接口
    module.exports = project;
});
