/**
 * 公共查询页面的写法
 */
define('trade/scripts/common/publicQuery.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var commonFunc = require("commonFunc");
	var publicService = require("service");
	var service_common = require("service_common");
//	var downslide = new (require("downslide")).Downslide();
	var pagingNum = global.pagingNum;
    var _pageId = "";
    var funcNo = "";
    var paraMap = {};
    var mainHeight = null;
    var slideHeight = null;
    var _history = false;
    var cancel_order = null;
    var _data = {};
	var dataResults = null;
	var intResults = 0;
	var clickEvent = null;
	var listElement = {};
	var listNum = 0;
	var _noData = null;
	var _historyDate = 7;
	var param_map={};
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var slideHeight = null;
	var load_finished=false;
    
	
	/**
     * 初始化
     */
	function init(data, pageId){
		listElement = {};
		listNum = 0;
		if(!pagingNum && data.pagingNum){
			pagingNum = data.pagingNum;
		}
		funcNo = data.funcNo;
		paraMap = $.cloneFun(data.param);
		_data = data.htmlData;
		_history = data.history;
		_historyDate = data.historyDate || 7;
		_noData = data.noData;
		clickEvent = data.clickEvent;
		if(pageId){
			_pageId = pageId;			
		}
		else{
			_pageId = "#"+$.getCurrentPageObj().pageId + " ";
		}
//		downslide.addSlide();
		if(_history){
			$(_pageId + " .date_filter").show();
			if(_history == 2){
				commonFunc.initTimeChoice(_pageId,_historyDate);
			}
			else{
				commonFunc.initTimeChoice(_pageId,_historyDate, true);
			}
		}
		else{
			$(_pageId + " .date_filter").hide();
		}
		cancel_order = $(_pageId+" .cancel_order");
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		mainHeight = common.setMainHeight(_pageId, false);
		var optionContrac= $(_pageId+".optionContrac").height();
		if(optionContrac){
			optionContrac= optionContrac+10;
		}
		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - ($(_pageId + " .main .date_filter").outerHeight(true) || 0) - $(_pageId+".option_search").getMHeight() - $(_pageId+".main_footer").getMHeight()-optionContrac - Number($(_pageId + ".main").css("margin-top").slice(0, -2) || 0);
//		downslide.slideInit(slideHeight,downQuery,pullQuery);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		}
		callsQuery();
	}
	
	function downQuery(data){
		//埋点
		var objectId = $(_pageId+" #wrapper").attr("objectId");
		var actionId = $(_pageId+" #wrapper").attr("actionId");
		common.comStat(objectId,2,actionId,true,{"i_direct": "1","i_type":"1" });
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		} 
		param_map={};
		callsQuery(data);
	}
	
	function pullQuery(data){
		if(pagingNum != 0){
			if($.isValue(dataResults)){
				callsUpHandler();
			}
			else{
				data = data || {};
				var position_str = cancel_order ? cancel_order.find(".part").last().attr("position_str") : "";
				//将搜索框的值加入到查询的入参中，防止上拉时，查询的数据不是输入框中，对应输入的代码数据
				if($.isValue(param_map)){
					for(t in param_map){
						data[t] = param_map[t];
					}
				}
				data["position_str"] = position_str;
				callsQuery(data);
			}
		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			$.closeModal(".picker-modal.modal-in");
//			downslide.loadReload();
			slideRefresh();
			if(cancel_order){
				cancel_order.html("");
				cancel_order.attr("style","");
				listElement = {};
				listNum = 0;
			} 
			callsQuery();
			
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			var objectId = $(this).attr("objectId");  
			var actionId = $(this).attr("actionId");  
			var name = $(this).attr("name");  
			if(objectId && actionId && name){
				common.comStat(objectId,2,actionId,true,{"i_change_name":name,"i_change_to":time1+"-"+time2});
			}
			e.stopPropagation(); // 阻止冒泡
		});
		// 刷新
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			var objectId = $(this).attr("objectId");
			var actionId = $(this).attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_group_name":"手动刷新"});
			backgroundInterface();
			e.stopPropagation();
		});
	}
	
    /**
	 * 委托查询
	 */
	function againQuery(para_map, func_no, data, history, pageId, height,_callback){
		param_map=para_map;
//		downslide.slideDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(func_no){
			funcNo = func_no;
		}
		if($.isValue(data)){
			_data = data;
		}
		if(typeof(history) != "undefined"){
			_history = history;
			if(_history){
				$(_pageId + " .date_filter").show();
				if(_history == 2){
					commonFunc.initTimeChoice(_pageId,_historyDate);
				}
				else{
					commonFunc.initTimeChoice(_pageId,_historyDate, true);
				}
			}
			else{
				$(_pageId + " .date_filter").hide();
			}
		}
		if(pageId){
			_pageId = pageId;
			cancel_order = $(_pageId+" .cancel_order");
		}
		var optionContrac= $(_pageId+".optionContrac").height();
		if(optionContrac){
			optionContrac= optionContrac+10;
		}
		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - ($(_pageId + " .main .date_filter").outerHeight(true) || 0) - optionContrac - Number($(_pageId + ".main").css("margin-top").slice(0, -2) || 0);
//		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - $(_pageId + " .main .date_filter").getMHeight();
		if(height){
			slideHeight = height;
		}
		slideRefresh(para_map);
//		downslide.slideInit(slideHeight,function(){
//			downQuery(para_map);
//		},function(){
//			pullQuery(para_map);
//		},_pageId);
		callsQuery(para_map,_callback);
    }
	
	/**
	 * 委托查询
	 */
	function callsQuery(para_map,_callback){
	 	var userInfo = common.getCurUserInfo();
		var param = $.cloneFun(paraMap);
		param.funcNo = funcNo;
	 	param.entrust_way = global.entrust_way;
	    param.branch_no =  userInfo.branch_no;
	    param.fund_account =  userInfo.fund_account;
	    param.cust_code =  userInfo.cust_code;
	    param.password =  userInfo.password;
	    param.session_id =  userInfo.session_id;
	    
		param.position_str = "";
		param.request_num = pagingNum || "";
		if(_history){
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = new Date(end_time.replaceAll("-", "/"));
			var time2 = new Date(begin_time.replaceAll("-", "/"));
			if(time1 < time2)
			{
			    $.alert("开始日期大于截止日期");
			    slideRefresh();
//			    downslide.slideRefresh();
//			    downslide.hidePullUp();
			    return false;
			}//截止时间
			param.begin_date = begin_time;
		    param.end_date = end_time;
		}
		if($.isValue(para_map)){
			for(t in para_map){
				param[t] = para_map[t];
			}
		}
		$.clearRequest();
		service_common.serviceCommonInvoke($.cloneFun(param),function(data){
			if(funcNo == data.funcNo) queryCallback(data,_callback);
		},
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 超时调用方法
//				downslide.slideRefresh();
//				downslide.loadFinished();
				slideRefresh();
				loadFinished();
				showNoData();
	        },
			"timeOutFunc":function(){ // 超时调用方法
//				downslide.slideRefresh();
//				downslide.loadFinished();
				slideRefresh();
				loadFinished();
				showNoData();
	        }
		});
	}
	
	function showNoData(){
		if(cancel_order && cancel_order.find(".part").length == 0){
			cancel_order.attr("style","");
			common.setNoData(true).height(slideHeight);
//			downslide.hidePullUp();
			if(_noData){_noData()}
		}
	}
	
	/**
	 * 委托查询回调
	 */
	function queryCallback(data,_callback){
		dataResults = null;
		intResults = 0;
		if(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var html = [];
					var i = 0;
					var r = results.length;
					if(r > pagingNum && pagingNum != 0){
						for (; i < r && i < pagingNum; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							 html.push(queryEntrustHTML(results[i]));
						}
						dataResults = results;
						intResults = i;
					}
					else{
						for (; i < r; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							html.push(queryEntrustHTML(results[i]));
						}
						dataResults = null;
						intResults = 0;
					}
					if(r < pagingNum){
						loadFinished();
//						downslide.loadFinished();
					}
					cancel_order.append(html.join(""));
					bindList();
					if(cancel_order.height() <= slideHeight){
						cancel_order.height(slideHeight);
					}
					else{
						cancel_order.attr("style","");
					}
					common.setNoData(false);
					slideRefresh();	
//					downslide.slideRefresh();	
					if(_callback){
						_callback(data.results);
					}
				}else{
					slideRefresh();
					loadFinished();
//					downslide.slideRefresh();
//					downslide.loadFinished();
					showNoData();
				}
			}
			else{
				$.alert(data.error_info);
				slideRefresh();
//				downslide.slideRefresh();
			}
		}
	}
	
	
	    
    function callsUpHandler(){
		var results = dataResults;
		var t = results.length;
		var i = intResults;
		if(results && t > 0 && i < t){
			var html = [];
			for (;i < t && i < (intResults + pagingNum); i++){
				if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
				 html.push(queryEntrustHTML(results[i]));
			}
			intResults = i;
			cancel_order.append(html.join(""));
			bindList();
			if(cancel_order.height() < slideHeight){
				cancel_order.height(slideHeight);
			}
			else{
				cancel_order.attr("style","");
			}
		}
		slideRefresh();
//		downslide.slideRefresh();
		if(intResults == t){
			loadFinished();
//			downslide.loadFinished();
		}
	}
	
	function bindList(){
		if(clickEvent){
			var eId = clickEvent.id;
			var eEvent = clickEvent.event;
			if(eEvent){
				var id = cancel_order.find(".part");
				if(eId){
					id = id.find(eId);
				}
				$.bindEvent(id, function(e){
					var listId = $(this).attr("list_id");
					if(eId){
						listId = $(this).parents("div.part[list_id]").attr("list_id");
					}
					var value = listElement[listId];
					var $this = this;
					eEvent(value , $this, e);
					e.stopPropagation(); // 阻止冒泡
				});
			}
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		listNum++;
		listElement["_e"+listNum] = element;
		var eleHtml = [];
		var top = _data.topDiv;
      	eleHtml.push("<div class=\"part\" list_id=\"_e"+listNum+"\" position_str=\""+element.position_str+"\">");
      	if($.isValue(top)){
      		var css = "";
      		if(top.css){
      			if(typeof(top.css) == "function"){
      				css = top.css(element);
      			}
      			else{
      				css = top.css;
      			}
      		}
      		else{
      			if($.inArray(element.entrust_bs, ["0","2","4","60","62","64","66","68","70","101","103"]) != -1 || $.inArray(element.business_flag, ["20","17"]) != -1){
      				css = "n1";
      			}else if($.inArray(element.entrust_bs, ["1","3","5","61","63","65","67","69","71","102","104"]) != -1 || $.inArray(element.business_flag, ["21","28"]) != -1){
      				css = "n2";
      			}
      		}
	        eleHtml.push("<div class=\"title\">");
	        if(top.entrust){
	        	var tagDiv = pjcs2(element,top.entrust);
	        	if(tagDiv){
	        		eleHtml.push("<span class=\"tag "+css+"\">"+tagDiv+"</span>");
	        	}
	        }
			eleHtml.push("<strong>"+pjcs2(element,top.name)+"</strong><small>"+pjcs2(element,top.code)+"</small>");
	        eleHtml.push("<span class=\"time\">"+ pjcs2(element,top.time)+"</span>");
			eleHtml.push("</div>");
      	}
        eleHtml.push("<ul>");
        var list = _data.liList;
        for(var i = 0; i < list.length; i++){
	    	eleHtml.push("<li style='"+(list[i][2] ? list[i][2] : "")+"'><span>"+pjcs0(element,list[i][0])+" </span><p>"+pjcs1(element,list[i][1])+"</p></li>");
        }
        eleHtml.push("</ul></div>");
		return eleHtml.join("");
	}
	
	/**
	 * 拼接数据 数组0位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs0(element, text){
		return typeof(text) == "function" ? text(element) : text;
	}
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs1(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
		if(value == ""){
			value = "--";
		}
		return value;
	}
	
	
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs2(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
//		if(value == ""){
//			value = "--";
//		}
		return value;
	}
	/**
	 * 销毁
	 */
	function destroy(){
		pagingNum="";
		_pageId = "";
    	funcNo = "";
    	paraMap = {};
    	_history = false;
    	_data = {};
    	slideHeight = null;
		dataResults = null;
		intResults = 0;
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		} 
		cancel_order = null;
//		downslide.slideDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		load_finished=false;
		param_map={};
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller(paramMap){
		var hasPullUp = true;
		if(!global.pagingNum || global.pagingNum == 0){//if(!pagingNum || pagingNum == 0){//期权合约查询有下拉加载样式
			hasPullUp = false;
		}
		var scrollOptions = {
			scrollerHeight: slideHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: hasPullUp, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: true, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				downQuery(paramMap); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
				if(!load_finished){
					pullQuery();
				}else{
					if(myScroller){
						myScroller.refresh();
					}
					loadFinished();
				}
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	function loadFinished(){
		load_finished = true;
		$(_pageId+" .iscroll_pullUp").html("<div class='load_finished'>已经没有数据了</div>");
	};
	function slideRefresh(){
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	};
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"againQuery" : againQuery,
		"destroy": destroy
	};
	module.exports = base;
});