/**
 * 公共查询页面的写法
 */
define('trade/scripts/common/publicQuery2.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var commonFunc = require("commonFunc");
	var publicService = require("service_common");
	var downslide = new (require("downslide")).Downslide();
	var pagingNum = global.pagingNum;
    var _pageId = "";
    var funcNo = "";
    var paraMap = {};
    var mainHeight = null;
    var slideHeight = null;
    var _history = false;
    var cancel_order = null;
    var _data = {};
	var dataResults = null;
	var intResults = 0;
	var clickEvent = null;
	var listElement = {};
	var listNum = 0;
	var _noData = null;
	var _historyDate = 7;
	var _callback = null;
    
	
	/**
     * 初始化
     */
	function init(data, pageId){
		listElement = {};
		listNum = 0;
		if(!pagingNum && data.pagingNum){
			pagingNum = data.pagingNum;
		}
		if(data.pagingNum==0||data.pagingNum==""){
			pagingNum = data.pagingNum;
		}
		funcNo = data.funcNo;
		paraMap = $.cloneFun(data.param);
		_data = data.htmlData;
		_history = data.history;
		_historyDate = data.historyDate || 7;
		_noData = data.noData;
		clickEvent = data.clickEvent;
		_callback = data.callback;
		if(pageId){
			_pageId = pageId;			
		}
		else{
			_pageId = "#"+$.getCurrentPageObj().pageId + " ";
		}
		downslide.addSlide();
		if(_history){
			$(_pageId + " .date_filter").show();
			if(_history == 2){
				commonFunc.initTimeChoice(_pageId,_historyDate);
			}
			else{
				commonFunc.initTimeChoice(_pageId,_historyDate, true);
			}
		}
		else{
			$(_pageId + " .date_filter").hide();
		}
		cancel_order = $(_pageId+" .cancel_order");
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		mainHeight = common.setMainHeight(_pageId, false);
		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - $(_pageId + " .main .date_filter").getMHeight() - $(_pageId + " .main .main_footer").getMHeight()-$(_pageId+".main .dealprice").getMHeight();
		if(pagingNum==0||pagingNum==""){
			downslide.slideInit(slideHeight,downQuery);
		}else{
			downslide.slideInit(slideHeight,downQuery,pullQuery);
		}
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		}
		callsQuery();
	}
	
	function downQuery(data){
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		} 
		callsQuery(data);
	}
	
	function pullQuery(data){
		if(pagingNum != 0){
			if($.isValue(dataResults)){
				callsUpHandler();
			}
			else{
				data = data || {};
				var position_str = cancel_order ? cancel_order.find(".part").last().attr("position_str") : "";
				data["position_str"] = position_str;
				callsQuery(data);
			}
		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			$.closeModal(".picker-modal.modal-in");
			downslide.loadReload();
			if(cancel_order){
				cancel_order.html("");
				cancel_order.attr("style","");
				listElement = {};
				listNum = 0;
			} 
			callsQuery();
			
			// var objectId = $(this).attr("objectId");
			// var actionId = $(this).attr("actionId");
			// var statPa = {
			// 		"tab_id": _pageId,
			// 		"start_date": $(_pageId+" #startDate").text(),
			// 		"end_date": $(_pageId+" #endDate").text()
			// 	};
			// common.stockStat(objectId,2,actionId,statPa);
			
			e.stopPropagation(); // 阻止冒泡
		});
		
		// 刷新
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			backgroundInterface();
			e.stopPropagation();
		});
	}
	
    /**
	 * 委托查询
	 */
	function againQuery(para_map, func_no, data, history, pageId, height){
		downslide.slideDestroy();
		if(func_no){
			funcNo = func_no;
		}
		if($.isValue(data)){
			_data = data;
		}
		if(typeof(history) != "undefined"){
			_history = history;
			if(_history){
				$(_pageId + " .date_filter").show();
				if(_history == 2){
					commonFunc.initTimeChoice(_pageId,_historyDate);
				}
				else{
					commonFunc.initTimeChoice(_pageId,_historyDate, true);
				}
			}
			else{
				$(_pageId + " .date_filter").hide();
			}
		}
		if(pageId){
			_pageId = pageId;
			cancel_order = $(_pageId+" .cancel_order");
		}
		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - $(_pageId + " .main .date_filter").getMHeight() - $(_pageId + " .main .main_footer").getMHeight();
		if(height){
			slideHeight = height;
		}
		downslide.slideInit(slideHeight,function(){
			downQuery(para_map);
		},function(){
			pullQuery(para_map);
		},_pageId);
		callsQuery(para_map);
    }
	
	/**
	 * 委托查询
	 */
	function callsQuery(para_map){
		var userInfo = common.getCurUserInfo();
		var param = $.cloneFun(paraMap);
		param.funcNo = funcNo;
		param.entrust_way = global.entrust_way;
	    param.branch_no =  userInfo.branch_no;
	    param.fund_account =  userInfo.fund_account;
	    param.cust_code =  userInfo.cust_code;
	    param.password =  userInfo.password;
		param.session_id =  userInfo.session_id;
		
		param.position_str = "";
		param.request_num = pagingNum || "";
		if(_history){
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = new Date(end_time.replaceAll("-", "/"));
			var time2 = new Date(begin_time.replaceAll("-", "/"));
			if(time1 < time2)
			{
			    $.alert("开始日期大于截止日期");
			    downslide.slideRefresh();
			    downslide.hidePullUp();
			    return false;
			}//截止时间
			param.begin_date = begin_time;
		    param.end_date = end_time;
		}
		if($.isValue(para_map)){
			for(t in para_map){
				param[t] = para_map[t];
			}
		}
		$.clearRequest();
		if(param.funcNo=="301508"||param.funcNo=="301509"){
			param.request_num = "";
		}
		publicService.serviceCommonInvoke($.cloneFun(param),function(data){
			if(funcNo == data.funcNo) queryCallback(data);
		},
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 超时调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				showNoData();
	        },
			"timeOutFunc":function(){ // 超时调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				showNoData();
	        }
		});
	}
	
	function showNoData(){
		if(cancel_order && cancel_order.find(".part").length == 0){
			cancel_order.attr("style","");
			common.setNoData(true).height(slideHeight);
			downslide.hidePullUp();
			if(_noData){_noData()}
		}
	}
	
	/**
	 * 委托查询回调
	 */
	function queryCallback(data){
		dataResults = null;
		intResults = 0;
		if(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var html = [];
					var i = 0;
					var r = results.length;
					if(r > pagingNum && pagingNum != 0){
						for (; i < r && i < pagingNum; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							 html.push(queryEntrustHTML(results[i]));
						}
						dataResults = results;
						intResults = i;
					}
					else{
						for (; i < r; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							html.push(queryEntrustHTML(results[i]));
						}
						dataResults = null;
						intResults = 0;
					}
					if(r < pagingNum){
						downslide.loadFinished();
					}
					cancel_order.append(html.join(""));
					bindList(results);
					if(cancel_order.height() <= slideHeight){
						cancel_order.height(slideHeight);
					}
					else{
						cancel_order.attr("style","");
					}
					common.setNoData(false);
					downslide.slideRefresh();
				}else{
					downslide.slideRefresh();
					downslide.loadFinished();
					showNoData();
				}
			}
			else{
				$.alert(data.error_info);
				downslide.slideRefresh();
			}
		}
	}
	
	
	    
    function callsUpHandler(){
		var results = dataResults;
		var t = results.length;
		var i = intResults;
		if(results && t > 0 && i < t){
			var html = [];
			for (;i < t && i < (intResults + pagingNum); i++){
				 html.push(queryEntrustHTML(results[i]));
			}
			intResults = i;
			cancel_order.append(html.join(""));
			bindList(results);
			if(cancel_order.height() < slideHeight){
				cancel_order.height(slideHeight);
			}
			else{
				cancel_order.attr("style","");
			}
		}
		downslide.slideRefresh();
		if(intResults == t){
			downslide.loadFinished();
		}
	}
	
	function bindList(data){
		if(clickEvent){
			var eId = clickEvent.id;
			var eEvent = clickEvent.event;
			if(eEvent){
				var id = cancel_order.find(".part");
				if(eId){
					id = id.find(eId);
				}
				$.bindEvent(id, function(e){
					var listId = $(this).attr("list_id");
					if(eId){
						listId = $(this).parents("div.part[list_id]").attr("list_id");
					}
					var value = listElement[listId];
					var $this = this;
					eEvent(value , $this, e);
					e.stopPropagation(); // 阻止冒泡
				}, downslide.clickType());
			}
		}
		if(_callback){
			_callback(data);
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		listNum++;
		listElement["_e"+listNum] = element;
		var eleHtml = [];
		var top = _data.topDiv;
      	eleHtml.push("<div class=\"part\" data-key=\""+pjcs2(element, _data.key)+"\" list_id=\"_e"+listNum+"\" position_str=\""+element.position_str+"\">");
      	if($.isValue(top)){
      		var css = "";
      		if(top.css){
      			if(typeof(top.css) == "function"){
      				css = top.css(element);
      			}
      			else{
      				css = top.css;
      			}
      		}
      		else{
      			if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70","76","102"]) != -1 || $.inArray(element.business_flag, ["20","17"]) != -1 || $.inArray(element.compact_type, ["0"]) != -1){
      				css = "n1";
      			}else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71","77","103"]) != -1 || $.inArray(element.business_flag, ["21","28"]) != -1 || $.inArray(element.compact_type, ["1"]) != -1){
      				css = "n2";
      			}
      		}
	        eleHtml.push("<div class=\"title\">");
	        if(top.entrust){
	        	var tagDiv = pjcs2(element,top.entrust);
	        	if(tagDiv){
	        		eleHtml.push("<span class=\"tag "+css+"\">"+tagDiv+"</span>");
	        	}
	        }
			eleHtml.push("<strong>"+pjcs2(element,top.name)+"</strong><small>"+pjcs2(element,top.code)+"</small>");
	        eleHtml.push("<span class=\"time\">"+ pjcs2(element,top.time)+"</span>");
			eleHtml.push("</div>");
      	}
        eleHtml.push("<ul>");
        var list = _data.liList;
        for(var i = 0; i < list.length; i++){
			var opts = list[i][2], liCla = "";
			if(opts){
				liCla = opts.liCla || '';
			}
	    	eleHtml.push("<li class='"+liCla+"'><span>"+pjcs0(element,list[i][0])+" </span><p>"+pjcs1(element,list[i][1])+"</p></li>");
        }
        eleHtml.push("</ul></div>");
		return eleHtml.join("");
	}
	
	/**
	 * 拼接数据 数组0位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs0(element, text){
		return typeof(text) == "function" ? text(element) : text;
	}
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs1(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
		if(value == ""){
			value = "--";
		}
		return value;
	}
	
	
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs2(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
//		if(value == ""){
//			value = "--";
//		}
		return value;
	}
	/**
	 * 销毁
	 */
	function destroy(){
		_pageId = "";
    	funcNo = "";
    	paraMap = {};
    	_history = false;
    	_data = {};
    	slideHeight = null;
		dataResults = null;
		intResults = 0;
		if(cancel_order){
			cancel_order.html("");
			cancel_order.attr("style","");
			listElement = {};
			listNum = 0;
		} 
		cancel_order = null;
		downslide.slideDestroy();
	}
	
	function slideRefresh(){
		downslide.slideDestroy();
		mainHeight = common.setMainHeight(_pageId, false);
		slideHeight = mainHeight - $(_pageId + " .main .tab_nav").getMHeight() - $(_pageId + " .main .toggle_nav").getMHeight() - $(_pageId + " .main .date_filter").getMHeight() - $(_pageId + " .main .main_footer").getMHeight()-$(_pageId+".main .dealprice").getMHeight();
		if(pagingNum==0||pagingNum==""){
			downslide.slideInit(slideHeight,downQuery);
		}else{
			downslide.slideInit(slideHeight,downQuery,pullQuery);
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"againQuery" : againQuery,
		"slideRefresh":slideRefresh,
		"destroy": destroy
	};
	module.exports = base;
});