/**
 * 统一登入相关的 js
 */
define('trade/scripts/common/tradeSsoLogin.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;

    function function909(paraMap) {
        var common = require("common");
        var commonFunc = require("commonFunc");
        if (paraMap && Object.getOwnPropertyNames(paraMap).length != 0) {
            //统一登入成功后除去交易密码错误，登入超时等提示框
            $("#newTradingTipsBox2").remove();
            $(".modal-in").remove();
            $(".modal-overlay-visible").remove();
            $(".modal").remove();

            //查询登录状态
            var results = ""; // 普通
            var RZRQresults = ""; // 信用
            var optionResults = ""; // 期权

            var paramStock = paraMap.Stock;
            var paramCredit = paraMap.StockRZRQ;
            var paramOption = paraMap.StockOption;

            if (paramStock) {
                if (paramStock && typeof (paramStock) == "string") {
                    paramStock = JSON.parse(paramStock);
                    results = paramStock.results;
                } else {
                    results = paramStock.results;
                }
                if (results && typeof (results) == "string") {
                    results = JSON.parse(results);
                    results = results.results;
                } else {
                    results = results.results;
                }
            }
            if (paramCredit) {
                if (paramCredit && typeof (paramCredit) == "string") {
                    paramCredit = JSON.parse(paramCredit);
                    RZRQresults = paramCredit.results;
                } else {
                    RZRQresults = paramCredit.results;
                }
                if (RZRQresults && typeof (RZRQresults) == "string") {
                    RZRQresults = JSON.parse(RZRQresults);
                    RZRQresults = RZRQresults.results;
                } else {
                    RZRQresults = RZRQresults.results;
                }
            }
            if (paramOption) {
                if (paramOption && typeof (paramOption) == "string") {
                    paramOption = JSON.parse(paramOption);
                    optionResults = paramOption.results;
                } else {
                    optionResults = paramOption.results;
                }
                if (optionResults && typeof (optionResults) == "string") {
                    optionResults = JSON.parse(optionResults);
                    optionResults = optionResults.results;
                } else {
                    optionResults = optionResults.results;
                }
            }
            if (results || RZRQresults || optionResults) {
                var currentPageCode = $.getCurrentPageObj() ? $.getCurrentPageObj().pageCode || "" : "";
                //登录之前必须清空之前的账号，并且不给原生发60403，否则又会退出新登录的账号
                common.clearUserInfo(null, null, true, 'login');

                if (results != undefined) {//判断是否存在普通
                    if (results != "") {
                        $.hidePreloader();
                        results[0]._loginClass = "0";
                        results[0].loginType = "0"; //保存登录类型
                        results[0]._acct_type = "201";
                        results[0].password = paramStock.password; // 保存交易密码
                        results[0]._input_content = results[0].fund_account;
                        results[0]._uniqueness = results[0].cust_code + "|" + results[0].fund_account;
                        common.setCurUserInfo(results[0]);//页面获取的用户信息
                        common.setAccountInfos(results);//权限等信息从这里获取
                        commonFunc.setNewStockAccount(results[0]);//查询股转股东账号
                    }
                }

                if (RZRQresults != undefined) {//判断是否存在两融
                    if (RZRQresults != "") {
                        //保存两融用户信息
                        RZRQresults[0].loginType = "0"; //保存登录类型
                        RZRQresults[0]._loginClass = "1";
                        RZRQresults[0]._acct_type = "202";
                        RZRQresults[0].password = paramCredit.password; // 保存交易密码
                        RZRQresults[0]._input_content = RZRQresults[0].fund_account;
                        RZRQresults[0]._uniqueness = RZRQresults[0].cust_code + "|" + RZRQresults[0].fund_account;
                        common.setCurUserInfo(RZRQresults[0]);//页面获取的用户信息
                        common.setAccountInfos(RZRQresults);//权限等信息从这里获取
                        $("#account_index .credit .unband").show();
                        $("#account_index .credit .openTips").hide();
                    } else {
                        $("#account_index .credit .unband").hide();
                        $("#account_index .credit .openTips").show();
                    }
                } else {
                    $("#account_index .credit .unband").hide();
                    $("#account_index .credit .openTips").show();
                }

                if (optionResults != undefined) {//判断是否存在期权
                    if (optionResults != "") {
                        //保存期权用户信息
                        optionResults[0].loginType = "2"; //保存登录类型
                        optionResults[0]._loginClass = "2";
                        optionResults[0]._acct_type = "204";
                        optionResults[0].password = paramOption.password; // 保存交易密码
                        optionResults[0]._input_content = optionResults[0].fund_account;
                        optionResults[0]._uniqueness = optionResults[0].cust_code + "|" + optionResults[0].fund_account;
                        common.setCurUserInfo(optionResults[0]);//页面获取的用户信息
                        common.setAccountInfos(optionResults);//权限等信息从这里获取
                        $("#account_index .option .unband").show();
                        $("#account_index .option .openTips").hide();
                    } else {
                        $("#account_index .option .unband").hide();
                        $("#account_index .option .openTips").show();
                    }
                } else {
                    $("#account_index .option .unband").hide();
                    $("#account_index .option .openTips").show();
                }

                //当前用户登录的主账户，用于判断原生进入新股申购和银证转账页面
                if (paraMap.main_acct == "204") {
                    sessionStorage.setItem("currentMainAccount", "0");
                } else if (paraMap.main_acct == "202") {
                    sessionStorage.setItem("currentMainAccount", "1");
                } else {
                    sessionStorage.setItem("currentMainAccount", "0");
                }

                //所有数据的json
                var paraMaps = paraMap.param || {};
                if (paraMaps && Object.getOwnPropertyNames(paraMaps).length != 0) {
                    if (paraMaps && typeof (paraMaps) == "string") {
                        paraMaps = JSON.parse(paraMaps);
                    }
                }

                //用户登录时携带的用户数据JSON
                var params = {};
                if ($.device.android) {
                    params = paraMaps.param || {};
                } else {
                    params = paraMaps;
                }
                if (params && Object.getOwnPropertyNames(params).length != 0) {
                    if (params && typeof (params) == "string") {
                        params = JSON.parse(params);
                    }
                }

                //页面跳转携带的json
                var _params = params.param || {};
                if (_params && Object.getOwnPropertyNames(_params).length != 0) {

                    if (_params && typeof (_params) == "string") {
                        _params = JSON.parse(_params);
                    }
                }

                // _params.isFromApp = ($.getPageParam() || {}).isFromApp
                var storageLoginSourceId = $.getSStorageInfo("loginSourceId");//保存在sessionStorage中的登录来源标识
                if (!storageLoginSourceId) {//如果为空，则证明是非当前webview发起的登录，则只做首页状态刷新不做跳转
                    params.topage = "account/index";
                } else {//如果不为空，则判断与登录返回的标识是否相等，如果不相等则只做首页状态刷新不做跳转
                    var loginSourceId = params.loginSourceId;
                    if (storageLoginSourceId != loginSourceId) {
                        params.topage = "account/index";
                    }
                }
                $.setSStorageInfo("loginSourceId", "");//判断结束后需清空sessionStorage登录标识
                if (!params.topage) {
                    params.topage = "account/index";
                } else if (params.topage && (params.topage.indexOf("addIndex") != -1 || params.topage.indexOf("login_router") != -1)) {
                    params.topage = "account/index";
                }

                //切换账号
                if (_params.switchUserInfo) {
                    if (_params.switchUserInfo == "0" || _params.switchUserInfo == "1" || _params.switchUserInfo == "2") {
                        common.switchingCurUser(_params.switchUserInfo);
                    }
                }
                if (params.topage == "account/index") {
                    $.pageRefresh();
                } else if (params.topage.indexOf("ggt") > -1) {
                    if (!common.checkGgtPermission(results[0].fund_account)) {
                        $.pageInit("account/index", 'ggt/noRight');
                    } else {
                        if (currentPageCode == params.topage) {
                            $.pageRefresh();
                        } else {
                            $.pageInit('account/index', params.topage, _params);
                        }
                    }
                }
                //添加股转权限（新三板）
                else if (params.topage.indexOf("third") > -1) {
                    var isLoginIn = $.getSStorageInfo("_isLoginIn");
                    if (isLoginIn && isLoginIn != "false" && isLoginIn.indexOf("stock") != -1) {
                        var _jurisdiction = commonFunc.getJurisdiction();
                        //本地没有缓存权限，则同步查询一次
                        if (!_jurisdiction.IsQuerySuccess) {
                            commonFunc.setJurisdiction(null, function (data) {
                                if (data.IsQuerySuccess != false && data.three_board_rights != "1") {//有返回、无权限
                                    $.pageInit("account/index", "third/thirdJurisdiction");
                                } else {
                                    if (currentPageCode == params.topage) {
                                        $.pageRefresh();
                                    } else {
                                        $.pageInit('account/index', params.topage, _params);
                                    }
                                }
                            })
                        }
                        //无权限
                        else if (_jurisdiction.three_board_rights != "1") {
                            $.pageInit("account/index", "third/thirdJurisdiction");
                        } else {
                            if (currentPageCode == params.topage) {
                                $.pageRefresh();
                            } else {
                                $.pageInit('account/index', params.topage, _params);
                            }
                        }
                    } else {//普通未登录的情况
                        $.pageInit('account/index', 'account/index', {"_loginClass": "0"});
                    }
                }
                    // else if(params.topage.indexOf("third")>-1){
                    // if(!common.checkThirdPermission(results[0].fund_account)){
                    // 		$.pageRefresh();
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',params.topage,_params);
                    // 	}
                // }
                else {
                    if (params.topage.indexOf("credit") > -1 || (params.topage.indexOf("gemAfter") > -1 && _params.switchUserInfo == "1") || _params.switchUserInfo == "1") { // 信用跳转页面验证
                        common.switchingCurUser(1);
                        var userInfo = common.getCurUserInfo();
                        if (userInfo && Object.keys(userInfo).length > 0) {
                            //两融科创板权限校验
                            if (global.account_kcbJurisdiction && params.topage.indexOf("credit/kcb/") == 0) {
                                commonFunc.kcbJurisdiction(1, userInfo, function (_rights) {
                                    if (_rights != "0") {//科创板权限（1无权限，0有权限）
                                        params.topage = "kcb/kcbDistrict";
                                    }
                                    if (currentPageCode == params.topage) {
                                        $.pageRefresh();
                                    } else {
                                        $.pageInit('account/index', params.topage, _params);
                                    }
                                });
                            } else {
                                if (currentPageCode == params.topage) {
                                    $.pageRefresh();
                                } else {
                                    $.pageInit('account/index', params.topage, _params);
                                }
                            }

                        } else {
                            $.pageRefresh();
                        }
                    } else if (params.topage.indexOf("option") > -1) {
                        common.switchingCurUser(2);
                        var userInfo = common.getCurUserInfo();
                        if (userInfo && Object.keys(userInfo).length > 0) {
                            if (currentPageCode == params.topage) {
                                $.pageRefresh();
                            } else {
                                $.pageInit('account/index', params.topage, _params);
                            }
                        } else {
                            $.pageRefresh();
                        }
                    } else {
                        //普通科创板权限校验
                        if (global.account_kcbJurisdiction && params.topage.indexOf("kcb/stock/") == 0) {
                            commonFunc.kcbJurisdiction(_params.switchUserInfo, results[0], function (_rights) {
                                if (_rights != "0") {//科创板权限（1无权限，0有权限）
                                    params.topage = "kcb/kcbDistrict";
                                }
                                if (currentPageCode == params.topage) {
                                    $.pageRefresh();
                                } else {
                                    $.pageInit('account/index', params.topage, _params);
                                }
                            });
                        } else {
                            //新股申购、银证转账
                            if (params.topage.indexOf("shares/oneKeyPurchase") == 0 || params.topage.indexOf("banking/transfer") == 0 || params.topage.indexOf("banking/transferNew") == 0) {
                                var currentMainAccount = sessionStorage.getItem("currentMainAccount");//当前登录的账户
                                _params.param = {"switchUserInfo": currentMainAccount || _params.switchUserInfo}
                            }
                            if (currentPageCode == params.topage) {
                                $.pageRefresh();
                            } else {
                                $.pageInit('account/index', params.topage, _params);
                            }
                        }
                    }
                }
                // commonFunc.newStockConfirmFunc();// 新股弹窗
                var userInfo = common.getCurUserInfo();
                if (userInfo.liquidation_flag == '1' && results[0] && $.isValue(results[0].liquidation_txt)) { // 清算提醒
                    common.singleIConfirm("", userInfo.liquidation_txt || '系统正在清算', function () {
                    }, "我知道了", '', '', {pageId: 'body', contentStyle: 'text-align:left;'});
                }
                //通知原生登录成功
                $.callMessage({
                    "funcNo": "70000",
                    "targetModule": "user_center",
                    "sourceModule": "trade",
                });
            }
        } else {
            $.pageRefresh();
        }
    }

    var base = {
        "function909": function909
    };

    module.exports = base;
});
