/**
 * 普通交易-买入
 */
define('trade/scripts/common/vBscroll.js', function (require, exports, module) {
    require("bScroll");
    var vIscroll = {
        time: getTime()
    };
    var props = {};

    function initScroll(scrollObj) {
        props = scrollObj;
        setTimeout(function () {
            vIscroll.bscroll = BetterScroll.createBScroll(props.warpId, $.extend({
                click: true,
                scrollY: true,
                bounceTime: 800,
                pullDownRefresh: props.pulldown ? {
                    threshold: 60,
                    stop: 60
                } : false,
                pullUpLoad:false,
            },scrollObj));
            vIscroll.bscroll.on('pullingDown', function () {
                props.pullingDownCallback && props.pullingDownCallback();
            })
            // 当 BetterScroll 滚动到 pulldown 的 threshold 阈值区域之内的时候派发，在这个事件内部，你可以做文案初始化的逻辑，比如提示用户“下拉刷新”
            if (props.pulldown) {
                vIscroll.bscroll.on('enterThreshold', function () {
                    $(props.pageId +'.bs_pullDownLabel').html('下拉加载上一页');
                    // 改变图片loading
                    $(props.pageId +'.bs_pullDownIcon').addClass('down');
                });
            }
            // 当 BetterScroll 滚动到 pulldown 的 threshold 阈值区域之外的时候派发。你可以提示用户“手指释放刷新”
            if (props.pulldown) {
                vIscroll.bscroll.on('leaveThreshold', function() {
                    $(props.pageId +'.bs_pullDownLabel').html('释放加载上一页');
                });
            }
            // 是否派发顶部下拉事件，用于下拉刷新
            if (props.pulldown) {
                vIscroll.bscroll.on('pullingDown', function(pos) {
                    $(props.pageId +'.bs_pullDownLabel').html('正在加载上一页');
                });
            }
        }, 100);
    }

    function refresh() {
        if(vIscroll.bscroll){
            vIscroll.bscroll.refresh();
            vIscroll.time = getTime();
            $(props.pageId +'.bs_pullDownTime').html(vIscroll.time);
            $(props.pageId +'.bs_pullDownIcon').removeClass('down');
            setTimeout(function(){
                vIscroll.bscroll.finishPullDown();
            },300);
        }
    }

    function getBScroll() {
        return vIscroll.bscroll;
    }

    function getBsPos(){
        if(vIscroll.bscroll){
            return {
                y:vIscroll.bscroll.y,
                x:vIscroll.bscroll.x
            };
        }else{
            return {};
        }
    }

    function destroy(){
        if(vIscroll.bscroll){
            vIscroll.bscroll.destroy();
            delete vIscroll.bscroll;
        }
    }

    function getTime(){
        // 返回 12:03:01
        var date = new Date();
        return date.getHours() + ':' + (date.getMinutes() < 10?'0' + date.getMinutes():date.getMinutes()) + ':' + (date.getSeconds() < 10?'0' + date.getSeconds():date.getSeconds());
    }

    module.exports = {
        init: initScroll,
        refresh: refresh,
        getBsPos: getBsPos,
        getBScroll: getBScroll,
        destroy:destroy,
    };
});
