/**
 * 信用交易-总资产界面
 */
define('trade/scripts/credit/asset/asset.js', function (require, exports, module) {

    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
	var commonHq = require("commonHq");
    var service_credit = require("service_credit");
    var service_stock = require("service_stock");
    var iscrollUtils = require("iscrollUtils");
    var service_hq = require("service_hq");
    var nativePluginService = require("nativePluginService");
    var keyboard = require("keyboard");
    if (global.hqCallInterface == 1) {
        service_hq = require("service_hqTrade");
    }
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_asset_asset ";
    var userInfo = null;
    var float_yks = 0;
    var hqData = {};
    var position_Timer = null;
    var _callback = true;
    var _openStock = {};
    var isShowWait = true;

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        common.pageBuryingPoint("105234");
        _openStock = {};
        $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
        common.switchingCurUser("1");
        $(_pageId + " .j-data-item strong").html("--");//资产数据
        $(_pageId + " #wcdbbl").html("--");//维持担保比例
        $(_pageId + ".no_more_data").hide();
        var prePageCode = $.getPageParam("prePageCode");
        if (prePageCode && ["credit_order_financingToBuy", "credit_order_financingToSell", "credit_order_ordinaryToBuy", "credit_order_ordinaryToSell"].indexOf(prePageCode) > -1) {
            if (["credit_order_financingToBuy", "credit_order_financingToSell"].indexOf(prePageCode) > -1) {
                $(_pageId + ".tab_list ul li").eq(0).attr("to-page", "credit_order_financingToBuy");
                $(_pageId + ".tab_list ul li").eq(1).attr("to-page", "credit_order_financingToSell");
            } else if (["credit_order_ordinaryToBuy", "credit_order_ordinaryToSell"].indexOf(prePageCode) > -1) {
                $(_pageId + ".tab_list ul li").eq(0).attr("to-page", "credit_order_ordinaryToBuy");
                $(_pageId + ".tab_list ul li").eq(1).attr("to-page", "credit_order_ordinaryToSell");
            }
        }
        common.bindStockEvent($(_pageId + '.tab_nav li'),
            function (pageCode, topage) {
                clearPositionTimer();
                $.pageInit(pageCode, topage, $.getPageParam(), '', true);
            });
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
        commonFunc.getLiquidationInfo(_pageId); //获取清算状态和清算提示信息
    }

    function load() {
        if ($.device.android) { //安卓图标兼容性处理
            $(_pageId + ".j-position-box .guarantee_text em").css("line-height", "0.17rem");
            $(_pageId + ".j-position-box .guarantee_text").css("line-height", "0.4rem");
            $(_pageId + ".j-position-box .guarantee_text").css("padding-top", "0.03rem");
            $(_pageId + ".j-tran-btn").addClass("android");
        }
        var mainHeight = common.setMainHeightNew(_pageId, false);
        $(_pageId + ".trade_second_page").css("min-height", mainHeight);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        jumpPageEvent();
        isShowWait = false;
        queryData();//查询持仓
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //资金负债明细
        $.bindEvent($(_pageId + ".j-data-info a"), function (e) {
            $.pageInit("credit/asset/asset", "credit/query/creditAssetsQuery", {"param": "assert_val"});
            e.stopPropagation();
        });
        //资金负债明细
        $.bindEvent($(_pageId + ".j-position-box .guarantee_text"), function (e) {
            $.pageInit("credit/asset/asset", "account/permissionOpening");
            e.stopPropagation();
        });
    }

    /**
     * 事件绑定
     */
    function jumpPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                clearPositionTimer();
                common.comStat(105239, 2, 103, true, {"i_group_name": "返回"});//埋点
                commonFunc.appThirdBack('credit_asset_asset', function () {
                    $.pageInit("credit/asset/asset", "account/index", {"history": true}, "left", true);
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        }, "tap");

        //转账
        $.bindEvent($(_pageId + "#transfer"), function (e) {
            $(this).unbind(e.type);
            this[e.type] = null;
            clearPositionTimer();
            common.comStat(105243, 2, 103, true, {"i_group_name": "取款"});//埋点
            $.setSStorageInfo("return_page", "credit/asset/asset");
            $.pageInit("credit/asset/asset", "banking/transferNew", {});
            e.preventDefault();
            e.stopPropagation();
        });

        //今日参考盈亏说明
        $.bindEvent($(_pageId + " #jrckyk_div").find("a"), function (e) {
            nativePluginService.function501152({
                "url":global.newFrameUrl + "fintechpages/synthetical/index.html#/public/description?defaultPage=1&switchUserInfo=1",
                "uniqueCode":"PalmHall-public/description",
                "isShowTitleBar":"0",
                "isUseFullScreenH5":"1"
            });
            common.comStat(105244, 2, 103, true, {"i_group_name": "今日参考盈亏"});//埋点
            e.preventDefault();
            e.stopPropagation();
        });
    }

    /**
     * 查询
     */
    function queryData() {
        clearPositionTimer();
        //查询资金账户
        queryCapital();
        _callback = false;
        if (position_Timer == null && global.positionRefreshTime) {
            commonFunc.initCheckTradeTimer();
            position_Timer = window.setInterval(function () {
                if (commonFunc.getTradingTime() && _callback && common.isAppFlag()) {
                    isShowWait = true;
                    queryCapital();
                    _callback = false;
                }
            }, global.positionRefreshTime);//定时刷新
        }
    }

    /**
     * 资金账户查询
     */
    function queryCapital() {
        if (!isShowWait) {
            $.showPreloader("");
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var password = userInfo.password;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "money_type": money_type,
            "is_homepage": "1"
        };
        $(_pageId + ".no_data_box").hide();
        //最后一个为超时处理函数
        service_credit.rzrq_fundQuery(param, queryCapitalCallback,
            {  //传给接口的json格式数据
                "isLastReq": false,
                "isShowWait": false,
                "isShowOverLay": false
            });
    }

    /**
     * 资金账户查询回调
     */
    function queryCapitalCallback(data) {
        queryPosition();
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results != "undefined" && results.length > 0) {
                    var data = results[0];
                    var assert_val = data.assert_val;  //总资产
                    $(_pageId + " #zzc").html((assert_val && assert_val != "--") ? common.numToMoneyType(assert_val, 2) : "--");
                    var per_assurescale_value = data.per_assurescale_value;//维持担保比例
                    $(_pageId + " #wcdbbl").html((per_assurescale_value && per_assurescale_value != "--") ? per_assurescale_value : "--");
                    var market_value = data.market_value;//持仓总市值
                    $(_pageId + " #cczsz").html((market_value && market_value != "--") ? common.numToMoneyType(market_value, 2) : "--");//持仓总市值
                    var enable_bail_balance = data.enable_bail_balance; //可用保证金
                    $(_pageId + " #kybzj").html((enable_bail_balance && enable_bail_balance != "--") ? common.numToMoneyType(enable_bail_balance, 2) : "--");
                    var total_income_balance = data.total_income_balance;
                    if (total_income_balance && total_income_balance != "--") {
                        total_income_balance = Number(total_income_balance);//浮动盈亏
                        var css = "";
                        if (total_income_balance > 0) {
                            css = "ared";
                        } else {
                            css = "agreen";
                        }
                        $(_pageId + " #ccckyk").removeClass("ared").removeClass("agreen").addClass(css).html(common.numToMoneyType(total_income_balance, 2));
                    } else {
                        $(_pageId + " #ccckyk").html("--");
                    }
                    var cash_asset = data.cash_asset;//现金资产
                    $(_pageId + " #xjzc").html((cash_asset && cash_asset != "--") ? common.numToMoneyType(cash_asset, 2) : "--");
                    var fetch_balance = data.fetch_balance;//可取
                    $(_pageId + " #xjkq").html((fetch_balance && fetch_balance != "--") ? common.numToMoneyType(fetch_balance, 2) : "--");
                    var daily_income_balance = data.daily_income_balance;//今日参考盈亏
                    if (daily_income_balance && daily_income_balance != "--") {
                        daily_income_balance = Number(daily_income_balance);
                        var css = "";
                        if (daily_income_balance > 0) {
                            css = "ared";
                        } else {
                            css = "agreen";
                        }
                        $(_pageId + " #jrckyk").removeClass("ared").removeClass("agreen").addClass(css).html(common.numToMoneyType(daily_income_balance, 2));
                    } else {
                        $(_pageId + " #jrckyk").html("--");
                    }
                    //字体缩放
                    $(_pageId + ".j-data-info strong").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 18, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-position-box strong").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize('总资产：'+$(this).text(), 18, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-data-info p").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 14, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-position-box p").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 14, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                } else {
                    $(_pageId + " .j-data-item strong").html("--");//资产数据
                    $(_pageId + " #wcdbbl").html("--");//维持担保比例
                }
            } else {
                if (!isShowWait) {
                    $.hidePreloader();
                }
                $.alert(data.error_info);
            }
        }
        initScroller();
    }

    function queryPosition() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password
        };
        service_credit.cc_query(param, queryPositionCallback, {
            "isLastReq": true,
            "isShowWait": false,
            "isShowOverLay": false,
            "timeOutFunc": function () {    //超时调用方法
                _callback = true;
                $(_pageId + ".no_data_box").show();
                if (!isShowWait) {
                    $.hidePreloader();
                }
                initScroller();
            }
        });
    }


    function queryPositionCallback(data) {
        if (!isShowWait) {
            $.hidePreloader();
        }
        _callback = true;
        var htmlTop = "";
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    float_yks = 0; //浮动盈亏
                    _openStock = $.getSStorageInfo("openStock", false) || {};
                    if (_openStock && typeof (_openStock) == "string") {
                        _openStock = JSON.parse(_openStock);
                    }
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var type = ""
                        var exchange_type = commonHq.getHqMarket(results[i].exchange_type);
                        type = exchange_type + ":" + results[i].stock_code;
                        float_yks += Number(results[i].float_yk);//计数总浮动盈亏
                        var isLastData = false;
                        if (i == results.length - 1) {
                            isLastData = true;
                        }
                        htmlTop += queryPositionHTML_stock(results[i], type, isLastData);
                    }
                    $(_pageId + ".j-position-table table tbody").html(htmlTop);
                    $(_pageId + ".no_data_box").hide();
                    $(_pageId + ".no_more_data").show();
                } else {
                    $(_pageId + ".no_data_box").show();
                }
            } else {
                $.alert(data.error_info);
            }

            //卖出事件
            $.bindEvent($(_pageId + '.j-position-table table .position_data'), function (e) {
                //判断是否被选中
                if ($(this).hasClass("active")) {
                    _openStock = {};
                    $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                    $(this).removeClass("active");
                    $(this).next().hide();
                    var addHeight = 0;
                    addHeight = $(this).next().height();
                    if (myScroller) {
                        var _height = myScroller.y;
                        _height += addHeight;
                        myScroller.scrollTo(0, _height);
                        myScroller.refresh();
                    }
                } else {
                    var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
                    //保存展开的股票
                    var openStock = {
                        "stock_code": $(this).attr("id"),
                        "exchange_type": $(this).attr("exchange_type"),
                        "stock_account": $(this).attr("stock_account"),
                    }
                    $.setSStorageInfo("openStock", JSON.stringify(openStock), false);
                    $(_pageId + ".j-position-table table .position_data").removeClass("active");
                    $(_pageId + ".j-position-table table .j-table-btns").hide();
                    $(this).addClass("active");
                    $(this).next().show();
                    var addHeight = 0;
                    if (myScroller) {
                        if (isNeedScroll) {
                            var _height = myScroller.y;
                            addHeight = $(this).next().height();
                            _height -= addHeight;
                            var maxScrollY = _height;
                            var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
                            _height -= temph;
                            myScroller.scrollTo(0, _height);
                            myScroller.y = _height;
                            myScroller.refresh();
                            myScroller.maxScrollY = maxScrollY;
                        } else {
                            myScroller.refresh();
                        }
                    }
                }
                e.stopPropagation();
            });

            //卖出事件
            $.bindEvent($(_pageId + ".j-position-table table .j-table-btns a"), function (e) {
                _openStock = {};
                $.setSStorageInfo("openStock", JSON.stringify(_openStock), false);
                $(this).parents("tr.j-table-btns").prev().removeClass("active");
                $(this).parents("tr.j-table-btns").prev().next().hide();
                var stock = $(this).parents("tr.j-table-btns").prev();
                var stock_code = stock.attr("id");
                var id = $(this).attr("id");
                var type = stock.attr("type");
                var exchange_type = stock.attr("exchange_type");
                var stock_account = stock.attr("stock_account");
                var market = "";
                var stock_name = stock.attr("stock_name");
                if (type) {
                    market = type.split(":");
                    if (market[0]) {
                        market = market[0];
                    }
                }
                if (id == "buy") {
                    //埋点
                    common.comStat(105242, 2, 204, true, {
                        "i_type": "跳买入",//操作类型
                        "i_exchange_type": exchange_type,//交易市场
                        "i_stock_code": stock_code,//股票代码
                        "i_stock_name": stock_name,//股票名称
                    });
                    $.pageInit("credit/asset/asset", "credit/order/ordinaryToBuy", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account
                    }, "", true);
                } else if (id == "sell") {
                    //埋点
                    common.comStat(105240, 2, 204, true, {
                        "i_type": "跳卖出",//操作类型
                        "i_exchange_type": exchange_type,//交易市场
                        "i_stock_code": stock_code,//股票代码
                        "i_stock_name": stock_name,//股票名称
                    });
                    $.pageInit("credit/asset/asset", "credit/order/ordinaryToSell", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account
                    }, "", true);
                } else if (id == "hq") {
                    //埋点
                    common.comStat(105241, 2, 204, true, {
                        "i_type": "跳行情",//操作类型
                        "i_exchange_type": exchange_type,//交易市场
                        "i_stock_code": stock_code,//股票代码
                        "i_stock_name": stock_name,//股票名称
                    });
                    if (global.callNative) {
                        var param = {
                            "funcNo": "50500",
                            "msgNo": "201",
                            "targetModule": "hqDispatcher",
                            "sourceModule": "trade",
                            "action": "0",
                            "param": {
                                "stockMarket": market,
                                "stockCode": stock_code,
                                "stockName": stock_name,
                            }
                        }
                        var pageCode = $.getCurrentPageObj().pageCode || '';
                        $.setSStorageInfo("go_hq_" + pageCode, true);
                        $.callMessage(param);
                    } else {
                        var stockInfo = {
                            "market": market,
                            "stockCode": stock_code,
                            "stockName": stock_name,
                            "moduleName": "trade"
                        }
                        window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                    }
                } else if (id == "cbj") {
                    common.comStat(105235, 2, 103, true, {"i_group_name": "修改成本价"});//埋点
                    var data = $(this).parents("tr.j-table-btns").prev();
                    var stockCode = data.attr("id"), exchangeType = data.attr("exchange_type"),
                        stockAccount = data.attr("stock_account");
                    var content = "<li><p>证券代码</p>" + stock_code + "</li>" +
                        "<li><p>修改前</p>" + data.attr("cost_price") + "</li>" +
                        "<li><p>币种</p>人民币</li>" +
                        "<li>" +
                        "<div class='CBJinput_box' style='border: 1px solid #dddddd;border-radius: 0.03rem;width: 0.9rem;height: 0.28rem;'><p>修改后</p>" +
                        "<input type='number' js-key='number' class='t1' id='costPrice' custom_keybord='0' maxLength='12'/>" +
                        "</div></li>";
                    common.costPriceiConfirm("成本价修改", content, function success() {
                        if (keyboard) {
                            keyboard.closeKeyPanel();
                        }
                        var costPrice = $(_pageId + "#costPrice").val();
                        if (!costPrice) {
                            $.alert("请输入修改后成本价！");
                            return false;
                        }
                        if (costPrice <= 0.000) {
                            $.alert("成本价格必须大于0.000。");
                            return false;
                        }
                        if (costPrice > 1000000000.000) {
                            $.alert("成本价格必须小于1000000000.000。");
                            return false;
                        }
                        var reg = /^(-?\d*)\.?\d{1,3}$/;
                        if (!reg.test(costPrice)) {
                            $.alert("成本价格只能精确到小数点后3位。");
                            return false;
                        }
                        var param = {
                            "entrust_way": global.entrust_way, // 委托方式  在configuration配置
                            "branch_no": userInfo.branch_no,
                            "fund_account": userInfo.fund_account,
                            "cust_code": userInfo.cust_code,
                            "stock_account": stockAccount,//股东代码
                            "exchange_type": exchangeType,//市场
                            "stock_code": stockCode,//股票代码
                            "cost_price": costPrice,//修改后的成本价
                            "password": userInfo.password
                        };
                        costModification(param);
                        common.comStat(105236, 2, 103, true, {"i_group_name": "提交成本价"});//埋点
                    }, function fail() {
                        if (keyboard) {
                            keyboard.closeKeyPanel();
                        }
                    });
                    if (keyboard) {
                        keyboard.keyInit();
                    }
                }
                e.stopPropagation();
            });
        }
        initScroller();
    }

    //成本价修改
    function costModification(param) {
        service_stock.costModification(param, function (data) {
            if (data.error_no == 0) {
                isShowWait = false;
                queryPosition();//刷新持仓
            } else {
                $.alert(data.error_info);
            }
        }, {
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () {
                initScroller();
            }
        });
    }

    function clearPositionTimer() {
        if (position_Timer != null) {
            window.clearInterval(position_Timer);
        }
        position_Timer = null;
    }

    /**
     * 证券持仓HTML生成
     */
    function queryPositionHTML_stock(element, type, isLastData) {
        var price_digit = 3;
        var eleHtml = "";
        var css = "";
        var float_yk = Number(element.float_yk);//浮动盈亏
        if (float_yk > 0) {
            css = "ared";
        } else if (float_yk < 0) {
            css = "agreen";
        }
        float_yk = float_yk.toFixed(price_digit);
        var active_css1 = "", active_css2 = " style='display: none;'";
        if (_openStock && _openStock.stock_code) {
            if (element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account) {
                active_css1 = "active";
                active_css2 = "";
            }
        }
        var market_value = Number(element.market_value).toFixed(price_digit);
        var float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%";
        var cost_price = Number(element.cost_price).toFixed(price_digit);
        var last_price = Number(element.last_price).toFixed(price_digit);
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        if (isLastData) {
            eleHtml += "<tr class='position_data no_border_bottom" + active_css1 + "' id='" + element.stock_code + "' type='" + type + "' stock_account='" + element.stock_account + "' cost_price='" + Number(element.cost_price).toFixed(price_digit) + "' exchange_type='" + element.exchange_type + "' stock_name='" + element.stock_name + "'>";
        } else {
            eleHtml += "<tr class='position_data " + active_css1 + "' id='" + element.stock_code + "' type='" + type + "' stock_account='" + element.stock_account + "' cost_price='" + Number(element.cost_price).toFixed(price_digit) + "' exchange_type='" + element.exchange_type + "' stock_name='" + element.stock_name + "'>";
        }
        eleHtml += "<td width='25%' ><p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 16, maxWidth + 5)+")'>" + element.stock_name + "</p>";
        eleHtml += "<span style='transform-origin: left;transform:scale("+$.getTransformScale(market_value, 14, maxWidth)+")'>" + market_value + "</span></td>";
        eleHtml += "<td width='25%' ><p class=\"" + css + "\" style='font-size:" + $.getTransformScaleFontSize(float_yk, 16, maxWidth) + "px;'>" + float_yk + "</p>";
        eleHtml += "<p class=\"" + css + "\" style='font-size:" + $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) + "px;'>" + float_yk_per + "</p></td>";
        eleHtml += "<td width='25%' ><p style='font-size:" + $.getTransformScaleFontSize(Number(element.cost_amount), 16, maxWidth) + "px;'>" + Number(element.cost_amount) + "</p>";
        eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(Number(element.enable_amount), 16, maxWidth) + "px;'>" + Number(element.enable_amount) + "</p></td>";
        eleHtml += "<td width='25%' ><p style='font-size:" + $.getTransformScaleFontSize(cost_price, 16, maxWidth) + "px;'>" + cost_price + "</p>";
        eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(last_price, 16, maxWidth) + "px;'>" + last_price + "</p></td>";
        eleHtml += "</tr>";
        eleHtml += "<tr class='j-table-btns' " + active_css2 + ">";
        eleHtml += "<td colspan='4'>";
        eleHtml += "<div class='ui layout j-btns-list'>";
        eleHtml += "<a id='buy' class='row-1 border-right' href='javascript:void(0);'>买入</a>";
        eleHtml += "<a id='sell' class='row-1 border-right' href='javascript:void(0);'>卖出</a>";
        eleHtml += "<a id='hq' class='row-1 border-right' href='javascript:void(0);'>行情</a>";
        eleHtml += "<a id='cbj' class='row-1' href='javascript:void(0);'>成本价</a>";
        eleHtml += "</div>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }


    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height(), // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                isShowWait = false;
                queryData(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
            myScroller.refresh();//解决初始化后页面无法下拉的问题
        } else {
            // myScroller.maxScrollY = vIscrollHeight;
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        commonFunc.clearCheckTradeTimer();
        common.pageBuryingPoint();
        service_credit.destroy();
        _callback = true;
        isShowWait = true;
        clearPositionTimer();
        $(_pageId + " .j-data-item strong").html("--");//资产数据
        $(_pageId + " #wcdbbl").html("--");//维持担保比例
        $(_pageId + " .j-position-table table tbody").html("");//持仓列表
        $(_pageId + ".no_more_data").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
