/**
 * 信用交易-总资产界面
 */
define('trade/scripts/credit/asset/debt.js', function (require, exports, module) {

    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var service_credit = require("service_credit");
    var nativePluginService = require("nativePluginService");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_asset_debt ";
    var userInfo = null;
    var compact_type = "0";//负债类型，0融资;1融券;2其他负债

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        common.pageBuryingPoint("108028");
        common.switchingCurUser("1");
        var prePageCode = $.getPageParam("prePageCode");
        if (prePageCode && ["credit_order_financingToBuy", "credit_order_financingToSell", "credit_order_ordinaryToBuy", "credit_order_ordinaryToSell"].indexOf(prePageCode) > -1) {
            if (["credit_order_financingToBuy", "credit_order_financingToSell"].indexOf(prePageCode) > -1) {
                $(_pageId + ".tab_list ul li").eq(0).attr("to-page", "credit_order_financingToBuy");
                $(_pageId + ".tab_list ul li").eq(1).attr("to-page", "credit_order_financingToSell");
            } else if (["credit_order_ordinaryToBuy", "credit_order_ordinaryToSell"].indexOf(prePageCode) > -1) {
                $(_pageId + ".tab_list ul li").eq(0).attr("to-page", "credit_order_ordinaryToBuy");
                $(_pageId + ".tab_list ul li").eq(1).attr("to-page", "credit_order_ordinaryToSell");
            }
        }
        common.bindStockEvent($(_pageId + '.tab_nav li'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, $.getPageParam(), '', true);
        });
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
        commonFunc.getLiquidationInfo(_pageId); //获取清算状态和清算提示信息
    }

    /**
     * 页面初始化
     */
    function initPage() {
        compact_type = $.getPageParam("compact_type");
        compact_type = compact_type ? compact_type : 0;
        $(_pageId + " .j-data-item strong").html("--");//资产数据
        $(_pageId + " #wcdbbl").html("--");//维持担保比例
        $(_pageId + " .liabilities_tab_list li").removeClass("active");
        $(_pageId + " .liabilities_tab_list li").eq(compact_type).addClass("active");
        $(_pageId + ".no_more_data").hide();
    }

    function load() {
        initPage();
        if ($.device.android) { //安卓图标兼容性处理
            $(_pageId + ".j-position-box .guarantee_text em").css("line-height", "0.17rem");
            $(_pageId + ".j-position-box .guarantee_text").css("line-height", "0.4rem");
            $(_pageId + ".j-position-box .guarantee_text").css("padding-top", "0.03rem");
        }
        var mainHeight = common.setMainHeightNew(_pageId, false);
        $(_pageId + ".trade_second_page").css("min-height", mainHeight);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        jumpPageEvent();
        queryData();//查询持仓
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //资金负债明细
        $.bindEvent($(_pageId + ".j-data-info a"), function (e) {
            $.pageInit("credit/asset/debt", "credit/query/creditAssetsQuery", {"param": "total_debit"});
            e.stopPropagation();
        });

        //资金负债明细
        $.bindEvent($(_pageId + ".j-position-box .guarantee_text"), function (e) {
            $.pageInit("credit/asset/debt", "account/permissionOpening");
            e.stopPropagation();
        });
    }

    /**
     * 事件绑定
     */
    function jumpPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                common.comStat(108037, 2, 103, true, {"i_group_name": "返回"});//埋点
                commonFunc.appThirdBack('credit_asset_dept', function () {
                    $.pageInit("credit/asset/dept", "account/index", {"history": true}, "left", true);
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        }, "tap");

        //负债列表tab切换
        $.bindEvent($(_pageId + ".liabilities_tab_list li"), function (e) {
            compact_type = $(this).attr("type");
            queryData();
            if (compact_type == "0") {
                common.comStat(108029, 2, 103, true, {"i_group_name": "融资负债"});//埋点
            } else if (compact_type == "1") {
                common.comStat(108030, 2, 103, true, {"i_group_name": "融券负债"});//埋点
            } else if (compact_type == "2") {
                common.comStat(108031, 2, 103, true, {"i_group_name": "其他负债"});//埋点
            }
            e.preventDefault();
            e.stopPropagation();
        });
    }

    /**
     * 查询
     */
    function queryData() {
        $.showPreloader("");
        //查询资金账户
        queryCapital();
    }

    /**
     * 资金账户查询
     */
    function queryCapital() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var password = userInfo.password;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "money_type": money_type,
            "is_homepage": "1"
        };
        $(_pageId + ".no_data_box").hide();
        //最后一个为超时处理函数
        service_credit.rzrq_fundQuery(param, queryCapitalCallback,
            {  //传给接口的json格式数据
                "isLastReq": false,
                "isShowWait": false,
                "isShowOverLay": false
            });
    }

    /**
     * 资金账户查询回调
     */
    function queryCapitalCallback(data) {
        queryPosition();
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results != "undefined" && results.length > 0) {
                    var data = results[0];
                    var total_debit = data.total_debit;  //总负债
                    $(_pageId + " #zfz").html((total_debit && total_debit != "--") ? common.numToMoneyType(total_debit, 2) : "--");
                    var per_assurescale_value = data.per_assurescale_value;//维持担保比例
                    $(_pageId + " #wcdbbl").html((per_assurescale_value && per_assurescale_value != "--") ? per_assurescale_value : "--");
                    var fin_compact_balance = data.fin_compact_balance;//融资负债
                    $(_pageId + " #rzfz").html((fin_compact_balance && fin_compact_balance != "--") ? common.numToMoneyType(fin_compact_balance, 2) : "--");
                    var slo_compact_balance = data.slo_compact_balance; //融券负债
                    $(_pageId + " #rqfz").html((slo_compact_balance && slo_compact_balance != "--") ? common.numToMoneyType(slo_compact_balance, 2) : "--");
                    var other_compact_balance = data.other_compact_balance; //其他负债
                    $(_pageId + " #qtfz").html((other_compact_balance && other_compact_balance != "--") ? common.numToMoneyType(other_compact_balance, 2) : "--");
                    var net_asset = data.net_asset;//净资产
                    $(_pageId + " #jzc").html((net_asset && net_asset != "--") ? common.numToMoneyType(net_asset, 2) : "--");
                    var assure_asset = data.assure_asset;//担保资产
                    $(_pageId + " #dbzc").html((assure_asset && assure_asset != "--") ? common.numToMoneyType(assure_asset, 2) : "--");
                    var enable_bail_balance = data.enable_bail_balance;//可用保证金
                    $(_pageId + " #kybzj").html((enable_bail_balance && enable_bail_balance != "--") ? common.numToMoneyType(enable_bail_balance, 2) : "--");
                    //字体缩放
                    $(_pageId + ".j-data-info strong").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 18, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-position-box strong").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 18, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-data-info p").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 14, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                    //字体缩放
                    $(_pageId + ".j-position-box p").each(function (idx, item) {
                        var zoom = $.getTransformScaleFontSize($(this).text(), 14, $(this).parent().width())
                        $(this).css({"font-size": zoom + 'px'});
                    });
                } else {
                    $(_pageId + " .j-data-item strong").html("--");//资产数据
                    $(_pageId + " #wcdbbl").html("--");//维持担保比例
                }
            } else {
                $.hidePreloader();
                $.alert(data.error_info);
            }
        }
        initScroller();
    }

    function queryPosition() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "password": password,
            "query_type": "0",//查询模式   0-未了结
            "compact_type": compact_type,//0融资;1融券;2其他负债
        };
        service_credit.openInterest_Query(param, queryPositionCallback, {
            "isLastReq": true,
            "isShowWait": false,
            "isShowOverLay": false,
            "timeOutFunc": function () {    //超时调用方法
                $(_pageId + ".no_data_box").show();
                $.hidePreloader();
                initScroller();
            }
        });
    }

    function queryPositionCallback(data) {
        $.hidePreloader();
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                $(_pageId + ".liabilities_tab_list li").removeClass("active");
                $(_pageId + ".liabilities_tab_list li").eq(compact_type).addClass("active");
                var results = data.results;
                var htmlTop = "";
                if (compact_type == "0") {
                    htmlTop += "<tr><th>证券/代码</th><th>到期/开仓</th><th>未还</th><th>盈亏</th></tr>";
                } else if (compact_type == "1") {
                    htmlTop += "<tr><th>证券/代码</th><th>到期/开仓</th><th>未还/总负债</th><th>盈亏</th></tr>";
                } else if (compact_type == "2") {
                    htmlTop += "<tr><th style='padding: 0.06rem 0.1rem;'>合约代码</th><th style='padding: 0.06rem 0.1rem;'>到期/开仓</th><th style='padding: 0.06rem 0.1rem;'>未还金额</th></tr>";
                }
                if (results && results.length > 0) {
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var type = ""
                        var exchange_type = results[i].exchange_type
                        if (exchange_type == 0 || exchange_type == 1) {
                            type = "SZ:" + results[i].stock_code;
                        } else if (exchange_type == 2 || exchange_type == 3) {
                            type = "SH:" + results[i].stock_code;
                        }
                        var isLastData = false;
                        if (i == results.length - 1) {
                            isLastData = true;
                        }
                        htmlTop += queryPositionHTML_stock(results[i], type, isLastData);
                    }
                    $(_pageId + ".j-position-table table").html(htmlTop);
                    $(_pageId + ".no_data_box").hide();
                    $(_pageId + ".no_more_data").show();
                } else {
                    $(_pageId + ".j-position-table table").html(htmlTop);
                    $(_pageId + ".no_more_data").hide();
                    $(_pageId + ".no_data_box").show();
                }
            } else {
                $.alert(data.error_info);
            }

            //卖出事件
            $.bindEvent($(_pageId + '.j-position-table table .position_data'), function (e) {
                //判断是否被选中
                if ($(this).hasClass("active")) {
                    $(this).removeClass("active");
                    $(this).next().hide();
                    var addHeight = 0;
                    addHeight = $(this).next().height();
                    if (myScroller) {
                        var _height = myScroller.y;
                        _height += addHeight;
                        myScroller.scrollTo(0, _height);
                        myScroller.refresh();
                    }
                } else {
                    var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
                    $(_pageId + ".j-position-table table .position_data").removeClass("active");
                    $(_pageId + ".j-position-table table .j-table-btns").hide();
                    $(this).addClass("active");
                    $(this).next().show();
                    var addHeight = 0;
                    if (myScroller) {
                        if (isNeedScroll) {
                            var _height = myScroller.y;
                            addHeight = $(this).next().height();
                            _height -= addHeight;
                            var maxScrollY = _height;
                            var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
                            _height -= temph;
                            myScroller.scrollTo(0, _height);
                            myScroller.y = _height;
                            myScroller.refresh();
                            myScroller.maxScrollY = maxScrollY;
                        } else {
                            myScroller.refresh();
                        }
                    }
                }
                e.stopPropagation();
            });

            //卖出事件
            $.bindEvent($(_pageId + ".j-position-table table .j-table-btns a"), function (e) {
                $(this).parents("tr.j-table-btns").prev().removeClass("active");
                $(this).parents("tr.j-table-btns").prev().next().hide();
                var info = $(this).parents("tr.j-table-btns").prev();
                var compact_id = info.attr("compact_id");
                var id = $(this).attr("id");
                var exchange_type = info.attr("exchange_type");
                var stock_account = info.attr("stock_account");
                var stock_code = info.attr("id");
                var stock_name = info.attr("stock_name");
                var market = "";
                if (type) {
                    market = type.split(":");
                    if (market[0]) {
                        market = market[0];
                    }
                }
                if (id == "mqhk") {//卖券还款
                    //埋点
                    common.comStat(108032, 2, 103, true, {"i_group_name": "卖券还款"});//埋点
                    // common.comStat(105242, 2, 204, true, {
                    //     "i_type": "跳卖券还款",//操作类型
                    //     "i_exchange_type": exchange_type,//交易市场
                    //     "i_stock_code": stock_code,//股票代码
                    //     "i_stock_name": stock_name,//股票名称
                    // });
                    $.pageInit("credit/asset/debt", "credit/order/sellTicketsRepayment", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account,
                        "compact_id": compact_id,
                        "compact_type": compact_type
                    });
                } else if (id == "xjhk") {//现金还款
                    //埋点
                    common.comStat(108034, 2, 103, true, {"i_group_name": "现金还款"});//埋点
                    // common.comStat(105242, 2, 204, true, {
                    //     "i_type": "跳现金还款",//操作类型
                    //     "i_exchange_type": exchange_type,//交易市场
                    //     "i_stock_code": stock_code,//股票代码
                    //     "i_stock_name": stock_name,//股票名称
                    // });
                    $.pageInit("credit/asset/debt", "credit/order/cashPayments", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account,
                        "compact_id": compact_id,
                        "compact_type": compact_type
                    });
                } else if (id == "hyls") {//合约流水
                    common.comStat(108033, 2, 103, true, {"i_group_name": "合约流水"});//埋点
                    $.pageInit("credit/asset/debt", "credit/query/singleContractFlowQuery", {
                        "compact_id": compact_id,
                        "compact_type": compact_type
                    });
                } else if (id == "hyzq") {//合约展期
                    var content = "<p>该合约即将到期，请确认是否需要展期？</p>"
                    common.iConfirmNew("合约展期确认", content, function () {
                        var param = {
                            "entrust_way": global.entrust_way,//委托方式
                            "branch_no": userInfo.branch_no,//分支机构
                            "fund_account": userInfo.fund_account,//资产账户
                            "cust_code": userInfo.cust_code,//客户代码
                            "password": userInfo.password,
                            "sessionid": userInfo.session_id,
                            "compact_id_str": compact_id
                        };
                        service_credit.contractExtensionEntrust(param, getStockBuyCallBack);
                    }, function () {
                    }, "确定", "取消");

                } else if (id == "mqhq") {//买券还券
                    //埋点
                    common.comStat(108035, 2, 103, true, {"i_group_name": "买券还券"});//埋点
                    // common.comStat(105242, 2, 204, true, {
                    //     "i_type": "跳现金还款",//操作类型
                    //     "i_exchange_type": exchange_type,//交易市场
                    //     "i_stock_code": stock_code,//股票代码
                    //     "i_stock_name": stock_name,//股票名称
                    // });
                    $.pageInit("credit/asset/debt", "credit/order/buyTicketsRepay", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account,
                        "compact_id": compact_id,
                        "compact_type": compact_type
                    });
                } else if (id == "xqhq") {// 现券还券
                    common.comStat(108036, 2, 103, true, {"i_group_name": "买券还券"});//埋点
                    //埋点
                    // common.comStat(105242, 2, 204, true, {
                    //     "i_type": "跳现金还款",//操作类型
                    //     "i_exchange_type": exchange_type,//交易市场
                    //     "i_stock_code": stock_code,//股票代码
                    //     "i_stock_name": stock_name,//股票名称
                    // });
                    $.pageInit("credit/asset/debt", "credit/order/bondAlsoCoupons", {
                        "code": stock_code,
                        "exchange_type": exchange_type,
                        "market": market,
                        "stock_account": stock_account,
                        "compact_id": compact_id,
                        "compact_type": compact_type
                    });
                }
                e.stopPropagation();
            });
        }
        initScroller();
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        if (data) {
            if (data.error_no == "0") {
                $.alert("展期提交成功");
                queryData();
            } else {
                $.alert(data.error_info);
            }
        }
    }

    /**
     * 证券持仓HTML生成
     */
    function queryPositionHTML_stock(element, type, isLastData) {
        //不展示合约状态compact_status=5(未形成负债）的合约
        var eleHtml = "";
        if (element.compact_status != "5") {
            var price_digit = 3;
            var float_yk = null;
            var css = "";
            if (compact_type == "0") {//融资负债
                float_yk = Number(element.fin_income);//浮动盈亏
                if (float_yk > 0) {
                    css = "ared";
                } else if (float_yk < 0) {
                    css = "agreen";
                }
            } else if (compact_type == "1") {//融券负债
                float_yk = Number(element.slo_income);//浮动盈亏
                if (float_yk > 0) {
                    css = "ared";
                } else if (float_yk < 0) {
                    css = "agreen";
                }
            }
            float_yk = float_yk ? float_yk.toFixed(price_digit) : "--";
            var total_debit = Number(element.total_debit).toFixed(price_digit);
            var maxWidth = ($(window).width() - 30) * 0.25 - 20;
            var stock_name = $.trim(element.stock_name) ? $.trim(element.stock_name) : "--";
            var stock_code = $.trim(element.stock_code) ? $.trim(element.stock_code) : "--";
            var ret_end_date = element.ret_end_date ? element.ret_end_date.replaceAll("-", "/") : "--";
            var open_date = element.open_date ? element.open_date.replaceAll("-", "/") : "--";
            if (compact_type == "0") {
                if (isLastData) {
                    eleHtml += "<tr class='position_data no_border_bottom' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                } else {
                    eleHtml += "<tr class='position_data' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                }
                eleHtml += "<td><p style='transform-origin: left;transform:scale("+$.getTransformScale(stock_name, 16, maxWidth + 5)+")'>" + stock_name + "</p>";
                eleHtml += "<span style='font-size:" + $.getTransformScaleFontSize(stock_code, 14, maxWidth) + "px;'>" + stock_code + "</span></td>";
                eleHtml += "<td><p style='font-size:" + $.getTransformScaleFontSize(ret_end_date, 16, maxWidth + 20) + "px;'>" + ret_end_date + "</p>";
                eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(open_date, 16, maxWidth + 20) + "px;'>" + open_date + "</p></td>";
                var price = Number(element.real_compact_balance) + Number(element.real_compact_fare) + Number(element.real_compact_interest);
                price = price.toFixed(price_digit)
                eleHtml += "<td><p style='font-size:" + $.getTransformScaleFontSize(price, 16, maxWidth) + "px;'>" + price + "</p>";
                eleHtml += "<td><p class='" + css + "' style='transform-origin: left;transform:scale("+$.getTransformScale(float_yk, 16, maxWidth)+")'>" + float_yk + "</p></td>";
                eleHtml += "</tr>";
                eleHtml += "<tr class='j-table-btns' style='display: none;'>";
                eleHtml += "<td colspan='4'>";
                eleHtml += "<div class='ui layout j-btns-list'>";
                eleHtml += "<a id='mqhk' class='row-1 border-right' href='javascript:void(0);'>卖券还款</a>";
                eleHtml += "<a id='xjhk' class='row-1 border-right' href='javascript:void(0);'>现金还款</a>";
                eleHtml += "<a id='hyls' class='row-1' href='javascript:void(0);'>合约流水</a>";
                // if (element.compact_postpone_flag == "0") {
                //     eleHtml += "<a id='hyzq' class='row-1' href='javascript:void(0);'>合约展期</a>";
                // }
                eleHtml += "</div>";
                eleHtml += "</td>";
                eleHtml += "</tr>";
            } else if (compact_type == "1") {
                if (isLastData) {
                    eleHtml += "<tr class='position_data no_border_bottom' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                } else {
                    eleHtml += "<tr class='position_data' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                }
                eleHtml += "<td><p style='transform-origin: left;transform:scale("+$.getTransformScale(stock_name, 16, maxWidth + 5)+")'>" + stock_name + "</p>";
                eleHtml += "<span style='font-size:" + $.getTransformScaleFontSize(stock_code, 14, maxWidth) + "px;'>" + stock_code + "</span></td>";
                eleHtml += "<td><p style='font-size:" + $.getTransformScaleFontSize(ret_end_date, 16, maxWidth + 20) + "px;'>" + ret_end_date + "</p>";
                eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(open_date, 16, maxWidth + 20) + "px;'>" + open_date + "</p></td>";
                eleHtml += "<td><p style='font-size:" + $.getTransformScaleFontSize(element.real_compact_amount, 16, maxWidth) + "px;'>" + element.real_compact_amount + "</p>";
                eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(total_debit, 16, maxWidth) + "px;'>" + total_debit + "</p></td>";
                eleHtml += "<td><p class='" + css + "' style='font-size:" + $.getTransformScaleFontSize(float_yk, 16, maxWidth) + "px;'>" + float_yk + "</p>";
                eleHtml += "</tr>";
                eleHtml += "<tr class='j-table-btns' style='display: none;'>";
                eleHtml += "<td colspan='4'>";
                eleHtml += "<div class='ui layout j-btns-list'>";
                eleHtml += "<a id='mqhq' class='row-1 border-right' href='javascript:void(0);'>买券还券</a>";
                eleHtml += "<a id='xqhq' class='row-1 border-right' href='javascript:void(0);'>现券还券</a>";
                eleHtml += "<a id='hyls' class='row-1' href='javascript:void(0);'>合约流水</a>";
                // if (element.compact_postpone_flag == "0") {
                //     eleHtml += "<a id='hyzq' class='row-1' href='javascript:void(0);'>合约展期</a>";
                // }
                eleHtml += "</div>";
                eleHtml += "</td>";
                eleHtml += "</tr>";
            } else if (compact_type == "2") {
                if (isLastData) {
                    eleHtml += "<tr class='position_data no_border_bottom' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                } else {
                    eleHtml += "<tr class='position_data' id='" + element.stock_code + "' compact_id='" + element.compact_id + "' stock_name='" + stock_name + "' type='" + type + "' exchange_type='" + element.exchange_type + "' stock_account='" + element.stock_account + "'>";
                }
                eleHtml += "<td style='padding: 0.06rem 0.1rem;'><p style='max-width: 150px;white-space: normal;word-break: break-all;'>" + element.compact_id + "</p></td>";
                eleHtml += "<td style='padding: 0.06rem 0.1rem;'><p style='font-size:" + $.getTransformScaleFontSize(ret_end_date, 16, maxWidth + 20) + "px;'>" + ret_end_date + "</p>";
                eleHtml += "<p style='font-size:" + $.getTransformScaleFontSize(open_date, 16, maxWidth + 20) + "px;'>" + open_date + "</p></td>";
                var price = Number(element.real_compact_balance) + Number(element.real_compact_fare) + Number(element.real_compact_interest);
                price = price.toFixed(price_digit)
                eleHtml += "<td style='padding: 0.06rem 0.1rem;'><p style='font-size:" + $.getTransformScaleFontSize(price, 16, maxWidth) + "px;'>" + price + "</p>";
                eleHtml += "</tr>";
                eleHtml += "<tr class='j-table-btns' style='display: none;'>";
                eleHtml += "<td colspan='4'>";
                eleHtml += "<div class='ui layout j-btns-list'>";
                eleHtml += "<a id='xjhk' class='row-1 border-right' href='javascript:void(0);'>现金还款</a>";
                eleHtml += "<a id='hyls' class='row-1' href='javascript:void(0);'>合约流水</a>";
                // if (element.compact_postpone_flag == "0") {
                //     eleHtml += "<a id='hyzq' class='row-1' href='javascript:void(0);'>合约展期</a>";
                // }
                eleHtml += "</div>";
                eleHtml += "</td>";
                eleHtml += "</tr>";
            }
        }
        return eleHtml;
    }


    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryData(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
            myScroller.refresh();//解决初始化后页面无法下拉的问题
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        service_credit.destroy();
        $(_pageId + " .j-data-item strong").html("--");//资产数据
        $(_pageId + " #wcdbbl").html("--");//维持担保比例
        $(_pageId + " .j-position-table table").html("");//持仓列表
        $(_pageId + ".no_more_data").hide();
        compact_type = 0;
        $(_pageId + " .liabilities_tab_list li").removeClass("active");
        $(_pageId + " .liabilities_tab_list li").eq(0).addClass("active");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
