/**
 * 科创板两融交易下单
 */
define('trade/scripts/credit/creditKcbOrder.js', function(require, exports, module) {
	var common = require("common");
	var commonHq = require("commonHq");
	var appropriate = require("appropriate");
	var gconfig = $.config;
	var global = gconfig.global;
	require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var service_creditKcb = require("service_creditKcb");
	var keyboard = require("keyboard");
	var commonTimer = require("commonTimer");
	var commonFunc = require("commonFunc");
	var userInfo = null; // 账号信息
	var stock_info = null;
	var stock_html = null;
	var _pageId = null;
	var _market = null;
	var _orderType = null;
	var _PageParam = {};
	var compactFlag=[];
	var clearMaxNumber=false;
    var market_html_data = {
		"SH" : [
			{"name":"限价委托","id":"0"},
			{"name":"对手方最优价格","id":"70"},
			{"name":"本方最优价格","id":"68"},
			{"name":"最优五档即时成交剩余撤销","id":"64"},
			{"name":"最优五档即时成交剩余转限价","id":"62"},
		],
		"SZ" : [
			{"name":"限价委托","id":"0"},
			{"name":"对手方最优价格","id":"70"},
			{"name":"本方最优价格","id":"68"},
			{"name":"即时成交剩余撤销","id":"4"},
			{"name":"最优五档即时成交剩余撤销","id":"64"},
			{"name":"全额成交或撤销委托","id":"66"},
		]
    };//市价委托的数据
	var entrustType = { // 融资融券委托类型
		"3": "6",
		"4": "7",
		"5": "0",
		"6": "0",
		"7": "7",
		"8": "6",
	};
	var orderName = { // 委托名称
		"3": "融资买入",
		"4": "融券卖出",
		"5": "普通买入",
		"6": "普通卖出",
		"7": "买券还券",
		"8": "卖券还款",
	};
	var okColor = { // 颜色
		"3": "red",
		"4": "blue",
		"5": "red",
		"6": "blue",
		"7": "red",
		"8": "blue",
	};
	//0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
	var _exchange = {
		"0": "0",
		"2": "0",
		"3": "0",
		"4": "0",
		"5": "0",
		"6": "0",
		"7": "0",
		"8": "0",
		"18": "0",
		"19": "0",
		"21": "0",
		"22": "0",
		"23": "0",
		"24": "0",
		"64": "0",
		"1": "1",
		"9": "2",
		"11": "2",
		"12": "2",
		"13": "2",
		"14": "2",
		"15": "2",
		"16": "2",
		"20": "2",
		"25": "2",
		"26": "2",
		"27": "2",
		"30": "2",
		"65": "2",
		"66": "2",
		"10": "3",
		"17": "4",
		"K":"2"//科创板
	};
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _checkoutSuccess = false;
	var _queryHolding = false;
	var _initScroller = null;
	var _functionHolding = null;
	var _singleCallback = null;
	var hqKt = require("minLines");
	var canvasJs = require("canvasJs");
	var _contractLinkage=true;
    var isTimingRefresh = false;

	/**
	 * 设置证券对象是信息参数
	 */
	function ioitStock() {
		var stockInfo = {
			"isHq":false,
			"stockCode": "", // 证券代码
			"stockName": "", // 证券名称
			"stockPrice": "", // 证券价格
			"stockNum": "",
			"upStop": 0, //涨停价
			"downStop": 0, //跌停价
			"latest_price": 0, //最新价
			"stockMaxAmount": 0, //证券最大数
			"price_step": 0.01, // 步长
			"price_digit": 2, // 小数点位数
			"lot_size": 1, //每手数量
			"stock_type": "", //证券类型
			"stock_market": "", //市场代码
			"gear_one": false, //是否启动五档
			"exchange_type": "", //交易市场（交易后台）
			"stock_account": "", // 股东账号 
			"market_price": false, // 是否市价委托
			"delist_info": "", // 退市提示语
			"delist_flag": "", //是否提示标示
			"error_no": null,
			"error_info": null,
	    	"isBond":false,//是否为债券
		};
		return stockInfo;
	}

	function initHtml() {
		stock_html = {
			"hqCanvas": $(_pageId + " .kcb_timeshare"),
			"hqxltb": $(_pageId + " .hqxltb i"),
			"stockCode": $(_pageId + " #stockCode"), // 证券
			"stockName": $(_pageId + " #stockCode").next("span"), // 证券名称
			"stockPrice": $(_pageId + " #stockPrice"), // 证券价格
			"stockNum": $(_pageId + " #stockNum"), // 证券数量
			"upStop": $(_pageId + " #up_stop"), //涨停价
			"downStop": $(_pageId + " #down_stop"), //跌停价
			"latestPrice": $(_pageId + " #latest_price"), //最新价
	    	"stockMaxAmount": $(_pageId + "#maxNumber"),//股票最大数
			"buyGear": $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
			"sellGear": $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
			"total": $(_pageId + " #total"), // 计算金额显示
//			"market_div": $(_pageId+" .kcb_trade_form .input_price a.market"), // 委托方式
//			"market_p": $(_pageId + " #market_list p"),
			"market_p" : $(_pageId+" .kcb_trade_form #entrustWay p"), // 委托方式
			"market_div" : $(_pageId+" .kcb_trade_form #entrustWay"), // 委托方式
			"stockList": $(_pageId + " #stock_list"), // 证券下拉列表
		}
	}

	/**
	 * 数据初始化
	 */
	function dataInit(pageId, orderType, market, initScroller, holding , singleCallback) {
		_initScroller = initScroller;
		_functionHolding = holding;
		_singleCallback = singleCallback;
		_PageParam = $.getPageParam() || {};
		_pageId = pageId;
		if(keyboard){
			keyboard.keyInit(inputVal,function(){
				$(_pageId + " input#kcbStockPrice").triggerFastBlur();
				$(_pageId + " input#stockPrice").triggerFastBlur();
			});
		}
		userInfo = common.getCurUserInfo();
		_orderType = orderType;
		stock_info = ioitStock();
		initHtml();
		_market = market;
		_stockCode = null;
		commonHq.initCheckTradeTimer();
		var stockCode = _PageParam["code"] || _PageParam["stock_code"];
		// 查询个股行情
		if(stockCode){
			$(_pageId + " #stockCode").removeClass("C100");
			$(_pageId + " #stockCode").quzhi(stockCode);
			var market = _PageParam["market"];
			var exchange_type = _PageParam["exchange_type"];
			getStockList(stockCode,market,exchange_type);
		}else{
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});
		}
//		if(_market)marketPrice();
		
		queryHolding();
		if(global.positionRefreshTime){
			commonTimer.setTimer(_pageId, function(){
				if(commonHq.getTradingTime() && _callback && common.isAppFlag()){
					isTimingRefresh = true;
					queryHolding(true);
				}
			}, global.positionRefreshTime);//定时刷新
		}
    }
	
	function inputVal(){
		vailSubmitOrder();
	}
	
	function isBuy(){
		if(_orderType == "3" || _orderType == "5" || _orderType == "7") {
			return true;
		} else {
			return false;
		}
	}
	
	/**
	 * 获取证券信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			var data = stock_html[param].quzhi();
			if(newest && stock_info){
				if(!data || data == "--"){
					stock_info[param] = 0;
				}
				else
				{
					stock_info[param] = data;
				}
			}
			return data;
		} else {
			return '';
		}
	}

	/**
	 * 设置证券信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest) {
		if(stock_html) {
			stock_html[key].quzhi(value);
            if (key == "stockName") {
                //股票名称长度过长缩放
                var maxWidth = (stock_html[key].parent().width() / 2) - 6;
                var zoomValue = $.getMaxFontSize(value, "0.16rem", maxWidth);
                stock_html[key].css({
                    "transform": "scale(" + zoomValue + ")",
                    "white-space": "nowrap",
                    "transform-origin": "left center"
                });
            }
			if(newest && stock_info) {
				if(value == "--") {
					value = 0;
				}
				stock_info[key] = value;
			}
		}
	}

	/**
	 * 市价委托
	 */
//	function marketPrice() {
//		//委托方式选择
//		$.bindEvent($(_pageId+" .kcb_trade_form #entrustWay p"), function(e){
//			$(_pageId + " .five_box ul li").removeClass("active");
//			if(keyboard){
//				keyboard.closeKeyPanel();
//			}
//			var id = stock_html.market_p.attr("id");
//			stock_html.market_p.attr("type",id);
//			e.stopPropagation();
//		});
//	}
	
	/**
	 * 
	 * @param {Object} stockPrice
	 */
	function isQueryMax(stockPrice) {
		clearMaxNumber=false;
		if(stock_info && (isBuy() || !stock_info.exchange_type) && stock_info.stockCode && stockPrice && Number(stockPrice) != 0) {
			queryMaxAmount(stock_info.stockCode, true);
		}
	}
	/**
	 * 事件绑定
	 */
	function elementBindEvent() {

		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e) {
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$(_pageId + " .five_box ul li").removeClass("active");
				var pageCode = $.getCurrentPageObj().pageCode || '';
				var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
				if (global.callNative) {
					if ($.getPageParam("isFromApp")) {
						//ios切换行情
						$.callMessage({
							"funcNo": "50500",
							"msgNo": "205",
							"sourceModule": "trade",
							"targetModule": "app",
							"action": "4",
							"param": {}
						});
					}
					$.pageInit(pageCode, prePageCode, {"_loginClass": "1"}, "left", true);
				} else {
					$.pageInit(pageCode, prePageCode, {"_loginClass": "1"}, "left", true);
				}
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");

		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");

//		$.bindEvent($(_pageId + " .kcb_trade_form .input_code .input_text"), function(e) {
//			$(_pageId + " .five_box ul li").removeClass("active");
//			if(keyboard){
//				if(global.callNative){
//					$(_pageId + " #stockCode").focus();
//					keyboard.popUpKeyboard($(_pageId + " #stockCode"));
//				}
//				else{
//					$(_pageId + " #stockCode").focus();
//					keyboard.popUpKeyboard($(_pageId + " #stockCode"));
//				}
//			}
//			else{
//				$(_pageId + " #stockCode").focus();
//			}
//			e.stopPropagation();
//		});

		$.bindEvent($(_pageId + " #stock_list"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			e.stopPropagation();
		}, "touchstart");
		if(!keyboard) {
			$.bindEvent($(_pageId + " #stockCode"), function(e) {
				stock_html.stockList.show();
				if(global.callNative){ // 同步原生的自选股
					var data = $.callMessage({"moduleName":"self-stock","funcNo": "60100", "searchKey":""});
					var source = "1"; // 渠道来源 0表示搜索码表 1 表示同步的自选股列表
					getStockListCallBack(data, "", source); // 显示证券列表
				}
				e.stopPropagation();
			});
		}
		$.bindEvent($(_pageId+" .kcb_trade_form .input_code .input_text span"), function(e){//输入时股票代码调键盘
			var click = e.type || "click";
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				$(_pageId + " div#stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			else{
				$(_pageId + " #stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			e.stopPropagation();
		});

		// 证券代码输入框监听
		$.bindEvent($(_pageId + " #stockCode"), function(e){ // 该监听方法是为了适配浏览器
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			else{
				var stockCode = $(this).val();
				stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
				stockCode = $.trim(stockCode);
				$(this).val(stockCode);
			}
			var stockCode = $(_pageId + " #stockCode").val();
			//控制证券代码输入，字母控制4位，数字6位
			if(stockCode.length > 4) {
				var vai1 = /^[0-9]+$/;
				if(!vai1.test(stockCode)) {
					stockCode = stockCode.substring(0, 4);
					$(_pageId + " #stockCode").quzhi(stockCode);
				}
			}
			if(stockCode.length == 0) {
				clearBuyMsg();
				$(_pageId + " #stockCode").addClass("C100");
				//买券还券的合约查询
				if(_orderType=="7"){//买券还券
					_singleCallback(stock_info.stockCode,stock_info.exchange_type,stock_info.stock_account);
					if(stock_info.stockCode){
						_contractLinkage=false;
					}else{
						_contractLinkage=true;
					}
				}
			}
			else{
				$(_pageId + " #stockCode").removeClass("C100");
			}
			if(stockCode) {
				if(stockCode != _stockCode) {
					_stockCode = stockCode;
					clearBuyMsg();
					var vai0 = /^[A-Za-z]+$/;
					var vai1 = /^[\u4e00-\u9fa5]+$/;
					if(stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))) { // 当输入的长度大于1 并且为字母的时候
						getStockList(stockCode); // 查询证券列表
					} else if(stockCode.length > 2) { // 当输入的长度大于3的时候
						getStockList(stockCode); // 查询证券列表
					}
				}
			}
			e.stopPropagation();
		}, "input");

		//数量输入
		$.bindEvent($(_pageId + " #stockNum"), function(e) {
			if(keyboard) {
				var key = "";
				if(!global.callNative) {
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d3" || key == "-12"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d2" || key == "-13"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d1" || key == "-14"){
					var num = stock_info.stockMaxAmount;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice, stockNum);
			e.stopPropagation();
		}, "input");

		// 限价价格输入框
		$.bindEvent($(_pageId + " #stockPrice"), function(e) {
			if(keyboard) {
				keyboard.popUpKeyboard($(this), e);
			}
			var stockPrice=$(_pageId + " #stockPrice").val();
			var stockNum = getStockInfo("stockNum");
			// limitingDigit($(this));
			totalValue(stockPrice,stockNum);
			
			if(stock_info) {
				if(stockPrice == "" || Number(stockPrice) == 0){
					if(isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						setStockInfo("stockMaxAmount","--",true);
					}
				}else{
					isQueryMax(stockPrice);
				}
			}
			e.stopPropagation();
		}, "input");

		// 限价价格输入框——失去焦点
		$.bindEvent($(_pageId + " #stockPrice"), function(e) {
//			if(stock_info) {
//				var stockPrice = $(_pageId + " #stockPrice").val();
			// 	if(stockPrice != "" && Number(stockPrice) != 0){
//					stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
//					setStockInfo("stockPrice",stockPrice);
//					}
//				}
			e.stopPropagation();
		}, "blur");
		
		// 科创板价格输入框
		$.bindEvent($(_pageId + " #kcbStockPrice"), function(e){
			if(keyboard) {
				keyboard.popUpKeyboard($(this), e);
			}
			var kcbPrice=$(_pageId + " #kcbStockPrice").val();
			var stockNum = getStockInfo("stockNum");
			kcbPrice = Number(kcbPrice);
			if(kcbPrice > 10000) {//限制最大输入值为10000
				var strPrice=kcbPrice.toString();
				kcbPrice=strPrice.substr(0,strPrice.length - 1) ;
				setStockInfo("stockPrice",kcbPrice);
			}
			// limitingDigit($(this));
			if(stock_info) {
				if(kcbPrice == "" || Number(kcbPrice) == 0){
					if(isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						setStockInfo("stockMaxAmount","--",true);
					}
				}else{
					totalValue(kcbPrice,stockNum);
					isQueryMax(kcbPrice);
				}
			}
			e.stopPropagation();
		},"input");
		
		// 科创板市价价格输入框-失去焦点
		$.bindEvent($(_pageId + " #kcbStockPrice"), function(e) {
		
//			if(stock_info) {
//				var stockPrice = $(_pageId + " #kcbStockPrice").val();
			// 	if(stockPrice != "" && Number(stockPrice) != 0){
//					stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
//					setStockInfo("stockPrice",stockPrice);
//					}
//				}
			e.stopPropagation();
		}, "blur");
		
		// 增加价格
		$.bindEvent($(_pageId + " .input_box.input_value.xj .add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode) {
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
					setStockInfo("stockPrice", 0);
					return false;
				}
				stockPrice = Number(stockPrice);
				var price_step = stock_info.price_step;
				if(stockPrice >= 0 && stockPrice < 999999999) {
					stockPrice = (parseFloat(stockPrice)+parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice", stockPrice);
					totalValue(stockPrice, stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 减少价格
		$.bindEvent($(_pageId + " .input_box.input_value.xj .less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode) {
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
					setStockInfo("stockPrice", 0);
					return false;
				}
				var price_step = stock_info.price_step;
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0) {
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice", stockPrice);
					totalValue(stockPrice, stockNum);
					isQueryMax(stockPrice);
					if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						clearMaxNumber=true;
						setStockInfo("stockMaxAmount","--",true);
					}
				}else{
					if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						clearMaxNumber=true;
						setStockInfo("stockMaxAmount","--",true);
					}
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 增加价格——保护限价
		$.bindEvent($(_pageId + " .input_box.input_value.sj .add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode) {
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
					setStockInfo("stockPrice", 0);
					return false;
				}
				stockPrice = Number(stockPrice);
				var price_step = stock_info.price_step;
				if(stockPrice >= 0 && stockPrice < 10000) {
					stockPrice = (parseFloat(stockPrice)+parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice", stockPrice);
					totalValue(stockPrice, stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 减少价格——保护限价
		$.bindEvent($(_pageId + " .input_box.input_value.sj .less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode) {
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)) {
					setStockInfo("stockPrice", 0);
					return false;
				}
				var price_step = stock_info.price_step;
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0) {
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice", stockPrice);
					totalValue(stockPrice, stockNum);
					isQueryMax(stockPrice);
					if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						clearMaxNumber=true;
						setStockInfo("stockMaxAmount","--",true);
					}
				}else{
					if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						clearMaxNumber=true;
						setStockInfo("stockMaxAmount","--",true);
					}
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 点击涨跌停价格联动
		$.bindEvent($(_pageId + " #up_stop").add($(_pageId + " #down_stop")).add($(_pageId + " #latest_price")), function(e) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).text();
			if(curPrice && curPrice != "--") {
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice", curPrice);
				common.changeFontSize($(_pageId + " #stockPrice"));
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice, stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
		
		// 五档买卖盘联动
		$.bindEvent($(_pageId + " .five_box ul li"), function(e) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).find("span").text();
			if(curPrice && curPrice != "--") {
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
				setStockInfo("stockPrice", curPrice);
				common.changeFontSize($(_pageId + " #stockPrice"));
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice, stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
		
		
		
		// 增加数量
		$.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".add"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum") || "0";
				if(!stockNum || !validatorUtil.isNumberFloat(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum) + stock_info.lot_size;
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
				$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 减少数量
		$.bindEvent($(_pageId + " .kcb_trade_main #stockNum").nextAll(".less"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum");
				if(!stockNum || !validatorUtil.isNumberFloat(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum =  Number(stockNum) - stock_info.lot_size;
				if(stockNum < 0) stockNum = 0;
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
				$(_pageId + " .kcb_trade_main .row_04 p").removeClass("check");
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 仓位选择
		$.bindEvent($(_pageId + " .kcb_trade_main .row_04 p"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				$(this).addClass("check").siblings().removeClass("check");
				var key = $(this).attr("type");
				if(key == "4"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "3"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "2"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "1"){
					var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
					if ( isBuy() ) {
						num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					}
					setStockInfo("stockNum",num+"");
				}
				common.changeFontSize($(_pageId + " #stockNum"));
				var stockNum = $(_pageId + " #stockNum").val();
				var stockPrice = getStockInfo("stockPrice");
				totalValue(stockPrice,stockNum);
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		},"touchstart");
		
		// 下单
		$.bindEvent($(_pageId + " #submitOrder"), function(e) {
			vailSubmitOrder();
		});

		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId), function(e) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			$(_pageId + " .five_box ul li").removeClass("active");
			if(stock_html) {
				stock_html.stockList.hide();
			}
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId + " .hqxltb i"),function(e){
			if($(this).hasClass("xl")){
				stock_html.hqxltb.attr("class","sl");
				stock_html.hqCanvas.show();
				if(_initScroller){
					_initScroller();
				}
			}
			else{
				stock_html.hqxltb.attr("class","xl");
				stock_html.hqCanvas.hide();
				if(_initScroller){
					_initScroller();
				}
			}
			e.stopPropagation();
		});
        //点击分时图
		$.bindEvent($(_pageId + " #hqt"),function(e){
			if(stock_info.stockCode && stock_info.stock_market){
				var pageCode = $.getCurrentPageObj().pageCode || '';
				if(global.callNative){
                    $.setSStorageInfo("go_hq_" + pageCode, true);
                        
                            var param = {
                                "funcNo": "50500",
                                "msgNo": "201",
                                "targetModule":"hqDispatcher",
                                "sourceModule":"trade",
                                "action":"0",
                                "param":{
                                    "stockMarket": stock_info.stock_market,
                                    "stockCode": stock_info.stockCode,
                                    "stockName": stock_info.stockName,
                                }
                            }
                            $.callMessage(param);
                }else{
                    var stockInfo = {
                        "market": stock_info.stock_market,
                        "stockCode": stock_info.stockName,
                        "stockName": stock_info.stockCode,
                        "moduleName" : "trade"
                    }
                    window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                }
			} else{
                $.alert("在行情服务器中没有查询到该只股票的信息");
            }
		});
		
		// 点击涨跌停价
		$.bindEvent($(_pageId + " #up_stop").add($(_pageId + " #down_stop")), function(e){
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var inputVal=$(this).html();
				if(inputVal && validatorUtil.isNumberFloat(inputVal) && inputVal != 0){
					inputVal = Number(inputVal).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",inputVal);
					common.changeFontSize($(_pageId + " #stockPrice"));
					totalValue(inputVal,stockNum);
					isQueryMax(inputVal);
				}
			}
			e.stopPropagation();
		});
		
		// 卖券还款、买券还券切换
		$.bindEvent($(_pageId + " .kcb_splitcont  li"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).addClass("active").siblings().removeClass("active");
			var _index=$(this).index();
			compactFlag=[];
			$(_pageId + " .rule_select").attr("compact_id","");
			$(_pageId+" .stockLiabilities strong").html("--");
			if(_index==0){
				$(_pageId+".subject").hide();
				$(_pageId+".contract").show();
				$(_pageId+" .totalLiabilities").show().siblings(".stockLiabilities").hide();
				$(_pageId+" .totalLiabilitiesAccount").show().siblings(".stockLiabilities").hide();
				if(_orderType=="7"){//买券还券
					_singleCallback(stock_info.stockCode,stock_info.exchange_type,stock_info.stock_account);
				}else if(_orderType=="8"){//卖券还款无筛选
					_singleCallback();
				}
				_initScroller();
			}else{
				$(_pageId+".subject").show();
				$(_pageId+".contract").hide();
				$(_pageId+" .stockLiabilities").show().siblings(".totalLiabilities").hide();
				$(_pageId+" .stockLiabilities").show().siblings(".totalLiabilitiesAccount").hide();
					if(_orderType=="7"){//买券还券
						_singleCallback(stock_info.stockCode,stock_info.exchange_type,stock_info.stock_account,compactFlag);
						if(stock_info.stockCode){
							_contractLinkage=false;
						}else{
							_contractLinkage=true;
						}//查询合约
					}else if(_orderType=="8"){//卖券还款
						_singleCallback();
					}
			}
			e.stopPropagation();
		});
	}

	/**
	 * 限制小数点位数
	 * @param {Object} price
	 */
	function limitingDigit($this) {
		var price_digit = stock_info.price_digit;
		var price = getStockInfo("stockPrice");
		if(price && validatorUtil.isNumberFloat(price)) {
			var cur_arr = (price + "").split(".");
			if(cur_arr.length == 2) {
				if(cur_arr[1].length > price_digit) {
					var price = cur_arr[0] + "." + cur_arr[1].substring(0, price_digit);
					setStockInfo("stockPrice", price)
				}
			}
		}
	}

	//行情列表接口有问题是，输入证券是6位数时直接调用交易接口
	function queryData(stockCode, exchange_type) {
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			queryMaxAmount(stockCode, false, exchange_type);
		}
	}

	//对行情接口返回数据进行处理
	function ListData(data) {
		stock_info.isHq = true;
		var price = data[4] ? data[4]:data[5];
		price = Number(price);
		var stockVal = data[0]; //证券代码
		var stkType = data[2];
		var stkkcbType = data[11];//是否为科创板
		
		var typeObj = commonHq.getHqtypeData(stockVal,stkType);
		stock_info.lot_size = typeObj.lot_size;
		stock_info.price_step = typeObj.price_step;
		stock_info.price_digit = typeObj.price_digit;
		
		$(_pageId + " p.limit em").text(typeObj.unit_name);
		$(_pageId + " .input_num .input_text em").text(typeObj.unit_name);
		
		if(stkkcbType=="K"){
			cdrFlag(stkkcbType,true);
			stock_info.stock_type=stkkcbType;
			//联动返回了，会重新赋值，此设置，是为联动不返回的容错处理
			stock_info.lot_size = 1;//科创板步数为1
			if(stkType=="16"){
				stock_info.price_step = 0.01;
				stock_info.price_digit = 2;
			}
		}else{
			cdrFlag(stkType,true);
			stock_info.stock_type=stkType;
		}
			
		$(_pageId + " #stockCode").removeClass("C100");
		setStockInfo("stockCode", stockVal, true);
		_stockCode = stockVal;
		setStockInfo("stockName",data[1],true); // 证券现价
		
		if(data[8] == "1"){
			$.hidePreloader();
			$.alert("该证券已停牌");
		}
		entrustMode();
		var p_price = _PageParam["price"] || _PageParam["entrust_price"];
		if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
			price = Number(p_price);
		}
		setStockInfo("stockPrice",price.toFixed(stock_info.price_digit)); // 证券现价
		setStockInfo("upStop",$.transferText(data[6],stock_info.price_digit),true); // 证券现价
		setStockInfo("downStop",$.transferText(data[7],stock_info.price_digit),true); // 证券现价
		setStockInfo("latestPrice",$.transferText(data[4],stock_info.price_digit),true); // 最新价
		if(data[6]){
			$(stock_html.upStop).addClass("ared");
		}
		if(data[7]){
			$(stock_html.downStop).addClass("agreen");
		}
		
		stock_info.stock_market = data[3];
//		stock_html.hqxltb.attr("class","xl").show();
		var list = stock_info.stock_market + ":" + stock_info.stockCode;
		hqKt.minLineFunc(_pageId, _pageId + " #hqt", list,$(_pageId).width() - 10,160);
		
		stock_info.gear_one = true;
		setFifthOrder();

		_fifthCallback = false;
		commonTimer.setTimer(_pageId+"Hqwd", function(){
			if(commonHq.getTradingTime() && _fifthCallback && common.isAppFlag()){
				setFifthOrder();
				_fifthCallback = false;
			}
		}, (global.refreshTime || 5000)); //定时刷新

		if(_market) {
			var Obj = {};
			if(stock_info.stock_market == "SH" && market_html_data && market_html_data.SH) {
				if(stock_html.market_p.attr("category") != "SH") {
					stock_html.market_p.attr("id", "").html("<em style='color: #ccc;'>请选择委托方式</em>");
				}
				Obj = market_html_data.SH;
			}
			else if(stock_info.stock_market == "SZ" && market_html_data && market_html_data.SZ)
			{
				if(stock_html.market_p.attr("category") != "SZ"){
					stock_html.market_p.attr("id","").html("<em style='color: #ccc;'>请选择委托方式</em>");
				}
//				if(global.serverConfig == "3"){
//					market_html_data.SZ = market_html_data.SZ.replace("64","95");
//				}
				Obj = market_html_data.SZ;
			}
 			common.selectList($(stock_html.market_div),'<span class="a03">选择委托方式</span>',Obj,function(obj){
	 			if(_orderType=="4") {//融卖不支持市价委托
					$.alert("融券卖出不支持市价委托");
					return false;
				}
	 			stock_html.market_p.text(obj.name).attr("id",obj.id);
				stock_html.market_p.attr("type",obj.id);
				if(obj.id=="0"){//限价委托
					UIchange(true);
				}else{
					UIchange();
				}
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum");
				totalValue(stockPrice,stockNum);
				isQueryMax(stockPrice);
	 		},function(){
	 			$.bindEvent($("#selectList h1.titlehsea span.a03"), function(e){
					var page = _pageId.replaceAll("_","/").replaceAll("#","").replaceAll(" ","");
					$.pageInit(page, "stock/stockExplain");
					e.stopPropagation();
				});
	 		});
		}
		entrustChange();
		//证券联动,查询证券信息，最大可买
		if(keyboard) {
			keyboard.closeKeyPanel();
		}
		queryMaxAmount(stockVal);
	}

	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(stockCode,market,exchange_type){
		if(stockCode != ""){
			var param = {
						"stockCode": stockCode,
						"market": market,
						"exchange_type": exchange_type
				};
            $.clearRequest();
			commonHq.getkcbStockList(param,stock_html.stockList,
				function(data){
					ListData(data);
				},
				function(data){
					queryData(data.stockCode,data.exchange_type);
				}
			);
		}
	}
	
	
	//五档买卖盘
	function setFifthOrder(){
		var market = stock_info.stock_market, stockCode = stock_info.stockCode;
		if(market && stockCode){
			var stock_list = market+":"+stockCode
			commonHq.getFifthOrder(stock_list,function(results){
				var price_digit = stock_info.price_digit;
				//start 填充分时图上面的的最新价等数据
				$(_pageId + ".kcb_timeshare .row_01 strong").text(results[1]);
				var kcb_timeshareEm = $(_pageId + ".kcb_timeshare .row_01 em");
				var r35=results[35];
				if(results[35]){
					r35 = (Number(results[35])).toFixed(price_digit);//内盘
				}
				kcb_timeshareEm.text((Number(results[30])).toFixed(price_digit)+ " " + r35 + " " + (Number(results[36])*100).toFixed(2)+"%");
				if(r35 > 0){
					kcb_timeshareEm.attr("class","ared");
				}
				else if(r35 < 0){
					kcb_timeshareEm.attr("class","agreen");
				}
				else{
					kcb_timeshareEm.attr("class","");
				}
				//end 填充分时图上面的的最新价等数据
				
				_fifthCallback = true;
				var yesProfit = results[26];
				if(stock_info.gear_one){
					var fifthOne = "";
					var presentPrice = results[30];
					if(isBuy()){
						fifthOne = results[10] || results[16];
					}else{
						fifthOne = results[16] || results[10];
					}
					if(presentPrice != 0 && (fifthOne == 0 || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)){
						fifthOne = presentPrice;
					}
					fifthOne = Number(fifthOne).toFixed(price_digit);
					var p_price = _PageParam["price"] || _PageParam["entrust_price"];
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						fifthOne  = Number(p_price).toFixed(price_digit);
					}
					setStockInfo("stockPrice",fifthOne); // 证券现价
					common.changeFontSize($(_pageId + " #stockPrice"));
					stock_info.gear_one = false;
				}
				//卖五档盘颜色集合
				for(var i = 0 ; i < 5 ; i ++){
					addColor(stock_html.buyGear.eq(i),results[16+i],yesProfit,results[21+i],price_digit);
					addColor(stock_html.sellGear.eq(i),results[6+i],yesProfit,results[11+i],price_digit);
				}
	
			},function(){
				_fifthCallback = true;
			});
		}
	}

	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div, price, yesProfit, num, price_digit) {
		var prices = div.find("span");
		var nums = div.find("em");
		yesProfit = Number(yesProfit).toFixed(price_digit);
		yesProfit = Number(yesProfit);
		price = Number(price).toFixed(price_digit);
		if(Number(price) == 0){
			prices.text("--").attr("class","");
		}
		else if(Number(price) > Number(yesProfit)){
			prices.text(price).attr("class","ared");
		}
		else if(Number(price) < Number(yesProfit))
		{
			prices.text(price).attr("class","agreen");
		}
		else
		{
			prices.text(price).attr("class","");
		}
		if(num == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(num >= 100000){
			nums.text((num * 0.0001).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}

	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(stockCode, isMax, exchange) {
		stock_html.stockList.html("");
		$.hidePreloader();
		var stock_price = getStockInfo("stockPrice");
		var entrust_bs = _PageParam["entrust_bs"];
		if(!entrust_bs){
			entrust_bs = "0";
			if(stock_info.market_price) {
				if(stock_html.market_p.attr("id")) {
					entrust_bs = stock_html.market_p.attr("type");
				}
			}
			if(!isBuy()) {
				entrust_bs = (Number(entrust_bs) + 1) + "";
			}
		}
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no; //分支机构
		var fund_account = userInfo.fund_account; //资产账户
		var cust_code = userInfo.cust_code; //客户代码
		var session_id = userInfo.session_id;
		var stock_code = stockCode;
		var entrust_price = stock_price;
		var stock_account = _PageParam["stock_account"] || stock_info.stock_account;
		var exchange_type = exchange || _exchange[stock_info.stock_type + ""] || stock_info.exchange_type;
		var param = {
			"entrust_way": entrust_way,
			"branch_no": branch_no,
			"fund_account": fund_account,
			"cust_code": cust_code,
			"session_id": session_id,
			"entrust_bs": entrust_bs,
			"stock_code": stock_code,
			"entrust_price": entrust_price,
			"stock_account": stock_account,
			"newstock_flag": "",
			"exchange_type": exchange_type,
			"entrust_type": entrustType[_orderType]
		};
		service_creditKcb.stock_link(param, function(data) {
  	  		stock_info.error_no = data.error_no;
  	  		stock_info.error_info = data.error_info;
			$.hidePreloader();
			if(isMax) {
				queryMaxAmountCallBackMax(data);
			} else {
				queryMaxAmountCallBack(data);
			}
			_PageParam = {};
		}, {
			"isLastReq": true,
			"isShowWait": true
		});
	}

	function queryMaxAmountCallBack(data) {
		if(data.error_no == 0) {
			var results = data.results;
			if(results.length > 0) {
				if(results.length == 1) {
					if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
					var price_digit = stock_info.price_digit;
					var exchange_type = results[0].exchange_type;
					stock_info.exchange_type = exchange_type;
					stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
					var stock_code = results[0].stock_code;
					
					var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
					if(buy_unit != 0){
						stock_info.lot_size = buy_unit;
					}
					var point = results[0].point ? Number(results[0].point) : 0;
					if(point != 0){
						var price_step = Math.pow(10,0-point);
						if(stock_code.substring(0,3) == "204"){
							price_step = 0.005;
						}
						stock_info.price_digit = point;
						price_digit = point;
						stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
					}
					if(!stock_info.isHq){
						entrustMode();
						var stock_type = results[0].stock_type;
						stock_info.stock_type=stock_type;
						$(_pageId + " #stockCode").removeClass("C100");
						setStockInfo("stockCode",stock_code,true);
						var p_price = _PageParam["price"] || _PageParam["entrust_price"];
						if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)) {
							results[0].price = p_price
						}
						setStockInfo("stockPrice",Number(results[0].price).toFixed(price_digit));
						common.changeFontSize($(_pageId + " #stockPrice"));
						if(exchange_type == 0 || exchange_type == 1)
						{
							stock_info.stock_market = "SZ";
						}
						else if(exchange_type == 2 || exchange_type == 3)
						{
							stock_info.stock_market = "SH";
							if(global.serverConfig == "3" && stock_type && stock_type.indexOf("Z") == 0){
								$(_pageId + " p.limit em").text("手");
								$(_pageId + " .input_num .input_text em").text("手");
								stock_info.lot_size = 1;
							}
						}
						if(results[0].up_limit != 0) {
							setStockInfo("upStop", Number(results[0].up_limit).toFixed(price_digit), true);
							$(stock_html.upStop).addClass("ared");
						}
						if(results[0].down_limit != 0) {
							setStockInfo("downStop", Number(results[0].down_limit).toFixed(price_digit), true);
							$(stock_html.downStop).addClass("agreen");
						}
						if(results[0].price != 0) {
							setStockInfo("latestPrice",$.transferText(data[4],p_price),true); // 最新价
						}
						
						if(_market){
							var Obj = {};
							if(stock_info.stock_market == "SH" && market_html_data && market_html_data.SH){
								if(stock_html.market_p.attr("category") != "SH"){
									stock_html.market_p.attr("id","").html("<em style='color: #ccc;'>请选择委托方式</em>");
								}
								Obj = market_html_data.SH;
							}
							else if(stock_info.stock_market == "SZ" && market_html_data && market_html_data.SZ)
							{
								if(stock_html.market_p.attr("category") != "SZ"){
									stock_html.market_p.attr("id","").html("<em style='color: #ccc;'>请选择委托方式</em>");
								}
//								if(global.serverConfig == "3"){
//									market_html_data.SZ = market_html_data.SZ.replace("64","95");
//								}
								Obj = market_html_data.SZ;
							}
							
							common.selectList($(stock_html.market_div),'<span class="a03">选择委托方式</span>',Obj,function(obj){
					 			if(_orderType=="4") {//融卖不支持市价委托
									$.alert("融券卖出不支持市价委托");
									return false;
								}
					 			stock_html.market_p.text(obj.name).attr("id",obj.id);
								stock_html.market_p.attr("type",obj.id);
								if(obj.id=="0"){//限价委托
									UIchange(true);
								}else{
									UIchange();
								}
								var stockPrice = getStockInfo("stockPrice");
								var stockNum = getStockInfo("stockNum");
								totalValue(stockPrice,stockNum);
								isQueryMax(stockPrice);
					 		},function(){
					 			$.bindEvent($("#selectList h1.titlehsea span.a03"), function(e){
									var page = _pageId.replaceAll("_","/").replaceAll("#","").replaceAll(" ","");
									$.pageInit(page, "stock/stockExplain");
									e.stopPropagation();
								});
					 		});
						}
						entrustChange();
						cdrFlag(stock_info.stock_type);
					}
					setStockInfo("stockName",results[0].stock_name,true);
					setStockInfo("stockMaxAmount",Number(results[0].stock_max_amount),true);
					stock_info.stock_account = results[0].stock_account;
					stock_info.delist_flag = results[0].delist_flag;
					stock_info.delist_info = results[0].delist_info;

					var p_num = _PageParam["num"] || _PageParam["entrust_amount"];
					if(p_num && p_num != 0 && validatorUtil.isNumeric(p_num)) {
						setStockInfo("stockNum", p_num, true);
					}
					
					if(isKcbStockType(results[0].stock_type)){//非科创板标的，弹出提示，并清空页面
						setStockInfo("stockCode","");// 证券价格
						$(_pageId + " #stockCode").addClass("C100");
						clearBuyMsg();
						$.alert("非科创板标的，请在信用交易模块进行买卖委托");
					}else{
						if([3,4,5].indexOf(_orderType)>=0){
                            //科创板权限开通
                            kcbConfirm(results[0].stock_type,results[0].technology_innovation_rights,results[0].technologyInnovation_cdr_rights);
							commonFunc.popupRightsConfirm(results[0],{checkKzz: true});
						}
					}
				}
				else if(results.length > 1){
					$.hidePreloader();
					var selectHeight = 0.4*results.length;
					if(results.length >= 7){
						selectHeight = 7 * 0.4;
					}
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:" + selectHeight + "rem\">";
					for(var i = 0; i < results.length; i++) {
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">" + results[i].stock_code + "</strong><em>" + results[i].stock_name + "</em></a>";
						listHtml += "<span style=\"display:none;\">" + results[i].exchange_type + "</span></li>";
					};
					listHtml += "</ul>";
					stock_html.stockList.html(listHtml).show();
					$.bindEvent($(_pageId + " .kcb_trade_form .select_box ul li"), function(e) {
						var exchange_type = $(this).find("span").text();
						stock_info.exchange_type = exchange_type;
						var stockCode = $(this).find("strong").text();
						stock_html.stockList.html("");
						queryData(stockCode, exchange_type);
						$(_pageId + " #stockCode").removeClass("C100");
						setStockInfo("stockName", $(this).find("em").text(), true);
						e.stopPropagation();
					});
				}
			}
		} else {
			$.alert(data.error_info);
		}
		
		if(_orderType=="7"){//买券还券
			_singleCallback(stock_info.stockCode,stock_info.exchange_type,stock_info.stock_account,compactFlag);
			_contractLinkage=false;
		}
	}

	function isKcbStockType(stock_type){
		return stock_type!="15" && stock_type!="16" && stock_type!="18" && stock_type!="19" 
	}

	function queryMaxAmountCallBackMax(data) {
		if(data.error_no == 0) {
			var results = data.results;
			if(results.length > 0) {
				var price_digit = stock_info.price_digit;
				if(!clearMaxNumber){
					setStockInfo("stockMaxAmount", Number(results[0].stock_max_amount), true);
				}
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
				stock_info.stock_type = results[0].stock_type || stock_info.stock_type;
				stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
				var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
				if(buy_unit != 0) {
					stock_info.lot_size = buy_unit;
				}
				stock_info.delist_flag = results[0].delist_flag;
				stock_info.delist_info = results[0].delist_info;
				if(isKcbStockType(results[0].stock_type)){//非科创板标的，弹出提示，并清空页面
					setStockInfo("stockCode","");// 证券价格
					$(_pageId + " #stockCode").addClass("C100");
					clearBuyMsg();
				}
			}
		}
		else{
			$.alert(data.error_info);
		}
	}
	
	/*
	 * 带入委托方式的时候，改变价格下拉框
	 */
	function entrustMode(){
		var entrustBs = _PageParam["entrust_bs"];
		if(entrustBs){
			if(entrustBs == "0" || entrustBs == "1"){//限价委托方式
				UIchange(true);
			}else{//市价委托方式
				UIchange();
			}
		}
	}
	
	/*
	 * 委托方式带入到下单页面填充
	 */
	function entrustChange(){
		var entrustBs = _PageParam["entrust_bs"];
		if(entrustBs){
			var entrustName=null;
			if(!isBuy()){
				entrustBs=Number(entrustBs)-1;
			}
			entrustName ={"0":"限价委托","70":"对手方最优价格","68":"本方最优价格","64":"最优五档即时成交剩余撤销","62":"最优五档即时成交剩余转限价","4":"即时成交剩余撤销","66":"全额成交或撤销委托"};
			stock_html.market_p.text(entrustName[entrustBs]).attr("id",entrustBs);
			stock_html.market_p.attr("type",entrustBs);
		}else{
			stock_html.market_p.text("限价委托").attr("id","0");
			stock_html.market_p.attr("type","0");
		}
	}
	
	/*
	 * 页面UI切换的时候
	 */
	function UIchange(isFixedPrice){
		$(_pageId+".row_04 p").removeClass("check");
		if(isFixedPrice){//限价
			$(_pageId + ".sj").hide();
			$(_pageId + ".xj").show();
			stock_html.stockPrice=$(_pageId + " #stockPrice");
			stock_info.market_price = false;
			if(isBuy()){//买入的时候需要切换最大可买
				$(_pageId + " #maxNumber").show();
				$(_pageId + " #kcbMaxNumber").hide();
				stock_html.stockMaxAmount=$(_pageId + " #maxNumber");
				setStockInfo("stockMaxAmount",$(_pageId + " #maxNumber").text(),true);
			}
		}else{//市价
			$(_pageId + ".sj").show();
			$(_pageId + ".xj").hide();
			stock_html.stockPrice=$(_pageId + " #kcbStockPrice");
			stock_info.market_price = true;
			if(isBuy()){//买入的时候需要切换最大可买
				$(_pageId + " #maxNumber").hide();
				$(_pageId + " #kcbMaxNumber").show();
				stock_html.stockMaxAmount=$(_pageId + " #kcbMaxNumber");
				setStockInfo("stockMaxAmount",$(_pageId + " #kcbMaxNumber").text(),true);
			}
		}
	}
	
	/*
	 * 科创板权限提示
	 */
	function kcbConfirm(stock_type,kcb_receipt_rights1,kcb_receipt_rights2){
		if(stock_type =="16" && kcb_receipt_rights2 != "0"){
			$.alert("您的信用账号尚未开通科创板存托凭证权限。请通过已开通权限的账号进行科创板新股申购或交易，如有疑问请致电客服电话400 821 1357进行咨询。");
			// $.alert("您尚未开通科创板存托凭证股东账号权限，如需进行交易，请到业务办理完成对应权限开通。");
		}
	}
	
	//科创板标志
	function cdrFlag(stock_type,isHq){
		var KCBArray = [];
		if(isHq){
			KCBArray = ["K"];
		}else{
			KCBArray = [15,16];
		}
		if(KCBArray.indexOf(stock_type)!=-1){ //科创板
			$(_pageId + ".input_text .logoStyle").show();	
			$(_pageId + ".input_text .logoStyle").addClass("kcbCss");	
			$(_pageId + ".input_text .logoStyle").text("科创");		
		}
		else{
			$(_pageId + ".input_text .cdrCss").hide();
		}
	}
	
	// 计算当前总值
	function totalValue(stockPrice, stockNum) {
		if(stock_html) {
			stock_html.total.text("").hide();
		}
		if(validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			if(stock_info.stock_type !== "" && stock_info.stockCode){
				var amount = commonHq.calculateStockAmount(stockPrice,stockNum,stock_info.stock_type,stock_info.stockCode);
				var text = "(¥"+$.formatMoney(""+amount)+")";
				stock_html.total.text(text).show();// 市价委托的时候点击无效.
			}
		}
	}

	/**
	 * 下单验证
	 * */
	function vailSubmitOrder() {

		var typeText = "买入";
		if(!isBuy()) {
			typeText = "卖出";
		}
		var compact_text = "";
		var compact_id = "";
		if($(_pageId + " .kcb_splitcont li:eq(1)").hasClass("active")) {
			compact_text = "指定合约";
			var compact_id = $(_pageId + " .rule_select").attr("compact_id");
			if(!compact_id || $.trim(compact_id).length == 0) {
				$.alert("请进行指定合约操作");
				return false;
			}
		}

		//验证证券代码输入是否正确
		var stockCode = stock_info.stockCode;
		if(stockCode.length == 0){
			$.alert("请输入正确的证券代码/简拼");
			return false;
		}
		var vai1 = /^[0-9]{6}$/;
		if(!vai1.test(stockCode)) {
			$.alert("证券代码输入错误");
			return false;
		}
		//验证证券价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length <= 0) {
			//科创板市价委托
			if(stock_info.market_price){
				$.alert("请输入保护限价");
			}else{
				$.alert("请输入" + typeText + "价格");
			}
			return false;
		} else if(!validatorUtil.isNumberFloat(stockPrice)) {
			$.alert("请正确输入价格");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount + "";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length <= 0) {
			$.alert("请输入" + typeText + "数量");
			return false;
		} else if(!validatorUtil.isNumberFloat(stockNum)) {
			$.alert("请正确输入数量");
			return false;
		}
		else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
		if(stock_info.error_no !== "0" && stock_info.error_no !== 0){
			$.alert(stock_info.error_info || "查询证券信息失败");
			return false;
		}
		var ts = [];
		//验证最大可买
		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
			ts.push("<em>最大可"+typeText+"为0；</em>");
		}
		else if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
			ts.push("<em>最大可"+typeText+"数量不足；</em>");
		}
		var lots_of = stock_info.lot_size;
		
		if(isBuy()){
			if(stock_info.market_price) {
				if(stockNum > 50000){
					ts.push("<em>市价买入超过5万股；</em>");
				}
				else if(stockNum < 200){
					ts.push("<em>市价买入低于200股；</em>");
				}
			}else{
				if(stockNum > 100000){
					ts.push("<em>限价买入超过10万股；</em>");
				}
				else if(stockNum < 200){
					ts.push("<em>限价买入低于200股；</em>");
				}
			}
		}else{
			if(($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<200) && (stockNum < stockMaxAmount)){
				ts.push("<em>可卖数不足200股，需一次性委托卖出；</em>");
			}
			if(stock_info.market_price) {
				if(stockNum > 50000){
					ts.push("<em>市价卖出超过5万股；</em>");
				}
			}else{
				if(stockNum > 100000){
					ts.push("<em>限价卖出超过10万股；</em>");
				}
			}
		}

		if (isBuy() && ["18", "19"].indexOf(stock_info.stock_type) >= 0 && stock_info.convertible_bonds_prompt) {// 18科创板可转债、19科创板CDR可转债
			ts.push(stock_info.convertible_bonds_prompt)
		}

		var up_stop = stock_info.upStop;
		var down_stop = stock_info.downStop;
		var entrust_bs = "0";
		var tipStrArray = [];
		var tipStr = "<div ><p>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
		tipStrArray.push(["证券名称", "<span style='font-size:" + $.getTransformScaleFontSize(stock_info.stockName, 16, $(window).width() * 0.48) + "px;'>" + stock_info.stockName +  "</span>"]);
		tipStrArray.push(["证券代码", stockCode]);
		if(stock_info.market_price) {
			if(!stock_html.market_p.attr("id") && _orderType!="4") {//融卖不支持市价委托
				$.alert("请选择市价委托方式");
				return false;
			}
			entrust_bs = stock_html.market_p.attr("type");
			tipStrArray.push(["委托方式", stock_html.market_p.text()]);
			tipStrArray.push(["保护限价", stockPrice]);
		} else {
			tipStrArray.push(["委托方式", "限价委托"]);
			tipStrArray.push(["委托价格", stockPrice]);
		}
		tipStrArray.push(["委托数量", stockNum]);
		if(up_stop && up_stop !="--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)){
			ts.push("<em>委托价格超过涨停价；</em>");
		}else if(down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)){
			ts.push("<em>委托价格低于跌停价；</em>");
		}
		tipStr += common.generatePrompt(tipStrArray);
		tipStr+="</div>";
		if (ts.length) {
			if(ts.length > 1){
				for(var i = 0; i < ts.length; i++){
					ts[i] = '<p>'+(i+1) + '.' + ts[i] + '</p>';
				}
			}else{
				ts[0] = '<p>' + ts[0] + '</p>';
			}
			tipStr += "<div class='pop_reminder_text'><h4>温馨提示</h4>" + ts.join("") + "</div>";
		}
		// if(ts){
		// 	tipStr += "<div><span style='color: red;'>"+ts+"</span><br><span class='b'>请确认是否继续以上委托？</span></div>";
		// }	
    // 2021.12.28 个股的交易风险提示需求屏蔽这里的提示 stock_info.delist_flag == "1" && stock_info.delist_info
    common.iConfirm(orderName[_orderType]+"确认", tipStr, function success() {
      if(!isBuy()) {
        entrust_bs = (Number(entrust_bs) + 1) + "";
      }
      var cust_code = userInfo.cust_code; //客户代码
      var fund_account = userInfo.fund_account; //资产账户
      var branch_no = userInfo.branch_no; //分支机构
      var session_id = userInfo.session_id;
      var entrust_way = global.entrust_way; // 委托方式  在configuration配置
      var exchange_type = stock_info.exchange_type;
      var stock_account = stock_info.stock_account;
      var stock_code = stockCode;
      var entrust_price = stockPrice;
      var entrust_amount = stockNum;
      var param = {
        "entrust_way": entrust_way,
        "branch_no": branch_no,
        "fund_account": fund_account,
        "cust_code": cust_code,
        "session_id": session_id,
        "entrust_bs": entrust_bs,
        "exchange_type": exchange_type,
        "stock_account": stock_account,
        "stock_code": stock_code,
        "entrust_price": entrust_price,
        "entrust_amount": entrust_amount,
        "entrust_type": entrustType[_orderType],
        "compact_id": compact_id
      };
      service_creditKcb.entrust_trade(param, getStockBuyCallBack, {
        "isLastReq": false,
        "isShowWait": false,
        "timeOutFunc": function() {
          $.hidePreloader();
        },
        "errorFunc": function() {
          $.hidePreloader();
        }
      });
      if (isBuy()) {
        stock_info.create_by = stock_info.create_by || $.getUUID();
        appropriate.function399932(stock_info)
      }
      $.showPreloaders("请等待...");
    }, function fail() {});

	}

	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data) {
		$.hidePreloader();
		if(data.error_no == 0) {
			var results = data.results;
			if(results && results.length > 0) {
				_checkoutSuccess = true;
//				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号：" + results[0].entrust_no;
				var tipStr = "交易委托已提交！<br>委托编号 "+results[0].entrust_no;
				$.alert(tipStr);
				stock_info.entrust_no = results[0].entrust_no;
				if (isBuy()) {
					appropriate.function399932(stock_info)
				}
			}
			clearBuyMsg();
			setStockInfo("stockCode", ""); // 证券价格
			$(_pageId + " #stockCode").addClass("C100");
			$(_pageId + " .rule_select").attr("compact_id","");
//			$(_pageId + " .rule_select p span").text("请选择");
			queryHolding();
			if(_orderType=="7"||_orderType=="8"){//卖券还款、卖券还券合约下单刷新
				_singleCallback();
			}
		} else {
			$.alert(data.error_info);
			setStockInfo("stockNum","",true); // 证券数量
			stock_html.total.text("").hide();
		}
	}

	/**
	 * 查询持仓数据
	 */
	function queryHolding(isShowWait) {
		if(_functionHolding && typeof(_functionHolding) == "function") {
			_functionHolding(isShowWait);
			//卖出事件
			$.preBindEvent($(_pageId + ".kcb_fund_table .ce_table.holding_table"), "li", function(e) {
				clearBuyMsg(); // 清楚数据
				var stockCode = $(this).attr("id");
				$(_pageId + "#stockCode").val(stockCode);
				_stockCode = stockCode;
				getStockList(stockCode);
				e.stopPropagation();
			}, "tap");
		} else {
			queryCHolding(isShowWait);
		}
	}

	/**
	 * 查询持仓数据
	 */
	function queryCHolding(isShowWait) {
		_callback = false;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code; //关联资产账户标志
		var session_id = userInfo.session_id;
		var stock_account = "";
		var stock_code = "";
		var exchange_type = "";
		var param = {
			"entrust_way": entrust_way,
			"branch_no": branch_no,
			"fund_account": fund_account,
			"cust_code": cust_code,
			"session_id": session_id,
			"stock_account": stock_account,
			"stock_code": stock_code,
			"exchange_type": exchange_type,
		    "query_flag":"1"
		};
		service_creditKcb.cc_query(param, function(data) {
			_callback = true;
			var w=$(_pageId).width() / 4 ;
			var html = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="ce_table holding_table" style="table-layout:fixed;"><tr><th scope="col" style="min-width:'+w+'px">证券/市值</th><th scope="col" style="min-width:'+w+'px">盈亏</th><th scope="col" style="min-width:'+w+'px">持仓/可用</th><th scope="col" style="min-width:'+w+'px">成本/现价</th></tr>';
			$(_pageId + " .kcb_fund_table div.ce_table").html(html + " </table>");
			common.setNoData(true);
			if(data && data != "undefined") {
				if(data.error_no == 0) {
					var results = data.results;
					if(results && results.length > 0) {
						for(var i = 0; i < results.length; i++) {
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							html += queryHoldingHTML_stock(results[i], i);
						}
						html += " </table>";
						$(_pageId + " .kcb_fund_table div.ce_table").html(html);
						common.setNoData(false);
						//卖出事件
						$.bindEvent($(_pageId + " .kcb_fund_table .ce_table.holding_table tr").slice(1), function(e) {
							clearBuyMsg(); // 清楚数据
							var stockCode = $(this).attr("id");
							$(_pageId + " #stockCode").removeClass("C100");
							$(_pageId + " #stockCode").quzhi(stockCode);
							_stockCode = stockCode;
							var exchange_type = $(this).attr("exchange_type");
							var stock_account = $(this).attr("stock_account");
							stock_info.stock_account=stock_account;
							stock_info.exchange_type=exchange_type;
							_PageParam = {
								"stock_account": stock_account,
							};
							getStockList(stockCode, "", exchange_type);
							$(_pageId + " .main").scrollTop(0);
							e.stopPropagation();
						}, "tap");
					}
				} else {
					$.alert(data.error_info);
				}
			}
			_queryHolding = true;
			if(_initScroller) {
				_initScroller(null,isTimingRefresh);
			}
		},{
			"isShowWait":isShowWait?false:true,
		});
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHoldingHTML_stock(element) {
		var price_digit = 3;
		var css = "",css1="";
		//浮动盈亏
		var float_yk = Number(element.float_yk); 
		if(float_yk > 0) {
			css = "ared";
		} else if(float_yk < 0) {
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
	   	var eleHtml = "";
      	eleHtml+="<tr stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" id="+element.stock_code +" >";
        eleHtml+="<td><span style='zoom:"+ $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25) +";'>"+element.stock_name +"</span><span>"+element.market_value +"</span></td>";
        eleHtml+="<td><span class=\""+css+"\">"+element.float_yk+"</span><span class=\""+css1+"\">"+element.float_yk_per+"%</span></td>";
        eleHtml+="<td><span>"+element.cost_amount+"</span><span>"+element.enable_amount+"</span></td>";
        eleHtml+="<td><sapn>"+element.cost_price+"</sapn><span>"+element.last_price+"</span></td>";
      	eleHtml+="</tr>";
        return eleHtml;
	}

	/**
	 * 
	 */
	function clearBuyMsg() {
		clearMaxNumber=false;
		_PageParam = {};
		stock_info = ioitStock();
		if(stock_html) {
			//清空canvas图
			$(_pageId + ".kcb_timeshare .row_01 strong").text("");
			$(_pageId + ".kcb_timeshare .row_01 em").text("--").removeClass("agreen").removeClass("ared");
			$(_pageId+"#hqt").html("");
			hqKt.clearCanvasFunc(_pageId);
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});
			stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 证券名称
			setStockInfo("stockPrice", ""); // 证券价格
			setStockInfo("stockNum", ""); // 证券数量
			setStockInfo("stockMaxAmount","--");
			stock_html.upStop.text("--"); //涨停价
			stock_html.downStop.text("--"); //跌停价
			$(stock_info.upStop).removeClass("ared");
			$(stock_info.downStop).removeClass("agreen");
			stock_html.latestPrice.text("--"); // 最新价
			stock_html.total.text("").hide();
			stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
			//还原限价
			$(_pageId+" .kcb_trade_form #entrustWay").unbind("click");
			stock_html.stockPrice=$(_pageId + " #stockPrice");
			stock_html.stockMaxAmount=$(_pageId + " #maxNumber");
			$(_pageId + " #maxNumber").quzhi("--");//清空限价的数量框
			$(_pageId + " #kcbMaxNumber").quzhi("--");//清空科创板的数量框
			$(_pageId + " #stockPrice").quzhi("");//清空限价的价格框
			$(_pageId + " #kcbStockPrice").quzhi("");//清空科创板的价格框
			stock_html.market_p.attr("id","").html("<em style='color: #ccc;'>请选择委托方式</em>");
			stock_html.market_p.attr("type","");
			stock_info.market_price = false;
			stock_info.isHq = false;
			$(_pageId + ".sj").hide();
			$(_pageId + ".xj").show();
			$(_pageId + " #kcbMaxNumber").hide();
			$(_pageId + " #maxNumber").show();
		}
		$(_pageId + ".input_text .logoStyle").hide();
		$(_pageId + ".input_text .logoStyle").removeClass("kcbCss");
		$(_pageId + ".input_text .logoStyle").text("");	
	   	commonTimer.clearTimer(_pageId+"Hqwd");
	   	_fifthCallback = true;
		_contractLinkage=true;
		$(_pageId + " .five_box ul li").removeClass("active");
		$(_pageId + " p.limit em").text("股");
		$(_pageId + " .input_num .input_text em").text("股");
		$(_pageId+" .stockLiabilities strong").html("--");
		$(_pageId+" .totalLiabilities strong").html("--");
		compactFlag=[];
		$(_pageId+".row_04 p").removeClass("check");
		$.closeModal(".picker-modal.modal-in");
	}

	function dataDestroy() {
        commonHq.clearCheckTradeTimer();
		$.clearRequest();
		isTimingRefresh = false;
		if(stock_html) {
			stock_html.hqxltb.removeClass("sl").addClass("xl");
			stock_html.hqCanvas.hide();
		}
		$(_pageId+" .totalLiabilities").show().siblings(".stockLiabilities").hide();
		$(_pageId+" .totalLiabilitiesAccount").show().siblings(".stockLiabilities").hide();
		$(_pageId + " #stockCode").quzhi("");
		$(_pageId + " #stockCode").addClass("C100");
		$(_pageId + " .rule_select").attr("compact_id","");
//		$(_pageId + " .rule_select p span").text("请选择");
		_stockCode = "";
		$(_pageId + " .kcb_fund_table .ce_table").html("");
		clearBuyMsg();
		commonTimer.clearTimer(_pageId);
		stock_info = null;
		stock_html = null;
		if(keyboard) {
			keyboard.keyDestroy();
		}
		_checkoutSuccess = false;
	}

	function getQueryHolding() {
		return _queryHolding;
	}
	

	var base = {
		"dataInit": dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy,
		"getQueryHolding": getQueryHolding,
		"getStockList":getStockList,
		"clearBuyMsg":clearBuyMsg
	};
	module.exports = base;
});
