/**
 * 信用交易-科创板-总资产界面
 */
define('trade/scripts/credit/kcb/asset.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var commonHq = require("commonHq");
	var	service_creditKcb = require("service_creditKcb");
	var commonTimer = require("commonTimer");
	var commonFunc = require("commonFunc");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
    var _pageId = "#credit_kcb_asset ";
    var userInfo = null;
    var position_Timer = null;
    var _callback = true;
    var hqData = {};
    var _openStock={};
    var abc=0;
    var myAbout = null;
	var hIAbout = require("hIscroll");
    
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("1");
		sessionStorage.setItem("isScroller","");
		_openStock={};
		$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
		
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),
			function(pageCode,topage){
				clearPositionTimer();
				$.pageInit(pageCode,topage,$.getPageParam(),'',true);
			});
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		vIscrollHeight = mainHeight;
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		jumpPageEvent();
		queryData();//查询持仓
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){}
	
	/**
	 * 事件绑定
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				clearPositionTimer();
				$.pageInit("credit/kcb/asset", "account/index", {"history": true}, "left", true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			clearPositionTimer();
			$.setSStorageInfo("return_page","credit/kcb/asset");
			$.pageInit("credit/kcb/asset","banking/transfer",{});
			e.stopPropagation();
		});
		
		// 刷新
		$.bindEvent($(_pageId + " .header .top_title .icon_refresh"), function(e){
			$(_pageId+" .kcb_hold_main2 strong").html("--");//总资产
			$(_pageId+" .kcb_fund_table .ce_table").html("");
			$(_pageId+".kcb_fund_table .ce_table tr.tools").hide();
			queryData();
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId), function(e){
			sessionStorage.setItem("isScroller","");
		}, "touchstart");
	}
    
	/**
	 * 查询
	 */
	function queryData(){
		clearPositionTimer();
		//查询资金账户
		queryCapital();
		queryPosition();
		_callback = false;
		if(position_Timer == null && global.positionRefreshTime){
			commonHq.initCheckTradeTimer();
			position_Timer = window.setInterval(function(){
				if(commonHq.getTradingTime() && _callback){
					queryCapital(true);
					queryPosition(true);
					_callback = false;
				}
			}, global.positionRefreshTime);//定时刷新
		}
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "is_homepage":"1",
			    "query_flag":"1"
		};
		//最后一个为超时处理函数
		service_creditKcb.zjzh_query(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
				    //总资产
				    var assert_val = $.formatMoney(results[0].assert_val,2);  
				    $(_pageId+" .kcb_hold_main2 .inner").eq(0).find("strong").html(assert_val.substring(0,assert_val.length-2)+"<em>"+ assert_val.substr(-2) +"</em>");
				    //科创板市值
					var market_value = $.formatMoney(results[0].market_val,2); 
				    $(_pageId+" .kcb_hold_main2 .more_info").eq(0).find("li").eq(0).find("strong").html(market_value.substring(0,market_value.length-2)+"<em>"+ market_value.substr(-2) +"</em>");
				    //可用资金
				    var enable_balance = results[0].enable_balance;
				    $(_pageId+" .kcb_hold_main2 .more_info").eq(0).find("li").eq(1).find("strong").html(enable_balance.substring(0,enable_balance.lastIndexOf("."))+"<em>"+ enable_balance.substr(enable_balance.lastIndexOf(".")) +"</em>");
//				 	
				    //科创板总盈亏
					var css = "";
					var float_yks = results[0].total_income_balance;
					//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
					if(float_yks > 0){
						css = "ared";
					}else if(float_yks < 0){
						css = "agreen";
					}
					var fas = Number(float_yks).toFixed(2);
					$(_pageId+" .kcb_hold_main2 .more_info").eq(0).find("li").eq(2).find("strong").html(fas.substring(0,fas.length-2)+"<em>"+ fas.substr(-2) +"</em>").addClass(css);
				    
				    //可取资金
				    var fetch_balance = $.formatMoney(results[0].fetch_balance,2);
				    $(_pageId+" .kcb_hold_main2 .more_info").eq(0).find("li").eq(3).find("strong").html(fetch_balance.substring(0,fetch_balance.length-2)+"<em>"+ fetch_balance.substr(-2) +"</em>");
				    
				}else{
					$(_pageId+".kcb_hold_main2 .inner>strong").text("--");//总资产
					$(_pageId+".kcb_hold_main2 .more_info li strong").text("--");//市值
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	
	function queryPosition(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password,
		    "query_flag":"1"
		};
		service_creditKcb.cc_query(param,queryPositionCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				common.setNoData(true,"暂无持仓记录");
				_callback = true;
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	
	function queryPositionCallback(data){
		hqData={};
		_callback = true;
		$(_pageId+'.kcb_fund_table .ce_table tr.tools').remove();
		$(_pageId+'.kcb_fund_table .ce_table tr.position_data').remove();
		var w=$(_pageId).width() / 4 ;
		var htmlTop = "<tr><th scope=\"col\" style='min-width:"+w+"px'>股票/市值</th> <th scope=\"col\" style='min-width:"+w+"px'>盈亏</th><th scope=\"col\" style='min-width:"+w+"px'>持仓/可用</th><th scope=\"col\" style='min-width:"+w+"px'>成本/现价</th></tr>";
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					float_yks = 0; //浮动盈亏
					_openStock=$.getSStorageInfo("openStock",false) || {};
					if(_openStock && typeof(_openStock) == "string"){
						_openStock = JSON.parse(_openStock);
					}
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long; 
						var type = ""
						var exchange_type = results[i].exchange_type
						if(exchange_type == 0 || exchange_type == 1)
						{
							type = "SZ:"+results[i].stock_code;
						}
						else if(exchange_type == 2 || exchange_type == 3)
						{
							type = "SH:"+results[i].stock_code;
						}
						var isLast="";
						if(i==(results.length-1)){
							isLast="true";
						}
						float_yks += Number(results[i].float_yk);//计数总浮动盈亏
						htmlTop += queryPositionHTML_stock(results[i],type,isLast);
					}
					$(_pageId+".kcb_fund_table .ce_table").html(htmlTop);
					common.setNoData(false);
					
					//卖出事件
					$.bindEvent($(_pageId+'.kcb_fund_table .ce_table tr.position_data'), function(e){
						var inv = $(_pageId+".kcb_fund_table .ce_table .tools._last").is(':visible') ? 0 : 34;
						var isLast=$(this).attr("islast");
						if(($(_pageId +  ".vertical_list").height() + inv) > $(_pageId + " #wrapper").height()){
							var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
							if(isLast=="true" || isNeedScroll){
								if($(this).next().height() > 0){
		                            abc = $(this).next().height();
		                        }
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".kcb_fund_table .ce_table .tools").hide();
								if(a){
									$(this).next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
		                            if($(this).next().height() > 0){
		                            	abc = $(this).next().height();
		                            }
		                            var maxScrollY = 0;
		                        	var _height=myScroller.y;
		                        	var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
									if($(this).next().is(':visible')){
										sessionStorage.setItem("isScroller","true");
										_height -= abc ;
										maxScrollY = _height;
									    _height -= temph;
									}else{
										_height += abc;
										maxScrollY = _height;
										sessionStorage.setItem("isScroller","");
									}
									myScroller.scrollTo(0,_height);
									myScroller.y = _height;
									myScroller.refresh();
									if(isLast=="true"){
										myScroller.maxScrollY = maxScrollY;
									}
								}
							}else{
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".kcb_fund_table .ce_table .tools").hide();
								if(a){
									$(this).next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
									myScroller.refresh();
								}
							}
						}
						else{
							var a = $(this).next().css("display") == "none" ? true : false;
							$(_pageId+".kcb_fund_table .ce_table .tools").hide();
							if(a){
								$(this).next().show();
								//保存展开的股票
								var openStock={
									"stock_code":$(this).attr("id"),
									"exchange_type":$(this).attr("exchange_type"),
									"stock_account":$(this).attr("stock_account"),
								}
								$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
							}else{
								_openStock={};
								$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
							}
							$(this).addClass("active").siblings().removeClass("active");
							if(myScroller){
								myScroller.refresh();
							}
						}
						initAbout();
						e.preventDefault();
					});
					
					//卖出按钮事件
					$.bindEvent($(_pageId+".kcb_fund_table .ce_table tr.tools a"), function(e){
						$(_pageId+".kcb_fund_table .ce_table tr.tools").hide();
						$(this).siblings().removeClass("active");
						var stock = $(this).parents("tr.tools").prev();
						var stock_code = stock.attr("id");
						var stock_name= stock.attr("stock_name");
						var id = $(this).attr("id");
						var type = stock.attr("type");
						var exchange_type = stock.attr("exchange_type");
						var stock_account = stock.attr("stock_account");
						var market = "";
						if(type){
							market = type.split(":");
							if(market[0]){
								market = market[0];
							}
						}
						if(id == "buy"){
							$.pageInit("credit/kcb/asset","credit/kcb/ordinaryToBuy",{"code":stock_code,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
						}
						else if(id == "sell"){
							$.pageInit("credit/kcb/asset","credit/kcb/ordinaryToSell",{"code":stock_code,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
						}
						else if(id == "hq"){
							if(global.callNative){
                                if(gconfig.platform == "2"){
                                    var param = {
                                        "stockMarket": market,
                                        "stockCode": stock_code,
                                        "stockName": stock_name,
                                            "moduleName" : "self-stock",
                                            "funcNo":"60105"
                                        }; 							
                                    $.callMessage(param);
                                }
                                else{
                                    var param = {
                                        "funcNo": "50500",
                                        "msgNo": "201",
                                        "targetModule":"hqDispatcher",
                                        "sourceModule":"trade",
                                        "action":"0",
                                        "param":{
                                            "stockMarket": market,
                                            "stockCode": stock_code,
                                            "stockName": stock_name,
                                        }
                                    }
                                    $.callMessage(param);
                                }
                            }else{
                                var stockInfo = {
                                    "market":market,
                                    "stockCode": stock_code,
                                    "stockName": stock_name,
                                    "moduleName" : "trade"
                                }
                                window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                            }
						}
						e.preventDefault();
					});
				}
				else{
					$(_pageId+".kcb_fund_table .ce_table").html(htmlTop);
					common.setNoData(true,"暂无持仓记录");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		initAbout();
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	function clearPositionTimer(){
		if (position_Timer != null ) {
	        window.clearTimeout(position_Timer);
	    }
		position_Timer = null;
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,type,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "",css1="";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		float_yk = float_yk.toFixed(price_digit);
        var active_css1 = "" , active_css2 = " style='display: none;'";
		if(_openStock && _openStock.stock_code){
			if(element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account){
				active_css1 = "active";
				active_css2 = "";
			}
		}
		var css3="";
		if(isLast=="true"){
			css3="_last";
		}else{
			css3="_nolast";
		}
		eleHtml+="<tr class='position_data "+active_css1+"' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\"  type=\""+type + "\" stock_name=\"" + element.stock_name+"\" id='"+element.stock_code +"' isLast='"+isLast +"'>";
		eleHtml+="<td><strong style='zoom:"+ $.getTransformScale(element.stock_name, 16, $(window).width() / 4 - 20) +";'>"+element.stock_name +"</strong><small>"+element.market_value +"</small></td>";
		eleHtml+="<td><span class=\""+css+"\">"+element.float_yk+"</span><span class=\""+css1+"\">"+element.float_yk_per+"%</span></td>";
		eleHtml+="<td>"+element.cost_amount+"<br/>"+element.enable_amount+"</td>";
		eleHtml+="<td>"+element.cost_price+"<br/>"+element.last_price+"</td>";
		eleHtml+="</tr>";
        eleHtml+="<tr class='tools "+css3+"'  "+active_css2+">";
        eleHtml+="<td colspan=\"4\">";
        eleHtml+="<ul>";
        eleHtml+="<li><a id=\"buy\" href=\"javascript:void(0);\"><span>普通买入</span></a></li>";
        eleHtml+="<li><a id=\"sell\" href=\"javascript:void(0);\"><span>普通卖出</span></a></li>";
        eleHtml+="<li><a id=\"hq\" href=\"javascript:void(0);\"><span>行情</span></a></li>";
        eleHtml+="</ul>";
        eleHtml+="</td>";
        eleHtml+="</tr>";
		return eleHtml;
	}
	
	/**
	 * 持仓上下滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: vIscrollHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/*
	 * 持仓左右滑动组件
	 */
	function initAbout(){
//		if(myAbout)
//		{
//			$(_pageId + " #pull_down_about").height("auto");
//			myAbout.destroy();
//			myAbout = null;
//		}
//		var config = {
//				wrapper: $(_pageId + " #aboutpper"), //wrapper对象
//				scroller: $(_pageId + " #aboutpper"), //scroller对象
//			};
//		// 设置 scroller 的宽度
//		myAbout = new hIAbout(config); //初始化，需要做if(!hIscroll._init)判断
		//必须用这个左右滑动组件，否则事件乱跳
		var scrollOptions = {
			$wrapper: $(_pageId + " #pull_down_about")
		};
		myAbout = iscrollUtils.hScroller(scrollOptions);
	};
	
	/**
	 * 销毁
	 */
	function destroy(){
        commonFunc.clearCheckTradeTimer();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myAbout)
		{
			$(_pageId + " #pull_down_about").height("auto");
			myAbout.destroy();
			myAbout = null;
		}
		$.clearRequest();
		clearPositionTimer();
		_callback = true;
		$(_pageId+" .kcb_hold_main2 strong").html("--");//总资产
		$(_pageId+" .kcb_fund_table .ce_table").html("");
		$(_pageId+".kcb_fund_table .ce_table tr.tools").hide();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
