/**
 * 信用交易-科创板-融资卖出
 */
define('trade/scripts/credit/kcb/financingToSell.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var creditKcbOrder = require("creditKcbOrder");
	var _pageId = "#credit_kcb_financingToSell ";
	var common = require("common");
	var service_creditKcb = require("service_creditKcb");
	var userInfo = null;  // 账号信息
	var downslide = new (require("downslide")).Downslide();
	var height_table = null;
	var _load = false;
	var _queryHolding = 0;
	
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("1");
		downslide.addSlide();
		userInfo = common.getCurUserInfo();
		
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false,true);
        height_table =  mainHeight - $(_pageId + ".kcb_trade_main").outerHeight(true) - $(_pageId + ".kcb_fund_table").css("margin-top").slice(0, -2) - 2;
        _load = true;
//      if(creditKcbOrder.getQueryHolding()){
//	        initScroller();
//      }
		$(_pageId + ".ce_btn div.order").css({"padding-top": "3px","line-height":"14px","width":$(_pageId + ".ce_btn a").width(),"display":"inline-block"});
		$(_pageId + ".ce_btn #total").css("display","inline-block");
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	
	function backgroundInterface(){
		
		var orderType = "4"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
		creditKcbOrder.dataInit(_pageId,orderType,true,initScroller);
		creditKcbOrder.elementBindEvent();
	}
	
	/**
	 * 初始化滑动组件
	 * isRefresh 是否是刷新
	 */
	function initScroller(height,isRefresh)
	{
		if(isRefresh){
			downslide.rollRefresh();
		}else{
			if(_load){
				height = height || height_table
				downslide.rollInit(height,_pageId,true);
			}
		}
		downslide.aboutInit();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//查询跳转
		$.bindEvent($(_pageId+" a.icon_search"), function(e){
			$.pageInit("credit/kcb/buyTicketsRepay","credit/kcb/queryCanRZBuyStock",{"param":"1"});
			e.stopPropagation();
		});
		
		// 刷新
		$.bindEvent($(_pageId + " .header .top_title .icon_refresh"), function(e){
			creditKcbOrder.dataDestroy();
			downslide.slideDestroy();
			backgroundInterface();
			e.stopPropagation();
		});
	}

	
	/**
	 * 数据重置
	 */
	function destroy(){
		creditKcbOrder.dataDestroy();
		downslide.slideDestroy();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});