/**
 * 信用交易-科创板-交易撤单
 */
define('trade/scripts/credit/kcb/tradeCancellation.js', function(require, exports, module) {
	var common = require("common");
	var _pageId = "#credit_kcb_tradeCancellation ";
   	var publicKcbCancel = require("publicKcbCancel");
    var data = {
		"queryFuncNo": "303017",
		"queryParam": {
			"query_flag":1,
		},
		"cancellModule":"credit",//表示两融撤单
		"promptBoxFun": function(e){//撤单后是否继续买入、卖出
			
			//根据可撤委托的买卖方向+委托类别来判断
			var buyEntrust=["0","62","64","66","68","70","4"];
			var sellEntrust=["1","63","65","67","69","71","5"];
			if(buyEntrust.indexOf(e.entrust_bs)!=-1 && (e.entrust_type=="0"||e.entrust_type=="9")){//（1）普通买入
				$.pageInit("credit/kcb/tradeCancellation","credit/kcb/ordinaryToBuy",e,"",true);
			}
			else if(sellEntrust.indexOf(e.entrust_bs)!=-1 && (e.entrust_type=="0"||e.entrust_type=="9")){//（2）普通卖出
				$.pageInit("credit/kcb/tradeCancellation","credit/kcb/ordinaryToSell",e,"",true);
			}
			else if(buyEntrust.indexOf(e.entrust_bs)!=-1 && e.entrust_type=="6"){//（3）融资买入
				$.pageInit("credit/kcb/tradeCancellation","credit/kcb/financingToBuy",e,"",true);
			}
			else if(sellEntrust.indexOf(e.entrust_bs)!=-1 && e.entrust_type=="7"){//（4）融券卖出
				$.pageInit("credit/kcb/tradeCancellation","credit/kcb/financingToSell",e,"",true);
			}
		},
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
//				["委托数量", function(e){
//					var amount=(Number(e.business_amount)/Number(e.entrust_amount))*100;
//					return '<em><i style="width:'+amount+'%"></i></em>'+e.business_amount+"/"+e.entrust_amount;
//				},true],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
				["委托价格", "entrust_price"],
				["成交价格", "business_price"],
				["委托时间", "entrust_time"],
				["委托状态", "entrust_state_name"],
				["委托编号", "entrust_no"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
				["stock_account","stock_account"],
			],
			//撤单提示字段
			"tipStr":[
//				[function(e){
//					return e.stock_name
//				}, "stock_code"],
				["业务名称", "entrust_type_name"],
				["证券名称", "stock_name"],
				["证券代码", "stock_code"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
			]
		},
		"cancelFuncNo":"303018",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
    }
    
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("1");
		publicKcbCancel.init(data);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
    }
		
	function load(){
		publicKcbCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$.pageBack("credit/kcb/mainOrder", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		
		// 刷新
		$.bindEvent($(_pageId + " .header .top_title .icon_refresh"), function(e){
			publicKcbCancel.load();
			e.stopPropagation();
		});
		
		publicKcbCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".dialog-overlay").hide();
		$(_pageId+".missconfirm").hide();
		publicKcbCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
	};
	module.exports = base;
});