/**
 * 信用交易-现券还券
 */
define('trade/scripts/credit/order/bondAlsoCoupons.js', function (require, exports, module) {
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var service_credit = require("service_credit");
    var _pageId = "#credit_order_bondAlsoCoupons ";
    var iscrollUtils = require("iscrollUtils");
    var keyboard = require("keyboard");
    var myScroller = null; // 滑动组件对象
    var userInfo = null;
    var listData = {};
    var stockInfo = {};
    var query_mode = null;
    var selectedList = [];//选择的合约集合
    var _compact_id = "";

    /**
     * 初始化
     */
    function init() {
        if (keyboard) {
            keyboard.keyInit();
        }
        common.pageBuryingPoint("107454");
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        _compact_id = $.getPageParam("compact_id") ? $.getPageParam("compact_id") : "";
        if (_compact_id) {
            $(_pageId + ".content .liabilities_tab_list li:eq(1)").addClass("active").siblings().removeClass("active");
            query_mode = "";
        } else {
            query_mode = "1";//汇总模式query_mode=1，普通模式不传
        }
        canPayStock(query_mode);//查询可还证券
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            setTimeout(function () {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
                if (prePageCode == "credit/asset/debt") {
                    var pageCode = $.getCurrentPageObj().pageCode || '';
                    $.pageInit(pageCode, prePageCode, {
                        "_loginClass": "1",
                        "compact_type": $.getPageParam("compact_type")
                    }, "left", true);
                } else {
                    $.pageBack();
                }
                common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
                e.preventDefault();
                e.stopPropagation();
            },300);
        });

        //提交委托
        $.bindEvent($(_pageId + ".transfer_btn_box .t_btn_text"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            vailSubmitOrder();
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            e.stopPropagation();
        });

        //全部
        $.bindEvent($(_pageId + ".guarantee_transfer_list .all_btn"), function (e) {
            var realCompactAmount = $(_pageId + "#realCompactAmount").val();
            if (realCompactAmount && realCompactAmount != "--") {
                $(_pageId + "#stockNum").quzhi(realCompactAmount);
            }
            e.stopPropagation();
        });

        //切换tab
        $.bindEvent($(_pageId + " .trade_second_page .liabilities_tab_list li"), function (e) {
            resetBuyForm()
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(this).addClass("active").siblings().removeClass("active");
            query_mode = $(this).attr("query_mode");
            $(_pageId + ".j-position-table table tbody").html("");
            canPayStock(query_mode);
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": name});
            e.stopPropagation();
        });

        //证券代码输入
        $.bindEvent($(_pageId + "#stockCode"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            } else {
                var stockCode = $(this).val();
                stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
                stockCode = $.trim(stockCode);
                $(this).val(stockCode);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode.length == 0) {
                resetBuyForm();
            }
            if (stockCode && stockCode.length == 6) {
                var stockData = listData[stockCode];
                if (stockData) {
                    $(_pageId + " #stockCode").quzhi(stockCode);
                    $(_pageId + " #stockCode").addClass("select");
                    $(_pageId + " #stockName").quzhi(stockData.stock_name);
                    $(_pageId + " #stockName").addClass("jsKey_stock_name");
                    var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                    var zoomValue = $.getMaxFontSize(stockData.stock_name, "0.18rem", maxWidth);
                    $(_pageId + " #stockName").css({
                        "transform": "scale(" + zoomValue + ")",
                        "white-space": "nowrap",
                        "transform-origin": "left center",
                    });
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    queryMaxAmount(stockCode);
                    common.comStat("108055", 2, "104", true, {
                        "i_change_name": "证券代码输入",
                        "i_change_to": stockData.stock_name
                    });
                }
            }
            e.stopPropagation();
        }, "input");

        //股票名称
        $.bindEvent($(_pageId + " #stockName"), function (e) {
            var click = e.type || "click";
            if (keyboard) {
                $(_pageId + " div#stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            } else {
                $(_pageId + " #stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            }
            e.stopPropagation();
        });

        //数量输入埋点
        $.bindEvent($(_pageId + "#stockNum"), function (e) {
            var stockNum = $(_pageId + " #stockNum").val();
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode) {
                var stockData = listData[stockCode];
                if (stockData) {
                    common.comStat("108056", 2, "2", false, {
                        "i_entrust_bs": "", // 交易方向( 1,买入 2,卖出)
                        "i_entrust_prop": "", // 委托属性
                        "i_exchange_type": stockData.exchange_type, // 交易市场
                        "i_stock_code": stockData.stockCode, // 股票代码
                        "i_stock_name": stockData.stockName, // 股票名称
                        "i_price": "", // 选择后的价格
                        "i_adjust_type": "5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
                        "i_max_cnt": $(_pageId + "#maxNum").val(), // 最大数量
                        "i_target_cnt": stockNum, // 调整之后的数量
                        "i_fast_btn": "", // 快捷键（全仓，1/2，1/4 ....（可留空））
                    });
                }
            }
            e.stopPropagation();
        }, "blur");

        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            e.stopPropagation();
        });
    }

    /**
     * 查询买入可用资金最大可买数量
     * */
    function queryMaxAmount(stockCode) {
        if (!stockCode) {
            return false;
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var stock_code = stockCode;
        var compact_id = selectedList.length > 0 ? selectedList.join(",") : "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "stock_code": stock_code,
            "compact_id": compact_id
        };
        service_credit.restock_link(param, queryMaxAmountCallBack);
    }

    /**
     * 查询买入可用资金最大可买数量回调方法
     */
    function queryMaxAmountCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 0) {
                if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
                stockInfo = $.extend(stockInfo, results[0]);
                var real_compact_amount = results[0].real_compact_amount;
                var enable_amount = results[0].enable_amount;
                $(_pageId + "#maxNum").val(enable_amount);//可用数量
                if (query_mode != "1") {//指定合约
                    var checkNum = $(_pageId + ".content .j-position-table tbody tr a.checked").length;
                    if (checkNum > 0) {
                        //判断当前选中合约是否有同类合约，不同类的将禁止选中
                        var num = 0;
                        $(_pageId + " .j-position-table table tbody tr a.checked").each(function () {
                            var temp = $(this).parents("tr").attr("real_compact_amount");
                            if (temp) {
                                num += Number(temp);
                            }
                        });
                        $(_pageId + "#realCompactAmount").val(num);//总应还数量
                    } else {
                        $(_pageId + "#realCompactAmount").val(real_compact_amount);//总应还数量
                    }
                } else {
                    $(_pageId + "#realCompactAmount").val(real_compact_amount);//总应还数量
                }
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        var operateion_type = "直接还券";
        //验证股票代码输入是否正确
        if (common.size(listData) == 0) {
            $.alert("没有可用持仓");
            return false;
        }
        if (!common.isValue(stockInfo)) {
            $.alert("请选证券代码");
            return false;
        }
        //验证还券数量
        var num = $(_pageId + "#stockNum").val();
        if (num.length == 0) {
            $.alert("请输入委托数量");
            return false;
        }
        if (Number(num) <= 0) {
            $.alert("委托数量必须大于0");
            return false;
        }
        var needPay = $(_pageId + "#realCompactAmount").val();
        if (Number(num) > Number(needPay)) {
            $.alert("委托数量大于需还数量");
            return false;
        }
        var mostBuy = $(_pageId + "#maxNum").val();
        if (Number(num) > Number(mostBuy)) {
            $.alert("该证券可还数量不足");
            return false;
        }

        if (query_mode != "1") {
            operateion_type = "指定合约还券";
            if (selectedList.length == 0) {
                $.alert("请选择合约");
                return false;
            }
        }
        var tipStrArray = [];
        tipStrArray.push(["<span style='font-size:" + $.getTransformScaleFontSize(stockInfo.stock_name, 16, $(window).width() * 0.48) + "px;'>" + stockInfo.stock_name +  "</span>", stockInfo.stock_code]);
        tipStrArray.push(["操作类型 ", operateion_type]);
        tipStrArray.push(["需还数量 ", $(_pageId + "#maxNum").val()]);
        tipStrArray.push(["还券数量 ", num]);
        var tipStr = "<div>";
        tipStr += common.generatePrompt(tipStrArray);
        tipStr += "</div>";
        common.iConfirm("现券还券", tipStr, function success() {
            var cust_code = userInfo.cust_code;	//客户代
            var fund_account = userInfo.fund_account;	//资产账户
            var branch_no = userInfo.branch_no;	//分支机构
            var sessionid = userInfo.session_id;
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var password = userInfo.password;
            var exchange_type = stockInfo.exchange_type;
            var stock_account = stockInfo.stock_account;
            var stock_code = stockInfo.stock_code;
            var entrust_amount = num;
            var compact_id = selectedList.length > 0 ? selectedList.join(",") : "";
            var cashgroup_prop = stockInfo.cashgroup_prop ? stockInfo.cashgroup_prop : "";//头寸性质1 - 专项，0 - 普通
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "password": password,
                "sessionid": sessionid,
                "exchange_type": exchange_type,
                "stock_account": stock_account,
                "stock_code": stock_code,
                "entrust_amount": entrust_amount,
                "compact_id": compact_id,
                "cashgroup_prop": cashgroup_prop
            };
            service_credit.repaystock(param, getStockBuyCallBack, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            $.showPreloaders("请等待...");
        }, null);
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        $.hidePreloader();
        if (data.error_no == 0) {
            var results = data.results;
            if (results) {
                //提示框
                var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号：" + results[0].entrust_no;
                $.alert(tipStr);
            }
            resetBuyForm();
            canPayStock(query_mode);
        } else {
            $.alert(data.error_info);
            resetBuyForm();
        }
    }


    /**
     * 持仓查询
     * 调用两个接口 股份查询，资金查询
     */
    function canPayStock(query_mode) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "position_str": "",
            "request_num": "",
            "query_type": "0",
            "compact_type": "1",
            "query_mode": query_mode,
        };
        service_credit.openInterest_Query(param, queryStockCallback);
    }

    //持仓查询回调方法
    function queryStockCallback(data) {
        $(_pageId + " .no_more_data").hide();
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (query_mode == "1") {
                    $(_pageId + ".j-position-table table").removeClass("custmo_contract_list");
                    $(_pageId + ".j-position-table table thead").html("<tr><th>证券/代码</th><th>需还</th><th>盈亏/息费</th>");
                } else {
                    $(_pageId + ".j-position-table table").addClass("custmo_contract_list");
                    $(_pageId + ".j-position-table table thead").html("<tr><th></th><th>证券/合约号</th><th>需还</th><th>盈亏/息费</th>");
                }
                if (results && results.length > 0) {
                    var listDiv = "";
                    $(_pageId + ".no_data_box").hide();
                    listData = {};
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        listData[results[i].stock_code + ""] = results[i];
                        listDiv += formatHtml(results[i]);
                    }
                    $(_pageId + ".j-position-table table tbody").html(listDiv);
                    $(_pageId + " .no_more_data").show();
                    $.bindEvent($(_pageId + " .j-position-table table tbody tr"), function (e) {
                        if (keyboard) {
                            keyboard.closeKeyPanel();
                        }
                        var stockCode = $(this).attr("stock_code");
                        if (query_mode != "1") {//指定合约
                            //如果带有禁选样式则不可选中
                            if ($(this).find("a").hasClass("noChoice")) {
                                return;
                            }
                            var checkNum = $(_pageId + ".content .j-position-table tbody tr a.checked").length;
                            if (checkNum > 0) {
                                var compact_source = $(_pageId + ".content .j-position-table tbody tr a.checked").first().parents("tr").attr("compact_source");
                                var curr_compact_source = $(this).attr("compact_source");
                                if (compact_source != curr_compact_source) {
                                    $(this).find("a").removeClass("checked");
                                    $.alert("普通与专项合约无法同时进行委托，请选择同类型合约");
                                    return false;
                                }
                            } else {
                                //判断当前选中合约是否有同类合约，不同类的将禁止选中
                                $(_pageId + " .j-position-table table tbody tr a").each(function () {
                                    if (stockCode != $(this).parents("tr").attr("stock_code")) {
                                        $(this).addClass("noChoice");
                                    }
                                });
                            }
                            $(this).find("a").toggleClass("checked");
                            //判断是否没有选中的列表，如果没有则清除禁选样式
                            checkNum = $(_pageId + ".content .j-position-table tbody tr a.checked").length;
                            if (checkNum == 0) {
                                $(_pageId + ".content .j-position-table tbody tr a").removeClass("noChoice");
                                resetBuyForm();
                            } else {
                                var stockData = listData[stockCode];
                                selectedList = [];
                                $(_pageId + " .j-position-table table tbody tr a.checked").each(function () {
                                    selectedList.push($(this).parents("tr").attr("id"));
                                });
                                var cashgroup_prop = $(this).attr("compact_source");
                                stockInfo.cashgroup_prop = cashgroup_prop ? cashgroup_prop : "";
                                // var stockCodeInput = $(_pageId + " #stockCode").val();
                                $(_pageId + " #stockCode").quzhi(stockCode);
                                $(_pageId + " #stockCode").addClass("select");
                                $(_pageId + " #stockName").quzhi(stockData.stock_name);
                                $(_pageId + " #stockName").addClass("jsKey_stock_name");
                                var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                                var zoomValue = $.getMaxFontSize(stockData.stock_name, "0.18rem", maxWidth);
                                $(_pageId + " #stockName").css({
                                    "transform": "scale(" + zoomValue + ")",
                                    "white-space": "nowrap",
                                    "transform-origin": "left center",
                                });
                                queryMaxAmount(stockCode);
                                // if (!stockCodeInput) {//代码框里有输入代码则不作联动查询，只勾选合约
                                //
                                // }
                            }
                        } else {//直接还券
                            var stockCode = $(this).attr("id");
                            var stockData = listData[stockCode];
                            resetBuyForm();
                            $(_pageId + " #stockCode").quzhi(stockCode);
                            $(_pageId + " #stockCode").addClass("select");
                            $(_pageId + " #stockName").quzhi(stockData.stock_name);
                            $(_pageId + " #stockName").addClass("jsKey_stock_name");
                            var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                            var zoomValue = $.getMaxFontSize(stockData.stock_name, "0.18rem", maxWidth);
                            $(_pageId + " #stockName").css({
                                "transform": "scale(" + zoomValue + ")",
                                "white-space": "nowrap",
                                "transform-origin": "left center",
                            });
                            queryMaxAmount(stockCode);
                        }
                        e.stopPropagation();
                    });
                    if (_compact_id) {
                        $(_pageId + ".j-position-table table tbody tr").each(function () {
                            if (_compact_id == $(this).attr("id")) {
                                var stockCode = $(this).attr("stock_code");
                                var checkNum = $(_pageId + ".content .j-position-table tbody tr a.checked").length;
                                if (checkNum == 0) {
                                    //判断当前选中合约是否有同类合约，不同类的将禁止选中
                                    $(_pageId + " .j-position-table table tbody tr a").each(function () {
                                        if (stockCode != $(this).parents("tr").attr("stock_code")) {
                                            $(this).addClass("noChoice");
                                        }
                                    });
                                }
                                $(this).find("a").addClass("checked");
                                selectedList = [];
                                selectedList.push(_compact_id);
                                var stockData = listData[stockCode];
                                var cashgroup_prop = $(this).attr("compact_source");
                                stockInfo.cashgroup_prop = cashgroup_prop ? cashgroup_prop : "";
                                // var stockCodeInput = $(_pageId + " #stockCode").val();
                                $(_pageId + " #stockCode").quzhi(stockCode);
                                $(_pageId + " #stockCode").addClass("select");
                                $(_pageId + " #stockName").quzhi(stockData.stock_name);
                                $(_pageId + " #stockName").addClass("jsKey_stock_name");
                                var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                                var zoomValue = $.getMaxFontSize(stockData.stock_name, "0.18rem", maxWidth);
                                $(_pageId + " #stockName").css({
                                    "transform": "scale(" + zoomValue + ")",
                                    "white-space": "nowrap",
                                    "transform-origin": "left center",
                                });
                                queryMaxAmount(stockCode);
                            }
                        })
                    }
                } else {
                    $(_pageId + ".j-position-table table tbody").html("");
                    $(_pageId + ".no_data_box").show();
                }
            } else {
                $.alert(data.error_info);
            }
            initScroller();
        }
    }

    function formatHtml(element) {
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        var price_digit = 2;
        var css = "";
        var slo_income = null;
        slo_income = Number(element.slo_income);
        if (slo_income > 0) {
            css = "ared";
        } else if (slo_income < 0) {
            css = "agreen";
        }
        slo_income = slo_income ? slo_income.toFixed(price_digit) : "--";
        var html = '';
        if (query_mode == "1") {
            html += '<tr id="' + element.stock_code + '">';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
            html += '<span style="font-size:' + $.getTransformScaleFontSize(element.stock_code, 14, maxWidth) + 'px;">' + element.stock_code + '</span>';
            html += '</td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.real_compact_amount, 16, maxWidth) + 'px;">' + element.real_compact_amount + '</p>';
            html += '</td>';
            html += '<td>';
            html += '<p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(slo_income, 16, maxWidth) + 'px;">' + slo_income + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.compact_interest).toFixed(price_digit), 16, maxWidth) + 'px;">' + Number(element.compact_interest).toFixed(price_digit) + '</p>';
            html += '</td>';
            html += '</tr>';
        } else {
            html += '<tr id="' + element.compact_id + '" stock_code="' + element.stock_code + '" compact_source="' + (element.compact_source ? element.compact_source : "") + '" real_compact_amount="' + element.real_compact_amount + '">';
            html += '<td><a class="t_check_box"></a></td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
            html += '<span style="font-size:' + $.getTransformScaleFontSize(element.compact_id, 14, ($(window).width() * 0.5 - 25)) + 'px;">' + element.compact_id + '</span>';
            html += '</td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.real_compact_amount, 16, maxWidth) + 'px;">' + element.real_compact_amount + '</p>';
            html += '</td>';
            html += '<td>';
            html += '<p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(slo_income, 16, maxWidth) + 'px;">' + slo_income + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.compact_interest).toFixed(price_digit), 16, maxWidth) + 'px;">' + Number(element.compact_interest).toFixed(price_digit) + '</p>';
            html += '</td>';
            html += '</tr>';
        }
        return html;
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var contentHeight = $(window).height() - $(_pageId + "header").height() - $(_pageId + ".liabilities_tab_list").height() - $(_pageId + ".guarantee_transfer_box").height();
        var temp = $(_pageId + ".j-position-table").height();
        $(_pageId + "#wrapper").css("height", contentHeight);
        if (contentHeight > temp) {
            contentHeight = contentHeight;
        } else {
            contentHeight = temp;
        }
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() - $(_pageId + ".liabilities_tab_list").height() - $(_pageId + ".guarantee_transfer_box").height(), // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                if ($(_pageId + ".trade_second_page .liabilities_tab_list li:eq(0)").hasClass("active")) {
                    query_mode = "1";
                } else {
                    query_mode = "";
                }
                canPayStock(query_mode);
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
            myScroller.refresh();
        } else {
            myScroller.maxScrollY = contentHeight + 1;
            myScroller.refresh();
        }
    }

    /**
     * 重置表单
     * */
    function resetBuyForm() {
        $(_pageId + "#maxNum").val("--");
        $(_pageId + "#realCompactAmount").val("--");
        $(_pageId + "#stockNum").quzhi("");
        $(_pageId + "#stockCode").quzhi("");
        $(_pageId + "#stockName").quzhi("");
        $(_pageId + "#stockCode").removeClass("select");
        $(_pageId + "#stockName").removeClass("jsKey_stock_name");
        $(_pageId + " .j-position-table table tbody tr a").removeClass("checked");
        $(_pageId + " .j-position-table table tbody tr a").removeClass("noChoice");
        selectedList = [];
        stockInfo = {};
        _compact_id = "";
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        resetBuyForm();
        $(_pageId + " .liabilities_tab_list li").eq(0).addClass("active").siblings().removeClass("active");
        $(_pageId + " .no_data_box").hide();
        $(_pageId + " .no_more_data").hide();
        $(_pageId + " .j-position-table table tbody").html("");
        query_mode = null;
        if (keyboard) {
            keyboard.keyDestroy();
        }
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
