/**
 * 信用交易-买券还券
 */
define('trade/scripts/credit/order/buyTicketsRepay.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var creditOrder = require("creditOrder");
    var _pageId = "#credit_order_buyTicketsRepay ";
    var common = require("common");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_credit = require("service_credit");
    var userInfo = null;  // 账号信息
    var _load = false;
    var mainHeight = null;
    var _compact_id = "";

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("107415");
        userInfo = common.getCurUserInfo();
        mainHeight = common.setMainHeightNew(_pageId, false, false);
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        _load = true;
        // if (creditOrder.getQueryHolding()) {
        //     initScroller();
        // }
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        _compact_id = $.getPageParam("compact_id") ? $.getPageParam("compact_id") : "";
        if (_compact_id) {
            $(_pageId + ".content .liabilities_tab_list li:eq(1)").addClass("active").siblings().removeClass("active");
        }
        var orderType = "7"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
        creditOrder.setClearCache(clearCache);
        creditOrder.dataInit(_pageId, orderType, true, queryContract, initScroller);
        creditOrder.elementBindEvent();
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        if (_load) {
            var contentHeight = $(window).height() - $(_pageId + "header").height() - $(_pageId + ".content .trans_enter_box").height() - $(_pageId + ".content .liabilities_tab_list").height() - $(_pageId + '.kcb_timeshare').height() - 10;
            var temp = $(_pageId + ".j-position-table").height();
            $(_pageId + "#wrapper").css("height", contentHeight);
            if (contentHeight > temp) {
                contentHeight = contentHeight;
            } else {
                contentHeight = temp;
            }
            var scrollOptions = {
                scrollerHeight: $(window).height() - $(_pageId + "header").height() - $(_pageId + ".content .trans_enter_box").height() - $(_pageId + ".content .liabilities_tab_list").height() - $(_pageId + '.kcb_timeshare').height() - 10, // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                bounceTime: 300 // 回弹的动画时间
            };
            if (!myScroller) {
                // 内容的高度比滚动区域高度小时
                // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
                if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                    scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
                }
                myScroller = iscrollUtils.vScroller(scrollOptions);
                myScroller.refresh();
            } else {
                myScroller.maxScrollY = contentHeight + 1;
                myScroller.refresh();
            }
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {

    }

    function queryContract(query_mode) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var _request_num = "1000";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "position_str": "",
            "request_num": _request_num,
            "query_type": "0",
            "compact_type": "1",
            "query_mode": query_mode,
        };
        service_credit.openInterest_Query(param, function (data) {
            $(_pageId + ".no_more_data").hide();
            if (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (query_mode == "1") {
                        $(_pageId + ".j-position-table table").removeClass("custmo_contract_list");
                        $(_pageId + ".j-position-table table thead").html("<tr><th>证券/代码</th><th>未还/息费</th><th>盈亏/保证金</th>");
                    } else {
                        $(_pageId + ".j-position-table table").addClass("custmo_contract_list");
                        $(_pageId + ".j-position-table table thead").html("<tr><th></th><th>证券/合约号</th><th>未还/息费</th><th>盈亏/到期日</th>");
                    }
                    if (results && results.length > 0) {
                        var listHtml = "";
                        $(_pageId + ".no_data_box").hide();
                        for (var i = 0; i < results.length; i++) {
                            if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                            listHtml += formatHtml(results[i]);
                        }
                        $(_pageId + ".j-position-table table tbody").html(listHtml);
                        $(_pageId + ".no_more_data").show();
                        if (_compact_id) {
                            $(_pageId + ".j-position-table table tbody tr").each(function () {
                                if (_compact_id == $(this).attr("id")) {
                                    var stockCode = $(this).attr("stock_code");
                                    var checkNum = $(_pageId + ".content .j-position-table tbody tr a.checked").length;
                                    if (checkNum == 0) {
                                        //判断当前选中合约是否有同类合约，不同类的将禁止选中
                                        $(_pageId + " .j-position-table table tbody tr a").each(function () {
                                            if (stockCode != $(this).parents("tr").attr("stock_code")) {
                                                $(this).addClass("noChoice");
                                            }
                                        });
                                    }
                                    $(this).find("a").addClass("checked");
                                    creditOrder.setCompactIdInfo(_compact_id);
                                    creditOrder.setCashgroupProp($(this).attr("compact_source"))
                                }
                            })
                        }
                    } else {
                        $(_pageId + ".j-position-table table tbody").html("");
                        $(_pageId + ".no_data_box").show();
                    }
                } else {
                    $.alert(data.error_info);
                }
            }
            initScroller();
        });
    }

    function formatHtml(element) {
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        var price_digit = 2;
        var css = "";
        var slo_income = null;
        slo_income = Number(element.slo_income);
        if (slo_income > 0) {
            css = "ared";
        } else if (slo_income < 0) {
            css = "agreen";
        }
        slo_income = slo_income ? slo_income.toFixed(price_digit) : "--";
        var html = '';
        var query_mode = $(_pageId + ".trade_second_page .liabilities_tab_list li.active").attr("query_mode");
        if (query_mode == "1") {
            html += '<tr id="' + element.stock_code + '" stock_name="' + element.stock_name + '" stock_account="' + element.stock_account + '" exchange_type="' + element.exchange_type + '">';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
            html += '<span style="font-size:' + $.getTransformScaleFontSize(element.stock_code, 14, maxWidth) + 'px;">' + element.stock_code + '</span>';
            html += '</td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.real_compact_amount, 16, maxWidth) + 'px;">' + element.real_compact_amount + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.compact_interest).toFixed(price_digit), 16, maxWidth) + 'px;">' + Number(element.compact_interest).toFixed(price_digit) + '</p>';
            html += '</td>';
            html += '<td>';
            html += '<p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(slo_income, 16, maxWidth) + 'px;">' + slo_income + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.used_bail_balance).toFixed(price_digit), 16, maxWidth) + 'px;">' + Number(element.used_bail_balance).toFixed(price_digit) + '</p>';
            html += '</td>';
            html += '</tr>';
        } else {
            html += '<tr id="' + element.compact_id + '" stock_code="' + element.stock_code + '" compact_source="' + (element.compact_source ? element.compact_source : "") + '" stock_name="' + element.stock_name + '" stock_account="' + element.stock_account + '" exchange_type="' + element.exchange_type + '" real_compact_amount="' + element.real_compact_amount + '">';
            html += '<td><a class="t_check_box"></a></td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
            html += '<span style="font-size:' + $.getTransformScaleFontSize(element.compact_id, 14, ($(window).width() * 0.5 - 25)) + 'px;">' + element.compact_id + '</span>';
            html += '</td>';
            html += '<td>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.real_compact_amount, 16, maxWidth) + 'px;">' + element.real_compact_amount + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.compact_interest).toFixed(price_digit), 16, maxWidth) + 'px;">' + Number(element.compact_interest).toFixed(price_digit) + '</p>';
            html += '</td>';
            html += '<td>';
            html += '<p class="' + css + '" style="font-size:' + $.getTransformScaleFontSize(slo_income, 16, maxWidth) + 'px;">' + slo_income + '</p>';
            html += '<p style="font-size:' + $.getTransformScaleFontSize(element.ret_end_date, 16, maxWidth) + 'px;">' + element.ret_end_date + '</p>';
            html += '</td>';
            html += '</tr>';
        }
        return html;
    }

    function clearCache() {
        _compact_id = "";
    }

    /**
     * 数据重置
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + " .liabilities_tab_list li").eq(0).addClass("active").siblings().removeClass("active");
        $(_pageId + " .no_data_box").hide();
        $(_pageId + " .j-position-table table tbody").html("");
        $(_pageId + " .no_more_data").hide();
        creditOrder.dataDestroy();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
