/**
 * 信用交易-现金还款
 */
define('trade/scripts/credit/order/cashPayments.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var service_credit = require("service_credit");
    var _pageId = "#credit_order_cashPayments ";
    var userInfo = null;
    var debtdate = ""; //合约日期
    var debtsno = "";  //合约编号
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var keyboard = require("keyboard");
    var contractData = {};
    var selectedList = [];
    var compact_id_info = ""; //直接还款默认传""
    var _pay_type = 0;        //下单时判断是直接还款还是指定合约还款 0 直接还款  1指定合约还款
    var wHeight = 0;
    var _load = false;
    var _compact_id = "";
    var _cashgroup_prop = "";//头寸性质，0-普通，1-专项

    /**
     * 初始化
     */
    function init() {
        if (keyboard) {
            keyboard.keyInit();
        }
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        wHeight = $("html").height() || gconfig.appHeight;
        _load = true;
        common.setMainHeightNew(_pageId, false, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        _compact_id = $.getPageParam("compact_id") ? $.getPageParam("compact_id") : "";
        if (_compact_id) {
            selectContractBuryingPoint();
        } else {
            buryingPoint();
        }
        queryFundSelectData();
        queryContract();
    }

    //直接还款埋点
    function buryingPoint() {
        common.pageBuryingPoint("105188");
        $(_pageId + ".content .guarantee_transfer_box .all_btn").attr("objectId", "105191");//全部点击
        $(_pageId + ".content .guarantee_transfer_box .all_btn").attr("actionId", "103");
        $(_pageId + ".content .transfer_btn_box").attr("objectId", "105192");//提交委托
        $(_pageId + ".content .transfer_btn_box").attr("actionId", "103");
    }

    /**
     * 选择合约埋点
     */
    function selectContractBuryingPoint() {
        common.pageBuryingPoint("105200");
        $(_pageId + ".content .guarantee_transfer_box .all_btn").attr("objectId", "105202");//全部点击
        $(_pageId + ".content .guarantee_transfer_box .all_btn").attr("actionId", "103");
        $(_pageId + ".content .transfer_btn_box").attr("objectId", "105203");//提交委托
        $(_pageId + ".content .transfer_btn_box").attr("actionId", "103");
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            e.stopPropagation();
        });

        //返回按钮
        $.bindEvent($(_pageId + "header .header_inner .back_btn"), function (e) {
            setTimeout(function () {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                var pageCode = $.getCurrentPageObj().pageCode || '';
                var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
                if (prePageCode == "credit/asset/debt") {
                    $.pageInit(pageCode, prePageCode, {
                        "_loginClass": "1",
                        "compact_type": $.getPageParam("compact_type")
                    }, "left", true);
                } else {
                    $.pageInit(pageCode, prePageCode, {"_loginClass": "1"}, "left", true);
                }
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //全额
        $.bindEvent($(_pageId + ".content .guarantee_transfer_list .all_btn"), function (e) {
            var mayPay = $(_pageId + "#mayPay").text();  //需还款额
            mayPay = mayPay.replaceAll(",", "");
            mayPay = mayPay && mayPay != "--" ? mayPay : 0;
            var enableMoney = $(_pageId + "#enableMoney").text();//可用资金
            enableMoney = enableMoney.replaceAll(",", "");
            enableMoney = enableMoney && enableMoney != "--" ? enableMoney : 0;
            var payMoney = 0;
            if (Number(enableMoney) > Number(mayPay)) {
                payMoney = mayPay;
            } else {
                payMoney = enableMoney;
            }
            $(_pageId + "#payMoney").quzhi(payMoney);
            $(_pageId + "#payMoney").attr("value", payMoney);
            $(_pageId + "#payMoney").children("em").text(payMoney);
            $(_pageId + "#payMoney").find("div.key_text").text(payMoney);
            if (mayPay.length == 0) {
                $(_pageId + "#payMoney").find("div.key_place").show();
            } else {
                $(_pageId + "#payMoney").find("div.key_place").hide();
            }
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": "全部"});
            e.stopPropagation();
        });

        //提交委托
        $.bindEvent($(_pageId + ".content .transfer_btn_box .t_btn_text"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if ($(_pageId + "#selectContract").attr("selectFlag") != "true") {
                compact_id_info = "";   //直接还款
                _pay_type = 0;
            } else {
                _pay_type = 1;
                compact_id_info = selectedList.join(",");
            }
            vailSubmitOrder();
            e.stopPropagation();
        });
    }

    /**
     * 资金查询
     */
    function queryFundSelectData(bz) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = bz ? bz : "";////货币 ""所有货币，0 人民币，1 港币，2 美元
        var password = userInfo.password;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "money_type": money_type
        };
        $(_pageId + "#mayPay").text("--");
        service_credit.remoney_link(param, queryFundSelectCallback);
    }

    /**
     * 资金查询回调方法
     * @param {Object} data 返回数据
     */
    function queryFundSelectCallback(data) {
        if (data) {
            if (data.error_no == 0) {
                var account = data.results;
                if (account && account != "undefined" && account.length > 0) {
                    var current_balance = account[0].fin_enrepaid_balance;
                    var total_debit = account[0].real_compact_balance;
                    $(_pageId + "#enableMoney").text(current_balance ? common.numToMoneyType(Number(current_balance).toFixed(2)) : "--");  //资金可用金额
                    $(_pageId + "#mayPay").text(total_debit ? common.numToMoneyType(Number(total_debit).toFixed(2)) : "--");  //需还款额
                } else {
                    $(_pageId + "#mayPay").text("--");
                    $(_pageId + "#enableMoney").text("--");
                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                }
            } else {
                $(_pageId + "#mayPay").text("--");
                $(_pageId + "#enableMoney").text("--");
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                $.alert(data.error_info);
            }
        }
    }

    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        var mostBuy = $(_pageId + " #mayPay").text();
        mostBuy = mostBuy.replaceAll(",", "");
        var operateion_type = "现金还款";
        if (Number(mostBuy) == 0) {
            $.alert("已不需要还款");
            return false;
        }
        //还款金额
        var money = $(_pageId + "#payMoney").val();
        if (money.length == 0) {
            $.alert("请输入还款金额");
            return false;
        }
        //验证股票价格输入是否正确
        if (!validatorUtil.isNumberFloat(money)) {
            $.alert("请正确输入还款金额");
            return false;
        }
        if (Number(money) <= 0) {
            $.alert("还款金额必须大于0");
            return false;
        }
        var avail = $(_pageId + " #enableMoney").text();
        avail = avail.replaceAll(",", "");
        if (Number(avail) < Number(money)) {
            $.alert("可用金额不足");
            return false;
        }
        //验证需还款额
        if (Number(money) > Number(mostBuy)) {
            $.alert("还款金额已经大于需还款额");
            return false;
        }

        if ($(_pageId + "#selectContract").attr("selectFlag") == "true") {
            operateion_type = "指定合约还款";
            if (compact_id_info == "") {
                $.alert("请选择合约");
                return false;
            }
        }
        var tipStrArray = [];
        tipStrArray.push(["资产账户", userInfo.fund_account]);
        tipStrArray.push(["操作类型 ", operateion_type]);
        tipStrArray.push(["需还款额 ", $(_pageId + " #mayPay").text()]);
        tipStrArray.push(["还款金额 ", money]);
        var tipStr = "<div>";
        tipStr += common.generatePrompt(tipStrArray);
        tipStr += "</div>";
        common.iConfirmNew("现金还款", tipStr, function success() {
            var cust_code = userInfo.cust_code;	//客户代码
            var fund_account = userInfo.fund_account;	//资产账户
            var branch_no = userInfo.branch_no;	//分支机构
            var sessionid = userInfo.session_id;
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var password = userInfo.password;
            var money_type = "0";
            var pay_type = _pay_type;
            var occur_balance = $(_pageId + "#payMoney").val();
            var compact_id = compact_id_info;
            var cashgroup_prop = "";
            if (compact_id) {
                cashgroup_prop = _cashgroup_prop;
            }
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "password": password,
                "sessionid": sessionid,
                "money_type": money_type,
                "pay_type": pay_type,
                "occur_balance": occur_balance,
                "compact_id": compact_id,
                "debtdate": debtdate,
                "debtsno": debtsno,
                "cashgroup_prop": cashgroup_prop
            };
            service_credit.repayment(param, getStockBuyCallBack, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            $.showPreloaders("请等待...");
            var objectId = $(_pageId + ".content .transfer_btn_box").attr("objectId");
            var actionId = $(_pageId + ".content .transfer_btn_box").attr("actionId");
            common.comStat(objectId, 2, actionId, true, {"i_group_name": "提交委托"});
        }, null);
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        $.hidePreloader();
        if (data.error_no == 0) {
            var results = data.results;
            resetBuyForm();
            if (results) {
                var occur_balance = results[0].occur_balance;
                var tipStr = "交易委托已提交，实际还款金额 : " + Number(occur_balance ? occur_balance : 0).toFixed(3);
                $.alert(tipStr);
            }
        } else {
            resetBuyForm();
            $.alert(data.error_info);
        }
        queryFundSelectData();
        queryContract();
    }


    function queryContract() {
        $(_pageId + ".content #selectContract").html("未指定");
        $(_pageId + ".content #selectContract").removeClass("current");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "query_type": "0",
        };
        service_credit.openInterest_Query(param, function (data) {
            contractData = {};
            $(_pageId + ".no_more_data").hide();
            if (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        $(_pageId + ".no_more_data").show();
                        var listHtml = "";
                        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
                        var isData = false;//是否有合约数据
                        for (var i = 0; i < results.length; i++) {
                            if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                            if (results[i].compact_type == "0" || results[i].compact_type == "2") {
                                isData = true;
                                contractData["" + results[i].compact_id] = results[i];
                                var stock_name = $.trim(results[i].stock_name) ? $.trim(results[i].stock_name) : "--";
                                var stock_code = $.trim(results[i].stock_code) ? $.trim(results[i].stock_code) : "--";
                                var open_date = $.trim(results[i].open_date) ? $.trim(results[i].open_date.replaceAll("-", "/")) : "--";
                                listHtml += '<tr>';
                                listHtml += '<td>';
                                listHtml += '<a class="t_check_box" href="javascript:void(0);" id="' + results[i].compact_id + '" stock_name="' + stock_name + '" compact_source="' + results[i].compact_source + '"></a>';
                                listHtml += '</td>';
                                listHtml += '<td>';
                                listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(stock_name, 16, maxWidth + 5)+')">' + stock_name + '</p>';
                                listHtml += '<span style="transform-origin: left;transform:scale('+$.getTransformScale(stock_code, 14, maxWidth)+')">' + stock_code + '</span>';
                                listHtml += '</td>';
                                listHtml += '<td>';
                                listHtml += '<p class="line_break">' + results[i].compact_id + '</p>';
                                listHtml += '</td>';
                                listHtml += '<td>';
                                listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(results[i].whhy, 14, maxWidth)+')">' + results[i].whhy + '</p>';
                                listHtml += '</td>';
                                listHtml += '<td>';
                                listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(open_date, 14, maxWidth)+')">' + open_date + '</p>';
                                listHtml += '</td>';
                                listHtml += '</tr>';
                            }
                        }
                        if (isData) {
                            addChoiceList($(_pageId + ".content .total_liabilities_box .sel_text"), listHtml, function (data, div) {
                                var length = data.length;
                                var tatolNeedToPay = 0;
                                if (length != 0) {
                                    if (length > 50) {
                                        $.alert("最多可指定50个合约");
                                        return false;
                                    }
                                    div.html("已选" + length + "个");
                                    div.addClass("current");
                                    for (var i = 0; i < length; i++) {
                                        selectedList.push(data.eq(i).attr("id"));
                                        tatolNeedToPay += Number(data.eq(i).parents("tr").find("p").eq(2).text());
                                        //埋点
                                        var objectId = div.attr("objectId");
                                        var actionId = div.attr("actionId");
                                        common.comStat(objectId, 2, actionId, true, {
                                            "i_change_name": "选择指定合约",
                                            "i_change_to": data.eq(i).attr("stock_name")
                                        });//埋点
                                        if (!_cashgroup_prop) {
                                            _cashgroup_prop = data.eq(i).attr("compact_source")
                                        }
                                    }
                                    tatolNeedToPay = Number(tatolNeedToPay).toFixed(2);
                                    //选择指定合约后统计金额
                                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("指定合约金额");
                                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("strong").text(common.numToMoneyType(tatolNeedToPay, 2));
                                    $(_pageId + "#payMoney").quzhi(tatolNeedToPay);
                                    $(_pageId + "#selectContract").attr("selectFlag", "true");
                                } else {
                                    div.html("未指定");
                                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                                    div.removeClass("current");
                                    selectedList = [];
                                    $(_pageId + "#payMoney").quzhi("");
                                    $(_pageId + "#selectContract").attr("selectFlag", "false");
                                    queryFundSelectData();
                                }
                            }, null, null);
                            $.bindEvent(_pageId + ".listSelection .j-position-table tbody tr", function (e) {
                                var checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
                                if (checkNum > 0) {
                                    var compact_source = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").first().attr("compact_source");
                                    var curr_compact_source = $(this).find("a").attr("compact_source");
                                    if (compact_source != curr_compact_source) {
                                        $(this).find("a").removeClass("checked");
                                        $.alert("普通与专项合约无法同时进行委托，请选择同类型合约");
                                        return false;
                                    }
                                }
                                $(this).find("a").toggleClass("checked");
                                checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
                                if (checkNum > 50) {
                                    $(this).find("a").removeClass("checked");
                                    $.alert("最多可指定50个合约");
                                    return false;
                                }
                                e.stopPropagation(); // 阻止冒泡
                            });
                        } else {
                            $(_pageId + ".content #selectContract").text("暂无合约");
                            $(_pageId + ".content #selectContract").removeClass("current");
                        }
                    } else {
                        $(_pageId + ".content #selectContract").text("暂无合约");
                        $(_pageId + ".content #selectContract").removeClass("current");
                    }
                }
            } else {
                $.alert(data.error_info);
            }
        }, {"isShowWait": false});
    }

    function addChoiceList(div, html, determine) {
        $(_pageId + ".listSelection .j-position-table tbody").html("");
        $.bindEvent(div, function (e) {
            div = $(this);
            $(_pageId + ".listSelection.multi").showLeft(null, null, function () {
                if (_compact_id) {
                    $(this).find("table tbody a").each(function () {
                        if (_compact_id == $(this).attr("id")) {
                            $(this).addClass("checked");
                        }
                    });
                }
            });
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
            if (!global.startJSkeyboard) {
                e.stopPropagation(); // 阻止冒泡
            }
            //埋点
            var clickObjectId = $(_pageId + ".content .total_liabilities_box .row-1").eq(1).attr("clickObjectId");
            var clickActionId = $(_pageId + ".content .total_liabilities_box .row-1").eq(1).attr("clickActionId");
            common.comStat(clickObjectId, 2, clickActionId, true, {"i_group_name": "选择指定合约"});
            common.pageBuryingPoint();
            common.pageBuryingPoint("105210");
        });
        $(_pageId + ".listSelection .j-position-table tbody").html(html);
        $.bindEvent(_pageId + ".listSelection .j-position-table tbody tr", function (e) {
            var checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
            if (checkNum > 0) {
                var compact_source = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").first().attr("compact_source");
                var curr_compact_source = $(this).find("a").attr("compact_source");
                if (compact_source != curr_compact_source) {
                    $(this).find("a").removeClass("checked");
                    $.alert("普通与专项合约无法同时进行委托，请选择同类型合约");
                    return false;
                }
            }
            $(this).find("a").toggleClass("checked");
            checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
            if (checkNum > 50) {
                $(this).find("a").removeClass("checked");
                $.alert("最多可指定50个合约");
                return false;
            }
            e.stopPropagation(); // 阻止冒泡
        });
        $.bindEvent(_pageId + ".listSelection .header_inner .back_btn", function (e) {
            $(_pageId + ".listSelection").hideLeft();
            //埋点
            var backObjectId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("backObjectId");
            var backActionId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("backActionId");
            common.comStat(backObjectId, 2, backActionId, true, {"i_group_name": "返回"});
            common.pageBuryingPoint();
            if (selectedList.length == 0) {//返回切换埋点
                buryingPoint();
            } else {
                selectContractBuryingPoint();
            }
            e.stopPropagation(); // 阻止冒泡
        });
        $.bindEvent(_pageId + ".listSelection.multi .header_inner .fr_trext_btn", function (e) {
            if (determine) {
                determine($(_pageId + ".listSelection .j-position-table tbody tr a.checked"), div);
            }
            $(_pageId + ".listSelection").hideLeft();
            //埋点
            var saveObjectId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("saveObjectId");
            var saveActionId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("saveActionId");
            common.comStat(saveObjectId, 2, saveActionId, true, {"i_group_name": "保存"});
            common.pageBuryingPoint();
            if ($(_pageId + ".listSelection .j-position-table tbody tr a.checked").length == 0) {//保存确定，切换埋点
                buryingPoint();
            } else {
                selectContractBuryingPoint();
            }
            e.stopPropagation(); // 阻止冒泡
        });
        if (_compact_id) {
            var compactInfo = contractData[_compact_id];
            if (compactInfo) {
                selectedList.push(_compact_id);
                _cashgroup_prop = compactInfo.compact_source;
                $(_pageId + ".content #selectContract").html("已选1个");
                $(_pageId + ".content #selectContract").addClass("current");
                var tatolNeedToPay = Number(compactInfo.whhy);
                tatolNeedToPay = Number(tatolNeedToPay).toFixed(2);
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("指定合约金额");
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("strong").text(common.numToMoneyType(tatolNeedToPay, 2));
                $(_pageId + "#payMoney").quzhi(tatolNeedToPay);
                $(_pageId + "#selectContract").attr("selectFlag", "true");
            }
        }
    }


    function initScroller() {
        if (_load) {
            var scrollOptions = {
                scrollerHeight: wHeight - $(_pageId + " .listSelection .header_inner").height() + 2, // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                isAlwaysShowPullUp: false,
                bounceTime: 300,// 回弹的动画时间
                pullUpHandler: function () {

                }
            };
            if (!myScroller) {
                myScroller = iscrollUtils.vScroller(scrollOptions);
            } else {
                myScroller.refresh();
            }
        }
    }

    /**
     * 重置表单
     * */
    function resetBuyForm() {
        selectedList = [];   //清除选择的合约
        $(_pageId + "#enableMoney").text("--");
        $(_pageId + "#mayPay").text("--");
        $(_pageId + "#payMoney").quzhi("");
        $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
        $(_pageId + "#selectContract").text("未指定");
        $(_pageId + "#selectContract").attr("selectFlag", "false");
        $(_pageId + "#selectContract").removeClass("current");
        _compact_id = "";
        _cashgroup_prop = "";
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        if (keyboard) {
            keyboard.keyDestroy();
        }
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        resetBuyForm();
        //退出该页面时清除页面上查询的合约信息
        $(_pageId + ".listSelection .j-position-table tbody").html("");
        $(_pageId + "#selectContract").unbind();
        $(_pageId + ".no_more_data").hide();
        contractData = {};
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
