/**
 * 信用交易-合约展期
 */
define('trade/scripts/credit/order/contractExtension.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#credit_order_contractExtension ";
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var common = require("common");
    var service_credit = require("service_credit");
    var userInfo = null;  // 账号信息
    var contractData = {};
    var contractInfo = [];
    var but_height = null;

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight();
        common.pageBuryingPoint("107393");
        userInfo = common.getCurUserInfo();
    }

    function load() {
        var mainHeight = common.setMainHeightNew(_pageId, false);
        $(_pageId + "footer .t_check_box").addClass("checked");
        but_height = $(_pageId + "footer").height();
        queryContract();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //查询跳转
        $.bindEvent($(_pageId + ".header_inner .fr_trext_btn"), function (e) {
            common.comStat(107395, 2, 103, true, {"i_group_name": "展期结果点击"});
            $.pageInit("credit/order/contractExtension", "credit/query/contractExtensionResult", {});
            e.stopPropagation();
        });

        //提交委托
        $.bindEvent($(_pageId + ".t_btn_text"), function (e) {
            //获取选择的合约的合约编号
            getChoiceData();
            common.comStat(107394, 2, 103, true, {"i_group_name": "展期申请点击"});
            e.stopPropagation();
        });

        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                var pageCode = $.getCurrentPageObj().pageCode || '';
                var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
                $.pageInit(pageCode, prePageCode, {"_loginClass": "1"}, "left", true);
                e.stopPropagation();
            }, 300);
        });
    }

    function getChoiceData() {
        //清除之前选择的
        contractInfo = [];
        $(_pageId + ".contract_flow_list .list_item a.checked").each(function () {
            var id = $(this).attr("id");
            contractInfo.push(id);
        });
        vailSubmitOrder();
    }

    function queryContract() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var _request_num = "1000";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "position_str": "",
            "request_num": _request_num,
            "compact_postpone_flag": "0"
        };
        service_credit.openInterest_Query(param, function (data) {
            $(_pageId + ".no_data_box").hide();
            contractData = {};
            if (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        var listHtml = "";
                        var isData = false;
                        for (var i = 0; i < results.length; i++) {
                            if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                            if (results[i].compact_postpone_flag == "0") {
                                isData = true;
                                contractData["" + results[i].compact_id] = results[i];
                                listHtml += getHtml(results[i]);
                            }
                        }
                        if (isData) {//是否有合约展期数据
                            //显示提交按钮
                            $(_pageId + "footer").show();
                            $(_pageId + ".contract_flow_list").html(listHtml);
                            $(_pageId + ".contract_flow_list").append('<div class="no_more_data" style="padding-top:0.1rem;text-align: left;padding-left: 0.15rem;color: #3f3f3f;font-size: 0.12rem;">温馨提示：<span style="color: #999999;">在归还到日期前10个交易日内可发起展期操作</span></div>');
                            $(_pageId + "footer .t_check_box").addClass("checked");
                            $.bindEvent(_pageId + ".contract_flow_list .list_item a", function (e) {
                                if ($(this).hasClass("checked")) {
                                    $(this).removeClass("checked");
                                    $(_pageId + "footer .t_check_box").removeClass("checked");
                                } else {
                                    $(this).addClass("checked");
                                    var total_num = $(_pageId + ".contract_flow_list .list_item a").length;
                                    var checked_num = $(_pageId + ".contract_flow_list .list_item a.checked").length;
                                    if (total_num == checked_num) {
                                        $(_pageId + "footer .t_check_box").addClass("checked");
                                    }
                                }
                                e.stopPropagation(); // 阻止冒泡
                            });

                            $.bindEvent(_pageId + "footer .t_check_box", function (e) {
                                if ($(this).hasClass("checked")) {
                                    $(this).removeClass("checked");
                                    $(_pageId + ".contract_flow_list .list_item a").removeClass("checked");
                                } else {
                                    $(this).addClass("checked");
                                    $(_pageId + ".contract_flow_list .list_item a").removeClass("checked").addClass("checked");
                                }
                                e.stopPropagation(); // 阻止冒泡
                            });
                        } else {
                            $(_pageId + ".contract_flow_list").html("");
                            $(_pageId + "footer").hide();
                            $(_pageId + ".no_data_box").show();
                        }
                    } else {
                        $(_pageId + ".contract_flow_list").html("");
                        $(_pageId + "footer").hide();
                        $(_pageId + ".no_data_box").show();
                    }
                } else {
                    $.alert(data.error_info);
                }
            }
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
        }, {
            "isShowWait": false, "timeOutFunc": function () {
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            }
        });
    }


    function getHtml(element) {
        var price_digit = 2;
        var html = "";
        var compact_type = element.compact_type;//0-融资，1-融券，2-其他
        var compact_type_name = "";
        var css = "label_02";
        if (compact_type == "0") {
            compact_type_name = "融资";
        } else if (compact_type == "1") {
            compact_type_name = "融券";
            css = "label_01";
        } else {
            compact_type_name = "其他负债";
        }
        var startDate = (element.open_date + "").replaceAll("-", "/");
        var endDate = (element.ret_end_date + "").replaceAll("-", "/");
        var statuss = {"0": "开仓未归还", "1": "部分归还", "2": "合约已过期", "3": "客户自行了结", "4": "手工了结", "5": "未形成负债"};
        var stock_name = $.trim(element.stock_name) ? $.trim(element.stock_name) : "--";
        var stock_code = $.trim(element.stock_code) ? $.trim(element.stock_code) : "--";
        html += '<div class="list_item">';
        html += '<div class="li_top border_bottom">';
        html += '<a class="t_check_box checked" href="javascript:void(0);" id="' + element.compact_id + '"></a>';
        html += '<span class="label_text ' + css + '">' + compact_type_name + '</span>';
        html += '<p class="fr_text">编号 ' + element.compact_id + '</p>';
        html += '</div>';
        html += '<div class="li_con">';
        html += '<ul class="flow_list">';
        html += '<li><span style="white-space: nowrap;transform-origin: left;transform:scale('+$.getTransformScale(stock_name, 14, 75)+')">' + stock_name + '</span>' + stock_code + '</li>';
        html += '<li><span>合约日期</span>' + startDate + '</li>';
        html += '<li><span>合约状态</span>' + statuss[element.compact_status] + '</li>';
        html += '<li><span>开仓数量</span>' + element.business_amount + '</li>';
        html += '<li><span>开仓金额</span>' + Number(element.business_price).toFixed(price_digit) + '</li>';
        html += '<li><span>已还金额</span>' + Number(element.repaid_balance).toFixed(price_digit) + '</li>';
        html += '<li><span>已还利息</span>' + Number(element.repaid_interest).toFixed(price_digit) + '</li>';
        html += '<li><span>合约来源</span>' + (element.compact_source_name ? element.compact_source_name : "--") + '</li>';
        if (element.compact_type == "1") {
            html += '<li><span>累计未还</span>' + element.real_compact_amount + '股</li>';
        } else {
            html += '<li><span>累计未还</span>' + Number(Number(element.real_compact_balance) + Number(element.real_compact_fare) + Number(element.real_compact_interest)).toFixed(price_digit) + '</li>';
        }
        html += '<li><span>合约年利率</span>' + element.year_rate + '</li>';
        html += '<li><span>合约到期日</span>' + endDate + '</li>';
        html += '</ul>';
        html += '</div>';
        html += '</div>';
        return html;
    }

    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        //验证股票代码输入是否正确
        if (common.size(contractData) == 0) {
            $.alert("没有合约信息");
            return false;
        }
        if (!common.isValue(contractInfo)) {
            $.alert("请选择合约");
            return false;
        }
        common.iConfirmNew("合约展期确认", "<p>所选合约即将到期 , 请确认是否需要展期 ?</p>", function (e) {
            //埋点
            var cust_code = userInfo.cust_code;	//客户代
            var fund_account = userInfo.fund_account;	//资产账户
            var branch_no = userInfo.branch_no;	//分支机构
            var sessionid = userInfo.session_id;
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var password = userInfo.password;
            var compact_id = contractInfo.join(",");
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "password": password,
                "sessionid": sessionid,
                "compact_id_str": compact_id
            };
            service_credit.contractExtensionEntrust(param, getStockBuyCallBack);
        }, function () {
        }, "确定", "取消");
    }

    /**
     * 委托下单返回
     * */
    function getStockBuyCallBack(data) {
        if (data) {
            if (data.error_no == "0") {
                $.alert("展期申请提交成功");
                queryContract();
            } else {
                $.alert(data.error_info);
            }
        }
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() - $(_pageId + "footer").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryContract();
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 数据重置
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".contract_flow_list").html("");
        $(_pageId + "footer .t_check_box").addClass("checked");
        $(_pageId + "footer").hide();
        $(_pageId + ".no_data_box").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
