/**
 * 信用交易-普通卖出
 */
define('trade/scripts/credit/order/ordinaryToSell.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var creditOrder = require("creditOrder");
    var commonFunc = require("commonFunc");
    var _pageId = "#credit_order_ordinaryToSell ";
    var common = require("common");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var height_table = null;
    var _load = false;
    var mainHeight = null;

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight(function () {
            if (myScroller) {
                myScroller.destroy();
                myScroller = null;
            }
        });
        common.pageBuryingPoint("105095");
        common.switchingCurUser("1");
        common.bindStockEvent($(_pageId + '.tab_list ul li'), function (pageCode, topage) {
            $.pageInit(pageCode, topage, {"prePageCode": $.getCurrentPageObj().pageId}, '', true);
        });
        mainHeight = common.setMainHeightNew(_pageId, false, false);

        if (global.requestLocation == 0) {
            backgroundInterface();
        }
        commonFunc.getLiquidationInfo(_pageId); //获取清算状态和清算提示信息
    }

    function load() {
        _load = true;
        height_table = mainHeight - $(_pageId + ".content .trans_enter_box").outerHeight(true) - $(_pageId + ".content .j-position-table").css("margin-top").slice(0, -2) - 4;
        if (creditOrder.getQueryHolding()) {
            initScroller();
        }
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        var orderType = "6"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
        creditOrder.dataInit(_pageId, orderType, true, null, initScroller);
        creditOrder.elementBindEvent();
    }

    /**
     * 初始化滑动组件
     */
    function initScroller(height) {
        if (_load) {
            var scrollOptions = {
                scrollerHeight: height || height_table, // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                bounceTime: 300 // 回弹的动画时间
            };
            if (!myScroller) {
                myScroller = iscrollUtils.vScroller(scrollOptions);
            } else {
                //设置底部持仓高度减去分时图高度
                $(_pageId + '#wrapper').height(mainHeight - $(_pageId + ".content .trans_enter_box").outerHeight(true) - $(_pageId + ".content .j-position-table").css("margin-top").slice(0, -2) - 4 - $(".kcb_timeshare").height());
                myScroller.refresh();
            }
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //标的券
        $.bindEvent($(_pageId + "#bdq"), function (e) {
            $.pageInit("credit/order/ordinaryToSell", "credit/query/queryUnderlyingSecurities", {"param": "collateral"});
            e.stopPropagation();
        });
    }

    /**
     * 数据重置
     */
    function destroy() {
        common.pageBuryingPoint();
        creditOrder.dataDestroy();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});