/**
 * 信用交易-卖券还款
 */
define('trade/scripts/credit/order/sellTicketsRepayment.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var creditOrder = require("creditOrder");
    var _pageId = "#credit_order_sellTicketsRepayment ";
    var common = require("common");
    var myScroller_id = null; // 滑动组件对象
    var height_table = null;
    var service_credit = require("service_credit");
    var userInfo = null;  // 账号信息
    var contractData = {};
    var _load = false;
    var wHeight = 0;
    var mainHeight = null;
    var _compact_id = "";
    var selectedList = [];

    /**
     * 初始化
     */
    function init() {
        common.pageChangeHeight(function () {
            if (myScroller) {
                myScroller.destroy();
                myScroller = null;
            }
        });
        common.switchingCurUser("1");
        wHeight = $("html").height() || gconfig.appHeight;
        mainHeight = common.setMainHeightNew(_pageId, false, false);
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        _load = true;
        height_table = mainHeight - $(_pageId + ".content .total_liabilities_box").height() - $(_pageId + ".content .trans_enter_box").outerHeight(true) - $(_pageId + ".content .j-position-table").css("margin-top").slice(0, -2) - 4;
        if (creditOrder.getQueryHolding()) {
            initScroller();
        }
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        _compact_id = $.getPageParam("compact_id") ? $.getPageParam("compact_id") : "";
        if (_compact_id) {
            selectContractBuryingPoint();
        } else {
            buryingPoint();
        }
        var orderType = "8"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
        creditOrder.dataInit(_pageId, orderType, true, null, initScroller, resetHeight);
        queryCapital();
        queryContract();
        creditOrder.elementBindEvent();
        creditOrder.setQueryContract(queryContract);
        creditOrder.setClearCache(clearCache);
        creditOrder.setQueryCapital(queryCapital);
    }

    /**
     * 资金账户查询
     */
    function queryCapital() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var password = userInfo.password;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "money_type": money_type,
            "is_homepage": "1"
        };
        //最后一个为超时处理函数
        service_credit.remoney_link(param, queryCapitalCallback,
            {  //传给接口的json格式数据
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false
            });
    }

    /**
     * 负债信息查询回调
     */
    function queryCapitalCallback(data) {
        if (data && data != "undefined") {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results != "undefined" && results.length > 0) {
                    var data = results[0];
                    var real_compact_balance = data.real_compact_balance;//融资负债
                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                    $(_pageId + ".content .total_liabilities_box strong").html((real_compact_balance && real_compact_balance != "--") ? common.numToMoneyType(real_compact_balance, 2) : "--");
                } else {
                    $(_pageId + ".content .total_liabilities_box strong").html("--");
                    $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                }
            } else {
                $(_pageId + ".content .total_liabilities_box strong").html("--");
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
                $.alert(data.error_info);
            }
        }
    }

    /**
     * 初始化滑动组件
     */
    function initScroller(height) {
        if (_load) {
            var contentHeight = mainHeight - $(_pageId + ".total_liabilities_box").height() - $(_pageId + ".trans_enter_box").height() - $(_pageId + '.kcb_timeshare').height() - 10;
            var temp = $(_pageId + ".j-position-table").height();
            $(_pageId + "#wrapper").css("height", contentHeight);
            if (contentHeight > temp) {
                contentHeight = contentHeight;
            } else {
                contentHeight = temp;
            }
            var scrollOptions = {
                scrollerHeight: height || height_table, // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                bounceTime: 300 // 回弹的动画时间
            };
            if (!myScroller) {
                myScroller = iscrollUtils.vScroller(scrollOptions);
            } else {
                myScroller.maxScrollY = contentHeight + 1;
                myScroller.refresh();
            }
        }
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {

    }

    //卖券还款埋点
    function buryingPoint() {
        common.pageBuryingPoint("105122");
        $(_pageId + ".content #hqCanvas").attr("objectId", "105143");//分时展示
        $(_pageId + ".content #hqCanvas").attr("actionId", "103");
        $(_pageId + ".content .total_liabilities_box .row-1:eq(1)").attr("clickObjectId", "105142");//选择合约点击
        $(_pageId + ".content .total_liabilities_box .row-1:eq(1)").attr("actionId", "103");
        $(_pageId + ".content #stock_list").attr("objectId", "105126");//股票列表选择
        $(_pageId + ".content #stock_list").attr("actionId", "104");
        $(_pageId + ".content #entrustWay").attr("objectId", "105137");//委托方式选择
        $(_pageId + ".content #entrustWay").attr("actionId", "104");
        $(_pageId + ".content .input_box_form.xj").attr("objectId", "105131");//价格输入
        $(_pageId + ".content .input_box_form.xj").attr("actionId", "1");
        $(_pageId + ".content .input_box_form.xj .less_btn").attr("objectId", "105130");//价格减
        $(_pageId + ".content .input_box_form.xj .less_btn").attr("actionId", "103");
        $(_pageId + ".content .input_box_form.xj .add_btn").attr("objectId", "105129");//价格加
        $(_pageId + ".content .input_box_form.xj .add_btn").attr("actionId", "103");
        $(_pageId + ".content #stockNum").parent(".input_box_form").attr("objectId", "105134");//数量输入
        $(_pageId + ".content #stockNum").parent(".input_box_form").attr("actionId", "2");
        $(_pageId + ".content .pos_check_box a:eq(0)").attr("objectId", "105138");//全仓
        $(_pageId + ".content .pos_check_box a:eq(0)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(1)").attr("objectId", "105139");//半仓
        $(_pageId + ".content .pos_check_box a:eq(1)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(2)").attr("objectId", "105140");//1/3仓
        $(_pageId + ".content .pos_check_box a:eq(2)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(3)").attr("objectId", "105141");//1/4仓
        $(_pageId + ".content .pos_check_box a:eq(3)").attr("actionId", "103");
        $(_pageId + ".content #submitOrder").parent(".lowet_btn_box").attr("objectId", "105135");//卖出下单委托确认框
        $(_pageId + ".content #submitOrder").parent(".lowet_btn_box").attr("actionId", "3");
        $(_pageId + ".content #submitOrder").attr("objectId", "105132");//卖出按钮
        $(_pageId + ".content #submitOrder").attr("actionId", "103");
        $(_pageId + ".content .trans_five_box").attr("objectId", "105133");//五档价格点击
        $(_pageId + ".content .trans_five_box").attr("actionId", "1");
        $(_pageId + ".content .j-position-table table").attr("objectId", "105136");//持仓点击
        $(_pageId + ".content .j-position-table table").attr("actionId", "104");
        $(_pageId + ".content .header_inner .back_btn").attr("objectId", "105125");//返回
        $(_pageId + ".content .header_inner .back_btn").attr("actionId", "103");
        $(_pageId + ".content .header_inner .back_btn").attr("name", "返回");
    }

    /**
     * 选择合约埋点
     */
    function selectContractBuryingPoint() {
        common.pageBuryingPoint("105151");
        $(_pageId + ".content #hqCanvas").attr("objectId", "105171");//分时展示
        $(_pageId + ".content #hqCanvas").attr("actionId", "103");
        $(_pageId + ".content .total_liabilities_box .row-1:eq(1)").attr("clickObjectId", "105170");//选择合约点击
        $(_pageId + ".content .total_liabilities_box .row-1:eq(1)").attr("actionId", "103");
        $(_pageId + ".content #stock_list").attr("objectId", "105154");//股票列表选择
        $(_pageId + ".content #stock_list").attr("actionId", "104");
        $(_pageId + ".content #entrustWay").attr("objectId", "105165");//委托方式选择
        $(_pageId + ".content #entrustWay").attr("actionId", "104");
        $(_pageId + ".content .input_box_form.xj").attr("objectId", "105159");//价格输入
        $(_pageId + ".content .input_box_form.xj").attr("actionId", "1");
        $(_pageId + ".content .input_box_form.xj .less_btn").attr("objectId", "105158");//价格减
        $(_pageId + ".content .input_box_form.xj .less_btn").attr("actionId", "103");
        $(_pageId + ".content .input_box_form.xj .add_btn").attr("objectId", "105157");//价格加
        $(_pageId + ".content .input_box_form.xj .add_btn").attr("actionId", "103");
        $(_pageId + ".content #stockNum").parent(".input_box_form").attr("objectId", "105162");//数量输入
        $(_pageId + ".content #stockNum").parent(".input_box_form").attr("actionId", "2");
        $(_pageId + ".content .pos_check_box a:eq(0)").attr("objectId", "105166");//全仓
        $(_pageId + ".content .pos_check_box a:eq(0)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(1)").attr("objectId", "105167");//半仓
        $(_pageId + ".content .pos_check_box a:eq(1)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(2)").attr("objectId", "105168");//1/3仓
        $(_pageId + ".content .pos_check_box a:eq(2)").attr("actionId", "103");
        $(_pageId + ".content .pos_check_box a:eq(3)").attr("objectId", "105169");//1/4仓
        $(_pageId + ".content .pos_check_box a:eq(3)").attr("actionId", "103");
        $(_pageId + ".content #submitOrder").parent(".lowet_btn_box").attr("objectId", "105163");//卖出下单委托确认框
        $(_pageId + ".content #submitOrder").parent(".lowet_btn_box").attr("actionId", "3");
        $(_pageId + ".content #submitOrder").attr("objectId", "105160");//卖出按钮
        $(_pageId + ".content #submitOrder").attr("actionId", "103");
        $(_pageId + ".content .trans_five_box").attr("objectId", "105161");//五档价格点击
        $(_pageId + ".content .trans_five_box").attr("actionId", "1");
        $(_pageId + ".content .j-position-table table").attr("objectId", "105164");//持仓点击
        $(_pageId + ".content .j-position-table table").attr("actionId", "104");
        $(_pageId + ".content .header_inner .back_btn").attr("objectId", "105153");//返回
        $(_pageId + ".content .header_inner .back_btn").attr("actionId", "103");
        $(_pageId + ".content .header_inner .back_btn").attr("name", "返回");
    }

    function queryContract() {
        $(_pageId + "#selectContract").html("未指定");
        $(_pageId + "#selectContract").removeClass("current");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "query_type": "0"
        };
        service_credit.openInterest_Query(param, function (data) {
            contractData = {};
            if (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        $(_pageId + ".listSelection .no_more_data").show();
                        var listHtml = "";
                        var maxWidth = $(window).width() * 0.2 - 10;
                        for (var i = 0; i < results.length; i++) {
                            if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                            if(!(results[i].compact_type == "0" || results[i].compact_type == "2")) {
                                continue;
                            }
                            contractData["" + results[i].compact_id] = results[i];
                            var stock_name = $.trim(results[i].stock_name) ? $.trim(results[i].stock_name) : "--";
                            var stock_code = $.trim(results[i].stock_code) ? $.trim(results[i].stock_code) : "--";
                            var open_date = $.trim(results[i].open_date) ? $.trim(results[i].open_date.replaceAll("-", "/")) : "--";
                            listHtml += '<tr>';
                            listHtml += '<td style="width: 15%;">';
                            listHtml += '<a class="t_check_box" href="javascript:void(0);" id="' + results[i].compact_id + '" stock_name="' + results[i].stock_name + '" compact_source="' + results[i].compact_source + '"></a>';
                            listHtml += '</td>';
                            listHtml += '<td>';
                            listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(stock_name, 16, maxWidth + 5)+')">' + stock_name + '</p>';
                            listHtml += '<span style="transform-origin: left;transform:scale('+$.getTransformScale(stock_code, 14, maxWidth)+')">' + stock_code + '</span>';
                            listHtml += '</td>';
                            listHtml += '<td>';
                            listHtml += '<p class="line_break">' + results[i].compact_id + '</p>';
                            listHtml += '</td>';
                            listHtml += '<td>';
                            listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(results[i].whhy, 14, maxWidth)+')">' + results[i].whhy + '</p>';
                            listHtml += '</td>';
                            listHtml += '<td>';
                            listHtml += '<p style="transform-origin: left;transform:scale('+$.getTransformScale(open_date, 14, $(window).width() * 0.2 - 20)+')">' + open_date + '</p>';
                            listHtml += '</td>';
                            listHtml += '</tr>';
                        }
                        addChoiceList($(_pageId + ".content #selectContract"), listHtml, function (data, div) {
                            var length = data.length;
                            selectedList = [];
                            resetHeight();
                            if (length != 0) {
                                if (length > 50) {
                                    $.alert("最多可指定50个合约");
                                    return false;
                                }
                                div.html("已选" + length + "个");
                                div.addClass("current");
                                var tatolNeedToPay = 0;
                                var compact_source = "";
                                for (var i = 0; i < length; i++) {
                                    selectedList.push(data.eq(i).attr("id"));
                                    tatolNeedToPay += Number(data.eq(i).parents("tr").find("p").eq(2).text());
                                    //埋点
                                    var objectId = div.attr("objectId");
                                    var actionId = div.attr("actionId");
                                    common.comStat(objectId, 2, actionId, true, {
                                        "i_change_name": "选择指定合约",
                                        "i_change_to": data.eq(i).attr("stock_name")
                                    });//埋点
                                    if (!compact_source) {
                                        compact_source = data.eq(i).attr("compact_source");
                                    }
                                }
                                creditOrder.setCashgroupProp(compact_source);//0-普通，1-专项
                                tatolNeedToPay = Number(tatolNeedToPay).toFixed(2);
                                //选择指定合约后统计金额
                                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("指定合约金额");
                                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("strong").text(common.numToMoneyType(tatolNeedToPay, 2));
                                resetHeight();
                                $(_pageId + "#selectContract").attr("selectFlag", "true");
                            } else {
                                div.html("未指定");
                                div.removeClass("current");
                                selectedList = [];
                                queryCapital();
                                $(_pageId + "#selectContract").attr("selectFlag", "false");
                            }
                            creditOrder.setCompactIdInfo(selectedList.join(","));
                        }, null, null);
                    } else {
                        $(_pageId + ".content #selectContract").text("暂无合约");
                        $(_pageId + ".content #selectContract").removeClass("current");
                        $(_pageId + ".listSelection .no_more_data").hide();
                    }
                } else {
                    $.alert(data.error_info);
                }
            }
        });
    }

    function addChoiceList(div, html, determine) {
        $(_pageId + ".listSelection .j-position-table tbody").html("");
        $.bindEvent(div, function (e) {
            div = $(this);
            $(_pageId + ".listSelection.multi").showLeft(null, null, function () {
                if (_compact_id) {
                    $(this).find("table tbody a").each(function () {
                        if (_compact_id == $(this).attr("id")) {
                            $(this).addClass("checked");
                        }
                    });
                }
            });
            if (!global.startJSkeyboard) {
                e.stopPropagation(); // 阻止冒泡
            }
            if (!myScroller_id) {
                initScroller_id();
            } else {
                myScroller_id.refresh();
            }
            //埋点
            var clickObjectId = $(_pageId + ".content .total_liabilities_box .row-1").eq(1).attr("clickObjectId");
            var clickActionId = $(_pageId + ".content .total_liabilities_box .row-1").eq(1).attr("clickActionId");
            common.comStat(clickObjectId, 2, clickActionId, true, {"i_group_name": "选择指定合约"});
            common.pageBuryingPoint();
            common.pageBuryingPoint("105180");
        });
        $(_pageId + ".listSelection .j-position-table tbody").html(html);
        $.bindEvent(_pageId + ".listSelection .j-position-table tbody tr", function (e) {
            var checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
            if (checkNum > 0) {
                var compact_source = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").first().attr("compact_source");
                var curr_compact_source = $(this).find("a").attr("compact_source");
                if (compact_source != curr_compact_source) {
                    $(this).find("a").removeClass("checked");
                    $.alert("普通与专项合约无法同时进行委托，请选择同类型合约");
                    return false;
                }
            }
            $(this).find("a").toggleClass("checked");
            checkNum = $(_pageId + ".listSelection .j-position-table tbody tr a.checked").length;
            if (checkNum > 50) {
                $(this).find("a").removeClass("checked");
                $.alert("最多可指定50个合约");
                return false;
            }
            e.stopPropagation(); // 阻止冒泡
        });
        $.bindEvent(_pageId + ".listSelection .header_inner .back_btn", function (e) {
            $(_pageId + ".listSelection").hideLeft();
            //埋点
            var backObjectId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("backObjectId");
            var backActionId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("backActionId");
            common.comStat(backObjectId, 2, backActionId, true, {"i_group_name": "返回"});
            common.pageBuryingPoint();
            if (selectedList.length == 0) {//返回切换埋点
                buryingPoint();
            } else {
                selectContractBuryingPoint();
            }
            e.stopPropagation(); // 阻止冒泡
        });
        $.bindEvent(_pageId + ".listSelection.multi .header_inner .fr_trext_btn", function (e) {
            if (determine) {
                determine($(_pageId + ".listSelection .j-position-table tbody tr a.checked"), div);
            }
            $(_pageId + ".listSelection").hideLeft();
            //埋点
            var saveObjectId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("saveObjectId");
            var saveActionId = $(_pageId + ".content .total_liabilities_box row-1").eq(1).attr("saveActionId");
            common.comStat(saveObjectId, 2, saveActionId, true, {"i_group_name": "保存"});
            common.pageBuryingPoint();
            if ($(_pageId + ".listSelection .j-position-table tbody tr a.checked").length == 0) {//保存确定，切换埋点
                buryingPoint();
            } else {
                selectContractBuryingPoint();
            }
            e.stopPropagation(); // 阻止冒泡
        });
        if (_compact_id) {
            var compactInfo = contractData[_compact_id];
            if (compactInfo) {
                $(_pageId + ".content #selectContract").html("已选1个");
                $(_pageId + ".content #selectContract").addClass("current");
                var tatolNeedToPay = Number(compactInfo.whhy);
                tatolNeedToPay = Number(tatolNeedToPay).toFixed(2);
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("指定合约金额");
                $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("strong").text(common.numToMoneyType(tatolNeedToPay, 2));
                $(_pageId + "#selectContract").attr("selectFlag", "true");
                resetHeight();
                selectedList.push(_compact_id);
                creditOrder.setCompactIdInfo(_compact_id);
                creditOrder.setCashgroupProp(compactInfo.compact_source);
            }
        }
    }

    function resetHeight() {
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        var height = common.setMainHeightNew(_pageId, false, false) - $(_pageId + ".total_liabilities_box").height() - $(_pageId + ".trans_enter_box").outerHeight(true) - $(_pageId + ".j-position-table").css("margin-top").slice(0, -2) - 4;
        initScroller(height);
    }

    function initScroller_id() {
        if (_load) {
            var scrollOptions = {
                scrollerHeight: wHeight - $(_pageId + " .listSelection .header_inner").height() + 2, // 滚动组件的高度
                $wrapper: $(_pageId + " #wrapper_id"),
                scrollbars: true, // 隐藏滚动条
                hasPullDown: false, // 是否显示下拉提示，默认 true
                hasPullUp: false, // 是否显示上拉提示，默认 true
                isAlwaysShowPullUp: false,
                bounceTime: 300,// 回弹的动画时间
            };
            if (!myScroller_id) {
                myScroller_id = iscrollUtils.vScroller(scrollOptions);
            } else {
                myScroller_id.refresh();
            }
        }
    }

    /**
     * 清楚缓存数据
     */
    function clearCache() {
        $(_pageId + ".content .total_liabilities_box strong").html("--");
        $(_pageId + ".content .total_liabilities_box .row-1:eq(0)").find("p").text("融资总负债");
        $(_pageId + "#selectContract").text("未指定");
        $(_pageId + "#selectContract").removeClass("current");
        $(_pageId + "#selectContract").attr("selectFlag", "false");
        $(_pageId + ".listSelection .j-position-table tbody").html("");
        $(_pageId + ".listSelection .no_more_data").hide();
        _compact_id = "";
        selectedList = [];
        common.pageBuryingPoint();
        buryingPoint();
    }

    /**
     * 数据重置
     */
    function destroy() {
        common.pageBuryingPoint();
        creditOrder.dataDestroy();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        if (myScroller_id) {
            myScroller_id.destroy();
            myScroller_id = null;
        }
        clearCache();
        $(_pageId + "#selectContract").unbind();
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
