/**
 * 信用交易-未偿还合约查询
 */
define('trade/scripts/credit/query/contractInquiryQuery.js', function (require, exports, module) {
    var service_credit = require("service_credit");
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_contractInquiryQuery ";
    var userInfo = null;
    var price_digit = 2;
    var queryType = null;

    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        queryType = $.getPageParam("param");
        if (queryType == "0") {
            common.pageBuryingPoint("105384");
            $(_pageId + ".header_inner h1").text("未偿还合约");
        } else if (queryType == "1") {
            common.pageBuryingPoint("105391");
            $(_pageId + ".header_inner h1").text("历史合约（60天）");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        queryMsg(queryType);//查询信息
    }

    /**
     * 查询信息
     */
    function queryMsg(queryType) {
        $(_pageId + ".no_data_box").hide();
        queryContracliata(queryType); //已了结合约查询
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                if (queryType == "0") {
                    common.comStat(105386, 2, 103, true, {"i_group_name": "返回"});//埋点
                } else if (queryType == "1") {
                    common.comStat(105393, 2, 103, true, {"i_group_name": "返回"});//埋点
                }
                $.pageBack("credit/query/financingQuery", "left");
                e.stopPropagation();
            },300);
        });
    }

    /**
     * 未偿还合约查询
     */
    function queryContracliata(queryType) {
        $(_pageId + ".contract_flow_list").html("");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "query_type": queryType,
            "sessionid": sessionid
        };
        service_credit.openInterest_Query(param, openInterest_QueryCallBack,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $(_pageId + ".no_data_box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });//未偿还合约查询
    }

    /**
     * 未偿还合约数据查询回调方法
     */
    function openInterest_QueryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var openInterestHtml = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        openInterestHtml += createHtml(data);
                    }
                    $(_pageId + ".no_data_box").hide();
                    $(_pageId + ".contract_flow_list").html(openInterestHtml);
                    $(_pageId + ".contract_flow_list").append('<div class="no_more_data" style="padding-top: 0;">没有更多数据了</div>');
                    //返回按钮
                    $.bindEvent($(_pageId + ".contract_flow_list .list_item .li_top p"), function (e) {
                        var compact_id = $(this).attr("id");
                        $.pageInit("credit/query/financingQuery", "credit/query/singleContractFlowQuery", {"compact_id": compact_id});
                        e.stopPropagation();
                    });
                } else {
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        }
    }

    /**
     * 生成未偿还合约html
     * @param {Object} element 数据项
     */
    function createHtml(element) {
        var type = "";
        var css = "label_02";
        if (element.compact_type == "0") {
            type = "融资";
        } else if (element.compact_type == "1") {
            type = "融券";
            css = "label_01";
        } else if (element.compact_type == "2") {
            type = "其他负债";
        }
        var statuss = {"0": "开仓未归还", "1": "部分归还", "2": "合约已过期", "3": "客户自行了结", "4": "手工了结", "5": "未形成负债"};
        var eleHtml = "";
        var stock_name = $.trim(element.stock_name) ? $.trim(element.stock_name) : "--";
        var stock_code = $.trim(element.stock_code) ? $.trim(element.stock_code) : "--";
        if (queryType == "0") {
            eleHtml += '<div class="list_item">';
            eleHtml += '<div class="li_top border_bottom link_box">';
            eleHtml += '<span class="label_text ' + css + '">' + type + '</span>';
            eleHtml += '<p class="fr_text" id="' + element.compact_id + '">编号 ' + element.compact_id + '</p>';
            eleHtml += '</div>';
            eleHtml += '<div class="li_con">';
            eleHtml += '<ul class="flow_list">';
            eleHtml += '<li><span class="flow_list_stock_name_long" style="font-size:'+ $.getTransformScaleFontSize(stock_name, 14, 65) +'px;">' + stock_name + '</span>' + stock_code + '</li>';
            eleHtml += '<li><span>合约日期</span>' + element.open_date + '</li>';
            eleHtml += '<li><span>合约状态</span>' + statuss[element.compact_status] + '</li>';
            eleHtml += '<li><span>开仓数量</span>' + element.business_amount + '</li>';
            eleHtml += '<li><span>开仓金额</span>' + Number(element.business_price).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>已还金额</span>' + Number(element.repaid_balance).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>已还利息</span>' + Number(element.repaid_interest).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>合约来源</span>' + (element.compact_source_name ? element.compact_source_name : "--") + '</li>';
            eleHtml += '<li><span>累计未还</span>' + element.real_compact_amount + '股</li>';
            eleHtml += '<li><span>合约年利率</span>' + element.year_rate + '</li>';
            eleHtml += '<li><span>合约到期日</span>' + element.ret_end_date + '</li>';
            eleHtml += '</ul>';
            eleHtml += '</div>';
            eleHtml += '</div>';
        } else {
            eleHtml += '<div class="list_item">';
            eleHtml += '<div class="li_top border_bottom link_box">';
            eleHtml += '<span class="label_text ' + css + '">' + type + '</span>';
            eleHtml += '<p class="fr_text" id="' + element.compact_id + '">编号 ' + element.compact_id + '</p>';
            eleHtml += '</div>';
            eleHtml += '<div class="li_con">';
            eleHtml += '<ul class="flow_list">';
            eleHtml += '<li><span class="flow_list_stock_name_long" style="font-size:'+ $.getTransformScaleFontSize(stock_name, 14, 65) +'px;">' + stock_name + '</span>' + stock_code + '</li>';
            eleHtml += '<li><span>合约日期</span>' + element.open_date + '</li>';
            eleHtml += '<li><span>合约状态</span>' + statuss[element.compact_status] + '</li>';
            eleHtml += '<li><span>开仓数量</span>' + element.business_amount + '</li>';
            eleHtml += '<li><span>开仓金额</span>' + Number(element.business_price).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>已还金额</span>' + Number(element.repaid_balance).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>已还利息</span>' + Number(element.repaid_interest).toFixed(price_digit) + '</li>';
            eleHtml += '<li><span>合约年利率</span>' + element.year_rate + '</li>';
            eleHtml += '</ul>';
            eleHtml += '</div>';
            eleHtml += '</div>';
        }
        return eleHtml;
    }


    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryMsg(queryType);//下拉获取上一页数据方法
                if (queryType == "0") {
                    common.comStat(105385, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
                } else if (queryType == "1") {
                    common.comStat(105392, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
                }
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".contract_flow_list").html("");
        $(_pageId + ".no_data_box").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
