/**
 * 信用交易-资产负债
 */
define('trade/scripts/credit/query/creditAssetsQuery.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var service_credit = require("service_credit");
    var iscrollUtils = require("iscrollUtils");
    var nativePluginService = require("nativePluginService");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_creditAssetsQuery ";
    var userInfo = null;//保存的客户信息
    var common = require("common");

    /**
     * 初始化
     * */
    function init() {
        common.pageBuryingPoint("107325");
        userInfo = common.getCurUserInfo();
        var prePage = $.getPageParam("param"); //获取上一个页面传过来的参数，判断展示 哪个页面
        if (prePage && prePage == "assert_val") {
            $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
            $(_pageId + "#zc").show();
            $(_pageId + "#fz").hide();
        } else if (prePage && prePage == "total_debit") {
            $(_pageId + ".tab_list li").eq(1).addClass("current").siblings().removeClass("current");
            $(_pageId + "#zc").hide();
            $(_pageId + "#fz").show();
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        queryAssetsData();
    }


    /**
     * 事件绑定
     * */
    function bindPageEvent() {
        //点击查询标题名字
        $.bindEvent($(_pageId + ".tab_list li"), function (e) {
            var titleIndex = $(this).index();
            if (titleIndex == 0) {
                $(this).addClass("current").siblings().removeClass("current");
                $(_pageId + "#zc").show();
                $(_pageId + "#fz").hide();
                common.comStat(107326, 2, 103, true, {"i_group_name": "资产"});//埋点
            } else if (titleIndex == 1) {
                $(this).addClass("current").siblings().removeClass("current");
                $(_pageId + "#zc").hide();
                $(_pageId + "#fz").show();
                common.comStat(107327, 2, 103, true, {"i_group_name": "负债"});//埋点
            }
            checkFontSize();
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
            e.stopPropagation();
        }, "tap");

        //后退
        $.bindEvent($(_pageId + " .header_inner .back_btn"), function (e) {
            setTimeout(function () {
                $.pageBack("credit/query/financingQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        });

        $.bindEvent($(_pageId + " #zcqj2"), function (e) {
            if (global.callNative && global.isSso) {
                var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=xy";
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "15",//打开风险警示权限开通页面
                        "title": "",
                        "toPage":toPage,
                    }
                }
                $.callMessage(param);
            }
        });

        $.bindEvent($(_pageId + " #zcqj"), function (e) {
            if (global.callNative && global.isSso) {
                var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=xy";
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "15",//打开风险警示权限开通页面
                        "title": "",
                        "toPage":toPage,
                    }
                }
                $.callMessage(param);
            }
        });

    }

    /**
     * 总数据查询
     */
    function queryAssetsData() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        service_credit.rzrq_liabilitiesQuery(param, rzrq_liabilitiesQueryCallBack,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $(_pageId + " .trade_second_page strong").text("--");
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    function checkFontSize(){
        $(_pageId+".overview_det strong").each(function(idx, item){
            var zoom = $.getTransformScaleFontSize($(item).text(), 32, $(item).width());
            $(item).css({"font-size": zoom+"px"});
        });
    }

    /**
     * 资产数据调方法
     * @param {Object} data 返回数据
     */
    function rzrq_liabilitiesQueryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var data = results[0];
                    //资产
                    console.log($(_pageId + "#zc strong").eq(0).width());
                    $(_pageId + "#zc strong").eq(0).text(data.assert_val ? common.numToMoneyType(data.assert_val, 2) : "--");//信用账户总资产
                    $(_pageId + "#zc strong").eq(1).text(data.per_assurescale_value ? common.transferText(data.per_assurescale_value * 100, 2) + "%" : "--");//维持担保比例
                    $(_pageId + "#zc strong").eq(2).text(data.net_asset ? common.numToMoneyType(data.net_asset, 2) : "--");//信用账户净资产
                    $(_pageId + "#zc strong").eq(3).text(data.market_value ? common.numToMoneyType(data.market_value, 2) : "--");//证券市值
                    $(_pageId + "#zc strong").eq(4).text(data.cash_asset ? common.numToMoneyType(data.cash_asset, 2) : "--");//现金资产
                    $(_pageId + "#zc strong").eq(5).text(data.assure_asset ? common.numToMoneyType(data.assure_asset, 2) : "--");//担保资产
                    $(_pageId + "#zc strong").eq(6).text(data.fetch_balance ? common.numToMoneyType(data.fetch_balance, 2) : "--");//可取资金
                    $(_pageId + "#zc strong").eq(7).text(data.enable_bail_balance ? common.numToMoneyType(data.enable_bail_balance, 2) : "--");//可用保证金
                    $(_pageId + "#zc strong").eq(8).text(data.assure_enbuy_balance ? common.numToMoneyType(data.assure_enbuy_balance, 2) : "--");//买担保品可用资金
                    $(_pageId + "#zc strong").eq(9).text(data.fin_enbuy_balance ? common.numToMoneyType(data.fin_enbuy_balance, 2) : "--");//买融资标的可用资金
                    $(_pageId + "#zc strong").eq(10).text(data.slo_enrepaid_balance ? common.numToMoneyType(data.slo_enrepaid_balance, 2) : "--");//买券还券可用资金
                    $(_pageId + "#zc strong").eq(11).text(data.fin_enrepaid_balance ? common.numToMoneyType(data.fin_enrepaid_balance, 2) : "--");//现金还款可用资金
                    $(_pageId + "#zc strong").eq(12).text(data.enable_out_asset ? common.numToMoneyType(data.enable_out_asset, 2) : "--");//可转出资产

                    //负债
                    $(_pageId + "#fz strong").eq(0).text(data.total_debit ? common.numToMoneyType(data.total_debit, 2) : "--");//总负债
                    $(_pageId + "#fz strong").eq(1).text(data.per_assurescale_value ? common.transferText(data.per_assurescale_value * 100, 2) + "%" : "--");//维持担保比例
                    $(_pageId + "#fz strong").eq(2).text(data.net_asset ? common.numToMoneyType(data.net_asset, 2) : "--");//净资产
                    $(_pageId + "#fz strong").eq(3).text(data.fin_compact_balance ? common.numToMoneyType(data.fin_compact_balance, 2) : "--");//融资负债
                    $(_pageId + "#fz strong").eq(4).text(data.fin_compact_fare ? common.numToMoneyType(data.fin_compact_fare, 2) : "--");//融资合约费用
                    $(_pageId + "#fz strong").eq(5).text(data.fin_compact_interest ? common.numToMoneyType(data.fin_compact_interest, 2) : "--");//融资合约利息
                    $(_pageId + "#fz strong").eq(6).text(data.fin_income ? common.numToMoneyType(data.fin_income, 2) : "--");//融资合约盈亏
                    $(_pageId + "#fz strong").eq(7).text(data.slo_compact_balance ? common.numToMoneyType(data.slo_compact_balance, 2) : "--");//融券负债
                    $(_pageId + "#fz strong").eq(8).text(data.slo_compact_fare ? common.numToMoneyType(data.slo_compact_fare, 2) : "--");//融券合约费用
                    $(_pageId + "#fz strong").eq(9).text(data.slo_compact_interest ? common.numToMoneyType(data.slo_compact_interest, 2) : "--");//融券合约利息
                    $(_pageId + "#fz strong").eq(10).text(data.slo_income ? common.numToMoneyType(data.slo_income, 2) : "--");  //融券合约盈亏
                    $(_pageId + "#fz strong").eq(11).text(data.other_compact_balance ? common.numToMoneyType(data.other_compact_balance, 2) : "--");  //其他负债
                    $(_pageId + "#fz strong").eq(12).text(data.other_fare ? common.numToMoneyType(data.other_fare, 2) : "--");  //其他合约费用
                    $(_pageId + "#fz strong").eq(13).text(data.other_compact_interest ? common.numToMoneyType(data.other_compact_interest, 2) : "--");  //其他合约利息
                    $(_pageId + ".trade_second_page strong").css("font-weight","normal");

                    checkFontSize();
                } else {
                    $(_pageId + " .trade_second_page strong").text("--");
                }
            } else {
                $.alert(data.error_info);
            }
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryAssetsData(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + "#zc").show();
        $(_pageId + "#fz").hide();
        $(_pageId + ".trade_second_page strong").text("--");
        $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
