/**
 * 信用交易-授信额度查询
 */
define('trade/scripts/credit/query/creditLine.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_credit = require("service_credit");
    var _pageId = "#credit_query_creditLine ";
    var userInfo = null;//保存的客户信息
    var common = require("common");

    /**
     * 初始化
     * */
    function init() {
        common.pageBuryingPoint("105456");
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        querycreditLineData();//查询数据
    }

    /**
     * 事件绑定
     * */
    function bindPageEvent() {
        //后退
        $.bindEvent($(_pageId + " .header_inner .back_btn"), function (e) {
            setTimeout(function () {
                common.comStat(105458, 2, 103, true, {"i_group_name": "返回"});
                $.pageBack("credit/query/financingQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        });

        //后退
        $.bindEvent($(_pageId + " .credit_line_tips a"), function (e) {
            if (global.callNative && global.isSso) {
                $.callMessage({
                    "funcNo": "50115",
                    "loadModuleName": "ygt",
                    "moduleName": "ygt",
                    "url": global.ygtUrl + "/new/ygt/index.html#!/lrLimit/preconception.html?isFromApp=true",
                    "statusColor": "#2A315B",//状态栏颜色
                    "isShowLoading": "1",
                    "targetModule": "trade"
                });
            } else {
                window.location.href = global.ygtUrl + "/new/ygt/index.html#!/lrLimit/preconception.html";
            }
            e.stopPropagation();
        });
    }

    /**
     * 总数据查询
     */
    function querycreditLineData() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        service_credit.rzrq_liabilitiesQuery(param, rzrq_liabilitiesQueryCallBack);
    }

    /**
     * 负债汇总数据方法
     * @param {Object} data 返回数据
     */
    function rzrq_liabilitiesQueryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var data = results[0];
                    $(_pageId + ".trade_second_page strong").eq(0).text(data.fcreditbal ? common.numToMoneyType(data.fcreditbal, 2) : "--");//授信额度
                    // $(_pageId + ".trade_second_page strong").eq(1).text(data.fcreditbal ? common.numToMoneyType(data.fcreditbal, 2) : "--");//融资授信额度
                    $(_pageId + ".trade_second_page strong").eq(1).text(data.fin_used_quota ? common.numToMoneyType(data.fin_used_quota, 2) : "--");//融资已用额度
                    $(_pageId + ".trade_second_page strong").eq(2).text(data.fcreditavl ? common.numToMoneyType(data.fcreditavl, 2) : "--");//融资可用额度
                    // $(_pageId + ".trade_second_page strong").eq(4).text(data.dcreditbal ? common.numToMoneyType(data.dcreditbal, 2) : "--");//融券授信额度
                    $(_pageId + ".trade_second_page strong").eq(3).text(data.slo_used_quota ? common.numToMoneyType(data.slo_used_quota, 2) : "--");//融券已用额度
                    $(_pageId + ".trade_second_page strong").eq(4).text(data.dcreditavl ? common.numToMoneyType(data.dcreditavl, 2) : "--");//融券可用额度
                    $(_pageId + ".trade_second_page strong").css("font-weight","normal");
                    $(_pageId+".overview_det strong").each(function(idx, item){
                        var zoom = $.getTransformScaleFontSize($(item).text(), 32, $(item).width());
                        $(item).css({"font-size": zoom+"px"});
                    });
                } else {
                    $(_pageId + ".trade_second_page strong").text("--");
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        }
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                querycreditLineData();//下拉获取上一页数据方法
                common.comStat(105457, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     * */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".trade_second_page strong").text("--");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
    };
    module.exports = base;
});