/**
 * Created by sizhe on 2016/10/12.
 */
/**
 * 信用交易-查询实时合约流水
 */
define('trade/scripts/credit/query/creditQueryContract.js', function (require, exports, module) {
    var service_credit = require("service_credit");
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_creditQueryContract ";
    var userInfo = null;
    var queryType = null;

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("105377");
        userInfo = common.getCurUserInfo();
    }

    function load() {
        var mianHeight = common.setMainHeight(_pageId, false);
        queryContract();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                common.comStat(105379, 2, 103, true, {"i_group_name": "返回"});//埋点
                $.pageBack("credit/query/financingQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        });
    }

    function queryContract() {
        $(_pageId + ".main .contract_list").html("");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        service_credit.curcontractquery(param, QueryCallBack,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $(_pageId + ".no_data").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }


    function QueryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var openInterestHtml = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        openInterestHtml += createHtml(data);
                    }
                    $(_pageId + ".main .contract_list").html(openInterestHtml);
                } else {
                    $(_pageId + ".no_data").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        }
    }


    function createHtml(element) {
        var type = "";
        if (element.compact_type == "0") {
            type = "融资";
        } else if (element.compact_type == "1") {
            type = "融券";
        } else {
            type = "其他负债";
        }
        var eleHtml = "";
        eleHtml += "<div class=\"part\">";
        eleHtml += "<div class=\"title\"><h5>" + type + "</h5>";
        eleHtml += "<span class=\"time\">合约编号 " + element.compact_id + "<span></div>";
        eleHtml += "<ul>";
        var stock_name = $.trim(element.stock_name) ? $.trim(element.stock_name) : "--";
        var stock_code = $.trim(element.stock_code) ? $.trim(element.stock_code) : "--";
        if (stock_name && stock_code) {
            eleHtml += "<li style='zoom:" + $.getTransformScale(stock_name + stock_code, 16, $(window).width() * 0.5) + ";'>" + stock_name + "<span>" + stock_code + "</span></li>";
        }
        eleHtml += "  <li>交易日期<span>" + element.init_date + "</span></li>";
        eleHtml += "  <li>委托编号<span>" + element.entrust_no + "</span></li>";
        eleHtml += "  <li>发生金额<span>" + element.occur_balance + "</span></li>";
        eleHtml += "  <li>发生数量<span>" + element.occur_amount + "</span></li>";
        // eleHtml += "  <li>交易类别<span>"+element.exchange_type_name+"</span></li>";
        // eleHtml += "  <li>备注<span>"+element.remark+"</span></li>";
        eleHtml += " </ul></div>";
        return eleHtml;
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + ".top_title").height() - 6, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryContract();
                common.comStat(105378, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".main .contract_list").html("");
        $(_pageId + ".no_data").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});