/**
 * 信用交易-历史查询
 */
define('trade/scripts/credit/query/creditQueryHistory.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_creditQueryHistory ";
    var commonFunc = require("commonFunc");
    var userInfo = null;
    var queryType = null;	
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		commonFunc.initTimeChoice(_pageId,6,true);
		queryType = $.getPageParam("param"); //根据参数判断委托还是成交查询
		$(_pageId+".search_list").html("");
		if(queryType=="entrust"){
			common.pageBuryingPoint("105398");
			$(_pageId + ".top_title h3").text("历史委托");
			$(_pageId+".tab_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			//埋点数据
			$(_pageId+" .date_filter").attr("startObjectId","105401");
			$(_pageId+" .date_filter").attr("endObjectId","105402");
			$(_pageId+" .date_filter").attr("actionId","104");
			$(_pageId + ".top_title .icon_back").attr("objectId","105399");
			$(_pageId + ".top_title .icon_back").attr("actionId","103");
			$(_pageId + ".date_filter .btn").attr("objectId","105403");
			$(_pageId + ".date_filter .btn").attr("actionId","104");
			$(_pageId + ".vertical_list").attr("objectId","105400");
			$(_pageId + ".vertical_list").attr("actionId","102");
		}else if(queryType=="deal"){
			common.pageBuryingPoint("105408");
			$(_pageId + ".top_title h3").text("历史成交");
			$(_pageId+".tab_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			//埋点数据
			$(_pageId+" .date_filter").attr("startObjectId","105409");
			$(_pageId+" .date_filter").attr("endObjectId","105410");
			$(_pageId+" .date_filter").attr("actionId","104");
			$(_pageId + ".top_title .icon_back").attr("objectId","105411");
			$(_pageId + ".top_title .icon_back").attr("actionId","103");
			$(_pageId + ".date_filter .btn").attr("objectId","105413");
			$(_pageId + ".date_filter .btn").attr("actionId","104");
			$(_pageId + ".vertical_list").attr("objectId","105412");
			$(_pageId + ".vertical_list").attr("actionId","102");
		}
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		callsQuery();
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");
				common.comStat(objectId, 2, actionId, true, {"i_group_name": "返回"});
				$.pageBack("credit/query/financingQuery", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//时间按钮
		$.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		
		//时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			// if(vIscroll._init){
			// 	vIscroll.scroll.destroy();
			// 	vIscroll.scroll = null;
			// 	vIscroll._init = false;
			// }
			callsQuery();
			//埋点
			var index=$(_pageId + ".tab_nav ul li.active").index();
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			var objectId=$(this).attr("objectId");
			var actionId=$(this).attr("actionId");
			common.comStat(objectId,2,actionId,true,{"i_change_name":"历史委托查询","i_change_to":time1+"-"+time2});
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			// if(vIscroll._init){
			// 	vIscroll.scroll.destroy();
			// 	vIscroll.scroll = null;
			// 	vIscroll._init = false;
			// }
			//在页面切换时清掉请求
			$.clearRequest();
			//切换页面时时间控件初始化
			commonFunc.initTimeChoice(_pageId,6,true);
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId + ".top_title h4 span").text($(this).find("a").text());
			callsQuery();
		});
		
		//点击其他位置，隐藏下拉框
		$.bindEvent($(_pageId + ".main"),function(){
		});
	}
	
	/**
	 * 调用查询
	 */
	function callsQuery(){
		if($(_pageId + ".top_title h3").text() == "历史委托"){
			$(_pageId+".search_list").html("");
			queryEntrust();
		}else{
			$(_pageId+".search_list").html("");
			queryDeal();
		}
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		$(_pageId+".search_list").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	//截止时间
		var time1=new Date(end_time.replaceAll("-", "/"));
		var time2=new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
			$.alert("开始日期大于截止日期");
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			return false;
		}
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "begin_time":begin_time,
		    "end_time":end_time
		};
		$(_pageId+ ".no_data").hide();
		service_credit.historywt_query(param,queryEntrustCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".search_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".search_list").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		if("0,4,62,64,66,68,70".indexOf(element.entrust_bs) != -1){
			css = "ared";
		}else if("1,5,63,65,67,69,71".indexOf(element.entrust_bs)!= -1){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.entrust_date+"&nbsp"+element.entrust_time+"</span>";
        eleHtml+="<h5 class=\""+css+"\">"+element.entrust_type_name+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <dd><em>编&#160;&#160;号</em>"+element.report_no+"</dd>";
        eleHtml+="    <dd><em>状&#160;&#160;态</em>"+element.entrust_state_name+"</dd>";
        eleHtml+="    <dd><em>委托价格</em>"+Number(element.entrust_price).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>委托数量</em>"+element.entrust_amount+"</dd>";
        eleHtml+="    <dd><em>成交价格</em>"+Number(element.business_price).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>成交数量</em>"+element.business_amount+"</dd>";
//      eleHtml+="    <dd><em>委托编号</em>"+element.entrust_no+"</dd>";
//      eleHtml+="    <dd><em>委托类别</em>"+element.entrust_type_name+"</dd>";
//      eleHtml+="    <dd><em>报价方式</em>"+element.trade_name+"</dd>";
        eleHtml+="    <dd><em>股东代码</em>"+element.stock_account+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	//截止时间
		var time1=new Date(end_time.replaceAll("-", "/"));
		var time2=new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
			$.alert("开始日期大于截止日期");
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			return false;
		}
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
		    "password":password,
		    "begin_time":begin_time,
		    "end_time":end_time
		};
		$(_pageId+ ".no_data").hide();
		service_credit.queryHistoryTrade(param,queryDealCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
		
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						data += queryDealHTML(results[i]);
					}
					$(_pageId+".search_list").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element){
		var price_digit = 3;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		if("0,4,62,64,66,68,70".indexOf(element.entrust_bs) != -1){
			css = "ared";
		}else if("1,5,63,65,67,69,71".indexOf(element.entrust_bs)!= -1){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+element.entrust_date+"&nbsp"+element.entrust_time+"</span>";
        eleHtml+="<h5 class=\""+css+"\">"+element.entrust_type_name+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
//      eleHtml+="    <dd><em>编&#160;&#160;&#160;号</em>"+element.entrust_no+"</dd>";
        eleHtml+="    <dd><em>委托编号</em>"+element.entrust_no+"</dd>";
        eleHtml+="    <dd><em>金&#160;&#160;额</em>"+Number(element.business_balance).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>成交价格</em>"+Number(element.business_price).toFixed(price_digit)+"</dd>";
        eleHtml+="    <dd><em>成交数量</em>"+element.business_amount+"</dd>";
        eleHtml+="    <dd><em>成交编号</em>"+element.business_id+"</dd>";
        eleHtml+="    <dd><em>股东代码</em>"+element.stock_account+"</dd>";
//      eleHtml+="    <dd><em>佣金费用</em>"+element.fare0+"</dd>";
//      eleHtml+="    <dd><em>印花税费</em>"+element.fare1+"</dd>";
//      eleHtml+="    <dd><em>过户费用</em>"+element.fare2+"</dd>";
//      eleHtml+="    <dd><em>其他费用</em>"+element.other_fare+"</dd>";
//      eleHtml+="    <dd><em>备&#160;&#160;&#160;注</em>"+element.remark+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
       
	}


	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- $(_pageId+".date_filter").height() - 6 , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				callsQuery();//下拉获取上一页数据方法
				var objectId=$(_pageId + ".vertical_list").attr("objectId");
				var actionId=$(_pageId + ".vertical_list").attr("actionId");
				common.comStat(objectId,2,actionId,true,{"i_direct": "下拉","i_type":"1" });
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".search_list").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		$.pageBack();
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});