/**
 * 信用交易-当日委托
 */
define('trade/scripts/credit/query/creditQueryToday.js', function (require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_credit = require("service_credit");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_creditQueryToday ";
    var commonFunc = require("commonFunc");
    var userInfo = null;

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("107371");
        userInfo = common.getCurUserInfo();
        $(_pageId + ".no_more_data").hide();
        var queryType = $.getPageParam("param");
        if (queryType == "entrust") {
            $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
        } else if (queryType == "deal") {
            $(_pageId + ".tab_list li").eq(1).addClass("current").siblings().removeClass("current");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        callsQuery();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                commonFunc.appThirdBack('credit_query_financingQuery', function(){
                    $.pageBack("credit/query/financingQuery", "left");
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });
        //页面切换
        $.bindEvent($(_pageId + ".tab_list ul li"), function (e) {
            $(this).addClass("current").siblings().removeClass("current");
            $(_pageId + ".j-position-table table").html("");
            callsQuery();
            if ($(this).index() == 0) {
                common.comStat(107372, 2, 103, true, {"i_group_name": "当日委托"});//埋点
            } else {
                common.comStat(107373, 2, 103, true, {"i_group_name": "当日成交"});//埋点
            }
            e.stopPropagation();
        });
    }

    /**
     * 调用查询
     */
    function callsQuery() {
        if ($(_pageId + ".tab_list ul li").eq(0).hasClass("current")) {
            $(_pageId + ".no_more_data").hide();
            queryEntrust();
        } else {
            $(_pageId + ".no_more_data").hide();
            queryDeal();
        }
    }

    /**
     * 委托查询
     */
    function queryEntrust() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_credit.todaywt_query(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": false,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        if (typeof (data) != "undefined" && data) {
            $(_pageId + ".no_more_data").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var data = "<thead><tr><th>名称/时间</th><th>委托/成交价</th><th>委托/成交数</th><th>类型/状态</th></tr></thead><tbody>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        data += queryEntrustHTML(results[i]);
                    }
                    $(_pageId + ".j-position-table table").html(data + "</tbody>");
                    $(_pageId + ".no_more_data").show();
                    $.bindEvent($(_pageId + ".j-position-table table tbody tr"), function (e) {
                        var cancel_flag = $(this).attr("cancel_flag");
                        if (cancel_flag == "0") {
                            var tipStrArray = [];
                            tipStrArray.push(["证券名称 ", "<strong style='font-size:" + $.getTransformScaleFontSize($(this).attr("stock_name"), 16, $(window).width() * 0.48) + "px;'>" + $(this).attr("stock_name") +  "</strong>"]);
                            tipStrArray.push(["证券代码 ", $(this).attr("stock_code")]);
                            tipStrArray.push(["买卖方向 ", $(this).attr("entrust_name")]);
                            tipStrArray.push(["委托价格 ", $(this).attr("entrust_price")]);
                            tipStrArray.push(["委托数量 ", $(this).attr("entrust_amount")]);
                            tipStrArray.push(["成交数量 ", $(this).attr("business_amount")]);
                            var tipStr = "<div>";
                            tipStr += common.generatePrompt(tipStrArray);
                            tipStr += "</div>";
                            var entrust_no = $(this).attr("id");
                            var exchange_type = $(this).attr("exchange_type");
                            common.iConfirmNew("确认撤单", tipStr, function () {
                                postCancelOrder(entrust_no, exchange_type);
                            }, null, "确定", "取消");
                        }
                        e.stopPropagation();
                    });
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 委托撤单
     * @param $currItem 当前条目
     */
    function postCancelOrder(entrust_no, exchange_type) {
        var batch_flag = "0";
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
            "batch_flag": batch_flag,
            "exchange_type": exchange_type
        };
        service_credit.credit_cancel(param, postCancelOrderCallback, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }

    /**
     * 委托撤单回调方法
     * @param {Object} data 返回数据
     */
    function postCancelOrderCallback(data) {
        $.hidePreloader();
        if (data.error_no == "0") {
            $.alert(data.error_info, function () {
                queryEntrust();
            });
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element) {
        var price_digit = 3;
        var css = "";
        var css1 = "";
        if (element.entrust_bs == "0") {//买入
            css = "trans_color_02";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_red"
            }
        } else if (element.entrust_bs == "1") {//卖出
            css = "trans_color_01";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_blue"
            }
        }
        // var entrust_name = element.entrust_type_name;
        var entrust_name = element.entrust_name_new;
        // if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
        //     entrust_name = element.entrust_name;
        // }
        var eleHtml = "";
        eleHtml += "<tr class='" + css1 + "' id='" + element.entrust_no + "' stock_name='" + element.stock_name + "' stock_code='" + element.stock_code + "' entrust_price='" + Number(element.entrust_price).toFixed(price_digit) + "' entrust_amount='" + element.entrust_amount + "' business_amount='" + element.business_amount + "' cancel_flag='" + element.cancel_flag + "' entrust_name='" + entrust_name + "' exchange_type='" + element.exchange_type + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale(" + $.getTransformScale(element.stock_name, 16, $(window).width()/4-25) + ")'>" + element.stock_name + "</p>";
        eleHtml += "<p>" + element.entrust_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.entrust_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.entrust_amount + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p style='"+common.setAjustFontSize((element.entrust_name_new || element.entrust_type_name), 16, 4, 0) +"' class='" + css + "'>" + (element.entrust_name_new || element.entrust_type_name) + "</p>";

       // eleHtml += "<p class=\"" + css + "\">" + (element.entrust_name_new || element.entrust_type_name) + "</p>";
        eleHtml += "<p>" + element.entrust_state_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_credit.todaycj_query(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": false,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    // $(_pageId + ".no_data_box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });

    }

    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        if (typeof (data) != "undefined" && data != null) {
            $(_pageId + ".no_more_data").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var data = "<tr><th>名称/时间</th><th>成交价/成交量</th><th>成交金额</th><th>类型/状态</th></tr>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        data += queryDealHTML(results[i]);
                    }
                    $(_pageId + ".j-position-table table").html(data);
                    $(_pageId + ".no_more_data").show();
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element) {
        var price_digit = 3;
        var css = "";
        // var css1 = "";
        if ("0,4,62,64,66,68,70".indexOf(element.entrust_bs) != -1) {
            css = "trans_color_02";
        } else if ("1,5,63,65,67,69,71".indexOf(element.entrust_bs) != -1) {
            css = "trans_color_01";
        }
        // if (element.real_status_name == "成交") {
        //     css1 = "color:green;";
        // } else if (element.real_status_name == "确认") {
        //     css1 = "color:black;";
        // } else if (element.real_status_name == "废单") {
        //     css1 = "color:gray;";
        // }
        var eleHtml = "";
        eleHtml += "<tr>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 16, $(window).width() / 4 - 25)+")'>" + element.stock_name + "</p>";
        eleHtml += "<p>" + element.business_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_balance).toFixed(price_digit) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p style='"+common.setAjustFontSize(element.entrust_type_name, 16, 4, 0) +"' class='" + css + "'>" + element.entrust_type_name + "</p>";
        eleHtml += "<p>" + element.real_status_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                callsQuery();//下拉获取上一页数据方法
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }


    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".j-position-table table").html("");
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".no_data_box").hide();
        $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "callsQuery": callsQuery,
        "destroy": destroy,
    };
    module.exports = base;
});
