/**
 * 信用交易-股份持仓查询
 */
define('trade/scripts/credit/query/custOwnStockQuery.js', function(require,exports,module){
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var	service_credit = require("service_credit");
	var	_pageId = "#credit_query_custOwnStockQuery ";
	var userInfo = null;//保存的客户信息
	var common = require("common");
    var myAbout = null;
	/**
	 * 初始化
	 * */
	function init(){
		common.pageBuryingPoint("105356");
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
	}
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryPosition();//查询持仓
	}
	/**
	 * 事件绑定
	 * */
	function bindPageEvent(){
		//后退
		$.bindEvent($(_pageId+" .top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(105358, 2, 103, true, {"i_group_name": "返回"});//埋点
				$.pageBack("credit/query/financingQuery", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
	}
	
	function queryPosition(){
			$(_pageId+".fund_table .ce_table").html("");
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var sessionid = userInfo.session_id;
			var password = userInfo.password;
			var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "sessionid":sessionid
			};
			service_credit.cc_query(param,function(data){
				if (data && data != "undefined") {
					if(data.error_no == 0){
						var results = data.results;
						if(results && results.length>0){
							var total_cost_balance = 0;//持仓数量X持仓成本
							var total_last_price = 0; //持仓数量X最新价
							var data = "<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>";
							var float_yk = 0; //浮动盈亏
							for (var i=0;i<results.length;i++){
								if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long; 
								 float_yk += Number(results[i].float_yk);//计数总浮动盈亏
								 total_cost_balance += Number(results[i].cost_amount)*Number(results[i].cost_price);
								 total_last_price += Number(results[i].cost_amount)*Number(results[i].last_price);
								 data += queryPositionHTML_stock(results[i]);
							}
							$(_pageId+".fund_table .ce_table").html(data);
							$(_pageId+".no_data").hide();
							
						}else{ 
							$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
							$(_pageId+".no_data").show();
						}
					}else{
						$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
						$(_pageId+".no_data").show();
						$.alert(data.error_info);
					}
				}else{
					$(_pageId+".fund_table .ce_table").html("<tr><th scope=\"col\">证券/市值</th> <th scope=\"col\">盈亏</th><th scope=\"col\">持仓/可用</th><th scope=\"col\">成本/现价</th></tr>");
					$(_pageId+".no_data").show();
					$.alert("查询失败");
				}
				initAbout();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			},{"isLastReq":true,"isShowWait":true,"isShowOverLay":true});
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){
		var price_digit = 3;
		var css = "";
		var float_yk = Number(element.float_yk).toFixed(price_digit);//浮动盈亏
		var float_yk_per = Number(element.float_yk_per).toFixed(price_digit);//浮动盈亏%
		if(float_yk>0){
			float_yk = "+" + float_yk;
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
       var eleHtml = "";
       eleHtml+="<tr id="+element.stock_code +">";
       eleHtml+="<td><strong style='transform-origin: left;white-space: nowrap;transform:scale("+$.getTransformScale(element.stock_name, 16, $(window).width() * 0.25-10)+")'>"+element.stock_name +"</strong><small>"+Number(element.market_value).toFixed(price_digit) +"</small></td>";
       eleHtml+="<td><span class=\""+css+"\">"+float_yk+"</span><span class=\""+css+"\">"+float_yk_per+"%</span></td>";
       eleHtml+="<td>"+Number(element.cost_amount)+"<br/>"+Number(element.enable_amount)+"</td>";
       eleHtml+="<td>"+Number(element.cost_price).toFixed(price_digit)+"<br/>"+Number(element.last_price).toFixed(price_digit)+"</td>";
       eleHtml+="</tr>";
       return eleHtml;
	}

	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".header").outerHeight(true) , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryPosition();
				//埋点 
				common.comStat(105357,2,102,true,{"i_direct": "下拉","i_type":"1" });
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	/*
	 * 持仓左右滑动组件
	 */
	function initAbout(){
		//必须用这个左右滑动组件，否则事件乱跳
		var scrollOptions = {
			$wrapper: $(_pageId + " #pull_down_about")
		};
		myAbout = iscrollUtils.hScroller(scrollOptions);
	};
	/**
	 * 销毁
	 * */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + " #msg td").text("--");
		$(_pageId+".fund_table .ce_table").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myAbout)
		{
			$(_pageId + " #pull_down_about").height("auto");
			myAbout.destroy();
			myAbout = null;
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
