/**
 * 信用交易-交割单查询
 */
define('trade/scripts/credit/query/deliveryOrderQuery.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_deliveryOrderQuery ";
    var commonFunc = require("commonFunc");
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("105470");
		userInfo = common.getCurUserInfo();
		commonFunc.initTimeChoice(_pageId,6);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		deliveryQuery();
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(105471, 2, 103, true, {"i_group_name": "返回"});
				commonFunc.appThirdBack('credit_query_deliveryOrderQuery', function () {
					$.pageBack("credit/query/financingQuery", "left");
				});
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//时间按钮
		$.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
			e.stopPropagation();
		});
		//时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			// if(vIscroll._init){
			// 	vIscroll.scroll.destroy();
			// 	vIscroll.scroll = null;
			// 	vIscroll._init = false;
			// }
			deliveryQuery();
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			common.comStat(105473,2,104,true,{"i_change_name":"交割单查询","i_change_to":time1+"-"+time2});
		});
		//点击其他位置，隐藏下拉框
		$.bindEvent($(_pageId + ".main"),function(){
//			if($(_pageId + ".top_title .top_nav").is(':visible')){
//				$(_pageId + ".top_title .top_nav").slideToggle("fast");
//			}
		});
	}
	
	/**
	 * 交割单查询
	 */
	function deliveryQuery(){
		$(_pageId+".fund_flow2").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var password = userInfo.password;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	//截止时间
		var time1=new Date(end_time.replaceAll("-", "/"));
		var time2=new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
			$.alert("开始日期大于截止日期");
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			return false;
		}
		var param={			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"password":password,
				"begin_time":begin_time,
				"end_time":end_time
			};
		$(_pageId+ ".no_data").hide();
		service_credit.deliveryOrder_Query(param,queryDeliveryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 交割单查询回调
	 */
	function queryDeliveryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_flow2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".fund_flow2").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 交割单查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
//		require("common").decimalKeep(element.stock_code ,function(data){  //获取保留的位数
//	    	if(data){
//	    		price_digit = data;
//	    	}
//		});
		var css = "";
		var business_name = element.business_name;
		if(element.entrust_bs == "0"){
			css = "ared";
		}else if(element.entrust_bs == "1"){
			css = "agreen";
		}
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<div class=\"title\">";
        eleHtml+="<h5>"+element.business_name+"</h5><span class=\"time\">"+element.init_date+"&nbsp"+element.report_time+"</span>";
        eleHtml+="</div><ul>";
		eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
		eleHtml += "    <li>成交数量<span>"+element.occur_amount+"</span></li>";
		eleHtml += "    <li>成交价格<span>"+Number(element.business_price).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>成交金额<span>"+Number(element.business_balance).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>发生金额<span>"+Number(element.occur_balance).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>佣金<span>"+Number(element.fare0).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>印花税<span>"+Number(element.fare1).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>过户费<span>"+Number(element.fare2).toFixed(price_digit)+"</span></li>";//后资金额
//		eleHtml += "    <li>合同序号<span>"+element.report_no+"</span></li>";//申请编号
		eleHtml += "    <li>成交编号<span>"+element.business_no+"</span></li>";
		eleHtml += "    <li>证券余额<span>"+Number(element.post_amount).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>资金余额<span>"+Number(element.post_balance).toFixed(price_digit)+"</span></li>";
		eleHtml += "    <li>证券账号<span>"+element.stock_account+"</span></li>";
		eleHtml += "    <li>交易市场名称<span>"+element.exchange_type_name+"</span></li>";
        eleHtml+="</ul>";
        eleHtml+="</div>";
        return eleHtml;

	}


	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- $(_pageId+".date_filter").height() - 6  , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				deliveryQuery();
				common.comStat(105472,2,102,true,{"i_direct": "下拉","i_type":"1" });
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".fund_flow2").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});