/**
 * 信用交易-历史资金流水查询
 */
define('trade/scripts/credit/query/liabilitiesFlowQuery.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_credit = require("service_credit");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_liabilitiesFlowQuery ";
    var commonFunc = require("commonFunc");
    var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("105418");
		userInfo = common.getCurUserInfo();
		commonFunc.initTimeChoice(_pageId,6);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		liabilitiesFlowQuery();
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(105419, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack("credit/query/financingQuery", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//时间按钮
		$.bindEvent($(_pageId + ".top_title .icon_nav"), function(e){
			$(_pageId + ".top_title .top_nav").slideToggle("fast");
		});
		
		//时间选择
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			// if(vIscroll._init){
			// 	vIscroll.scroll.destroy();
			// 	vIscroll.scroll = null;
			// 	vIscroll._init = false;
			// }
			liabilitiesFlowQuery();
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			common.comStat(105421,2,104,true,{"i_change_name":"历史资金流水查询","i_change_to":time1+"-"+time2});
		});
		
		//点击其他位置，隐藏下拉框
		$.bindEvent($(_pageId + ".main"),function(){
		});
	}
	
	/**
	 * 负债变动流水查询
	 */
	function liabilitiesFlowQuery(){
		$(_pageId+".fund_flow2").html("");		
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	//截止时间
		var time1=new Date(end_time.replaceAll("-", "/"));
		var time2=new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
			$.alert("开始日期大于截止日期");
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			return false;
		}
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"sessionid":sessionid,
				"begin_time" : begin_time,
				"end_time" : end_time
		};
		$(_pageId+ ".no_data").hide();
		service_credit.queryAssetFlow(param,liabilitiesFlowQueryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 负债变动流水查询回调
	 */
	function liabilitiesFlowQueryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_flow2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryFlowHTML(results[i]);
					}
					$(_pageId+".fund_flow2").html(data);		
				}else{
					$(_pageId+".no_data").show();
				}
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryFlowHTML(element){
		var price_digit = 3;
		var css="";
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<div class=\"title\">";
        eleHtml+="<h5>"+element.business_name+"</h5><span class=\"time\">"+element.init_date+"&nbsp"+element.init_time+"</span>";
        eleHtml+="</div><ul>";
//      eleHtml+="	<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
        eleHtml+="    <li>流水号<span>"+element.entrust_no+"</span></li>";
        eleHtml+="    <li>发生金额<span>"+Number(element.occur_balance).toFixed(price_digit)+"</span></li>";
        eleHtml+="    <li>资金余额<span>"+Number(element.post_balance).toFixed(price_digit)+"</span></li>";
        eleHtml+="    <li>成交数量<span>"+element.occur_amount+"</span></li>";
        eleHtml+="    <li>成交价格<span>"+Number(element.business_price).toFixed(price_digit)+"</span></li>";
        eleHtml+="    <li>发生利息<span>"+Number(element.occur_interest).toFixed(price_digit)+"</span></li>";
        eleHtml+="    <li>后余利息<span>"+Number(element.post_interest).toFixed(price_digit)+"</span></li>";
		eleHtml+="    <li>币种<span>"+element.money_type_name+"</span></li>";
        eleHtml+="</ul></div>";
        return eleHtml;
	}

	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- $(_pageId+".date_filter").height() - 6 , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				common.comStat(105420,2,102,true,{"i_direct": "下拉","i_type":"1" });
				liabilitiesFlowQuery();//下拉获取上一页数据方法
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".fund_flow2").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});