/**
 * 信用交易---查询标的证券
 */
define('trade/scripts/credit/query/queryCanRZBuyStock.js', function(require,exports,module){
	var gconfig = $.config;
	var global = gconfig.global;
	var	service_credit = require("service_credit");
	var common = require("common");
	var	financialSecurities = false;
	var	_pageId = "#credit_query_queryCanRZBuyStock ";
	var userInfo = null;//保存的客户信息
	var _request_num = 30;
	var _isData = true;
    var _stockName = "";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var vIscrollHeight = null;
	// var	VIscroll = require("vIscroll");
	// var	vIscroll = {"scroll":null,"_init":false};	//上下滑动
 	var time = null;
	var keyboard = require("keyboard");

	/**
	 * 初始化
	 * */
	function init()
	{   
		common.pageBuryingPoint("105438");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
	}
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryData();//查询数据
	}
	
	/**
	 * 事件绑定
	 * */
	function bindPageEvent()
	{
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			setTimeout(function () {
				if (keyboard) {
					keyboard.closeKeyPanel();
				}
				common.comStat(105442, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack("credit/query/financingQuery", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//点击查询按钮
		$.bindEvent($(_pageId+" .search_box2 .inner a"),function(){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(105439,2,103,true,{"i_group_name":"查询"});
			$(_pageId + " #remove").remove();
			$(_pageId+" .fund_table tr").eq(0).nextAll().remove();
			var stockCode = $(_pageId+" #stockCode").val();
			var vai2=/^[0-9]{6}$/;
			if(vai2.test(stockCode)){
				queryData(stockCode);
				common.comStat(105441,2,104,true,{"i_change_name": "证券代码","i_change_to":stockCode });
			}
			else{
				$.alert("请输入有效的6位数证券代码");
			}
		});
		//融资，融券切换
		$.bindEvent($(_pageId+" .toggle_nav li"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId+" .fund_table tbody tr").eq(0).nextAll().remove();
			$(_pageId + " #remove").remove();
			$(_pageId + " #numRemove").remove();
			$(_pageId + " #stockCode").val("");
			$(this).addClass("active").siblings().removeClass("active");
			financialSecurities = ($(_pageId+" .toggle_nav li").index($(this)) == 1);
			if(financialSecurities){
				$(_pageId+" #changeName").text("融券保证金比例").css("width", "20%");
				$(_pageId + " .fund_table tr").append("<th id= \"numRemove\" scope=\"col\">当前数量</th>");
			}else
			{
				$(_pageId + " #numRemove").remove();
				$(_pageId+" #changeName").text("融资保证金比例").css("width", "inherit");
			}
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			queryData();
		});
		//股票代码输入框监听
		$.bindEvent($(_pageId+"#stockCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var stockCode = $(this).val();
			if(!stockCode){
				$(_pageId+"#stock_list").html("");
				queryData();
				if(keyboard){
					keyboard.closeKeyPanel();
				}
			}else{
				$(_pageId+"#stockCode").quzhi(stockCode);
			}
			e.stopPropagation();
		},"input");
		
		//点击其他地方去掉列表
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId+"#stock_list").html("");
		},"touchstart");

	}
	/**
	 * 查询数据
	 */
	function queryData(stockCode)
	{
		$(_pageId+" .visc_wrapper .visc_pullUp").show();
		_isData = true;
		var poststr = $(_pageId+" .fund_table tbody tr").last().attr("poststr");
		var vai2=/^[0-9]{6}$/;
		if(stockCode && vai2.test(stockCode)){
			$(_pageId+" .fund_table tbody tr").eq(0).nextAll().remove();
			poststr = "";
		}
		else{
			stockCode = "";
		}
		$(_pageId+ ".no_data").hide();
		$(_pageId+" .ti_table tr").eq(0).nextAll().remove();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var stock_code = stockCode ? stockCode : "";
		var exchange_type = "";
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
			"stock_code":stock_code,
			"exchange_type":exchange_type,
			"poststr":poststr,
			"request_num":_request_num
		};
		if(financialSecurities){
			service_credit.queryCanBeMargin(param,queryCallBack);
		}else{
			service_credit.qualificationInquiry(param,queryCallBack);
		}
	}
	/**
	 * 回调方法
	 * @param {Object} data 返回数据
	 */
	function queryCallBack(data)
	{
		if (data) {
			if(data.error_no == 0)
			{
				var results = data.results;	
				queryMsg = data.results;//将返回的结果集保存
				if(results && results.length > 0)
				{
					var dataHtml = "";
					for(i = 0;i < results.length; i++)
					{
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						var data = results[i];
						dataHtml += createHtml(data);
					}
					$(_pageId+ ".no_data").hide();
					$(_pageId+" .fund_table tr").last().after(dataHtml);
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}
				}
				else{
					$(_pageId+" .fund_table tr").eq(0).nextAll().remove();
					$(_pageId+ ".no_data").show();
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}
				}
				if(_request_num <= results.length){
					$(_pageId+" .visc_wrapper .visc_pullUp").show();
					_isData = true;
				}
				else
				{
					$(_pageId+" .visc_wrapper .visc_pullUp").hide();
					_isData = false;
				}
			}
			else
			{
				$(_pageId+" .fund_table tr").eq(0).nextAll().remove();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
				$.alert(data.error_info);
			}
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element)
	{
		var status = "";
		if(element.finance_status == "0"||element.slo_status == "0"){
			status = "正常";
		}else if(element.finance_status == "1"||element.slo_status == "1"){
			status = "暂停";
		}
		if(element.today_enable == "0"){
			enable = "是";
		}else if(element.today_enable == "1"){
			enable = "否";
		}
		
		var eleHtml = "";
		    eleHtml += "<tr id='remove' poststr='"+ element.position_str+"'>";
			eleHtml += "<td>"+element.stock_code+"</td>";
			eleHtml += "<td style='zoom:"+ $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25) +";'>"+element.stock_name+"</td>";
			eleHtml += "<td>"+element.exchange_type_name+"</td>";
			if(financialSecurities){
				var slo_ratio = element.bail_ratio || "--";
				eleHtml += "<td>"+slo_ratio+"</td>";
				eleHtml += "<td>"+element.enable_amount+"</td>";
//				eleHtml += "<td>"+status+"</td>";
//				eleHtml += "<td>"+element.enable_amount+"</td>";
			}else{
				var slo_ratio = element.fin_ratio || 0;
				slo_ratio = (Number(slo_ratio) * 100).toFixed(2);
				eleHtml += "<td>"+slo_ratio+"%</td>";
//				eleHtml += "<td>"+status+"</td>";
//				eleHtml += "<td>"+""+"</td>";
			}
			
			eleHtml +="</tr>";
		return eleHtml;
	}

	/**
	 * 下拉刷新初始化
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height() - $(_pageId+" .search_box2").outerHeight()- 6 ,//显示内容区域的高度，当isPaingType为false时传, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				$(_pageId+" .fund_table tbody tr").eq(0).nextAll().remove();
				//查询资产数据
				var stockCode = $(_pageId+" #stockCode").val();
				stockCode = $.trim($(_pageId + "#stockCode").val().substring(0,6));
				queryData(stockCode);
				common.comStat(105440,2,102,true,{"i_direct": "下拉","i_type":"1" });
			},
			pullUpHandler: function(){
				if(_isData){
					queryData()
				}
				//上拉获取下一页数据方法
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	/**
	 * 销毁
	 * */
	function destroy()
	{
		common.pageBuryingPoint();
		_isData = true;
	    _stockName = "";
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #stockName").text("证券名称");
		financialSecurities = false;
		$(_pageId + " #numRemove").remove();
		$(_pageId + " #remove").remove();
		$(_pageId+" .fund_table tr").eq(0).nextAll().remove();
		$(_pageId+" .toggle_nav li").eq(0).addClass("active").siblings().removeClass("active");
		$(_pageId+" #changeName").text("融资保证金比例").css("width", "inherit");
	    $(_pageId+" .fund_table tbody tr").eq(0).nextAll().remove();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	
	var base = {
		"init" : init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});