/**
 * 信用交易---查询标的证券
 */
define('trade/scripts/credit/query/queryUnderlyingSecurities.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var service_credit = require("service_credit");
    var service_xkj = require("service_xkj");
    var nativePluginService = require("nativePluginService");
    var common = require("common");
    var _pageId = "#credit_query_queryUnderlyingSecurities ";
    var userInfo = null;//保存的客户信息
    var _request_num = 30;
    var _isData = true;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var keyboard = require("keyboard");
    var query_type = null;
    var isPullUp = false;
    var pdfurl = null;

    /**
     * 初始化
     * */
    function init() {
        common.pageBuryingPoint("108038");
        if (keyboard) {
            keyboard.keyInit();
        }
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        query_type = $.getPageParam("param");
        if (query_type == "financing") {
            //融资标的
            $(_pageId + ".tab_list ul li").eq(0).addClass("current").siblings().removeClass("current");
        } else if (query_type == "securities") {
            //融券标的
            $(_pageId + ".tab_list ul li").eq(1).addClass("current").siblings().removeClass("current");
        } else if (query_type == "collateral") {
            //担保品标的
            $(_pageId + ".tab_list ul li").eq(2).addClass("current").siblings().removeClass("current");
        }
        callsQuery();
        getPDF();
    }

    /**
     * 调用查询
     */
    function callsQuery() {
        isPullUp = false;
        query_type = $(_pageId + ".tab_list ul li.current").attr("type");
        if (query_type == "financing") {
            //融资标的 303005
            qualificationInquiry();
        } else if (query_type == "securities") {
            //融券标的 303006
            queryCanBeMargin();
        } else if (query_type == "collateral") {
            //担保品标的 303002
            db_query();
        }
    }
    function getPDF(){
        service_xkj.require2001029({
            file_key:'credit_stock_desc_file'
        },function(data){
            console.log(data);
            if (data.error_no == 0) {
                pdfurl = data.results;
                //点击说明按钮
                $.bindEvent($(_pageId + " #readme"), function () {
                    // 设置 go_hq_ 参数，这样返回的时候不会刷新页面
                    var pageCode = $.getCurrentPageObj().pageCode || '';
                    $.setSStorageInfo("go_hq_" + pageCode, true);
					nativePluginService.function50240({
						btnMode: "1",
						url: pdfurl.url,
						title: pdfurl.name
					});
                });
            } else {
                $.alert(data.error_info);
            }
        });
    }
    /**
     * 事件绑定
     * */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                // common.comStat(105442, 2, 103, true, {"i_group_name": "返回"});
                $.pageBack();
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });
        //点击查询按钮
        $.bindEvent($(_pageId + " .query_btn"), function () {
            isPullUp = false;
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            common.comStat(108043, 2, 103, true, {"i_group_name": "查询"});
            var stockCode = $(_pageId + " #stockCode").val() || "";
            var vai2 = /^[0-9]{6}$/;
            if (vai2.test(stockCode) || !stockCode) {
                $(_pageId + " .j-position-table table").html("");
                $(_pageId + " .no_more_data").hide();
                if (query_type == "financing") {
                    //融资标的 303005
                    qualificationInquiry(stockCode);
                } else if (query_type == "securities") {
                    //融券标的 303006
                    queryCanBeMargin(stockCode);
                } else if (query_type == "collateral") {
                    //担保品标的 303002
                    db_query(stockCode);
                }
            } else {
                $.alert("请输入有效的6位数证券代码");
            }
        });
        //融资，融券切换
        $.bindEvent($(_pageId + " .tab_list li"), function (e) {
            isPullUp = false;
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + " .j-position-table table").html("");
            $(_pageId + " .no_more_data").hide();
            $(_pageId + " #stockCode").val("");
            $(_pageId + "#stockCode").quzhi("");
            $(this).addClass("current").siblings().removeClass("current");
            query_type = $(this).attr("type");
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
            if (query_type == "financing") {
                //融资标的 303005
                qualificationInquiry();
                common.comStat(108039, 2, 103, true, {"i_change_name": "融资标的"});
            } else if (query_type == "securities") {
                //融券标的 303006
                queryCanBeMargin();
                common.comStat(108040, 2, 103, true, {"i_change_name": "融券标的"});
            } else if (query_type == "collateral") {
                //担保品标的 303002
                db_query();
                common.comStat(108041, 2, 103, true, {"i_change_name": "担保证券"});
            }
        });
        //股票代码输入框监听
        $.bindEvent($(_pageId + "#stockCode"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode && stockCode.length == 6) {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                common.comStat("108042", 2, "104", true, {
                    "i_change_name": "证券代码输入",
                    "i_change_to": $(_pageId + " #stockCode").val()
                });
            }
            e.stopPropagation();
        }, "input");

        //点击其他地方去掉列表
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
        }, "touchstart");

    }

    /**
     * 查询数据
     */
    function qualificationInquiry(stockCode) {
        $(_pageId + " .visc_wrapper .visc_pullUp").show();
        _isData = true;
        var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
        stockCode = stockCode || "";
        $(_pageId + ".no_data_box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var stock_code = stockCode ? stockCode : "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "poststr": poststr,
            "request_num": _request_num
        };
        service_credit.qualificationInquiry(param, qualificationInquiryCallBack);
    }

    /**
     * 回调方法
     * @param {Object} data 返回数据
     */
    function qualificationInquiryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var dataHtml = '';
                    if (!isPullUp) {
                        dataHtml = '<tr><th>名称/代码</th><th class="text_center">市场名称</th><th class="text_center">融资保证金比例</th></tr>';
                    }
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        dataHtml += createQualificationInquiryHtml(data);
                    }
                    if (!isPullUp) {
                        $(_pageId + " .j-position-table table").html(dataHtml);
                    } else {
                        $(_pageId + " .j-position-table table tr").last().after(dataHtml);
                    }
                }
                var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
                //定位串为空
                if (!poststr) {
                    if (results.length == 0) {//结果集为0，则显示无数据效果
                        $(_pageId + " .j-position-table table").html("");
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").show();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else if (_request_num > results.length) {//请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                } else {//定位串不为空
                    if (results.length == 0 || _request_num > results.length) {//结果集为0，则显示无数据效果 || 请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                }
                isPullUp = false;
            } else {
                isPullUp = false;
                $.alert(data.error_info);
            }
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
        }
    }


    /**
     * 生成html
     * @param {Object} element 数据项
     */
    function createQualificationInquiryHtml(element) {
        var eleHtml = "";
        eleHtml += '<tr poststr="' + element.position_str + '">';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:'+$.getTransformScaleFontSize(element.stock_name, 14, $(window).width() * 0.3)+'px">' + element.stock_name + '</p>';
        eleHtml += '<span>' + element.stock_code + '</span>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        eleHtml += '<p>' + element.exchange_type_name + '</p>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        var fin_ratio = element.fin_ratio ? (Number(element.fin_ratio) * 100).toFixed(2) + "%" : "--";
        eleHtml += '<p>' + fin_ratio + '</p>';
        eleHtml += '</td>';
        eleHtml += '</tr>';
        return eleHtml;
    }

    function queryCanBeMargin(stockCode) {
        $(_pageId + " .visc_wrapper .visc_pullUp").show();
        _isData = true;
        var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
        stockCode = stockCode || "";
        $(_pageId + ".no_data_box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var stock_code = stockCode ? stockCode : "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "poststr": poststr,
            "request_num": _request_num
        };
        service_credit.queryCanBeMargin(param, queryCanBeMarginCallBack);
    }

    /**
     * 回调方法
     * @param {Object} data 返回数据
     */
    function queryCanBeMarginCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var dataHtml = '';
                    if (!isPullUp) {
                        dataHtml = '<tr><th>名称/代码</th><th class="text_center">市场名称</th><th class="text_center">融券保证金比例</th></tr>';
                    }
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        dataHtml += createCanBeMarginHtml(data);
                    }
                    if (!isPullUp) {
                        $(_pageId + " .j-position-table table").html(dataHtml);
                    } else {
                        $(_pageId + " .j-position-table table tr").last().after(dataHtml);
                    }
                }
                var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
                //定位串为空
                if (!poststr) {
                    if (results.length == 0) {//结果集为0，则显示无数据效果
                        $(_pageId + " .j-position-table table").html("");
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").show();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else if (_request_num > results.length) {//请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                } else {//定位串不为空
                    if (results.length == 0 || _request_num > results.length) {//结果集为0，则显示无数据效果 || 请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                }
                isPullUp = false;
            } else {
                isPullUp = false;
                $.alert(data.error_info);
            }
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
        }
    }

    /**
     * 生成html
     * @param {Object} element 数据项
     */
    function createCanBeMarginHtml(element) {
        var eleHtml = "";
        eleHtml += '<tr poststr="' + element.position_str + '">';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:'+$.getTransformScaleFontSize(element.stock_name, 14, $(window).width() * 0.3)+'px">' + element.stock_name + '</p>';
        eleHtml += '<span>' + element.stock_code + '</span>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        eleHtml += '<p>' + element.exchange_type_name + '</p>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        var bail_ratio = element.bail_ratio ? (Number(element.bail_ratio) * 100).toFixed(2) + "%" : "--";
        eleHtml += '<p>' + bail_ratio + '</p>';
        eleHtml += '</td>';
        eleHtml += '</tr>';
        return eleHtml;
    }

    function db_query(stockCode) {
        $(_pageId + " .visc_wrapper .visc_pullUp").show();
        _isData = true;
        var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
        stockCode = stockCode || "";
        $(_pageId + ".no_data_box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var stock_code = stockCode ? stockCode : "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "stock_code": stock_code,
            "exchange_type": exchange_type,
            "position_str": poststr,
            "request_num": _request_num
        };
        service_credit.db_query(param, db_queryCallBack);
    }

    /**
     * 回调方法
     * @param {Object} data 返回数据
     */
    function db_queryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var dataHtml = '';
                    if (!isPullUp) {
                        dataHtml = '<tr><th>名称/代码</th><th class="text_center">担保折算率</th><th class="text_center" id="stockgroup">证券分类<em class="problem-icon"></em></th></tr>';
                    }
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        dataHtml += createDbQueryHtml(data);
                    }
                    if (!isPullUp) {
                        $(_pageId + " .j-position-table table").html(dataHtml);
                    } else {
                        $(_pageId + " .j-position-table table tr").last().after(dataHtml);
                    }
                }
                //点击说明按钮
                $.bindEvent($(_pageId + " #stockgroup"), function () {
                    // 设置 go_hq_ 参数，这样返回的时候不会刷新页面
                    var pageCode = $.getCurrentPageObj().pageCode || '';
                    $.setSStorageInfo("go_hq_" + pageCode, true);
					nativePluginService.function50240({
						btnMode: "1",
						url: pdfurl.url,
						title: pdfurl.name
					});
                });
                var poststr = $(_pageId + " .j-position-table table tr").last().attr("poststr") || "";
                //定位串为空
                if (!poststr) {
                    if (results.length == 0) {//结果集为0，则显示无数据效果
                        $(_pageId + " .j-position-table table").html("");
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").show();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else if (_request_num > results.length) {//请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                } else {//定位串不为空
                    if (results.length == 0 || _request_num > results.length) {//结果集为0，则显示无数据效果 || 请求数量大于返回结果数量
                        $(_pageId + " .no_more_data").show();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").hide();
                        _isData = false;
                    } else {
                        $(_pageId + " .no_more_data").hide();
                        $(_pageId + ".no_data_box").hide();
                        $(_pageId + " .visc_wrapper .visc_pullUp").show();
                        _isData = true;
                    }
                }
                isPullUp = false;
            } else {
                isPullUp = false;
                $.alert(data.error_info);
            }
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
        }
    }

    /**
     * 生成html
     * @param {Object} element 数据项
     */
    function createDbQueryHtml(element) {
        var market = element.exchange_type;
        var market_class = '';
        if (market == "0") {
            market = "深";
            market_class = 'market_sz';
        } else if (market == "1") {
            market = "深";
            market_class = 'market_sz';
        } else if (market == "2") {
            market = "沪";
            market_class = 'market_sh';
        } else if (market == "3") {
            market = "沪";
            market_class = 'market_sh';
        } else if (market == "A") {
            market = "股转";
            market_class = 'market_sb';
        } else if(market == "9") {
            market = "京";
            market_class = 'market_sb';
        } else {
            market = "其他";
            market_class = 'market_qt';
        }
        var assure_ratio = element.assure_ratio ? (Number(element.assure_ratio) * 100).toFixed(2) + "%" : "--";
        var eleHtml = "";
        eleHtml += '<tr poststr="' + element.position_str + '">';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:'+$.getTransformScaleFontSize(element.stock_name, 14, $(window).width() * 0.3)+'px;">' + element.stock_name + '</p>';
        eleHtml += '<span>' + element.stock_code + '<em class="' + market_class + '">' + market + '</em>' + '</span>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        eleHtml += '<p>' + assure_ratio + '</p>';
        eleHtml += '</td>';
        eleHtml += '<td class="text_center">';
        eleHtml += '<p style="font-size:'+$.getTransformScaleFontSize(element.stockgroup_name, 16, $(window).width() * 0.3)+'px;">' + element.stockgroup_name + '</p>';
        eleHtml += '</td>';
        eleHtml += '</tr>';
        return eleHtml;
    }


    /**
     * 下拉刷新初始化
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2,//显示内容区域的高度，当isPaingType为false时传, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                isPullUp = false;
                //查询资产数据
                var stockCode = $(_pageId + " #stockCode").val();
                stockCode = $.trim($(_pageId + "#stockCode").val().substring(0, 6));
                $(_pageId + " .j-position-table table").html("");
                if (query_type == "financing") {
                    //融资标的 303005
                    qualificationInquiry(stockCode);
                } else if (query_type == "securities") {
                    //融券标的 303006
                    queryCanBeMargin(stockCode);
                } else if (query_type == "collateral") {
                    //担保品标的 303002
                    db_query(stockCode);
                }
                // common.comStat(105440, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
            },
            pullUpHandler: function () {
                //上拉获取下一页数据方法
                if (_isData) {
                    isPullUp = true;
                    if (query_type == "financing") {
                        //融资标的 303005
                        qualificationInquiry();
                    } else if (query_type == "securities") {
                        //融券标的 303006
                        queryCanBeMargin();
                    } else if (query_type == "collateral") {
                        //担保品标的 303002
                        db_query();
                    }
                }
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     * */
    function destroy() {
        common.pageBuryingPoint();
        _isData = true;
        isPullUp = false
        $(_pageId + " #stockCode").val("");
        $(_pageId + ".tab_list ul li").eq(0).addClass("current").siblings().removeClass("current");
        $(_pageId + " .j-position-table table").html("");
        $(_pageId + " .no_more_data").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        if (keyboard) {
            keyboard.keyDestroy();
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
