/**
 * 信用交易-单合约流水查询
 */
define('trade/scripts/credit/query/singleContractFlowQuery.js', function (require, exports, module) {
    var service_credit = require("service_credit");
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var _pageId = "#credit_query_singleContractFlowQuery ";
    var userInfo = null;
    var compact_id = null;

    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        // common.pageBuryingPoint("105384");
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        compact_id = $.getPageParam("compact_id");
        $(_pageId + ".header_inner .two_row span").text("合约编号：" + compact_id);
        queryMsg();//查询信息
    }

    /**
     * 查询信息
     */
    function queryMsg() {
        $(_pageId + ".no_data_box").hide();
        queryContracliata(); //查询合约流水
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            // common.comStat(105385, 2, 103, true, {"i_group_name": "返回"});//埋点
            setTimeout(function () {
                var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
                if (prePageCode == "credit/asset/debt") {
                    var pageCode = $.getCurrentPageObj().pageCode || '';
                    $.pageInit(pageCode, prePageCode, {
                        "_loginClass": "1",
                        "compact_type": $.getPageParam("compact_type")
                    }, "left", true);
                } else {
                    $.pageBack();
                }
                e.stopPropagation();
            },300);
        });
    }

    /**
     * 未偿还合约查询
     */
    function queryContracliata() {
        $(_pageId + ".contract_flow_list").html("");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "compact_id": compact_id,
        };
        service_credit.singleContractFlowQuery(param, singleContractFlowQueryCallBack,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $(_pageId + ".no_data_box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });//未偿还合约查询
    }

    /**
     * 未偿还合约数据查询回调方法
     */
    function singleContractFlowQueryCallBack(data) {
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var openInterestHtml = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        var data = results[i];
                        openInterestHtml += createHtml(data);
                    }
                    $(_pageId + ".no_data_box").hide();
                    $(_pageId + ".contract_flow_list").html(openInterestHtml);
                    $(_pageId + ".contract_flow_list").append('<div class="no_more_data" style="padding-top: 0;">没有更多数据了</div>');
                } else {
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        }
    }

    /**
     * 生成未偿还合约html
     * @param {Object} element 数据项
     */
    function createHtml(element) {
        var css = "label_02";
        var compactTypes = {"0": "融资", "1": "融券", "2": "其他负债"};
        // if (element.compact_type == "1") {
        //     css = "label_01";
        // } else if (element.business_flag_name && element.business_flag_name.indexOf("合约展期") > -1) {
        //     css = "label_03";
        // }
        var eleHtml = "";
        var stock_name = $.trim(element.stock_name) ? $.trim(element.stock_name) : "--";
        var stock_code = $.trim(element.stock_code) ? $.trim(element.stock_code) : "--";
        eleHtml += '<div class="list_item">';
        eleHtml += '<div class="li_top border_bottom">';
        eleHtml += '<span class="label_text">' + element.business_flag_name + '</span>';
        eleHtml += '<p class="fr_text">' + element.init_date + '</p>';
        eleHtml += '</div>';
        eleHtml += '<div class="li_con">';
        eleHtml += '<ul class="flow_list flow_list2">';
        eleHtml += '<li><span class="flow_list_stock_name_long" style="font-size:'+ $.getTransformScaleFontSize(stock_name, 14, 65) +'px;">' + stock_name + '</span>' + stock_code + '</li>';
        eleHtml += '<li><span>合约类型</span>' + compactTypes[element.compact_type] + '</li>';
        eleHtml += '<li><span>发生金额</span>' + element.occur_balance + '</li>';
        eleHtml += '<li><span>发生数量</span>' + element.occur_amount + '</li>';
        eleHtml += '<li><span>后资金额</span>' + element.post_balance + '</li>';
        eleHtml += '<li><span>后证券额</span>' + element.post_amount + '</li>';
        eleHtml += '<li><span>发生费用</span>' + element.occur_fare + '</li>';
        eleHtml += '<li><span>后余费用</span>' + element.post_fare + '</li>';
        eleHtml += '<li><span>发生利息</span>' + element.occur_interest + '</li>';
        eleHtml += '<li><span>后余利息</span>' + element.post_interest + '</li>';
        eleHtml += '</ul>';
        eleHtml += '</div>';
        eleHtml += '</div>';
        return eleHtml;
    }


    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                queryMsg();//下拉获取上一页数据方法
                // common.comStat(105386, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".header_inner .two_row span").text("");
        $(_pageId + ".contract_flow_list").html("");
        $(_pageId + ".no_data_box").hide();
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
