/**
 * 普通交易-详情
 */
define('trade/scripts/credit/query/stockDetails.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
    var service_stock = require("service_stock");
    var service_xkj = require("service_xkj");
    var _pageId = "#credit_query_stockDetails ";
	var mainHeight = null;
	var flag="";//1当日委托 2、当日成交 3、历史委托 4、历史成交 5、交割单 6、对账单 7、当日资金流水 8、ETF委托查询 9、ETF成交查询
	var search_type="1";//1、近一周 2、近一月 3、近三月 0、自定义
	var begin_time="0";
	var end_time="0";
	var titleName="";//标题名称
	var selectIndex=0;//选择的数据索引
	var cbpconfer_id = 0;//约定号
	var en_bondtrade_trans_status = 0;//允许债券现券转发信息状态
	var dataList=null;
    var paramMap = null;//上个页面传递过来的数据
    var userInfo = null;
    /**
     * 初始化
     */
	function init(){
        paramMap=null;
		mainHeight =  common.setMainHeight(_pageId, false);
       if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
        userInfo = common.getCurUserInfo();
        if (null != $.getCurrentPageObj() && null != $.getCurrentPageObj().param) {
            if (null != $.getCurrentPageObj().param.param) {
                paramMap = $.getCurrentPageObj().param.param;
            } else {
                paramMap = $.getCurrentPageObj().param;
            }
        }
        if (null == paramMap && null != $.getPageParam("param")) {
            paramMap = $.getPageParam("param");
        }

        if (null == paramMap &&null != $.getCurrentPageObj() && null != $.getCurrentPageObj().params) {
            if (null != $.getCurrentPageObj().params.param) {
                paramMap = $.getCurrentPageObj().params.param;
            } else {
                paramMap = $.getCurrentPageObj().param;
            }
        }

        if (paramMap && Object.getOwnPropertyNames(paramMap).length != 0) {
            if (paramMap && typeof (paramMap) == "string") {
                paramMap = JSON.parse(paramMap);
            }

            if (paramMap.flag != null) {
                flag = paramMap.flag;
            }

            if (paramMap.search_type != null) {
                search_type = paramMap.search_type;
            }

            if (paramMap.begin_time != null) {
                begin_time = paramMap.begin_time;
            }

            if (paramMap.end_time != null) {
                end_time = paramMap.end_time;
            }

            if (paramMap.titleName != null) {
                titleName = paramMap.titleName;
            }

            if (paramMap.selectIndex != null) {
                selectIndex = paramMap.selectIndex;
            }
            if (paramMap.en_bondtrade_trans_status != null) {
                en_bondtrade_trans_status = paramMap.en_bondtrade_trans_status;
            }
            if (paramMap.cbpconfer_id != null) {
                cbpconfer_id = paramMap.cbpconfer_id;
            }
        }
        $(_pageId+".header .title").html(titleName);
        console.log(paramMap);
        reset();

        if(global.requestLocation == 1){
			backgroundInterface();
		}
	}

	function backgroundInterface() {
        $.showPreloaders("请等待...");
        queryDetail()
    }

    /**
     * 成交查询
     */
    function queryDetail(){
        var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var time1 = new Date(end_time.replaceAll("-", "/"));
        var time2 = new Date(begin_time.replaceAll("-", "/"));
        if(search_type==0){
            if(time1 < time2) {
                $.alert("开始日期大于截止日期");
                return false;
            }//截止时间
        }
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
            "password":password,
            "search_type":search_type,
            "begin_time":search_type==0?begin_time:"",
            "end_time":search_type==0?end_time:"",
			"funcNo":getFuncNo(flag)
        };
        if(en_bondtrade_trans_status){
            param.en_bondtrade_trans_status = en_bondtrade_trans_status;
        }
        if(cbpconfer_id){
            param.cbpconfer_id = cbpconfer_id;
            delete param.search_type;
            delete param.begin_time;
            delete param.end_time;
        }
        if(["1001018","1001019"].indexOf(param.funcNo) > -1){
            param.system_id = 1;
            param.trade_code = param.funcNo;
            param.client_id = param.cust_code;
            delete param.funcNo;
            service_xkj.queryStockDetail(param,callback,{
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "timeOutFunc":function(){ // 超时调用方法
                    $.hidePreloader();
                    reset();
                }
            });
            return;
        }
        service_stock.queryStockDetail(param,callback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "timeOutFunc":function(){ // 超时调用方法
                    $.hidePreloader();
                    reset();
                }
            });

    }

    /**
     * 成交查询回调
     */
    function callback(data){
        if (typeof(data) != "undefined" && data != null) {
            $.hidePreloader();
            if(data.error_no == 0){
                var results = data.results;
                if(results != "undefined" && results.length>0){
                    dataList =results;
                    if(dataList.length==1){
                        selectIndex=0;
                        dealData(dataList,selectIndex);
                    }else{
                        dealData(dataList,selectIndex);
                    }
                }else{
                	reset();
				}
            } else{
                $.alert(data.error_info);
            }
        } else{
            $.alert("查询失败");
        }
    }


    /*********
	 * 处理数据
     */
    function dealData(dataList,selectIndex) {
        showHtml(dataList[selectIndex]);
    	if(dataList.length==1){
            $(_pageId+"#last").removeClass('btn_trade').addClass('btn_trade_default');
            $(_pageId+"#next").removeClass('btn_trade').addClass('btn_trade_default');
		}else{
            if(selectIndex==0){
                $(_pageId+"#last").removeClass('btn_trade').addClass('btn_trade_default');
                $(_pageId+"#next").removeClass('btn_trade_default').addClass('btn_trade');
			}else if(selectIndex==dataList.length-1){
                $(_pageId+"#next").removeClass('btn_trade').addClass('btn_trade_default');
                $(_pageId+"#last").removeClass('btn_trade_default').addClass('btn_trade');
			}else{
                $(_pageId+"#next").removeClass('btn_trade_default').addClass('btn_trade');
                $(_pageId+"#last").removeClass('btn_trade_default').addClass('btn_trade');
            }
		}

    }

    /**********
	 * 显示详情数据
     * @param element
	 * flag //1当日委托 2、当日成交 3、历史委托 4、历史成交 5、交割单 6、对账单 7、当日资金流水 8、ETF委托查询 9、ETF成交查询
     * flag 10、债券现券-匹配成交-委托查询 
     * flag 11、债券现券-匹配成交-历史成交
     * flag 12、债券现券-协商成交-申报回复查询
     * flag 13、债券现券-协商成交-当日委托
     * flag 14、债券现券-协商成交-当日成交
     * flag 15、债券现券-协商成交-历史委托
     * flag 16、债券现券-协商成交-历史成交
     * flag 17、债券现券-协商成交-申报信息查询
     * flag 18、大宗交易-当日委托
     * flag 19、大宗交易-当日成交
     * flag 20、大宗交易-历史委托
     * flag 21、北交所-债券现券-协商成交-当日委托
     * flag 22、北交所-债券现券-协商成交-当日成交
     * flag 23、北交所-债券现券-协商成交-历史委托
     * flag 24、北交所-债券现券-协商成交-历史成交
     * flag 25、北交所-大宗交易-当日委托
     * flag 26、北交所-大宗交易-当日成交
     * flag 27、北交所-大宗交易-历史委托
     * flag 28、北交所-大宗交易-历史成交
     * flag 29、上海-减持信息详情
     * flag 30、深圳-减持信息详情
     */
    function showHtml(element) {
        if($.isValue(element.stock_name_long)) element.stock_name = element.stock_name_long;
        if(flag=="1"||flag=="3"||flag=="8"||flag=="10"||flag=="23"||flag=="27"){
            let price_digit = 3;
            if(flag=="23"){
                price_digit = 4;
            }
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
                $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red");
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                $(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue");
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
			var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+common.getShowStr((common.getShowStr(element.entrust_date,'',0,0)+" "+common.getShowStr(element.entrust_time,'',0,0)),'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">'+common.getShowStr(element.entrust_prop_name,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',2,price_digit)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',2,price_digit)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',2,2)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',3,2)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);


            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="2"||flag=="4"||flag=="9"||flag=="11" || flag=="16" || flag=="22"||flag=="24"||flag=="26"||flag=="28"){
            let price_digit = 3;
            if(flag=="22" || flag=="24"){
                price_digit = 4;
            }
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
            //    $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.business_name || '买入','--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                // $(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.business_name || '卖出','--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+common.getShowStr((common.getShowStr(element.entrust_date,'',0,0)+" "+common.getShowStr(element.entrust_time,'',0,0)),'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">币种类型</span><span class="footer reset">'+getMoneyType(element.money_type)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">'+(element.business_date+" "+element.business_time)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.business_no,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',2,price_digit)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',2,2)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',3,2)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">佣金</span><span class="footer reset">'+common.getShowStr(element.fare0,'--',2,3)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">印花税</span><span class="footer reset">'+common.getShowStr(element.fare1,'--',2,3)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">过户费</span><span class="footer reset">'+common.getShowStr(element.fare2,'--',2,3)+'</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="5"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));
            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.business_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red");
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.business_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue");
            }else{
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.business_name,'--',0,0));
            }

            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托日期</span><span class="footer reset">'+common.getShowStr(element.entrust_date,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">币种类型</span><span class="footer reset">'+getMoneyType(element.money_type)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">'+common.getShowStr((common.getShowStr(element.business_date,'',0,0)+" "+common.getShowStr(element.business_time,'',0,0)),'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.business_no,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',2,3)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',3,2)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">佣金</span><span class="footer reset">'+common.getShowStr(element.fare0,'--',2,3)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">印花税</span><span class="footer reset">'+common.getShowStr(element.fare1,'--',2,3)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">过户费</span><span class="footer reset">'+common.getShowStr(element.fare2,'--',2,3)+'</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="6"||flag=="7"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+".btn_dzd_head_title").html(common.getShowStr(element.business_name,'--',0,0));
            $(_pageId+".btn_dzd_head_content").html(common.getShowStr(element.occur_balance,'--',3,2));
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生时间</span><span class="footer reset">'+common.getShowStr((common.getShowStr(element.business_date,'',0,0)+" "+common.getShowStr(element.business_time,'',0,0)),'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券名称</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.8) +'px!important;">'+common.getShowStr(element.stock_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券代码</span><span class="footer reset">'+common.getShowStr(element.stock_code,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生数量</span><span class="footer reset">'+common.getShowStr(element.occur_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',2,3)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生金额</span><span class="footer reset">'+common.getShowStr(element.occur_balance,'--',3,2)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">后资金额</span><span class="footer reset">'+common.getShowStr(element.post_balance,'--',3,2)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">流水号</span><span class="footer reset">'+common.getShowStr(element.serial_no,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);
        }else if(flag=="12"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if(en_bondtrade_trans_status){
                $(_pageId+".footer2").hide();
                $(_pageId+".footer3").show();
            }else{
                $(_pageId+".footer2").show();
                $(_pageId+".footer3").hide();
            }
            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">交易系统执行编号</span><span class="footer reset">'+common.getShowStr(element.exec_id,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+common.getShowStr(element.init_date,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">'+common.getShowStr(element.settle_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">'+common.getShowStr(element.settle_perio_name,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.bond_investor_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">'+common.getShowStr(element.agency_no,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.bond_investor_type_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">'+common.getShowStr(element.trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="13"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.curr_date+" "+element.curr_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除数量</span><span class="footer reset">'+common.getShowStr(element.trade_cancel_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">'+common.getShowStr(element.settle_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">'+common.getShowStr(element.settle_perio_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报类型</span><span class="footer reset">'+common.getShowStr(element.tradereport_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报模式</span><span class="footer reset">'+common.getShowStr(element.trade_handling_name,'--',0,0)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_type_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.bond_investor_id,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">'+common.getShowStr(element.agency_no,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.bond_investor_type_name,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">'+common.getShowStr(element.trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#four_part").html(fourHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="14"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.curr_date+" "+element.entrust_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">'+(element.business_time === "0"?"--":(element.init_date+" "+element.business_time)) +'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.business_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交类型</span><span class="footer reset">'+common.getShowStr(element.real_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交状态</span><span class="footer reset">'+common.getShowStr(element.real_status_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除状态</span><span class="footer reset">'+common.getShowStr(element.business_cancel_status_name,'--',0,0)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_type_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="15"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.entrust_date+" "+element.entrust_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.business_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除数量</span><span class="footer reset">'+common.getShowStr(element.trade_cancel_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报模式</span><span class="footer reset">'+common.getShowStr(element.trade_handling_name,'--',0,0)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_type_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.bond_investor_id,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">'+common.getShowStr(element.agency_no,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.bond_investor_type_name,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">'+common.getShowStr(element.trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#four_part").html(fourHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="17"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if(en_bondtrade_trans_status){
                $(_pageId+".footer2").hide();
                $(_pageId+".footer3").show();
            }else{
                $(_pageId+".footer2").show();
                $(_pageId+".footer3").hide();
            }
            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_bs_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">转发信息状态</span><span class="footer reset">'+common.getShowStr(element.bondtrade_trans_status_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">交易系统执行编号</span><span class="footer reset">'+common.getShowStr(element.exec_id,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+common.getShowStr(element.init_date,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">'+common.getShowStr(element.settle_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">'+common.getShowStr(element.settle_perio_name,'--',0,0)+'</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.oppo_bond_investor_type_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">'+common.getShowStr(element.bond_investor_id,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">'+common.getShowStr(element.agency_no,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">'+common.getShowStr(element.bond_investor_type_name,'--',0,0)+'</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">'+common.getShowStr(element.trader_id,'--',0,0)+'</span></li>';

            $(_pageId+"#four_part").html(fourHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="18"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.curr_date+" "+element.curr_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">'+common.getShowStr(element.entrust_prop_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托方向</span><span class="footer reset">'+common.getShowStr(element.entrust_bs_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">'+common.getShowStr(element.reduction_type_name,'--',0,0)+'</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',0,0)+'</span></li>';
           $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系人</span><span class="footer reset">'+common.getShowStr(element.relation_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系电话</span><span class="footer reset">'+common.getShowStr(element.relation_tel,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">'+common.getShowStr(element.prop_seat_no,'--',0,0)+'</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="19"){
            
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.curr_date+" "+element.entrust_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">'+common.getShowStr(element.entrust_prop_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托方向</span><span class="footer reset">'+common.getShowStr(element.entrust_bs_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">'+common.getShowStr(element.reduction_type_name,'--',0,0)+'</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">'+(element.business_time === "0"?"--":(element.init_date+" "+element.business_time)) +'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.cbp_business_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交类型</span><span class="footer reset">'+common.getShowStr(element.real_type_name,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交状态</span><span class="footer reset">'+common.getShowStr(element.real_status_name,'--',0,0)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">'+common.getShowStr(element.prop_seat_no,'--',0,0)+'</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="20"){
            
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_type_trans_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.curr_date+" "+element.entrust_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">'+common.getShowStr(element.reduction_type_name,'--',0,0)+'</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">'+common.getShowStr(element.cbp_business_id,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">'+common.getShowStr(element.business_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">'+common.getShowStr(element.business_balance,'--',0,0)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系人</span><span class="footer reset">'+common.getShowStr(element.relation_name,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系电话</span><span class="footer reset">'+common.getShowStr(element.relation_tel,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.cbpconfer_id,'--',0,0)+'</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">'+common.getShowStr(element.prop_seat_no,'--',0,0)+'</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="21" || flag=="25"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('<em>'+common.getShowStr(element.stock_name,'--',0,0)+'</em><span>'+common.getShowStr(element.stock_code,'--',0,0)+'</span>');
            $(_pageId+"#stock_name em").css('fontSize',$.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.7));

            if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
               // $(_pageId+"#entrust_bs").html('买入');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('blue').addClass("red")
            }else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
                //$(_pageId+"#entrust_bs").html('卖出');
                $(_pageId+"#entrust_bs").html(common.getShowStr(element.entrust_name,'--',0,0));
                $(_pageId+"#entrust_bs").removeClass('normal').removeClass('red').addClass("blue")
            }else{
                $(_pageId+"#entrust_bs").html(element.entrust_name);
            }
            // 委托查询 类别优先使用后端返回的字段
            if(element.entrust_name_new){
                $(_pageId+"#entrust_bs").html(element.entrust_name_new);
            }
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">'+(element.entrust_date+" "+element.entrust_time)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">'+common.getShowStr(element.entrust_no,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">'+common.getShowStr(element.stock_account,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">'+common.getShowStr(element.entrust_state_name,'--',0,0)+'</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">'+common.getShowStr(element.entrust_type_name,'--',0,0)+'</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">'+common.getShowStr(element.entrust_price,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">'+common.getShowStr(element.entrust_amount,'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">'+common.getShowStr(element.entrust_balance === undefined ?'':common.numToMoneyType(element.entrust_balance),'--',0,0)+'</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">'+common.getShowStr(element.business_amount,'',3,2)+'</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">'+common.getShowStr(element.confer_no,'--',0,0)+'</span></li>';
            if(flag === '25'){
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方席位号</span><span class="footer reset">'+common.getShowStr(element.oppo_seatno,'--',0,0)+'</span></li>';
            }
            if(flag === "21"){
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">'+common.getShowStr(element.oppo_trader_id,'--',0,0)+'</span></li>';
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">'+common.getShowStr(element.oppo_agency,'--',0,0)+'</span></li>';
            }

            $(_pageId+"#three_part").html(threeHtml);


            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="29"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            var _width60 = ($(window).width() - 30) * 0.6;
            var _width40 = ($(window).width() - 30) * 0.4;
            var renderList = [
                {
                    name:'证券名称',
                    key:'stock_name',
                    type:'1'
                },
                {
                    name:'证券代码',
                    key:'stock_code',
                    type:'1'
                },
                {
                    name:'股东账号',
                    key:'stock_account',
                    type:'1'
                },
                {
                    name:'席位编号',
                    key:'seat_no',
                    type:'1'
                },
                {
                    name:'证券余额',
                    key:'surplusstock_amount',
                    type:'2'
                },
                {
                    name:'已用额度',
                    key:'used_quota',
                    type:'2'
                },
                {
                    name:'上日已用额度',
                    key:'pre_used_quota',
                    type:'2'
                },
                {
                    name:'流通股数',
                    key:'stock_circulate_amount',
                    type:'2'
                },
                {
                    name:'冻结数量',
                    key:'frozen_amount',
                    type:'2'
                },
                {
                    name:'股份认定数量一',
                    key:'cognizancestock_amount1',
                    type:'2'
                },
                {
                    name:'股份认定数量二',
                    key:'cognizancestock_amount2',
                    type:'2'
                },
                {
                    name:'竞价限制减持数量',
                    key:'reducectrl_amount',
                    type:'3'
                },
                {
                    name:'竞价实时可卖额度',
                    key:'real_quota',
                    type:'3'
                },
                {
                    name:'竞价期初可卖额度',
                    key:'begin_enable_quota',
                    type:'3'
                },
                {
                    name:'大宗限制减持数量',
                    key:'blockreducectrl_amount',
                    type:'4'
                },
                {
                    name:'大宗减持受让方限制数量',
                    key:'blockrecectrl_amount',
                    type:'4'
                },
                {
                    name:'大宗实时可卖额度',
                    key:'block_real_quota',
                    type:'4'
                },
                {
                    name:'大宗实时可卖额度(非受限股份）',
                    key:'block_real_quota1',
                    type:'4'
                },
                {
                    name:'大宗普通卖出已使用额度',
                    key:'block_used_quota',
                    type:'4'
                },
                {
                    name:'大宗减持卖出已使用额度',
                    key:'reduce_used_quota',
                    type:'4'
                },
                {
                    name:'大宗期初可卖额度',
                    key:'block_enable_quota',
                    type:'4'
                },
                {
                    name:'上日大宗普通卖出已使用额度',
                    key:'preblock_used_quota',
                    type:'4'
                },
                {
                    name:'上日大宗减持卖出已用额度',
                    key:'prereduce_used_quota',
                    type:'4'
                },
                {
                    name:'大宗期初可卖额度(非受限股份）',
                    key:'block_enable_quota1',
                    type:'4'
                },
            ];

            var firstHtml='';
            
            renderList.forEach(function(item){
                if(item.type === '1'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    firstHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            
            renderList.forEach(function(item){
                if(item.type === '2'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    secondHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            
            renderList.forEach(function(item){
                if(item.type === '3'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    threeHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            renderList.forEach(function(item){
                if(item.type === '4'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    fourHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#four_part").html(fourHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }else if(flag=="30"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#five_part_div").show();
            $(_pageId+"#six_part_div").show();
            var _width60 = ($(window).width() - 30) * 0.6;
            var _width40 = ($(window).width() - 30) * 0.4;
            var renderList = [
                {
                    name:'证券名称',
                    key:'stock_name',
                    type:'1'
                },
                {
                    name:'证券代码',
                    key:'stock_code',
                    type:'1'
                },
                {
                    name:'股东账号',
                    key:'stock_account',
                    type:'1'
                },
                {
                    name:'席位编号',
                    key:'seat_no',
                    type:'1'
                },
                {
                    name:'无限售流通股总量',
                    key:'stock_total_amount',
                    type:'2'
                },
                {
                    name:'冻结数量',
                    key:'frozen_amount',
                    type:'2'
                },
                {
                    name:'已使用额度',
                    key:'used_quota',
                    type:'2'
                },
                {
                    name:'上日已使用额度',
                    key:'pre_used_quota',
                    type:'2'
                },
                {
                    name:'股份数量一',
                    key:'stock_amount1',
                    type:'3'
                },
                {
                    name:'股份数量二',
                    key:'stock_amount2',
                    type:'3'
                },
                {
                    name:'股份数量三',
                    key:'stock_amount3',
                    type:'3'
                },
                {
                    name:'股份数量四',
                    key:'stock_amount4',
                    type:'3'
                },
                {
                    name:'股份数量五',
                    key:'stock_amount5',
                    type:'3'
                },
                {
                    name:'股份数量六',
                    key:'stock_amount6',
                    type:'3'
                },
                {
                    name:'股份数量一（含冻结）',
                    key:'stock_amount1_ex',
                    type:'4'
                },
                {
                    name:'股份数量二（含冻结）',
                    key:'stock_amount2_ex',
                    type:'4'
                },
                {
                    name:'股份数量三（含冻结）',
                    key:'stock_amount3_ex',
                    type:'4'
                },
                {
                    name:'股份数量四（含冻结）',
                    key:'stock_amount4_ex',
                    type:'4'
                },
                {
                    name:'股份数量三（竞价）',
                    key:'stock_amount3_t',
                    type:'4'
                },
                {
                    name:'竞价实时可卖额度',
                    key:'real_quota',
                    type:'5'
                },
                {
                    name:'竞价期初可卖额度',
                    key:'begin_enable_quota',
                    type:'5'
                },
                {
                    name:'大宗实时可卖额度',
                    key:'block_real_quota',
                    type:'6'
                },
                {
                    name:'大宗实时可卖额度(非受限股份）',
                    key:'block_real_quota1',
                    type:'6'
                },
                {
                    name:'大宗普通卖出已使用额度',
                    key:'block_used_quota',
                    type:'6'
                },
                {
                    name:'大宗减持卖出已使用额度',
                    key:'reduce_used_quota',
                    type:'6'
                },
                {
                    name:'大宗期初可卖额度',
                    key:'block_enable_quota',
                    type:'6'
                },
                {
                    name:'上日大宗普通卖出已使用额度',
                    key:'preblock_used_quota',
                    type:'6'
                },
                {
                    name:'上日大宗减持卖出已用额度',
                    key:'prereduce_used_quota',
                    type:'6'
                },
                {
                    name:'大宗期初可卖额度(非受限股份）',
                    key:'block_enable_quota1',
                    type:'6'
                },
            ];

            var firstHtml='';
            
            renderList.forEach(function(item){
                if(item.type === '1'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    firstHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            
            renderList.forEach(function(item){
                if(item.type === '2'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    secondHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            renderList.forEach(function(item){
                if(item.type === '3'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    threeHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            renderList.forEach(function(item){
                if(item.type === '4'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    fourHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#four_part").html(fourHtml);

            var fiveHtml='';
            renderList.forEach(function(item){
                if(item.type === '5'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    fiveHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#five_part").html(fiveHtml);

            var sixHtml='';
            renderList.forEach(function(item){
                if(item.type === '6'){
                    var text = common.getShowStr(element[item.key],'--',0,0);
                    sixHtml+='<li style="height: 0.35rem"><span class="header" style="font-size:'+ $.getTransformScaleFontSize(item.name, 16, _width60) +'px;">' + item.name + '</span><span class="footer reset" style="font-size:'+ $.getTransformScaleFontSize(text, 16, _width40) +'px;">'+text+'</span></li>';
                }
            });
            $(_pageId+"#six_part").html(sixHtml);

            if(element.remark && element.remark.trim()){
                $(_pageId+"#trade_mark span").html(element.remark);
                $(_pageId+"#trade_mark").show();
            }else{
                $(_pageId+"#trade_mark").hide();
            }
        }
    }

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
        $.bindEvent($(_pageId + ".header .icon_back"), function(e){
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                //埋点
                $.setSStorageInfo("trade_query_begin_time",begin_time);
                $.setSStorageInfo("trade_query_end_time",end_time);
                $.setSStorageInfo("trade_query_search_type",search_type);
                $.pageBack("stock/stockQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        },"tap");


        $.bindEvent($(_pageId + "#last"), function(e){
        	if($(_pageId+"#last").hasClass('btn_trade')){
        		selectIndex=Number(selectIndex)-1;
        		if(selectIndex<0){
        			selectIndex=0;
				}
				if(dataList!=null&&dataList.length>0&&selectIndex<dataList.length-1){
                    dealData(dataList,selectIndex);
				}

			}
        });

        $.bindEvent($(_pageId + "#next"), function(e){
            if($(_pageId+"#next").hasClass('btn_trade')){
                selectIndex=Number(selectIndex)+1;
                if(dataList!=null&&dataList.length>0){
                    if(selectIndex>dataList.length-1){
                        selectIndex=dataList.length-1;
                    }
                    dealData(dataList,selectIndex);
                }
            }
        });
        // 拒绝成交
        $.bindEvent($(_pageId + "#cancel"), function(e){
            var item = dataList[selectIndex];
            if(!item.exec_id){
                return;
            }

            var tipStrArray = [];
            tipStrArray.push(["债券代码", item.stock_code]);
            tipStrArray.push(["债券名称", "<em style='font-size:" + $.getTransformScaleFontSize(item.stock_name, 16, $(window).width() * 0.48) + "px;'>" + item.stock_name + "</em>"]);
            tipStrArray.push(["买入价格", item.entrust_price]);
            tipStrArray.push(["买入数量", item.entrust_amount + "张"]);
            tipStrArray.push(["约定号", (item.cbpconfer_id || "").trim() || "--"]);
            tipStrArray.push(["成交申报类型", "拒绝成交"]);
            var tipStr = "<div >";
            tipStr += common.generatePrompt(tipStrArray);
            tipStr += "</div>";
            common.iConfirm("回复确认", tipStr, function () {
                bondReplyEntrust(item.exec_id,"3");
            }, function () {
            });
        });
        // 接受成交
        $.bindEvent($(_pageId + "#determine"), function(e){
            var item = dataList[selectIndex];
            if(!item.exec_id){
                return;
            }
            var tipStrArray = [];
            tipStrArray.push(["债券代码", item.stock_code]);
            tipStrArray.push(["债券名称", "<em style='font-size:" + $.getTransformScaleFontSize(item.stock_name, 16, $(window).width() * 0.48) + "px;'>" + item.stock_name + "</em>"]);
            tipStrArray.push(["买入价格", item.entrust_price]);
            tipStrArray.push(["买入数量", item.entrust_amount]);
            tipStrArray.push(["约定号", (item.cbpconfer_id || "").trim() || "--"]);
            tipStrArray.push(["成交申报类型", "接受成交"]);
            var tipStr = "<div >";
            tipStr += common.generatePrompt(tipStrArray);
            tipStr += "</div>";
            common.iConfirm("回复确认", tipStr, function () {
                bondReplyEntrust(item.exec_id,"2");
            }, function () {
            });
        });


	}
    // 债券现券交易协商确认委托
    function bondReplyEntrust(exec_id,tradereport_type) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "exec_id": exec_id,
            "tradereport_type": tradereport_type,
            "cust_code": cust_code,
            "sessionid": sessionid,
        };
        // 每次查询前,先将暂无数据隐藏
        $(_pageId + ".no_data").hide();
        // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
        service_stock.bondReplyEntrust(param, function (data) {
            $.hidePreloader();
            var tipStr = "<span class='wt-tips-title'>委托结果</span><br>" + data.error_info;
            if (data.error_no == 0) {
                if (typeof data.results[0] != "undefined" && data.results[0] != null) {
                    $.alert(tipStr, function () {
                        $.pageBack();
                    });
                }
            } else {
                $.alert(tipStr, function () { 
                    $.pageBack();
                });
            }
        },
        { // 传给接口的json格式数据            
            "isLastReq": true,
            "isShowWait": true,
            "isShowOverLay": false,
            "timeOutFunc": function () { // 超时调用方法
                $.hidePreloader();
            }
        });
    }


    /********
	 * 重置
     */
	function reset() {
        if(en_bondtrade_trans_status){
            $(_pageId+".footer2").hide();
            $(_pageId+".footer3").show();
        }else{
            $(_pageId+".footer2").show();
            $(_pageId+".footer3").hide();
        }
        $(_pageId+"#three_part_div").hide();
        $(_pageId+"#four_part_div").hide();
        $(_pageId+"#five_part_div").hide();
        $(_pageId+"#six_part_div").hide();
        if(flag=="1"||flag=="3"||flag=="8"||flag=="10"||flag=="23"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('--<span>--</span>');

            $(_pageId+"#entrust_bs").html('--');
            $(_pageId+"#entrust_bs").removeClass('red').removeClass('blue').addClass("normal")
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);
            $(_pageId+"#trade_mark").hide();

        }else if(flag=="2"||flag=="4"||flag=="9"||flag=="11" || flag=="16" || flag=="22"||flag=="24"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('--<span>--</span>');

            $(_pageId+"#entrust_bs").html('--');
            $(_pageId+"#entrust_bs").removeClass('red').removeClass('blue').addClass("normal")
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">币种类型</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">佣金</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">印花税</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">过户费</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="5"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+"#stock_name").html('--<span>--</span>');

            $(_pageId+"#entrust_bs").html('--');
            $(_pageId+"#entrust_bs").removeClass('red').removeClass('blue').addClass("normal")
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托日期</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">币种类型</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">佣金</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">印花税</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">过户费</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="6"||flag=="7"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").hide();
            $(_pageId+"#trade_mark").hide();
            $(_pageId+".btn_dzd_head_title").html('--');
            $(_pageId+".btn_dzd_head_content").html('--');
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券名称</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券代码</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">发生金额</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">后资金额</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">流水号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="12"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html("--");
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">交易系统执行编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="13"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html('--');
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报类型</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报模式</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#four_part").html(fourHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="14"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html('--');
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交类型</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交状态</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除状态</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="15"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html('--');
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">交易解除数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交申报模式</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#four_part").html(fourHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="17"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html("--");
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">转发信息状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">交易系统执行编号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算方式</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">结算周期</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易主体类型</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易商代码</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易主体类型</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">本方交易员代码</span><span class="footer reset">--</span></li>';

            $(_pageId+"#four_part").html(fourHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="18"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html("--");
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托方向</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">--</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
           $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系人</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系电话</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="19"){
            
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html("--");
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托属性</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托方向</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">--</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交时间</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交类型</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交类型</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交状态</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="20"){
            
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');

            $(_pageId+"#entrust_bs").html("--");
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股份类别</span><span class="footer reset">--</span></li>';

            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交编号</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交金额</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系人</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">联系电话</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">席位号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#three_part").html(threeHtml);

            $(_pageId+"#trade_mark").hide();
        }else if(flag=="21" || flag=="25"){
            $(_pageId+"#header_first_div").show();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#stock_name").html('--');
            $(_pageId+"#entrust_bs").html('--');
            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托时间</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托编号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托状态</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">委托类别</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托价格</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">委托金额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">成交数量</span><span class="footer reset">--</span></li>';
            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            
            threeHtml+='<li style="height: 0.35rem"><span class="header">约定号</span><span class="footer reset">--</span></li>';
            if(flag === '25'){
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方席位号</span><span class="footer reset">--</span></li>';
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方股东账号</span><span class="footer reset">--</span></li>';
            }
            if(flag === "21"){
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易员代码</span><span class="footer reset">--</span></li>';
                threeHtml+='<li style="height: 0.35rem"><span class="header">对方交易商代码</span><span class="footer reset">--</span></li>';
            }

            $(_pageId+"#three_part").html(threeHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="29"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();

            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券名称</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券代码</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">席位编号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">证券余额</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">已用额度</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">上日已用额度</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">流通股数</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">冻结数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">股份认定数量一</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">股份认定数量二</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">竞价限制减持数量</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">竞价实时可卖额度</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">竞价期初可卖额度</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗限制减持数量</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗减持受让方限制数量</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗实时可卖额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗实时可卖额度(非受限股份）</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗普通卖出已使用额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗减持卖出已使用额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗期初可卖额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">上日大宗普通卖出已使用额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">上日大宗减持卖出已用额度</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">大宗期初可卖额度(非受限股份）</span><span class="footer reset">--</span></li>';

            $(_pageId+"#four_part").html(fourHtml);
            $(_pageId+"#trade_mark").hide();
        }else if(flag=="30"){
            $(_pageId+"#header_first_div").hide();
            $(_pageId+"#header_second_div").hide();
            $(_pageId+"#first_part_div").show();
            $(_pageId+"#second_part_div").show();
            $(_pageId+"#three_part_div").show();
            $(_pageId+"#four_part_div").show();
            $(_pageId+"#five_part_div").show();
            $(_pageId+"#six_part_div").show();

            var firstHtml='';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券名称</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">证券代码</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">股东账号</span><span class="footer reset">--</span></li>';
            firstHtml+='<li style="height: 0.35rem"><span class="header">席位编号</span><span class="footer reset">--</span></li>';
            $(_pageId+"#first_part").html(firstHtml);

            var secondHtml='';
            secondHtml+='<li style="height: 0.35rem"><span class="header">无限售流通股总量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">冻结数量</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">已使用额度</span><span class="footer reset">--</span></li>';
            secondHtml+='<li style="height: 0.35rem"><span class="header">上日已使用额度</span><span class="footer reset">--</span></li>';

            $(_pageId+"#second_part").html(secondHtml);

            var threeHtml='';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量一</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量二</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量三</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量四</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量五</span><span class="footer reset">--</span></li>';
            threeHtml+='<li style="height: 0.35rem"><span class="header">股份数量六</span><span class="footer reset">--</span></li>';

            $(_pageId+"#three_part").html(threeHtml);

            var fourHtml='';
            fourHtml+='<li style="height: 0.35rem"><span class="header">股份数量一（含冻结）</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">股份数量二（含冻结）</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">股份数量三（含冻结）</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">股份数量四（含冻结）</span><span class="footer reset">--</span></li>';
            fourHtml+='<li style="height: 0.35rem"><span class="header">股份数量三（竞价）</span><span class="footer reset">--</span></li>';
            
            $(_pageId+"#four_part").html(fourHtml);

            var fiveHtml='';
            fiveHtml+='<li style="height: 0.35rem"><span class="header">竞价实时可卖额度</span><span class="footer reset">--</span></li>';
            fiveHtml+='<li style="height: 0.35rem"><span class="header">竞价期初可卖额度</span><span class="footer reset">--</span></li>';

            $(_pageId+"#five_part").html(fiveHtml);

            var sixHtml='';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗实时可卖额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗实时可卖额度(非受限股份）</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗普通卖出已使用额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗减持卖出已使用额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗期初可卖额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">上日大宗普通卖出已使用额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">上日大宗减持卖出已用额度</span><span class="footer reset">--</span></li>';
            sixHtml+='<li style="height: 0.35rem"><span class="header">大宗期初可卖额度(非受限股份）</span><span class="footer reset">--</span></li>';

            $(_pageId+"#six_part").html(sixHtml);
            $(_pageId+"#trade_mark").hide();
        }

        $(_pageId+"#last").removeClass('btn_trade').addClass('btn_trade_default');
        $(_pageId+"#next").removeClass('btn_trade').addClass('btn_trade_default');

    }

    /**********
	 * 获取功能号
     * @param flag 1、当日委托 2、当日成交 3、历史委托 4、历史成交 5、交割单 6、对账单 7、当日资金流水 8、ETF委托查询 9、ETF成交查询
     * @param flag 10、债券现券-匹配成交-委托查询 11、债券现券-匹配成交-历史成交
     * @param flag 12、债券现券-协商成交-申报回复查询
     * @param flag 13、债券现券-协商成交-当日委托
     * @param flag 14、债券现券-协商成交-当日成交
     * @param flag 15、债券现券-协商成交-历史委托
     * @param flag 16、债券现券-协商成交-历史成交
     * @param flag 17、债券现券-协商成交-申报信息查询
     * @param flag 18、大宗交易-当日委托
     * @param flag 19、大宗交易-当日成交
     * @param flag 20、大宗交易-历史委托
     * @param flag 21、北交所-债券现券-协商成交-当日委托
     * @param flag 22、北交所-债券现券-协商成交-当日成交
     * @param flag 23、北交所-债券现券-协商成交-历史委托
     * @param flag 24、北交所-债券现券-协商成交-历史成交
     * @param flag 25、北交所-大宗交易-当日委托
     * @param flag 26、北交所-大宗交易-当日成交
     * @param flag 27、北交所-大宗交易-历史委托
     * @param flag 28、北交所-大宗交易-历史成交
     * @param flag 29、上海-减持信息详情
     * @param flag 30、深圳-减持信息详情
     */
	function getFuncNo(flag) {
		if(flag=="1"){
			return "301508";
		}else if(flag=="2"){
            return "301509";
        }else if(flag=="3"){
            return "301510";
        }else if(flag=="4"){
            return "301511";
        }else if(flag=="5"){
            return "301547";
        }else if(flag=="6"){
            return "301523";
        }else if(flag=="7"){
            return "301516";
        }else if(flag=="8"){
            return "361547";
        }else if(flag=="9"){
            return "361548";
        }else if(flag=="10"){
            return "361557";
        }else if(flag=="11"){
            return "361558";
        }else if(flag=="12"){
            return "361562";
        }else if(flag=="13"){
            return "361566";
        }else if(flag=="14"){
            return "361567";
        }else if(flag=="15"){
            return "361568";
        }else if(flag=="16"){
            return "361570";
        }else if(flag=="17"){
            return "361562";
        }else if(flag=="18"){
            return "361575";
        }else if(flag=="19"){
            return "361576";
        }else if(flag=="20"){
            return "361577";
        }else if(flag=="21"){
            return "361583";
        }else if(flag=="22"){
            return "361584";
        }else if(flag=="23"){
            return "361585";
        }else if(flag=="24"){
            return "361586";
        }else if(flag=="25"){
            return "361588";
        }else if(flag=="26"){
            return "361589";
        }else if(flag=="27"){
            return "361590";
        }else if(flag=="28"){
            return "361591";
        }else if(flag=="29"){
            return "1001018";
        }else if(flag=="30"){
            return "1001019";
        }
    }

    /********
     * 获取币种类型
     * @param moneyType
     * @returns {string}
     */
    function getMoneyType(moneyType) {
        if(moneyType=="0"){
            return "人民币";
        }else if(moneyType=="1"){
            return "美元";
        }else if(moneyType=="2"){
            return "港币";
        }else {
            return "--";
        }
    }

	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		reset();
        flag="";//1当日委托 2、当日成交 3、历史委托 4、历史成交 5、交割单 6、对账单 7、当日资金流水 8、ETF委托查询 9、ETF成交查询
        search_type="1";//1、近一周 2、近一月 3、近三月 0、自定义
        begin_time="0";
        end_time="0";
        titleName="";//标题名称
        selectIndex=0;//选择的数据索引
        dataList=null;
        paramMap = null;//上
        cbpconfer_id = null;//约定号
        en_bondtrade_trans_status = null;//允许债券现券转发信息状态
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
