/**
 *  担保品转入
 */
define('trade/scripts/credit/transferred/collateralTransferIn.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#credit_transferred_collateralTransferIn ";
    var common = require("common");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_credit = require("service_credit");
    var userInfo = null;
    var positionData = {};
    require("validatorUtils");
    var validatorUtil = $.validatorUtils;
    var keyboardCredit = require("keyboardCredit");

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("105265");
        if (keyboardCredit) {
            keyboardCredit.keyInit();
        }
        userInfo = common.getCurUserInfo();
        common.bindStockEvent($(_pageId + '.tab_list ul li'), true);
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
        elementBindEvent();
    }

    function backgroundInterface() {
        callsQuery();
    }

    function elementBindEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                if (keyboardCredit) {
                    keyboardCredit.closeKeyPanel();
                }
                common.comStat(105266, 2, 103, true, {"i_group_name": "返回"});//埋点
                $.pageBack();
                e.preventDefault();
                e.stopPropagation();
            },300);
        });
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //股票代码框事件
        $.bindEvent($(_pageId + "#stockCode"), function (e) {
            if (keyboardCredit) {
                keyboardCredit.popUpKeyboard($(this), e);
            } else {
                var stockCode = $(this).val();
                stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g, "");
                stockCode = $.trim(stockCode);
                $(this).val(stockCode);
            }
            var stockCode = $(_pageId + " #stockCode").val();
            if (stockCode.length == 0) {
                clearBuyMsg();
            }
            if (stockCode && stockCode.length == 6) {
                var codeInfo = positionData[stockCode];
                if (codeInfo) {
                    $(_pageId + "#maxNum").val(codeInfo.enable_amount);
                    $(_pageId + " #stockCode").quzhi(stockCode);
                    $(_pageId + " #stockCode").addClass("select");
                    $(_pageId + " #stockName").quzhi(codeInfo.stock_name);
                    setStockNameFontSize(codeInfo.stock_name);
                    $(_pageId + " #stockName").addClass("jsKey_stock_name");
                    // var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                    // var zoomValue = $.getMaxFontSize(codeInfo.stock_name, "0.18rem", maxWidth);
                    // $(_pageId + " #stockName").css({
                    //     "transform": "scale(" + zoomValue + ")",
                    //     "white-space": "nowrap",
                    //     "transform-origin": "left center",
                    // });
                    if (keyboardCredit) {
                        keyboardCredit.closeKeyPanel();
                    }
                } else {
                    $.alert("请输入您持有的担保品证券代码");
                }
            }
            e.stopPropagation();
        }, "input");

        //股票名称
        $.bindEvent($(_pageId + " #stockName"), function (e) {
            var click = e.type || "click";
            if (keyboardCredit) {
                $(_pageId + " div#stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            } else {
                $(_pageId + " #stockCode").triggerFastClick();
                $(_pageId + " #stockCode").focus();
            }
            e.stopPropagation();
        });

        //点击全部
        $.bindEvent($(_pageId + " .all_btn"), function (e) {
            var maxNum = $(_pageId + "#maxNum").val();
            if (maxNum && maxNum != "--") {
                $(_pageId + "#stockNum").quzhi(maxNum);
            }
            e.stopPropagation();
        });

        $.bindEvent($(_pageId + ".t_btn_text"), function (e) {
            if (keyboardCredit) {
                keyboardCredit.closeKeyPanel();
            }
            var stockCode = $(_pageId + "#stockCode").val();
            var stockNum = $(_pageId + "#stockNum").val();
            var maxNum = $(_pageId + "#maxNum").val();
            if (stockCode.length == 0) {
                $.alert("请输入证券代码");
                return false;
            }
            if (!validatorUtil.isNumberFloat(stockNum)) {
                $.alert("请正确输入数量");
                return false;
            } else if (parseFloat(stockNum) <= 0) {
                $.alert("数量必须大于0");
                return false;
            } 
            // else if (parseFloat(maxNum) < parseFloat(stockNum)) {
            //     $.alert("委托数量大于可划数量");
            //     return false;
            // }
            var codeInfo = positionData[stockCode];
            var tipStr = '<ul class="pop_cancel_order">';
            tipStr += '<li><span>划转方向</span><p>普通 → 信用</p></li>';
            tipStr += '<li><span>证券名称</span><p style="font-size:'+ $.getTransformScaleFontSize(codeInfo.stock_name, 16, $(window).width() * 0.48) +'px;">' + codeInfo.stock_name + '</p></li>';
            tipStr += '<li><span>证券代码</span><p>' + stockCode + '</p></li>';
            tipStr += '<li><span>委托数量</span><p>' + stockNum + '</p></li>';
            tipStr += '</ul>';
            tipStr += '<div class="pop_tips_text">提示：T+1日到账</div>';
            common.iConfirmNew("担保品转入", tipStr, function () {
                codeInfo.entrust_amount = stockNum;
                getStockMsg(codeInfo);//股票联动，获取信息
                common.comStat(105272,2,103,true,{"i_group_name":"转入提交"});
            }, function () {
            }, "确定", "取消");
            e.stopPropagation();
        });

        //点击页面其他位置收起键盘
        $.bindEvent($(_pageId), function (e) {
            if (keyboardCredit) {
                keyboardCredit.closeKeyPanel();
            }
            e.stopPropagation();
        });
    }
    function setStockNameFontSize(value){
        var stockname = $(_pageId + "#stockName");
        //股票名称长度过长缩放
        var maxWidth = stockname.parent().width() * 0.6;
        var zoomValue = $.getMaxFontSize(value, "0.16rem", maxWidth);
        stockname.css({
            "transform": "scale(" + zoomValue + ")",
            "white-space": "nowrap",
            "transform-origin": "left center"
        });
    }
    /**
     * 清空信息
     */
    function clearBuyMsg() {
        $(_pageId + "#maxNum").val("--");
        $(_pageId + "#stockNum").quzhi("");
        $(_pageId + "#stockCode").quzhi("");
        $(_pageId + "#stockName").quzhi("");
        $(_pageId + "#stockCode").removeClass("select");
        $(_pageId + "#stockName").removeClass("jsKey_stock_name");
    }

    /**
     * 调用查询
     */
    function callsQuery() {
        $(_pageId + ".no_data_box").hide();
        queryTradePosition();
    }

    /**
     * 交易持仓查询
     */
    function queryTradePosition() {
        /**
         * 担保信息查询(划入信息查询)
         */
        var param = {
            entrust_way: global.entrust_way, // 委托方式  在configuration配置
            branch_no: userInfo.branch_no, // 分支机构
            cust_code: userInfo.cust_code, // 客户编号
            fund_account: userInfo.fund_account,//资金账号（普通）
            sessionid: userInfo.session_id, // 会话号
            stock_account: "", // 证券账号
            stock_code: "", // 股票代码
        };
        if (global.serverConfig == "2") {
            var stockInfo = common.getTransferInfo();//获取登录后保存的普通账户信息
            param.cust_code = stockInfo.cust_code;
            param.fund_account = stockInfo.fund_account;
            param.password = stockInfo.password;
            param.password_c = stockInfo.password_c;
        }
        service_credit.transferInPostion(param, queryMsgCallBack,{"isShowWait": false});
    }

    /**
     * 查询信息回调函数
     */
    function queryMsgCallBack(data) {
        $(_pageId + ".no_more_data").hide();
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var html = ""
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        positionData["" + results[i].stock_code] = results[i];
                        html += creatHtml(results[i]);
                    }
                    $(_pageId + " .j-position-table table tbody").html(html);
                    $(_pageId + ".no_more_data").show();
                    //划出按钮
                    $.bindEvent($(_pageId + " .j-position-table table tbody tr"), function (e) {
                        clearBuyMsg();
                        var stockCode = $(this).attr("id");//股票代码
                        var codeInfo = positionData[stockCode];
                        $(_pageId + "#maxNum").val(codeInfo.enable_amount);
                        $(_pageId + " #stockCode").quzhi(stockCode);
                        $(_pageId + " #stockCode").addClass("select");
                        $(_pageId + " #stockName").quzhi(codeInfo.stock_name);
                        setStockNameFontSize(codeInfo.stock_name);
                        $(_pageId + " #stockName").addClass("jsKey_stock_name");
                        // var maxWidth = ($(_pageId + " #stockName").parent().width() / 2) - 6;
                        // var zoomValue = $.getMaxFontSize(codeInfo.stock_name, "0.18rem", maxWidth);
                        // $(_pageId + " #stockName").css({
                        //     "transform": "scale(" + zoomValue + ")",
                        //     "white-space": "nowrap",
                        //     "transform-origin": "left center",
                        // });
                        if (keyboardCredit) {
                            keyboardCredit.closeKeyPanel();
                        }
                        e.stopPropagation();
                    });
                } else {
                    $(_pageId + " .j-position-table table tbody").html("");
                    $(_pageId + ".no_data_box").show();
                }
            } else {
                $.alert(data.error_info);
            }
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 生成查询持仓函数
     * @param {Object} data
     */
    function creatHtml(element) {
        var eleHtml = "";
        var cssClass = "";
        // if (element.last_price > element.cost_price) {
        //  cssClass = "ared";
        // } else if (element.last_price < element.cost_price) {
        //     cssClass = "agreen";
        // } else {
        //     cssClass = "";
        // }
        var float_vk = Number(element.float_yk).toFixed(2);
        if (+float_vk > 0) {
            float_vk = "+" + float_vk;
            cssClass = "ared";
        } else if (float_vk < 0) {
            cssClass = "agreen";
        }
        var float_yk_per = element.float_yk_per;
        var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        eleHtml += '<tr id="' + element.stock_code + '">';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) + 'px;">' + element.stock_name + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.market_value).toFixed(2), 16, maxWidth) + 'px;">' + Number(element.market_value).toFixed(2) + '</p>';
        eleHtml += '</td>';
        eleHtml += '<td>';
        eleHtml += '<p class="' + cssClass + '" style="font-size:' + $.getTransformScaleFontSize(float_vk, 16, maxWidth) + 'px;">' + float_vk + '</p>';
        eleHtml += '<p class="' + cssClass + '" style="font-size:' + $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) + 'px;">' + float_yk_per + '%</p>';
        eleHtml += '</td>';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.cost_amount).toFixed(0), 16, maxWidth) + 'px;">' + Number(element.cost_amount).toFixed(0) + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.enable_amount).toFixed(0), 16, maxWidth) + 'px;">' + Number(element.enable_amount).toFixed(0) + '</p>';
        eleHtml += '</td>';
        eleHtml += '<td>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.cost_price).toFixed(2), 16, maxWidth) + 'px;">' + Number(element.cost_price).toFixed(2) + '</p>';
        eleHtml += '<p style="font-size:' + $.getTransformScaleFontSize(Number(element.last_price).toFixed(2), 16, maxWidth) + 'px;">' + Number(element.last_price).toFixed(2) + '</p>';
        eleHtml += '</td>';
        eleHtml += '</tr>';
        return eleHtml;
    }

    /**
     * 股票联动，获取信息
     */
    function getStockMsg(codeInfo) {
        var param = {};
        var stockInfo = common.getTransferInfo() || {};//获取登录后保存的普通账户信息
        param.branch_no = stockInfo.branch_no || userInfo.branch_no;//分支机构（普通）
        param.fund_account = stockInfo.fund_account || userInfo.fund_account;
        ; //资金账号（普通）
        param.cust_code = stockInfo.cust_code || userInfo.cust_code;//客户编号
        param.password = stockInfo.password;//密码
        param.stock_account = codeInfo.stock_account;//证券账号
        param.exchange_type = codeInfo.exchange_type;//交易类别（见数据字典）
        param.entrust_way = global.entrust_way; // 委托方式  在configuration配置
        param.branch_no_crdt = userInfo.branch_no;//分支机构（信用）
        param.fund_account_crdt = userInfo.fund_account;//资金账户（信用）
        param.client_id_crdt = userInfo.cust_code;//客户编号（信用）
        param.password_crdt = userInfo.password; // 信用账户交易密码
        param.sessionid = "";//会话
        param.cost_price = codeInfo.cost_price;//成本价格
        param.last_price = codeInfo.last_price;//现价
        param.stock_code = codeInfo.stock_code;//证券代码
        param.entrust_amount = codeInfo.entrust_amount;//过户数量
        param.stock_account_crdt = userInfo.stock_account;//证券账号（信用）
        param.entrust_bs = "0";//买卖方向（76：买入--普转信，77：卖出--信转普）
        service_credit.dbin_link(param, function (data) {
            getStockMsgCallback(data, codeInfo)
        }, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }

    /**
     * 股票联动回调函数
     */
    function getStockMsgCallback(data, codeInfo) {
        if (data.error_no == "0") {
            var result = data.results[0];
            stockTransIn(codeInfo, result);
        } else {
            $.alert(data.error_info);
            return false;
        }
    }

    /**
     * 划转操作
     */
    function stockTransIn(codeInfo, result) {
        var param = {};
        var stockInfo = common.getTransferInfo() || {};//获取登录后保存的普通账户信息
        param.branch_no = stockInfo.branch_no || userInfo.branch_no;//分支机构（普通）
        param.fund_account = stockInfo.fund_account || userInfo.fund_account;//资金账号（普通）
        param.cust_code = stockInfo.cust_code || userInfo.cust_code;//客户编号
        param.password = stockInfo.password;//密码
        param.entrust_way = global.entrust_way; // 委托方式  在configuration配置
        param.password_crdt = userInfo.password; // 信用账户交易密码
        param.sessionid = "";//会话
        param.seat_no = result.seat_no;//席位编号（普通）
        param.stock_code = codeInfo.stock_code;//证券代码
        param.branch_no_crdt = userInfo.branch_no;//分支机构（信用）
        param.client_id_crdt = userInfo.cust_code;//客户编号（信用）
        param.fund_account_crdt = userInfo.fund_account;//资金账户（信用）
        param.entrust_amount = codeInfo.entrust_amount;//过户数量
        param.stock_account_crdt = result.stock_account_crdt || $.trim(codeInfo.stock_account) || userInfo.stock_account;//证券账号（信用）
        param.stock_account = result.stock_account || stockInfo.stock_account || userInfo.stock_account;//证券账号（普通）
        param.exchange_type = result.exchange_type;//交易类别（见数据字典）
        param.seat_no_crdt = result.seat_no_crdt;//席位编号（信用）
        param.cost_price = result.cost_price;//成本价格
        param.last_price = result.last_price;//现价
        param.entrust_bs = "76";//买卖方向（76：买入--普转信，77：卖出--信转普）
        service_credit.dbin_sub(param, transCallback, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
    }

    /**
     * 划入回调函数
     */
    function transCallback(data) {
        $.hidePreloader();
        if (data.error_no == "0") {
            clearBuyMsg();
            $.alert("委托成功，委托编号：" + data.results[0].entrust_no, function () {
                queryTradePosition();
            });
        } else {
            $.alert(data.error_info, function () {
                queryTradePosition();
            });
        }
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() - $(_pageId + ".guarantee_transfer_box").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                //埋点
                common.comStat(105267, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
                callsQuery(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        clearBuyMsg();
        $(_pageId + ".no_data_box").hide();
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".j-position-table table tbody").html("");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
        if (keyboardCredit) {
            keyboardCredit.keyDestroy();
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
