/**
 * 划转撤单
 */
define('trade/scripts/credit/transferred/transferCancellation.js', function (require, exports, module) {
    var _pageId = "#credit_transferred_transferCancellation ";
    var gconfig = $.config;
    var global = gconfig.global;
    var service_credit = require("service_credit");
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var common = require("common");
    var userInfo = null;
    var entrustNos = [];

    /**
     * 初始化
     */
    function init() {
        common.pageBuryingPoint("105296");
        userInfo = common.getCurUserInfo();
        common.bindStockEvent($(_pageId + '.tab_list ul li'), true);
        if (global.requestLocation == 0) {
            backgroundInterface();
        }

    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        queryTransCanCancel();//查询撤单信息
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                common.comStat(105297, 2, 103, true, {"i_group_name": "返回"});//埋点
                $.pageBack();
                e.preventDefault();
                e.stopPropagation();
            },300);
        });
    }

    /**
     * 查询撤单数据
     */
    function queryTransCanCancel() {
        entrustNos = [];
        $(_pageId + ".no_data_box").hide();
        $(_pageId + ".cancel_order").html("");
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var password = userInfo.password;
        var sessionid = userInfo.session_id;
        var stock_account = "";
        var stock_code = "";
        var entrust_bs = "";
        var exchange_type = "";
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "exchange_type": exchange_type,
            "stock_account": stock_account,
            "stock_code": stock_code,
            "entrust_bs": entrust_bs
        };
        service_credit.queryTransCanCancel(param, queryCancelCallBack,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () {
                    $(_pageId + ".no_data_box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /*
     * 查询撤单回调
     */
    function queryCancelCallBack(data) {
        $(_pageId + ".no_more_data").hide();
        entrustNos = [];
        if (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    var queryStockHtml = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        entrustNos.push(results[i].entrust_no);
                        queryStockHtml += creatCancelHtml(results[i]);
                    }
                    $(_pageId + ".cancel_order").html(queryStockHtml);
                    $(_pageId + ".no_more_data").show();

                    $.bindEvent($(_pageId + ".cancel_order .part"), function (e) {
                        common.comStat(105299, 2, 103, true, {"i_group_name": "撤单提交"});//埋点
                        var $this = $(this);
                        var entrust_no = $this.attr("data-id");
                        var tipStrArray = [];
                        tipStrArray.push([$this.find("div.title strong").text(), $this.find("div.title small").text()]);
                        tipStrArray.push(["买卖方向 ", $this.find("div.title span.tag").text()]);
                        // tipStrArray.push(["委托价格 ", $this.find("ul li").eq(0).find("p").text()]);
                        tipStrArray.push(["委托数量 ", $this.find("ul li").eq(0).find("p").text()]);
                        tipStrArray.push(["委托编号 ", entrust_no]);
                        var tipStr = "<div >";
                        tipStr += common.generatePrompt(tipStrArray);
                        tipStr += "</div>";
                        //埋点数据
                        var comStatParam = {
                            "i_entrust_bs": $this.attr("entrust_bs"), // 交易方向( 1,买入 2,卖出)
                            "i_stock_code": $this.find("div.title small").text(), // 股票代码
                            "i_stock_name": $this.find("div.title strong").text(), // 股票名称
                            "i_entrust_prop": "", // 委托属性
                            "i_exchange_type": $this.attr("data-type"), // 交易市场
                            "i_entrust_price": $this.attr("entrust_price"), // 选择后的价格
                            "i_entrust_amount": $this.attr("entrust_amount"), // 委托数量
                        }
                        common.iConfirm("确认撤单", tipStr, function () {
                            var exchange_type = $this.attr("data-type");
                            postCancelOrder(entrust_no, exchange_type); // 确认撤单
                            comStatParam.i_oper = "1";
                            common.comStat(105300, 2, 3, false, comStatParam);
                        }, function () {
                            comStatParam.i_oper = "2";
                            common.comStat(105300, 2, 3, false, comStatParam);
                        });
                        e.stopPropagation();
                    }, "tap");
                } else {
                    $(_pageId + ".no_data_box").show();
                }
            } else {
                $.alert(data.error_info);
            }
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 生成查询持仓函数
     * @param {Object} data
     */
    function creatCancelHtml(element) {
        var price_digit = 3;
        var css = "";
        var entrust_name = "";
        if (element.entrust_bs == "76" || element.entrust_bs == "0") {
            entrust_name = "担保品转入";
            css = "ared";
        } else if (element.entrust_bs == "77" || element.entrust_bs == "1") {
            entrust_name = "担保品转出";
            css = "agreen";
        }
        var eleHtml = "";
        eleHtml += "<div class=\"part\" data-id='" + element.entrust_no + "' data-type='" + element.exchange_type + "' entrust_price='" + element.entrust_price + "' entrust_amount='" + element.entrust_amount + "' entrust_bs='" + element.entrust_bs + "'>";
        eleHtml += "<div class=\"title\"><span class=\"tag " + css + "\">" + entrust_name + "</span><strong>" + element.stock_name + "</strong><small>" + element.stock_code + "</small>";
        eleHtml += "<span class=\"time\">" + element.entrust_time + "</span></div><ul>";
        eleHtml += "<li><span>委托数量:</span><p>" + element.entrust_amount + "</p></li>";
        eleHtml += "<li><span>委托状态:</span><p>" + element.entrust_state_name + "</p></li>";
        eleHtml += "</ul></div>";
        return eleHtml;
    }

    /**
     * 委托撤单
     * @param $currItem 当前条目
     */
    function postCancelOrder(entrust_no, exchange_type) {
        var batch_flag = "0";
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
            "batch_flag": batch_flag,
            "exchange_type": exchange_type
        };
        service_credit.credit_cancel(param, CancelCallBack);
    }

    function CancelCallBack(data) {
        if (data.error_no == "0") {
            $.alert(data.error_info, function () {
                queryTransCanCancel();
            });
        } else {
            $.alert(data.error_info);
        }
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                //埋点
                common.comStat(105298, 2, 102, true, {"i_direct": "下拉", "i_type": "1"});
                queryTransCanCancel(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }


    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        entrustNos = [];
        $(_pageId + ".no_data_box").hide();
        $(_pageId + ".no_more_data").hide();
        $(_pageId + ".cancel_order").html("");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
    };
    module.exports = base;
});