/**
 * 转股回售
 */
define('trade/scripts/debtzg/converHS.js', function (require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#debtzg_converHS ";
    var service_debt = require("service_debt");
    var service_stock = require("service_stock");
    var service_native_sync = require("service_native_sync");
    var keyboard = require("keyboard");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var userInfo = null;
    require("validatorUtils");
    /**
     * 全局定时任务setId
     */
    var globalSetId = undefined;
    var validata = $.validatorUtils;
    var stockInfo = null;
    // 0:转股、1：回售
    var index = 0;
    var paramInfo = {
        "query_type": ["2", "1"], //  证券类型 （A4配售，Z9回售，Z8转股）
        "entrust_bs": ["11", "12"], //  委托标志（见数据字典) 11转股，12回售，14配售
        "msg": ["转股", "回售"]
    }
    var moduleType = "ZG";
    /**
     * 页面dom元素集合
     */
    var jDom = {
        /**
         * 债券代码Dom
         */
        bondCodeDom: $(_pageId + "#bondCode"),
        /**
         * 回售代码Dom
         */
        resaleCodeDom: $(_pageId + "#resaleCode"),
        /**
         * tab切换Dom
         */
        tabSwitchUrlDom: $(_pageId + ".tab_nav ul"),
        /**
         * tab切换显示隐藏的Dom元素
         */
        tabDomContainer: $(_pageId + '.lst_container'),
        /**
         * 债券列表Dom元素
         */
        bondList: $(_pageId + "#bondList"),
        /**
         * 回售列表Dom元素
         */
        resaleList: $(_pageId + "#resaleList"),
        /**
         * 股东账号容器Dom
         */
        stockAccountList: $(_pageId + ".stockAccountList"),
        /**
         * 股东账户列表Dom
         */
        selectStockAccount: $(_pageId + ".select_stockAccount"),
        /**
         * 转股数量Dom
         */
        stockNumDom: $(_pageId + "#stockNum"),
        /**
         * 回售数量Dom
         */
        resaleNumDom: $(_pageId + "#resaleNum"),
        /**
         * 正股名称Dom
         */
        stockNameDom: $(_pageId + ".stockName"),
        /**
         * 转股价格Dom
         */
        stockPriceDom: $(_pageId + '.stockPrice'),
        /**
         * 提交按钮Dom
         */
        submitBtnDom: $(_pageId + ".main .converHS_submit")
    }
    /**
     * 初始化
     */
    function init() {
        if (jDom.tabSwitchUrlDom.find('li.active').index() == 0) {
            common.pageBuryingPoint("100460");
        } else {
            common.pageBuryingPoint("100475");
        }
        if (keyboard) {
            keyboard.keyInit();
        }
        // 左上角返回按钮事件绑定
        jumpPageEvent();
        userInfo = common.getCurUserInfo();
        // 权限信息查询
        commonFunc.setJurisdiction(userInfo);
        if (global.requestLocation == 0) {
            setAccountList();
        }
        interValHandle();
    }

    function load() {
        bindPageEvent();
        var mainHeight = common.setMainHeight(_pageId, false);
        if (global.requestLocation == 1) {
            setAccountList();
        }
        interValHandle();
    }
    /**
     * 清除全局interValHandle定时任务
     */
    function closeinterValHandle() {
        clearInterval(globalSetId);
        globalSetId = undefined;
    }

    /**
     * 全局定时处理任务
     */
    function interValHandle() {
        if (globalSetId != undefined) {
            closeinterValHandle();
        }
        globalSetId = setInterval(function () {
            // 转股
            if (index == 0) {
                /**
                 * 处理按钮可用与不可用的状态START
                 */
                {
                    var bondCode = jDom.bondCodeDom.val();
                    var stock_account = $(jDom.stockAccountList[0]).find('p').attr("type");
                    var stockName = jDom.stockNameDom.html();
                    var stockPrice = jDom.stockPriceDom.html();
                    var stockNum = jDom.stockNumDom.val();
                    // 可以点击
                    if (bondCode && stock_account) {
                        jDom.submitBtnDom.addClass('enable');
                    } else {
                        // 不可以带点击
                        jDom.submitBtnDom.removeClass('enable');
                    }
                }
                {
                    // 是否在焦点
                    var isFoucs = jDom.bondCodeDom.parent().find('.t1.jsKey.active').length > 0;
                    var sCode = jDom.bondCodeDom.parent().find('#bondCode').quzhi();
                    var arrCode = stockInfo?stockInfo.stock_code:'';
                    // 当前再焦点
                    if (isFoucs) {
                        // 当前显示的值
                        if (arrCode.length > 1) {
                            jDom.bondCodeDom.parent().find('#bondCode').quzhi(arrCode);
                        }
                    } else {
                        var stockName = jDom.bondCodeDom.parent().find('#bondCode').attr('stockname');
                        // 当前不在焦点
                        if (arrCode.length < 2 && stockName) {
                            jDom.bondCodeDom.parent().find('#bondCode').quzhi(stockName + ' ' + arrCode[0]);
                        }
                    }
                }
            } else { // 回售
                /**
                 * 处理按钮可用与不可用的状态START
                 */
                {
                    var resaleCode = jDom.resaleCodeDom.val();
                    var stock_account = $(jDom.stockAccountList[1]).find('p').attr("type");
                    var resaleNum = jDom.resaleNumDom.val();
                    // 可以点击
                    if (resaleCode && stock_account && +resaleNum) {
                        jDom.submitBtnDom.addClass('enable');
                    } else {
                        // 不可以带点击
                        jDom.submitBtnDom.removeClass('enable');
                    }
                }
                {
                    // 是否在焦点
                    var isFoucs = jDom.resaleCodeDom.parent().find('.t1.jsKey.active').length > 0;
                    var sCode = jDom.resaleCodeDom.parent().find('#resaleCode').quzhi();
                    var arrCode = stockInfo?stockInfo.stock_code:'';
                    // 当前再焦点
                    if (isFoucs) {
                        // 当前显示的值
                        if (arrCode.length > 1) {
                            jDom.resaleCodeDom.parent().find('#resaleCode').quzhi(arrCode);
                        }
                    } else {
                        var stockName = jDom.resaleCodeDom.parent().find('#resaleCode').attr('stockname');
                        // 当前不在焦点
                        if (arrCode.length < 2 && stockName) {
                            jDom.resaleCodeDom.parent().find('#resaleCode').quzhi(stockName + ' ' + arrCode[0]);
                        }
                    }
                }
            }

        }, 100)
    }
    /**
     * 跳转页面事件
     * $(this).unbind();
     * this.click = null;
     */
    function jumpPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
                var param = $.getPageParam().param;
                var _index = jDom.tabSwitchUrlDom.find('li.active').index();
                var objectId = (_index == 0 ? 100463 : 100477);
                common.comStat(objectId, 2, 103, true, { "i_group_name": "返回" });
                if (param && param.app_third && param.app_third === 'mall') {
                    $.callMessage({ "moduleName": "push", "funcNo": "50114", "params": {} });
                } else {
                    $.pageBack("account/index", "left");
                }
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });
    }

    /**
     * 查询正股信息
     */
    function queryPositiveStockInfo(bond_code, exchange_type) {
        service_native_sync.native5011520({
            codeMarket: bond_code + "." + exchange_type,
        }, function (oData) {
            console.log(oData);
            var results = oData || {};
            // 正股名称
            jDom.stockNameDom.html(results.name || '--');
            jDom.stockNameDom.css('color', results.name ? '#333' : '#999');
            // 转股价格
            jDom.stockPriceDom.html(results.transferPrice || '--');
            jDom.stockPriceDom.css('color', results.transferPrice ? '#333' : '#999');
        });
    }
    /**
     * 股票联动         
     * */
    function queryMaxAmount(stockCode, exchange, stock_price, account) {
        $.hidePreloader();
        var entrust_bs = paramInfo.entrust_bs[index];
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no; //分支机构
        var fund_account = userInfo.fund_account; //资产账户
        var cust_code = userInfo.cust_code; //客户代码
        var session_id = userInfo.session_id;
        var stock_code = stockCode;
        var entrust_price = stock_price;
        var stock_account = account;
        var exchange_type = exchange;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "session_id": session_id,
            "entrust_bs": entrust_bs,
            "stock_code": stock_code,
            "entrust_price": entrust_price,
            "stock_account": stock_account,
            "newstock_flag": "",
            "exchange_type": exchange_type
        };
        service_stock.queryStockMaxBuy(param, function (data) {
            $.hidePreloader();
            queryLinkageMaxAmountCallBack(data);
        }, { "isLastReq": true, "isShowWait": true });

    }
    // 输入股票代码
    function queryLinkageMaxAmountCallBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            $(_pageId + ".label_stocktype").remove();
            if (results.length == 1) {
                stockInfo = results[0];
                stockInfo.last_price = results[0].price;
                if($.isValue(stockInfo.stock_name_long)) stockInfo.stock_name = stockInfo.stock_name_long;
                if (index == 0) {
                    var market = commonHq.getSZTHqMarket(stockInfo.exchange_type,stockInfo.stock_type);
                    // 转股
                    queryPositiveStockInfo(stockInfo.stock_code, market);
                    // 债券名称和代码
                    jDom.bondCodeDom.parent().find('#bondCode').quzhi(stockInfo.stock_name + ' ' + stockInfo.stock_code);
                    jDom.bondCodeDom.parent().find('#bondCode').attr('stockname', stockInfo.stock_name);
                    // 股东代码
                    $(jDom.stockAccountList[index]).find('p').attr("type", stockInfo.stock_account);
                    // 委托类型
                    $(jDom.stockAccountList[index]).find('p').attr("exchange", stockInfo.exchange_type);
                    $(jDom.stockAccountList[index]).find('p > em').css('color', '#333');
                    // 股东代码
                    $(jDom.stockAccountList[index]).find('p > em').html(stockInfo.exchange_type_name + " " + stockInfo.stock_account);
                    var stocktypehtml = getStockTypeName(stockInfo.stock_type,stockInfo.convertible_bonds,stockInfo.exchange_type);
                    if(stocktypehtml){
                        $(_pageId + ".code .jsKey").eq(0).prepend("<span class='label_stocktype'>" + stocktypehtml + "</span>");
                    }
                } else {
                    // 回售
                    jDom.resaleCodeDom.parent().find('#resaleCode').quzhi(stockInfo.stock_name + ' ' + stockInfo.stock_code);
                    jDom.resaleCodeDom.parent().find('#resaleCode').attr('stockname', stockInfo.stock_name);
                    // 股东代码
                    $(jDom.stockAccountList[index]).find('p').attr("type", stockInfo.stock_account);
                    // 委托类型
                    $(jDom.stockAccountList[index]).find('p').attr("exchange", stockInfo.exchange_type);
                    $(jDom.stockAccountList[index]).find('p > em').css('color', '#333');
                    // 股东代码
                    $(jDom.stockAccountList[index]).find('p > em').html(stockInfo.exchange_type_name + " " + stockInfo.stock_account);
                    var stocktypehtml = getStockTypeName(stockInfo.stock_type,stockInfo.convertible_bonds,stockInfo.exchange_type);
                    if(stocktypehtml){
                        $(_pageId + ".code .jsKey").eq(1).prepend("<span class='label_stocktype'>" + stocktypehtml + "</span>");
                    }
                }
                // $(_pageId + "#stockAmount").quzhi(results[0].stock_max_amount);
                // exchangePD();
                commonFunc.popupRightsConfirm(results[0], { checkKzz: true });
            } else if (results.length > 1) {
                var dataInfo = {};
                $.hidePreloader();
                var selectHeight = 0.44 * results.length;
                if (results.length >= 5) {
                    selectHeight = 5 * 0.44;
                }
                var ulDom;
                if (index == 1) {
                    // 回售
                    ulDom = jDom.resaleList.find('ul');
                } else {
                    // 转股
                    ulDom = jDom.bondList.find('ul');
                }
                ulDom.css('height', selectHeight + 'rem');
                var listHtml = '';
                for (var i = 0; i < results.length; i++) {
                    if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                    var stocktypeHtml = getStockTypeName(results[i].stock_type,results[i].convertible_bonds,results[i].exchange_type);
                    if(stocktypeHtml){
                        stocktypeHtml = "<span class='label_stocktype'>" + stocktypeHtml + "</span>"
                    }
                    listHtml += "<li exchange_type='" + results[i].exchange_type + "' stock_account='" + results[i].stock_account + "' price='" + results[i].price + "' stockName='" + results[i].stock_name + "'>";
                    listHtml += "<a href='javascript:void(0);' style='padding-left:0.20rem;'>";
                    listHtml += stocktypeHtml;
                    listHtml += "<strong style='font-size:0.15rem'>" + results[i].stock_code + "</strong>";
                    listHtml += "<em style='position: relative;float: right;right: 0.1rem;top: 0rem;'>" + results[i].stock_name + "</em></a></li>";
                    dataInfo[results[i].stock_code + "" + results[i].exchange_type] = results[i];
                };
                ulDom.html(listHtml);
                ulDom.slideDown(100);
                var liDom;
                if (index == 1) {
                    // 回售
                    liDom = jDom.resaleList.find('ul li');
                } else {
                    // 转股
                    liDom = jDom.bondList.find('ul li');
                }
                $.bindEvent(liDom, function (e) {
                    var stockCode = $(this).find("strong").text();
                    var exchange_type = $(this).attr("exchange_type");
                    var stock_account = $(this).attr("stock_account");
                    var price = $(this).attr("price");
                    stockInfo = dataInfo[stockCode + "" + exchange_type];
                    stockInfo.last_price = stockInfo.price;
                    ulDom.slideToggle(100);
                    dataInfo = {};
                    queryMaxAmount(stockCode, exchange_type, price, stock_account)
                    e.stopPropagation();
                }, 'tap');
            }
        } else {
            $.alert(data.error_info);
        }
    }
    function getStockTypeName(stock_type,convertible_bonds,exchange_type){
        var stocktypeHtml = "";
        if(convertible_bonds === "1" && stock_type === "22"){
            stocktypeHtml = "京债";
        }else if(convertible_bonds === "1" && stock_type === "24"){
            stocktypeHtml = "股转";
        }else if(convertible_bonds === "1" && exchange_type === "0"){
            stocktypeHtml = "深债";
        }else if(convertible_bonds === "1" && exchange_type === "2"){
            stocktypeHtml = "沪债";
        }
        return stocktypeHtml;
    }
    /**
     * 下单验证
     * */
    function vailSubmitOrder() {
        // 按钮不可点击
        if (!jDom.submitBtnDom.hasClass('enable')) {
            return
        }
        var stockNum;
        var stock_account;
        // 转股
        if (index == 0) {
            if (!jDom.bondCodeDom.val()) {
                $.alert("请输入" + paramInfo.msg[index] + "代码");
                return false;
            }
            //验证基金份额输入是否正确
            stockNum = jDom.stockNumDom.val();
            if ($.trim(stockNum).length <= 0) {
                $.alert("请输入" + paramInfo.msg[index] + "数量");
                return false;
            }
            stock_account = $(jDom.stockAccountList[index]).find('p').attr("type");
            if (!stock_account) {
                $.alert("请选择股东账号");
                return false;
            }
        } else {// 回售
            if (!jDom.resaleCodeDom.val()) {
                $.alert("请输入" + paramInfo.msg[index] + "代码");
                return false;
            }
            //验证基金份额输入是否正确
            stockNum = jDom.resaleNumDom.val();
            if ($.trim(stockNum).length <= 0) {
                $.alert("请输入" + paramInfo.msg[index] + "数量");
                return false;
            }
            stock_account = $(jDom.stockAccountList[index]).find('p').attr("type");
            if (!stock_account) {
                $.alert("请选择股东账号");
                return false;
            }
        }

        var tipStrArray = [];
        tipStrArray.push([paramInfo.msg[index] + "名称", "<span style='font-size:" + $.getTransformScaleFontSize(stockInfo.stock_name, 16, $(window).width() * 0.48) + "px;'>" + stockInfo.stock_name +  "</span>"]);
        tipStrArray.push([paramInfo.msg[index] + "代码 ", stockInfo.stock_code]);
        tipStrArray.push([paramInfo.msg[index] + "数量 ", stockNum]);
        var tipStr = "<div >";
        tipStr += common.generatePrompt(tipStrArray);
        tipStr += "</div>";

        var stockParam = {
            "i_entrust_bs": "", //买卖方向
            "i_entrust_prop": "", //委托属性名称
            "i_exchange_type": $(jDom.stockAccountList[index]).find('p').attr("exchange") || stockInfo.exchange_type, //交易市场名称
            "i_stock_code": stockInfo.stock_code, //股票代码
            "i_stock_name": jDom.stockNameDom.html(), //股票名称
            "i_entrust_price": stockInfo.price, //委托价格
            "i_entrust_amount": stockNum, //委托数量
        }
        var _index = jDom.tabSwitchUrlDom.find('li.active').index();
        var objectId = (_index == 0 ? 100468 : 100482);

        common.iConfirm(paramInfo.msg[index] + "确认", tipStr, function success() {
            var cust_code = userInfo.cust_code; //客户代码
            var fund_account = userInfo.fund_account; //资产账户
            var branch_no = userInfo.branch_no; //分支机构
            var session_id = userInfo.session_id;
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var exchange_type = $(jDom.stockAccountList[index]).find('p').attr("exchange");
            var param = {
                "stock_account": stock_account || stockInfo.stock_account,
                "batch_no": "",
                "branch_no": branch_no,
                "cust_code": cust_code,
                "entrust_price": stockInfo.last_price,
                "entrust_amount": stockNum,
                "exchange_type": exchange_type || stockInfo.exchange_type,
                "entrust_way": entrust_way,
                "fund_account": fund_account,
                "session_id": session_id,
                "password": userInfo.password,
                "stock_code": stockInfo.stock_code,
                "entrust_bs": paramInfo.entrust_bs[index]
            };
            service_debt.newDebtDistribution(param, function (data) {
                $.hidePreloader();
                getBuyCallBack(data, param);
            }, {
                "isShowOverLay": false,
                "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                },
                "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            $.showPreloaders("请等待...");
            //埋点
            stockParam.i_oper = "1"; //动作（1确定 2取消）
            common.comStat(objectId, 2, 3, false, stockParam);
        }, function fail() {
            //埋点
            stockParam.i_oper = "2"; //动作（1确定 2取消）
            common.comStat(objectId, 2, 3, false, stockParam);
        });
    }
    /**
     * 申购回调
     * @param {*} data 
     * @param {*} param 
     */
    function getBuyCallBack(data, param) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results) {
                $.alert("委托已提交，流水号" + data.results[0].entrust_no);
                $(_pageId + "#stockCode").quzhi(""); //代码
                clearBuyMsg();
            }
        } else {
            jDom.stockNumDom.parent().find('#stockNum').quzhi("");
            jDom.resaleNumDom.parent().find('#resaleNum').quzhi("");
            $.alert(data.error_info);
        }
    }

    /**
     * 关闭页面所有浮窗
     */
    function closeFloatDom() {
        setTimeout(function() {
            var sUlDom = jDom.selectStockAccount.find('ul');
            var bUlDom = jDom.bondList.find('ul');
            var rUlDom = jDom.resaleList.find('ul');
            $(sUlDom[0]).slideUp(100);
            $(sUlDom[1]).slideUp(100);
            bUlDom.slideUp(100);
            rUlDom.slideUp(100);
        }, 120);
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 债券代码input事件监听
        $.bindEvent(jDom.bondCodeDom, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var stockCode = jDom.bondCodeDom.quzhi();
            var vai1 = /^[0-9]+$/;
            if (!vai1.test(stockCode)) {
                jDom.bondCodeDom.quzhi(stockCode.replace(/[^0-9]/g, ""));
            }
            stockCode = jDom.bondCodeDom.quzhi();
            if (stockCode.length == 6) {
                queryMaxAmount(stockCode);
                //埋点
                var _index = jDom.tabSwitchUrlDom.find('li.active').index();
                var objectId = (_index == 0 ? 100464 : 100478);
                common.comStat(objectId, 2, 104, true, { "i_change_name": "证券代码输入", "i_change_to": stockCode });
            } else {
                clearBuyMsg(1);
            }
        }, "input");
        // 回售代码input事件监听
        $.bindEvent(jDom.resaleCodeDom, function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var stockCode = jDom.resaleCodeDom.quzhi();
            var vai1 = /^[0-9]+$/;
            if (!vai1.test(stockCode)) {
                jDom.resaleCodeDom.quzhi(stockCode.replace(/[^0-9]/g, ""));
            }
            stockCode = jDom.resaleCodeDom.quzhi();
            if (stockCode.length == 6) {
                queryMaxAmount(stockCode);
                //埋点
                var _index = jDom.tabSwitchUrlDom.find('li.active').index();
                var objectId = (_index == 0 ? 100464 : 100478);
                common.comStat(objectId, 2, 104, true, { "i_change_name": "证券代码输入", "i_change_to": stockCode });
            } else {
                clearBuyMsg(1);
            }
        }, "input");
        // 债券代码输入tab事件
        $.bindEvent(jDom.bondCodeDom.parent(), function (e) {
            closeFloatDom();
            e.stopPropagation();
        }, 'tap');
        // 回售代码输入tab事件
        $.bindEvent(jDom.resaleCodeDom.parent(), function (e) {
            closeFloatDom();
            e.stopPropagation();
        }, 'tap');
        // 转股/回售 TAB切换事件
        $.bindEvent(jDom.tabSwitchUrlDom.find('li'), function (e) {
            closeFloatDom();
            jDom.tabDomContainer.hide();
            // 重写框架
            // $.pageRefresh();
            clearBuyMsg();
            index = $(this).index();
            $(this).addClass("active").siblings().removeClass("active");
            $(jDom.tabDomContainer[index]).show();
            // 清除请求对象
            $.clearRequest();
            bindPageEvent();
            // 页面埋点
            common.pageBuryingPoint();
            if (index == "0") {
                moduleType = "ZG";
                common.pageBuryingPoint("100460");
            } else if (index == "1") {
                moduleType = "HS";
                common.pageBuryingPoint("100475");
            }
            //埋点
            var objectId = $(this).find("a").attr("objectId");
            var actionId = $(this).find("a").attr("actionId");
            var name = $(this).find("a").attr("name");
            // 埋点
            common.comStat(objectId, 2, actionId, true, { "i_group_name": name });
            e.stopPropagation(); // 阻止冒泡
        }, "tap");

        // 转股数量
        $.bindEvent(jDom.stockNumDom.parent(), function (e) {
            closeFloatDom();
            e.stopPropagation();
        }, "tap");
        // 回售数量
        $.bindEvent(jDom.resaleNumDom.parent(), function (e) {
            closeFloatDom();
            e.stopPropagation();
        }, "tap");
        // 转股数量输入
        $.bindEvent(jDom.stockNumDom, function (e) {
            var valStr = e.target.value;
            // 小数点出现次数
            var dotCount = valStr.match(/\./g);
            dotCount = dotCount ? dotCount.length : 0;
            // 去除首位是0又重复输入0的情况
            if(dotCount == 0 && valStr.length > 1 && valStr[0] =='0'){
                e.target.value = valStr[1];
            }
            else if(valStr == '.') {
                // 排除首位输入.的情况
                e.target.value = '';
            }
            else if(dotCount > 1){
                // 屏蔽多个小数点的情况
                e.target.value = valStr.substring(0,valStr.length - 1);
            }
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            e.stopPropagation();
        }, "input");
        // 回售数量输入
        $.bindEvent(jDom.resaleNumDom, function (e) {
            var valStr = e.target.value;
            // 小数点出现次数
            var dotCount = valStr.match(/\./g);
            dotCount = dotCount ? dotCount.length : 0;
            // 去除首位是0又重复输入0的情况
            if(dotCount == 0 && valStr.length > 1 && valStr[0] =='0'){
                e.target.value = valStr[1];
            }
            else if(valStr == '.') {
                // 排除首位输入.的情况
                e.target.value = '';
            }
            else if(dotCount > 1){
                // 屏蔽多个小数点的情况
                e.target.value = valStr.substring(0,valStr.length - 1);
            }
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            e.stopPropagation();
        }, "input");

        // 转股数量失去光标
        $.bindEvent(jDom.stockNumDom, function (e) {
            //埋点
            var _index = jDom.tabSwitchUrlDom.find('li.active').index();
            var objectId = (_index == 0 ? 100466 : 100480);
            if (stockInfo && Object.keys(stockInfo).length > 0) {
                var stockCode = stockInfo.stock_code;
                if (stockCode) {
                    var stockParam = {
                        "i_entrust_bs": "", //买卖方向
                        "i_entrust_prop": "", //委托属性名称
                        "i_exchange_type": stockInfo.exchange_type, //交易市场名称
                        "i_stock_code": stockCode, //股票代码
                        "i_stock_name": stockInfo.stock_name, //股票名称
                        "i_adjust_type": 5, //调整方式（1,加 2,减 3快捷键 4,直接输入）
                        "i_max_cnt": "", //最大数量
                        "i_price": stockInfo.last_price, // 选择后的价格
                        "i_target_cnt": $(this).val(), // 调整之后的数量
                        "i_fast_btn": "", // 快捷键（全仓，1/2，1/4 ....（可留空））
                    }
                    common.comStat(objectId, 2, 2, false, stockParam);
                }
            }
            e.stopPropagation();
        }, "blur");

        // 回售数量失去光标
        $.bindEvent(jDom.resaleNumDom, function (e) {
            //埋点
            var _index = jDom.tabSwitchUrlDom.find('li.active').index();
            var objectId = (_index == 0 ? 100466 : 100480);
            if (stockInfo && Object.keys(stockInfo).length > 0) {
                var stockCode = stockInfo.stock_code;
                if (stockCode) {
                    var stockParam = {
                        "i_entrust_bs": "", //买卖方向
                        "i_entrust_prop": "", //委托属性名称
                        "i_exchange_type": stockInfo.exchange_type, //交易市场名称
                        "i_stock_code": stockCode, //股票代码
                        "i_stock_name": stockInfo.stock_name, //股票名称
                        "i_adjust_type": 5, //调整方式（1,加 2,减 3快捷键 4,直接输入）
                        "i_max_cnt": "", //最大数量
                        "i_price": stockInfo.last_price, // 选择后的价格
                        "i_target_cnt": $(this).val(), // 调整之后的数量
                        "i_fast_btn": "", // 快捷键（全仓，1/2，1/4 ....（可留空））
                    }
                    common.comStat(objectId, 2, 2, false, stockParam);
                }
            }
            e.stopPropagation();
        }, "blur");

        //认购---提交按钮
        $.bindEvent($(_pageId + ".main .converHS_submit"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var _index = jDom.tabSwitchUrlDom.find('li.active').index();
            var objectId = (_index == 0 ? 100467 : 100481);
            common.comStat(objectId, 2, 103, true, { "i_group_name": "提交" });
            // 数据校验
            vailSubmitOrder();
            e.stopPropagation();
        });

        //更多操作 按钮
        $.bindEvent($(_pageId + ".hs_more_btn"), function (e) {
            $.pageInit("debtzg/converHS","stock/stockQuery");
        }, "tap");
    }

    /*
     * 查询股东账号
     */
    function setAccountList() {
        commonFunc.getStockAccount(["0", "2", "9", "A"], userInfo, function (data) {
            if (data && data.length > 0) {
                var div = "";
                var selectHeight = 0.44 * data.length;
                if (data.length >= 5) {
                    selectHeight = 5 * 0.44;
                }
                for (var i = 0; i < data.length; i++) {
                    div += '<li exchangeName="' + data[i].exchange_type_name + '" exchange="' + data[i].exchange_type + '" type="' + data[i].stock_account + '"><a href="javascript:void(0);" style="padding-left:0.20rem;"><strong style="font-size:0.15rem;">' + data[i].stock_account + '</strong>' + data[i].exchange_type_name + '</a></li>';
                }
                var ulDom = jDom.selectStockAccount.find('ul');
                jDom.selectStockAccount.find('ul').css("height",selectHeight + "rem");
                ulDom.html(div);
                var liDom = ulDom.find('li');
                $.bindEvent(jDom.stockAccountList, function (e) {
                    $(_pageId + " .five_box ul li").removeClass("active");
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    if (liDom && liDom.length > 0) {
                        $(ulDom[index]).slideToggle(100);
                    }
                    e.stopPropagation();
                });
                $.bindEvent(liDom, function (e) {
                    $(_pageId + " .five_box ul li").removeClass("active");
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    var type = $(this).attr("type");
                    var exchange = $(this).attr("exchange");
                    var exchangeName = $(this).attr("exchangeName");
                    var pDom = $(jDom.stockAccountList[index]).find('p');
                    pDom.attr("type", type);
                    pDom.attr("exchange", exchange);
                    var emDom = pDom.find('em');
                    emDom.css('color', '#333');
                    emDom.html(exchangeName + " " + type);
                    ulDom.hide();

                    var _index = jDom.tabSwitchUrlDom.find('li.active').index();
                    var objectId = (_index == 0 ? 100465 : 100479);
                    common.comStat(objectId, 2, 104, true, { "i_change_name": "股东账号列表", "i_change_to": type });
                    e.stopPropagation();
                });
            } else {
                $(jDom.stockAccountList[index]).find('p > em').html("没有对应的股东账号");
                jDom.selectStockAccount.find('ul').hide();
            }
        });
    }

    /**
     * 重置页面数据  
     */
    function clearBuyMsg(type) {
        jDom.bondList.find('ul').slideUp(100);
        jDom.stockNameDom.quzhi("--");
        jDom.stockNameDom.css('color','#999');
        if (type !== 1) {
            jDom.bondCodeDom.parent().find('#bondCode').quzhi('');
            jDom.resaleCodeDom.parent().find('#resaleCode').quzhi('');
        }
        jDom.resaleCodeDom.parent().find('#resaleCode').attr('stockname', '');
        jDom.bondCodeDom.parent().find('#bondCode').attr('stockname', '');
        jDom.stockNumDom.parent().find('#stockNum').quzhi("");
        jDom.resaleNumDom.parent().find('#resaleNum').quzhi("");
        jDom.stockAccountList.find('em').html('请选择股东账号')
        jDom.stockAccountList.find('em').css('color', '#999');
        jDom.stockAccountList.find('p').attr("type", "");
        jDom.stockAccountList.find('p').attr("exchange", "");
        jDom.selectStockAccount.find('ul').hide();
        $(_pageId + ".label_stocktype").remove();
        jDom.stockPriceDom.html('--');
        jDom.stockPriceDom.css('color','#999');
        stockInfo = null;
    }

    /**
     * 销毁
     */
    function destroy() {
        closeinterValHandle();
        jDom.tabSwitchUrlDom.find('li').removeClass("active");
        jDom.tabSwitchUrlDom.find('li:eq(0)').addClass("active");
        index = 0;
        jDom.tabDomContainer.hide();
        $(jDom.tabDomContainer[0]).show();
        // 页面埋点
        common.pageBuryingPoint();
        moduleType = "ZG";
        // 重置页面数据
        clearBuyMsg();
        if (keyboard) {
            keyboard.keyDestroy();
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
