/**
 * 沪市LOF交易-赎回
 */
define('trade/scripts/fund/SHLOF/redeem.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#fund_SHLOF_redeem ";
    var service_fund = require("service_fund");
    var userInfo= null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var listData = {};
	var fundInfo = {};
	var keyboard = require("keyboard");

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101424");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	
	function backgroundInterface(){
		jumpPageEvent();
		queryHoldingsQuery();//查询可赎回基金
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101425,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/grading/order","left");
			e.stopPropagation();
		});
		
		//股票代码输入框监听
		$.bindEvent($(_pageId+" #fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $(_pageId + " #fundCode").val();
			if(fundCode.length == 6){
				queryStockData(fundCode);
			}else{
				clearBuyMsg();
			}
			e.stopPropagation();
		},"input");
		
		$.bindEvent($(_pageId + "#fundSum"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var price = $(_pageId + "#fundSum").val();
			if(price && validata.isNumberFloat(price)){
				var cur_arr = (price+"").split(".");
				if(cur_arr.length == 2){
					if(cur_arr[1].length > 2){
						$(_pageId + "#fundSum").quzhi(cur_arr[0]+"."+cur_arr[1].substring(0,2))
					}
				}
			}
		},"input");
	}
	
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid="";
		var fund_company ="";
		var fund_code ="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"filt_flag":"1"
		};
		service_fund.queryStockData(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		listData = {};
		fundInfo = {};
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1 multi_list'>";
					listDiv += "<div class='top'><p style='width:25%;font-size: 0.14rem;'>证券代码</p><p style='width:25%;font-size: 0.14rem;'>证券名称</p><p style='width:25%;font-size: 0.14rem;'>证券数量</p><p style='width:25%;font-size: 0.14rem;'>可卖数量</p></div>";
					listDiv += "<ul>";
//					listDiv += "<li ><a href=\"javascript:void(0);\" style='display:table;width:100%'><em style='width:25%;display:table-cell'>证券代码</em><em style='width:25%;display:table-cell'>证券名称</em><em style='width:25%;display:table-cell'>证券数量</em><em style='width:25%;display:table-cell'>可卖数量</em></a></li>"
					for(var i = 0; i < results.length; i++) {
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						listData[results[i].stock_code + ""] = results[i];
						listDiv += "<li id=" + results[i].stock_code + "><a href=\"javascript:void(0);\"style='display:table;width:100%'><em style=width:25%;display:table-cell>" + results[i].stock_code + "</em><span style='width:25%;display:table-cell;zoom:"+ $.getTransformScale(results[i].stock_name, 16, $(window).width() * 0.23)+";'>" + results[i].stock_name + "</span><span style='width:25%;display:table-cell'>" + results[i].cost_amount + "</span><span style='width:25%;display:table-cell'>" + results[i].enable_amount + "</span></a></li>";
					}
					listDiv += "</ul></div>";
//					var listDiv = "<div class='bank_list center'><ul>";
//					for (var i=0;i<results.length;i++){
//						listData[results[i].stock_code+""] = results[i];
//						listDiv += "<li id='"+results[i].stock_code+"'><a href=\"javascript:void(0);\">"+results[i].stock_name+" <small>"+results[i].stock_code+"</small></a></li>";
//					}
//					listDiv += "</ul></div>";
					common.addChoiceList($(_pageId + ".select_fund"), "选择赎回基金代码",listDiv,function(data, div){
						var id = data.attr("id");
						fundInfo = listData[id];
						$(_pageId + "#fundCode").quzhi(fundInfo.stock_code);
						$(_pageId + "#fundName").val(fundInfo.stock_name);
						$(_pageId + "#fundNav").val(Number(fundInfo.last_price).toFixed(4) || 0);
						$(_pageId +".fund_form2 .limit em").text(Number(fundInfo.enable_amount));//持有份额
						$(_pageId + "#purchaseLimit").val(Number(fundInfo.enable_amount));
						$(_pageId + "#fundSum").quzhi("");
					},null,null,keyboard);
					$(_pageId + ".select_fund").show();
				}
				else{
					$(_pageId + ".select_fund").hide();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	//下单提交基金
	function submitOrderFund(){
		if(common.size(listData) == 0){
			$.alert("没有可赎回的基金");
			return false;
		}
		if(!common.isValue(fundInfo)){
			$.alert("请选可赎回的基金");
			return false;
		}
		var numMax =$(_pageId+".fund_form2 .limit em").text();
		var fundSum = $(_pageId+"#fundSum").val();
		if(validata.isEmpty(numMax)|| numMax=="0" || numMax=="--"){
			$.alert("赎回数量为0");
			return false;
		}
		if(validata.isEmpty(fundSum)){
			$.alert("赎回数量不能为空");
			return false;
		}
		// else if(Number(fundSum)>Number(numMax)){
		// 	$.alert("赎回数量不能大于可赎份额");
		// 	return false;
		// }
		var tipStrArray = [];
		tipStrArray.push(["交易方向 ", "赎回"]);
		tipStrArray.push(["基金名称", "<span style='font-size:" + $.getTransformScaleFontSize(fundInfo.stock_name, 16, $(window).width() * 0.48) + "px;'>" + fundInfo.stock_name +  "</span>"]);
		tipStrArray.push(["基金代码 ", fundInfo.stock_code]);
		tipStrArray.push(["赎回数量 ", fundSum]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		//埋点数据
		var comStatParam={
			"i_entrust_bs":"2", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":fundInfo.stock_code, // 股票代码
			"i_stock_name":fundInfo.stock_name, // 股票名称
			"i_entrust_prop":"LFR", // 委托属性
			"i_exchange_type":fundInfo.exchange_type, // 交易市场
			"i_entrust_price":$(_pageId+"#fundNav").val() || "1", // 选择后的价格
			"i_entrust_amount":fundSum, // 委托数量
		}
		common.iConfirm("下单确定",tipStr,function success(){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;      //分支机构
			var fund_account = userInfo.fund_account; //资金账号
			var cust_code = userInfo.cust_code;       //客户编号
			var sessionid = userInfo.session_id;      //会话号
			var fund_code = fundInfo.stock_code; //基金代码
			var amount = fundSum;      //赎回数量
	        var entrust_price = $(_pageId+"#fundNav").val() || "1"; //收费方式//巨额方式
			var param = {
					"entrust_way" : entrust_way,
					"branch_no" : branch_no,
					"fund_account" : fund_account,
					"cust_code" : cust_code,
					"sessionid" :sessionid,
					"fund_code":fund_code,
					"entrust_bs":"2",
					"exchange_type":fundInfo.exchange_type,
					"stock_account":fundInfo.stock_account,
					"entrust_amount":amount,
	                "entrust_price":entrust_price,
	                "entrust_prop":'LFR'
			};
			service_fund.redeemSHLOF(param,function(data){
				$.hidePreloader();
				if(data.error_no ==0){
					$.alert(("委托已经提交，委托编号："+data.results[0].entrust_no));
					queryHoldingsQuery();
					clearBuyMsg();
					$(_pageId + "#fundCode").quzhi("");
				}else{
					$.alert(data.error_info);
				}
			},{"isShowOverLay":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
        	common.comStat(101427,2,3,false,comStatParam);
			$.showPreloaders("请等待...");
		},function fail(){
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
        	common.comStat(101427,2,3,false,comStatParam);
		});
	}
	
	function queryStockData(stock_code){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		if(stock_code || fundInfo.stock_code){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代码
			var sessionid="";
			var exchange_type = fundInfo.exchange_type || "";
			var fund_code = fundInfo.stock_code || "";
			var stock_account = fundInfo.stock_account || "";
			if(stock_code){
				exchange_type = "";
				fund_code = stock_code;
				stock_account = "";
			}
			$(_pageId+"#fundSum").quzhi("");
			$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
			fundInfo = {};
			var param={
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"sessionid":sessionid,
					"exchange_type":exchange_type,
					"stock_code":fund_code,
					"stock_account":stock_account
			};
			service_fund.queryStockData(param,function(data){
				if (typeof(data) != undefined && typeof(data) != null) {
					if(data.error_no == 0){
						if(data.results && data.results[0]){
							if($.isValue(data.results[0].stock_name_long)) data.results[0].stock_name = data.results[0].stock_name_long;
							fundInfo = data.results[0];
							listData[""+data.results[0].stock_code] = data.results[0];
							$(_pageId + "#fundCode").quzhi(fundInfo.stock_code);
							$(_pageId + "#fundName").val(fundInfo.stock_name);
							$(_pageId + "#fundNav").val(Number(fundInfo.last_price).toFixed(4) || 0);
							$(_pageId +".fund_form2 .limit em").text(Number(fundInfo.enable_amount));//持有份额
							$(_pageId + "#purchaseLimit").val(Number(fundInfo.enable_amount));
							$(_pageId + "#fundSum").quzhi("");
						}
						else{
							$.alert("持仓中没有查询到数据");
						}
					}
				}
			},{"isShowWait":false,"isShowOverLay":false});
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//申购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//埋点
			common.comStat(101426,2,103,true,{"i_group_name":"沪市LOF赎回提交"});
			submitOrderFund();
			e.stopPropagation();
		});
		//全部
		$.bindEvent($(_pageId + ".fund_form2 .all .all_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var purchaseLimit = $(this).prev("input").val();
			$(_pageId + "#fundSum").quzhi(purchaseLimit);
			e.stopPropagation();
		});
	}
	
	function clearBuyMsg(){
		$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundNav").val("");
		$(_pageId + "#fundSum").quzhi("");
		$(_pageId+"#purchaseLimit").val("");
		fundInfo = {};
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		if(keyboard){
			keyboard.keyDestroy();
		}
//		$(_pageId+" .select_box p").text("请选择...");
		$(_pageId + "#fundCode").quzhi("");
		$(_pageId + " .select_fund").hide();
		listData = {};
		clearBuyMsg();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
