/**
 * 沪市LOF交易-认购
 */
define('trade/scripts/fund/SHLOF/subscribe.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var appropriate = require("appropriate");
    var _pageId = "#fund_SHLOF_subscribe ";
    var service_fund = require("service_fund");
    var commonFunc = require("commonFunc");
    var userInfo = null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
    var fundcode = null;
    var exchange_type = null;
	var keyboard = require("keyboard");

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101416");
		if(keyboard){
			keyboard.keyInit();
		}
		jumpPageEvent();
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	function backgroundInterface(){
		queryCapital();
		var stockCode = $.getPageParam("code");
        var param = $.getPageParam("param");
        // 接收外链传参
        fundcode = param && param.fundcode;
        exchange_type = param && param.exchange_type;
		if(stockCode){
			$(_pageId + " #fundCode").quzhi(stockCode);
			getFundList(stockCode);
		}else if(fundcode){
            $(_pageId + "#fundCode").quzhi(fundcode);//基金名称
            getFundList(fundcode,exchange_type || '');
        }
		//股票代码输入框监听
		$.bindEvent($(_pageId+" #fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $(_pageId + " #fundCode").val();
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearBuyMsg();
			}
			e.stopPropagation();
		},"input");
		
		$.bindEvent($(_pageId + "#fundSum"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var price = $(_pageId + "#fundSum").val();
			if(price && validata.isNumberFloat(price)){
				var cur_arr = (price+"").split(".");
				if(cur_arr.length == 2){
					if(cur_arr[1].length > 2){
						$(_pageId + "#fundSum").quzhi(cur_arr[0]+"."+cur_arr[1].substring(0,2))
					}
				}
			}
		},"input");
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101417,2,103,true,{"i_group_name":"返回"});
            var param = $.getPageParam("param");
            if (param && param.form === 'mall') {
                $.callMessage({
                    "moduleName": "mall_trade",
                    "funcNo": "50114",
                });
            } else {
                $.pageBack();
            }
			// $.pageBack("fund/grading/order","left");
			e.stopPropagation();
		});
		
        // 银证转账点击事件
        $.bindEvent($(_pageId + "#yzzz"), function (e) {
            //跳转
            $.pageInit("fund/SHLOF/subscribe", "banking/transferNew");
            e.stopPropagation();
            e.preventDefault();
        });
        // ETF基金网上现金认购点击事件
        $.bindEvent($(_pageId + ".link-btn"), function (e) {
            //跳转
            $.pageInit("fund/SHLOF/subscribe", "fund/etfFund/etfSubscription");
            e.stopPropagation();
            e.preventDefault();
        });
	}
	
		/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
		};
		//最后一个为超时处理函数
		service_fund.queryFundSelect(param,queryCapitalCallback,{"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results[0]){
					$(_pageId+".fund_form2 .cash_ky em").text(Number(results[0].enable_balance).toFixed(2));//可用
				}else{
					$(_pageId+".fund_form2 .cash_ky em").text("--");//可用
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr,exchange_type){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		if(fundStr!= "" && fundStr.length==6){
			clearBuyMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var entrust_bs="17";
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
				    "exchange_type":exchange_type,
					"entrust_bs":entrust_bs,
					"fund_code":fund_code
			};
			service_fund.queryStockMaxBuySHLOF(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
                commonFunc.popupRightsConfirm(results[0], {checkCyb: false, checkKzz: false,ckeckReits:true});
				if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
				var nav=results[0].price!=""?results[0].price:"0";
                var fundCompany = results[0].exchange_type;
				$(_pageId+"#fundName").val(results[0].stock_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").val(Number(nav).toFixed(4)).attr("data-account",results[0].stock_account);
				$(_pageId+"#purchaseLimit").val(results[0].stock_max_amount);
				$(_pageId+".fund_form2 .cash_ky em").text(Number(results[0].enable_balance).toFixed(2));//可用
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#fundCode").val());
		if(buy_stockCode.length == 0){
			$.alert("请输入基金代码");
			return false;
		}	
		if(buy_stockCode.length != 6){
			$.alert("基金代码输入错误");
			return false;
		}	
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#fundSum").val();
		var can_buy = $(_pageId+".fund_form2 .cash_ky em").text();
		if($.trim(now_price).length<=0){
			$.alert("请输入认购数量");
			return false;
		}else if(now_price=="0"){
			$.alert("认购数量不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入认购数量");
			return false;
		}
		var tipStrArray = [];
        var fundName = $(_pageId+" #fundName").val();
		tipStrArray.push(["交易方向 ", "认购"]);
		tipStrArray.push(["基金名称", "<span style='font-size:" + $.getTransformScaleFontSize(fundName, 16, $(window).width() * 0.48) + "px;'>" + fundName +  "</span>"]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["认购数量 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray, "", "list");
		tipStr += "</div>";
		//埋点数据
		var comStatParam={
			"objectId":"101419",
			"actionId": "3",
			"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":buy_stockCode, // 股票代码
			"i_stock_name":$(_pageId+" #fundName").val(), // 股票名称
			"i_entrust_prop":"LFS", // 委托属性
			"i_exchange_type":$(_pageId+"#fundName").attr("data-fundCom"), // 交易市场
			"i_entrust_price":$(_pageId+"#fundNav").val() || "1", // 选择后的价格
			"i_entrust_amount":now_price, // 委托数量
		}
//		common.iConfirm("下单确定",tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no  = userInfo.branch_no;	//分支机构
			var sessionid=userInfo.sessionid;
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_company=$(_pageId+"#fundName").attr("data-fundCom");
			var fund_code=buy_stockCode;
	        var entrust_price = $(_pageId+"#fundNav").val() || "1"; //收费方式
//			var balance=Number(now_price/entrust_price);
			var balance = now_price;
			var business_type = "1";
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"sessionid":sessionid,
					"exchange_type":fund_company,
					"fund_code":fund_code,
					"fund_name": $(_pageId+" #fundName").val(),
					"stock_code":fund_code,
					"entrust_bs":"1",
					"stock_account":$(_pageId+"#fundNav").attr("data-account"),
					"entrust_amount":balance,
	                "entrust_price":entrust_price,
	                "business_type":business_type,
	                "entrust_prop":'LFS'
				};
				appropriate.placeOrder(comStatParam,param,tipStr,function(instr_batch_no){
					param.instr_batch_no = instr_batch_no;
					service_fund.gradingSubscription(param,function(data){
				    	$.hidePreloader();
				    	getBuyCallBack(data,param);
				    },{"isLastReq":false,"isShowWait":false,
						"timeOutFunc":function(){
							$.hidePreloader();
						},"errorFunc":function(){
							$.hidePreloader();
						}});
					$.showPreloaders("请等待...");
				});
//			    service_fund.gradingSubscription(param,function(data){
//			    	$.hidePreloader();
//			    	getBuyCallBack(data,param);
//			    },{"isShowOverLay":false,"isShowWait":false,
//				"timeOutFunc":function(){
//					$.hidePreloader();
//				},"errorFunc":function(){
//					$.hidePreloader();
//				}});
//			$.showPreloaders("请等待...");
//			},function fail(){
//		});
	}
	//认购回调
	function getBuyCallBack(data,param){
		if(data.error_no == 0){
			var results = data.results;
				if(results){
					$(_pageId+"#fundSum").quzhi("");
					$.alert("委托已经提交，委托编号："+results[0].entrust_no,function(){
						var fundCode = $.trim($(_pageId+"#fundCode").val());
						getFundList(fundCode);
					});
					appropriate.function399931({serial_no:results[0].entrust_no});
				}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//认购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//埋点
			common.comStat(101418,2,103,true,{"i_group_name":"沪市LOF认购提交"});
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		//全部
		$.bindEvent($(_pageId + ".fund_form2 .all .all_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var purchaseLimit = $(this).prev("input").val();
			$(_pageId + "#fundSum").quzhi(purchaseLimit);
			e.stopPropagation();
		});
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
//		$(_pageId + " .input_text input").slice(1).val("");
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundNav").val("");
		$(_pageId + "#fundSum").quzhi("");
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		clearBuyMsg();
		$(_pageId + "#fundCode").quzhi("");
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
