/**
 * ETF交易-撤单
 */
define('trade/scripts/fund/etfFund/etfCancel.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#fund_etfFund_etfCancel ";
    var publicCancel = require("publicCancel2");
    var data = {
		"queryFuncNo": "302107",
		"queryParam": {
			"cancel_flag":"1"
		},
		"cancellModule":"stock",//表示普通撤单
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["委托份额", "entrust_amount"],
				["委托金额", "entrust_balance"],
				["委托时间", "report_time"],
				["委托编号", "entrust_no"],
				["委托状态", "entrust_state_name"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["stock_code","stock_code"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
			],
			//撤单提示字段
			"tipStr":[
				["基金代码", "stock_code"],
				["基金名称", "stock_name"],
				["业务名称", "entrust_name"],
				["委托份额", "entrust_amount"],
			]
		},
		"cancelFuncNo":"302109",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
  	}
    //金证mid
    if(global.serverConfig == 4){
	    data = {
			"queryFuncNo": "302107",
			"queryParam": {},
			"cancellModule":"stock",//表示普通撤单
			"htmlData": {
				"topDiv": {
					"entrust": "entrust_name",
					"name": "stock_name",
					"code": "stock_code",
				},
				"liList": [
					["委托份额", "entrust_amount"],
					["委托金额", "entrust_balance"],
					["成交价格", ""],
					["成交份额", ""],
					["成交金额", ""],
					["委托时间", ""],
					["委托编号", "entrust_no"],
					["委托状态", "entrust_state_name"],
				],
				//撤单时要的参数名称，值
				"cancel":[
					["entrust_no","entrust_no"],
					["entrust_date","entrust_date"],
					["exchange_type","exchange_type"],
				],
				//撤单提示字段
				"tipStr":[
					["基金代码", "stock_code"],
					["基金名称", "stock_name"],
					["业务名称", "entrust_name"],
					["委托份额", "entrust_amount"],
					["成交份额", ""],
				]
			},
			"cancelFuncNo":"302109",
			//撤单接口需要的其他参数
			"cancelParam": {
			},
	  	}
    }
    /**
     * 初始化
     */
	function init(){
		$(_pageId+" .tab_nav[gth"+global.serverConfig+"]").hide();
		publicCancel.init(data);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
    }
		
	function load(){
		publicCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			common.returnNative();
			$.pageInit("fund/etfFund/etfCancel","fund/etfFund/home",{},"left",true);
			e.stopPropagation();
			e.preventDefault();
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".tab_nav ul li a"), function(e){
			$.clearRequest();
			if($(this).parent("li").index() == 1){
				$.pageInit("fund/etfFund/etfCancel","fund/etfFund/etfCancelSubscription",{},"",true);
			}
		});
		
		publicCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});