/**
 * ETF交易-网下认购撤单
 */
define('trade/scripts/fund/etfFund/etfCancelSubscription.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#fund_etfFund_etfCancelSubscription ";
    var publicCancel = require("publicCancel2");
    var data = {
		"queryFuncNo": "302102",
		"queryParam": {
			"cancel_flag":"0"//可撤单标识
		},
		"cancellModule":"stock",//表示普通撤单
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["认购数额", "entrust_amount"],
				["股票名称", "stock_name"],
				["股票代码", "stock_code"],
				["委托时间", "entrust_time"],
				["委托状态", "entrust_state_name"],
//				["委托编号", "entrust_no"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
				["entrust_price","entrust_price"],
				["stock_code","stock_code"],
				["component_code","component_code"],
				["entrust_amount","entrust_amount"],
				["stock_account","stock_account"]
			],
			//撤单提示字段
			"tipStr":[
				["基金代码", "stock_code"],
				["基金名称", "stock_name"],
				["业务名称", "entrust_name"],
				["认购数额", "entrust_amount"],
			]
		},
		"cancelFuncNo":"302116",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
  	}
    /**
     * 初始化
     */
	function init(){
		$(_pageId+" .tab_nav[gth"+global.serverConfig+"]").hide();
		publicCancel.init(data);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
    }
		
	function load(){
		publicCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageInit("fund/etfFund/etfCancelSubscription","fund/etfFund/home",{},"left",true);
			e.stopPropagation();
			e.preventDefault();
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".tab_nav ul li a"), function(e){
			$.clearRequest();
			if($(this).parent("li").index() == 0){
				$.pageInit("fund/etfFund/etfCancelSubscription","fund/etfFund/etfCancel",{},"",true);
			}
		});
		
		publicCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});