/**
 * ETF交易-撤单
 */
 define('trade/scripts/fund/etfFund/etfLineChart.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
    var service_xkj = require("service_xkj");
    require("echarts");
    var common = require("common");
    var commonTimer = require("commonTimer");
    var commonHq = require("commonHq");
    var service_hq = require("service_hq");
    var chartType = "1"; // 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
    var chartTimeType = "1"; // 1 近1月 2 近3月 3 近6月 4 近1年 5 近3年 
    var chartObj = {};
    var chartData = [];
    var _pageId = "";
    var fundDataList = null;
    /**
     * 初始化
     */
	function init(){
    }
		
	function load(){
	}
    function initHtml(){
        _pageId = "#" + $.getCurrentPageObj().pageId + " ";
        $(_pageId + ".detail-warp").remove();
        $(_pageId + ".padtopten-new").append('<div class="detail-warp" style="display: none;">\
            <!-- 实时净值、最新价、溢折率 -->\
            <ul class="real-time">\
                <li style="text-align: center;">\
                    <p class="real-value iopv-value"></p>\
                    <p class="real-label">实时净值(IOPV)<em class="program iopv"></em></p>\
                </li>\
                <li style="text-align: center;">\
                    <p class="real-value last-price"></p>\
                    <p class="real-label">最新价</p>\
                </li>\
                <li style="text-align: right;padding-right: 0.36rem;">\
                    <p class="real-value convert-value"></p>\
                    <p class="real-label">溢折率<em class="program convert"></em></p>\
                </li>\
            </ul>\
            <!-- 七日年化、最新价、万份收益 -->\
            <ul class="real-time hbjj" style="display: none;">\
                <li style="text-align: center;">\
                    <p class="real-value seven-days"></p>\
                    <p class="real-label">七日年化</p>\
                </li>\
                <li style="text-align: center;">\
                    <p class="real-value ten-thousand-value"></p>\
                    <p class="real-label">万份收益</p>\
                </li>\
                <li style="text-align: right;padding-right: 0.36rem;">\
                    <p class="real-value last-price"></p>\
                    <p class="real-label">最新价</p>\
                </li>\
            </ul>\
            <!-- 普通基金折线图导航 -->\
            <ul class="chart-nav">\
                <li data-type="1" class="active">累计收益率</li>\
                <li data-type="2">单位净值</li>\
                <li data-type="3">累计净值</li>\
                <!-- <li data-type="4">净值估算</li> -->\
            </ul>\
            <!-- 货币基金折线图导航 -->\
            <ul class="chart-nav hbjj" style="display: none;">\
                <li data-type="5" class="active">七日年化</li>\
                <li data-type="6">万份收益</li>\
            </ul>\
            <!-- 折线图tips -->\
            <div class="tips">\
                <div class="nav-val ljsyl">\
                    <p class="nav-val-date"></p>\
                    <p class="nav-val-legend" style="text-align: right;">\
                        <em class="point-red"></em>\
                        <span>本基金</span>\
                        <span class="fund-val"></span>\
                    </p>\
                    <p class="nav-val-legend" style="text-align: right;">\
                        <em class="point-blue"></em>\
                        <span class="ljsyl-label"></span>\
                        <span class="hs-val"></span>\
                    </p>\
                </div>\
                <div class="nav-val estimated" style="display: none;">\
                    <p class="nav-val-date"></p>\
                    <p class="nav-val-legend" style="text-align: right;padding-right: 15px;">\
                        <span>估值</span>\
                        <span class="estimated-nav"></span>\
                    </p>\
                    <p class="nav-val-legend" style="text-align: right;">\
                        <span>估值涨幅</span>\
                        <span class="estimated-change"></span>\
                    </p>\
                </div>\
                <div class="nav-val pubtips" style="display: none;">\
                    <p class="nav-val-date"></p>\
                    <p class="nav-val-legend" style="text-align: right;">\
                        <em class="point-red"></em>\
                        <span class="lab">单位净值</span>\
                        <span class="fund-nav-val"></span>\
                    </p>\
                </div>\
            </div>\
            <!-- 折线图 -->\
            <div id="fundcharts"></div>\
            <div class="fundcharts-nodata" style="display:none;"><img src="../../../images/img_nodata.png" /><p>暂无数据</p></div>\
            <!-- 折线图 x轴 模拟 -->\
            <ul class="date-list">\
                <li></li>\
                <li style="text-align: center;"></li>\
                <li style="text-align: right;"></li>\
            </ul>\
            <!-- 折线图 日期范围选择 -->\
            <ul class="chart-date-nav">\
                <li data-type="1" class="active">近1月</li>\
                <li data-type="2">近3月</li>\
                <li data-type="3">近6月</li>\
                <li data-type="4">近1年</li>\
                <li data-type="5">近3年</li>\
            </ul>\
            <!-- 净值估算 不需要日期选择，显示提示信息 -->\
            <div class="estimated-readme" style="display: none;">净值估算数据按照基金持仓和指数走势估算，不构成投资建议，仅供参考，实际涨跌幅以基金净值为准。</div>\
            <!-- 查看更多行情 -->\
            <div class="more-btn">查看更多行情 </div>\
        </div>');
    }
    function showContent(data){
        fundDataList = data;
        // 判断是不是货币ETF基金
        if(fundDataList.etfcode_type === "4"){
            $(_pageId + ".real-time").hide();
            $(_pageId + ".chart-nav").hide();
            $(_pageId + ".hbjj").show();
            chartType = "5";
        }
        // 查询折线图数据
        getChartData();
        // 查询实时净值和昨收净值
        getETFInfo(fundDataList.stock_code, commonHq.getHqMarket(fundDataList.exchange_type));
        // 设置定时器查询
        commonTimer.setTimer(_pageId, function () {
            getETFInfo(fundDataList.stock_code, commonHq.getHqMarket(fundDataList.exchange_type));
        }, global.positionRefreshTime);//定时刷新
    }
    
    function getChartData(){
        if(chartType === "4"){
            require3001039(fundDataList.stock_code);
        }else{
            require3001038();
        }
    }
    // 持营ETF基金折线图查询
    function require3001038(){
        chartChange(chartType);
        chartObj.clear && chartObj.clear();
        service_xkj.require3001038({
            productCode: fundDataList.stock_code,
            exchangeType: commonHq.getHqMarket(fundDataList.exchange_type),
            etfcodeType: fundDataList.etfcode_type,
            timeType:chartTimeType,
        },function(data){
            $(_pageId + "#fundcharts").hide();
            $(_pageId + ".fundcharts-nodata").show();
            if (data.error_no == 0) {
                $(_pageId + '.detail-warp').show();
                if(data.results.length > 0){
                    $(_pageId + "#fundcharts").show();
                    $(_pageId + ".fundcharts-nodata").hide();
                    drawLineCharts(chartType,data.results);
                    chartData = data.results;
                    // 判断是不是货币ETF基金
                    if(fundDataList.etfcode_type === "4"){
                        // 展示最后一条数据的7日年化和万份收益
                        var data = data.results[data.results.length - 1];
                        $(_pageId + ".seven-days").html(data.sevenDaysAnnualProfit?parseFloat(data.sevenDaysAnnualProfit).toFixed(4) + "%":"--");
                        $(_pageId + ".ten-thousand-value").html(data.profitPerMillion?parseFloat(data.profitPerMillion).toFixed(4):"--");
                    }
                    if(chartType === "1"){
                        $(_pageId + ".tips .ljsyl-label").html(data.results[0].indexName);
                    }
                }
            } else if(data.error_no === -300100027){
                $(_pageId + '.detail-warp').hide();
            }else {
                $.alert(data.error_info);
            }
        });
    }
    // 基金实时估值接口
    function require3001039(fundCode){
        chartChange("4");
        chartObj.clear && chartObj.clear();
        service_xkj.require3001039({
            productCode:fundCode,
        },function(data){
            $(_pageId + "#fundcharts").hide();
            $(_pageId + ".fundcharts-nodata").show();
            if (data.error_no == 0) {
                if(data.results.length > 0){
                    $(_pageId + "#fundcharts").show();
                    $(_pageId + ".fundcharts-nodata").hide();
                    drawLineCharts("4",data.results);
                    chartData = data.results;
                }
            } else {
                $.alert(data.error_info);
            }
        });
    }
    // 绘制折线图 type 1 累计收益率 2 单位净值 3 累计净值 4 净值估算
    function drawLineCharts(type,results) {
        chartObj = echarts.init(document.getElementById("fundcharts"), null, { renderer: 'svg' });
        clearLegend();
        var option = {
            tooltip: {
                trigger: 'axis',
                axisPointer: {
                    type: 'cross',
                    snap: true,
                    label: {
                        fontSize: 10,
                        backgroundColor: "#EE4034"
                    },
                    crossStyle: {
                        color: '#EE4034'
                    },
                    lineStyle: {
                        color: '#EE4034'
                    },
                },
                showContent: true,
                formatter: function(params){
                    // console.log(params);
                    // 设置选中的点
                    chartObj.dispatchAction({
                        type: 'showTip',
                        seriesIndex: 0,
                        // 数据项的 index，如果不指定也可以通过 name 属性根据名称指定数据项
                        dataIndex: params[0].dataIndex,
                    })
                    // 显示tips
                    if(type === "1"){
                        return '<div class="tips">\
                                    <div class="nav-val show-tips">\
                                        <p class="nav-val-date">' + params[0].axisValue + '</p>\
                                        <p class="nav-val-legend" style="text-align: right;">\
                                            <em class="point-red"></em>\
                                            <span>本基金</span>\
                                            <span class="fund-val ' + (addClassRedOrGreen(params[0].data)) + '">' + params[0].data + '%</span>\
                                        </p>\
                                        <p class="nav-val-legend" style="text-align: right;">\
                                            <em class="point-blue"></em>\
                                            <span>' + chartData[params[0].dataIndex].indexName + '</span>\
                                            <span class="hs-val ' + (addClassRedOrGreen(params[1].data)) + '">' + (params[1].data === "NaN"?'--':params[1].data + '%') + '</span>\
                                        </p>\
                                    </div>\
                                </div>';
                    }else if(type === "2" || type === "3" || type === "5" || type === "6"){
                        var dict = {
                            "2":"单位净值",
                            "3":"累计净值",
                            "5":"七日年化",
                            "6":"万份收益",
                        };
                        var val = params[0].data;
                        if(type === "5"){
                            val = val + "%";
                        }
                        return '<div class="tips">\
                                    <div class="nav-val show-tips">\
                                        <p class="nav-val-date">' + params[0].axisValue + '</p>\
                                        <p class="nav-val-legend" style="text-align: right;">\
                                            <em class="point-red"></em>\
                                            <span class="lab">' + dict[type] + '</span>\
                                            <span class="fund-nav-val ' + (addClassRedOrGreen(params[0].data)) + '">' + val + '</span>\
                                        </p>\
                                    </div>\
                                </div>';
                    }else if(type === "4"){
                        return '<div class="tips">\
                                    <div class="nav-val show-tips">\
                                        <p class="nav-val-date">' + params[0].axisValue + '</p>\
                                        <p class="nav-val-legend" style="text-align: right;">\
                                            <span>估值</span>\
                                            <span class="estimated-nav ' + (addClassRedOrGreen(chartData[params[0].dataIndex].estimatedChange)) + '">' + chartData[params[0].dataIndex].estimatedNav + '</span>\
                                        </p>\
                                        <p class="nav-val-legend" style="text-align: right;">\
                                            <span>估值涨幅</span>\
                                            <span class="estimated-change ' + (addClassRedOrGreen(chartData[params[0].dataIndex].estimatedChange)) + '">' + chartData[params[0].dataIndex].estimatedChange + '%</span>\
                                        </p>\
                                    </div>\
                                </div>';
                    }
                },
                className:"fund-line-tips",
                position:[0,-35],
                padding:0,
                extraCssText:"box-shadow:none;width:100%;"
            },
            legend: {
                show: false,
            },
            grid: {
                containLabel: true,
                top: 20,
                right: 16,
                bottom: 10,
                left: 16,
            },
            xAxis: {
                type: 'category',
                boundaryGap: false,
                position: "top",
                axisLine: {
                    show: false,
                },
                axisLabel: {
                    show: false,
                },
                axisTick: {
                    show: false,
                },
            },
            yAxis: {
                type: 'value',
                axisLabel: {
                    color: '#999999',
                    fontSize: 10,
                    formatter: function (val) {
                        // type 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
                        if(type === "1" || type === "4"){ 
                            return val.toFixed(2) + "%";
                        }else if(type === "5"){
                            return val.toFixed(4) + "%";
                        }else{ // 其他折线图统一处理
                            return val.toFixed(4);
                        }
                    },
                },
                splitLine: {
                    lineStyle: {
                        type: "dotted",
                        color: "#EDEDED",
                        width: 0.5,
                    },
                },
                axisPointer: {
                    label: {
                        formatter: function (data) {
                            // type 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
                            if(type === "1" || type === "4"){ 
                                return data.value.toFixed(2) + "%";
                            }else if(type === "5"){
                                return data.value.toFixed(4) + "%";
                            }else{ // 其他折线图统一处理
                                return data.value.toFixed(4);
                            }
                        },
                    },
                },
            },
            series: [
                {
                    type: 'line',
                    color: "#EE4034",
                    showSymbol: false,
                    symbolSize: 5,
                    emphasis: { // 拐点激活样式，
                        itemStyle: {
                            borderWidth: 1.5
                        },
                    },
                    lineStyle: {
                        width: 1,
                    },
                    areaStyle: {
                        color: new echarts.graphic.LinearGradient(0, 0, 0, 1, [
                            {
                                offset: 0,
                                color: '#FDBFC2'
                            },
                            {
                                offset: 1,
                                color: '#FFFFFF'
                            }
                        ])
                    },
                },
            ]
        };
        var xAxisData = []; // 坐标轴数据
        var line_data = []; // 折线图数据
        var max_point = []; // 单位净值最大点的坐标
        var min_point = []; // 单位净值最小点的坐标
        // 单位净值 需要增加最高点和最低点展示
        var markPoint = {
          symbol:"circle",
          symbolSize:5,
          silent:true,
          label:{
            color:"#333333",
            fontSize:9,
            align:"left",
          },
          data: [
            { 
              name: '最低', 
              itemStyle:{
                color:"#3285EA",
              },
              label:{},
            },
            { 
              name: '最高', 
              itemStyle:{
                borderWidth:0,
              },
              label:{},
            },
          ]
        };
        var _leg = results.length;
        // type 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
        if(type === "1"){
            // 累计收益率 是两条折线图
            // 累计收益率 需要增加最高点和最低点展示
            var max = { nav: 0 };
            var min = max;
            var line2 = {
                type: 'line',
                showSymbol: false,
                symbolSize: 5,
                lineStyle: {
                    width: 1,
                },
                color: "#4C7ED5",
                data: []
            };
            results.forEach(function(item,index){
                if(index === 0){
                    min = item;
                    max = item;
                    min_point = [index,item.navYield];
                    max_point = [index,item.navYield];
                }
                if(parseFloat(max.navYield) < parseFloat(item.navYield)){
                    max = item;
                    max_point = [index,item.navYield];
                }
                if(parseFloat(min.navYield) > parseFloat(item.navYield)){
                    min = item;
                    min_point = [index,item.navYield];
                }
                item.navYield = parseFloat(item.navYield).toFixed(2);
                item.hs300Yield = parseFloat(item.hs300Yield).toFixed(2);
                xAxisData.push(item.navDate);
                line_data.push(item.navYield);
                line2.data.push(item.hs300Yield);
            });
            option.series.push(line2);
            markPoint.data[0].value = min.navYield + "%";
            markPoint.data[0].xAxis = min.navDate;
            markPoint.data[0].yAxis = min.navYield;
            markPoint.data[1].value = max.navYield + "%";
            markPoint.data[1].xAxis = max.navDate;
            markPoint.data[1].yAxis = max.navYield;
            var navYield = results[_leg - 1].navYield;
            var hs300Yield = results[_leg - 1].hs300Yield;
            // 本基金
            $(_pageId + ".tips .fund-val").addClass(addClassRedOrGreen(navYield)).html(navYield?navYield + "%":"--");
            // 沪深300
            $(_pageId + ".tips .hs-val").addClass(addClassRedOrGreen(hs300Yield)).html(hs300Yield && hs300Yield !== "NaN"?hs300Yield + "%":"--");
            // 显示tips
            $(_pageId + ".tips .ljsyl").show();
            $(_pageId + ".tips .estimated").hide();
            $(_pageId + ".tips .pubtips").hide();

        }else if(type === "2"){
            // 单位净值 需要增加最高点和最低点展示
            var max = { nav: 0 };
            var min = max;
            results.forEach(function(item,index){
                if(index === 0){
                    min = item;
                    max = item;
                    min_point = [index,item.nav];
                    max_point = [index,item.nav];
                }
                item.nav = parseFloat(item.nav).toFixed(4);
                xAxisData.push(item.navDate);
                line_data.push(item.nav);
                if(parseFloat(max.nav) < parseFloat(item.nav)){
                    max = item;
                    max_point = [index,item.nav];
                }
                if(parseFloat(min.nav) > parseFloat(item.nav)){
                    min = item;
                    min_point = [index,item.nav];
                }
            });
            markPoint.data[0].value = min.nav;
            markPoint.data[0].xAxis = min.navDate;
            markPoint.data[0].yAxis = min.nav;
            markPoint.data[1].value = max.nav;
            markPoint.data[1].xAxis = max.navDate;
            markPoint.data[1].yAxis = max.nav;
            option.yAxis.scale = true;
            // option.series[0].markPoint = markPoint;
            // 显示tips
            $(_pageId + ".tips .ljsyl").hide();
            $(_pageId + ".tips .estimated").hide();
            $(_pageId + ".tips .pubtips").show();
            $(_pageId + ".tips .pubtips .lab").html("单位净值");
            $(_pageId + ".tips .pubtips .fund-nav-val").addClass(addClassRedOrGreen(results[_leg - 1].nav)).html(results[_leg - 1].nav);
        }else if(type === "3" || type === "5" || type === "6"){ 
            var dict = {
                "3": {
                    lab:"累计净值",
                    key:"cumulativeNet"
                },
                "5":{
                    lab:"七日年化",
                    key:"sevenDaysAnnualProfit"
                },
                "6":{
                    lab:"万份收益",
                    key:"profitPerMillion"
                },
            };
            // 累计净值 需要增加最高点和最低点展示
            var max = { nav: 0 };
            var min = max;
            results.forEach(function(item,index){
                var val = item[dict[type].key];
                if(isNaN(parseFloat(val))){
                    return;
                }
                // 累计净值 需要增加最高点和最低点展示
                if(type === "3"){
                    if(index === 0){
                        min = item;
                        max = item;
                        min_point = [index,val];
                        max_point = [index,val];
                    }
                    if(parseFloat(max[dict[type].key]) < parseFloat(val)){
                        max = item;
                        max_point = [index,val];
                    }
                    if(parseFloat(min[dict[type].key]) > parseFloat(val)){
                        min = item;
                        min_point = [index,val];
                    }
                }
                item[dict[type].key] = parseFloat(val).toFixed(4);
                xAxisData.push(item.navDate);
                line_data.push(item[dict[type].key]);
            });
            // 累计净值 需要增加最高点和最低点展示
            if(type === "3"){
                markPoint.data[0].value = min[dict[type].key];
                markPoint.data[0].xAxis = min.navDate;
                markPoint.data[0].yAxis = min[dict[type].key];
                markPoint.data[1].value = max[dict[type].key];
                markPoint.data[1].xAxis = max.navDate;
                markPoint.data[1].yAxis = max[dict[type].key];
            }
            option.yAxis.scale = true;
            // 显示tips
            $(_pageId + ".tips .ljsyl").hide();
            $(_pageId + ".tips .estimated").hide();
            $(_pageId + ".tips .pubtips").show();
            $(_pageId + ".tips .pubtips .lab").html(dict[type].lab);
            
            var value = results[_leg - 1][dict[type].key];
            if(type === "5"){
                value = value?value + "%":"--";
            }
            $(_pageId + ".tips .pubtips .fund-nav-val").addClass(addClassRedOrGreen(results[_leg - 1][dict[type].key])).html(value);
        }else if(type === "4"){
            // 净值估算
            results.forEach(function(item){
                item.estimatedNav = parseFloat(item.estimatedNav);
                item.estimatedChange = parseFloat(item.estimatedChange).toFixed(2);
                item.targetTime = item.targetTime.replace(/(\d{4})(\d{2})(\d{2})(\d{2})(\d{2})/,"$1-$2-$3 $4:$5");
                xAxisData.push(item.targetTime);
                line_data.push(item.estimatedChange);
            });
            // 显示tips
            $(_pageId + ".tips .ljsyl").hide();
            $(_pageId + ".tips .estimated").show();
            $(_pageId + ".tips .pubtips").hide();
            $(_pageId + ".tips .estimated .estimated-nav").addClass(addClassRedOrGreen(results[_leg - 1].estimatedChange)).html(results[_leg - 1].estimatedNav);
            $(_pageId + ".tips .estimated .estimated-change").addClass(addClassRedOrGreen(results[_leg - 1].estimatedChange)).html(results[_leg - 1].estimatedChange + "%");
        }
        
        if(type === "4"){
            // 如果估值图的点不满，补足剩余的点
            var arr = addTimeXAxisData(xAxisData);
            if(arr.length > 0){
                xAxisData = xAxisData.concat(arr);
            }
        }else if(xAxisData.length < 2){
            // 如果x轴数据小于两个点，默认给他补3个点，用最后一个点的值
            var t = xAxisData[xAxisData.length - 1];
            xAxisData.push(t);
            xAxisData.push(t);
            xAxisData.push(t);
        }
        option.xAxis.data = xAxisData;
        option.series[0].data = line_data;
        chartObj.clear();
        chartObj.setOption(option);
        // 估值图与其他类型的图不一样
        if(type === "4"){
            // 设置x轴日期显示
            $(_pageId + ".date-list li").eq(0).html("09:30");
            $(_pageId + ".date-list li").eq(1).html("11:30/13:00");
            $(_pageId + ".date-list li").eq(2).html("15:00");
            // tips 日期
            $(_pageId + ".tips .nav-val-date").html(results[_leg - 1].targetTime);
        }else{
            // 设置x轴日期显示
            $(_pageId + ".date-list li").eq(0).html(results[0].navDate);
            $(_pageId + ".date-list li").eq(1).html(results[parseInt(_leg / 2)].navDate);
            $(_pageId + ".date-list li").eq(2).html(results[_leg - 1].navDate);
            // tips 日期
            $(_pageId + ".tips .nav-val-date").html(results[_leg - 1].navDate);
        }
        // 单位净值图需要等折线图绘制完毕后，判断最高最低点的位置，动态调整文本位置(判断左右位置)
        if(type === "1" || type === "2" || type === "3"){
            var left = [-45,0];
            var right = [5,0];
            var minPoint = chartObj.convertToPixel({seriesIndex: 0}, [0, 0])[0];
            var maxPoint = chartObj.convertToPixel({seriesIndex: 0}, [_leg - 1, results[_leg - 1].nav])[0];
            var _max = chartObj.convertToPixel({seriesIndex: 0}, max_point)[0]; // 最大值位置
            var _min = chartObj.convertToPixel({seriesIndex: 0}, min_point)[0]; // 最小值位置
            if(_leg.length <= 1){ // 只有一个点时
                markPoint.data[0].label.offset = right;
                markPoint.data.shift();
            }else{
                if(_max >= maxPoint / 2 ){ // 最大值点在图的右侧
                    markPoint.data[1].label.offset = left;
                }else if(_max < maxPoint / 2 ){ // 最大值点在图的左侧
                    markPoint.data[1].label.offset = right;
                }
                if(_min >= maxPoint / 2 ){ // 最小值点在图的右侧
                    markPoint.data[0].label.offset = left;
                }else if(_min < maxPoint / 2 ){ // 最小值点在图的左侧
                    markPoint.data[0].label.offset = right;
                }
            }
            var addOption = {
                series: [
                    {
                        markPoint:markPoint
                    }
                ]
            };
            chartObj.setOption(addOption);
        }
    }
    // 折线图顶部和底部日期切换
    function chartChange(type){
        // type 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
        if(type === "1"){
           // 显示tips
           $(_pageId + ".tips .ljsyl").show();
           $(_pageId + ".tips .estimated").hide();
           $(_pageId + ".tips .pubtips").hide();

       }else if(type === "2"){
           // 显示tips
           $(_pageId + ".tips .ljsyl").hide();
           $(_pageId + ".tips .estimated").hide();
           $(_pageId + ".tips .pubtips").show();
           $(_pageId + ".tips .pubtips .lab").html("单位净值");
       }else if(type === "3" || type === "5" || type === "6"){ 
           // 显示tips
           $(_pageId + ".tips .ljsyl").hide();
           $(_pageId + ".tips .estimated").hide();
           $(_pageId + ".tips .pubtips").show();
       }else if(type === "4"){
           // 显示tips
           $(_pageId + ".tips .ljsyl").hide();
           $(_pageId + ".tips .estimated").show();
           $(_pageId + ".tips .pubtips").hide();
       }
       $(_pageId + ".date-list li").eq(0).html("");
       $(_pageId + ".date-list li").eq(1).html("");
       $(_pageId + ".date-list li").eq(2).html("");
       clearTips();
    }
    // 请求实时指标数据
    function getETFInfo(fundcode, market) {
        var param = {
            "stock_list": market + ':' + fundcode,
        };
        service_hq.querySZYStock(param, function (data) {
            if (data) {
                // console.log(data);
	            // paraMap["field"] ="22:24:23:2:3:1:112";	    
                if (data.errorNo == 0 && data.results.length > 0) {
                    var result = data.results[0];
                    if(common.isValue(result[6]) || common.isValue(result[3])){
                        var lastIopv = common.isValue(result[6]) && result[6] !== "--"?parseFloat(result[6]).toFixed(4):"--";
                        var lastPrice = common.isValue(result[3]) && result[3] !== "--"?parseFloat(result[3]).toFixed(3):"--";
                        var up = result[4];
                        var convert = "--";
                        if(common.isValue(result[6]) && result[6] !== "--" && common.isValue(result[3]) && result[3] !== "--"){
                            convert = ((lastPrice - lastIopv) / lastIopv * 100).toFixed(2);
                        }
                        // 最新价 重置
                        $(_pageId + ".last-price").removeClass("ared").removeClass("agreen");
                        // 溢折率 重置
                        $(_pageId + ".convert-value").removeClass("ared").removeClass("agreen");

                        $(_pageId + ".iopv-value").html(lastIopv);//实时净值(IOPV)
                        $(_pageId + ".last-price").addClass(addClassRedOrGreen(up)).html(lastPrice);//最新价
                        $(_pageId + ".convert-value").addClass(addClassRedOrGreen(convert)).html(convert && convert != "--"?convert + "%":convert);//溢折率
                    }
                }
            }
        });
    }
    function addClassRedOrGreen(num,base){
        var b = base || 0;
        if(num === "--"){
            return ""
        }else if(parseFloat(num) > b){
            return "ared";
        }else if(parseFloat(num) < b){
            return "agreen";
        }else{
            return ""
        }
    }
    // 净值估算图 计算x轴数据 x轴应该有240个点，每分钟1个点
    function addTimeXAxisData(xAxisData){
        var _leg = xAxisData.length;
        var new_date = new Date();
        var date = new_date.getFullYear() + "-" + (new_date.getMonth() + 1 < 10?"0" + (new_date.getMonth() + 1):new_date.getMonth() + 1) + "-" + (new_date.getDate() < 10?"0" + new_date.getDate():new_date.getDate());
        var allTime = [];
        if(_leg >= 240){
            return [];
        }else{
            var h = ["09","10","11","13","14"];
            for(var i = 0;i <= h.length - 1;i++){
                for(var j = 0;j <= 59;j++){
                    allTime.push(date + " " + h[i] + ":" + (j < 10?"0" + j:j))
                }
            }
            // 删除09：00-09：30之间的时间
            allTime.splice(0,30);
            // 删除11：30-13：00之间的时间
            allTime.splice(121,30);
            // 添加15:00点
            allTime.push(date + " 15:00");
            // 返回 x轴剩下的点坐标
            return allTime.splice(_leg,allTime.length - 1);
        }
    }
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
        // 折线图类型切换 监听
        $.bindEvent($(_pageId + " .chart-nav li"), function (e) {
            var type = $(this).attr("data-type");
            // 当前tab不可重复点击
            if(type === chartType){
                return
            }
            $.clearRequest();
            chartType = type;
            $(_pageId + " .chart-nav li").removeClass("active");
            $(this).addClass("active")
            // 重置时间为近1月
            chartTimeType = "1";
            $(_pageId + " .chart-date-nav li").removeClass("active");
            $(_pageId + " .chart-date-nav li").eq(0).addClass("active");
            getChartData();
            if(chartType === "4"){
                // 显示 净值估算提示信息
                $(_pageId + ".estimated-readme").show();
                // 隐藏 日期选择控件
                $(_pageId + ".chart-date-nav").hide();
            }else{
                // 隐藏 净值估算提示信息
                $(_pageId + ".estimated-readme").hide();
                // 显示 日期选择控件
                $(_pageId + ".chart-date-nav").show();
            }

        });
        // 全局监听 点击折线图之外的地方，隐藏tips
        //  $.bindEvent($(_pageId), function (e) {
        //     if($(_pageId + ".fund-line-tips").css("visibility") === "hidden"){
        //         chartObj.dispatchAction && chartObj.dispatchAction({
        //             type: 'hideTip'
        //         });
        //     }
        //  });
         // 监听折线图触摸事件
         $.bindEvent($(_pageId + "#fundcharts"), function(e){
            chartObj.dispatchAction({
                type: 'updateAxisPointer',
            });
         },"touchend");
        // 折线图 日期范围选择 监听
        $.bindEvent($(_pageId + " .chart-date-nav li"), function (e) {
            $.clearRequest();
            var type = $(this).attr("data-type");
            chartTimeType = type;
            $(_pageId + " .chart-date-nav li").removeClass("active");
            $(this).addClass("active");
            getChartData();
        });
        // 实时净值(IOPV) 监听
        $.bindEvent($(_pageId + " .iopv"), function (e) {
            $.alert("IOPV全称为基金份额参考净值，是由交易所计算的ETF实时单位净值的近似值，以便于投资者估计ETF交易价格是否偏离了内在价值","",function(){ },"我知道了");
        });
        // 溢折率 监听
        $.bindEvent($(_pageId + " .convert"), function (e) {
            $.alert("溢折率=（最新价-IOPV）/IOPV*100%，正值代表溢价率，负值代表折价率","",function(){ },"我知道了");
        });
        // 溢折率 监听
        $.bindEvent($(_pageId + " .more-btn"), function (e) {
            var pageCode = $.getCurrentPageObj().pageCode || '';
            $.setSStorageInfo("go_hq_" + pageCode, true);
            $.callMessage({
                "funcNo": "501156",
                "url": global.f10Url +"/index.html?s=" + fundDataList.stock_code + "&p=hsjy_1167&searchhead=0&section=f10#/ETFDetails",
                "stockName": fundDataList.stock_name_long || fundDataList.stock_name,
                "stockMarket": commonHq.getHqMarket(fundDataList.exchange_type),
                "stockCode": fundDataList.stock_code
            });
        });
	}
    // 清除legend 信息
    function clearLegend(){
        // 重置 折线图 tips
        // 本基金
        $(_pageId + ".tips .fund-val").removeClass("ared").removeClass("agreen");
        // 沪深300
        $(_pageId + ".tips .hs-val").removeClass("ared").removeClass("agreen");
        // 单位净值
        $(_pageId + ".tips .pubtips .fund-nav-val").removeClass("ared").removeClass("agreen");
        // 估值
        $(_pageId + ".tips .estimated-nav").html("--").removeClass("ared").removeClass("agreen");
        // 估值涨幅
        $(_pageId + ".tips .estimated-change").html("--").removeClass("ared").removeClass("agreen");
    }
    // 重置 折线图 tips
	function clearTips(){
        // 日期
        $(_pageId + ".tips .nav-val-date").html("");
        // 本基金
        $(_pageId + ".tips .fund-val").html("");
        // 沪深300
        $(_pageId + ".tips .hs-val").html("");
        // 沪深300
        $(_pageId + ".tips .ljsyl-label").html("");
        // 单位净值
        $(_pageId + ".tips .fund-nav-val").html("");
        // 估值
        $(_pageId + ".tips .estimated-nav").html("--");
        // 估值涨幅
        $(_pageId + ".tips .estimated-change").html("--");
    }
	function clearData(){
		commonTimer.clearTimer(_pageId);
        // 重置底部折线图和指标状态
        $(_pageId + '.detail-warp').hide();
        // 默认显示 实时净值、最新价、溢折率
        $(_pageId + ".real-time").show();
        // 默认显示 普通基金折线图导航
        $(_pageId + ".chart-nav").show();
        // 默认显示 累计收益率
        $(_pageId + ".chart-nav li").removeClass("active");
        // 累计收益率 tab选中
        $(_pageId + ".chart-nav li[data-type='1']").addClass("active");
        // 七日年化 tab选中
        $(_pageId + ".chart-nav li[data-type='5']").addClass("active");
        chartType = "1"; // 1 累计收益率 2 单位净值 3 累计净值 4 净值估算 5 七日年化 6 万份收益
        // 重置 折线图 tips
        clearTips();
        // 清除样式
        clearLegend()
        // 默认显示累计收益率 tip
        $(_pageId + ".ljsyl").show();
        $(_pageId + ".estimated").hide();
        $(_pageId + ".pubtips").hide();
        $(_pageId + ".pubtips .lab").html("单位净值");
        // 隐藏 净值估算提示信息
        $(_pageId + ".estimated-readme").hide();
        // 显示 日期选择控件
        $(_pageId + ".chart-date-nav").show();


        // 重置 折线图 x轴
        $(_pageId + ".date-list li").html("");
        // 默认显示 近1月
        $(_pageId + ".chart-date-nav li").removeClass("active");
        $(_pageId + ".chart-date-nav li").eq(0).addClass("active");
        chartTimeType = "1"; // 1 近1月 2 近3月 3 近6月 4 近1年 5 近3年 
        // 隐藏货币基金相关信息
        $(_pageId + ".hbjj").hide();
        // 实时净值(IOPV) 重置
        $(_pageId + ".iopv-value").html("");
        // 最新价 重置
        $(_pageId + ".last-price").html("");
        $(_pageId + ".last-price").removeClass("ared").removeClass("agreen");
        // 溢折率 重置
        $(_pageId + ".convert-value").html("");
        $(_pageId + ".convert-value").removeClass("ared").removeClass("agreen");
        // 七日年化 重置
        $(_pageId + ".seven-days").html("");
        // 万份收益 重置
        $(_pageId + ".ten-thousand-value").html("");
    }
	
    
	/**
	 * 销毁
	 */
	function destroy(){
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"clearData" : clearData,
		"getChartData" : getChartData,
		"initHtml" : initHtml,
		"showContent" : showContent,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
