/**
 * ETF基金赎回
 */
define('trade/scripts/fund/etfFund/etfRedeemOther.js', function(require, exports, module) {
    var _pageId = "#fund_etfFund_etfRedeemOther ";
	var gconfig = $.config;
	var global = gconfig.global;
    var common = require("common");
	var keyboard = require("keyboard");
	var service_fundETF = require("service_fundETF");
	require("validatorUtils");
	var validata = $.validatorUtils;
	var fundDataList={}; 
	var userInfo = null;
    
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		if(keyboard){
			keyboard.keyInit();
		}
		var mainHeight = common.setMainHeight(_pageId, false);
    }
		
	function load(){
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.pageInit("fund/etfFund/etfRedeemOther","fund/etfFund/home",{},"left",true);
			e.stopPropagation();
			e.preventDefault();
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$.clearRequest();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + "#fundCode").quzhi("");
			clearBuyMsg();
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+".fundcode").hide();
			var $index=$(this).index();
			if($index == 0){
				$(_pageId+".fundcode.ordinaryETF").show();
			}
			else if($index == 1){
				$(_pageId+".fundcode.crossMarketETF").show();
			}
			else if($index == 2){
				$(_pageId+".fundcode.crossBorderETF").show();
			}
		});
		
		//股票代码输入框监听
		$.bindEvent($(_pageId+" #fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $(this).val();
			if(fundCode.length == 6){
				getFundList(fundCode);
				if(keyboard){
					keyboard.closeKeyPanel();
				}
			}else{
				clearBuyMsg();
			}
			e.stopPropagation();
		},"input");
		
		//全部
		$.bindEvent($(_pageId + " #all"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var maxNumber = $(_pageId + " #maxNumber").quzhi();
			if(!maxNumber) {
				return false;
			}
			$(_pageId+"#fundNumber").quzhi(maxNumber);
			e.stopPropagation();
		});
		
		//赎回
		$.bindEvent($(_pageId + ".applyvote .nocheck"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			vailSubmitOrder();
			e.stopPropagation();
		});
	}
	
	/*
	 * 区分板块
	 */
	function changePlates(){
		//网上现金
		if($(_pageId + ".tab_nav ul li:eq(0)").hasClass("active")){
			return "ordinaryETF";
		}
		//网下现金
		else if($(_pageId + ".tab_nav ul li:eq(1)").hasClass("active")){
			return "crossMarketETF";
		}
		//网下股票
		else if($(_pageId + ".tab_nav ul li:eq(2)").hasClass("active")){
			return "crossBorderETF";
		}
	}
    
    /**
	 * 获取基金列表（联动）
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			clearBuyMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var stock_code = fundStr;
			var entrust_bs="1";//认购、申购是买入、赎回是卖出
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
					"entrust_bs":entrust_bs,
					"stock_code":stock_code
			};
			service_fundETF.etfStockMaxBuyQuery(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
				var nav=results[0].price?results[0].price:"0";
				nav = Number(nav).toFixed(4);
				var curretPlate=changePlates();
				$(_pageId+".fundcode."+curretPlate+" #fundName").quzhi(results[0].stock_name);//基金名称
				$(_pageId+".fundcode."+curretPlate+" #fundNav").quzhi(nav);//基金净值
//				$(_pageId+".fundcode."+curretPlate+" #fundUnit").quzhi(results[0].buy_unit);//赎回单位
				$(_pageId+".fundcode."+curretPlate+" #fundUnit").quzhi(results[0].report_unit);//赎回单位
				$(_pageId+".fundcode."+curretPlate+" #maxNumber").quzhi(results[0].stock_max_amount);//可赎回数
				fundDataList=results[0];
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证赎回代码输入是否正确
		if(fundDataList.stock_code.length == 0){
			$.alert("请输入赎回代码");
			return false;
		}	
		if(fundDataList.stock_code.length != 6){
			$.alert("赎回代码输入错误");
			return false;
		}	
		//验证基金份额输入是否正确
		var curretPlate=changePlates();
		var fundNumber = $(_pageId+".fundcode."+curretPlate+" #fundNumber").val();
		if($.trim(fundNumber).length<=0){
			$.alert("请输入申购份额");
			return false;
		}else if(fundNumber=="0"){
			$.alert("申购份额不能为0");
			return false;
		}else if(!validata.isNumberFloat(fundNumber)||parseFloat(fundNumber)<0){
			$.alert("请正确输入申购份额");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["赎回代码 ", fundDataList.stock_code]);
		tipStrArray.push(["基金名称",fundDataList.stock_name]);
		tipStrArray.push(["赎回份额 ", fundNumber]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		
		common.iConfirm("下单确认",tipStr,function success(){
			var param = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"session_id":userInfo.session_id,
				"password":userInfo.password,
				"stock_code":fundDataList.stock_code,
				"exchange_type":fundDataList.exchange_type,
				"stock_account":fundDataList.stock_account,
				"entrust_amount":fundNumber,
				"entrust_price":fundDataList.price,
			};
			
			var inter="";
			if(changePlates()=="ordinaryETF"){//普通ETF
				inter="etfRedeemOther";
			}else if(changePlates()=="crossMarketETF"){//跨市场ETF
				inter="etfRedeemOther";
			}else if(changePlates()=="crossBorderETF"){//跨境ETF
				inter="etfRedeemOther";
			}
		    service_fundETF[inter](param,function(data){
		    	$.hidePreloader();
		    	getBuyCallBack(data,param);
		    },{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}});
			$.showPreloaders("请等待...");
		},function fail(){});
	}
	//申购回调
	function getBuyCallBack(data,param){
		if(data.error_no == 0){
			var results = data.results;
				if(results){
					$.alert("委托已经提交，委托编号："+results[0].entrust_no);
					clearBuyMsg();
					$(_pageId + "#fundCode").quzhi("");
				}
		}else{
			$.alert(data.error_info);
		}
	}
	
    function clearBuyMsg(){
    	fundDataList={};
		$(_pageId+"#fundName").quzhi("");//基金名称
		$(_pageId+"#fundNav").quzhi("");//基金净值
		$(_pageId+"#fundUnit").quzhi("");//申购单位
		$(_pageId+"#maxNumber").quzhi("");//可申购数
		$(_pageId+"#fundNumber").quzhi("");//申购份额
    }
    
	/**
	 * 销毁
	 */
	function destroy(){
		$.clearRequest();
		$(_pageId + ".tab_nav ul li").removeClass("active");
		$(_pageId + ".tab_nav ul li:eq(0)").addClass("active");
		$(_pageId+".fundcode").hide();
		$(_pageId+".fundcode.ordinaryETF").show();
		$(_pageId + "#fundCode").quzhi("");
		if(keyboard){
			keyboard.keyDestroy();
		}
		clearBuyMsg();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});