/**
 * ETF基金认购
 */
define('trade/scripts/fund/etfFund/etfSubscription.js', function (require, exports, module) {
    var _pageId = "#fund_etfFund_etfSubscription ";
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var keyboard = require("keyboard");
    var appropriate = require("appropriate");
    var service_fundETF = require("service_fundETF");
    require("validatorUtils");
    var validata = $.validatorUtils;
    var fundDataList = {};
    var cfgDataList = {};
    var userInfo = null;
    var fundcode = null;
    var exchange_type = null;
    var submitBtnName = {
        "0": "认购",
        "1": "网下现金认购",
        "2": "网下股票认购"
    };

    /**
     * 初始化
     */
    function init() {
        userInfo = common.getCurUserInfo();
        if (keyboard) {
            keyboard.keyInit();
        }
        var mainHeight = common.setMainHeight(_pageId, false);
        var param = $.getPageParam("param");
        // 接收外链传参
        fundcode = param && param.fundcode;
        exchange_type = param && param.exchange_type;
        if(fundcode){
            $(_pageId + "#fundCode").quzhi(fundcode);//基金名称
            getFundList(fundcode,exchange_type || '');
        }
    }

    function load() {
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + " .top_title .icon_back"), function (e) {
            $(this).unbind(e.type);
            this[e.type] = null;
            $(_pageId + " .cmpscode").hide();
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var param = $.getPageParam("param");
            if (param && param.form === 'mall') {
                $.callMessage({
                    "moduleName": "mall_trade",
                    "funcNo": "50114",
                });
            } else {
                $.pageBack();
            }
            e.stopPropagation();
            e.preventDefault();
        });

        //页面切换
        $.bindEvent($(_pageId + ".tab_nav ul li"), function (e) {
            $(_pageId + " .cmpscode").hide();
            $.clearRequest();
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + "#fundCode").quzhi("");
            clearBuyMsg();
            $(this).addClass("active").siblings().removeClass("active");
            $(_pageId + ".fundcode").hide();
            var $index = $(this).index();
            if ($index == 0) {
                $(_pageId + ".fundcode.onlineCash").show();
            } else if ($index == 1) {
                $(_pageId + ".fundcode.netCash").show();
            } else if ($index == 2) {
                $(_pageId + ".fundcode.offlineStock").show();
            }
            $(_pageId + ".applyvote .nocheck").html(submitBtnName[$index]);
        });

        //股票代码输入框监听
        $.bindEvent($(_pageId + " #fundCode"), function (e) {
            $(_pageId + " .cmpscode").hide();
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var curretPlate = changePlates();
            var fundCode = $(this).val();
            var fundNumber = $(_pageId + " #fundNumber").val();
            if (fundCode.length > 0 && fundNumber.length > 0) {
                $(_pageId + '.applyvote a').removeClass('btn-disable');
            } else {
                $(_pageId + '.applyvote a').addClass('btn-disable');
            }
            if (fundCode.length == 6) {
                getFundList(fundCode);
                if (keyboard) {
                    keyboard.closeKeyPanel();
                }
            } else {
                clearBuyMsg();
            }
            e.stopPropagation();
        }, "input");

        //认购份额输入框监听
        $.bindEvent($(_pageId + " #fundNumber"), function (e) {
            if (keyboard) {
                keyboard.popUpKeyboard($(this), e);
            }
            var fundNumber = $(this).val();
            var fundCode = $(_pageId + " #fundCode").val();
            if (fundCode.length > 0 && fundNumber.length > 0) {
                $(_pageId + '.applyvote a').removeClass('btn-disable');
            } else {
                $(_pageId + '.applyvote a').addClass('btn-disable');
            }
        }, "input");
        //点击成份股输入框
        $.bindEvent($(_pageId + " #cfgCode"), function (e) {
            if (keyboard) {
                keyboard.clickOpenKeyboard($(this), _pageId);
            }
            $(_pageId + " .cmpscode").show();
            e.stopPropagation();
        });

        //成份股代码输入框监听
        $.bindEvent($(_pageId + " #cfgCode"), function (e) {
            if (fundDataList && fundDataList.stock_code && fundDataList.stock_code.length > 0) {
                if (keyboard) {
                    keyboard.popUpKeyboard($(this), e);
                }
                var curretPlate = changePlates();
                var cfgCode = $(this).val();
                //第六位去查询接口
                if (cfgCode.length == 6) {
                    componentStockCodeQuery(cfgCode);
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    $(_pageId + ".cmpscode").hide();//成份股列表
                } else {
                    $(_pageId + " #cfgName").quzhi("");//成份股名称
                }
            } else {
                $.alert("请输入认购代码");
            }
            e.stopPropagation();
        }, "input");

        //下单
        $.bindEvent($(_pageId + ".applyvote .nocheck"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            vailSubmitOrder();
            e.stopPropagation();
        });

        //点击页面其他地方
        $.bindEvent($(_pageId), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId + " .cmpscode").hide();
        });
    }

    /*
     * 区分板块
     */
    function changePlates() {
        //网上现金
        if ($(_pageId + ".tab_nav ul li:eq(0)").hasClass("active")) {
            return "onlineCash";
        }
        //网下现金
        else if ($(_pageId + ".tab_nav ul li:eq(1)").hasClass("active")) {
            return "netCash";
        }
        //网下股票
        else if ($(_pageId + ".tab_nav ul li:eq(2)").hasClass("active")) {
            return "offlineStock";
        }
    }

    /**
     * 获取基金列表（联动）
     *
     */
    function getFundList(fundStr, exchange_type, stock_account) {
        if (fundStr != "" && fundStr.length == 6) {
            clearBuyMsg();
            var entrust_way = global.entrust_way; // 委托方式  在configuration配置
            var stock_code = fundStr;
            var entrust_bs = "0";//认购、申购是买入、赎回是卖出
            var branch_no = userInfo.branch_no;
            var fund_account = userInfo.fund_account;
            var cust_code = userInfo.cust_code;//关联资产账户标志
            var param = {
                "entrust_way": entrust_way,
                "branch_no": branch_no,
                "fund_account": fund_account,
                "cust_code": cust_code,
                "entrust_bs": entrust_bs,
                "stock_code": stock_code,
                "stock_account": stock_account,
                "exchange_type": exchange_type,
            };
            service_fundETF.etfStockMaxBuyQuery(param, getFundInfoBack);
        }
    }

    function getFundInfoBack(data) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results.length > 1) {
                var listDiv = "";
                for (var i = 0; i < results.length; i++) {
                    if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                    listDiv += "<p stock_code='" + results[i].stock_code + "' exchange_type='" + results[i].exchange_type + "' stock_account='" + results[i].stock_account + "'><span>" + results[i].stock_code + "</span>" + results[i].stock_name + "</p>";
                }
                $(_pageId + " .cmpscode1").html(listDiv);
                //				if($(_pageId+" .cmpscode p").length >= 4){
                //					$(_pageId+".cmpscode").css({"height":"1.8rem","overflow":"scroll"});
                //				}else{
                $(_pageId + ".cmpscode1").css({ "height": (2 * 0.45) + "rem" });
                //				}
                $(_pageId + " .cmpscode1").show();
                //列表选择事件
                $.bindEvent($(_pageId + " .cmpscode1 p"), function (e) {
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    $(_pageId + " .cmpscode1").hide();
                    var stockCode = $(this).attr("stock_code");
                    var exchangeType = $(this).attr("exchange_type");
                    var stockAccount = $(this).attr("stock_account");
                    getFundList(stockCode, exchangeType, stockAccount);
                    e.stopPropagation();
                });

            } else if (results && results.length > 0) {
                if ($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
                var curretPlate = changePlates();
                $(_pageId + ".fundcode." + curretPlate + " #fundName").quzhi(results[0].stock_name);//基金名称
                if (changePlates() == "onlineCash") {//网上现金
                    $(_pageId + ".fundcode." + curretPlate + " #fundUnit").quzhi(results[0].buy_unit);//后端没给字段
                } else if (changePlates() == "netCash") {//网下现金
                    $(_pageId + ".fundcode." + curretPlate + " #fundUnit").quzhi(results[0].cash_unit);
                } else if (changePlates() == "offlineStock") {//网下股票
                    $(_pageId + ".fundcode." + curretPlate + " #fundUnit").quzhi(results[0].stock_unit);
                }
                $(_pageId + ".fundcode." + curretPlate + " #maxNumber").quzhi(results[0].stock_max_amount);//可认购数
                fundDataList = results[0];
                //网下股票
                if (changePlates() == "offlineStock") {
                    componentStockCodeQuery();
                }
            } else {
                $.alert("该证券不支持此类交易");
            }
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * 下单验证
     *
     */
    function vailSubmitOrder() {
        //验证认购代码输入是否正确
        var stock_code = $(_pageId + " #fundCode").val();
        if (!stock_code || stock_code.length == 0) {
            $.alert("请输入认购代码");
            return false;
        }
        if (stock_code.length != 6) {
            $.alert("认购代码输入错误");
            return false;
        }
        var cfgCode = $(_pageId + "." + changePlates() + " #cfgCode").val();
        var cfgName = $(_pageId + "." + changePlates() + " #cfgName").val();
        //网下股票
        if (changePlates() == "offlineStock") {
            if (cfgCode.length == 0) {
                $.alert("请输入成份股代码");
                return false;
            }
            if (cfgCode.length != 6) {
                $.alert("成份股代码输入错误");
                return false;
            }
        }
        //验证基金份额输入是否正确
        var fundNumber = $(_pageId + "." + changePlates() + " #fundNumber").val();
        var tipName = (changePlates() == "offlineStock") ? "认购股数" : "认购份额";
        if ($.trim(fundNumber).length <= 0) {
            $.alert("请输入" + tipName);
            return false;
        } else if (fundNumber == "0") {
            $.alert(tipName + "不能为0");
            return false;
        } else if (!validata.isNumberFloat(fundNumber) || parseFloat(fundNumber) < 0) {
            $.alert("请正确输入" + tipName);
            return false;
        }
        var tipStrArray = [];
        tipStrArray.push(["认购代码 ", fundDataList.stock_code]);
        tipStrArray.push(["基金名称", fundDataList.stock_name]);
        //网下股票
        if (changePlates() == "offlineStock") {
            tipStrArray.push(["成分股代码 ", cfgCode]);
            tipStrArray.push(["成分股名称 ", cfgName]);
        }
        tipStrArray.push([tipName, fundNumber]);
        var tipStr = "<div >";
        tipStr += common.generatePrompt(tipStrArray);
        tipStr += "</div>";

        // common.iConfirm("网上现金认购确认", tipStr, function success() {
        var business_type = "6";
        var param = {
            "entrust_way": global.entrust_way,
            "branch_no": userInfo.branch_no,
            "fund_account": userInfo.fund_account,
            "cust_code": userInfo.cust_code,
            "session_id": userInfo.session_id,
            "password": userInfo.password,
            "fund_name": fundDataList.stock_name,
            "stock_code": fundDataList.stock_code,
            "exchange_type": fundDataList.exchange_type,
            "stock_account": fundDataList.stock_account,
            "entrust_price": fundDataList.price,
            "component_code": cfgCode,
            "entrust_amount": fundNumber,
            "business_type": business_type
        };

        appropriate.placeOrder({}, param, tipStr, function (instr_batch_no) {
            param.instr_batch_no = instr_batch_no;
            var inter = "";
            if (changePlates() == "onlineCash") {//网上现金
                inter = "onlineCashSubscription";
            } else if (changePlates() == "netCash") {//网下现金
                inter = "offlineCashSubscription";
            } else if (changePlates() == "offlineStock") {//网下股票
                inter = "offlineShareSubscription";
            }
            service_fundETF[inter](param, function (data) {
                $.hidePreloader();
                getBuyCallBack(data, param);
            }, {
                "isLastReq": false, "isShowWait": false,
                "timeOutFunc": function () {
                    $.hidePreloader();
                }, "errorFunc": function () {
                    $.hidePreloader();
                }
            });
            $.showPreloaders("请等待...");
        });
        // }, function fail() {
        // });
    }

    /*
     * 申购回调
     */
    function getBuyCallBack(data, param) {
        if (data.error_no == 0) {
            var results = data.results;
            if (results) {
                $.alert("委托已经提交，委托编号：" + results[0].entrust_no);
                appropriate.function399931({ serial_no: results[0].entrust_no });
                $(_pageId + "#fundCode").quzhi("");
                clearBuyMsg();
            }
        } else {
            $.alert(data.error_info);
        }
    }


    /**
     * ETF成份股代码查询
     * */
    function componentStockCodeQuery(component_code) {
        if (component_code) {
            $(_pageId + ".cmpscode").hide();
        } else {
            $(_pageId + ".cmpscode").html("").hide().css({ "height": "0rem" });//成份股列表
        }
        var param = {
            "entrust_way": global.entrust_way,
            "branch_no": userInfo.branch_no,
            "fund_account": userInfo.fund_account,
            "cust_code": userInfo.cust_code,
            "password": userInfo.password,
            "session_id": userInfo.session_id,
            "stock_code": fundDataList.stock_code,
            "exchange_type": fundDataList.exchange_type,
            "component_code": component_code,
        };
        service_fundETF.componentStockCodeQuery(param, function (data) {
            if (data.error_no == 0) {
                var results = data.results;
                if (results && results.length > 0) {
                    //如果是输满六位的时候，就直接填充
                    if (component_code) {
                        $(_pageId + "#cfgCode").quzhi(results[0].component_code);//成份股代码
                        $(_pageId + "#cfgName").quzhi(results[0].component_name);//成份股名称
                        $(_pageId + "#cfgMaxNumber").quzhi(results[0].enable_amount);//可用成份股
                    } else {
                        cfgDataList = results;
                        var eleHtml = "";
                        for (var i = 0; i < results.length; i++) {
                            eleHtml += "<p component_code='" + results[i].component_code + "' component_name='" + results[i].component_name + "'><span>" + results[i].component_code + "</span>" + results[i].component_name + "</p>";
                        }
                        $(_pageId + " .cmpscode2").html(eleHtml);//成份股列表
                        cfgBindEvent();
                    }
                } else {
                    if (component_code) {
                        $.alert("持仓暂无该成份股代码");
                    }
                }
            } else {
                $.alert(data.error_info);
            }
        });
    }

    /*
     * 成份股下拉列表高度以及事件
     */
    function cfgBindEvent() {
        if ($(_pageId + " .cmpscode2 p").length >= 4) {
            $(_pageId + ".cmpscode2").css({ "height": "1.8rem", "overflow": "scroll" });
        } else {
            $(_pageId + ".cmpscode2").css({ "height": (($(_pageId + " .cmpscode2 p").length) * 0.45) + "rem" });
        }
        $.bindEvent($(_pageId + " .cmpscode2 p"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            componentStockCodeQuery($(this).attr("component_code"));
            e.stopPropagation();
        });
    }

    /*
     * 清空页面
     */
    function clearBuyMsg() {
        fundDataList = {};
        cfgDataList = {};
        $(_pageId + "#fundName").quzhi("");//基金名称
        $(_pageId + "#fundUnit").quzhi("");//申购单位
        $(_pageId + "#maxNumber").quzhi("");//可申购数
        $(_pageId + "#fundNumber").quzhi("");//申购份额
        $(_pageId + " #cfgCode").quzhi("");//成份股代码
        $(_pageId + " #cfgName").quzhi("");//成份股名称
        $(_pageId + " #cfgMaxNumber").quzhi("");//可用成份股
        $(_pageId + ".cmpscode").html("").hide().css({ "height": "0rem" });//成份股列表
        $(_pageId + " .cmpscode1").html("").hide();
        $(_pageId + '.applyvote a').addClass('btn-disable');
    }

    /**
     * 销毁
     */
    function destroy() {
        $.clearRequest();
        $(_pageId + ".tab_nav ul li").removeClass("active");
        $(_pageId + ".tab_nav ul li:eq(0)").addClass("active");
        $(_pageId + ".fundcode").hide();
        $(_pageId + ".fundcode.onlineCash").show()
        $(_pageId + ".applyvote .nocheck").html(submitBtnName[0]);
        $(_pageId + "#fundCode").quzhi("");
        if (keyboard) {
            keyboard.keyDestroy();
        }
        clearBuyMsg();
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
