/**
 * ETF基金-历史查询
 */
define('trade/scripts/fund/etfFund/queryHistory.js', function(require, exports, module) {
    var _pageId = "#fund_etfFund_queryHistory ";
	var gconfig = $.config; 
	var global = gconfig.global;
    var publicQuery = require("publicQuery2");
    var commonStat = require("commonStat");
    var queryType="";
    var data = {
		"funcNo": "302108",
		"param": {},
		"history": true,
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_bs_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["委托份额", "entrust_amount"],
				["冻结解冻额", "prev_balance"],
				["委托编号", "entrust_no"],
				["委托状态", "entrust_state_name"],
				["委托时间", function(e){
					return e.init_date + " " + e.curr_time;
				}, {liCla: "full"}],
			],
		}
    }
    
    var data1 = {
    	"funcNo": "302115",
		"param": {},
		"history": true,
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_bs_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["成交份额", "business_amount"],
				["成交金额", "business_balance"],
				["成交编号", "business_no"],
				["成交时间", function(e){
					return e.business_date + " " + e.business_time;
				}],
			],
		}
    }
    
    /**
     * 初始化
     */
	function init(){
		var a = $.getPageParam();
		queryType = $.getPageParam("param");
		queryType = "entrust";
		if(queryType=="entrust"){
//			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			publicQuery.init(data);
			$(_pageId+".header h3").html("历史申赎委托");
		}else{
//			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			publicQuery.init(data1);
			$(_pageId+".header h3").html("历史申赎成交");
		}
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageInit("fund/etfFund/queryHistory","fund/etfFund/home",{},"left",true);
			e.stopPropagation();
			e.preventDefault();
		});
		 
		// 刷新
		$.bindEvent($(_pageId + " .header .top_title .icon_refresh"), function(e){
			if(queryType=="entrust"){
				publicQuery.againQuery(data.param,data.funcNo,data.htmlData,data.history);
			}
			else{
				publicQuery.againQuery(data1.param,data1.funcNo,data1.htmlData,data1.history);
			}
			e.stopPropagation();
		});
		
		//页面切换
//		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
//			$.clearRequest();
//			$(this).addClass("active").siblings().removeClass("active");
//			$(_pageId+" .cancel_order").html("");
//			$(_pageId+" .cancel_order").attr("style","");
//			if($(this).index() == 0){
//				publicQuery.againQuery(data.param,data.funcNo,data.htmlData,data.history);
//			}
//			else{
//				publicQuery.againQuery(data1.param,data1.funcNo,data1.htmlData,data1.history);
//			}
//		});
		
		publicQuery.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicQuery.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});