/**
 * 场外基金-定投查询
 */
define('trade/scripts/fund/fixedInvestment/fixedFundQuery.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var publicQuery = require("publicQuery");
	var _pageId = "#fund_fixedInvestment_fixedFundQuery ";
    var data = {
    	"funcNo" : "302039", //301503  302005
    	"pagingNum": 15,
    	"param" : {
    		fund_company:"",
    		fund_code:""
    	},
    	"history":false,
    	"htmlData" : {
	    	"topDiv":{
		  		"name":"fund_name",
		  		"code":"fund_code"
	    	},
	    	"liList":[
					["基金类型","fund_type_name"],
	    			["基金净值","nav"],
	    			["最低定投","min_timer_balance"],
	    			["基金状态","fund_status_name"],
			    	["风险等级","fund_risklevel_name","width:100%;"],
	    		],
    	}
    }
    var fundTypeData = [
    	{"id":"","name":"选择基金类型"},
    	{"id":"0","name":"股票类型"}
    ];
    var fundRiskData = [
    	{"id":"","name":"选择基金风险等级"},
    	{"id":"0","name":"低风险类型"}
    
    ];
	/**
	 * 初始化
	 */
	function init() {
		common.pageBuryingPoint("101217");
		if(keyboard) {
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		publicQuery.init(data);
	}

	function load() {
		publicQuery.load();
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e) {
			setTimeout(function () {
				//埋点
				common.comStat(101218, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("fund/fixedInvestment/fixedFundQuery", "fund/fixedInvestment/fixedInvestment", null, "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		$.bindEvent($(_pageId + ".pleasecode .row_01 i"), function(e) {
			var fundCode = $.trim($(_pageId + "#fundCode").val());
//			if(fundCode.length == 6){
				var param = data.param;
				param.fund_code = fundCode;  //根据基金代码查询
				$(_pageId+".cancel_order").html("");
				publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history);
//			}
			e.stopPropagation();
		});

		//股票代码输入框监听
		$.bindEvent($(_pageId + "#fundCode"), function(e) {
			if(keyboard) {
				keyboard.popUpKeyboard($(this), e);
			}
			var fundCode = $.trim($(this).val());
			if(fundCode.length == 6) {
				var param = data.param;
				param.fund_code = fundCode;  //根据基金代码查询
				$(_pageId+".cancel_order").html("");
				publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history,_pageId,null,queryCallback);
			} else if (fundCode.length == 0) {
				var param = data.param;
				param.fund_code = "";  //根据基金代码查询
				$(_pageId+".cancel_order").html("");
				publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history);
			} else {
				clearMsg();
			}
			e.stopPropagation();
		}, "input");
		
		//基金类型
// 		common.selectList($(_pageId + " #fundType span"),"选择基金类型",fundTypeData,function(obj){
// 			var param = data.param;
//			param.fund_type = obj.id;  //根据基金类型查询
//			publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history);
// 		});
		
		//风险等级
//		common.selectList($(_pageId + " #fundRisk span"),"选择基金风险等级",fundRiskData,function(obj){
//			var param = data.param;
//			param.fund_risk = obj.id;  //根据基金类型查询
//			publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history);
//		});
		
		$.preBindEvent($(_pageId + "#cancel_order_data"), ".part", function(e) {
			var param = {
				"fund_code":$(this).find(".title").find("small").text()
			};
			$.pageInit("fund/fixedInvestment/fixedFundQuery","fund/fixedInvestment/fixedInvestment",param,"left");
			e.stopPropagation();
		});
	}
	
	function queryCallback(data){
		//埋点
		common.comStat(101219,2,104,true,{"i_change_name":"证券代码输入","i_change_to":data[0].fund_name});
	}
	
	function clearMsg() {
		data.param.fund_code="";
	}

	/**
	 * 数据重置
	 */
	function destroy() {
		common.pageBuryingPoint();
		if(keyboard) {
			keyboard.keyDestroy();
		}
		clearMsg();
		$(_pageId + "#fundCode").val('');
		publicQuery.destroy();
	}

	var base = {
		"init": init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});