/**
 * 场外基金-定投下单
 */
define('trade/scripts/fund/fixedInvestment/fixedInvestment.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var commonFunc = require("commonFunc");
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
    var appropriate = require("appropriate");
		require("validatorUtils");
	var validata = $.validatorUtils;
	var myScroller = null; // 滑动组件对象
	var _pageId = "#fund_fixedInvestment_fixedInvestment ";
	var userInfo=null;
//	var downslide = new (require("downslide")).Downslide();
	var fund_info = {
		"pay_cycle_unit":"0",//扣款周期(月是0；周是1) //扣款周期单位
		"pay_cycle_rate":"1",//扣款周期频率(每月和每周是1，每两周是2) //扣款周期频率
		"littlePeriod":"0", //每月扣款日
		"qmTypeDate":"0",
		"bigPeriodId":"0",
	};
	var bigPeriod = [
    	{"id":"0","name":"每月"},
    	{"id":"1","name":"每周"},
    	{"id":"2","name":"每两周"}
    ];
	var littlePeriod = {
		"0": [
		    	{"id":"0","name":"每月1号"},{"id":"1","name":"每月2号"},{"id":"2","name":"每月3号"},{"id":"3","name":"每月4号"},
		    	{"id":"4","name":"每月5号"},{"id":"5","name":"每月6号"},{"id":"6","name":"每月7号"},{"id":"7","name":"每月8号"},
		    	{"id":"8","name":"每月9号"},{"id":"9","name":"每月10号"},{"id":"10","name":"每月11号"},{"id":"11","name":"每月12号"},
		    	{"id":"12","name":"每月13号"},{"id":"13","name":"每月14号"},{"id":"14","name":"每月15号"},{"id":"15","name":"每月16号"},
		    	{"id":"16","name":"每月17号"},{"id":"17","name":"每月18号"},{"id":"18","name":"每月19号"},{"id":"19","name":"每月20号"},
		    	{"id":"20","name":"每月21号"},{"id":"21","name":"每月22号"},{"id":"22","name":"每月23号"},{"id":"23","name":"每月24号"},
		    	{"id":"24","name":"每月25号"},{"id":"25","name":"每月26号"},{"id":"26","name":"每月27号"},{"id":"27","name":"每月28号"}
	    ],
		"1": [
		    	{"id":"0","name":"星期一"},{"id":"1","name":"星期二"},{"id":"2","name":"星期三"},{"id":"3","name":"星期四"},{"id":"4","name":"星期五"}
	    ],
		"2": [
		    	{"id":"0","name":"星期一"},{"id":"1","name":"星期二"},{"id":"2","name":"星期三"},{"id":"3","name":"星期四"},{"id":"4","name":"星期五"}
	    ]
	};
	var qmTypeDate = [
		{"id":"0","name":"设置定投日期"},
		{"id":"1","name":"累计金额上限"},
		{"id":"2","name":"累计金额次数"}
	];
	var mainHeight = "";
	var slideHeight = "";
	var queryEntrustInfo = [];  //查询的结果
	var pageNum = global.pagingNum || 15; //分页 每页数目
	var position_str = "";//柜台定位串
	var intResults = "";//当前页条数
	var dataResults = "";//后端接口不能分页时有值
	var orderParam="";//下单参数
    var comStatParam={};
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var slideHeight = null;
	var load_finished=false;
    var noticeToInvestors = require("noticeToInvestors");
    /**
     * 初始化
     */
	function init(){
//		downslide.addSlide();
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo=common.getCurUserInfo();
		if($.getPageParam("param") == "query"){
			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			$(_pageId+" #query").show();
			$(_pageId+" .fund_form2").hide();
			common.pageBuryingPoint("101170");
		}else{
			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			$(_pageId+" .fund_form2").show();
			$(_pageId+" #query").hide();
			common.pageBuryingPoint("101197");
		}
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		mainHeight =  common.setMainHeight(_pageId, false);
		slideHeight = mainHeight- $(_pageId+".date_filter").height();
//		downslide.slideInit(slideHeight, downQuery, pullQuery);
		common.initTimeChoice(_pageId,0,true,$.getTradingDay(0, "yyyy-MM-dd"),$.getTradingDay(0, "yyyy-MM-dd"));
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryCapital();
		if($.getPageParam("param") == "query"){
			querySetDateEntrust();
		}else{
			if($.getPageParam("fund_code")){
				getFundList($.getPageParam("fund_code"));
			}
		}
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
		};
		//最后一个为超时处理函数
		service_fund.queryFundSelect1(param,queryCapitalCallback,{"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results[0]){
					$(_pageId+".fund_form2 .applyvote p em").text(Number(results[0].enable_balance).toFixed(2));//可用
				}else{
					$(_pageId+".fund_form2 .applyvote p em").text("--");//可用
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}

	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			clearMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";
			var branch_no = userInfo.branch_no;
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"fund_company":fund_company,
				"fund_code":fund_code
			};
			service_fund.queryFixFund(param,getFundInfoBack);
		}
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
//				$(_pageId + ".fund_form2 .applyvote a").removeClass("nocheck");
				var nav=results[0].nav!=""?results[0].nav:"0";
				var fundCompany = results[0].fund_company;
				var fund_code = $.trim(results[0].fund_code);
				$(_pageId+"#fundName").text(results[0].fund_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").text(nav);
				$(_pageId +".fund_form2 #noinput").hide();
				$(_pageId +".fund_form2 #activeInput .tips").text(results[0].fund_risklevel_name || "--");
				$(_pageId +".fund_form2 #activeInput span").text(fund_code);
				//最低定投金额
				$(_pageId +".fund_form2 #eachMoney").setPlaceholder("最低定投金额"+results[0].min_timer_balance);
				$(_pageId +".fund_form2 #activeInput").show();
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}


	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId +".fund_form2 #activeInput span").text());
		if(buy_stockCode.length == 0 || buy_stockCode=="--"){
			$.alert("请选择基金代码");
			return false;
		}
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#eachMoney").val();
		if($.trim(now_price).length<=0){
			$.alert("请输入定投金额");
			return false;
		}else if(now_price=="0"){
			$.alert("定投金额不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入定投金额");
			return false;
		}
		var en_fund_date = Number(fund_info.littlePeriod) + 1;
		var en_fund_date_text1 = bigPeriod[fund_info.bigPeriodId].name;
		var en_fund_date_text2 = littlePeriod[fund_info.bigPeriodId][fund_info.littlePeriod].name;
		var tipStrArray = [];
		tipStrArray.push(["基金名称", $(_pageId+" #fundName").text()]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["期满类型 ", qmTypeDate[fund_info.qmTypeDate].name]);
		if(fund_info.qmTypeDate=="0"){
			//对定投选择时间选择验证
			var today=new Date(new Date().toDateString());
			if(!$(_pageId+"#startInput").val()||!$(_pageId+"#endInput").val()){
				$.alert("请选择时间");
				return false;
			}
			var startDate=new Date($(_pageId+"#startInput").val().toString());
			var endDate=new Date($(_pageId+"#endInput").val().toString());
			if(startDate.getTime()<today.getTime()){
				$.alert("开始日期只能是当日或当日以后");
				return false;
			}
			if(startDate.getTime()>endDate.getTime()){
				$.alert("开始日期必须小于结束日期");
				return false;
			}
			tipStrArray.push(["开始日期 ", $(_pageId+"#startInput").val()]);
			tipStrArray.push(["结束日期 ", $(_pageId+"#endInput").val()]);
		}else if(fund_info.qmTypeDate=="1"){
			var max_ration_balance = $(_pageId+"#max_ration_balance").val();
			if(Number(max_ration_balance == "0")){
				$.alert("累计金额不能为0");
				return false;
			}else if(Number(max_ration_balance) - Number(now_price) < 0){
				$.alert("定投金额不能大于累计金额");
				return false;
			}
			tipStrArray.push(["累计金额 ", max_ration_balance]);
		}else if(fund_info.qmTypeDate=="2"){
			var max_ration_times=$(_pageId+"#max_ration_times").val();
			if(Number(max_ration_times) <= 0){
				$.alert("累计次数必须大于0");
				return false;
			}
			tipStrArray.push(["累计次数 ", max_ration_times]);
		}
		tipStrArray.push([en_fund_date_text1+"扣款日 ",en_fund_date_text2]);
		tipStrArray.push(["定投金额 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray, "", "list");
		tipStr += "</div>";
//		common.iConfirm("下单确认",tipStr,function success(){
			var param={
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"password":userInfo.password,
				"session_id":userInfo.sessionid,
				"fund_company":$(_pageId+"#fundName").attr("data-fundCom"),
			}
			noticeToInvestors.function399901(param,function(){
				var start_date = $(_pageId+"#startInput").val();
				var end_date = $(_pageId+"#endInput").val();
				var ration_type = fund_info.qmTypeDate; //期满类型
				ration_type != "0" ? (end_date="") : "";
				var orderParam = {
					"entrust_way":global.entrust_way,
					"branch_no":userInfo.branch_no,
					"fund_account":userInfo.fund_account,
					"cust_code":userInfo.cust_code,
					"session_id":userInfo.session_id,
					"stock_code":buy_stockCode,
					"business_type": "2",
					"exchange_type": $(_pageId+"#fundName").attr("data-fundCom"),
					"fund_company":$(_pageId+"#fundName").attr("data-fundCom"),
					"fund_code":buy_stockCode,
					"fund_name": $(_pageId+" #fundName").text(),
					"flag":"",
					"balance":now_price,
					"start_date":start_date,
					"end_date":end_date,
					"en_fund_date":en_fund_date,
					"ration_type":ration_type,
					"max_ration_balance":$(_pageId+"#max_ration_balance").val() || "",
					"max_ration_times":$(_pageId+"#max_ration_times").val() || "",
					"pay_cycle_unit":fund_info.pay_cycle_unit,//扣款周期单位(月是0；周是1)
					"pay_cycle_rate":fund_info.pay_cycle_rate,//扣款周期频率(每月和每周是1，每两周是2)
					"isFixedFlag":true
				};
				appropriate.placeOrder(comStatParam,orderParam,tipStr,function(instr_batch_no){
					orderParam.instr_batch_no = instr_batch_no;
					service_fund.setDateEntrust1(orderParam, entrustCallBack,{"isShowOverLay":false,"isShowWait":false,
					"timeOutFunc":function(){
						$.hidePreloader();
					},"errorFunc":function(){
						$.hidePreloader();
					}});
					$.showPreloaders("请等待...");
				});
			});
//		},function fail(){
//		});
	}

	function entrustCallBack(data) {
		$.hidePreloader();
		if(data.error_no=="0"){
			var results=data.results;
			if(results&&results.length>0){
				$.alert("下单成功，委托号"+results[0].serial_no);
				$(_pageId +".fund_form2 #activeInput span").text("");//清空定投代码
				clearMsg();
				$(_pageId +".fund_form2 #noinput").show();
				$(_pageId +".fund_form2 #activeInput").hide();
				queryCapital();
				appropriate.function399931({serial_no:results[0].serial_no});
			}
		}
		else{
			$.alert(data.error_info);
		}
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				if ($(_pageId + ".toggle_nav ul li.active").index() == 0) {
					common.comStat(101171, 2, 103, true, {"i_group_name": "返回"});
				} else {
					common.comStat(101198, 2, 103, true, {"i_group_name": "返回"});
				}
				$.pageInit("fund/fixedInvestment/fixedInvestment", "fund/outside/order", "", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//点击基金代码
		$.bindEvent($(_pageId + "#fund_code").add($(_pageId+" #activeInput em")).add($(_pageId+" #activeInput span")), function(e){
			common.comStat(101199,2,103,true,{"i_group_name":"选择定投代码"});
			$.pageInit("fund/fixedInvestment/fixedInvestment","fund/fixedInvestment/fixedFundQuery");
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId + ".kkr"), function(e){
			$.alert("扣款日如遇非交易日，则顺延至下一个交易日",null,null,"知道了");
			e.stopPropagation();
		});
		
		// tab切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index() == 1){
				$(_pageId+" .fund_form2").show();
				$(_pageId+" #query").hide();
				common.pageBuryingPoint();
				common.pageBuryingPoint("101197");
			}
			else{
				destroy();
				common.pageBuryingPoint("101170");
//				clearMsg();
				$(_pageId +".fund_form2 #noinput").show();
				$(_pageId +".fund_form2 #activeInput").hide();
				$(_pageId+" .fund_form2").hide();
				$(_pageId+" #query").show();
//				downslide.slideDestroy();
				queryEntrustInfo = [];
				slideHeight = mainHeight- $(_pageId+".date_filter").height();
//				downslide.slideInit(slideHeight, downQuery, pullQuery);
				querySetDateEntrust();
			}
		});
		
	 	
		//选择定投周期
		common.selectList($(_pageId + " #bigPeriod"),"选择定投时间",bigPeriod,function(obj){
	 		var statName="";
			$(_pageId + " #bigPeriod").html(obj.name+"<i></i>");
			fund_info.bigPeriodId=obj.id;
			fund_info.littlePeriod = "0";  //根据基金类型查询
			
			common.selectList($(_pageId + " #littlePeriod"),"选择定投时间",littlePeriod[obj.id],function(obj){
				$(_pageId + " #littlePeriod").html(obj.name+"<i></i>");
				fund_info.littlePeriod = obj.id;  //根据基金类型查询
				
				//埋点
				if(fund_info.pay_cycle_unit=="0"&&fund_info.pay_cycle_rate=="1"){//月
					statName=obj.name;
				}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="1"){//每周
					statName="每周"+obj.name;
				}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="2"){//每两周
					statName="每两周"+obj.name;
				}
				common.comStat(101200,2,104,true,{"i_change_name":"定投周期","i_change_to":statName});
	 		});
	 		//扣款周期
			if(obj.id=="0"){//月
	 			$(_pageId + " #littlePeriod").html("每月1号<i></i>");
	 			fund_info.pay_cycle_unit="0";
	 			statName="1号";
			}
			else{//周
	 			$(_pageId + " #littlePeriod").html("星期一<i></i>");
	 			fund_info.pay_cycle_unit="1";
	 			statName="星期一";
			}
			//扣款频率
	 		if(obj.id=="0"||obj.id=="1"){//每周或者每月，扣款频率为1
	 			fund_info.pay_cycle_rate ="1";
	 		}else{
	 			fund_info.pay_cycle_rate ="2";
	 		}
			//埋点
			common.comStat(101200,2,104,true,{"i_change_name":"定投周期","i_change_to":obj.name+statName});
   		});
   		
		//选择扣款日期
 		common.selectList($(_pageId + " #littlePeriod"),"选择定投时间",littlePeriod[0],function(obj){
			$(_pageId + " #littlePeriod").html(obj.name+"<i></i>");
			fund_info.littlePeriod = obj.id;  //根据基金类型查询
 		});
 		
	 	$(_pageId + " #bigPeriod").html("每月<i></i>");
	 	$(_pageId + " #littlePeriod").html("每月1号<i></i>");
	 	
 		//选择期满类型
 		common.selectList($(_pageId + " #qmTypeDate"),"选择期满类型",qmTypeDate,function(obj){
			fund_info.qmTypeDate = obj.id;
			$(_pageId+"#max_ration_balance").quzhi("");
			$(_pageId+"#max_ration_times").quzhi("");
			$(_pageId + " #qmTypeDate").html(obj.name+"<i></i>");
			$(_pageId + ".data-qmTypeDate").hide();
			$(_pageId + ".data-qmTypeDate[data-qmTypeDate='"+obj.id+"']").show();
			//埋点
			common.comStat(101201,2,104,true,{"i_change_name":"期满类型","i_change_to":obj.name});
 		});


		//股票代码输入框监听
		$.bindEvent($(_pageId+"#fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $.trim($(this).val());
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearMsg();
			}
			e.stopPropagation();
		},"input");

		//定投金额——保留两位小数
		$.bindEvent($(_pageId+" #eachMoney"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var input_val=$(this).val();
			if(input_val&&input_val!=null&&input_val!=""&&input_val!=undefined){
				var n=(input_val.split('.')).length-1;
				if(n>1){
//					input_val=input_val.replace(".","");
					input_val=input_val.substring(0,input_val.length-1);
				}
				var valName=input_val.split('.')[1];
				if(valName&&valName.length>2){
					input_val=input_val.substring(0,input_val.length-1);
				}
			}
			$(_pageId+" #eachMoney").quzhi(input_val);
		},"input");
		
		//累计金额——保留两位小数
		$.bindEvent($(_pageId+" #max_ration_balance"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var input_val=$(this).val();
			if(input_val&&input_val!=null&&input_val!=""&&input_val!=undefined){
				var n=(input_val.split('.')).length-1;
				if(n>1){
//					input_val=input_val.replace(".","");
					input_val=input_val.substring(0,input_val.length-1);
				}
				var valName=input_val.split('.')[1];
				if(valName&&valName.length>2){
					input_val=input_val.substring(0,input_val.length-1);
				}
			}
			$(_pageId+" #max_ration_balance").quzhi(input_val);
		},"input");
		
		//勾选协议
		$.bindEvent($(_pageId+" #rule_check").add($(_pageId+" #rule_check .a1")),function (e) {
			if($(_pageId+" #rule_check").hasClass("on")){
				$(_pageId+" #rule_check").removeClass("on");
			}else{
				$(_pageId+" #rule_check").addClass("on");
			}
			e.stopPropagation();
		},"tap");
		
		//打开协议
		$.bindEvent($(_pageId+" .agreementClass .btn"),function (e) {
			agreementQuery();
			e.stopPropagation();
		},"tap");
		
		//定投下单
		$.bindEvent($(_pageId+" .applyvote .ce_btn"),function (e) {
//			if(!$(this).hasClass("nocheck")){
				//埋点
				common.comStat(101202,2,103,true,{"i_group_name":"定投提交"});
				if(keyboard){
					keyboard.closeKeyPanel();
				};
				if($(_pageId+" #rule_check").hasClass("on")){
					vailSubmitOrder();
				}else{
					$.alert("请同意并签署《定期定额基金投资计划协议书》");
					return false;
				}
				
//			}
			e.stopPropagation();
		},"click");
		//绑定事件
//		bindQueryEvent();
	}
	
	function bindQueryEvent(){
		$.bindEvent($(_pageId+" #query .termbtn .stop"), function(e) {
			//埋点
			common.comStat(101172,2,103,true,{"i_group_name":"终止定投"});
			var idx = $(this).parents(".part").index();
			var entrustInfo = queryEntrustInfo[idx];
			var tipStrArray = [];
			tipStrArray.push(["基金名称", entrustInfo.fund_name]);
			tipStrArray.push(["基金代码 ", entrustInfo.fund_code]);
			tipStrArray.push(["定投金额 ", entrustInfo.balance]);
			var tipStr = "<div >";
			tipStr += common.generatePrompt(tipStrArray);
			tipStr += "</div>";
			common.iConfirm("终止定投确认",tipStr,function success(){
				var cust_code = userInfo.cust_code;	//客户代码
				var fund_account = userInfo.fund_account;	//资产账户
				var branch_no  = userInfo.branch_no;	//分支机构
				var session_id=userInfo.session_id;
				var entrust_way = global.entrust_way; // 委托方式  在configuration配置
				var fund_company = entrustInfo.fund_company;
				var fund_code=entrustInfo.fund_code;
				var en_fund_date = entrustInfo.en_fund_date;
				var allotno = entrustInfo.allotno; 
				var stock_account = entrustInfo.stock_account; 
				var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"session_id":session_id,
					"fund_company":fund_company,
					"fund_code":fund_code,
					"en_fund_date":en_fund_date,
					"allotno":allotno,
					"stock_account":stock_account
				};
				service_fund.stopFundEntrust(param, stopEntrustCallBack,{"isShowOverLay":false,"isShowWait":false,
							"timeOutFunc":function(){
								$.hidePreloader();
							},"errorFunc":function(){
								$.hidePreloader();
							}});
						$.showPreloaders("请等待...");
				},function fail(){
			});
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId+" #query .termbtn .update"),function(e) {
			//埋点
			common.comStat(101173,2,103,true,{"i_group_name":"修改定投"});
			var idx = $(this).parents(".part").index();
			var entrustInfo = queryEntrustInfo[idx];
			var param = {
				fund_code : entrustInfo.fund_code,//基金代码
				en_fund_date : entrustInfo.en_fund_date,//扣款日
				allotno : entrustInfo.allotno, //申请编号
				ration_type : entrustInfo.ration_type,//期满类型
				balance :entrustInfo.balance,//定投金额
				start_date : entrustInfo.start_date,//开始时间
				end_date : entrustInfo.end_date,//结束时间
				max_ration_balance: entrustInfo.max_ration_balance,//最大定投金额  
				max_ration_times : entrustInfo.max_ration_times,//最大定投次数
				pay_cycle_unit : entrustInfo.pay_cycle_unit,//扣款周期
				pay_cycle_rate : entrustInfo.pay_cycle_rate,//扣款频率
				en_fund_date : entrustInfo.en_fund_date,//扣款日
			};
			$.pageInit("fund/fixedInvestment/fixedInvestment","fund/fixedInvestment/updateFixedFund",param);
			e.stopPropagation();
		},"tap");
	}
	
	 function stopEntrustCallBack(data) {
		$.hidePreloader();
		if(data.error_no=="0"){
			var results=data.results;
			if(results&&results.length>0){
				$.alert("定投委托已提交，委托号"+results[0].serial_no);
			}
		}else{
			$.alert(data.error_info);
		}
		downQuery();
	}
	 
	function downQuery(){
		position_str = "";
		$(_pageId+" .fund_cast").html("");
		querySetDateEntrust();
	}
	
	function pullQuery(){
		if($.isValue(dataResults)){
			callsUpHandler(); //后端不支持分页时进入
		}else{
			position_str = $(_pageId + " .fund_cast .shrik").last().attr("position_str") || "";
			querySetDateEntrust();
		}
	}
	
	function callsUpHandler(){
		var results = dataResults;
		var t = results.length;
		var i = intResults;
		if(results && t > 0 && i < t){
			var html = [];
			for (;i < t && i < (intResults + pageNum); i++){
				 html.push(queryEntrustHtml(results[i]));
			}
			intResults = i;
			var cancel_order = $(_pageId+".fund_cast");
			cancel_order.append(html.join(""));
			if(cancel_order.height() < slideHeight){
				cancel_order.height(slideHeight);
			}
			else{
				cancel_order.attr("style","");
			}
		}
		bindQueryEvent();
//		downslide.slideRefresh();
		
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
		if(intResults == t){
//			downslide.loadFinished();
			loadFinished();
		}
	}
	//查询基金定投
	function querySetDateEntrust() {
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var session_id=userInfo.session_id;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"session_id":session_id,
			"entrust_way":entrust_way,
			"request_num":pageNum,
			"position_str":position_str
		}
		service_fund.fundInvestmentQuery1(param,queryCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+" .fund_cast").html("");
				common.setNoData(true,"暂无记录");
//				downslide.slideRefresh();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		})
	}
	
	function queryCallBack(data) {
		if (typeof(data) != "undefined" && data) {
//			queryEntrustInfo = "";
			dataResults = "";
			intResults = 0;
//			$(_pageId+".fund_cast").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				var r = results.length;
				var minLen = r;
				if(r>0 && results!= "undefined"){
					var html = "";
					if(r > pageNum && pageNum != "0"){    //前端自动分页
						queryEntrustInfo = results;
						dataResults = $.cloneFun(results);
						minLen = pageNum;
						intResults = pageNum;
					}else{
						dataResults = "";
						intResults = 0;
						results.forEach(function(ele){
							queryEntrustInfo.push(ele);
						});
					}
					for (var i=0; i < minLen ;i++){
						html += queryEntrustHtml(results[i],i);
					}
					if(r < pageNum){
//						downslide.loadFinished();
						loadFinished();
					}
					$(_pageId+".fund_cast").append(html);
					bindQueryEvent();
					common.setNoData(false,"暂无记录");
//					downslide.slideRefresh();
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}

				}else{
//					downslide.slideRefresh();
//					downslide.loadFinished();
//					downslide.hidePullUp();
					common.setNoData(true);
//					downslide.hidePullUp();
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}
					loadFinished();
				}
			}
			else{
				$.alert(data.error_info);
//				downslide.slideRefresh();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		}
	}

	function queryEntrustHtml(element,i) {
		var eleHtml = "";
		eleHtml+="<div class=\"part shrik\" position_str='" + (element.position_str || '') + "' >";
		eleHtml+="<div class=\"title\"><strong>"+element.fund_name+" </strong><small>"+element.fund_code+"</small></div>";
		eleHtml+="<ul>";
		eleHtml+="<li style='text-align: left;'><span>定投金额</span><p style='font-size:0.14rem'>"+element.balance+"</p></li>";
		eleHtml+="<li style='text-align: left;'><span>当前定投金额</span><p style='font-size:0.14rem'>"+element.curr_ration_balance+"</p></li>";
		eleHtml+="<li style='text-align: left;'><span>开始日期</span><p style='font-size:0.14rem'>"+element.start_date+"</p></li>";
		if(element.ration_type=="0"){//设定结束日期
			eleHtml+="<li style='text-align: left;'><span>结束日期</span><p style='font-size:0.14rem'>"+element.end_date+"</p></li>";
		}
		else if(element.ration_type=="1"){//累计金额上限
			eleHtml+="<li style='text-align: left;'><span>最大定投金额</span><p style='font-size:0.14rem'>"+element.max_ration_balance+"</p></li>";
		}
		else if(element.ration_type=="2"){//累计成功次数
			eleHtml+="<li style='text-align: left;'><span>最大定投次数</span><p style='font-size:0.14rem'>"+element.max_ration_times+"</p></li>";
		}
		
		eleHtml+="<li style='text-align: left;'><span>下次扣款日</span><p style='font-size:0.14rem'>"+element.next_pay_date+"</p></li>";
		var withdrawingDate="";
		//月
		if(element.pay_cycle_unit=="0"&&element.pay_cycle_rate=="1"){
			withdrawingDate="每月"+element.en_fund_date+"号";
		}
		//每周
		else if(element.pay_cycle_unit=="1"&&element.pay_cycle_rate=="1"){
			withdrawingDate="每周周"+element.en_fund_date;
		}
		//每两周
		else if(element.pay_cycle_unit=="1"&&element.pay_cycle_rate=="2"){
			withdrawingDate="每两周周"+element.en_fund_date;
		}
		eleHtml+="<li style='text-align: left;'><span>扣款允许日</span><p style='font-size:0.14rem'>"+withdrawingDate+"</p></li>";
		
		
		
		eleHtml+="</ul>";
		eleHtml+="<p class=\"termbtn clearfix\">";
		eleHtml+="<a href=\"javascript:void(0);\" class=\"stop\" data-index=\""+i+"\">终止</a>";
		eleHtml+="<a href=\"javascript:void(0);\" class=\"update\" data-index=\""+i+"\">修改</a>";
		eleHtml+="</p>";
		eleHtml+="</div>";
		return eleHtml;
	}

	//协议查询
	function agreementQuery() {
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var session_id=userInfo.session_id;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"session_id":session_id,
			"entrust_way":entrust_way,
		}
		service_fund.agreementQuery(param,agreementQueryCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				common.setNoData(true,"暂无记录");
			}
		})
	}
	
	function agreementQueryCallBack(data) {
		if (typeof(data) != "undefined" && data) {
			if(data.error_no == 0){
				var result=data.results;
				agreementQueryDiv(result[0].text_content);
			}else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 适当性弹出框div
	 * @param {Object} data 适当性查询接口返回数据
	 */
	function agreementQueryDiv(data){
		var div = '<div class="appropriate agreementQuery"><header class="header">';
    		div += '<div class="top_title">';
        	div += '<a href="javascript:void(0);" class="icon_back"></a>';
        	div += '<h3>定期定额基金投资计划协议书</h3>';
        	div += '</div>';
    		div += '</header>';
    		div += '<section class="main">';
    		div += '<div class="iscroll_vWrapper" id="wrapper" style="position: relative;">';
        	div += '<div class="iscroll_vScroller">';
            div += '<div class="vertical_list" data-is-content="true" style="padding: 10px;background: #ffffff;">';
            div += data;
    		div += '</div>';
    		div += '</div>';
    		div += '</section></div>';
    		
		$(_pageId).append(div);
		$(_pageId + " .appropriate").show();
		
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId + " .agreementQuery .header").height(), // 滚动组件的高度
			$wrapper: $(_pageId + " .appropriate #wrapper"),
			scrollbars: true, // 隐藏滚动条
			hasPullDown: false, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			bounceTime: 300 // 回弹的动画时间
		};
		iscrollUtils.vScroller(scrollOptions);
		
		// 返回
		$.bindEvent($(_pageId + " .agreementQuery .header .icon_back"), function(e){
			$(_pageId + " .agreementQuery").remove();
			e.stopPropagation();
		});
	}

	function clearMsg() {
		$(_pageId+"#eachMoney").quzhi("");
		$(_pageId+".fund_cast").html("");
		$(_pageId+"#fundNav").text("--");
		$(_pageId+"#fundName").text("--");
		fund_info.littlePeriod = "0"; //每月定投日
//		fund_info.qmTypeDate = "0";
		$(_pageId +".fund_form2 #eachMoney").setPlaceholder("最低定投金额--");
		$(_pageId+"#max_ration_balance").quzhi("");
		$(_pageId+"#max_ration_times").quzhi("");
		$(_pageId+" #rule_check").removeClass("on");
//		$(_pageId+"#selectPayDate p").text("请选择扣款日");
	}

	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		load_finished=false;
	 	$(_pageId + " #qmTypeDate").html("设置定投日期<i></i>");
		$(_pageId + ".data-qmTypeDate").hide();
		$(_pageId + ".data-qmTypeDate[data-qmTypeDate='0']").show();
		fund_info = {
			"pay_cycle_unit":"0",//扣款周期(月是0；周是1) //扣款周期单位
			"pay_cycle_rate":"1",//扣款周期频率(每月和每周是1，每两周是2) //扣款周期频率
			"littlePeriod":"0", //每月扣款日
			"qmTypeDate":"0",
			"bigPeriodId":"0",
		};
		if(keyboard){
			keyboard.keyDestroy();
		}
//		downslide.slideDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		clearMsg();
		$(_pageId +".fund_form2 #noinput").show();
		$(_pageId +".fund_form2 #activeInput").hide();
		$(_pageId+".fund_cast").html("");
		queryEntrustInfo = [];
		position_str = "";//柜台定位串
		intResults = "";
		dataResults = "";
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller(){
		var hasPullUp = true;
		if(!global.pagingNum || global.pagingNum == 0){
			hasPullUp = false;
		}
		var scrollOptions = {
			scrollerHeight: slideHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + "#query #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: hasPullUp, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				downQuery(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
				if(!load_finished){
					pullQuery();
				}else{
					if(myScroller){
						myScroller.refresh();
					}
					loadFinished();
				}
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	function loadFinished(){
		load_finished = true;
		$(_pageId+" .iscroll_pullUp").html("<div class='load_finished'>已经没有数据了</div>");
	};
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});