/**
 * 场外基金-定投下单
 */
define('trade/scripts/fund/fixedInvestment/updateFixedFund.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var commonFunc = require("commonFunc");
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
		require("validatorUtils");
	var validata = $.validatorUtils;
	var myScroller = null; // 滑动组件对象
	var _pageId = "#fund_fixedInvestment_updateFixedFund ";
	var userInfo=null;
	var downslide = new (require("downslide")).Downslide();
	var payDate="1";
	var fund_info = {
		"pay_cycle_unit":"0",//扣款周期(月是0；周是1) //扣款周期单位
		"pay_cycle_rate":"1",//扣款周期频率(每月和每周是1，每两周是2) //扣款周期频率
		"littlePeriod":"0",//每月扣款日
		"qmTypeDate":"0",//期满类型
		"bigPeriodId":"0",
		"allotno":"" ,   //申请编号
	};
	var bigPeriod = [
    	{"id":"0","name":"每月"},
    	{"id":"1","name":"每周"},
    	{"id":"2","name":"每两周"},
    ];
	var littlePeriod = {
		"0": [
		    	{"id":"0","name":"每月1号"},{"id":"1","name":"每月2号"},{"id":"2","name":"每月3号"},{"id":"3","name":"每月4号"},
		    	{"id":"4","name":"每月5号"},{"id":"5","name":"每月6号"},{"id":"6","name":"每月7号"},{"id":"7","name":"每月8号"},
		    	{"id":"8","name":"每月9号"},{"id":"9","name":"每月10号"},{"id":"10","name":"每月11号"},{"id":"11","name":"每月12号"},
		    	{"id":"12","name":"每月13号"},{"id":"13","name":"每月14号"},{"id":"14","name":"每月15号"},{"id":"15","name":"每月16号"},
		    	{"id":"16","name":"每月17号"},{"id":"17","name":"每月18号"},{"id":"18","name":"每月19号"},{"id":"19","name":"每月20号"},
		    	{"id":"20","name":"每月21号"},{"id":"21","name":"每月22号"},{"id":"22","name":"每月23号"},{"id":"23","name":"每月24号"},
		    	{"id":"24","name":"每月25号"},{"id":"25","name":"每月26号"},{"id":"26","name":"每月27号"},{"id":"27","name":"每月28号"}
	    ],
		"1": [
		    	{"id":"0","name":"星期一"},{"id":"1","name":"星期二"},{"id":"2","name":"星期三"},{"id":"3","name":"星期四"},{"id":"4","name":"星期五"}
	    ],
		"2": [
		    	{"id":"0","name":"星期一"},{"id":"1","name":"星期二"},{"id":"2","name":"星期三"},{"id":"3","name":"星期四"},{"id":"4","name":"星期五"}
	    ]
	};
	var qmTypeDate = [
		{"id":"0","name":"设置定投日期"},
		{"id":"1","name":"累计金额上限"},
		{"id":"2","name":"累计金额次数"}
	];
	var mainHeight = "";
	var queryEntrustInfo = "";
	var en_fund_date="";
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101183");
		downslide.addSlide();
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo=common.getCurUserInfo();
		$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		mainHeight =  common.setMainHeight(_pageId, false);
		var slideHeight = mainHeight- $(_pageId+".date_filter").height();
//		downslide.slideInit(slideHeight,querySetDateEntrust);
		common.initTimeChoice(_pageId,0,true,$.getTradingDay(0, "yyyy-MM-dd"),$.getTradingDay(0, "yyyy-MM-dd"));
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryCapital();
		if($.getPageParam("fund_code")){
			getFundList($.getPageParam("fund_code"));
			fund_info.allotno = $.getPageParam("allotno"); //申请编号
			var pay_cycle_unit = $.getPageParam("pay_cycle_unit");//扣款周期
			var pay_cycle_rate = $.getPageParam("pay_cycle_rate");//扣款频率
			en_fund_date = $.getPageParam("en_fund_date");//扣款日
			fund_info.pay_cycle_unit = pay_cycle_unit;
			fund_info.pay_cycle_rate = pay_cycle_rate;
			fund_info.littlePeriod = Number(en_fund_date)-1;//日期
			
			//月
			if(pay_cycle_unit=="0"&&pay_cycle_rate=="1"){
				fund_info.bigPeriodId=0;
			}
			//每周
			else if(pay_cycle_unit=="1"&&pay_cycle_rate=="1"){
				fund_info.bigPeriodId=1;
			}
			//每两周
			else if(pay_cycle_unit=="1"&&pay_cycle_rate=="2"){
				fund_info.bigPeriodId=2;
			}
			if(en_fund_date){
				$(_pageId + " #bigPeriod").html(bigPeriod[fund_info.bigPeriodId]["name"]+"<i></i>");
//				$(_pageId + " #bigPeriod").data("picker").value=bigPeriod[fund_info.bigPeriodId]["name"];
				
				//选择扣款日期
		 		common.selectList($(_pageId + " #littlePeriod"),"选择定投时间",littlePeriod[fund_info.bigPeriodId],function(obj){
					$(_pageId + " #littlePeriod").html(obj.name+"<i></i>");
					fund_info.littlePeriod = obj.id;  //根据基金类型查询
					
					//埋点
					if(fund_info.pay_cycle_unit=="0"&&fund_info.pay_cycle_rate=="1"){//月
						statName=obj.name;
					}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="1"){//每周
						statName="每周"+obj.name;
					}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="2"){//每两周
						statName="每两周"+obj.name;
					}
					common.comStat(101185,2,104,true,{"i_change_name":"定投周期","i_change_to":statName});
			 	});
	 	
				$(_pageId + " #littlePeriod").html(littlePeriod[fund_info.bigPeriodId][en_fund_date-1]["name"]+"<i></i>");
				$(_pageId + " #littlePeriod").data("picker").value=littlePeriod[fund_info.bigPeriodId][en_fund_date-1]["name"];
			}
			setPageParam();
		}
	}
	
	/*
	 * 设置页面参数
	 */
	function setPageParam(){
		fund_info.qmTypeDate = $.getPageParam("ration_type");//期满类型
		$(_pageId + " #eachMoney").quzhi($.getPageParam("balance"));//定投金额
		if(fund_info.qmTypeDate){
			$(_pageId + " #qmTypeDate").html(qmTypeDate[fund_info.qmTypeDate].name+"<i></i>");
			$(_pageId + ".data-qmTypeDate").hide();
			$(_pageId + ".data-qmTypeDate[data-qmTypeDate='"+qmTypeDate[fund_info.qmTypeDate].id+"']").show();
			//设置定投日期
			if(fund_info.qmTypeDate=="0"){
				$(_pageId + " #startInput").val($.getPageParam("start_date"));
				$(_pageId + " #startInput").data("picker").value=$.getPageParam("start_date");
				$(_pageId + " #endInput").val($.getPageParam("end_date"));
				$(_pageId + " #endInput").data("picker").value=$.getPageParam("end_date");
			}//累计金额上限
			else if(fund_info.qmTypeDate=="1"){
				//最大定投金额  
				$(_pageId+"#max_ration_balance").quzhi($.getPageParam("max_ration_balance"));
			}//累计金额次数
			else if(fund_info.qmTypeDate=="2"){
				//最大定投次数
				$(_pageId+"#max_ration_times").quzhi($.getPageParam("max_ration_times"));
			}
		}
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
		};
		//最后一个为超时处理函数
		service_fund.queryFundSelect1(param,queryCapitalCallback,{"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results[0]){
					$(_pageId+".fund_form2 .applyvote p em").text(Number(results[0].enable_balance).toFixed(2));//可用
				}else{
					$(_pageId+".fund_form2 .applyvote p em").text("--");//可用
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			clearMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";
			var branch_no = userInfo.branch_no;
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"fund_company":fund_company,
				"fund_code":fund_code
			};
			service_fund.queryFixFund(param,getFundInfoBack);
		}
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
//				$(_pageId + ".fund_form2 .applyvote a").removeClass("nocheck");
				var nav=results[0].nav!=""?results[0].nav:"0";
				var fundCompany = results[0].fund_company;
				var fund_code = $.trim(results[0].fund_code);
				$(_pageId+"#fundName").text(results[0].fund_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").text(nav);
				$(_pageId +".fund_form2 #activeInput .tips").text(results[0].fund_risklevel_name || "--");
				$(_pageId +".fund_form2 #activeInput span").text(fund_code);
				$(_pageId +".fund_form2 #eachMoney").setPlaceholder("最低定投金额"+results[0].min_timer_balance);
				$(_pageId +".fund_form2 #activeInput").show();
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}


	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId +".fund_form2 #activeInput span").text());
		if(buy_stockCode.length == 0){
			$.alert("请选择基金代码");
			return false;
		}
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#eachMoney").val();
		if($.trim(now_price).length<=0){
			$.alert("请输入定投金额");
			return false;
		}else if(now_price=="0"){
			$.alert("定投金额不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入定投金额");
			return false;
		}
		var en_fund_date = Number(fund_info.littlePeriod) + 1;
		var en_fund_date_text1 = bigPeriod[fund_info.bigPeriodId].name;
		var en_fund_date_text2 = littlePeriod[fund_info.bigPeriodId][fund_info.littlePeriod].name;
		var tipStrArray = [];
		tipStrArray.push(["基金名称", $(_pageId+" #fundName").text()]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["期满类型 ", qmTypeDate[fund_info.qmTypeDate].name]);
		if(fund_info.qmTypeDate=="0"){
			//对定投选择时间选择验证
			var today=new Date(new Date().toDateString());
			if(!$(_pageId+"#startInput").val()||!$(_pageId+"#endInput").val()){
				$.alert("请选择时间");
				return false;
			}
			var startDate=new Date($(_pageId+"#startInput").val().toString());
			var endDate=new Date($(_pageId+"#endInput").val().toString());
			if(startDate.getTime()<today.getTime()){
				$.alert("开始日期只能是当日或当日以后");
				return false;
			}
			if(startDate.getTime()>endDate.getTime()){
				$.alert("开始日期必须小于结束日期");
				return false;
			}
			tipStrArray.push(["开始日期 ", $(_pageId+"#startInput").val()]);
			tipStrArray.push(["结束日期 ", $(_pageId+"#endInput").val()]);
		}else if(fund_info.qmTypeDate=="1"){
			var max_ration_balance = $(_pageId+"#max_ration_balance").val();
			if(Number(max_ration_balance) == "0"){
				$.alert("累计金额不能为0");
				return false;
			}else if(Number(max_ration_balance) < Number(now_price)){
				$.alert("定投金额不能大于累计金额");
				return false;
			}
			tipStrArray.push(["累计金额 ", max_ration_balance]);
		}else if(fund_info.qmTypeDate=="2"){
			var max_ration_times=$(_pageId+"#max_ration_times").val();
			if(Number(max_ration_times) <= 0){
				$.alert("累计次数必须大于0");
				return false;
			}
			tipStrArray.push(["累计次数 ", max_ration_times]);
		}
		tipStrArray.push([en_fund_date_text1+"扣款日 ",en_fund_date_text2]);
		tipStrArray.push(["定投金额 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		common.iConfirm("下单确认",tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no  = userInfo.branch_no;	//分支机构
			var session_id=userInfo.session_id;
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_company=$(_pageId+"#fundName").attr("data-fundCom");
			var fund_code=buy_stockCode;
			var balance=now_price;
			var start_date = $(_pageId+"#startInput").val();
			var end_date = $(_pageId+"#endInput").val();
			var ration_type = fund_info.qmTypeDate; //期满类型
			var max_ration_balance = $(_pageId+"#max_ration_balance").val() || "";
			var max_ration_times = $(_pageId+"#max_ration_times").val() || "";
			var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"flag":"",
				"balance":balance,
				"start_date":start_date,
				"end_date":end_date,
				"en_fund_date":en_fund_date,
				"ration_type":ration_type,
				"max_ration_balance":max_ration_balance,
				"max_ration_times":max_ration_times,
				"allotno" : fund_info.allotno,
				"pay_cycle_unit" : fund_info.pay_cycle_unit,//扣款周期
				"pay_cycle_rate" : fund_info.pay_cycle_rate,//扣款频率
				"en_fund_date" : en_fund_date,//扣款日
			};
			service_fund.updateFixFundEntrust(param, entrustCallBack,{"isShowOverLay":false,"isShowWait":false,
						"timeOutFunc":function(){
							$.hidePreloader();
						},"errorFunc":function(){
							$.hidePreloader();
						}});
					$.showPreloaders("请等待...");
		},function fail(){
		});
	}

	function entrustCallBack(data) {
		$.hidePreloader();
		if(data.error_no=="0"){
			var results=data.results;
			if(results&&results.length>0){
				$.alert("定投委托已提交，委托号"+results[0].serial_no,function(){
					$.pageInit("fund/fixedInvestment/updateFixedFund","fund/fixedInvestment/fixedInvestment",{"param":"query"},"left");
				});
			}
		}else{
			$.alert(data.error_info);
		}
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				//埋点
				common.comStat(101184, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("fund/fixedInvestment/updateFixedFund", "fund/fixedInvestment/fixedInvestment", {"param": "query"}, "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//选择定投周期
		common.selectList($(_pageId + " #bigPeriod"),"选择定投时间",bigPeriod,function(obj){
	 		var statName="";
			$(_pageId + " #bigPeriod").html(obj.name+"<i></i>");
			fund_info.bigPeriodId=obj.id;
			fund_info.littlePeriod = "0";  //根据基金类型查询
			
			common.selectList($(_pageId + " #littlePeriod"),"选择定投时间",littlePeriod[obj.id],function(obj){
				$(_pageId + " #littlePeriod").html(obj.name+"<i></i>");
				fund_info.littlePeriod = obj.id;  //根据基金类型查询
				
				//埋点
				if(fund_info.pay_cycle_unit=="0"&&fund_info.pay_cycle_rate=="1"){//月
					statName=obj.name;
				}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="1"){//每周
					statName="每周"+obj.name;
				}else if(fund_info.pay_cycle_unit=="1"&&fund_info.pay_cycle_rate=="2"){//每两周
					statName="每两周"+obj.name;
				}
				common.comStat(101185,2,104,true,{"i_change_name":"定投周期","i_change_to":statName});
	 		});
	 		//扣款周期
			if(obj.id=="0"){//月
	 			$(_pageId + " #littlePeriod").html("每月1号"+"<i></i>");
	 			fund_info.pay_cycle_unit="0";
	 			statName="1号";
			}
			else{//周
	 			$(_pageId + " #littlePeriod").html("星期一"+"<i></i>");
	 			fund_info.pay_cycle_unit="1";
	 			statName="星期一";
			}
			//扣款频率
	 		if(obj.id=="0"||obj.id=="1"){//每周或者每月，扣款频率为1
	 			fund_info.pay_cycle_rate ="1";
	 		}else{
	 			fund_info.pay_cycle_rate ="2";
	 		}
			//埋点
			common.comStat(101185,2,104,true,{"i_change_name":"定投周期","i_change_to":obj.name+statName});
   		});
   		
	 	
	 	//定投扣款日
	 	$.bindEvent($(_pageId + ".kkr"), function(e){
			$.alert("扣款日如遇非交易日，则顺延至下一个交易日",null,null,"知道了");
			e.stopPropagation();
		});
 		//选择期满类型
// 		common.selectList($(_pageId + " #qmTypeDate"),"选择期满类型",qmTypeDate,function(obj){
//			fund_info.qmTypeDate = obj.id;
//			$(_pageId+"#max_ration_balance").quzhi("");
//			$(_pageId+"#max_ration_times").quzhi("");
//			$(_pageId + " #qmTypeDate").html(obj.name+"<i></i>");
//			$(_pageId + ".data-qmTypeDate").hide();
//			$(_pageId + ".data-qmTypeDate[data-qmTypeDate='"+obj.id+"']").show();
//			console.log(fund_info);
//			//埋点
//			common.comStat(101186,2,104,true,{"i_change_name":"期满类型","i_change_to":obj.name});
// 		});
 		

		//定投下单
		$.bindEvent($(_pageId+" .applyvote .ce_btn"),function (e) {
//			if(!$(this).hasClass("nocheck")){
				//埋点
				common.comStat(101187,2,103,true,{"i_group_name":"修改定投提交"});
				if(keyboard){
					keyboard.closeKeyPanel();
				};
				vailSubmitOrder();
//			}
			e.stopPropagation();
		},"click");
		
		//定投金额——保留两位小数
		$.bindEvent($(_pageId+" #eachMoney"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var input_val=$(this).val();
			if(input_val&&input_val!=null&&input_val!=""&&input_val!=undefined){
				var n=(input_val.split('.')).length-1;
				if(n>1){
//					input_val=input_val.replace(".","");
					input_val=input_val.substring(0,input_val.length-1);
				}
				var valName=input_val.split('.')[1];
				if(valName&&valName.length>2){
					input_val=input_val.substring(0,input_val.length-1);
				}
			}
			$(_pageId+" #eachMoney").quzhi(input_val);
			e.stopPropagation();
		},"input");
		
		//累计金额——保留两位小数
		$.bindEvent($(_pageId+" #max_ration_balance"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var input_val=$(this).val();
			if(input_val&&input_val!=null&&input_val!=""&&input_val!=undefined){
				var n=(input_val.split('.')).length-1;
				if(n>1){
//					input_val=input_val.replace(".","");
					input_val=input_val.substring(0,input_val.length-1);
				}
				var valName=input_val.split('.')[1];
				if(valName&&valName.length>2){
					input_val=input_val.substring(0,input_val.length-1);
				}
			}
			$(_pageId+" #max_ration_balance").quzhi(input_val);
			e.stopPropagation();
		},"input");
	}

	function clearMsg() {
		$(_pageId+"#eachMoney").quzhi("");
		$(_pageId+"#fundNav").text("--");
		$(_pageId+"#fundName").text("--");
		fund_info.littlePeriod = "0"; //每月定投日
		fund_info.allotno = "";
		fund_info.qmTypeDate = "0";
		$(_pageId +".fund_form2 #eachMoney").setPlaceholder("最低定投金额--");
		$(_pageId+"#max_ration_balance").quzhi("");
		$(_pageId+"#max_ration_times").quzhi("");
	}

	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		fund_info = {
			"pay_cycle_unit":"0",//扣款周期(月是0；周是1) //扣款周期单位
			"pay_cycle_rate":"1",//扣款周期频率(每月和每周是1，每两周是2) //扣款周期频率
			"littlePeriod":"0",//每月扣款日
			"qmTypeDate":"0",//期满类型
			"bigPeriodId":"0",
			"allotno":"" ,   //申请编号
		};
		if(keyboard){
			keyboard.keyDestroy();
		}
		downslide.slideDestroy();
		clearMsg();
		queryEntrustInfo = "";
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});