/**
 * 分级基金-撤单
 */
define('trade/scripts/fund/grading/cancel.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_fund = require("service_fund");
    var _pageId = "#fund_grading_cancel ";
    var userInfo = null;
    var stock_code = "";
    var stock_num = "";  
    var stock_direction = "";
    var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101555");
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		userInfo = common.getCurUserInfo();
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(gconfig.triggerEventName);
				this[gconfig.triggerEventName] = null;
//			$.pageInit("stock/stockCancel","account/index",{});
				common.comStat(101556, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack("fund/grading/order", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	
	function backgroundInterface(){
		queryCancellation(); // 可撤单查询
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}
    
	/**
	 * 可撤单查询
	 */
	function queryCancellation(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid
		};
		// 每次查询前,先将暂无数据隐藏
		$(_pageId + ".no_data").hide();
		// 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_fund.floorQueryTrustData(param,queryTrustDataCallback,
		{ // 传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			$(_pageId + ".main .fund_list2").html("");
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var data = "";
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						data += queryTrustDataHTML(results[i],i);
					}
					$(_pageId + ".main .fund_list2").html(data);
					$(_pageId+ ".no_data").hide();
					// 撤单事件
					$.bindEvent($(_pageId+".fund_list2 .part"), function(e){
						//埋点
						common.comStat(101558,2,103,true,{"i_group_name":"选择撤单"});
						var $this = $(this);
						var tipStrArray = [];
						tipStrArray.push(["基金代码", $this.find("h5 small").text()]);
						tipStrArray.push(["委托类型 ", $this.find("ul li").eq(0).find("span").text()]);
						tipStrArray.push(["委托份额 ", $this.find("ul li").eq(2).find("span").text()]);
						tipStrArray.push(["委托金额 ", $this.find("ul li").eq(3).find("span").text()]);
						var tipStr = "<div >";
						tipStr += common.generatePrompt(tipStrArray);
						tipStr += "</div>";
						//埋点数据
						var comStatParam={
							"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
							"i_stock_code":$this.find("h5 small").text(), // 股票代码
							"i_stock_name":$this.find("h5 em").text(), // 股票名称
							"i_entrust_prop":"", // 委托属性
							"i_exchange_type":$this.attr("fund_company"), // 交易市场
							"i_entrust_price":$this.find("ul li").eq(3).find("span").text(), // 选择后的价格
							"i_entrust_amount":$this.find("ul li").eq(2).find("span").text(), // 委托数量
						}
						common.iConfirm("确认撤单",tipStr,function(){
							cancellation($this); // 确认撤单
							comStatParam.i_oper = "1"; // 动作（1确定 2取消）
				        	common.comStat(101559,2,3,false,comStatParam);
						},function(){
							comStatParam.i_oper = "2"; // 动作（1确定 2取消）
				        	common.comStat(101559,2,3,false,comStatParam);
						});
						e.stopPropagation();
					},"tap");
				}else{
					$(_pageId + ".no_data").show();
					$(_pageId + ".visc_pullUp").hide();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var price_digit = 3;
		var css = "";
		var eleHtml = "";
      	eleHtml +='<div class="part" entrust_no="'+element.entrust_no+'" fund_company="'+element.exchange_type+'">';
        eleHtml +='<div class="title"><span class="time">'+element.entrust_state_name+'</span>';
        eleHtml +='<h5><em>'+element.stock_name+'</em> <small>'+element.stock_code+'</small></h5></div><ul>';
       	eleHtml +='<li>委托类型  <span>'+element.entrust_type_name+'</span></li>';
        eleHtml +='<li>委托时间  <span>'+element.curr_time+'</span></li>';
       	eleHtml +='<li>委托数量  <span>'+Number(element.entrust_amount)+'</span></li>';
        eleHtml +='<li>委托面值  <span>'+Number(element.entrust_price).toFixed(price_digit)+'</span></li>';
        eleHtml +='</ul></div>';
		return eleHtml;
	}

	/**
	 * 确定撤单
	 */
	function cancellation($div){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code; // 关联资产账户标志
		var sessionid = userInfo.session_id;
		var batch_flag = "0";
		var entrust_no = $div.attr("entrust_no");
		var fund_code = $div.find("h5 small").text();
		var allot_date = $div.find("ul li").eq(1).text();
		var fund_company = $div.attr("fund_company");
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
		    "entrust_no" : entrust_no,
		    "batch_flag" : "0",
		    "exchange_type" : fund_company
		};
		service_fund.postCancelOrder(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					$.alert("撤单已提交",function(){
						queryCancellation(); //刷新页面重新加载数据
					});
				}
			}else{  
				$.alert(data.error_info,function(){queryCancellation();});
			}
		}else{
			$.alert("撤单失败",function(){queryCancellation();});
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() - 1, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				common.comStat(101557,2,102,true,{"i_direct":"1","i_type":"1"});
				queryCancellation(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	/**
	 * 销毁
	 */
	function destroy(){
	    stock_code = "";
	    stock_num = "";  
	    stock_direction = "";
		$(_pageId + ".main .fund_list2").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});