/**
 * 分级基金-基金合并
 */
define('trade/scripts/fund/grading/merge.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var appropriate = require("appropriate");
	var common = require("common");
	var _pageId = "#fund_grading_merge ";
    var service_fund = require("service_fund");
    var userInfo= null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var listData = {};
	var fundInfo = {};
	var keyboard = require("keyboard");

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101503");
		if(keyboard){
			keyboard.keyInit();
		}
		jumpPageEvent();
		userInfo = common.getCurUserInfo();
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				if (keyboard) {
					keyboard.closeKeyPanel();
				}
				$(this).unbind(e.type);
				this[e.type] = null;
				//埋点
				common.comStat(101504, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack("fund/grading/order", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr,exchangeType){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		if(fundStr!= "" && fundStr.length==6){
			clearBuyMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var entrust_bs="27";
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
					"entrust_bs":entrust_bs,
					"fund_code":fund_code,
					"exchange_type":exchangeType,
			};
			service_fund.gradingSplitMergeQuery(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length ==1){
				if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
				$(_pageId+"#fund_stock_list").html("");
				var nav=results[0].price!=""?results[0].price:"0";
                var fundCompany = results[0].exchange_type;
				$(_pageId+"#fundName").val(results[0].stock_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").val(nav).attr("data-account",results[0].stock_account);
				$(_pageId+"#purchaseLimit").val(Number(results[0].merge_amount));
				$(_pageId+" .fund_split h5 em").text(Number(results[0].merge_amount));//可用
			}
			else if(results && results.length > 0){
				var selectHeight = 0.44*results.length;
				if(results.length >= 5){
					selectHeight = 5 * 0.44;
				}
				var html='<ul style="height:'+selectHeight+'rem">';
				for (var i=0;i<results.length;i++) {
					if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
					html+='<li>';
					html+='<a href="javascript:void(0);">';
					html+='<strong>'+results[i].stock_code+'</strong>'+results[i].stock_name+'</a>';
					html+='<span style="display:none;">'+results[i].exchange_type+'</span>';
					html+='</li>';
				}
				html+='</ul>';
				$(_pageId+"#fund_stock_list").html(html);
				$.bindEvent($(_pageId + "#fund_stock_list ul li"),function(e){
					var exchangeType = $(this).find("span").text();
					var fundCode = $(this).find("strong").text();
					getFundList(fundCode,exchangeType);
					e.stopPropagation();
				});
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#fundCode").val());
		if(buy_stockCode.length == 0){
			$.alert("请输入基金代码");
			return false;
		}	
		if(buy_stockCode.length != 6){
			$.alert("基金代码输入错误");
			return false;
		}	
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#fundSum").val();
		var can_buy = $(_pageId+".fund_split h5 em").text();
		if($.trim(now_price).length<=0){
			$.alert("请输入合并数量");
			return false;
		}else if(now_price=="0"){
			$.alert("合并数量不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入合并数量");
			return false;
		}else if(Number(now_price)>Number(can_buy)){
			$.alert("合并数量超过最多可以合并数量");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["基金名称", $(_pageId+" #fundName").val()]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["合并数量 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		//埋点数据
		var comStatParam={
			"objectId":"101506",
			"actionId":"3",
			"i_entrust_bs":"27", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":buy_stockCode, // 股票代码
			"i_stock_name":$(_pageId+" #fundName").val(), // 股票名称
			"i_entrust_prop":"LFM", // 委托属性
			"i_exchange_type":$(_pageId+"#fundName").attr("data-fundCom"), // 交易市场
			"i_entrust_price":$(_pageId+"#fundNav").val() || "1", // 选择后的价格
			"i_entrust_amount":now_price, // 委托数量
		}
//		common.iConfirm("下单确定",tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no  = userInfo.branch_no;	//分支机构
			var sessionid=userInfo.sessionid;
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_company=$(_pageId+"#fundName").attr("data-fundCom");
			var fund_code=buy_stockCode;
			var balance=now_price;
	        var entrust_price = $(_pageId+"#fundNav").val() || "1"; //收费方式
			var business_type = "3";
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"sessionid":sessionid,
					"exchange_type":fund_company,
					"fund_code":fund_code,
					"stock_code":fund_code,
					"entrust_bs":"27",
					"stock_account":$(_pageId+"#fundNav").attr("data-account"),
					"entrust_amount":balance,
	                "entrust_price":entrust_price,
	                "business_type":business_type,
	                "entrust_prop":'LFM'
				};
				appropriate.placeOrder(comStatParam,param,tipStr,function(instr_batch_no){
					param.instr_batch_no = instr_batch_no;
					service_fund.gradingSplitMerge(param,function(data){
			    		$.hidePreloader();
			    		getBuyCallBack(data,param);
			    	},{"isLastReq":false,"isShowWait":false,
						"timeOutFunc":function(){
							$.hidePreloader();
						},"errorFunc":function(){
							$.hidePreloader();
						}});
					$.showPreloaders("请等待...");
				});
//			    service_fund.gradingSplitMerge(param,function(data){
//			    	getBuyCallBack(data,param);
//			    });
//			},function fail(){
//		});
	}
	//申购回调
	function getBuyCallBack(data,param){
		if(data.error_no == 0){
			var results = data.results;
				if(results){
					$(_pageId+"#fundSum").quzhi("");
					$.alert("委托已经提交，委托编号："+results[0].entrust_no,function(){
						var fundCode = $.trim($(_pageId+"#fundCode").val());
						getFundList(fundCode);
					});
				}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//股票代码输入框监听
		$.bindEvent($(_pageId+"#fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $.trim($(this).val());
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearBuyMsg();
			}
			e.stopPropagation();
		},"input");
		
		//申购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//埋点
			common.comStat(101505,2,103,true,{"i_group_name":"合并提交"});
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		//全部
		$.bindEvent($(_pageId + ".fund_form2 .all .all_btn"), function(e){
			var purchaseLimit = $(this).prev("input").val();
			$(_pageId + "#fundSum").val(purchaseLimit);
			e.stopPropagation();
		});
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId+"#fundName").attr("data-fundCom","");
		$(_pageId+"#fund_stock_list").html("");
		$(_pageId+" .fund_split h5 em").text("--");//可用
//		$(_pageId + " .input_text input").slice(1).val("");
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundNav").val("");
		$(_pageId + "#fundSum").quzhi("");
		$(_pageId+"#purchaseLimit").val("");
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		if(keyboard){
			keyboard.keyDestroy();
		}
		clearBuyMsg();
		$(_pageId + "#fundCode").quzhi("");
		common.pageBuryingPoint();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});