/**
 * 分级基金-申购
 */
define('trade/scripts/fund/inside/etfOfflineStockSubscribe.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#fund_inside_etfOfflineStockSubscribe ";
    var service_fund = require("service_fund");
    var userInfo = null;

    /**
     * 初始化
     */
	function init(){
		jumpPageEvent();
		userInfo = common.getCurUserInfo();
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageBack();
			e.stopPropagation();
		});
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
		};
		//最后一个为超时处理函数
		service_fund.queryFundSelect(param,queryCapitalCallback,{"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results[0]){
					$(_pageId+".fund_form2 .limit em").text(Number(results[0].enable_balance).toFixed(2));//可用
				}else{
					$(_pageId+".fund_form2 .limit em").text("--");//可用
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			clearBuyMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var entrust_bs="20";
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
					"entrust_bs":entrust_bs,
					"fund_code":fund_code
			};
			service_fund.queryStockMaxBuy(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
				var nav=results[0].price!=""?results[0].price:"0";
                var fundCompany = results[0].exchange_type;
				$(_pageId+"#fundName").val(results[0].stock_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").val(nav).attr("data-account",results[0].stock_account);
				$(_pageId+"#purchaseLimit").val(results[0].stock_max_amount);
				$(_pageId+".fund_form2 .limit em").text(Number(results[0].enable_balance).toFixed(2));//可用
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}

	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//股票代码输入框监听
		$.bindEvent($(_pageId+"#fundCode"), function(e){
			var fundCode = $.trim($(this).val());
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearMsg();
			}
			e.stopPropagation();
		},"input");
		
		//申购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		//全部
		$.bindEvent($(_pageId + ".fund_form2 .all .all_btn"), function(e){
			var purchaseLimit = $(this).prev("input").val();
			$(_pageId + "#fundSum").val(purchaseLimit);
			e.stopPropagation();
		});
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearMsg(){
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		clearMsg();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});