/**
 * Created by sizhe on 2016/11/19.
 */
/**
 * 场外基金--历史查询
 */
define('trade/scripts/fund/inside/fundQueryHistory.js', function(require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_fund = require("service_fund");
    var _pageId = "#fund_inside_fundQueryHistory ";
    var userInfo = null;

    /**
     * 初始化
     */
    function init(){
		common.pageBuryingPoint("101363");
        userInfo = common.getCurUserInfo();
        commonFunc.initTimeChoice(_pageId,6,true);
        callsQuery();
    }

    function load(){
        var mianHeight = common.setMainHeight(_pageId, false);
    }
    /**
     * 事件绑定
     */
    function bindPageEvent(){
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			//埋点
			common.comStat(101364,2,103,true,{"i_group_name":"返回"});
            $.pageInit("fund/inside/fundQueryHistory","fund/inside/index",{"history":true},"left",true);
            e.stopPropagation();
        });
        //时间选择
        $.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			//埋点
			common.comStat(101366,2,103,true,{"i_group_name":"查询"});
            callsQuery();
        });
    }

    /**
     * 调用查询
     */
    function callsQuery(){
        $(_pageId+".fund_list2").html("");
        queryEntrust();
    }

    /**
     * 委托查询
     */
    function queryEntrust(){
        var entrust_way=global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid=userInfo.session_id;
        var end_time = $(_pageId+" #endDate").text();
        var begin_time = $(_pageId+" #startDate").text();	//截止时间
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
            "begin_time":begin_time,
            "end_time":end_time
        };
        $(_pageId+ ".no_data").hide();
        service_fund.floorQueryHistory(param,queryEntrustCallback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "timeOutFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data){
        if (typeof(data) != "undefined" && data) {
            $(_pageId+".main .fund_list2").html("");
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                if(results.length>0 && results!= "undefined"){
                    var html = '';
                    for (var i=0;i<results.length;i++){
                        if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i],i);
                    }
                    $(_pageId+ ".main .fund_list2").html(html);
                    $(_pageId+ ".no_data").hide();
                }else{
                    $(_pageId+".no_data").show();
                }
            }
            else{
                $.alert(data.error_info);
            }
        }
        else{
            $.alert("查询失败");
        }
        if(!myScroller){
            initScroller();
        }else{
            myScroller.refresh();
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element,i){
        var price_digit = 2;
        var css = "";
        var eleHtml = "";
        eleHtml +='<div class="part">';
        eleHtml +='<div class="title">';
        eleHtml +='<h5>'+element.stock_name+' <small>'+element.stock_code+'</small></h5></div><ul>';
        eleHtml +='<li>委托类型  <span>'+element.entrust_type_name+'</span></li>';
        eleHtml +='<li>委托状态  <span>'+element.entrust_state_name+'</span></li>';
        eleHtml +='<li>委托数量  <span>'+Number(element.entrust_amount)+'</span></li>';
        eleHtml +='<li>委托价格 <span>'+Number(element.entrust_price).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托编号 <span>'+element.entrust_no+'</span></li>';
        eleHtml +='<li class="full">委托时间 <span>'+element.init_date+" "+element.curr_time+'</span></li>';
        eleHtml +='</ul></div>';
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal(){
        var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var end_time = $(_pageId+" #endDate").text();
        var begin_time = $(_pageId+" #startDate").text();	//截止时间
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
            "begin_time":begin_time,
            "end_time":end_time
        };
        $(_pageId+ ".no_data").hide();
        service_fund.queryHistoryTrade(param,queryDealCallback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "timeOutFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 成交查询回调
     */
    function queryDealCallback(data){
        if (typeof(data) != "undefined" && data != null) {
            $(_pageId+" .tarde_hit").html("");
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                if(results != "undefined" && results.length>0){
                    var html = "";
                    for (var i=0;i<results.length;i++){
                        html += queryDealHTML(results[i],i);
                    }
                    $(_pageId+".main .fund_list2").html(html);
                    $(_pageId+".no_data").hide();
                }else{
                    $(_pageId+".no_data").show();
                }
            }
            else{
                $.alert(data.error_info);
            }
        }
        else{
            $.alert("查询失败");
        }
        if(!myScroller){
            initScroller();
        }else{
            myScroller.refresh();
        }
    }
    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element){
        var price_digit = 3;
        var css = "";
        var eleHtml = "";
        eleHtml +='<div class="part">';
        eleHtml +='<div class="title">';
        eleHtml +='<h5>'+element.fund_name+' <small>'+element.fund_code+'</small></h5></div><ul>';
        eleHtml +='<li>委托类型  <span>'+element.business_name+'</span></li>';
        eleHtml +='<li>委托状态  <span>已成交</span></li>';
        eleHtml +='<li>委托份额  <span>'+Number(element.shares).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托金额 <span>'+Number(element.balance).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li class="full">成交时间 <span>'+element.business_date+" "+element.business_time+'</span></li>';
        eleHtml +='</ul></div>';
        return eleHtml;
    }

    /**
     * 初始化滑动组件
     */
    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() - 6 , // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
				//埋点
				common.comStat(101365,2,102,true,{"i_direct":"1","i_type":"1"});
                callsQuery();
            }
        };
        if(!myScroller)
        {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy(){
		common.pageBuryingPoint();
        $(_pageId+".fund_list2").html("");
        $(_pageId + ".top_title .top_nav").hide();
        if(myScroller){
            myScroller.destroy();
            myScroller=null;
        }
    }


    /**
     * 重写框架里面的pageBack方法
     */
    function pageBack(){
        $.pageInit("fund/inside/fundQueryHistory","fund/inside/index",{});
    }

    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "pageBack": pageBack
    };
    module.exports = base;
});