/**
 * 场内基金-认购汇总查询查询
 */
define('trade/scripts/fund/inside/query.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_fund=require("service_fund");
    var _pageId = "#fund_inside_query ";
	var userInfo=null;
	var height=null;
    /**
     * 初始化
     */
	function init(){
		userInfo=common.getCurUserInfo();
		query();
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		height = mianHeight - $(_pageId+".tab_nav").outerHeight(true);
	}

	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$.pageInit("fund/inside/query","fund/inside/index","left");
			e.stopPropagation();
		});
		//切换查询
		$.bindEvent($(_pageId+".toggle_nav ul li"),function (e) {
			$(this).siblings().removeClass();
			$(this).addClass("active");
			query();
			e.stopPropagation();
		});
	}

	function query() {
		if($(_pageId+".toggle_nav ul li:eq(0)").hasClass("active")){
			//查询现金认购
			queryCashSubscribe();
		}else{
			//查询股票认购
			queryStockSubscribe();
		}
	}

	function queryCashSubscribe() {
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var fund_code = fundStr;
		var fund_company="";
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"fund_company":fund_company,
			"fund_code":fund_code
		};
		service_fund.getFundInfo(param,queryCashSubscribeCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}

	function queryCashSubscribeCallBack(data) {
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+".fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += getCashSubscribeHtml(results[i]);
					}
					$(_pageId+".fund_list2").html(html);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			$.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}

	function getCashSubscribeHtml(element) {
		var html="";
		html+="<tr>";
		html+="<td>"+element.date+"</td>";
		html+="<td>159910</td>";
		html+="<td><strong>华夏沪深</strong><small>300</small></td>";
		html+="<td>4,000</td>";
		return html;
	}

	function queryStockSubscribe() {
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var fund_code = fundStr;
		var fund_company="";
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"fund_company":fund_company,
			"fund_code":fund_code
		};
		service_fund.getFundInfo(param,queryStockSubscribeCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}


	function queryStockSubscribeCallBack(data) {
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+".fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += getStockSubscribeHtml(results[i]);
					}
					$(_pageId+".fund_list2").html(html);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			$.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}

	function getStockSubscribeHtml(element) {
		var html="";
		html+="<tr>";
		html+="<td>"+element.date+"</td>";
		html+="<td>159910</td>";
		html+="<td><strong>华夏沪深</strong><small>300</small></td>";
		html+="<td>4,000</td>";
		return html;
	}

	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight:height , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				query(); // 模拟查询接口数据操作
			},
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}


	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + ".main .fund_list2").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});