/**
 * 场外基金-基金账户查询
 */
define('trade/scripts/fund/outside/account.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var _pageId = "#fund_outside_account ";
	var service_fund = require("service_fund");
	var userInfo = null;
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101141");
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101142,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/order","left");
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId + ".top_title .right_text"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101144,2,103,true,{"i_group_name":"开户"});
			$.pageInit("fund/outside/account","fund/outside/openAccount",{});
			e.stopPropagation();
		});
		
		userInfo = common.getCurUserInfo();
		custFundQuery();//客户信息查询
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
	}
	
	/**
	 * 查询客户绑定的信息
	 */
	function custFundQuery(){
		$(_pageId + " .fund_account").html("");
		$(_pageId + " .no_data").hide();
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.getCustMsg(param,queryFundCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
	    });
	}
	/**
	 * 查询客户信息回调
	 */
	function queryFundCallBack(data){
		if (data) {
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results && results.length > 0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryFundHTML(results[i],i);
					}
					$(_pageId+ ".main .fund_account").html(html);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	function queryFundHTML(element){
		var eleHtml = "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><h5><i class="icon"></i>'+element.company_name+'</h5>';
        eleHtml += '<span class="time"><nobr>开户日期 '+element.open_date+'</nobr></span></div><ul>';
        eleHtml += '<li>基金账号<span>'+element.trans_account+'</span></li>';
        eleHtml += '<li>公司代码<span>'+element.fund_company+'</span></li>';
        eleHtml += '<li>账户全名<span>'+element.holder_name+'</span></li>';
        eleHtml += '<li>账户状态<span>'+element.holder_status_name+'</span></li>';
        eleHtml += '</ul></div>';
        return eleHtml;
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}

	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight:  $(window).height() - $(_pageId+".top_title").height() - $("#afui #footer").height() - $(_pageId+".tab_nav").height() - 6 , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				common.comStat(101143,2,102,true,{"i_direct":"1","i_type":"1"});
				custFundQuery();
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + " .fund_account").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});