/**
 * 场外基金-分红设置
 */
define('trade/scripts/fund/outside/bonus.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#fund_outside_bonus ";
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var userInfo = null;
	/**
	 * 初始化
	 */
	function init() {
		common.pageBuryingPoint("101128");
		userInfo = common.getCurUserInfo();
		queryFundStock();
	}

	function load() {
		var mainHeight = common.setMainHeight(_pageId, false);
	}

	/**
	 * 查询客户基金持仓
	 */
	function queryFundStock() {
		$(_pageId + ".no_data").hide();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.queryFundData(param, queryFundStockCallBack, { //传给接口的json格式数据            
			"isLastReq": true,
			"isShowWait": true,
			"isShowOverLay": false,
			"timeOutFunc": function() { //超时调用方法
				$(_pageId + ".no_data").show();
				if(!myScroller) {
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
	    });
	}
	
	function queryFundStockCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryFundStockHTML(results[i]);
					}
					$(_pageId + ".fund_bonus").html(html);
					$(_pageId + ".no_data").hide();
					$.bindEvent($(_pageId + ".fund_bonus .part .type_box dd"), function(e) {
						var flag = $(this).find("span").attr("class");
						if(flag != "active") {
							$(this).siblings().find("span").removeClass("active");
							$(this).find("span").addClass("active");
							var fund_company = $(this).parent("dl").attr("fund_company");
							var fund_code = $(this).parent("dl").attr("fund_code");
							var mode = "0";
							var text = $(this).find("span").text();
							if(text == "现金分红") {
								mode = "1";
							}
							var tipStrArray = [];
							
							tipStrArray.push(["确认将分红方式设置为：", text]);
							var tipStr = "<div >";
							tipStr += common.generatePrompt(tipStrArray);
							tipStr += "</div>";
							var context = this;
							
							//埋点
							common.comStat(101131,2,104,true,{"i_change_name":"分红方式","i_change_to":text});
							
							common.iConfirm("分红方式", tipStr, function sure() {
								bonusModeSetting(mode, fund_code, fund_company);
							}, function cancel() {
								$(context).find("span").removeClass("active");
								$(context).siblings().find("span").addClass("active");
							}, "确定", "取消");
						}
						$(_pageId+" ._content .table_tips_list tr td:eq(0)").css({"width":"25%"});
						e.stopPropagation();
					},"tap");
				}else{
					$(_pageId + ".no_data").show();
				}
			} else {
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	function queryFundStockHTML(element){
		var price_digit = 3;
		var css = "";
		if(element.income_balance > 0){
			css = "ared";
		}else if(element.income_balance < 0){
			css = "agreen";
		}else{
			css = "";
		}
		var eleHtml = "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><h5>'+element.fund_name+' <small>'+element.fund_code+'</small></h5>';
        eleHtml += '<span class="stat">正常</span></div><ul>';
        eleHtml += '<li><span>最新净值</span><strong class="'+css+'">'+Number(element.nav)+'</strong></li>';
        eleHtml += '<li><span>基金市值</span><strong class="'+css+'">'+Number(element.market_value)+'</strong></li>';
        eleHtml += '<li><span>持有份额</span><strong>'+Number(element.enable_shares)+'</strong></li>';
        eleHtml += '</ul><div class="type_box"><dl fund_code="'+element.fund_code+'" fund_company="'+element.fund_company+'">';
        eleHtml += '<dt>分红方式：</dt>';
		if(element.dividendmethod == "0"){
			eleHtml += '<dd><span>现金分红</span></dd>';
			eleHtml += '<dd><span class="active">红利转投</span></dd>';
		} else {
			eleHtml += '<dd><span class="active">现金分红</span></dd>';
			eleHtml += '<dd><span>红利转投</span></dd>';
		}
        eleHtml += '</dl></div></div>';
        return eleHtml;
	}
	
	function bonusModeSetting(mode,fund_code,fund_company){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var fund_company = fund_company || "";
		var fund_code = fund_code;
		var dividendmethod = mode;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "fund_company":fund_company,
		 		"fund_code":fund_code,
		 		"dividendmethod":dividendmethod
		};
		//最后一个为超时处理函数
		service_fund.bonusModeSetting(param, bonusModeSettingCallBack, { //传给接口的json格式数据            
			"isLastReq": true,
			"isShowWait": false,
			"isShowOverLay": false,
		});
	}
	
	function bonusModeSettingCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					$.alert("分红设置成功，流水号"+results[0].serial_no);
				}
			} else {
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101129,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/order","left");
			e.stopPropagation();
		});
	}

	/**
	 * 初始化滑动组件
	 */
	function initScroller() {
		var scrollOptions = {
			scrollerHeight:  $(window).height() - $(_pageId+".top_title").height() - $("#afui #footer").height() - $(_pageId+".tab_nav").height() - 6 , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				common.comStat(101130,2,102,true,{"i_direct":"1","i_type":"1"});
				queryFundStock();
			}
		};
		if(!myScroller) {
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		} else {
			myScroller.refresh();
		}
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + ".fund_bonus").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});