/**
 * 场外基金-基金转换
 */
define('trade/scripts/fund/outside/convert.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#fund_outside_convert ";
	var service_fund = require("service_fund");
	var keyboard = require("keyboard");
    var userInfo= null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var listData = {};
	var fundInfo = {};
	var listDataOut = {};
	var fundInfoOut = {};
	var mainHeight=0;
	var formHeight=0;
    var appropriate = require("appropriate");
	var comStatParam={}
    var noticeToInvestors = require("noticeToInvestors");
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101100");
		if(keyboard){
			keyboard.keyInit();
		}
		//返回
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101101,2,103,true,{"i_group_name":"返回"});
			$.pageBack();
			e.stopPropagation();
		});
		userInfo = common.getCurUserInfo();
		queryHoldingsQuery();//查询可赎回基金
    }
		
	function load(){
		mainHeight =  common.setMainHeight(_pageId, false);
		formHeight = $(_pageId+".fund_form2").height();
	}
	
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid="";
		var fund_company ="";
		var fund_code ="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
		};
		service_fund.queryFundData(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for (var i=0;i<results.length;i++){
						listData[results[i].fund_code+""] = results[i];
						listDiv += "<li id='"+results[i].fund_code+"'><a href=\"javascript:void(0);\">"+results[i].fund_name+" <small>"+results[i].fund_code+"</small></a></li>";
					}
					listDiv += "</ul></div>";
					//埋点参数
					var buriedPointParam={
						"backObjectId":101122,
						"backActionId":103,
						"backParamMap":{
							"i_group_name":"返回",
						 },
						 "pageObjectId2":101121,//页面埋点参数
						 "pageObjectId1":101100,
					}
					common.addChoiceList($(_pageId+" #fundCodeTo p"), "选择转出基金",listDiv,function(data, div){
						//埋点
						common.comStat(101102,2,103,true,{"i_group_name":"选择转出基金"});
						
						div.html(data.find("a small").text());
						var id = data.attr("id");
						fundInfo = listData[id];
						$(_pageId + "#fundNameTo").val(fundInfo.fund_name);
						$(_pageId + "#fundNav").val(fundInfo.nav || 0);
						$(_pageId+".fund_form2 .limit em").text(Number(fundInfo.enable_shares));//持有份额
						$(_pageId+"#fundSum").val("");
						$(_pageId+"#fundSum").quzhi("");
						listDataOut = {};
						$(_pageId+"#fundCodeOut").html("<p>请选择...</p>");
						$(_pageId+"#fundNameOut").val("");
						$(_pageId+"#inFundNav").val("");
						fundInfoOut = {};
						getFundList(fundInfo);
					},false,"fundTo",keyboard,buriedPointParam);
				}
				else{
					$(_pageId+" #fundCodeTo p").text("暂无可转出基金");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundInfo){
		if(fundInfo && fundInfo.fund_company){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundInfo.fund_code;
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
					"fund_code":fund_code
			};
			service_fund.queryEableTransIntoFund(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				listDataOut = {};
				var listDiv = "<div class='bank_list center1'><ul>";
				for (var i=0;i<results.length;i++){
					if(fundInfo.fund_code != results[i].fund_code){
						listDataOut[results[i].fund_code+""] = results[i];
						listDiv += "<li id='"+results[i].fund_code+"'><a href=\"javascript:void(0);\">"+results[i].fund_name+" <small>"+results[i].fund_code+"</small></a></li>";
					}
				}
				listDiv += "</ul></div>";
				//埋点参数
				var buriedPointParam={
					"backObjectId":101115,
					"backActionId":103,
					"backParamMap":{
						"i_group_name":"返回",
					 },
					"pageObjectId2":101114,//页面埋点参数
					 "pageObjectId1":101100,
				}
				common.addChoiceList($(_pageId+" #fundCodeOut p"), "选择转入基金",listDiv,function(data, div){
					//埋点
					common.comStat(101103,2,103,true,{"i_group_name":"选择转入基金"});
						
					div.html(data.find("a small").text());
					var id = data.attr("id");
					fundInfoOut = listDataOut[id];
					$(_pageId + "#fundNameOut").val(fundInfoOut.fund_name);
					$(_pageId + "#inFundNav").val(fundInfoOut.nav||0);
					$(_pageId+"#fundSum").val("");
					$(_pageId+"#fundSum").quzhi("");
				},false,"fundOut",keyboard,buriedPointParam);
			}
			else{
				$(_pageId+" #fundCodeOut p").text("暂无可转入基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	function fundConversion(){
		if(common.size(fundInfo) == 0){
			$.alert("没有可转出的基金");
			return false;
		}
		if(!common.isValue(fundInfo)){
			$.alert("请选转出的基金");
			return false;
		}
		if(common.size(listDataOut) == 0){
			$.alert("没有可转入的基金");
			return false;
		}
		if(!common.isValue(fundInfoOut)){
			$.alert("请选转入的基金");
			return false;
		}
		var numMax =$(_pageId+".fund_form2 .limit em").text();
		var fundSum = $(_pageId+"#fundSum").val();
		if(validata.isEmpty(numMax)|| numMax=="0" || numMax=="--"){
			$.alert("可转份额为0");
			return false;
		}
		if(validata.isEmpty(fundSum)){
			$.alert("转换份额不能为空");
			return false;
		}else if(Number(fundSum)>Number(numMax)){
			$.alert("赎回份额不能大于可转份额");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["转出基金名称", fundInfo.fund_name]);
		tipStrArray.push(["转出基金代码 ", fundInfo.fund_code]);
		tipStrArray.push(["转入基金名称", fundInfoOut.fund_name]);
		tipStrArray.push(["转入基金代码 ", fundInfoOut.fund_code]);
		tipStrArray.push(["转换份额 ", fundSum]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray, "", "list");
		tipStr += "</div>";
		
		var param={
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"password":userInfo.password,
			"session_id":userInfo.sessionid,
			"fund_company":$(_pageId+"#fundName").attr("data-fundCom"),
		}
		noticeToInvestors.function399901(param,function(){
//		common.iConfirm("下单确定",tipStr,function success(){
			var orderParam = {
				"entrust_way" : global.entrust_way,
				"branch_no" : userInfo.branch_no,
				"fund_account" : userInfo.fund_account,
				"cust_code" : userInfo.cust_code,
				"sessionid" :userInfo.session_id,
				"fund_company" : fundInfo.fund_company,//基金公司
				"fund_code" : fundInfo.fund_code,//基金代码
				"stock_code" : fundInfo.fund_code,//基金代码
				"trans_code": fundInfoOut.fund_code,//基金代码
				"trans_amount" : fundSum,////赎回份额
				"exceedflag" : 0,//巨额方式
				"business_type":"2"
			};
			var appropriateParam = {
				"entrust_way" : global.entrust_way,
				"branch_no" : userInfo.branch_no,
				"fund_account" : userInfo.fund_account,
				"cust_code" : userInfo.cust_code,
				"sessionid" :userInfo.session_id,
				"fund_company" : fundInfo.fund_company,//基金公司
				"fund_code" : fundInfo.fund_code,//基金代码
				"fund_name": fundInfo.fund_name,//基金名称
				"stock_code" : fundInfoOut.fund_code,//基金代码
				"trans_amount" : fundSum,////赎回份额
				"exceedflag" : 0,//巨额方式
				"business_type":"2"
			};
			appropriate.placeOrder(comStatParam,appropriateParam,tipStr,function(instr_batch_no){
				orderParam.instr_batch_no = instr_batch_no;
				service_fund.fundConversion(orderParam,function(data){
					if(data.error_no ==0){
						$.alert("转换成功");
						if(data.results && data.results[0]){
							appropriate.function399931({serial_no:data.results[0].serial_no});
						}
					}else{
						$.alert(data.error_info);
					}
					clearMsg();
					queryHoldingsQuery();
				},{ "isLastReq":false,"isShowWait":false,
					"timeOutFunc":function(){
						$.hidePreloader();
					},"errorFunc":function(){
						$.hidePreloader();
					}
				});
				$.showPreloaders("请等待...");
			});
//		},function fail(){});
		});
		$(_pageId+"#newTradingTipsBox2 ._content .table_tips_list tr td:eq(0)").css({"width":"35%","min-width":"35%"});
	}

	function clearMsg() {
		$(_pageId+"#fundCodeTo").html("<p>请选择...</p>");
		$(_pageId+"#fundNameTo").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#fundCodeOut").html("<p>请选择...</p>");
		$(_pageId+"#fundNameOut").val("");
		$(_pageId+"#inFundNav").val("");
		$(_pageId+"#fundSum").val("");
		$(_pageId+"#fundSum").quzhi("");
		$(_pageId+".fund_form2 .limit em").text("--");
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//申购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//埋点
			common.comStat(101104,2,103,true,{"i_group_name":"转换提交"});
			fundConversion();
			e.stopPropagation();
		});
		//数量输入
		$.bindEvent($(_pageId + "#fundSum"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		},"input");
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		if(keyboard){
			keyboard.keyDestroy();
		}
		$(_pageId+" .select_box p").text("请选择...");
		$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
		$(_pageId + "input").quzhi("");
		$(_pageId+" #fundCodeTo p").unbind();
		$(_pageId+" #fundCodeOut p").unbind();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});