/**
 * 场外基金-定投下单
 */
define('trade/scripts/fund/outside/fixedInvestment.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var commonFunc = require("commonFunc");
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
		require("validatorUtils");
	var validata = $.validatorUtils;
	var myScroller = null; // 滑动组件对象
	var _pageId = "#fund_outside_fixedInvestment ";
	var userInfo=null;
	var payDate="";
    /**
     * 初始化
     */
	function init(){
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo=common.getCurUserInfo();
		if($.getPageParam("param") == "query"){
			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			$(_pageId+" .fund_cast").show();
			$(_pageId+" .fund_form2").hide();
			querySetDateEntrust();
		}else{
			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			$(_pageId+" .fund_form2").show();
			$(_pageId+" .fund_cast").hide();
		}
		commonFunc.initTimeChoice(_pageId);
		queryFundPayDate();
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
	}
	
	function queryFundPayDate() {
		// var entrust_way=global.entrust_way; // 委托方式  在configuration配置
		// var branch_no = userInfo.branch_no;
		// var fund_account = userInfo.fund_account;
		// var cust_code = userInfo.cust_code;
		// var sessionid=userInfo.session_id;
		// var param={
		// 	"entrust_way":entrust_way,
		// 	"branch_no":branch_no,
		// 	"fund_account":fund_account,
		// 	"cust_code":cust_code,
		// 	"sessionid":sessionid
		// };
		// service_fund.queryFundPayDate(param ,queryFundPayDateCallback);
		var data={
			"error_no":0
		}
		var results=[];
		for(var i=1;i<=25;i++){
			var ele={};
			ele.pay_day=i;
			ele.save_plan_name="每月"+i+"号";
			results.push(ele);
		}
		data.results=results;
		queryFundPayDateCallback(data);
	}

	function queryFundPayDateCallback(data) {
		if(data.error_no == 0){
			$(_pageId+".no_data").hide();
			var results = data.results;
			if(results.length>0 && results!= "undefined"){
				var selectHeight=0;
				if(results.length >= 4){
					selectHeight = 4 * 0.44;
				}else{
					selectHeight = results.length*0.44;
				}
				$(_pageId+"#selectPayDate ul").css({"height":selectHeight+"rem"});
				var listHtml = "";
				for(var i = 0;i < results.length; i++) {
					listHtml+="<li id='"+results[i].pay_day+"'><a href='javascript:void(0);'>"+results[i].save_plan_name+"</a></li>";
				}
				$(_pageId+"#selectPayDate ul").html(listHtml);
				$.bindEvent($(_pageId+"#selectPayDate ul li"),function (e) {
					$(_pageId+"#selectPayDate p").text($(this).text());
					//记录选择的数据
					payDate=$(this).attr("id");
					$(_pageId+"#selectPayDate ul").hide();
					e.stopPropagation();
				},"tap");
			}
		}
		else{
			// $.alert(data.error_info);
		}
	}

	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr){
		if(fundStr!= "" && fundStr.length==6){
			clearMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";
			var branch_no = userInfo.branch_no;
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"fund_company":fund_company,
				"fund_code":fund_code
			};
			service_fund.getFundInfo(param,getFundInfoBack);
		}
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length > 0){
				var nav=results[0].nav!=""?results[0].nav:"0";
				var fundCompany = results[0].fund_company;
				$(_pageId+"#fundName").val(results[0].fund_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").val(nav);
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$.alert(data.error_info);
		}
	}


	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#fundCode").val());
		if(buy_stockCode.length == 0){
			$.alert("请输入基金代码");
			return false;
		}
		if(buy_stockCode.length != 6){
			$.alert("基金代码输入错误");
			return false;
		}
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#eachMoney").val();
		if($.trim(now_price).length<=0){
			$.alert("请输入定投金额");
			return false;
		}else if(now_price=="0"){
			$.alert("定投金额不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入定投金额");
			return false;
		}
		//对定投选择时间选择验证
		var today=new Date(new Date().toDateString());
		if(!$(_pageId+"#startInput").val()||!$(_pageId+"#endInput").val()){
			$.alert("请选择时间");
			return false;
		}
		var startDate=new Date($(_pageId+"#startInput").val().toString());
		var endDate=new Date($(_pageId+"#endInput").val().toString());
		if(startDate.getTime()<today.getTime()){
			$.alert("开始日期只能是当日或当日以后")
			return false;
		}
		if(startDate.getTime()>endDate.getTime()){
			$.alert("开始日期必须小于截止日期");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["基金名称", $(_pageId+" #fundName").val()]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["定投金额 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		common.iConfirm("下单确定",tipStr,function success(){
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no  = userInfo.branch_no;	//分支机构
			var sessionid=userInfo.sessionid;
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_company=$(_pageId+"#fundName").attr("data-fundCom");
			var fund_code=buy_stockCode;
			var balance=now_price;
			var start_date=startDate.format("yy-MM-dd");
			var end_date=endDate.format("yy-MM-dd");
			var en_fund_date=payDate;
			var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
				"flag":"",
				"balance":balance,
				"startDate":start_date,
				"endDate":end_date,
				"en_fund_date":en_fund_date
			};
			service_fund.setDateEntrust(param, entrustCallBack);
		},function fail(){
		});
	}

	function entrustCallBack(data) {
		if(data.error_no=="0"){
			var results=data.results;
			if(results&&results.length>0){
				$.alert("下单成功，委托号"+results[0].serial_no);
				clearMsg();
				$(_pageId+"#fundCode").quzhi("");
			}
		}else{
			$.alert(data.error_info);
		}
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageBack();
			e.stopPropagation();
		});

		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index() == 0){
				$(_pageId+" .fund_form2").show();
				$(_pageId+" .fund_cast").hide();
			}
			else{
				$(_pageId+" .fund_cast").show();
				$(_pageId+" .fund_form2").hide();
				querySetDateEntrust();
			}
		});
		$.bindEvent($(_pageId+"#selectPayDate"),function (e) {
			$(this).find("ul").toggle();
			e.stopPropagation();
		},"tap");

		//定投金额输入
		$.bindEvent($(_pageId+"#eachMoney"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		},"input");

		//股票代码输入框监听
		$.bindEvent($(_pageId+"#fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $.trim($(this).val());
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearMsg();
			}
			e.stopPropagation();
		},"input");

		//定投下单
		$.bindEvent($(_pageId+".ce_btn"),function (e) {
			vailSubmitOrder();
			e.stopPropagation();
		},"tap");
	}
	
	//查询基金定投
	function querySetDateEntrust() {
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"sessionid":sessionid,
			"entrust_way":entrust_way
		}
		service_fund.fundInvestmentQuery(param,queryCallBack,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+".vote_list2").html("");
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		})
	}
	
	function queryCallBack(data) {
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryEntrustHtml(results[i]);
					}
					$(_pageId+".fund_list2").html(html);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			$.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}

	function queryEntrustHtml(element) {
		var eleHtml = "";
		eleHtml+="<div class=\"part\">";
		eleHtml+="<div class=\"title\"><h5>"+element.fund_name+" <small>"+element.fund_code+"</small></h5><span class=\"stat\">"+element.protocol_status_name+"</span></div>";
		eleHtml+="<ul>";
		eleHtml+="<li><span>开始日期</span><p>"+element.start_date+"</p></li>";
		eleHtml+=" <li class=\"dot\"></li>";
		eleHtml+="<li><span>截止日期</span><p>"+element.end_date+"</p></li>";
		eleHtml+="</ul>";
		eleHtml+="<div class=\"stat_box\">";
		eleHtml+="<span>扣款日 <em>"+element.en_fund_date+"</em></span>";
		eleHtml+="<span>定投金额 <em>"+element.balance+"</em></span>";
		eleHtml+="<span>已投 <em>"+element.num+"</em>期</span>";
		eleHtml+="</div>";
		eleHtml+="</div>";
		return eleHtml;
	}


	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()-10 , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				querySetDateEntrust()// 模拟查询接口数据操作
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	function clearMsg() {
		$(_pageId+"#eachMoney").quzhi("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#fundName").val("");
		$(_pageId+"#selectPayDate p").text("请选择扣款日");
		payDate="";
	}

	/**
	 * 数据重置
	 */
	function destroy(){
		if(keyboard){
			keyboard.keyDestroy();
		}
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
		clearMsg();
		$(_pageId+"#fundCode").quzhi("");
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});