/**
 * 场外基金-基金开户
 */
define('trade/scripts/fund/outside/openAccount.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#fund_outside_openAccount ";
	var service_fund = require("service_fund");
	var noticeToInvestors = require("noticeToInvestors");
	var userInfo = null;
	var listData = {};
	var accounts = {};
	var accountInfo = {};
	var queryList={};
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101149");
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101150,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/account","left");
			e.stopPropagation();
		});
		userInfo = common.getCurUserInfo();
		custFundQuery();
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
	}
	
	/**
	 * 查询客户绑定的信息
	 */
	function custFundQuery(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.getCustMsg(param,queryFundCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":false,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				fundCompanyQuery();
			}
	    });
	}
	/**
	 * 查询客户信息回调
	 */
	function queryFundCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var html = "";
					for (var i=0;i<results.length;i++){
						accounts[""+results[i].fund_company] = true;
					}
				}else{
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		fundCompanyQuery();
	}
	
	/**
	 * 查询客户绑定的信息
	 */
	function fundCompanyQuery(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.getFundCompany(param,getFundCompanyCallBack);
	}
	/**
	 * 查询客户信息回调
	 */
	function getFundCompanyCallBack(data){
		if (data) {
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var flag=true;
					var listHtml = "<div class='bank_list'><ul>";
					for (var i=0;i<results.length;i++){
						if(!accounts[results[i].fund_company]){
							listData[i+""] = results[i];
							var company_name = results[i].company_name;
							listHtml += "<li id='"+i+"'><a href=\"javascript:void(0);\"><i></i>"+company_name+"</a></li>";
							flag=false;
						}
					}
					listHtml += "</ul></div>";
					if(flag){
						$(_pageId+" .select_box p").text("暂无可开户基金公司");
					}
					common.addChoiceList($(_pageId+" .select_box p"), "选择开户基金公司",listHtml,function(data, div){
						div.html(data.find("a").html());
						var id = data.attr("id");
						accountInfo = listData[id];
						function399901();
					});
				}
				else{
					$(_pageId+" .select_box p").text("暂无可开户基金公司");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 基金开户和协议状态查询
	 */
	function function399901(){
		queryList={};
		var param={
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"password":userInfo.password,
			"session_id":userInfo.sessionid,
			"fund_company":accountInfo.fund_company,
		}
		// 查询是否开户
		service_fund.function399901(param, function(data){
			$(_pageId + ".fund_open .x-notice-tips .x-checkbox").removeClass("checked");
			$(_pageId+".x-notice-tips").hide();
			$(_pageId + ".fund_open .ce_btn a").removeClass("disabled");
			if(data.error_no == 0) {
				var results = data.results;
				if(results && results.length > 0){
					queryList=results[0];
					if(results[0].isProtocol=="false"){
						$(_pageId+".x-notice-tips").show();
						$(_pageId + ".fund_open .ce_btn a").addClass("disabled");
					}
					
					//《证券投资基金投资者权益须知书》
					$.bindEvent($(_pageId + ".fund_open .x-notice-tips .x-notice-text"), function(e){
						noticeToInvestors.investorAgreementTips(queryList);
						e.stopPropagation();
					});
					//本人已知晓并同意上述协议
					$.bindEvent($(_pageId + ".fund_open .x-notice-tips .x-check-text"), function(e){
						$(this).find(".x-checkbox").toggleClass("checked");
						if($(this).find(".x-checkbox").hasClass("checked")){
							$(_pageId + ".fund_open .ce_btn a").removeClass("disabled");
						}else{
							$(_pageId + ".fund_open .ce_btn a").addClass("disabled");
						}
						e.stopPropagation();
					});
				}
			} else {
				$.alert(data.error_info);
			}
		},{"isLastReq":true,"isShowWait":true,
			"timeOutFunc":function(){
			$(_pageId + ".fund_open .x-notice-tips .x-checkbox").removeClass("checked");
				$(_pageId+".x-notice-tips").hide();
				$(_pageId + ".fund_open .ce_btn a").removeClass("disabled");
				$.hidePreloader();
			},"errorFunc":function(){
			$(_pageId + ".fund_open .x-notice-tips .x-checkbox").removeClass("checked");
				$(_pageId+".x-notice-tips").hide();
				$(_pageId + ".fund_open .ce_btn a").removeClass("disabled");
				$.hidePreloader();
			},
		});
	}
	
	/**
	 * 协议签署以及开户流程
	 */
	function accountOpenProcess(){
		if(!common.isValue(accountInfo)){
			$.alert("请选择开户基金公司");
			return false;
		}
		if(common.isValue(queryList)){
			//未签署协议
			if(queryList.isProtocol=="false"){
				function399902();//先签署、再开户
			}
			//已签署协议
			else{
				openFundAccount();//直接开户
			}
		}else{
			openFundAccount();//未查询到协议签署状态则直接开户
		}
	}
	
	/*
	*  签署协议
	* */
	function function399902(){
		var paramMap={
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"password":userInfo.password,
			"session_id":userInfo.sessionid,
			"sign_version":queryList.agreement_version,
		}
		service_fund.function399902(paramMap, function(data){//签署协议
			if(data.error_no == 0) {
				openFundAccount();//开户
			}
			else{
				//签署失败不能下单
				$.alert(data.error_info);
			}
		},{"isLastReq":true,"isShowWait":true,
			"timeOutFunc":function(){
				//签署失败不能下单
				$.hidePreloader();
			},"errorFunc":function(){
				//签署失败不能下单
				$.hidePreloader();
			},
		});
	}
	
	/**
	 * 开户
	 */
	function openFundAccount(){
		var param={				
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"fund_company" : accountInfo.fund_company,
			"stock_account" : "",
			"flag" : ""
		};
		//最后一个为超时处理函数
		service_fund.openFundAccount(param,function (data){
			if (data) {
				if(data.error_no == 0){
					$(_pageId+".no_data").hide();
					var results = data.results;
					if(results && results.length > 0){
						$(_pageId + " .fund_notice").show();
						$(_pageId + " .fund_open").hide();
						accountInfo = {};
						queryList={};
						$(_pageId+" .select_box p").html("请选择");
						$(_pageId+".x-notice-tips").hide();
						$(_pageId + ".fund_open .ce_btn a").addClass("disabled");
						$(_pageId + ".fund_open .x-notice-tips .x-checkbox").removeClass("checked");
					}
				}
				else{
					$.alert(data.error_info);
				}
			}
		});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//确定
		$.bindEvent($(_pageId + ".fund_open .ce_btn a"), function(e){
			//埋点
			common.comStat(101151,2,103,true,{"i_group_name":"开户提交"});
			if(!$(this).hasClass("disabled")){
				accountOpenProcess();
			}else{
				if(!common.isValue(accountInfo)){
					$.alert("请选择开户基金公司");
				}
				else if(common.isValue(queryList) && queryList.isProtocol=="false"){
					$.alert("需先阅读并确认“投资者权益须知书”");
				}
			}
			e.stopPropagation();
		});
		$.bindEvent($(_pageId + ".fund_notice .links a"), function(e){
			$.pageBack("fund/outside/account","left");
			e.stopPropagation();
		});
		//开户成功后点击确认按钮跳转到基金账户查询页面
		$.bindEvent($(_pageId + ".fund_notice .ce_btn a"), function(e){
			$.pageBack("fund/outside/account","left");
			// $.pageRefresh();
			e.stopPropagation();
		});
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + " .fund_notice").hide();
		$(_pageId + " .fund_open").show();
		$(_pageId+" .select_box p").html("请选择");
		listData = {};
		accounts = {};
		accountInfo = {};
		$(_pageId+".x-notice-tips").hide();
		$(_pageId + ".fund_open .ce_btn a").addClass("disabled");
		$(_pageId + ".fund_open .x-notice-tips .x-checkbox").removeClass("checked");
		queryList={};
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});