/**
 * 场外基金-基金持仓
 */
define('trade/scripts/fund/outside/position.js', function(require, exports, module) {
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#fund_outside_position ";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_fund = require("service_fund");
	var userInfo =null;
	var position_Timer = null;
	
	var appropriate = require("appropriate");
	
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("100979");
		common.switchingCurUser("0");
		appropriate.positionDetails();
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		jumpPageEvent();
		userInfo = common.getCurUserInfo();
		queryData();
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		var height_search = mianHeight - $(_pageId+".tab_nav").outerHeight(true);
		$(_pageId+" .main .search_nav").height(height_search-10).css("overflow-y","auto"); //查询目录添加高度
	}

	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(100985,2,103,true,{"i_group_name":"返回"});
			$.pageInit("fund/outside/position","account/index",{"history":true},"left",true);
//			$.pageBack("account/index","left");
			e.stopPropagation();
		});
		
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(100983,2,103,true,{"i_group_name":"银证转账"});
			$.setSStorageInfo("return_page","fund/outside/position");
			$.pageInit("fund/outside/position","banking/transferNew",{});
			e.preventDefault();
			e.stopPropagation();
		});
	}
	
	function queryData(){
		clearPositionTimer();
		queryCapital();
		queryFundStock();
		if(position_Timer == null && global.positionRefreshTime){
			commonFunc.initCheckTradeTimer();
			position_Timer = window.setInterval(function(){
				if(commonFunc.getTradingTime() && common.isAppFlag()){
					queryCapital(true);
					queryFundStock(true);
				}
			}, global.positionRefreshTime);//定时刷新
		}
	}

	function clearPositionTimer(){
		if (position_Timer != null ) {
			window.clearInterval(position_Timer);
		}
		position_Timer = null;
	}

	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志、
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "is_homepage":"1"
		};
		service_fund.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":false,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
	    });
	}
	
	function queryCapitalCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var assert_val = Number(results[0].assert_val).toFixed(2)+"";
					$(_pageId+" .inner>strong").html(assert_val.substring(0,assert_val.length-2)+"<em>"+ assert_val.substr(-2) +"</em>");//总资产
					var fetch_balance = Number(results[0].fetch_balance).toFixed(2)+"";
					$(_pageId+" .more_info li").eq(2).find("strong").html(fetch_balance.substring(0,fetch_balance.length-2)+"<em>"+ fetch_balance.substr(-2) +"</em>");//可取
					var enable_balance = Number(results[0].enable_balance).toFixed(2)+"";
					$(_pageId+" .more_info li").eq(0).find("strong").html(enable_balance.substring(0,enable_balance.length-2)+"<em>"+ enable_balance.substr(-2) +"</em>");//可用
					
					//添加总浮动盈亏
					var css = "";
					var sign = "";
					var float_yks = float_yks = results[0].float_yk || results[0].total_income_balance;
					//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
					if(float_yks > 0){
						css = "ared";
					}else if(float_yks < 0){
						css = "agreen";
					}
					var fas = Number(float_yks).toFixed(2);
					// var fas = sign + common.numToMoneyType(float_yks,2);
					$(_pageId+" .more_info ul li").eq(1).find("strong").html(fas.substring(0,fas.length-2)+"<em>"+ fas.substr(-2) +"</em>");//盈亏
					//添加参考市值
					float_yks = results[0].today_yk || results[0].daily_income_balance;
					if(float_yks > 0){
						css = "ared";
					}else if(float_yks < 0){
						css = "agreen";
					}
					// var fa = sign + common.numToMoneyType(float_yks,2);
					var fa = results[0].market_val || "0";
					$(_pageId+" .more_info ul li").eq(3).find("strong").html(fa.substring(0,fa.length-2)+"<em>"+ fa.substr(-2) +"</em>");//盈亏
				}
				else{
					$(_pageId+".hold_main2 .inner>strong").text("--");//总资产
					$(_pageId+".hold_main2 .more_info li strong").text("--");//市值
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 查询客户基金持仓
	 */
	function queryFundStock(isShowWait){
		$(_pageId+ ".no_data").hide();
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code
		};
		//最后一个为超时处理函数
		service_fund.queryFundData(param,queryFundStockCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
	    });
	}
	
	function queryFundStockCallBack(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryFundStockHTML(results[i]);
					}
					$(_pageId + ".fund_list").html(html);
					$(_pageId+".no_data").hide();
				}else{
					$(_pageId + ".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	function queryFundStockHTML(element){
		var price_digit = 3;
		var css = "";
		var	dividendmethod = "现金分红";
		if(element.dividendmethod == "0"){
			dividendmethod = "红利转投资";
		}
		if(element.income_balance > 0){
			css = "ared";
		}else if(element.income_balance < 0){
			css = "agreen";
		}else{
			css = "";
		}
		var eleHtml = "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><span class="stat">正常</span>';
        eleHtml += '<h5>'+element.fund_name+'<small>'+element.fund_code+'</small></h5></div><ul>';
        eleHtml += '<li>最新净值<span class="'+css+'">'+Number(element.nav)+'</span></li>';
        eleHtml += '<li>持有份额<span>'+Number(element.enable_shares)+'</span></li>';
        eleHtml += '<li>基金市值<span class="'+css+'">'+Number(element.market_value)+'</span></li>';
        eleHtml += '<li>分红方式<span>'+dividendmethod+'</span></li>';
        eleHtml += '</ul></div>';
        return eleHtml;
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
	}

	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height() - $("#afui #footer").height() - $(_pageId+".tab_nav").height() - 6, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				common.comStat(100984,2,102,true,{"i_direct":"1","i_type":"1"});
				queryData();
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

    
	/**
	 * 销毁
	 */
	function destroy(){
        commonFunc.clearCheckTradeTimer();
		common.pageBuryingPoint();
		$(_pageId+".hold_main2 .inner>strong").text("--");//总资产
		$(_pageId+".hold_main2 .more_info li strong").text("--");//市值
		$(_pageId + ".fund_list").html('');
		clearPositionTimer();
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
