/**
 * 场外基金-基金申购
 */
define('trade/scripts/fund/outside/purchase.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var appropriate = require("appropriate");
    var _pageId = "#fund_outside_purchase ";
	var keyboard = require("keyboard");
    var service_fund = require("service_fund");
    var noticeToInvestors = require("noticeToInvestors");
    var userInfo = null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var selectFund = $(_pageId+".select_fund");
	

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101028");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
    }
	function initPurchaseFunds() {
		 var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	//分支机构
        var fund_account = userInfo.fund_account;	//资产账户
        var cust_code = userInfo.cust_code;	//客户代码
        var fund_status = 0;
        var sessionid="";
        var fund_company ="";
       
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
            "fund_company":fund_company,
            "fund_status":fund_status,
        };
        service_fund.getFundInfo(param,queryFundDataCallback,{"timeOutFunc":bindGetEnablePurchaseList,"errorFunc":bindGetEnablePurchaseList});
	}
	
	function queryFundDataCallback(data) {
		if(data) {
			if(data.error_no == 0) {
				$(_pageId + ".select_fund").css("display","block");
				results = data.results;
				if(results && results.length > 0) {
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for(var i = 0; i < results.length; i++) {
						listData[results[i].fund_code + ""] = results[i];
						listDiv += "<li id='" + results[i].fund_code + "'><a href=\"javascript:void(0);\"style='display:table;width:100%'><em style=width:25%;display:table-cell>" + results[i].fund_code + "</em><span style='width:75%;display:table-cell'>" + results[i].fund_name + "</span></a></li>";
					}
					listDiv += "</ul></div>";
					//埋点参数
					var buriedPointParam={
						"backObjectId":101044,
						"backActionId":103,
						"backParamMap":{
							"i_group_name":"返回",
						 },
						 "pageObjectId2":101043,//页面埋点参数
						 "pageObjectId1":101028,
					}
					common.addChoiceList(selectFund, "选择申购基金代码", listDiv, function(data, div) {
						//埋点
						common.comStat(101030,2,103,true,{"i_group_name":"选择可申购基金"});
						var id = data.attr("id");
						$(_pageId + " #fundCode").quzhi(id);
						getFundList(id);
					},null,null,keyboard,buriedPointParam);
				} else {
					$(_pageId + " #fundCode").quzhi("暂无可申购基金");
				}
			} else {
				$.alert(data.error_info);
				//重新绑定事件
				bindGetEnablePurchaseList();
				$(_pageId + ".select_fund").css("display","block");
			}
		}
	}
	
	function bindGetEnablePurchaseList() {
		$.bindEvent($(_pageId + " .select_fund"), function(e) {
			$(this).unbind();
			queryHoldingsQuery();
			e.stopPropagation();
		});
	}
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		initPurchaseFunds();
		jumpPageEvent();
		queryCapital();
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101029,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/order","left");
			$(_pageId + ".select_fund").css("display","none");
			e.stopPropagation();
		});
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "0";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "money_type":money_type,
		};
		//最后一个为超时处理函数
		service_fund.queryFundSelect(param,queryCapitalCallback,{"isShowWait":false,"isShowOverLay":false});
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data){
			if(data.error_no == 0){
				
				var results = data.results;
				if(results && results[0]){
					$(_pageId+".fund_form2 .limit em").text(Number(results[0].enable_balance).toFixed(2));//可用
				}else{
					$(_pageId+".fund_form2 .limit em").text("--");//可用
				}
				
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 获取基金列表
	 * */
	function getFundList(fundStr){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		if(fundStr!= "" && fundStr.length==6){
			clearBuyMsg();
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var fund_code = fundStr;
			var fund_company="";
			var branch_no = userInfo.branch_no;	
			var fund_account = userInfo.fund_account;
			var cust_code = userInfo.cust_code;//关联资产账户标志
			var fund_status = 0;
			var param={				
					"entrust_way":entrust_way,
				    "branch_no":branch_no,
				    "fund_account":fund_account,
				    "cust_code":cust_code,
					"fund_company":fund_company,
					"fund_code":fund_code,
					"fund_status":fund_status
			};
			$(_pageId + ".select_fund").css("display","none");
			service_fund.getFundInfo(param,getFundInfoBack);
		}	
	}
	function getFundInfoBack(data){
		if(data.error_no == 0){
			$(_pageId + ".select_fund").css("display","block");
			var results = data.results;
			if(results && results.length > 0){
				var nav=results[0].nav!=""?results[0].nav:"0";
                var fundCompany = results[0].fund_company;
				$(_pageId+"#fundName").val(results[0].fund_name).attr("data-fundCom",fundCompany);
				$(_pageId+"#fundNav").val(nav);
				//埋点
				common.comStat(101031,2,104,true,{"i_change_name":"证券代码输入","i_change_to":results[0].fund_name});
			}
			else{
				$.alert("没有查询到对应的基金");
			}
		}else{
			$(_pageId + ".select_fund").css("display","block");
			$.alert(data.error_info);
		}
	}
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		//验证基金代码输入是否正确
		var buy_stockCode = $.trim($(_pageId+"#fundCode").quzhi());
		if(buy_stockCode.length == 0){
			$.alert("请输入基金代码");
			return false;
		}	
		if(buy_stockCode.length != 6){
			$.alert("基金代码输入错误");
			return false;
		}	
		//验证基金份额输入是否正确
		var now_price = $(_pageId+"#fundSum").val();
		var can_buy = $(_pageId+".fund_form2 .limit em").text();
		if($.trim(now_price).length<=0){
			$.alert("请输入申购金额");
			return false;
		}else if(now_price=="0"){
			$.alert("申购金额不能为0");
			return false;
		}else if(!validata.isNumberFloat(now_price)||parseFloat(now_price)<0){
			$.alert("请正确输入申购金额");
			return false;
		}else if(Number(now_price)>Number(can_buy)){
			$.alert("申购金额超过可用金额");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["基金名称", $(_pageId+" #fundName").val()]);
		tipStrArray.push(["基金代码 ", buy_stockCode]);
		tipStrArray.push(["申购金额 ", now_price]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray, "", "list");
		tipStr += "</div>";
		
		var param={
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"password":userInfo.password,
			"session_id":userInfo.sessionid,
			"fund_company":$(_pageId+"#fundName").attr("data-fundCom"),
		}
		noticeToInvestors.function399901(param,function(){
			//埋点数据
			var comStatParam={
				"objectId":$(_pageId+".ce_btn").attr("objectId"),
				"actionId":$(_pageId+".ce_btn").attr("actionId"),
				"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
				"i_stock_code":buy_stockCode, // 股票代码
				"i_stock_name":$(_pageId+" #fundName").val(), // 股票名称
				"i_entrust_prop":"", // 委托属性
				"i_exchange_type":$(_pageId+"#fundName").attr("data-fundCom"), // 交易市场
				"i_entrust_price":now_price, // 选择后的价格
				"i_entrust_amount":"", // 委托数量
			}
			var orderParam = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"sessionid":userInfo.sessionid,
				"fund_company":$(_pageId+"#fundName").attr("data-fundCom"),
				"exchange_type":$(_pageId+"#fundName").attr("data-fundCom"),
				"fund_code":buy_stockCode,
				"fund_name": $(_pageId+" #fundName").val(),
				"stock_code":buy_stockCode,
				"flag":"",
				"balance":now_price,
				"business_type":"2",
				"charge_type":"",//收费方式
				"prof_flag":userInfo.prof_flag
			};
			appropriate.placeOrder(comStatParam,orderParam,tipStr,function(instr_batch_no){
				orderParam.instr_batch_no = instr_batch_no;
				service_fund.getpurchaseBuy(orderParam,function(data){
					$.hidePreloader();
					getBuyCallBack(data,orderParam);
				},{"isLastReq":false,"isShowWait":false,
					"timeOutFunc":function(){
						$.hidePreloader();
					},"errorFunc":function(){
						$.hidePreloader();
					}});
				$.showPreloaders("请等待...");
			});
		});
	}
	//申购回调
	function getBuyCallBack(data,param){
		if(data.error_no == 0){
			var results = data.results;
				if(results){
					$.alert(data.error_info);
					queryCapital();
					appropriate.function399931({serial_no:results[0].serial_no});
				}
			$(_pageId+"#fundCode").quzhi("");
			clearBuyMsg();
	  	}else if(data.error_no == "-30200710") {
			var imsg = "该基金您暂未开通权限，您是否现在开通？";
			common.iConfirm("基金开户",imsg,function() { // 点击确定
				var param = {
						"entrust_way" : global.entrust_way, // 委托方式  在configuration配置
						"branch_no" : userInfo.branch_no, // 分支机构
						"fund_account" : userInfo.fund_account, //资产账户
						"cust_code" : userInfo.cust_code, //客户代码
						"sessionid" : userInfo.sessionid, // 会话号
						"fund_company" : $(_pageId+"#fundName").attr("data-fundCom") // 基金公司代码
				};
				// 基金开户
				service_fund.fundOpenAccount(param, function(data){
					if(data.error_no == 0) {
						$.alert("基金户开通成功");
						//vailSubmitOrder();
					} else {
						$.alert(data.error_info);
					}
				});
			});
		}else if(data.error_no == "-30200711"){
			common.iConfirm("下单提示",data.error_info,function() {
				param.flag = "1";
				service_fund.getpurchaseBuy(param,getBuyCallBack);
			});
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//股票代码输入框监听
		$.bindEvent($(_pageId+"#fundCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var fundCode = $.trim($(this).quzhi());
			if(fundCode.length == 6){
				getFundList(fundCode);
			}else{
				clearBuyMsg();
			}
			e.stopPropagation();
		},"input");

		//金额输入
		$.bindEvent($(_pageId+"#fundSum"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		},"input");
		
		//申购
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//埋点
			common.comStat(101032,2,103,true,{"i_group_name":"申购提交"});
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		
		
	}
	
	
	/**
	 * 重置页面数据  
	 */
	function clearBuyMsg(){
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundNav").val("");
		$(_pageId + "#fundSum").quzhi("");
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		clearBuyMsg();
		if(keyboard){
			keyboard.keyDestroy();
		}
		$(_pageId + "#fundCode").quzhi("");
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});