/**
 * 场外基金-今日查询
 */
define('trade/scripts/fund/outside/queryToday.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var _pageId = "#fund_outside_queryToday ";
    var userInfo = null;
    var queryType = null; //查询内容
    
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		queryType = $.getPageParam("param");
		if(queryType=="entrust"){
			common.pageBuryingPoint("101230");
			$(_pageId+".vertical_list").attr("objectId","101233");
			$(_pageId+".vertical_list").attr("actionId","102");
			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
		}else{
			common.pageBuryingPoint("101239");
			$(_pageId+".vertical_list").attr("objectId","101240");
			$(_pageId+".vertical_list").attr("actionId","102");
			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
		}
		callsQuery();
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			//埋点
			if($(_pageId + ".top_title .toggle_nav ul li.active").index()==0){
				common.comStat(101234,2,103,true,{"i_group_name":"返回"});
			}else{
				common.comStat(101241,2,103,true,{"i_group_name":"返回"});
			}
			$.pageBack("fund/outside/query","left");
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			$(this).addClass("active").siblings().removeClass("active");
			callsQuery();
			common.pageBuryingPoint();
			if($(_pageId + ".top_title .toggle_nav ul li.active").index()==0){
				$(_pageId+".vertical_list").attr("objectId","101233");
				$(_pageId+".vertical_list").attr("actionId","102");
				common.pageBuryingPoint("101230");
			}else{
				$(_pageId+".vertical_list").attr("objectId","101240");
				$(_pageId+".vertical_list").attr("actionId","102");
				common.pageBuryingPoint("101239");
			}
			//埋点
			var objectId=$(this).attr("objectId");
			var actionId=$(this).attr("actionId");
			var name=$(this).attr("name");
			common.comStat(objectId,2,actionId,true,{"i_group_name":name});
		});
		
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		$(_pageId+".fund_list2").html("");
		if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
			queryEntrust();
		}else{
			queryDeal();
		}
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "sessionid":sessionid
			};
			$(_pageId+ ".no_data").hide();
			service_fund.queryTodayTrust(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){ // 超时调用方法
					$(_pageId+ ".no_data").show();
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}
		        }
			});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".main .fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryEntrustHTML(results[i],i);
					}
					$(_pageId+ ".main .fund_list2").html(html);
					$(_pageId+ ".no_data").hide();
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element,i){
		var price_digit = 3;
		var css = "";
		var eleHtml = "";
      	eleHtml +='<div class="part">';
        eleHtml +='<div class="title">';
        eleHtml +='<h5>'+element.fund_name+' <small>'+element.fund_code+'</small></h5></div><ul>';
        eleHtml +='<li>委托类型  <span>'+element.business_name+'</span></li>';
        eleHtml +='<li>委托状态  <span>'+element.entrust_status_mame+'</span></li>';
        eleHtml +='<li>委托份额  <span>'+Number(element.shares).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托金额 <span>'+Number(element.balance).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托时间 <span>'+element.entrust_time+'</span></li>';
        eleHtml +='</ul></div>';
		return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid
		};
		$(_pageId+ ".no_data").hide();
		service_fund.queryTodayTrade(param,queryDealCallback,
		    {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
	        }
		});
		
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryDealHTML(results[i],i);
					}
					$(_pageId+".main .fund_list2").html(html);
					$(_pageId+".no_data").hide();
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element,i){
		var price_digit = 3;
		var css = "";
		var eleHtml = "";
      	eleHtml +='<div class="part">';
        eleHtml +='<div class="title"><span class="tag n1">'+element.business_name+'</span>';
        eleHtml +='<h5>'+element.fund_name+' <small>'+element.fund_code+'</small></h5></div><ul>';
        eleHtml +='<li>委托份额  <span>'+Number(element.shares).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托金额 <span>'+Number(element.balance).toFixed(price_digit)+'</span></li>';
        eleHtml +='<li>委托时间 <span>'+element.business_time+'</span></li>';
        eleHtml +='</ul></div>';
		return eleHtml;
	}
	
	// /**
	//  * 初始化滑动组件
	//  */
	// function initVIScroll(){
	// 	if(!vIscroll._init){
	// 		var config = {
	// 				"isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
	// 				"visibleHeight": $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6 ,//显示内容区域的高度，当isPaingType为false时传
	// 				"container": $(_pageId+"#v_container_funds_jj"),
	// 				"wrapper":$(_pageId+"#v_wrapper_funds_jj"),
	// 				"downHandle": function() {
	// 					callsQuery();//下拉获取上一页数据方法
	// 				},
	// 				"upHandle": function() {
	// 					//上拉获取下一页数据方法
	// 				},
	// 				"wrapperObj": null
	// 		};
	// 		vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
	// 		vIscroll._init = true;
	// 	} else {
	// 		vIscroll.scroll.refresh();
	// 	}
	// 	$(_pageId+ ".visc_pullUp").hide();
	// }

	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height()- 6, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				var objectId=$(_pageId+".vertical_list").attr("objectId");
				var actionId=$(_pageId+".vertical_list").attr("actionId");
				common.comStat(objectId,2,actionId,true,{"i_direct":"1","i_type":"1"});
				
				callsQuery();
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".main .fund_list2").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		$.pageInit("stock/stockQueryToday","stock/stockQuery",{});
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});