/**
 * 场外基金-赎回
 */
define('trade/scripts/fund/outside/redeem.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#fund_outside_redeem ";
    var service_fund = require("service_fund");
	var keyboard = require("keyboard");
    var userInfo= null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var listData = {};
	var fundInfo = {};

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101077");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		jumpPageEvent();
		
		queryHoldingsQuery();//查询可赎回基金
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(101078,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/order","left");
			$(_pageId+".big_select").css("display","none");
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid="";
		var fund_company ="";
		var fund_code ="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
		};
		service_fund.queryFundData(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for (var i=0;i<results.length;i++){
						listData[results[i].fund_code+""] = results[i];
						listDiv += "<li id='"+results[i].fund_code+"'><a href=\"javascript:void(0);\">"+results[i].fund_name+" <small>"+results[i].fund_code+"</small></a></li>";
					}
					listDiv += "</ul></div>";
					
					//埋点参数
					var buriedPointParam={
						"backObjectId":101094,
						"backActionId":103,
						"backParamMap":{
							"i_group_name":"返回",
						 },
						 "pageObjectId2":101093,//页面埋点参数
						 "pageObjectId1":101077,
					}
					common.addChoiceList($(_pageId+"#fund_code p"), "选择赎回基金代码",listDiv,function(data, div){
						//埋点
						common.comStat(101079,2,103,true,{"i_group_name":"选择可赎回基金"});
						
						div.html(data.find("a small").text());
						var id = data.attr("id");
						fundInfo = listData[id];
						$(_pageId + "#fundName").val(fundInfo.fund_name);
						$(_pageId + "#fundNav").val(fundInfo.nav || 0);
						$(_pageId+".fund_form2 .limit em").text(Number(fundInfo.enable_shares));//持有份额
						$(_pageId + "#fundSum").val("");
					},null,null,keyboard,buriedPointParam);
				}
				else{
					$(_pageId+"#fund_code p").text("暂无可赎回基金");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	//下单提交基金
	function submitOrderFund(){
		if(common.size(listData) == 0){
			$.alert("没有可赎回的基金");
			return false;
		}
		if(!common.isValue(fundInfo)){
			$.alert("请选可赎回的基金");
			return false;
		}
		var numMax =$(_pageId+".fund_form2 .limit em").text();
		var fundSum = $(_pageId+"#fundSum").val();
		if(validata.isEmpty(numMax)|| numMax=="0" || numMax=="--"){
			$.alert("可赎份额为0");
			return false;
		}
		if(validata.isEmpty(fundSum)||isNaN(fundSum)){
			$.alert("赎回份额不能为空或者不正确");
			return false;
		}else if(Number(fundSum)>Number(numMax)){
			$.alert("赎回份额不能大于可赎份额");
			return false;
		}
		var exceedflagText = $(_pageId+"#market_list .select_box p").text();
		var exceedflag;
		if(exceedflagText == "放弃") {
			exceedflag = 0;
		}else if(exceedflagText == "顺延") {
			exceedflag = 1;
		}else {
			$.alert("请选择巨额标识");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["基金名称", fundInfo.fund_name]);
		tipStrArray.push(["基金代码 ", fundInfo.fund_code]);
		tipStrArray.push(["赎回份额 ", fundSum]);
		tipStrArray.push(["巨额标识",exceedflagText]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		//埋点数据
		var comStatParam={
			"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":fundInfo.fund_code, // 股票代码
			"i_stock_name":fundInfo.fund_name, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":"", // 交易市场
			"i_entrust_price":"", // 选择后的价格
			"i_entrust_amount":fundSum, // 委托数量
		}
		var objectId = $(_pageId+".ce_btn").attr("objectId");
		var actionId = $(_pageId+".ce_btn").attr("actionId");
		common.iConfirm("下单确定",tipStr,function success(){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;      //分支机构
			var fund_account = userInfo.fund_account; //资金账号
			var cust_code = userInfo.cust_code;       //客户编号
			var sessionid = userInfo.session_id;      //会话号
			var fund_company = "";                    //基金公司
			var fund_code = fundInfo.fund_code; //基金代码
			var amount = fundSum;      //赎回份额
			var param = {
					"entrust_way" : entrust_way,
					"branch_no" : branch_no,
					"fund_account" : fund_account,
					"cust_code" : cust_code,
					"sessionid" :sessionid,
					"fund_company" : fund_company,
					"fund_code" : fund_code,
					"amount" : amount,
					"exceedflag" : exceedflag
			};
			service_fund.submitOrder(param,function(data){
				if(data.error_no ==0){
					var msg="赎回成功，流水号"+data.results[0].serial_no;
					$.alert(msg);
					clearMsg();
					$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
				}else{
					clearMsg();
					$.alert(data.error_info);
				}
				queryHoldingsQuery();
			});
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
			common.comStat(objectId,2,actionId,false,comStatParam);
		},function fail(){
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
			common.comStat(objectId,2,actionId,false,comStatParam);
		});
		$(_pageId+"#newTradingTipsBox2 ._content .table_tips_list tr td:eq(0)").css({"width":"25%"});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//赎回
		$.bindEvent($(_pageId + ".fund_form2 .ce_btn"), function(e){
			//埋点
			common.comStat(101080,2,103,true,{"i_group_name":"赎回提交"});
			submitOrderFund();
			$(_pageId+".big_select").css("display","none");
			 e.stopPropagation();
		});
		
		//赎回数量输入
		$.bindEvent($(_pageId+"#fundSum"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			$(_pageId+".big_select").css("display","none");
			e.stopPropagation();
		},"input");
		
		//巨额选择
		$.bindEvent($(_pageId+"#market_list"),function (e) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			if($(_pageId+".big_select").css("display") == "none"){
				$(_pageId+".big_select").css("display","block");
			}else {
				$(_pageId+".big_select").css("display","none");
			}
			
			e.stopPropagation();
		},"click");
		
		$.bindEvent($(_pageId+".big_select li:eq(0)"),function (e) {
			$(_pageId+".big_select").css("display","none");
			$(_pageId+"#market_list p").text("放弃");
			//埋点
			common.comStat(101082,2,104,true,{"i_change_name":"赎回方式","i_change_to":"放弃"});
			e.stopPropagation();
		},"click");
		
		$.bindEvent($(_pageId+".big_select li:eq(1)"),function (e) {
			$(_pageId+".big_select").css("display","none");
			$(_pageId+"#market_list p").text("顺延");
			//埋点
			common.comStat(101082,2,104,true,{"i_change_name":"赎回方式","i_change_to":"顺延"});
			
			e.stopPropagation();
		},"click");
		
		$.bindEvent($(_pageId),function (e) {
			if(keyboard) {
				keyboard.closeKeyPanel();
			}
			$(_pageId+".big_select").css("display","none");
			e.stopPropagation();
		},"click");
		
	}

	function clearMsg() {
		fundInfo = {};
		$(_pageId+" .select_box p").text("请选择...");
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundNav").val("");
		$(_pageId + "#fundSum").quzhi("");
		$(_pageId+".listSelection.radio .list li").removeClass("active");
		$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
      		
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		if(keyboard){
			keyboard.keyDestroy();
		}
		clearMsg();
		listData=[];
		$(_pageId+".fund_form2 .limit em").text("--"); //可赎份额数量
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});