/**
 * 场外基金 -- 风险测评
 */
define('trade/scripts/fund/outside/riskEvaluation.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_fund = require("service_fund");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var userInfo = null;
	var mainHeight = null;
	var _pageId = "#fund_outside_riskEvaluation ";
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101640");
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			common.comStat(101641,2,103,true,{"i_group_name":"返回"});
			$.pageBack("fund/outside/order","left");
			e.stopPropagation();
		});
        $(_pageId+" .test_result .notice_box").hide();
		userInfo = common.getCurUserInfo();
		$(_pageId + ".test_result").hide();
		$(_pageId + ".test_main").hide();
		queryRiskLevel();
    }
	
	function load(){
		mainHeight =  common.setMainHeight(_pageId, false);//设置页面高度 显示隐藏底部
	}
	
	function queryRiskLevel(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
			    "organ_flag":"0"
		};
		//最后一个为超时处理函数
		service_fund.queryRiskLevel(param,queryRiskLevelCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				queryRiskQuestions();
			}
	    });
	}
	
	function queryRiskLevelCallBack(data){
		if (data) {
			if (data.error_no == 0) {
				var results = data.results;
				if(results && results.length > 0 && results[0]){
					$(_pageId + ".test_result").show();
					$(_pageId + ".test_main").hide();
					$(_pageId+" .test_result .links").hide();
					$(_pageId+" .test_result .inner").show();
					//corp_end_date是测评日，update_date到期日
					var update_date=results[0].update_date.substr(0,4)+"-"+results[0].update_date.substr(4,2)+"-"+results[0].update_date.substr(6,2);
					if(results[0].risk_flag == 1){
						$(_pageId+" .test_result .inner .icon").addClass("over");
						$(_pageId+" .test_result .inner .icon strong").text("0");
						$(_pageId+" .test_result .inner .icon p").text("已过期");
						$(_pageId+" .test_result .inner .icon span").text("到期时间："+update_date);
						var txt = "您好，您的风险测评已过期，上次测评日期是"+update_date;
                        $(_pageId+" .test_result .notice_box").show();
						$(_pageId+" .test_result .notice_box p span").text(txt);
                        $(_pageId+" .test_result .links").show();
					}else if(results[0].risk_flag == 2){
						$(_pageId+" .test_result .inner .icon").addClass("over");
						$(_pageId+" .test_result .inner .icon strong").text("0");
						$(_pageId+" .test_result .inner .icon p").text(results[0].risk_name);
						$(_pageId+" .test_result .inner .icon span").text("到期时间："+update_date);
						var txt = "您好，您目前未做风险测评";
                        $(_pageId+" .test_result .notice_box").show();
						$(_pageId+" .test_result .notice_box p span").text(txt);
                        $(_pageId+" .test_result .links").show();
					}
					else{
						$(_pageId+" .test_result .inner .icon").removeClass("over");
						// $(_pageId+" .test_result .inner .icon strong").text(results[0].risk_level);
						$(_pageId+" .test_result .inner .icon strong").text(Number(results[0].paper_score).toFixed(0));
						$(_pageId+" .test_result .inner .icon p").text(results[0].risk_name);
						$(_pageId+" .test_result .inner .icon span").text("到期时间："+update_date);
						if(results[0].risk_level > 2){
							$(_pageId+" .test_result .notice_box").hide();
							$(_pageId+" .test_result .links").show();
						}
						else{
							$(_pageId+" .test_result .notice_box").show();
							var txt = "您好，你的测评等级为"+results[0].risk_name+"，不利于后面综合评分，";
							$(_pageId+" .test_result .notice_box p span").text(txt);
                            $(_pageId+" .test_result .links").show();
						}
					}
				}
				else{
					queryRiskQuestions();
				}
			}
			else{  
				$.alert(data.error_info,function () {
					queryRiskQuestions();
				});
			}
		}
	}
	
	
	/**
	 * 风险测评题目查询
	 */
	function queryRiskQuestions(){
		$(_pageId + ".test_result").hide();
		$(_pageId + ".test_main").show();
		var testHeight = mainHeight - $(_pageId+" .test_main .ce_btn").outerHeight(true) - 10;
		// $(_pageId + " .test_main .test").html("").height(testHeight);
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
			    "organ_flag":"0"
		};
		//最后一个为超时处理函数
		service_fund.queryRiskQuestions(param,queryRiskQuestionsCallBack,{
			"timeOutFunc":function(){ // 超时调用方法
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 查询基金题目回调
	 */
	function queryRiskQuestionsCallBack(data){
		if(data.error_no == "0"){
			if(data.results[0]){
				creatHtml(data.results);
				// 为选择按钮添加事件
				$.bindEvent($(_pageId+" .test_main .test_box ul li"),function(){
					var quetype = $(this).attr("data-kind");	 // 问题类型0：单选，1：多选
					if(quetype == 1){
						if($(this).find("input").attr("checked")){
							$(this).find("input").removeAttr("checked");
						}else{
							$(this).find("input").attr("checked","checked");
						}
					}else{
						$(this).siblings().find("input").removeAttr("checked");
						if($(this).find("input").attr("checked")){
							$(this).find("input").removeAttr("checked");
						}else{
							$(this).find("input").attr("checked","checked");
						}
					}
				},"tap");
			}
		}else{
			$.alert(data.error_info);
			return false;
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 生成题目的html
	 */
	function creatHtml(data){
		var question_no;
		var length = data.length;
		var k = 1;
		var html = [];
		for(var i=0; i < length; i++){
			var result = data[i];
			var question_content = data[i].question_content;//问题内容
			var answer_content =  data[i].answer_content;//答案内容
			var answer_no = data[i].answer_no;
			var kind = data[i].question_kind;//问题类型(0：单选，1：多选)
			if(question_no != data[i].question_no){
				if(i != 0){
					html.push("</ul></div>");
				}
				html.push("<div class=\"test_box\"><h5>"+k+"，"+question_content+"</h5>");
				k++;
	        	html.push("<ul>");
	            html.push("<li  data-kind='"+kind+"'><span class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no='"+data[i].question_no+"' data-answer_no='"+answer_no+"' data-score='"+data[i].score+"' /><label for=\"radio_1\">"+answer_content+"</label></span></li>");
			}else{
				html.push("<li  data-kind='"+kind+"'><span class=\"icon_radio\"><input type=\"radio\" class=\"r1\" data-question_no='"+data[i].question_no+"' data-answer_no='"+answer_no+"' data-score='"+data[i].score+"' /><label for=\"radio_1\">"+answer_content+"</label></span></li>");
			}
			question_no = data[i].question_no;
		}
		if(length != 0){
			html.push("</ul></div>");
		}
		$(_pageId + " .test_main .test").html(html.join(""));
	}

	/**
	 * 获取后端需要的答案
	 */
	function getAnswer(){
		var oDl = $(_pageId + " .test_box");
		var custTotalAnswer = "";
		var aNotFinish = []; // 题目未完成的数组
		for(var num =0;num<oDl.length;num++){
			var custAnswer = [];
			var custScore = [];
			var actCheckBox = oDl.eq(num).find("input");
			var ans_question_no = actCheckBox.eq(0).attr("data-question_no");
			if(oDl.eq(num).find("input[checked='checked']").length==0){
				aNotFinish.push(num+1);
				continue;
			}
			for(var i = 0;i<actCheckBox.length;i++){
				var oInput = actCheckBox.eq(i);
				var hasChecked = oInput.attr("checked");
				if(hasChecked == "checked"){
					var k = 0;
					var ans_answer_no = oInput.attr("data-answer_no");
					var ans_score = oInput.attr("data-score");
					custAnswer[k] = ans_answer_no;
					custScore[k] = ans_score;
					k++;
				}
			}
			custTotalAnswer += ans_question_no + "|" + custAnswer.toString()+ "|" + custScore.toString() + ";";
			//custTotalAnswer += ans_question_no + "&" + custAnswer.toString() + "|" ;
		}
		if(aNotFinish.length > 0){
			$.alert("您的风险测评还有题目未完成，请继续完成：" + aNotFinish.join(","));
			return false;
		}
		return custTotalAnswer;
	}
	
	
	
	/**
	 * 提交客户所需要的答案
	 */
	function submitCustAnswer(){
		//获取保存在本地的账户信息
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var password = userInfo.password;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var risk_kind = "1";//0 A股 1 基金
		var paper_answer = getAnswer();
		if(!paper_answer){
			return false;
		}
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "password":password,
			    "risk_kind":risk_kind,
			    "organ_flag":"0",
			    "paper_answer":paper_answer
		};
		//最后一个为超时处理函数
		service_fund.submitCustAnswer(param,queryRiskLevelCallBack,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
			}
	    });
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		$.bindEvent($(_pageId+" .test_result p a"),function(e){
			queryRiskQuestions();
			e.stopPropagation();
		},"tap");
		
		$.bindEvent($(_pageId+" .test_main .ce_btn a"),function(e){
			submitCustAnswer();
			e.stopPropagation();
		},"tap");
	}

	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height(), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: false, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			// pullDownHandler: function(){
			// }
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId + " .test_main .test").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});