/**
 * 场外基金-基金转托
 */
define('trade/scripts/fund/outside/transfer.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var _pageId = "#fund_outside_transfer ";
	var service_fund = require("service_fund");
    var userInfo= null;
    	require("validatorUtils");
	var validata = $.validatorUtils;
	var listData = {};
	var fundInfo = {};
    /**
     * 初始化
     */
	function init(){
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		queryHoldingsQuery();//查询可赎回基金
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
	}
	
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid="";
		var fund_company ="";
		var fund_code ="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"fund_company":fund_company,
				"fund_code":fund_code,
		};
		service_fund.queryFundData(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for (var i=0;i<results.length;i++){
						listData[results[i].fund_code+""] = results[i];
						listDiv += "<li id='"+results[i].fund_code+"'><a href=\"javascript:void(0);\">"+results[i].fund_name+" <small>"+results[i].fund_code+"</small></a></li>";
					}
					listDiv += "</ul></div>";
					common.addChoiceList($(_pageId+" .select_box p"), "选择转出基金",listDiv,function(data, div){
						div.html(data.find("a small").text());
						var id = data.attr("id");
						fundInfo = listData[id];
						$(_pageId + "#fundName").val(fundInfo.fund_name);
						$(_pageId + "#fundNav").val(fundInfo.nav || 0);
						$(_pageId + "#fundCompany").val(fundInfo.company_name);
						$(_pageId+".fund_form2 .limit em").text(Number(fundInfo.enable_shares));//持有份额
						$(_pageId + "#fundSum").val("");
					},null,null,keyboard);
				}
				else{
					$(_pageId+" .select_box p").text("暂无可转出基金");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}

	function vailSubmitOrder(){
		if(common.size(fundInfo) == 0){
			$.alert("没有可转出的基金");
			return false;
		}
		if(!common.isValue(fundInfo)){
			$.alert("请选转出的基金");
			return false;
		}
		var numMax =$(_pageId+".fund_form2 .limit em").text();
		//托管机构代码
		var agentCode=$(_pageId+"#agencyCode").val();
		if(!agentCode||agentCode.length==0){
			$.alert("请输入托管机构代码");
			return false;
		}
		var fundSum = $(_pageId+"#fundSum").val();
		if(validata.isEmpty(numMax)|| numMax=="0" || numMax=="--"){
			$.alert("可转份额为0");
			return false;
		}
		if(validata.isEmpty(fundSum)){
			$.alert("转出份额不能为空");
			return false;
		}else if(Number(fundSum)>Number(numMax)){
			$.alert("转出份额不能大于可转份额");
			return false;
		}
		var tipStrArray = [];
		tipStrArray.push(["转出基金名称", fundInfo.fund_name]);
		tipStrArray.push(["转出基金代码 ", fundInfo.fund_code]);
		tipStrArray.push(["托管机构代码", agentCode]);
		tipStrArray.push(["转出数量 ", fundSum]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		common.iConfirm("下单确定",tipStr,function success(){
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;      //分支机构
			var fund_account = userInfo.fund_account; //资金账号
			var cust_code = userInfo.cust_code;       //客户编号
			var sessionid = userInfo.session_id;      //会话号
			var fund_company = fundInfo.fund_company;                    //基金公司
			var fund_code = fundInfo.fund_code; //基金代码
			var agentCode = agentCode;
			var balance = fundSum;
			var param = {
				"entrust_way" : entrust_way,
				"branch_no" : branch_no,
				"fund_account" : fund_account,
				"cust_code" : cust_code,
				"sessionid" :sessionid,
				"fund_company" : fund_company,
				"fund_code" : fund_code,
				"agentCode" :agentCode,
				"balance" : balance
			};
			service_fund.fundTransferEntrust(param,function (data) {
				if (typeof data != "undefined" && data != null) {
					if (data.error_no == 0) {
						if(typeof data.results[0] != "undefined" && data.results[0] != null ){
							$.alert("撤单成功,流水号"+results[0].entrust_no);
							clearMsg();
						}
					}else{
						$.alert(data.error_info);
					}
				}else{
					$.alert("转托失败");
				}
			});
		},function fail(){});
	}



	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageBack("fund/outside/order","left");
			e.stopPropagation();
		});
		//转出数量
		$.bindEvent($(_pageId+"#fundSum"),function (e) {
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		},"input");
		//下单提交
		$.bindEvent($(_pageId+".ce_btn a"),function (e) {
			vailSubmitOrder();
			e.stopPropagation()
		},"tap");
	}

	//清除数据
	function clearMsg() {
		fundInfo={};
		$(_pageId + "#fundName").val("");
		$(_pageId + "#fundCompany").val("");
		$(_pageId+"#fundNav").val("");
		$(_pageId+"#agencyCode").val("");
		$(_pageId+"#fundSum").quzhi("");
		$(_pageId+".fund_form2 .limit em").text("--");
		$(_pageId+" .select_box p").text("选择转出基金");
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		if(keyboard){
			keyboard.keyDestroy();
		}
		fundInfo={};
		clearMsg();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});