/**
 * 创业板盘后-委托查询
 */
define('trade/scripts/gemAfter/gemEntrustQuery.js', function(require, exports, module) {
    var _pageId = "#gemAfter_gemEntrustQuery ";
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
    var downslide = new (require("downslide")).Downslide();
    var commonFunc = require("commonFunc");
	var	service_gemAfter = require("service_gemAfter").getInstance();
	var titleObj = {// 页面标题集合
		today_entrust: "当日委托",
		today_deal: "当日成交",
		history_entrust: "历史委托"
	};
	var queryType = '';// 委托类型 对应titleObj的key
    
    /**
     * 初始化
     */
	function init(){
		queryType = $.getPageParam("param");
		$(_pageId + ".top_title h3").text(titleObj[queryType] || '--');
		$(_pageId + ".data_check").css("display", queryType == "history_entrust" ? "block": "none");
		if(queryType == "history_entrust") {// 历史查询 初始化日期组件
			commonFunc.initTimeChoice(_pageId,6, true);
		}
		userInfo = common.getCurUserInfo();
		downslide.addSlide();// 添加滑动组件dom
    }
		
	function load(){
		var slideHeight = $(window).height() - $(_pageId + "header").height() - $(_pageId + " .data_check").height();
		downslide.slideInit(slideHeight, function() {queryData();});// 初始化滑动组件 高度、下拉回调
		$(_pageId + ".no_data").height(slideHeight-20);// 暂无数据高度
		
		queryData();// 查询数据
	}
	
	function queryData() {// 查询数据
		var ctrlParam = {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 请求错误异常调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				common.setNoData(true);
	        },
			"timeOutFunc":function(){ // 超时调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				common.setNoData(true);
	        }
		}
		
		if(userInfo) {// 存在用户信息 已登录
			var end_time = $(_pageId+" #endDate").text();
			var begin_time = $(_pageId+" #startDate").text();			
			var param = {
				"account_type": userInfo._loginClass,
				"entrust_way": global.entrust_way,
				"branch_no": userInfo.branch_no,
				"fund_account": userInfo.fund_account,
				"password": userInfo.password,
				"cust_code": userInfo.cust_code,
				"sessionid": userInfo.sessionid,
				"begin_date": begin_time,
				"end_date": end_time
			};
			
			if(queryType == "history_entrust") {// 历史委托
				var time1 = new Date(param.end_date.replaceAll("-", "/"));
				var time2 = new Date(param.begin_date.replaceAll("-", "/"));
				if(time1 < time2) {
					$.alert("开始日期大于截止日期");
					return false;
				}
				service_gemAfter.history_entrust_ser(param, queryDataCallback, ctrlParam);
			} else if(queryType == "today_deal") {// 当日成交
				service_gemAfter.today_deal_ser(param, queryDataCallback, ctrlParam);
			} else if(queryType == "today_entrust") {// 当日委托
				service_gemAfter.today_entrust_ser(param, queryDataCallback, ctrlParam);
			} else common.setNoData(true, 0);
		} else {
			common.setNoData(true, 0);
		}
	}
	
	function queryDataCallback(data) {
		if(data) {
			if(data.error_no == 0) {
				if(data.results && data.results.length > 0) {
					common.setNoData(false);
					var eleHtml = [];
					for (var i = 0; i < data.results.length; i++) {
						if($.isValue(data.results[i].stock_name_long)) data.results[i].stock_name = data.results[i].stock_name_long;
						var element = data.results[i];
						var html = "<div class='part'>"+
						"<div class='title'><span class='tag "+(["n1","n2"][Number(element.entrust_bs)]||"")+"'>"+element.entrust_name+"</span>"+
						"<strong style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 14, $(window).width() * 0.48) +"px;'>"+element.stock_name+"</strong><small>"+element.stock_code+"</small><span class='time'>"+(queryType == "today_deal"?"":element.entrust_state_name)+"</span></div>";
						if(queryType == "today_entrust") {
							html+="<ul><li><span>委托价格</span><p>"+element.entrust_price+"</p></li>"+
							"<li><span>委托数量</span><p>"+element.entrust_amount+"</p></li>"+
							"<li><span>成交数量</span><p>"+element.business_amount+"</p></li>"+
							"<li><span>委托编号</span><p>"+element.entrust_no+"</p></li>"+
							"<li><span>委托时间</span><p>"+element.entrust_time+"</p></li>"+
							"</ul>";
						} else if(queryType == "today_deal") {
							html+="<ul><li><span>成交价格</span><p>"+element.business_price+"</p></li>"+
							"<li><span>成交数量</span><p>"+element.business_amount+"</p></li>"+
							"<li><span>成交编号</span><p>"+element.business_no+"</p></li>"+
							"<li><span>成交时间</span><p>"+element.business_time+"</p></li>"+
							"</ul>";
						} else if(queryType == "history_entrust") {
							html+="<ul><li><span>委托价格</span><p>"+element.entrust_price+"</p></li>"+
							"<li><span>委托数量</span><p>"+element.entrust_amount+"</p></li>"+
							(Number(element.business_amount)>0?("<li><span>成交价格</span><p>"+element.business_price+"</p></li>"):"")+
							"<li><span>成交数量</span><p>"+element.business_amount+"</p></li>"+
							"<li><span>委托编号</span><p>"+element.entrust_no+"</p></li>"+
							"<li><span>委托日期</span><p>"+element.entrust_date+"</p></li>"+
							"</ul>";
						}
						html+="</div>";
						eleHtml.push(html);
					}
					$(_pageId + ".cancel_order").html(eleHtml.join(""));
				} else {
					$(_pageId + ".cancel_order").html("");
					common.setNoData(true);
				}
			} else {
				$(_pageId + ".cancel_order").html("");
				common.setNoData(true);
				$.alert(data.error_info);
			}
			downslide.slideRefresh();
		}
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//查询
		$.bindEvent($(_pageId + "#clickQuery"), function(e){
			queryData();
			e.stopPropagation();
		});
		
		//刷新按钮
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			queryData();
			e.stopPropagation();
		});
		
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + ".cancel_order").html("");
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
