/**
 * 创业板盘后-撤单
 */
define('trade/scripts/gemAfter/gemStockCancel.js', function(require, exports, module) {
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#gemAfter_gemStockCancel ";
	var downslide = new (require("downslide")).Downslide();
	var	service_gemAfter = require("service_gemAfter").getInstance();
	var witchAccount = null;
	var userInfo = null;
	var dataResults = [];// 撤单列表

    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		var paramMap=$.getPageParam("param");
		if(paramMap && Object.getOwnPropertyNames(paramMap).length != 0){
			if(paramMap && typeof(paramMap) == "string"){
				paramMap = JSON.parse(paramMap);
			}
			if(paramMap.switchUserInfo){
				common.switchingCurUser(paramMap.switchUserInfo);
			}
		}
		userInfo = common.getCurUserInfo();
		downslide.addSlide();// 添加滑动组件dom
    }
		
	function load(){
		var slideHeight = $(window).height() - $(_pageId + "header").height() - $(_pageId + ".tab_nav").height();
		downslide.slideInit(slideHeight, function() {queryData();});// 初始化滑动组件 高度、下拉回调
		$(_pageId + ".no_data").height(slideHeight-20);// 暂无数据高度
		
		queryData();// 查询数据
	}
	
	function queryData() {// 查询数据
		var ctrlParam = {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 请求错误异常调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				common.setNoData(true, 1);
	        },
			"timeOutFunc":function(){ // 超时调用方法
				downslide.slideRefresh();
				downslide.loadFinished();
				common.setNoData(true, 1);
	        }
		}
		
		if(userInfo) {// 存在用户信息 已登录
			var param = {
				"account_type": userInfo._loginClass,
				"entrust_way": global.entrust_way,
				"branch_no": userInfo.branch_no,
				"fund_account": userInfo.fund_account,
				"password": userInfo.password,
				"cust_code": userInfo.cust_code,
				"sessionid": userInfo.sessionid
			};
			service_gemAfter.gemCancelQuery_ser(param, queryDataCallback, ctrlParam);
		} else {
			common.setNoData(true, 0);
		}
	}
	
	function queryDataCallback(data) {
		dataResults = [];
		if(data) {
			if(data.error_no == 0) {
				if(data.results && data.results.length > 0) {
					common.setNoData(false);
					var eleHtml = [];
					for (var i = 0; i < data.results.length; i++) {
						if($.isValue(data.results[i].stock_name_long)) data.results[i].stock_name = data.results[i].stock_name_long;
						var element = data.results[i];
						var html = "<div class='part'>"+
						"<div class='title'><span class='tag "+(["n1","n2"][Number(element.entrust_bs)]||"")+"'>"+element.entrust_name+"</span>"+
						"<strong style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 14, $(window).width() * 0.48) +"px;'>"+element.stock_name+"</strong><small>"+element.stock_code+"</small><a href='javascript:void(0);' class='remove_btn'>撤单</a></div>"+
						"<ul><li><span>委托价格</span><p>"+element.entrust_price+"</p></li>"+
						"<li><span>委托数量</span><p>"+element.entrust_amount+"</p></li>"+
						"<li><span>成交价格</span><p>"+element.business_price+"</p></li>"+
						"<li><span>成交数量</span><p>"+element.business_amount+"</p></li>"+
						"<li><span>委托编号</span><p>"+element.entrust_no+"</p></li>"+
						"<li><span>委托时间</span><p>"+element.entrust_time+"</p></li>"+
						"<li><span>委托状态</span><p>"+element.entrust_state_name+"</p></li>"+
						"</ul></div>";
						eleHtml.push(html);
					}
					dataResults = data.results;
					$(_pageId + ".cancel_order").html(eleHtml.join(""));
				} else {
					$(_pageId + ".cancel_order").html("");
					common.setNoData(true, 0);
				}
			} else {
				$(_pageId + ".cancel_order").html("");
				common.setNoData(true, 1);
				$.alert(data.error_info);
			}
			downslide.slideRefresh();
		}
	}
    
	/**
	 * 确定撤单
	 * results 撤单数据，支持多条
	 * isCancellEntrust 是否撤单后继续委托 results多条时无效
	 */
	function cancellation(results, isCancellEntrust){
		var entrust_no_arr = [];
		for (var i = 0; i < results.length; i++) {
			entrust_no_arr.push(results[i].entrust_no);
		}
		var param = {
			"account_type": userInfo._loginClass,
			"entrust_way": global.entrust_way,
			"branch_no": userInfo.branch_no,
			"fund_account": userInfo.fund_account,
			"password": userInfo.password,
			"cust_code": userInfo.cust_code,
			"sessionid": userInfo.sessionid,
			"batch_flag": results.length>1?1:0,
			"entrust_date": results.length>1?"":results[0].entrust_date,
			"entrust_no": entrust_no_arr.join(),
			"exchange_type": results.length>1?"":results[0].exchange_type
		};
		service_gemAfter.gemCancelEntrust_ser(param, function(data) {
			if(data) {
				if(data.error_no == 0) {
					var t = $.isValue(data.results && data.results.length && data.results[0].entrust_no) ? "<br/>委托编号："+data.results[0].entrust_no : "";
					$.alert("撤单委托已提交！"+t,function(){
						if(results.length == 1 && isCancellEntrust) {// 撤单后继续委托
							//撤单重买卖，用撤单数据里面的【委托数量-成交数量】就是对应要带到买卖页面的数量数据
							results[0].entrust_amount = Number(results[0].entrust_amount) - Number(results[0].business_amount);
							if(results[0].entrust_bs == 0) {// 撤买
								$.pageInit("gemAfter/gemStockCancel", "gemAfter/gemStockBuy", results[0]);
								return;
							}
							if(results[0].entrust_bs == 1) {// 撤卖
								$.pageInit("gemAfter/gemStockCancel", "gemAfter/gemStockSell", results[0]);
								return;
							}
						}
					});							
					queryData();// 查询数据
				} else {  
					$.alert(data.error_info);
				}
			} else {
				$.alert("撤单失败");
			}
		});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		
		//刷新按钮
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			queryData();// 查询数据
			e.stopPropagation();
		});

		$.bindEvent($(_pageId+".top_title .jyxz"), function(e){
			var pageCode = $.getCurrentPageObj().pageCode || '';
			$.pageInit(pageCode,"kcb/stock/kcbPHExplain",{},"right");
			e.stopPropagation();
		});
		
		// 撤单
		$.preBindEvent($(_pageId+".cancel_order"), " .part a.remove_btn", function(e){
			var element = dataResults[$(this).parents(".part").index()];
			if(element) {
				var tipStrArray = [
					["证券名称", element.stock_name],
					["证券代码", element.stock_code],
					["委托价格", element.entrust_price],
					["委托数量", element.entrust_amount],
					["成交数量", element.business_amount]
				];
				var btnName = ["撤单后继续买入","撤单后继续卖出"][Number(element.entrust_bs)]||"";
				var tipStr = "<div ><p class=\"user_msg\">"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
				tipStr += common.generatePrompt(tipStrArray);
				tipStr += "</div>";
				common.iConfirm3("撤单确认",tipStr,function(){
					cancellation([element]);
				}, null, "撤单", "取消", btnName&&function(){
					cancellation([element], btnName);
				}, btnName);
			}
			e.stopPropagation();
		});
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		witchAccount = null;
		userInfo = null;
		dataResults = [];
		$(_pageId + ".cancel_order").html("");
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
