/**
 * 创业板盘后交易下单
 */
define('trade/scripts/gemAfter/gemStockOrder.js', function(require, exports, module) {
	var common = require("common");
	var commonHq = require("commonHq");
	var commonFunc = require("commonFunc");
	var appropriate = require("appropriate");
	var gconfig = $.config;
	var global = gconfig.global;
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var	service_gemAfter = require("service_gemAfter").getInstance();
	var keyboard = require("keyboard");
	var commonTimer = require("commonTimer");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
//  var fifthOrder_timer = null;//五档行情定时器
//  var position_timer = null;
    var _pageId = null;
    var _orderType = null;
    var _PageParam = {};
    var isFiveReturn=false;
    var isLinkageReturn=false;
    var notice_no = null;//系统提示信息 为4时，显示弹框
    var notice_info = null;//系统提示信息
    var nativePluginService = require("nativePluginService");
	var btnOrderName = { // 按钮名称
		"1":"买入",
		"2":"卖出"
	};
	var okColor = { // 颜色
		"1": "red",
		"2": "blue",
	};
    //0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
    var _exchange = {
			"0":"0", "2":"0", "3":"0", "4":"0", "5":"0", "6":"0", "7":"0", "8":"0",
			"1":"1",
			"9":"2", "11":"2", "12":"2", "13":"2", "14":"2", "15":"2", "16":"2",
			"10":"3",
			"17":"4",
			"18":"0", "19":"0", "21":"0", "22":"0", "23":"0", "24":"0", "64":"0",
			"20":"2", "25":"2", "26":"2", "27":"2", "30":"2", "65":"2", "66":"2",
			"43":"0", "45":"0", // CDR
			"44":"2", "46":"2"
		};
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _checkoutSuccess = false;
	var _queryHolding = false;
	var _initScroller = null;
	
	var hqKt = require("minLines");
	var canvasJs = require("canvasJs");
	var holdingList = [];
	/**
	 * 设置证券对象是信息参数
	 */
	function ioitStock(){
		var stockInfo = {
			"isHq":false,
	    	"stockCode" : "", // 证券代码
	    	"stockName" : "", // 证券名称
	    	"stockPrice" : "",// 证券价格
	    	"stockNum" : "",
	    	"upStop" : 0, //涨停价
	    	"downStop" : 0,//跌停价
	    	"mostNew" : 0, //最新价
	    	"stateNew" : "",//状态
	    	"stockMaxAmount" : 0,//证券最大数
	    	"price_step" : 0.01, // 步长
			"price_digit" : 2, // 小数点位数
			"lot_size" : 1, //每手数量
			"stock_type" : "",//证券类型
			"trade_stock_type" : "",//证券类型
			"stock_market" : "",//市场代码
			"gear_one" : false,//是否启动五档
			"exchange_type" : "",//交易市场（交易后台）
			"stock_account" : "",// 股东账号 
			"delist_info" : "",// 退市提示语
			"delist_flag" : "",//是否退市标示
			"error_no": null,
			"error_info": null,
	    	"isBond":false,//是否为债券
	    };
	    return stockInfo;
	}
	
	function initHtml(){
		stock_html = {
			"hqCanvas": $(_pageId + " .timeshare"),
			"hqxltb": $(_pageId + " .hqxltb i"),
	    	"stockCode" : $(_pageId + " #stockCode"), // 证券
	    	"stockName" : $(_pageId + " #stockCode").next("span"), // 证券名称
	    	"stockPrice" : $(_pageId + " #stockPrice"),// 证券价格
	    	"stockNum" : $(_pageId + " #stockNum"), // 证券数量
	    	"upStop" : $(_pageId + " #up_stop"), //涨停价
	    	"downStop" : $(_pageId + " #down_stop"),//跌停价
	    	"mostNew" : $(_pageId + " #most_new"), //最新价
	    	"stateNew" : $(_pageId + " #state_new"),//状态
	    	"present_price": $(_pageId + " .five_box .limit_move .present_price p span"),//现价
	    	"stockMaxAmount": $(_pageId + " .kcb_trade_form p.limit strong"),//证券最大数
	    	"buyGear" : $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
		   	"sellGear" : $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
		   	"total" : $(_pageId + " #total"),// 计算金额显示
			"stockList" : $(_pageId + " #stock_list"),// 证券下拉列表
		}
	}
	

    /**
     * 数据初始化
     */
	function dataInit(pageId,orderType, initScroller){
		_initScroller = initScroller;
		_PageParam = $.getPageParam() || {};
		console.log(_PageParam);
		_pageId = pageId;
		if(keyboard){
			keyboard.keyInit(vailSubmitOrder,function(){
				$(_pageId + " input#stockPrice").triggerFastBlur();
			});
		}
		var paramMap=$.getPageParam("param");
		if(paramMap && Object.getOwnPropertyNames(paramMap).length != 0){
			if(paramMap && typeof(paramMap) == "string"){
				paramMap = JSON.parse(paramMap);
			}
			if(paramMap.switchUserInfo){
				common.switchingCurUser(paramMap.switchUserInfo);
			}
		}
		userInfo = common.getCurUserInfo();
		commonFunc.setJurisdiction(userInfo);
		_orderType = orderType;
		stock_info = ioitStock();
		initHtml();
		_stockCode = null;
		commonFunc.initCheckTradeTimer();
		window._stockInfo = {};// 五档的股票信息
		
		var stockCode = _PageParam["code"] || _PageParam["stock_code"];
		// 查询个股行情
		if(stockCode){
			$(_pageId + " #stockCode").removeClass("C100");
			$(_pageId + " #stockCode").quzhi(stockCode);
			var market = _PageParam["market"];
			var exchange_type = _PageParam["exchange_type"];
			var stock_account = _PageParam["stock_account"]
			getStockList(stockCode, market, exchange_type, stock_account);
		}else{
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});
		}
		
		queryHolding();
		if(global.positionRefreshTime){
			commonTimer.setTimer(_pageId, function(){
				if(commonFunc.getTradingTime() && _callback && common.isAppFlag()){
					queryHolding();
				}
			}, global.positionRefreshTime);//定时刷新
		}
    }
	
	function isBuy(){
		if(_orderType == "1"){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * 获取证券信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			var data = stock_html[param].quzhi();
			if(newest && stock_info){
				if(!data || data == "--"){
					stock_info[param] = 0;
				}
				else
				{
					stock_info[param] = data;
				}
			}
			return data;
		}
		else{
			return '';
		}
	}
	
	/**
	 * 设置证券信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest){
		if(stock_html){
			stock_html[key].quzhi(value);
			if(key == "stockName"){
				//股票名称长度过长缩放
				var maxWidth = (stock_html[key].parent().width() / 2)-6;
				var zoomValue = $.getMaxFontSize(value,"0.18rem", maxWidth);
				stock_html[key].css({"transform":"scale(" + zoomValue + ")","white-space": "nowrap","transform-origin":"left center"});
			}
			if(newest && stock_info){
				if(value == "--"){
					value = 0;
				}
				stock_info[key] = value;
			}
		}
	}
	
	
	/**
	 * 
	 * @param {Object} stockPrice
	 */
	function isQueryMax(stockPrice){
		if(stock_info && stock_info.stockCode && stockPrice && stockPrice != "0" && stock_info.stock_account){
			queryMaxAmount(stock_info.stockCode,true);
		}
	}
	/**
	 * 事件绑定
	 */
	function elementBindEvent(){
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$(_pageId + " .five_box ul li").removeClass("active");
				var pageCode = $.getCurrentPageObj().pageCode || '';
				if (global.callNative) {
					if ($.getPageParam("isFromApp")) {
//					var param = $.getPageParam();
						//ios切换行情
						$.callMessage({
							"funcNo": "50500",
							"msgNo": "205",
							"sourceModule": "trade",
							"targetModule": "app",
							"action": "4",
							"param": {}
						});
					}
					$.pageInit(pageCode, "account/index", {"_loginClass": userInfo._loginClass}, "left", true);
				} else {
					$.pageInit(pageCode, "account/index", {"_loginClass": userInfo._loginClass}, "left", true);
				}
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		
		//刷新按钮
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			dataRefresh();
			e.stopPropagation();
		});

		$.bindEvent($(_pageId+".top_title .jyxz"), function(e){
			var pageCode = $.getCurrentPageObj().pageCode || '';
			$.pageInit(pageCode,"kcb/stock/kcbPHExplain",{},"right");
			e.stopPropagation();
		});

		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");
		
		$.bindEvent($(_pageId + " #stock_list"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			e.stopPropagation();
		}, "touchstart");
		
		if(!keyboard){
			$.bindEvent($(_pageId + " #stockCode"), function(e){
				stock_html.stockList.show();
				if(global.callNative){ // 同步原生的自选股
					var data = $.callMessage({"moduleName":"self-stock","funcNo": "60100", "searchKey":""});
					var source = "1"; // 渠道来源 0表示搜索码表 1 表示同步的自选股列表
					getStockListCallBack(data,"",source); // 显示证券列表
				}
				e.stopPropagation();
			});
		}
		
		$.bindEvent($(_pageId+" .kcb_trade_form .input_code .input_text span"), function(e){//输入时股票代码调键盘
			var click = e.type || "click";
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				$(_pageId + " div#stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			else{
				$(_pageId + " #stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			e.stopPropagation();
		});
		
		// 证券代码输入框监听
		$.bindEvent($(_pageId + " #stockCode"), function(e){ // 该监听方法是为了适配浏览器
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			else{
				var stockCode = $(this).val();
				stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g,"");
				stockCode = $.trim(stockCode);
				$(this).val(stockCode);
			}
			// $(_pageId+"#stock_list").html("").hide(); IOS点击会优先触发列表隐藏导致事件无响应
			var stockCode = $(_pageId + " #stockCode").val();
			//控制证券代码输入，字母控制4位，数字6位
			if(stockCode.length > 4){
				var vai1 = /^[0-9]+$/;
				if(!vai1.test(stockCode)){
					stockCode = stockCode.substring(0,4);
					$(_pageId + " #stockCode").quzhi(stockCode);
				}
			}
			if(stockCode.length == 0){
				clearBuyMsg();
				$(_pageId + " #stockCode").addClass("C100");
			}
			else{
				$(_pageId + " #stockCode").removeClass("C100");
			}
			if(stockCode){
				if(stockCode != _stockCode){
					_stockCode = stockCode;
					clearBuyMsg();
					var vai0 = /^[A-Za-z]+$/;
					var vai1 = /^[\u4e00-\u9fa5]+$/;
					if(stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))){ // 当输入的长度大于1 并且为字母的时候
						getStockList(stockCode); // 查询证券列表
					}else if(stockCode.length > 2){ // 当输入的长度大于3的时候
						getStockList(stockCode); // 查询证券列表
					}
				}
			}
			e.stopPropagation();
		},"input");
		
		//数量输入
		$.bindEvent($(_pageId + " #stockNum"),function(e){
			if(keyboard){
				var key = "";
				$(_pageId+".warehose p").removeClass("active");
				$(_pageId+".warehose p").removeClass("check");
				if(!global.callNative){
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					$(_pageId+".warehose p").eq(3).addClass("active");
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d3" || key == "-12"){
					$(_pageId+".warehose p").eq(2).addClass("active");
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d2" || key == "-13"){
					$(_pageId+".warehose p").eq(1).addClass("active");
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else if(key == "d1" || key == "-14"){
					$(_pageId+".warehose p").eq(0).addClass("active");
					var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
					if ( isBuy() ) {
						num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					}
					setStockInfo("stockNum",num+"");
					common.changeFontSize($(_pageId + " #stockNum"));
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
			e.stopPropagation();
		},"input");
		
		// 价格输入框
		$.bindEvent($(_pageId + " #stockPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = $(_pageId + " #stockPrice").val();
				if(stockPrice == "" || Number(stockPrice) == 0){
					if(isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						setStockInfo("stockMaxAmount","--",true);
					}
				}else{
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}
			e.stopPropagation();
		},"input");
		
		// 价格输入框
		$.bindEvent($(_pageId + " #stockPrice"), function(e){
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = $(_pageId + " #stockPrice").val();
				if(stockPrice != 0){
					if(stockPrice != ""){
//						stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
						stockPrice = Number(stockPrice);
						setStockInfo("stockPrice",stockPrice);
					}
//					else{
//						stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
//					}
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}
			e.stopPropagation();
		},"blur");
		// 增加价格
		$.bindEvent($(_pageId + " .trade_main #stockPrice").nextAll(".add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				var price_step = stock_info.price_step;
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",price_step);
					return false;
				}
				stockPrice = Number(stockPrice);  
				
				if(stockPrice >= 0 && stockPrice < 999999999){
					stockPrice = (parseFloat(stockPrice)+parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 减少价格
		$.bindEvent($(_pageId + " .trade_main #stockPrice").nextAll(".less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",0);
					return false;
				}
				var price_step = stock_info.price_step;
				
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0){
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 五档买卖盘联动
		$.bindEvent($(_pageId + " .five_box ul li"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).find("span").text();
			if(curPrice && curPrice != "--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				
				setStockInfo("stockPrice",curPrice);
				common.changeFontSize($(_pageId + " #stockPrice"));
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice,stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
		
		// 增加数量
		$.bindEvent($(_pageId + " .trade_main #stockNum").nextAll(".add"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum") || "0";
				if(!stockNum || !validatorUtil.isNumberFloat(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum) + stock_info.lot_size;
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
				$(_pageId + " .trade_main .row_04 p").removeClass("check");
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		// 减少数量
		$.bindEvent($(_pageId + " .trade_main #stockNum").nextAll(".less"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum");
				if(!stockNum || !validatorUtil.isNumberFloat(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum =  Number(stockNum) - stock_info.lot_size;
				if(stockNum < 0) stockNum = 0;
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
				$(_pageId + " .trade_main .row_04 p").removeClass("check");
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 仓位选择
		$.bindEvent($(_pageId + " .trade_main .row_04 p"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				$(this).addClass("check").siblings().removeClass("check");
				var key = $(this).attr("type");
				if(key == "4"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "3"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "2"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "1"){
					var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
					if ( isBuy() ) {
						num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					}
					setStockInfo("stockNum",num+"");
				}
				common.changeFontSize($(_pageId + " #stockNum"));
				var stockNum = $(_pageId + " #stockNum").val();
				var stockPrice = getStockInfo("stockPrice");
				totalValue(stockPrice,stockNum);
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 下单
		$.bindEvent($(_pageId + " #submitOrder"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " .five_box ul li").removeClass("active");
			if(stock_html){
				stock_html.stockList.hide();
			}
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId + " .hqxltb i"),function(e){
			if($(this).hasClass("xl")){
				stock_html.hqxltb.attr("class","sl");
				stock_html.hqCanvas.show();
				if(_initScroller){
					_initScroller(true);
				}
			}
			else{
				stock_html.hqxltb.attr("class","xl");
				stock_html.hqCanvas.hide();
				if(_initScroller){
					_initScroller(true);
				}
			}
			e.stopPropagation();
		});
		
		 //点击分时图
		$.bindEvent($(_pageId + " #hqt"),function(e){
			if(stock_info.stockCode && stock_info.stock_market){
				var pageCode = $.getCurrentPageObj().pageCode || '';
				if(global.callNative){
                    $.setSStorageInfo("go_hq_" + pageCode, true);
                            var param = {
                                "funcNo": "50500",
                                "msgNo": "201",
                                "targetModule":"hqDispatcher",
                                "sourceModule":"trade",
                                "action":"0",
                                "param":{
                                    "stockMarket": stock_info.stock_market,
                                    "stockCode": stock_info.stockCode,
                                    "stockName": stock_info.stockName,
                                }
                            }
                            $.callMessage(param);
                }else{
                    var stockInfo = {
                        "market": stock_info.stock_market,
                        "stockCode": stock_info.stockName,
                        "stockName": stock_info.stockCode,
                    }
                    window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                }
			}else{
                $.alert("在行情服务器中没有查询到该只股票的信息");
            }
		});
		
		// 点击涨跌停价格联动
		$.bindEvent($(_pageId + " #up_stop").add($(_pageId + " #down_stop")).add($(_pageId + " #latest_price")), function(e) {
			$(_pageId + " .five_box ul li").removeClass("active");
			var curPrice = $(this).text();
			if(curPrice && curPrice != "--") {
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice", curPrice);
				common.changeFontSize($(_pageId + " #stockPrice"));
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice, stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
	}
	
	//行情列表接口有问题是，输入证券是6位数时直接调用交易接口
	function queryData(stockCode,exchange_type, stock_account){
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			queryMaxAmount(stockCode, false, exchange_type, stock_account);
		}
	}
	
	//对行情接口返回数据进行处理
	function ListData(data){
		stock_info.isHq = true;
		var price = data[4] ? data[4]:data[5];
		price = Number(price);
		var stockVal = data[0]; //证券代码
		var stkType = data[2];//股票类型
		var stkHLType = data[10];//沪伦通
		var stkkcbType = data[11];//是否为科创板
		var tradeState = data[12];//交易状态
		var typeObj = commonHq.getHqtypeData(stockVal,stkType);
		stock_info.lot_size = typeObj.lot_size;
		stock_info.price_step = typeObj.price_step;
		$(_pageId + " p.limit em.cdw").text(typeObj.unit_name);
//		$(_pageId + " .input_num .input_text em.cdw").text(typeObj.unit_name);
		$(_pageId + " .input_num .input_value em.cdw").text(typeObj.unit_name);
		var price_digit = typeObj.price_digit;
		stateTradefun(tradeState);
		// if(stkHLType == "3"){
		// 	cdrFlag(stkHLType,true);
		// 	stock_info.stock_type=stkHLType;
		// }
		// else if(stkkcbType=="K"){
		// 	cdrFlag(stkkcbType,true);
		// 	stock_info.stock_type=stkkcbType;
		// 	stock_info.lot_size = 1;
		// 	if(stkType=="16"){
		// 		price_digit = 2;
		// 		stock_info.price_step = 0.01;
		// 	}
		// }else{
		// 	cdrFlag(stkType,true);
		// 	stock_info.stock_type=stkType;
		// }
    stock_info.stock_type=stkType;
		$(_pageId + " #stockCode").removeClass("C100");
		setStockInfo("stockCode",stockVal,true);
		_stockCode = stockVal;
		setStockInfo("stockName",data[1],true); // 证券现价
		
		if(data[8] == "1"){
			$.hidePreloader();
			$.alert("该股票正处于停牌阶段，请关注具体复牌时间，了解公司股票恢复交易的信息。");
		}
		var p_price = _PageParam["price"] || _PageParam["entrust_price"];
		if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
			price  = Number(p_price);
		}
		setStockInfo("stockPrice",price.toFixed(price_digit)); // 证券现价
		common.changeFontSize($(_pageId + " #stockPrice"));	
		setStockInfo("upStop",$.transferText(data[6],price_digit),true); // 涨停价
		setStockInfo("downStop",$.transferText(data[7],price_digit),true); // 涨跌价
		setStockInfo("mostNew",$.transferText(data[4],price_digit),true); // 证券最新价
//		stock_html.present_price.text(price.toFixed(price_digit));
		priceColor(stock_html.present_price, data[4], data[5], price_digit);
		
		stock_info.price_digit = price_digit;
		stock_info.stock_market = data[3];
		stock_html.hqxltb.attr("class","xl").show();
		var list = stock_info.stock_market + ":" + stock_info.stockCode;
		hqKt.minLineFunc(_pageId, _pageId + " #hqt", list,$(_pageId).width() - 10,160);
		
		stock_info.gear_one = true;
		setFifthOrder(true);
		_fifthCallback = false;
		
		commonTimer.setTimer(_pageId+"Hqwd", function(){
			if(commonFunc.getTradingTime() && _fifthCallback && common.isAppFlag()){
				setFifthOrder();
				_fifthCallback = false;
			}
		}, (global.refreshTime || 5000));//定时刷新
		
		//证券联动,查询证券信息，最大可买
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		queryMaxAmount(stockVal);
	}
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(stockCode,market,exchange_type, stock_account){
		if(stockCode != ""){
			var param = {
						"stockCode": stockCode,
						"market": market,
						"exchange_type": exchange_type,
						"stock_account": stock_account,
						"count": 50,
						"type": "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66",// 行情stocktype 18=创业板
						"marketType": "1"
					};
			commonHq.getkcbStockList(param,stock_html.stockList,
				function(data){
					ListData(data,param);
				},
				function(data){
					queryData(data.stockCode, data.exchange_type, data.stock_account);
				}
			);
		}
	}
	
	
	//五档买卖盘
	function setFifthOrder(isFirstFive){
		isFiveReturn=false;
		var market = stock_info.stock_market, stockCode = stock_info.stockCode;
		if(market && stockCode){
			var stock_list = market+":"+stockCode
			commonHq.getFifthOrder(stock_list,function(results){
				// window._stockInfo = {
				// 	"stockMarket": results[3],
				// 	"stockCode": results[0],
				// 	"stockType": results[2]
				// };
				// if(isFirstFive) {// 首次查询，订阅推送
				// 	commonFunc.fivePushFunc("0");// 订阅五档推送
				// 	commonFunc.fivePushCallBackFunc({"results": [results]}, callbackFifthOrder);// 推送回调
				// }
				callbackFifthOrder({"results": [results]});
			},function(){
				_fifthCallback = true;
			});
		}
	}
	
	function callbackFifthOrder(data) {
		var results = data.results[0];
		var price_digit = stock_info.price_digit;
		// $(_pageId + ".timeshare .row_01 strong").text(results[1]);
		var timeshareEm = $(_pageId + ".timeshare .row_01 em");
		var r35=results[35];
		if(results[35]){
			r35 = (Number(results[35])).toFixed(price_digit);//内盘
		}
		timeshareEm.text((Number(results[30])).toFixed(price_digit)+ " " + r35 + " " + (Number(results[36]*100)).toFixed(2)+"%");
		if(r35 > 0){
			timeshareEm.attr("class","ared");
		}
		else if(r35 < 0){
			timeshareEm.attr("class","agreen");
		}
		else{
			timeshareEm.attr("class","");
		}
		setStockInfo("mostNew",$.transferText(results[30],price_digit),true); // 证券最新价
		_fifthCallback = true;
		var yesProfit = results[26];
		var presentPrice = results[30] || yesProfit;
		priceColor(stock_html.present_price, presentPrice, yesProfit, price_digit);
		if(stock_info.gear_one){
			var fifthOne = "";
			if(isBuy()){
				fifthOne = results[10] || results[16];
			}else{
				fifthOne = results[16] || results[10];
			}
			if(presentPrice != 0 && (fifthOne == 0 || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)){
				fifthOne = presentPrice;
			}
			fifthOne = Number(fifthOne).toFixed(price_digit);
			var p_price = _PageParam["price"] || _PageParam["entrust_price"];
			if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
				fifthOne  = Number(p_price).toFixed(price_digit);
			}
			setStockInfo("stockPrice",fifthOne); // 证券现价
			common.changeFontSize($(_pageId + " #stockPrice"));
			stock_info.gear_one = false;
			isFiveReturn=true;
			firstAllReturn();
		}
		//卖五档盘颜色集合
		for(var i = 0 ; i < 5 ; i ++){
			addColor(stock_html.buyGear.eq(i),results[16+i],yesProfit,results[21+i],price_digit);
			addColor(stock_html.sellGear.eq(i),results[6+i],yesProfit,results[11+i],price_digit);
		}

	}
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function priceColor(div,price,yesProfit,price_digit){
		yesProfit = Number(yesProfit).toFixed(price_digit);
		yesProfit = Number(yesProfit);
		price = Number(price).toFixed(price_digit);
		if(price == 0){
			div.text("--").attr("class","");
		}
		else if(price > yesProfit){
			div.text(price).attr("class","ared");
		}
		else if(price < yesProfit)
		{
			div.text(price).attr("class","agreen");
		}
		else
		{
			div.text(price).attr("class","");
		}
	}
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div,price,yesProfit,num,price_digit){
		var prices = div.find("span");
		priceColor(prices,price,yesProfit,price_digit);
		var nums = div.find("em");
		num = Number(num);
		if(num == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(num >= 100000){
			nums.text((num * 0.0001).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}

	/**
	 * 股票联动业务或者查询最大可买卖业务 通过isMax参数决定 true表示查最大可买卖
	 * 
	 * 股票联动新接口 普通交易310514 信用313000
	 * 
	 * 获取到价格后查询最大可买可卖接口
	* 普通交易新的最大可买和可卖接口不一样 310513、310516
	* 信用交易最大可买卖接口还是为一个接口 313060
	 * */
	function queryMaxAmount(stockCode,isMax, exchange, account){
		isLinkageReturn=false;
		stock_html.stockList.html("");
		$.hidePreloader();
		var stock_price = getStockInfo("stockPrice");
		var entrust_bs = isBuy()?102:103;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var stock_code = stockCode;
		var entrust_price = stock_price;
		var stock_account = account || stock_info.stock_account;
		var exchange_type = exchange || stock_info.exchange_type || _exchange[stock_info.stock_type+""];
		var param = {
				"account_type": userInfo._loginClass,
				"isBuy": isBuy(),
				"isMax": isMax,
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"password":password,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
				"stock_account": stock_account,
	            "exchange_type":exchange_type,
				"stock_type": stock_info.trade_stock_type,
				"entrust_type": "0"
			};
  	  	service_gemAfter.queryStockMaxAmount(param,function(data){
  	  		stock_info.error_no = data.error_no;
  	  		stock_info.error_info = data.error_info;
			$.hidePreloader();
	  	  	if(isMax){
		  	  	queryMaxAmountCallBackMax(data);
	  	  	}else{
	  	  		queryMaxAmountCallBack(data);
	  	  	}
	  	  	_PageParam = {};
	  	  },{"isLastReq":true,"isShowWait":false});
		
	}
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length > 0){
				if(results.length == 1){
					if($.isValue(results[0].stock_name_long)) results[0].stock_name = results[0].stock_name_long;
					var price_digit = stock_info.price_digit;
					var exchange_type = results[0].exchange_type;
					stock_info.exchange_type = exchange_type;
					stock_info.convertible_bonds_prompt = results[0].convertible_bonds_prompt; // 转债提示
					
					var stock_code = results[0].stock_code;
					var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
					if(buy_unit != 0){
						stock_info.lot_size = buy_unit;
					}
					var point = results[0].point ? Number(results[0].point) : 0;
					if(point != 0){
						var price_step = Math.pow(10,0-point);
						if(stock_code.substring(0,3) == "204"){
							price_step = 0.005;
						}
//						stock_info.price_step = price_step;
						stock_info.price_step = results[0].price_step ? Number(results[0].price_step) : price_step;
						stock_info.price_digit = point;
						price_digit = point;
					}
					if(!stock_info.isHq){
						var stock_type = results[0].stock_type;
						stock_info.stock_type=stock_type;
						$(_pageId + " #stockCode").removeClass("C100");
						setStockInfo("stockCode",stock_code,true);
						var p_price = _PageParam["price"] || _PageParam["entrust_price"];
						if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
							results[0].price = p_price
						}
						setStockInfo("stockPrice",Number(results[0].price).toFixed(price_digit));
						if(results[0].price != 0){//最新价
							setStockInfo("mostNew",Number(results[0].price).toFixed(price_digit),true);
						}
						common.changeFontSize($(_pageId + " #stockPrice"));
						if(exchange_type == 0 || exchange_type == 1)
						{
							stock_info.stock_market = "SZ";
						}
						else if(exchange_type == 2 || exchange_type == 3)
						{
							stock_info.stock_market = "SH";
							if(global.serverConfig == "3" && stock_type && stock_type.indexOf("Z") == 0){
								$(_pageId + " p.limit em.cdw").text("手");
								$(_pageId + " .input_num .input_text em.cdw").text("手");
								$(_pageId + " .input_num .input_value em.cdw").text("手");
								stock_info.lot_size = 1;
							}
						}
						if(results[0].up_limit != 0){
							setStockInfo("upStop",Number(results[0].up_limit).toFixed(price_digit),true);
						}
						if(results[0].down_limit != 0){
							setStockInfo("downStop",Number(results[0].down_limit).toFixed(price_digit),true);
						}
					}
					setStockInfo("stockName",results[0].stock_name,true);
					$(_pageId + ".timeshare .row_01 strong").text(results[0].stock_name);
					stock_info.delist_flag = results[0].delist_flag;
					stock_info.delist_info = results[0].delist_info;
					stock_info.trade_stock_type = results[0].stock_type;
					stock_info.stock_type = results[0].stock_type;
					
					var p_num = _PageParam["num"] || _PageParam["entrust_amount"];
					if(p_num && p_num != 0 && validatorUtil.isNumeric(p_num)){
						setStockInfo("stockNum",p_num,true);
					}
					//CDR
//					if(results[0].cdr_rights == "1" || results[0].innovate_rights == "1"){
//						cdrStock(results[0]);
//					}

          notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
          notice_info = results[0].notice_info;//系统提示信息
          // 判断是否配置了提示信息
          if(notice_no === "4"){
            common.singleIConfirmNew("温馨提示",notice_info,function(){ },"我知道了");
          }
					commonFunc.getStockAccount([stock_info.exchange_type,"","1"].join('|'), userInfo, function(data){
						if(data && data[0] && data[0].stock_account) {
							stock_info.stock_account = data[0].stock_account;
							isLinkageReturn=true;
							firstAllReturn();
						}
					});
					
					// if(["f", "p", "q"].indexOf(results[0].stock_type)<0){//非创业板标的，弹出提示，并清空页面
					// 	$.alert("非创业板标的，无法进行盘后固定价格交易委托",null,function(){
					// 		setStockInfo("stockCode","");// 证券价格
					// 		$(_pageId + " #stockCode").addClass("C100");
					// 		clearBuyMsg();
					// 	});
					// 	return;
					// }
								
					if(_orderType ==1) {
						commonFunc.popupRightsConfirm(results[0], {checkCyb: true, checkKzz: true});
					}
				}
				else if(results.length > 1){
					$.hidePreloader();
					var selectHeight = 0.4*results.length;
					if(results.length >= 7){
						selectHeight = 7 * 0.4;
					}
					var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
					for(var i = 0;i < results.length; i++) {
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i].stock_code+"</strong><em>"+results[i].stock_name+"</em></a>";
						listHtml +=	"<span style=\"display:none;\">"+results[i].exchange_type+"</span></li>";
					};
					listHtml+="</ul>";
					stock_html.stockList.html(listHtml).show();
					$.bindEvent($(_pageId + " .kcb_trade_form .select_box ul li"),function(e){
						var exchange_type = $(this).find("span").text();
						stock_info.exchange_type = exchange_type;
						var stockCode = $(this).find("strong").text();
						stock_html.stockList.html("");
						queryData(stockCode,exchange_type);
						$(_pageId + " #stockCode").removeClass("C100");
						setStockInfo("stockName",$(this).find("em").text(),true);
						e.stopPropagation();
					});
				}
			}
		}else{
			$.alert(data.error_info);
		}
	}
	function queryMaxAmountCallBackMax(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				setStockInfo("stockMaxAmount",Number(results[0].stock_max_amount),true);
			}
		}
		else{
			$.alert(data.error_info);
		}
	}
	
	
	/*
	 * 输入股票代码时五档和联动都返回的时候查询最大可买数量
	 * (以前的价格传的错的，第一次联动的时候，传的最新,不是对手价，所以五档返回对手价后，在重新查一下最大可委托数量)
	 */
	function firstAllReturn(){
		if(isLinkageReturn && isFiveReturn){
			var priceVal=getStockInfo("stockPrice");
			isQueryMax(priceVal);
		}
	}
	
	//CDR标志
	function cdrFlag(stock_type,isHq){
		var CDRArray = [];
		var CQArray = [];
		var hlCDRArray;
		var KCBArray = [];
		if(isHq){
			CDRArray = [43,44];
			CQArray = [45,46];
			hlCDRArray=[3];
			KCBArray = ["K"];
		}else{
			CDRArray = [10];
//			CQArray = [0];
			hlCDRArray=[11];
			KCBArray = [15,16];
		}
		if(CDRArray.indexOf(stock_type)!=-1){ //CDR
			$(_pageId + ".input_text .cdrCss").text("CDR");
			$(_pageId + ".input_text .cdrCss").show();	
			if(!isHq){//行情接口已经做了处理
//				$(_pageId + " p.limit em.cdw").text("份");
//				$(_pageId + " .input_num .input_value em.cdw").text("份");
			}
		}
		else if(CQArray.indexOf(stock_type)!=-1){ //创企
			$(_pageId + ".input_text .cdrCss").text("创企");			
			$(_pageId + ".input_text .cdrCss").show();
		}
		else if(hlCDRArray.indexOf(stock_type)!=-1){ //沪伦通
			$(_pageId + ".input_text .cdrCss").text("沪伦");			
			$(_pageId + ".input_text .cdrCss").show();
		}
		else if(KCBArray.indexOf(stock_type)!=-1){ //科创板
			$(_pageId + ".input_text .cdrCss").text("科创");			
			$(_pageId + ".input_text .cdrCss").show();
		}
		else{
			$(_pageId + ".input_text .cdrCss").hide();
		}
//		if(!isBuy()){//卖出更改图标的样式
			$(_pageId + ".input_text .cdrCss").addClass("cdrCssSell");
//		}
	}
	
	/*
	 * 创业板盘后交易状态判断
	 */
	function stateTradefun(flag){
		if(flag=="A"){
			setStockInfo("stateNew","盘后交易",true);
			$(_pageId+"#zx").html("最新");
		}else{
			setStockInfo("stateNew","非盘后交易",true);
			$(_pageId+"#zx").html("最新");
		}
	}
	
	// 计算当前总值
	function totalValue(stockPrice,stockNum){
		if(stock_html){
			stock_html.total.text("").hide();
		}
		if(validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			if(stock_info.stock_type !== "" && stock_info.stockCode){
				var amount = commonHq.calculateStockAmount(stockPrice,stockNum,stock_info.stock_type,stock_info.stockCode);
				var text = "(¥"+$.formatMoney(""+amount)+")";
				if(!stock_info.market_price) {
					stock_html.total.text(text).show();// 市价委托的时候点击无效.
				}
			}
		}
	}
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		
		var typeText = "买入";
		if(!isBuy()){
			typeText = "卖出";
		}
		//验证证券代码输入是否正确
		var stockCode = stock_info.stockCode;
		if(stockCode.length == 0){
			$.alert("请输入正确的证券代码/简拼");
			return false;
		}	
		var vai1 = /^[0-9]{6}$/;
		if(!vai1.test(stockCode)){
			$.alert("证券代码输入错误");
			return false;
		}	
		//验证证券价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length<=0){
			$.alert("请输入"+typeText+"价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockPrice)){
			$.alert("请正确输入价格");
			return false;
		}else if(parseFloat(stockPrice)<=0){
			$.alert("价格必须大于0");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount+"";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length<=0){
			$.alert("请输入"+typeText+"数量");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockNum)){
			$.alert("请正确输入数量");
			return false;
		}
		else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
//		if(stock_info.error_no !== "0" && stock_info.error_no !== 0){
//			$.alert(stock_info.error_info || "查询证券信息失败");
//			return false;
//		}
		var ts = [];
		//验证最大可买
		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
			ts.push("<em>最大可"+typeText+"为0；</em>");
		}
		else if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
			ts.push("<em>最大可"+typeText+"数量不足；</em>");
		}
		var isMax = parseFloat(stockMaxAmount)<parseFloat(stockNum);// 是否满足最大可委托数的提示
		var lots_of = stock_info.lot_size;

		if(["f","p"].indexOf(stock_info.trade_stock_type)>=0&&!isMax && stockNum > 1000000){
			ts.push("<em>创业板股票盘后定价买卖单笔不得超过100万股，强制委托可能失败；</em>");
		}
		if (isBuy() && ["18", "19"].indexOf(stock_info.stock_type) >= 0 && stock_info.convertible_bonds_prompt) {// 18科创板可转债、19科创板CDR可转债
			ts.push(stock_info.convertible_bonds_prompt)
		}
		var	up_stop = null;
		var	down_stop = null;
		var entrust_bs = isBuy()?102:103;
		var tipStrArray = [];
		up_stop = stock_info.upStop;
		down_stop = stock_info.downStop;
		if(up_stop && up_stop !="--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)){
			ts.push("<em>委托价格超过涨跌幅限制范围；</em>");//委托价格超过涨停价；
		}else if(down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)){
			ts.push("<em>委托价格超过涨跌幅限制范围；</em>");//委托价格低于跌停价；
		}
		
		var tipStr = "<div ><p>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
		tipStrArray.push(["证券代码", stockCode]);
		tipStrArray.push(["证券名称", "<span style='font-size:" + $.getTransformScaleFontSize(stock_info.stockName, 16, $(window).width() * 0.48) + "px;'>" + stock_info.stockName +  "</span>"]);
		tipStrArray.push(["委托价格", stockPrice]);
		tipStrArray.push(["委托数量", stockNum]);
		tipStr += common.generatePrompt(tipStrArray);
		tipStr+="</div>";
		if (ts.length) {
			if(ts.length > 1){
				for(var i = 0; i < ts.length; i++){
					ts[i] = '<p>'+(i+1) + '.' + ts[i] + '</p>';
				}
			}else{
				ts[0] = '<p>' + ts[0] + '</p>';
			}
			tipStr += "<div class='pop_reminder_text'><h4>温馨提示</h4>" + ts.join("") + "</div>";
		}
		// if(ts){
		// 	tipStr += "<div class='_reminder'><span class='b'>温馨提示：</span><span class='w'>"+ts+"</span></div><br><span>请确认是否继续以上委托？</span>";
		// }	
    // 2021.12.28 个股的交易风险提示需求屏蔽这里的提示 stock_info.delist_flag == "1" && stock_info.delist_info
    common.iConfirm("下单确认",tipStr,function success(){
      var cust_code = userInfo.cust_code;	//客户代码
      var fund_account = userInfo.fund_account;	//资产账户
      var branch_no = userInfo.branch_no;	//分支机构
      var session_id = userInfo.session_id;
      var entrust_way = global.entrust_way; // 委托方式  在configuration配置
      var exchange_type = stock_info.exchange_type;
      var stock_account = stock_info.stock_account;
      var stock_code = stockCode;
      var entrust_price = stockPrice;
      var entrust_amount = stockNum;
      var param = {
          "account_type": userInfo._loginClass,
          "entrust_way":entrust_way,
          "branch_no":branch_no,
          "fund_account":fund_account,
          "cust_code":cust_code,
          "session_id":session_id,
          "entrust_bs":entrust_bs,
          "exchange_type":exchange_type,
          "stock_account":stock_account,
          "stock_code":stock_code,
          "entrust_price":entrust_price,
          "entrust_amount":entrust_amount,
        };
        service_gemAfter.getStockPHBuy(param,getStockBuyCallBack,{"isShowOverLay":false,"isShowWait":false,
          "timeOutFunc":function(){
            $.hidePreloader();
          },"errorFunc":function(){
            $.hidePreloader();
          }});
          if (isBuy()) {
            stock_info.create_by = stock_info.create_by || $.getUUID();
            appropriate.function399932(stock_info)
          }
//					$.showPreloaders("请等待...");
      },function fail(){});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				_checkoutSuccess = true;
				var tipStr = "<p style=''>委托提交成功,委托编号 :"+results[0].entrust_no+"</p>";
				var html="";
				if(isBuy()){
					html="<div class='_reminder' style=''><span class='w'>收盘后进行撮合，如果买入委托价格低于收盘价则申报无效，请留意盘后的收盘价情况，避免申报无效。</span></div>";
				}else{
					html="<div class='_reminder' style=''><span class='w'>收盘后进行撮合，如果卖出委托价格高于收盘价则申报无效，请留意盘后的收盘价情况，避免申报无效。</span></div>";
				}
				common.singleIConfirm(btnOrderName[_orderType]+"委托结果",tipStr+html,function success(){});
				stock_info.entrust_no = results[0].entrust_no;
				if (isBuy()) {
					appropriate.function399932(stock_info)
				}
				clearBuyMsg();
				setStockInfo("stockCode","");// 证券价格
				$(_pageId + " #stockCode").addClass("C100");
			}
			queryHolding();
		}else{
			$.alert(data.error_info);
			setStockInfo("stockNum","",true); // 证券数量
			stock_html.total.text("").hide();
			$(_pageId+".warehose p").removeClass("active");
			$(_pageId+".warehose p").removeClass("check");
		}
	}
	
	
	/**
	 * 查询持仓数据
	 */
	function queryHolding(){
		_callback = false;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var stock_account ="";
		var stock_code = "";
		var exchange_type = "";
		var param={
				"account_type": userInfo._loginClass,
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"exchange_type":exchange_type,
		   		"query_flag":""
		};
		service_gemAfter.queryStockData(param,queryHoldingCallback,{"isLastReq":true,"isShowWait":false,"isShowOverLay":false,"timeOutFunc":function(){ 
				_callback = true;
				$.hidePreloader();
				//超时调用方法
				if($(_pageId+".fund_table2 tbody tr").length<1){
					common.setNoData(true);
				}
				if(_initScroller){
					_initScroller();
				}
			}});
	}
	
	function queryHoldingCallback(data){
		$.hidePreloader();
		var w=$(_pageId).width() / 4 ;
		// $(_pageId+".fund_table2 table th").css('min-width',w+"px");
		_callback = true;
		$(_pageId+'.position_div tbody').html("");
		// $(_pageId+'.fund_table .ce_table tr.add').remove();
		common.setNoData(true,"暂无持仓记录");
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				holdingList = data.results;
				if(results && results.length>0){
					var htmlTop = "";
					for (var i=0;i<results.length;i++){ 
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						htmlTop += queryHoldingHTML_stock(results[i],i);
					}
					$(_pageId+".position_div tbody").html(htmlTop);
					common.setNoData(false);
					//卖出事件
					$.bindEvent($(_pageId+" .position_div tbody tr"), function(e){
						clearBuyMsg();// 清楚数据
						var stockCode = $(this).attr("id");
						$(_pageId + " #stockCode").removeClass("C100");
						$(_pageId + " #stockCode").val(stockCode);
						_stockCode = stockCode;
						var exchange_type = $(this).attr("exchange_type");
						var stock_account = $(this).attr("stock_account");
						stock_info.exchange_type = exchange_type;
						stock_info.stock_account = stock_account;
						getStockList(stockCode, "", exchange_type, stock_account);
						$(_pageId + " .main").scrollTop(0);
						e.stopPropagation();
					});
				}
			}else{
				common.setNoData(true);
				$.alert(data.error_info);
			}
		}
		_queryHolding = true;
		if(_initScroller){
			_initScroller();
		}
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHoldingHTML_stock(element){
		var price_digit = 3;
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk > 0){
			css = "ared";
		}else if(float_yk < 0){
			css = "agreen";
		}
		//浮动盈亏比例
		var css1 = "";
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		var maxWidth = ($(window).width() - 30) * 0.25 - 20;
		var eleHtml = "";
		var marketValue = element.market_value,
		stockName = element.stock_name,
		float_yk_per = element.float_yk_per + "%",
		cost_amount = element.cost_amount,
		enable_amount = element.enable_amount,
		cost_price = element.cost_price,
		last_price = element.last_price;
		eleHtml+="<tr stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" id='"+element.stock_code +"'>";
		eleHtml+='<td><p style="transform-origin: left;transform:scale('+$.getTransformScale(stockName, 16, maxWidth+5)+')">'+stockName +'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p></td>';
        eleHtml+='<td><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>';
        eleHtml+='<p class="'+css1+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+float_yk_per+'</p></td>';
		eleHtml+='<td><p style="font-size:'+$.getTransformScaleFontSize(cost_amount, 16, maxWidth) +'px;">'+cost_amount+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></td>';
		eleHtml+='<td><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></td>';
		eleHtml+="</tr>";
		return eleHtml;
	   	var eleHtml = "";
      	eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" id="+element.stock_code +" >";
        eleHtml+="<td><span style='zoom:"+ $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25) +";'>"+element.stock_name +"</span><span>"+element.market_value +"</span></td>";
        eleHtml+="<td><span class=\""+css+"\">"+element.float_yk+"</span>";
        if(Number(element.float_yk_per)>0){
			css = "ared";
		}else if(Number(element.float_yk_per)<0){
			css = "agreen";
		}else{
			css = "";
		}
        eleHtml+="<span class=\""+css+"\">"+element.float_yk_per+"%</span></td>";
        eleHtml+="<td><span>"+element.cost_amount+"</span><span>"+element.enable_amount+"</span></td>";
        eleHtml+="<td><span>"+element.cost_price+"</span><span>"+element.last_price+"</span></td>";
      	eleHtml+="</tr>";
        return eleHtml;
	}
	
	/**
	 * 
	 */
	function clearBuyMsg(){
		_PageParam = {};
		$.clearRequest();
		stock_info = ioitStock();
		if(stock_html){
			//清空canvas图
			$(_pageId + ".timeshare .row_01 strong").text("");
			$(_pageId + ".timeshare .row_01 em").text("--").removeClass("agreen").removeClass("ared");
			$(_pageId+"#hqt").html("");
			hqKt.clearCanvasFunc(_pageId);
			hqKt.frameFunc(_pageId, _pageId + " #hqt", $(_pageId).width() - 10,160);
			canvasJs.minLineFunc([{}],{});
	    	stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 证券名称
	    	setStockInfo("stockPrice","");// 证券价格
	    	setStockInfo("stockNum",""); // 证券数量
	    	setStockInfo("stateNew","--"); // 交易状态
	    	stock_html.upStop.text("--"); //涨停价
	    	stock_html.downStop.text("--");//跌停价
	    	stock_html.mostNew.text("--"); //最新价
	    	stock_html.present_price.text("--");
	    	stock_html.stockMaxAmount.text("--");//证券最大数
			stock_html.total.text("").hide();
		   	stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
		}
		isLinkageReturn = true;
		isFiveReturn = true;
		$(_pageId + ".input_text .cdrCss").text("");
		$(_pageId + ".input_text .cdrCss").hide();
	   	commonTimer.clearTimer(_pageId+"Hqwd");
	   	_fifthCallback = true;
		$(_pageId + " .five_box ul li").removeClass("active");
		$(_pageId + " p.limit em.cdw").text("股");
		$(_pageId + " .input_num .input_text em.cdw").text("股");
		$(_pageId + " .input_num .input_value em.cdw").text("股");
		if(!isBuy()){//卖出更改图标的样式
			$(_pageId + ".input_text .cdrCss").removeClass("cdrCssSell");
		}
		
		window._stockInfo = {};// 五档股票信息改变时清理
	}
	
	function dataDestroy(){
        commonFunc.clearCheckTradeTimer();
		$.clearRequest();
		isTimingRefresh = false;
		if(stock_html){
			stock_html.hqxltb.removeClass("sl").addClass("xl");
			stock_html.hqCanvas.hide();
		}
		$(_pageId + " #stockCode").quzhi("");
		$(_pageId + " #stockCode").addClass("C100");
		_stockCode = "";
		$(_pageId+'.position_div tbody').html("");
		clearBuyMsg();
		commonTimer.clearTimer(_pageId);
		commonTimer.clearTimer(_pageId + "_minLines");
		stock_info = null;
		stock_html = null;
		if(keyboard){
			keyboard.keyDestroy();
		}
		_checkoutSuccess = false;
		$(_pageId+".warehose p").removeClass("active");
		$(_pageId+".warehose p").removeClass("check");
    // 退出页面后，销毁弹框
    $("#singleIConfirmNew").remove();
    $("#newTradingTipsBox2").remove();
	}
	
	
	//2019-12-10 刷新按钮
	function dataRefresh(){
		var stockCode = $.trim($(_pageId+"#stockCode").val().substring(0,6));
		if(stockCode.length==6){
			$.showRightTopPreloaders();
       		queryMaxAmount(stock_info.stockCode,true);
       		//查询五档
       		setFifthOrder();
       	}
		$.showRightTopPreloaders();
		queryHolding();
	}
	
	var base = {
		"dataInit" : dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy
	};
	module.exports = base;
});
