/**
 * 创业板盘后-卖出
 */
define('trade/scripts/gemAfter/gemStockSell.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var gemStockOrder = require("gemStockOrder");
	var common = require("common");
	var commonFunc = require("commonFunc");
	var _pageId = "#gemAfter_gemStockSell ";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var height_table = null;
	var _load = false;
	
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
	}
			
	function load(){
		_load = true;
		var mainHeight =  common.setMainHeight(_pageId, false);
		height_table =  mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".lr").outerHeight(true) - $(_pageId + ".fund_table2").css("margin-top").slice(0, -2);
		initScroller();
		var orderType = "2"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
		gemStockOrder.dataInit(_pageId,orderType,initScroller);
		gemStockOrder.elementBindEvent(); 
	}

	/**
	 * 初始化滑动组件
	 */
	function initScroller(isRefresh)
	{
		var mainHeight =  common.setMainHeight(_pageId, false);
		height_table = mainHeight - $(_pageId + ".tab_nav").outerHeight(true) - $(_pageId + ".lr").outerHeight(true) - $(_pageId + ".fund_table2").css("margin-top").slice(0, -2);
		$(_pageId + " #wrapper").height(height_table);
		if(_load){
			var scrollOptions = {
				scrollerHeight: height_table, // 滚动组件的高度
				$wrapper: $(_pageId + " #wrapper"),
				scrollbars: true, // 隐藏滚动条
				hasPullDown: false, // 是否显示下拉提示，默认 true
				hasPullUp: false, // 是否显示上拉提示，默认 true
				bounceTime: 300 // 回弹的动画时间
			};
			if(!myScroller)
			{
				myScroller = iscrollUtils.vScroller(scrollOptions);
			}
			else
			{
				myScroller.refresh();
			}
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		gemStockOrder.dataDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});