/**
 * 港股交易-撤单
 */
define('trade/scripts/ggt/ggtCancel.js',function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var vIscrollHeight = null;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_ggt = require("service_ggt");
    var _pageId = "#ggt_ggtCancel ";
    var entrustNo = ""; //撤单编号
	var exchangeType = ""; //市场类型
    var userInfo = null;
	var position_str = "";
	var _request_num="20";
    var _stockInfo={
    	"stockCode":"",
    	"stockName":"",
    	"entrustName":"",
    	"entrustPrice":"",
    	"entrustAmount":"",
    	"businessPrice":"",
    	"businessAmount":"",
    	"entrustNo":"",
    	"exchangeType":"",
    	"entrust_bs":""
    };
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("100855");
		common.switchingCurUser("0");
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		common.setMainHeight(_pageId, false);
		userInfo = common.getCurUserInfo();
    }
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(100856, 2, 103, true, {"i_group_name": "返回"});
				if (global.callNative) {
					if ($.getPageParam("isFromApp")) {
//					var param = $.getPageParam();
						//ios切换行情
						$.callMessage({
							"funcNo": "50500",
							"msgNo": "205",
							"sourceModule": "trade",
							"targetModule": "app",
							"action": "4",
							"param": {}
						});
						$.pageInit("ggt/ggtCancel", "account/index", {"history": true}, "left", true);
					} else {
						$.pageInit("ggt/ggtCancel", "account/index", {"history": true}, "left", true);
					}
				} else {
					$.pageInit("ggt/ggtCancel", "account/index", {}, true);
				}
				e.preventDefault();
			},300);
		});

		// 刷新
		$.bindEvent($(_pageId + ".icon_refresh"), function(e){
			$.showRightTopPreloaders();
			queryCancellation(position_str);
			e.stopPropagation();
		});
	}
    
    function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		vIscrollHeight = mianHeight - $(_pageId+".tab_nav").height();
		queryCancellation(position_str); //可撤单查询
    }
    
	/**
	 * 可撤单查询
	 */
	function queryCancellation(position){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var password = userInfo.password;
		var sessionid = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
            "request_num":_request_num,
            "position_str":position
		};
		//每次查询前,先将暂无数据隐藏
		$(_pageId+ ".no_data").hide();
		//最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
		service_ggt.queryTodayTrusts_ggt(param,queryTrustDataCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){    //超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
	        }
		});
	}
	
	/**
	 * 可撤单查询回调
	 */
	function queryTrustDataCallback(data){
		if (typeof(data) != undefined && typeof(data) != null) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var html = "";
					for (var i=0;i<results.length;i++){
						html += queryTrustDataHTML(results[i]);
					}
					if(position_str==""){
						$(_pageId+".fund_list2").html(html);
					}else{
						$(_pageId+".fund_list2").append(html);
					}
					position_str=results[results.length-1].position_str;
					cancelEvent();
				}else{
					if(position_str==""){
						$(_pageId+".fund_list2").html("");
						$(_pageId+".no_data").show();
					}
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 可撤单查询HTML生成
	 */
	function queryTrustDataHTML(element){
		var price_digit = 3;
		var css = "";
		var entrust_name = "";
		if(element.entrust_bs == 0){
			css = "tag n1";
		}else if(element.entrust_bs == 1){
			css = "tag n2";
		}
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
		var eleHtml = "";
		eleHtml+="<div class=\"part\" data-id='"+element.entrust_no+"' data-type='"+element.exchange_type+"' entrust_bs='"+element.entrust_bs+"'>";
		eleHtml+="<div class=\"title\"><span class=\""+css+"\">"+entrust_name+"</span><h5><em>"+element.stock_name+"</em><small>"+element.stock_code+"</small></h5><span class=\"time\">"+element.entrust_state_name+"</span></div>"
       	eleHtml+="<ul>";
       	eleHtml+="<li>委托价  <span id=\"entrustPrice\">"+Number(element.entrust_price).toFixed(price_digit)+"</span></li>";
       	eleHtml+="<li>委托数  <span id=\"entrustAmount\">"+element.entrust_amount+"</span></li>";
       	eleHtml+="<li>成交价  <span id=\"businessPrice\">"+Number(element.business_price).toFixed(price_digit)+"</span></li>";
       	eleHtml+="<li>成交数  <span id=\"businessAmount\">"+element.business_amount+"</span></li>";
       	eleHtml+="<li>交易市场  <span>"+element.exchange_type_name+"</span></li>";
       	eleHtml+="<li>委托时间  <span>"+element.entrust_time+"</span></li>";
       	eleHtml+="</ul>";
       	eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 点击撤单事件
	 */
	function cancelEvent(){
		// 撤单事件
		$.bindEvent($(_pageId+".fund_list2 .part"), function(e){
			_stockInfo.stockCode=$(this).find(".title h5 em").text();
			_stockInfo.stockName=$(this).find(".title small").text();
			_stockInfo.entrustName=$(this).find(".title span").text();
			_stockInfo.entrustPrice=$(this).find("#entrustPrice").text();
			_stockInfo.entrustAmount=$(this).find("#entrustAmount").text();
			_stockInfo.businessPrice=$(this).find("#businessPrice").text();
			_stockInfo.businessAmount=$(this).find("#businessAmount").text();
			_stockInfo.entrustNo=$(this).attr("data-id");
			_stockInfo.exchangeType=$(this).attr("data-type");
			_stockInfo.entrust_bs=$(this).attr("entrust_bs");
			isCancellation();
			common.comStat(100858,2,103,true,{"i_group_name": "撤单提交"});
			e.stopPropagation();
		},"tap");
		// 确定撤单
		$.bindEvent($(_pageId+" .pop_footer #ok"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
			cancellation(_stockInfo.entrustNo,_stockInfo.exchangeType);
			buryingPointParam(true);
			e.stopPropagation();
		},"tap");
		// 取消撤单
		$.bindEvent($(_pageId+".pop_footer #cancel"), function(e){
			$(_pageId+".backdrop").hide();
			$(_pageId+".pop_box").hide();
			buryingPointParam(false);
			e.stopPropagation();
		},"tap");
	}
	
	/*
	 * 埋点参数
	 */
	function buryingPointParam(type){
		var comStatParam={
			"i_entrust_bs" :_stockInfo.entrust_bs,//交易方向（1,买入 2,卖出）
			"i_exchange_type" :_stockInfo.exchangeType,// 交易市场
			"i_stock_code" :_stockInfo.stockCode,// 股票代码
			"i_stock_name" :_stockInfo.stockName,// 股票名称
			"i_entrust_prop" :"",// 委托属性名称
			"i_entrust_price" :_stockInfo.entrustPrice,// 委托价格
			"i_entrust_amount" :_stockInfo.entrustAmount,// 委托数量
		}
		if(type){
			comStatParam.i_oper="1";  //动作（1确定 2取消）
		}else{
			comStatParam.i_oper="2";  //动作（1确定 2取消）
		}
		common.comStat(100859,2,3,false,comStatParam);
	}
	
	/**
	 * 确定撤单
	 */
	function isCancellation(){
		$(_pageId+".pop_box .pop_main ul li:eq(0)").find("em").text(_stockInfo.stockCode);
		$(_pageId+".pop_box .pop_main ul li:eq(0)").find("strong").text(_stockInfo.stockName);
		$(_pageId+".pop_box .pop_main ul li:eq(1)").find("em").text(_stockInfo.entrustName);
		$(_pageId+".pop_box .pop_main ul li:eq(2)").find("strong").text(_stockInfo.entrustPrice);
		$(_pageId+".pop_box .pop_main ul li:eq(3)").find("strong").text(_stockInfo.entrustAmount);
		$(_pageId+".pop_box .pop_main ul li:eq(4)").find("strong").text(_stockInfo.businessPrice);
		$(_pageId+".pop_box .pop_main ul li:eq(5)").find("strong").text(_stockInfo.businessAmount);
		$(_pageId+".backdrop").show();
		$(_pageId+".pop_box").show();
	}
	/**
	 * 确定撤单
	 */
	function cancellation(entrust_no){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var batch_flag = "0";
		var entrust_no = entrust_no;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		    "entrust_no":entrust_no,
		    "batch_flag":batch_flag
		};
		service_ggt.postCancelOrder_ggt(param,postCancelOrderCallback);
	}
    //确定撤单回调
	function postCancelOrderCallback(data){
		if (typeof data != "undefined" && data != null) {
			if (data.error_no == 0) {	
				if(typeof data.results[0] != "undefined" && data.results[0] != null ){
					$.alert("撤单成功");
					position_str = "";
					queryCancellation();//刷新页面重新加载数据
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			$.alert("撤单失败");
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: vIscrollHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				position_str = "";
				queryCancellation(); // 模拟查询接口数据操作
				//埋点 
				common.comStat(100857,2,102,true,{"i_direct": "1","i_type":"1" });
			},
			pullUpHandler: function(){
				queryCancellation(position_str);
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	/**
	 * 销毁
	 */
	function destroy(){
	    entrustNo = "";
		exchangeType = "";
		$(_pageId+".cancel_order").html("");
		if(myScroller){
			myScroller.destroy();
			myScroller=null;
		}
		common.pageBuryingPoint();
	}

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});