/**
 * 港股交易-公司行为申报
 */
define('trade/scripts/ggt/ggtCompanyHdEntrust.js',function(require, exports, module){
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_hq = require("service_hq");
	if(global.hqCallInterface == 1){
		service_hq = require("service_hqTrade");
	}
	var service_ggt = require("service_ggt");
	var _pageId = "#ggt_ggtCompanyHdEntrust ";
	var userInfo = null;
	var _voteInfo= {
		"stock_code": "",
		"corpbehavior_code": "",
		"business_type": "",
		"report_type":"",
		"report_amount":"",
		"business_type_name":"",
		"report_type_name":"",
		"exchange_type":"",
        "stock_account":""
	};
	
	
	/**
	 * 初始化
	 */
	function init(){
		common.pageBuryingPoint("100881");
		userInfo = common.getCurUserInfo();
		var param=$.getPageParam().param;
		if(param){
			_voteInfo.stock_code=param.stock_code;
			_voteInfo.exchange_type=param.exchange_type;
			$(_pageId+"#stockCode").val(param.stock_code);
			_voteInfo.corpbehavior_code=param.corpbehavior_code;
			$(_pageId+"#HdCode").val(param.corpbehavior_code);
			distinguishingTypes();
			stockAccountFun();
            if(_voteInfo.exchange_type=="S"){
            	$(_pageId+".label_g").addClass("SK");
            }
            else if(_voteInfo.exchange_type=="G"){
            	$(_pageId+".label_g").addClass("HK");
            }
		}
	}
	
	/*
	 * 根据市场，筛选两个市场对应的主股东账号，用于提交的时候传递
	 */
	function stockAccountFun(){
		var getInfo = common.getAccountInfos();
		if(getInfo && Object.keys(getInfo).length>0){
			var getInfo1=getInfo["stock"];
			if(getInfo1 && Object.keys(getInfo1).length>0){
				var getInfo2=getInfo1[userInfo.fund_account];
				if(getInfo2 && Object.keys(getInfo2).length>0){
					for(var i=0;i<getInfo2.length;i++){
						if(getInfo2[i].exchange_type==_voteInfo.exchange_type && getInfo2[i].main_flag=="1"){
							_voteInfo.stock_account=getInfo2[i].stock_account;
						}
					}
				}
			}
		}
	}
	
	
	function load(){
			
	}
	/*
	 * 区分业务类型
	 */
	function distinguishingTypes(){
		var eleHtml="";
		if(_voteInfo.exchange_type=="S"){
			eleHtml+='<li id="SGBG" name="0"><a href="javascript:void(0);">收购保管</a></li>';
			eleHtml+='<li id="QPSB" name="1"><a href="javascript:void(0);">红利选择权申报</a></li>';
			eleHtml+='<li id="PGRG" name="2"><a href="javascript:void(0);">配股认购</a></li>';
//			eleHtml+='<li id="TPSB" name="3"><a href="javascript:void(0);">投票申报</a></li>';
//			eleHtml+='<li id="ZT01" name="4"><a href="javascript:void(0);">报盘转托管</a></li>';
//			eleHtml+='<li id="ZT03" name="5"><a href="javascript:void(0);">转托管反向调整</a></li>';
//			eleHtml+='<li id="DJJD" name="6"><a href="javascript:void(0);">司法解冻</a></li>';
//			eleHtml+='<li id="DJDJ" name="7"><a href="javascript:void(0);">司法冻结</a></li>';
//			eleHtml+='<li id="DJXD" name="8"><a href="javascript:void(0);">续冻</a></li>';
//			eleHtml+='<li id="LHJC" name="9"><a href="javascript:void(0);">解除轮候</a></li>';
		}
		else if(_voteInfo.exchange_type=="G"){
			eleHtml+='<li id="H63" name="1"><a href="javascript:void(0);">公司收购申报业务</a></li>';
			eleHtml+='<li id="H64" name="2"><a href="javascript:void(0);">公开招股申报业务</a></li>';
			eleHtml+='<li id="H65" name="3"><a href="javascript:void(0);">供股行权申报业务</a></li>';
			eleHtml+='<li id="H66" name="4"><a href="javascript:void(0);">红利现金选择权申报业务</a></li>';
//			eleHtml+='<li id="H62" name="0"><a href="javascript:void(0);">投票申报业务回报</a></li>';
//			eleHtml+='<li id="H63" name="1"><a href="javascript:void(0);">公司收购申报业务回报</a></li>';
//			eleHtml+='<li id="H64" name="2"><a href="javascript:void(0);">公开招股申报业务</a></li>';
//			eleHtml+='<li id="H65" name="3"><a href="javascript:void(0);">供股行权申报业务</a></li>';
//			eleHtml+='<li id="H66" name="4"><a href="javascript:void(0);">红利现金选择权申报业务</a></li>';
		}
    	$(_pageId+"#declareTypeUl").html(eleHtml);
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(100882, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("ggt/ggtCompanyHdDeclare", "ggt/ggtQuery", {}, true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		});

		//选择投票信息列
		$.bindEvent($(_pageId+".input_form .select_code"),function (e) {
			//埋点
			common.comStat(100883,2,103,true,{"i_group_name":"证券代码选择"});
			$.pageInit("ggt/ggtCompanyHdEntrust","ggt/ggtQueryCompanyHdInfo",{"whichPage":"ggt/ggtCompanyHdEntrust"});
			e.stopPropagation();
		});

		//选择业务类型
		$.bindEvent($(_pageId+".input_form .select_type #declareType"),function (e) {
			$(_pageId+"#reportTypeUl").hide();
			$(_pageId+"#declareTypeUl").toggle();
			e.stopPropagation();
		});
		
		//选择申报类型
		$.bindEvent($(_pageId+".input_form .select_type #reportType"),function (e) {
			$(_pageId+"#reportTypeUl").toggle();
			$(_pageId+"#declareTypeUl").hide();
			e.stopPropagation();
		});

		//业务类型选择和申报
		$.bindEvent($(_pageId+".input_form .select_type ul li"),function (e) {
			//埋点
			var objectId=$(this).parents(".select_type").attr("objectId");
			var actionId=$(this).parents(".select_type").attr("actionId");
			var name=$(this).parents(".select_type").attr("name");
			common.comStat(objectId,2,actionId,true,{"i_group_name":name});
			
			if($(this).parent().parent().find("input").attr("id")=="declareType"){
				$(_pageId+".input_form .select_type #declareType").val($(this).find("a").text());
				_voteInfo.business_type=$(this).attr("name");
				_voteInfo.business_type_name=$(this).find("a").text();
			}else{
				$(_pageId+".input_form .select_type #reportType").val($(this).find("a").text());
				_voteInfo.report_type=$(this).attr("name");
				_voteInfo.report_type_name=$(this).find("a").text();
				if(_voteInfo.report_type=="0"){
					$(_pageId+"#reportNumInput").hide();
				}else{
					$(_pageId+"#reportNumInput").show();
				}
			}
			$(this).parent("ul").hide();
			e.stopPropagation();
		},"tap");

		//点击其他地方
		$.bindEvent($(_pageId),function(e){
			$(_pageId+"#reportTypeUl").hide();
			$(_pageId+"#declareTypeUl").hide();
		});
		
		//下单
		$.bindEvent($(_pageId+"#orderButton"),function(e){
			//埋点
			common.comStat(100886,2,103,true,{"i_group_name":"投票申报提交"});
			//获取页面上的输入参数
			_voteInfo.report_amount=$(_pageId+"#declareAmount").val();
			vailSubmitOrder();
			e.stopPropagation();
		});

		//数量输入
//		$.bindEvent($(_pageId+"#declareAmount"),function(e){
//			if(keyboard){
//				keyboard.popUpKeyboard($(this),e);
//			}
//			var _code=$(_pageId + "#declareAmount").quzhi();
//			if(_code){
//				_code=_code.replace(".","");
//				$(_pageId + "#declareAmount").quzhi(_code);
//			}
//			e.stopPropagation();
//		},"input");
	}

	//清除用户输入的数据.
	function clearMg() {
		for(var ele in _voteInfo){
			_voteInfo[ele]="";
		}
		$(_pageId + " #stockCode").val("");
		$(_pageId + " #HdCode").val("");
		$(_pageId + " #declareAmount").val("");
		$(_pageId+"#declareType").val("");
		$(_pageId+"#reportType").val("");
		$(_pageId+"#reportNumInput").show();
		$(_pageId+".label_g").removeClass("HK");
		$(_pageId+".label_g").removeClass("SK");
		$(_pageId+"#declareTypeUl").html("").hide();
	}
	
	
	//下单验证
    function vailSubmitOrder(){
		if(_voteInfo.stock_code.length < 5){
			$.alert("请选择股票代码");
			return false;
		}
		//判断有木有选择业务类型和申报类型
		if(_voteInfo.business_type==""){
			$.alert("请选择业务类型");
			return false;
		}
		if(_voteInfo.report_type==""){
			$.alert("请选择申报类型");
			return false;
		}
		if(_voteInfo.report_type=="1"){
			//判断输入的申报数量
			if(!_voteInfo.report_amount){
				$.alert("请输入申报数量");
				return false;
			}
			if(_voteInfo.report_amount<=0){
				$.alert("申报数量要大于0");
				return false;
			}
		}
		//定义弹出层确认
		var tipStr ="<div>";
		var tipStrArray = [];
		tipStr+="<h3>公司行为申报</h3>";
		tipStr+="</div>";
		tipStr+="<div>";
		tipStrArray.push(["证券代码 :",_voteInfo.stock_code]);
		tipStrArray.push(["业务类型 :",_voteInfo.business_type_name]);
		tipStrArray.push(["申报类型 :",_voteInfo.report_type_name]);
		tipStrArray.push(["行为代码 :",_voteInfo.corpbehavior_code]);
		if(_voteInfo.report_type=="1"){
			tipStrArray.push(["申报数量 :",_voteInfo.report_amount]);
		}
		tipStr+=common.generatePrompt(tipStrArray);
		tipStr+="</div>";
		
		//埋点数据
		var comStatParam={
			"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":_voteInfo.stock_code, // 股票代码
			"i_stock_name":_voteInfo.stock_name, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":_voteInfo.exchange_type, // 交易市场
			"i_entrust_price":"", // 选择后的价格
			"i_entrust_amount":"", // 委托数量
		}
		var objectId = $(_pageId+".ce_btn").attr("objectId");
		var actionId = $(_pageId+".ce_btn").attr("actionId");
		
		//根据选择的申报类型改变输入的数量
		common.iConfirm("",tipStr,function success(){
			var entrust_way =global.entrust_way;
			var branch_no = userInfo.branch_no;
			var fund_account=userInfo.fund_account;
			var cust_code=userInfo.cust_code;
			var sessionid=userInfo.session_id;
			var stock_code=_voteInfo.stock_code;
			var stock_account=_voteInfo.stock_account;
			var business_type=_voteInfo.business_type;
			var report_type=_voteInfo.report_type;
			var corpbehavior_code=_voteInfo.corpbehavior_code;
			var report_amount=_voteInfo.report_amount;
			var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"business_type":business_type,
				"report_type":report_type,
				"corpbehavior_code":corpbehavior_code,
				"report_amount":report_amount,
				"exchange_type":_voteInfo.exchange_type
			};
		service_ggt.ggtCompanyHdEntrust(param,CallBack);
		comStatParam.i_oper = "1"; // 动作（1确定 2取消）
		common.comStat(objectId,2,actionId,false,comStatParam);
  	},function fill(){
		comStatParam.i_oper = "2"; // 动作（1确定 2取消）
		common.comStat(objectId,2,actionId,false,comStatParam);
  	});
		$(_pageId+"._content").css("font-size","15px");
  }
    
    function CallBack(data){
    	if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>提示</span><br>委托已提交，委托编号："+results[0].serial_no;
				$.alert(tipStr);
				clearMg();
			}
		}else{
			$.alert(data.error_info);
			clearMg();
		}
  }

	/***
	 * 销毁
	 */
	function destroy(){
		clearMg();
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	}
	module.exports = base;
});
