/**
 * 港股交易-持仓
 */
define('trade/scripts/ggt/ggtHolding.js',function(require, exports, module) {
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_ggt = require("service_ggt");
	var service_hq = require("service_hq");
	if(global.hqCallInterface == 1){
		service_hq = require("service_hqTrade");
	}
	var service_stock = require("service_stock");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
    var myHScroller = null; 
    var canBuy = 0 ;//可用
    var market_val = 0 ;//市值
    var _pageId = "#ggt_ggtHolding ";
    var userInfo = null;
    var position_Timer = null;
    var _callback = true;
    var float_yks = 0;
    var _openStock={};
    var abc=0;
    
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("100731");
		common.switchingCurUser("0");
		sessionStorage.setItem("isScroller","");
		_openStock={};
		$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		userInfo = common.getCurUserInfo();
		pageContentChange();
		jumpPageEvent();
		common.setMainHeight(_pageId, false);			
    }
		
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		vIscrollHeight = mianHeight - $(_pageId+".tab_nav").outerHeight(true)-2;
		$(_pageId + " #wrapper").height(vIscrollHeight);
		// if(!myScroller){ //初始化高度会有问题
		// 	initScroller();
		// }else{
		// 	myScroller.refresh();
		// }
		initHScroller();
		queryData();//查询持仓
	}

	function pageContentChange(){
		$(_pageId+".position_div thead th").each(function(idx, item){
			var zoom = $.getTransformScaleFontSize($(item).text(), 14, ($(window).width()) * 0.25 - 15)
			$(item).css({"font-size": zoom+"px" });
		});
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){}
	
	/**
	 * 事件绑定
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				//埋点
				common.comStat(100737, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("ggt/ggtHolding", "account/index", {"history": true}, "left", true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(100736,2,103,true,{"i_group_name":"银证转账"});
			$.setSStorageInfo("return_page","stock/stockHolding");
			$.pageInit("ggt/ggtHolding","banking/transferNew",{});
			e.preventDefault();
			e.stopPropagation();
		});
		$.bindEvent($(_pageId), function(e){
			sessionStorage.setItem("isScroller","");
		}, "touchstart");

		// 刷新
		$.bindEvent($(_pageId + ".icon_refresh"), function(e){
			$.showRightTopPreloaders();
			queryData();
			e.stopPropagation();
		});
	}

    
	/**
	 * 查询
	 */
	function queryData(){
		clearPositionTimer();
		//查询资金账户
		queryCapital();
		queryAvailableHolding();
		queryPosition();
		_callback = false;
		if(position_Timer == null && global.positionRefreshTime){
			commonFunc.initCheckTradeTimer();
			position_Timer = window.setInterval(function(){
				if(commonFunc.getTradingTime() && _callback && common.isAppFlag()){
					queryCapital(true);
					queryPosition(true);
					_callback = false;
				}
			}, global.positionRefreshTime);//定时刷新
		}
	}


	function queryAvailableHolding(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
		};
		service_ggt.queryAvailableHolding_ggt(param,function(data){
			if(data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					$(_pageId+".j-data-lower strong").each(function(idx, item){
						$(item).css("font-size","18px");
					});
					$(_pageId+".j-data-lower span").each(function(idx, item){
						$(item).css("font-size","18px");
					});
					if(results && results!= "undefined" && results.length >0){
						for(var i=0;i<results.length;i++){
							var info = results[i];
							if(info.exchange_type == "G"){
								$(_pageId + ".ggt #jyzt").text(info.trade_flag == "1" ? "交易日" : info.trade_flag == "1" ? "非交易日" : "--");
								$(_pageId + ".ggt #jrsyed").text(info.surplus_quota ? info.surplus_quota + "亿" : "--");
							}else if(info.exchange_type == "S"){
								$(_pageId + ".sgt #jyzt").text(info.trade_flag == "1" ? "交易日" : info.trade_flag == "1" ? "非交易日" : "--");
								$(_pageId + ".sgt #jrsyed").text(info.surplus_quota ? info.surplus_quota + "亿" : "--");
							}
						}
					}else{
						$(_pageId+".hold_main2 .j-data-lower strong").text("--");
					}
					//字体缩放
					$(_pageId+".j-data-lower strong").each(function(idx, item){
						item = $(item);
						item.css("font-size",$.getTransformScaleFontSize(item.text(), 18, item.parent().width() - 40)+"px");
					});
					$(_pageId+".j-data-lower span").each(function(idx, item){
						item = $(item);
						item.css("font-size",$.getTransformScaleFontSize(item.text(), 18, item.width() -5) + "px");
					});
				}else{
					$.alert(data.error_info);
				}
			}
		},
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}

	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "is_homepage":""
		};
		//最后一个为超时处理函数
		service_ggt.queryFundSelect_ggt(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var type = {"0":"RMB","1":"Dollar","2":"HKD"};
					for(var i=0;i<results.length;i++){
						var id = _pageId +"#"+ (type[results[i].money_type] || "RMB");
						var assert_val = Number(results[i].assert_val).toFixed(2)+"";
						$(id +" #zzc").html(assert_val.substring(0,assert_val.length-2)+""+ assert_val.substr(-2) +"");//总资产
						// if(assert_val.length>12){
						// 	$(id+" .inner>strong").css("font-size", "0.22rem");
						// }
						var fetch_balance = Number(results[i].fetch_balance).toFixed(2)+"";
						$(id+" #kq").html(fetch_balance.substring(0,fetch_balance.length-2)+""+ fetch_balance.substr(-2) +"");//可取
						var enable_balance = Number(results[i].enable_balance).toFixed(2)+"";
						$(id+" #ky").html(enable_balance.substring(0,enable_balance.length-2)+""+ enable_balance.substr(-2) +"");//可用
						var market_val=Number(results[i].market_val).toFixed(2)+"";   //港股市值
						$(id+" #ccsz").html(market_val.substring(0,market_val.length-2)+""+ market_val.substr(-2) +"");
						//添加总浮动盈亏
						var css = "";
						var float_yks = results[i].total_income_balance;
						//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
						if(float_yks > 0){
							css = "ared";
						}else if(float_yks < 0){
							css = "agreen";
						}
						// var fas = Number(float_yks).toFixed(2);
						var fas=Number(results[i].total_income_balance).toFixed(2)+"";
						$(id+" #ccckyk").html(fas.substring(0,fas.length-2)+""+ fas.substr(-2) +"").removeClass().addClass(css);//持仓盈亏;
						//仓位
						var stock_position = results[i].stock_position
						$(id + " #cwbox").html('<span style="width:'+stock_position+';"></span>仓位 '+ stock_position);
					}
					//字体缩放
					$(_pageId+".j-data-top strong").each(function(idx, item){
						item = $(item);
						item.css("font-size",$.getTransformScaleFontSize(item.text(), 18, item.parent().width() - 36) + "px");
					});
				}else{
					$(_pageId+".hold_main2 .j-data-top strong").text("--");
					$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	
	function queryPosition(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
		    "password":password
		};
		service_ggt.queryHolding_ggt(param,function (data){
				_callback = true;
				$(_pageId+'.position_div tr.tools').remove();
				$(_pageId+'.position_div tr.add').remove();
				if (data && data != "undefined") {
					if(data.error_no == 0){
						var results = data.results;
						var dataHtml="";
						if(results && results.length>0){
							float_yks = 0; //浮动盈亏
							_openStock=$.getSStorageInfo("openStock",false) || {};
							if(_openStock && typeof(_openStock) == "string"){
								_openStock = JSON.parse(_openStock);
							}
							for (var i=0;i<results.length;i++){ 
								float_yks += Number(results[i].float_yk);//计数总浮动盈亏
								var isLast="";
								if(i==(results.length-1)){
									isLast="true";
								}
								dataHtml += queryPositionHTML_stock(results[i],isLast);
							}
							$(_pageId+".position_div tbody").html(dataHtml);
							$(_pageId+".no_data").hide();
							//卖出事件
							holdClickEvent();
						}
						else{
							// $(_pageId+".position_div tbody").html("<div class='top'><p style='width: 10%'><span scope=\"col\">市场</span></p><p style='width: 25%'><span scope=\"col\">证券/市值</span></p><p style='width: 25%'><span scope=\"col\">盈亏</span></p><p style='width: 20%'><span scope=\"col\">持仓/可用</span></p><p style='width: 20%'><span scope=\"col\">成本/现价</span></p></div>");
							$(_pageId+".no_data").show();
						}
					}else{
						$.alert(data.error_info);
					}
				}
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			},{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	
	
	function clearPositionTimer(){
		if (position_Timer != null ) {
	        window.clearInterval(position_Timer);
	    }
		position_Timer = null;
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		float_yk = float_yk.toFixed(2);
		//浮动盈亏比例
		var css1 = "";
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		var market = "",lable = "";
		if(element.exchange_type == "S" || element.exchange_type == "s"){
			img = "SK ";
			lable = "j-label-02";
			market="深";
		}else if(element.exchange_type == "G" || element.exchange_type == "g"){
			img = "HK ";
			lable="j-label-01";
			market="沪"
		}
        var active_css1 = "" , active_css2 = " style='display: none;'";
		if(_openStock && _openStock.stock_code){
			if(element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account){
				active_css1 = "active";
				active_css2 = "";
			}
		}
		var css3="";
		if(isLast=="true"){
			css3="_last";
		}else{
			css3="_nolast";
		}

		var maxWidth = ($(window).width() - 25 - 35 - 30 - 15 -25) / 4;
		var setTranslateX = function(value){
			if(value != 1){
				return 'translateX('+ (value - 1) * maxWidth +'px)';
			}
			return '';
		}
		var eleHtml = "";
		var marketValue = Number(element.market_value).toFixed(price_digit),
		float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
		hold_amount = Number(element.hold_amount),
		enable_amount = Number(element.enable_amount),
		cost_price = Number(element.cost_price).toFixed(price_digit),
		last_price = Number(element.last_price).toFixed(price_digit);
		eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" stock_name=\""+element.stock_name+"\"  id='"+element.stock_code +"'>";
		eleHtml+='<td><label class="j-label '+lable+'">'+market+'</label>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(element.stock_name, 16, maxWidth + 5) +'px;">'+element.stock_name +'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p></td>';
        eleHtml+='<td><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>';
        eleHtml+='<p class="'+css1+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+float_yk_per+'</p></td>';
		eleHtml+='<td><p style="font-size:'+$.getTransformScaleFontSize(hold_amount, 16, maxWidth) +'px;">'+hold_amount+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></td>';
		eleHtml+='<td><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></td>';
		// eleHtml+='<td></td>'
		eleHtml+="</tr>";
		eleHtml+="<tr class='j-table-btns tools "+css3+"' "+active_css2+">";
        eleHtml+="<td colspan=\"4\">";
        eleHtml+="<ul class='ui layout j-btns-list'>";
        eleHtml+="<a id=\"buy\" class=\"row-1 border-right\" href=\"javascript:void(0);\">买入</a>";
        eleHtml+="<a id=\"sell\" class=\"row-1 border-right\" href=\"javascript:void(0);\">卖出</a>";
        eleHtml+="<a id=\"hq\" class=\"row-1 border-right\" href=\"javascript:void(0);\">行情</a>";
		eleHtml+="<a id=\"cbj\" class=\"row-1\" href=\"javascript:void(0);\">成本价</a>";
		// eleHtml+="<a id=\"mx\" class=\"row-1\" class=\"row-1\" href=\"javascript:void(0);\">明细</a>";
        eleHtml+="</ul>";
        eleHtml+="</td>";
		eleHtml+="</tr>";
		return eleHtml;

        eleHtml+="<dl class='position_data  "+active_css1+"' id='"+element.stock_code +"' stock_account='"+element.stock_account +"' cost_price='"+Number(element.cost_price).toFixed(price_digit) +"'  exchange_type='"+element.exchange_type+"' stock_name='"+element.stock_name +"' isLast='"+isLast+"'>";
        eleHtml+="<dd style='width: 10%'><i style='display: block;position: static;margin-left: 0.05rem;' class='position_g "+img+"' ></i></dd>";
        eleHtml+="<dd><p><strong>"+element.stock_name +"</strong></p><p><small>"+Number(element.market_value).toFixed(2) +"</small></p></dd>";
        eleHtml+="<dd><p><span class=\""+css+"\">"+float_yk+"</span></p><p><span class=\""+css+"\">"+Number(element.float_yk_per).toFixed(2)+"%</span></p></dd>";
        eleHtml+="<dd><p>"+Number(element.hold_amount)+"</p><p>"+Number(element.enable_amount)+"</p></dd>";
        eleHtml+="<dd><p>"+Number(element.cost_price).toFixed(price_digit)+"</p><p>"+Number(element.last_price).toFixed(price_digit)+"</p></dd>";
        eleHtml+="</dl>";
		eleHtml+="<dd class='toolstwo "+css3+"'  "+active_css2+"><ul>";
		eleHtml+="<li><a id=\"buy\" href=\"javascript:void(0);\"><span>买入</span></a></li>";
		eleHtml+="<li><a id=\"sell\" href=\"javascript:void(0);\"><span>卖出</span></a></li>";
		eleHtml+="<li><a id=\"hq\" href=\"javascript:void(0);\"><span>行情</span></a></li>";
		eleHtml+="<li><a id=\"cbj\" href=\"javascript:void(0);\"><span>成本价</span></a></li>";
		eleHtml+="</ul></dd>";
		return eleHtml;
	}
	
	//持仓点击事件
	function holdClickEvent(){
		$.bindEvent($(_pageId+'.position_div  tr.add'), function(e){
			var inv = $(_pageId+".position_div .tools._last").is(':visible') ? 0 : 34;
			var isLast=$(this).attr("islast");
			if(($(_pageId +  ".vertical_list").height() + inv) > $(_pageId + " #wrapper").height()){
				var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
				if(isLast=="true" || isNeedScroll){
					if($(this).next().height() > 0){
                        abc = $(this).next().height();
                    }
					var a = $(this).next().css("display") == "none" ? true : false;
					$(_pageId+".position_div .tools").hide();
					if(a){
						$(this).next().show();
						//保存展开的股票
						var openStock={
							"stock_code":$(this).attr("id"),
							"exchange_type":$(this).attr("exchange_type"),
							"stock_account":$(this).attr("stock_account"),
						}
						$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
					}else{
						_openStock={};
						$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
					}
					$(this).addClass("active").siblings().removeClass("active");
					if(myScroller){
                        if($(this).next().height() > 0){
                        	abc = $(this).next().height();
                        }
                        var maxScrollY = 0;
                    	var _height=myScroller.y;
                    	var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
						if($(this).next().is(':visible')){
							sessionStorage.setItem("isScroller","true");
							_height -= abc ;
							maxScrollY = _height;
						    _height -= temph;
						}else{
							_height += abc;
							maxScrollY = _height;
							sessionStorage.setItem("isScroller","");
						}
						myScroller.scrollTo(0,_height);
						myScroller.y = _height;
						myScroller.refresh();
						if(isLast=="true"){
							myScroller.maxScrollY = maxScrollY;
						}
					}
				}else{
					var a = $(this).next().css("display") == "none" ? true : false;
					$(_pageId+".position_div .tools").hide();
					if(a){
						$(this).next().show();
						//保存展开的股票
						var openStock={
							"stock_code":$(this).attr("id"),
							"exchange_type":$(this).attr("exchange_type"),
							"stock_account":$(this).attr("stock_account"),
						}
						$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
					}else{
						_openStock={};
						$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
					}
					$(this).addClass("active").siblings().removeClass("active");
					if(myScroller){
						myScroller.refresh();
					}
				}
			}
			else{
				var a = $(this).next().css("display") == "none" ? true : false;
				$(_pageId+".position_div .tools").hide();
				if(a){
					$(this).next().show();
					//保存展开的股票
					var openStock={
						"stock_code":$(this).attr("id"),
						"exchange_type":$(this).attr("exchange_type"),
						"stock_account":$(this).attr("stock_account"),
					}
					$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
				}else{
					_openStock={};
					$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
				}
				$(this).addClass("active").siblings().removeClass("active");
				if(myScroller){
					myScroller.refresh();
				}
			}
			e.stopPropagation();
		});
		//卖出事件
		$.bindEvent($(_pageId+".position_div tr.tools a"), function(e){
			_openStock={};
			$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
			$(_pageId+".position_div tr.tools").hide();
			$(this).parents(".toolstwo").siblings().removeClass("active");
			var stock = $(this).parents("tr.tools").prev();
			var stock_code = stock.attr("id");
			var id = $(this).attr("id");
			var exchange_type = stock.attr("exchange_type");
			var stock_account = stock.attr("stock_account");
			var stock_name= stock.attr("stock_name");
			if(id == "buy"){
				//埋点
				common.comStat(100732,2,204,true,{
					"i_type":"跳买入",//操作类型
					"i_exchange_type":exchange_type,//交易市场
					"i_stock_code":stock_code,//股票代码
					"i_stock_name":stock_name,//股票名称
				});
				$.pageInit("ggt/ggtHolding","ggt/ggtBuy",{"code":stock_code,"exchange_type":exchange_type,"stock_account":stock_account,isHold:"1"});
			}
			else if(id == "sell"){
				//埋点
				common.comStat(100733,2,204,true,{
					"i_type":"跳卖出",//操作类型
					"i_exchange_type":exchange_type,//交易市场
					"i_stock_code":stock_code,//股票代码
					"i_stock_name":stock_name,//股票名称
				});
				$.pageInit("ggt/ggtHolding","ggt/ggtSell",{"code":stock_code,"exchange_type":exchange_type,"stock_account":stock_account,isHold:"1"});
			}
			else if(id == "hq"){
				if(stock_code){
					//埋点
					common.comStat(100734,2,204,true,{
						"i_type":"跳行情",//操作类型
						"i_exchange_type":exchange_type,//交易市场
						"i_stock_code":stock_code,//股票代码
						"i_stock_name":stock_name,//股票名称
					});
					var market = exchange_type == 'S'? 'SK':'HK';
					if(global.callNative){
                        var pageCode = $.getCurrentPageObj().pageCode || '';
                        $.setSStorageInfo("go_hq_" + pageCode, true);							
                        var param = {
                            "funcNo": "50500",
                            "msgNo": "201",
                            "targetModule":"hqDispatcher",
                            "sourceModule":"trade",
                            "action":"0",
                            "param":{
                                "stockMarket": market,
                                "stockCode": stock_code,
                                "stockName": stock_name,
                            }
                        }
                        $.callMessage(param);
                    }else{
                        var stockInfo = {
                            "market": market,
                            "stockCode": stock_code,
                            "stockName": stock_name,
                            "moduleName" : "trade"
                        }
                        window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                    }
				}		
			}else if(id == "cbj"){
				var content="<li><p>证券代码</p>"+stock_code+"</li>"+
       						"<li><p>修改前</p>"+stock.find("td").eq(3).find("p").eq(0).text()+"</li>"+
	               			"<li><p>币种</p>人民币</li>"+
        					"<li><p>修改后</p>"+
        					"<input type='number' js-key='number' style='border: 1px solid #dddddd;' class='t1' id='costPrice' maxLength='8' custom_keybord='0'/>"+
        					"</li>";
				common.costPriceiConfirm("成本价修改",content,function success(){
					//埋点
					common.comStat(100735,2,204,true,{
						"i_type":"修改成本价",//操作类型
						"i_exchange_type":exchange_type,//交易市场
						"i_stock_code":stock_code,//股票代码
						"i_stock_name":stock_name,//股票名称
					});
				
					var costPrice=$(_pageId+"#costPrice").val();
						if(!costPrice){
							$.alert("请输入修改后成本价！");
							return false;
						}
						if(costPrice<=0.000){
							$.alert("成本价格必须大于0.000。");
							return false;
						}
						if(costPrice>1000000000.000){
							$.alert("成本价格必须小于1000000000.000。");
							return false;
						}
						var reg=/^(-?\d*)\.?\d{1,3}$/;
						if(!reg.test(costPrice)){
							$.alert("成本价格只能精确到小数点后3位。");
							return false;
						}
					var param={				
						"entrust_way":global.entrust_way, // 委托方式  在configuration配置 
					    "branch_no":userInfo.branch_no,
					    "fund_account":userInfo.fund_account,
					    "cust_code":userInfo.cust_code,
					    "stock_account":stock_account,//股东代码
					    "exchange_type":exchange_type,//市场
					    "stock_code":stock_code,//股票代码
					    "cost_price":costPrice,//修改后的成本价
					    "password":userInfo.password
					};
					costModification(param);
				},function fail(){
					if(keyboard){
						keyboard.closeKeyPanel();
					}
				});
			}
			e.stopPropagation();
		});
	}
	//成本价修改
	function costModification(param){
		service_stock.costModification(param,function(data){
			if(data.error_no == 0){
				queryPosition("",true);//刷新持仓
			}else{
				$.alert(data.error_info);
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: vIscrollHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryData(); // 模拟查询接口数据操作
			},
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 初始化滑动组件
	 * @param queryFunc 查询函数
	 */
	function initHScroller()
	{
		var scrollOptions = {
			$wrapper: $(_pageId + " #hwrapper")
		};
		// 设置滚动内容的宽度
		// 显示左右滑动内容，防止页面闪动
		$(_pageId + " .iscroll_hScroller>div").width($(window).width()).show();
		// 设置 scroller 的宽度
		$(_pageId + " #hscroller").width($(window).width() * 3);
		//字体缩放
		$(_pageId+".j-data-info p").each(function(idx, item){
			var zoom = $.getTransformScaleFontSize($(item).text(), 14, $(item).width())
			$(item).css({"font-size": zoom+"px" });
		});			
//		myHScroller = iscrollUtils.hScroller(scrollOptions);
	}
	/**
	 * 销毁
	 */
	function destroy(){
        commonFunc.clearCheckTradeTimer();
		common.pageBuryingPoint();
		clearPositionTimer();
		_callback = true;
	    canBuy = 0 ;//可用
	    market_val = 0 ;//市值
		$(_pageId+".hold_main2 .j-data-top strong").text("--");
		$(_pageId+".hold_main2 .j-data-lower strong").text("--");
		$(_pageId+".hold_main2 .j-data-lower span").text("--");
		$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myHScroller)
		{
			myHScroller.destroy();
			myHScroller = null;
		}
		$(_pageId+".fund_table .ce_table dd.toolstwo").hide();
		$(_pageId+".fund_table .ce_table").html("");
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
