/**
 * 港股交易-公司行为申报查询
 */
define('trade/scripts/ggt/ggtQueryCompanyHdEntrust.js',function(require, exports, module) {
	
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_ggt = require("service_ggt");
    var _pageId = "#ggt_ggtQueryCompanyHdEntrust ";
    var userInfo = null;
    
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("100947");
		common.setMainHeight(_pageId, false);
		userInfo = common.getCurUserInfo();
    }
	
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
		callsQuery();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(100949, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("ggt/ggtQueryVoteToDeclare", "ggt/ggtQuery", {}, true);
				e.preventDefault();
			},300);
		});
		
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			callsQuery();
		});
	}
	
	
	/**
	 * 查询投票申报
	 */
	function callsQuery(){
		var entrust_way=global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var stock_account=userInfo.stock_account;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "password":password,
		    "sessionid":sessionid,
		};
		$(_pageId+ ".no_data").hide();
		service_ggt.queryCompanyHdDeclare(param,queryEntrustCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".fund_list2").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
		
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
		var css = "";
		if(element.exchange_type == "S"){//深市
			css = "tag n1";
		}else if(element.exchange_type == "G"){
			css = "tag n2";
		}
		var eleHtml = "";
		eleHtml+="<div class=\"part\">";
		eleHtml+="<div class=\"title\"><span class=\""+css+"\">"+element.exchange_type_name+"</span><h5><em>"+element.stock_name+"</em><small>"+element.stock_code+"</small></h5><span class=\"time\">"+element.apply_time+"</span></div>";
       	eleHtml+="<ul>";
       	eleHtml+="<li class='widthAdaptation'>行为代码 : <span>"+element.corpbehavior_code+"</span></li>";
       	eleHtml+="<li class='widthAdaptation'>申报类型 : <span>"+element.report_type_name+"</span></li>";
       	eleHtml+="<li class='widthAdaptation'>委托数量 : <span>"+Number(element.entrust_amount).toFixed(0)+"</span></li>";
       	eleHtml+="<li class='widthAdaptation'>申请编号 : <span>"+element.report_id+"</span></li>";
       	eleHtml+="<li class='widthAdaptation'>业务类型 : "+element.business_type_name+"</span></li>";
       	eleHtml+="<li class='full'><span><em style='color:#999999'>结果说明 : </em>"+element.result_info+"</span></li>";
       	eleHtml+="</ul>";
       	eleHtml+="</div>";
		
//		var eleHtml = "";
//		eleHtml+="<div class=\"part\">";
//		eleHtml+="<div class=\"title\">";
//		eleHtml+="<h5 style='margin-left: 0rem'>"+element.stock_name+" <small>"+element.stock_code+"</small></h5><span class=\"time\">"+element.apply_time+"</span>";
//		eleHtml+="</div>";
//		eleHtml+="<ul>";
//		eleHtml+="<li>行为代码 <em>"+element.corpbehavior_code+"</em></li>";
//		eleHtml+="<li>申报类型 <em>"+element.report_type_name+"</em></li>";
//		eleHtml+="<li>委托数量 <em>"+Number(element.entrust_amount).toFixed(0)+"</em></li>";
//		eleHtml+="<li>申请编号 <em>"+element.report_id+"</em></li>";
//		// eleHtml+="<li>席位编号 <em>"+element.seat_no+"</em></li>";
//		eleHtml+="<li style='width:100%'>业务类型 <em>"+element.business_type_name+"</em></li>";
//		eleHtml+="</div>";
		return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				common.comStat(100948,2,102,true,{"i_direct":"1","i_type":"1"});
				callsQuery(); // 模拟查询接口数据操作
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_list2").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		common.pageBuryingPoint();
	}

	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});