/**
 * 港股交易-额度查询
 */
define('trade/scripts/ggt/ggtQueryLimit.js',function(require, exports, module) {
	
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_ggt = require("service_ggt");
    var _pageId = "#ggt_ggtQueryLimit ";
    var userInfo = null;
    
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("100972");
		common.setMainHeight(_pageId, false);
		userInfo = common.getCurUserInfo();
    }
	
	function load(){
		queryLimit();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(100974, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("ggt/ggtQueryLimit", "ggt/ggtQuery", {}, true);
				e.preventDefault();
			},300);
		});
	}
	
	
	/**
	 * 查询投票申报
	 */
	function queryLimit(){
		var cust_code = userInfo.cust_code;	//客户代码
		var fund_account = userInfo.fund_account;	//资产账户
		var branch_no  = userInfo.branch_no;	//分支机构
		var sessionid=userInfo.sessionid;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var password= userInfo.password;
		var param = {
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"password":password,
			"sessionid":sessionid,
		};
		$(_pageId+ ".no_data").hide();
		service_ggt.queryAvailable_ggt(param,queryEntrustCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".fund_list2").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".fund_list2").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
		
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
		var productStatus = "";
		if(element.product_status == "1"){
			productStatus = "额度用完";
		}else if(element.product_status == "2"){
			productStatus = "额度可用";
		}
		
		var eleHtml = "";
		eleHtml+="<div class=\"part\">";
		eleHtml+="<ul>";
		eleHtml+="<li class='widthAdaptation'>交  易  所   <span>  "+element.exchange_type_name+"</span></li>";
		eleHtml+="<li class='widthAdaptation'>更新日期   <span>"+element.upddate+"</span></li>";
		eleHtml+="<li class='widthAdaptation'>每日初始   <span>"+Number(element.total_quota).toFixed(0)+"</span></li>";
		eleHtml+="<li class='widthAdaptation'>日中剩余   <span>"+Number(element.surplus_quota).toFixed(0)+"</span></li>";
		eleHtml+="<li class='widthAdaptation'>额度状态   <span>"+productStatus+"</span></li>";
		eleHtml+="<li class='widthAdaptation'>交易状态   <span>"+element.mkttrdstatus_name+"</span></li>";
		eleHtml+="</ul>";
		eleHtml+="</div>";
        return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				common.comStat(100973,2,102,true,{"i_direct":"1","i_type":"1"});
				queryLimit(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".fund_list2").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		common.pageBuryingPoint();
	}

	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});