/**
 * 查询对账单
 */
define('trade/scripts/ggt/queryStatementList.js',function(require, exports, module) {
	var gconfig = $.config; 
	var global = gconfig.global;
	var _pageId = "#ggt_queryStatementList ";
    var userInfo = null;
	var common = require("common");
	var commonFunc = require("commonFunc");
	var service_ggt = require("service_ggt");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象

    /**
     * 初始化
     */
    function init(){
		common.pageBuryingPoint("100975");
		userInfo = common.getCurUserInfo();
		commonFunc.initTimeChoice(_pageId,6, true);
    	ggtBillChecking();
    }
    
    function load(){
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
            setTimeout(function () {
                common.comStat(100977, 2, 103, true, {"i_group_name": "返回"});
                $.pageBack("ggt/ggtQuery", "left");
                e.preventDefault();
            },300);
		});
		
		$.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			ggtBillChecking();
		});
	}
    
    
    //查询公司相关信息
    function ggtBillChecking() {
        var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid=userInfo.session_id;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();
		var time1=new Date(end_time.replaceAll("-", "/"));
		var time2=new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2) {
			$.alert("开始日期大于截止日期");
			return false;
		}
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
		    "begin_time":begin_time,
		    "end_time":end_time,
        };
        service_ggt.ggtBillChecking(param, queryCallBack,
       		{
           "isLastReq":true,
           "isShowWait":true,
           "isShowOverLay":false,
           "timeOutFunc":function(){
               $(_pageId+ ".no_data").show();
               if(!myScroller){
                   initScroller();
               }else{
                   myScroller.refresh();
               }
           }
       });
    }


    function queryCallBack(data) {
        if (typeof(data) != "undefined" && data) {
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                var dataHtml="";
                if(results.length>0 && results!= "undefined"){
                    for (var i=0;i<results.length;i++){
                    	dataHtml += getHtml(results[i]);
                    }
                    $(_pageId+".cancel_order").html(dataHtml);
                }else{
                	$(_pageId+".no_data").show();
                }
                if(!myScroller){
                    initScroller();
                }else{
                    myScroller.refresh();
                }
            }
            else{
                $(_pageId+".no_data").show();
                $.alert(data.error_info);
            }
        }
        else{
            $.alert("查询失败");
        }
    }

    function getHtml(element) {
		var price_digit = 3;
		var css = "";
		var entrust_name = "";
		if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
			entrust_name = element.entrust_name;
		}
		if(element.entrust_bs == "0"){
			css = "tag n1";
			entrust_name ="买";
		}else if(element.entrust_bs == "1"){
			css = "tag n2";
			entrust_name ="卖";
		}
        var eleHtml = "";
		eleHtml+="<div class=\"part\">";
		eleHtml+="<div class=\"title\"><span class=\""+css+"\">"+entrust_name+"</span><h5><em>"+element.stock_name+"</em><small>"+element.stock_code+"</small></h5></div>";
       	eleHtml+="<ul>";
       	eleHtml+="<li>成交数量 <span>"+element.business_amount+"</span></li>";
       	eleHtml+="<li>发生金额 <span>"+element.business_balance+"</span></li>";
       	eleHtml+="<li>清算金额 <span>"+element.clear_balance+"</span></li>";
       	eleHtml+="<li>佣金<span>"+element.fare0+"</span></li>";
       	eleHtml+="<li>印花税 <span>"+element.fare1+"</span></li>";
       	eleHtml+="<li>过户费<span>"+element.fare2+"</span></li>";
       	eleHtml+="<li>其他费<span>"+element.other+"</span></li>";
       	eleHtml+="<li>币种 <span>"+element.money_type+"</span></li>";
       	eleHtml+="<li>交易市场 <span>"+element.exchange_type_name+"</span></li>";
       	eleHtml+="<li>交易日期 <span>"+element.init_date+"</span></li>";// class='full'
       	eleHtml+="</ul>";
       	eleHtml+="</div>";
        return eleHtml;
	}
    
    /**
     * 初始化滑动组件
     */
    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId+".header").height()- $(_pageId+".date_filter").height(), // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: false, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
            	ggtBillChecking();
            	//埋点
            	common.comStat(100976,2,102,true,{"i_direct":"1","i_type":"1"});
            },
            pullUpHandler: function(){
            }
        };
        if(!myScroller)
        {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }

	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
        if(myScroller)
        {
            myScroller.destroy();
            myScroller = null;
        }
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
	};
	module.exports = base;
});