/**
 * K线
 */
define("trade/scripts/hq/chart/minLines.js", function(require, exports, module) {
	var canvasJs = require("canvasJs");
	var hqCommon = require("hqCommon");
	var commonHq = require("commonHq");
	var commonTimer = require("commonTimer");
	var serviceHq = require("chartservice_hq");
	var gconfig = $.config;
	var global = gconfig.global;
	//	var _pageId = null; // 当前页面的pageId

	var parStockList = []; // 行情图股票入参
	var canvasLineResults = { // canvas画图数据结果集
		"min": [], // 分时结果集
		"five": [], // 五日结果集
		"nMinute": [], //分钟K线结果集
		"day": {
			"0": [],
			"1": [],
			"2": []
		}, // 日K结果集
		"week": {
			"0": [],
			"1": [],
			"2": []
		}, // 周K结果集
		"month": {
			"0": [],
			"1": [],
			"2": []
		} // 月K结果集
	};
	var targetResults = {
		"day": [], // 指标日K结果集
		"week": [], // 指标周K结果集
		"month": [] //指标 月K结果集
	};
	var canvasType = "min"; // 当前选中行情图的type 与id对应
	var targetType = 0; // K线指标类型 默认0(成交量)-VOL 1-MACD 2-BOLL 3-KDJ
	var historyLoadCount = 0; // 历史加载K线数量 即屏幕上最后一个点到今天之间的数据点个数
	var userInfo = null;
	var stockIndex = null; //股票信息 股票代码
	var stockInfo = null; // 进入当前股票详情页面所携带的信息
	var stockCode = null;
	var updateState = true;
	var isShowMsg = {
		"isShowWait": false,
		"isAsync": true
	}; // 控制页面自动刷新时不显示等代层

	function minLineFunc(_pageId, _divId, stockIndex, width, height, callback) { //_pageId:页面id   _divId:图表id  stockIndex: 市场:代码  如: SZ:000001
		getStockNowPrice(_pageId, _divId, stockIndex, width, height, callback); //获取股票基本信息
	}

	function frameFunc(_pageId, _divId, width, height) {
		var eleStr = "<div class=\"graph_box clearfix\">\
							<div class=\"graph_img\">\
								<div class=\"stock_chart\" style=\"height: 100%;position: relative;\">\
									<div class=\"canvas\" id=\"frame\"><canvas></canvas></div>\
									<div class=\"canvas\" id=\"crux\" style=\"display: none;\"><canvas></canvas></div>\
									<div class=\"line\" id=\"min\" style=\"position: absolute;top: 0;\">\
										<canvas></canvas>\
									</div>\
								</div>\
							</div>\
						</div>";

		$(_divId).html(eleStr); //添加页面结构
		$(_divId).find(".graph_box").css("height", height);
		$(_divId).find(".graph_box .graph_img").css("height", height);
		$(_divId).find(".graph_box").css("width", width);

		if (canvasType == "day" || canvasType == "week" || canvasType == "month") {
			$(_divId + "#k_btn").show().siblings(".chart_btn").hide();
		} else {
			$(_divId + ".chart_btn").hide();
		}
		canvasJs.frameFunc(_pageId, width, height); // 构建canvas画图架子
	}


	function getHqMinKLine(stockIndex, _pageId, call) { // 分时、五日、K线数据查询
		if (parStockList.length > 1) window.saleShowState = false; //叠加状态点击买卖点无效
		if (!stockInfo) return;
		var param = {
			"stock_code": stockIndex.split(":")[1],
			"market": stockIndex.split(":")[0]
		};
		if (canvasType == "min") { // 分时、五日行情
			param.stock_list = stockIndex;
			param.start = 0;
			param.dayitem = 1;
//			param.field = "2:5:10:8:11:12:13:7";
			param.field = "1:7:2:5:10:8";
			var callback = function(data) {
				getStackHqFiveLineCallBack(canvasType, data, call);
			}
			serviceHq.getHqMinLine2(param, callback, isShowMsg);
		}
	}

	function getHqNKMinLineCallBack(type, data) { // 分钟K线的回调函数
		//		hqCommon.refreshFunc(_pageId);
		//		data = hqCommon.resultsVoFunc(data);
		if (data) {
			if (data.errorNo == 0) {
				if (data.results && data.results.length > 0) { // 存在K线数据
					canvasLineResults[type][0] = []; // 清空数据
					stockInfo[type] = data.same; // 将是否是一条数据的判断值保存起来
					for (var i = data.results.length - 1; i >= 0; i--) {
						var stock = data.results[i];
						var kLineJson = {
							"date": stock[0], // 日期
							"minutes": stock[1], // 分钟数
							"open": stock[2], // 开盘价
							"close": stock[3], // 收盘价
							"high": stock[4], // 最高价
							"low": stock[5], // 最低价
							"uppercent": (stock[3] - stock[6]) / stock[6], // 涨跌幅
							"up": stock[3] - stock[6], // 涨跌
							"zf": (stock[4] - stock[5]) / stock[6], // 振幅
							"preClose": stock[6], // 昨收
							"volume": stock[7], // 成交量
							"amount": stock[8], // 成交额
							"ma5": stock[11], // ma5
							"ma10": stock[12], // ma10
							"ma20": stock[13], // ma20
							"ma60": stock[14] // ma60
						};
						canvasLineResults[type][0].unshift(kLineJson);
					}
				}
				canvasJs.KLineFunc(canvasLineResults[type], stockInfo, type, targetType, 0); // 根据数据画K线图
			} else {
				layerUtils.dialog(0, data.errorInfo, 1);
			}
		}
	}

	function getTargetResultsCallBack(type, data) { // K线指标接口回调
		//		data = hqCommon.resultsVoFunc(data);
		if (data) {
			if (data.errorNo == 0) {
				targetResults[type] = data.results;
				if (global.targetType != 0) { // 成交量画图过滤
					canvasJs.drawTargetKLineFunc(canvasType, global.targetType, targetResults[type]);
				}
			} else {
				layerUtils.iAlert(data.error_info);
			}
		}
	}

	function getStackHqKMinLineCallBack(type, data, isLastCount) { // K线的回调函数
		//		hqCommon.refreshFunc(_pageId);
		//		data = hqCommon.resultsVoFunc(data);
		if (data) {
			if (data.errorNo == 0) {
				if (data.results && data.results.length > 0) { // 存在K线数据
					stockInfo[type] = data.same; // 将是否是一条数据的判断值保存起来
					function typeAccuracy(type, value) { // 根据股票类型和type[1-价格 2-量额]判断value的精度换算
						return value;
					}

					if (!canvasLineResults[type][global.rehabilitation][0]) canvasLineResults[type][global.rehabilitation][0] = []; // 单只股票的容器
					for (var j = data.results.length - 1; j >= 0; j--) { // 单只股票的数据
						var stock = data.results[j];
						var arr = canvasLineResults[type][global.rehabilitation][0];
						if (isLastCount && arr.length > 0) arr.pop();
						if (arr && arr.length > 0 && arr[arr.length - 1].date >= stock[0] && arr[0].date <= stock[0] && stock[0] != 0) {
							continue;
						}
						//							if(global.rehabilitation == "0"){//不复权
						var kLineJson = {
							"date": stock[0], // 日期
							"open": typeAccuracy(1, stock[1]), // 开盘价
							"high": typeAccuracy(1, stock[2]), // 最高价
							"close": typeAccuracy(1, stock[3]), // 收盘价
							"low": typeAccuracy(1, stock[4]), // 最低价
							//									"uppercent" : stock[9], // 涨跌幅
							//									"up" : stock[8], // 涨跌
							//									"zf" : (stock[2] - stock[4]) / stock[5], // 振幅
							//									"preClose" : typeAccuracy(1, stock[5]), // 昨收
							"volume": typeAccuracy(2, stock[5]), // 成交量
							"amount": typeAccuracy(2, stock[6]), // 成交额
							"ma5": typeAccuracy(1, stock[7]), // ma5
							"ma10": typeAccuracy(1, stock[8]), // ma10
							"ma20": typeAccuracy(1, stock[9]), // ma20
							"ma60": typeAccuracy(1, stock[10]) // ma60
						};
						//							}else{
						//								var kLineJson = {
						//									"date" : stock[0], // 日期
						//									"open" : typeAccuracy(1, stock[1]), // 开盘价
						//									"high" : typeAccuracy(1, stock[3]), // 最高价
						//									"close" : typeAccuracy(1, stock[2]), // 收盘价
						//									"low" : typeAccuracy(1, stock[4]), // 最低价
						//									"uppercent" : (stock[2] - stock[5]) / stock[5], // 涨跌幅
						//									"up" : typeAccuracy(1, stock[2] - stock[5]), // 涨跌
						//									"zf" : (stock[3] - stock[4]) / stock[5], // 振幅
						//									"preClose" : typeAccuracy(1, stock[5]), // 昨收
						//									"volume" : typeAccuracy(2, stock[6]), // 成交量
						//									"amount" : typeAccuracy(2, stock[7]), // 成交额
						//									"ma5" : typeAccuracy(1, stock[8]), // ma5
						//									"ma10" : typeAccuracy(1, stock[9]), // ma10
						//									"ma20" : typeAccuracy(1, stock[10]), // ma20
						//									"ma60" : typeAccuracy(1, stock[12]) // ma60
						//								};
						//							}
						if (isLastCount) {
							canvasLineResults[type][global.rehabilitation][0].push(kLineJson);
						} else {
							canvasLineResults[type][global.rehabilitation][0].unshift(kLineJson);
						}
					}
					canvasJs.KLineFunc(canvasLineResults[type][global.rehabilitation], stockInfo, type, global.targetType, historyLoadCount); // 根据数据画K线图

				}
				if (targetResults[type].length != 0 && global.targetType != 0) { // 成交量画图过滤
					canvasJs.drawTargetKLineFunc(type, global.targetType, targetResults[type]);
				}
				//				canvasJs.KLineFunc(canvasLineResults[type], stockInfo, type, targetType); // 根据数据画K线图
			} else {
				layerUtils.iAlert(data.error_info);
			}
		}
	}

	function getStackHqFiveLineCallBack(type, data, callback) { // 分时五日行情数据的回调函数
		//		hqCommon.refreshFunc(_pageId);
		//		data = hqCommon.resultsVoFunc(data);
		if (data) {
			if (data.errorNo == 0) {
				if (data.results) {
					if (callback && data.results.length > 0) {
						callback(data.results[data.results.length - 1]);
					}
					canvasLineResults[type]["0"] = []; // 单只股票的容器
                    var arrayData= data.results[0];
                    var result= arrayData;
					//二进制的行情30089接口跟http的返回数据的格式不一样，下面的图是按照http来画的，所以要转换一下
					if(arrayData && arrayData.length > 0){
						result ={
							"market": arrayData[0],//市场代码
							"code": arrayData[1],//股票代码
							"stockname": arrayData[2],//股票名称
							"stocktype": arrayData[3],//股票类型
							"highprice": arrayData[4],//该段分时区间最高价
							"lowprice": arrayData[5],//该段分时区间最低价
							"allfsdots": arrayData[6] || arrayData["array"] || [],//该只股票总的分时点数
							"array": arrayData[7],//集合
							"count":"" ,//该只股票的分时数据条数
						}
					}
                    if(!result["array"]){
                        result["array"] = [];
                    }
					
					for (var i = 0; i < result["array"].length; i++) {
						var stock = result["array"][i];
						var minFiveJson = {
							"date": stock[0], // 日期
							"prec": stock[1], // 昨收
							"minutes": stock[2], // 分钟数
							"currPrice": stock[3], // 现价
							"averPrice": stock[4], // 均价
							"volume": stock[5], // 成交量
							"allfsdots": result["allfsdots"], // 总点数
						};
						canvasLineResults[type]["0"].push(minFiveJson);
					}
					canvasLineResults[type]["0"].allfsdots = result["allfsdots"];
				}
				canvasJs.minLineFunc(canvasLineResults["min"], stockInfo); // 根据数据画分时图
			}
		}
	}

	function bindEvent(_pageId, stockIndex) {
		$.preBindEvent($(_pageId + ".price_box "), "em", function(e) {
			var stockIndex = $(this).attr("stockIndex");
			if (stockIndex && parStockList.join("|").indexOf(stockIndex) > -1) { // 点击的是叠加股票并且存在叠加列表参数中
				var index = $.inArray(stockIndex, parStockList);
				$(_pageId + "#minFiveStack span").eq(index).remove();
				$(_pageId + "#kLineStack .price_text").eq(index).remove();
				parStockList.splice(index, 1);
			}
			canvasLineResults = { // canvas画图数据结果集
				"min": [], // 分时结果集
				"five": [], // 五日结果集
				"nMinute": [], //分钟K线结果集
				"day": {
					"0": [
						[]
					],
					"1": [
						[]
					],
					"2": [
						[]
					]
				}, // 日K结果集
				"week": {
					"0": [
						[]
					],
					"1": [
						[]
					],
					"2": [
						[]
					]
				}, // 周K结果集
				"month": {
					"0": [
						[]
					],
					"1": [
						[]
					],
					"2": [
						[]
					]
				} // 月K结果集
			};
			isAutoRefresh = false;
			if (canvasType == "min" || canvasType == "five") {
				parStockList.length > 1 ? $(_pageId + "#minFiveStack").show().siblings(".price_box").hide() : $(_pageId + "#m_price_box").show().siblings(".price_box").hide();
			} else if (canvasType == "day" || canvasType == "week" || canvasType == "month") {
				parStockList.length > 1 ? $(_pageId + "#kLineStack").show().siblings(".price_box").hide() : $(_pageId + "#k_price_box").show().siblings(".price_box").hide();
			}
			getHqMinKLine(stockIndex);
			e.stopPropagation();
		}, "click");

		$.preBindEvent($(_pageId + ".pellucidity .drop_result "), "a", function(e) {
			if ($(this).attr("class") != "more") {
				var info = newQuerySearchResults["2"][$(this).index()];
				if (info) {
					if (stockInfo.stockType == 98 || stockInfo.stockType == 99) {
						if (!(info.stockType == 98 || info.stockType == 99)) {
							layerUtils.dialog(0, "该类型不允许叠加", 1);
							return false;
						}
					} else {
						if (info.stockType == 98 || info.stockType == 99) {
							layerUtils.dialog(0, "该类型不允许叠加", 1);
							return false;
						}
					}
				}
				var stockIndex = $(this).attr("stockIndex");
				if (parStockList.length > 3) {
					layerUtils.dialog(0, "超过叠加的最大品种数", 1);
					return false;
				}
				if (parStockList.join("|").indexOf(stockIndex) < 0) {
					parStockList.push(stockIndex);
				} else {
					layerUtils.dialog(0, $(this).find("span").text() + "已经存在该品种", 1);
					return false
				}
				var minHtml = "<span><em class=\"icon_bank2\" stockIndex=" + stockIndex + "></em>" + $(this).find("span").text() + "  <i>--</i></span>"
				var kHtml = "<div class=\"price_text clearfix\"><span class=\"right_span\">时间：<i>--</i></span>";
				kHtml += "<p><span><em class=\"icon_bank2\"  stockIndex=" + stockIndex + "></em>" + $(this).find("span").text() + "</span>";
				kHtml += "<span class=\"swidth\">开 <i class=\"read1\">--</i></span><span class=\"swidth\">高 <i>--</i></span>";
				kHtml += "<span class=\"swidth\">低 <i>--</i></span><span class=\"swidth\">收 <i>--</i></span>";
				kHtml += "<span  class=\"swidth\">涨跌幅 <i class=\"read1\">--</i></span><span class=\"swidth\">成交量 <i>--</i></span></p></div>";
				$(_pageId + "#minFiveStack").append(minHtml);
				$(_pageId + "#kLineStack").append(kHtml);
				if (canvasType == "min" || canvasType == "five") {
					$(_pageId + "#minFiveStack").show().siblings(".price_box").hide();
				} else if (canvasType == "day" || canvasType == "week" || canvasType == "month") {
					$(_pageId + "#kLineStack").show().siblings(".price_box").hide();
				}
				isAutoRefresh = false;
				getHqMinKLine(stockIndex); // 获取行情分时K线数据;
				$(_pageId + ".pellucidity").hide();
			}
			e.stopPropagation();
		}, "click");

		//2-个股详情-K线
		$.bindEvent($(_pageId + ".graph_check"), function() {
			$(_pageId + ".btn_graph5 .drop_graph5").toggle();
		}, "click");

		$.bindEvent($(_pageId + ".stock_top_logo"), function() {
			$.redirect("hq/main");
		}, "click");

		// 点击复权
		$.bindEvent($(_pageId + ".chart_btn .btn_graph5 .drop_graph5 a"), function() {
			global.rehabilitation = $(this).attr("queryType");
			$(_pageId + ".chart_btn .btn_graph5 .graph_check").html($(this).text() + "<em></em>");
			$(_pageId + ".btn_graph5 .drop_graph5").hide();
			getHqMinKLine(stockIndex); // 切换获取对应数据画图
		});

		// 点击指标
		$.bindEvent($(_pageId + ".chart_btn .graph_nav1_ul  li"), function() {
			if (!$(this).hasClass("current")) {
				$(this).addClass("current").siblings().removeClass();
				if (!targetResults[canvasType]) return false;
				var type = $(this).attr("id"); // 获取当前选中的行情指标类型
				var targetTypeList = {
					"VOL": 0,
					"MACD": 1,
					"BOLL": 2,
					"KDJ": 3,
					"RSI": 4,
					"BIAS": 5,
					"CR": 6,
					"PSY": 7
				};
				global.targetType = targetTypeList[type];
				canvasJs.drawTargetKLineFunc(canvasType, global.targetType, targetResults[canvasType]);
			}

		});

		// 行情图指标切换
		$.bindEvent($(_pageId + ".graph_nav .graph_ul li a"), function() {
			if ($(this).attr("id") == "sale") {
				var preCanvasType = $(_pageId + ".graph_nav .graph_ul li a.nav_a").attr("id");
				if (preCanvasType == "min" || preCanvasType == "day") {
					window.saleShowState = window.saleShowState ? false : true;
					if (window.saleShowState) global.hqKLineSpace = 7;
					getHqMinKLine(stockIndex);
				}
				return;
			}
			//			$(_pageId + "#crux").css("z-index", "auto");
			canvasType = $(this).attr("id"); // 获取当前选中的行情图指标
			isAutoRefresh = false;
			if (!$(this).hasClass("nav_a") || canvasType == "nMinute") {
				if (canvasType == "nMinute") {
					if ($(_pageId + ".drop_graph_box").css("display") == "none") {
						if (canvasType == "day" || canvasType == "week" || canvasType == "month") {
							$(_pageId + ".s_btn").show();
							$(_pageId + " .index_wrap").show();
						}
						$(_pageId + ".drop_graph_box").show();
					} else {
						$(_pageId + ".drop_graph_box").hide();
					}
					canvasType = $(_pageId + ".graph_nav .graph_ul li a.nav_a").attr("id");
					return;
				} else {
					var jq_nMin = $(_pageId + ".graph_nav .graph_ul li a[id=nMinute]");
					jq_nMin.removeAttr("type");
					jq_nMin.html("分钟");
					$(_pageId + ".drop_graph_box").hide();
				}
				currentCheckIndex = $(this).index();
				if (canvasType == "pk") $(_pageId + "#frame").hide(); // 盘口则隐藏canvas架子框
				else $(_pageId + "#frame").show();
				if (canvasType == "day" || canvasType == "week" || canvasType == "month") {
					$(_pageId + ".btn_graph5").show();
					$(_pageId + "#k_btn").show().siblings(".chart_btn").hide();
					if (parStockList.length > 1) {
						$(_pageId + "#kLineStack").show().siblings(".price_box").hide();
					} else {
						$(_pageId + "#k_price_box").show().siblings(".price_box").hide();
					}
					$(_pageId + "#maBox").show();
				} else {
					if (parStockList.length > 1) {
						$(_pageId + "#minFiveStack").show().siblings(".price_box").hide();
					} else {
						$(_pageId + "#m_price_box").show().siblings(".price_box").hide();
					}
					$(_pageId + "#maBox").hide();
					$(_pageId + ".chart_btn").hide();
				}
				$(_pageId + ".graph_nav .graph_ul li a").removeClass("nav_a");
				$(this).addClass("nav_a");
				$(_pageId + ".stock_chart .line[id=" + canvasType + "]").show().siblings(".line").hide(); // 跳至指定页
				$(_pageId + ".header .icon_refresh").addClass("request"); // 增加刷新转动效果
				//				isShowMsg = {"isShowWait" : true};
				getHqMinKLine(stockIndex); // 切换获取对应数据画图
			}
		});
		//分钟滑动显示
		$.bindEvent($(_pageId + ".graph_nav .graph_ul li "), function() {
			if ($(this).find("a").attr("id") == "nMinute") {
				$(_pageId + ".drop_graph_box").show();
			} else {
				$(_pageId + ".drop_graph_box").hide();
			}

		}, "mouseover");
		$.bindEvent($(_pageId + ".drop_graph_box"), function() {
			$(_pageId + ".drop_graph_box").hide();
		}, "mouseout");

		// 分钟线切换
		$.bindEvent($(_pageId + ".drop_graph_box a"), function(e) {
			e.stopPropagation();
			var jq_nMin = $(_pageId + ".graph_nav .graph_ul li a[id=nMinute]")
			jq_nMin.attr("type", $(this).attr("id"));
			jq_nMin.html($(this).html());
			$(_pageId + ".graph_nav .graph_ul li a").removeClass("nav_a")
			jq_nMin.addClass("nav_a");
			currentCheckIndex = jq_nMin.parents("li").index();
			$(this).parent().hide();
			canvasType = jq_nMin.attr("id"); // 获取当前选中的行情图指标	
			$(_pageId + "#k_price_box").show().siblings(".price_box").hide();
			$(_pageId + "#maBox").show();
			$(_pageId + ".btn_graph5").hide(); //分钟隐藏复权

			$(_pageId + ".stock_chart .line").eq(currentCheckIndex).show().siblings(".line").hide();
			//			myHIscroll ? myHIscroll.scrollToPage(currentCheckIndex) : ""; // 跳至指定页
			$(_pageId + ".header .icon_refresh").addClass("request"); // 增加刷新转动效果
			getHqMinKLine(stockIndex); // 切换获取对应数据画图
		});


		$.bindEvent($(_pageId + "#crux"), function(e) {
			var offsetLeft = $(this).parents(".stock_chart").offset().left;
			var offsetTop = $(this).parents(".stock_chart").offset().top;
			var clientX = e["clientX"] - offsetLeft - parseFloat($(this).css("left"));
			var clientY = e["clientY"] - offsetTop - parseFloat($(this).css("top"));
			var results = [];
			if ("day,week,month".indexOf(canvasType) > -1) {
				results = canvasLineResults[canvasType][global.rehabilitation];
			} else {
				results = canvasLineResults[canvasType];
			}
			var moveCallBakc = function(stockInfoList) {
				var point = hqCommon.typePoint(stockInfo.stockType); // 股票类型判断位数
				if (parStockList.length > 1 && canvasType != "nMinute") {
					for (var i = 0; i < stockInfoList.length; i++) {
						var data = stockInfoList[i];
						if ("min,five".indexOf(canvasType) > -1) {
							$(_pageId + "#minFiveStack span").eq(i).find("i").text(hqCommon.judgeColorValue(1, ((data.currPrice.toFixed(point) / data.prec.toFixed(point) - 1) * 100).toFixed(2)) + "%").removeClass().addClass(hqCommon.judgeColorValue(2, (data.currPrice / data.prec - 1))); //涨跌幅 
						} else {
							var sWidth = 0;
							$(_pageId + "#kLineStack .price_text").each(function() {
								var _self = this;
								$(_self).find("span").slice(2).each(function() {
									sWidth = Math.max($(this).text().length * 7, sWidth)
								})
							})

							var tWidth = $("#kLineStack .price_text").last().find("span:eq(2)").width();
							if (tWidth < sWidth) {
								$(_pageId + "#kLineStack .swidth").width(sWidth);
							}
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(0)").find("i").text(data.date); //时间
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(2)").find("i").text(data.open.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.open - data.preClose)); //今开
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(3)").find("i").text(data.high.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.high - data.preClose)); //最高
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(4)").find("i").text(data.low.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.low - data.preClose)); //最低
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(5)").find("i").text(data.preClose.toFixed(point)); //昨收
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(6)").find("i").text(hqCommon.judgeColorValue(1, (data.uppercent * 100).toFixed(2)) + "%").removeClass().addClass(hqCommon.judgeColorValue(2, (data.uppercent * 100).toFixed(2))); //涨跌幅
							$(_pageId + "#kLineStack .price_text").eq(i).find("span:eq(7)").find("i").text((data.volume > 10000 ? hqCommon.judgeColorValue(3, data.volume) : data.volume)); //成交量
						}
					}

				} else {

					var data = stockInfoList[0];
					if ("min,five".indexOf(canvasType) > -1) {
						$(_pageId + "#m_price_box span:eq(0)").find("i").text(hqCommon.numberConvertDate(2, data.minutes)); //时间
						$(_pageId + "#m_price_box span:eq(1)").find("i").text(data.currPrice.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.currPrice - stockInfo.prec)); //价格
						$(_pageId + "#m_price_box span:eq(2)").find("i").text(hqCommon.judgeColorValue(1, ((data.currPrice.toFixed(point) / stockInfo.prec.toFixed(point) - 1) * 100).toFixed(2)) + "%").removeClass().addClass(hqCommon.judgeColorValue(2, (data.currPrice / stockInfo.prec - 1))); //涨跌幅 
						$(_pageId + "#m_price_box span:eq(3)").find("i").text((data.volume > 10000 ? hqCommon.judgeColorValue(3, data.volume) : data.volume) + ((stockInfo.market == "HK" || stockInfo.stockType == 99 || stockInfo.stockType == 98) ? "股" : "手")); //成交量 
					} else {
						//						var sWidth = 0;
						//						$(_pageId + "#k_price_box span").slice(1).each(function(){
						//							sWidth = Math.max(($(this).text().gblen() +1) * 5,sWidth)
						//						})
						//						var tWidth = $("#k_price_box span:eq(1)").width();
						//						if(tWidth < sWidth){
						//							$(_pageId + "#k_price_box .swidth").width(sWidth);
						//						}
						$(_pageId + "#k_price_box span:eq(0)").find("i").text(canvasType == "nMinute" ? hqCommon.numberConvertDate(2, data.minutes) : data.date); //时间
						$(_pageId + "#k_price_box span:eq(1)").find("i").text(data.open.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.open - data.preClose)); //今开
						$(_pageId + "#k_price_box span:eq(2)").find("i").text(data.high.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.high - data.preClose)); //最高
						$(_pageId + "#k_price_box span:eq(3)").find("i").text(data.low.toFixed(point)).removeClass().addClass(hqCommon.judgeColorValue(2, data.low - data.preClose)); //最低
						$(_pageId + "#k_price_box span:eq(4)").find("i").text(data.preClose.toFixed(point)); //昨收
						$(_pageId + "#k_price_box span:eq(5)").find("i").text(hqCommon.judgeColorValue(1, (data.uppercent * 100).toFixed(2)) + "%").removeClass().addClass(hqCommon.judgeColorValue(2, (data.uppercent * 100).toFixed(2))); //涨跌幅
						$(_pageId + "#k_price_box span:eq(6)").find("i").text((data.volume > 10000 ? hqCommon.judgeColorValue(3, data.volume) : data.volume) + ((stockInfo.market == "HK" || stockInfo.stockType == 99 || stockInfo.stockType == 98) ? "股" : "手")); //成交量
					}
				}

			}
			canvasJs.moveCruxFunc(clientX, clientY, results, stockInfo, canvasType, targetType, moveCallBakc); // 画移动的十字架
		}, "mousemove");

		$.bindEvent($(_pageId + "#crux"), function() {
			var cruxCanvas = $(_pageId + "#crux canvas")[0];
			if (cruxCanvas) {
				var ctx = cruxCanvas.getContext('2d'); // 获取十字架画布
				ctx.clearRect(0, 0, cruxCanvas.width, cruxCanvas.height); // 清理画布上的内容
			}
		}, "mouseout");

		//		$.bindEvent($(_pageId + ".stock_chart"), function() { // 点击横屏
		//			var param = {
		//					"stockInfo" : JSON.stringify(stockInfo),
		//					"canvasType" : canvasType
		//			};
		//			$.redirect("hq/landscape", param);
		//		});


		$.preBindEvent($(_pageId + ".fund_new .search_nav"), " li", function() {
			if ($(this).attr("id")) {
				var param = {
					"id": $(this).attr("id"), // 详情标识id
					"title": $(this).find("span").html() // 详情title
				};
				$.redirect("hq/infoDetail", param);
			}
		});

		$.bindEvent($(_pageId + "#k_btn #s_btn a"), function(e) { // 缩放功能
			e.stopPropagation();
			var idx = $(this).index();
			if (+idx == 0 || +idx == 1) { //← →
				var count = historyLoadCount;
				var farLeftCount = canvasLineResults[canvasType][global.rehabilitation][0].length - (Math.floor(($(_pageId + "#crux").width() + global.hqKLineSpace) / (global.hqKLineSpace * (global.hqKlineMultiple + 1))));
				historyLoadCount = +idx == 0 ? count + 4 : count - 4;
				historyLoadCount = historyLoadCount > farLeftCount ? farLeftCount : historyLoadCount; // 当滑到最左端继续右滑时屏幕展示的K线会变少
				historyLoadCount = historyLoadCount >= 0 ? historyLoadCount : 0; // 当滑到最右端继续左滑时未负数，需还原0
				canvasJs.KLineFunc(canvasLineResults[canvasType][global.rehabilitation], stockInfo, canvasType, global.targetType, historyLoadCount); // 画历史K线数据的历史加载数据
				if (global.targetType != 0) { // 拖动加载历史数据时，也需要画历史指标
					canvasJs.drawTargetKLineFunc(canvasType, global.targetType, targetResults[canvasType]);
				}
				if (historyLoadCount >= farLeftCount) {
					isAutoRefresh = false;
				}
			} else if (+idx == 2) { // 放大
				global.hqKLineSpace += 0.5;
				global.hqKLineSpace = (global.hqKLineSpace >= 7 ? 7 : global.hqKLineSpace);
			} else if (+idx == 3) { // 缩小
				global.hqKLineSpace -= 0.5;
				global.hqKLineSpace = (global.hqKLineSpace <= 0 ? 0.5 : global.hqKLineSpace);
			}
			//			canvasJs.clearCanvasFunc(); // 离开页面时清理画布上面画的数据图，避免下次换股票进入时页面上还是显示上一只股票的股票图
			//			canvasJs.frameFunc(); // 构建canvas画图架子
			getHqMinKLine(stockIndex); // 获取行情分时K线数据
		});

		$.bindEvent($(_pageId + ".graph_nav .graph_more .btn_breed"), function(e) { // 叠加品种
			e.stopPropagation();
			$(this).hide();
			$(_pageId + ".pellucidity").show();
		});
		$.bindEvent($(_pageId + ".graph_nav .graph_more .btn_more"), function(e) { // 叠加品种关闭按钮
			$(this).siblings(".btn_breed").toggle();
		}, "click");
		$.bindEvent($(_pageId + ".pellucidity .icon_close"), function(e) { // 叠加品种关闭按钮
			e.stopPropagation();
			$(_pageId + ".pellucidity").hide();
		});

		$.bindEvent($(_pageId + ".btn_add"), function() { // 自选股的添加删除
			if (isZxgState) { //删除
				hqCommon.isTradeLogin(2, null, function(data) {
					var stocks = data.split("|");
					var stkStr = "";
					for (var i = 0; i < stocks.length; i++) {
						if (stocks[i] == stockItem) continue;
						stkStr += "|" + stocks[i];
					}
					hqCommon.isTradeLogin(1, stkStr);
					isZxgState = false;
					$(_pageId + ".btn_add").html("添加自选");
				});
			} else { //添加
				hqCommon.isTradeLogin(2, null, function(data) {
					hqCommon.isTradeLogin(1, data ? (data + "|" + stockItem) : stockItem);
					isZxgState = true;
					$(_pageId + ".btn_add").html("删除自选");
				});
			}
		}, "click");
	}

	//股票基本信息
	function getStockNowPrice(_pageId, _divId, stockIndex, width, height, callback) {
		var param = {
			"stock_list": stockIndex,
			"field": "24:22:2:3:1:6:19:18:8:9:10:11:32:31:27:13:12:45:46:56:21:23:148"
		};
		var ctlParam = { //控制参数
			"isLastReq": true,
			"isShowWait": false,
			"isAsync": true
		};
		serviceHq.getStockNowPrice(param, function(data) {
			if (data) {
				if (data.errorNo == 0) {
					var result = data.results[0];
					var stockInfos = {
						"stockCode": result[0], //股票代码
						"stockName": result[1], //股票名称
						"now": result[2].toFixed(3), //现价
						"up": result[3].toFixed(3), //涨跌
						"uppercent": (result[4] * 100).toFixed(2) + "%", //涨幅
						"total": result[5], //总量
						"outside": result[6], //外盘
						"inside": result[7], //内盘
						"hsl": (result[8] * 100).toFixed(2) + "%", //换手
						"open": result[9].toFixed(3), //今开
						"high": result[10].toFixed(3), //最高
						"low": result[11].toFixed(3), //最低
						"mgjz": result[12], //每股净资
						"zsz": result[13], //总市值
						"ltsz": result[14], //流通市值
						"syl": result[15], //市盈率
						"yesClose": result[16].toFixed(3), //昨收
						"prec": Number(result[16].toFixed(3)), //昨收
						"ztj": result[17].toFixed(3), //涨停价
						"dtj": result[18].toFixed(3), //跌停价
						"dateTime": result[19], //行情源日期及时间
						"stockType": result[20], //股票类型
						"market": result[21], //股票市场
						"secondStockType": result[22] // 二级分类
					};
					stockInfo = stockInfos;

					frameFunc(_pageId + " ", _divId + " ", width, height); //构建画图框架
					getHqMinKLine(stockIndex, _pageId, callback); // 分时、五日、K线数据查询
					commonTimer.clearTimer(_pageId + "_minLines");
					commonTimer.setTimer(_pageId + "_minLines", function() {
						if (commonHq.getTradingTime()) {
							getHqMinKLine(stockIndex, _pageId, callback); // 分时、五日、K线数据查询
						}
					}, (global.refreshTime || 5000));
					bindEvent(_divId + " ", stockIndex); //事件绑定
				} else {

				}
			}
		}, ctlParam);
	}


	function clearCanvasFunc(_pageId) { //_pageId：页面id
		commonTimer.clearTimer(_pageId + "_minLines");
		canvasLineResults = { // canvas画图数据结果集
			"min": [], // 分时结果集
			"five": [], // 五日结果集
			"nMinute": [], //分钟K线结果集
			"day": {
				"0": [],
				"1": [],
				"2": []
			}, // 日K结果集
			"week": {
				"0": [],
				"1": [],
				"2": []
			}, // 周K结果集
			"month": {
				"0": [],
				"1": [],
				"2": []
			} // 月K结果集
		};
		targetResults = {
			"day": [], // 指标日K结果集
			"week": [], // 指标周K结果集
			"month": [] //指标 月K结果集
		};
		canvasType = "min"; // 当前选中行情图的type 与id对应
		targetType = 0; // K线指标类型 默认0(成交量)-VOL 1-MACD 2-BOLL 3-KDJ
		$(_pageId + ".price_box i").html("--");
		canvasJs.clearCanvasFunc();
		//		canvasJs.frameFunc(_pageId); // 构建canvas画图架子
	}

	var canvas = {
		"minLineFunc": minLineFunc, // 画分时图方法
		"frameFunc": frameFunc,
		//			"fiveLineFunc" : fiveLineFunc, // 画五日图方法
		//			"KLineFunc" : KLineFunc, // 画K线图方法
		//			"drawTargetKLineFunc" : drawTargetKLineFunc, // 画K线指标图方法
		//			"moveCruxFunc" : moveCruxFunc, // 移动十字架方法
		//			"flowsDetailFunc" : flowsDetailFunc, // 资金明细方法
		"clearCanvasFunc": clearCanvasFunc // 清理画布上面画的某只股票的行情图
	};
	module.exports = canvas;
});
