/**
 * 公共撤单页面的写法
 */
define('trade/scripts/kcb/com/publicKcbCancel.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var publicService = require("service_common");
	var downslide = new (require("downslide")).Downslide();
	var pagingNum = global.pagingNum;
	var userInfo = null;
    var _pageId = "";
    var queryFuncNo = "";
    var queryParam = {};
    
    var cancelFuncNo = "";
    var cancelParam = {};
    
    var slideHeight = null;
    var kcb_cancel_order = null;
    var _data = {};
	var dataResults = null;
	var intResults = 0;
	var interfaceNum = 0;
	var interfaceData = {};
	var statParam = [];
	var promptBoxFun = null;
	
	var extraConfig = null; // 解耦和重用，有时候有点矛盾
	var optionSetting = null;
	var _module=null;//当前模块
	/**
     * 初始化
     */
	function init(data, pageId){
		userInfo = common.getCurUserInfo();
		_module=data.cancellModule;
		queryFuncNo = data.queryFuncNo;
		queryParam = data.queryParam || {};
		_data = data.htmlData;
		cancelFuncNo = data.cancelFuncNo;
		cancelParam = data.cancelParam;
		statParam = data.statParam;
		promptBoxFun = data.promptBoxFun;
		if(pageId){
			_pageId = pageId;			
		}
		else{
			_pageId = "#"+$.getCurrentPageObj().pageId + " ";
		}
		downslide.addSlide();
		kcb_cancel_order = $(_pageId+" .kcb_cancel_order");
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(_extraConfig){
		slideHeight = common.setMainHeight(_pageId, false) - ($(_pageId + " .tab_nav").outerHeight(true) || 0) - ($(_pageId + " .toggle_nav").outerHeight(true) || 0) - ($(_pageId + " .date_filter").outerHeight(true) || 0) - ($(_pageId + " .main_footer").height() || 0);
		extraConfig = _extraConfig;
		if(extraConfig && extraConfig.optionSetting) { //期权设置
			optionSetting = extraConfig.optionSetting.getOptionSetting();
			if(+optionSetting.ignoreConfirm && !optionSetting.ignoreConfirmToptip) { //不要下单时的提示
				$(_pageId + ".prompbar").show();
				slideHeight = slideHeight - $(_pageId + ".prompbar").height();
			}else{
				$(_pageId + ".prompbar").hide();
			}
		}
		downslide.slideInit(slideHeight,backgroundInterface,pullQuery);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		interfaceNum = 0;
		interfaceData = {};
		kcb_cancel_order.html("");
		kcb_cancel_order.attr("style","");
		callsQuery();
	}
	
	function pullQuery(){
		if(pagingNum != 0){
			if($.isValue(dataResults)){
				callsUpHandler();
			}
			else{
				var position_str = kcb_cancel_order.find(".part").last().attr("position_str");
				callsQuery({"position_str":position_str});
			}
		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		if(extraConfig && extraConfig.optionSetting) { //期权设置
			//关闭小喇叭
			$.bindEvent($(_pageId+" .prompbar a"), function(e){
				slideHeight = slideHeight + $(_pageId + ".prompbar").height();
				$(_pageId + ".prompbar").hide();
				optionSetting.ignoreConfirmToptip = 1;
				extraConfig.optionSetting.setOptionSetting(optionSetting);
				downslide.slideRefresh();
				kcb_cancel_order && kcb_cancel_order.height(slideHeight);
				$(_pageId + "#pull_down_slide").height(slideHeight);
				e.stopPropagation();
			});
		}
	}
	
	/**
	 * 委托查询
	 */
	function callsQuery(para_map){
		var param = $.cloneFun(queryParam);
		param.funcNo = queryFuncNo;
		param.position_str = "";
		param.request_num = pagingNum || "";
		if($.isValue(para_map)){
			for(t in para_map){
				param[t] = para_map[t];
			}
		}
		$.clearRequest();
		publicService.kcbQueryCommon($.cloneFun(param),queryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 超时调用方法
				$(_pageId + " .main_footer").hide();
				downslide.slideRefresh();
				downslide.loadFinished();
				showNoData();
	        },
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId + " .main_footer").hide();
				downslide.slideRefresh();
				downslide.loadFinished();
				showNoData();
	        }
		});
	}
	
	function showNoData(){
		if(kcb_cancel_order && kcb_cancel_order.find(".part").length == 0){
			common.setNoData(true,"暂无可撤单记录").height(slideHeight);
			$(_pageId+"footer.cancelFooter").hide();
			downslide.hidePullUp();
		}
	}
	
	/**
	 * 委托查询回调
	 */
	function queryCallback(data){
		dataResults = null;
		intResults = 0;
		if(data){
			if(data.error_no == 0){
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var html = [];
					var i = 0;
					var r = results.length;
					if(r > pagingNum && pagingNum != 0){
						for (; i < r && i < pagingNum; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							 html.push(queryEntrustHTML(results[i]));
						}
						dataResults = results;
						intResults = i;
					}
					else{
						for (; i < r; i++){
							if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
							html.push(queryEntrustHTML(results[i]));
						}
						dataResults = null;
						intResults = 0;
					}
					if(r < pagingNum){
						downslide.loadFinished();
					}
					kcb_cancel_order.append(html.join(""));
					$(_pageId + " .main_footer").show().css({"visibility":"visible"});
					if(kcb_cancel_order.height() <= slideHeight){
						kcb_cancel_order.height(slideHeight);
					}
					else{
						kcb_cancel_order.attr("style","");
					}
					bindEvent();
					common.setNoData(false);
					downslide.slideRefresh();
				}else{
					$(_pageId + " .main_footer").hide();
					downslide.slideRefresh();
					downslide.loadFinished();
					showNoData();
				}
			}
			else{
				$.alert(data.error_info);
				downslide.slideRefresh();
			}
		}
	}
	
	
	    
    function callsUpHandler(){
		var results = dataResults;
		var t = results.length;
		var i = intResults;
		if(results && t > 0 && i < t){
			var html = [];
			for (;i < t && i < (intResults + pagingNum); i++){
				if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
				 html.push(queryEntrustHTML(results[i]));
			}
			intResults = i;
			kcb_cancel_order.append(html.join(""));
			if(kcb_cancel_order.height() <= slideHeight){ // 这里这么做应该是为了在页面数据区域及以下都能下拉，必要性不高
				kcb_cancel_order.height(slideHeight);
			}
			else{
				kcb_cancel_order.attr("style","");
			}
			bindEvent();
		}
		downslide.slideRefresh();
		if(intResults == t){
			downslide.loadFinished();
		}
	}
	
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var eleHtml = [];
		interfaceNum++;
    	interfaceData[""+interfaceNum] = element;
		var top = _data.topDiv;
      	eleHtml.push("<div class=\"part\" data-id=\""+interfaceNum+"\" position_str=\""+element.position_str+"\">");
      	if($.isValue(top)){
      		var css = "";
      		if(top.css){
      			if(typeof(top.css) == "function"){
      				css = top.css(element);
      			}
      			else{
      				css = top.css;
      			}
      		}
      		else{
      			if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1 || $.inArray(element.business_flag, ["20","17"]) != -1){
      				css = "n1";
      			}else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1 || $.inArray(element.business_flag, ["21","28"]) != -1){
      				css = "n2";
      			}
      		}
      		if(top.isEnableMultiSelect){ //撤单多选
	        	eleHtml.push("<div class=\"title\" style=\"padding-left: 0.3rem\">");
	        	eleHtml.push("<i></i>");
	        }else{
	        	eleHtml.push("<div class=\"title\">");
	        }
	        if(top.entrust){
		        eleHtml.push("<span class=\"tag "+css+"\">"+pjcs2(element,top.entrust)+"</span>");
	        }
			eleHtml.push("<strong style='font-size:" + $.getTransformScaleFontSize(pjcs2(element,top.name), 16, $(window).width() * 0.4) + "px;'>"+pjcs2(element,top.name)+"</strong><small>"+pjcs2(element,top.code)+"</small>");
	        eleHtml.push("<a href='javascript:void(0);' class='remove_btn'>撤单</a>");
			eleHtml.push("</div>");
      	}
      	
      	if((_module=="credit" ||_module=="ggt")&&top.isEnableMultiSelect){
        	eleHtml.push("<ul style='padding-left: 0.32rem;'>");
      	}else{
        	eleHtml.push("<ul>");
      	}
      	
        var list = _data.liList;
        for(var i = 0; i < list.length; i++){
        	var btnHtml="";
        	if((_module=="credit"||_module=="ggt")&&list[i][2]&&interfaceNum==1){
        		btnHtml="<i></i>"
        	}
	    	eleHtml.push("<li><span>"+btnHtml+""+pjcs0(element,list[i][0])+" </span><p>"+pjcs1(element,list[i][1])+"</p></li>");
        }
        eleHtml.push("</ul></div>");
		return eleHtml.join("");
	}
	
	/**
	 * 拼接数据 数组0位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs0(element, text){
		return typeof(text) == "function" ? text(element) : text;
	}
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs1(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
		if(value == ""){
			value = "--";
		}
		return value;
	}
	/**
	 * 拼接数据 数组1位的
	 * @param {Object} element
	 * @param {Object} text
	 */
	function pjcs2(element, text){
		var value = "";
		if(text && typeof(text) == "string"){
			value = element[text] || "";
		}
		else if(text && typeof(text) == "function"){
			value = text(element);
		}
//		if(value == ""){
//			value = "--";
//		}
		return value;
	}
	
	/**
	 * 绑定撤单事件
	 */
	function bindEvent(){
		$.bindEvent($(_pageId+".kcb_cancel_order .part a.remove_btn"), function(e){
			var $this = $(this).parents("div.part");
			var id = $this.attr("data-id");
			var element = interfaceData[id];
			var tipStr = _data.tipStr;
			var tipStrArray = [];
	      	if($.isValue(tipStr)){
		      	for(var i = 0; i < tipStr.length; i++){
					tipStrArray.push([pjcs0(element,tipStr[i][0]), pjcs2(element,tipStr[i][1])]);
		      	}
	      	}
	      	var cancelFunc = function(){
				var cancel = _data.cancel;
				var page = {};
				if($.isValue(cancel)){
			      	for(var i = 0; i < cancel.length; i++){
			      		var name = cancel[i][0];
			      		page[""+name] = pjcs2(element,cancel[i][1]);
			      	}
		      	}
				cancellation(page); // 确认撤单
			}
			var tipStr = "<div ><p class=\"user_msg\">"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
			tipStr += common.generatePrompt(tipStrArray);
			tipStr += "</div>";
			var btnName=null;
			if(promptBoxFun){
				if(_module=="credit"){
					var buyEntrust=["0","62","64","66","68","70","4"];
					var sellEntrust=["1","63","65","67","69","71","5"];
					if(buyEntrust.indexOf(element.entrust_bs)!=-1 && (element.entrust_type=="0"||element.entrust_type=="9")){
						btnName="撤单后继续普通买入";
					}
					else if(sellEntrust.indexOf(element.entrust_bs)!=-1 && (element.entrust_type=="0"||element.entrust_type=="9")){
						btnName="撤单后继续普通卖出";
					}
					else if(buyEntrust.indexOf(element.entrust_bs)!=-1 && element.entrust_type=="6"){
						btnName="撤单后继续融资买入";
					}
					else if(sellEntrust.indexOf(element.entrust_bs)!=-1 && element.entrust_type=="7"){
						btnName="撤单后继续融券卖出";
					}
				}
				if(_module=="ggt"){
					btnName="撤单后继续买入";
					if(element.entrust_bs == "0"&&element.entrust_type=="0"){
						btnName="撤单后继续买入";
					}
					else if(element.entrust_bs == "1"&&element.entrust_name=="卖出"){
						btnName="撤单后继续卖出";
					}
					else if(element.entrust_bs == "1"&&element.entrust_name=="零股卖出"){
						btnName="撤单后继续零股卖出";
					}
				}
				if(_module=="stock"){
					var buyEntrust=["0","62","64","66","68","70","4"];
					var sellEntrust=["1","63","65","67","69","71","5"];
					if(buyEntrust.indexOf(element.entrust_bs)!=-1){
						btnName="撤单后继续买入";
					}
					else if(sellEntrust.indexOf(element.entrust_bs)!=-1){
						btnName="撤单后继续卖出";
					}
				}
			}
			//支持重买重买的属性
			if(promptBoxFun && btnName){ // 搜索了下，这个还没position用到
				common.iConfirm3("撤单确认",tipStr,cancelFunc,function(){}, "撤单", "取消", function(){
					var cancel = _data.cancel;
					var page = {};
					if($.isValue(cancel)){
				      	for(var i = 0; i < cancel.length; i++){
				      		var name = cancel[i][0];
				      		page[""+name] = pjcs2(element,cancel[i][1]);
				      	}
			      	}
					cancellation(page,function(){
						//撤单重买卖，用撤单数据里面的【委托数量-成交数量】就是对应要带到买卖页面的数量数据
						element.entrust_amount = Number(element.entrust_amount) - Number(element.business_amount);
						promptBoxFun(element);
					}); // 确认撤单
				}, btnName);
			}
			else{
				if(optionSetting && optionSetting.ignoreConfirm) {
					cancelFunc();
					return;
				}
				common.iConfirm("撤单确认",tipStr,cancelFunc);
			}
			
			if($.isValue(statParam)){
				var objectId = statParam[0][0];
				var actionId = statParam[0][1];
				var pan = statParam[0][2];
				var statPa = {};
				$.each(pan,function(key,value){
					statPa[key] = pjcs2(element,value);
				})
			}

			e.stopPropagation();
		}, downslide.clickType());
		
		if(_data.topDiv.isEnableMultiSelect || $(_pageId + ".main_footer").length > 0){ //多选撤单
			// 点击按钮
			$.bindEvent($(_pageId+".kcb_cancel_order .part .title i"), function(e){
				$(this).toggleClass("active");
				var allActive = true;
				$(_pageId+".kcb_cancel_order .part .title i").each(function(idx, item){
					if(!$(this).hasClass("active")) {
						allActive = false;
					}
				});
				var list = $(_pageId+" .kcb_cancel_order .part .title i.active");
				var listLength = list.length;
				if(allActive){
					if(_module=="credit"){
						$(_pageId+".main_footer .check_box").addClass("active");
					}else if(_module=="ggt"){
						$(_pageId+".main_footer .check_box").addClass("active");
						$(_pageId+".main_footer .check_box").html("<i></i>全选（"+listLength+"）");
					}else{
						$(_pageId+".main_footer .check_box i").addClass("active");
						$(_pageId+".main_footer .check_box i").html("全选（"+listLength+"）");
					}
				}else{
					if(_module=="credit"){
						$(_pageId+".main_footer .check_box").removeClass("active");
					}
					else if(_module=="ggt"){
						$(_pageId+".main_footer .check_box").html("<i></i>全选");
						$(_pageId+".main_footer .check_box").removeClass("active");
					}else{
						$(_pageId+".main_footer .check_box i").removeClass("active");
						$(_pageId+".main_footer .check_box i").html("全选");
					}
				}
				if(_module=="credit"){
					var activeLen=$(_pageId+".kcb_cancel_order .part .title i.active").length;
					if(activeLen>0){
						$(_pageId+".main_footer .onekey_drawal a").removeClass("banbtn");
					}else{
						$(_pageId+".main_footer .onekey_drawal a").addClass("banbtn");
					}
				}
				e.stopPropagation();
			}, downslide.clickType());
			// 全选按钮
			$.bindEvent($(_pageId+".main_footer .check_box"), function(e){
				var _$this="",_html="";
				if(_module=="credit"){
					_$this=$(this);
					_html="<i></i>全选";
				}
				else if(_module=="ggt"){
					_$this=$(this);
					_html="<i></i>全选";
				}
				else{
					_$this=$(this).find("i");
					_html="全选";
				}
				if(_$this.hasClass("active")){
					_$this.removeClass("active");
					_$this.html(_html);
					$(_pageId + ' .kcb_cancel_order .part .title i').removeClass("active");
					if(_module=="credit"){
						$(_pageId+".main_footer .onekey_drawal a").addClass("banbtn");
					}
					if(_module=="ggt"){
						$(_pageId+".main_footer .onekey_drawal a").addClass("banbtn");
					}
					
				}
				else{
					_$this.addClass("active");
					$(_pageId + ' .kcb_cancel_order .part .title i').addClass("active");
					var list = $(_pageId+" .kcb_cancel_order .part .title i.active");
					var listLength = list.length;
					_$this.html(_html+"（"+listLength+"）");
					if(_module=="credit"){
						$(_pageId+".main_footer .onekey_drawal a").removeClass("banbtn");
					}
					if(_module=="ggt"){
						$(_pageId+".main_footer .onekey_drawal a").removeClass("banbtn");
					}
				}
				e.stopPropagation();
			}, downslide.clickType());
			//一键撤单
			$.bindEvent($(_pageId+".main_footer .onekey_check a.btn"), function(e){
				var list = $(_pageId+" .kcb_cancel_order .part .title i.active");
				var listLength = list.length;
				if(listLength == 0) {
					$.alert("请勾选要撤单的期权合约！");
					return false;
				}
				var onekey_cancel = function(){
					var cancel = _data.cancel;
					var page = {};
					list.each(function(idx, item){
						var id = $(this).parent(".title").parent(".part").attr("data-id");
						var element = interfaceData[id];
						if($.isValue(cancel) && element){
					      	for(var i = 0; i < cancel.length; i++){
					      		var name = cancel[i][0];
					      		page[""+name] = (page[""+name] ? (page[""+name] + "," + pjcs2(element,cancel[i][1])) : pjcs2(element,cancel[i][1]));
					      	}
				      	}
					});
					cancellation(page); // 确认撤单
				}
				if(optionSetting && optionSetting.ignoreConfirm) {
					onekey_cancel();
					return;
				}
				var tipStr = "<div ><strong>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</strong>";
				tipStr += "<p>您已选择<em>"+listLength+"笔</em>委托进行撤单操作，是否确认批量操作？</p>"
				tipStr += "</div>";
				common.iConfirm("撤单确认",tipStr,onekey_cancel);
				e.stopPropagation();
			}, downslide.clickType());
			
			//一键撤单（两融批量撤单）
			$.bindEvent($(_pageId+".main_footer .onekey_drawal a"), function(e){
				var list = $(_pageId+" .kcb_cancel_order .part .title i.active");
				var listLength = list.length;
				if(listLength == 0) {
					return false;
				}
				var onekey_cancel = function(){
					var cancel = _data.cancel;
					var page = {};
					list.each(function(idx, item){
						var id = $(this).parent(".title").parent(".part").attr("data-id");
						var element = interfaceData[id];
						if($.isValue(cancel) && element){
					      	for(var i = 0; i < cancel.length; i++){
					      		var name = cancel[i][0];
					      		page[""+name] = (page[""+name] ? (page[""+name] + "," + pjcs2(element,cancel[i][1])) : pjcs2(element,cancel[i][1]));
					      	}
				      	}
					});
					cancelParam.batch_flag="1";//批量撤单标志（0:不是，1：是）
					cancellation(page); // 确认撤单
				}
				if(optionSetting && optionSetting.ignoreConfirm) {
					onekey_cancel();
					return;
				}
				var tipStr = "<div ><strong>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</strong>";
				tipStr += "<p>您已选择<em>"+listLength+"笔</em>委托进行撤单操作，是否确认批量操作？</p>"
				tipStr += "</div>";
				common.iConfirm("撤单确认",tipStr,onekey_cancel);
				e.stopPropagation();
			}, downslide.clickType());
		}
		
		//委托数量说明弹框
		$.bindEvent($(_pageId+".kcb_cancel_order .part ul li span i"), function(e){
			$(_pageId+".dialog-overlay").show();
			$(_pageId+".missconfirm").show();
			e.stopPropagation();
		}, downslide.clickType());
		//委托数量说明
		$.bindEvent($(_pageId+".missconfirm .row_03 "), function(e){
			$(_pageId+".dialog-overlay").hide();
			$(_pageId+".missconfirm").hide();
			e.stopPropagation();
		}, downslide.clickType());
	}
	
	function cancellation(Param, callback){
		var param = Param;
		param.funcNo = cancelFuncNo;
		if($.isValue(cancelParam)){
			for(t in cancelParam){
				param[t] = cancelParam[t];
			}
		}
		publicService.kcbQueryCommon($.cloneFun(param),function(data){
			$.hidePreloader();
			if(data){
				if (data.error_no == 0) {
					$(_pageId+".main_footer .check_box i").removeClass("active");
					if($.isValue(data.results)){
						if(_data.topDiv.isEnableMultiSelect || $(_pageId + ".main_footer").length > 0) { // 批量撤单
							var tipStr = "";
							$.each(data.results, function(idx,item) {
								if(item.error_no == "0"){
									tipStr += "<p>委托编号" + " "+item.entrust_no ;
									tipStr += ",撤单已提交<br/>"+ "</p>";
								}else{
									tipStr += "<p>委托编号" +" "+ item.entrust_no ;
									tipStr += ",撤单失败<br/>"+ "</p>";
									item.error_info?(tipStr += "<em style=\"color:#de4c39\">失败原因："+item.error_info+"</em></p>"):"</p>";
								}
							});
							$.alert(tipStr,function(){
								downslide.loadReload();
								interfaceNum = 0;
								interfaceData = {};
								kcb_cancel_order.html("");
								kcb_cancel_order.attr("style","");
								//两融,港股通委托失败,无需跳转至下单委托页面(仅针对单个撤单，多个撤单，不予跳转)
								if((_module=="credit" || _module=="ggt")&&data.results[0].error_no != "0"){
									callsQuery();
								}else{
									if(callback){
										callsQuery();
										callback();
									}
									else{
										callsQuery();
									}
								}
							});
						}else{ //单个的提交
							var t = data.results[0] ? "<br/>委托编号："+data.results[0].entrust_no : "";
							$.alert("撤单委托已提交！"+t,function(){
								downslide.loadReload();
								interfaceNum = 0;
								interfaceData = {};
								kcb_cancel_order.html("");
								kcb_cancel_order.attr("style","");
								if(callback){
									callsQuery();
									callback();
								}
								else{
									callsQuery();
								}
							});
						}
						
					}
				}else{  
					$.alert(data.error_info);
				}
			}else{
				$.alert("撤单失败");
			}
		},
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){ // 超时调用方法
				$.hidePreloader();
				$.alert("撤单失败");
	        },
			"timeOutFunc":function(){ // 超时调用方法
				$.hidePreloader();
				$.alert("撤单失败");
	        }
		});
		$.showPreloaders("请等待...");
		if(_module=="credit"){
			$(_pageId+".main_footer .onekey_drawal a").addClass("banbtn");
    		$(_pageId+".main_footer .check_box").html("<i></i>全选").removeClass("active");
		}
		if(_module=="ggt"){
			$(_pageId+".main_footer .onekey_drawal a").addClass("banbtn");
    		$(_pageId+".main_footer .check_box").html("<i></i>全选").removeClass("active");
		}
	}
	
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId + " .main_footer").show().css({"visibility":"hidden"});
		_pageId = "";
    	queryFuncNo = "";
    	queryParam = {};
    	cancelFuncNo = "";
    	cancelParam = {};
    	slideHeight = null;
		dataResults = null;
		intResults = 0;
    	_data = {};
    	interfaceNum = 0;
    	interfaceData = {};
    	if(kcb_cancel_order){
			kcb_cancel_order.html("");
			kcb_cancel_order.attr("style","");
    	}
    	if(_module=="credit"){
    		$(_pageId+".main_footer .check_box").html("<i></i>全选").removeClass("active");
    	}
    	else if(_module=="ggt"){
    		$(_pageId+".main_footer .check_box").html("<i></i>全选").removeClass("active");
    	}
    	else{
    		$(_pageId+".main_footer .check_box i").html("全选").removeClass("active");
    	}
		kcb_cancel_order = null;
		downslide.slideDestroy();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
