/**
 * 普通交易-查询
 */
define('trade/scripts/kcb/stock/kcbPHExplain.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#kcb_stock_kcbPHExplain ";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var myScrollerHeight=null;

    /**
     * 初始化
     */
	function init(){
	}
		
	function load(){
		myScrollerHeight=$(window).height()-$(_pageId+".header").height();
		initScroller();
	}
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageBack("kcb/stock/kcbStockQuery");
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
	}
    /**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: myScrollerHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){},
			pullUpHandler: function(){}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	/**
	 * 销毁
	 */
	function destroy(){
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
	};
	module.exports = base;
});