/**
 * 普通交易——科创板盘后撤单
 */
define('trade/scripts/kcb/stock/kcbPHStockCancel.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#kcb_stock_kcbPHStockCancel ";
    var publicKcbCancel = require("publicKcbCancel");
    var data = {
		"queryFuncNo": "301571",
		"queryParam": {
			"query_flag":1,
		},
//		"promptBoxFun": function(e){
//			if(e.entrust_bs == "100"){
//				$.pageInit("kcb/stock/kcbPHStockCancel","kcb/stock/kcbPHStockBuy",e,"",true);
//			}
//			else if(e.entrust_bs == "101"){
//				$.pageInit("kcb/stock/kcbPHStockCancel","kcb/stock/kcbPHStockSell",e,"",true);
//			}
//		},
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交价格", "business_price"],
				["成交数量", "business_amount"],
				["委托编号", "entrust_no"],
				["委托时间", "entrust_time"],
				["委托状态", "entrust_state_name"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
			],
			//撤单提示字段
			"tipStr":[
				["证券名称", "stock_name"],
				["证券代码", "stock_code"],
				["业务名称", "entrust_name"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
			]
		},
		"cancelFuncNo":"301578",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
		"statParam":[
			//撤单按钮
			[100141, 10046,{"revoke_stock_code":"stock_code"}],
			//撤单提示框
			[100142, 10047],
		]
    }
    
    if(global.serverConfig == 1){
    	data.htmlData.liList=[
			["委托编号", "entrust_no"],
			["委托价格", "entrust_price"],
			["委托数量", "entrust_amount"],
			["成交数量", "business_amount"],
			["委托状态", "entrust_state_name"],
			["委托时间", "entrust_time"],
    	];
    	data.htmlData.tipStr=[
			[function(e){
				return e.stock_name
			}, "stock_code"],
			["买卖方向", "entrust_name"],
			["委托价格", "entrust_price"],
			["委托数量", "entrust_amount"],
			["成交数量", "business_amount"],
		];
    }
    
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("0");
		publicKcbCancel.init(data);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
    }
		
	function load(){
		publicKcbCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		
		
		publicKcbCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicKcbCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});