/**
 * 普通交易-科创板撤单
 */
define('trade/scripts/kcb/stock/kcbStockCancel.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#kcb_stock_kcbStockCancel ";
    var publicKcbCancel = require("publicKcbCancel");
    var data = {
		"queryFuncNo": "301515",
		"queryParam": {
			"query_flag":1,
		},
		"cancellModule":"stock",//表示普通撤单
		"promptBoxFun": function(e){
			var buyEntrust=["0","62","64","66","68","70","4"];
			var sellEntrust=["1","63","65","67","69","71","5"];
			if(buyEntrust.indexOf(e.entrust_bs)!=-1){
				$.pageInit("kcb/stock/kcbStockCancel","kcb/stock/kcbStockBuy",e,"",true);
			}
			else if(sellEntrust.indexOf(e.entrust_bs)!=-1){
				$.pageInit("kcb/stock/kcbStockCancel","kcb/stock/kcbStockSell",e,"",true);
			}
		},
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["委托价格", "entrust_price"],
				["成交价格", "business_price"],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
				["委托状态", "entrust_state_name"],
				["委托时间", "entrust_time"],
				["委托编号", "entrust_no"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
			],
			//撤单提示字段
			"tipStr":[
				["证券名称", "stock_name"],
				["证券代码", "stock_code"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
			]
		},
		"cancelFuncNo":"301502",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
		"statParam":[
			//撤单按钮
			[100141, 10046,{"revoke_stock_code":"stock_code"}],
			//撤单提示框
			[100142, 10047],
		]
    }
    if(global.serverConfig == 1){
    	data.htmlData.liList=[
			["委托编号", "entrust_no"],
			["委托价格", "entrust_price"],
			["委托数量", "entrust_amount"],
			["成交数量", "business_amount"],
			["委托状态", "entrust_state_name"],
			["委托时间", "entrust_time"],
    	];
    	data.htmlData.tipStr=[
			[function(e){
				return e.stock_name
			}, "stock_code"],
			["买卖方向", "entrust_name"],
			["委托价格", "entrust_price"],
			["委托数量", "entrust_amount"],
			["成交数量", "business_amount"],
		];
    }
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("0");
		publicKcbCancel.init(data);
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
    }
		
	function load(){
		publicKcbCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageInit("kcb/stock/kcbStockCancel", "account/index", {"history": true}, "left", true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		
		
		publicKcbCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicKcbCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});