/**
 * 普通交易-持仓
 */
define('trade/scripts/kcb/stock/kcbStockHolding.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_stockKcb = require("service_stockKcb");
	var service_stock = require("service_stock");
	var commonFunc = require("commonFunc");
	var commonHq = require("commonHq");
	var commonTimer = require("commonTimer");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
	var keyboard = require("keyboard");
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
    var _pageId = "#kcb_stock_kcbStockHolding ";
    var userInfo = null;
    var _callback = true;
    var hqData = {};
    var _openStock={};
    var abc=0;
    var myAbout = null;
	var hIAbout = require("hIscroll");
    
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.switchingCurUser("0");
		sessionStorage.setItem("isScroller","");
		_openStock={};
		$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
		
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		userInfo = common.getCurUserInfo();
		jumpPageEvent();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		vIscrollHeight = mainHeight - $(_pageId + " .tab_nav").outerHeight(true)-2;
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryData();//查询持仓
		
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){}
	
	/**
	 * 事件绑定
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageInit("kcb/stock/kcbStockHolding", "account/index", {"history": true}, "left", true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.setSStorageInfo("return_page","kcb/stock/stockHolding");
			$.pageInit("kcb/stock/kcbStockHolding","banking/transferNew",{});
			e.stopPropagation();
		});
		
		//成本价输入框
		$.bindEvent($(_pageId + "#costPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		}, "input");
		
		$.bindEvent($(_pageId), function(e){
			sessionStorage.setItem("isScroller","");
		}, "touchstart");
	}
    
	/**
	 * 查询
	 */
	function queryData(){
		clearPositionTimer();
		//查询资金账户
		queryCapital();
		queryPosition();
		_callback = false;
		if(global.positionRefreshTime){
			commonHq.initCheckTradeTimer();
			commonTimer.setTimer(_pageId, function(){
				if(commonHq.getTradingTime() && _callback){
					queryCapital(true);
					queryPosition(true);
					_callback = false;
				}
			}, global.positionRefreshTime);
		};
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "flag": "0",
		  		"query_flag":"1"
		};
		//最后一个为超时处理函数
		service_stockKcb.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
			},
			"errorFunc":function(){
			}
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var type = {"0":"RMB ","1":"Dollar","2":"HKD"};
					for(var i=0;i<results.length;i++){
						var id = _pageId +"#"+ type[results[i].money_type];
						var assert_val = Number(results[i].assert_val).toFixed(2)+"";
						$(id+" .inner>strong").html(assert_val.substring(0,assert_val.length-2)+""+ assert_val.substr(-2) +"");//总资产
						//科创板市值
						var market_val = Number(results[i].market_val).toFixed(2)+"";
						$(id+" .more_info li").eq(0).find("strong").html(market_val.substring(0,market_val.length-2)+""+ market_val.substr(-2) +"");
						
						//可用资金
						var enable_balance = Number(results[i].enable_balance).toFixed(2)+"";
						$(id+" .more_info li").eq(1).find("strong").html(enable_balance.substring(0,enable_balance.length-2)+""+ enable_balance.substr(-2) +"");
						
						//科创板总盈亏
						var css = "";
						var float_yks = results[i].float_yk || results[i].total_income_balance;
						//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
						if(float_yks > 0){
							css = "ared";
						}else if(float_yks < 0){
							css = "agreen";
						}
						var fas = Number(float_yks).toFixed(2);
						$(id+" .more_info ul li").eq(2).find("strong").html(fas.substring(0,fas.length-2)+""+ fas.substr(-2) +"").addClass(css);
						//可取资金
						var fetch_balance = Number(results[i].fetch_balance).toFixed(2)+"";
						$(id+" .more_info ul li").eq(3).find("strong").html(fetch_balance.substring(0,fetch_balance.length-2)+""+ fetch_balance.substr(-2) +"");
					}
				}else{
					$(_pageId+".kcb_hold_main2 .inner>strong").text("--");//总资产
					$(_pageId+".kcb_hold_main2 .more_info li strong").text("--").attr("class","");//市值
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	
	function queryPosition(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password,
		    "query_flag":"1"
		};
		service_stockKcb.queryStockData(param,queryPositionCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"errorFunc":function(){
			},
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无持仓记录");
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	
	function queryPositionCallback(data){
		var w=$(_pageId).width() / 4 ;
		// $(_pageId+".kcb_fund_table .ce_table th").css('min-width',w+"px");
		_callback = true;
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var htmlTop = "";
					_openStock=$.getSStorageInfo("openStock",false) || {};
					if(_openStock && typeof(_openStock) == "string"){
						_openStock = JSON.parse(_openStock);
					}
					for (var i=0;i<results.length;i++){ 
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						var type = ""
						var exchange_type = results[i].exchange_type
						if(exchange_type == 0 || exchange_type == 1)
						{
							type = "SZ:"+results[i].stock_code;
						}
						else if(exchange_type == 2 || exchange_type == 3)
						{
							type = "SH:"+results[i].stock_code;
						}
						var isLast="";
						if(i==(results.length-1)){
							isLast="true";
						}
						htmlTop += queryPositionHTML_stock(results[i],type,isLast);
					}
					$(_pageId+".position_div tbody").html(htmlTop);
					common.setNoData(false);
					//卖出事件
					$.bindEvent($(_pageId+'.position_div tr.add'), function(e){
						var inv = $(_pageId+".position_div .tools._last").is(':visible') ? 0 : 34;
						var isLast=$(this).attr("islast");
						if(($(_pageId +  ".vertical_list").height() + inv) > $(_pageId + " #wrapper").height()){
							var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
							if(isLast=="true" || isNeedScroll){
								if($(this).next().height() > 0){
		                            abc = $(this).next().height();
		                        }
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".position_div .tools").hide();
								if(a){
									$(this).next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
		                            if($(this).next().height() > 0){
		                            	abc = $(this).next().height();
		                            }
		                            var maxScrollY = 0;
		                        	var _height=myScroller.y;
		                        	var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
									if($(this).next().is(':visible')){
										sessionStorage.setItem("isScroller","true");
										_height -= abc ;
										maxScrollY = _height;
									    _height -= temph;
									}else{
										_height += abc;
										maxScrollY = _height;
										sessionStorage.setItem("isScroller","");
									}
									myScroller.scrollTo(0,_height);
									myScroller.y = _height;
									myScroller.refresh();
									if(isLast=="true"){
										myScroller.maxScrollY = maxScrollY;
									}
								}
							}else{
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".position_div .tools").hide();
								if(a){
									$(this).next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
									myScroller.refresh();
								}
							}
						}
						else{
							var a = $(this).next().css("display") == "none" ? true : false;
							$(_pageId+".position_div .tools").hide();
							if(a){
								$(this).next().show();
								//保存展开的股票
								var openStock={
									"stock_code":$(this).attr("id"),
									"exchange_type":$(this).attr("exchange_type"),
									"stock_account":$(this).attr("stock_account"),
								}
								$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
							}else{
								_openStock={};
								$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
							}
							$(this).addClass("active").siblings().removeClass("active");
							if(myScroller){
								myScroller.refresh();
							}
						}
						initAbout();
						e.preventDefault(); 
					});
					
					//卖出按钮事件
					$.bindEvent($(_pageId+".position_div tr.tools a"), function(e){
						$(_pageId+".position_div tr.tools").hide();
						$(this).siblings().removeClass("active");
						var stock = $(this).parents("tr.tools").prev();
						var stock_code = stock.attr("id");
						var stock_name= stock.attr("stock_name");
						var id = $(this).attr("id");
						var type = stock.attr("type");
						var exchange_type = stock.attr("exchange_type");
						var stock_account = stock.attr("stock_account");
						var market = "";
						if(type){
							market = type.split(":");
							if(market[0]){
								market = market[0];
							}
						}
						if(id == "buy"){
							$.pageInit("kcb/stock/kcbStockHolding","kcb/stock/kcbStockBuy",{"code":stock_code,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
						}
						else if(id == "sell"){
							$.pageInit("kcb/stock/kcbStockHolding","kcb/stock/kcbStockSell",{"code":stock_code,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
						}
						else if(id == "hq"){
							if(global.callNative){
                                var pageCode = $.getCurrentPageObj().pageCode || '';
                                $.setSStorageInfo("go_hq_" + pageCode, true);		
                                if(gconfig.platform == "2"){
                                    var param = {
                                        "stockMarket": market,
                                        "stockCode": stock_code,
                                        "stockName": stock_name,
                                            "moduleName" : "self-stock",
                                            "funcNo":"60105"
                                        }; 							
                                    $.callMessage(param);
                                }
                                else{
                                    var param = {
                                        "funcNo": "50500",
                                        "msgNo": "201",
                                        "targetModule":"hqDispatcher",
                                        "sourceModule":"trade",
                                        "action":"0",
                                        "param":{
                                            "stockMarket": market,
                                            "stockCode": stock_code,
                                            "stockName": stock_name,
                                        }
                                    }
                                    $.callMessage(param);
                                }
                            }else{
                                var stockInfo = {
                                    "market": market,
                                    "stockCode": stock_code,
                                    "stockName": stock_name,
                                    "moduleName" : "trade"
                                }
                                window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
                            }
						}
						else if(id == "cbj"){
							var content="<li><p>证券代码</p>"+stock_code+"</li>"+
	               						"<li><p>修改前</p>"+ stock.find("td").eq(3).find("p").eq(0).text()+"</li>"+
	               						"<li><p>币种</p>人民币</li>"+
	                					"<li>"+
                						"<div class='CBJinput_box' style='border: 1px solid #dddddd;border-radius: 0.03rem;width: 0.9rem;height: 0.28rem;'><p>修改后</p>"+
	                					"<input type='number' js-key='number' class='t1' id='costPrice' custom_keybord='0'/>"+
	                					"</div></li>";
							common.costPriceiConfirm("成本价修改",content,function success(){
								_openStock={};
								$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								var costPrice=$(_pageId+"#costPrice").val();
								if(!costPrice){
									$.alert("请输入修改后成本价！");
									return false;
								}
								if(costPrice<=0.000){
									$.alert("成本价格必须大于0.000。");
									return false;
								}
								if(costPrice>1000000000.000){
									$.alert("成本价格必须小于1000000000.000。");
									return false;
								}
								var reg=/^(-?\d*)\.?\d{1,3}$/;
								if(!reg.test(costPrice)){
									$.alert("成本价格只能精确到小数点后3位。");
									return false;
								}
								var param={				
									"entrust_way":global.entrust_way, // 委托方式  在configuration配置 
								    "branch_no":userInfo.branch_no,
								    "fund_account":userInfo.fund_account,
								    "cust_code":userInfo.cust_code,
								    "stock_account":stock_account,//股东代码
								    "exchange_type":exchange_type,//市场
								    "stock_code":stock_code,//股票代码
								    "cost_price":costPrice,//修改后的成本价
								    "password":userInfo.password
								};
								costModification(param);
							},function fail(){
								_openStock={};
								$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								if(keyboard){
									keyboard.closeKeyPanel();
								}
							});
							if(keyboard){
								keyboard.keyInit();
							}
						
						}
						e.preventDefault();
					});
				}
				else{
					common.setNoData(true,"暂无持仓记录");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		initAbout();
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	//成本价修改
	function costModification(param){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		service_stock.costModification(param,function(data){
			if(data.error_no == 0){
				queryPosition();//刷新持仓
			}else{
				$.alert(data.error_info);
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				$.hidePreloader();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	
	function clearPositionTimer(){
		commonTimer.clearTimer(_pageId);
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,type,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "",css1="",css3="";
		//浮动盈亏
		var float_yk = Number(element.float_yk);
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		if(isLast=="true"){
			css3="_last";
		}else{
			css3="_nolast";
		}
        var active_css1 = "" , active_css2 = " style='display: none;'";
		if(_openStock && _openStock.stock_code){
			if(element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account){
				active_css1 = "active";
				active_css2 = "";
			}
		}

		var maxWidth = ($(window).width() - 30) * 0.25 - 20;
		var marketValue = element.market_value,
		float_yk_per = element.float_yk_per + "%",
		cost_amount = element.cost_amount,
		enable_amount = element.enable_amount,
		cost_price = element.cost_price,
		last_price = element.last_price;
		float_yk = float_yk.toFixed(price_digit);
		eleHtml+="<tr class='add "+active_css1+"' stock_account=\""+element.stock_account+"\" stock_name=\""+element.stock_name+"\" exchange_type=\""+element.exchange_type+"\"  type=\""+type+"\" id='"+element.stock_code +"'  isLast='"+isLast+"'>";
		eleHtml+='<td><p style="transform-origin: left;transform:scale('+$.getTransformScale(element.stock_name, 16, maxWidth + 5)+')">'+element.stock_name +'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p></td>';
        eleHtml+='<td><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>';
        eleHtml+='<p class="'+css1+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+float_yk_per+'</p></td>';
		eleHtml+='<td><p style="font-size:'+$.getTransformScaleFontSize(cost_amount, 16, maxWidth) +'px;">'+cost_amount+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></td>';
		eleHtml+='<td><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>';
		eleHtml+='<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></td>';
        eleHtml+="</tr>";
		eleHtml+="<tr class='j-table-btns tools "+css3+"' "+active_css2+">";
        eleHtml+="<td colspan=\"4\">";
        eleHtml+="<ul class='ui layout j-btns-list'>";
        eleHtml+="<a id=\"buy\" class=\"row-1 border-right\" href=\"javascript:void(0);\">买入</a>";
        eleHtml+="<a id=\"sell\" class=\"row-1 border-right\" href=\"javascript:void(0);\">卖出</a>";
        eleHtml+="<a id=\"hq\" class=\"row-1 border-right\" href=\"javascript:void(0);\">行情</a>";
		eleHtml+="<a id=\"cbj\" class=\"row-1\" href=\"javascript:void(0);\">成本价</a>";
		// eleHtml+="<a id=\"mx\" class=\"row-1\" class=\"row-1\" href=\"javascript:void(0);\">明细</a>";
        eleHtml+="</ul>";
        eleHtml+="</td>";
		eleHtml+="</tr>";

        // eleHtml+="<tr class='add "+active_css1+"' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\"  type=\""+type+"\" id='"+element.stock_code +"'  isLast='"+isLast+"'>";
        // eleHtml+="<td><span style='zoom:"+ $.getTransformScale(element.stock_name, 16, $(window).width() * 0.25) +";'>"+element.stock_name +"</span><span>"+element.market_value +"</span></td>";
        // eleHtml+="<td><span class=\""+css+"\">"+element.float_yk+"</span>";
        // eleHtml+="<span class=\""+css1+"\">"+element.float_yk_per+"%</span></td>";
        // eleHtml+="<td><span>"+element.cost_amount+"</span><span>"+element.enable_amount+"</span></td>";
        // eleHtml+="<td><sapn>"+element.cost_price+"</sapn><span>"+element.last_price+"</span></td>";
        // eleHtml+="</tr>";
		// eleHtml+="<tr class='tools "+css3+"' "+active_css2+">";
        // eleHtml+="<td colspan=\"4\">";
        // eleHtml+="<ul>";
        // eleHtml+="<li><a id=\"buy\" href=\"javascript:void(0);\"><span>买入</span></a></li>";
        // eleHtml+="<li><a id=\"sell\" href=\"javascript:void(0);\"><span>卖出</span></a></li>";
        // eleHtml+="<li><a id=\"hq\" href=\"javascript:void(0);\"><span>行情</span></a></li>";
        // eleHtml+="<li><a id=\"cbj\" href=\"javascript:void(0);\"><span>成本价</span></a></li>";
        // eleHtml+="</ul>";
        // eleHtml+="</td>";
        // eleHtml+="</tr>";
		return eleHtml;
	}
	
	/**
	 * 持仓上下滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: vIscrollHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/*
	 * 持仓左右滑动组件
	 */
	function initAbout(){
//		if(myAbout)
//		{
//			$(_pageId + " #pull_down_about").height("auto");
//			myAbout.destroy();
//			myAbout = null;
//		}
//		var config = {
//				wrapper: $(_pageId + " #aboutpper"), //wrapper对象
//				scroller: $(_pageId + " #aboutpper"), //scroller对象
//			};
//		// 设置 scroller 的宽度
//		myAbout = new hIAbout(config); //初始化，需要做if(!hIscroll._init)判断
		//必须用这个左右滑动组件，否则事件乱跳
		// var scrollOptions = {
		// 	$wrapper: $(_pageId + " #pull_down_about")
		// };
		// myAbout = iscrollUtils.hScroller(scrollOptions);
	};
	
	/**
	 * 销毁
	 */
	function destroy(){
        commonHq.clearCheckTradeTimer();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myAbout)
		{
			$(_pageId + " #pull_down_about").height("auto");
			myAbout.destroy();
			myAbout = null;
		}
		$.clearRequest();
		clearPositionTimer();
		_callback = true;
		$(_pageId+".kcb_hold_main2 .inner>strong").text("--");//总资产
		$(_pageId+".kcb_hold_main2 .more_info li strong").text("--").attr("class","");//市值
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
