/**
 * 普通交易-历史查询
 */
define('trade/scripts/kcb/stock/kcbStockQueryHistory.js', function(require, exports, module) {
    var _pageId = "#kcb_stock_kcbStockQueryHistory ";
	var gconfig = $.config; 
	var global = gconfig.global;
    var publicKcbQuery = require("publicKcbQuery");
    var commonStat = require("commonStat");
	var common = require("common");
    var data = {
		"funcNo": "301574",
		"param": {},
		"history": true,
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
				"time": "entrust_state_name",
			},
			"liList": [
				["委托编号", "entrust_no"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交价格", "business_price"],
				["成交数量", "business_amount"],
				["委托时间", function(e){
					return e.entrust_date + " " + e.entrust_time;
				}],
			],
		}
    }
    if(global.serverConfig == 2){
    	data = {
			"funcNo": "301574",
			"param": {},
			"history": true,
			"htmlData": {
				"topDiv": {
					"entrust": "entrust_name",
					"name": "stock_name",
					"code": "stock_code",
					"time": "entrust_state_name",
				},
				"liList": [
					["委托价格", "entrust_price"],
					["委托数量", "entrust_amount"],
					["成交数量", "business_amount"],
					["委托编号", "entrust_no"],
					["委托日期", function(e){
						return e.entrust_date + " " + e.entrust_time;
					}],
				],
			}
	    }
    }
    var data1 = {
    	"funcNo": "301575",
		"param": {},
		"history": true,
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["成交价格", "business_price"],
				["成交数量", "business_amount"],
				["成交编号", "business_no"],
				["成交日期", function(e){
					return e.business_date + " " + e.business_time;
				}],
			],
		}
    }
    
    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("0");
		if(global.serverConfig=="2"){
			$(_pageId+".header2").show();
			$(_pageId+".header1").hide();
		}else{
			$(_pageId+".header2").hide();
			$(_pageId+".header1").show();
		}
		var a = $.getPageParam();
		queryType = $.getPageParam("param");
		if(queryType=="entrust"){
			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			publicKcbQuery.init(data);
		}else{
			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			publicKcbQuery.init(data1);
		}
    }
		
	function load(){
		publicKcbQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageBack("kcb/stock/kcbStockQueryHistory", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		
		//页面切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			$.clearRequest();
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" .kcb_cancel_order").html("");
			$(_pageId+" .kcb_cancel_order").attr("style","");
			if($(this).index() == 0){
				publicKcbQuery.againQuery(data.param,data.funcNo,data.htmlData,data.history);
			}
			else{
				publicKcbQuery.againQuery(data1.param,data1.funcNo,data1.htmlData,data1.history);
			}
		});
		
		publicKcbQuery.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicKcbQuery.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});