/**
 * Created by sizhe on 2016/11/22.
 */
/**
 * 普通交易-网络投票
 */
define('trade/scripts/netVote/netVote.js', function (require, exports, module) {
  var common = require("common");
  var gconfig = $.config;
  var global = gconfig.global;
  var iscrollUtils = require("iscrollUtils");
  var myScroller = null; // 滑动组件对象
  var service_added = require("service_added");
  var _pageId = "#netVote_netVote ";
  var userInfo = null;
  var keyboard = require("keyboard");

  /**
   * 初始化
   */
  function init() {
    common.pageBuryingPoint("101575");
    common.bindStockEvent($(_pageId + ".tab_nav li a")); // 绑定头部菜单事件
    userInfo = common.getCurUserInfo();
    queryVoteList(); // 查询股东大会信息
    keyboard && keyboard.keyInit();
  }

  function load() {

  }

  /**
   * 事件绑定
   */
  function bindPageEvent() {
    // 返回按钮
    $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
      common.comStat(101576, 2, 103, true, { "i_group_name": "返回" });
      keyboard && keyboard.closeKeyPanel();
      $.pageInit("netVote/netVote", "netVote/index", { "history": true }, "left", true);
      e.preventDefault();
      e.stopPropagation();
    });
    // 查询
    $.bindEvent($(_pageId + ".inner a"), function (e) {
      keyboard && keyboard.closeKeyPanel();
      queryByCode(); //模糊查询
      e.stopPropagation();
    });

    $.bindEvent($(_pageId + " #stockCode"), function (e) {
        if (keyboard) {
            keyboard.popUpKeyboard($(this), e);
        }
        var code = $(_pageId + " #stockCode").val();
        if(code.length <= 0){
            queryByCode(); //模糊查询
        }
    }, "input");
  }

  /**
   * 查询股东大会信息
   */
  function queryVoteList() {
    var entrust_way = global.entrust_way; // 委托方式  在configuration配置
    var branch_no = userInfo.branch_no;
    var fund_account = userInfo.fund_account;
    var cust_code = userInfo.cust_code;
    var password = userInfo.password;
    var sessionid = userInfo.session_id;
    var param = {
      "entrust_way": entrust_way,
      "branch_no": branch_no,
      "fund_account": fund_account,
      "cust_code": cust_code,
      "password": password,
      "sessionid": sessionid
    };
    // 每次查询前,先将暂无数据隐藏
    $(_pageId + ".no_data").hide();
    // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
    service_added.queryStockMeetingInfo(param, function (data) {
      if (data.error_no == 0) {
        var results = data.results;
        if (results && results.length > 0) {
          var data = "";
          for (var i = 0; i < results.length; i++) {
            data += queryHTML(results[i]);
          }
          $(_pageId + ".vote_list3").html(data);
          $.bindEvent($(_pageId + ".part"), function (e) {
            var vote_code = $(this).attr("data-code");
            var meeting_seq = $(this).attr("data-seq");
            var companycode = $(this).attr("data-companycode");
            common.comStat(101578, 2, 103, true, { "i_group_name": "选择投票记录" });
            $.pageInit("netVote/netVote", "netVote/voteContent", { "vote_code": vote_code, "meeting_seq": meeting_seq, "companycode": companycode });
            e.stopPropagation();
          }, "tap");
        } else {
          $(_pageId + ".no_data").show();
        }
        if (!myScroller) {
          initScroller();
        } else {
          myScroller.refresh();
        }
      }
      else {
        $.alert(data.error_info);
      }
    }, { // 传给接口的json格式数据
      "isLastReq": true,
      "isShowWait": true,
      "isShowOverLay": false,
      "timeOutFunc": function () { // 超时调用方法
        $(_pageId + ".no_data").show();
        if (!myScroller) {
          initScroller();
        } else {
          myScroller.refresh();
        }
      }
    });
  }

  function queryHTML(element) {
    var eleHtml = "";
    eleHtml += "<div class=\"part\" data-seq='" + element.meeting_seq + "' data-code='" + element.vote_code + "' data-companycode='" + element.company_code + "'>";
    eleHtml += "<div class=\"title\"><h5>" + element.company_name + " <small>" + element.company_code + "</small></h5><a href=\"javascript:void(0);\" class=\"btn\">投票</a></div>";
    eleHtml += "<div class='vote_list_content'>";
    eleHtml += "<p class='vote_text'>";
    eleHtml += "股东大会名称:<span class='vote_value'>" + element.meeting_desc;
    eleHtml += "</span></p>";
    eleHtml += "<p class='vote_text'>";
    eleHtml += "股东大会编码:<span class='vote_value'>" + element.meeting_seq;
    eleHtml += "</span></p>";
    eleHtml += "<p class='vote_text'>";
    eleHtml += "股东大会类型:<span class='vote_value'>" + element.meeting_type;
    eleHtml += "</span></p>";
    eleHtml += "<p class='vote_text'>";
    eleHtml += "起始日期:<span class='vote_value'>" + element.meeting_begin;
    eleHtml += "</span></p>";
    eleHtml += "<p class='vote_text'>";
    eleHtml += "到期日期:<span class='vote_value'>" + element.meeting_end;
    eleHtml += "</span></p>";
    eleHtml += "</div>";
    eleHtml += "</div>";
    return eleHtml;
  }

  /**
   * 模糊查询信息
   */
  function queryByCode() {
    var code = $(_pageId + "#stockCode").val();
    var isNoData = true;
    $(_pageId + ".no_data").hide();
    if(code.length <= 0){
        $(_pageId + ".part").show();
    }else{
        $(_pageId + ".part").each(function () {
            var stockCode = $(this).find(".title small").text();
            if (stockCode.indexOf(code) != -1) {
              $(this).show();
              isNoData = false;
            } else {
              $(this).hide();
            }
        });
        if(isNoData){
            $(_pageId + ".no_data").show();
        }
    }
    myScroller && myScroller.refresh();
  }


  function initScroller() {
    var mainHeight = common.setMainHeight(_pageId, false) - Number($(_pageId + ".main").css("margin-top").slice(0, -2));
    $(_pageId + ".main").css({ "height": mainHeight, "overflow-y": "auto" });
    var scrollOptions = {
      scrollerHeight: mainHeight, // 滚动组件的高度
      pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
      $wrapper: $(_pageId + " #wrapper"),
      hasPullDown: true, // 是否显示下拉提示，默认 true
      hasPullUp: false, // 是否显示上拉提示，默认 true
      isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
      pullDownHandler: function () {
        common.comStat(101577, 2, 102, true, { "i_direct": "1", "i_type": "1" });
        queryVoteList();
      }
    };
    if (!myScroller) {
      // 内容的高度比滚动区域高度小时
      // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
      if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
        scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
      }
      myScroller = iscrollUtils.vScroller(scrollOptions);
    }
    else {
      myScroller.refresh();
    }
  }


  /**
   * 数据重置
   */
  function destroy() {
    common.pageBuryingPoint();
    $(_pageId + ".vote_list").html("");
    if (myScroller) {
      myScroller.destroy();
      myScroller = null;
    }
    keyboard && keyboard.closeKeyPanel();
    keyboard && keyboard.keyDestroy();
    $(_pageId + "#stockCode").quzhi("");
  }

  /**
   * 重写框架里面的pageBack方法
   */
  function pageBack() {
    $.pageInit("netVote/netVote", "account/index", {});
    keyboard && keyboard.closeKeyPanel();
  }

  var base = {
    "init": init,
    "load": load,
    "bindPageEvent": bindPageEvent,
    "destroy": destroy,
    "pageBack": pageBack
  };
  module.exports = base;
});
