/**
 * Created by sizhe on 2016/11/22.
 */
/**
 * 普通交易-网络结果记录查询
 */
define('trade/scripts/netVote/voteResultQuery.js',function(require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_added = require("service_added");
    var _pageId = "#netVote_voteResultQuery ";
    var userInfo = null;

    /**
     * 初始化
     */
    function init(){
		common.pageBuryingPoint("101619");
        common.bindStockEvent($(_pageId+".tab_nav li a")); // 绑定头部菜单事件
        userInfo=common.getCurUserInfo();
        commonFunc.initTimeChoice(_pageId,7);
        resultQuery(); // 查询投票历史纪录
    }

    /**
     * 事件绑定
     */
    function bindPageEvent(){
        // 返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			common.comStat(101620,2,103,true,{"i_group_name":"返回"});
        	$.pageBack();
//          pageBack();
        });

        $.bindEvent($(_pageId + ".date_filter .btn"), function(e){
			common.comStat(101621,2,103,true,{"i_group_name":"查询"});
            resultQuery();
        });
    }

    /**
     * 查询投票历史纪录
     */
    function resultQuery(){
        var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var end_date = $(_pageId+" #endDate").text();
        var begin_date = $(_pageId+" #startDate").text();	//截止
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "begin_date":begin_date,
            "end_date":end_date
        };
        // 每次查询前,先将暂无数据隐藏
        $(_pageId + ".no_data").hide();
        // 最后一个函数为超时函数,在超时后,显示暂无数据,并且初始化滑动组件
        service_added.resultQuery(param,function(data){
            if(data.error_no == 0){
                var results = data.results;
                if(results && results.length>0){
                    var data = "";
                    for (var i=0;i<results.length;i++){
                        data += queryHTML(results[i]);
                    }
                    $(_pageId + ".search_list ").html(data);
                }else{
       				$(_pageId + ".search_list").html("");
                    $(_pageId + ".no_data").show();
                }
                if(!myScroller){
                    initScroller();
                }else{
                    myScroller.refresh();
                }
            }
            else{
                $.alert(data.error_info);
            }
        },{ // 传给接口的json格式数据
            "isLastReq":true,
            "isShowWait":true,
            "isShowOverLay":false,
            "timeOutFunc":function(){ // 超时调用方法
                $(_pageId+ ".no_data").show();
                if(!myScroller){
                    initScroller();
                }else{
                    myScroller.refresh();
                }
            }
        });
    }

    function queryHTML(element){
        var vote_type = "";
        var eleHtml = "";
        eleHtml+="<div class=\"part\">";
        eleHtml+="<span class=\"time\">"+(element.entrust_date?element.entrust_date:"--") +"</span>";
        eleHtml+="<h5>"+(element.stock_name?element.stock_name:"--")+"  "+(element.stock_code?element.stock_code:"--")+"</h5>";
        eleHtml+="<dl class=\"clearfix\">";
        eleHtml+="    <dd><span class='titName'>股东大会名称</span>"+(element.meeting_name?element.meeting_name:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>股东大会编码</span>"+(element.meeting_seq?element.meeting_seq:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>交易类别</span>"+(element.exchange_type?element.exchange_type:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>会议类型</span>"+(element.meeting_type?element.meeting_type:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>结束日期</span>"+(element.end_date?element.end_date:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>证券账户</span>"+(element.stock_account?element.stock_account:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>资产账号</span>"+(element.fund_account?element.fund_account:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>议案编号</span>"+(element.motion_id?element.motion_id:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>投票类别</span>"+(element.vote_type_name?element.vote_type_name:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>投票结果</span>"+(element.vote_result?element.vote_result:"--")+"</dd>";
        eleHtml+="    <dd><span class='titName'>弃权数量</span>"+(element.waive_amount?element.waive_amount:"--")+"</dd>";
        eleHtml+="</dl>";
        eleHtml+="</div>";
        return eleHtml;
    }

    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId+".header").height()- $(_pageId+".tab_nav").height()- $(_pageId+".date_filter").height()- 16 , // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
                resultQuery();
            }
        };
        if(!myScroller)
        {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }


    /**
     * 数据重置
     */
    function destroy(){
		common.pageBuryingPoint();
        $(_pageId + ".search_list").html("");
        if(myScroller){
            myScroller.destroy();
            myScroller=null;
        }
    }

    /**
     * 重写框架里面的pageBack方法
     */
    function pageBack(){
        $.pageInit("voting/voteQuery","account/index",{});
    }

    var base = {
        "init" : init,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy,
        "pageBack": pageBack
    };
    module.exports = base;
});