/**
 * 新股新债日历
 */
define('trade/scripts/nsb/calendar.js', function (require, exports, module) {
    var gconfig = $.config;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var service = require("service_stock");
    var service_hq = require("service_hq");
    var service_xkj = require("service_xkj");
    require("dayjs");
    var _pageId = "#nsb_calendar ";
    var pagecode='nsb/calendar'
    var swiper =require("swiper");
    var html = '';
    var dest;//获取到的完整数据

    var dateArr;//计算获取的日期区间

    var selectIndex=-1;//首页会缓存索引，不是从首页进来的这个值为空

    var todaySSData=null;//今日上市最新价

    /**
     * 初始化
     */
    function init() {
        common.setMainHeight(_pageId, false);//
    }

    function load() {
        $.setSStorageInfo("nsb_isCalendarStocks","",true);
        $.setSStorageInfo("nsb_calendar","",true);
        $.setSStorageInfo("nsb_stock_code","",true);
        $.setSStorageInfo("nsb_market","",true);
        $.setSStorageInfo("nsb_calendar","",true);
        $(_pageId + ".swiper-wrapper").hide();
        $(_pageId + ".no_data").hide();

        queryStocks();
    }

    /*********
     * 请求新股数据
     * 200028新债
     * 200029新股
     */
    function queryStocks() {
        service_xkj.require1001009({}, function (data) {
            if (data){
                if(data.error_no == 0){
                    var results = data.results;
                    if(results.length>0 && results!= "undefined"){
                        queryBonds(results);
                    }else{
                        queryBonds('');
                    }
                }else{
                    queryBonds('');
                }
            }else{
                queryBonds('');
            }
        });
    }

    /*******
     * 请求新债数据
     * @param stockList
     */
    function queryBonds(stockList) {
        service_xkj.require1001010({}, function (data) {
            $(_pageId+".main_calendar").show();
            $(_pageId + ".nsb_no_data").hide();
            $(_pageId + ".calendar_warp").show();
            if (data){
                if(data.error_no == 0){
                    var results = data.results;
                    if(results.length>0 && results!= "undefined"){
                        operaData(stockList, results);
                    }else{
                        operaData(stockList, '');
                    }
                }else{
                    operaData(stockList, '');
                }
            }else{
                operaData(stockList, '');
            }

        });
    }


    /*********
     * 处理数据 新股新债数据合在一起
     * @param stockList 新股数据
     * @param bondList 新债数据
     */
    function operaData(stockList, bondList) {
        var dataList = stockList;
        if(dataList!=''&&dataList.length>0){
            if(bondList!=''&&bondList.length>0){
                for (var i = 0; i < bondList.length; i++) {
                    dataList.push(bondList[i]);
                }
            }
        }else{
            if(bondList!=''&&bondList.length>0){
                dataList=bondList;
            }
        }
        if(dataList&&dataList!=''&&dataList.length>0){
            // 处理证券长名称
            for (var i=0;i<dataList.length;i++){
                if($.isValue(dataList[i].longStockName)) dataList[i].stockName = dataList[i].longStockName;
                if($.isValue(dataList[i].longBndName)) dataList[i].bndName = dataList[i].longBndName;
                if(dataList[i].market === 'BJ'){
                    dataList[i].market = 'SZ';
                    dataList[i].isbj = true;
                }
            }
            var data = JsonSort(dataList, 'pubdate');//通过日期排序
            dest = group(data);
            if (dest && dest.length > 0) {
                var startDate = dest[0].pubdate;
                var endDate = dest[dest.length - 1].pubdate;
                dateArr = getdiffdate(startDate, endDate);//获取日期区间
                for (var i = 0; i < dateArr.length; i++) {
                    var currentDateArr = getInfoByDate(dateArr[i]);
                    html += showCalendar(dateArr[i], currentDateArr,i);
                    //各个按钮点击事件处理
                }
                $(_pageId + ".swiper-wrapper").show();
                $(_pageId + ".swiper-wrapper").html(html);

                var swiper = new Swiper('.swiper-container', {
                    slidesPerView: 7,
                    mode:'horizontal',
                    clickable:true,
                    loop:false,//禁止循环滑动
                    observer:true,
                    //observeParents:true
                });
                $.bindEvent($(_pageId + ".swiper-wrapper .day"), function() { // 待申购
                    var index=$(this).attr("data-index");
                    clickDate(index);

                });
                showToday();
            }
        }else{
            $(_pageId + ".calendar_warp").hide();
            $(_pageId + ".nsb_no_data").show();
        }

    }

    /*********
     * 显示今天
     */
    function showToday() {
        if(todaySSData==null){
            var currentDateArr = getInfoByDate(dateArr[0]);//获取当前日期数
            var todayLastPrice =[];//今日上市数据的最新价
            if (currentDateArr && currentDateArr.data && currentDateArr.data.length > 0) {
                for(var x=0;x<currentDateArr.data.length;x++){//3申购 1上市 2缴款
                    var currentData = currentDateArr.data[x];
                    if(currentData.type=="1"){
                        todayLastPrice.push(currentData.market+":"+(currentData.stockCode&&currentData.stockCode.length>0?currentData.stockCode:currentData.bndCode))
                    }
                }
            }
            getLastPrice(todayLastPrice.join("|"));
        }else{
            clickDate(0)
        }

    }


    /********
     * 显示日历
     */
    function showCalendar(currentDate, currentDateArr,i) {
        var eleHtml = "";
        eleHtml += "<div class='swiper-slide add"+i +"'>";
        eleHtml += "<span class='week text-size-12'>" + getWeekByDate(currentDate) + "</span>";
        eleHtml += "<span class='day mt10 circle-30-red sub' data-index='" + i+"'>" + getDay(currentDate,1) + "</span>";
        eleHtml += "<span>";
        eleHtml += "<p>";
        if (currentDateArr && currentDateArr.data && currentDateArr.data.length > 0) {
            var flag = showCalendarPoint(currentDateArr.data);
            if (flag == 1 || flag == 3 || flag == 11 || flag == 13) {
                eleHtml += "<a class='circle-5-red sub'></a>";
            }
            if (flag == 2 || flag == 3 || flag == 12 || flag == 13) {
                eleHtml += "<a class='circle-5-blue sub'></a>";
            }
            if (flag == 10 || flag == 11 | flag == 12 | flag == 13) {
                eleHtml += "<a class='circle-5-yellow sub'></a>";
            }
        }else{
            eleHtml += "<a class='circle-5-trans sub'></a>";
        }
        eleHtml += "</p>";
        eleHtml += "</span>";
        eleHtml += "</div>";
        return eleHtml;
    }


    /********
     * 浮点数乘法运算
     * 保留两位小数
     * @param arg1
     * @param arg2
     * @returns {number}
     * @constructor
     */
    function FloatMul(arg1,arg2) {
        var m=0,s1=arg1.toString(),s2=arg2.toString();
        try{m+=s1.split(".")[1].length}catch(e){}
        try{m+=s2.split(".")[1].length}catch(e){}
        return Number(s1.replace(".",""))*Number(s2.replace(".",""))/Math.pow(10,m);
    }

    /******
     * 显示详情数据
     * @param element
     * @returns {string}
     */
    function addMainHTML(element) {
        var eleHtml = "";
        var code = (element.stockCode&&element.stockCode.length>0?element.stockCode:element.bndCode);
        var isCalendarStocks= (element.stockCode&&element.stockCode.length>0?"1":"0");
        eleHtml += "<li class='sub mt15' data-index='"+isCalendarStocks+"' data-isbj='"+element.isbj+"' data-flag='"+element.market+"' data-id='"+code+"'>";
        eleHtml += "<p class='text-size-16 color-title ui layout'>" + (element.stockName&&element.stockName.length>0?element.stockName:element.bndName);
        eleHtml += "<a class='margin-left-10 color-content text-size-16'>" + (element.stockCode&&element.stockCode.length>0?element.stockCode:element.bndCode) + "</a>";
        if (element.bndCode&&element.bndCode.length>0) {
            eleHtml += "<a class='calendarBounds'>债</a>";
        }
        eleHtml += "</p>";
        if (element.type == 1) {//type 1上市 2缴款 3申购
            eleHtml += "<div class='mt5 text-size-14'>最新价格：";
            eleHtml += "<a class='color-red'>"+"--"+"</a>";
            eleHtml += "<a class='margin-left-20 color-content'>涨幅率：";
            eleHtml += "<a class='color-red'>" + "--"+ "</a></a>"
        } else if (element.type == 2) {
            eleHtml += "<div class='mt5 text-size-14'>每中一签需缴款：";
            eleHtml += "<a class='color-red'>" +(element.ballotPrice&&element.ballotPrice.length>0?Number(element.ballotPrice).toFixed(2):'--') + "</a>";
        }else if (element.type == 3) {
            eleHtml += "<div class='mt5 text-size-14'>申购代码：";
            eleHtml += "<a class='color-content'>"+(element.stockCode&&element.stockCode.length>0?element.subscribeCode:element.subscribeCode)+"</a>";
            eleHtml += "<a class='margin-left-20 color-content'>发行价：";
            eleHtml += "<a class='color-content'>" + (element.issuePrice&&element.issuePrice.length>0?Number(element.issuePrice).toFixed(2):'--') + "</a></a>"
        }
        eleHtml += "</div>";
        eleHtml += "</li>";
        return eleHtml;
    }

    /*******
     * 添加今日上市
     * @param element
     * @param todaySSData
     * @param i
     * @returns {string}
     */
    function addTodayMainHTML(element,todaySSDataArr,index) {
        var todaySSData = todaySSDataArr[element.market + ':' + (element.stockCode&&element.stockCode.length>0?element.stockCode:element.bndCode)];
        var eleHtml = "";
        var code = (element.stockCode&&element.stockCode.length>0?element.stockCode:element.bndCode);
        var isCalendarStocks= (element.stockCode&&element.stockCode.length>0?"1":"0");
        eleHtml += "<li class='sub mt15' data-index='"+isCalendarStocks+"' data-isbj='"+element.isbj+"' data-flag='"+element.market+"' data-id='"+code+"'>";
        eleHtml += "<p class='text-size-16 color-title ui layout'>" + (element.stockName&&element.stockName.length>0?element.stockName:element.bndName);
        eleHtml += "<a class='margin-left-10 color-content text-size-16'>" + (element.stockCode&&element.stockCode.length>0?element.stockCode:element.bndCode) + "</a>";
        if (element.bndCode&&element.bndCode.length>0) {
            eleHtml += "<a class='calendarBounds'>债</a>";
        }
        eleHtml += "</p>";
        if (element.type == 1) {//type 1上市 2缴款 3申购
            var now = todaySSData.now;
            if(!!now && element.stockCode){
              now = now.toFixed(2);
            }else if(!!now){
              now = now.toFixed(3);
            }
            eleHtml += "<div class='mt5 text-size-14'>最新价格：";
            eleHtml += "<a class='color-red'>"+(now?now:"--")+"</a>";
            eleHtml += "<a class='margin-left-20 color-content'>涨跌幅：";
            if(todaySSData.uppercent&&todaySSData.uppercent<0){
                eleHtml += "<a class='color-green'>" + (todaySSData.uppercent?FloatMul(todaySSData.uppercent,100).toFixed(2)+"%":"--")+ "</a></a>"
            }else{
                eleHtml += "<a class='color-red'>" + (todaySSData.uppercent?FloatMul(todaySSData.uppercent,100).toFixed(2)+"%":"--")+ "</a></a>"
            }
        } else if (element.type == 2) {
            eleHtml += "<div class='mt5 text-size-14'>每中一签需缴款：";
            eleHtml += "<a class='color-red'>" +(element.ballotPrice&&element.ballotPrice.length>0?Number(element.ballotPrice).toFixed(2):'--') + "</a>";
        }else if (element.type == 3) {
            eleHtml += "<div class='mt5 text-size-14'>申购代码：";
            eleHtml += "<a class='color-content'>"+(element.stockCode&&element.stockCode.length>0?element.subscribeCode:element.subscribeCode)+"</a>";
            eleHtml += "<a class='margin-left-20 color-content'>发行价：";
            eleHtml += "<a class='color-content'>" + (element.issuePrice&&element.issuePrice.length>0?Number(element.issuePrice).toFixed(2):'--') + "</a></a>"
        }
        eleHtml += "</div>";
        eleHtml += "</li>";
        return eleHtml;
    }



    /*********
     * 点击日历按钮事件
     * @param index 0今天
     */
    function clickDate(index) {
        var j=0;
        var yssIndex=0;
        for(j=0;j<dateArr.length;j++){
            if(j==index){
                if(index==0){
                    $(_pageId + ".swiper-wrapper .add"+j+" .day").removeClass("sub");//添加红色外圈
                    $(_pageId + ".swiper-wrapper .add"+j+" .day").removeClass("sub1");//移除红色外圈
                    $(_pageId + ".swiper-wrapper .add"+j+" .day").html("今");//添加红色外圈
                }else{
                    $(_pageId + ".swiper-wrapper .add"+j+" .day").removeClass("sub");//添加红色外圈
                }

                var currentDateArr = getInfoByDate(dateArr[j]);//获取当前日期数
                // 据
                $(_pageId + ".currentYM").html(getDay(dateArr[j],2));
                $(_pageId + ".redLi").hide();
                $(_pageId + ".blueLi").hide();
                $(_pageId + ".yellowLi").hide();
                if (currentDateArr && currentDateArr.data && currentDateArr.data.length > 0) {
                    $(_pageId + ".calendar").show();
                    $(_pageId + ".no_data").hide();
                    var redHtml='';
                    var blueHtml='';
                    var yellowHtml='';
                    var redCount=0;
                    var blueCount=0;
                    var yellowCount=0;
                    for(var x=0;x<currentDateArr.data.length;x++){//3申购 1上市 2缴款
                        var currentData = currentDateArr.data[x];
                        if(currentData.type=="3"){
                            redHtml+=addMainHTML(currentData);
                            redCount=redCount+1;
                        }
                        if(currentData.type=="2"){
                            yellowHtml+=addMainHTML(currentData);
                            yellowCount=yellowCount+1;
                        }
                        if(currentData.type=="1"){

                            if(index==0 && todaySSData!=null){
                                blueHtml+=addTodayMainHTML(currentData,todaySSData,yssIndex);
                                yssIndex++;
                            }else{
                                blueHtml+=addMainHTML(currentData);
                            }

                            blueCount=blueCount+1;
                        }
                    }
                    var flag = showCalendarPoint(currentDateArr.data);
                    if (flag == 1 || flag == 3 || flag == 11 || flag == 13) {
                        $(_pageId + ".redLi").show();
                        $(_pageId + ".redMain").html(redHtml);
                        $(_pageId + ".red-background-15").html("申购"+redCount+"只");
                        $.bindEvent($(_pageId + ".redMain li"), function() { // 打新须知
                            var  stock_code=$(this).attr("data-id");
                            var  market=$(this).attr("data-flag");
                            var isCalendarStocks = $(this).attr("data-index");
                            var isbj = $(this).attr("data-isbj");
                            $.setSStorageInfo("nsb_isCalendarStocks",isCalendarStocks,true);
                            $.setSStorageInfo("nsb_stock_code",stock_code,true);
                            if(isbj === 'true'){
                                $.setSStorageInfo("nsb_market",'BJ',true);
                            }else{
                                $.setSStorageInfo("nsb_market",market,true);
                            }
                            $.setSStorageInfo("nsb_calendar","0",true);
                            $.pageInit(pagecode,"nsb/detail",{},true);
                        });
                    }
                    if (flag == 2 || flag == 3 || flag == 12 || flag == 13) {
                        $(_pageId + ".blueLi").show();
                        $(_pageId + ".blueMain").html(blueHtml);
                        $(_pageId + ".blue-background-15").html("上市"+blueCount+"只");
                        $.bindEvent($(_pageId + ".blueMain li"), function() { // 打新须知
                            var  stock_code=$(this).attr("data-id");
                            var  market=$(this).attr("data-flag");
                            var isCalendarStocks = $(this).attr("data-index");
                            var isbj = $(this).attr("data-isbj");
                            $.setSStorageInfo("nsb_isCalendarStocks",isCalendarStocks,true);
                            $.setSStorageInfo("nsb_stock_code",stock_code,true);
                            if(isbj === 'true'){
                                $.setSStorageInfo("nsb_market",'BJ',true);
                            }else{
                                $.setSStorageInfo("nsb_market",market,true);
                            }
                            $.setSStorageInfo("nsb_calendar","0",true);
                            $.pageInit(pagecode,"nsb/detail",{},true);
                        });
                    }
                    if (flag == 10 || flag == 11 | flag == 12 | flag == 13) {
                        $(_pageId + ".yellowLi").show();
                        $(_pageId + ".yellowMain").html(yellowHtml);
                        $(_pageId + ".yellow-background-15").html("缴款"+yellowCount+"只");
                        $.bindEvent($(_pageId + ".yellowMain li"), function() { // 打新须知
                            var  stock_code=$(this).attr("data-id");
                            var  market=$(this).attr("data-flag");
                            var isCalendarStocks = $(this).attr("data-index");
                            var isbj = $(this).attr("data-isbj");
                            $.setSStorageInfo("nsb_isCalendarStocks",isCalendarStocks,true);
                            $.setSStorageInfo("nsb_calendar","0",true);
                            $.setSStorageInfo("nsb_stock_code",stock_code,true);
                            if(isbj === 'true'){
                                $.setSStorageInfo("nsb_market",'BJ',true);
                            }else{
                                $.setSStorageInfo("nsb_market",market,true);
                            }
                            $.pageInit(pagecode,"nsb/detail",{},true);
                        });
                    }
                } else{
                    $(_pageId + ".calendar").hide();
                    $(_pageId + ".no_data").show();

                }
            }else{
                $(_pageId + ".swiper-wrapper .add"+j+" .day").addClass("sub");//移除红色外圈
                if(j==0){
                    $(_pageId + ".swiper-wrapper .add"+j+" .day").addClass("sub1");//添加红色外圈
                }
            }
        }

    }

    /**********
     * 获取最新价
     * @param stock_list
     */
    function getLastPrice(stock_list) {
        var param={
            "stock_list":stock_list,
        }
        todaySSData = {};
        // 按照查询的代码列表设置hash表
        var list = param.stock_list.split('|');
        list.forEach(function(item){
          todaySSData[item] = {
            name:'',  
            market:item.split(":")[0],
            now:'',
            uppercent:'',
          };
        });
        service_hq.getStockNowPrice(param, function (data) {
            if (data){
                if(data.errorNo == 0){
                  // 把返回的数据填充到hash表中
                  for(var i = 0; i < data.results.length;i++){
                    var stock = data.results[i];
                    var name = stock[0];// 名称
                    var code = stock[1];// 代码
                    var market = stock[9];// 市场
                    var now = stock[2];// 现价
                    var uppercent = stock[12];//涨幅
                    todaySSData[market + ':' + code] = {
                      name:name,  
                      market:market,
                      now:now,
                      uppercent:uppercent,
                    };
                  }
                    clickDate(0);
                }else{
                    clickDate(0);
                }
            }else{
                clickDate(0);
            }
        });


    }


    /******
     * 根据日期获取日
     * @param pubdate 2020-12-08
     * @param flag 1、获取 08 2、获取 2020年12月
     * @returns {*|string}
     */
    function getDay(pubdate,flag) {
        var arr = pubdate.split("-")
        if(flag==1){
            return arr[2];
        }else{
            return arr[0]+"年"+arr[1]+"月";
        }
    }

    /***********
     * 获取今天得日期
     * @returns {string}YYYY-MM-DD
     */
    function getNowFormatDate() {
        var date = new Date();
        var seperator1 = "-";
        var year = date.getFullYear();
        var month = date.getMonth() + 1;
        var strDate = date.getDate();
        if (month >= 1 && month <= 9) {
            month = "0" + month;
        }
        if (strDate >= 0 && strDate <= 9) {
            strDate = "0" + strDate;
        }
        var currentdate = year + seperator1 + month + seperator1 + strDate;
        return currentdate;
    }

    /********
     * 比较两个日期的大小
     * @param date1
     * @param date2
     * @return true date1大 false date2大
     */
    function dateCompare(date1,date2){
        var oDate1 = new Date(date1);
        var oDate2 = new Date(date2);
        if(oDate1.getTime() > oDate2.getTime()){
            return true;
        } else {
            return false;
        }
    }

    /**********
     * 显示'点'样式  flag 1申购 2上市 10缴款
     * return 0、无数据 1、申购 2、上市 3、申购+上市 10、缴款 11、申购+缴款 12、上市+缴款 13、申购+上市+缴款
     */
    function showCalendarPoint(data) {
        var SGFlag = 0;//1申购
        var SSFlag = 0;//2上市
        var JKFlag = 0;//10缴款
        if (data && data.length != 0) {
            for (var i = 0; i < data.length; i++) {
                if ('1' == data[i].type) {
                    SSFlag = 2;
                }
                if ('2' == data[i].type) {
                    JKFlag = 10;
                }
                if ('3' == data[i].type) {
                    SGFlag = 1;
                }
            }
        }
        return SGFlag + SSFlag + JKFlag;
    }

    /**
     * 根据日期字符串获取星期几
     * @param dateString 日期字符串（如：2020-05-02）
     * @returns {日一二三四五六}七选一
     */
    function getWeekByDate(dateString) {
        var dateArray = dateString.split("-");
        date = new Date(dateArray[0], parseInt(dateArray[1] - 1), dateArray[2]);
        return "日一二三四五六".charAt(date.getDay());
    };

    /*********
     * 根据日期筛选获取对应的数据
     */
    function getInfoByDate(pubdate) {
        var currentDateArr;
        for (var i = 0; i < dest.length; i++) {
            if (pubdate == dest[i].pubdate) {
                currentDateArr = dest[i];
                break
            }
        }
        return currentDateArr;
    }

    /********
     * 按时间排序
     * @param arr
     * @param order asc升序 desc降序
     * @param sortBy
     * @returns {*}
     */
    function JsonSort(json, key) {
        for (var j = 1, jl = json.length; j < jl; j++) {
            var temp = json[j],
                val = temp[key],
                i = j - 1;
            while (i >= 0 && json[i][key] > val) {
                json[i + 1] = json[i];
                i = i - 1;
            }
            json[i + 1] = temp;

        }
        return json;
    }

    /**********
     * 获取两日期之间日期列表函数
     * @param stime 初始日期 初始日期大于今天以今天为准 初始日期小于等于今天以初始日期为准
     * @param etime 结束日期
     */
    function getdiffdate(stime, etime) {
        //初始化日期列表，数组
        var diffdate = new Array();
        var i = 0;
        //开始日期小于等于结束日期,并循环
        if(dateCompare(stime,getNowFormatDate())){
            stime = getNowFormatDate();
        }

        while (stime <= etime) {
            diffdate[i] = stime;
            stime = dayjs(stime).add(1, 'day').format('YYYY-MM-DD');
            //增加数组key
            i++;
        }
        return diffdate;
    }

    /********
     * 按时间分组
     * @param arr
     */
    function group(arr) {
        var map = {}, dest = [];
        for (var i = 0; i < arr.length; i++) {
            var ai = arr[i];
            if (!map[ai.pubdate] && ai.pubdate) {
                dest.push({
                    pubdate: ai.pubdate,
                    data: [ai]
                });
                map[ai.pubdate] = ai;
            } else if(ai.pubdate) {
                for (var j = 0; j < dest.length; j++) {
                    var dj = dest[j];
                    if (dj.pubdate == ai.pubdate) {
                        dj.data.push(ai);
                        break;
                    }
                }
            }
        }
        return dest;
    }


    /**
     * 事件绑定
     */
    function bindPageEvent() {
        $.bindEvent($(_pageId + ".icon_back"), function() { // 返回
            $.pageBack();
        });

        $.bindEvent($(_pageId + "header .reserve"), function() { // 打新须知
            $.pageInit(pagecode,"nsb/help",{},true);
        });
    }

    /**
     * 数据重置
     */
    function destroy() {
         html = '';
         dest=null;//获取到的完整数据
         dateArr=null;//计算获取的日期区间
         selectIndex=-1;
         todaySSData=null;//今日上市最新价
        service.destroy();
    }

    var base = {
        "init": init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
