define('trade/scripts/nsb/detail.js', function (require, exports, module) { // 行情设置页面
    var gconfig = $.config;
    var global = gconfig.global;
    var service = require("service_stock");
    var service_hq = require("service_hq");
    var service_xkj = require("service_xkj");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var _pageId = "#nsb_detail ";
    var pagecode = "nsb/detail";

    var stock_code = '';
    var market = '';

    var stockFlag = "0";//true表示新股 false表示新债
    
    var bjsFlag = "";//0表示北交所

    var selectIndex=-1;

    var detailData=null;

    var stock_type=null;

    var calendar ="1";
    var isCalendarStocks="";//打新日历跳转过来的

    function init() { // 初始化

    }

    function load() {

        if(commonFunc.hasSaveStr("stockFlag")){
            stockFlag = commonFunc.getSaveStr("stockFlag","0");
        }

        if(commonFunc.hasSaveStr("nsb_calendar")){
            calendar = commonFunc.getSaveStr("nsb_calendar",false);
        }

        if(calendar=="0"){
            if(commonFunc.hasSaveStr("nsb_isCalendarStocks")){
                isCalendarStocks = commonFunc.getSaveStr("nsb_isCalendarStocks","");
            }
        }

        if(commonFunc.hasSaveStr("nsb_stock_code")){
            stock_code = commonFunc.getSaveStr("nsb_stock_code","");
        }

        if(commonFunc.hasSaveStr("nsb_market")){
            market = commonFunc.getSaveStr("nsb_market","");
        }
        if(calendar=="0"&&null!=isCalendarStocks&&isCalendarStocks!=""&&isCalendarStocks.length>0){
            if(isCalendarStocks=="1"){
                $(_pageId + ".stocks").show();
                $(_pageId + ".bonds").hide();
            }else{
                $(_pageId + ".stocks").hide();
                $(_pageId + ".bonds").show();
            }
        }else{
            if(stockFlag=="0"){
                $(_pageId + ".stocks").show();
                $(_pageId + ".bonds").hide();
            }else{
                $(_pageId + ".stocks").hide();
                $(_pageId + ".bonds").show();
            }
        }



        getNSBStockType()
        //更新数据
        getNewStockInfo();
        
    }

    function getNSBStockType(stockcode) {
        var m =market;
        if (market == "0" || market == "1") {
            m="SZ";
        } else if (market == "2" || market == "3") {
            m="SH";
        } else if(market === 'BJ'){
            m="SZ";
        }
        var param = {
          "stock_list": (m+":"+ (stockcode || stock_code)),
        };
        service_hq.getNSBStockType(param,function (data) {
            $.hidePreloader();
            if(data){
                if(data.errorNo==0){
                    if(data.results&&data.results.length>0){
                        stock_type = data.results[0][0];
                        if(null!=stock_type){
                            $(_pageId + ".gotoHQText" ).show();
                            $(_pageId + ".gotoHQArrow" ).show();
                        }else{
                            $(_pageId + ".gotoHQText" ).hide();
                            $(_pageId + ".gotoHQArrow" ).hide();
                        }
                    }else{
                        $(_pageId + ".gotoHQText" ).hide();
                        $(_pageId + ".gotoHQArrow" ).hide();
                    }
                }else{
                    $(_pageId + ".gotoHQText" ).hide();
                    $(_pageId + ".gotoHQArrow" ).hide();

                }
            }else{
                $(_pageId + ".gotoHQText" ).hide();
                $(_pageId + ".gotoHQArrow" ).hide();

            }
        });
        
    }

    function bindPageEvent() { // 页面元素事件绑定方法

        $.bindEvent($(_pageId + ".icon_back"), function() { // 返回
            $.pageBack();
        });

        $.bindEvent($(_pageId + ".gotoHQText"), function() { // 查看行情
            if(detailData==null||detailData=="undefined"||detailData.length==0){
                return;
            }

            if(calendar=="0"&&null!=isCalendarStocks&&isCalendarStocks!=""&&isCalendarStocks.length>0){
                if(isCalendarStocks=="1"){
                    gotoHQ(stock_type,detailData.market.replace('BJ','SZ'),detailData.stockCode,detailData.stockName);
                }else{
                    gotoHQ(stock_type,detailData.market.replace('BJ','SZ'),detailData.bndCode,detailData.bndName);
                }
            }else{
                if(stockFlag=="0"){
                    gotoHQ(stock_type,detailData.market.replace('BJ','SZ'),detailData.stockCode,detailData.stockName);
                }else{
                    gotoHQ(stock_type,detailData.market.replace('BJ','SZ'),detailData.bndCode,detailData.bndName);
                }
            }

        });
        $.bindEvent($(_pageId + ".nsb_more_info"), function() { 
            // F10-白色主题
            // 沪深A和北证
            // https://6mwo9al63.lightyy.com/index.html?p=hsjy_1167&s=600000&section=f10&h=0&tg=_blank&nuflag=1
            // 其中固定参数
            // section=f10&h=0&tg=_blank&nuflag=1&p=hsjy_1167

            // 科创板
            // https://2dqvih6in.lightyy.com/index.html?p=hsjy_1167&s=688001&section=f10&h=0&tg=_blank&nuflag=1
            // 其中固定参数
            // section=f10&h=0&tg=_blank&nuflag=1&p=hsjy_1167
            if(detailData){
                var url = "https://6mwo9al63.lightyy.com/index.html?p=hsjy_1167&section=f10&h=0&tg=_blank&nuflag=1";
                if(detailData.stockFlag === "1"){
                    url = "https://2dqvih6in.lightyy.com/index.html?p=hsjy_1167&section=f10&h=0&tg=_blank&nuflag=1";
                }
                url += "&s=" + detailData.stockCode;
                // private String shareTitle;//分享标题
                // private String shareContent;//分享内容
                // private String shareUrl;//分享连接
                // private String isCanShare;//是否显示分享按钮 0不显示 1显示 默认1显示
                $.callMessage({
                    "funcNo": "501156",
                    "url": url,
                    "stockName": detailData.stockName,
                    "stockMarket": detailData.market,
                    "stockCode": detailData.stockCode,
                    "isCanShare": "0",
                });
            }
        });
    }


    /*******
     * 跳转行情
     * @param stockType
     * @param stockMarket
     * @param stockCode
     * @param stockName
     */
    function gotoHQ(stockType,stockMarket,stockCode,stockName) {
        if(global.callNative){
            if(gconfig.platform == "2"){
                var param = {
                    "stockMarket": stockMarket,
                    "stockCode": stockCode,
                    "stockName": stockName,
                    "moduleName" : "self-stock",
                    "funcNo":"60105"
                };
                $.callMessage(param);
            }
            else{
                var param = {
                    "funcNo": "50500",
                    "msgNo": "201",
                    "targetModule":"hqDispatcher",
                    "sourceModule":"trade",
                    "action":"0",
                    "param":{
                        "stockMarket": stockMarket,
                        "stockCode": stockCode,
                        "stockName": stockName,
                    }
                }
                $.callMessage(param);
            }
        }else{
            var stockInfo = {
                "market":stockMarket,
                "stockCode":stockCode,
                "stockName":stockName,
                "moduleName" : "trade"
            }
            window.location.href = gconfig.seaBaseUrl + "hq/index.html#!/hq/ggStockInfo.html?stockInfo=" + JSON.stringify(stockInfo);
        }
    }

    /**************
     * 新股20022 subcribeCode   stockCode  market  id
     * 新债20027  bondCode sgdm catalogid
     * 查询详情
     */
    function getNewStockInfo() {
        var param;
        // 北交所股票不需要进度条，这里隐藏掉
        $(_pageId + '.dates').show();
        if(market === 'BJ'){
          $(_pageId + '.dates').hide();
        }
        if(["0","1","2","3"].indexOf(market)>-1){
            if(calendar=="0"){
                if (isCalendarStocks=="1") {
                    param = {
                        "subcribeCode": stock_code,
                        "trade_code": "1001006",
                    };
                } else {
                    param = {
                        "trade_code": "1001007",
                        "subcribeCode":stock_code,
                    };
                }
            }else{
                if (stockFlag=="0") {
                    param = {
                        "subcribeCode": stock_code,
                        "trade_code": "1001006",
                    };
                } else {
                    param = {
                        "trade_code": "1001007",
                        "subcribeCode":stock_code,
                    };
                }
            }
            param.market = commonHq.getHqMarket(market);
        }else{
            if(calendar=="0"){
                if (isCalendarStocks=="1") {
                    param = {
                        "stockCode": stock_code,
                        "trade_code": "1001006",
                    };
                } else {
                    param = {
                        "trade_code": "1001007",
                        "bondCode":stock_code,
                    };
                }
            }else{
                if (stockFlag=="0") {
                    param = {
                        "stockCode": stock_code,
                        "trade_code": "1001006",
                    };
                } else {
                    param = {
                        "trade_code": "1001007",
                        "market": market,
                        "bondCode":stock_code,
                    };
                }
            }
            param.market = market;
        }

        service_xkj.getNewStockInfoNew(param, function (data) {
            if (data) {
                if (data.error_no == 0) {
                    if (data.dsName && data.dsName.length > 0) {
                        var result = data["results"];
                        detailData=result;
                        if(result==null||result=="undefined"||result.length==0){
                            return;
                        }
                        var date = new Date();

                        if($.isValue(result.longStockName)) result.stockName = result.longStockName;
                        if($.isValue(result.longBndName)) result.bndName = result.longBndName;
                        $.each(result, function (index, value) {
                            if ("listDate" == index) {
                                value = value ? value : "尚未公布";
                            }
                            if(calendar=="0"&&null!=isCalendarStocks&&isCalendarStocks!=""&&isCalendarStocks.length>0){
                                if(isCalendarStocks=="1"){
                                    if ("issuevol" == index || "applymaxOnline" == index || "sharesOnline" == index) {
                                        value = value ? Number(value) + "股" : "--";
                                    }
                                }else{
                                    if ("issuevol" == index || "applymaxOnline" == index || "sharesOnline" == index) {
                                        value = value ? Number(value) + "张" : "--";
                                    }
                                }
                            }else{
                                if(stockFlag=="0"){
                                    if ("issuevol" == index || "applymaxOnline" == index || "sharesOnline" == index) {
                                        value = value ? Number(value) + "股" : "--";
                                    }
                                }else{
                                    if ("issuevol" == index || "applymaxOnline" == index || "sharesOnline" == index) {
                                        value = value ? Number(value) + "张" : "--";
                                    }
                                }
                            }





                            if ("matchDate"||"payDay"==index||"listDate" == index || "ballotDate" == index || "subscribeDate" == index || "distributiondate" == index) {
                                if (value && new Date(value) < date) {
                                    $(_pageId + ".nsb_padtopwu ." + index).parents("li").addClass("check");
                                } else {
                                    $(_pageId + ".nsb_padtopwu ." + index).parents("li").removeClass("check");
                                }
                            }

                            if ("market" == index) {
                                if(value == "SH"){
                                  value = "沪";
                                }else if(value == "BJ"){
                                  value = "京";
                                }else{
                                  value = "深";
                                }
                                if(value=="深"){
                                  $(_pageId + ".nsb_conveible .row_01 em").removeClass("red");
                                }else{
                                  $(_pageId + ".nsb_conveible .row_01 em").addClass("red");
                                }
                            }

                            if(calendar=="0"&&null!=isCalendarStocks&&isCalendarStocks!=""&&isCalendarStocks.length>0){
                                if(isCalendarStocks=="1"){
                                    if ("stockName" == index) {
                                        $(_pageId + ".header ." + index).html(value ? value : "--");
                                    }
                                }else{
                                    if ("bndName" == index) {
                                        $(_pageId + ".header ." + "stockName").html(value ? value : "--");
                                    }
                                }
                            }else{
                                if(stockFlag=="0"){
                                    if ("stockName" == index) {
                                        $(_pageId + ".header ." + index).html(value ? value : "--");
                                    }
                                }else{
                                    if ("bndName" == index) {
                                        $(_pageId + ".header ." + "stockName").html(value ? value : "--");
                                    }
                                }
                            }



                            if("zgyjl"==index){
                                value = value ? Number(value).toFixed(2) + "%" : "--";
                            }

                            if("kzgPrice"==index||"convertprice"==index||"zgjz"==index||"issuePrice"==index){
                                value = value ? Number(value).toFixed(2) : "--";
                            }

                            $(_pageId + ".nsb_padtopwu ." + index).html(value ? value : "--");
                            // 正股名称长名称兼容处理
                            if ("stockName" == index) {
                                $(_pageId + ".nsb_padtopwu ." + index).css('font-size',$.getTransformScaleFontSize(value ? value : "--", 16, 74))
                            }
                        });
                    }
                }
            }
        });
    }

    /********
     * 浮点数除法运算
     * @param arg1
     * @param arg2
     * @returns {number}
     * @constructor
     */
    function FloatDiv(arg1,arg2){
        var t1=0,t2=0,r1,r2;
        try{t1=arg1.toString().split(".")[1].length}catch(e){}
        try{t2=arg2.toString().split(".")[1].length}catch(e){}
        with(Math){
            r1=Number(arg1.toString().replace(".",""));
            r2=Number(arg2.toString().replace(".",""));
            return (r1/r2)*pow(10,t2-t1);
        }
    }

    function destroy() { // 销毁
         stock_code = '';
        market = '';

        stockFlag = "0";//true表示新股 false表示新债

        selectIndex=-1;

        detailData=null;

        stock_type=null;

         calendar ="";
        isCalendarStocks="";//打新日历跳转过来的
        $(_pageId + ".gotoHQText" ).hide();
        $(_pageId + ".gotoHQArrow" ).hide();
        $(_pageId + ".reset").html("--");
        $(_pageId + ".reset1").html("");
        service.destroy();
    }

    var set = {
        "init": init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = set;
});
