/**
 * 普通交易-买入
 */
define('trade/scripts/nsb/index.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var publicService = require("service_common");
    var service = require("service_stock");
    var service_xkj = require("service_xkj");
    var service_third = require("service_third");
    var _pageId = "#nsb_index ";
    var pagecode = "nsb/index";
    var nativePluginService = require("nativePluginService");
    var keyboard = require("keyboard");
    var appropriate = require("appropriate");
    require("validatorUtils");
    var validator = $.validatorUtils;
    var validatorUtil = $.validatorUtils;

    var isStocks = true;//true新股 false新债
    var isBjs = false; // 是否北交所
    var checkDate = '';//待申购，做对比的日期，判断前一个日期和当前是否一样，一样就不显示头部日期，不一样就显示
    var selectIndex = 1;//选择的索引，默认今日申购
    var is_login = "0";//0未登录 1已登录

    var userInfo;//用户信息

    var jrsgLoginData;//今日申购登录数据

    var isFirstIn = "0";//0表示首次进入，1表示已经进入

    var stockListSize = "0";//新股数量
    var bondListSize = "0";//新债数量
    var bjsListSize = "0";//北证数量

    var quotaList = {
        "SZ": 0,
        "SH": 0,
        "KC": 0,
    };
    var paramMap = null;//上个页面传递过来的数据
    var newStockType = "0";//0普通交易 1信用账户
    var jurisdiction = null;
    var stockFlag = "";//0表示新股 1表示新债
    var bjsFlag = "";//0表示北交所
    var bjsRight = "";//北交所权限，1代表有权限
    var uuid;
    var fist_agree = "";
    var second_agree = "";
    var agree_id = "";


    /**********
     * 初始化
     */
    function init() {
        var isFromApp = $.getPageParam("isFromApp");
        if (isFromApp == "true") {//从其他模块跳转过来做标识转义
            $.setSStorageInfo("app_third", "native");
            $.setSStorageInfo("app_third_mainpage", "nsb_index");
        }
        common.pageChangeHeight();
        //  clearIntentParam();
        isStocks = true;//true新股 false新债
        checkDate = '';//待申购，做对比的日期，判断前一个日期和当前是否一样，一样就不显示头部日期，不一样就显示
        selectIndex = 1;//选择的索引，默认今日申购
        is_login = "0";//0未登录 1已登录

        userInfo = null;//用户信息

        jrsgLoginData = null;//今日申购登录数据

        isFirstIn = "0";//0表示首次进入，1表示已经进入

        stockListSize = "0";//新股数量
        bondListSize = "0";//新债数量
        bjsListSize = "0";//新债数量

        quotaList = {
            "SZ": 0,
            "SH": 0,
            "KC": 0,
        };
        paramMap = null;//上个页面传递过来的数据
        newStockType = "0";//0普通交易 1信用账户
        jurisdiction = null;
        common.setMainHeight(_pageId, false);
        if (isIphoneX()) {
            $(_pageId + ".footer1").addClass(".nsb_padding-bottom-33");
            $(_pageId + ".footer2").addClass(".nsb_padding-bottom-33");
        }
        pageInit();
        if (keyboard) {
            keyboard.keyInit();
        }
        window.onresize= function(){
            common.setMainHeight(_pageId, false);
        };
    }

    function load() {
        clearIntentParam();
        if (null != $.getCurrentPageObj() && null != $.getCurrentPageObj().param) {
            if (null != $.getCurrentPageObj().param.param) {
                paramMap = $.getCurrentPageObj().param.param;
            } else {
                paramMap = $.getCurrentPageObj().param;
            }
        }
        if (null == paramMap && null != $.getPageParam("param")) {
            paramMap = $.getPageParam("param");
        }

        if (null == paramMap &&null != $.getCurrentPageObj() && null != $.getCurrentPageObj().params) {
            if (null != $.getCurrentPageObj().params.param) {
                paramMap = $.getCurrentPageObj().params.param;
            } else {
                paramMap = $.getCurrentPageObj().param;
            }
        }

        if (paramMap && Object.getOwnPropertyNames(paramMap).length != 0) {
            if (paramMap && typeof (paramMap) == "string") {
                paramMap = JSON.parse(paramMap);
            }

            if (paramMap.switchUserInfo != null && paramMap.switchUserInfo.length > 0) {
                newStockType = paramMap.switchUserInfo;
            }
            // 处理字符串boolean
            if(typeof paramMap.isStocks === 'string' && paramMap.isStocks === 'true'){
              paramMap.isStocks = true;
            }else if(typeof paramMap.isStocks === 'string' && paramMap.isStocks === 'false'){
              paramMap.isStocks = false;
            }
            // 处理字符串boolean
            if(typeof paramMap.isBjs === 'string' && paramMap.isBjs === 'true'){
              paramMap.isBjs = true;
            }else if(typeof paramMap.isBjs === 'string' && paramMap.isBjs === 'false'){
              paramMap.isBjs = false;
            }

            if(paramMap.param && paramMap.param.selectIndex !== undefined){
                selectIndex = paramMap.param.selectIndex;
            }

            isStocks = paramMap.isStocks;
            isBjs = paramMap.isBjs;
        }
       // var switchUserInfo = paramMap.switchUserInfo || "0";
        common.switchingCurUser(newStockType);//切换用户
        userInfo = common.getCurUserInfo();
        getIntentParam();
        // 信用交易不展示北交所
        if(newStockType === '1'){
          $(_pageId + ".nsb_header_tab ul li:eq(2)").hide();
        }else{
          $(_pageId + ".nsb_header_tab ul li:eq(2)").show();
        }
        if (userInfo && common.isEmptyObject(userInfo)) {//登录的情况
            is_login = "1"
            hasRight(); // 查询北交所权限
            queryDJKData();////代缴款列表查询
            commonFunc.getJurisdiction(userInfo, function (jur) {
                jurisdiction = jur;
            });
            function399933();
        }
        queryListAmount();
    }

    function pageInit() {
        $(_pageId + ".no_data").hide(); // 今日无新股发行,试试预约打新
        $(_pageId + ".nsb-yydxg").show(); // 新股-预约打新股-按钮
        $(_pageId + ".nsb-yydxz").hide(); // 新股-预约打新债-按钮
        $(_pageId + ".footer1").hide();  // 一键申购
        $(_pageId + ".footer2").hide(); // 底部 登录即可预约打新
        // $(_pageId + ".onclikput").hide();  // 底部 申购时间：09:15-11:30，13:00-15:00
        $(_pageId + '.circle-15-red').hide(); // 新股-今日申购-红点条数
        $(_pageId + ".circle-10-red").hide(); // 新股-代缴款-红点条数
        $(_pageId + ".djk_tips").hide();     // 新股-您今日有2笔待缴款，请保证账户可用资金余额充足 提示
        $(_pageId + ".djk_tips_line").show();
        $(_pageId + ".nsb-dxrl").show(); // 新股-四个按钮-打新日历
    }


    /*********
     * 获取传递到下一个页面的参数
     */
    function getIntentParam() {
        if (commonFunc.hasSaveStr("switchUserInfo")) {
            newStockType = commonFunc.getSaveStr("switchUserInfo", "0");
        }

        if (commonFunc.hasSaveStr("stockFlag")) {
            stockFlag = commonFunc.getSaveStr("stockFlag", "0");
            if (stockFlag == "0") {
                isStocks = true;
            } else {
                isStocks = false;
            }
        }

        if (commonFunc.hasSaveStr("bjsFlag")) {
          bjsFlag = commonFunc.getSaveStr("bjsFlag", "0");
            if (bjsFlag == "0") {
                isBjs = true;
            } else {
              isBjs = false;
            }
        }
        if (commonFunc.hasSaveStr("isFirstIn")) {
            isFirstIn = commonFunc.getSaveStr("isFirstIn", "0");
        }

        if (commonFunc.hasSaveStr("selectIndex")) {
            selectIndex = Number(commonFunc.getSaveStr("selectIndex", "1"));
        }

        if (commonFunc.hasSaveStr("stockListSize")) {
            stockListSize = commonFunc.getSaveStr("stockListSize", "0");
        }

        if (commonFunc.hasSaveStr("bondListSize")) {
            bondListSize = commonFunc.getSaveStr("bondListSize", "0");
        }

        if (commonFunc.hasSaveStr("bjsListSize")) {
          bjsListSize = commonFunc.getSaveStr("bjsListSize", "0");
        }
    }


    /***********
     * 设置进入下一个页面的保存的参数参数
     */
    function setIntentParam() {
        $.setSStorageInfo("switchUserInfo", newStockType, true);
        $.setSStorageInfo("isFirstIn", isFirstIn, true);
        $.setSStorageInfo("selectIndex", selectIndex + "", true);
        $.setSStorageInfo("stockListSize", stockListSize, true);
        $.setSStorageInfo("bjsListSize", bjsListSize, true);
        $.setSStorageInfo("bondListSize", bondListSize, true);
        if (isBjs) {
          $.setSStorageInfo("bjsFlag", "0", true);
          $.setSStorageInfo("stockFlag", "0", true);
        } else if (isStocks) {
            $.setSStorageInfo("stockFlag", "0", true);
            $.setSStorageInfo("bjsFlag", "1", true);
        } else {
            $.setSStorageInfo("stockFlag", "1", true);
            $.setSStorageInfo("bjsFlag", "1", true);
        }
    }

    /*********
     * 清除缓存
     */
    function clearIntentParam() {
        $.setSStorageInfo("isJK", "", true);
        $.setSStorageInfo("nsb_sg_pageInfo", "", true);
        $.setSStorageInfo("nsb_sg_index", "", true);
        $.setSStorageInfo("nsb_stock_code", "", true);
        $.setSStorageInfo("nsb_market", "", true);
        $.setSStorageInfo("nsb_results", "", true);
        $.setSStorageInfo("nsb_entrustResults", "", true);

        $.setSStorageInfo("nsb_isCalendarStocks","",true);
        $.setSStorageInfo("nsb_calendar","",true);
        $.setSStorageInfo("nsb_stock_code","",true);
        $.setSStorageInfo("nsb_market","",true);
        $.setSStorageInfo("nsb_calendar","",true);
    }


    /**
     * 事件绑定
     */
    function bindPageEvent() {
        $.bindEvent($(_pageId + "header .icon_back"), function () { // 返回
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                $.pageBack();
            });
            // $.pageInit(pagecode,"account/index",{"_loginClass":newStockType});
        });

        $.bindEvent($(_pageId + ".nsb_header_tab ul li:eq(0)"), function () { // 新股
            $.clearRequest();
            isStocks = true;
            isBjs = false;
            topTabChange();
            if(is_login === "1"){
                function399933();
            }
        });

        $.bindEvent($(_pageId + ".nsb_header_tab  ul li:eq(1)"), function () { // 新债
            $.clearRequest();
            isStocks = false;
            isBjs = false;
            topTabChange();
        });

        $.bindEvent($(_pageId + ".nsb_header_tab  ul li:eq(2)"), function () { // 北交所
            $.clearRequest();
            isStocks = true;
            isBjs = true;
            topTabChange();
        });

        $.bindEvent($(_pageId + "header .nsb_dxxz"), function () { // 打新须知
            setIntentParam();
            $.pageInit(pagecode, "nsb/help", {}, true);
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-djk"), function () { // 待缴款
            setIntentParam();
            var islogin = isTradeLogin();
            if(!islogin){
                return;
            }
            $.setSStorageInfo("isJK", "0", true);
            $.pageInit(pagecode, "nsb/sgjk", {}, true);
        });
        $.bindEvent($(_pageId + ".fund_table2 .nsb-sgcx"), function () { // 申购查询
            setIntentParam();
            var islogin = isTradeLogin();
            if(!islogin){
                return;
            }
            $.setSStorageInfo("isJK", "1", true);
            $.setSStorageInfo("isJK", "1");
            $.pageInit(pagecode, "nsb/sgjk", {}, true);
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-zghs"), function () { // 转股回售
            setIntentParam();
            var islogin = isTradeLogin();
            if(!islogin){
                return;
            }
            if (newStockType && newStockType == "1") {
                $.pageInit(pagecode, "credit/debtzg/converHS", {}, true);
            } else {
                $.pageInit(pagecode, "debtzg/converHS", {}, true);
            }
        });


        $.bindEvent($(_pageId + ".fund_table2 .nsb-yydxg"), function (e) { // 预约打新
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            setIntentParam();
            openTJD();
            e.stopPropagation();	// 阻止冒泡
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-yydxz"), function (e) { // 预约打新
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            setIntentParam();
            openTJD();
            e.stopPropagation();	// 阻止冒泡
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-dxrl"), function () { // 打新日历
            setIntentParam();
            $.pageInit(pagecode, "nsb/calendar", {}, true);
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-wdsg"), function () { // 北交所-我的申购
            setIntentParam();
            var islogin = isTradeLogin();
            if(!islogin){
                return;
            }
            $.pageInit(pagecode, "nsb/wdsg", {}, true);
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-xjcx"), function () { // 北交所-询价查询
            setIntentParam();
            var islogin = isTradeLogin();
            if(!islogin){
                return;
            }
            $.pageInit(pagecode, "nsb/xjcx", {}, true);
        });

        $.bindEvent($(_pageId + ".fund_table2 .nsb-dxgl"), function () { // 北交所-打新攻略
          setIntentParam();
          $.pageInit(pagecode, "bjs/publicOffering/bidHelp", {}, true);
        });

        $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(0)"), function () { // 待申购
            $.clearRequest();
            showMainView(0);
        });
        $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(1)"), function () { // 今日申购
            $.clearRequest();
            showMainView(1);
        });
        $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(2)"), function () { // 待上市
            $.clearRequest();
            showMainView(2);
        });
        $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(3)"), function () { // 已上市
            $.clearRequest();
            showMainView(3);
        });
        $.bindEvent($(_pageId + ".btn"), function () { //一键申购
          if ($(this).hasClass("default")) return;
          if(!isBjs){
            if (!$(_pageId + ".btn").hasClass("default")) {
                if(second_agree && isStocks){
                    common.singleIConfirmNew("新股申购特别提示", second_agree, function () {
                        var stocks = [];
                        for (var i = 0; i < jrsgLoginData.stockList.length; i++) {
                            if ($(_pageId + ".jrsg" + i).hasClass("act")) {
                                var curr = jrsgLoginData.stockList[i];
                                var stock_code = curr.stock_code;
                                stocks.push(stock_code);
                            }
                        }
                        var paraMap = {
                            agree_type: "2",
                            stock_code: stocks.join(","),
                            text_content: second_agree,
                        }
                        appropriate.function399934(paraMap,function(data){
                            if(data.error_no == "0"){
                                agree_id = data.results[0].id;
                            }
                        });
                        commitCheck(jrsgLoginData);
                    }, "我知道了",undefined,undefined,undefined,"xgxz");
                }else{
                    commitCheck(jrsgLoginData);
                }
            }
          }else{
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var results = [];
            $(_pageId + ".conveible .act").each(function () {
                results.push(JSON.parse($(this).parent().parent().attr("element")));
            });
            if (bjsRight !== '1') {
              common.iConfirm("温馨提示", "您尚未开通北交所交易权限，如需进行交易，请到业务办理完成对应权限开通。", function success(html) {
                  if (global.callNative && global.isSso) {
                    setIntentParam();
                    var moduleName = + new Date();
                    $.callMessage({
                        "funcNo": "50115",
                        "loadModuleName": "ygt",
                        "moduleName": moduleName,
                        "url": global.ygtUrl + "/new/ygt/index.html#!/bzjyOpen/index.html?isFromApp=true&moduleName=" + moduleName,
                        "statusColor": "#EE4034",//状态栏颜色
                        "isShowLoading": "1",
                        "targetModule": "trade"
                    });
                  }
              }, function fail() {
                $(_pageId).css('overflow','hidden');
                common.inputConfirm(_pageId, results, "申购", submitOrder, keyboard);
              }, "开通权限", "取消");
            }else{
              $(_pageId).css('overflow','hidden');
              common.inputConfirm(_pageId, results, "申购", submitOrder, keyboard);
            }
          }
        });

        //登录即可一键申购 or 登录即可预约打新
        $.bindEvent($(_pageId + " .btnSub"), function (e) {
            setIntentParam();
            if (selectIndex == 0) {//预约打新
                openTJD()
            } else {//一键申购
                var topage = "nsb/index";
                if (userInfo && common.isEmptyObject(userInfo)) {//登录的情况
                    setIntentParam();
                    if (pagecode != topage) {
                        $.pageInit(pagecode, topage, {"_loginClass": newStockType, "param": getParam()}, "", true);
                    }
                } else {
                    commonFunc.login(pagecode, "account/login", {
                        "topage": pagecode,
                        "_loginClass": newStockType,
                        "param": getParam()
                    }, {
                        "topage": pagecode,
                        "param": getParam()
                    });
                }
            }
            e.stopPropagation();
        }, "tap");
    }
    // 打开预约打新页面
    function openTJD(){
        setIntentParam();
        var pageCode = $.getCurrentPageObj().pageCode || '';
        $.setSStorageInfo("go_hq_" + pageCode, true);
        // 如果是新债，直接打开恒生条件单-新股新债
        if(!isStocks){
            nativePluginService.function501152({
                "url": global.zntjd + "/h5-web/#/strategy/zndx?tab=zndxKzz",
                "uniqueCode":"",
                "isShowTitleBar": "0",
                "isUseFullScreenH5": "1",
                "loginMode":"2"
            });
            return;
        }
        // 未登录，先唤起登录
        if (is_login == "1") {
            // 判断用户是否签署预约打新的留痕
            service_xkj.require2001033({
                "agreement_no": "appointment_new_stock",
                "client_id": userInfo.cust_code,
                "fund_account": userInfo.fund_account
              }, function (data) {
                  $.hidePreloader();
                  console.log(data);
                  if(data.error_no == "0"){
                    var results = data.results;
                    common.singleIConfirmNew("温馨提示", results.agree_content, function () {
                        nativePluginService.function501152({
                            "url": global.zntjd + "/h5-web/#/strategy/zndx?tab=zndxXg",
                            "uniqueCode":"",
                            "isShowTitleBar": "0",
                            "isUseFullScreenH5": "1",
                            "loginMode":"2"
                        });
                        var paraMap = {
                            agree_type: "3",
                            text_content: results.agree_content,
                        }
                        appropriate.function399934(paraMap)
                    }, "我知道了",undefined,undefined,undefined,"xgxz");
                  }
              }, { //控制参数
                  "isShowWait": false,
              });
        }else{
            commonFunc.login();
        }
        
    }


    function getParam() {
        var param = {
            "isStocks": isStocks,
            "switchUserInfo": newStockType,
            "_loginClass": newStockType
        };
        return param;
    }

    /********
     * 顶部table切换
     */
    function topTabChange() {
        $(_pageId + ".allCheckBox em").removeClass("act"); // 一键申购-全选框
        // $(_pageId + ".onclikput").hide(); // 底部 申购时间：09:15-11:30，13:00-15:00
        common.setNoData(false);
        if(isBjs && isBjs !== 'false'){
          $(_pageId + '.j_bjs_nav').css('display','block'); // 北交所 四个按钮
          $(_pageId + '.j_xgxz_nav').css('display','none'); // 新股新债 四个按钮
          $(_pageId + ".nsb_header_tab  ul li:eq(0)").removeClass("active"); // 顶部-新股按钮
          $(_pageId + ".nsb_header_tab  ul li:eq(1)").removeClass("active"); // 顶部-新债按钮
          $(_pageId + ".nsb_header_tab  ul li:eq(2)").addClass("active"); // 顶部-北交所按钮
          $(_pageId + "header .nsb_dxxz").css('display','none');  // 顶部右侧-打新须知
          $(_pageId + ".nsb_tab_nav ul li a:eq(0)").text('近日询价'); // 北交所-近日询价 tab
          $(_pageId + ".nsb_tab_nav ul li:eq(3)").css('display','none');// 北交所-隐藏已上市 tab
          $(_pageId + ".nsb_jrsg_edcx_bg_main").hide(); // 新股-今日申购-额度展示
          // $(_pageId + ".onclikput").show(); // 底部 申购时间：09:15-11:30，13:00-15:00
          showMainView(selectIndex === 3?1:selectIndex);
        }else if(isStocks && isStocks !== 'false') {
            $(_pageId + '.j_bjs_nav').css('display','none'); // 北交所 四个按钮
            $(_pageId + '.j_xgxz_nav').css('display','block'); // 新股新债 四个按钮
            $(_pageId + "header .nsb_dxxz").css('display','block'); // 顶部右侧-打新须知
            if (newStockType && newStockType != "1") {//信用账户没有预约打新
                $(_pageId + ".nsb-djk").removeClass("three_percent"); // 新股-四个按钮-待缴款
                $(_pageId + ".nsb-sgcx").removeClass("three_percent"); // 新股-四个按钮-申购查询
                $(_pageId + ".nsb-yydxg").removeClass("three_percent"); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").removeClass("three_percent"); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-zghs").removeClass("three_percent"); // 新股-四个按钮-转股回售
                $(_pageId + ".nsb-dxrl").removeClass("three_percent"); // 新股-四个按钮-打新日历
                $(_pageId + ".circle-10-new").removeClass("three_percent"); // 新股-四个按钮-打新日历-右上角new标志
                $(_pageId + ".circle-10-red").removeClass("three_percent"); // 新股-代缴款-红点条数
                $(_pageId + ".nsb-yydxg").show(); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").hide(); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-zghs").hide(); // 新股-四个按钮-转股回售
                $(_pageId + ".nsb-dxrl").show(); // 新股-四个按钮-打新日历
            } else {
                $(_pageId + ".nsb-djk").addClass("three_percent"); // 新股-四个按钮-待缴款
                $(_pageId + ".nsb-sgcx").addClass("three_percent"); // 新股-四个按钮-申购查询
                $(_pageId + ".nsb-yydxg").addClass("three_percent"); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").addClass("three_percent"); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-zghs").addClass("three_percent"); // 新股-四个按钮-转股回售
                $(_pageId + ".nsb-dxrl").addClass("three_percent"); // 新股-四个按钮-打新日历
                $(_pageId + ".circle-10-new").addClass("three_percent"); // 新股-四个按钮-打新日历-右上角new标志
                $(_pageId + ".circle-10-red").addClass("three_percent"); // 新股-代缴款-红点条数
                $(_pageId + ".nsb-yydxg").hide(); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").hide(); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-zghs").hide(); // 新股-四个按钮-转股回售

            }
            $(_pageId + ".nsb_header_tab  ul li:eq(0)").addClass("active"); // 顶部-新股按钮
            $(_pageId + ".nsb_header_tab  ul li:eq(1)").removeClass("active"); // 顶部-新债按钮
            $(_pageId + ".nsb_header_tab  ul li:eq(2)").removeClass("active"); // 顶部-北交所按钮
            $(_pageId + ".nsb_tab_nav ul li a:eq(0)").text('待申购');// 新股-待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").css('display','block');// 新股-已上市-显示 tab
            showMainView(selectIndex);
        } else {
            $(_pageId + '.j_bjs_nav').css('display','none'); // 北交所 四个按钮
            $(_pageId + '.j_xgxz_nav').css('display','block');// 新股新债 四个按钮
            $(_pageId + "header .nsb_dxxz").css('display','block'); // 顶部右侧-打新须知
            if (newStockType && newStockType != "1") {//信用账户没有预约打新
                $(_pageId + ".nsb-yydxg").hide(); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").show(); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-dxrl").hide(); // 新股-四个按钮-打新日历
            }else{
                $(_pageId + ".nsb-yydxg").hide(); // 新股-预约打新股-按钮
                $(_pageId + ".nsb-yydxz").hide(); // 新股-预约打新债-按钮
                $(_pageId + ".nsb-dxrl").show(); // 新股-四个按钮-打新日历
            }
            $(_pageId + ".nsb-zghs").show(); // 新股-四个按钮-转股回售
            $(_pageId + ".nsb_header_tab ul li:eq(1)").addClass("active"); // 顶部-新债按钮
            $(_pageId + ".nsb_header_tab ul li:eq(0)").removeClass("active"); // 顶部-新股按钮
            $(_pageId + ".nsb_header_tab  ul li:eq(2)").removeClass("active"); // 顶部-北交所按钮
            $(_pageId + ".nsb_jrsg_edcx_bg_main").hide(); // 今日申购-额度查询
            $(_pageId + ".nsb-djk").removeClass("three_percent"); // 新股-四个按钮-待缴款
            $(_pageId + ".nsb-sgcx").removeClass("three_percent"); // 新股-四个按钮-预约打新
            $(_pageId + ".nsb-yydxg").removeClass("three_percent"); // 新股-预约打新股-按钮
            $(_pageId + ".nsb-yydxz").removeClass("three_percent"); // 新股-预约打新债-按钮
            $(_pageId + ".nsb-zghs").removeClass("three_percent"); // 新股-四个按钮-转股回售
            $(_pageId + ".nsb-dxrl").removeClass("three_percent"); // 新股-四个按钮-打新日历
            $(_pageId + ".circle-10-new").removeClass("three_percent"); // 新股-四个按钮-打新日历-右上角new标志
            $(_pageId + ".circle-10-red").removeClass("three_percent"); // 新股-代缴款-红点条数
            $(_pageId + ".nsb_tab_nav ul li a:eq(0)").text('待申购'); // 新股-待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").css('display','block'); // 新股-已上市-显示 tab
            showMainView(selectIndex);
        }
        $(_pageId + ".main").show();
    }

    /*****
     * 显示主页面
     * @param index 0待申购 1今日申购 2待上市 3已上市
     */
    function showMainView(index) {
        selectIndex = index;
        $(_pageId + ".has_data").hide();
        $(_pageId + ".has_data1").hide();
        $(_pageId + ".footer2").hide(); // 底部 登录即可预约打新
        $(_pageId + ".footer1").hide(); // 一键申购
        $(_pageId + ".nsb_sel_fixed_box .btn").html("一键申购");
        $(_pageId + ".btnSub").html("登录即可一键申购");
        showCircle();
        common.setNoData(false);
        if (index == 0) {
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").addClass("active");    // 待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active"); // 今日申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active"); // 待上市 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active"); // 已上市 tab
            $(_pageId + ".line1").hide();    // 待上市 细线
            $(_pageId + ".justify-content-space-between").hide(); // 待上市 列表标题
            $(_pageId + ".footer1").hide();  // 一键申购
            $(_pageId + ".footer2").hide();  // 底部 登录即可预约打新
            $(_pageId + ".nsb_jrsg_edcx_bg_main").hide(); // 新股-今日申购-额度展示
            $(_pageId + ".fund_table2 .ce_table .tbody").html('') // 待上市 列表
            $(_pageId + ".fund_table2 .dsg").html(''); // 待申购|今日申购 列表
            queDsg()
        } else if (index == 1) {
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active"); // 待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").addClass("active");    // 今日申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active"); // 待上市 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active"); // 已上市 tab
            $(_pageId + ".line1").hide(); // 待上市 细线
            $(_pageId + ".justify-content-space-between").hide(); // 待上市 列表标题
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html(''); // 待申购|今日申购 列表
            if (userInfo!=null && common.isEmptyObject(userInfo)) {//登录的情况
                is_login = "1"
                stockJrsgEDQuery();//今日额度查询
            }else{
                queJrsg();
            }
        } else if (index == 2) {
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active"); // 待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active"); // 今日申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").addClass("active");    // 待上市 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").removeClass("active"); // 已上市 tab
            $(_pageId + ".line1").show(); // 待上市 细线
            $(_pageId + ".justify-content-space-between").show(); // 待上市 列表标题
            $(_pageId + ".justify-content-space-between div").eq(3).html("中签率");
            $(_pageId + ".nsb_jrsg_edcx_bg_main").hide(); // 新股-今日申购-额度展示
            $(_pageId + ".fund_table2 .ce_table .tbody").html(''); // 待上市 列表
            $(_pageId + ".fund_table2 .dsg").html(''); // 待申购|今日申购 列表
            $(_pageId + ".footer1").hide();  // 一键申购
            $(_pageId + ".footer2").hide();  // 底部 登录即可预约打新
            queDss()
        } else if (index == 3) {
            $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active"); // 待申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active"); // 今日申购 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(2)").removeClass("active"); // 待上市 tab
            $(_pageId + ".nsb_tab_nav ul li:eq(3)").addClass("active");    // 已上市 tab
            $(_pageId + ".justify-content-space-between").show(); // 待上市 列表标题
            $(_pageId + ".justify-content-space-between div").eq(3).html("累计涨幅");
            $(_pageId + ".line1").show(); // 待上市 细线
            $(_pageId + ".footer1").hide();  // 一键申购
            $(_pageId + ".footer2").hide(); // 底部 登录即可预约打新
            $(_pageId + ".nsb_jrsg_edcx_bg_main").hide(); // 新股-今日申购-额度展示
            $(_pageId + ".fund_table2 .ce_table .tbody").html(''); // 待上市 列表
            $(_pageId + ".fund_table2 .dsg").html(''); // 待申购|今日申购 列表
            queYss();
        }
    }


    /********
     * 显示无数据
     * @param index 1 待申购 2今日申购 3待上市 4 已上市
     */
    function noData(index) {

        if (index == 0) {
            $(_pageId + ".no_data .no_data_tip").html("暂无待申购信息");
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
        } else if (index == 1) {
            if (newStockType != "1") {
                if (isStocks) {
                    $(_pageId + ".no_data .no_data_tip").html("今日无新股发行,试试<a class='tip_yydx'>预约打新</a>吧");
                } else {
                    $(_pageId + ".no_data .no_data_tip").html("今日无新债发行,试试<a class='tip_yydx'>预约打新</a>吧");
                }
                // 预约打新
                $.bindEvent($(_pageId + ".no_data_tip .tip_yydx"), function (e) {
                    if (keyboard) {
                        keyboard.closeKeyPanel();
                    }
                    openTJD();
                    e.stopPropagation();	// 阻止冒泡
                });
            } else {
                $(_pageId + ".no_data .no_data_tip").html("今日暂无申购");
            }

            if (is_login == "1") {
                $(_pageId + ".footer2").hide();
                $(_pageId + ".footer1").hide();
                $(_pageId + ".nsb_jrsg_edcx_bg_main").hide();
            } else {
                $(_pageId + ".footer2").hide();
                $(_pageId + ".footer1").hide();
                $(_pageId + ".nsb_jrsg_edcx_bg_main").hide();
            }
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
        } else if (index == 2) {
            $(_pageId + ".no_data .no_data_tip").html("未查询到待上市信息");
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
        } else if (index == 3) {
            $(_pageId + ".no_data .no_data_tip").html("未查询到已上市信息");
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
        }
        $(_pageId + ".has_data1").hide();
        $(_pageId + ".has_data").hide();
        $(_pageId + ".no_data").show();
        $(_pageId + ".main").show();
    }

    /**********
     * 各个页面初始化显示
     *  @param index 1 待申购 2今日申购 3待上市 4 已上市
     */
    function initHTML(index) {
        $(_pageId + '.justify-content-space-between div').eq(3).show();
        if (index == 0) {
            checkDate = '';
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
            $(_pageId + '.fund_table2 .color-ddd').show();
            $(_pageId + '.fund_table2 .ce_table').hide();
        } else if (index == 1) {
            checkDate = '';
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
            $(_pageId + '.fund_table2 .color-ddd').show();
            $(_pageId + '.fund_table2 .ce_table').hide();
        } else if (index == 2) {
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
            $(_pageId + '.fund_table2 .color-ddd').hide();
            $(_pageId + '.fund_table2 .ce_table').show();
            $(_pageId + '.fund_table2 .ce_table .tbody tr.add').remove();
            if(isBjs){
              $(_pageId + '.justify-content-space-between div').eq(3).hide(); // 北交所-待上市-不显示第四列
            }
        } else if (index == 3) {
            $(_pageId + ".fund_table2 .ce_table .tbody").html('')
            $(_pageId + ".fund_table2 .dsg").html('');
            $(_pageId + '.fund_table2 .color-ddd').hide();
            $(_pageId + '.fund_table2 .ce_table').show();
            $(_pageId + '.fund_table2 .ce_table .tbody tr.add').remove();
        }
    }

    /**********
     * 显示有数据
     * @param index 1 待申购 2今日申购 3待上市  4已上市
     */
    function hasData(index, results) {
        if (index == 0) {
            $(_pageId + ".no_data").hide(); // 暂无数据
            $(_pageId + ".has_data").hide(); // 没有更多数据了
            $(_pageId + ".has_data1").show(); // 没有更多数据了
            if (is_login != "1") { //0未登录 1已登录
                if (newStockType && newStockType != "1" && !isBjs) {
                    $(_pageId + ".footer2").show();
                    $(_pageId + ".btnSub").html("登录即可预约打新");
                } else {
                    $(_pageId + ".footer2").hide();
                }
                $(_pageId + ".footer1").hide();
            } else {
                if (newStockType && newStockType != "1" && !isBjs) {
                    $(_pageId + ".footer2").show();
                    if(isStocks && isStocks !== 'false') {
                        $(_pageId + ".btnSub").html("预约打新股");
                    }else{
                        $(_pageId + ".btnSub").html("预约打新债");
                    }
                } else {
                    $(_pageId + ".footer2").hide();
                }
                $(_pageId + ".footer1").hide();
            }
            $.bindEvent($(_pageId + ".nsb_arrow"), function () { // 待申购、今日申购列表点击进入详情
                var stock_code = $(this).attr("data-id");
                var market = $(this).attr("data-flag");
                setIntentParam();
                $.setSStorageInfo("nsb_stock_code", stock_code, true);
                $.setSStorageInfo("nsb_market", market, true);
                $.pageInit(pagecode, "nsb/detail", {}, true);
            });
        } else if (index == 1) {
            $(_pageId + ".no_data").hide();
            $(_pageId + ".has_data1").show();
            $(_pageId + ".has_data").hide();

            if (keyboard) {
                keyboard.keyInit();
            }
            btnClick(results);
            if (is_login == "1") { //0未登录 1已登录
                for (var i = 0; i < results.length; i++) {
                    if (!$(_pageId + ".jrsg" + i).hasClass("notClick")) {
                        if (authControlSingle(results, i, false)) {
                            $(_pageId + ".jrsg" + i).addClass("act");
                            var checkLength = document.getElementsByClassName("select act").length;//选中的个数
                            if (checkLength > 0) {
                                $(_pageId + ".btn").removeClass("default");
                            } else {
                                $(_pageId + ".btn").addClass("default");
                            }
                            if (checkLength == results.length) {
                                $(_pageId + ".allCheckBox em").addClass("act");
                            }
                        }
                    }
                }

                var checkLength = document.getElementsByClassName("select act").length;//选中的个数
                if (checkLength > 0) {
                    $(_pageId + ".btn").removeClass("default");
                } else {
                    $(_pageId + ".btn").addClass("default");
                }
                $(_pageId + ".footer2").hide();
                $(_pageId + ".footer1").show();
                if (isStocks) {
                    $(_pageId + ".nsb_jrsg_edcx_bg_main").show();
                    $(_pageId + ".nsb_jrsg_edcx_bg .sz").html(quotaList.SZ);
                    $(_pageId + ".nsb_jrsg_edcx_bg .sh").html(quotaList.SH);
                    $(_pageId + ".nsb_jrsg_edcx_bg .kc").html(quotaList.KC);
                } else {
                    $(_pageId + ".nsb_jrsg_edcx_bg_main").hide();
                }
            } else {
                $(_pageId + ".footer2").show();
                $(_pageId + ".btnSub").html("登录即可一键申购");
                $(_pageId + ".footer1").hide();
                $(_pageId + ".nsb_jrsg_edcx_bg_main").hide();
            }

        } else if (index == 2) {
            $(_pageId + ".no_data").hide();
            $(_pageId + ".has_data").show();
            $(_pageId + ".has_data1").hide();
            $(_pageId + ".footer2").hide();
            $(_pageId + ".footer1").hide();
            $.bindEvent($(_pageId + ".fund_table2 .ce_table .tbody .background-white"), function () { // 待申购、今日申购列表点击进入详情
                var stock_code = $(this).attr("data-id");
                var market = $(this).attr("data-flag");
                $.setSStorageInfo("nsb_stock_code", stock_code, true);
                $.setSStorageInfo("nsb_market", market, true);
                setIntentParam();
                $.pageInit(pagecode, "nsb/detail", {}, true);
            });
        } else if (index == 3) {
            $(_pageId + ".no_data").hide();
            $(_pageId + ".has_data").show();
            $(_pageId + ".has_data1").hide();
            $(_pageId + ".footer2").hide();
            $(_pageId + ".footer1").hide();
            $.bindEvent($(_pageId + ".fund_table2 .ce_table .tbody .background-white"), function () { // 待申购、今日申购列表点击进入详情
                var stock_code = $(this).attr("data-id");
                var market = $(this).attr("data-flag");
                $.setSStorageInfo("nsb_stock_code", stock_code, true);
                $.setSStorageInfo("nsb_market", market, true);
                setIntentParam();
                $.pageInit(pagecode, "nsb/detail", {}, true);
            });
        }
    }

    /********************************************今日申购*************************************************************************/

    /*********
     * 请求今日申购数据
     *
     */
    function queJrsg() {
        // 北交所数据单独处理
        if(isBjs){
          queryTodayPurchase();
          $(_pageId + ".nsb_sel_fixed_box .btn").attr("class", "btn default");
          $(_pageId + ".nsb_sel_fixed_box .row-1 span").html("");
          $(_pageId + ".nsb_sel_fixed_box .row-1 em").attr("class", "");
          // $(_pageId + ".onclikput").show();
          return false;
        }
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var sessionid = userInfo.sessionid;
        var exchange_type = userInfo.exchange_type;
        var stock_account = userInfo.stock_account;
        var param = {
            "funcNo": "361534",
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "sessionid": sessionid,
            "cust_code": cust_code,
            "password": password,
            "exchange_type": exchange_type,
            "stock_account": stock_account,
            "is_login": is_login,
        };
        service.nsbJrsg(param, function (data) {
            $.hidePreloader();
            // 判断是否在当前tab，不在不渲染
            if(!isBjs && selectIndex === 1){
              operaJrsgData(data);
            }
        },{ //控制参数
            "isShowWait": false,
        });
    }

    /*******
     * 处理今日申购的数据
     */
    function operaJrsgData(jrsgData) {
        if (is_login == "1") {
            jrsgLoginData = jrsgData;
        }
        initHTML(1);
        if (jrsgData) {
            if (jrsgData.error_no == 0) {
                var useData = null;//需要使用的数据
                if (isStocks) {
                    useData = jrsgData.stockList;
                    if (jrsgData.bondList && jrsgData.bondList.length > 0) {
                    }
                } else {
                    useData = jrsgData.bondList;
                }

                if (useData && useData.length > 0) {
                    isFirstIn = "1";
                    var results = JsonSort(useData, 'is_subscribed', "asc");//根据是否申购排序 已申购排后面
                    //生成页面
                    var html = '';
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryJrsgHTML(results, results[i], i);
                    }
                    $(_pageId + ".fund_table2 .dsg").html(html);
                    hasData(1, results);
                } else {
                    // if (isFirstIn == "0" && isStocks) {//首次进入页面，如果没有数据。进入待申购页面
                    //     isFirstIn = "1";
                    //     showMainView(0);
                    // }
                    noData(1);
                }
            } else {
                noData(1);
            }
        } else {
            noData(1);
        }
    }


    /*******
     * 申购页面按钮点击事件
     * @param results
     */
    function btnClick(results) {
        //申购数量输入
        $.bindEvent($(_pageId + ".t1"), function (e) {
            var index = $(this).attr("data-index");
            if (keyboard) {
                keyboard.popUpKeyboard($(_pageId + "#purchaseNum" + index), e);
            }
            // e.stopPropagation();
        }, "input");


        //＋ 、 －
        $.bindEvent($(_pageId + ".nsb_input_value em"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var index = $(this).attr("data-index");
            var css = $(this).attr("class");
            var inp = $(this).nextAll("input");
            var buy_unit = $(this).attr("buy_unit") || 500;

            buy_unit = Number(buy_unit);
            var all = Number(inp.val());
            if (css == "less") {
                if (all - buy_unit < 0) {
                    all = 0;
                } else {
                    all = all - buy_unit;
                }
            } else if (css == "add") {
                all = all + buy_unit;
            }
            $(_pageId + "#purchaseNum" + index).quzhi(all);
            e.stopPropagation();	// 阻止冒泡
        });

        // 点击进入详情
        $.bindEvent($(_pageId + ".nsb_conveible .row_02"), function () { // 待申购、今日申购列表点击进入详情
            var stock_code = $(this).parent().find('.nsb_arrow').attr("data-id");
            var market = $(this).parent().find('.nsb_arrow').attr("data-flag");
            setIntentParam();
            $.setSStorageInfo("nsb_stock_code", stock_code, true);
            $.setSStorageInfo("nsb_market", market, true);
            $.pageInit(pagecode, "nsb/detail", {}, true);
        });

        //列表单选
        $.bindEvent($(_pageId + ".select"), function () {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            var index = $(this).attr("data-index");
            if ($(_pageId + ".jrsg" + index).hasClass("notClick")) {
                common.singleIConfirm("温馨提示", "可申购数量为0", function () {

                }, "确定");
                return;
            }
            if ($(_pageId + ".jrsg" + index).hasClass("act")) {// 已选择
                $(_pageId + ".jrsg" + index).removeClass("act");
                $(_pageId + ".allCheckBox em").removeClass("act");
                var checkLength = document.getElementsByClassName("select act").length;//选中的个数
                if (checkLength > 0) {
                    $(_pageId + ".btn").removeClass("default");
                } else {
                    $(_pageId + ".btn").addClass("default");
                }
            } else {//未选择
                if ( authControlSingle(results, index, true) || !isStocks) {
                    $(_pageId + ".jrsg" + index).addClass("act");
                    var checkLength = document.getElementsByClassName("select act").length;//选中的个数
                    if (checkLength > 0) {
                        $(_pageId + ".btn").removeClass("default");
                    } else {
                        $(_pageId + ".btn").addClass("default");
                    }
                    if (checkLength == results.length) {
                        $(_pageId + ".allCheckBox em").addClass("act");
                    }
                }
            }
        });

        //全选
        $.bindEvent($(_pageId + ".allCheckBox"), function (e) {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            if ($(_pageId + " .select").hasClass("act")) {//已选择
                $(_pageId + " .select").removeClass("act");
                $(_pageId + ".allCheckBox em").removeClass("act");
                $(_pageId + ".btn").addClass("default");
            } else {//未选择
                for (var i = 0; i < results.length; i++) {
                    if (!$(_pageId + ".jrsg" + i).hasClass("notClick")) {
                        if (authControlSingle(results, i, true) || !isStocks) {
                            $(_pageId + ".jrsg" + i).addClass("act");
                            var checkLength = document.getElementsByClassName("select act").length;//选中的个数
                            if (checkLength > 0) {
                                $(_pageId + ".btn").removeClass("default");
                            } else {
                                $(_pageId + ".btn").addClass("default");
                            }
                            if (checkLength == results.length) {
                                $(_pageId + ".allCheckBox em").addClass("act");
                            }
                        }
                    }
                }
            }
            e.stopPropagation();// 阻止冒泡
        });

    }


    /********
     * 今日申购页面生成
     * @param element
     * @param i
     */
    function queryJrsgHTML(data, element, i) {
        var eleHtml = "";
        var buy_unit = element.buy_unit || "0";
        buy_unit = Number(buy_unit);
        var apply_sell = "";
        var high_amount = element.high_amount;
        if (element.exchange_type == "0") {
            apply_sell = quotaList.SZ;
        } else if (element.exchange_type == "2" && (element.stock_type != "15" && element.stock_type != "16")) {
            apply_sell = quotaList.SH;
        } else if (element.exchange_type == "2" && (element.stock_type == "15" || element.stock_type == "16")) {//科创板
            apply_sell = quotaList.KC;
        }
        if (validator.isNumeric(apply_sell)) {
            apply_sell = Number(apply_sell);
        } else {
            apply_sell = 0;
        }
        if (validator.isNumeric(high_amount)) {
            high_amount = Number(high_amount);
        } else {
            high_amount = 0;
        }


        if (isStocks) {
            var canInputValue = (high_amount > apply_sell) ? apply_sell : high_amount;
            eleHtml += "<li>";
            eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow' data-flag='" + element.exchange_type + "' data-id='" + element.stock_code + "'></span>";
            eleHtml += "<div class='mainInfo justify-content-space-between sub1'>"
            eleHtml += "<div class='row_01 sub'>"

            if (is_login == "1") {
                if (canInputValue == 0) {
                    eleHtml += "<i data-index='" + i + "' class='jrsg" + i + " select notClick'></i>"
                } else {
                    eleHtml += "<i data-index='" + i + "' class='jrsg" + i + " select'></i>"
                }
                // eleHtml+="<i data-index='"+i+"' class='jrsg"+i+" select'></i>"
                if (element.exchange_type == "0" || element.exchange_type == "1") {
                    eleHtml += "<em class='djk_blue sub'>深</em>"
                } else if (element.exchange_type == "2" || element.exchange_type == "3") {
                    eleHtml += "<em class='djk_red sub'>沪</em>"
                }
                if (element.stock_type == "f" || element.stock_type == "q" || element.stock_type == "p") {
                    eleHtml += "<em class='djk_yellow sub'>创</em>"
                    eleHtml += "<span class='stock_name padding-left-60' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else if (element.stock_type == "15" || element.stock_type == "16") {
                    eleHtml += "<em class='djk_yellow sub'>科</em>"
                    eleHtml += "<span class='stock_name padding-left-60' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else {
                    eleHtml += "<span class='stock_name padding-left-40' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                }
            } else {
                if (element.exchange_type == "0" || element.exchange_type == "1") {
                    eleHtml += "<em class='djk_blue'>深</em>"
                } else if (element.exchange_type == "2" || element.exchange_type == "3") {
                    eleHtml += "<em class='a01 djk_red'>沪</em>"
                }
                if (element.stock_type == "f" || element.stock_type == "q" || element.stock_type == "p") {
                    eleHtml += "<em class='djk_yellow'>创</em>"
                    eleHtml += "<span class='stock_name padding-left-20' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else if (element.stock_type == "15" || element.stock_type == "16") {
                    eleHtml += "<em class='djk_yellow'>科</em>"
                    eleHtml += "<span class='stock_name padding-left-20' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else {
                  eleHtml += "<span class='stock_name' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                }
            }

            eleHtml += "<span class='stock_code'>" + element.stock_code + "</span>"
            eleHtml += "</div>"
            if (element.is_subscribed == "1") {//已申购
                eleHtml += "<div class='stock_djk_div'>"
                eleHtml += "<span class='stock_djk gray'>已申购</span>"
                eleHtml += "</div>"
            }
            eleHtml += "</div>"
            eleHtml += "<ul class='row_02 sub'>"
            eleHtml += "<li><span class='hed'>发行价格</span><span>" + dealNumberToFix(element.last_price, 2) + "</span></li>"
            eleHtml += "<li><span class='hed'>市盈率</span><span>" + (element.diluted_peratio && element.diluted_peratio.length > 0 ? element.diluted_peratio : "--") + "</span></li>"
            eleHtml += "<li><span class='hed'>发行总数</span><span>" + (element.issue_vol && element.issue_vol.length > 0 ? element.issue_vol : "--") + "</span></li>"
            eleHtml += "<li><span class='hed'>申购上限</span><span>" + (element.high_amount && element.high_amount.length > 0 ? element.high_amount : "--") + "</span></li>"
            eleHtml += "</ul>"
            eleHtml += "</div>"
            if (is_login == "1") {
                if (canInputValue == 0) {
                    eleHtml += "<div class='input_box' data-index='" + i + "'>";
                    eleHtml += "<div buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='nsb_input_value'>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='less default'></em>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='add default'></em>";
                    eleHtml += "<input readonly='true' value='" + Number(canInputValue) + "' buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' js-key='tel8' type='tel' class='t1 color-line' id='purchaseNum" + i + "'/>";
                    eleHtml += "</div>";
                    eleHtml += "</div>";
                    eleHtml += "<div class='height10'></div>"
                } else {
                    eleHtml += "<div class='input_box' data-index='" + i + "'>";
                    eleHtml += "<div buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='nsb_input_value'>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='less'></em>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='add'></em>";
                    eleHtml += "<input value='" + Number(canInputValue) + "' buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' js-key='tel8' type='tel' class='t1' id='purchaseNum" + i + "'/>";
                    eleHtml += "</div>";
                    eleHtml += "</div>";
                    eleHtml += "<div class='height10'></div>"
                }
            }

            eleHtml += "</li>"
        } else {
            var canInputValue = high_amount;
            eleHtml += "<li>";
            eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow' data-flag='" + element.exchange_type + "' data-id='" + element.stock_code + "'></span>";
            eleHtml += "<div class='mainInfo justify-content-space-between sub1' data-flag='" + element.exchange_type + "' data-id='" + element.stock_code + "'>"
            eleHtml += "<div class='row_01 sub'>"
            if (is_login == "1") {
                if (canInputValue == 0) {
                    eleHtml += "<i data-index='" + i + "' class='jrsg" + i + " select notClick'></i>"
                } else {
                    eleHtml += "<i data-index='" + i + "' class='jrsg" + i + " select'></i>"
                }

                if (element.exchange_type == "0" || element.exchange_type == "1") {
                    eleHtml += "<em class='djk_blue sub'>深</em>"
                } else if (element.exchange_type == "2" || element.exchange_type == "3") {
                    eleHtml += "<em class='djk_red sub'>沪</em>"
                }
                if (element.stock_type == "p") {
                    eleHtml += "<em class='djk_yellow sub'>创</em>"
                    eleHtml += "<span class='stock_name padding-left-60' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else if (element.stock_type == "15") {
                    eleHtml += "<em class='djk_yellow sub'>科</em>"
                    eleHtml += "<span class='stock_name padding-left-60' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else {
                    eleHtml += "<span class='stock_name padding-left-40' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                }
            } else {
                if (element.exchange_type == "0" || element.exchange_type == "1") {
                    eleHtml += "<em class='djk_blue'>深</em>"
                } else if (element.exchange_type == "2" || element.exchange_type == "3") {
                    eleHtml += "<em class='a01 djk_red'>沪</em>"
                }
                if (element.stock_type == "p") {
                    eleHtml += "<em class='djk_yellow'>创</em>"
                    eleHtml += "<span class='stock_name padding-left-20' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else if (element.stock_type == "15") {
                    eleHtml += "<em class='djk_yellow'>科</em>"
                    eleHtml += "<span class='stock_name padding-left-20' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                } else {
                    eleHtml += "<span class='stock_name' style='font-size:"+ $.getTransformScaleFontSize(element.stock_name, 16, $(window).width() * 0.3) +"px;'>" + element.stock_name + "</span>"
                }
            }
            eleHtml += "<span class='stock_code'>" + element.stock_code + "</span>"
            eleHtml += "</div>"

            if (element.is_subscribed == "1") {//已申购
                eleHtml += "<div class='stock_djk_div'>"
                eleHtml += "<span class='stock_ysg'>已申购</span>"
                eleHtml += "</div>"
            }

            eleHtml += "</div>"
            eleHtml += "<ul class='row_02 sub'>"
            eleHtml += "<li><span class='hed'>发行价格</span><span>" + dealNumberToFix(element.last_price, 2) + "</span></li>"
            eleHtml += "<li><span class='hed'>转股价</span><span>" + dealNumberToFix(element.convert_price, 2) + "</span></li>"
            eleHtml += "<li><span class='hed'>信用评级</span><span>" + (element.bond_rating ? element.bond_rating : "--") + "</span></li>"
            eleHtml += "<li><span class='hed'>申购上限</span><span>" + (element.high_amount && element.high_amount.length > 0 ? element.high_amount : "--") + "</span></li>"
            eleHtml += "</ul>"
            eleHtml += "</div>"

            if (is_login == "1") {
                if (canInputValue == 0) {
                    eleHtml += "<div class='input_box' data-index='" + i + "'>";
                    eleHtml += "<div buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='nsb_input_value'>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='less default'></em>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='add default'></em>";
                    eleHtml += "<input readonly='true' value='" + Number(canInputValue) + "' buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' js-key='tel8' type='tel' class='t1 color-line' id='purchaseNum" + i + "'/>";
                    eleHtml += "</div>";
                    eleHtml += "</div>";
                    eleHtml += "<div class='height10'></div>"
                } else {
                    eleHtml += "<div class='input_box' data-index='" + i + "'>";
                    eleHtml += "<div buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='nsb_input_value'>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='less'></em>";
                    eleHtml += "<em buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' class='add'></em>";
                    eleHtml += "<input value='" + Number(canInputValue) + "' buy_unit='" + Number(buy_unit) + "' data-index='" + i + "' js-key='tel8' type='tel' class='t1' id='purchaseNum" + i + "'/>";
                    eleHtml += "</div>";
                    eleHtml += "</div>";
                    eleHtml += "<div class='height10'></div>"
                }
            }
            eleHtml += "</li>"
        }

        return eleHtml;
    }

    /***********
     * 获取小数点的数值
     * @param str
     * @param fixLength
     */
    function dealNumberToFix(str, fixLength) {
        if (str == null || str == undefined || str == "undefined" || str == "" || str == "--" || str.length == 0) {
            return "--";
        } else {
            if (validator.isNumeric(str)) {
                return Number(str).toFixed(fixLength);
            } else {
                return str;
            }

        }
    }

    /*********
     * 新股申购额度查询
     */
    function stockJrsgEDQuery() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var sessionid = userInfo.sessionid;
        var exchange_type = userInfo.exchange_type;
        var stock_account = userInfo.stock_account;
        var param = {
            "funcNo": newStockType == "1" ? "303028" : "301519",
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "sessionid": sessionid,
            "cust_code": cust_code,
            "password": password,
            //"exchange_type":exchange_type,
            // "stock_account":stock_account,
        };
        service.nsbJrsg(param, function (data) {
            $.hidePreloader();
            if (data) {
                if (data.error_no == 0) {
                    if (typeof data.results != "undefined" && data.results != null && data.results != "") {
                        var results = data.results;
                        for (var i = 0; i < results.length; i++) {
                            var exchange_type = results[i].exchange_type;
                            var enable_amount = results[i].enable_amount;
                            //$(_pageId+".nsb_jrsg_edcx_bg").show();
                            if (exchange_type == "0") {//深市
                                quotaList.SZ = enable_amount;
                                $(_pageId + ".nsb_jrsg_edcx_bg .sz").html(enable_amount);
                            } else if (exchange_type == "2") {//沪市
                                quotaList.SH = enable_amount;
                                $(_pageId + ".nsb_jrsg_edcx_bg .sh").html(enable_amount);
                                if (results[i].stib_enable_quota) {
                                    quotaList.KC = results[i].stib_enable_quota;
                                    $(_pageId + ".nsb_jrsg_edcx_bg .kc").html(results[i].stib_enable_quota);
                                }
                            }
                        }
                    }
                }
            }
            queJrsg();
        });
    }

    /*********
     * 代缴款列表查询
     */
    function queryDJKData() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var param = {
            "funcNo": "361536",
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
        };
        service.nsbJrsg(param, function (data) {
            $.hidePreloader();
            if (data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results.length > 0 && results != "undefined") {
                        $(_pageId + ".circle-10-red").show();
                        $(_pageId + ".djk_tips").show();
                        $(_pageId + ".djk_tips_line").hide();
                        $(_pageId + ".djk_tips p").html("您今日有" + results.length + "笔待缴款，请保证账户可用资金余额充足" + "<a class='djk_tips_close_icon'></a>");
                        $.bindEvent($(_pageId + ".djk_tips_close_icon"), function () { //代缴款提示X按钮
                            $(_pageId + ".djk_tips").hide();
                            $(_pageId + ".djk_tips_line").show();
                        });
                    } else {
                        $(_pageId + ".djk_tips").hide();
                        $(_pageId + ".djk_tips_line").show();
                    }
                }
            }
        });
    }


    /******
     * 权限管理【单个选择】
     * 新股 科创板权限 科创板存托凭证权限
     * 新债 可转债权限
     * @param LoginData 登录数据
     * @param index 索引
     * @param showTipsDialog 是否弹权限弹框
     * @returns {boolean}
     */
    function authControlSingle(LoginData, index, showTipsDialog) {
        if (LoginData && LoginData.length > 0) {
            var sigleData = LoginData[index];
            if (isStocks) {
                var technology_innovation_rights = sigleData.technology_innovation_rights;//科创板权限 1无权限 0有权限
                var technologyInnovation_cdr_rights = sigleData.technologyInnovation_cdr_rights;//科创板存托凭证
                var registration_rights = sigleData.registration_rights;//注册制权限

                if (technology_innovation_rights == "1") {
                    if (showTipsDialog) {
                        var titleTips = "";
                        if (newStockType && newStockType == "1") {
                            titleTips = "您尚未开通信用交易账户科创板权限，如需进行交易，请到业务办理完成对应权限开通。";
                        } else {
                            titleTips = "您尚未开通普通交易账户科创板权限，如需进行交易，请到业务办理完成对应权限开通。";
                        }
                        common.iConfirm("温馨提示", titleTips, function success(html) {
                            if (global.callNative && global.isSso) {
                              setIntentParam();
                                var param = {
                                    "funcNo": "50500",
                                    "msgNo": "123",
                                    "sourceModule": "",
                                    "targetModule": "tradeDispatcher",
                                    "action": "1",
                                    "param": {
                                        "business_type": userInfo._loginClass,//普通0  两融1
                                        "event": "2",//打开权限开通页面
                                        "title": "",
                                    }
                                }
                                $.callMessage(param);
                            }
                        }, function fail() {
                        }, "开通权限", "取消");
                    }
                    return false;
                }
                if (technologyInnovation_cdr_rights == "1") {
                    if (showTipsDialog) {
                        if (newStockType && newStockType == "1") {
                            $.alert("您的信用账号尚未开通科创板存托凭证权限。请通过已开通权限的账号进行科创板新股申购或交易，如有疑问请致电客服电话400 821 1357进行咨询。");
                        } else {
                            $.alert("您尚未开通科创板存托凭证股东账号权限，如需进行交易，请到业务办理完成对应权限开通。");
                        }
                    }
                    return false;
                }

                if (['f', 'p', 'q'].indexOf(sigleData.stock_type) > -1) {//创业板权限
                    return popupRightsCybConfirmNew(sigleData, jurisdiction, showTipsDialog);
                }
                if (registration_rights == "0" && sigleData.stock_type === "23" && userInfo.prof_flag !== "1") {
                    common.iConfirm("风险揭示", sigleData.registration_rights_prompt, function success(html) {
                        if (global.callNative && global.isSso) {
                            var jump_url = {
                                "url": global.newFrameUrl + "fintechpages/business/index.html#/stockRegisterRight/index",
                                "uniqueCode":"PalmHall-stockRegisterRight/index",
                                "loginMode":"2"
                            };
                            nativePluginService.function501152(jump_url);
                        }
                    }, function fail() {
                    }, "开通权限", "取消");
                }
            } else {
                var convertible_bonds_rights = sigleData.convertible_bonds_rights;
                return popupRightsKzzConfirmNew(convertible_bonds_rights, jurisdiction, showTipsDialog);
            }
            return true;
        } else {
            return false;
        }
    }


    /*******
     * 创业板权限判断
     * @param results
     * @param jurisdiction
     */
    function popupRightsCybConfirmNew(results, jurisdiction, showTipsDialog) {
        var userInfo = common.getCurUserInfo();
        if (results && userInfo && jurisdiction) {
            var isOpenGemPerm = jurisdiction.gem_rights_switch == 1; // 是否开启创业板权限校验
            var stock_type = results.stock_type;
            if (jurisdiction.prof_flag != "1" && isOpenGemPerm && stock_type) {
                var gem_rights = results.gem_rights || jurisdiction.gem_rights;
                var gem_register_rights = results.gem_register_rights || jurisdiction.gem_register_rights;
                if (((stock_type == "f" && gem_rights == "1" && gem_register_rights != "0") || (["p", "q"].indexOf(stock_type) >= 0 && gem_register_rights == "1"))) {  //创业板
                    if (showTipsDialog) {
                        common.iConfirm("温馨提示", gem_rights == "0" ? "您尚未开通创业板权限，如需进行交易，请到业务办理完成对应权限开通。" : "尊敬的投资者您好，您无创业板注册制证券的交易权限，请到业务办理完成对应权限的开通。", function success(html) {
                            if (global.callNative && global.isSso) {
                              setIntentParam();
                                var param = {
                                    "funcNo": "50500",
                                    "msgNo": "123",
                                    "sourceModule": "",
                                    "targetModule": "tradeDispatcher",
                                    "action": "1",
                                    "param": {
                                        "business_type": userInfo._loginClass,//普通0  两融1
                                        "event": gem_rights == "1" ? "9" : "10",//打开权限开通页面
                                        "title": "",
                                    }
                                }
                                $.callMessage(param);
                            }
                        }, function fail() {
                        }, "开通权限", "取消");
                    }
                    return false;
                } else {
                    return true;
                }
            } else {
                return true;
            }
        }
        return false;
    }

    /********
     * 可转债权限提示框
     * @param convertible_bonds_rights
     * @param jurisdiction
     * @returns {boolean}
     */
    function popupRightsKzzConfirmNew(convertible_bonds_rights, jurisdiction, showTipsDialog) {
        var userInfo = common.getCurUserInfo();
        if (convertible_bonds_rights && userInfo && jurisdiction) {
            if (convertible_bonds_rights == "1") {
                if (showTipsDialog) {
                    common.iConfirm("风险揭示", "尊敬的投资者您好，您无可转债的交易权限，请到业务办理完成对应权限的开通。", function success(html) {
                        if (global.callNative && global.isSso) {
                          setIntentParam();
                            //   旧版可转债权限开通
                            // var param = {
                            //     "funcNo": "50500",
                            //     "msgNo": "123",
                            //     "sourceModule": "",
                            //     "targetModule": "tradeDispatcher",
                            //     "action": "1",
                            //     "param": {
                            //         "business_type": userInfo._loginClass,//普通0  两融1
                            //         "event": "11",//打开权限开通页面
                            //         "title": "",
                            //     }
                            // }
                            // $.callMessage(param);
                            var jump_url = {
                                "url": global.newFrameUrl + "fintechpages/business/index.html#/convertibleBondOpen/index",
                                "uniqueCode":"PalmHall-convertibleBondOpen/index",
                                "loginMode":"11"
                            };
                            $.callMessage($.extend({
                                moduleName: "trade",
                                funcNo: "501152",
                                openLoadBar:'0',  //是否显示加载等待层 1显示  0不显示 默认不显示
                                isShowTitleBar:'1',   // 是否显示标题栏 1:显示；0:不显示 默认显示
                                titleBgColor: '#EE4034',  //状态栏颜色&标题栏颜色
                                isSaveCache:'1',  //是否启用缓存 1启用 0不启用 默认启用
                                isSupportPullDownRefresh:'0',  //是否启用自带的下拉刷新1 启用 0 不启用 默认不启用
                                reloadCallback: 'subMessagingCallBack', // 跨模块页面刷新调用
                                bgColor:'#FFFFFF',  //webView 背景颜色
                                isFullScreen:'1',  //是否开启沉浸式状态栏 1启用 0不启用 默认启用
                            },jump_url));
                        }
                    }, function fail() {
                    }, "开通权限", "取消");
                }
                return false;
            } else {
                return true;
            }
        } else {
            return false;
        }
        return false;
    }

    function hasRight() {
      // 判断是否有京A权限
      var param = {
        "entrust_way": global.entrust_way,
        "branch_no": userInfo.branch_no,
        "fund_account": userInfo.fund_account,
        "cust_code": userInfo.cust_code,
        "password": userInfo.password,
        "session_id": userInfo.session_id,
        "login_type": userInfo._loginClass
      };
      publicService.queryJurisdiction(param, function (data) {
        bjsRight = data.results[0].bjs_rights;
      }, {
        "isShowWait": false,
      });
    }

    /*********
     * 申购校验
     */
    function commitCheck(loginData) {
        var jrsgLoginData = null;
        if (isStocks) {
            jrsgLoginData = loginData.stockList;
        } else {
            jrsgLoginData = loginData.bondList;
        }
        if (!common.isValue(jrsgLoginData)) {
            $.alert("暂无可以申购的代码信息");
            return false;
        }
        var selectListLength = document.getElementsByClassName("select act").length;//选中的个数
        if (selectListLength == 0) {
            $.alert("请勾选要申购的代码");
            return false;
        }

        var entrustcodes = [];
        var entrustResults = [];
        var kcbBonds = [];//科创板可转债stock_list
        var kcbTips = '';
        var tipStr = '';
        tipStr += '<div class="justify-content-space-between sub"><div class="f1">名称/代码</div><div class="f1">发行价</div><div class="f1">申购数量</div></div>';
        for (var i = 0; i < jrsgLoginData.length; i++) {
            if ($(_pageId + ".jrsg" + i).hasClass("act")) {

                var curr = jrsgLoginData[i];
                var exchange_type = curr.exchange_type;//交易市场
                var stock_account = curr.stock_account;//股东号
                var stock_code = curr.stock_code;
                var last_price = curr.last_price;
                var stock_name = curr.stock_name;
                var stock_type = curr.stock_type;
                if (!isStocks&&(stock_type=="18"||stock_type=="19"||stock_type=="7")) {
                    //默认使用第一条数据
                    if (kcbTips.length == 0) {
                        kcbTips = curr.convertible_bonds_prompt;
                    }
                    //如果有科创板可转债或者科创板cdr可转债则替换文案
                    if (stock_type=="18"||stock_type=="19") {
                        kcbTips = curr.convertible_bonds_prompt;
                    }
                }
                kcbBonds.push(stock_code);

                var num = $(_pageId + "#purchaseNum" + i).val();
                var buy_unit = $(_pageId + "#purchaseNum" + i).attr("buy_unit") || 500;
                var apply_sell = "";

                if (curr.exchange_type == "0") {
                    apply_sell = quotaList.SZ;
                } else if (curr.exchange_type == "2" && (curr.stock_type != "15" && curr.stock_type != "16")) {
                    apply_sell = quotaList.SH;
                } else if (curr.exchange_type == "2" && (curr.stock_type == "15" || curr.stock_type == "16")) {//科创板
                    apply_sell = quotaList.KC;
                }
                if (validator.isNumeric(apply_sell)) {
                    apply_sell = Number(apply_sell);
                } else {
                    apply_sell = 0;
                }

                var high_amount = curr.high_amount;


                if (validator.isNumeric(high_amount)) {
                    high_amount = Number(high_amount);
                } else {
                    high_amount = 0;
                }
                var canSGCount = 0;

                if (isStocks) {
                    canSGCount = high_amount > apply_sell ? apply_sell : high_amount;//两者取小
                } else {
                    canSGCount = high_amount;
                }

                if (!validatorUtil.isNumeric(num)) {
                    common.singleIConfirm("温馨提示", "【 " + stock_name + " 】" + "输入数量有误", function () {

                    }, "确定");
                    return false;
                } else if (Number(num) == "0") {
                    common.singleIConfirm("温馨提示", "【 " + stock_name + " 】" + "输入数量不能为0", function () {

                    }, "确定");
                    return false;
                } else if (num % Number(buy_unit) != 0) {
                    common.singleIConfirm("温馨提示", "【 " + stock_name + " 】" + "申购数量应该为" + buy_unit + "的整数倍", function () {

                    }, "确定");
                    return false;
                } else if (Number(num) > canSGCount) {
                    common.singleIConfirm("温馨提示", "【 " + stock_name + " 】" + "申购数量大于可申购数量", function () {

                    }, "确定");
                    return false;
                }

                tipStr += '<div class="justify-content-space-between color-title text-size-16">';
                tipStr += '<div class="f1"><p style="font-size:'+ $.getTransformScaleFontSize(stock_name, 16, $(window).width()*0.8/3 - 30) +'px;">' + stock_name + '</p><p class="color-line text-size-12">' + stock_code + '</p></div>';
                tipStr += '<div class="f1">' + last_price + '</div>';
                tipStr += '<div class="f1">' + num + '</div>';
                tipStr += '</div>';
                entrustcodes.push(stock_code + ":" + exchange_type + ":" + last_price + ":" + num + ":" + stock_account);
                entrustResults.push(stock_code + ";" + stock_name);
            }
        }
        if (entrustcodes && entrustcodes.length > 0) {
            if (!isStocks && kcbTips.length > 0) {
                common.iConfirm('温馨提示', '<div style="text-align:left;">' + kcbTips + '</div>', function () {
                    orderConfirm(entrustcodes, tipStr, entrustResults, kcbBonds,kcbTips);
                    uuid = $.getUUID();
                    var paraMap = {
                        stockCode: kcbBonds.join(','),
                        entrust_no: "",
                        convertible_bonds_prompt: kcbTips,
                        stock_type: '18'
                    }
                    paraMap.create_by = uuid;
                    // console.log(paraMap);
                    appropriate.function399932(paraMap)
                }, null, '我知道了')
            } else {
                orderConfirm(entrustcodes, tipStr, entrustResults, null,null);
            }

        }
    }

    /*******
     * 申购确认
     */
    function orderConfirm(entrustcodes, tipStr, entrustResults, kcbBonds,kcbTips) {
        common.iConfirm("申购确认", tipStr, function () {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            order(entrustcodes, entrustResults, kcbBonds,kcbTips,uuid)
        }, function () {
            if (keyboard) {
                keyboard.closeKeyPanel();
            }
            $(_pageId).attr("key-panel-main", "true");
        }, "确定", "取消");

    }

    /*******
     * 一键申购
     */
    function order(entrustcodes, entrustResults, kcbBonds,kcbTips,uuid) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var password = userInfo.password;
        var sessionid = userInfo.sessionid;
        var exchange_type = userInfo.exchange_type;
        var stock_account = userInfo.stock_account;
        var param = {
            "funcNo": isStocks ? (newStockType == "0" ? "301539" : "303052") : "301551",
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "sessionid": sessionid,
            "cust_code": cust_code,
            "password": password,
            "exchange_type": exchange_type,
            "stock_account": stock_account,
            "entrustcodes": entrustcodes.join("|")
        };

        service.nsbJrsg(param, function (data) {
            $.hidePreloader();
            if (typeof (data) != "undefined" && data) {
                if (data.error_no == 0) {
                    var results = data.results;
                    //调用可转债留痕接口
                    var entrust_no = [];
                    var stocks = [];
                    if(results.length>0){
                        for(var i=0;i<results.length;i++){
                            if(null!=results[i].entrust_no&&results[i].entrust_no!=undefined&&results[i].entrust_no!=""&&results[i].entrust_no.length>0){
                                entrust_no.push(results[i].entrust_no);
                                stocks.push(results[i].stock_code);
                            }
                        }
                    }
                    if (null != kcbBonds && kcbBonds.length > 0&&kcbTips) {
                            if(kcbTips!=null&&kcbTips.length>0&&entrust_no!=null&&entrust_no.length>0){
                                var paraMap = {
                                    stockCode: kcbBonds.join(","),
                                    entrust_no: entrust_no.join(","),
                                    convertible_bonds_prompt: kcbTips,
                                    stock_type: '18'
                                }
                                paraMap.create_by = uuid;
                                // console.log(paraMap);
                                appropriate.function399932(paraMap);
                            }
                    }
                    if(isStocks && second_agree){
                        appropriate.function399934({
                            agree_type: "2",
                            text_content: second_agree,
                            entrust_no: entrust_no.join(","),
                            id: agree_id,
                            stockCode: stocks.join(',')
                        })
                    }
                    gotoResult(data, entrustResults);
                } else {
                    $.alert(data.error_info);
                }
            }
        }, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        //$.showPreloaders("请等待...");
    }

    /*********
     * 跳转结果页
     * @param data
     */
    function gotoResult(data, entrustResults) {
        var results = data.results;
        if (results.length > 0) {//接口返回正确，跳转结果页
            jrsgLoginData = null;
            $(_pageId + ".allCheckBox em").removeClass("act");
            setIntentParam();
            $.setSStorageInfo("nsb_results", data, true);
            $.setSStorageInfo("nsb_entrustResults", entrustResults, true);
            $.pageInit(pagecode, "nsb/result", {}, true);
        }
    }

        /********************************************待申购*************************************************************************/

        /*********
         * 请求待申购数据 或者北交所近日询价数据
         */
        function queDsg() {
            if(isBjs){
              $(_pageId + ".nsb_sel_fixed_box .btn").attr("class", "btn default");
              $(_pageId + ".nsb_sel_fixed_box .row-1 span").html("");
              $(_pageId + ".nsb_sel_fixed_box .row-1 em").attr("class", "");
              queryRecentEnquiry();
            }else if (isStocks) {
                service_xkj.require1001004({
                  "flag": "6",
                }, function (data) {
                    $.hidePreloader();
                    operaDsgData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            } else {
              service_xkj.require1001005({
                  "flag": "2",
                }, function (data) {
                    $.hidePreloader();
                    operaDsgData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            }
        }

        /*******
         * 处理待申购的数据
         */
        function operaDsgData(data) {
          // 判断是否在当前tab，不在不渲染
          if(!isBjs && selectIndex === 0){
            initHTML(0);
            if (data && data.error_no == 0) {

                if (data && data.results.length > 0 && data.results != "undefined") {
                    var results = data.results;
                    var html = '';
                    for (var i = 0; i < results.length; i++) {
                        if($.isValue(results[i].longStockName)) results[i].stockName = results[i].longStockName;
                        if($.isValue(results[i].longBndName)) results[i].bndName = results[i].longBndName;
                        html += queryDSGHTML(results, results[i], i);
                    }
                    $(_pageId + ".fund_table2 .dsg").html(html);
                    hasData(0, results);
                } else {
                    noData(0);
                }
            } else {
                noData(0);
            }
          }
        }

        /********
         * 待申购页面生成
         * @param element
         * @param i
         */
        function queryDSGHTML(data, element, i) {
            var eleHtml = "";
            if (isStocks) {
                eleHtml += "<li>";
                if (checkDate != element.subscribeDate) {
                    eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow sub' data-flag='" + element.market + "' data-id='" + element.stockCode + "'></span>";
                    checkDate = element.subscribeDate;
                    eleHtml += "<div class='justify-content-space-between sub2 '" + element.subscribeDate + ">"
                    eleHtml += "<div class='nsb_djk_date'>" + element.subscribeDate + getWeekByDate(element.subscribeDate) + "</div>"
                    eleHtml += "<div class='nsb_djk_date_count'><a class='color-red'>" + getCountIndexByDate(data, element.subscribeDate) + "</a>只新股</div>"
                    eleHtml += "</div>"
                } else {
                    eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow'  data-flag='" + element.market + "' data-id='" + element.stockCode + "'></span>";
                }

                eleHtml += "<div class='mainInfo justify-content-space-between sub1'>"
                eleHtml += "<div class='row_01 sub'>"
                if (element.market == "SZ") {
                    eleHtml += "<em class='a01 djk_blue'>深</em>"
                } else if (element.market == "SH") {
                    eleHtml += "<em class='a01 djk_red'>沪</em>"
                }
                //eleHtml+="<em class='a02 djk_yellow'>创</em>"
                eleHtml += "<span class='stock_name'>" + element.stockName + "</span>"
                //eleHtml+="<span class='stock_name padding-left-20'>"+element.stock_name+"</span>"
                eleHtml += "<span class='stock_code'>" + element.stockCode + "</span>"
                eleHtml += "</div>"

                // eleHtml+="<div class='stock_djk_div'>"
                // eleHtml+="<span class='stock_djk gray'>待缴款</span>"
                // eleHtml+="</div>"
                eleHtml += "</div>"
                eleHtml += "<ul class='row_02 sub'>"
                eleHtml += "<li><span class='hed'>发行价格</span><span>" + dealNumberToFix(element.issuePrice, 2) + "</span></li>"
                eleHtml += "<li><span class='hed'>市盈率</span><span>" + dealNumberToFix(element.dilutedperatio, 2) + "</span></li>"
                eleHtml += "<li><span class='hed'>发行总数</span><span>" + (element.issuevol && element.issuevol.length > 0 ? element.issuevol : "--") + "</span></li>"
                eleHtml += "<li><span class='hed'>申购上限</span><span>" + (element.applymaxOnline && element.applymaxOnline.length > 0 ? element.applymaxOnline : "--") + "</span></li>"
                eleHtml += "</ul>"
                eleHtml += "</div>"
                eleHtml += "</li>"
            } else {
                eleHtml += "<li>";
                if (checkDate != element.sgDate) {
                    eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow sub'  data-flag='" + element.market + "' data-id='" + element.bndCode + "'></span>";
                    checkDate = element.sgDate;
                    eleHtml += "<div class='justify-content-space-between sub2 '" + element.sgDate + ">"
                    eleHtml += "<div class='nsb_djk_date'>" + element.sgDate +getWeekByDate(element.sgDate) +"</div>"
                    eleHtml += "<div class='nsb_djk_date_count'><a class='color-red'>" + getCountIndexByDate(data, element.sgDate) + "</a>只新债</div>"
                    eleHtml += "</div>"
                } else {
                    eleHtml += "<div class='nsb_conveible'><span class='nsb_arrow'  data-flag='" + element.market + "' data-id='" + element.bndCode + "'></span>";
                }

                eleHtml += "<div class='mainInfo justify-content-space-between sub1'>"
                eleHtml += "<div class='row_01 sub'>"
                if (element.market == "SZ") {
                    eleHtml += "<em class='a01 djk_blue'>深</em>"
                } else if (element.market == "SH") {
                    eleHtml += "<em class='a01 djk_red'>沪</em>"
                }
                //eleHtml+="<em class='a02 djk_yellow'>创</em>"
                eleHtml += "<span class='stock_name'>" + element.bndName + "</span>"
                //eleHtml+="<span class='stock_name padding-left-20'>"+element.stock_name+"</span>"
                eleHtml += "<span class='stock_code'>" + element.bndCode + "</span>"
                eleHtml += "</div>"

                // eleHtml+="<div class='stock_djk_div'>"
                // eleHtml+="<span class='stock_djk gray'>待缴款</span>"
                // eleHtml+="</div>"
                eleHtml += "</div>"
                eleHtml += "<ul class='row_02 sub'>"
                eleHtml += "<li><span class='hed'>发行价格</span><span>" + dealNumberToFix(element.issPri, 2) + "</span></li>"
                eleHtml += "<li><span class='hed'>信用评级</span><span>" + (element.zqpj && element.zqpj.length > 0 ? element.zqpj : "--") + "</span></li>"
                eleHtml += "<li><span class='hed'>申购日期</span><span>" + (element.sgDate && element.sgDate.length > 0 ? element.sgDate : "--") + "</span></li>"
                eleHtml += "<li><span class='hed'>申购上限</span><span>" + (element.applymaxOnline && element.applymaxOnline.length > 0 ? element.applymaxOnline : "--") + "</span></li>"
                eleHtml += "</ul>"
                eleHtml += "</div>"
                eleHtml += "</li>"
            }

            return eleHtml;
        }

        /********************************************待上市*************************************************************************/

        /*********
         * 请求待上市数据
         */
        function queDss() {
          if(isBjs){
            service_xkj.require1001004({
              "market": "BJ",
              "flag": "3",
            }, function (data) {
                $.hidePreloader();
                operaDssData(data);
            }, { //控制参数
                "isShowWait": false,
            });
          }else if (isStocks) {
                service_xkj.require1001004({
                  "flag": "3",
                }, function (data) {
                    $.hidePreloader();
                    operaDssData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            } else {
                service_xkj.require1001005({
                  "flag": "3",
                }, function (data) {
                    $.hidePreloader();
                    operaDssData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            }
        }

        /*************
         * 处理待上市数据
         */
        function operaDssData(data) {
          // 判断是否在当前tab，不在不渲染
          if(selectIndex === 2){
            initHTML(2);
            if (data && data.error_no == 0) {
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var dataList = results;
                    var html = '';
                    for (var i = 0; i < dataList.length; i++) {
                        if($.isValue(results[i].longStockName)) results[i].stockName = results[i].longStockName;
                        if($.isValue(results[i].longBndName)) results[i].bndName = results[i].longBndName;
                        html += queryDssHTML(dataList[i], i);
                    }
                    $(_pageId + ".fund_table2 .ce_table .tbody").html(html);
                    hasData(2, results);
                } else {
                    noData(2);
                }
            } else {
                noData(2);
            }
          }
        }


        /*********
         * 待上市页面生成
         * @param element
         * @param i
         * @returns {string}
         */
        function queryDssHTML(element, i) {
            var eleHtml = "";
            if (isBjs) {
              eleHtml += "<tr data-flag='" + element.market + "' data-id='" + element.stockCode + "' class='background-white' id=\"" + i + "\">";
              eleHtml += "<td><span class='color-title text-size-16'>" + element.stockName + "</span>" +
                  "<span class='color-line text-size-12'>" + element.stockCode + "</span>" +
                  "</td>";
              eleHtml += "<td><span class='color-title text-size-16 text-align-center'>" + dealNumberToFix(element.issuePrice, 2) + "</span></td>";
              eleHtml += "<td><span class='color-title text-size-16 text-align-right padding-left-10'>" + (element.listDate && element.listDate.length > 0 ? element.listDate.substr(5, 5) : '未公布') + "</span></td>";
              eleHtml += "</tr>";
            }else if (isStocks) {
                eleHtml += "<tr data-flag='" + element.market + "' data-id='" + element.stockCode + "' class='background-white' id=\"" + i + "\">";
                eleHtml += "<td><span class='color-title textOverFlow' style='font-size:"+ $.getTransformScaleFontSize(element.stockName, 16, $(window).width()/4 - 25) +"px;'>" + element.stockName + "</span>" +
                    "<span class='color-line text-size-12'>" + element.stockCode + "</span>" +
                    "</td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center'>" + dealNumberToFix(element.issuePrice, 2) + "</span></td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center padding-left-10'>" + (element.listDate && element.listDate.length > 0 ? element.listDate.substr(5, 5) : '未公布') + "</span></td>";
                eleHtml += "<td><span class='color-red text-size-16'>" + (element.ballotRate && element.ballotRate.length > 0 ? element.ballotRate + '%' : "--") + "</span></td>";
                eleHtml += "</tr>";
            } else {
                eleHtml += "<tr data-flag='" + element.market + "' data-id='" + element.bndCode + "' class='background-white' id=\"" + i + "\">";
                eleHtml += "<td><span class='color-title textOverFlow' style='font-size:" + $.getTransformScaleFontSize(element.bndName, 16, $(window).width()/4 - 25) + "px;'>" + element.bndName + "</span>" +
                    "<span class='color-line text-size-14'>" + element.bndCode + "</span>" +
                    "</td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center'>" + dealNumberToFix(element.issPri, 2) + "</span></td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center padding-left-10'>" + (element.listDate && element.listDate.length > 0 ? element.listDate.substr(5, 5) : '未公布') + "</span></td>";
                eleHtml += "<td><span class='color-red text-size-16'>" + (element.zql && element.zql.length > 0 ? element.zql + '%' : "--") + "</span></td>";
                eleHtml += "</tr>";
            }
            return eleHtml;
        }


        /********************************************已上市*************************************************************************/

        /*********
         * 请求已上市数据
         */
        function queYss() {
            if (isStocks) {
                service_xkj.require1001004({
                  "flag": "7",
                }, function (data) {
                    $.hidePreloader();
                    operaYssData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            } else {
                service_xkj.require1001005({
                  "flag": "4",
                }, function (data) {
                    $.hidePreloader();
                    operaYssData(data);
                }, { //控制参数
                    "isShowWait": false,
                });
            }
        }

        /*************
         * 处理已上市数据
         */
        function operaYssData(data) {
          // 判断是否在当前tab，不在不渲染
          if(selectIndex === 3){
            initHTML(3);
            if (data && data.error_no == 0) {
                console.log(data);
                var results = data.results;
                var hqStocks = [];
                if (results.length > 0 && results != "undefined") {
                    var dataList = results;
                    var html = '';
                    for (var i = 0; i < dataList.length; i++) {
                        if($.isValue(results[i].longStockName)) results[i].stockName = results[i].longStockName;
                        if($.isValue(results[i].longBndName)) results[i].bndName = results[i].longBndName;
                        html += queryYssHTML(dataList[i], i);
                        if (isStocks) {
						    hqStocks.push(results[i].market + ":" + results[i].stockCode);
                        }else{
						    hqStocks.push(results[i].market + ":" + results[i].bndCode);
                        }
                    }
                    $(_pageId + ".fund_table2 .ce_table .tbody").html(html);
                    commonHq.getStockNowPrice(hqStocks.join("|"),getStockNowPriceCallBack);
                    hasData(3, results);
                } else {
                    noData(3);
                }
            } else {
                noData(3);
            }
          }
        }
        function getStockNowPriceCallBack(data){
            // console.log(data);
            for (var key in data) {
                if (Object.hasOwnProperty.call(data, key)) {
                    var element = data[key];
                    var line = $(_pageId + ".fund_table2 .ce_table .tbody tr[data-type='" + key + "'] td");
                    var issuePrice = line.eq(1).find('span').html();
                    var item = line.eq(3).find('span');
                    if(element[2] === undefined || !issuePrice){
                        break;
                    }
                    var value = (element[2] - parseFloat(issuePrice))/parseFloat(issuePrice) * 100;
                    if(value > 0){
                        item.addClass('ared');
                    }else if(value < 0){
                        item.addClass('agreen');
                    }
                    item.html(value.toFixed(2) + '%');
                }
            }
        }
        /*********
         * 已上市页面生成
         * @param element
         * @param i
         * @returns {string}
         */
        function queryYssHTML(element, i) {
            var eleHtml = "";
            if (isStocks) {
                eleHtml += "<tr data-type='" + element.market + ":" + element.stockCode + "' data-flag='" + element.market + "' data-id='" + element.stockCode + "' class='background-white' id=\"" + i + "\">";
                eleHtml += "<td><span class='color-title textOverFlow' style='font-size:"+ $.getTransformScaleFontSize(element.stockName, 16, $(window).width()/4 - 25) +"px;'>"+ element.stockName + "</span>" +
                    "<span class='color-line text-size-14'>" + element.stockCode + "</span>" +
                    "</td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center'>" + dealNumberToFix(element.issuePrice, 2) + "</span></td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center padding-left-10'>" + (element.listDate && element.listDate.length > 0 ? element.listDate.substr(5, 5) : '未公布') + "</span></td>";
                eleHtml += "<td><span class='text-size-16'>--</span></td>";
                eleHtml += "</tr>";
            } else {
                eleHtml += "<tr data-type='" + element.market + ":" + element.bndCode + "' data-flag='" + element.market + "' data-id='" + element.bndCode + "' class='background-white' id=\"" + i + "\">";
                eleHtml += "<td ><span class='color-title textOverFlow' style='font-size:" + $.getTransformScaleFontSize(element.bndName, 16, $(window).width()/4 - 25) + "px;'>"+ element.bndName + "</span>" +
                    "<span class='color-line text-size-14'>" + element.bndCode + "</span>" +
                    "</td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center'>" + dealNumberToFix(element.issPri, 2) + "</span></td>";
                eleHtml += "<td><span class='color-title text-size-16 text-align-center padding-left-10'>" + (element.listDate && element.listDate.length > 0 ? element.listDate.substr(5, 5) : '未公布') + "</span></td>";
                eleHtml += "<td><span class='text-size-16'>--</span></td>";
                eleHtml += "</tr>";
            }
            return eleHtml;
        }

      /**
       * 近日询价查询
       */
      function queryRecentEnquiry() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo && userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "session_id": session_id,
        };
        service_third.queryRecentEnquiry(param, function (data) {
          // 判断是否在当前tab，不在不渲染
          if(isBjs && selectIndex === 0){
            initHTML(0);
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        common.setNoData(false);
                        var html = "";
                        for (var i = 0; i < results.length; i++) {
                            html += queryRecentEnquiryHTML(results[i], i);
                        }
                        $(_pageId + ".fund_table2 .dsg").html(html);
                        $(_pageId + ".has_data").show();
                        if (keyboard) {
                            keyboard.keyInit();
                        }
                        bindHtmlEvent();
                        if (is_login != "1") {
                          $(_pageId + ".footer2").show(); // 底部 登录即可预约打新
                          $(_pageId + ".btnSub").html("登录即可一键询价");
                        } else {
                          $(_pageId + ".footer1").show(); // 一键申购
                          $(_pageId + ".btn").html("一键询价");
                        }
                    } else {
                      $(_pageId + ".fund_table2 .dsg").html("");
                      var _noData = '<span class="icon"></span><p class="no_data_tip">近日无询价发行</p>';
                      common.setNoData(true, "", "", _noData, _noDataCallback);
                    }
                } else {
                  $(_pageId + ".fund_table2 .dsg").html("");
                    common.setQueryFail(true);
                }
            }
          }
        }, {
            "isShowWait": true,
        });
      }
      /**
       * 处理北交所近日询价数据
       */
      function queryRecentEnquiryHTML(element, i) {
        var eleHtml = "<div class='conveible' element='" + JSON.stringify(element) + "'>";
        eleHtml += "<div class='row_01 lessp'>";
        eleHtml += "<i class='sel'></i><strong>" + element.issue_name + "</strong><span>" + element.issue_code + "</span>";
        // eleHtml += "<div class='sgoubtn' element='" + JSON.stringify(element) + "'><a href='javascript:void(0);'>询价</a></div>";
        eleHtml += "</div>";
        eleHtml += "<ul class='row_02 clearfix' issue_name='" + element.issue_name + "' issue_code='" + element.issue_code + "' exchange_type='" + element.exchange_type + "' up_price='" + element.up_price + "'>";
        eleHtml += "<li><span>证券代码</span>" + element.stock_code + "</li>";
        eleHtml += "<li><span>发行数量</span>" + common.dgitConversion(Number(element.issue_amount)) + "股</li>";
        eleHtml += "<li><span>开始日期</span>" + element.start_date + "</li>";
        eleHtml += "<li><span>截止日期</span>" + element.end_date + "</li>";
        eleHtml += "<li><span>价格上限</span>" + element.up_price + "</li>";
        eleHtml += "<li><span>价格下限</span>" + element.down_price + "</li>";
        eleHtml += "<li><span>询价上限</span>" + common.dgitConversion(Number(element.high_amount)) + "股</li>";
        eleHtml += "<li><span>询价下限</span>" + common.dgitConversion(Number(element.low_amount)) + "股</li>";
        eleHtml += '<span class="nsb_arrow sub" data-flag="' + commonHq.getHqMarket(element.exchange_type) + '" data-id="' + element.issue_code + '"></span>';
        eleHtml += "</ul>";
        eleHtml += "</div>";
        return eleHtml;
      }
      /**
       * 今日申购查询
       */
      function queryTodayPurchase() {
          var entrust_way = global.entrust_way; // 委托方式  在configuration配置
          var branch_no = userInfo.branch_no;	 //分支机构
          var fund_account = userInfo.fund_account;//资产账户
          var cust_code = userInfo.cust_code;  	 //客户代码
          var session_id = userInfo.session_id;
          var password = userInfo.password;
          var param = {
              "entrust_way": entrust_way,
              "branch_no": branch_no,
              "fund_account": fund_account,
              "cust_code": cust_code,
              "password": password,
              "session_id": session_id,
              "is_login": '0', //今日申购 is_login  0表示非登陆，，1表示登陆
          };
          service_third.queryTodayPurchase(param, function (data) {
            // 判断是否在当前tab，不在不渲染
            if(isBjs && selectIndex === 1){
              initHTML(1);
              if (data && data != "undefined") {
                  if (data.error_no == 0) {
                      var results = data.results;
                      if (results && results.length > 0) {
                          common.setNoData(false);
                          var html = "";
                          for (var i = 0; i < results.length; i++) {
                              html += queryTodayPurchaseHTML(results[i], i);
                          }
                          $(_pageId + ".fund_table2 .dsg").html(html);
                          if (keyboard) {
                              keyboard.keyInit();
                          }
                          bindHtmlEvent();
                          if (is_login != "1") {
                            $(_pageId + ".footer2").show();
                            $(_pageId + ".btnSub").html("登录即可一键申购");
                          } else {
                            $(_pageId + ".footer1").show();
                          }
                          $(_pageId + ".has_data").show();
                      } else {
                        $(_pageId + ".fund_table2 .dsg").html("");
                        var _noData = '<span class="icon"></span><p class="no_data_tip">今日无新股</p>';
                        common.setNoData(true, "", "", _noData, _noDataCallback);
                      }
                  } else {
                    $(_pageId + ".fund_table2 .dsg").html("");
                      common.setQueryFail(true);
                  }
              }
            }
          }, {
              "isShowWait": true,
          });
      }
      /**
       * 处理北交所今日申购数据
       */
      function queryTodayPurchaseHTML(element, i) {
          var eleHtml = "<div class='conveible' element='" + JSON.stringify(element) + "'>";
          eleHtml += "<div class='row_01 lessp'>";
          eleHtml += "<i class='sel'></i><strong>" + element.issue_name + "</strong><span>" + element.issue_code + "</span>";
          if (element.finalist_flag == "1") {
              $(_pageId + ".notyeponed").show();
              $.bindEvent($(_pageId + ".notyeponed .close"), function (e) {
                  $(_pageId + ".notyeponed").hide();
                  downslide.slideDestroy();
                  var mainHeight = common.setMainHeight(_pageId, true);
                  downslide.slideInit(mainHeight, backgroundInterface);
                  e.stopPropagation();
              });
              eleHtml += "<i class='chuaunyet'>询价已入围</i>";
          }
          // eleHtml += "<div class='sgoubtn' element='" + JSON.stringify(element) + "'><a href='javascript:void(0);'>申购</a></div>";
          eleHtml += "</div>";
          eleHtml += "<ul class='row_02 clearfix' issue_name='" + element.issue_name + "' issue_code='" + element.issue_code + "' exchange_type='" + element.exchange_type + "' up_price='" + element.up_price + "'>";
          eleHtml += "<li><span>证券代码</span>" + element.stock_code + "</li>";
          eleHtml += "<li><span>发行数量</span>" + common.dgitConversion(Number(element.issue_amount)) + "股</li>";
          eleHtml += "<li><span>价格上限</span>" + element.up_price + "</li>";
          eleHtml += "<li><span>价格下限</span>" + element.down_price + "</li>";
          eleHtml += "<li><span>申购上限</span>" + common.dgitConversion(Number(element.high_amount)) + "股</li>";
          eleHtml += "<li><span>申购下限</span>" + common.dgitConversion(Number(element.low_amount)) + "股</li>";
          eleHtml += '<span class="nsb_arrow sub" data-flag="' + commonHq.getHqMarket(element.exchange_type) + '" data-id="' + element.issue_code + '"></span>';
          eleHtml += "</ul>";
          eleHtml += "</div>";
          return eleHtml;
      }
      // /生成的页面元素的事件
      function bindHtmlEvent() {
          //列表点击
          $.bindEvent($(_pageId + ".conveible .row_02"), function (e) {
              if (keyboard) {
                  keyboard.closeKeyPanel();
              }
              var element = JSON.parse($(this).parent().attr("element"));
              $.setSStorageInfo("nsb_stock_code", element.stock_code, true);
              $.setSStorageInfo("nsb_market", 'BJ', true);
              $.pageInit(pagecode, "nsb/detail", {}, true);

              setIntentParam();
              e.stopPropagation();
          });
          //单行（取消）选中
          $.bindEvent($(_pageId + ".conveible i.sel"), function (e) {
              e.stopPropagation();
              $(this).toggleClass("act");
              var len = $(_pageId + ".conveible i.sel.act").length;
              $(_pageId + ".nsb_sel_fixed_box .btn").attr("class", "btn " + (len ? "" : "default"));
              $(_pageId + ".nsb_sel_fixed_box .row-1 span").html(len ? "（" + len + "）" : "");
              $(_pageId + ".nsb_sel_fixed_box .row-1 em").attr("class", len && len == $(_pageId + ".conveible i.sel").length ? "act" : "");
              return false;
          });
          //全选
          $.bindEvent($(_pageId + ".allCheckBox"), function (e) {
            e.stopPropagation();
            if (!$(_pageId + ".conveible i.sel").length) return;
            $(this).toggleClass("act");
            $(_pageId + ".conveible i.sel").attr("class", "sel " + ($(this).hasClass("act") ? "act" : ""));
            $(_pageId + ".nsb_sel_fixed_box .row-1 em").attr("class", $(this).hasClass("act") ? "act" : "");
            var len = $(_pageId + ".conveible i.sel.act").length;
            $(_pageId + ".nsb_sel_fixed_box .row-1 span").html(len ? "（" + len + "）" : "");
            $(_pageId + ".nsb_sel_fixed_box .btn").attr("class", "btn " + (len ? "" : "default"));
          });
      }
      //询价|申购 提交
      function submitOrder(results) {
        $(_pageId).css('overflow','auto');
          // 今日询价 selectIndex == 0
          // 今日申购 selectIndex == 1
          var tipStr = "<p class='titleBox'>" + userInfo.client_name + "(" + userInfo.fund_account + ")</p>";
          var tipStrArray = [];
          var batch_data = [];
          for (var i = 0; i < results.length; i++) {
              var element = results[i];
              tipStrArray.push(["发行代码", element.issue_code]);
              tipStrArray.push(["证券名称", element.issue_name]);
              if(selectIndex == 0){
                tipStrArray.push(["询价价格", element.entrust_price]);
                tipStrArray.push(["询价数量", element.entrust_amount]);
              }else{
                tipStrArray.push(["申购价格", element.entrust_price]);
                tipStrArray.push(["申购数量", element.entrust_amount]);
              }
              tipStrArray.push([]);// 多条之间的空隙
              batch_data.push([element.issue_code, element.exchange_type, element.entrust_price, element.entrust_amount, element.issue_name].join(":"));
          }
          tipStr += common.generatePrompt(tipStrArray, '', "thirdCss");
          var ts = '';
          if(selectIndex == 0){
            ts = "温馨提示:(1)多次询价时，以最后一笔有效近日询价作为其最终近日询价。<br>(2)投资者参与询价即视为授权全国北交所公司向本次发行股票的发行人和相应主承销商提供其报价信息及必要的身份信息。<br>(3)投资者参与询价，入围后必须按询价数量参与申购。";
          }else{
            ts = "温馨提示：多次申购时，以首笔有效申购申报作为其最终申购申报。";
          }
          if (ts) {
              tipStr += "<div class='_reminder_gz'><span class='w'>" + ts + "</span></div>";
          }
          // var stock_account = ""
          // commonFunc.getNewStockAccount([element.exchange_type], userInfo, function(data){
          // 	stock_account = data[0].stock_account;
          // });
          var comStatRequest = function (results, i_oper) {
              for (var i = 0; i < results.length; i++) {
                  var element = results[i];
                  //埋点数据
                  var comStatParam = {
                      "i_oper": i_oper,
                      "i_entrust_bs": "1", // 交易方向( 1,买入 2,卖出)
                      "i_stock_code": element.issue_code, // 股票代码
                      "i_stock_name": element.issue_name, // 股票名称
                      "i_entrust_prop": "", // 委托属性
                      "i_exchange_type": element.exchange_type, // 交易市场
                      "i_entrust_price": element.entrust_price, // 选择后的价格
                      "i_entrust_amount": element.entrust_amount, // 委托数量
                  }
                  if(selectIndex == 0){
                    common.comStat(101904, 2, 3, false, comStatParam);
                  }else{
                    common.comStat(101904, 2, 3, false, comStatParam);
                  }
              }
          }
          common.thirdIConfirm(selectIndex == 0?"询价确认":"申购确认", tipStr, function success() {
              var param = {
                  "entrust_way": global.entrust_way,// 委托方式  在configuration配置
                  "branch_no": userInfo.branch_no,//分支机构
                  "fund_account": userInfo.fund_account,//资产账户
                  "cust_code": userInfo.cust_code,//客户代码
                  "password": userInfo.password,
                  "session_id": userInfo.session_id,
                  "batch_flag": results.length > 1 ? 1 : 0,
                  "batch_data": batch_data.join("|")
              };
              if(selectIndex == 0){
                service_third.enquiry(param, succesCallback, {
                    "isShowOverLay": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    }, "errorFunc": function () {
                        $.hidePreloader();
                    }
                });
              }else{
                service_third.purchase(param, succesCallback, {
                    "isShowOverLay": false, "isShowWait": false,
                    "timeOutFunc": function () {
                        $.hidePreloader();
                    }, "errorFunc": function () {
                        $.hidePreloader();
                    }
                });
              }
              $.showPreloaders("请等待...");
              comStatRequest(results, '1') // 动作（1确定 2取消）
          }, function fail() {
              comStatRequest(results, '2') // 动作（1确定 2取消）
          }, "确定", "取消", null, "tap");
      }
      function succesCallback(data) {
          $.hidePreloader();
          $(_pageId + ".nsb_sel_fixed_box .row-1 em").attr("class","");
          $(_pageId + ".nsb_sel_fixed_box .btn").attr("class", "btn default");
          if (data && data.error_no == "0") {
              if (data.results.length > 0) {
                  common.entrustResultsConfirm(data.results, function () {
                    if(selectIndex == 0){
                      queryRecentEnquiry();
                    }else{
                      queryTodayPurchase();
                    }
                  });
              }
          } else {
              $.alert(data.error_info);
          }
      }
      function isTradeLogin(){
        var type = newStockType;
        if (!common.isTradeLogin(type)) {
            commonFunc.login($.getCurrentPageObj().pageCode, $.getCurrentPageObj().pageCode, {
                "_loginClass": type,
                "topage": $.getCurrentPageObj().pageCode,
            }, { 
                "topage": $.getCurrentPageObj().pageCode 
            });
            return false;
        }
        return true;
      }
      /**
       * "暂无数据"后的回调
       * */
      function _noDataCallback() {
      }
      /**
       * 查询首页新股，新债数量
       */
      function queryListAmount() {
        var param = {};
        param.funcNo = "310300";
        param.entrust_way = global.entrust_way;
        param.branch_no = userInfo.branch_no;
        param.fund_account = userInfo.fund_account;
        param.cust_code = userInfo.cust_code;
        param.password = userInfo.password;
        param.session_id = userInfo.session_id;
        param.new_bond_flag = "1"; //是否查询新债 0.不查询 1.查询
        param.new_stock_flag = "1"; //是否查询新股
        param.new_gz_stock_flag = "1"; //是否查询股转新股
        param.loan_flag = "1";
        publicService.serviceCommonInvoke(param, function (data) {
          // module_name（0新股，1新债，2国债逆回购 3:股转新股）
          if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length) {
              for (var i = 0; i < results.length; i++) {
                var numberText = parseInt(results[i].number);
                if (results[i].module_name == "0" && numberText > 0) {
                  stockListSize = numberText;
                } else if (results[i].module_name == "1" && numberText > 0) {
                  bondListSize = numberText;
                } else if (results[i].module_name == "3" && numberText > 0) {
                  bjsListSize = numberText;
                }
              }
              queryJRSG();
              topTabChange();
            }
          } else {
            $.alert(data.error_info);
          }
          $.hidePreloader();
        },
          {
            "isShowWait": false,
          });
      }
      function function399933(){
        if(isStocks){
            appropriate.function399933({
                agree_type: "1",
            },function(data){
                console.log(data);
                if(data.error_no == "0"){
                    var results = data.results[0];
                    second_agree = results.newstock_second_content; // 注册制打新 非首次交易留痕提示
                    fist_agree = results.newstock_first_content;     // 注册制打新 首次交易留痕提示
                    if(results.isAgree === "0"){
                        common.singleIConfirmNew("首次新股申购风险提示", fist_agree, function () {
                            var paraMap = {
                                agree_type: "1",
                                text_content: fist_agree,
                            }
                            appropriate.function399934(paraMap)
                        }, "我知道了",undefined,undefined,undefined,"xgxz");
                    }
                }
            });
        }
      }
      /**
       * 查询今日申购数量
       */
      function queryJRSG(){
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = (userInfo && userInfo.branch_no) || "";	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "session_id": session_id,
            "is_login": '0', //今日申购 is_login  0表示非登陆，，1表示登陆
        };
        service_third.queryTodayPurchase(param, function (data) {
          if (data && data != "undefined") {
              if (data.error_no == 0) {
                  var results = data.results;
                  bjsListSize = results.length;
                  showCircle();
              }
          }
        }, {
            "isShowWait": true,
        });
      }
      /**
       * 红点显示
       */
      function showCircle(){
        if (isBjs) {
          if (bjsListSize != "0" || bjsListSize != 0 || bjsListSize == "undefined") {
              $(_pageId + '.circle-15-red').show(); // 北交所-今日申购-红点条数
              $(_pageId + '.circle-15-red').html(bjsListSize);
          }else if(bjsListSize == 0){
            $(_pageId + '.circle-15-red').hide(); // 北交所-今日申购-红点条数
          }
        }else if (isStocks) {
            if (stockListSize != "0" || stockListSize != 0 || stockListSize == "undefined") {
                $(_pageId + '.circle-15-red').show(); // 新股-今日申购-红点条数
                $(_pageId + '.circle-15-red').html(stockListSize);
            } if(stockListSize == 0){
              $(_pageId + '.circle-15-red').hide(); // 北交所-今日申购-红点条数
            }
        } else if (!isStocks) {
            if (bondListSize != "0" || bondListSize != 0 || bondListSize == "undefined") {
                $(_pageId + '.circle-15-red').show(); // 新债-今日申购-红点条数
                $(_pageId + '.circle-15-red').html(bondListSize);
            } if(bondListSize == 0){
              $(_pageId + '.circle-15-red').hide(); // 北交所-今日申购-红点条数
            }
        }
      }
        /********************************************公共方法*************************************************************************/


        /**
         * 根据日期字符串获取星期几
         * @param dateString 日期字符串（如：2020-05-02）
         * @returns {日一二三四五六}七选一
         */
        function getWeekByDate(dateString) {
            if (isToday(dateString)) {
                return "  今日";
            }
            var dateArray = dateString.split("-");
            var date = new Date(dateArray[0], parseInt(dateArray[1] - 1), dateArray[2]);
            return "  周" + "日一二三四五六".charAt(date.getDay());
        };

        /*******
         * 是否是今天
         * @param str
         * @returns {boolean}
         */
        function isToday(str) {
            var d = new Date();
            var y = d.getFullYear(); // 年
            var m = d.getMonth() + 1; // 月份从0开始的
            var d = d.getDate(); //日
            return str == (y + '-' + m + '-' + d);
        }

        /********
         * 按时间排序
         * @param arr
         * @param flag asc升序 desc降序
         * @param sortBy
         * @returns {*}
         */
        function JsonSort(json, key, flag) {
            for (var j = 1, jl = json.length; j < jl; j++) {
                var temp = json[j],
                    val = temp[key],
                    i = j - 1;
                if (flag == 'asc') {
                    while (i >= 0 && json[i][key] > val) {
                        json[i + 1] = json[i];
                        i = i - 1;
                    }
                } else if (flag == 'desc') {
                    while (i >= 0 && json[i][key] < val) {
                        json[i + 1] = json[i];
                        i = i - 1;
                    }
                }

                json[i + 1] = temp;

            }
            return json;
        }

        /********
         * 根据日期获取数据条数
         * @param data  数据
         * @param currentDate
         * @returns {number}
         */
        function getCountIndexByDate(data, currentDate) {
            var countIndex = 0;
            for (var i = 0; i < data.length; i++) {
                if (isStocks) {
                    if (currentDate == data[i].subscribeDate) {
                        countIndex = countIndex + 1;
                    }
                } else {
                    if (currentDate == data[i].sgDate) {
                        countIndex = countIndex + 1;
                    }
                }

            }
            return countIndex;
        }

        function isIphoneX() {
            var resu = nativePluginService.function50001();
            if (resu && null != resu) {
                if (resu.error_no == 0) {
                    var devicePlatform = resu.results[0].devicePlatform.replace(/\s+/g, "").toLocaleLowerCase();//去空格转小写
                    if (devicePlatform.indexOf("iphonex") != -1
                        || devicePlatform.indexOf("iphone11") != -1
                        || devicePlatform.indexOf("iphone12") != -1) {
                        return true;
                    }
                }
            }
            return false;
        }
        /**
         * 数据重置
         */
        function destroy() {
            pageInit();
            isStocks = true;//true新股 false新债
            checkDate = '';//待申购，做对比的日期，判断前一个日期和当前是否一样，一样就不显示头部日期，不一样就显示
            selectIndex = 1;//选择的索引，默认今日申购
            is_login = "0";//0未登录 1已登录

            userInfo = null;//用户信息

            jrsgLoginData = null;//今日申购登录数据

            isFirstIn = "0";//是否是首次进入新股新债页面
            jurisdiction = null;

            quotaList = {
                "SZ": 0,
                "SH": 0,
                "KC": 0,
            };
            paramMap = null;//上个页面传递过来的数据
            newStockType = "0";//0普通交易 1信用账户
            $(_pageId + ".main").hide();
            service.destroy();
            fist_agree = "";
            second_agree = "";
            agree_id = "";
            $("#singleIConfirmNew").remove();
        }

        var base = {
            "init": init,
            "load": load,
            "bindPageEvent": bindPageEvent,
            "destroy": destroy
        };
        module.exports = base;
    }

);
