/**
 * 北交所-我的申购
 */
define('trade/scripts/nsb/wdsg.js', function (require, exports, module) {
  var gconfig = $.config;
  var global = gconfig.global;
  var common = require("common");
  var commonFunc = require("commonFunc");
  var service = require("service_stock");
  var _pageId = "#nsb_wdsg ";
  var pagecode = "nsb/wdsg"
  var html = '';
  var userInfo;

  var checkDate = '';//判断页面是否显示日期
  var sgIndex = 0;//申购table索引

  //  var paramMap="";//上个页面传递过来的数据

  var begin_time;
  var end_time;
  /**
   * 初始化
   */
  function init() {

    common.setMainHeight(_pageId, false);
    $(_pageId + '.sgcx_main_info').css('height', window.innerHeight + 'px')
  }

  function load() {

    if (commonFunc.hasSaveStr("switchUserInfo")) {
      common.switchingCurUser(commonFunc.getSaveStr("switchUserInfo", "0"));
    }

    userInfo = common.getCurUserInfo();

    commonFunc.initTimeChoice(_pageId, 7);
    var end_ = $(_pageId + " #endDate").text();
    var begin_ = $(_pageId + " #startDate").text();
    begin_time = begin_.replaceAll("-", "");
    end_time = end_.replaceAll("-", "");
    showMainView(0);

  }


  /*********
   * 申购数据查询
   */
  function querySGData() {
    var entrust_way = global.entrust_way; // 委托方式  在configuration配置
    var branch_no = userInfo.branch_no;
    var fund_account = userInfo.fund_account;
    var cust_code = userInfo.cust_code;
    var password = userInfo.password;
    var param = {
      "funcNo": "361540",
      "entrust_way": entrust_way,
      "branch_no": branch_no,
      "fund_account": fund_account,
      "cust_code": cust_code,
      "password": password,
      "begin_time": begin_time,
      "end_time": end_time,
    };
    service.nsbJrsg(param, function (data) {
      $.hidePreloader();
      if (data) {
        operaSGData(data);
      }
    });
  }


  /********
   * 申购数据处理
   * @param data
   */
  function operaSGData(data) {
    html = '';
    if (data) {
      if (data.error_no == 0) {
        var results = data.results;
        if (results.length > 0 && results != "undefined") {
          for (var i = 0; i < results.length; i++) {
            html += querySGHTML(results[i], i);
          }
          $(_pageId + ".sgcx_main_info").show();
          $(_pageId + ".sgcx_main_info").html(html);
          $(_pageId + ".no_data").hide();
        } else {
          nodata(0);
        }
      } else {
        nodata(0);
        if (data.error_no < 0) {
          $.alert(data.error_info)
        }
      }
    } else {
      nodata(0);
    }
  }

  /*******
   * 申购页面显示
   * @param element
   * @param i
   * @returns {string}
   */
  function querySGHTML(element, i) {
    var eleHtml = "";
    eleHtml += "<li>";
    //eleHtml+="<div class='nsb_conveible'>";
    if (checkDate != element.entrust_date) {
      eleHtml += "<div class='nsb_conveible'>";
      checkDate = element.entrust_date;
      eleHtml += "<div class='justify-content-space-between sub2 '" + element.entrust_date + ">"
      eleHtml += "<div class='nsb_djk_date'>" + joint(element.entrust_date, "-") + "</div>"
      eleHtml += "</div>"
    } else {
      eleHtml += "<div class='nsb_conveible'>";
    }
    eleHtml += "<div class='justify-content-space-between sub1'>";
    eleHtml += "<div class='row_01 sub' style='padding-left: 0.15rem;'>";
    eleHtml += "<span class='stock_name'>" + element.issue_name + "</span>";
    eleHtml += "<span class='stock_code reset'>" + element.issue_code + "</span>";
    eleHtml += "</div>";
    eleHtml += "</div>";
    eleHtml += "<ul class='row_02 sub'>";
    eleHtml += "<li><span class='hed'>申购价格</span><span class='stock_name reset'>" + (element.report_price && element.report_price.length > 0 ? parseFloat(element.report_price).toFixed(2) : "--") + "</span></li>";
    eleHtml += "<li><span class='hed'>申购数量</span><span class='applymax_online reset'>" + (element.report_amount && element.report_amount.length > 0 ? element.report_amount : "--") + "</span></li>";
    eleHtml += "<li><span class='hed'>申购时间</span><span class='subscribe_code reset'>" + joint(element.entrust_time, ":") + "</span></li>"
    eleHtml += "<li><span class='hed'>委托状态</span><span class='issue_price reset'>" + (element.report_state_name && element.report_state_name.length > 0 ? element.report_state_name : "--") + "</span></li>";
    eleHtml += "</ul>";
    eleHtml += "</div>";
    eleHtml += "</li>";
    return eleHtml;
  }

  /*********
   * 拼接字符串
   * @param str
   * @param jointStr
   */
  function joint(str, jointStr) {
    if (str && str.length > 0) {
      if (str.length == 5) {
        str = "0" + str;
        return str.substring(0, 2) + jointStr + str.substring(2, 4) + jointStr + str.substring(4, 6);
      } else if (str.length == 6) {
        return str.substring(0, 2) + jointStr + str.substring(2, 4) + jointStr + str.substring(4, 6);
      } else if (str.length == 8) {
        return str.substring(0, 4) + jointStr + str.substring(4, 6) + jointStr + str.substring(6, 8);
      } else {
        return str;
      }
    }
    return "--";
  }




  /*********
   * 中签记录数据查询
   */
  function queryZQJLData() {
    var entrust_way = global.entrust_way; // 委托方式  在configuration配置
    var branch_no = userInfo.branch_no;
    var fund_account = userInfo.fund_account;
    var cust_code = userInfo.cust_code;
    var password = userInfo.password;
    var param = {
      "funcNo": "361541",
      "entrust_way": entrust_way,
      "branch_no": branch_no,
      "fund_account": fund_account,
      "cust_code": cust_code,
      "password": password,
      "begin_time": begin_time,
      "end_time": end_time,
    };
    service.nsbJrsg(param, function (data) {
      $.hidePreloader();
      if (data) {
        operaZQJLData(data);
      }
    });
  }


  /********
   * 中签记录数据处理
   * @param data
   */
  function operaZQJLData(data) {
    html = '';
    if (data) {
      if (data.error_no == 0) {
        var results = data.results;
        if (results.length > 0 && results != "undefined") {
          for (var i = 0; i < results.length; i++) {
            html += queryZQJLHTML(results[i], i);
          }
          $(_pageId + ".sgcx_main_info").show();
          $(_pageId + ".sgcx_main_info").html(html);

          $(_pageId + ".no_data").hide();
        } else {
          nodata(1);
        }
      } else {
        nodata(1);
        if (data.error_no < 0) {
          $.alert(data.error_info)
        }
      }
    } else {
      nodata(1);
    }
  }

  /*******
   * 中签记录页面显示
   * @param element
   * @param i
   * @returns {string}
   */
  function queryZQJLHTML(element, i) {
    var eleHtml = "";
    var banlance = (parseFloat(element.occur_amount) || 0) * (parseFloat(element.business_price) || 0);
    eleHtml += "<li>";
    eleHtml += "<div class='nsb_conveible'>";
    eleHtml += "<div class='justify-content-space-between sub1'>";
    eleHtml += "<div class='row_01 sub' style='padding-left: 0.15rem;'>";
    eleHtml += "<span class='stock_name'>" + element.stock_name + "</span>"
    eleHtml += "<span class='stock_code reset'>" + element.stock_code + "</span>";
    eleHtml += "</div>";
    eleHtml += "</div>";
    eleHtml += "<ul class='row_02 sub'>";
    eleHtml += "<li><span class='hed'>中签日期</span><span class='stock_name reset'>" + joint(element.init_date, "-") + "</span></li>";
    eleHtml += "<li><span class='hed'>中签数量</span><span class='applymax_online reset'>" + (element.occur_amount && element.occur_amount.length > 0 ? element.occur_amount : "--") + "</span></li>";
    eleHtml += "<li><span class='hed'>成交价格</span><span class='subscribe_code reset'>" + (element.business_price && element.business_price.length > 0 ? element.business_price : "--") + "</span></li>"
    eleHtml += "<li><span class='hed'>成交金额</span><span class='issue_price reset'>" + banlance.toFixed(2) + "</span></li>";
    eleHtml += "</ul>";
    eleHtml += "</div>";
    eleHtml += "</li>";
    return eleHtml;
  }

  /**
 * 事件绑定
 */
  function bindPageEvent() {
    $.bindEvent($(_pageId + "header .icon_back"), function () { // 返回
      $.pageBack();
    });

    $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(0)"), function () { // 申购查询
      showMainView(0);
    });

    $.bindEvent($(_pageId + ".nsb_tab_nav ul li:eq(1)"), function () { // 中签查询
      showMainView(1);
    });

    $.bindEvent($(_pageId + " .date_filter .btn"), function (e) {
      var end_ = $(_pageId + " #endDate").text();
      var begin_ = $(_pageId + " #startDate").text();
      begin_time = begin_.replaceAll("-", "");
      end_time = end_.replaceAll("-", "");
      if (Number(begin_time) > Number(end_time)) {
        $.alert("开始日期大于结束日期");
        return;
      }
      checkDate = '';
      if (sgIndex == 0) {
        querySGData();
      } else if (sgIndex == 1) {
        queryZQJLData();
      } 
    });

  }


  /*****
   * 显示主页面
   * @param index 0申购查询 1中签查询
   */
  function showMainView(index) {
    sgIndex = index;
    checkDate = '';
    commonFunc.initTimeChoice(_pageId, 7);
    var end_ = $(_pageId + " #endDate").text();
    var begin_ = $(_pageId + " #startDate").text();
    begin_time = begin_.replaceAll("-", "");
    end_time = end_.replaceAll("-", "");
    $(_pageId + ".sgcx_main_info").html('');
    if (index == 0) {
      $(_pageId + ".nsb_tab_nav ul li:eq(0)").addClass("active");
      $(_pageId + ".nsb_tab_nav ul li:eq(1)").removeClass("active");
      $(_pageId + ".line1").hide();
      querySGData();
    } else if (index == 1) {
      $(_pageId + ".nsb_tab_nav ul li:eq(1)").addClass("active");
      $(_pageId + ".nsb_tab_nav ul li:eq(0)").removeClass("active");
      $(_pageId + ".line1").hide();
      queryZQJLData();
    }
  }

  /*******
   * 无数据
   * @param flag
   */
  function nodata(flag) {
    if (flag == 0) {
      $(_pageId + ".no_data .no_data_tip").html("未查询到申购信息");
      $(_pageId + ".sgcx_main_info").html('');
      $(_pageId + ".djk").hide();
      $(_pageId + ".sgcx_main_info").hide();
      $(_pageId + ".nsb_no_data").hide();
      $(_pageId + ".no_data").show();
    } else if (flag == 1) {
      $(_pageId + ".no_data .no_data_tip").html("未查询到中签信息");
      $(_pageId + ".sgcx_main_info").html('');
      $(_pageId + ".djk").hide();
      $(_pageId + ".sgcx_main_info").hide();
      $(_pageId + ".nsb_no_data").hide();
      $(_pageId + ".no_data").show();
    }
  }

  /********
   * 浮点数加法运算
   * @param arg1
   * @param arg2
   * @returns {number}
   * @constructor
   */
  function FloatAdd(arg1, arg2) {
    var r1, r2, m;
    try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
    m = Math.pow(10, Math.max(r1, r2));
    return (arg1 * m + arg2 * m) / m;
  }

  /********
   * 浮点数减法运算
   * @param arg1
   * @param arg2
   * @returns {string}
   * @constructor
   */
  function FloatSub(arg1, arg2) {
    var r1, r2, m, n;
    try { r1 = arg1.toString().split(".")[1].length } catch (e) { r1 = 0 }
    try { r2 = arg2.toString().split(".")[1].length } catch (e) { r2 = 0 }
    m = Math.pow(10, Math.max(r1, r2));
    //动态控制精度长度
    n = (r1 = r2) ? r1 : r2;
    return ((arg1 * m - arg2 * m) / m).toFixed(n);
  }

  /*******
 * 数据重置
 */
  function destroy() {
    $.clearRequest();
    html = '';
    userInfo = null;
    checkDate = '';//判断页面是否显示日期
    begin_time = '';
    end_time = '';
    sgIndex = 0;
    $(_pageId + ".sgcx_main_info").hide();
    $(_pageId + ".sgcx_main_info").html('');
    $(_pageId + ".no_data").hide();
    service.destroy();
  }

  var base = {
    "init": init,
    "load": load,
    "bindPageEvent": bindPageEvent,
    "destroy": destroy
  };
  module.exports = base;
});
