/**
 * 键盘js
 */
define('trade/scripts/option/keyboard1.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
    require('keyPanel'); // 首先引入 keyPanel 插件
	var myKeyPanel = new $.KeyPanel(); // 创建与当前页面对应的 keyPanel 对象
    
	/**
	 * 初始化页面的键盘div
	 */
	function keyInit(inputValue){
		keyDestroy();
		keypanel(inputValue);
	}
	
	/**
	 * 生成对应的键盘div
	 * @param {Object} _pageId 页面的id
	 */
	function setDiv(_pageId){
//		$("._jump_layer_mask").show();
		var jpMap = {
				"telephone":"1", // 打电话键盘
				"number":"6", // 带小数点数字键盘
				"tel":"7",
				"tel2":"2",
				"tel8":"8",
				"english":"4",
				"shares":"5",
				"password2":"m2",
				"password8":"m8",
				"password9":"m9",
				"password10":"m10"
			};
		var inputKey = $(_pageId+' input[js-key]');
		inputKey.attr("readonly","readonly");
		inputKey.attr("type","password");
		inputKey.hide();
		for(var i = 0; i < inputKey.length; i++){
			var inp = inputKey.eq(i);
			if(inp.next("div.jsKey").length == 0){
				var typeName = inp.attr("js-key");
				var type = jpMap[typeName];
				var id = inp.attr("id");
				var css = inp.attr("class");
				var val = inp.val();
				var placeholder = inp.attr("placeholder");
				var maxlength = inp.attr("maxlength");
				var div = [];
				if(type == "5"){
					div.push("<div is-stock-input='true' id='");
				}
				else{
					div.push("<div id='");
				}
				div.push(id);
				div.push("' class='");
				div.push(css);
				div.push(" jsKey' key-type='");
				div.push(type);
				div.push("' maxlength='");
				div.push(maxlength);
				var valem = val;
				var key_text = val;
				var key_pwd = "";
				if(type.indexOf("m") != -1){
					key_pwd = " key_pwd";
					val = val + "";
					key_text = "";
					valem = "";
					for(var i = 0; i < val.length; i++){
						key_text += "<b></b>";
						valem += "*";
					}
				}
				div.push("'><em style='display: none;'>"+valem+"</em><div ");
				if(inp.css("text-align") == "right"){
					div.push("style='right: 5px;' ");
				}
				div.push("class='key_input");
				div.push(key_pwd+"'><div class='key_text'>"+key_text+"</div>");
				div.push("<div class='key_cursor'></div></div>");
				if(placeholder){
					var di = "";
					if(val){
						di = "style=\"display: none;\"";
					}
					div.push("<div "+di+" class='" + css + " key_place'>" + placeholder + "</div>");
				}
				div.push("</div>");
				inp.after(div.join(""));
				if(val){
					inp.next("div.jsKey").val(val);
				}
			}
		}
//		$("._jump_layer_mask").hide();
	}
	
	/**
	 * 当原生键盘弹出时
	 * 计算页面上提高度
	 * @param {Object} n 当前点击的div $()对象
	 */
	function liftingHeight(n) {
		var a = n.parents('[key-panel-main="true"]');
		a.css("margin-top", "0px");
		$("#rewriteWaitingLayer").show();
		if(a && a.length > 0) {
			var b = n.offset().top;
			var	c = n.height();
			var	d = gconfig.appHeight - 280;
			var	e = b + c + 20 - d;
			var	f = a.css("margin-top").slice(0, -2);
			if(e > 0){
				a.css("margin-top", +f - e + "px");
				if(f - e < 0){
					$("#rewriteWaitingLayer").hide();
				}
			}
		}
	}

	/**
	 * 设置键盘公共方法
	 * @param {Object} data
	 */
	function keypanel(inputValue){
		var _pageId = "#"+$.getCurrentPageObj().pageId;
		//把h5的js自绘键盘改成对应的原生键盘配置
		setDiv(_pageId);
		
		/**
		 * 点击页面其他地方隐藏键盘
		 */
		$.bindEvent($(_pageId), function(e){
			if(global.callNative){
				$(_pageId).css("margin-top", "0px");
				$("#rewriteWaitingLayer").show();
				$.callMessage({"moduleName":global.nativeModuleName,"funcNo": "50211"});
			}
		    $(_pageId + " div.jsKey.active[key-type]").triggerHandler("blur");
		    $(_pageId + " div.jsKey.active[key-type]").removeClass("active");
		    myKeyPanel.close();
		});
		
		/**
		 * 点击输入框
		 */
		$.bindEvent($(_pageId + " div.jsKey[key-type]"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			clickOpenKeyboard(this,_pageId,inputValue);
			e.stopPropagation();
		});
		
		// 默认绑定键盘的input事件
		if(!global.callNative){
			$.bindEvent($(_pageId + " div.jsKey[key-type]"), function(e){
				var a = e.detail;
				popUpKeyboard($(this),e);
			    e.stopPropagation();
			}, "input");
		}else{
			$.bindEvent($(_pageId + " input[js-key]"), function(e){
				var a = e.detail;
				popUpKeyboard($(this),e);
			    e.stopPropagation();
			}, "input");
		}
		
	}
	
	/**
	 * 打开键盘
	 * @param {Object} t
	 */
	function clickOpenKeyboard(t,_pageId,inputValue){
		var appMap = {"1":"3","6":"3","7":"6","8":"3","2":"7","4":"1","5":"2","m2":"5","m8":"4"};
		$.closeModal(".picker-modal.modal-in");
		var $this = $(t);
		var keyPanelType = $this.attr("key-type");
		if(!$this.hasClass("active") && keyPanelType){
			$(_pageId + " div.jsKey.active").triggerHandler("blur");
			$(_pageId + " div.jsKey.active").removeClass("active");
		    $this.addClass("active");
			if(!global.callNative){
				var isPassword = false;
			    var keyPanelConfig = {
			            beforeInitFunc: function(){
			            	
			            },
			            afterInitFunc: function(){
			            	
			            },
			            beforeCloseFunc: function(){
			            	
			            },
			            afterCloseFunc: function(){
			            	
			            },
			            isSaveDom: true, // 是否保存键盘 DOM 在页面中
						skinName:'default2',//目前皮肤包括black，white,default,default2,缺省是default
						okFunc : function() { // 点击键盘确定按钮绑定的方法
							if(inputValue){
								inputValue();
							}// 根据值搜索对应股票
						}
			    };
				if(keyPanelType.indexOf("m") != -1){
					keyPanelType = keyPanelType.replace("m","");
					isPassword = true;
					keyPanelConfig.isSaveDom = false;
				}
			    myKeyPanel.init(t, keyPanelType, isPassword, keyPanelConfig); // 执行初始化
			}
			else{
				window.customKeyboardEvent = {
					keyBoardFinishFunction: function(){
						$(_pageId).css("margin-top", "0px");
						$("#rewriteWaitingLayer").show();
						$(_pageId + " div.jsKey.active").removeClass("active");
					},
					keyBoardInputFunction: function(keyCode){
						if(keyCode == -4){
							$(_pageId).css("margin-top", "0px");
							$("#rewriteWaitingLayer").show();
							$(_pageId + " div.jsKey.active").removeClass("active");
						}
						$this.prev("input").attr("keyDiv",keyCode);
						$this.prev("input").triggerHandler("input");
					}
				};
				var pageId = _pageId.substring(1,_pageId.length);
				var eleId = $this.attr("id");
				var keyboardType = appMap[keyPanelType];
				liftingHeight($this);
			$.callMessage({"moduleName":global.nativeModuleName,"funcNo": "50210", "pageId":pageId, "eleId":eleId, "doneLable":"确定", "keyboardType":keyboardType});
			}
		}
	}
	
	/**
	 * 输入值是改变div的值
	 * @param {Object} jsKey 当前点击的div
	 * @param {Object} e
	 */
	function popUpKeyboard(jsKey, e){
		if(!global.callNative){
			var type = jsKey.attr("key-type") || "";
			var op_str = jsKey.attr("value") || jsKey.val();
			jsKey.val(op_str);
	  		var key_text = jsKey.find("div.key_input div.key_text");
			var inp = jsKey.prev("input");
			if(op_str.length == 0){
				jsKey.find("div.key_place").show();
			}else{
				jsKey.find("div.key_place").hide();
			}
			if(type.indexOf("m") != -1){
				var pwdDiv = '';
				for(var i = 0; i < op_str.length; i++){
					pwdDiv += "<b></b>";
				}
				key_text.html(pwdDiv);
			}
			else{
				key_text.html(op_str);
			}
			jsKey.attr("value","");
			inp.val(op_str);
		}
		else{
			var op_str = jsKey.val();
			jsKey = jsKey.next("div.jsKey");
			var type = jsKey.attr("key-type") || "";
	  		var key_text = jsKey.find("div.key_input div.key_text");
			var inp = jsKey.prev("input");
			if(op_str.length == 0){
				jsKey.find("div.key_place").show();
			}else{
				jsKey.find("div.key_place").hide();
			}
			if(type.indexOf("m") != -1){
				var pwdDiv = '';
				for(var i = 0; i < op_str.length; i++){
					pwdDiv += "<b></b>";
				}
				key_text.html(pwdDiv);
			}
			else{
				key_text.html(op_str);
			}
		}
	}
	
	/**
	 * 退出页面时执行的清除方法
	 */
	function keyDestroy(){
		if(global.callNative){
			$(_pageId).css("margin-top", "0px");
			$("#rewriteWaitingLayer").show();
			$.callMessage({"moduleName":global.nativeModuleName,"funcNo": "50211"});
			$(_pageId + " div.jsKey[key-type]").prev("input").attr("keyDiv","");
		}
		var _pageId = "#"+$.getCurrentPageObj().pageId;
		$(_pageId + " div.jsKey.active[key-type]").triggerHandler("blur");
		$(_pageId + " div.jsKey.active[key-type]").removeClass("active");
		$(_pageId + " div.jsKey[key-type]").val("").attr("value","");
		$(_pageId + " div.jsKey[key-type] em").text("");
		$(_pageId + " div.jsKey[key-type]").find("div.key_input div.key_text").html("");
		$(_pageId + " div.jsKey[key-type]").find("div.key_place").show();
		myKeyPanel.close();
	}
	
	/**
	 * 隐藏键盘方法
	 */
	function closeKeyPanel(){
		var _pageId = "#"+$.getCurrentPageObj().pageId;
		if(global.callNative){
			$(_pageId).css("margin-top", "0px");
			$("#rewriteWaitingLayer").show();
			$.callMessage({"moduleName":global.nativeModuleName,"funcNo": "50211"});
		}
		$(_pageId + " div.jsKey.active[key-type]").triggerHandler("blur");
		$(_pageId + " div.jsKey.active[key-type]").removeClass("active");
		myKeyPanel.close();
	}
	
	var base = {
    	"keyInit": keyInit,
    	"clickOpenKeyboard":clickOpenKeyboard,
    	"closeKeyPanel": closeKeyPanel,
    	"popUpKeyboard": popUpKeyboard,
    	"keyDestroy": keyDestroy
    };
    if(!global.startJSkeyboard && !global.callNative){
    	base = null;
    }

    module.exports = base;
});