/**
 * 信用交易-交易撤单]
 */
define('trade/scripts/option/order/cancellation.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var _pageId = "#option_order_cancellation ";
	var common = require("common");
   	var publicCancel = require("publicCancel");
    var data = {
		"queryFuncNo": "305021",
		"queryParam": {},
		"htmlData": {
			"topDiv": {
//				"entrust": "entrust_name",
				"name": "option_name",
				"code": "option_code",
			},
			"liList": [
				["业务名称", "entrust_name"],
				["委托状态", "entrust_status_name"],
				["委托价格", "opt_entrust_price"],
				["委托数量", "entrust_amount"],
				["成交价格", "opt_business_price"],
				["成交数量", "business_amount"],
				["委托时间", "entrust_time"],
				["委托编号", "entrust_no"],
				["委托属性", "entrust_prop_name"],
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
			],
			//撤单提示字段
			"tipStr":[
				["合约代码", "option_code"],
				["合约名称", "option_name"],
				["委托编号", "entrust_no"],
//				["委托方式", "entrust_prop_name"],
				["委托价格", "opt_entrust_price"],
				["委托数量", "entrust_amount"],
			]
		},
		"cancelFuncNo":"305006",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
    }
    
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("107085");
		common.switchingCurUser("2");
		publicCancel.init(data);
    }
		
	function load(){
		publicCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
          		var pageCode = $.getCurrentPageObj().pageCode || '';
          		var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
			common.returnNative();
			common.comStat(107086,2,103,true,{"i_group_name":"返回"});//埋点
			
			if(global.callNative){
				if($.getPageParam("isFromApp")){
					//ios切换行情
					$.callMessage({
						"funcNo": "50500",
						"msgNo": "205",
						"sourceModule":"trade",
						"targetModule":"app",
						"action":"4",
						"param":{}
					});
				}
				$.pageInit(pageCode,prePageCode,{"_loginClass":"2"},"left",true);
			}
			else{
				$.pageInit(pageCode,prePageCode,{"_loginClass":"2"},"left",true);
			}
			e.stopPropagation();
		});
		
		
		publicCancel.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		publicCancel.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
	};
	module.exports = base;
});