/**
 * 股票期权--下单--行权
 */
define('trade/scripts/option/order/exercise.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var _pageId = "#option_order_exercise ";
	var service_option = require("service_option");
	var common = require("common");
	var keyboard = require("keyboard");
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var userInfo = null;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var slideHeight = null;
	
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("107254");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			common.comStat(107255,2,103,true,{"i_group_name":"返回"});
          		var pageCode = $.getCurrentPageObj().pageCode || '';
          		var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
			$.pageInit(pageCode,prePageCode,{"_loginClass":"2"},"left",true);
			e.stopPropagation();
		});
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
		slideHeight = mainHeight - $(_pageId + " .option_tab").getMHeight();
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryData();
	}
	
	
	function queryData(){
		$(_pageId+" .option_pos_table table").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.recentVesting(param,queryDayOrderCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无可行权记录");
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	function queryDayOrderCallback(data){
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var htmlTop = '';
					htmlTop += '<tr class="trTop"><th scope="col">&nbsp;</th><th scope="col">期权名称</th><th scope="col">持仓/可用</th><th scope="col">均价/现价</th><th scope="col">浮动盈亏</th></tr>';
					for (var i=0;i<results.length;i++){ 
						htmlTop += queryEntrustHTML(results[i]);
					}
					$(_pageId+" .option_pos_table table").html(htmlTop);
					
					$.bindEvent($(_pageId+" .option_pos_table table tr.date_td td.btn"), function(e){
						var $div = $(this).parent("tr.date_td").prev("tr");
						var optionCode = $div.attr("id");
						var optionName = $div.attr("option_name");
						var exchange = $div.attr("exchange_type");
						queryMaxAmount(optionCode,optionName,exchange);
						e.stopPropagation();
					});
					
					common.setNoData(false,"暂无可行权记录");
				}
				else{
					common.setNoData(true,"暂无可行权记录");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element,i){
		var price_digit = 4;
		var eleHtml = "";
		var css = "";
		var float_yk = Number(element.income_balance);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		float_yk = float_yk.toFixed(2);
		eleHtml+='<tr class="cc" id="'+element.option_code+'" option_name="'+element.option_name+'" exchange_type="'+element.exchange_type+'">';
		eleHtml+='<td>';
		if(element.opthold_type == 0){
			eleHtml+='<em class="label label_01">权利</em>';
		}
		else if(element.opthold_type == 1){
			eleHtml+='<em class="label label_02">义务</em>';
		}
		else if(element.opthold_type == 2){
			eleHtml+='<em class="label label_03">备兑</em>';
		}
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.option_name+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.hold_amount+'</p>';
		eleHtml+='<p>'+element.enable_amount+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.cost_price+'</p>';
		eleHtml+='<p>'+element.last_price+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p class="'+css+'">'+float_yk+'</p>';
		eleHtml+='</td>';
		eleHtml+='</tr>';
		eleHtml+='<tr class="date_td">';
		eleHtml+='<td colspan="4"><em class="tag tag_01">期</em>'+element.exercise_date+' (剩余'+element.apart_days+'天)';
		if(element.opthold_type == 1){
			eleHtml+='<em class="tag tag_02">保</em>'+element.duty_used_bail;
		}
		eleHtml+='</td>';
		if(element.apart_days >= 0){
			eleHtml+='<td class="btn"><a href="javascript:void(0)" class="more_btn">立即行权</a></td>';
		}
		eleHtml+='</tr>';
		return eleHtml;
	}
	
	
	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(optionCode,optionName, exchange){
		var entrust_bs = "1";
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = "";
		var entrust_prop_opt = "92";//92
		var entrust_price = "";
		var option_code = optionCode;
		var entrust_oc = "2";//0：开仓  1：平仓  2：行权）
		var covered_flag = "0";//备兑标志（见数据字典）
		var stock_account = "";
		var exchange_type = exchange;
		var param = {
				 "entrust_way": entrust_way,
				 "branch_no": branch_no,
				 "fund_account": fund_account,
				 "cust_code": cust_code,
				 "stock_code": stock_code,
				 "option_code": option_code,
				 "entrust_bs": entrust_prop_opt,//0：买入，1：卖出
				 "entrust_oc": entrust_oc,
				 "entrust_prop_opt": entrust_prop_opt,
				 "covered_flag": covered_flag,
				 "entrust_price": entrust_price,
			};
  	  	service_option.optionCodeInformation(param,queryMaxAmountCallBackMax,{"isLastReq":true,"isShowWait":true});
		
	}
	function queryMaxAmountCallBackMax(data){
		if(data.error_no == 0){
			var results = data.results;
			if(data.DataSet) {
				results = data.DataSet;
			}
			if(results.length>0){
				getStockMsg(results[0]);
			}
		}
		else{
			$.alert(data.error_info);
		}
	}
	
	
	 /**
     * 股票联动，获取信息
     */
    function getStockMsg(data){
    	$(_pageId).attr("key-panel-main","false");
		var tipStr = "<div class='pop_nums back_form' >";
		tipStr += '<div class="input_form" style="margin:0 -10px;padding-left:0;"><div class="input_text text left bor dif_bg_form">';
		tipStr += '<label class="left10">合约名称</label><input type="text" class="t1" style="width: 80%;" value="'+data.option_name;
		tipStr += '" readonly="readonly"/>';
		tipStr += '</div><div class="input_text text left bor dif_bg_form"><label class="left10">可行权数量</label><input type="text" class="t1" style="width: 80%;"  value="'+Number(data.enable_amount);
		tipStr += '" readonly="readonly"/>';
		tipStr += '</div><div class="input_text text left bor mt10" style="height: 30px;"><label class="left10">行权数量</label>';
    	tipStr += '<input id="transferIn" js-key="tel8" type="tel" class="t1 transferIn"/><a style="border: 1px solid #2277CC;" href="javascript:void(0);" class="all">全部</a></div></div></div>';
		//埋点数据
		var comStatParam={
			"i_entrust_bs": "1", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":data.option_code, // 股票代码
			"i_stock_name":data.option_name, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":data.exchange_type, // 交易市场
			"i_entrust_price":data.lastprice || data.exercise_price || "0.01", // 选择后的价格
			"i_entrust_amount":"", // 委托数量
		}
		common.iConfirm("行权",tipStr,function($html){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var num = $html.find("#transferIn").val();
			vailSubmitOrder(data,num);//股票联动，获取信息
			$(_pageId).attr("key-panel-main","true");
			comStatParam.i_entrust_amount= num;
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
			common.comStat(107259,2,3,false,comStatParam);
		},function($html){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId).attr("key-panel-main","true");
			var num = $html.find("#transferIn").val();
			comStatParam.i_entrust_amount= num;
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
			common.comStat(107259,2,3,false,comStatParam);
		},"提交","取消",function($html){
			var canTurnNun = $html.find(".dif_bg_form input").val();
			var num = $html.find("#transferIn").val();
			if(!num || num.length == 0){
				$.alert("请输入数量");
				return false;
			}
			else if(!validatorUtil.isNumeric(num)){
				$.alert("输入数量无效");
				return false;
			}
			else if(num <= 0){
				$.alert("请输入数量大于0");
				return false;
			}else{
				return true;
			}
		});
		if(keyboard){
			keyboard.keyInit();
		}
		$.bindEvent($(_pageId+".pop_nums .input_text .all"),function(e){
			var all = $(this).parent(".input_text").prev(".dif_bg_form").find("input").val() || "";
//			$(this).parents(".input_text").next(".input_box").find(".input_value input").val(all);
			$(_pageId+" #transferIn").quzhi(all);
			e.stopPropagation();	// 阻止冒泡
		});
    
    }
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(results,stockNum){
		
		var entrust_bs = "1";
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = results.stock_code;
		var entrust_prop_opt = "92";
		var entrust_price = results.lastprice || results.exercise_price || "0.01";
		var option_code = results.option_code;
		var entrust_oc = "2";//0：开仓  1：平仓  2：行权）
		var covered_flag = "0";//备兑标志（见数据字典）
		var exchange_type = results.exchange_type;
		var stock_account = results.stock_account;
		var entrust_amount = stockNum;
		var param = {
				 "entrust_way": entrust_way,
				 "branch_no": branch_no,
				 "fund_account": fund_account,
				 "cust_code": cust_code,
				 "session_id": session_id,
				 "exchange_type": exchange_type,
				 "stock_account": stock_account,
				 "option_code": option_code,
				 "entrust_amount": entrust_amount,
				 "entrust_price": entrust_price,
				 "entrust_bs": entrust_prop_opt,
				 "entrust_oc": entrust_oc,
				 "entrust_prop_opt": entrust_prop_opt,
				 "covered_flag": covered_flag
			};
		service_option.placeAnOrder(param,getStockBuyCallBack,{"isShowOverLay":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}});
		$.showPreloaders("请等待...");
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				$.alert(tipStr);
			}
			queryData();
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller(){
		var scrollOptions = {
			scrollerHeight: slideHeight-10, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		common.bindStockEvent($(_pageId + '.option_tab ul li a'),true);
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+" .option_pos_table table").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});