/**
 * 信用交易-下单首页
 */
define('trade/scripts/option/order/homePage.js', function(require, exports, module) {
    var _pageId = "#option_order_homePage ";
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var commonHq = require("commonHq");
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var service_option = require("service_option");
	var keyboard = require("keyboard1");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var fifthOrder_timer = null;//五档行情定时器
    var position_timer = null;
    var _orderType = "1";
    var _PageParam = {};
    var downslide = new (require("downslide")).Downslide();
    var downslide1 = new (require("downslide")).Downslide();
    var butPriceList=[];
    var market_data = {
		"SH" : {
			"86":"市价剩余转限价",
			"88":"市价即时全部成交否则撤单",
			"90":"市价即时成交剩余撤单",
//			"3":"市价IOC",
//			"4":"市价FOK",
//			"5":"市价剩转限价GFD",
		},
		"SZ" : {
			"6":"市价最优五档即时成交剩余撤销",
			"7":"市价全额成交或撤销",
			"8":"市价本方最优价格",
			"9":"市价对手方最优价格",
			"10":"市价即时成交剩余撤销",
		},
    };//市价委托的数据
	var orderTypeInfo = { // 委托名称
		"1":{
			"name":"买入开仓",
			"entrust_bs":"0",
			"entrust_oc":"0",
			"covered_flag":"0",
		},
		"2":{
			"name":"卖出开仓",
			"entrust_bs":"1",
			"entrust_oc":"0",
			"covered_flag":"0",
		},
		"3":{
			"name":"买入平仓",
			"entrust_bs":"0",
			"entrust_oc":"1",
			"covered_flag":"0",
		},
		"4":{
			"name":"卖出平仓",
			"entrust_bs":"1",
			"entrust_oc":"1",
			"covered_flag":"0",
		},
		"5":{
			"name":"备兑开仓",
			"entrust_bs":"1",
			"entrust_oc":"0",
			"covered_flag":"1",
		},
		"6":{
			"name":"备兑平仓",
			"entrust_bs":"0",
			"entrust_oc":"1",
			"covered_flag":"1",
		},
		"7":{
			"name":"行权",
			"entrust_bs":"1",
			"entrust_oc":"2",
			"covered_flag":"0",
		},
	};
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _queryHolding = false;
    var notice_info = null;//系统提示信息
	var JumpUpDown;
	var setHomepage = require("trade/scripts/option/set/homepage.js");
	var _priceObj = setHomepage.getPriceObj();
	var setDate="";
	
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("107024");
		common.switchingCurUser("2");
		downslide.addSlide();
		if(keyboard){
			keyboard.keyInit();
		}
		_PageParam = $.getPageParam() || {};
		userInfo = common.getCurUserInfo();
		stock_info = ioitStock();
		initHtml();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
		var slideHeight = mainHeight - $(_pageId + " .place_order_top").getMHeight() - $(_pageId + " .place_order_main").getMHeight() - $(_pageId + " .option_tab ").getMHeight();
		downslide.rollInit(slideHeight,_pageId+" .main");
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		if(stock_info){
			$(_pageId + " #stockNum").nextAll("em").find("i").text(stock_info.lot_size);
		}
		commonHq.initCheckTradeTimer();
		var option_code = _PageParam["optionCode"];
		// 查询个股行情
		if(option_code){
			var stockCode = _PageParam["code"] || _PageParam["stock_code"];
			var market = _PageParam["market"];
			var exchange_type = _PageParam["exchange_type"];
			queryData(option_code,exchange_type,stockCode,market);
		}
		marketPrice();
		queryCapital();
		queryDayOrder();
		queryPosition();
//		hqwnChoice();
		underlyingSecurities();
		
		
		if(position_timer == null && global.positionRefreshTime){
			position_timer = window.setInterval(function(){
				if(commonHq.getTradingTime() && _callback && common.isAppFlag()){
					queryCapital(true);
					queryHolding(true);
				}
			}, global.positionRefreshTime);//定时刷新
		}
	}
	
	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "is_homepage":""
		};
		//最后一个为超时处理函数
		service_option.queryAssets(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					for(var i=0;i<results.length;i++){
						if(results[i].money_type == "0"){
							var risk_degree = results[i].risk_degree;//风险度
							$(_pageId+" .place_order_top p em").eq(0).html(risk_degree);//总资产
							var enable_balance = Number(results[i].enable_balance).toFixed(2);
							$(_pageId+" .place_order_top p em").eq(1).html(enable_balance);//可取
						}
					}
				}else{
					$(_pageId+" .place_order_top p em").text("--");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	function underlyingSecurities(){
		$(_pageId + " .chooserOption #month").attr("type","");
		$(_pageId + " .chooserOption #month").text("所有日期");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.underlyingSecurities(param,underlyingSecuritiesCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
			}
		});
	}
	function underlyingSecuritiesCallback(data){
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					if(results.length == 1){
						$(_pageId + " .chooserOption #stockCode").text(results[0].stock_code+"  "+results[0].stock_name);
						queryOptionList(results[0].stock_code);
					}
					var htmlData= [];
					for (var i=0;i<results.length;i++){ 
						var obj = {
							"id":results[i].stock_code,
							"name":results[i].stock_code+"  "+results[i].stock_name,
						}
						htmlData.push(obj);
					}
					common.selectList($(_pageId + " .chooserOption #stockCode"),"",htmlData,function(obj){
			 			$(_pageId + " .chooserOption #stockCode").text(obj.name);
			 			$(_pageId + " .chooserOption #month").attr("type","");
			 			$(_pageId + " .chooserOption #month").text("所有日期");
					 	if($(_pageId+"#optionType li.active").index()==0){//认购
							common.comStat(107069,2,104,true,{"i_change_name":"期权标的列表","i_change_to":obj.id});//埋点
					 	}else{//认估
							common.comStat(107078,2,104,true,{"i_change_name":"期权标的列表","i_change_to":obj.id});//埋点
					 	}
			 			queryOptionList(obj.id);
                         common.selectList($(_pageId + " .chooserOption #month"),"",'',function(obj){});
			 		});
				}
				else{
					$(_pageId + " .chooserOption #stockCode").text("没有期权标的");
				}
			}else{
				$.alert(data.error_info);
			}
		}
	}
	
	
	/**
	 * 设置股票对象是信息参数
	 */
	function ioitStock(){
		setDate = $.getLStorageInfo("option_set_setDate") || setHomepage.mrz;
		$(_pageId + " #stockPrice").find("span").text(_priceObj[setDate.price_mode]);
		$(_pageId + " #stockPrice").find("span").attr("type",setDate.price_mode);
		$(_pageId + " #stockPrice").nextAll("em").find("i").text(setDate.add_price);
		var stockInfo = {
			"isHq":false,
	    	"optionCode": "",//期权合约代码
	    	"optionName": "",//期权合约名称
	    	"stockPrice" : "",// 证券价格
	    	"stockNum" : "",
            "opt_down_price": "", // 跌停价
            "opt_up_price": "", // 涨停价
	    	"stockMaxAmount" : 0,//证券最大数
	    	"price_step" : Number(setDate.add_price) || 0.0001, // 步长
			"price_digit" : 4, // 小数点位数
			"lot_size" : Number(setDate.num_add) || 1, //每手数量
			"stock_type" : "",//证券类型
			"stock_market" : "",//市场代码
			"gear_one" : false,//是否启动五档
			"exchange_type" : "",//交易市场（交易后台）
			"stock_account" : "",// 股东账号 
			"market_price" : false, // 是否市价委托
			"split_order":Number(setDate.split_order)||0//拆单数量
	    };
	    return stockInfo;
	}
	
	function initHtml(){
		stock_html = {
	    	"optionCode" : $(_pageId + " #optionCode em"), // 证券
	    	"optionName" : $(_pageId + " #optionCode input"), // 证券名称
	    	"stockPrice" : $(_pageId + " #stockPrice"),// 证券价格
	    	"stockNum" : $(_pageId + " #stockNum"), // 证券数量
	    	"stockMaxAmount": $(_pageId + " .ch_switch_box p em"),//证券最大数
	    	"buyGear" : $(_pageId + " .five_box tr").eq(5).nextAll("tr"), // 买五档
		   	"sellGear" : $(_pageId + " .five_box tr").eq(5).prevAll("tr"), // 卖五档
		   	"total" : $(_pageId + " .ce_btn #total"),// 计算金额显示
			"market_div" : $(_pageId+" #market"), // 委托方式
			"market_p" : $(_pageId + " #market_p"),
			"stockList" : $(_pageId + " #stock_list"),// 证券下拉列表
		}
	}
	
	
	/**
	 * 通过输入的字符查询出对应的证券列表
	 * @param {Object} stockCode 输入的字符
	 */
	function queryData(option_code,exchange_type,stockCode,market){
		clearBuyMsg();
		var vai1 = /^[0-9]{8}$/;
		var vai2 = /^[0-9]{6}$/;
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		if(vai1.test(option_code)){
			
			queryMaxAmount(option_code, false, exchange_type, stockCode);
		}
		if(!vai2.test(stockCode)){
			queryOptionList(stockCode);
		}
	}
	
	
	
	/**
	 * 查询股票的期权数据列表
	 * @param {Object} stockCode
	 * @param {Object} exerciseMonth
	 * @param {Object} exercisePrice
	 * @param {Object} option_code
	 */
	function queryOptionList(stockCode, callback){
		if(stockCode){
			var dataList = [];
			var monthList = {};
			var setOption = function(){
				var month = $(_pageId + " .chooserOption #month").attr("type");
				if(month){
	 				list = monthList[month];
	 			}
	 			else{
	 				list = dataList;
	 			}
		    	if(list){
		    		var optionType = $(_pageId + ' .chooserOption #optionType li.active').index() == 1 ? "P" : "C";//期权类型
		    		var html = "";
					for(var i = 0; i < list.length; i++){
						if(list[i].option_type == optionType){
							html += "<li id='" + list[i].option_code + "'>" + list[i].option_name + "</li>";
						}
					}
					$(_pageId+" .chooserOption .check_option_list ul").html(html);
		    		downslide1.rollRefresh();
		    		$.bindEvent($(_pageId+" .chooserOption .check_option_list ul li"), function(e){
						$.closeModal(".picker-modal.modal-in");
						$(this).addClass("active").siblings().removeClass("active");
						queryData($(this).attr("id"));
						//埋点
					 	if($(_pageId+"#optionType li.active").index()==0){//认购
							common.comStat(107071,2,104,true,{"i_change_name":"期权合约列表","i_change_to":$(this).html()});
					 	}else{
							common.comStat(107080,2,104,true,{"i_change_name":"期权合约列表","i_change_to":$(this).html()});
					 	}
						$(_pageId + " .chooserOption").hideLeft();
						e.stopPropagation();
					}, downslide1.clickType());
		    	}else{
					$(_pageId+" .chooserOption .check_option_list ul").html('');
                    $.closeModal(".picker-modal.modal-in");
				}
			}
			
			$.bindEvent($(_pageId+" .chooserOption .toggle_nav li"), function(e){
				if(!$(this).hasClass("active")){
					$.closeModal(".picker-modal.modal-in");
					$(this).addClass("active").siblings().removeClass("active");
					var objectId="";
					common.pageBuryingPoint();
					if($(this).index()==0){
						objectId="107067";
						common.pageBuryingPoint("107065");
					}else{
						objectId="107068";
						common.pageBuryingPoint("107076");
					}
					common.comStat(objectId,2,103,true,{"i_group_name":$(this).find("a").html()});//埋点
					setOption();
				}
				e.stopPropagation();
			});
			
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代码
			var session_id = userInfo.session_id;
			var stock_code = stockCode;
			var param = {
					 "entrust_way": entrust_way,
					 "branch_no": branch_no,
					 "fund_account": fund_account,
					 "cust_code": cust_code,
					 "stock_code": stock_code,
				};
		  	service_option.optionCodeInformation(param,function(data){
		  		_stockCode = stockCode;
		  		if(data.error_no == 0){
		  			dataList = data.results;
					if(data.DataSet) {
						dataList = data.DataSet;
					}
					if(dataList.length>0){
						if(stock_info){
							stock_info.isHq = true;
						}
						optionTypeList = {};
						monthList = {};
						if($.isValue(dataList)){
							var optionType = $(_pageId + '.chooserOption #optionType li.active').index() == 1 ? "P" : "C";//期权类型
							var html = "";
							for(var i = 0; i < dataList.length;i++){
								if(dataList[i].option_type == optionType){
									html += "<li id='" + dataList[i].option_code + "'>" + dataList[i].option_name + "</li>";
								}
								var month = dataList[i].exercise_month;
                                var key = dataList[i].exercise_month.replace(/(\d{6})\d{2}/,'$1');
								var ml = monthList[key+""] || [];
								ml.push(dataList[i]);
								monthList[key+""] = ml;
							}
							$(_pageId+" .chooserOption .check_option_list ul").html(html);
							if($(_pageId+" .chooserOption .check_option_list ul").isShow()){
								downslide1.rollRefresh();
							}
							$.bindEvent($(_pageId+" .chooserOption .check_option_list ul li"), function(e){
								$.closeModal(".picker-modal.modal-in");
								$(this).addClass("active").siblings().removeClass("active");
								queryData($(this).attr("id"));
								//埋点
							 	if($(_pageId+"#optionType li.active").index()==0){//认购
									common.comStat(107071,2,104,true,{"i_change_name":"期权合约列表","i_change_to":$(this).html()});
							 	}else{
									common.comStat(107080,2,104,true,{"i_change_name":"期权合约列表","i_change_to":$(this).html()});
							 	}
								$(_pageId + " .chooserOption").hideLeft();
								e.stopPropagation();
							}, downslide1.clickType());
							
							var htmlData = [{"id":"","name":"所有日期"}];
							for (var n in monthList){ 
								monthList[n].sort(function(a,b){
									return Number(a.exercise_price) - Number(b.exercise_price);
								});
								var obj = {
									"id":n,
									"name":n.substring(0,4) +'年' + n.substring(4,6) + '月',
								}
								htmlData.push(obj);
							}
							common.selectList($(_pageId + " .chooserOption #month"),"",htmlData,function(obj){
                                if(!obj){
                                    $.closeModal(".picker-modal.modal-in");
                                    return;
                                }
					 			$(_pageId + " .chooserOption #month").attr("type",obj.id);
					 			$(_pageId + " .chooserOption #month").text(obj.name);
					 			if($(_pageId+"#optionType li.active").index()==0){//认购
									common.comStat(107070,2,104,true,{"i_change_name":"到期日期列表","i_change_to":obj.name});//埋点
					 			}else{//认估
									common.comStat(107079,2,104,true,{"i_change_name":"到期日期列表","i_change_to":obj.name});//埋点
					 			}
					 			setOption();
					 		});
						}
						JumpUpDown = function(obj){
                            var key = obj.exercise_month.replace(/(\d{6})\d{2}/,'$1');
							var lists = monthList[key];
							var list = [];
							for(var i = 0; i <lists.length; i++){
								if(lists[i].option_type == obj.option_type){
									list.push(lists[i]);
								}
							}
							for(var i = 0; i <list.length; i++){
								if(list[i].option_code == obj.option_code){
									if(i == 0){
										$(_pageId + " .value_btn .fl_value").attr("id","");
										$(_pageId + " .value_btn .fl_value p").text("--");
										$(_pageId + " .value_btn .fr_value").attr("id",list[i+1].option_code);
										$(_pageId + " .value_btn .fr_value p").eq(0).text(list[i+1].option_name);
									}
									else if(i == list.length - 1){
										$(_pageId + " .value_btn .fl_value").attr("id",list[i-1].option_code);
										$(_pageId + " .value_btn .fl_value p").eq(0).text(list[i-1].option_name);
										$(_pageId + " .value_btn .fr_value").attr("id","");
										$(_pageId + " .value_btn .fr_value p").text("--");
									}
									else{
										$(_pageId + " .value_btn .fl_value").attr("id",list[i-1].option_code);
										$(_pageId + " .value_btn .fl_value p").eq(0).text(list[i-1].option_name);
										$(_pageId + " .value_btn .fr_value").attr("id",list[i+1].option_code);
										$(_pageId + " .value_btn .fr_value p").eq(0).text(list[i+1].option_name);
									}
									break;
								}
							}
							$.bindEvent($(_pageId + " .value_btn .fl_value").add($(_pageId + " .value_btn .fr_value")), function(e){
								var data_id=$(this).attr("data-id");
								if(data_id=="1"){
									common.comStat(107028,2,103,true,{"i_group_name":"上一只期权合约"});//埋点
								}else{
									common.comStat(107029,2,103,true,{"i_group_name":"下一只期权合约"});//埋点
								}
								var option_code = $(this).attr("id");
								if(option_code){
									queryData(option_code);
								}
								e.stopPropagation();
							});
						};
						if(callback){
							callback();
						}
					}else{
						$(_pageId+" .chooserOption .check_option_list ul").html('');
						common.selectList($(_pageId + " .chooserOption #month"),"",'',function(obj){});
					}
				}
				else{
					$.alert(data.error_info);
				}
		  	},{"isLastReq":true,"isShowWait":true});
			
		}
	}
	
	/**
	 * 市价委托
	 */
	function marketPrice(market){
		var input_value = stock_html.stockPrice.parents(".change_value_box");
		input_value.show();
		var liHtml = [{"id":"1","name":"限价委托"}];
		if(market){
			$.each(market_data[market], function(key,value) {
				 var obj = {"id":key,"name":value};
				 liHtml.push(obj);
			});
		}
		common.selectList($(_pageId + " #market"),"",liHtml,function(obj){
			if(obj.id == "1")
			{
				common.comStat(107030,2,104,true,{"i_change_name":"委托类型","i_change_to":"限价委托"});//埋点
				stock_html.market_div.find("input").val("限价委托");
				stock_html.market_div.attr("type",obj.id);
				stock_html.market_p.hide();
				input_value.show();
				stock_info.market_price = false;
				var stockPrice = getStockInfo("stockPrice");
				isQueryMax(stockPrice);
				//限价委托还原价格
				if(butPriceList && butPriceList.length>0){
					$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text(butPriceList[0]);
					$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text(butPriceList[1]);
					$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text(butPriceList[2]);
					$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text(butPriceList[3]);
				}
			}
			else
			{
				common.comStat(107030,2,104,true,{"i_change_name":"委托类型","i_change_to":"市价委托"});//埋点
				common.comStat(107031,2,104,true,{"i_change_name":"委托类型","i_change_to":obj.name});//埋点
				stock_html.market_div.find("input").val("市价委托");
				stock_html.market_div.attr("type",obj.id);
				stock_html.market_p.find("input").val(obj.name);
				input_value.hide();
				stock_html.market_p.show();
				stock_info.market_price = true;
				isQueryMax(0.01);
				//市价委托重置按钮上面的价格
				$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text("--");
				$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text("--");
				$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text("--");
				$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text("--");
			}
 		});
	}
	
	
	function isBuy(){
		if(_orderType == "1" || _orderType == "3" || _orderType == "6"){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * 获取证券信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			if(param == "stockPrice"){
				return $(_pageId + " #stockPrice").find("em").text();
			}
			else{
				var data = stock_html[param].quzhi();
				if(newest && stock_info){
					if(!data || data == "--"){
						stock_info[param] = 0;
					}
					else
					{
						stock_info[param] = data;
					}
				}
			}
			return data;
		}
		else{
			return '';
		}
	}
	
	/**
	 * 设置证券信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest){
		if(stock_html){
			if(key == "stockPrice"){
				$(_pageId + " #stockPrice").find("em").text(value);
				if(value){
					$(_pageId + " #stockPrice").find(" .key_place").hide();
				}
				else{
					$(_pageId + " #stockPrice").find(" .key_place").show();
				}
				$(_pageId + " #stockPrice").find(".key_text").text(value);
			}
			else{
				stock_html[key].quzhi(value);
				if(newest && stock_info){
					if(value == "--"){
						value = 0;
					}
					stock_info[key] = value;
				}
                if (key == "optionName") {
                    //股票名称长度过长缩放
                    var maxWidth = stock_html[key].parent().width() - 38;
                    var zoomValue = $.getTransformScaleFontSize(value, 16, maxWidth);
                    stock_html[key].css({
                        "fontSize": zoomValue + "px",
                    });
                }
			}
		}
	}
	
	
	/**
	 * 
	 * @param {Object} stockPrice
	 */
	function isQueryMax(stockPrice){
//		if(stock_info && (isBuy() || !stock_info.exchange_type) && stock_info.optionCode && stockPrice && stockPrice != "0"){
//			queryMaxAmount(stock_info.optionCode,true);
//		}
	}
	/**
	 * 限制小数点位数
	 * @param {Object} price
	 */
	function limitingDigit($this){
		var price_digit = stock_info.price_digit;
		var price = getStockInfo("stockPrice");
		if(price && validatorUtil.isNumberFloat(price)){
			var cur_arr = (price+"").split(".");
			if(cur_arr.length == 2){
				if(cur_arr[1].length > price_digit){
					var price = cur_arr[0]+"."+cur_arr[1].substring(0,price_digit);
					setStockInfo("stockPrice",price)
				}
			}
		}
	}
	
	
	
	
	//五档买卖盘
	function setFifthOrder(){
		var option_code = stock_info.optionCode;
		if(option_code){
			var fifthOrder = {
				"SecurityID" : option_code
			};
			var fifthOrder = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account": userInfo.fund_account,	//资产账户
				"cust_code": userInfo.cust_code,	//客户代码
				"exchange_type":stock_info.exchange_type,
				"option_code":option_code,
			};
			service_option.queryOptionsMarket(fifthOrder,callbackOptionsMarket,{"isShowWait":false,"errorFunc":function(){_fifthCallback = true;}});
			
//			commonHq.getOptionsFifthOrder(stock_info.stock_market+":"+option_code,function(results){
//				_fifthCallback = true;
//				var yesProfit = Number(results[26]);
//				var price_digit = stock_info.price_digit;
//				if(stock_info.gear_one){
//					var fifthOne = "";
//					var presentPrice = results[30];
//					if(isBuy()){
//						fifthOne = results[10];
//					}else{
//						fifthOne = results[16];
//					}
//					$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text(Number(results[10]).toFixed(price_digit));
//					$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text(Number(results[10]).toFixed(price_digit));
//					$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text(Number(results[16]).toFixed(price_digit));
//					$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text(Number(results[10]).toFixed(price_digit));
////					if(presentPrice != 0 && (fifthOne == "0" || presentPrice == results[0] || presentPrice == results[0])){
////						fifthOne = presentPrice;
////					}
//					fifthOne = Number(fifthOne).toFixed(price_digit);
//					var p_price = $.getPageParam("price");
//					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
//						fifthOne  = Number(p_price).toFixed(price_digit);
//					}
//					if(fifthOne && fifthOne != 0){
//						setStockInfo("stockPrice",fifthOne); // 股票现价
//					}
//					stock_info.gear_one = false;
//				}
//				//卖五档盘颜色集合
//				for(var i = 0 ; i < 5 ; i ++){
//					
//					addColor(stock_html.buyGear.eq(i),Number(results[16+i]),yesProfit,results[21+i],price_digit);
//					
//					addColor(stock_html.sellGear.eq(i),Number(results[6+i]),yesProfit,results[11+i],price_digit);
//				}
//			},function(){
//				_fifthCallback = true;
//			});
		}
	}
	
	function callbackOptionsMarket(data){
		_fifthCallback = true;
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var yesProfit = Number(results[0].opt_open_price);
				var price_digit = stock_info.price_digit;
				if(stock_info.gear_one){
					var fifthOne = "";
					var presentPrice = results[0].opt_last_price;
//					if(isBuy()){
//						fifthOne = results[0].opt_sale_price1;
//					}else{
//						fifthOne = results[0].opt_buy_price1;
//					}
//					butPriceList=[results[0].opt_sale_price1,results[0].opt_sale_price1,results[0].opt_buy_price1,results[0].opt_buy_price1];
//					if(presentPrice != 0 && (fifthOne == "0" || presentPrice == results[0].opt_high_price || presentPrice == results[0].opt_low_price)){
						fifthOne = presentPrice;
//					}
					fifthOne = Number(fifthOne).toFixed(price_digit);
					var p_price = $.getPageParam("price");
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						fifthOne  = Number(p_price).toFixed(price_digit);
					}
					setStockInfo("stockPrice",fifthOne); // 股票现价
					$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text(fifthOne);
					$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text(fifthOne);
					$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text(fifthOne);
					$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text(fifthOne);
					stock_info.gear_one = false;
				}
				//卖五档盘颜色集合
				for(var i = 0 ; i < 5 ; i ++){
					
					addColor(stock_html.buyGear.eq(i),Number(results[0]["opt_buy_price"+(i+1)]),yesProfit,results[0]["buy_amount"+(i+1)],price_digit);
					
					addColor(stock_html.sellGear.eq(i),Number(results[0]["opt_sale_price"+(i+1)]),yesProfit,results[0]["sale_amount"+(i+1)],price_digit);
				}
			}
		}else{
//			$.alert(data.error_info);
		}
	}
	
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div,price,yesProfit,num,price_digit){
		var prices = div.find("td").eq(0);
		var nums = div.find("td").eq(1);
		yesProfit = Number(yesProfit).toFixed(price_digit);
		price = Number(price).toFixed(price_digit);
		if(Number(price) == 0){
			prices.text("--").attr("class","");
		}
		else if(Number(price) > Number(yesProfit)){
			prices.text(price).attr("class","ared");
		}
		else if(Number(price) < Number(yesProfit))
		{
			prices.text(price).attr("class","agreen");
		}
		else
		{
			prices.text(price).attr("class","");
		}
		if(num == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(num >= 100000){
			nums.text((num * 0.0001).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}
	
	
	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(optionCode,isMax, exchange, stockCode,callback){
		$(_pageId + " .place_order_main").addClass("current");
		$.hidePreloader();
		var entrust_bs = orderTypeInfo[_orderType].entrust_bs;
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = stockCode;
		var entrust_prop_opt = stock_html.market_div.attr("type");
		var entrust_price = getStockInfo("stockPrice");
		if(entrust_prop_opt == "1"){
			if($(_pageId + ".change_value_box .fok_btn").hasClass("active")){
				entrust_prop_opt = "84";
			}
			else{
				entrust_prop_opt = "82";
			}
		}
		if(entrust_bs == "1"){
			entrust_prop_opt = Number(entrust_prop_opt) + 1 + "";
		}
		var option_code = optionCode;
		var entrust_oc = orderTypeInfo[_orderType].entrust_oc;//0：开仓  1：平仓  2：行权）
		var covered_flag = orderTypeInfo[_orderType].covered_flag;//备兑标志（见数据字典）
		var stock_account = _PageParam["stock_account"] || stock_info.stock_account;
		var exchange_type = exchange || stock_info.exchange_type;
		var param = {
				 "entrust_way": entrust_way,
				 "branch_no": branch_no,
				 "fund_account": fund_account,
				 "cust_code": cust_code,
				 "stock_code": stock_code,
				 "option_code": option_code,
				 "entrust_bs": entrust_prop_opt,//0：买入，1：卖出
				 "entrust_oc": entrust_oc,
				 "entrust_prop_opt": "0",
				 "covered_flag": covered_flag,
				 "entrust_price": entrust_price,
			};
  	  	service_option.optionCodeInformation(param,function(data){
	  	  	if(isMax){
		  	  	queryMaxAmountCallBackMax(data,callback);
	  	  	}else{
	  	  		queryMaxAmountCallBack(data,callback);
	  	  	}
	  	  },{"isLastReq":true,"isShowWait":!isMax});
		
	}
	function queryMaxAmountCallBack(data,callback){
		if(data.error_no == 0){
			var results = data.results;
			if(data.DataSet) {
				results = data.DataSet;
			}
			if(results.length > 0){
				if(results.length == 1){
					if(_stockCode){
						JumpUpDown(results[0]);
					}
					else{
						queryOptionList(results[0].stock_code,function(){
							JumpUpDown(results[0]);
						});
					}
					var price_digit = stock_info.price_digit;
                    opt_down_price = results[0].opt_down_price;
                    opt_up_price = results[0].opt_up_price;
					var point = results[0].lastprice ? Number(results[0].lastprice) : 0;
					var p_price = _PageParam["price"] || _PageParam["entrust_price"];
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						point = p_price
					}
					setStockInfo("stockPrice",Number(point).toFixed(price_digit));
					var option_code = results[0].option_code;
					setStockInfo("optionCode",option_code,true);
					setStockInfo("optionName",results[0].option_name,true);
					setStockInfo("stockMaxAmount",Number(results[0].enable_amount),true);
					var exchange_type = results[0].exchange_type;
					stock_info.exchange_type = exchange_type;
					stock_info.stock_account = results[0].stock_account;
					
					if(exchange_type == "0" || exchange_type == "1" || exchange_type == "5")
					{
						stock_info.stock_market = "SZ";
						marketPrice("SZ");
					}
					else if(exchange_type == "2" || exchange_type == "3" || exchange_type == "15")
					{
						stock_info.stock_market = "SH";
						marketPrice("SH");
					}
					var setDate = $.getLStorageInfo("option_set_setDate") || setHomepage.mrz;
					var p_num = _PageParam["num"] || _PageParam["entrust_amount"]||setDate.order_num;
					if(p_num && p_num != 0 && validatorUtil.isNumeric(p_num)){
						setStockInfo("stockNum",p_num,true);
					}
					
					if (fifthOrder_timer != null ) {
				        window.clearInterval(fifthOrder_timer);
				    }
					stock_info.gear_one = true;
					setFifthOrder();
                    notice_info = results[0].notice_info;//系统提示信息
					_fifthCallback = false;
					fifthOrder_timer =  window.setInterval(function(){
						if(commonHq.getTradingTime() && _fifthCallback && common.isAppFlag()){
							setFifthOrder();
							_fifthCallback = false;
						}
					}, (global.refreshTime || 5000));//定时刷新
				}
			}
		}else{
			$.alert(data.error_info);
		}
		_PageParam = {};
        callback && callback();
	}
	function queryMaxAmountCallBackMax(data,callback){
		if(data.error_no == 0){
			var results = data.results;
			if(data.DataSet) {
				results = data.DataSet;
			}
			if(results.length>0){
				var price_digit = stock_info.price_digit;
				var setDate = $.getLStorageInfo("option_set_setDate") || setHomepage.mrz;
				setStockInfo("stockNum",setDate.order_num,true);
				setStockInfo("stockMaxAmount",Number(results[0].enable_amount),true);
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
                notice_info = results[0].notice_info;//系统提示信息
			}
		}
		else{
			$.alert(data.error_info);
		}
		_PageParam = {};
        callback && callback();
	}
	
	// 计算当前总值
	function totalValue(stockPrice,stockNum){
		if(stock_html){
			stock_html.total.text("");
		}
	}
	
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		
		//验证证券代码输入是否正确
		var optionCode = stock_info.optionCode;
		if(optionCode.length == 0){
			$.alert("请先选择合约代码");
			return false;
		}	
		var vai1 = /^[0-9]{8}$/;
		if(!vai1.test(optionCode)){
			$.alert("合约代码不正确");
			return false;
		}	
		//验证证券价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length<=0){
			$.alert("请输入委托价格");
			return false;
		}
		else if(stockPrice == 0){
			$.alert("输入价格不能为0");
			return false;
		}
		else if(!validatorUtil.isNumberFloat(stockPrice)){
			$.alert("请正确输入价格");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount+"";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length<=0){
			$.alert("请输入委托数量");
			return false;
		}else if(!validatorUtil.isNumeric(stockNum)){
			$.alert("请正确输入数量");
			return false;
		}
		else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
        if (opt_up_price && opt_up_price != "--" && Number(stockPrice) > Number(opt_up_price)) {
			$.alert("超过涨跌停范围");
			return false;
        } else if (opt_down_price && opt_down_price != "--" && Number(stockPrice) < Number(opt_down_price)) {
			$.alert("超过涨跌停范围");
			return false;
        }
		var ts = "";
		//验证最大可买
//		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
////			$.alert("最大可"+typeText+"为0");
//			ts += "<em>最大可"+typeText+"为0；</em>";
////			return false;
//		}
//		else if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
////			$.alert("最大可"+typeText+"数量不足");
//			ts += "<em>最大可"+typeText+"数量不足；</em>";
////			return false;
//		}
		var entrust_bs = orderTypeInfo[_orderType].entrust_bs;
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = stock_info.stock_code;
		var entrust_prop_opt = stock_html.market_div.attr("type");
		var entrust_price = stockPrice;
		if(entrust_prop_opt == "1"){
			if($(_pageId + ".change_value_box .fok_btn").hasClass("active")){
				entrust_prop_opt = "84";
			}
			else{
				entrust_prop_opt = "82";
			}
		}
		if(entrust_bs == "1"){
			entrust_prop_opt = Number(entrust_prop_opt) + 1 + "";
		}
		var option_code = stock_info.optionCode;
		var entrust_oc = orderTypeInfo[_orderType].entrust_oc;//0：开仓  1：平仓  2：行权）
		var covered_flag = orderTypeInfo[_orderType].covered_flag;//备兑标志（见数据字典）
		var exchange_type = stock_info.exchange_type;
		var stock_account = stock_info.stock_account;
		var entrust_amount = stockNum;
		var param = {
			 "entrust_way": entrust_way,
			 "branch_no": branch_no,
			 "fund_account": fund_account,
			 "cust_code": cust_code,
			 "session_id": session_id,
			 "exchange_type": exchange_type,
			 "stock_account": stock_account,
			 "stock_code": stock_code,
			 "option_code": option_code,
			 "entrust_amount": entrust_amount,
			 "entrust_price": entrust_price,
			 "entrust_bs": entrust_prop_opt,          // 买卖方向
			 "entrust_oc": entrust_oc,				  // 开平仓方向
			 "covered_flag": covered_flag,            // 备兑标志
			 "confirm_flag": "1"
		};
		
		var tipStrArray = [];
		var tipStr = "<div >";
//		tipStrArray.push([stock_info.optionName, optionCode]);
		tipStrArray.push(["买卖方向", orderTypeInfo[_orderType].name]);
		tipStrArray.push(["合约代码", stock_info.optionCode]);
		tipStrArray.push(["合约名称", "<em style='white-space:nowrap;zoom:"+$.getTransformScale(stock_info.optionName, 16, $(window).width() * 0.3)+"'>" + stock_info.optionName +  "</em>"]);
		if(stock_info.market_price){
			stock_price = "0.01";
			tipStrArray.push(["委托价格", "市价委托"]);
		}else{
			tipStrArray.push(["委托价格", stockPrice]);
		}
		if(+setDate.split_order && (stockNum - setDate.split_order > 0)){
			//启动自动拆单
			tipStrArray.push(["委托数量", stockNum + "(自动拆单)"]);
		}else {
			tipStrArray.push(["委托数量", stockNum]);
		}
		tipStr += common.generatePrompt(tipStrArray);
		if(ts){
			tipStr += "<div class='_reminder'><span class='b'>温馨提示：</span><span class='w'>"+ts+"</span></div>";
		}
		tipStr+="</div>";
		//埋点数据
		var comStatParam={
			"i_entrust_bs":entrust_prop_opt, // 交易方向( 1,买入 2,卖出)
			"i_stock_code":stock_code, // 股票代码
			"i_stock_name":stock_info.optionName, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":stock_info.exchange_type, // 交易市场
			"i_entrust_price":entrust_price, // 选择后的价格
			"i_entrust_amount":entrust_amount, // 委托数量
		}
        queryMaxAmount(stock_info.optionCode,true,undefined,undefined,function(){
            // 如果有提示信息，先提示用户，点击确定后在继续下单操作。
            if(notice_info){
                common.iConfirm("温馨提示",notice_info,function(){
                    common.iConfirm("下单确认",tipStr,function(){
                        tradeOption(param);
                        comStatParam.i_oper = "1"; // 动作（1确定 2取消）
                        common.comStat(107042,2,3,false,comStatParam);
                    },function fail(){
                        comStatParam.i_oper = "2"; // 动作（1确定 2取消）
                        common.comStat(107042,2,3,false,comStatParam);
                    });
                },function fail(){
                });
                return;
            }
            common.iConfirm("下单确认",tipStr,function(){
                tradeOption(param);
                comStatParam.i_oper = "1"; // 动作（1确定 2取消）
                common.comStat(107042,2,3,false,comStatParam);
            },function fail(){
                comStatParam.i_oper = "2"; // 动作（1确定 2取消）
                common.comStat(107042,2,3,false,comStatParam);
            });
        });
		
//		common.iConfirm("下单确认",tipStr,function success(){
//			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
//			var branch_no  = userInfo.branch_no;	//分支机构
//			var fund_account = userInfo.fund_account;	//资产账户
//			var cust_code = userInfo.cust_code;	//客户代码
//			var session_id = userInfo.session_id;
//			var stock_code = $(_pageId + ' #stockCode').val();
//			var entrust_prop_opt = stock_html.market_div.attr("type");
//			var entrust_price = stockPrice;
//			if(entrust_prop_opt == "1"){
//				if($(_pageId + ".change_value_box .fok_btn").hasClass("active")){
//					entrust_prop_opt = "84";
//				}
//				else{
//					entrust_prop_opt = "82";
//				}
//			}
//			if(entrust_bs == "1"){
//				entrust_prop_opt = Number(entrust_prop_opt) + 1 + "";
//			}
//			var option_code = stock_info.optionCode;
//			var entrust_oc = orderTypeInfo[_orderType].entrust_oc;//0：开仓  1：平仓  2：行权）
//			var covered_flag = orderTypeInfo[_orderType].covered_flag;//备兑标志（见数据字典）
//			var exchange_type = stock_info.exchange_type;
//			var stock_account = stock_info.stock_account;
//			var entrust_amount = stockNum;
//			var param = {
//					 "entrust_way": entrust_way,
//					 "branch_no": branch_no,
//					 "fund_account": fund_account,
//					 "cust_code": cust_code,
//					 "session_id": session_id,
//					 "exchange_type": exchange_type,
//					 "stock_account": stock_account,
//					 "option_code": option_code,
//					 "entrust_amount": entrust_amount,
//					 "entrust_price": entrust_price,
//					 "entrust_bs": entrust_prop_opt,
//					 "entrust_oc": entrust_oc,
//					 "entrust_prop_opt": entrust_prop_opt,
//					 "covered_flag": covered_flag
//				};
//			service_option.placeAnOrder(param,getStockBuyCallBack,{"isShowOverLay":false,"isShowWait":false,
//					"timeOutFunc":function(){
//						$.hidePreloader();
//					},"errorFunc":function(){
//						$.hidePreloader();
//					}});
//				$.showPreloaders("请等待...");
//			},function fail(){});

	}
	
	//购买入口
	function tradeOption(param) {
		var max_amount = Number(setDate.split_order);
		var entrust_amount = Number(param.entrust_amount);
		
		var orderOne = function (orderParam){
			service_option.placeAnOrder(orderParam,function(data){
				getStockBuyCallBack(data);
			},{"isShowOverLay":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
			}});
		}
		
		var batchOrder =  function(orderParam){
			var count = Math.ceil(entrust_amount.div(max_amount));
			var amount = "";
			for (var i = 0; i < count-1; i++) {
				amount = amount + max_amount + ",";
			}
			amount = amount + (entrust_amount - max_amount * i);
			orderParam.entrust_amount = amount;
			orderOne(param);
		}
		
		if(max_amount && max_amount > 0 && (entrust_amount - max_amount > 0)){
			//启动自动拆单
			param.separate_flag = "1";
			batchOrder(param);
		}else{
			orderOne(param);
		}
		$.showPreloaders("请等待");
	}
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		_PageParam = {};
		$.hidePreloader();
		if(data.error_no == 0){
			$.alert(data.error_info,function(){
                setStockInfo("stockNum","",true); // 证券数量
                stock_html.total.text("");
                queryDayOrder();
                queryPosition();
            });
		}else{
			$.alert(data.error_info);
		}
	}
	
	
	/**
	 * 查询持仓数据
	 */
	function queryHolding(isShowWait){
		var i = $(_pageId + " .option_tab li.active").index();
		if(i == 1){
			queryDayOrder(isShowWait);
		}
		if(i == 2){
//			hqwnChoice();
		}
		else{
			queryPosition(isShowWait);
		}
	}
	
	function hqwnChoice(){
		$(_pageId+" #ownChoice table tr:not(.trTop)").remove();
		common.setNoData(true,"暂无自选记录",$(_pageId+ " #ownChoice .no_data"),"<p>暂无自选记录</p>");
	}
	
	function queryPosition(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.queryPosition(param,queryPositionCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无持仓记录",$(_pageId+ " #position .no_data"),"<p>暂无持仓记录</p>");
			}
		});
	}
	function queryPositionCallback(data){
		$(_pageId+" #position table tr:not(.trTop)").remove();
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var htmlTop = '';
					for (var i=0;i<results.length;i++){ 
						htmlTop += queryPositionHTML_stock(results[i]);
					}
					$(_pageId+" #position table").append(htmlTop);
					common.setNoData(false,"暂无持仓记录",$(_pageId+ " #position .no_data"));
					//卖出事件
					$.bindEvent($(_pageId+" #position table tr.cc"), function(e){
						clearBuyMsg();// 清楚数据
						_PageParam = {};
						var optionCode = $(this).attr("id");
						var exchange_type = $(this).attr("exchange_type");
						var stock_account = $(this).attr("stock_account");
						var n = $(this).find("td").eq(2).find("p").eq(1).text();
						_PageParam = {
							"stock_account":stock_account,
							"entrust_amount":Number(n),
							};
						queryData(optionCode,exchange_type);
						common.comStat(107043,2,104,true,{"i_change_name":"持仓列表","i_change_to":$(this).attr("option_name")});//埋点
						e.stopPropagation();
					}, downslide.clickType());
				}
				else{
					common.setNoData(true,"暂无持仓记录",$(_pageId+ " #position .no_data"),"<p>暂无持仓记录</p>");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		downslide.rollRefresh();
	}
	
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element){
		var price_digit = 4;
		var eleHtml = "";
		var css = "";
		var float_yk = Number(element.income_balance);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		float_yk = float_yk.toFixed(2);
		eleHtml+='<tr class="cc" id="'+element.option_code+'" opthold_type="'+element.opthold_type+'" option_name="'+element.option_name+'">';
		eleHtml+='<td>';
		if(element.opthold_type == 0){
			eleHtml+='<em class="label label_01">权利</em>';
		}
		else if(element.opthold_type == 1){
			eleHtml+='<em class="label label_02">义务</em>';
		}
		else if(element.opthold_type == 2){
			eleHtml+='<em class="label label_03">备兑</em>';
		}
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.option_name+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.hold_amount+'</p>';
		eleHtml+='<p>'+element.enable_amount+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p style="transform-origin: left;transform:scale('+$.getTransformScale(element.cost_price, 16, $(window).width() * 0.2)+')">'+element.cost_price+'</p>';
		eleHtml+='<p>'+element.last_price+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p class="'+css+'" style="transform-origin: left;transform:scale('+$.getTransformScale(float_yk, 16, $(window).width() * 0.2)+')">'+float_yk+'</p>';
		eleHtml+='</td>';
		eleHtml+='</tr>';
		eleHtml+='<tr class="date_td">';
		eleHtml+='<td colspan="5"><em class="tag tag_01">期</em>'+element.exercise_date+' (剩余'+element.apart_days+'天)';
		if(element.opthold_type == 1){
			eleHtml+='<em class="tag tag_02">保</em>'+element.duty_used_bail;
		}
		eleHtml+='</td></tr>';
		return eleHtml;
	}
	
	function queryDayOrder(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.queryDayOrder(param,queryDayOrderCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无当日委托记录",$(_pageId+ " #query .no_data"),"<p>暂无当日委托记录</p>");
			}
		});
	}
	function queryDayOrderCallback(data){
		$(_pageId+" #query table tr:not(.trTop)").remove();
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var htmlTop = '';
					for (var i=0;i<results.length;i++){ 
						htmlTop += queryEntrustHTML(results[i]);
					}
					$(_pageId+" #query table").append(htmlTop);
					common.setNoData(false,"暂无当日委托记录",$(_pageId+ " #query .no_data"));
					
					//卖出事件
//					$.bindEvent($(_pageId+' #query table tr.nr'), function(e){
//						cancellation($(this));
//						e.stopPropagation();
//					}, downslide.clickType());
					
				}
				else{
					common.setNoData(true,"暂无当日委托记录",$(_pageId+ " #query .no_data"),"<p>暂无当日委托记录</p>");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		downslide.rollRefresh();
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element,i){
		var price_digit = 3;
		var eleHtml = "";
        eleHtml+='<tr class="nr" data-id="'+element.entrust_no+'" data-type="'+element.exchange_type+'">';
		eleHtml+='<td>';
		if(element.entrust_bs == "0" && element.entrust_oc == "0" && element.covered_flag != "1"){
			eleHtml+='<em class="label label_04">买开</em>';
		}
		else if(element.entrust_bs == "1" && element.entrust_oc == "0" && element.covered_flag != "1"){
			eleHtml+='<em class="label label_05">卖开</em>';
		}
		else if(element.entrust_bs == "0" && element.entrust_oc == "1" && element.covered_flag != "1"){
			eleHtml+='<em class="label label_06">买平</em>';
		}
		else if(element.entrust_bs == "1" && element.entrust_oc == "1" && element.covered_flag != "1"){
			eleHtml+='<em class="label label_07">卖平</em>';
		}
		else if(element.entrust_bs == "1" && element.entrust_oc == "0" && element.covered_flag == "1"){
			eleHtml+='<em class="label label_08">备开</em>';
		}
		else if(element.entrust_bs == "0" && element.entrust_oc == "1" && element.covered_flag == "1"){
			eleHtml+='<em class="label label_09">备平</em>';
		}
		else if(element.entrust_oc == "2"){
			eleHtml+='<em class="label label_10">行权</em>';
		}
		else if((element.entrust_prop == "OTU" || element.entrust_prop == "100") && element.entrust_bs == "0"){
			eleHtml+='<em class="label label_11">锁定</em>';
		}
		else if((element.entrust_prop == "OTU" || element.entrust_prop == "100") && element.entrust_bs == "1"){
			eleHtml+='<em class="label label_12">解锁</em>';
		}
		eleHtml+='</td>';
		eleHtml+='<td>';
		if(element.entrust_prop == "OTU" || element.entrust_prop == "100"){
			eleHtml+='<p>'+element.stock_name+'</p>';
			eleHtml+='<p>'+element.stock_code+'</p>';
		}
		else{
			eleHtml+='<p>'+element.option_name+'</p>';
			eleHtml+='<p style="display: none;">'+element.option_code+'</p>';
		}
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.entrust_amount+'</p>';
		eleHtml+='<p>'+element.business_amount+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.opt_entrust_price+'</p>';
		eleHtml+='<p>'+element.opt_business_price+'</p>';
		eleHtml+='</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.entrust_status_name+'</p>';
		eleHtml+='</td>';
		eleHtml+='</tr>';
		eleHtml+='<tr class="date_td">';
		eleHtml+='<td colspan="5" class="com_time">委托时间 '+element.entrust_time+'</td>';
		eleHtml+='</tr>';
		return eleHtml;
	}
	
//	function cancellation($this){
//		var tipStrArray = [];
//		tipStrArray.push(["合约代码", $this.find("td").eq(1).find("p").eq(1).text()]);
//		tipStrArray.push(["合约名称", $this.find("td").eq(1).find("p").eq(0).text()]);
//		tipStrArray.push(["委托编号 ", $this.attr("data-id")]);
//		tipStrArray.push(["委托价格 ", $this.find("td").eq(3).find("p").eq(0).text()]);
//		tipStrArray.push(["委托数量 ", $this.find("td").eq(2).find("p").eq(0).text()]);
//		var tipStr = "<div >";
//		tipStr += common.generatePrompt(tipStrArray);
//		tipStr += "</div>";
//		//埋点数据
//		var comStatParam={
//			"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
//			"i_stock_code":$this.find("td").eq(1).find("p").eq(1).text(), // 股票代码
//			"i_stock_name":$this.find("td").eq(1).find("p").eq(0).text(), // 股票名称
//			"i_entrust_prop":"", // 委托属性
//			"i_exchange_type":$this.attr("data-type"), // 交易市场
//			"i_entrust_price":$this.find("td").eq(3).find("p").eq(0).text(), // 选择后的价格
//			"i_entrust_amount":$this.find("td").eq(2).find("p").eq(0).text(), // 委托数量
//		}
//		common.iConfirm("确认撤单",tipStr,function(){
//			var entrust_no = $this.attr("data-id");
//			var exchange_type = $this.attr("data-type");
//			postCancelOrder(entrust_no,exchange_type); 
//			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
//			common.comStat(107046,2,3,false,comStatParam);
//		},function(){
//			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
//			common.comStat(107046,2,3,false,comStatParam);
//		}});
//	}
	
	/**
	 * 委托撤单
	 * @param $currItem 当前条目
	 */
	function postCancelOrder(entrust_no,exchange_type){
		var batch_flag="0";
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//货币 ""所有货币，0 人民币，1 港币，2 美元
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";////货币 ""所有货币，0 人民币，1 港币，2 美元
		var session_id=userInfo.session_id;
		var password= userInfo.password;
		var param={				
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
				"entrust_no":entrust_no,
				"batch_flag":batch_flag,
				"exchange_type":exchange_type
		};
		service_option.cancellation(param,postCancelOrderCallback);
	}
	/**
	 * 委托撤单回调方法
	 * @param {Object} data 返回数据
	 */
	function postCancelOrderCallback(data){
    	if(data.error_no == "0"){
    		var t = data.results[0] ? "<br/>委托编号："+data.results[0].entrust_no : "";
    		$.alert("撤单委托已提交！"+t,function(){
				queryDayOrder();
			});
    	}else{
    		$.alert(data.error_info);
    	}
	}
	
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		$.bindEvent($(_pageId + " .header .top_title .h_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(107026,2,103,true,{"i_group_name":"返回"});//埋点
			if(global.callNative){
				if($.getPageParam("isFromApp")){
					//ios切换行情
					$.callMessage({
						"funcNo": "50500",
						"msgNo": "205",
						"sourceModule":"trade",
						"targetModule":"app",
						"action":"4",
						"param":{}
					});
				}
				$.pageBack("account/index","left");
			}
			else{
				$.pageBack("account/index","left");
			}
			e.stopPropagation();
		},"click");
		
		//查询跳转
		$.bindEvent($(_pageId+" .header .top_title .icon_set"), function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(107025,2,103,true,{"i_group_name":"交易设置"});//埋点
			$.pageInit("option/order/homePage","option/set/homepage",{});
			e.stopPropagation();
		});
		
		//持仓查询切换
		$.bindEvent($(_pageId + " .main .option_tab li"), function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			var i = $(this).index();
			$(_pageId+" .option_pos_table").hide();
			if(i == 1){
				$(_pageId+" #query").show();
				common.comStat(107045,2,103,true,{"i_group_name":"当日委托"});//埋点
			}
			else if(i == 2){
				$(_pageId+" #ownChoice").show();
			}
			else{
				$(_pageId+" #position").show();
				common.comStat(107044,2,103,true,{"i_group_name":"持仓"});//埋点
			}
			$(this).addClass("active").siblings().removeClass("active");
			
			downslide.rollRefresh();
			e.stopPropagation();
		})
		
		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");
		
		// 证券代码输入框监听
		$.bindEvent($(_pageId + " #optionCode"), function(e){ // 该监听方法是为了适配浏览器
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			common.comStat(107027,2,103,true,{"i_group_name":"期权合约选择"});//埋点
			$(_pageId + " .chooserOption").showLeft(undefined,undefined,function(){
				var height = $(_pageId + " .chooserOption").getHeight() - $(_pageId + " .chooserOption .header").getMHeight() - $(_pageId + " .chooserOption .option_tab").getMHeight() - $(_pageId + " .chooserOption .select_option").getMHeight();
				downslide1.rollInit(height,_pageId + " .chooserOption");
				common.pageBuryingPoint();
				if($(_pageId+" .chooserOption .toggle_nav li:eq(0)").hasClass("active")){
					common.pageBuryingPoint("107065");
				}else{
					common.pageBuryingPoint("107076");
				}
			});
			e.stopPropagation();
		});
		
		//备兑
		$.bindEvent($(_pageId+" .ch_switch_box .swith_det .switch"), function(e){
			$(_pageId + ".keyboard1").hide();
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(!$(this).hasClass("active")){
				$(this).addClass("active")
				$(_pageId + " .trading_list .row-1").eq(0).removeClass("red_bg");
				$(_pageId + " .trading_list .row-1").eq(1).removeClass("green_bg");
			}
			else{
				$(_pageId + " .trading_list .row-1").eq(0).addClass("red_bg");
				$(_pageId + " .trading_list .row-1").eq(1).addClass("green_bg");
				$(this).removeClass("active");
			}
			e.stopPropagation();
		});
		
		//查询跳转
		$.bindEvent($(_pageId+" .chooserOption .top_title .search_back"), function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			$(_pageId + " .chooserOption").hideLeft();
			if($(_pageId+" .chooserOption .toggle_nav li.active").index()==0){
				common.comStat(107066,2,103,true,{"i_group_name":"返回"});//埋点
			}else{
				common.comStat(107077,2,103,true,{"i_group_name":"返回"});//埋点
			}
			e.stopPropagation();
		});
		
		//查询跳转
		$.bindEvent($(_pageId + " #stockNum"), function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.clickOpenKeyboard(this,_pageId)
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			e.stopPropagation();
		});
		
		
		//数量输入
		$.bindEvent($(_pageId + " #stockNum"),function(e){
			if(keyboard){
				var key = "";
				if(!global.callNative){
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d3" || key == "-12"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d2" || key == "-13"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d1" || key == "-14"){
					var num = stock_info.stockMaxAmount;
					setStockInfo("stockNum",num+"");
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
			e.stopPropagation();
		},"input");
		
		//数量输入埋点
		$.bindEvent($(_pageId + "#stockNum"),function(e){
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			if(stock_info && stock_info.optionCode && stockPrice && stockPrice != "0"){
				common.comStat(107037,2,2,false,{
					"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":"", // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.optionCode, // 股票代码
					"i_stock_name":stock_info.optionName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"blur");
		
		// 价格输入框
//		$.bindEvent($(_pageId + " #stockPrice"), function(e){
//			if(keyboard){
//				keyboard.popUpKeyboard($(this),e);
//			}
//			limitingDigit($(this));
//			e.stopPropagation();
//		},"input");
		
//		$.bindEvent($(_pageId + " #stockPrice"), function(e){
//			if(stock_info){
//				var stockNum = getStockInfo("stockNum");
//				var stockPrice = $(_pageId + " #stockPrice").val();
//				if(stockPrice != ""){
//					stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
//					setStockInfo("stockPrice",stockPrice);
//				}
//				else{
//					stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
//				}
//				totalValue(stockPrice,stockNum);
//				isQueryMax(stockPrice);
//			}
//			e.stopPropagation();
//		},"blur");
		// 增加价格
		$.bindEvent($(_pageId + " .trade_main .input_value #stockPrice").nextAll("em.add"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			common.comStat(107032,2,103,true,{"i_group_name":"增加价格"});//埋点
			if(stock_info && stock_info.optionCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice") || "0";
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice","");
					inputVal();
					return false;
				}
				stockPrice = Number(stockPrice);  
				if(stockPrice >= 0 && stockPrice < 999999999){
					stockPrice = (parseFloat(stockPrice)+parseFloat(stock_info.price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
					inputVal(stockPrice);
				}
			}else{
				$.alert("请先选择合约代码");
			}
			e.stopPropagation();
		});
		// 减少价格
		$.bindEvent($(_pageId + " .trade_main .input_value #stockPrice").nextAll("em.less"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			common.comStat(107033,2,103,true,{"i_group_name":"减少价格"});//埋点
			if(stock_info && stock_info.optionCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice") || "0";
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice","");
					return false;
				}
				var price_step = stock_info.price_step;
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0){
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
					inputVal(stockPrice);
				}
			}else{
				$.alert("请先选择合约代码");
			}
			e.stopPropagation();
		});
		
		// 增加价格
		$.bindEvent($(_pageId + " .trade_main .input_value #stockNum").nextAll("em.add"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			common.comStat(107035,2,103,true,{"i_group_name":"增加数量"});//埋点
			if(stock_info && stock_info.optionCode){
				var stockNum = getStockInfo("stockNum") || "0";
				var stockPrice = getStockInfo("stockPrice");
				if(!stockNum || !validatorUtil.isEnNumeric(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum);  
				if(stockNum >= 0 && stockNum < 999999999){
					stockNum = stockNum + stock_info.lot_size;
					setStockInfo("stockNum",stockNum);
					totalValue(stockPrice,stockNum);
				}
			}else{
				$.alert("请先选择合约代码");
			}
			e.stopPropagation();
		});
		// 减少价格
		$.bindEvent($(_pageId + " .trade_main .input_value #stockNum").nextAll("em.less"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			common.comStat(107036,2,103,true,{"i_group_name":"减少数量"});//埋点
			if(stock_info && stock_info.optionCode){
				var stockNum = getStockInfo("stockNum") || "0";
				var stockPrice = getStockInfo("stockPrice");
				if(!stockNum || !validatorUtil.isEnNumeric(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum);
				if(stockNum - stock_info.lot_size >= 0){
					stockNum = stockNum - stock_info.lot_size;
					setStockInfo("stockNum",stockNum);
					totalValue(stockPrice,stockNum);
				}
			}else{
				$.alert("请先选择合约代码");
			}
			e.stopPropagation();
		});
		
		// 五档买卖盘联动
		$.bindEvent($(_pageId + " .five_box tr"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			var curPrice = $(this).find("td").eq(0).text();
			if(curPrice && curPrice != "--"){
//				$(this).siblings().removeClass("active");
//				$(this).parent().siblings().find("li").removeClass("active");
//				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",curPrice);		
				inputVal(curPrice);	
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice,stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
		// 下单
		$.bindEvent($(_pageId + " .trading_list .row-1"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " #stockPrice").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if($(_pageId + " .place_order_main").hasClass("current") && ($(this).hasClass("red_bg") || $(this).hasClass("green_bg"))){
				_orderType = $(this).attr("type");
				if($(_pageId+" .ch_switch_box .swith_det .switch").hasClass("active")){
					if(_orderType == "2"){
						_orderType = "5";
					}
					else if(_orderType == "3"){
						_orderType = "6";
					}
				}
				vailSubmitOrder();
			}
			//埋点
			var _type = $(this).attr("type");
			if(_type=="2"){//卖开
				common.comStat(107038,2,103,true,{"i_group_name":"卖开提交"});
			}else if(_type=="3"){//买平
				common.comStat(107039,2,103,true,{"i_group_name":"买平提交"});
			}else if(_type=="1"){//买开
				common.comStat(107040,2,103,true,{"i_group_name":"买开提交"});
			}else if(_type=="4"){//卖平
				common.comStat(107041,2,103,true,{"i_group_name":"卖平提交"});
			}
		});
		
		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId + ".main").add($(_pageId + ".header")),function(e){
			$(_pageId + ".keyboard1").hide();
			$(_pageId + " #stockPrice").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + " .five_box ul li").removeClass("active");
			if(stock_html){
				stock_html.stockList.hide();
			}
			e.stopPropagation();
		});
		
		
		$.bindEvent($(_pageId + " #market"),function(e){
			$(_pageId + ".keyboard1").hide();
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			e.stopPropagation();
		});
		
		optionKeyboard();
	}
	
	function optionKeyboard(){
		
		  	$.bindEvent($(_pageId + " #stockPrice"), function(e){
				if(keyboard){
					keyboard.closeKeyPanel();
				}
				$.closeModal(".picker-modal.modal-in");
				if($(_pageId + ".change_value_box .fok_btn").hasClass("active")){
					$(_pageId + ".keyboard1 .dialog_tit .fok_btn").addClass("active");
				}
				else{
					$(_pageId + ".keyboard1 .dialog_tit .fok_btn").removeClass("active");
				}
		  		$(_pageId + ".keyboard1").show();
				$(this).addClass("active");
		  		e.stopPropagation();
		  	});
		  	
		  	$.bindEvent($(_pageId + ".keyboard1 .dialog_tit .fok_btn"),function(e){
		  		if($(this).hasClass("active")){
		  			$(this).removeClass("active");
		  			$(_pageId + ".change_value_box .fok_btn").removeClass("active");
				}
				else{
					$(this).addClass("active");
					$(_pageId + ".change_value_box .fok_btn").addClass("active");
				}
		  		e.stopPropagation();
		  	});
		  	
		  	$.bindEvent($(_pageId + ".keyboard1 .dialog_tit .dia_confirm_btn"),function(e){
		  		$(_pageId + ".keyboard1").hide();
				$(_pageId + " #stockPrice").removeClass("active");
				maidian();
		  		e.stopPropagation();
		  	});
		  	
		  	
		  	var $input = $(_pageId + " #stockPrice");
		  	$(_pageId + ".keyboard1 .keyboard_pop li.num_btn").unbind("touchstart");
		  	$.bindEvent($(_pageId + ".keyboard1 .keyboard_pop li.num_btn"), function(e){
		  		$input.find(" .key_place").hide();
		  		var v = $input.find("em").text();
		  		var value = $(this).find("a").text();
		  		if(value == "." && v.indexOf(".") != -1){
		  			$input.find("em").text(v);
	  				$input.find(".key_text").text(v);
	  				inputVal(v);
		  		}
		  		else{
		  			if(value){
		  				if(!(v && v.length > 8)){
		  					$input.find("em").text(v+value);
		  					$input.find(".key_text").text(v+value);
		  					inputVal(v+value);
		  				}
		  			}
		  			else{
		  				if(v){
		  					v = v.substring(0,v.length-1);
		  					if(!v){
		  						$input.find(".key_text").text("");
		  						$input.find(" .key_place").show();
		  						$input.find("em").text("");
		  						inputVal();
		  					}
		  					$input.find("em").text(v);
		  					$input.find(".key_text").text(v);
		  					inputVal(v);
		  				}
		  			}
		  		}
		  		e.stopPropagation();
		  	},"touchstart");
		
	}
	
	/*
	 * 更改按钮价格
	 */
	function inputVal(val){
  		if(val){
  			butPriceList=[val,val,val,val];
			$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text(val);
			$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text(val);
			$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text(val);
			$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text(val);
  		}else{
  			butPriceList=[];
			$(_pageId + " .trading_list .row-1").eq(0).find("p").eq(0).text("--");
			$(_pageId + " .trading_list .row-1").eq(2).find("p").eq(0).text("--");
			$(_pageId + " .trading_list .row-1").eq(1).find("p").eq(0).text("--");
			$(_pageId + " .trading_list .row-1").eq(3).find("p").eq(0).text("--");
  		}
	}
	
	/*
	 * 价格输入埋点
	 */
	function maidian(){
		var stockNum = getStockInfo("stockNum");
		var stockPrice = $(_pageId + " #stockPrice .key_text").quzhi();
		if(stock_info && stock_info.optionCode && stockPrice && stockPrice != "0"){
			common.comStat(107034,2,1,false,{
				"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
				"i_entrust_prop":"", // 委托属性
				"i_exchange_type":stock_info.exchange_type, // 交易市场
				"i_stock_code":stock_info.optionCode, // 股票代码
				"i_stock_name":stock_info.optionName, // 股票名称
				"i_price":stockPrice, // 选择后的价格
				"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
			});
		}
	}
	
	
	/**
	 * 
	 */
	function clearBuyMsg(){
		butPriceList=[];
		$(_pageId + " .value_btn div").attr("id","");
		$(_pageId + " .value_btn div p").text("--");
		$(_pageId + " .trading_list .row-1>p:first-child").text("--");
		$(_pageId + " #stockPrice").removeClass("active");
		$.closeModal(".picker-modal.modal-in");
        $.closeModal(".modal.modal-in");
		$(_pageId + " .place_order_main").removeClass("current");
		$.clearRequest();
		stock_info = ioitStock();
		if(stock_html){
	    	stock_html.optionName.val(""); // 证券名称
	    	stock_html.market_p.hide();
	    	setStockInfo("stockPrice","");// 证券价格
	    	setStockInfo("stockNum",""); // 证券数量
	    	stock_html.stockMaxAmount.text("--");//证券最大数
		   	stock_html.total.text("");
		   	stock_html.buyGear.find("td").removeClass("agreen").removeClass("ared").text("--");
//			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("td").removeClass("agreen").removeClass("ared").text("--");
//			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
			stock_html.market_div.find("input").val("限价委托");
			stock_html.market_div.attr("type","1");
			stock_html.stockPrice.parents(".change_value_box").show();
			
			var liHtml = [{"id":"1","name":"限价委托"}];
			common.selectList($(_pageId + " #market"),"",liHtml,function(obj){
				if(obj.id == "1")
				{
					stock_html.market_div.find("input").val("限价委托");
					stock_html.market_div.attr("type",obj.id);
					stock_html.market_p.hide();
					stock_html.stockPrice.parents(".change_value_box").show();
					stock_info.market_price = false;
					var stockPrice = getStockInfo("stockPrice");
					isQueryMax(stockPrice);
				
				}
			});
			
		}
	   	if (fifthOrder_timer != null ) {
	        window.clearInterval(fifthOrder_timer);
	    }
	   	_fifthCallback = true;
		$(_pageId + " .five_box ul li").removeClass("active");
		$(_pageId + " .chooserOption .check_option_list ul li").removeClass("active");
		
	}
	
	
	/**
	 * 数据重置
	 */
	function destroy(){
        commonHq.clearCheckTradeTimer();
		common.pageBuryingPoint();
		_stockCode = null;
		$(_pageId + ".change_value_box .fok_btn").removeClass("active");
		$(_pageId+" .option_pos_table table tr:not(.trTop)").remove();
		clearBuyMsg();
		_PageParam = {};
		if (position_timer != null ) {
	        window.clearInterval(position_timer);
	    }
		position_timer = null;
		stock_info = null;
		stock_html = null;
		if(keyboard){
			keyboard.keyDestroy();
		}
		$(_pageId + " .main .option_tab li").removeClass("active");
		$(_pageId + " .main .option_tab li:eq(0)").addClass("active");
		$(_pageId+" #position").show();
		$(_pageId+" #query").hide();
		$(_pageId+" #ownChoice").hide();
        notice_info = null;


        
        $(_pageId + " .value_btn .fl_value p").eq(0).css({"fontSize": "0.13rem",});
        $(_pageId + " .value_btn .fr_value p").eq(0).css({"fontSize": "0.13rem",});
        $(_pageId + " #optionCode").css({"fontSize": "0.16rem"});
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
