/**
 * 股票期权--下单--证券解锁
 */
define('trade/scripts/option/order/securitiesUnlock.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var service_option = require("service_option");
	var _pageId = "#option_order_securitiesUnlock ";
	var common = require("common");
	var userInfo = null;
	var listData = {};
	var fundInfo = {};
	var _stock_account = null;
	var _exchange_type = null;
	
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.pageBack("option/order/homePage","left");
			e.stopPropagation();
		});
		queryHoldingsQuery();
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
	}
	
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
		};
		service_option.queryCommonPosition(param,queryFundDataCallback);
	}

	//持仓查询回调方法
	function queryFundDataCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for (var i=0;i<results.length;i++){
						listData[results[i].stock_code+""] = results[i];
						listDiv += "<li id='"+results[i].stock_code+"'><a href=\"javascript:void(0);\">"+results[i].stock_name+" <small>"+results[i].stock_code+"</small></a></li>";
					}
					listDiv += "</ul></div>";
					common.addChoiceList($(_pageId+" .input_select .select_box p"), "选择证券代码",listDiv,function(data, div){
						div.html(data.find("a").text());
						var id = data.attr("id");
						fundInfo = listData[id];
						getStockList(id);
					});
				}
				else{
					$(_pageId+" .select_box p").text("暂无解锁证券代码");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 查询合约代码
	 * */
	function getStockList(stockCode)
	{
		$(_pageId+" #most").val("");
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id= userInfo.session_id;
		var stock_code = stockCode;
		var fund_account_opt = userInfo.fund_account;//衍生品资金账户
		var option_account = "";//衍生品合约账户
		var stock_account = "";
		var seat_no = "";
		var exchange_type = "";
		var lock_direction = "2";
		var param = {
				"entrust_way": entrust_way,
				 "branch_no": branch_no,
				 "fund_account": fund_account,
				 "cust_code": cust_code,
				 "session_id": session_id,
				 "fund_account_opt": fund_account_opt,
				 "option_account": option_account,
				 "stock_account": stock_account,
				 "seat_no": seat_no,
				 "exchange_type": exchange_type,
				 "stock_code": stock_code,
				 "lock_direction": lock_direction
			};
		service_option.querySecuritiesTransferred(param,queryMaxAmountCallBack);
	}
	
	function queryMaxAmountCallBack(data)
	{
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0)
			{
				_exchange_type = results[0].exchange_type;
				_stock_account = results[0].stock_account
//				$(_pageId+" #stockName").attr("value",results[0].stock_name);
				$(_pageId+" #most").val(Number(results[0].enable_amount));
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder()
	{	
		if($.size(listData) == 0){
			$.alert("没有可解锁的代码");
			return false;
		}
		if(!$.isValue(fundInfo)){
			$.alert("请选可解锁的代码");
			return false;
		}
		//验证最大可买
		var mostBuy = $(_pageId+" #most").val();
//		if (mostBuy.length == 0) {
//			$.alert("该只股票没有可解锁数量");
//			return false;
//		} else if (mostBuy <= 0) {
//			$.alert("最大可解锁为0");
//			return false;
//		} 
		//验证买入数量
		var mounttake = $(_pageId + " #num").val();
		if (mounttake.length == 0) {
			$.alert("请输入解锁数量");
			return false;
		} else if (mounttake <= 0) {
			$.alert("输入的解锁数量无效");
			return false;
		} 
		
		var exchange_type = "";
		var secu_acc = "";
		var tipStrArray = [];
		var tipStr = "<div >";
		tipStrArray.push(["操作类型", '证券解锁']);
		tipStrArray.push(["证券代码", fundInfo.stock_code]);
		tipStrArray.push(["证券名称", fundInfo.stock_name]);
		tipStrArray.push(["解锁数量", mounttake]);
		tipStr += common.generatePrompt(tipStrArray);
		tipStr+="</div>";
		common.iConfirm("下单确认",tipStr,function success(){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代码
			var session_id= userInfo.session_id;
			var stock_account = _stock_account;
			var stock_code = fundInfo.stock_code;
			var entrust_amount = mounttake;
			var fund_account_opt = userInfo.fund_account;//衍生品资金账户
			var option_account = "";//衍生品合约账户
			var seat_no = "";
			var exchange_type = _exchange_type;
			var lock_direction = "2";
			var param = {
					"entrust_way": entrust_way,
					 "branch_no": branch_no,
					 "fund_account": fund_account,
					 "cust_code": cust_code,
					 "session_id": session_id,
					 "fund_account_opt": fund_account_opt,
					 "option_account": option_account,
					 "stock_account": stock_account,
					 "seat_no": seat_no,
					 "exchange_type": exchange_type,
					 "stock_code": stock_code,
					 "lock_direction": lock_direction,
					 "entrust_amount": entrust_amount
				};
			service_option.AgainstSecuritiesTransfer(param,getStocktakeCallBack);
		}, null);
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStocktakeCallBack(data)
	{
		$(_pageId + " input").val("");
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				$.alert(tipStr);
				getStockList(fundInfo.stock_code);
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//查询跳转
		$.bindEvent($(_pageId+" .ce_btn a"), function(e){
			vailSubmitOrder();
			e.stopPropagation();
		});
		
		//查询跳转
		$.bindEvent($(_pageId+".input_form a.btn"), function(e){
			$(_pageId + " #num").val($(_pageId + " #most").val());
			e.stopPropagation();
		});
		
		
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		$(_pageId + " input").val("");
		$(_pageId + " #num").quzhi();
		$(_pageId + " .input_select .select_box p").text("请选择证券");
		listData = {};
		fundInfo = {};
		_stock_account = null;
		_exchange_type = null;
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});