/**
 * 股票期权--下单--证券锁定
 */
define('trade/scripts/option/order/securityLock.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var service_option = require("service_option");
	var _pageId = "#option_order_securityLock ";
	var common = require("common");
	var commonFunc = require("commonFunc");
	var downslide = new (require("downslide")).Downslide();
	var userInfo = null;
	var listData = {};
	var fundInfo = {};
	var keyboard = require("keyboard1");
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var _stock_account = null;
	var _exchange_type = null;
	
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("107279");
		downslide.addSlide();
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).unbind(e.type);
			this[e.type] = null;
			common.comStat(107280,2,103,true,{"i_group_name":"返回"});
          	var pageCode = $.getCurrentPageObj().pageCode || '';
          	var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
			$.pageInit(pageCode,prePageCode,{"_loginClass":"2"},"left",true);
			e.stopPropagation();
		});
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
		var slideHeight = mainHeight - $(_pageId + " .select_option").getMHeight() - $(_pageId + " .option_tab").getMHeight();
		downslide.slideInit(slideHeight,queryData);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryData();
//		if(global.serverConfig != 2){//T2柜台不支持，只能手动输入
			queryHoldingsQuery();
//			queryPosition();
//		}
	}
	function queryData(){
		// if(global.serverConfig == 2){
		// 	queryDayOrder();
		// }
		// else{
			if($(_pageId + " .option_tab li.active").index() == 1){
				queryDayOrder();
			}
			else{
				queryPosition();
			}
		// }
	}
	/**
	 * 持仓查询
	 * 调用两个接口 股份查询，资金查询
	 */
	function queryHoldingsQuery(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var sessionid="";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid,
		};
		service_option.queryLockableHolding(param,queryLockableHoldingCallback);
	}

	//持仓查询回调方法
	function queryLockableHoldingCallback(data){
		if (data) {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					listData = {};
					var listDiv = "<div class='bank_list center1'><ul>";
					for (var i=0;i<results.length;i++){
						listData[results[i].stock_code+""] = results[i];
						listDiv += "<li id='"+results[i].stock_code+"'><a href=\"javascript:void(0);\">"+results[i].stock_name+" <small>"+results[i].stock_code+"</small></a></li>";
					}
					listDiv += "</ul></div>";
					//埋点参数
					var buriedPointParam={
						"objectId":107281,
						"actionId":103,
						"paramMap":{
							"i_group_name":"背兑证券选择"
						  },
						"backObjectId":107297,
						"backActionId":103,
						"backParamMap":{
							"i_group_name":"返回",
						  },
						"clickObjectId":107298,
						"clickActionId":104,
						"clickParamMap":{
							"i_change_name":"选择背兑证券",
							"i_change_to":""
						  },
						 "pageObjectId2":107296,//页面埋点参数
						 "pageObjectId1":107279,
					}
					common.addChoiceList($(_pageId+" .input_select .select_box p"), "选择证券代码",listDiv,function(data, div){
						var id = data.attr("id");
						div.html(id);
						fundInfo = listData[id];
						getStockList(id);
						$(_pageId+" #stockName").val(fundInfo.stock_name);
					},null,null,null,buriedPointParam);
				}
				else{
					$(_pageId+" .select_box p").text("暂无锁定证券代码");
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/**
	 * 查询合约代码
	 * */
	function getStockList(stockCode)
	{
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id= userInfo.session_id;
		var stock_code = stockCode;
		var fund_account_opt = userInfo.fund_account;//衍生品资金账户
		var fund_account_comm = userInfo.cust_code;
		var option_account = "";//衍生品合约账户
		var stock_account = fundInfo.stock_account || "";
		var seat_no = "";
		var exchange_type = fundInfo.exchange_type || "";
		var lock_direction = "";
		var param = {
				"entrust_way": entrust_way,
				 "branch_no": branch_no,
				 "fund_account": fund_account,
				 "cust_code": cust_code,
				 "session_id": session_id,
				 "fund_account_opt": fund_account_opt,
				 "fund_account_comm": fund_account_comm,
				 "option_account": option_account,
				 "stock_account": stock_account,
				 "seat_no": seat_no,
				 "exchange_type": exchange_type,
				 "stock_code": stock_code,
				 "lock_direction": lock_direction
			};
		service_option.querySecuritiesTransferred(param,queryMaxAmountCallBack);
	}
	
	function queryMaxAmountCallBack(data)
	{
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0)
			{
				if(results[0] && results[0].exchange_type){
					var stock_name = fundInfo.stock_name;
					fundInfo = results[0];
					_exchange_type = results[0].exchange_type;
					_stock_account = results[0].stock_account;
					if(fundInfo.stock_name){
						$(_pageId+" #stockName").val(fundInfo.stock_name);
					}
					else{
						fundInfo.stock_name = stock_name;
					}
					$(_pageId+" #lock").val(Number(results[0].enable_amount));
					$(_pageId+" #solvable").val(Number(results[0].locked_amount));
				}
				else{
					$.alert("没有查询该标的的备兑信息",function(){
						$(_pageId + " input").val("");
						$(_pageId + " #num").quzhi("");
					});
				}
			}
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(lock_direction)
	{	
		var txt = "锁定";
		if(lock_direction == 2){
			txt = "解锁";
		}
		if(!$.isValue(fundInfo)){
			$.alert("请输入"+txt+"的代码");
			return false;
		}
		//验证最大可买
		var mostBuy = $(_pageId+" #most").val();
//		if (mostBuy.length == 0) {
//			$.alert("该只股票没有可解锁数量");
//			return false;
//		} else if (mostBuy <= 0) {
//			$.alert("最大可解锁为0");
//			return false;
//		} 
		//验证买入数量
		var mounttake = $(_pageId + " #num").val();
		if (mounttake.length == 0) {
			$.alert("请输入"+txt+"数量");
			return false;
		} else if (mounttake <= 0) {
			$.alert("输入的"+txt+"数量无效");
			return false;
		} 
		
		var exchange_type = "";
		var secu_acc = "";
		var tipStrArray = [];
		var tipStr = "<div >";
		tipStrArray.push(["操作类型", '证券'+txt]);
		tipStrArray.push(["证券代码", fundInfo.stock_code]);
		tipStrArray.push(["证券名称", fundInfo.stock_name]);
		tipStrArray.push([txt+"数量", mounttake]);
		tipStr += common.generatePrompt(tipStrArray);
		tipStr+="</div>";
		var lock_direction = lock_direction;
		
		//埋点数据
		var comStatParam={
			"i_entrust_bs":"", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":fundInfo.stock_code, // 股票代码
			"i_stock_name":fundInfo.stock_name, // 股票名称
			"i_entrust_prop":"", // 委托属性
			"i_exchange_type":_exchange_type, // 交易市场
			"i_entrust_price":"", // 选择后的价格
			"i_entrust_amount":mounttake, // 委托数量
		}
		var objectId=(lock_direction == 1 ? "107285" : "107286");
		common.iConfirm("下单确认",tipStr,function success(){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代码
			var session_id= userInfo.session_id;
			var fund_account_comm = userInfo.cust_code;
			var stock_account = _stock_account;
			var stock_code = fundInfo.stock_code;
			var entrust_amount = mounttake;
			var fund_account_opt = userInfo.fund_account;//衍生品资金账户
			var option_account = fundInfo.stock_account_opt;//衍生品合约账户
			var seat_no = "";
			var exchange_type = _exchange_type;
			var param = {
					"entrust_way": entrust_way,
					 "branch_no": branch_no,
					 "fund_account": fund_account,
					 "cust_code": cust_code,
					 "session_id": session_id,
					 "fund_account_comm": fund_account_comm,
					 "fund_account_opt": fund_account_opt,
					 "option_account": option_account,
					 "stock_account": stock_account,
					 "seat_no": seat_no,
					 "exchange_type": exchange_type,
					 "stock_code": stock_code,
					 "lock_direction": lock_direction,
					 "entrust_amount": entrust_amount
				};
			service_option.AgainstSecuritiesTransfer(param,getStocktakeCallBack);
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
			common.comStat(objectId,2,3,false,comStatParam);
		}, function(){
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
			common.comStat(objectId,2,3,false,comStatParam);
		});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStocktakeCallBack(data)
	{
		if(data.error_no == 0){
			var results = data.results;
			if(results){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				$.alert(tipStr,function(){
					getStockList(fundInfo.stock_code);
					$(_pageId + " #num").quzhi("");
					queryData();
				});
			}
		}else{
			$(_pageId + " #num").quzhi("");
			$.alert(data.error_info);
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//点击查询按钮
		$.bindEvent($(_pageId+" #stockCode"),function(e){
//			if(keyboard){
//				keyboard.closeKeyPanel();
//			}
//			var stockCode = $(_pageId+" #stockCode").val();
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var stockCode = $(this).val();
			var vai2=/^[0-9]{6}$/;
			if(vai2.test(stockCode)){
				getStockList(stockCode);
			}
			else{
//				$.alert("请输入有效的6位数标的代码");
			}
		}, "input");
		
		//持仓查询切换
		$.bindEvent($(_pageId + " .option_tab li"), function(e){
			if($(this).index() == 1){
				$(_pageId+" #position").hide();
				$(_pageId+" #query").show();
			}else{
				$(_pageId+" #query").hide();
				$(_pageId+" #position").show();
			}
			$(this).addClass("active").siblings().removeClass("active");
			queryData();
			downslide.slideRefresh();
			e.stopPropagation();
		})
		
		//锁定
		$.bindEvent($(_pageId+" .ce_btn #locking"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			vailSubmitOrder("1");
			e.stopPropagation();
		});
		
		//解锁
		$.bindEvent($(_pageId+" .ce_btn #unlock"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			vailSubmitOrder("2");
			e.stopPropagation();
		});
		
		// 增加数量
		$.bindEvent($(_pageId + " .back_form .tnb_input_form em.add"),function(e){
			common.comStat(107282,2,103,true,{"i_group_name":"增加数量"});
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(fundInfo){
				var stockNum = $(_pageId + " #num").val() || "0";
				if(!stockNum || !validatorUtil.isEnNumeric(stockNum)){
					$(_pageId + " #num").quzhi(0);
					return false;
				}
				stockNum = Number(stockNum);  
				if(stockNum >= 0 && stockNum < 999999999){
					stockNum = stockNum + 1;
					$(_pageId + " #num").quzhi(stockNum);
				}
			}else{
				$.alert("请先选择证券");
			}
			e.stopPropagation();
		},"touchstart");
		
		// 减少数量
		$.bindEvent($(_pageId + " .back_form .tnb_input_form em.less"),function(e){
			common.comStat(107283,2,103,true,{"i_group_name":"减少数量"});
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(fundInfo){
				var stockNum = $(_pageId + " #num").val() || "0";
				if(!stockNum || !validatorUtil.isEnNumeric(stockNum)){
					$(_pageId + " #num").quzhi(0);
					return false;
				}
				stockNum = Number(stockNum);
				if(stockNum - 1 >= 0){
					stockNum = stockNum - 1;
					$(_pageId + " #num").quzhi(stockNum);
				}
			}else{
				$.alert("请先选择证券");
			}
			e.stopPropagation();
		},"touchstart");
		
		//数量输入埋点
		$.bindEvent($(_pageId + "#num"),function(e){
			var num = $(_pageId + " #num").val();
			var stockCode=$(_pageId+" .select_box p").html();
			var stockName=$(_pageId+" #stockName").val();
			if(stockCode){
				var entrust_bs="";
				common.comStat(107284,2,2,false,{
					"i_entrust_bs":entrust_bs, // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":"", // 委托属性
					"i_exchange_type":_exchange_type, // 交易市场
					"i_stock_code":stockCode, // 股票代码
					"i_stock_name":stockName, // 股票名称
					"i_price":"", // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":"", // 最大数量
					"i_target_cnt":num, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"blur");
	}
	
	function queryPosition(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.queryCommonPosition(param,queryPositionCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无委托记录",$(_pageId+ " #position .no_data"));
				downslide.slideRefresh();
			}
		});
	}
	function queryPositionCallback(data){
		$(_pageId+" #position table tr:not(.trTop)").remove();
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length > 0){
					var htmlTop = '';
					for (var i=0;i<results.length;i++){
						htmlTop += queryPositionHTML(results[i]);
					}
					$(_pageId+" #position table").append(htmlTop);
					common.setNoData(false,"暂无委托记录",$(_pageId+ " #position .no_data"));
				}
				else{
					common.setNoData(true,"暂无委托记录",$(_pageId+ " #position .no_data"));
				}
			}else{
				$.alert(data.error_info);
			}
		}
		downslide.slideRefresh();
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryPositionHTML(element,i){
		var price_digit = 3;
		var eleHtml = "";
        eleHtml+='<tr>';
		eleHtml+='<td>&nbsp;</td>';
		eleHtml+='<td>'+element.stock_code+'</td>';
		eleHtml+='<td>'+element.stock_name+'</td>';
		eleHtml+='<td>'+element.enable_amount+'</td>';
		eleHtml+='<td>'+element.locked_amount+'</td>';
		eleHtml+='</tr>';
		return eleHtml;
	}
	
	function queryDayOrder(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_option.dayReleaseLockedUnlock(param,queryDayOrderCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ 
				_callback = true;
				//超时调用方法
				common.setNoData(true,"暂无委托记录",$(_pageId+ " #query .no_data"));
				downslide.slideRefresh();
			}
		});
	}
	function queryDayOrderCallback(data){
		$(_pageId+" #query table tr:not(.trTop)").remove();
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var htmlTop = '';
					for (var i=0;i<results.length;i++){ 
						htmlTop += queryEntrustHTML(results[i]);
					}
					$(_pageId+" #query table").append(htmlTop);
					common.setNoData(false,"暂无委托记录",$(_pageId+ " #query .no_data"));
				}
				else{
					common.setNoData(true,"暂无委托记录",$(_pageId+ " #query .no_data"));
				}
			}else{
				$.alert(data.error_info);
			}
		}
		downslide.slideRefresh();
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element,i){
		var price_digit = 3;
		var eleHtml = "";
		eleHtml+='<tr>';
		eleHtml+='<td>&nbsp;</td>';
		eleHtml+='<td>';
		eleHtml+='<p>'+element.stock_code+'</p>';
		eleHtml+='<p>'+element.stock_name+'</p>';
		eleHtml+='</td>';
		if(element.entrust_bs == '0'){
			eleHtml+='<td>锁定</td>';
		}
		else{
			eleHtml+='<td>解锁</td>';
		}
		eleHtml+='<td>'+element.entrust_amount+'</td>';
		eleHtml+='<td>'+element.entrust_status_name+'</td>';
		eleHtml+='<td>'+element.entrust_time+'</td>';
		eleHtml+='</tr>';
		return eleHtml;
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		$(_pageId + " input").val("");
		$(_pageId + " #num").quzhi("");
		$(_pageId+" .fund_table table tr:not(.trTop)").remove();
		$(_pageId + " .input_select .select_box p").text("请选择证券");
		listData = {};
		fundInfo = {};
		_stock_account = null;
		_exchange_type = null;
		common.pageBuryingPoint();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});