/**
 * 普通交易-持仓
 */
define('trade/scripts/option/position/holdingsQuery.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var commonHq = require("commonHq");
    var iscrollUtils = require("iscrollUtils");
    var service_option = require("service_option");
    var nativePluginService = require("nativePluginService");

    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#option_position_holdingsQuery ";

    var userInfo = null;
    var mainHeight = null;
    var position_Timer = null;
    var _callback = true;

    var myScroller = null; // 滑动组件对象

    /**
     * 初始化
     */
    function init() {
        if ($.device.android) { //安卓图标兼容性处理
            $(_pageId + ".j-tran-btn").addClass("android");
        }
        common.pageChangeHeight();
        common.pageBuryingPoint("107104");
        common.switchingCurUser("2");
        common.bindStockEvent($(_pageId + '.tab_nav ul li a'), true);
        userInfo = common.getCurUserInfo();
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }


    function load() {
        mainHeight = common.setMainHeight(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        queryCapital();
        queryPosition();
        clearPositionTimer();
        //查询资金账户
        _callback = false;
        if (position_Timer == null && global.positionRefreshTime) {
            commonHq.initCheckTradeTimer();
            position_Timer = window.setInterval(function () {
                if (commonHq.getTradingTime() && _callback && common.isAppFlag()) {
                    queryCapital(true);
                    queryPosition(true);
                    _callback = false;
                }
            }, global.positionRefreshTime);//定时刷新
        }

    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) { //返回按钮
            $(this).unbind(e.type);
            this[e.type] = null;
            common.comStat(107107, 2, 103, true, {"i_group_name": "返回"});
            var pageCode = $.getCurrentPageObj().pageCode || '';
            var prePageCode = $.getCurrentPageObj().prePageCode || 'account/index';
            commonFunc.appThirdBack('option_position_holdingsQuery', function () {
                $.pageInit(pageCode, prePageCode, {"_loginClass": "2"}, "left", true);
            });

            e.stopPropagation();
        }, "tap");

        $.bindEvent($(_pageId + "#transfer"), function (e) { //转账
            $(this).unbind(e.type);
            this[e.type] = null;
            common.comStat(107106, 2, 103, true, {"i_group_name": "银衍转账"});
            $.setSStorageInfo("return_page", "option/position/holdingsQuery");
            $.pageInit("option/position/holdingsQuery", "banking/transfer", {});
            e.preventDefault();
            e.stopPropagation();
        });

        $.bindEvent($(_pageId + "#zcqj"), function (e) {//全景
            $(this).unbind(e.type);
            this[e.type] = null;
            e.stopPropagation();
            if (global.callNative && global.isSso) {
                var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=qq";
                var param = {
                    "funcNo": "50500",
                    "msgNo": "123",
                    "sourceModule": "",
                    "targetModule": "tradeDispatcher",
                    "action": "1",
                    "param": {
                        "business_type": userInfo._loginClass,//普通0  两融1
                        "event": "15",//打开风险警示权限开通页面
                        "title": "",
                        "toPage": toPage,
                    }
                }
                $.callMessage(param);
            }
        });

        $.preBindEvent($(_pageId + ".cc-list-content"), ".td", function (e) { //卖出事件
            e.stopPropagation();
            var param = {
                "optionCode": $(this).attr("id"),
                "opthold_type": $(this).attr("opthold_type"),
                "exchange_type": $(this).attr("exchange_type"),
            }
            common.comStat(107105, 2, 103, true, {"i_group_name": "点击持仓合约"});
            $.pageInit("option/position/holdingsQuery", "option/order/homePage", param);
        });

        $.bindEvent($(_pageId + ".other-col"), function (e) { //持仓左滑右滑监听
            var _this = $(this);
            if (_this.width() * 0.5 - _this.scrollLeft() > 2) {
                $(_pageId + ".right-tip-arrow").show();
            } else {
                $(_pageId + ".right-tip-arrow").hide();
            }
        }, 'scroll');

        $.bindEvent($(_pageId + ".j-exp-icon"), function (e) { //今日参考盈亏说明
            var msg = '';
            msg += '<p>1. 交易日仅9:15-16:00期间显示,不参与晚间清算,仅供盘中参考;</p>';
            msg += '<p>2. 非交易日不显示;</p>';
            msg += '<p>3. 已计入交易手续费,但不包括理财产品收益;</p>';
            msg += '<p>4. 若昨日有股票分红、配股等情况,可能导致今日参考盈亏计算不准确;</p>';
            msg += '<p>5. 今日参考盈亏仅为参考值,不作为具体的投资参考意见,请以账户实际收益为准。</p>';
            common.singleIConfirmNew("今日参考盈亏", msg, null, "我知道了");
            e.preventDefault();
            e.stopPropagation();
        });
    }

    /**
     * 资金账户查询
     */
    function queryCapital(isShowWait) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var password = userInfo.password;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var money_type = "";  //  0：人民币，1：美元，2：港币
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "password": password,
            "cust_code": cust_code,
            "money_type": money_type,
            "is_homepage": ""
        };
        var ctrlParam = {  //传给接口的json格式数据
            "isLastReq": true,
            "isShowWait": isShowWait ? false : true,
            "isShowOverLay": false
        };
        //最后一个为超时处理函数
        service_option.queryAssets(param, queryCapitalCallback, ctrlParam);
    }

    /**
     * 资金账户查询回调
     */
    function queryCapitalCallback(data) {
        data = data || {};
        if (data.error_no == 0) {
            var results = data.results;
            if (results && results.length > 0) {
                for (var i = 0; i < results.length; i++) {
                    if (results[i].money_type == "0") {
                        var optionAsset = results[i] || {};
                        $(_pageId + ".option-banner .fxd").text("风险度: " + (optionAsset.risk_degree || '--')); //风险度
                        var zzc = toThousands(optionAsset.total_asset); //总资产
                        $(_pageId + ".option-banner .zzc").text(zzc).css("font-size", adjustFontSize(zzc, 18));
                        var kybzj = toThousands(optionAsset.enable_bail_balance); //可用保证金
                        $(_pageId + ".option-banner .kybzj").text(kybzj).css("font-size", adjustFontSize(kybzj, 18));
                        var totalBalance = optionAsset.income_balance || optionAsset.total_income_balance; //持仓参考盈亏
                        var ccyk = toThousands(totalBalance); //持仓参考盈亏
                        $(_pageId + ".option-banner .ccyk").addClass(getColor(totalBalance)).text(ccyk).css("font-size", adjustFontSize(ccyk, 18));
                        var ccsz = toThousands(optionAsset.market_value); //持仓市值
                        $(_pageId + ".option-banner .ccsz").text(ccsz).css("font-size", adjustFontSize(ccsz, 18));
                        var kq = toThousands(optionAsset.fetch_balance); //可取资金
                        $(_pageId + ".option-banner .kq").text(kq).css("font-size", adjustFontSize(kq, 18));
                        var jrckyk = toThousands(optionAsset.daily_income_balance); //今日参考盈亏
                        $(_pageId + ".option-banner .jrckyk").addClass(getColor(optionAsset.daily_income_balance)).text(jrckyk).css("font-size", adjustFontSize(jrckyk, 18));
                    }
                }
            } else {
                $(_pageId + ".option-banner strong").text("--").removeClass("ared agreen");
            }
        } else {
            data.error_info && $.alert(data.error_info);
        }
    }

    /**
     * 自适应字体大小
     * @param value 值
     * @param fontSize 默认大小
     * @param pad
     * @returns {string}
     */
    function adjustFontSize(value, fontSize, pad) {
        pad = pad || 0;
        return $.getTransformScaleFontSize(value, fontSize, (window.innerWidth - 30) * 0.3 - pad) + 'px';
    }

    /**
     * 格式化数字，转为每3位用逗号分隔
     * @returns {string}
     */
    function toThousands(asset) {
        if (asset !== 0 && !asset) {
            return '--';
        }
        if (isNaN(asset)) {
            return asset;
        }
        return $.formatMoney(asset, 2);
    }


    /**
     * 查询持仓
     */
    function queryPosition(isShowWait) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "session_id": session_id,
            "password": password
        };
        var ctrlParam = {
            "isShowWait": isShowWait ? false : true,
            "timeOutFunc": function () { //超时调用方法
                _callback = true;
                common.setNoData(true, "暂无持仓记录", $(_pageId + " #position .no_data"));
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            }
        };
        var queryPositionCallback = function (data) {
            _callback = true;
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        queryPositionHTML_stock(results);
                        common.setNoData(false, "暂无持仓记录", $(_pageId + ".no_data"));
                    } else {
                        $(_pageId + ".cc-content").hide();
                        common.setNoData(true, "暂无持仓记录", $(_pageId + ".no_data"));
                    }
                } else {
                    $.alert(data.error_info);
                }
            }
            if (!myScroller) {
                initScroller();
            } else {
                myScroller.refresh();
            }
        }
        service_option.queryPosition(param, queryPositionCallback, ctrlParam);
    }

    /**
     * 清除定时器
     */
    function clearPositionTimer() {
        if (position_Timer != null) {
            window.clearInterval(position_Timer);
        }
        position_Timer = null;
    }

    /**
     * 证券持仓HTML生成
     */
    function queryPositionHTML_stock(results) {
        var firstColHtml = '<div class="title thin-border">合约名称/代码</div>';
        var secondColHtml = '<div class="col second-col"><div class="title thin-border">持仓/可用</div>';
        var thirdColHtml = '<div class="col fourth-col"><div class="title thin-border">成本/现价</div>';
        var fourthColHtml = '<div class="col last-col"><div class="title thin-border">市值/盈亏</div>';
        for (var i = 0; i < results.length; i++) {
            var element = results[i] || {};
            var opthTypeHtml = '--';
            if (element.opthold_type == 0) {
                opthTypeHtml = '<span class="border trans_color_02 bor_color_02">权利方</span>';
            } else if (element.opthold_type == 1) {
                opthTypeHtml = '<span class="border trans_color_01 bor_color_01">义务方</span>';
            } else if (element.opthold_type == 2) {
                opthTypeHtml = '<span class="border trans_color_03 bor_color_03">备兑方</span>';
            }
            var optionType = element.option_type === '1' ? "认沽" : element.option_type === "0" ? "认购" : "--";
            firstColHtml += '<div class="td thin-border" id="' + element.option_code + '" stock_code="' + element.stock_code + '" opthold_type="' + element.opthold_type + '" exchange_type="' + element.exchange_type + '">' +
                '<p style="font-size: ' + adjustFontSize(element.option_name, 16) + '">' + element.option_name + '</p>' +
                '<p>' + element.option_code + '</p>' +
                '<div class="cc-info contract_flow_list">' + opthTypeHtml +
                '<span class="border marginLR8">' + optionType + '</span>' +
                '<span class="border">' + element.exercise_date + '到期 剩余' + element.apart_days + '天</span>' +
                '</div></div>';
            secondColHtml += '<div class="td thin-border" id="' + element.option_code + '" stock_code="' + element.stock_code + '" opthold_type="' + element.opthold_type + '" exchange_type="' + element.exchange_type + '">' +
                '<p style="font-size:' + adjustFontSize(element.hold_amount, 16, 20) + '">' + element.hold_amount + '</p>' +
                '<p style="font-size:' + adjustFontSize(element.enable_amount, 16, 20) + '">' + element.enable_amount + '</p>' +
                '</div>';
            thirdColHtml += '<div class="td thin-border" id="' + element.option_code + '" stock_code="' + element.stock_code + '" opthold_type="' + element.opthold_type + '" exchange_type="' + element.exchange_type + '">' +
                '<p>' + element.cost_price + '</p>' +
                '<p>' + element.last_price + '</p>' +
                '</div>';
            fourthColHtml += '<div class="td thin-border" id="' + element.option_code + '" stock_code="' + element.stock_code + '" opthold_type="' + element.opthold_type + '" exchange_type="' + element.exchange_type + '">' +
                '<p class="' + getColor(element.market_value) + '" style="font-size:' + adjustFontSize(element.market_value, 16, 20) + '">' + element.market_value + '</p>' +
                '<p class="' + getColor(element.income_balance) + '" style="font-size:' + adjustFontSize(element.income_balance, 16, 20) + '">' + toFixed(element.income_balance) + '</p>' +
                '</div>';
        }
        secondColHtml += '</div>';
        thirdColHtml += '</div>';
        fourthColHtml += '</div>';
        $(_pageId + ".cc-list-content .first-col").html(firstColHtml);
        $(_pageId + ".cc-list-content .other-col").html(secondColHtml + thirdColHtml + fourthColHtml);
        $(_pageId + ".cc-content").show();
    }

    /**
     * 初始化滑动组件
     */
    function initScroller() {
        mainHeight = common.setMainHeight(_pageId, false);
        var scrollOptions = {
            scrollerHeight: mainHeight - Number($(_pageId + ".main").css("margin-top").slice(0, -2) || 0), // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                backgroundInterface(); // 模拟查询接口数据操作
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时 iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 格式化小数点
     * @param num
     * @param digit
     * @returns {string|*}
     */
    function toFixed(num, digit) {
        if (num !== 0 && !num) {
            return '--';
        }
        if (isNaN(num)) {
            return num;
        }
        digit = digit || 2;
        num = Number(num);
        return num.toFixed(digit);
    }


    /**
     * 转为百分比
     * @param value
     * @param sum
     * @returns {string}
     */
    function toPercent(value, sum) {
        if (!sum || sum == 0) {
            return '--';
        }
        return (value * 100 / sum).toFixed(2) + '%';
    }

    /**
     * 字体颜色：>0红色  =0 黑色  <0绿色
     */
    function getColor(value) {
        return parseFloat(value) > 0 ? 'ared' : parseFloat(value) < 0 ? 'agreen' : '';
    }

    /**
     * 销毁
     */
    function destroy() {
        commonHq.clearCheckTradeTimer();
        common.pageBuryingPoint();
        $.clearRequest();
        clearPositionTimer();
        _callback = true;
        $(_pageId + ".option-banner strong").text("--").removeClass("ared agreen");
        $(_pageId + ".cc-list-content .first-col").empty();
        $(_pageId + ".cc-list-content .other-col").empty();
        $(_pageId + ".cc-content").hide();
        if (myScroller) {
            myScroller.scrollTo(0, 0);
            myScroller.destroy();
            myScroller = null;
        }
    }
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
        "destroy": destroy
    };
    module.exports = base;
});
