/**
 * 持仓
 */
define('trade/scripts/option/query/custOwnStockQuery.js', function(require, exports, module) {
    var _pageId = "#option_query_custOwnStockQuery ";
    var common = require("common");
    var publicQuery = require("publicQuery");
    var data = {
    	"funcNo" : "305003",
    	"param" : {},
    	"history":false,
    	"htmlData" : {
	    	"topDiv":{
//	    		"entrust":"",
		  		"name":"option_name",
		  		"code":"option_code",
	    		"time":function(){
	    			return "平仓";
	    		},
	    	},
	    	"liList":[
	    			["期权类型","option_type_name"],
	    			["持仓类型","opthold_type_name"],
	    			["成本价格","cost_price"],
	    			["最新价格",function(element){
	    				var float_yk = Number(element.income_balance);//浮动盈亏
						var css = "";
						if(float_yk>0){
							css = "ared";
						}else if(float_yk<0){
							css = "agreen";
						}
						return "<em class='"+css+"'>"+element.last_price+"</em>";
	    			}],
	    			["持仓数量","hold_amount"],
	    			["可用数量","enable_amount"],
	    			["浮动盈亏",function(element){
	    				var float_yk = Number(element.income_balance);//浮动盈亏
						var css = "";
						if(float_yk>0){
							css = "ared";
						}else if(float_yk<0){
							css = "agreen";
						}
						return "<em class='"+css+"'>"+element.income_balance+"</em>";
	    			}],
	    			["最新市值",function(element){
	    				var float_yk = Number(element.income_balance);//浮动盈亏
						var css = "";
						if(float_yk>0){
							css = "ared";
						}else if(float_yk<0){
							css = "agreen";
						}
						return "<em class='"+css+"'>"+element.market_value+"</em>";
	    			}],
	    		],
    	}
    }
    /**
     * 初始化
     */
	function init(){
		publicQuery.init(data);
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			$.pageBack("option/query/stockQuery","left");
			e.stopPropagation();
		});
		
		publicQuery.bindPageEvent();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		publicQuery.destroy();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});