/**
 * 查询股票期权合约
 */
define('trade/scripts/option/query/optionContrac.js', function(require, exports, module) {
	var _pageId = "#option_query_optionContrac ";
    var common = require("common");
    var publicQuery = require("publicQuery");
	var keyboard = require("keyboard");
    var data = {
    	"funcNo" : "305022",
    	"pagingNum": 50,
    	"param" : {},
    	"history":false,
    	"htmlData" : {
	    	"topDiv":{
//	    		"entrust":"",
		  		"name":"option_name",
		  		"code":"option_code",
//	    		"time":"entrust_oc_name",
	    	},
//	    	"liList":[
//					["合约类型","option_type_name"],
//			    	["交易市场","exchange_type_name"],
//	    			["标的代码","stock_code"],
//	    			["标的名称","stock_name"],
////	    			["合约标示","optcontract_id"],
//	    			["行权模式","option_mode_name"],
//	    			["合约单位","amount_per_hand"],
////					["合约名称","option_name"],
////					["期权昨收","opt_close_price"],
////					["标的昨收","close_price"],
////					["涨停价","opt_up_price"],
////					["跌停价","opt_down_price"],
////					["行权类别","option_type_name"],
//					["行权价格","exercise_price"],
//					["单笔保证金","initper_balance"],
//					["交易开始日期","begin_date"],
//					["交易截止日期","end_date"],
//					["行权开始日期","exe_begin_date"],
//					["行权截止日期","exe_end_date"],
////					["单笔保证金","initper_balance"],
//					["调整状态","opt_updated_status_name"],
////					["停牌状态","optcode_status_name"],
//	    			["限价买单笔申报上限数量","limit_buy_high_amount"],
//	    			["限价卖单笔申报上限数量","limit_sell_high_amount"],
////	    			["单笔限价申报最低数量","limit_low_amount"],
//	    			["市价买单笔申报上限","mkt_buy_high_amount"],
//	    			["市价卖单笔申报上限","mkt_sell_high_amount"],
////	    			["单笔市价申报最低数量","mkt_low_amount"],
//	    		],
	    	"liList":[
					["合约类型","option_type_name"],
			    	["交易市场","exchange_type_name"],
	    			["标的代码","stock_code"],
	    			["履行方式","option_mode_name"],
	    			["合约单位","amount_per_hand"],
	    			["首个交易日","begin_date"],
	    			["最后交易日","end_date"],
					["开始行权日","exe_begin_date"],
					["到期行权日","exe_end_date"],
					["行权价格","exercise_price"],
					["单位保证金","initper_balance"],
					["调整标志","opt_updated_status_name"],
					["限价单笔上限","limit_high_amount"],
	    			["市价单笔上限","mkt_high_amount"],
	    		],
    	}
    }
    /**
     * 初始化
     */
	function init(){
		if(keyboard){
			keyboard.keyInit();
		}
		publicQuery.init(data);
		common.pageBuryingPoint("107213");
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(107218,2,103,true,{"i_group_name":"返回"});
			$.pageBack("option/query/stockQuery","left");
			e.stopPropagation();
		});
		
		//标的代码
		$.bindEvent($(_pageId+"#stockCode"), function(e){
			var stockCode=$(this).val();
			if(stockCode&&stockCode.length>5){
				common.comStat(107216,2,104,true,{"i_change_name":"标的代码","i_change_to":stockCode});
			}
			e.stopPropagation();
		},"blur");
		
		//合约代码
		$.bindEvent($(_pageId+"#optionCode "), function(e){
			var optionCode=$(this).val();
			if(optionCode&&optionCode.length>5){
				common.comStat(107217,2,104,true,{"i_change_name":"合约代码","i_change_to":optionCode});
			}
			e.stopPropagation();
		},"blur");
		
		//查询
//		$.bindEvent($(_pageId + ".option_search .inner a"), function(e){
		$.bindEvent($(_pageId + ".trade_main  .option_query"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.clearRequest();
			$(_pageId+" .cancel_order").html("");
			$(_pageId+" .cancel_order").attr("style","");
			var param = data.param;
			param.stock_code = $(_pageId+" #stockCode").val();
			param.option_code = $(_pageId+" #optionCode").val();;
			publicQuery.againQuery(param,data.funcNo,data.htmlData,data.history);
			common.comStat(107214,2,103,true,{"i_group_name":"查询"});
		});
		
		publicQuery.bindPageEvent();
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		if(keyboard){
			keyboard.keyDestroy();
		}
		publicQuery.destroy();
		data.param={};
		$(_pageId+"#stockCode").quzhi("");
		$(_pageId+"#optionCode").quzhi("");
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});	
	
