/**
 * 欠资欠券查询
 */
define('trade/scripts/option/query/postageDue.js', function(require, exports, module) {
	
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var service_option = require("service_option");
    var _pageId = "#option_query_postageDue ";
    var userInfo = null;
    var queryType = null; //查询内容
    
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
		callsQuery();
    }
		
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
//			$.pageInit("option/query/queryToday","option/query/stockQuery",{});
			$.pageBack("option/query/stockQuery","left");
		});
		//页面切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			$(this).addClass("active").siblings().removeClass("active");
			callsQuery();
		});
		
	}
    
	/**
	 * 调用查询
	 */
	function callsQuery(){
		$(_pageId+".stock_order").html("");
		if($(_pageId+".toggle_nav ul li").eq(0).hasClass("active")){
			queryEntrust();
		}else{
			queryDeal();
		}
	}
	
	/**
	 * 委托查询
	 */
	function queryEntrust(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var session_id=userInfo.session_id;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "cust_code":cust_code,
			    "session_id":session_id
			};
			$(_pageId+ ".no_data").hide();
			service_option.queryPostageDues(param,queryEntrustCallback,
				{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"timeOutFunc":function(){ // 超时调用方法
					$(_pageId+ ".no_data").show();
					if(!myScroller){
						initScroller();
					}else{
						myScroller.refresh();
					}
		        }
			});
	}
	/**
	 * 委托查询回调
	 */
	function queryEntrustCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".main .stock_order").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var html = '';
					for (var i=0;i<results.length;i++){
						html += queryEntrustHTML(results[i],i);
					}
					$(_pageId+ ".main .stock_order").html(html);
					$(_pageId+ ".no_data").hide();
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element,i){
		var price_digit = 3;
		var eleHtml = "";
      	eleHtml+='<div class="part">';
        eleHtml+='<ul>';
        eleHtml+='<li>资金余额 <em>'+element.fund_bln+'</em></li>';
        eleHtml+='<li>昨日余额 <em>'+element.fund_prebln+'</em></li>';
        eleHtml+='<li>可用金额 <em>'+element.fund_avl+'</em></li>';
        eleHtml+='<li>应付资金 <em>'+element.exe_due_amt+'</em></li>';
        eleHtml+='<li>欠资金额 <em>'+element.exe_lack_amt+'</em></li>';
        eleHtml+='</ul></div>';
		return eleHtml;
	}
	
	/**
	 * 成交查询
	 */
	function queryDeal(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;//
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id
		};
		$(_pageId+ ".no_data").hide();
		service_option.queryOweCoupons(param,queryDealCallback,
		    {
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){ // 超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
	        }
		});
		
	}
	/**
	 * 成交查询回调
	 */
	function queryDealCallback(data){
		if (typeof(data) != "undefined" && data != null) {
			$(_pageId+" .tarde_hit").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results != "undefined" && results.length>0){
					var html = '';
					for (var i=0;i<results.length;i++){
						html += queryDealHTML(results[i],i);
					}
					$(_pageId+".main .stock_order").html(html);
					$(_pageId+".no_data").hide();
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		else{
			  $.alert("查询失败");
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 成交查询HTML生成
	 */
	function queryDealHTML(element,i){
		var price_digit = 3;
		var eleHtml = "";
      	eleHtml+='<div class="part">';
        eleHtml+='<ul>';
        eleHtml+='<li>证券代码 <em>'+element.opt_undl_code+'</em></li>';
        eleHtml+='<li>证券名称 <em>'+element.opt_undl_name+'</em></li>';
        eleHtml+='<li>证券可用 <em>'+element.opt_undl_avl+'</em></li>';
        eleHtml+='<li>应付数量 <em>'+element.exe_due_qty+'</em></li>';
        eleHtml+='<li>欠券数量 <em>'+element.exe_lack_qty+'</em></li>';
        eleHtml+='<li>证券账户 <em>'+element.trdacct+'</em></li>';
        eleHtml+='</ul></div>';
		return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".toggle_nav").height() , // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				callsQuery(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		$(_pageId+".main .stock_order").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});