/**
 * 减持信息
 */
 define('trade/scripts/publicQuery/stockShreduction.js', function (require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_xkj = require("service_xkj");
    var _pageId = "#publicQuery_stockShreduction ";
    var userInfo = null;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
    var queryType = 'entrust'; //查询内容
    var isGoDetail = false;
    /**
     * 初始化
     */
    function init() {
        queryType = 'entrust'; //查询内容
        userInfo = common.getCurUserInfo();
        var paramMap = $.getPageParam("param");
        if (paramMap && typeof (paramMap) == "object") {
            if (paramMap.param) {
                queryType = paramMap.param;
            }
        } else {
            queryType = paramMap;
        }
        var trade_query_nav_type = $.getSStorageInfo("stock_shreduction_query_nav_type");
        if (trade_query_nav_type) {
            queryType = trade_query_nav_type;
        }
        if (queryType === "entrust") {
            $(_pageId + ".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
        } else {
            $(_pageId + ".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }
    function load() {
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            setTimeout(function () {
                setScrollHeight();
            }, 20);
        };
    }
    function backgroundInterface() {
        callsQuery();
    }
    /**
     * 事件绑定
     */
    function bindPageEvent() {
        // 返回按钮事件
        $.bindEvent($(_pageId + ".top_title .icon_back"), function () { 
          commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
              $.pageBack();
          });
        });

        //页面切换
        $.bindEvent($(_pageId + ".toggle_nav ul li"), function (e) {
            setTimeData();
            $.clearRequest();
            $(this).addClass("active").siblings().removeClass("active");
            // 设置tab切换
            if ($(_pageId + ".toggle_nav ul li").eq(0).hasClass('active')) {
                queryType = 'entrust';
            } else {
                queryType = 'deal';
            }
            $.setSStorageInfo("stock_shreduction_query_nav_type", queryType);
            callsQuery();
        });
    }
    /**
     * 调用查询
     */
    function callsQuery() {
        $(_pageId + ".c-list").html("");
        setScrollHeight();
        $(_pageId + ".c-no-more-data").hide();
        if (queryType === "entrust") {
            queryEntrust();
        } else {
            queryDeal();
        }
    }
    function setScrollHeight() {
        var mianHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mianHeight;
        $(_pageId + '.main').height(mianHeight);
        $(_pageId + "#wrapper").height(mianHeight);
        $(_pageId + " .c-no-data-box").height(vIscrollHeight + 1);
    }
    /**
     * 委托查询
     */
    function queryEntrust() {
        $(_pageId + ".c-list").html("");
        $(_pageId + ".c-list").hide();
        $(_pageId + ".c-no-data-box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;

        var param = {
			"entrust_way":entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "client_id": cust_code,
            "sessionid": sessionid,
        };
        service_xkj.require1001018(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "errorFunc": function () { // 超时调用方法
                    $(_pageId + ".c-no-data-box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                },
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".c-no-data-box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        $(_pageId + ".c-no-more-data").hide();
        if (typeof (data) != "undefined" && data) {
            if (data.error_no == 0) {
                $(_pageId + ".c-no-data-box").hide();
                var results = data.results;
                var html = '';
                if (results.length > 0 && results != "undefined") {
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i], i);
                    }
                    $(_pageId + ".main .c-list").html(html);
                    $(_pageId + ".c-no-more-data").show();
                    $(_pageId + ".c-list").show();
                    $(_pageId + ".c-no-data-box").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .c-list .c-to-detail-btn"), function (e) {
                        setTimeData();
                        var selectIndex = $(this).attr("data-index");
                        var _loginClass = userInfo._loginClass || "0";//普通0  两融1
                        var toPage = "stock/stockDetails";
                        var param = {
                            'titleName': '减持信息详情',
                            'flag': '29',
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        if(_loginClass === "1"){
                            toPage = "credit/query/stockDetails";
                        }
                        $.pageInit("publicQuery/stockShreduction", toPage, param);
                    });
                } else {
                    $(_pageId + ".c-no-more-data").hide();
                    $(_pageId + ".c-no-data-box").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element, i) {
        var eleHtml = '<li class="c-list-item ' + (i !== 0?'mt10':'') + '">\
            <p class="c-title border-bottom c-flex c-aic">\
                <span class="c-item-label c-mr-6">' + element.stock_name + '</span>\
                <span class="c-item-value">' + element.stock_code + '</span>\
                <span class="c-item-value c-right-status">' + element.stock_account + '</span>\
            </p>\
            <div class="c-content">\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">证券余额</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.surplusstock_amount + '</span>\
                </div>\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">自由流通股数量</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.stock_circulate_amount + '</span>\
                </div>\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">股份认定数量一</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.cognizancestock_amount1 + '</span>\
                </div>\
                <div class="c-flex">\
                    <span class="c-item-label">股份认定数量二</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.cognizancestock_amount2 + '</span>\
                </div>\
            </div>\
            <div class="c-to-detail-btn thin-border-top" data-index=' + i + '>更多详情 <span class="c-to-detail-btn-icon"></span></div>\
        </li>';
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal() {
        $(_pageId + ".c-list").html("");
        $(_pageId + ".c-list").hide();
        $(_pageId + ".c-no-data-box").hide();
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var param = {
			"entrust_way":entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "client_id": cust_code,
            "sessionid": sessionid,
        };
        service_xkj.require1001019(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    $(_pageId + ".c-no-data-box").show();
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });

    }
    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        $(_pageId + ".c-no-more-data").hide();
        if (typeof (data) != "undefined" && data != null) {
            if (data.error_no == 0) {
                $(_pageId + ".c-no-data-box").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var html = "";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    html += '</table>';
                    $(_pageId + ".main .c-list").html(html);
                    $(_pageId + ".c-no-more-data").show();
                    $(_pageId + ".c-list").show();
                    $(_pageId + ".c-no-data-box").hide();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .c-list .c-to-detail-btn"), function (e) {
                        setTimeData();
                        var selectIndex = $(this).attr("data-index");
                        var param = {
                            'titleName': '减持信息详情',
                            'flag': '30',
                            "selectIndex": selectIndex
                        };
                        isGoDetail = true;
                        $.pageInit("publicQuery/stockShreduction", "stock/stockDetails", param);
                    });
                } else {
                    $(_pageId + ".c-no-more-data").hide();
                    $(_pageId + ".c-no-data-box").show();
                }
            }
            else {
                $.alert(data.error_info);
            }
        }
        else {
            $.alert("查询失败");
        }
        if (!myScroller) {
            initScroller();
        } else {
            myScroller.refresh();
        }
    }
    
    /**
     * 委托查询HTML生成
     */
     function queryDealHTML(element, i) {
        var eleHtml = '<li class="c-list-item ' + (i !== 0?'mt10':'') + '">\
            <p class="c-title border-bottom c-flex c-aic">\
                <span class="c-item-label c-mr-6">' + element.stock_name + '</span>\
                <span class="c-item-value">' + element.stock_code + '</span>\
                <span class="c-item-value c-right-status">' + element.stock_account + '</span>\
            </p>\
            <div class="c-content">\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">无限售流通股总量</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.stock_total_amount + '</span>\
                </div>\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">冻结数量</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.frozen_amount + '</span>\
                </div>\
                <div class="c-flex c-mb-6">\
                    <span class="c-item-label">股份数量一</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.stock_amount1 + '</span>\
                </div>\
                <div class="c-flex">\
                    <span class="c-item-label">股份数量二</span>\
                    <span class="c-item-value c-f-1 c-tar">' + element.stock_amount2 + '</span>\
                </div>\
            </div>\
            <div class="c-to-detail-btn thin-border-top" data-index=' + i + '>更多详情 <span class="c-to-detail-btn-icon"></span></div>\
        </li>';
        return eleHtml;
    }
    /**
     * 初始化滑动组件
     */
    function initScroller() {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            deceleration:0.002,
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                callsQuery()
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
                $(_pageId + " .c-no-data-box").height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else {
            myScroller.refresh();
        }
    }
    // 保持日期控件数据
    function setTimeData() {
        $.setSStorageInfo("stock_shreduction_query_nav_type", queryType);
    }
    /**
     * 销毁
     */
    function destroy() {
        if (isGoDetail) {
            isGoDetail = false;
        } else {
            $(_pageId + ".c-list").html("");
            $(_pageId + ".top_title .top_nav").hide();
            $.setSStorageInfo("stock_shreduction_query_nav_type", '');
            if (myScroller) {
                myScroller.destroy();
                myScroller = null;
            }
        }
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
