/**
 * 新债-中签查询
 */
define('trade/scripts/purchaseNewDebt/newSuccess.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var commonFunc = require("commonFunc");
	var	service_debt = require("service_debt");
	var common = require("common");
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var _pageId = "#purchaseNewDebt_newSuccess ";
	var userInfo =null;
	var whichPage ="";
	var witchAccount = "";
	
    /**
     * 初始化
     */
	function init() {
		common.pageBuryingPoint("100520");
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	function backgroundInterface(){
		commonFunc.initTimeChoice(_pageId,7);
		queryAchiveData(); //中签查询
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			commonFunc.appThirdBack('purchaseNewDebt_newSuccess', function(){
				$.pageBack("account/index","left");
			});
			
			//埋点
			common.comStat(100523,2,103,true,{"i_group_name": "返回" });
			e.stopPropagation();
		});
		
		//查询
		$.bindEvent($(_pageId + " .date_filter .btn"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			common.comStat(100524,2,104,true,{"i_change_name":"新债中签查询","i_change_to":time1+"-"+time2});
			queryAchiveData();
		});
	}
    
	/***
	 * 查询中签数据
	 */
	function queryAchiveData(){
		$(_pageId+".seach_list2").html("");
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();
		var time1 = new Date(end_time.replaceAll("-", "/"));
		var time2 = new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
		    $.alert("开始日期大于截止日期");
		    return false;
		}//截止时间
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_time":begin_time,
		    "end_time":end_time,
		    "account_type":userInfo._loginClass
		};
		$(_pageId+ ".no_data").hide();
		service_debt.historyDebtSigningQuery(param,querySuccessDataCallBack);
	}
	/**
	 * 查询自选股数据回调方法
	 */
	function querySuccessDataCallBack(data)	{
		if (typeof data != "undefined" && data != null) {
			if(data.error_no == 0){
				if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
					var results = data.results;	
					var dataHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						dataHtml += createHtml(data);
					}
					$(_pageId+".seach_list2").html(dataHtml);
					$(_pageId+ ".no_data").hide();
				}else{
					$(_pageId+ ".no_data").show();
				}
			}
			else{
				  $.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element){
		var eleHtml =  "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><span class="time">'+element.init_date+'</span>';
        eleHtml += "<h5>"+element.stock_name+"<small>"+element.stock_code+"</small></h5></div><ul>";
        eleHtml += "<li>成交编号<span>"+element.business_no+"</span></li>";
        eleHtml += "<li>中签数量<span>"+Number(element.occur_amount)+"</span></li>";
        eleHtml += "<li>成交价格<span>"+Number(element.business_price).toFixed(3)+"</span></li>";
        eleHtml += "<li>成交金额<span>"+Number(element.business_balance).toFixed(3)+"</span></li>";
        eleHtml += "<li>股东账号<span>"+element.stock_account+"</span></li>";
        eleHtml += "<li>所属市场<span>"+element.exchange_type_name+"</span></li>";
        eleHtml += "<li style='width: 100%'>备注<span>"+element.remark+"</span></li>";
        eleHtml += "</ul></div>";
	    return eleHtml;
	}
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height()  - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - $(_pageId+".date_filter").height(), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				common.comStat(100525,2,102,true,{"i_direct": "1","i_type":"1" });
				queryAchiveData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".seach_list2").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});