/**
 * 服务密码——激活
 */
define('trade/scripts/servicePassword/activation.js',function(require, exports, module) {
	var service_stock = require("service_stock");
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var _pageId = "#servicePassword_activation ";
	var userInfo =null;
	var marketArr=[];
	var type="";
	var keyboard = require("keyboard");
	
    /**
     * 初始化
     */
	function init() {
		common.pageBuryingPoint("101626");
		if(keyboard){
			keyboard.keyInit(null,function(){
				$(_pageId+"#branch").picker("close");
			});
		}
		userInfo = common.getCurUserInfo();
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		businessQueryStockAccountList();
    }
	function load(){
		var mianHeight = common.setMainHeight(_pageId, false);
		
	}
	
	function backgroundInterface(){}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		// 返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(101627,2,103,true,{"i_group_name":"返回"});
			$.pageBack("account/index","left");
			e.stopPropagation();	// 阻止冒泡
		});
		$.bindEvent($(_pageId + "#branch"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var accountValue=$(_pageId + "#activationCode").val();
			var inputValue=$(this).val();
			if($.trim(inputValue).length>0){
				if($.trim(accountValue).length<=0){
					$(_pageId+".error_tips").show();
					$(_pageId+".error_tips").html("请输入激活码");
				}else{
					$(_pageId+".error_tips").html("");
					$(_pageId+".error_tips").hide();
				}
			}else{
				$(_pageId+".error_tips").show();
				$(_pageId+".error_tips").html("请选择股东代码");
			}
			if(inputValue&&inputValue!=""&&inputValue!=null){
				var stock_account=$(this).val();
				for (var i=0;i<marketArr.length;i++) {
					if(marketArr[i].stockAccount==stock_account){
						type=marketArr[i].exchangeType;
					}
				}
				activateServicePasswordLinkage(type,stock_account);//联动
			}
            validateData();
			e.stopPropagation();	// 阻止冒泡
		},"change");
		
		$.bindEvent($(_pageId + "#activationCode"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var accountValue=$(_pageId + "#branch").val();
			var inputValue=$(this).val();
			if($.trim(inputValue).length>0){
				if($.trim(accountValue).length<=0){
					$(_pageId+".error_tips").show();
					$(_pageId+".error_tips").html("请选择股东代码");
				}else{
					$(_pageId+".error_tips").html("");
					$(_pageId+".error_tips").hide();
				}
			}else{
				$(_pageId+".error_tips").show();
				$(_pageId+".error_tips").html("请输入激活码");
			}
            validateData();
			e.stopPropagation();	// 阻止冒泡
		},"input");
		//提交
		$.bindEvent($(_pageId + ".define_button"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			common.comStat(101628,2,103,true,{"i_group_name":"激活提交"});
			var branchValue=$(_pageId + "#branch").val();
			var activationValue=$(_pageId + "#activationCode").val();
			if($.trim(branchValue).length<=0){
				$.alert("请选择股东代码");
				return false;
			}
			if($.trim(activationValue).length<=0){
				$.alert("请输入激活码");
				return false;
			}
			servicePasswordSumbit();
			e.stopPropagation();	// 阻止冒泡
		});
	}
    // 校验数据是否输入
    function validateData(){
        var activationCode = $(_pageId + " #activationCode").val();
        var branch = $(_pageId + " #branch").val();
        if(!branch || !$.trim(activationCode)){
            $(_pageId + ".define_button").addClass('define_button_disabled');
        }else{
            $(_pageId + ".define_button").removeClass('define_button_disabled');
        }
    }
     /**
     * 查询股东账户
     */
	function businessQueryStockAccountList() {
		var param = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"password":userInfo.password,
				"sessionid":userInfo.sessionid,
				// "businessType":"0"
		};
		service_stock.queryStockAccountList(param, function(data) {
			var branch_arr = [];
			var exchange_arr = [];
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results!= "undefined" && results.length >0){
                        var exchange = {
                            "0":"深",
                            "2":"沪",
                        };
						for(var i=0;i<results.length;i++){
                            var account = results[i];
							var stock_account=account.stock_account;
                            if(account.main_flag === "1" && (account.exchange_type === "2" || account.exchange_type === "0") && account.holder_status === "0"){
                                branch_arr.push(stock_account);
                                exchange_arr.push(exchange[account.exchange_type] + "   " + stock_account);
                                var param={
                                        "stockAccount":stock_account,
                                        "exchangeType":account.exchange_type,
                                        "stockCode":account.stock_code
                                    }
                                marketArr.push(param);
                            }
						}
						
						var cs="font-family: -apple-system, BlinkMacSystemFont, 'PingFang SC', 'Hiragino Sans GB', 'Microsoft YaHei', sans-serif;";
						$("#branch").picker({
							  toolbarTemplate: 
							  		'<header class="bar bar-nav">'+
							  		'<button class="button button-link pull-left close-picker" style="'+cs+'">取消</button>'+
							  		'<button class="button button-link pull-right close-picker" id="yes" style="'+cs+'">确定</button>'+
							  		'<div class="titlehsea"></div></header>'
							  ,
							  cols: [
							    {
							      textAlign: 'center',
							      values: branch_arr,
                                  displayValues:exchange_arr,
							    }
							  ],
							  cssClass:'timeColor'
						});
						
					}
				}else{
					$.alert(data.error_info);
				}
			}
		},{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}
		});
	}
	
	/**
     * 服务密码联动
     */
	function activateServicePasswordLinkage(exchange_type,stock_account) {
		var param = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"password":userInfo.password,
				"sessionid":userInfo.sessionid,
				"exchange_type":exchange_type,//市场   
				"stock_account":stock_account,//股东代码
				"businessType":"0"//0为激活 1为挂失
		};
		service_stock.servicePasswordLinkage(param, function(data) {
			var branch_arr = [];
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results!= "undefined" && results.length >0){
						for(var i=0;i<results.length;i++){
							$(_pageId+".check_text").attr("entrust_price",results[i].entrust_price);
							$(_pageId+".check_text").attr("stock_code",results[i].stock_code);
						}
					}
				}else{
					$.alert(data.error_info);
				}
			}
		},{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}
		});
	}
	
	/**
     * 服务密码提交
     */
	function servicePasswordSumbit() {
		var param = {
				"entrust_way":global.entrust_way,
				"branch_no":userInfo.branch_no,
				"fund_account":userInfo.fund_account,
				"cust_code":userInfo.cust_code,
				"password":userInfo.password,
				"sessionid":userInfo.sessionid,
				"exchange_type":type,//市场   
				"stock_code":$(_pageId+".check_text").attr("stock_code"),//代码
				"entrust_price":$(_pageId+".check_text").attr("entrust_price"),//价格
				"stock_account":$(_pageId+"#branch").val(),//股东代码
				"entrust_amount":$(_pageId+"#activationCode").val(),//激活码 
				"businessType":"0"//0为激活 1为挂失
		};
		service_stock.servicePasswordSumbit(param, function(data) {
			var branch_arr = [];
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results!= "undefined" && results.length >0){
						$.alert("<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>激活请求提交成功，委托编号："+results[0].entrust_no);
					}
				}else{
					$.alert(data.error_info);
				}
				$(_pageId+"#activationCode").quzhi("");
                $(_pageId + ".define_button").addClass('define_button_disabled');
			}
		},{"isLastReq":false,"isShowWait":false,
			"timeOutFunc":function(){
				$.hidePreloader();
			},"errorFunc":function(){
				$.hidePreloader();
			}
		});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+"#branch").unbind("click");
		$(_pageId+"#branch").data("picker",null);
		$(_pageId+"#branch").attr("value","");
		$(_pageId+"#branch").show();
		$(_pageId+"#branch").val("");
		$(_pageId+"#activationCode").quzhi("");
		$(_pageId+".error_tips").show();
		$(_pageId+".error_tips").html("请选择股东代码");
        $(_pageId + ".define_button").addClass('define_button_disabled');
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
