/**
 * 新股-配号查询
 */
define('trade/scripts/shares/distribution.js',function(require, exports, module) {
	var service_stock = require("service_stock");
	var common = require("common");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var _pageId = "#shares_distribution ";
	var userInfo =null;
	var whichPage ="";
	var witchAccount = "";
	
    /**
     * 初始化
     */
	function init() {
		userInfo = common.getCurUserInfo();
		if(userInfo._loginClass&&userInfo._loginClass=="1"){
			common.pageBuryingPoint("105507");
		}else{
			common.pageBuryingPoint("100320");
		}
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		buryingPoint();
    }
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	
	function backgroundInterface(){
		commonFunc.initTimeChoice(_pageId,7);
		queryDistributionData(); //中签查询
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		//返回按钮
		$.bindEvent($(_pageId+".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105510,2,103,true,{"i_group_name": "返回" });
			}else{//普通交易
				common.comStat(100323,2,103,true,{"i_group_name": "返回" });
			}
			commonFunc.appThirdBack('shares_distribution', function(){
				$.pageBack();
			});		
			
			e.stopPropagation();
			e.preventDefault();
		});
		
		//页面切换
		$.bindEvent($(_pageId + " .date_filter .btn"), function(e){
			if(!myScroller){
				initScroller();
			}else{
				myScroller.refresh();
			}
			queryDistributionData();
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105511,2,104,true,{"i_change_name":"新股配号查询","i_change_to":time1+"-"+time2});
			}else{//普通交易
				common.comStat(100324,2,104,true,{"i_change_name":"新股配号查询","i_change_to":time1+"-"+time2});
			}
		});
	}
    
	/*
	 * 埋点参数
	 */
	function buryingPoint(){
		if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
			$(_pageId+".tab_nav li:eq(0)").find("a").attr("objectId","105481");
			$(_pageId+".tab_nav li:eq(0)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(1)").find("a").attr("objectId","105482");
			$(_pageId+".tab_nav li:eq(1)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(2)").find("a").attr("objectId","105483");
			$(_pageId+".tab_nav li:eq(2)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(3)").find("a").attr("objectId","105484");
			$(_pageId+".tab_nav li:eq(3)").find("a").attr("actionId","103");
			$(_pageId+".date_filter").attr("startObjectId","105508");
			$(_pageId+".date_filter").attr("endObjectId","105509");
			$(_pageId+".date_filter").attr("actionId","104");
			
		}else{//普通交易
			$(_pageId+".tab_nav li:eq(0)").find("a").attr("objectId","100295");
			$(_pageId+".tab_nav li:eq(0)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(1)").find("a").attr("objectId","100296");
			$(_pageId+".tab_nav li:eq(1)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(2)").find("a").attr("objectId","100297");
			$(_pageId+".tab_nav li:eq(2)").find("a").attr("actionId","103");
			$(_pageId+".tab_nav li:eq(3)").find("a").attr("objectId","100298");
			$(_pageId+".tab_nav li:eq(3)").find("a").attr("actionId","103");
			$(_pageId+".date_filter").attr("startObjectId","100321");
			$(_pageId+".date_filter").attr("endObjectId","100322");
			$(_pageId+".date_filter").attr("actionId","104");
		}
	}
	/***
	 * 查询中签数据
	 */
	function queryDistributionData(){
		$(_pageId+".seach_list2").html("");
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var end_time = $(_pageId+" #endDate").text();  
		var begin_time = $(_pageId+" #startDate").text();	
		var time1 = new Date(end_time.replaceAll("-", "/"));
		var time2 = new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
		    $.alert("开始日期大于截止日期");
		    return false;
		}//截止时间
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
		    "stock_account":"",
		    "begin_time":begin_time,
		    "end_time":end_time,
		    "account_type":userInfo._loginClass
		};
		$(_pageId+ ".no_data").hide();
		service_stock.queryDistributionData(param,queryDistributionCallBack);
	}
	/**
	 * 查询自选股数据回调方法
	 */
	function queryDistributionCallBack(data)	{
		if (typeof data != "undefined" && data != null) {
			if(data.error_no == 0){
				if(typeof data.results != "undefined" && data.results!= null && data.results != ""){
					var results = data.results;	
					var dataHtml = "";
					for(var i = 0;i < results.length; i++){
						var data = results[i];
						dataHtml += createHtml(data);
					}
					$(_pageId+".seach_list2").html(dataHtml);
					$(_pageId+ ".no_data").hide();
				}else{
					$(_pageId+ ".no_data").show();
				}
			}
			else{
				  $.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	/**
	 * 生成html
	 * @param {Object} element 数据项
	 */
	function createHtml(element){
		var eleHtml =  "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><span class="time">'+element.init_date+'</span>';
        eleHtml += "<h5>"+element.stock_name+"<small>"+element.stock_code+"</small></h5></div><ul>";
        eleHtml += "<li>配号数量<span>"+Number(element.occur_amount)+"</span></li>";
//      eleHtml += "<li>委托价格<span>"+Number(element.business_price).toFixed(3)+"</span></li>";
        eleHtml += "<li>股东账号<span>"+element.stock_account+"</span></li>";
        eleHtml += "<li>所属市场<span>"+element.exchange_type_name+"</span></li>";
        eleHtml += "<li style='width: 100%'>备注<span>"+element.remark+"</span></li>";
        eleHtml += "</ul></div>";
	return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height()  - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - $(_pageId+".date_filter").height(), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
					common.comStat(105512,2,102,true,{"i_direct": "1","i_type":"1" });
				}else{//普通交易
					common.comStat(100325,2,102,true,{"i_direct": "1","i_type":"1" });
				}
				queryDistributionData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".seach_list2").html("");
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});