/**
 * 新股中签明细查询
 */
define('trade/scripts/shares/recordQuery.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var commonFunc = require("commonFunc");
	var global = gconfig.global;
	var service_stock = require("service_stock");
    var _pageId = "#shares_recordQuery ";
    var userInfo =  null;
    var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
    	
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		if(userInfo._loginClass&&userInfo._loginClass=="1"){
			common.pageBuryingPoint("105534");
		}else{
			common.pageBuryingPoint("100348");
		}
    }
		
	function load(){
		statementQuery();
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			//埋点
			if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
				common.comStat(105535,2,103,true,{"i_group_name": "返回" });
			}else{
				common.comStat(100349,2,103,true,{"i_group_name": "返回" });
			}
			
			$.pageBack("shares/more","left");
			e.stopPropagation();
		});
	}
	
	/**
	 * 对账单查询
	 */
	function statementQuery(){
		$(_pageId+ ".no_data").hide();
		$(_pageId+".seach_list2 ").html("");
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid=userInfo.session_id;
		var business_flag = "";
		var money_type = "";
		var param = {			
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"sessionid":sessionid,
			"money_type":money_type,
			"business_flag" : business_flag,
			"account_type":userInfo._loginClass
		};
		$(_pageId+ ".no_data").hide();
		service_stock.theCurrentSuccess(param,queryStatementOfAccountCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 对账单查询回调
	 */
	function queryStatementOfAccountCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".seach_list2 ").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					var data = "";
					for (var i=0;i<results.length;i++){
						data += queryEntrustHTML(results[i]);
					}
					$(_pageId+".seach_list2 ").html(data);
				}else{
					$(_pageId+".no_data").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 2;
		var css = "";
		var ipo_info_status = {"0":"认购资金不足额","1":"认购资金足额","2":"未处理状态"};
		var eleHtml =  "";
		eleHtml += '<div class="part">';
        eleHtml += '<div class="title"><span class="time">'+element.init_date+'</span>';
        eleHtml += "<h5>"+element.stock_name+"<small>"+element.stock_code+"</small></h5></div><ul>";
        eleHtml += "<li>中签数量<span>"+Number(element.ipo_lucky_amount)+"</span></li>";
        eleHtml += "<li>中签金额<span>"+Number(element.lucky_balance).toFixed(price_digit)+"</span></li>";
        eleHtml += "<li>中签价格<span>"+Number(element.issue_price).toFixed(price_digit)+"</span></li>";
        eleHtml += "<li>中签缺口金额<span>"+Number(element.ipo_short_balance).toFixed(price_digit)+"</span></li>";
        eleHtml += "<li>认购状态<span>"+ipo_info_status[element.ipo_info_status]+"</span></li>";
        eleHtml += "<li>股东账号<span>"+element.stock_account+"</span></li>";
        eleHtml += "<li style='width: 100%'>备注<span>"+element.remark+"</span></li>";
        eleHtml += "</ul></div>";
	    return eleHtml;
	}
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		var scrollOptions = {
			scrollerHeight: $(window).height()  - $(_pageId+".top_title").height()- $(_pageId+".tab_nav").height() - $(_pageId+".date_filter").height(), // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				//埋点
				if(userInfo._loginClass&&userInfo._loginClass=="1"){//信用交易
					common.comStat(105536,2,102,true,{"i_direct": "1","i_type":"1" });
				}else{
					common.comStat(100350,2,102,true,{"i_direct": "1","i_type":"1" });
				}
				statementQuery(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+" .seach_list2").html("");
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");	
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});