/**
 */
define('trade/scripts/stock/explainDetails.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#stock_explainDetails ";
	var downslide = new (require("downslide")).Downslide();
	var nameList={
		"0":"限价委托",
		"62":"最优五档即时成交剩余转限价",
		"64":"最优五档即时成交剩余撤销",
		"70":"对手方最优价格",
		"68":"本方最优价格",
		"4":"即时成交剩余撤销",
		"64":"最优五档即时成交剩余撤销",
		"66":"全额成交或撤销委托",
	}
	
    /**
     * 初始化
     */
	function init(){
		downslide.addSlide();
		var param = $.getPageParam() || {};
		
		$(_pageId + " .header .top_title h3").text(nameList[param.param]);
		$(_pageId + " .main .boost").hide();
		$(_pageId + " .main .boost[type='"+param.param+"']").show();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
		
	function load(){
		var mainHeight =  common.setMainHeight(_pageId, false);
        var height_table =  mainHeight - $(_pageId + ".tab_nav").getMHeight();
		downslide.rollInit(height_table);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageBack("stock/stockExplain", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		$(_pageId + " .header .top_title h3").text("");
		$(_pageId + " .main .boost").hide();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
