/**
 * Created by sizhe on 2016/10/19.
 */
/**
 * 普通交易-限售股份查询
 */
define('trade/scripts/stock/limitedStockQuery.js', function(require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var _pageId = "#stock_limitedStockQuery ";
    var userInfo = null;
    var iscrollUtils = require("iscrollUtils");
	var HIscroll = require("hIscroll");// 导入滑动插件
    var myScroller = null; // 滑动组件对象
	var hIscroll = null;

    /**
     * 初始化
     */
    function init(){
        userInfo = common.getCurUserInfo();
		common.pageBuryingPoint("100283");
        if(global.requestLocation == 0){
            backgroundInterface();
        }
    }

    function load(){
        if(global.requestLocation == 1){
            backgroundInterface();
        }
        var mianHeight = common.setMainHeight(_pageId, false);
    }
    function backgroundInterface(){
        limitedStockQuery();
    }
    /**
     * 事件绑定
     */
    function bindPageEvent(){
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                //埋点
                common.comStat(100284, 2, 103, true, {"i_group_name": "返回"});
                $.pageBack("stock/limitedStockQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        },"tap");
    }

    /**
     * 委托查询
     */
    function limitedStockQuery(){
        var entrust_way=global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid=userInfo.session_id;
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
        };
        $(_pageId+ ".no_data").hide();
        service_stock.limitedStockQuery(param,queryCallback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "errorFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                },
                "timeOutFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryCallback(data){
        if (typeof(data) != "undefined" && data) {
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                var html="";
                if(results.length>0 && results!= "undefined"){
                    for (var i=0;i<results.length;i++){
                        html += queryHTML(results[i]);
                    }
                    $(_pageId+ ".fund_flow2").html(html);
                    $(_pageId + ".fund_flow2").show();
                    $(_pageId+ ".no_data").hide();
                }else{
                    $(_pageId+".no_data").show();
                }
            }
            else{
                $.alert(data.error_info);
            }
        }
        else{
            $.alert("查询失败");
        }
        if(!myScroller){
            initScroller();
        }else{
            myScroller.refresh();
        }
    }

    /**
     * 深市HTML生成
     */
    function queryHTML(element){
        var exchange_type = element.exchange_type;

        var eleHtml = "";


        eleHtml+='<div class="part">';
        eleHtml+='<div class="stocks nsb_padtopwu nsb_conveible"style="border-bottom: 1px solid #ffffff">'


        if(exchange_type=="0"||exchange_type=="1"){//深市
            eleHtml+='<div class="row_01"style="border-bottom: 1px solid #ffffff">'
            eleHtml+='<em class="a01 market blue_full">深</em>'
        }else if(exchange_type=="2"||exchange_type=="3"){//沪市
            eleHtml+='<div class="row_01"style="border-bottom: 1px solid #ffffff">'
            eleHtml+='<em class="a01 market red_full">沪</em>'
        }else if(exchange_type=="9"||exchange_type=="A"){//沪市
            eleHtml+='<div class="row_01"style="border-bottom: 1px solid #ffffff;padding: 0 0 0 0.4rem;">'
            eleHtml+='<em class="a01 market blue_full_two">股转</em>'
        }

        eleHtml+='<span class="stock_name reset">'+common.getShowStr(element.stock_code,"--",0,0)+'</span>'
        eleHtml+='<span class="gotoHQText" style="position: absolute;font-size:0.12rem ;right: 0.3rem; color: #999999;">'+common.getShowStr(element.shdc_authority_type_name,"",0,0)+'</span>'
        eleHtml+='</div></div>'


        eleHtml+='<ul><li style="height: 0.3rem!important;">证券账号<span>'+common.getShowStr(element.stock_account,"--",0,0)+'</span></li>';
        eleHtml+='<li style="height: 0.3rem!important;">当前数量<span>'+common.getShowStr(element.current_amount,"--",0,0) +'</span></li>';
        eleHtml+='<li style="height: 0.3rem!important;">占用数量<span>'+common.getShowStr(element.ocpused_amount,"--",0,0)+'</span></li>';
        eleHtml+='<li style="width: 0;min-width: 50%;display: inline-table;height: 0.3rem">冻结数量<span>'+common.getShowStr(element.frozen_amount,"--",0,0)+'</span></li>';

        if(exchange_type=="0"||exchange_type=="1"||exchange_type=="9"||exchange_type=="A"){//深市
            eleHtml+='<li style="width: 100%;min-width: 100%;display: inline-table;height: 0.3rem">股份性质<span>'+common.getShowStr(element.stock_property_name,"--",0,0)+'</span></li>';
        }else if(exchange_type=="2"||exchange_type=="3"){//沪市
            eleHtml+='<li style="height: 0.3rem!important;">挂牌年份<span>'+common.getShowStr(element.shdc_market_year,"--",0,0)+'</span></li>';
            eleHtml+='<li style="width: 0;min-width: 50%;display: inline-table;height: 0.3rem">结束日期<span>'+common.getShowStr(element.shdc_end_date,"--",0,0)+'</span></li>';
            eleHtml+='<li style="width: 100%;min-width: 100%;display: inline-table;height: 0.3rem">流通类型<span>'+common.getShowStr(element.shdc_circulate_type_name,"--",0,0)+'</span></li>';
        }

        eleHtml+='<li style="width: 100%;min-width: 100%;display: inline-table;height: 0.3rem">担保证券市值<span>'+common.getShowStr(element.limit_secu_market_value,"--",0,0)+'</span></li>';

        eleHtml+='</ul></div>';
        return eleHtml;
    }

	function scrollRecommendTG(){
		if (hIscroll) {
			hIscroll.destroy();
			hIscroll = null;
		}
		var scrollConfig = {
			"wrapper" : $(_pageId + ".fund_flow2"), // wrapper元素，必传
			"scroller" : $(_pageId + ".fund_flow2"), // scroller元素，必传
		};
		hIscroll = new HIscroll(scrollConfig);
//		$(_pageId + " .fund_table").css("overflow","inherit");
	  };
    /**
     * 初始化滑动组件
     */
    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
                limitedStockQuery(); // 模拟查询接口数据操作
            },
            pullUpHandler: function(){
            }
        };
        if(!myScroller)
        {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy(){
		common.pageBuryingPoint();
        $(_pageId+ ".no_data").hide();
        //清空数据
        $(_pageId+ ".main .fund_flow2").html('');
       // $(_pageId+ ".main .ce_table ").html("");
        if(myScroller)
        {
            myScroller.destroy();
            myScroller = null;
        }
		if (hIscroll) {
			hIscroll.destroy();
			hIscroll = null;
		}
    }


    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
