/**
 * 普通交易-当日资金流水查询
 */
define('trade/scripts/stock/moneyFlow.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_stock = require("service_stock");
    var _pageId = "#stock_moneyFlow ";
    var userInfo = null;
	var VIscroll = require("vIscroll");
	var vIscroll = {"scroll":null,"_init":false};		//上下滑动
    var commonFunc = require("commonFunc");
    
    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		common.pageBuryingPoint("100258");
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	
	function load(){
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mianHeight = common.setMainHeight(_pageId, false);
	}
	function backgroundInterface(){
		moneyFlow();//查询资金流水数据
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				//埋点
				common.comStat(100259, 2, 103, true, {"i_group_name": "返回"});
//			$.pageInit("stock/moneyFlow","stock/stockQuery",{});
				$.pageBack("stock/stockQuery", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");

        //更多按钮
        $.bindEvent($(_pageId + ".nsb_sel_fixed_box"), function (e) {
            $.pageInit("stock/moneyFlow", "stock/statementQuery", {"param":""});
        });


	}
	
	/**
	 * 当日资金流水查询
	 */
	function moneyFlow(){
        $(_pageId+".j-position-table").html("");
        $(_pageId+".j-position-table").hide();
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var sessionid = userInfo.session_id;
		var param = {			
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"sessionid":sessionid
		};
		$(_pageId+ ".no_data_box").hide();
        $(_pageId+".no_more_data").hide();
		service_stock.querySameDayCapitalFlow(param,moneyFlowQueryCallback,
			{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$(_pageId+ ".no_data_box").show();
                if(!vIscroll._init){
                    initVIScroll();
                }else{
                    vIscroll.scroll.refresh();
                }
			}
		});
	}
	/**
	 *  当日资金流水查询回调
	 */
	function moneyFlowQueryCallback(data){
		if (typeof(data) != "undefined" && data) {
			$(_pageId+".state_list").html("");
			if(data.error_no == 0){
				$(_pageId+".no_data_box").hide();
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
                    var data = '<table width="100%" border="0" cellspacing="0" cellpadding="0" class="fixed"><tr><th scope="col">证券/时间</th><th scope="col">价格/数量</th><th scope="col">发生金额</th><th style="width: 25%;" scope="col">业务名称</th></tr>';
                    for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						data += queryDealHTML(results[i],i);
					}
                    data += '</table>';
                    $(_pageId+".main .j-position-table").html(data);
                    $(_pageId+".j-position-table").show();
                    $(_pageId+".no_data").hide();
                    $(_pageId+".no_more_data").show();
                    //进入详情
                    $.bindEvent($(_pageId + ".main .j-position-table tr"), function(e){
                        var selectIndex=$(this).attr("data-index");
                        var param = {
                            'titleName':'资金流水详情',
                            'flag':'7',
                            'search_type':'',
                            "begin_time":'',
                            "end_time":'',
							"selectIndex":selectIndex
                        };

                        $.pageInit("stock/moneyFlow", "stock/stockDetails", param);
                    });
				}else{
					$(_pageId+".no_data_box").show();
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
        if(!vIscroll._init){
            initVIScroll();
        }else{
            vIscroll.scroll.refresh();
        }
	}

    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element,i){
        var price_digit = 3;
        var css = "";
        var entrust_name = element.entrust_type_name;
        if(element.entrust_name && element.entrust_name!==" " && element.entrust_name!==""){
            entrust_name = element.entrust_name;
        }
        if($.inArray(element.entrust_bs, ["0"]) != -1){
            css = "trans_color_02";
            // entrust_name ="买入";
        }else if($.inArray(element.entrust_bs, ["1"]) != -1){
            css = "trans_color_01";
            // entrust_name ="卖出";
        }else{
            css = "";
        }
        var eleHtml = "";
		var maxWidth = ($(window).width() - 30) * 0.25 - 20;
        var showStock_name=element.stock_name;
        if(showStock_name==""||showStock_name==" "){
            showStock_name="--";
        }
        eleHtml+="<tr data-index='"+i+"'>";
        eleHtml+="<td><p style='transform-origin: left;transform:scale("+$.getTransformScale(showStock_name, 16, maxWidth)+")'>"+showStock_name+"</p><span>"+element.business_time+"</span></td>";
        eleHtml+="<td><p>"+Number(element.business_price).toFixed(3)+"</p><p>"+element.occur_amount+"</p></td>";
        eleHtml+="<td><p style='line-height: 0.4rem!important;'>"+Number(element.occur_balance).toFixed(3)+"</p></td>";
        eleHtml+="<td><p style='line-height: 0.4rem!important;"+common.setAjustFontSize(element.business_name,16,4,5)+"' class='"+css+"'>"+element.business_name+"</p></td>";
        eleHtml+="</tr>";
        return eleHtml;
    }
	
	/**
	 * 委托查询HTML生成
	 */
	function queryEntrustHTML(element){
		var price_digit = 3;
		var css = "";
		var business_name = element.business_name;
		if($.inArray(element.entrust_bs, ["0","4","62","64","66","68","70"]) != -1){
			css = "n1";
		}else if($.inArray(element.entrust_bs, ["1","5","63","65","67","69","71"]) != -1){
			css = "n2";
		}
		else{
			css = '';
		}
        var eleHtml = "";
        eleHtml+='<div class="part"><div class="title">';
        eleHtml+='<span class="tag '+css+'">'+business_name+'</span><small>'+element.business_date+'</small>';
        eleHtml+="</div><ul>";
        eleHtml+='<li>证券名称<span>'+(element.stock_name || "--")+'</span></li>';
        eleHtml+='<li>证券代码<span>'+(element.stock_code || "--")+'</span></li>';
        eleHtml+="<li>币种<span>"+element.money_type_name+"</span></li>";
        eleHtml+="<li>委托编号<span>"+element.entrust_no+"</span></li>";
        eleHtml+="<li>发生金额<span>"+Number(element.occur_balance)+"</span></li>";
        eleHtml+="<li>后资金额<span>"+Number(element.enable_balance)+"</span></li>";
        eleHtml+="<li>成交价格<span>"+Number(element.business_price)+"</span></li>";
//      eleHtml+="<li>成交数量<span>"+Number(element.matchqty)+"</span></li>";
//      eleHtml+="<li>委托价格<span>"+Number(element.orderprice)+"</span></li>";
        eleHtml+="<li>股东账号<span>"+element.stock_account+"</span></li>";
        eleHtml+="<li style='width: 100%;'>备注<span style='display: initial;'>"+element.remark+"</span></li>";
        eleHtml+="</ul></div>";
        return eleHtml;
	}

    /**
     * 初始化上下滑动组件
     */
     function initVIScroll(){
    	if(!vIscroll._init){
    		var config = {
    			"isPagingType": false,		//false表示是微博那种累加形式，true表示分页形式
    			"visibleHeight": $(window).height() - $(_pageId + "header").height(), // 滚动组件的高度
    			"container": $(_pageId+" #v_container_funds_jj"),	
    			"wrapper":$(_pageId+" #v_wrapper_funds_jj"),	
    			"downHandle": function() {
                    moneyFlow();//下拉获取上一页数据方法
    			},
    			"upHandle": function() {
    			},
    			"wrapperObj": null
    		};
    		vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
    		vIscroll._init = true; 						//尽量只初始化一次，保持性能
            window.vIscroll=vIscroll;
            setTimeout(function(){
                // 绑定截长屏分享
				$.bindEvent($(_pageId + ".share_customer"), function (e) {
					var scroll = vIscroll.scroll.getWrapperObj();
					commonFunc.longScreenShot({
						scroll: scroll,
						topFixedHeight:$(_pageId + 'header').height(),
						offsetHeight:Math.max(scroll.scrollerH,$(_pageId + '.main').height()) + $(_pageId + 'header').height(),
						// 最大可滚动距离
						maxScrollY: scroll.maxScrollY > 0?0:-(scroll.maxScrollY - scroll.minScrollY),
					});
				});
            },200);
    	}else{
    		vIscroll.scroll.refresh();
    	}
    	$(_pageId + ".visc_pullUp").css("display","none");
    }
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
        $(_pageId+".j-position-table").html("");
        $(_pageId+".j-position-table").hide();
		$(_pageId + ".top_title .top_nav").hide();
		$(_pageId + " .top_title small").text("一周内");	
		if(vIscroll._init){
			vIscroll.scroll.refresh();
		}
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
