/**
 * 普通交易-持仓
 */
define('trade/scripts/stock/stockHolding.js', function(require, exports, module) {
	var common = require("common");
	var commonFunc = require("commonFunc");
	var commonHq = require("commonHq");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_stock = require("service_stock");
	var service_hq = require("service_hq");
    var nativePluginService = require("nativePluginService");
	if(global.hqCallInterface == 1){
		service_hq = require("service_hqTrade");
	}
	var iscrollUtils = require("iscrollUtils");
	var iscroll5 = require("iscroll5");
	var keyboard = require("keyboard");
	var mainHeight = null;
	var myScroller = null; // 滑动组件对象
    var vIscrollHeight = null;
    var myHScroller = null;
    var canBuy = 0 ;//可用
    var market_val = 0 ;//市值
    var _pageId = "#stock_stockHolding ";
    var userInfo = null;
    var position_Timer = null;
    var _callback = true;
    var float_yks = 0;
    var _openStock={};
	var right_table_scroll = null;
    var isDestroy = true;
	var request_num = 20; // 持仓分页参数
	var stockHoldingHeader = [
		{"index":0,"fieldPropName1":"name","fieldPropName2":"code","titleText":"名称/代码"},
		{"index":1,"fieldPropName1":"market_value","fieldPropName2":"market_value_per","titleText":"市值/仓位"},
		{"index":2,"fieldPropName1":"float_yk","fieldPropName2":"float_yk_per","titleText":"盈亏/比例"},
		{"index":3,"fieldPropName1":"cost_amount","fieldPropName2":"enable_amount","titleText":"持有/可用"},
		{"index":4,"fieldPropName1":"cost_price","fieldPropName2":"last_price","titleText":"成本/现价"},
		{"index":5,"fieldPropName1":"av_buy_price","titleText":"买入均价"},
	];

    /**
     * 初始化
     */
	function init(){
		common.switchingCurUser("0");
		common.pageBuryingPoint("100163");
		sessionStorage.setItem("isScroller","");
		_openStock={};
		$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
		common.pageChangeHeight();
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),function(pageCode,topage){
			$.pageInit(pageCode,topage,$.getPageParam(),'',true);
		});
		userInfo = common.getCurUserInfo();
		jumpPageEvent();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		isDestroy = true;
		commonFunc.getLiquidationInfo(_pageId); //获取清算状态和清算提示信息
		getStockHoldingHeader();
        common.subscribeOn("50243",getStockHoldingHeader);
		initRightScroll();
    }

	function load(){
		if($.device.android){ //安卓图标兼容性处理
			$(_pageId + ".j-tran-btn").addClass("android");
		}
		initHScroller();
		// pageContentChange();
		mainHeight = common.setMainHeight(_pageId, false);
		vIscrollHeight = mainHeight - $(_pageId+".tab_nav").outerHeight(true)-2- $(_pageId + ".tip_qs").outerHeight(true);
		$(_pageId + " #wrapper").height(vIscrollHeight);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryData();//查询持仓

	}

	function pageContentChange(){
		$(_pageId+".position_div thead th").each(function(idx, item){
			var zoom = $.getTransformScaleFontSize($(item).text(), 14, ($(window).width()) * 0.25 - 15)
			$(item).css({"font-size": zoom+"px" });
		});
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent(){}

	/**
	 * 事件绑定
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
                var pageObj = $.getCurrentPageObj() || '';
				//埋点
				common.comStat(100169, 2, 103, true, {"i_group_name": "返回"});
				commonFunc.appThirdBack('stock_stockHolding', function () {
                    // 判断是需要返回之前的页面，而不是交易首页
                    if(pageObj && pageObj.param && pageObj.param.param && pageObj.param.param.isGoBack === '1'){
                        $.pageBack("bjs/index", "left");
                    }else{
                                    $.pageInit("stock/stockHolding", "account/index", {"history": true}, "left", true);
                    }
				});
				e.preventDefault();
				e.stopPropagation();
			},300);
		},"tap");
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(100168,2,103,true,{"i_group_name":"银证转账"});
			$.setSStorageInfo("return_page","stock/stockHolding");
			isDestroy = false;
			$.pageInit("stock/stockHolding","banking/transferNew",{});
			e.preventDefault();
			e.stopPropagation();
		});

		//理财
		$.bindEvent($(_pageId + "#financial"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.callMessage({
				"funcNo": "50500",
				"msgNo": "304",
				"targetModule":"appDispatcher",
				"sourceModule":"trade",
				"action":"3",
				"param":{
					"moduleLoginType":"0",
					"index":"3"
				}
			});
			e.preventDefault();
			e.stopPropagation();
		});

		//成本价输入框
		$.bindEvent($(_pageId + "#costPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		}, "input");

		//表头编辑按钮
		$.bindEvent($(_pageId + ".edit-icon"), function(e){
			$.callMessage({
				moduleName: "trade",
				funcNo: "501152",
				openLoadBar:'0',  //是否显示加载等待层 1显示  0不显示 默认不显示
				isShowTitleBar:'0',   // 是否显示标题栏 1:显示；0:不显示 默认显示
				isUseFullScreenH5: "1",
				titleBgColor: '#EE4034',  //状态栏颜色&标题栏颜色
				isSaveCache:'1',  //是否启用缓存 1启用 0不启用 默认启用
				isSupportPullDownRefresh:'0',  //是否启用自带的下拉刷新1 启用 0 不启用 默认不启用
				reloadCallback: 'subMessagingCallBack', // 跨模块页面刷新调用
				bgColor:'#FFFFFF',  //webView 背景颜色
				isFullScreen:'1',  //是否开启沉浸式状态栏 1启用 0不启用 默认启用
				"url":global.newFrameUrl + "fintechpages/synthetical/index.html#/trade/tableHeaderEdit",
				"uniqueCode":"synthetical-trade/tableHeaderEdit",
			});
		}, );

		$.bindEvent($(_pageId), function(e){
			sessionStorage.setItem("isScroller","");
		}, "touchstart");

		$.bindEvent($(_pageId + ".j-exp-icon"), function(e){
            nativePluginService.function501152({
                "url":global.newFrameUrl + "fintechpages/synthetical/index.html#/public/description?defaultPage=1&switchUserInfo=0",
                "uniqueCode":"PalmHall-public/description",
                "isShowTitleBar":"0",
                "isUseFullScreenH5":"1"
            });
			e.stopPropagation();
		});

        //全景
        $.bindEvent($(_pageId + "#zcqj"), function(e){
            if (global.callNative && global.isSso) {
				var toPage = global.intelligenceUrl + "/m_znzh_sszd/tiiiasa/views/login_router.html?needlogin=true&tabid=pt";
				var param = {
					"funcNo": "50500",
					"msgNo": "601",
					"targetModule": "mallDispatcher",
					"action": 3,
					"param": {
						"business_type": userInfo._loginClass,//普通0  两融1
						"event": "15",//打开风险警示权限开通页面
						"title": "",
						"toPage": toPage,
					}
				}
                $.callMessage(param);
            }
            e.stopPropagation();
        });


	}

    function getStockHoldingHeader(){
        // 获取保存编辑的表头数据
        var data = $.callMessage({
            funcNo: '50043',
            key: 'stockHoldingHeader'
        }).results[0].value;
        if(typeof data == "string" && data != ""){
            data = JSON.parse(data);
        }
        if(data && data[userInfo.cust_code]){
            stockHoldingHeader = data[userInfo.cust_code];
        }
        $(_pageId + ".left_fixed_table .first").html(stockHoldingHeader[0].titleText);
        var thtml = [];
        for (var i = 1;i <= stockHoldingHeader.length - 1 ;i++){
            var item = stockHoldingHeader[i];
            thtml.push("<th>" + item.titleText + "</th>");
        }
        $(_pageId + ".right_table thead tr").html(thtml.join(""));
    }
	/**
	 * 查询
	 */
	function queryData(){
		clearPositionTimer();
		//查询资金账户
		queryCapital(false,function(){
			queryPosition(false);
		});
		_callback = false;
		if(position_Timer == null && global.positionRefreshTime){
			commonFunc.initCheckTradeTimer();
			position_Timer = window.setInterval(function(){
				if(commonFunc.getTradingTime() && _callback && common.isAppFlag()){
					queryCapital(true,function(){
						queryPosition(true,true);
					});
					_callback = false;
				}
			}, 5000);//定时刷新
		}
	}
	/**
	 * 资金账户查询
	 */
	function queryCapital(isShowWait,callback){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "money_type":money_type,
			    "is_homepage":""
		};
		//最后一个为超时处理函数
		service_stock.queryFundSelect(param,function(data){
				queryCapitalCallback(data,callback);
			},
		{  //传给接口的json格式数据
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false
	    });
	}

	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data,callback){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var isShowJrckyk = results[0].dailyIncomeBalance_flag == 1;
					var type = {"0":"RMB ","1":"Dollar","2":"HKD"};
					for(var i=0;i<results.length;i++){
						var id = _pageId +"#"+ type[results[i].money_type];
						var assert_val = Number(results[i].assert_val).toFixed(2)+"";
						$(id+" #zzc").html(assert_val.substring(0,assert_val.length-2)+""+ assert_val.substr(-2) +"");//总资产
						var fetch_balance = Number(results[i].fetch_balance).toFixed(2)+"";
						$(id+" #kq").html(fetch_balance.substring(0,fetch_balance.length-2)+""+ fetch_balance.substr(-2) +"");//可取
						var enable_balance = Number(results[i].enable_balance).toFixed(2)+"";
						$(id+" #ky").html(enable_balance.substring(0,enable_balance.length-2)+""+ enable_balance.substr(-2) +"");//可用

						//添加总浮动盈亏
						var css = "";
						var float_yks = results[i].float_yk || results[i].total_income_balance;
						//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+"
						if(float_yks > 0){
							css = "ared";
						}else if(float_yks < 0){
							css = "agreen";
						}
						var fas = Number(float_yks).toFixed(2);
						$(id+" #ccckyk").html(fas.substring(0,fas.length-2)+""+ fas.substr(-2) +"").removeClass().addClass(css);//持仓盈亏
						//当日参考盈亏
						if(isShowJrckyk){ // 是否显示当日参考盈亏1显示
							var daily_income_balance = results[i].daily_income_balance;
							$(id+" #jrckyk").html(daily_income_balance).removeClass().addClass(daily_income_balance > 0 ? "ared" : daily_income_balance < 0 ? "agreen" : "");
							$(_pageId + " #jrckyk").parent().show();
						}else{
							$(_pageId + " #jrckyk").parent().hide();
						}
						//持仓市值
						var market_val = Number(results[i].market_val || "0").toFixed(2)+"";
						$(id+" #ccsz").html(market_val.substring(0,market_val.length-2)+""+ market_val.substr(-2) +"");
						//仓位
						var stock_position = results[i].stock_position
						$(id + " #cwbox").html('<span style="width:'+stock_position+';"></span>仓位 '+ stock_position);
					}
					//字体缩放
					$(_pageId+".j-data-info strong").each(function(idx, item){
						item = $(item);
						item.setTransformScale($.getTransformScale(item.text(), 18, item.parent().width() - 36));
					});
				}else{
					$(_pageId+".hold_main2 .j-stock-data strong").text("--");
					$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
		callback && callback();
	}


	function queryPosition(isShowWait,isInterval){
        if(myHScroller === null){
            return;
        }
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var sessionid = userInfo.session_id;
		var password = userInfo.password;
		var param={
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "sessionid":sessionid,
			"request_num": request_num,
			"password":password,
			"include_ggt": myHScroller.getCurPageIdx() === 0?"1":"", // 包括港股通
			"money_type": myHScroller.getCurPageIdx()
		};
		service_stock.queryStockData(param,function(data){
			queryPositionCallback(data,isInterval);
		},{
			"isLastReq":true,
			"isShowWait":isShowWait?false:true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				_callback = true;
				//超时调用方法
				$(_pageId+ ".no_data").show();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}


	function queryPositionCallback(data,isInterval){
		_callback = true;
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		$(_pageId+'.left_fixed_table tr.tools').remove();
		$(_pageId+'.left_fixed_table tr.add').remove();
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					float_yks = 0; //浮动盈亏
          			var htmlTop = "";
					var htmlLeft = "";
					_openStock=$.getSStorageInfo("openStock",false) || {};
					if(_openStock && typeof(_openStock) == "string"){
						_openStock = JSON.parse(_openStock);
					}
					for (var i=0;i<results.length;i++){
						if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
						var type = ""
						var exchange_type = commonHq.getHqMarket(results[i].exchange_type);
                        type = exchange_type + ":" + results[i].stock_code;
						var isLast="";
						if(i==(results.length-1)){
							isLast="true";
						}
						float_yks += Number(results[i].float_yk);//计数总浮动盈亏
						htmlTop += queryPositionHTML_stock(results[i],type,isLast);
						htmlLeft += queryPositionLeftHTML_stock(results[i],type,isLast);
					}
					$(_pageId+".position_div tbody").html(htmlTop);
					$(_pageId+".left_fixed_table tbody").html(htmlLeft);
					if(!isInterval){
						initRightScroll();
					}
					$(_pageId+".no_data").hide();
					//卖出事件
					$.bindEvent($(_pageId+'.left_fixed_table tr.add,'+_pageId+'.right_table tr.add'), function(e){
						var inv = $(_pageId+".left_fixed_table .tools._last").is(':visible') ? 0 : 34;
						var isLast=$(this).attr("islast");
						if(($(_pageId +  ".vertical_list").height() + inv) > $(_pageId + " #wrapper").height()){
							var isNeedScroll = ($(this).next().is(':visible') == false && e.clientY < $(window).height()) && (e.clientY > ($(window).height() - $(this).height()));
							if(isLast=="true" || isNeedScroll){
								if($(this).next().height() > 0){
		                            abc = $(this).next().height();
		                        }
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".left_fixed_table .tools").hide();
								$(_pageId+".right_table .tools").hide();
								if(a){
									//显示右边表格站位条
									var type = $(this).attr('type');
									$(_pageId+".left_fixed_table tr[type='" + type + "']").next().show();
									$(_pageId+".right_table tr[type='" + type + "']").next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
		                            if($(this).next().height() > 0){
		                            	abc = $(this).next().height();
		                            }
		                            var maxScrollY = 0;
		                        	var _height=myScroller.y;
		                        	var temph = e.currentTarget.getBoundingClientRect().height - $(window).height() + e.currentTarget.getBoundingClientRect().y;
								if($(this).next().is(':visible')){
									sessionStorage.setItem("isScroller","true");
									_height -= abc;
										maxScrollY = _height;
									    _height -= temph;
								}else{
									_height += abc;
										maxScrollY = _height;
									sessionStorage.setItem("isScroller","");
								}
								myScroller.scrollTo(0,_height);
									myScroller.y = _height;
									myScroller.refresh();
									if(isLast=="true"){
										myScroller.maxScrollY = maxScrollY;
									}
								}
							}else{
								var a = $(this).next().css("display") == "none" ? true : false;
								$(_pageId+".left_fixed_table .tools").hide();
								$(_pageId+".right_table .tools").hide();
								if(a){
									//显示右边表格站位条
									var type = $(this).attr('type');
									$(_pageId+".left_fixed_table tr[type='" + type + "']").next().show();
									$(_pageId+".right_table tr[type='" + type + "']").next().show();
									//保存展开的股票
									var openStock={
										"stock_code":$(this).attr("id"),
										"exchange_type":$(this).attr("exchange_type"),
										"stock_account":$(this).attr("stock_account"),
									}
									$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
								}else{
									_openStock={};
									$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
								}
								$(this).addClass("active").siblings().removeClass("active");
								if(myScroller){
									myScroller.refresh();
								}
							}
						}
						else{
							var a = $(this).next().css("display") == "none" ? true : false;
							$(_pageId+".left_fixed_table .tools").hide();
							$(_pageId+".right_table .tools").hide();
							if(a){
								//显示右边表格站位条
								var type = $(this).attr('type');
								$(_pageId+".left_fixed_table tr[type='" + type + "']").next().show();
								$(_pageId+".right_table tr[type='" + type + "']").next().show();
								//保存展开的股票
								var openStock={
									"stock_code":$(this).attr("id"),
									"exchange_type":$(this).attr("exchange_type"),
									"stock_account":$(this).attr("stock_account"),
								}
								$.setSStorageInfo("openStock",JSON.stringify(openStock),false);
							}else{
								_openStock={};
								$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
							}
							$(this).addClass("active").siblings().removeClass("active");
							if(myScroller){
								myScroller.refresh();
							}
						}
						e.stopPropagation();
					});

					//卖出事件
					$.bindEvent($(_pageId+".left_fixed_table tr.tools a"), function(e){
						_openStock={};
						$.setSStorageInfo("openStock",JSON.stringify(_openStock),false);
						$(_pageId+".left_fixed_table tr.tools").hide();
						$(_pageId+".right_table tr.tools").hide();
						$(this).siblings().removeClass("active");
						var stock = $(this).parents("tr.tools").prev();
						var stock_code = stock.attr("id");
						var id = $(this).attr("id");
						var type = stock.attr("type");
						var exchange_type = stock.attr("exchange_type");
						var cost_price = stock.attr("cost_price");
						var stock_account = stock.attr("stock_account");
						var market = "";
						var stock_name= stock.attr("stock_name");
						if(type){
							market = type.split(":");
							if(market[0]){
								market = market[0];
							}
						}
						if(id == "buy"){
							//埋点
							common.comStat(100164,2,204,true,{
								"i_type":"跳买入",//操作类型
								"i_exchange_type":exchange_type,//交易市场
								"i_stock_code":stock_code,//股票代码
								"i_stock_name":stock_name,//股票名称
							});

                            if(exchange_type === "G" || exchange_type === "S"){
                                $.pageInit("ggt/ggtHolding","ggt/ggtBuy",{"code":stock_code,"exchange_type":exchange_type,"stock_account":stock_account,isHold:"1"});
                            }else{
                                $.pageInit("stock/stockHolding","stock/stockBuy",{"code":stock_code,"name":stock_name,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
                            }
						}
						else if(id == "sell"){
							//埋点
							common.comStat(100165,2,204,true,{
								"i_type":"跳卖出",//操作类型
								"i_exchange_type":exchange_type,//交易市场
								"i_stock_code":stock_code,//股票代码
								"i_stock_name":stock_name,//股票名称
							});

                            if(exchange_type === "G" || exchange_type === "S"){
                                $.pageInit("ggt/ggtHolding","ggt/ggtSell",{"code":stock_code,"exchange_type":exchange_type,"stock_account":stock_account,isHold:"1"});
                            }else{
                                $.pageInit("stock/stockHolding","stock/stockSell",{"code":stock_code,"name":stock_name,"exchange_type":exchange_type,"market":market,"stock_account":stock_account},"",true);
                            }
						}
						else if(id == "hq"){
                            var pageCode = $.getCurrentPageObj().pageCode || '';
                            $.setSStorageInfo("go_hq_" + pageCode, true);		
                            var param = {
                                "funcNo": "50500",
                                "msgNo": "201",
                                "targetModule":"hqDispatcher",
                                "sourceModule":"trade",
                                "action":"0",
                                "param":{
                                    "stockCode": stock_code,
                                    "stockName": stock_name,
                                }
                            }	
                            if(exchange_type === "G" || exchange_type === "S"){
                                //埋点
                                common.comStat(100734,2,204,true,{
                                    "i_type":"跳行情",//操作类型
                                    "i_exchange_type":exchange_type,//交易市场
                                    "i_stock_code":stock_code,//股票代码
                                    "i_stock_name":stock_name,//股票名称
                                });			
                                param.param.stockMarket = exchange_type == 'S'? 'SK':'HK';
                            }else{
                                //埋点
                                common.comStat(100166,2,204,true,{
                                    "i_type":"跳行情",//操作类型
                                    "i_exchange_type":exchange_type,//交易市场
                                    "i_stock_code":stock_code,//股票代码
                                    "i_stock_name":stock_name,//股票名称
                                });
                                param.param.stockMarket = market;
                            }
                            if(global.callNative){
                                $.callMessage(param);
                            }
						}
						else if(id == "cbj"){
							var content="<li><p>证券代码</p>"+stock_code+"</li>"+
	               						"<li><p>修改前</p>"+ cost_price+"</li>"+
	               						"<li><p>币种</p>人民币</li>"+
	                					"<li>"+
                						"<div class='CBJinput_box' style='border: 1px solid #dddddd;border-radius: 0.03rem;width: 0.9rem;height: 0.28rem;'><p>修改后</p>"+
	                					"<input type='number' js-key='number' class='t1' id='costPrice' custom_keybord='0'/>"+
	                					"</div></li>";
							common.costPriceiConfirm("成本价修改",content,function success(){
								var costPrice=$(_pageId+"#costPrice").val();
								if(!costPrice){
									$.alert("请输入修改后成本价！");
									return false;
								}
								if(costPrice<=0.000){
									$.alert("成本价格必须大于0.000。");
									return false;
								}
								if(costPrice>1000000000.000){
									$.alert("成本价格必须小于1000000000.000。");
									return false;
								}
								var reg=/^(-?\d*)\.?\d{1,3}$/;
								if(!reg.test(costPrice)){
									$.alert("成本价格只能精确到小数点后3位。");
									return false;
								}
								var param={
									"entrust_way":global.entrust_way, // 委托方式  在configuration配置
								    "branch_no":userInfo.branch_no,
								    "fund_account":userInfo.fund_account,
								    "cust_code":userInfo.cust_code,
								    "stock_account":stock_account,//股东代码
								    "exchange_type":exchange_type,//市场
								    "stock_code":stock_code,//股票代码
								    "cost_price":costPrice,//修改后的成本价
								    "password":userInfo.password
								};
								costModification(param);
							},function fail(){
								if(keyboard){
									keyboard.closeKeyPanel();
								}
							});
							if(keyboard){
								keyboard.keyInit();
							}
						}
						e.stopPropagation();
					});
				}
				else{
					$(_pageId+".no_data").show();
				}
			}else{
				$.alert(data.error_info);
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}

	function clearPositionTimer(){
		if (position_Timer != null ) {
	        window.clearInterval(position_Timer);
	    }
		position_Timer = null;
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,type,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "",css1="";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
        var active_css1 = "" , active_css2 = " style='display:none'";
		if(_openStock && _openStock.stock_code){
			if(element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account){
				active_css1 = "active";
				active_css2 = "";
			}
		}
		var css3="";
		if(isLast=="true"){
			css3="_last";
		}else{
			css3="_nolast";
		}
        var hgtFlag = "";
        if(element.exchange_type === "G"){
            hgtFlag = "<em class='ggt'>沪</em>";
        }else if(element.exchange_type === "S"){
            hgtFlag = "<em class='sgt'>深</em>";
        }
		var total_market = $(_pageId + '#hscroller>div').eq(myHScroller.getCurPageIdx()).find('#zzc').html();
		var maxWidth = ($(window).width() - 30) * 0.25 - 20;
		var marketValue = Number(element.market_value).toFixed(price_digit),
		float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
		cost_amount = Number(element.cost_amount),
		market_per = "",
		enable_amount = Number(element.enable_amount),
		cost_price = Number(element.cost_price).toFixed(price_digit),
		av_buy_price = Number(element.av_buy_price).toFixed(price_digit),
		last_price = Number(element.last_price).toFixed(price_digit);
		float_yk = float_yk.toFixed(price_digit);
		if(parseFloat(total_market)){
			market_per = (Number(element.market_value) / parseFloat(total_market) * 100).toFixed(2) + "%";
		}else{
			market_per = '0.00%';
		}
    	eleHtml+="<tr class='add "+active_css1+"' cost_price='"+cost_price+"' stock_account='"+element.stock_account+"' stock_name='"+element.stock_name+"' exchange_type='"+element.exchange_type+"'  type='"+type+"' id='"+element.stock_code +"'  isLast='"+isLast+"'>";
		var columMap = {
			"cost_amount":[
				'<td><div class="td-warp"><p style="font-size:'+$.getTransformScaleFontSize(cost_amount, 16, maxWidth) +'px;">'+cost_amount+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></div></td>'
			],
			"market_value":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(market_per, 16, maxWidth) +'px;">'+market_per+'</p></div></td>'
			],
			"cost_price":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></div></td>'
			],
			"float_yk":[
				'<td><div class="td-warp"><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>',
				'<p class="'+css+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+ Number(element.float_yk_per).toFixed(price_digit) +'%</p></div></td>'
			],
			"av_buy_price":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(av_buy_price, 16, maxWidth) +'px;">'+av_buy_price+'</p></div></td>'
			],
			"name":[
				'<td><div class="td-warp"><p style="transform-origin: left;transform:scale('+$.getTransformScale(element.stock_name, 16, maxWidth + 5)+')">' + hgtFlag +element.stock_name +'</p>',
				'<p>'+element.stock_code+'</p></div></td>'
			],
		}
		// 按照保存的表头顺序渲染右侧表格
		for (var i = 1; i <= stockHoldingHeader.length - 1;i++){
			eleHtml += columMap[stockHoldingHeader[i].fieldPropName1].join("");
		}

        eleHtml+="</tr>";
		eleHtml+="<tr class='j-table-btns tools "+css3+"' "+active_css2+">";
		eleHtml+="<td colspan=\"4\">";
		eleHtml+="<ul class='ui layout j-btns-list'>";
		eleHtml+="<a class=\"row-1 border-right\" href=\"javascript:void(0);\"></a>";
		eleHtml+="</ul>";
		eleHtml+="</td>";
		eleHtml+="</tr>";

        // eleHtml+="<dl class='position_data "+active_css1+"' exchange_type=\""+element.exchange_type+"\"  type=\""+type+"\" id='"+element.stock_code +"' stock_account='"+element.stock_account +"' stock_name='"+element.stock_name +"' cost_price='"+Number(element.cost_price).toFixed(price_digit) +"' isLast='"+isLast+"'>";
        // eleHtml+="<dd><p><strong>"+element.stock_name +"</strong></p><p><small>"+Number(element.market_value).toFixed(price_digit) +"</small></p></dd>";
        // eleHtml+="<dd><p><span class=\""+css+"\">"+float_yk+"</span></p><p><span class=\""+css+"\">"+Number(element.float_yk_per).toFixed(price_digit)+"%</span></p></dd>";
        // eleHtml+="<dd><p>"+Number(element.cost_amount)+"</p><p>"+Number(element.enable_amount)+"</p></dd>";
        // eleHtml+="<dd><p>"+Number(element.cost_price).toFixed(price_digit)+"</p><p>"+Number(element.last_price).toFixed(price_digit)+"</p></dd>";
        // eleHtml+="</dl>";
		// eleHtml+="<dd class='toolstwo "+css3+"'  "+active_css2+"><ul>";
		// eleHtml+="<li><a id=\"buy\" href=\"javascript:void(0);\"><span>买入</span></a></li>";
		// eleHtml+="<li><a id=\"sell\" href=\"javascript:void(0);\"><span>卖出</span></a></li>";
		// eleHtml+="<li><a id=\"hq\" href=\"javascript:void(0);\"><span>行情</span></a></li>";
		// eleHtml+="<li><a id=\"cbj\" href=\"javascript:void(0);\"><span>成本价</span></a></li>";
		// eleHtml+="</ul></dd>";
		return eleHtml;
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionLeftHTML_stock(element,type,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "",css1="";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk>0){
			css = "ared";
		}else if(float_yk<0){
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		var active_css1 = "" , active_css2 = " style='display:none'";
		if(_openStock && _openStock.stock_code){
			if(element.stock_code == _openStock.stock_code && element.exchange_type == _openStock.exchange_type && element.stock_account == _openStock.stock_account){
				active_css1 = "active";
				active_css2 = "";
			}
		}
		var css3="";
		if(isLast=="true"){
			css3="_last";
		}else{
			css3="_nolast";
		}
        var hgtFlag = "";
        if(element.exchange_type === "G"){
            hgtFlag = "<em class='ggt'>沪</em>";
        }else if(element.exchange_type === "S"){
            hgtFlag = "<em class='sgt'>深</em>";
        }
		var total_market = $(_pageId + '#hscroller>div').eq(myHScroller.getCurPageIdx()).find('#zzc').html();
		var maxWidth = ($(window).width() - 30) * 0.25 - 20;
		var marketValue = Number(element.market_value).toFixed(price_digit),
			float_yk_per = Number(element.float_yk_per).toFixed(price_digit) + "%",
			cost_amount = Number(element.cost_amount),
			market_per = "",
			enable_amount = Number(element.enable_amount),
			cost_price = Number(element.cost_price).toFixed(price_digit),
			av_buy_price = Number(element.av_buy_price).toFixed(price_digit),
			last_price = Number(element.last_price).toFixed(price_digit);
		float_yk = float_yk.toFixed(price_digit);
		if(parseFloat(total_market)){
			market_per = (Number(element.market_value) / parseFloat(total_market) * 100).toFixed(2) + "%";
		}else{
			market_per = '0.00%';
		}
		eleHtml+="<tr class='add "+active_css1+"' cost_price='"+cost_price+"' stock_account='"+element.stock_account+"' stock_name='"+element.stock_name+"' exchange_type='"+element.exchange_type+"'  type='"+type+"' id='"+element.stock_code +"'  isLast='"+isLast+"'>";
		var columMap = {
			"cost_amount":[
				'<td><div class="td-warp"><p style="font-size:'+$.getTransformScaleFontSize(cost_amount, 16, maxWidth) +'px;">' + cost_amount+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(enable_amount, 16, maxWidth) +'px;">'+enable_amount+'</p></div></td>'
			],
			"market_value":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(marketValue, 16, maxWidth) +'px;">'+marketValue+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(market_per, 16, maxWidth) +'px;">'+market_per+'</p></div></td>'
			],
			"cost_price":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(cost_price, 16, maxWidth) +'px;">'+cost_price+'</p>',
				'<p style="font-size:'+ $.getTransformScaleFontSize(last_price, 16, maxWidth) +'px;">'+last_price+'</p></div></td>'
			],
			"float_yk":[
				'<td><div class="td-warp"><p class="'+css+'" style="font-size:'+$.getTransformScaleFontSize(float_yk, 16, maxWidth) +'px;">'+float_yk+'</p>',
				'<p class="'+css+'" style="font-size:'+ $.getTransformScaleFontSize(float_yk_per, 16, maxWidth) +'px;">'+ Number(element.float_yk_per).toFixed(price_digit) +'%</p></div></td>'
			],
			"av_buy_price":[
				'<td><div class="td-warp"><p style="font-size:'+ $.getTransformScaleFontSize(av_buy_price, 16, maxWidth) +'px;">'+av_buy_price+'</p></div></td>'
			],
			"name":[
				'<td><div class="td-warp"><p style="transform-origin: left;transform:scale('+$.getTransformScale(element.stock_name, 16, maxWidth + 5)+')">' + hgtFlag +element.stock_name +'</p>',
				'<p>'+element.stock_code+'</p></div></td>'
			],
		}
		// 按照保存的表头顺序渲染左侧表格
		eleHtml += columMap[stockHoldingHeader[0].fieldPropName1];
		eleHtml+="</tr>";
		eleHtml+="<tr class='j-table-btns tools "+css3+"' "+active_css2+">";
		eleHtml+="<td colspan=\"4\">";
		eleHtml+="<ul class='ui layout j-btns-list'>";
		eleHtml+="<a id=\"buy\" class=\"row-1 border-right\" href=\"javascript:void(0);\">买入</a>";
		eleHtml+="<a id=\"sell\" class=\"row-1 border-right\" href=\"javascript:void(0);\">卖出</a>";
		eleHtml+="<a id=\"hq\" class=\"row-1 border-right\" href=\"javascript:void(0);\">行情</a>";
		eleHtml+="<a id=\"cbj\" class=\"row-1\" href=\"javascript:void(0);\">成本价</a>";
		eleHtml+="</ul>";
		eleHtml+="</td>";
		eleHtml+="</tr>";
		return eleHtml;
	}

	//成本价修改
	function costModification(param){
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		service_stock.costModification(param,function(data){
			if(data.error_no == 0){
				queryPosition(false);//刷新持仓
			}else{
				$.alert(data.error_info);
			}
		},{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"timeOutFunc":function(){
				$.hidePreloader();
				if(!myScroller){
					initScroller();
				}else{
					myScroller.refresh();
				}
			}
		});
	}
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		vIscrollHeight = mainHeight - $(_pageId+".tab_nav").outerHeight(true)-2- $(_pageId + ".tip_qs").outerHeight(true);
		$(_pageId + " #wrapper").height(vIscrollHeight);
		var scrollOptions = {
			scrollerHeight: vIscrollHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			probeType: 3,
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: true, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				request_num = 20;
				queryData(); // 模拟查询接口数据操作
				myScroller.options.hasPullUp = true;
				$(_pageId + ".iscroll_pullUp").show();
				$(_pageId + ".no_more_data").hide();
			},
			pullUpHandler: function(){
                // TODO  接口添加上港股通后，判断下一页需要增加港股通持仓是否有下一页
				if($(".left_fixed_table .add").length >= request_num && $(".left_fixed_table .add").length > 0){
					request_num += 20;
					queryPosition(true);
				}else{
					$(_pageId + ".iscroll_pullUp").css('display','none !important');
					if($(".left_fixed_table .add").length > 0){
						$(_pageId + ".no_more_data").show();
					}
				}
			},
			onScrollMove: function(data){
				if(myScroller.y < -248){
					$(_pageId + ".fixed-header").show();
					if($(_pageId + ".tip_qs").css('display') !== 'none'){
						$(_pageId + ".fixed-header").css('top','122px');
					}
				}else{
					$(_pageId + ".fixed-header").hide();
				}
				// console.log(data,myScroller.y);
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	/**
	 * 初始化滑动组件
	 * @param queryFunc 查询函数
	 */
	function initHScroller()
	{
		var scrollOptions = {
			$wrapper: $(_pageId + " #hwrapper"),
			scrollEndHandler:function(){//滚动结束时的处理函数
				$.clearRequest();
				var pagex=myHScroller.getCurPageIdx();
				var dotName="";
				if(pagex==0){
					dotName="人民币";
				}else if(pagex==1){
					dotName="美元";
				}else if(pagex==2){
					dotName="港币";
				}
				$(_pageId + ".j-dot-list em").removeClass("on").eq(pagex).addClass("on");
				common.comStat(100167,2,104,true,{"i_change_name":"资产","i_change_to":dotName});//埋点
				queryPosition(false);
			}
		};
		// 设置滚动内容的宽度
		// 显示左右滑动内容，防止页面闪动
		$(_pageId + " .iscroll_hScroller>div").width($(window).width()).show();
		// 设置 scroller 的宽度
		$(_pageId + " #hscroller").width($(window).width() * 3);
		if(!myHScroller){
			myHScroller = iscrollUtils.hScroller(scrollOptions);
		}

	}
	/**
	 * 初始化横向滑动组件
	 */
	function initRightScroll(){
		if(right_table_scroll){
			right_table_scroll.refresh && right_table_scroll.refresh();
		}else{
			var hasClick = $.device.android?true:false;
			right_table_scroll = new iscroll5(_pageId + '#right_scroll', {
				scrollX: true,
				scrollY: false,
				probeType: 3,
				click:hasClick,
			});
            var fixed_scroll = $(_pageId + "#fixed_scroll");
			right_table_scroll.on('scroll',function(){
				// console.log(right_table_scroll.x);
				//显示隐藏左右小图标
				if (right_table_scroll.x >= 0) {
					$(_pageId + '.left-icon').hide();
					$(_pageId + '.right-icon').show();
				} else if (right_table_scroll.x <= right_table_scroll.maxScrollX) {
					$(_pageId + '.left-icon').show();
					$(_pageId + '.right-icon').hide();
				} else {
					$(_pageId + '.left-icon').show();
					$(_pageId + '.right-icon').show();
					//滚动固定标题
					fixed_scroll[0].scrollLeft = Math.abs(right_table_scroll.x);
				}
			});
            $.bindEvent(fixed_scroll, function(e){
                var scrollLeft = e.target.scrollLeft;
                // console.log(scrollLeft);
                right_table_scroll.scrollTo(-scrollLeft,0);
            },"scroll");
		}
	}

	function destroy(){
        commonFunc.clearCheckTradeTimer();
		if(isDestroy){
			destroy2();
		}
		$(_pageId+".hold_main2 .j-stock-data strong").text("--");
		$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
   		 //字体缩放
		$(_pageId+".j-data-info strong").each(function(idx, item){
		  item = $(item);
		  item.setTransformScale(0);
		});
	}


	/**
	 * 销毁
	 */
	function destroy2(){
		common.pageBuryingPoint();
		if(keyboard){
			keyboard.keyDestroy();
		}
		clearPositionTimer();
		_callback = true;
	    canBuy = 0 ;//可用
	    market_val = 0 ;//市值
		request_num = 20;
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myHScroller){
			myHScroller.destroy();
			myHScroller = null;
		}
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		$(_pageId+'.left_fixed_table tr.tools').remove();
		$(_pageId+'.left_fixed_table tr.add').remove();
		if(right_table_scroll){
			right_table_scroll.destroy();
			right_table_scroll = null;
		}
		$(".fixed-header").hide();

		stockHoldingHeader = [
			{"index":0,"fieldPropName1":"name","fieldPropName2":"code","titleText":"名称/代码"},
			{"index":1,"fieldPropName1":"market_value","fieldPropName2":"market_value_per","titleText":"市值/仓位"},
			{"index":2,"fieldPropName1":"float_yk","fieldPropName2":"float_yk_per","titleText":"盈亏/比例"},
			{"index":3,"fieldPropName1":"cost_amount","fieldPropName2":"enable_amount","titleText":"持有/可用"},
			{"index":4,"fieldPropName1":"cost_price","fieldPropName2":"last_price","titleText":"成本/现价"},
			{"index":5,"fieldPropName1":"av_buy_price","titleText":"买入均价"},
		];
        common.subscribeOff("50243",getStockHoldingHeader);
	}
    function takeScreenshot(){
        nativePluginService.function50106({
            content: "您的手机正在进行截屏，请注意信息保护"
        });
    }

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"takeScreenshot": takeScreenshot,
		"destroy": destroy
	};
	module.exports = base;
});
