/**
 * 普通交易-查询
 */
define('trade/scripts/stock/stockQuery.js', function(require, exports, module) {
	var commonFunc = require("commonFunc");
	var common = require("common");
	var gconfig = $.config; 
    var global = gconfig.global;
	var mainHeight = null;
    var _pageId = "#stock_stockQuery ";

    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("100180");
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),function(pageCode,topage){
			$.pageInit(pageCode,topage,$.getPageParam(),'',true);
		});
        $.setSStorageInfo("trade_query_begin_time",'');
        $.setSStorageInfo("trade_query_end_time",'');
        $.setSStorageInfo("trade_query_search_type",'');
		jumpPageEvent();
		commonFunc.getLiquidationInfo(_pageId); //获取清算状态和清算提示信息
        var userInfo = common.getCurUserInfo();
        if (common.checkGgtPermission(userInfo.fund_account)) {
            $(_pageId+" .tips").show();
        }else{
            $(_pageId+" .tips").hide();
        }
    }
		
	function load(){
		mainHeight = common.setMainHeight(_pageId, false);
		var height_search = mainHeight - $(_pageId+".tab_nav").outerHeight(true) - $(_pageId + ".tip_qs").outerHeight(true);
		$(_pageId+" .main .search_nav").height(height_search-10).css("overflow-y","auto"); //查询目录添加高度
        // 页面高度变化重置滚动容器高度
        window.onresize = function () {
            setTimeout(function(){
                mainHeight = common.setMainHeight(_pageId, false);
                var height_search = mainHeight - $(_pageId+".tab_nav").outerHeight(true) - $(_pageId + ".tip_qs").outerHeight(true);
                $(_pageId+" .main .search_nav").height(height_search-10).css("overflow-y","auto"); //查询目录添加高度
            },20);
        };
	}
	/**
	 * 跳转页面事件
	 * $(this).unbind();
	 * this.click = null;
	 */
	function jumpPageEvent(){
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                var pageObj = $.getCurrentPageObj() || '';
                //埋点
                common.comStat(100190, 2, 103, true, { "i_group_name": "返回" });
                commonFunc.appThirdBack('stock_stockQuery', function () {
                    // 判断是需要返回之前的页面，而不是交易首页
                    if (pageObj && pageObj.param && pageObj.param.param && pageObj.param.param.isGoBack === '1') {
                        $.pageBack("bjs/index", "left");
                    } else {
                        $.pageInit("stock/stockQuery", "account/index", { "history": true }, "left", true);
                    }
                    // $.pageBack();
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        }, "tap");
		
		//查询页面事件跳转
		common.bindStockEvent($(_pageId + ".main .search_nav ul li a"));

		// 请前往“港股通”交易专区
		$.bindEvent($(_pageId + ".j_to_ggt"), function(e){
            $.pageInit("stock/stockQuery","ggt/ggtBuy",{});
		});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		$.pageInit("stock/stockQuery","account/index",{});
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});
