/**
 * Created by sizhe on 2016/10/19.
 */
/**
 * 普通交易-资金明细查询
 */
define('trade/scripts/stock/stockQueryCapitalMoreInfo.js', function(require, exports, module) {
    var common = require("common");
    var commonFunc = require("commonFunc");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_stock = require("service_stock");
    var _pageId = "#stock_stockQueryCapitalMoreInfo ";
    var userInfo = null;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象

    /**
     * 初始化
     */
    function init(){
        userInfo = common.getCurUserInfo();
		common.pageBuryingPoint("100269");
        if(global.requestLocation == 0){
            backgroundInterface();
        }
    }

    function load(){
        if(global.requestLocation == 1){
            backgroundInterface();
        }
        var mianHeight = common.setMainHeight(_pageId, false);
    }
    function backgroundInterface(){
        commonFunc.initTimeChoice(_pageId,6);
        queryCapital();
    }
    /**
     * 事件绑定
     */
    function bindPageEvent(){
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
            setTimeout(function () {
                $(this).unbind(e.type);
                this[e.type] = null;
                //埋点
                common.comStat(100270, 2, 103, true, {"i_group_name": "返回"});
//			$.pageInit("stock/stockQueryHistory","stock/stockQuery",{});
                $.pageBack("stock/stockQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            },300);
        },"tap");
        
        //查询
        $.bindEvent($(_pageId + ".date_filter .btn"), function(e){
            if(!myScroller){
                initScroller();
            }else{
                myScroller.refresh();
            }
            queryCapital();
			//埋点
			var end_time = $(_pageId+" #endDate").text();  
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = begin_time.replaceAll("-", "");
			var time2 = end_time.replaceAll("-", "");
			common.comStat(100271,2,104,true,{"i_change_name":"资金明细查询","i_change_to":time1+"-"+time2});
        });
    }

    /**
     * 委托查询
     */
    function queryCapital(){
        var entrust_way=global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid=userInfo.session_id;
        var end_time = $(_pageId+" #endDate").text();
        var begin_time = $(_pageId+" #startDate").text();
        var time1 = new Date(end_time.replaceAll("-", "/"));
        var time2 = new Date(begin_time.replaceAll("-", "/"));
        if(time1 < time2)
        {
            $.alert("开始日期大于截止日期");
            return false;
        }//截止时间
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "sessionid":sessionid,
            "begin_time":begin_time,
            "end_time":end_time
        };
        $(_pageId+ ".no_data").hide();
        service_stock.queryAccountFlow(param,queryCallback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "errorFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                },
                "timeOutFunc":function(){ // 超时调用方法
                    $(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 委托查询回调
     */
    function queryCallback(data){
        if (typeof(data) != "undefined" && data) {
            $(_pageId+".main .search_table2").html("");
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                var html="";
                if(results.length>0 && results!= "undefined"){
                    for (var i=0;i<results.length;i++){
                        if($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryHTML(results[i]);
                    }
                    $(_pageId+ ".main .fund_flow2").html(html);
                    $(_pageId+ ".no_data").hide();
                }else{
                    $(_pageId+".no_data").show();
                }
            }
            else{
                $.alert(data.error_info);
            }
        }
        else{
            $.alert("查询失败");
        }
        if(!myScroller){
            initScroller();
        }else{
            myScroller.refresh();
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryHTML(element){
        var price_digit = 3;
        var css = "";
        var eleHtml = "";
        eleHtml+='<div class="part"><div class="title">';
        eleHtml+='<span>'+element.business_name+'</span><small class="time">'+element.business_date+'</small>';
        eleHtml+='</div><ul>';
        eleHtml+='<li>证券名称<span>'+element.stock_name+'</span></li>';
        eleHtml+='<li>证券代码<span>'+element.stock_code +'</span></li>';
        eleHtml+='<li>币种名称<span>'+element.money_type_name+'</span></li>';
        eleHtml+='<li style="width: 0;min-width: 50%;display: inline-table;">发生金额<span>'+Number(element.occur_balance).toFixed(price_digit)+'</span></li>';
        eleHtml+='<li>流水序号<span>'+element.serial_no+'</span></li>';
        // eleHtml+='<li>资金余额<span>'+Number(element.post_balance).toFixed(price_digit)+'</span></li>';
        // eleHtml+='<li>发生金额<span>'+Number(element.occur_balance).toFixed(price_digit)+'</span></li>';
        // eleHtml+='<li>股份余额<span>'+Number(element.post_amount).toFixed(price_digit)+'</span></li>';
        eleHtml+='</ul></div>';
        return eleHtml;
    }

    /**
     * 初始化滑动组件
     */
    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId+".top_title").height()- $(_pageId+".date_filter").height() , // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
                queryCapital(); // 模拟查询接口数据操作
            },
            pullUpHandler: function(){
            }
        };
        if(!myScroller)
        {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy(){
		common.pageBuryingPoint();
        $(_pageId+ ".no_data").hide();
        $(_pageId+".search_table2").html("");
        //清空数据
        $(_pageId+ ".main .fund_flow2").html("");
        $(_pageId + ".top_title .top_nav").hide();
        if(myScroller)
        {
            myScroller.destroy();
            myScroller = null;
        }
    }


    var base = {
        "init" : init,
        "load" : load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
