/**
 * 股转系统-大宗交易买卖交易下单
 */
define('trade/scripts/third/agreementOrder.js', function(require, exports, module) {
	var common = require("common");
	var commonHq = require("commonHq");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var service_third = require("service_third");
	var keyboard = require("keyboard");
	var commonTimer = require("commonTimer");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
//  var fifthOrder_timer = null;//五档行情定时器
//  var position_timer = null;
    var _pageId = null;
    var _orderType = null;
    var _PageParam = {};
    var hqData = {};
	var orderName = { // 委托名称
		"1":"限价买入",
		"2":"限价卖出",
		"3":"定价申报买入",
		"4":"定价申报卖出",
		"5":"成交确认买入",
		"6":"成交确认卖出",
		"7":"互报确认买入",
		"8":"互报确认卖出",
		"9":"大宗交易买入",
		"10":"大宗交易卖出",
	};
	var _entrust_bs = {
		"1":"0",
		"2":"1",
		"3":"60",
		"4":"61",
		"5":"2",
		"6":"3",
		"7":"101",
		"8":"102",
		"9":"103",
		"10":"104",
	}
	var _entrust_prop = {
		"1":"3",
		"2":"3",
		"3":"1",
		"4":"1",
		"5":"2",
		"6":"2",
		"7":"4",
		"8":"4",
		"9":"5",
		"10":"5",
	};
    //0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
    var _exchange = {
			"0":"0", "2":"0", "3":"0", "4":"0", "5":"0", "6":"0", "7":"0", "8":"0",
			"1":"1",
			"9":"2", "11":"2", "12":"2", "13":"2", "14":"2", "15":"2", "16":"2",
			"10":"3",
			"17":"4",
			"18":"0", "19":"0", "21":"0", "22":"0", "23":"0", "24":"0", "64":"0",
			"20":"2", "25":"2", "26":"2", "27":"2", "30":"2", "65":"2", "66":"2"
		};
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _queryHolding = false;
	var _initScroller = null;
    var queryStockHqFlowNo;
    
	/**
	 * 设置股票对象是信息参数
	 */
	function ioitStock(){
		var stockInfo = {
			"isHq":false,
	    	"stockCode" : "", // 股票代码
	    	"stockName" : "", // 股票名称
	    	"stockPrice" : "",// 股票价格
	    	"stockNum" : "",
	    	"confer_no" : "", //约定号码 
	    	"target_seat" : "", // 对方席位
	    	"target_stock_account" : "", // 对方股东
	    	"transfer_mode": "",//转让方式
			"upStop" : 0, //涨停价
	    	"downStop" : 0,//跌停价
	    	"stockMaxAmount" : 0,//股票最大数
	    	"price_step" : 0.01, // 步长
			"price_digit" : 2, // 小数点位数
			"lot_size" : 1, //每手数量
			"stock_type" : "",//股票类型
			"stock_market" : "",//市场代码
			"gear_one" : false,//是否启动五档
			"exchange_type" : "",//交易市场（交易后台）
			"stock_account" : "",// 股东账号 
			"delist_info" : "",// 退市提示语
			"delist_flag" : "",//是否提示标示
            "isBond": false,//是否为债券
			"error_no": null,
			"error_info": null,
	    };
	    return stockInfo;
	}
	
	function initHtml(){
		stock_html = {
			"stock_account": $(_pageId + " #account p"),
			"account_ul": $(_pageId + " #account ul"),
	    	"stockCode" : $(_pageId + " #stockCode"), // 股票
	    	"stockName" : $(_pageId + " #stockCode").next("span"), // 股票名称
	    	"stockPrice" : $(_pageId + " #stockPrice"),// 股票价格
	    	"stockNum" : $(_pageId + " #stockNum"), // 股票数量
			"upStop" : $(_pageId + " #up_stop"), //涨停价
	    	"downStop" : $(_pageId + " #down_stop"),//跌停价
	    	"confer_no" : $(_pageId + " #confer_no"), //约定号码 
	    	"target_seat" : $(_pageId + " #target_seat"), // 对方席位
	    	"transfer_mode": $(_pageId + " #transfer_mode"),//转让方式
	    	"target_stock_account" : $(_pageId + " #target_stock_account"), // 对方股东
	    	"stockMaxAmount": $(_pageId + " #stockMaxAmount"),//股票最大数
	    	"buyGear" : $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
		   	"sellGear" : $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
		   	"total" : $(_pageId + ".ce_btn #total"),// 计算金额显示
			"market_ul" : $(_pageId + " #market_list ul"),
			"stockList" : $(_pageId + "#stock_list"),// 股票下拉列表
			"referenList": $(_pageId + ".referen span"),
			"srincomeList": $(_pageId + ".srincome span"),
			"layerLevel": $(_pageId + " #layerLevel"),//层级
			"transferWay": $(_pageId + " #transferWay"),//转让方式
	    	"transfer_state": $(_pageId + " #transfer_state"),//交易状态
		   	"total" : $(_pageId + " #total"),// 计算金额显示
		   	"label_txt" : $(_pageId + " .label_txt"),// 单位显示
		}
	}
	

    /**
     * 数据初始化
     */
	function dataInit(pageId,orderType, initScroller){
		_initScroller = initScroller;
		_PageParam = $.getPageParam() || {};
		_pageId = pageId;
		if(keyboard){
			keyboard.keyInit(null,null,null,_pageId);
		}
		userInfo = common.getCurUserInfo();
		_orderType = orderType;
		stock_info = ioitStock();
		initHtml();
		_stockCode = null;
		commonHq.initCheckTradeTimer();
		setAccountList();
		var stockCode = _PageParam["code"] || _PageParam["stock_code"];
		// 查询个股行情
		if(stockCode){
			$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
			$(_pageId + " #stockCode").quzhi(stockCode);
			var market = _PageParam["market"];
			var exchange_type = _PageParam["exchange_type"];
			var stock_account = _PageParam["stock_account"]
			getStockList(stockCode, market, exchange_type, stock_account);
		}
		//是否需要五档查询
		queryHolding();
		if(global.positionRefreshTime){
			commonTimer.setTimer(_pageId, function(){
				if(commonHq.getTradingTime() && _callback){
					queryHolding(true);
				}
			}, global.positionRefreshTime);//定时刷新
		}
    }
	function setAccountList(){
		commonFunc.getStockAccount(["9","A"], userInfo, function(data){
			if(data && data.length > 0){
				var div = "";
				var floatFX="";
				if(_orderType=="1"||_orderType=="2"){
					floatFX="left";
				}else{
					floatFX="right";
				}
				for(var i = 0; i < data.length; i++){
					div += '<li exchange="'+data[i].exchange_type+'" type="'+data[i].stock_account+'"><a href="javascript:void(0);" style="padding-left:0.20rem;"><strong style="font-size:0.15rem;float:'+floatFX+';">'+data[i].stock_account+'</strong>'+data[i].exchange_type_name+'</a></li>'
				}
				stock_html.account_ul.html(div);
				setStockAccount(_PageParam["stock_account"],_PageParam["exchange_type"]);
				$.bindEvent(stock_html.account_ul.find("li"), function(e){
					common.comStat((isBuy()?101832:101862),2,103,true,{"i_group_name":"切换股东账号"});
					$(_pageId + " .five_box ul li").removeClass("active");
					if(keyboard){
						keyboard.closeKeyPanel();
					}
					var type = $(this).attr("type");
					var exchange = $(this).attr("exchange");
//					if(type != stock_html.stock_account.attr("type"))
					{
						stock_html.stock_account.attr("type",type);
						stock_html.stock_account.attr("exchange",exchange);
						stock_html.stock_account.html($(this).text());
						if(stock_info && stock_info.stockCode){
							stock_info.stock_account = type;
							stock_info.exchange_type = exchange;
							getStockList(stock_info.stockCode,"",exchange, type);
						}
					}
					stock_html.account_ul.hide();
					e.stopPropagation();
				});
				$.bindEvent($(_pageId + " #account"), function(e){
					$(_pageId + " .five_box ul li").removeClass("active");
					if(keyboard){
						keyboard.closeKeyPanel();
					}
					if($(this).find("ul li") && $(this).find("ul li").length > 0){
						$(this).find("ul").slideToggle();
					}
					else{
						$(this).find("ul").hide();
					}
					e.stopPropagation();
				});
			}
			else{
				stock_html.stock_account.html("没有对应的股东账号");
				stock_html.account_ul.hide();
			}
		});
	}
	function setStockAccount(stock_account, exchange_type){
		if(stock_account || exchange_type){
			var ea = stock_html.account_ul.find("li[exchange='"+exchange_type+"'][type='"+stock_account+"']");
			if(!ea || ea.length == 0){
				var a = stock_html.account_ul.find("li[type='"+stock_account+"']");
				ea = a;
				if(!a || a.length == 0){
					var e = stock_html.account_ul.find("li[exchange='"+exchange_type+"']");
					ea = e;
				}
			}
			if(ea && ea.length > 0){
				stock_html.stock_account.attr("type",ea.attr("type"));
				stock_html.stock_account.attr("exchange",ea.attr("exchange"));
				stock_html.stock_account.html(ea.text());
			}
		}
    }
	
	function isBuy(){
		if(_orderType == "1" || _orderType == "3" || _orderType == "5" || _orderType == "7" || _orderType == "9"){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * 获取股票信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			var data = stock_html[param].quzhi();
			if(newest && stock_info){
				if(!data || data == "--"){
					stock_info[param] = 0;
				}
				else
				{
					stock_info[param] = data;
				}
			}
			return data;
		}
		else{
			return '';
		}
	}
	
	/**
	 * 设置股票信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest){
		if(stock_html){
			stock_html[key].quzhi(value);
			if(newest && stock_info){
				if(value == "--"){
					value = 0;
				}
				stock_info[key] = value;
			}
		}
	}

	/**
	 * 
	 * @param {Object} stockPrice
	 */
	function isQueryMax(stockPrice){
		if(stock_info && (isBuy() || !stock_info.exchange_type) && stock_info.stockCode && stockPrice && stockPrice != "0"){
			queryMaxAmount(stock_info.stockCode,true);
		}
	}
	/**
	 * 事件绑定
	 */
	function elementBindEvent(){
		
        $.bindEvent($(_pageId + " .top_title .icon_back"), function (e) {
            $.pageBack();
        });
		
		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");
		
		$.bindEvent($(_pageId+" .trade_form .input_code .input_text"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
//				$(_pageId + " div#stockCode").triggerFastClick();
//				if(global.callNative){
//					$(_pageId + " input#stockCode").focus();
//					keyboard.clickOpenKeyboard($(_pageId + " input#stockCode")[0],_pageId);
//				}
//				else{
					keyboard.clickOpenKeyboard($(_pageId + " div#stockCode")[0],_pageId);
//				}
			}
			else{
				$(_pageId + "#stockCode").triggerFastClick();
				$(_pageId + "#stockCode").focus();
			}
			e.stopPropagation();
		});
		
		$.bindEvent($(_pageId + " #stock_list"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			e.stopPropagation();
		});
		
		if(!keyboard){
			$.bindEvent($(_pageId + "#stockCode"), function(e){
				stock_html.stockList.show();
				e.stopPropagation();
			});
		}
		
		$.bindEvent($(_pageId+" .trade_form .input_code .input_text span"), function(e){//输入时股票代码调键盘
			var click = e.type || "click";
			if(keyboard){
				$(_pageId + " div#stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			else{
				$(_pageId + " #stockCode").triggerFastClick();
				$(_pageId + " #stockCode").focus();
			}
			e.stopPropagation();
		});
		
		// 股票代码输入框监听
		$.bindEvent($(_pageId + "#stockCode"), function(e){ // 该监听方法是为了适配浏览器
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			else{
				var stockCode = $(this).val();
				stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g,"");
				stockCode = $.trim(stockCode);
				$(this).val(stockCode);
			}
			var stockCode = $(_pageId + " #stockCode").val();
			//控制股票代码输入，字母控制4位，数字6位
			if(stockCode.length > 4){
				var vai1 = /^[0-9]+$/;
				if(!vai1.test(stockCode)){
					stockCode = stockCode.substring(0,4);
					$(_pageId + " #stockCode").quzhi(stockCode);
				}
			}
			if(stockCode.length == 0){
				clearBuyMsg();
				$(_pageId + " #stockCode").addClass("C100").removeClass("inputContent");
			}
			else{
				$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
			}
			if(stockCode){
				if(stockCode != _stockCode){
					_stockCode = stockCode;
					clearBuyMsg();
					var vai0 = /^[A-Za-z]+$/;
					var vai1 = /^[\u4e00-\u9fa5]+$/;
					if(stockCode.length > 1 && (vai0.test(stockCode) || vai1.test(stockCode))){ // 当输入的长度大于1 并且为字母的时候
						getStockList(stockCode); // 查询股票列表
					}else if(stockCode.length > 2){ // 当输入的长度大于3的时候
						getStockList(stockCode); // 查询股票列表
					}
				}
			}
			e.stopPropagation();
		},"input");
		
		//数量输入
		$.bindEvent($(_pageId + "#stockNum"),function(e){
			if(keyboard){
				var key = "";
				if(!global.callNative){
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d3" || key == "-12"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d2" || key == "-13"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d1" || key == "-14"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			var stockNum = $(_pageId + "#stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
			e.stopPropagation();
		},"input");
		
		//数量输入埋点
		$.bindEvent($(_pageId + "#stockNum"),function(e){
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				common.comStat((isBuy() ? 101837 : 101867),2,2,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":getStockInfo("stockPrice"), // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":$(_pageId + "#stockNum").val(), // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"blur");
		
		// 价格输入框
		$.bindEvent($(_pageId + "#stockPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			limitingDigit($(this));
			e.stopPropagation();
		},"input");

		//价格输入框失去焦点
		$.bindEvent($(_pageId + "#stockPrice"), function(e){
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = $(_pageId + " #stockPrice").val();
				if(stockPrice != 0){
					if(stockPrice != ""){
						stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
						setStockInfo("stockPrice",stockPrice);
					}
	//				else{
	//					stockPrice = Number(stockPrice).toFixed(stock_info.price_digit);
	//				}
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
					
					//埋点
					if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
						common.comStat((isBuy()?101836:101866),2,1,false,{
							"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
							"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
							"i_exchange_type":stock_info.exchange_type, // 交易市场
							"i_stock_code":stock_info.stockCode, // 股票代码
							"i_stock_name":stock_info.stockName, // 股票名称
							"i_price":stockPrice, // 选择后的价格
							"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
						});
					}
				}
			}
			e.stopPropagation();
		},"blur");
		
		// 增加价格
		$.bindEvent($(_pageId + " .input_value .add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",0);
					return false;
				}
				stockPrice = Number(stockPrice);  
				if(stockPrice >= 0 && stockPrice < 999999999){
					stockPrice = (parseFloat(stockPrice)+parseFloat(stock_info.price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					common.comStat((isBuy() ? 101834 : 101864),2,1,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"1", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 减少价格
		$.bindEvent($(_pageId + " .input_value .less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = getStockInfo("stockPrice");
				if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
					setStockInfo("stockPrice",0);
					return false;
				}
				var price_step = stock_info.price_step;
				stockPrice = Number(stockPrice);
				if(stockPrice - price_step >= 0){
					stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
					setStockInfo("stockPrice",stockPrice);
					totalValue(stockPrice,stockNum);
					isQueryMax(stockPrice);
				}
				
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					common.comStat((isBuy() ? 101835 : 101865),2,1,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"2", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}else{
				$.alert("请输入正确的证券代码/简拼");
			}
			e.stopPropagation();
		});
		
		// 增加数量
		$.bindEvent($(_pageId + " .input_num .add"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum") || "0";
				if(!stockNum || !validatorUtil.isNumeric(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum) + stock_info.lot_size;
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
			}else{
				$.alert("请先输入股票代码");
			}
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"1", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
				});
			}
			e.stopPropagation();
		});
		
		// 减少数量
		$.bindEvent($(_pageId + " .input_num .less"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				var stockNum = getStockInfo("stockNum") || "0";
				if(!stockNum || !validatorUtil.isNumeric(stockNum)){
					setStockInfo("stockNum",0);
					return false;
				}
				stockNum = Number(stockNum) - stock_info.lot_size;
				if(stockNum < 0){
					stockNum = 0;
				}
				setStockInfo("stockNum",stockNum);
				totalValue(stockPrice,stockNum);
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					var objectId = $(this).attr("objectId");
					var actionId = $(this).attr("actionId");
					common.comStat(objectId,2,actionId,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"2", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}else{
				$.alert("请先输入股票代码");
			}
		});
		
		// 全部
		$.bindEvent($(_pageId + " #stockNum").nextAll("a.btn"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				var stockPrice = getStockInfo("stockPrice");
				setStockInfo("stockNum",stock_info.stockMaxAmount);
				totalValue(stockPrice,stock_info.stockMaxAmount);
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					common.comStat((isBuy() ? 101838 : 101868),2,2,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"3", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
						"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
						"i_target_cnt":$(_pageId + "#stockNum").val(), // 调整之后的数量
						"i_fast_btn":"全部", // 快捷键（全仓，1/2，1/4 ....（可留空））
					});
				}
			}else{
				$.alert("请先输入股票代码");
			}
			e.stopPropagation();
		});
		
		// 五档买卖盘联动
		$.bindEvent($(_pageId + ".five_box ul li"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).find("span").text();
			if(curPrice && curPrice != "--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",curPrice);			
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice,stockNum);
				isQueryMax(stockPrice);
			}
			e.stopPropagation();
		});
		// 下单
		$.bindEvent($(_pageId + "#submitOrder"),function(e){
			//埋点
			common.comStat((isBuy()?"101842":"101872"),2,103,true,{"i_group_name": (isBuy()?"大宗交易买入":"大宗交易卖出")});
			vailSubmitOrder();
		});
		
		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + ".five_box ul li").removeClass("active");
			if(stock_html){
				stock_html.stockList.hide();
				stock_html.market_ul.hide();
			}
			e.stopPropagation();
		});
		
		// 刷新（持仓、五档、股东账号）股东账号数据、行情数据、当日委托数据、最大可买卖数
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			commonFunc.setStockAccount(userInfo,function(){
				setAccountList();
			});
			queryHolding();
			if(stock_info.stockCode){
				getStockList(stock_info.stockCode, stock_info.stock_market, stock_info.exchange_type, stock_info.stock_account);
			}
			e.stopPropagation();
		});
		
		//约定号码
		$.bindEvent($(_pageId + "#confer_no"),function(e){
			common.comStat(isBuy()?101839:101869,2,103,true,{"i_group_name":"约定号码"});
			e.stopPropagation();
		},"blur");
		//对方席位
		$.bindEvent($(_pageId + "#target_seat"),function(e){
			common.comStat(isBuy()?101840:101870,2,103,true,{"i_group_name":"对方席位"});
			e.stopPropagation();
		},"blur");
		//对方股东
		$.bindEvent($(_pageId + "#target_stock_account"),function(e){
			common.comStat(isBuy()?101841:101871,2,103,true,{"i_group_name":"对方股东"});
			e.stopPropagation();
		},"blur");
	}
	
	/**
	 * 限制小数点位数
	 * @param {Object} price
	 */
	function limitingDigit($this){
		var price_digit = stock_info.price_digit;
		var price = getStockInfo("stockPrice");
		if(price && validatorUtil.isNumberFloat(price)){
			var cur_arr = (price+"").split(".");
			if(cur_arr.length == 2){
				if(cur_arr[1].length > price_digit){
					var price = cur_arr[0]+"."+cur_arr[1].substring(0,price_digit);
					setStockInfo("stockPrice",price)
				}
			}
		}
	}
	
	//行情列表接口有问题是，输入股票是6位数时直接调用交易接口
	function queryData(stockCode,exchange_type, stock_account){
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			queryMaxAmount(stockCode, false, exchange_type, stock_account);
		}
	}
	
	//对行情接口返回数据进行处理
	function ListData(data){
		stock_html.stockList.html("");
		stock_info.isHq = true;
		var price = data[4] ? data[4]:data[5];
		price = Number(price);
		var stockVal = data[0]; //证券代码
		var stkType = data[2];
		stock_info.stock_market = data[3];
		stock_info.stock_type = stkType;
		
        bondJudgment();
        if(stock_info.isBond){
            stock_html.label_txt.html("张");
			stock_info.price_step = 0.001;
			stock_info.price_digit = 3;
        }else{
            stock_html.label_txt.html("股");
			stock_info.price_step = 0.01;
			stock_info.price_digit = 2;
        }
		var typeObj = commonHq.getHqtypeData(stockVal,stkType);
		
		$(_pageId + " p.limit em").text(typeObj.unit_name);
		$(_pageId + " .input_num .input_text em").text(typeObj.unit_name);
		
		var code3 = (data[0]+"").substring(0,3);
		var price_digit = stock_info.price_digit;
			
		$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
		setStockInfo("stockCode",stockVal,true);
		_stockCode = stockVal;
		setStockInfo("stockName",data[1],true); // 证券现价
		
		if(data[8] == "1"){
			$.hidePreloader();
			$.alert("该股票正处于停牌阶段，请关注具体复牌时间，了解公司股票恢复交易的信息。");
		}
		var p_price = _PageParam["price"] || _PageParam["entrust_price"];
		if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
			price  = Number(p_price);
		}
		setStockInfo("stockPrice",price.toFixed(price_digit)); // 证券现价
		setStockInfo("upStop",(data[6]).toFixed(price_digit),true); // 证券现价
		setStockInfo("downStop",(data[7]).toFixed(price_digit),true); // 证券现价
		
		commonHq.getThirdNowPrice(data[3]+":"+stockVal,function(results){
			if(stock_html){
                var second_type = results[16];
				//股转分层标签
				var wjc = results[12];
				var wjcMap = {"0":"其它","1":"基础","2":"创新","3":"京A"};
				if(wjc && wjcMap[wjc]){
					stock_html.layerLevel.show();
					stock_html.layerLevel.find("b").text(wjcMap[wjc]);
				}
				//转让类型标签
				var transferTypeMap = {"T":"协议","M":"做市","B":"连续","C":"集合","O":"其他",};
				if(results[15] && transferTypeMap[results[15]]){
					stock_info.transfer_mode = results[15];
					stock_html.transferWay.show();
					stock_html.transferWay.find("b").text(transferTypeMap[results[15]]);
				}
                if(second_type === "BKZ"){
					stock_html.layerLevel.show();
					stock_html.layerLevel.find("b").text("京债");
                    stock_html.label_txt.html("张");
                    stock_info.price_step = 0.001;
                    stock_info.price_digit = 3;
                    price_digit = stock_info.price_digit;
                }else if(second_type === "GKZ"){
					stock_html.layerLevel.show();
					stock_html.layerLevel.find("b").text("股转");
                    stock_html.label_txt.html("张");
                    stock_info.price_step = 0.001;
                    stock_info.price_digit = 3;
                    price_digit = stock_info.price_digit;
                }
                setStockInfo("stockPrice",price.toFixed(price_digit)); // 证券现价
				// labelNameCss();
				//交易状态
				if(results[11] == "T"){
					stock_html.transfer_state.val("允许大宗交易");
				}
				else if(results[11] == "F"){
					stock_html.transfer_state.val("不允许大宗交易");
				}
								
				if(stock_html.srincomeList){
					stock_html.srincomeList.eq(0).text($.transferText(results[13],price_digit));
					stock_html.srincomeList.eq(1).text($.transferText(results[5],price_digit));
					stock_html.srincomeList.eq(2).text($.transferText(results[14],price_digit));
				}
				if(stock_html.referenList){
					stock_html.referenList.eq(0).text((results[4]).toFixed(price_digit));
					var reference = null;
					if(results[2] == "41"){//两网级退市B股（3位小数）的股票类型是41
						reference = Number(results[8]).toFixed(3);
					}else{
						reference = Number(results[8]).toFixed(2);
					}
					if(results[15] == "C"){
						stock_html.referenList.eq(1).text(reference);
						stock_html.referenList.eq(2).text(results[9]);
						stock_html.referenList.eq(3).text(results[10]);
					}
					else if(code3 == "400" || code3 == "430"){
						stock_html.referenList.eq(1).text(reference);
					}
				}
			}
		});
		
		if(_orderType == 1 || _orderType == 2 || _orderType == 3 || _orderType == 4){
			stock_info.gear_one = true;
			setFifthOrder();
			_fifthCallback = false;
			
			commonTimer.setTimer(_pageId+"Hqwd", function(){
				if(commonHq.getTradingTime() && _fifthCallback){
					setFifthOrder();
					_fifthCallback = false;
				}
			}, (global.refreshTime || 5000));//定时刷新
		}
		
		
		//股票联动,查询股票信息，最大可买
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		queryMaxAmount(stockVal);
	}
	
	/**
	 * 通过输入的字符查询出对应的股票列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(stockCode,market,exchange_type, stock_account){
		if(stockCode != ""){
			var param = {
				"stockCode": stockCode,
				"type":"17:31:32:33:34:35:36:37:38:39:40:41:42",
				"market": market,
				"exchange_type": exchange_type,
				"stock_account": stock_account,
			};
            $.clearRequest();
//			setTimeout(function(){
//				if(queryStockHqFlowNo && queryStockHqFlowNo.length > 0){
//					window.clearNativeRequestCallback(queryStockHqFlowNo);
//				}
				commonHq.getThirdStockList(param,stock_html.stockList,
					function(data){
						ListData(data,param);
					},
					function(data){
						stock_info.stockCode = data.stockCode;
						queryData(data.stockCode, data.exchange_type, data.stock_account);
					}
				);
//			},0);
		}
	}
	
	//五档买卖盘
	function setFifthOrder(){
		var market = stock_info.stock_market, stockCode = stock_info.stockCode;
		if(market && stockCode){
			var stock_list = market+":"+stockCode
			var price_digit = stock_info.price_digit;
			commonHq.getThirdNowPrice(stock_list,function(data){
				setStockInfo("upStop",(data[6]).toFixed(price_digit),true); // 证券现价
				setStockInfo("downStop",(data[7]).toFixed(price_digit),true); // 证券现价
				if(stock_html){
					stock_html.referenList.eq(0).text((data[4]).toFixed(price_digit));
					var reference = null;
					if(data[2] == "41"){//两网级退市B股（3位小数）的股票类型是41
						reference = Number(data[8]).toFixed(3);
					}else{
						reference = Number(data[8]).toFixed(2);
					}
					var code = (data[0]+"").substring(0,3);
					if(data[15] == "C"){
						stock_html.referenList.eq(1).text(reference);
						stock_html.referenList.eq(2).text(data[9]);
						stock_html.referenList.eq(3).text(data[10]);
					}
					else if(code == "400" || code == "430"){
						stock_html.referenList.eq(1).text(reference);
					}
				}
			});
			commonHq.getFifthOrder(stock_list,function(results){
				_fifthCallback = true;
				var yesProfit = results[26];
				if(stock_info.gear_one){
					var fifthOne = "";
					var presentPrice = results[30];
					if(isBuy()){
						fifthOne = results[10] || results[16];
					}else{
						fifthOne = results[16] || results[10];
					}
					if(presentPrice != 0 && (fifthOne == 0 || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)){
						fifthOne = presentPrice;
					}
					fifthOne = Number(fifthOne).toFixed(price_digit);
					var p_price = _PageParam["price"] || _PageParam["entrust_price"];
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						fifthOne  = Number(p_price).toFixed(price_digit);
					}
					setStockInfo("stockPrice",fifthOne); // 证券现价
					stock_info.gear_one = false;
				}
				//卖五档盘颜色集合
				for(var i = 0 ; i < 5 ; i ++){
					addColor(stock_html.buyGear.eq(i),results[16+i],yesProfit,results[21+i],price_digit);
					addColor(stock_html.sellGear.eq(i),results[6+i],yesProfit,results[11+i],price_digit);
				}
	
			},function(){
				_fifthCallback = true;
			});
		}
	}
	
	
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div,price,yesProfit,num,price_digit){
		var prices = div.find("span");
		var nums = div.find("em");
		yesProfit = Number(yesProfit).toFixed(price_digit);
		yesProfit = Number(yesProfit);
		price = Number(price).toFixed(price_digit);
		if(Number(price) == 0){
			prices.text("--").attr("class","");
		}
		else if(Number(price) > Number(yesProfit)){
			prices.text(price).attr("class","ared");
		}
		else if(Number(price) < Number(yesProfit))
		{
			prices.text(price).attr("class","agreen");
		}
		else
		{
			prices.text(price).attr("class","");
		}
		if(num == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(num >= 100000){
			nums.text((num * 0.0001).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}
	
	
	/**
	 * 查询买入可用资金最大可买可卖数量
	 * */
	function queryMaxAmount(stockCode,isMax, exchange, account){
		stock_html.stockList.html("");
		$.hidePreloader();
		var stock_price = getStockInfo("stockPrice");
		var entrust_prop = _entrust_prop[_orderType];
		var entrust_bs = _entrust_bs[_orderType];
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = stockCode;
		var entrust_price = stock_price;
		var stock_account = account || stock_html.stock_account.attr("type") || stock_info.stock_account;
		var exchange_type = exchange || stock_info.exchange_type || _exchange[stock_info.stock_type+""];
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"entrust_bs":entrust_bs,
				"stock_code":stock_code,
				"entrust_price":entrust_price,
                "bjs_flag":'0',
				"stock_account": stock_account,
	            "newstock_flag":"",
	            "exchange_type":exchange_type,
	            "entrust_prop":entrust_prop
			};
		service_third.querythirdMaxBuy(param,function(data){
  	  		stock_info.error_no = data.error_no;
  	  		stock_info.error_info = data.error_info;
			$.hidePreloader();
	  	  	if(isMax){
		  	  	queryMaxAmountCallBackMax(data);
	  	  	}else{
	  	  		queryMaxAmountCallBack(data);
	  	  	}
	  	  	_PageParam = {};
	  	  },{"isLastReq":true,"isShowWait":true});
		
	}
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length == 1){
				stock_html.stockList.html("");
				var stock_code = results[0].stock_code;
                var stock_type = results[0].stock_type;
                var convertible_bonds = results[0].convertible_bonds;
                // 步长使用柜台返回的数据
                if(results[0].price_step){
                    stock_info.price_step = ((+results[0].price_step) / 1000);
                }
                if(convertible_bonds === "1" && stock_type === "22"){
                    stock_html.label_txt.html("张");
                    stock_info.price_digit = 3;
                }else if(convertible_bonds === "1" && stock_type === "24"){
                    stock_html.label_txt.html("张");
                    stock_info.price_digit = 3;
                }
				var price_digit = stock_info.price_digit;
				if(!stock_info.isHq){
					$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
					setStockInfo("stockCode",stock_code,true);
					setStockInfo("stockName",results[0].stock_name,true);
					var p_price = _PageParam["price"] || _PageParam["entrust_price"];
					if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
						results[0].price = p_price
					}
					setStockInfo("stockPrice",Number(results[0].price).toFixed(price_digit));
					if(exchange_type == 0 || exchange_type == 1)
					{
						stock_info.stock_market = "SZ";
					}
					else if(exchange_type == 2 || exchange_type == 3)
					{
						stock_info.stock_market = "SH";
					}
				}
				var max_amount="";
				if(results[0].stock_max_amount==""){
					max_amount="--";
				}else{
					max_amount=Number(results[0].stock_max_amount);
				}
				setStockInfo("stockMaxAmount",max_amount,true);
				var maxL = stock_html.stockMaxAmount.parent("label");
				if(maxL && maxL.length > 0){
					stock_html.stockNum.setPlaceholder(maxL.text());
				}
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
				setStockAccount(stock_info.stock_account,stock_info.exchange_type);
				var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
				if(buy_unit != 0){
					stock_info.lot_size = buy_unit;
				}
				stock_info.delist_flag = results[0].delist_flag;
				stock_info.delist_info = results[0].delist_info;
				var p_num = _PageParam["num"] || _PageParam["orderamount"];
				if(p_num && p_num != 0 && validatorUtil.isNumeric(p_num)){
					setStockInfo("stockNum",p_num,true);
				}
	    	 	// 约定号码
				var confer_no = _PageParam["confer_no"] || _PageParam["confernum"];
				if(confer_no){
					setStockInfo("confer_no",confer_no,true);
				}
				// 对方席位
				var target_seat = _PageParam["target_seat"] || _PageParam["seat"];
				if(target_seat){
					setStockInfo("target_seat",target_seat,true);
				}
				// 对方股东
				var target_stock_account = _PageParam["target_stock_account"];
				if(target_stock_account){
					setStockInfo("target_stock_account",target_stock_account,true);
				}
				setStockInfo("transfer_mode",results[0].stbtrans_type_name);
				if(results[0].stbtrans_information){
					$.alert(results[0].stbtrans_information);
				}
				if(global.serverConfig == 3){
					if(_orderType == "5" || _orderType == "6" || _orderType == "9" || _orderType == "10"){
						queryHqInfo(stock_code);
						$(_pageId+' .fund_table').show();
					}
				}
			}
			else if(results.length > 1){
				$.hidePreloader();
				var selectHeight = 0.4*results.length;
				if(results.length >= 7){
					selectHeight = 7 * 0.4;
				}
				var listHtml = "<ul style=\"position:relative;display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
				for(var i = 0;i < results.length; i++) {
					listHtml += "<li stock_name="+results[i].stock_name+"><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\">"+results[i].stock_code+"</strong><em>"+results[i].stock_name+"</em></a>";
					listHtml +=	"<span style=\"display:none;\">"+results[i].exchange_type+"</span></li>";
				};
				listHtml+="</ul>";
				stock_html.stockList.html(listHtml).show();
				$.bindEvent($(_pageId + " .trade_form .select_box ul li"),function(e){
					var exchange_type = $(this).find("span").text();
					stock_info.exchange_type = exchange_type;
					var stockCode = $(this).find("strong").text();
					stock_html.stockList.html("");
					queryData(stockCode,exchange_type);
					setStockInfo("stockName",$(this).find("em").text(),true);
					//埋点
					common.comStat((isBuy()?101833:101863),2,104,true,{"i_change_name":"股票输入","i_change_to":$(this).attr("stock_name")});
					e.stopPropagation();
				});
			}
		}else{
			$.alert(data.error_info);
		}
	}
	function queryMaxAmountCallBackMax(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length>0){
				var price_digit = stock_info.price_digit;
				var max_amount="";
				if(results[0].stock_max_amount==""){
					max_amount="--";
				}else{
					max_amount=Number(results[0].stock_max_amount);
				}
				setStockInfo("stockMaxAmount",max_amount,true);
				var maxL = stock_html.stockMaxAmount.parent("label");
				if(maxL && maxL.length > 0){
					stock_html.stockNum.setPlaceholder(maxL.text());
				}
				var exchange_type = results[0].exchange_type;
				stock_info.exchange_type = exchange_type;
				stock_info.stock_account = results[0].stock_account;
				setStockAccount(stock_info.stock_account,stock_info.exchange_type);
				var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
				if(buy_unit != 0){
					stock_info.lot_size = buy_unit;
				}
				stock_info.delist_flag = results[0].delist_flag;
				stock_info.delist_info = results[0].delist_info;
				setStockInfo("transfer_mode",results[0].stbtrans_type_name);
				if(results[0].stbtrans_information){
					$.alert(results[0].stbtrans_information);
				}
			}
		}
		else{
			$.alert(data.error_info);
		}
	}
	
	// 计算当前总值
	function totalValue(stockPrice,stockNum){
		if(stock_html){
			stock_html.total.text("").hide();
		}
		if(validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			if(stock_info.stock_type !== "" && stock_info.stockCode){
				var amount = commonHq.calculateStockAmountNew(stockPrice,stockNum,stock_info.stock_type,stock_info.stockCode);
				var text = "(¥"+$.formatMoney(""+amount)+")";
				stock_html.total.text(text).show();
			}
		}
	}
    /*
    * 关于债券的判断
    */
    function bondJudgment() {
        switch (stock_info.stock_type) {
            case 6:
            case 21:
            case 22:
            case 23:
            case 24:
            case 14:
            case 25:
            case 26:
            case 27:
            case 30:
                stock_info.isBond = true;
                break;
        }
    }
	
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		
		var typeText = "买入";
		if(!isBuy()){
			typeText = "卖出";
		}
		//验证股票代码输入是否正确
		var stockCode = stock_info.stockCode;
		if(stockCode.length == 0){
			$.alert("请输入正确的证券代码/简拼");
			return false;
		}	
		var vai1 = /^[0-9]{6}$/;
		if(!vai1.test(stockCode)){
			$.alert("股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length<=0){
			$.alert("请输入"+typeText+"价格");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockPrice)){
			$.alert("请正确输入价格");
			return false;
		}
		else if(parseFloat(stockPrice)<=0){
			$.alert("价格必须大于0");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount+"";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length<=0){
			$.alert("请输入"+typeText+"数量");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockNum)){
			$.alert("请正确输入数量");
			return false;
		}
		else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
		if(stock_info.error_no !== "0" && stock_info.error_no !== 0){
			$.alert(stock_info.error_info || "查询证券信息失败");
			return false;
		}
		var ts = "";
		//验证最大可买
		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
//			$.alert("最大可"+typeText+"为0");
			ts += "<em>最大可"+typeText+"为0；</em>";
//			return false;
		}
		else if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
//			$.alert("最大可"+typeText+"数量不足");
			ts += "<em>最大可"+typeText+"数量不足；</em>";
//			return false;
		}
		var lots_of = stock_info.lot_size;
		if(isBuy()){
			if(stockNum % Number(lots_of) != 0){
//				$.alert("买入数量应为" + lots_of + "的倍数");
				if(_orderType!="9"){
					ts += "<em>买入数量应为" + lots_of + "的整数倍；</em>";
				}
//				return false;
			}
// 			else if(stockNum > 1000000){
// //				$.alert("买入数量必须小于或等于100万股");
// 				ts += "<em>买入数量必须小于或等于100万股；</em>";
// //				return false;
// 			}
		}else{
			if(stockNum != stockMaxAmount && stockNum % Number(lots_of) != 0){
//				$.alert("卖出数量应为" + lots_of + "的倍数");
				if(_orderType!="10"){
					ts += "<em>卖出数量应为" + lots_of + "的整数倍；</em>";
				}
//				return false;
			}
		}
		
		var	up_stop = stock_info.upStop;
		var	down_stop = stock_info.downStop;
		var ywmc = $(_pageId + " #transfer_mode").quzhi();
		if(!ywmc || ywmc == "null" || ywmc == "--"){
			ywmc = "";
		}
		var tipStrArray = [];
		tipStrArray.push(["股东账号", stock_info.stock_account]);
		tipStrArray.push(["证券代码", stockCode]);
		tipStrArray.push(["证券名称", stock_info.stockName]);
		tipStrArray.push(["业务名称", ywmc+orderName[_orderType]]);
		tipStrArray.push(["委托价格", stockPrice]);
		tipStrArray.push(["委托数量", stockNum]);
		
		var confer_no = $.trim(getStockInfo("confer_no")); //约定号码 
		if(stock_html && stock_html.confer_no.length != 0){
			if(confer_no.length<=0){
				$.alert("请输入约定号码");
				return false;
			}
			if(_orderType == "5" || _orderType == "6"){
				if(!Number(confer_no) || Number(confer_no) < 1000000 || Number(confer_no) >= 99999999){
					ts += "<em>您的约定号不满足“大于等于100万且小于99999999”的要求；</em>";
				}
			}
			else if(!Number(confer_no) || Number(confer_no) <= 0 || Number(confer_no) >= 1000000){
				ts += "<em>您的约定号不满足“大于0且小于100万”的要求；</em>";
			}
			tipStrArray.push(["约定号码", confer_no]);
		}
    	var target_seat = getStockInfo("target_seat"); // 对方席位
    	if(stock_html && stock_html.target_seat.length != 0){
			if($.trim(target_seat).length<=0){
				$.alert("请输入对方席位");
				return false;
			}
			tipStrArray.push(["对方席位", target_seat]);
		}
    	var target_stock_account = getStockInfo("target_stock_account"); // 对方股东
    	if(stock_html && stock_html.target_stock_account.length != 0){
			if($.trim(target_stock_account).length<=0){
				$.alert("请输入对方股东");
				return false;
			}
			tipStrArray.push(["对方股东", target_stock_account]);
		}
		if(up_stop && up_stop !="--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)){
			ts += "<em>委托价格超过涨停价；</em>";
		}else if(down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)){
			ts += "<em>委托价格低于跌停价；</em>";
		}
		var tipStr = "<div ><p>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
		tipStr += common.generatePrompt(tipStrArray);
		if(ts){
			tipStr += "<div class='_reminder'><span class='b'>温馨提示：</span><span class='w'>"+ts+"</span></div>";
		}
		tipStr+="</div>";
		
		//埋点数据
		var comStatParam={
			"i_entrust_bs":isBuy() ? "1" : "2", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":stockCode, // 股票代码
			"i_stock_name":stock_info.stockName, // 股票名称
			"i_entrust_prop":_entrust_bs[_orderType], // 委托属性
			"i_exchange_type":stock_info.exchange_type, // 交易市场
			"i_entrust_price":stockPrice, // 选择后的价格
			"i_entrust_amount":stockNum, // 委托数量
		}
		
		common.iConfirm("下单确认",tipStr,function success(){
			var entrust_bs = _entrust_bs[_orderType];
			var entrust_prop = _entrust_prop[_orderType];
			var cust_code = userInfo.cust_code;	//客户代码
			var fund_account = userInfo.fund_account;	//资产账户
			var branch_no = userInfo.branch_no;	//分支机构
			var session_id = userInfo.session_id;
			var entrust_way = global.entrust_way; // 委托方式  在configuration配置
			var exchange_type = stock_info.exchange_type;
			var stock_account = stock_info.stock_account;
			var stock_code = stockCode;
			var entrust_price = stockPrice;
			var entrust_amount = stockNum;
			var param = {
					"entrust_way":entrust_way,
					"branch_no":branch_no,
					"fund_account":fund_account,
					"cust_code":cust_code,
					"session_id":session_id,
					"entrust_bs":entrust_bs,
					"exchange_type":exchange_type,
					"stock_account":stock_account,
					"stock_code":stock_code,
					"entrust_price":entrust_price,
					"entrust_amount":entrust_amount,
					"entrust_prop":entrust_prop,
					"confer_no" : confer_no, //约定号码 
			    	"oppo_seatno" : target_seat, // 对方席位
			    	"oppo_stkaccount" : target_stock_account, // 对方股东
				};
			service_third.getthirdBuy(param,getStockBuyCallBack,{"isShowOverLay":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
			$.showPreloaders("请等待...");
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
			common.comStat((isBuy() ? "101843" : "101873"),2,3,false,comStatParam);
		},function fail(){
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
			common.comStat((isBuy() ? "101843" : "101873"),2,3,false,comStatParam);
		});
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].ordersno;
				$.alert(tipStr);
				clearBuyMsg();
				setStockInfo("stockCode","");// 股票价格
				$(_pageId + " #stockCode").addClass("C100").removeClass("inputContent");
			}
			queryHolding();
		}else{
			$.alert(data.error_info);
			setStockInfo("stockNum","",true); // 证券数量
			stock_html.total.text("").hide();
//			clearBuyMsg();
//			setStockInfo("stockCode","");// 证券价格
//			$(_pageId + " #stockCode").addClass("C100").removeClass("inputContent");
		}
	}
	
	/**
	 * 查询持仓数据
	 */
	function queryHolding(isShowWait){
		if( _orderType == "1" || _orderType == "2" ||  _orderType == "3" || _orderType == "4"){
			queryHoldings1(isShowWait);
		}
		else if(_orderType == "5" || _orderType == "6" || _orderType == "9" || _orderType == "10"){
			if(global.serverConfig != 3){
				queryHqInfo("",isShowWait);
			}
		}
	}
	
	/**
	 * 查询
	 *
	 */
	function queryHqInfo(stock_code,isShowWait) {
		var entrust_way= global.entrust_way;
		var branch_no = userInfo.branch_no;
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;
		var session_id = userInfo.session_id;
		var stock_code = stock_code;
		var entrust_bs = "";
		var param={
			"entrust_way":entrust_way,
			"branch_no":branch_no,
			"fund_account":fund_account,
			"cust_code":cust_code,
			"session_id":session_id,
			"stock_code":stock_code,
            "bjs_flag": "0",
			"entrust_bs":entrust_bs
		};
		service_third.queryConfirmEntrust(param,queryQhCallBack,{"isLastReq":true,"isShowWait":isShowWait?false:true,"isShowOverLay":false});
	}

	function queryQhCallBack(data) {
		var dataHq = [];
		_callback = true;
		$(_pageId+' .fund_table .ce_table tr.add').remove();
		common.setNoData(true,"暂无记录");
		if (data){
			if(data.error_no == 0){
				var results = data.results;
				if(results.length>0 && results!= "undefined"){
					dataHq = results;
					var html = "<tr class='trTop'><th scope='col'>名称/代码</th><th scope='col'>数量/价格</th><th scope='col'>约定/席位</th><th scope='col'>买卖/状态</th></tr>";
					for (var i=0;i<results.length;i++){
						html += queryHTML(results[i],i);
					}
					$(_pageId+" .fund_table table.ce_table").html(html);
					$(_pageId+ " .no_data").hide();
					common.setNoData(false);
					//卖出事件
					$.bindEvent($(_pageId+" .fund_table .ce_table tr.add"), function(e){
						clearBuyMsg();// 清楚数据
						var id = $(this).attr("id");
						_PageParam = dataHq[id];
						
						var p_price = _PageParam["price"] || _PageParam["entrust_price"];
						if(p_price && p_price != 0 && validatorUtil.isNumberFloat(p_price)){
							setStockInfo("stockPrice",Number(p_price).toFixed(stock_info.price_digit));
						}
					
						// 约定号码
						var confer_no = _PageParam["confer_no"] || _PageParam["confernum"];
						if(confer_no){
							setStockInfo("confer_no",confer_no,true);
						}
						// 对方席位
						var target_seat = _PageParam["target_seat"] || _PageParam["seat"];
						if(target_seat){
							setStockInfo("target_seat",target_seat,true);
						}
						// 对方股东
						var target_stock_account = _PageParam["target_stock_account"];
						if(target_stock_account){
							setStockInfo("target_stock_account",target_stock_account,true);
						}
						setStockAccount(_PageParam["stock_account"],_PageParam["exchange_type"]);
						var stockCode = _PageParam.stock_code;
						$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
						$(_pageId + " #stockCode").quzhi(stockCode);
						_stockCode = stockCode;
						getStockList(stockCode);
//						$(_pageId + " .main").scrollTop(0);
						e.stopPropagation();
					}, "tap");
				}else{
					common.setNoData(true,"暂无记录");
				}
			}
			else{
//				$.alert(data.error_info);
			}
		}
		_queryHolding = true;
		if(_initScroller){
			_initScroller();
		}
	}
	
	
	function queryHTML(element,i) {
	   	var eleHtml = "";
        eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" id=\""+i +"\">";
        eleHtml+="<td><span>"+element.stock_name +"</span><span>"+element.stock_code +"</span></td>";
        eleHtml+="<td><span>"+element.entrust_amount+"</span><span>"+element.entrust_price+"</span></td>";
        eleHtml+="<td><span>"+element.confer_no+"</span><span>"+element.oppo_seatno+"</span></td>";
        eleHtml+="<td><span>"+element.entrust_name+"</span><span>"+element.entrust_state_name+"</span></td>";
      	eleHtml+="</tr>";
        return eleHtml;
	}
	
	var zrMap = {"T":"协议转让","M":"做市转让","B":"集合/连续竞价转让","C":"集合竞价转让","O":"其他"}, cjMap = {"0":"其它层","1":"基础层","2":"创新层"};
	function getStockNowPriceCallBack(data){
		hqData = data || {};
		$.each(hqData,function(key,value){
			var zr = zrMap[""+value[5]] || "--";
			var cj = cjMap[""+value[4]] || "--";
			var datr = $(_pageId+'.fund_table .ce_table tr.add[type="'+key+'"]').find("td").eq(4);
			datr.find("span").eq(0).text(zr);
			datr.find("span").eq(1).text(cj);
		})
		if(_initScroller){
			_initScroller();
		}
	}
	
	/**
	 * 查询持仓数据
	 */
	function queryHoldings1(isShowWait){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var stock_account ="";
		var stock_code = "";
		var exchange_type = "";
		var param={
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"stock_account":stock_account,
				"stock_code":stock_code,
				"exchange_type":exchange_type,
		};
		service_third.querythirdData(param,queryHoldingCallback,{"isLastReq":true,"isShowWait":isShowWait?false:true,"isShowOverLay":false});
	}
	
	function queryHoldingCallback(data){
		_callback = true;
		$(_pageId+'.fund_table .ce_table tr.add').remove();
		common.setNoData(true,"暂无持仓记录");
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					var hqStocks = [];
					var htmlTop = "";
					for (var i=0;i<results.length;i++){ 
						var type = results[i].stock_code;
						hqStocks.push(type);
						htmlTop += queryHoldingHTML_stock(results[i],type);
					}
					if(results[0].stb_flag != "1"){
					commonHq.getThirdStockInfo(hqStocks.join("|"),getStockNowPriceCallBack);
					}
					$(_pageId+".fund_table table").append(htmlTop);
					common.setNoData(false);
					//卖出事件
					$.bindEvent($(_pageId+" .fund_table .ce_table tr").slice(1), function(e){
						clearBuyMsg();// 清楚数据
						var stockCode = $(this).attr("id");
						$(_pageId + " #stockCode").removeClass("C100").addClass("inputContent");
						$(_pageId + " #stockCode").quzhi(stockCode);
						_stockCode = stockCode;
						var exchange_type = $(this).attr("exchange_type");
						var stock_account = $(this).attr("stock_account");
						setStockAccount(stock_account,exchange_type);
						getStockList(stockCode, "", exchange_type, stock_account);
						$(_pageId + " .main").scrollTop(0);
						e.stopPropagation();
					}, "tap");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		_queryHolding = true;
		if(_initScroller){
			_initScroller();
		}
	}
	/**
	 * 证券持仓HTML生成
	 */
	function queryHoldingHTML_stock(element,type){
		var css = "";
		var float_yk = Number(element.float_yk);//浮动盈亏
		if(float_yk > 0){
			css = "ared";
		}else if(float_yk < 0){
			css = "agreen";
		}
	   	var eleHtml = "";
        eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\"  type=\""+type+"\" id='"+element.stock_code +"' stock_name='"+element.stock_name +"'>";
        eleHtml+="<td><span>"+element.stock_name +"</span><span>"+element.market_value +"</span></td>";
        eleHtml+="<td><span class=\""+css+"\">"+element.float_yk+"</span><span class=\""+css+"\">"+element.float_yk_per+"%</span></td>";
        eleHtml+="<td><span>"+element.cost_amount+"</span><span>"+element.enable_amount+"</span></td>";
        eleHtml+="<td><span>"+element.cost_price+"</span><span>"+element.last_price+"</span></td>";
        eleHtml+="<td class='hqzrcj'><span>" + (element.stbtrans_type_name || "--") +"</span><span>" + (element.stb_layer_name || "--") +"</span></td>";
      	eleHtml+="</tr>";
        return eleHtml;
	}
	
	/**
	 * 
	 */
	function clearBuyMsg(){
		_PageParam = {};
		stock_info = ioitStock();
		if(stock_html){
		   	stock_html.stock_account.attr("type","");
			stock_html.stock_account.attr("exchange","");
			stock_html.stock_account.html('<em style="color: #ccc;">请选择股东账号</em>');
			stock_html.account_ul.hide();
	    	stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 股票名称
	    	setStockInfo("stockPrice","");// 股票价格
	    	setStockInfo("stockNum",""); // 股票数量
	    	stock_html.stockNum.setPlaceholder("输入数量");
	    	setStockInfo("confer_no",""); // 约定号码
	    	setStockInfo("target_seat",""); // 对方席位
	    	setStockInfo("target_stock_account",""); // 对方股东
	    	setStockInfo("transfer_mode","--"); // 
	    	setStockInfo("stockMaxAmount","--"); // 股票最大数
			stock_html.upStop.text("--"); //涨停价
	    	stock_html.downStop.text("--");//跌停价
		   	stock_html.total.text("").hide();
		   	stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
			stock_html.market_ul.html("");
			stock_html.referenList.text("--");
			stock_html.srincomeList.text("--");
			stock_html.market_ul.hide();
			stock_html.layerLevel.find("b").text("");
			stock_html.transferWay.find("b").text("");
			stock_html.layerLevel.hide();
			stock_html.transferWay.hide();
			stock_html.transfer_state.val("--");
            stock_html.label_txt.html("股");
		}
	   	commonTimer.clearTimer(_pageId+"Hqwd");
	   	_fifthCallback = true;
		$(_pageId + ".five_box ul li").removeClass("active");
		$(_pageId + " p.limit em").text("股");
		$(_pageId + " .input_num .input_text em").text("股");
		if((_orderType == "5" || _orderType == "6" || _orderType == "9" || _orderType == "10") && global.serverConfig == 3){
			$(_pageId+' .fund_table').hide();
		}
	}
	
	function dataDestroy(){
        commonHq.clearCheckTradeTimer();
		$.clearRequest();
		$(_pageId + " #stockCode").quzhi("");
		$(_pageId + " #stockCode").addClass("C100").removeClass("inputContent");
		$(_pageId + " #account p").html('<em style="color: #ccc;">请选择股东账号</em>');
		$(_pageId + " #account ul").html("").hide();
		_stockCode = "";
		$(_pageId+'.fund_table .ce_table tr.add').remove();
		clearBuyMsg();
		commonTimer.clearTimer(_pageId);
		stock_info = null;
		stock_html = null;
		if(keyboard){
			keyboard.keyDestroy();
		}
	}
	
	function getQueryHolding(){
		return _queryHolding;
	}
	
	var base = {
		"dataInit" : dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy,
		"getQueryHolding": getQueryHolding
	};
	module.exports = base;
});
