/**
 * 股转系统-持仓
 */
define('trade/scripts/third/asset/holding.js', function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
	var service_third = require("service_third");
	var commonHq = require("commonHq");
	var commonTimer = require("commonTimer");
	var myHScroller = null;
    var _pageId = "#third_asset_holding ";
    var userInfo = null;
    var _callback = true;
    var hqData = {};
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var slideHeight = null;
	var fillHtml=null;
    
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		fillHtml=$(_pageId+".fund_table #fillHtml");
		common.pageChangeHeight();
		common.pageBuryingPoint("101800");
		common.switchingCurUser("0");
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		userInfo = common.getCurUserInfo();
		jumpPageEvent();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
		
    }
		
	function load(){
		initHScroller();
		var mainHeight = common.setMainHeight(_pageId, false);
		slideHeight = mainHeight - $(_pageId+".tab_nav").outerHeight(true)-2;
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		queryData();//查询持仓
		
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){}
	
	/**
	 * 事件绑定
	 */
	function jumpPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				$(this).unbind(e.type);
				this[e.type] = null;
				common.comStat(101802, 2, 103, true, {"i_group_name": "返回"});
				$.pageInit("third/asset/holding", "account/index", {"history": true}, "left", true);
				e.stopPropagation();
				e.preventDefault();
			},300);
		},"tap");
		//转账
		$.bindEvent($(_pageId + "#transfer"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			$.setSStorageInfo("return_page","third/asset/holding");
			common.comStat(101804,2,103,true,{"i_group_name":"银证转账"});
			$.pageInit("third/asset/holding","banking/transferNew",{});
			e.preventDefault();
			e.stopPropagation();
		});
		
		// 刷新
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			$.showRightTopPreloaders();
			queryData();//查询持仓
			e.stopPropagation();
		});
	}
    
	/**
	 * 查询
	 */
	function queryData(){
		clearPositionTimer();
		//查询资金账户
		queryCapital(true);
		queryPosition(true);
		if(global.serverConfig == 1){
			queryDesirableAmount();
		}
		_callback = false;
		if(global.positionRefreshTime){
			commonHq.initCheckTradeTimer();
			commonTimer.setTimer(_pageId, function(){
				if(commonHq.getTradingTime() && _callback){
					queryCapital(false);
					queryPosition(false);
					_callback = false;
				}
			}, global.positionRefreshTime);
		};
	}
	/**
	 * 查询可取金额
	 */
	function queryDesirableAmount(){
		var param={				
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"password":userInfo.password,
			"cust_code":userInfo.cust_code,
			"money_type":"",
			"flag": "0"
		};
		//最后一个为超时处理函数
		service_third.queryDesirableAmount(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results!= "undefined" && results.length >0){
						var type = {"0":"RMB ","1":"Dollar"};
						for(var i=0;i<results.length;i++){
							var id = _pageId +"#"+ type[results[i].money_type];
							var fetch_balance = Number(results[i].fetch_balance).toFixed(2)+"";
							$(id+" .more_info li").eq(2).find("strong").html(fetch_balance.substring(0,fetch_balance.length-2)+""+ fetch_balance.substr(-2) +"");//可取
						}
					}
				}
			}
		},
		{  //传给接口的json格式数据            
			"isLastReq":false,                
			"isShowWait":false,
			"isShowOverLay":false
	    });
	}
	
	/**
	 * 资金账户查询
	*isShowWait  是否等待转圈
	 */
	function queryCapital(isShowWait){
		var param={				
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"password":userInfo.password,
			"cust_code":userInfo.cust_code,
			"money_type":"",
			"flag": "0"
		};
		//最后一个为超时处理函数
		service_third.queryFundSelect(param,queryCapitalCallback,
		{  //传给接口的json格式数据            
			"isLastReq":true,                
			"isShowWait":isShowWait,
			"isShowOverLay":false,
			"timeOutFunc":function(){},
			"errorFunc":function(){}
	    });
	}
	
	/**
	 * 资金账户查询回调
	 */
	function queryCapitalCallback(data){
		if (data && data!= "undefined"){
			if(data.error_no == 0){
				var results = data.results;
				if(results && results!= "undefined" && results.length >0){
					var type = {"0":"RMB ","1":"Dollar"};
					for(var i=0;i<results.length;i++){
						var id = _pageId +"#"+ type[results[i].money_type];
						var assert_val = Number(results[i].assert_val).toFixed(2)+"";
						
						$(id+" #zzc").html(assert_val.substring(0,assert_val.length-2)+""+ assert_val.substr(-2) +"");//总资产
						// if(assert_val.length>12){
						// 	$(id+" .inner>strong").css("font-size", "0.22rem");
						// }
						if(global.serverConfig != 1){
							var fetch_balance = Number(results[i].fetch_balance).toFixed(2)+"";
							$(id+" .more_info li").eq(2).find("strong").html(fetch_balance.substring(0,fetch_balance.length-2)+""+ fetch_balance.substr(-2) +"");//可取
						}
						var enable_balance = Number(results[i].enable_balance).toFixed(2)+"";
						$(id+" .more_info li").eq(0).find("strong").html(enable_balance.substring(0,enable_balance.length-2)+""+ enable_balance.substr(-2) +"");//可用
						
						//添加总浮动盈亏
						var css = "";
						var float_yks = results[i].float_yk || results[i].total_income_balance;
						if(float_yks > 0){
							css = "ared";
						}else if(float_yks < 0){
							css = "agreen";
						}
						//当浮动盈亏,浮动盈亏比例大于0 时,在前面添加一个 "+" 
						var fas = Number(float_yks).toFixed(2);
						$(id+" #ccckyk").html(fas.substring(0,fas.length-2)+""+ fas.substr(-2) +"").addClass(css).removeClass().addClass(css);//盈亏
						//添加当日浮动盈亏
						float_yks = results[i].market_val || "0";
						var fa =  Number(float_yks).toFixed(2)//$.formatMoney(float_yks,2);
						$(id+" #ccsz").html(fa.substring(0,fa.length-2)+""+ fa.substr(-2) +"");//盈亏
						//仓位
						var stock_position = results[i].stock_position
						$(id + " #cwbox").html('<span style="width:'+stock_position+';"></span>仓位 '+ stock_position);
					}
					//字体缩放
					$(_pageId+".j-data-info strong").each(function(idx, item){
						item = $(item);
						item.setTransformScale($.getTransformScale(item.text(), 18, item.parent().width() - 36));
					});			
				}else{
					$(_pageId+".hold_main2 .j-stock-data strong").text("--");
					$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
				}
			}
			else{
				$.alert(data.error_info);
			}
		}
	}
	
	/*
	 * 查询持仓数据
	*isShowWait  是否等待转圈
	**/
	function queryPosition(isShowWait){
		var param={				
			"entrust_way":global.entrust_way,
		    "branch_no":userInfo.branch_no,
		    "fund_account":userInfo.fund_account,
		    "cust_code":userInfo.cust_code,
		    "session_id":userInfo.session_id,
			"password":userInfo.password,
			"money_type": myHScroller.getCurPageIdx()
		};
		service_third.querythirdData(param,queryPositionCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait,
			"isShowOverLay":false,
			"errorFunc":function(){ 
				_callback = true;
				// $.Template7.global = {
				//     isShow: (global.serverConfig=="2" ? true : false)
				// };
				// $(_pageId+" .fund_table .ce_table").remove();
				// var compiledTemplate = $.Template7.compile($('#templateTitle').html());
				// fillHtml.html(compiledTemplate());
				// //错误调用方法
				// common.setNoData(true,"暂无持仓记录");
				// if(!myScroller){
				// 	initScroller();
				// }else{
				// 	myScroller.refresh();
				// }
			
			},
			"timeOutFunc":function(){ 
				_callback = true;
				// $.Template7.global = {
				//     isShow: (global.serverConfig=="2" ? true : false)
				// };
				// $(_pageId+" .fund_table .ce_table").remove();
				// var compiledTemplate = $.Template7.compile($('#templateTitle').html());
				// fillHtml.html(compiledTemplate());
				// //超时调用方法
				// common.setNoData(true,"暂无持仓记录");
				// if(!myScroller){
				// 	initScroller();
				// }else{
				// 	myScroller.refresh();
				// }
			}
		});
	}
	
	function queryPositionCallback(data){
		// $(_pageId+" .fund_table .ce_table").remove();
		var scrollX = $(_pageId+'.position_div')[0].scrollLeft;
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		$.Template7.global = {
			isShow: (global.serverConfig=="2" ? true : false)
		};
		hqData={};
		_callback = true;
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;		
				if(results && results.length>0){
					var htmlTop = "";
					for (var i=0;i<results.length;i++){ 
						htmlTop += queryPositionHTML_stock(results[i]);
					}
					$(_pageId+".position_div tbody").html(htmlTop);
					$(_pageId+'.position_div')[0].scrollLeft = scrollX;
					common.setNoData(false);
					// var compiledTemplate = $.Template7.compile($('#template').html());
					// fillHtml.html(compiledTemplate(data));
				}
				else{
					common.setNoData(true,"暂无持仓记录");
					// $(_pageId+" .fund_table .ce_table").remove();
					// var compiledTemplate = $.Template7.compile($('#templateTitle').html());
					// fillHtml.html(compiledTemplate());
				}
			}else{
				$.alert(data.error_info);
				// var compiledTemplate = $.Template7.compile($('#templateTitle').html());
				// fillHtml.html(compiledTemplate());
			}
		}
		if(!myScroller){
			initScroller();
		}else{
			myScroller.refresh();
		}
	}

	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,type,isLast){
		var price_digit = 3;
		var eleHtml = "";
		var css = "",css1="";
		var float_yk = element.float_yk;//浮动盈亏
		if(+float_yk>0){
			css = "ared";
		}else if(+float_yk<0){
			css = "agreen";
		}
		//浮动盈亏比例
		if(Number(element.float_yk_per)>0){
			css1 = "ared";
		}else if(Number(element.float_yk_per)<0){
			css1 = "agreen";
		}
		var maxWidth = $(window).width() * 0.25;
		var marketValue =element.market_value,
		float_yk_per = element.float_yk_per + "%",
		cost_amount = element.cost_amount,
		enable_amount = element.enable_amount,
		cost_price = element.cost_price,
		last_price = element.last_price,
		stbtrans_type_name = element.stbtrans_type_name || "--",
		stb_layer_name = element.stb_layer_name || "--";
		eleHtml+="<tr class='add' stock_account=\""+element.stock_account+"\" exchange_type=\""+element.exchange_type+"\" id='"+element.stock_code +"'>";
		eleHtml+='<td><p style="zoom:'+ $.getTransformScale(element.stock_name, 16, maxWidth - 20) +'">'+element.stock_name +'</p>';
		eleHtml+='<p style="zoom:'+ $.getTransformScale(marketValue, 16, maxWidth - 20) +'">'+marketValue+'</p></td>';
        eleHtml+='<td><p class="'+css+'" style="zoom:'+$.getTransformScale(float_yk, 16, maxWidth - 20) +';">'+float_yk+'</p>';
        eleHtml+='<p class="'+css1+'" style="zoom:'+ $.getTransformScale(float_yk_per, 16, maxWidth - 20) +';">'+float_yk_per+'</p></td>';
		eleHtml+='<td><p style="zoom:'+$.getTransformScale(cost_amount, 16, maxWidth - 20) +';">'+cost_amount+'</p>';
		eleHtml+='<p style="zoom:'+ $.getTransformScale(enable_amount, 16, maxWidth - 20) +';">'+enable_amount+'</p></td>';
		eleHtml+='<td><p style="zoom:'+ $.getTransformScale(cost_price, 16, maxWidth - 20) +';">'+cost_price+'</p>';
		eleHtml+='<p style="zoom:'+ $.getTransformScale(last_price, 16, maxWidth - 20) +'">'+last_price+'</p></td>';
		eleHtml+='<td class="hqzrcj"><p style="zoom:'+ $.getTransformScale(stbtrans_type_name, 16, maxWidth - 20) +';">'+stbtrans_type_name+'</p>';
		eleHtml+='<p style="zoom:'+ $.getTransformScale(stb_layer_name, 16, maxWidth - 20) +'">'+stb_layer_name+'</p></td>';
        eleHtml+="</tr>";	
		return eleHtml;
	}
	  
	  
	function clearPositionTimer(){
		commonTimer.clearTimer(_pageId);
	}
	
	
	/**
	 * 初始化滑动组件
	 */
	function initScroller(){
		var scrollOptions = {
			scrollerHeight: slideHeight, // 滚动组件的高度
			pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
			$wrapper: $(_pageId + " #wrapper"),
			hasPullDown: true, // 是否显示下拉提示，默认 true
			hasPullUp: false, // 是否显示上拉提示，默认 true
			isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
			pullDownHandler: function(){
				queryData(); // 模拟查询接口数据操作
			},
			pullUpHandler: function(){
			}
		};
		if(!myScroller)
		{
			// 内容的高度比滚动区域高度小时
			// iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
			if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
			{
				scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
			}
			myScroller = iscrollUtils.vScroller(scrollOptions);
		}
		else
		{
			myScroller.refresh();
		}
	}

	/**
	 * 初始化滑动组件
	 * @param queryFunc 查询函数
	 */
	function initHScroller()
	{
		var scrollOptions = {
			$wrapper: $(_pageId + " #hwrapper"),
			scrollEndHandler:function(){//滚动结束时的处理函数
				var pagex=myHScroller.getCurPageIdx();
				var dotName="";
				if(pagex==0){
					dotName="人民币";
				}else if(pagex==1){
					dotName="美元";
				}else if(pagex==2){
					dotName="港币";
				}
				$(_pageId + ".j-dot-list em").removeClass("on").eq(pagex).addClass("on");
				common.comStat(101803,2,104,true,{"i_change_name":"资产信息","i_change_to":dotName});//埋点
				queryPosition();
			}
		};
		// 设置滚动内容的宽度
		// 显示左右滑动内容，防止页面闪动
		$(_pageId + " .iscroll_hScroller>div").width($(window).width()).show();
		// 设置 scroller 的宽度
		$(_pageId + " #hscroller").width($(window).width() * 2);
		
		myHScroller = iscrollUtils.hScroller(scrollOptions);
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
        commonHq.clearCheckTradeTimer();
		$.clearRequest();
		clearPositionTimer();
		_callback = true;
		$(_pageId+".hold_main2 .j-stock-data strong").text("--");
		$(_pageId+" #cwbox").html('<span style="width:0%;"></span>仓位 --');
		$(_pageId+'.fund_table .ce_table tr.add').unbind();
		$(_pageId+".fund_table .ce_table tr.tools a").unbind();
		$(_pageId+'.fund_table .ce_table').remove();
		$(_pageId+'.position_div tr.tools').remove();
		$(_pageId+'.position_div tr.add').remove();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
		if(myHScroller)
		{
			myHScroller.destroy();
			myHScroller = null;
		}
		common.pageBuryingPoint();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
