/**
 * 股转系统-限价买卖下单
 */
define('trade/scripts/third/limitPriceOrder.js', function(require, exports, module) {
	var common = require("common");
	var commonHq = require("commonHq");
	var commonFunc = require("commonFunc");
	var gconfig = $.config;
	var global = gconfig.global;
		require("validatorUtils");
	var validatorUtil = $.validatorUtils;
	var service_third = require("service_third");
	var keyboard = require("keyboard");
	var commonTimer = require("commonTimer");
    var userInfo = null;  // 账号信息
    var stock_info = null;
    var stock_html = null;
    var _pageId = null;
    var _orderType = null;
    var _PageParam = {};
	
	var stbLayerMap = {"0":"其它","1":"基础","2":"创新","3":"京A"};//股转分层标签
	var stbtransTypeMap = {"T":"协议","M":"做市","B":"连续","C":"集合","O":"其他",};//转让类型标签
    //0：深A，1：深B，2：沪A，3：沪B，4：三板，9：特转A，A：特转B，F1：郑州交易所，F2：大连交易所，F3：上海交易所，F4：金融交易所，G：港股
    var _exchange = {
			"0":"0", "2":"0", "3":"0", "4":"0", "5":"0", "6":"0", "7":"0", "8":"0",
			"1":"1",
			"9":"2", "11":"2", "12":"2", "13":"2", "14":"2", "15":"2", "16":"2",
			"10":"3",
			"17":"4",
			"18":"0", "19":"0", "21":"0", "22":"0", "23":"0", "24":"0", "64":"0",
			"20":"2", "25":"2", "26":"2", "27":"2", "30":"2", "65":"2", "66":"2",
			"43":"0", "45":"0", // CDR
			"44":"2", "46":"2"
		};
	var market_html_data = [
			{"name":"限价委托","id":"0"},
			{"name":"对手方最优价格","id":"70"},
			{"name":"本方最优价格","id":"68"},
			{"name":"最优五档即时成交剩余撤销","id":"64"},
			{"name":"最优五档即时成交剩余转限价","id":"62"},
		];
	var _stockCode = null;
	var _callback = true;
	var _fifthCallback = true;
	var _checkoutSuccess = false;
	var _initScroller = null;
	var _slideReset = null; //回到页面顶部的方法
	var clearMaxNumber=false;
	var fillHtml=null;
  var notice_no = null;//系统提示信息 为4时，显示弹框
  var notice_info = null;//系统提示信息
    
	/**
	 * 设置股票对象是信息参数
	 */
	function ioitStock(){
		var stockInfo = {
	    	"stockCode" : "", // 股票代码
	    	"stockName" : "", // 股票名称
	    	"stockPrice" : "",// 股票价格
	    	"stockNum" : "",
	    	"stbtrans_type": "",//转让方式
	    	"stb_layer": "",//股转分层
			"upStop" : 0, //涨停价
	    	"downStop" : 0,//跌停价
	    	"stockMaxAmount" : 0,//股票最大数
	    	"price_step" : 0.01, // 步长
			"price_digit" : 2, // 小数点位数
			"lot_size" : 1, //每手数量
			"stock_type_hq" : "",//行情股票类型
			"stock_type_trade":"",//交易股票类型
			"stock_market" : "",//市场代码
			"gear_one" : false,//是否启动五档
			"exchange_type" : "",//交易市场（交易后台）
			"stock_account" : "",// 股东账号 
			"_isQueryTradeListFail" : false, //模糊列表是否返回的标识（用来判断证券基础信息里面是否需要查询五档）
			"fifthGearReturn":false,//五档返回
			"securitiesInfoReturn":false,//证券基础信息返回
			"priceChangeFlag":false,//价格改变后是否添加放大缩小的效果
	    };
	    return stockInfo;
	}
	
	function initHtml(){
		stock_html = {
			"stock_account": $(_pageId + " #account p"),//股东账号
			"account_ul": $(_pageId + " #account ul"),//股东账号列表
	    	"stockCode" : $(_pageId + " #stockCode"), // 股票代码
	    	"stockName" : $(_pageId + " #stockCode").next("span"), // 股票名称
	    	"stockPrice" : $(_pageId + " #stockPrice"),// 股票价格
	    	"stockNum" : $(_pageId + " #stockNum"), // 股票数量
			"upStop" : $(_pageId + " #up_stop"), //涨停价
	    	"downStop" : $(_pageId + " #down_stop"),//跌停价
	    	"stockMaxAmount": $(_pageId + " #maxNumber"),//股票最大数
	    	"buyGear" : $(_pageId + " .five_box ul").eq(1).find("li"), // 买五档
		   	"sellGear" : $(_pageId + " .five_box ul").eq(0).find("li"), // 卖五档
		   	"total" : $(_pageId + " #total"),// 计算金额显示
			"market_ul" : $(_pageId + " #market_list ul"),
			"stockList" : $(_pageId + "#stock_list"),// 股票下拉列表
			"referenList": $(_pageId + ".referen span"),//最新、参考、匹配、不匹配
			"label_g": $(_pageId + " .label_g"),//页面标签
			"market_p" : $(_pageId+" #entrustWay p")//委托方式
		}
	}
	

    /**
     * 数据初始化
     */
	function dataInit(pageId,orderType, initScroller, slideReset){
		_initScroller = initScroller;
		_slideReset=slideReset;
		_PageParam = $.getPageParam() || {};
		_pageId = pageId;
		fillHtml=$(_pageId+"#fillHtml");
		if(keyboard){
			keyboard.keyInit(null,null,"tap",_pageId);
		}
		userInfo = common.getCurUserInfo();
		_orderType = orderType;
		stock_info = ioitStock();
		initHtml();
		_stockCode = null;
		commonHq.initCheckTradeTimer();
	
		commonFunc.getNewStockAccount(["9","A"], userInfo, function(data){
			setAccountList(data);
		});
		
		var stockCode = _PageParam["code"] || _PageParam["stock_code"] || "";
		stock_info.stockCode = stockCode;
		// 查询个股行情
		if(stockCode){
			stock_info.priceChangeFlag = true;
			updatePageInfo(stockCode);
			getStockList(stockCode);
		}
		//持仓查询
		queryHolding(true);
		_callback = false;
		if(global.positionRefreshTime){
			commonTimer.setTimer(_pageId, function(){
				if(commonHq.getTradingTime() && _callback){
					queryHolding(false);
					_callback = false;
				}
			}, global.positionRefreshTime);//定时刷新
		}
		entrustWayInit();
    }
	
	/*
	*股东账号查询
	* */
	function setAccountList(data,type){
		if(data && data.length > 0){
			var listHtml = "<ul>";
			for(var i = 0; i < data.length; i++){
				var icon_css = "";
				if(data[i].main_flag == "1"){//主
					icon_css = "mainAccount_icon";
				}
				var bank_accounts = "<span>"+data[i].holder_kind_name+" "+data[i].exchange_type_name+"—"+data[i].stock_account+"</span>";
				listHtml+="<li exchange='"+data[i].exchange_type+"' type='"+data[i].stock_account+"' exchangeName='"+data[i].exchange_type_name+"'><span class='asset_select'>"+bank_accounts+"<i></i></span><em class='asset_icon "+icon_css+"'></em></li>";
			}
			listHtml+="</ul>";
			
			//切换股东账号
			common.addPageTabList($(_pageId + " #account"), "选择股东账号",listHtml,function(data,div){
				if(keyboard){
					keyboard.closeKeyPanel();
				}
				stock_info.stock_account = data.attr("type");
				stock_info.exchange_type = data.attr("exchange");
				setStockAccount(stock_info.stock_account,stock_info.exchange_type);//设置页面展示的股东帐号以及对应的市场
				if(stock_info && stock_info.stockCode){
					isQueryMax();
				}
				//埋点
				common.comStat(isBuy()?101723:101753,2,103,true,{"i_group_name":"切换股东账号"});
			},"","",keyboard);
			
			if(!type){//设置默认展示的股东账号和市场
				setStockAccount(data[0].stock_account, data[0].exchange_type);
			}else{//根据当前传递的股东账号和市场进行页面展示（如：持仓点击、页面传递）
				setStockAccount(stock_info.stock_account, stock_info.exchange_type);
			}
		}
		else{
			stock_html.stock_account.html("--");
			stock_html.stock_account.attr("exchange_type","");
			stock_html.stock_account.attr("stock_account","");
			// stock_html.account_ul.hide();
			$.bindEvent($(_pageId + " #account"), function(e){
				$.alert("无对应的股东账户");
			});
		}
	}
	
	function setStockAccount(stock_account, exchange_type){
		if(stock_account || exchange_type){
			var ea = $(_pageId + " .allacout ul").find("li[exchange='"+exchange_type+"'][type='"+stock_account+"']");
			if(ea && ea.length > 0){
				$(_pageId + " .allacout ul li").removeClass("check");
				ea.addClass("check");
				stock_info.exchange_type = ea.attr("exchange");
				stock_info.stock_account = ea.attr("type");
				if(stock_html){
					stock_html.stock_account.html(ea.attr("exchangeName")+"—"+ea.attr("type"));
					stock_html.stock_account.attr("exchange_type",stock_info.exchange_type);
					stock_html.stock_account.attr("stock_account",stock_info.stock_account);
				}
			}else{
				if(stock_html){
					stock_html.stock_account.html("--");
					stock_html.stock_account.attr("exchange_type","");
					stock_html.stock_account.attr("stock_account","");
					// stock_html.account_ul.hide();
				}
				$.bindEvent($(_pageId + " #account"), function(e){
					$.alert("无对应的股东账户");
				});
			}
		}
	}
	
	/**
	 * @description 设置页面展示的股东账号
	 */
	function setShareholderAccount(){
		stock_info.stock_account = stock_html.stock_account.attr("stock_account");
		var shareMarket = ["9","A"];
		if(stock_info.exchange_type && shareMarket.indexOf(stock_info.exchange_type)!=-1){
			commonFunc.getNewStockAccount([stock_info.exchange_type], userInfo, function(data){
				// if(JSON.stringify(data).indexOf(stock_info.stock_account)==-1){
					setAccountList(data,stock_info.stock_account ? true : false);
				// }
			});
		}else{
			stock_html.stock_account.html("--");
			stock_html.stock_account.attr("exchange_type","");
			stock_html.stock_account.attr("stock_account","");
			// stock_html.account_ul.hide();
			$.bindEvent($(_pageId + " #account"), function(e){
				$.alert("无对应的股东账户");
			});
		}
	}
	
	function isBuy(){
		if(_orderType == "1" || _orderType == "3" || _orderType == "5" || _orderType == "7" || _orderType == "9"){
			return true;
		}
		else{
			return false;
		}
	}
	
	/**
	 * 获取股票信息
	 * @param {Object} param 对应id名的值
	 * @param {Object} newest 是否不同步
	 */
	function getStockInfo(param, newest){
		if(stock_html){
			var data = stock_html[param].quzhi();
			if(newest && stock_info){
				if(!data || data == "--"){
					stock_info[param] = 0;
				}
				else
				{
					stock_info[param] = data;
				}
			}
			return data;
		}
		else{
			return '';
		}
	}
	
	/**
	 * 设置股票信息的值 可以为对象
	 * @param {Object} key 输入字符串支持单个，输入对象支持全部
	 * @param {Object} value 只支持单个字符串的值
	 * @param {Object} newest 是否改变对象的值 默认是改变，true是不改变
	 */
	function setStockInfo(key, value, newest){
		if(stock_html){
			stock_html[key].quzhi(value);
			if(newest && stock_info){
				if(value == "--"){
					value = 0;
				}
				stock_info[key] = value;
			}
		}
	}

	/**
	 * 最大可买卖查询
	 */
	function isQueryMax(){
		clearMaxNumber=false;
		//判断代码、市场、股东账号
		if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
			queryStockMaxAmount();
		}else{
			$.hidePreloader();
		}
	}
	/**
	 * 事件绑定
	 */
	function elementBindEvent(){
		//返回
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			//埋点
			common.comStat(isBuy()?101722:101752,2,103,true,{"i_group_name":"返回"});
			if(global.callNative){
				if($.getPageParam("isFromApp")){
					var pageCode = $.getCurrentPageObj().pageCode || '';
					//ios切换行情
					$.callMessage({
						"funcNo": "50500",
						"msgNo": "205",
						"sourceModule":"trade",
						"targetModule":"app",
						"action":"4",
						"param":{}
					});
					$.pageInit(pageCode,'account/index',{"_loginClass":"0"},"left",true);
				}else{
					$.pageInit($.getCurrentPageObj().pageCode,"account/index",{"history":true},"left",true);
				}
			}
			else{
				$.pageInit($.getCurrentPageObj().pageCode,"account/index",{"history":true},"left",true);
			}
			e.stopPropagation();
			e.preventDefault();
		},"tap");
		
		//关闭ios键盘
		$.bindEvent($(_pageId), function(e){
			if(e.target !== document.activeElement)
			{
				document.activeElement.blur();
			}
		}, "click");
		
		$.bindEvent($(_pageId+"  .input_code .input_text span"), function(e){//输入时股票代码调键盘
			var click = e.type || "click";
			if(keyboard){
				$(_pageId + " div#stockCode").triggerFastTap();
				$(_pageId + " #stockCode").focus();
			}
			else{
				$(_pageId + " #stockCode").triggerFastTap();
				$(_pageId + " #stockCode").focus();
			}
			e.stopPropagation();
			e.preventDefault();
		},"tap");
		
		$.bindEvent($(_pageId + " #stock_list"), function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			e.stopPropagation();
		});
		
		if(!keyboard){
			$.bindEvent($(_pageId + "#stockCode"), function(e){
				stock_html.stockList.show();
				e.stopPropagation();
			});
		}
		
		// 股票代码输入框监听
		$.bindEvent($(_pageId + "#stockCode"), function(e){ // 该监听方法是为了适配浏览器
			$(_pageId + " .five_box ul li").removeClass("active");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			else{
				var stockCode = $(this).val();
				stockCode = stockCode.replaceAll(/([^A-Za-z0-9])/g,"");
				stockCode = $.trim(stockCode);
				$(this).val(stockCode);
			}
			var stockCode = $(_pageId + " #stockCode").val();
			//控制股票代码输入，字母控制4位，数字6位
			if(stockCode.length > 4){
				var vai1 = /^[0-9]+$/;
				if(!vai1.test(stockCode)){
					stockCode = stockCode.substring(0,4);
					$(_pageId + " #stockCode").quzhi(stockCode);
				}
			}
			if(stockCode.length == 0){
				clearBuyMsg();
				_stockCode = "";
				$(_pageId + " #stockCode").addClass("C100");
			}
			else{
				$(_pageId + " #stockCode").removeClass("C100");
			}
			if(stockCode){
				if(stockCode != _stockCode){
					_stockCode = stockCode;
					clearBuyMsg();
					if(stockCode.length > 0){
						getStockList(stockCode); // 查询股票列表
					}
				}
			}
			e.stopPropagation();
		},"input");
		
		//数量输入
		$.bindEvent($(_pageId + "#stockNum"),function(e){
			if(keyboard){
				var key = "";
				if(!global.callNative){
					key = e.detail["keyDiv"] ? e.detail["keyDiv"].attr("key") : "";
				}
				else{
					key = $(this).attr("keyDiv");
				}
				if(key == "d4" || key == "-11"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d3" || key == "-12"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d2" || key == "-13"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else if(key == "d1" || key == "-14"){
					var num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
					setStockInfo("stockNum",num+"");
				}
				else{
					keyboard.popUpKeyboard($(this),e);
				}
			}
			var stockNum = $(_pageId + "#stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				//委托方式
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat((isBuy() ? 101733 : 101763),2,2,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"2", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"input");
		
		// 限价价格输入框
		$.bindEvent($(_pageId + " #stockPrice"), function(e){
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = $(_pageId + " #stockPrice").val();
				if(stockPrice == ""){
					if(isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						setStockInfo("stockMaxAmount","--",true);
					}
				}
				totalValue(stockPrice,stockNum);
				isQueryMax();
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					//委托方式
					var entrust_bs = stock_html.market_p.attr("type");
					if(!isBuy()){
						entrust_bs = (Number(entrust_bs)+1) + "";
					}
					common.comStat((isBuy()?101727:101757),2,1,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":entrust_bs, // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}
			e.stopPropagation();
		},"input");
		
		// 限价价格框——增加价格
		$.bindEvent($(_pageId + " #stockPrice").nextAll(".add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockNum = getStockInfo("stockNum");
			var stockPrice = getStockInfo("stockPrice");
			if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
				setStockInfo("stockPrice",0);
				return false;
			}
			stockPrice = Number(stockPrice);  
			var price_step = stock_info.price_step;

			if(stockPrice >= 0 && stockPrice < 999999999){
				stockPrice = (parseFloat(stockPrice)+parseFloat(price_step)).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",stockPrice);
				totalValue(stockPrice,stockNum);
				isQueryMax();
			}
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");
				//委托方式
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"1", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
				});
			}
			e.stopPropagation();
		},"tap");
		
		// 限价价格框——减少价格
		$.bindEvent($(_pageId + " #stockPrice").nextAll(".less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockNum = getStockInfo("stockNum");
			var stockPrice = getStockInfo("stockPrice");
			if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
				setStockInfo("stockPrice",0);
				return false;
			}
			var price_step = stock_info.price_step;
			stockPrice = Number(stockPrice);
			if(stockPrice - price_step >= 0){
				stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",stockPrice);
				totalValue(stockPrice,stockNum);
				isQueryMax();
				if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
					$.clearRequest();
					clearMaxNumber=true;
					setStockInfo("stockMaxAmount","--",true);
				}
			}else{
				if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
					$.clearRequest();
					clearMaxNumber=true;
					setStockInfo("stockMaxAmount","--",true);
				}
			}
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");
				//委托方式
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"2", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
				});
			}
			e.stopPropagation();
		},"tap");
		
		// 保护限价价格框
		$.bindEvent($(_pageId + " #protectStockPrice"), function(e){
			if(keyboard) {
				keyboard.popUpKeyboard($(this), e);
			}
			if(stock_info){
				var stockNum = getStockInfo("stockNum");
				var stockPrice = $(_pageId + " #protectStockPrice").val();
				if(stockPrice == ""){
					if(isBuy()){//买入的时候价格为空清空最大可买
						$.clearRequest();
						setStockInfo("stockMaxAmount","--",true);
					}
				}
				totalValue(stockPrice,stockNum);
				isQueryMax();
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					//委托方式
					var entrust_bs = stock_html.market_p.attr("type");
					if(!isBuy()){
						entrust_bs = (Number(entrust_bs)+1) + "";
					}
					common.comStat((isBuy()?101727:101757),2,1,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":entrust_bs, // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":stockPrice, // 选择后的价格
						"i_adjust_type":"5", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}
			e.stopPropagation();
		},"input");
		
		// 保护限价价格框——增加价格
		$.bindEvent($(_pageId + " #protectStockPrice").nextAll(".add"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockNum = getStockInfo("stockNum");
			var stockPrice = getStockInfo("stockPrice");
			if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
				setStockInfo("stockPrice",0);
				return false;
			}
			stockPrice = Number(stockPrice);  
			var price_step = stock_info.price_step;
			if(stockPrice >= 0 && stockPrice < 999999999999){
				stockPrice = (parseFloat(stockPrice)+parseFloat(price_step)).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",stockPrice);
				totalValue(stockPrice,stockNum);
				isQueryMax();
			}
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");//委托方式
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"1", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
				});
			}
			e.stopPropagation();
		},"tap");
		
		// 保护限价价格框——减少价格
		$.bindEvent($(_pageId + " #protectStockPrice").nextAll(".less"),function(e){
			$(_pageId + " .five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockNum = getStockInfo("stockNum");
			var stockPrice = getStockInfo("stockPrice");
			if(!stockPrice || !validatorUtil.isNumberFloat(stockPrice)){
				setStockInfo("stockPrice",0);
				return false;
			}
			var price_step = stock_info.price_step;
			stockPrice = Number(stockPrice);
			if(stockPrice - price_step >= 0){
				stockPrice = (parseFloat(stockPrice) - parseFloat(price_step)).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",stockPrice);
				totalValue(stockPrice,stockNum);
				isQueryMax();
				if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
					$.clearRequest();
					clearMaxNumber=true;
					setStockInfo("stockMaxAmount","--",true);
				}
			}else{
				if(Number(stockPrice)==0 && isBuy()){//买入的时候价格为空清空最大可买
					$.clearRequest();
					clearMaxNumber=true;
					setStockInfo("stockMaxAmount","--",true);
				}
			}
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).attr("objectId");
				var actionId = $(this).attr("actionId");
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"2", // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
				});
			}
			e.stopPropagation();
		},"tap");
		
		// 增加数量
		$.bindEvent($(_pageId + " .input_num .add"),function(e){
			$(_pageId + ".five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockPrice = getStockInfo("stockPrice");
			var stockNum = getStockInfo("stockNum") || "0";
			if(!stockNum || !validatorUtil.isNumeric(stockNum)){
				setStockInfo("stockNum",0);
				return false;
			}
			stockNum = Number(stockNum) + stock_info.lot_size;
			setStockInfo("stockNum",stockNum);
			totalValue(stockPrice,stockNum);
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat((isBuy() ? 101731 : 101761),2,2,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"1", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"tap");
		// 减少数量
		$.bindEvent($(_pageId + " .input_num .less"),function(e){
			$(_pageId + ".five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var stockPrice = getStockInfo("stockPrice");
			var stockNum = getStockInfo("stockNum") || "0";
			if(!stockNum || !validatorUtil.isNumeric(stockNum)){
				setStockInfo("stockNum",0);
				return false;
			}
			stockNum = Number(stockNum) - stock_info.lot_size;
			if(stockNum < 0){
				stockNum = 0;
			}
			setStockInfo("stockNum",stockNum);
			totalValue(stockPrice,stockNum);
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat((isBuy() ? 101732 : 101762),2,2,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"2", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"tap");
		
		// 增加价格
		$.bindEvent($(_pageId + " #stockNum").nextAll("a.btn"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			if(stock_info && stock_info.stockCode){
				setStockInfo("stockNum",stock_info.stockMaxAmount);
			}else{
				$.alert("请先输入股票代码");
			}
			e.stopPropagation();
		});
		// 五档买卖盘联动
		$.bindEvent($(_pageId + ".five_box ul li"),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			var curPrice = $(this).find("span").text();
			if(curPrice && curPrice != "--"){
				$(this).siblings().removeClass("active");
				$(this).parent().siblings().find("li").removeClass("active");
				$(this).addClass("active");
				curPrice = Number(curPrice).toFixed(stock_info.price_digit);
				setStockInfo("stockPrice",curPrice);		
				common.changeFontSize($(_pageId + " #stockPrice"));		
				var stockNum = getStockInfo("stockNum");
				totalValue(curPrice,stockNum);
				isQueryMax(curPrice);
				//埋点
				if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
					var entrust_bs = stock_html.market_p.attr("type");
					if(!isBuy()){
						entrust_bs = (Number(entrust_bs)+1) + "";
					}
					common.comStat((isBuy()?101730 : 101760),2,1,false,{
						"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
						"i_entrust_prop":entrust_bs, // 委托属性
						"i_exchange_type":stock_info.exchange_type, // 交易市场
						"i_stock_code":stock_info.stockCode, // 股票代码
						"i_stock_name":stock_info.stockName, // 股票名称
						"i_price":curPrice, // 选择后的价格
						"i_adjust_type":(isBuy()?3:4), // 调整方式(1,加 2,减 3,买5档 4,卖5档 5,直接输入 6点击最新价 7点击涨停价 8点击跌停价)
					});
				}
			}
			e.stopPropagation();
		});
		
		// 下单
		$.bindEvent($(_pageId + "#submitOrder"),function(e){
			//埋点
			common.comStat((isBuy()? 101729:101759),2,103,true,{"i_group_name":(isBuy()? "买入":"卖出")});
			vailSubmitOrder();
		});
		
		// 点击其他位置去掉五档点击效果
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(_pageId + ".five_box ul li").removeClass("active");
			if(stock_html){
				stock_html.stockList.hide();
				stock_html.market_ul.hide();
			}
		},"tap");
		
		// 点击涨跌停价
		$.bindEvent($(_pageId + " #up_stop").add($(_pageId + " #down_stop")), function(e){
			$(_pageId + ".five_box ul li").removeClass("active");
			if(stock_info){
				$.closeModal(".picker-modal.modal-in");
				if(keyboard){
					keyboard.closeKeyPanel();
				}
				var stockNum = getStockInfo("stockNum");
				var inputVal=$(this).html();
				if(inputVal && validatorUtil.isNumberFloat(inputVal) && inputVal != 0){
					setStockInfo("stockPrice",inputVal);
					common.changeFontSize($(_pageId + " #stockPrice"));
					totalValue(inputVal,stockNum);
					isQueryMax();
				}
			}
			e.stopPropagation();
		});
		
		// 仓位选择
		$.bindEvent($(_pageId + ".row_04 p"),function(e){
			$(_pageId + ".five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).addClass("check");
			var key = $(this).attr("type");
			var i_fast_btn = "";
			if(key == "4"){
				var num = (stock_info.stockMaxAmount / stock_info.lot_size / 4).toFixed0(0) * stock_info.lot_size;
				setStockInfo("stockNum",num+"");
				i_fast_btn="1/4仓";
			}
			else if(key == "3"){
				var num = (stock_info.stockMaxAmount / stock_info.lot_size / 3).toFixed0(0) * stock_info.lot_size;
				setStockInfo("stockNum",num+"");
				i_fast_btn="1/3仓";
			}
			else if(key == "2"){
				var num = (stock_info.stockMaxAmount / stock_info.lot_size / 2).toFixed0(0) * stock_info.lot_size;
				setStockInfo("stockNum",num+"");
				i_fast_btn="半仓";
			}
			else if(key == "1"){
				var num = parseFloat(stock_info.stockMaxAmount); //最大可卖可以是 小数 (参考华金，邮件20180716)
				if ( isBuy() ) {
					num = (stock_info.stockMaxAmount / stock_info.lot_size / 1).toFixed0(0) * stock_info.lot_size;
				}
				setStockInfo("stockNum",num+"");
				i_fast_btn="全仓";
			}
			common.changeFontSize($(_pageId + " #stockNum"));
			var stockNum = $(_pageId + " #stockNum").val();
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,stockNum);
			//埋点
			if(stock_info && stock_info.stockCode && stock_info.exchange_type && stock_info.stock_account){
				var objectId = $(this).parent().attr("objectId");
				var actionId = $(this).parent().attr("actionId");
				var entrust_bs = stock_html.market_p.attr("type");
				if(!isBuy()){
					entrust_bs = (Number(entrust_bs)+1) + "";
				}
				common.comStat(objectId,2,actionId,false,{
					"i_entrust_bs":isBuy()?"1":"2", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":entrust_bs, // 委托属性
					"i_exchange_type":stock_info.exchange_type, // 交易市场
					"i_stock_code":stock_info.stockCode, // 股票代码
					"i_stock_name":stock_info.stockName, // 股票名称
					"i_price":stockPrice, // 选择后的价格
					"i_adjust_type":"3", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":stock_info.stockMaxAmount, // 最大数量
					"i_target_cnt":stockNum, // 调整之后的数量
					"i_fast_btn":i_fast_btn, // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			var iTime = setTimeout(function() {
				$(_pageId + " .row_04 p").removeClass("check");
				clearTimeout(iTime);
			}, 200);
			e.stopPropagation();
		});
		
		// 刷新（证券基础信息、持仓、五档、股东账号）股东账号数据、行情数据、当日委托数据、最大可买卖数
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			$(_pageId + ".five_box ul li").removeClass("active");
			$.closeModal(".picker-modal.modal-in");
			$.showRightTopPreloaders();
			stock_info.priceChangeFlag = true;
			commonFunc.setNewStockAccount(userInfo,function(){
				if(!stock_info.stockCode){//未输入代码时就全量更新
					commonFunc.getNewStockAccount(["9","A"], userInfo, function(data){
						setAccountList(data);
					});
				}
			});
			queryHolding(true);
			//刷新证券基础信息
			if(stock_info && stock_info.stockCode){
				getStockList(stock_info.stockCode);
			}
			e.stopPropagation();
		});
	}
	
	/**
	 * 限制小数点位数
	 * @param {Object} price
	 */
	function limitingDigit($this){
		var price_digit = stock_info.price_digit;
		var price = getStockInfo("stockPrice");
		if(price && validatorUtil.isNumberFloat(price)){
			var cur_arr = (price+"").split(".");
			if(cur_arr.length == 2){
				if(cur_arr[1].length > price_digit){
					var price = cur_arr[0]+"."+cur_arr[1].substring(0,price_digit);
					setStockInfo("stockPrice",price)
				}
			}
		}
	}
	
	//行情列表接口有问题是，输入股票是6位数时直接调用交易接口
	function queryData(stockCode){
		var vai1 = /^[0-9]{6}$/;
		if(vai1.test(stockCode)){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			queryMaxAmount(stockCode);
		}
	}
	
	/**
	 * @description 模糊搜索接口只返回一条数据处理
	 * @param {Object} data 接口返回的结果集
	 */
	function ListData(data){
		//输入满六位，存在唯一结果收起键盘
		if(keyboard){
			keyboard.closeKeyPanel();
		}
		
		// 1、更新股票代码、股票名称
		var stockVal = data[0]; //证券代码
        stock_info.second_type = data[19]; // 股票二级分类
		$(_pageId + " #stockCode").removeClass("C100");
		_stockCode = stockVal;
		setStockInfo("stockCode",stockVal,true);
		setStockInfo("stockName",data[1],true); // 证券名称
		
		//转让方式标签
		if(data[14] && stbtransTypeMap[data[14]]){
			stock_info.stbtrans_type = data[14];
			var labelVal= stock_html.label_g.eq(0);
			labelVal.show();
			labelVal.find("b").text(stbtransTypeMap[data[14]]);
		}
		//股转分层标签
		var wjc = data[15];
		if(wjc && stbLayerMap[wjc]){
			var labelVal= stock_html.label_g.eq(1);
			labelVal.show();
			labelVal.find("b").text(stbLayerMap[wjc]);
			stock_info.stb_layer = wjc;
		}
        if(stock_info.second_type === "BKZ"){
            var labelVal= stock_html.label_g.eq(1);
			labelVal.show();
			labelVal.find("b").text("京债");
			stock_info.stb_layer = wjc;
        }else if(stock_info.second_type === "GKZ"){
            var labelVal= stock_html.label_g.eq(1);
			labelVal.show();
			labelVal.find("b").text("股转");
			stock_info.stb_layer = wjc;
        }
		labelNameCss();
		
		// 2.更新股票类型，从行情接口判断证券基础信息，包含：（价格步进值&价格精度、数量步进值、证券单位）
		stock_info.stock_type_hq = data[2];//股票类型
		var typeObj = commonHq.getNewHqtypeData(stockVal,stock_info.stock_type_hq);
		entrustWayInit();
		// stock_info.stock_unit = typeObj.unit_name ? typeObj.unit_name : stock_info.stock_unit;// 更新证券单位
		// if(stock_info.stock_unit){
		// 	$(_pageId + " p.limit em").text(stock_info.stock_unit);
		// }
		
		var priceStep = data[9];//价差
		if(priceStep){
			stock_info.price_step = Number(priceStep);
			var _priceDigit = stock_info.price_step.toString().split(".");
			if(_priceDigit){
				_priceDigit = _priceDigit[1].length;
				stock_info.price_digit = _priceDigit ? _priceDigit : stock_info.price_digit;
			}
		}
		
		var buy_unit = data[10] ? Number(data[10]) : 0;
		if(buy_unit != 0){
			stock_info.lot_size = buy_unit;//数量单位
		}
		
		// 3.从行情搜索接口更新股票类型，按股票类型转译为交易接口对应的交易市场，并保存起来
		stock_info.exchange_type =String(typeObj.exchange_type)  || stock_html.stock_account.attr("exchange_type");
		
		// 4、根据交易市场，获取对应的股东账号列表
		setShareholderAccount();
		
		
		// 6、更新委托方式
		stock_info.stock_market = data[3];
		entrustInit();//带入委托方式的时候，改变价格下拉框
		
		// 7、保存最新价（如果有就传给“证券基础信息查询”的接口）
		var price = data[4] ? data[4]:data[5];
		stock_info.last_price = Number(price).toFixed(stock_info.price_digit);
		
		// 8、更新涨跌停，当涨停价跌停价其中之一为0时，则涨跌停价格均显示--（只从行情取）
		if((data[6] && data[6] != 0 && !isNaN(Number(data[6]))) && (data[7] && data[7] != 0 && !isNaN(Number(data[7])))) {
			setStockInfo("upStop",$.transferText(data[6],stock_info.price_digit),true);
			setStockInfo("downStop",$.transferText(data[7],stock_info.price_digit),true);
		}else{
			setStockInfo("upStop","--",true);
			setStockInfo("downStop","--",true);
		}
		
		//填充最新、参考、匹配、不匹配（只从行情取）
		if(stock_html.referenList){
			stock_html.referenList.eq(0).text($.transferText(stock_info.last_price));
			var reference = Number(data[11]).toFixed(stock_info.price_digit);
			stock_html.referenList.eq(1).text($.transferText(reference));
			stock_html.referenList.eq(2).text($.transferText(data[12]));
			stock_html.referenList.eq(3).text($.transferText(data[13]));
		}
		
		// 查询五档（20003）
		stock_info.gear_one = true;
		setFifthOrder();
		_fifthCallback = false;
		commonTimer.setTimer(_pageId+"Hqwd", function(){
			if(commonHq.getTradingTime() && _fifthCallback){
				setFifthOrder();
				_fifthCallback = false;
			}
		}, (global.refreshTime || 5000));//定时刷新
		
		//查询证券基础信息
		queryMaxAmount(stockVal);
	}
	
	/**
	 * 通过输入的字符查询出对应的股票列表
	 * @param {Object} stockCode 输入的字符
	 */
	function getStockList(stockCode,market){
		stock_info._isQueryTradeListFail = false;
		if(stockCode != ""){
			var param = {
				"stockCode": stockCode,
				"type":"17:31:32:33:34:35:36:37:38:39:40:41:42",
				"market": market
			};
            $.clearRequest();
			commonHq.getNewThirdStockList(param,stock_html.stockList,
				function(data){
					ListData(data,param);
				},
				function(data){
					stock_info._isQueryTradeListFail = true;
					stock_info.stockCode = data.stockCode;
					stock_info.fifthGearReturn = true;
					//模糊搜索失败了，没有对应的市场，不清空就会传页面默认的，会出现市场不对应的情况
					stock_info.exchange_type = "";
					queryData(data.stockCode);
				}
			);
		}
	}
	
	//五档买卖盘
	function setFifthOrder(){
		var market = stock_info.stock_market, stockCode = stock_info.stockCode;
		if(market && stockCode){
			var stock_list = market+":"+stockCode
			var price_digit = stock_info.price_digit;
			//填充五档
			commonHq.getFifthOrder(stock_list,function(results){
				_fifthCallback = true;
				var yesProfit = results[26];
				if(stock_info.gear_one){
					var fifthOne = "";
					var presentPrice = results[30];
					if(isBuy()){
						fifthOne = results[10] || results[16];
					}else{
						fifthOne = results[16] || results[10];
					}
					if(presentPrice != 0 && (fifthOne == 0 || presentPrice == stock_info.upStop || presentPrice == stock_info.downStop)){
						fifthOne = presentPrice;
					}
					stock_info.opponentPrice = fifthOne;
					stock_info.gear_one = false;
				}
				//卖五档盘颜色集合
				for(var i = 0 ; i < 5 ; i ++){
					addColor(stock_html.buyGear.eq(i),results[16+i],yesProfit,results[21+i],price_digit);
					addColor(stock_html.sellGear.eq(i),results[6+i],yesProfit,results[11+i],price_digit);
				}
	
				stock_info.fifthGearReturn = true;
				fillingPrice();
			},function(){
				_fifthCallback = true;
				stock_info.fifthGearReturn = true;
				fillingPrice();
			});
		}
	}
	
	
	
	//根据昨收改动价格颜色 , 没有价格的地方显示“--”
	function addColor(div,price,yesProfit,num,price_digit){
		var prices = div.find("span");
		var nums = div.find("em");
		yesProfit = Number(yesProfit).toFixed(price_digit);
		price = Number(price).toFixed(price_digit);
		if(Number(price) == 0){
			prices.text("--").attr("class","");
		}
		else if(Number(price) > Number(yesProfit)){
			prices.text(price).attr("class","ared");
		}
		else if(Number(price) < Number(yesProfit))
		{
			prices.text(price).attr("class","agreen");
		}
		else
		{
			prices.text(price).attr("class","");
		}
		if(Number(num) == 0){
			// num 返回0 时，先判断价格是否也是0 是显示--，不是显示0
            if(Number(price) == 0){
                nums.text("--");
            }else{
                nums.text(num);
            }
		}
		else if(Number(num) >= 100000){
			nums.text((num * 0.0001).toFixed(2) + "万");
		}
		else{
			nums.text(num);
		}
	}
	
	
	/**
	 * @description 证券基础信息查询
	 * */
	function queryMaxAmount(stockCode){
		stock_html.stockList.html("");
		//委托方式
		var entrust_bs = stock_html.market_p.attr("type");
		if(!isBuy()){
			entrust_bs = (Number(entrust_bs)+1) + "";
		}
		var exchange_type = stock_info.exchange_type || stock_html.stock_account.attr("exchange_type") || _exchange[stock_info.stock_type_hq+""];
		var param = {
				"entrust_way":global.entrust_way,// 委托方式  在configuration配置
				"branch_no":userInfo.branch_no,//分支机构
				"fund_account":userInfo.fund_account,//资产账户
				"cust_code":userInfo.cust_code,//客户代码
				"password":userInfo.password,//密码
	            "sysnode_id":userInfo.sysnode_id,//系统节点编号
				"session_id":userInfo.session_id,
				"entrust_bs":entrust_bs,
				"stock_code":stockCode,
				"entrust_price":stock_info.last_price,
	            "exchange_type":exchange_type
			};
		service_third.querythirdNewMaxBuy(param,function(data){
	  	  	queryMaxAmountCallBack(data);
	  	},{"isLastReq":false,"isShowWait":true,
			"timeout": global.stockTimeout,
			"timeOutFunc": function(){
				stock_info.securitiesInfoReturn = true;
				fillingPrice();
			},"errorFunc":function(){
				stock_info.securitiesInfoReturn = true;
				fillingPrice();
			},
		});
		
	}
	
	/** 
	 * @description 证券基础信息查询回调
	 * @param {type} data 
	 */
	function queryMaxAmountCallBack(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length == 1){
				//输入满六位，存在唯一结果收起键盘
				if(keyboard){
					keyboard.closeKeyPanel();
				}
				//更新股票代码、股票名称
				$(_pageId + " #stockCode").removeClass("C100");
				var stock_code = results[0].stock_code || stock_info.stockCode;
				_stockCode = stock_code;
				setStockInfo("stockCode",stock_code,true);
				setStockInfo("stockName",results[0].stock_name,true);
				
				//转让类型标签
				if(results[0].stbtrans_type.trim() && stbtransTypeMap[stock_info.stbtrans_type]){
					stock_info.stbtrans_type = results[0].stbtrans_type;
					var labelVal= stock_html.label_g.eq(0);
					labelVal.show();
					labelVal.find("b").text(stbtransTypeMap[stock_info.stbtrans_type]);
				}
				//股转分层
				
                if(stock_info.second_type === "BKZ"){
                }else if(stock_info.second_type === "GKZ"){
                }else if(results[0].stb_layer.trim() && stbLayerMap[stock_info.stb_layer]){
					var labelVal= stock_html.label_g.eq(1);
					labelVal.show();
					stock_info.stb_layer = results[0].stb_layer;
					labelVal.find("b").text(stbLayerMap[stock_info.stb_layer]);
					entrustWayInit();
				}
				labelNameCss();
				// 判断是否京A股票，京A股票提示文本
				isBJ(results[0].stb_layer);
				
				//更新价格步进值&价格精度
				stock_info.price_step = results[0].price_step ? results[0].price_step : stock_info.price_step;
				stock_info.price_digit = results[0].point ? results[0].point : stock_info.price_digit;
					
				//更新数量步进值
				var buy_unit = results[0].buy_unit ? Number(results[0].buy_unit) : 0;
				if(buy_unit != 0){
					stock_info.lot_size = buy_unit;
				}
					
				// //更新证券单位（交易有就更新）
				// stock_info.stock_unit = results[0].store_unit ? results[0].store_unit : stock_info.stock_unit;
				// if(stock_info.stock_unit){
				// 	$(_pageId + " p.limit em").text(stock_info.stock_unit);
				// }
				
				//更新交易市场、股票类型
				stock_info.exchange_type =String(results[0].exchange_type)  || stock_html.stock_account.attr("exchange_type");
				stock_info.stock_type_trade = results[0].stock_type;
				
				//根据交易市场，获取对应的股东账号列表
				setShareholderAccount();
				
				
				//将交易市场转译成行情的市场，并更新委托方式
				stock_info.stock_market = commonHq.getHqMarket(stock_info.exchange_type);
				entrustInit();
				
				//保存最新价
				if(!stock_info.last_price){//行情没有返回最新价的情况
					stock_info.last_price = results[0].price ? Number(results[0].price).toFixed(stock_info.price_digit) : "";//保存交易的最新价
				}
				
				//更新价格
				stock_info.securitiesInfoReturn = true;
				fillingPrice();
				//如果交易模糊列表查询失败直接请求证券基础信息开启五档查询
				if(stock_info._isQueryTradeListFail) setFifthOrder();
				
				//异步处理：风险警示等产品状态信息，弹框提示(根据项目实际情况来定义)
				if(results[0].warn_info&&results[0].warn_info!=""){
					$.alert(results[0].warn_info);
				}
        if(isBuy()){
          notice_no = results[0].notice_no;//系统提示信息 为4时，显示弹框
          notice_info = results[0].notice_info;//系统提示信息
          if(notice_no === "4"){
            common.singleIConfirmNew("温馨提示",notice_info,function(){ },"我知道了");
          }
        }
			}
			else if(results.length > 1){
				$.hidePreloader();
				var selectHeight = 0.4*results.length;
				if(results.length >= 7){
					selectHeight = 7 * 0.4;
				}
				var listHtml = "<ul style=\"display:block;overflow-y:auto;height:"+selectHeight+"rem\">";
				for(var i = 0;i < results.length; i++) {
					listHtml += "<li><a href=\"javascript:void(0);\" style=\"padding-left:0.20rem;\"><strong style=\"font-size:0.15rem\" stock_name='"+results[i].stock_name+"'>"+results[i].stock_code+"</strong><em>"+results[i].stock_name+"</em></a>";
					listHtml +=	"<span style=\"display:none;\">"+results[i].exchange_type+"</span></li>";
				};
				listHtml+="</ul>";
				stock_html.stockList.html(listHtml).show();
				$.bindEvent($(_pageId + " .select_box ul li"),function(e){
					var exchange_type = $(this).find("span").text();
					stock_html.stock_account.attr("exchange_type",exchange_type);
					var stockCode = $(this).find("strong").text();
					setStockInfo("stockName",$(this).find("em").text(),true);
					stock_html.stockList.html("");
					queryData(stockCode);
					//埋点
					var name = $(this).find("strong").attr("stock_name");
					var objectId = stock_html.stockList.attr("objectId");
					var actionId = stock_html.stockList.attr("actionId");
					common.comStat(objectId,2,actionId,true,{"i_change_name":"股票输入","i_change_to":name});
					e.stopPropagation();
				});
			}
		}else if(data.error_no == -310700100){ // 证券代码不存在
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.alert(data.error_info);
		}else{
			if(keyboard){
				keyboard.closeKeyPanel();
			}
		}
	}
	
	/**
	 * @description 查询最大可买、卖数量
	 */
	function queryStockMaxAmount(){
		stock_html.stockList.html("");
		var stock_price = getStockInfo("stockPrice");
		//价格为空，不查询接口
		if(!stock_price){
			$.hidePreloader();
			return false;
		}
		//委托方式
		var entrust_bs = stock_html.market_p.attr("type");
		if(!isBuy()){
			entrust_bs = (Number(entrust_bs)+1) + "";
		}
		var param = {
			"entrust_way":global.entrust_way,// 委托方式  在configuration配置
			"branch_no":userInfo.branch_no,//分支机构
			"fund_account":userInfo.fund_account,//资产账户
			"cust_code":userInfo.cust_code,//客户代码
			"password":userInfo.password,//密码
			"session_id":userInfo.session_id,
			"entrust_bs":entrust_bs,
			"stock_code":stock_info.stockCode,
			"entrust_price":stock_price,
			"stock_account": stock_info.stock_account,
			"exchange_type":stock_info.exchange_type || stock_html.stock_account.attr("exchange_type") || _exchange[stock_info.stock_type_hq+""],
			"stock_type": stock_info.stock_type_trade
		};
		var _interface= isBuy() ? "queryThirdMaxAmountBuy" : "queryThirdMaxAmountSell";
	  	service_third[_interface](param,function(data){
		  	queryMaxAmountCallBackMax(data);
	  	},{"isLastReq":true,"isShowWait":true});
	}
	
	function queryMaxAmountCallBackMax(data){
		if(data.error_no == 0){
			var results = data.results;
			if(results.length > 0){
				var stock_max_amount = results[0].stock_max_amount;
				if(!validatorUtil.isEmpty(stock_max_amount)) {
					if(!clearMaxNumber) setStockInfo("stockMaxAmount",Number(stock_max_amount),true);
				}else{
					if(!clearMaxNumber) setStockInfo("stockMaxAmount",'--',true);// 不抛错，前端最大可买卖数显示为“--”
				}
			}else{
				if(!clearMaxNumber) setStockInfo("stockMaxAmount",'--',true);// 不抛错，前端最大可买卖数显示为“--”
			}
		}else{
			if(!clearMaxNumber) setStockInfo("stockMaxAmount",'--',true);// 不抛错，前端最大可买卖数显示为“--”
		}
	}
	
	/*
	 *填充价格，查询最大数量
	 */
	function fillingPrice(){
		//自动刷新以及切换为保护限价后点右上角手动刷新，这两种情况价格都不更新
		if(stock_info.securitiesInfoReturn && stock_info.fifthGearReturn){
			if(!stock_info.market_price){
			var p_price = _PageParam["entrust_price"];
			if((p_price != (""||null||undefined)) && validatorUtil.isNumberFloat(p_price)){
				price = p_price ;
				var p_num = getStockInfo("stockNum");
				totalValue(Number(p_price),p_num);
			}
			var _price = p_price || stock_info.opponentPrice || stock_info.last_price;
			if((_price != (""||null||undefined)) && validatorUtil.isNumberFloat(_price)){
				setStockInfo("stockPrice",Number(_price).toFixed(stock_info.price_digit),true);
				if(stock_info.priceChangeFlag){
					common.changeFontSize($(_pageId + " #stockPrice"));
					stock_info.priceChangeFlag = false;
				}
				isQueryMax();
			}else{
				$.hidePreloader();
				}
			}else{
				isQueryMax();
			}
			stock_info.securitiesInfoReturn = false; 
			stock_info.fifthGearReturn = false; 
		}else{
			$.hidePreloader();
		}
	}

	// 标签样式
	function labelNameCss(){
		$(_pageId+".deleteBefore").removeClass("thirdTwo");
		stock_html.label_g.eq(1).removeClass("labelTwo");
		var labelOne = stock_html.label_g.eq(0).css("display") == "none" ? false : true;
		var labelTwo = stock_html.label_g.eq(1).css("display") == "none" ? false : true;
		if(labelOne && labelTwo){
			$(_pageId+".deleteBefore").addClass("thirdTwo");
			stock_html.label_g.eq(1).addClass("labelTwo");
		}
	}
	
	// 计算当前总值
	function totalValue(stockPrice,stockNum){
		if(stock_html){
			stock_html.total.text("").hide();
		}
		if(validatorUtil.isNumberFloat(stockPrice) && validatorUtil.isNumeric(stockNum)){
			if(stock_info.stockCode){
				var amount = commonHq.calculateStockAmountNew(stockPrice,stockNum,stock_info.stockCode);
				var text = $.formatMoney(""+amount);
				stock_html.total.text(text).show();;
			}
		}
	}
	
	
	/*
	 * @description 委托方式初始化
	 */
	function entrustInit(){
		// //设置默认委托方式
		// stock_html.market_p.text("限价委托").attr("type","0");
		// stock_html.market_p.attr("category","SH");
		
		var entrustBs = _PageParam["entrust_bs"];
		if(entrustBs){
			//委托方式带入到下单页面填充
			var entrustName=null;
			if(!isBuy()){
				entrustBs=Number(entrustBs)-1;
			}
			entrustName ={"0":"限价委托","70":"对手方最优价格","68":"本方最优价格","64":"最优五档即时成交剩余撤销","62":"最优五档即时成交剩余转限价"};
			stock_html.market_p.text(entrustName[entrustBs]);
			stock_html.market_p.attr("type",entrustBs);
			
			//切换页面UI
			if(entrustBs == "0" || entrustBs == "1"){//限价委托
				UIchange(true);
			}else{//市价委托
				UIchange();
			}
		
		}
	}
	
	/*
	 * @description 页面UI切换的时候
	 */
	function UIchange(isFixedPrice){
		// $(_pageId + " .row_04 p").removeClass("check");
		if(isFixedPrice){//限价
			$(_pageId + ".sj").hide();
			$(_pageId + ".xj").show();
			stock_html.stockPrice=$(_pageId + " #stockPrice");
			stock_info.market_price = false;
			if(isBuy()){//买入的时候需要切换最大可买
				$(_pageId + " #maxNumber").show();
				$(_pageId + " #protectMaxNumber").hide();
				stock_html.stockMaxAmount=$(_pageId + " #maxNumber");
				setStockInfo("stockMaxAmount",$(_pageId + " #maxNumber").text(),true);
			}
		}else{//市价
			$(_pageId + ".sj").show();
			$(_pageId + ".xj").hide();
			stock_html.stockPrice=$(_pageId + " #protectStockPrice");
			stock_info.market_price = true;
			if(isBuy()){//买入的时候需要切换最大可买
				$(_pageId + " #maxNumber").hide();
				$(_pageId + " #protectMaxNumber").show();
				stock_html.stockMaxAmount=$(_pageId + " #protectMaxNumber");
				setStockInfo("stockMaxAmount",$(_pageId + " #protectMaxNumber").text(),true);
			}
		}
	}
		
	/**
	 * 下单验证
	 * */
	function vailSubmitOrder(){
		var typeText = "买入";
		if(!isBuy()){
			typeText = "卖出";
		}
		//验证股票代码输入是否正确
		var stockCode = stock_info.stockCode;
		if(stockCode.length == 0){
			$.alert("请输入正确的证券代码/简拼");
			return false;
		}	
		var vai1 = /^[0-9]{6}$/;
		if(!vai1.test(stockCode)){
			$.alert("股票代码输入错误");
			return false;
		}	
		//验证股票价格输入是否正确
		var stockPrice = getStockInfo("stockPrice");
		if($.trim(stockPrice).length<=0){
			if(stock_info.market_price){
				$.alert("请输入保护限价");
			}else{
			$.alert("请输入"+typeText+"价格");
			}
			return false;
		}else if(!validatorUtil.isNumberFloat(stockPrice)){
			$.alert("请正确输入价格");
			return false;
		}
		else if(parseFloat(stockPrice)<=0){
			$.alert("价格必须大于0");
			return false;
		}
		var stockMaxAmount = stock_info.stockMaxAmount+"";
		//验证买入数量
		var stockNum = getStockInfo("stockNum");
		if($.trim(stockNum).length<=0){
			$.alert("请输入"+typeText+"数量");
			return false;
		}else if(!validatorUtil.isNumberFloat(stockNum)){
			$.alert("请正确输入数量");
			return false;
		}
		else if(parseFloat(stockNum)<=0){
			$.alert("数量必须大于0");
			return false;
		}
		var ts = "";
		//验证最大可买
		if($.trim(stockMaxAmount).length<=0||parseFloat(stockMaxAmount)<=0){
			ts += "<em>最大可"+typeText+"为0；</em>";
		}
		else if(parseFloat(stockMaxAmount)<parseFloat(stockNum)){
			ts += "<em>最大可"+typeText+"数量不足；</em>";
		}
		
		var	up_stop = stock_info.upStop;
		var	down_stop = stock_info.downStop;
		var tipStrArray = [];
		tipStrArray.push(["证券代码", stockCode]);
		tipStrArray.push(["证券名称", stock_info.stockName]);
		tipStrArray.push(["委托方式", stock_html.market_p.html()]);
		tipStrArray.push([(stock_info.market_price? "保护限价":"委托价格"), stockPrice]);
		tipStrArray.push(["委托数量", stockNum]);
		if(up_stop && up_stop !="--" && up_stop != 0 && Number(stockPrice) > Number(up_stop)){
			ts += "<em>"+(stock_info.market_price? "保护限价":"委托价格")+"超过涨停价；</em>";
		}else if(down_stop && down_stop != "--" && down_stop != 0 && Number(stockPrice) < Number(down_stop)){
			ts += "<em>"+(stock_info.market_price? "保护限价":"委托价格")+"低于跌停价；</em>";
		}
		// var tipStr = "<div ><p>"+userInfo.client_name+" ("+common.setAsteriskHide(userInfo.fund_account,4,4,4)+")</p>";
		var tipStr = "<div ><p>"+userInfo.client_name+" ("+(stock_info.stock_account || "--")+")</p>";
		tipStr += common.generatePrompt(tipStrArray);
		if(ts){
			tipStr += "<div class='_reminder'><span class='b'>温馨提示：</span><span class='w'>"+ts+"</span></div>";
		}
		tipStr+="</div>";
		//委托方式
		var entrust_bs = stock_html.market_p.attr("type");
		if(!isBuy()){
			entrust_bs = (Number(entrust_bs)+1) + "";
		}
		//埋点数据
		var comStatParam={
			"i_entrust_bs":isBuy() ? "1" : "2", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":stockCode, // 股票代码
			"i_stock_name":stock_info.stockName, // 股票名称
			"i_entrust_prop":entrust_bs, // 委托属性
			"i_exchange_type":stock_info.exchange_type, // 交易市场
			"i_entrust_price":stockPrice, // 选择后的价格
			"i_entrust_amount":stockNum, // 委托数量
		}
		common.iConfirm(typeText+"确认",tipStr,function success(){
			var param = {
				"entrust_way":global.entrust_way,// 委托方式  在configuration配置
				"branch_no":userInfo.branch_no,//分支机构
				"fund_account":userInfo.fund_account,//资产账户
				"cust_code":userInfo.cust_code,//客户代码
				"password":userInfo.password,//密码
				"session_id":userInfo.session_id,
				"entrust_bs":entrust_bs,
				"exchange_type":stock_info.exchange_type || stock_html.stock_account.attr("exchange_type") || _exchange[stock_info.stock_type_hq+""],
				"stock_account":stock_info.stock_account,
				"stock_code":stockCode,
				"entrust_price":stockPrice,
				"entrust_amount":stockNum
			};
			service_third.getthirdNewBuy(param,getStockBuyCallBack,{"isShowOverLay":false,"isShowWait":false,
				"timeOutFunc":function(){
					$.hidePreloader();
				},"errorFunc":function(){
					$.hidePreloader();
				}});
			$.showPreloaders("请等待...");
			comStatParam.i_oper = "1";
			common.comStat((isBuy() ? "101734" : "101764"),2,3,false,comStatParam);
		},function fail(){
			comStatParam.i_oper = "0";
			common.comStat((isBuy() ? "101734" : "101764"),2,3,false,comStatParam);
		},"确定","取消",null,"tap");
	}
	
	/**
	 * 委托下单返回
	 * */
	function getStockBuyCallBack(data){
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
			if(results && results.length>0){
				_checkoutSuccess = true;
				var tipStr = "<span style='font-weight:bold;font-size: 18px;'>交易提示</span><br>交易委托已提交，委托编号："+results[0].entrust_no;
				$.alert(tipStr);
				clearBuyMsg();
				setStockInfo("stockCode","");// 股票价格
				$(_pageId + " #stockCode").addClass("C100");
			}
			queryHolding(true);
		}else{
			$.alert(data.error_info);
		}
	}
	
	/**
	* 查询持仓数据
	*isShowWait  是否等待转圈
	 */
	function queryHolding(isShowWait){
		_callback = false;
		var param={
			"entrust_way":global.entrust_way,
			"branch_no":userInfo.branch_no,
			"fund_account":userInfo.fund_account,
			"cust_code":userInfo.cust_code,
			"session_id":userInfo.session_id,
			"stock_account":"",
			"stock_code":"",
			"exchange_type":""
		};
		service_third.querythirdData(param,queryHoldingCallback,{
			"isLastReq":true,
			"isShowWait":isShowWait,
			"isShowOverLay":false,
			"timeout": global.stockTimeout,
			"timeOutFunc":function(){
				$.hidePreloader();
				_callback = true;
				// common.setQueryFail(true);
				// $.Template7.global = {
				//     isShow: (global.serverConfig=="2" ? true : false)
				// };
				// $(_pageId+" .fund_table .ce_table").remove();
				// var template = $('#templateTitle').html();
				// var compiledTemplate = $.Template7.compile(template);
				// fillHtml.html(compiledTemplate());
				// if(_initScroller){
				// 	_initScroller(true);
				// }
			},"errorFunc":function(){
				$.hidePreloader();
				_callback = true;
				// common.setQueryFail(true);
				// $.Template7.global = {
				//     isShow: (global.serverConfig=="2" ? true : false)
				// };
				// $(_pageId+" .fund_table .ce_table").remove();
				// var template = $('#templateTitle').html();
				// var compiledTemplate = $.Template7.compile(template);
				// fillHtml.html(compiledTemplate());
				// if(_initScroller){
				// 	_initScroller(true);
				// }
			}});
	}
	
	function queryHoldingCallback(data){
		_callback = true;
		$.Template7.global = {
			isShow: (global.serverConfig=="2" ? true : false)
		};
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					common.setNoData(false);
					$(_pageId+" .position_div .ce_table tr").slice(1).unbind();
					$(_pageId+" .position_div .ce_table").remove();
					var template = $('#template').html();
					var winWidth = $(window).width();
					$.Template7.registerHelper("getTransformScale",  function(text, size){
						return $.getTransformScale(text, size, winWidth*0.25 - 20)
					})
					var compiledTemplate = $.Template7.compile(template);
					fillHtml.html(compiledTemplate(data));
					
					//卖出事件
					$.bindEvent($(_pageId+" .position_div .ce_table tr").slice(1), function(e){
						clearBuyMsg();// 清除数据
						var stockCode = $(this).attr("id");
						$(_pageId + " #stockCode").removeClass("C100");
						$(_pageId + " #stockCode").quzhi(stockCode);
						_stockCode = stockCode;
						var exchange_type = $(this).attr("exchange_type");
						var stock_account = $(this).attr("stock_account");
						stock_html.stock_account.attr("exchange_type",exchange_type);
						stock_html.stock_account.attr("stock_account",stock_account);
						stock_info.stockCode = stockCode;
						stock_info.stock_market = commonHq.getHqMarket(exchange_type);
						var objectId = (isBuy()?101735:101765);
						common.comStat(objectId,2,104,true,{"i_change_name":"持仓列表","i_change_to":stockCode});//埋点
						getStockList(stockCode);
						if(_slideReset){
							_slideReset();
						}
						e.stopPropagation();
					});
				}else{
					common.setNoData(true,"暂无持仓记录");
					$(_pageId+" .position_div .ce_table").remove();
					var template = $('#templateTitle').html();
					var compiledTemplate = $.Template7.compile(template);
					fillHtml.html(compiledTemplate());
				}
			}else{
				common.setQueryFail(true);
				$(_pageId+" .position_div .ce_table").remove();
				var template = $('#templateTitle').html();
				var compiledTemplate = $.Template7.compile(template);
				fillHtml.html(compiledTemplate());
			}
		}else{
			common.setQueryFail(true);
			$(_pageId+" .position_div .ce_table").remove();
			var template = $('#templateTitle').html();
			var compiledTemplate = $.Template7.compile(template);
			fillHtml.html(compiledTemplate(data));
		}
		if(_initScroller){
			_initScroller(true);
		}
	}

	
	/*
	 * @description 更新页面带入的参数
	 */
	function updatePageInfo(stockCode){
		//代码
		$(_pageId + " #stockCode").removeClass("C100");
		$(_pageId + " #stockCode").quzhi(stockCode);
		//数量
		var p_num = _PageParam["num"] || _PageParam["entrust_amount"];
		if(p_num && p_num != 0 && validatorUtil.isNumeric(p_num)){
			setStockInfo("stockNum",p_num,true);
			var stockPrice = getStockInfo("stockPrice");
			totalValue(stockPrice,p_num);
		}
		stock_info.stock_market = _PageParam["market"];
		//股东账号、市场
		stock_html.stock_account.attr("exchange_type",_PageParam["exchange_type"]);
		stock_html.stock_account.attr("stock_account",_PageParam["stock_account"]);
	}
	
	function entrustWayInit(){
        $(_pageId+"  #entrustWay").removeClass("unBind");
		//当层级为空或者确定不为精选层，都可以选择委托方式
		if((stock_info.stock_type_hq&&[40,41].indexOf(stock_info.stock_type_hq)!=-1)||(stock_info.stb_layer && stock_info.stb_layer!="3")){
			$(_pageId+"  #entrustWay").unbind("click");
            $(_pageId+"  #entrustWay").addClass("unBind");
			stock_html.market_p.text("限价委托").attr("type","0");
			return false;
		}
		common.selectList($(_pageId+" #entrustWay"),'<span class="a03">选择委托方式</span>',market_html_data,function(obj){
			if(obj.name.length>10){
				stock_html.market_p.css("font-size","0.12rem");
			}else{
				stock_html.market_p.css("font-size","0.14rem");
			}
			stock_html.market_p.text(obj.name);
			stock_html.market_p.attr("type",obj.id);
			
			var objectId = "" ,actionId = "",name="";
			if(isBuy()){
				objectId=101736;
				actionId=104;
			}else{
				objectId=101766;
				actionId=104;
			}
			if(obj.id=="0"){//限价委托
				UIchange(true);
				name="限价";
			}else{
				UIchange();
				name="市价";
				//埋点
				var sjObjectId = "" ,sjActionId = "";
				if(isBuy()){
					sjObjectId=101737;
					sjActionId=104;
				}else{
					sjObjectId=101767;
					sjActionId=104;
				}
				common.comStat(sjObjectId,2,sjActionId,true,{"i_change_name":"市价类型","i_change_to":obj.name});
			}
			common.comStat(objectId,2,actionId,true,{"i_change_name":"委托类型","i_change_to":name});
			var stockPrice = getStockInfo("stockPrice");
			var stockNum = getStockInfo("stockNum");
			totalValue(stockPrice,stockNum);
			isQueryMax();
		},function(){
			$.bindEvent($("#selectList h1.titlehsea span.a03"), function(e){
				var page = _pageId.replaceAll("_","/").replaceAll("#","").replaceAll(" ","");
				$.pageInit(page, "stock/stockExplain");
				e.stopPropagation();
			});
		});
	}
  /**
   * @description 判断是否是京A股票   
   * @author cfx   
   * @date 2021-09-23 14:56:07   
   * @modifyContent 修改点描述...   
   */
  function isBJ(stkcode_ctrlstr){
    if(stkcode_ctrlstr === '3'){
      $.alert("此菜单只可进行新三板股票交易，请重新输入。若是北交所A股（原新三板精选层），请前往普通买卖交易。");
    }
  }
	/**
	 * 
	 */
	function clearBuyMsg(){
		_PageParam = {};
		stock_info = ioitStock();
		if(stock_html){
			stock_html.stock_account.attr("exchange_type","");
			stock_html.stock_account.attr("stock_account","");
			stock_html.label_g.hide();
			stock_html.label_g.find("b").text("");
			$(_pageId+".deleteBefore").removeClass("thirdTwo");
			stock_html.label_g.eq(1).removeClass("labelTwo");
			
			// stock_html.account_ul.hide();
	    	stock_html.stockName.html("<em class=\"placeholder stockCode\"></em>"); // 股票名称
	    	setStockInfo("stockPrice","");// 股票价格
	    	setStockInfo("stockNum",""); // 股票数量
	    	stock_html.stockNum.setPlaceholder("输入数量");
	    	setStockInfo("stockMaxAmount","--"); // 股票最大数
			stock_html.upStop.text("--"); //涨停价
	    	stock_html.downStop.text("--");//跌停价
		   	stock_html.total.text("").hide();
		   	stock_html.buyGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.buyGear.find("em").text("--");
			stock_html.sellGear.find("span").removeClass("agreen").removeClass("ared").text("--");
			stock_html.sellGear.find("em").text("--");
			stock_html.stockList.html("");
			stock_html.market_ul.html("");
			stock_html.referenList.text("--");
			stock_html.market_ul.hide();
			stock_html.label_g.removeClass("third");
			stock_html.label_g.find("span").removeClass();
			stock_html.label_g.find("b").text("");
			stock_html.market_p.attr("type","0").html("限价委托");
			$(_pageId + " #maxNumber").quzhi("--");//清空限价的数量框
			$(_pageId + " #protectMaxNumber").quzhi("--");//清空市价的数量框
			$(_pageId + " #maxNumber").show();//限价的数量框
			$(_pageId + " #protectMaxNumber").hide();//市价的数量框
			$(_pageId + " #stockPrice").quzhi("");//清空限价的价格框
			$(_pageId + " #protectStockPrice").quzhi("");//清空市价的价格框
			$(_pageId + ".sj").hide();
			$(_pageId + ".xj").show();
			//清空价格、数量输入框
			stock_html.stockMaxAmount=$(_pageId + " #maxNumber");
			stock_html.stockPrice=$(_pageId + " #stockPrice");
			stock_html.market_p.css("font-size","0.14rem");
			entrustWayInit();
			commonFunc.getNewStockAccount(["9","A"], userInfo, function(data){
				setAccountList(data);
			});
		}
		$.closeModal(".picker-modal.modal-in");
	   	commonTimer.clearTimer(_pageId+"Hqwd");
	   	_fifthCallback = true;
		$(_pageId + ".five_box ul li").removeClass("active");
//		$(_pageId+"  #entrustWay").unbind("click");
	}
	
	function dataDestroy(){
		$.clearRequest();
		$(_pageId+" .position_div .ce_table tr").slice(1).unbind();
		$(_pageId+" .position_div .ce_table").remove();
		_callback = true;
		$(_pageId + " #stockCode").quzhi("");
		$(_pageId + " #stockCode").addClass("C100");
		$(_pageId + " #account p").html('<em style="color: #ccc;">请选择股东账号</em>');
		$(_pageId + " #account ul").html("").hide();
		_stockCode = "";
		clearBuyMsg();
		commonTimer.clearTimer(_pageId);
		stock_info = null;
		stock_html = null;
		if(keyboard){
			keyboard.keyDestroy();
		}
		_checkoutSuccess = false;
		commonHq.clearCheckTradeTimer();
    // 退出页面后，销毁弹框
    $("#singleIConfirmNew").remove();
    $("#newTradingTipsBox2").remove();
	}
	
	var base = {
		"dataInit" : dataInit,
		"elementBindEvent": elementBindEvent,
		"dataDestroy": dataDestroy,
	};
	module.exports = base;
});
