/**
 * 股转系统要约收购申报
 */
define('trade/scripts/third/more/report.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_third = require("service_third");
    var _pageId = "#third_more_report ";
	var keyboard = require("keyboard");
	var yysgList = [];
	var userInfo = {};
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102090");
		if(keyboard){
			keyboard.keyInit();
		}
		userInfo = common.getCurUserInfo();
		common.bindStockEvent($(_pageId+".tab_nav ul li a"),true);
		yysgList = $.getPageParam("yysgList"); 
    }
	function load(){
		var mainHeight = $(window).height()-$(_pageId + " .top_title").height() - $(_pageId + " .tab_nav").height()-10;
		$(_pageId + " article.boost").height(mainHeight).css("overflow","auto");
		gfxzList();
		if(yysgList){
			creatHtml();
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//点击其他位置隐藏键盘
		$.bindEvent($(_pageId),function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}	
			e.stopPropagation();
		});
		
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102091, 2, 103, true, {"i_group_name": "返回"});
				if (keyboard) {
					keyboard.closeKeyPanel();
				}
				$.closeModal(".picker-modal.modal-in");
//			$.pageBack();
				$.pageInit("third/more/report", "third/order/order", {}, true, true);
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//选择按钮
		$.bindEvent($(_pageId + ".input_form #choose"), function(e){
			//埋点
			common.comStat(102103,2,103,true,{"i_group_name":"解除要约代码选择"});
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.closeModal(".picker-modal.modal-in");
			$.pageInit("third/more/report","third/more/reportList",{"fromPage":"third/more/report"});
			e.stopPropagation();
		});
		
		//下单按钮
		$.bindEvent($(_pageId + ".applyvote"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.closeModal(".picker-modal.modal-in");
			//埋点
			common.comStat(102100,2,103,true,{"i_group_name":"申购提交"});
			orderTrade();
			e.stopPropagation();
		});
		
		//全部按钮
		$.bindEvent($(_pageId + "#all"), function(e){
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$.closeModal(".picker-modal.modal-in");
			var enable = $(_pageId+"#enableAmount").html();
			if(enable!="--"){
				$(_pageId+"#entrustAmount").quzhi(enable);
			}
			//埋点
			if(yysgList || $.isValue(yysgList)){
				common.comStat(102099,2,2,false,{
					"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":"58", // 委托属性
					"i_exchange_type":yysgList.exchange_type, // 交易市场
					"i_stock_code":$(_pageId+"#applyCode").val(), // 股票代码
					"i_stock_name":$(_pageId+"#applyName").html(), // 股票名称
					"i_price":$(_pageId+" #purchasePrice").html(), // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":$(_pageId+"#enableAmount").html(), // 最大数量
					"i_target_cnt":$(_pageId+"entrustAmount").val(), // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		});
		
		//要约代码输入框
		$.bindEvent($(_pageId + " #applyCode"), function(e){
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var stock_code = $(_pageId+"#applyCode").val();
			if(stock_code.length==6){
				common.comStat(102102,2,104,true,{"i_change_name":"解除要约代码","i_change_to":stock_code});//埋点
				getYysgInfo(stock_code);
			}else{
				clearMsg();
			}
			e.stopPropagation();
		},"input");
		
		// 证券名称点击事件
		$.bindEvent($(_pageId+" #applyName"), function(e){
			$(_pageId + " #applyCode").triggerFastClick();
			$(_pageId + " #applyCode").focus();
			e.stopPropagation();
		});
		
		//要约数量输入框
		$.bindEvent($(_pageId + " #entrustAmount"), function(e){
			$.closeModal(".picker-modal.modal-in");
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			var stock_num = $(_pageId + "#entrustAmount").quzhi();
			stock_num = stock_num.replace(/\./g,"");
			$(_pageId + "#entrustAmount").quzhi(stock_num);
			e.stopPropagation();
		},"input");
		
		//数量框
		$.bindEvent($(_pageId+"#entrustAmount"), function(e){
			//埋点
			if(yysgList || $.isValue(yysgList)){
				common.comStat(102098,2,2,false,{
					"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
					"i_entrust_prop":"58", // 委托属性
					"i_exchange_type":yysgList.exchange_type, // 交易市场
					"i_stock_code":$(_pageId+"#applyCode").val(), // 股票代码
					"i_stock_name":$(_pageId+"#applyName").html(), // 股票名称
					"i_price":$(_pageId+" #purchasePrice").html(), // 选择后的价格
					"i_adjust_type":"5", // 调整方式（1,加 2,减 3快捷键 5,直接输入）
					"i_max_cnt":$(_pageId+"#enableAmount").html(), // 最大数量
					"i_target_cnt":$(this).val(), // 调整之后的数量
					"i_fast_btn":"", // 快捷键（全仓，1/2，1/4 ....（可留空））
				});
			}
			e.stopPropagation();
		},"blur");
	}
	
	function getYysgInfo(stock_code){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var stock_code = stock_code;
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
			    "purchase_id":stock_code
		};
		//最后一个为超时处理函数
		service_third.queryYysgList(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results!= "undefined" && results.length >0){
						yysgList = data.results[0];
						creatHtml();
					}else{
						$.alert("不存在此要约代码");
					}
				}else{
					$.alert(data.error_info);
				}
			}
		},
		{  //传给接口的json格式数据            
			"isLastReq":false,                
			"isShowWait":false,
			"isShowOverLay":false
	    });
	}
	
	function queryStockMaxBuy(){
		if(!yysgList || !$.isValue(yysgList)){
			return false;
		}
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	//分支机构
		var fund_account = userInfo.fund_account;	//资产账户
		var cust_code = userInfo.cust_code;	//客户代码
		var session_id = userInfo.session_id;
		var stock_code = yysgList.purchase_id;
		var entrust_price = yysgList.purchase_price;
		var exchange_type = yysgList.exchange_type;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"entrust_bs":"58",
				"stock_code":stock_code,
				"entrust_price":entrust_price,
	            "exchange_type":exchange_type,
	            "stb_stock_property":$(_pageId+" .back_form p.selecbox").attr("value"),
			};
  	  	service_third.queryYysgMaxBuy(param,function(data){
  	  		if(data){
				if(data.error_no=="0"){
					if(data.results.length>0){
						$(_pageId+"#enableAmount").html(data.results[0].stock_max_amount||"--");
						yysgList.stock_account = data.results[0].stock_account;
					}
				}else{
					$.alert(data.error_info);
				}
  	  		}
	  	  },{"isLastReq":true,"isShowWait":true});
	}
	
	function creatHtml(){
		$(_pageId+" #applyCode").quzhi(yysgList.purchase_id);
		$(_pageId+"	#applyName").html(yysgList.purchase_name).addClass("text_name");
		$(_pageId+" #purchaseId").html(yysgList.stock_code);
		// $(_pageId+" #purchaseName").html(yysgList.stock_name);
		$(_pageId+" #purchasePrice").html(yysgList.purchase_price);
		queryStockMaxBuy();
	}
	
	function gfxzList(){
		var market_html_data = [
			{"name":"无限售流通股","id":"00"},
			{"name":"挂牌后个人类限售股","id":"01"},
			{"name":"股权激励限售股","id":"02"},
			{"name":"挂牌后机构类限售股","id":"03"},
			{"name":"高管锁定股","id":"04"},
			{"name":"挂牌前个人类限售股","id":"05"},
			{"name":"挂牌前机构类限售股","id":"06"},
			// {"name":"非流通股","id":"07"}
		];
		common.selectList($(_pageId+" .back_form p.selecbox"),'选择股份性质',market_html_data,function(obj){
			$(_pageId+" .back_form p.selecbox").html(obj.name+"<i></i>").attr("value",obj.id);
			//顶点特殊处理：股份性质选择“无限售流通股”之外的股份性质，隐藏掉可用股数、【全部】按钮
			if(obj.id=="00"){
				$(_pageId+"#enableDiv").show();
				$(_pageId+"#entrustDiv").addClass("btn");
				$(_pageId+"#entrustDiv #all").show();
				queryStockMaxBuy();
			}else{
				$(_pageId+"#enableDiv").hide();
				$(_pageId+"#entrustDiv").removeClass("btn");
				$(_pageId+"#entrustDiv #all").hide();
			}
			common.comStat(102104,2,104,true,{"i_change_name":"解除股份性质","i_change_to":obj.name});//埋点
	 	});
	 	$(_pageId+" .back_form p.selecbox").html("无限售流通股<i></i>").attr("value","00");
	}
	
	function orderTrade(){
		var stock_code = $(_pageId+"#applyCode").val();
		var entrust_amount = $(_pageId+"#entrustAmount").val();
		if(stock_code.length!=6){
			$.alert("请输入要约申报代码");
			return false;
		}
		if(entrust_amount==""){
			$.alert("请输入预受数量");
			return false;
		}
		
		var tipStrArray = [];
		tipStrArray.push(["证券名称", yysgList.stock_name]);
		tipStrArray.push(["要约代码 ", stock_code]);
		tipStrArray.push(["股份性质 ", $(_pageId+" .back_form p.selecbox").html()]);
		tipStrArray.push(["预受数量 ", entrust_amount]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		//埋点数据
		var comStatParam={
			"i_entrust_bs":"1", // 交易方向( 1,买入 2,卖出)
			"i_stock_code":stock_code, // 股票代码
			"i_stock_name":yysgList.stock_name, // 股票名称
			"i_entrust_prop":"58", // 委托属性
			"i_exchange_type":yysgList.exchange_type, // 交易市场
			"i_entrust_price":yysgList.purchase_price, // 选择后的价格
			"i_entrust_amount":entrust_amount, // 委托数量
		}
		common.iConfirm("要约申报确认",tipStr,function success(){
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var branch_no  = userInfo.branch_no;	//分支机构
			var fund_account = userInfo.fund_account;	//资产账户
			var cust_code = userInfo.cust_code;	//客户代码
			var session_id = userInfo.session_id;
			var stb_stock_property = $(_pageId+" .back_form p.selecbox").attr("value");
			var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"session_id":session_id,
				"entrust_bs":"58",
				"stock_code":stock_code,
	            "exchange_type":yysgList.exchange_type,
				"stock_account":yysgList.stock_account,
				"stb_stock_property":stb_stock_property,
				"entrust_amount":entrust_amount
			};
	  	  	service_third.yysgOrder(param,function(data){
	  	  		if(data){
					if(data.error_no=="0"){
						$.alert("委托已提交成功，委托编号是:"+data.results[0].entrust_no);
						clearMsg();
						$(_pageId+"#applyCode").quzhi("");
					}else{
						$.alert(data.error_info);
					}
	  	  		}
		  	},{"isLastReq":true,"isShowWait":true});
			comStatParam.i_oper = "1"; // 动作（1确定 2取消）
			common.comStat(102101,2,3,false,comStatParam);
		},function fail(){
			comStatParam.i_oper = "2"; // 动作（1确定 2取消）
			common.comStat(102101,2,3,false,comStatParam);
		});
	}
    
    function clearMsg(){
		$(_pageId+"#purchaseId").html("--");
		$(_pageId+"#enableAmount").html("--");
		$(_pageId+"#purchasePrice").html("--");
		$(_pageId+"#entrustAmount").quzhi("");
		yysgList = [];
		$(_pageId + " #applyName").html("").removeClass("text_name");
		// $(_pageId + " #purchaseName").html("");
    }
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		clearMsg();
		$(_pageId+"#applyCode").val("");
		$(_pageId+" .back_form p.selecbox").html("无限售流通股<i></i>").attr("value","00");
		$.closeModal(".picker-modal.modal-in");
		if(keyboard){
			keyboard.keyDestroy();
		}
		$(_pageId+"#enableDiv").show();
		$(_pageId+"#entrustDiv").addClass("btn");
		$(_pageId+"#entrustDiv #all").show();
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});