/**
 * 股转系统要约收购列表
 */
define('trade/scripts/third/more/reportList.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_third = require("service_third");
	var service_hq = require("service_hq");
    var _pageId = "#third_more_reportList ";
    var downslide = new (require("downslide")).Downslide();
	var fromPage = "";
	var yysgList = [];
	var userInfo = null;
	var mainHeight = 0;
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102150");
		downslide.addSlide();
		fromPage = $.getPageParam("fromPage");
		userInfo = common.getCurUserInfo();
    }
	function load(){
		mainHeight = $(window).height()-$(_pageId + " .top_title").height() - $(_pageId + " .tab_nav").height()-10;
		$(_pageId + " article.boost").height(mainHeight);
		downslide.slideInit(mainHeight,queryData);
		queryData();
		
		if($(_pageId + ".tab_nav ul li").index()=="0"){
			$(_pageId+"#pull_down_slide").attr("objectId","102154");
			$(_pageId+"#pull_down_slide").attr("actionId","102");
		}else{
			$(_pageId+"#pull_down_slide").attr("objectId","102156");
			$(_pageId+"#pull_down_slide").attr("actionId","102");
		}
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102151, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//切换列表
		$.bindEvent($(_pageId + ".tab_nav ul li"), function(e){
			$(this).addClass("active").siblings().removeClass("active");
			if($(this).index()=="0"){
				$(_pageId + "#yysg").show().siblings().hide();
				//埋点
				common.comStat(102152,2,103,true,{"i_group_name":"要约收购信息"});
				$(_pageId+"#pull_down_slide").attr("objectId","102154");
				$(_pageId+"#pull_down_slide").attr("actionId","102");
			}else{
				$(_pageId + "#yyhg").show().siblings().hide();
				//埋点
				common.comStat(102153,2,103,true,{"i_group_name":"要约收购信息"});
				$(_pageId+"#pull_down_slide").attr("objectId","102156");
				$(_pageId+"#pull_down_slide").attr("actionId","102");
			}
			downslide.slideInit(mainHeight,queryData);
			queryData();
//			downslide.slideRefresh();
			e.stopPropagation();
		});
		
	}
	
	function queryData(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
		};
		//最后一个为超时处理函数
		service_third.queryYysgList(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					yysgList = data.results;
					if(results && results!= "undefined" && results.length >0){
						var html1="",html2="";
						var sgList = "",hgList = "";
						for(var i=0;i<results.length;i++){
							var market = "SH";
							if(results[i].exchange_type=="9"){
								market = "SZ";
							}
							if(results[i].purchase_sign=="1"){
								html2 += creatHtml(results[i],i,true);
								sgList += market + ":" + results[i].stock_code;
							}else{
								html1 += creatHtml(results[i],i,false);
								sgList += market + ":" + results[i].stock_code;
							}
						}
						$(_pageId + "#yysg").html(html1);
						$(_pageId + "#yyhg").html(html2);
						// getNumberSg(sgList,"2");
						// getNumberHg(hgList,"3");
						//点击列表
						$.bindEvent($(_pageId + ".cancel_order .part"), function(e){
							var i = $(this).attr("index");
							//埋点
							$(this).addClass("active").siblings().removeClass("active");
							if($(this).index()=="0"){
								common.comStat(102155,2,104,true,{"i_change_name":"要约收购信息列表","i_change_to":yysgList[i].stock_name});
							}else{
								common.comStat(102157,2,104,true,{"i_change_name":"要约回购信息列表","i_change_to":yysgList[i].stock_name});
							}
							$.pageInit("third/more/reportList",fromPage,{"yysgList":yysgList[i]},true);
							e.stopPropagation();
						});
						
					}else{
						common.setNoData(true);
					}
				}else{
					$.alert(data.error_info);
					common.setNoData(true);
				}
				downslide.slideRefresh();
			}
		},
		{  //传给接口的json格式数据            
			"isLastReq":false,                
			"isShowWait":false,
			"isShowOverLay":false
	    });
	}
    
    function creatHtml(result,i,type){
    	var html = "<div index="+i+" class=\"part\">";
    	html += "<div class=\"title\">";
    	html += "<strong>"+result.purchase_name+"</strong><small>"+result.purchase_id+"</small><span class=\"time color\">"+result.purchase_status_name+"</span>";
    	html += "</div><ul>";
    	html += "<li><span>要约价格</span><p>"+result.purchase_price+"</p></li>";
//  	html += "<li><span>要约类型</span><p>"+result.purchase_type_name+"</p></li>";
    	html += "<li><span>开始日期</span><p>"+result.begin_date+"</p></li>";
    	// html += "<li><span>标的名称</span><p>"+result.stock_name+"</p></li>";
    	html += "<li><span>结束日期</span><p>"+result.end_date+"</p></li>";
    	html += "<li><span>标的代码</span><p>"+result.stock_code+"</p></li>";
    	// if(type){
    	// 	html += "<li class="+result.stock_code+"><span>回购数量</span><p>--</p></li>";
    	// }else{
    	// 	html += "<li class="+result.stock_code+"><span>收购数量</span><p>--</p></li>";
    	// }
    	html += "</ul></div>";
    	return html;
    }
    
    // //获取收购/回购数量
    // function getNumberSg(stock_list,dataType){
    // 	var param = {
    // 		"version":"1",
		  //   "dataType":dataType,
		  //   "stock_list":stock_list
    // 	};
    // 	service_hq.getReportAmount(param,function(data){
    // 		if(data.errorNo=="0"){
    // 			if(data.results.length!=0){
    // 				var results = data.results;
    // 				for(var i=0;i<results.length;i++){
    // 					$(_pageId + "#yysg "+data[1]+" p").html(data[9]);
    // 				}
    // 			}
    // 		}else{
    // 			$.alert(data.errorInfo);
    // 		}
    // 	});
    // }
    
   // //获取收购/回购数量
   //  function getNumberHg(stock_list,dataType){
   //  	var param = {
   //  		"version":"1",
		 //    "dataType":dataType,
		 //    "stock_list":stock_list
   //  	};
   //  	service_hq.getReportAmount(param,function(data){
   //  		if(data.errorNo=="0"){
   //  			if(data.results.length!=0){
   //  				var results = data.results;
   //  				for(var i=0;i<results.length;i++){
   //  					$(_pageId + "#yyhg "+data[1]+" p").html(data[9]);
   //  				}
   //  			}
   //  		}else{
   //  			$.alert(data.errorInfo);
   //  		}
   //  	});
   //  }
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		fromPage = "";
		yysgList = [];
		$(_pageId + "#yysg").show().siblings().hide();
		$(_pageId + ".tab_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
		common.setNoData(false);
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});