/**
 * 盘后大宗卖出
 */
define('trade/scripts/third/order/afterBulkSell.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var thirdOrder = require("thirdOrder");
	var common = require("common");
	var _pageId = "#third_order_afterBulkSell ";
	var iscrollUtils = require("iscrollUtils");
	var myScroller = null; // 滑动组件对象
	var height_table = null;
	var _load = false;
	
    /**
     * 初始化
     */
	function init(){
		if(global.requestLocation == 0){
			backgroundInterface();
		}

    }

    function load() {
		if(global.requestLocation == 1){
			backgroundInterface();
		}
		var mainHeight =  common.setMainHeight(_pageId, false);
        height_table =  mainHeight - $(_pageId + ".tnb_form").outerHeight(true) - $(_pageId + ".fund_table").css("margin-top").slice(0, -2);
        _load = true;
        if(thirdOrder.getQueryHolding()){
	        initScroller();
        }
		$(_pageId + ".ce_btn div.order").css({"padding-top": "3px","line-height":"14px","width":$(_pageId + ".ce_btn a").width(),"display":"inline-block"});
		$(_pageId + ".ce_btn #total").css("display","inline-block");
	}
    
	function backgroundInterface(){
		var orderType = "10"; // 1 ，买入  2，卖出  3，融资买入 4，融券卖出  5，普通买入 6，普通卖出 7，买券还券 8，卖券还款
		thirdOrder.dataInit(_pageId,orderType,initScroller);
		thirdOrder.elementBindEvent();
	}
	/**
	 * 初始化滑动组件
	 */
	function initScroller()
	{
		if(_load){
			var scrollOptions = {
				scrollerHeight: height_table, // 滚动组件的高度
				$wrapper: $(_pageId + " #wrapper"),
				scrollbars: true, // 隐藏滚动条
				hasPullDown: false, // 是否显示下拉提示，默认 true
				hasPullUp: false, // 是否显示上拉提示，默认 true
				bounceTime: 300 // 回弹的动画时间
			};
			if(!myScroller)
			{
				myScroller = iscrollUtils.vScroller(scrollOptions);
			}
			else
			{
				myScroller.refresh();
			}
		}
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		thirdOrder.dataDestroy();
		if(myScroller)
		{
			myScroller.destroy();
			myScroller = null;
		}
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});