/**
 * 新三板-撤单
 */
define('trade/scripts/third/order/cancel.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#third_order_cancel ";
   	var publicCancel = require("publicCancel");
    var data = {
		"queryFuncNo": "301704",
		"queryParam": {},
		"htmlData": {
			"topDiv": {
				"entrust": "entrust_name",
				"name": "stock_name",
				"code": "stock_code",
			},
			"liList": [
				["委托编号", "entrust_no"],
//				["委托属性", "entrust_prop_name"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交价格", "business_price"],
				["成交数量", "business_amount"],
//				["对方席位", "prop_seat_no"],
//				["对方股东", "prop_stock_account"],
				["委托状态", "entrust_state_name"],
				["委托时间", "entrust_time"],
//				if(element.entrust_prop == "2"){
//		       		eleHtml+="<li><span>对方席位 </span><p>"+element.prop_seat_no+"</p></li>";
//				}
//		       	if(element.entrust_prop == "4"){
//		       		eleHtml+="<li><span>对方席位 </span><p>"+element.prop_seat_no+"</p></li>";
//		       		eleHtml+="<li><span>对方股东 </span><p>"+element.prop_stock_account+"</p></li>";
//				}
			],
			//撤单时要的参数名称，值
			"cancel":[
				["entrust_no","entrust_no"],
				["entrust_date","entrust_date"],
				["exchange_type","exchange_type"],
			],
			//撤单提示字段
			"tipStr":[
				["证券名称", "stock_name"],
				["证券代码", "stock_code"],
				["委托价格", "entrust_price"],
				["委托数量", "entrust_amount"],
				["成交数量", "business_amount"],
//				["买卖方向", "entrust_type_name"],
			]
		},
		"cancelFuncNo":"301705",
		//撤单接口需要的其他参数
		"cancelParam": {
		},
    }
    
    /**
     * 初始化
     */
	function init(){
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		common.pageBuryingPoint("101780");
		common.switchingCurUser("0");
		publicCancel.init(data);
    }
		
	function load(){
		publicCancel.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(101782, 2, 103, true, {"i_group_name": "返回"});
				if (global.callNative) {
					if ($.getPageParam("isFromApp")) {
						var pageCode = $.getCurrentPageObj().pageCode || '';
						//ios切换行情
						$.callMessage({
							"funcNo": "50500",
							"msgNo": "205",
							"sourceModule": "trade",
							"targetModule": "app",
							"action": "4",
							"param": {}
						});
						$.pageInit(pageCode, 'account/index', {"_loginClass": "0"}, "left", true);
					} else {
						$.pageBack("third/order/order", "left");
					}
				} else {
					$.pageBack("third/order/order", "left");
				}
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		publicCancel.bindPageEvent();
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicCancel.destroy();
		common.pageBuryingPoint();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});