/**
 * 股转系统限价买入
 */
define('trade/scripts/third/order/limitPriceSell.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var limitPriceOrder = require("limitPriceOrder");
	var common = require("common");
	var _pageId = "#third_order_limitPriceSell ";
	var downslide = new (require("downslide")).Downslide();
	var height_table = null;
	
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("101750");
		downslide.addSlide();
		common.bindStockEvent($(_pageId + '.tab_nav ul li a'),true);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }

    function load() {
		var mainHeight =  common.setMainHeight(_pageId, false);
        height_table =  mainHeight - $(_pageId + ".tab_nav").outerHeight(true);
		initScroller();
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
    
	function backgroundInterface(){
		var orderType = "2"; // 1:限价买入、2:限价卖出
		limitPriceOrder.dataInit(_pageId,orderType,initScroller,slideReset);
		limitPriceOrder.elementBindEvent();
	}
	
	/**
	 * 初始化滑动组件
	 * isRefresh 是否是刷新
	 */
	function initScroller(isRefresh)
	{
		downslide.aboutInit();
		if(isRefresh){
			downslide.rollRefresh();
		}else{
			downslide.slideDestroy();
			downslide.rollInit(height_table,_pageId,true);
		}
	}
	
	/**
	 * 回到页面顶部的方法
	 */
	function slideReset(){
		downslide.rollInitReset();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
	}
	
	/**
	 * 数据重置
	 */
	function destroy(){
		limitPriceOrder.dataDestroy();
		downslide.slideDestroy();
		common.pageBuryingPoint();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});