/**
 * 股转系统下单主页面
 */
define('trade/scripts/third/order/order.js',function(require, exports, module) {
	var common = require("common");
	var gconfig = $.config;
	var global = gconfig.global;
    var _pageId = "#third_order_order ";
    var service_third = require("service_third");
    var userInfo = null;
    var judge = false;
    var isLogin = false;
    var hintText = "";
	
	
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("101810");
		userInfo = common.getCurUserInfo();
		common.bindStockEvent($(_pageId+".tab_nav ul li a"),true);
		if(global.requestLocation == 0){
			backgroundInterface();
		}
	}
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		var orderHeigt = mainHeight - $(_pageId + ".main .tab_nav").outerHeight(true);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
//		permissionCheck();//是否有股转和优先股权限
		
//		common.bindStockEvent($(_pageId + ".main .search_nav ul li a"),false,false,downslide.clickType());
		$.bindEvent($(_pageId + ".main .search_nav ul li a"), function(e){
			//埋点
			var objectId =  $(this).attr("objectId");
			var actionId =  $(this).attr("actionId");
			var name =  $(this).attr("name");
			common.comStat(objectId,2,actionId,true,{"i_group_name":name});
			
			var topage = $(this).attr("to-page").replaceAll("_","/"); //获取跳转的页面
			var param =  $(this).attr("param");
			var type = $(this).attr("type");
			if(!param){
				param = "";
			}
			if(type){
				if(judge){
					if(isLogin){
						$(this).unbind(e.type);
						this[e.type] = null;
						$.pageInit("third/order/order",topage,{"param":param});
					}
					else{
						if(hintText){
							$.alert(hintText);
						}
					}
				}
				else{
					$(this).unbind(e.type);
					this[e.type] = null;
					$.pageInit("third/order/order",topage,{"param":param}); 
				}
			}
			else{
				$(this).unbind(e.type);
				this[e.type] = null;
				$.pageInit("third/order/order",topage,{"param":param}); 
			}
		});
	}
	
	function permissionCheck(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var password = userInfo.password;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var money_type = "";  //  0：人民币，1：美元，2：港币
		var param={				
				"entrust_way":entrust_way,
			    "branch_no":branch_no,
			    "fund_account":fund_account,
			    "password":password,
			    "cust_code":cust_code,
		};
		service_third.permissionCheck(param,function(data){
			if (data){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						judge = true;
						if(results[0].preferred_stock_flag == 0){
							hintText = results[0].preferred_stock_info;
							isLogin = false;
						}
						else{
							isLogin = true;
						}
					}
				}
			}
		});
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			$(this).unbind(e.type);
			this[e.type] = null;
			common.comStat(101812,2,103,true,{"i_group_name":"返回"});
            if($.getPageParam("isGoBack") === "1"){
                $.pageBack();
                return;
            }
			$.pageInit("third/order/order","account/index",{"history":true},"left",true);
			e.stopPropagation();
			e.preventDefault();
		},"tap");
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
