/**
 * 股转系统公开发行历史申报
 */
define('trade/scripts/third/publicOffering/historyDeclare.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
    var _pageId = "#third_publicOffering_historyDeclare ";
	var downslide = new (require("downslide")).Downslide();
	var userInfo=null;
	var service_third = require("service_third");
    /**
     * 初始化
     */
	function init(){
    $.pageInit("third/publicOffering/historyDeclare", "bjs/publicOffering/historyDeclare", {"history": false}, "left", true);
    }
	function load(){
	}
	
	function backgroundInterface(){
		queryHistoryDeclare();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102041, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//右上角刷新
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			//埋点
			common.comStat(102042,2,103,true,{"i_group_name":"点击刷新"});
			$.showRightTopPreloaders();
			queryHistoryDeclare();
			e.stopPropagation();
		});
		
		//时间选择
		$.bindEvent($(_pageId + ".repurtime .btn"), function(e){
			queryHistoryDeclare();
			var end_time = $(_pageId+" #endDate").text();
			var begin_time = $(_pageId+" #startDate").text();	
			var time1 = end_time.replaceAll("-", "");
			var time2 = begin_time.replaceAll("-", "");
			common.comStat(102046,2,104,true,{"i_change_name":"历史申报查询","i_change_to":time1+"——"+time2});//埋点
			e.stopPropagation(); // 阻止冒泡
		});
	}
	
	/**
	 * 历史申报查询
	 */
	function queryHistoryDeclare(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var end_time = $(_pageId+" #endDate").text();
		var begin_time = $(_pageId+" #startDate").text();	
		var time1 = new Date(end_time.replaceAll("-", "/"));
		var time2 = new Date(begin_time.replaceAll("-", "/"));
		if(time1 < time2)
		{
		    $.alert("开始日期大于截止日期");
		    downslide.slideRefresh();
		    downslide.hidePullUp();
		    return false;
		}//截止时间
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
				"begin_date":begin_time,
				"end_date":end_time,
			};
		service_third.queryHistoryDeclare(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						common.setNoData(false);
						var html = "";
						// html+='<tr><th scope="col">名称/代码</th><th scope="col">申报价/申报数</th><th scope="col">状态/日期</th></tr>';
						for (var i=0;i<results.length;i++){ 
							html += queryHistoryDeclareHTML(results[i]);
						}
						$(_pageId+" .fill_table").html(html);
					}else{
						$(_pageId+" .fill_table").html("");
						common.setNoData(true);
					}
				}
				else{
					$(_pageId+" .fill_table").html("");
					common.setQueryFail(true);
				}
			}else{
				$(_pageId+" .fill_table").html("");
				common.setQueryFail(true);
			}
			downslide.slideRefresh();
		},{
			"isLastReq":true,
			"isShowWait":true,
			// "timeout": global.newsharesTimeout,
			"errorFunc":function(){
				$(_pageId+" .fill_table").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			},
			"timeOutFunc":function(){
				$(_pageId+" .fill_table").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			}
		});
	}
	
	/**
	 * HTML生成（未登录）
	 */
	function queryHistoryDeclareHTML(element){
		var eleHtml = "";
		eleHtml += '<tr><td><span>'+element.issue_name+'</span>';
		if(element.type_flag=="1"){
        	eleHtml += "<span>"+element.issue_code+"<font class='chuaunyet'>申购</font></span></td>";
        }else{
        	eleHtml += "<span>"+element.issue_code+"<font class='chuaunyet sg'>询价</font></span></td>";
        }
		eleHtml += '<td><span>'+element.report_price+'</span><span>'+element.report_amount+'</span></td>';
		eleHtml += '<td><span>'+element.report_state_name+'</span><span>'+element.report_time+'</span></td></tr>';
		return eleHtml;
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		downslide.slideDestroy();
		$(_pageId+" .fill_table").html("");
		common.pageBuryingPoint();
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
