/**
 * 股转系统公开发行我的申报
 */
define('trade/scripts/third/publicOffering/myDeclare.js', function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var common = require("common");
    var commonFunc = require("commonFunc");
    var _pageId = "#third_publicOffering_myDeclare ";
    var downslide = new (require("downslide")).Downslide();
    var userInfo = null;
    var service_third = require("service_third");
    var publicOfferingQuery = require("publicOfferingQuery");

    /**
     * 初始化
     */
    function init() {
      $.pageInit("third/publicOffering/myDeclare", "bjs/publicOffering/myDeclare", {"history": false}, "left", true);
    }

    function load() {
    }

    function backgroundInterface() {
        queryMyDeclare();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".top_title .icon_back"), function (e) {
            setTimeout(function () {
                //埋点
                common.comStat(101891, 2, 103, true, {"i_group_name": "返回"});
                commonFunc.appThirdBack($.getCurrentPageObj().pageId, function () {
                    $.pageBack();
                });
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //右上角刷新
        $.bindEvent($(_pageId + ".top_title .icon_refresh"), function (e) {
            $.showRightTopPreloaders();
            queryMyDeclare();
            e.stopPropagation();
        });

        //股转发行跳转
        $.bindEvent($(_pageId + ".xingutab .stockCalendar"), function (e) {
            //埋点
            common.comStat(101892, 2, 103, true, {"i_group_name": "发行日历"});
            common.jumpHpNewshare("1", {"isShowBack": "true", "moduleType": "2"});
            e.stopPropagation();
        });

        //历史申报查询
        $.bindEvent($(_pageId + ".onclikbtn"), function (e) {
            $.pageInit("third/publicOffering/myDeclare", "third/publicOffering/historyDeclare");
            e.stopPropagation();
        });
    }

    /**
     * 我的申报查询
     */
    function queryMyDeclare() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;	 //分支机构
        var fund_account = userInfo.fund_account;//资产账户
        var cust_code = userInfo.cust_code;  	 //客户代码
        var session_id = userInfo.session_id;
        var password = userInfo.password;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "password": password,
            "session_id": session_id,
        };
        service_third.queryMyDeclare(param, function (data) {
            if (data && data != "undefined") {
                if (data.error_no == 0) {
                    var results = data.results;
                    if (results && results.length > 0) {
                        common.setNoData(false);
                        var html = "<tr><th scope='col'>名称/代码</th><th scope='col'>申购价/申购数</th><th scope='col'>状态/时间</th></tr>";
                        for (var i = 0; i < results.length; i++) {
                            html += queryMyDeclareHTML(results[i]);
                        }
                        $(_pageId + ".ce_table").html(html);
                    } else {
                        $(_pageId + ".ce_table").html("");
                        common.setNoData(true);
                    }
                } else {
                    $(_pageId + ".ce_table").html("");
                    common.setQueryFail(true);
                }
            }
            downslide.slideRefresh();
        }, {
            "isLastReq": true,
            "isShowWait": true,
//			"timeout": global.newsharesTimeout,
            "errorFunc": function () {
                $(_pageId + ".ce_table").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            },
            "timeOutFunc": function () {
                $(_pageId + ".ce_table").html("");
                common.setQueryFail(true);
                downslide.slideRefresh();
            }
        });
    }

    /**
     * HTML生成
     */
    function queryMyDeclareHTML(element) {
        var eleHtml = "<tr>";
        eleHtml += "<td><span>" + element.issue_name + "</span>";
        if (element.type_flag == "1") {
            eleHtml += "<span>" + element.issue_code + "<font class='chuaunyet'>申购</font></span></td>";
        } else {
            eleHtml += "<span>" + element.issue_code + "<font class='chuaunyet sg'>询价</font></span></td>";
        }
        eleHtml += "<td><span>" + element.report_price + "</span><span>" + element.report_amount + "</span></td>";
        eleHtml += "<td><span>" + element.report_state_name + "</span><span>" + element.report_time + "</span></td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 销毁
     */
    function destroy() {
        downslide.slideDestroy();
        $(_pageId + ".ce_table").html("");
        common.pageBuryingPoint();
    }


    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
