/**
 * 股转系统查询适当性类别
 */
define('trade/scripts/third/query/queryAppropriateness.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_third = require("service_third");
    var _pageId = "#third_query_queryAppropriateness ";
	var userInfo=null;
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102340");
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		var height = mainHeight - $(_pageId+".tab_nav").height()-11;
		$(_pageId+".search_nav").height(height).css({"overflow":"auto"});
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryAppropriateness();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(102341, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
	}
	
	/**
	 * 适当性类别查询
	 */
	function queryAppropriateness(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		if(global.serverConfig=="3"){
			$(_pageId+".row_01").html("客户号："+cust_code);
		}else{
			$(_pageId+".row_01").html("资金账号："+fund_account);
		}
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
				"cust_name":userInfo.cust_name,
			};
		service_third.queryAppropriateness(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						for(var i = 0; i < results.length; i++){
							var type = results[i].appropriatenes_type;
							$(_pageId+"ul.row_02 li[type='"+type+"']").addClass("active");
						}
					}else{
						$(_pageId+"ul.row_02 li").removeClass("active");
					}
				}
				else{
					$(_pageId+"ul.row_02 li").removeClass("active");
				}
			}
//			downslide.slideRefresh();
		},{
			"isLastReq":true,
			"isShowWait":true,
//			"timeout": global.newsharesTimeout,
			"errorFunc":function(){
//				downslide.slideRefresh();
			},
			"timeOutFunc":function(){
//				downslide.slideRefresh();
			}
		});
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+"ul.row_02 li").removeClass("active");
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});