/**
 * 新三板意向单查询
 */
define('trade/scripts/third/query/queryConfirmOrder.js',function(require,exports,module){
	var gconfig = $.config;
	var global = gconfig.global;
    var vIscrollHeight = null;
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var service_third=require("service_third");
	var	_pageId = "#third_query_queryConfirmOrder ";
	var userInfo = null;//保存的客户信息
	var _voteDataList={};
	var position_str = "";
	var dataHtm1;
	var common = require("common");
	/**
	 * 初始化
	 * */
	function init(){
		dataHtml = "";
		position_str = "";
		userInfo = common.getCurUserInfo();
		queryIntentOrder();
	}
	
    function load() {
        var mainHeight = common.setMainHeight(_pageId, false);
        vIscrollHeight = mainHeight - $(_pageId+".tab_nav").height();
        if(!myScroller){
            initScroller();
        }else{
            myScroller.refresh();
        }
    }
	/**
	 * 事件绑定
	 * */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
            setTimeout(function () {
                $.pageInit("third/query/query", "third/query/query", {}, true);
                e.preventDefault();
                e.stopPropagation();
            },300);
		});
	}
	
	/**
     * 意向单查询
     */
    function queryIntentOrder(){
        var entrust_way= global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var session_id=userInfo.session_id;
        var param={
            "entrust_way":entrust_way,
            "branch_no":branch_no,
            "fund_account":fund_account,
            "cust_code":cust_code,
            "session_id":session_id,
            "request_num":"20",
            "position_str":position_str
        };
        $(_pageId+ ".no_data").hide();
        service_third.queryConfirmOrder(param,queryCallback,
            {
                "isLastReq":true,
                "isShowWait":true,
                "isShowOverLay":false,
                "timeOutFunc":function(){
                	$(_pageId+ ".no_data").show();
                    if(!myScroller){
                        initScroller();
                    }else{
                        myScroller.refresh();
                    }
                }
            });
    }
    /**
     * 意向单查询回调
     */
    function queryCallback(data){
        if (typeof(data) != "undefined" && data) {
            $(_pageId+".fund_list2").html("");
            if(data.error_no == 0){
                $(_pageId+".no_data").hide();
                var results = data.results;
                if(results.length>0 && results!= "undefined"){
                    
                    for (var i=0;i<results.length;i++){
                        dataHtml += queryEntrustHTML(results[i]);
                        _voteDataList[results[i].stock_code+results[i].confernum]=results[i];
                        position_str = results[results.length-1].position_str;
                    }
                    $(_pageId+".fund_list2").html(dataHtml);
                    //获取投票数据
                    $.bindEvent($(_pageId+" .part"),function (e) {
                        var key=$(this).attr("data-flag");
                        var data=_voteDataList[key];
                        var param={
                        		 "stockCode":data.stock_code,
                                 "bsflag":data.bsflag,
                                 "seat":data.seat,
                                 "confernum":data.confernum,
                                 "orderqty":data.orderqty
                        };
                        if(data.bsflag == "6S"){
                        	$.pageInit("","third/order/tradeConfirmBuy",param);
                        }else if(data.bsflag == "6B"){
                        	$.pageInit("","third/order/tradeConfirmSell",param);
                        }
                        e.stopPropagation();
                    },"tap");
                    
                }else{
                	if(position_str){  //position_str定位串不为空代表不是第一页
                		$(_pageId+".fund_list2").html(dataHtml);
                	}else{
                		$(_pageId+".no_data").show();
                	}
                }
                if(!myScroller){
                    initScroller();
                }else{
                    myScroller.refresh();
                }
//                if(!vIscroll._init){
//                    initVIScroll();
//                }else{
//                    vIscroll.scroll.refresh();
//                }
            }
            else{
            	$.alert(data.error_info);
            }
        }
        else{
        	$.alert("查询失败");
        }
    }

    /**
     * 查询HTML生成
     */
    function queryEntrustHTML(element){
        var eleHtml = "";
        var status = "";
        if(element.status == "1"){
        	status = "有效";
        }else{
        	status = "无效";
        }
//        eleHtml+="<div class=\"part\" data-flag='"+element.stock_code+element.confernum+"'>";
//        eleHtml+="<dl class=\"clearfix\">";
//        eleHtml+="<dt>"+element.stock_name+" <small>"+element.stock_code+"</small></dt>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>席位代码</em>"+element.seat+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>委托类别</em>"+element.bsflag_name+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>委托数量</em>"+Number(element.orderqty).toFixed(0)+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>委托价格</em>"+element.orderprice+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>成交约定号</em>"+element.confernum+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>委托时间</em>"+element.ordertime+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>记录状态</em>"+status+"</dd>";
//        eleHtml+="    <dd style='display: inline;width: 50%;float: left;'><em>备用标志</em>"+element.remark+"</dd>";
//        eleHtml+="</dl>";
//        eleHtml+="</div>";
        
		eleHtml+="<div class=\"part\" data-flag='"+element.stock_code+element.confernum+"'>";
		eleHtml+="<div class=\"title\"><h5><em>"+element.stock_name+"</em><small>"+element.stock_code+"</small></h5></div>"
       	eleHtml+="<ul>";
		eleHtml+="<li style='width:100%;'>委托类别 <span>"+element.bsflag_name+"</span></li>";
       	eleHtml+="<li>席位代码 <span>"+element.seat+"</span></li>";
       	eleHtml+="<li>委托数量 <span>"+Number(element.orderqty).toFixed(0)+"</span></li>";
       	eleHtml+="<li>委托价格 <span>"+element.orderprice+"</span></li>";
       	eleHtml+="<li>成交约定号 <span>"+element.confernum+"</span></li>";
       	eleHtml+="<li>委托时间 <span>"+element.ordertime+"</span></li>";
       	eleHtml+="<li>记录状态 <span>"+status+"</span></li>";
       	// eleHtml+="<li>备用标志 <span>"+element.remark+"</span></li>";
       	eleHtml+="</ul>";
       	eleHtml+="</div>";
        
        
        return eleHtml;
    }

    /**
     * 初始化滑动组件
     */
    function initScroller()
    {
        var scrollOptions = {
            scrollerHeight: vIscrollHeight, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: false, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function(){
            	position_str = "";
            	dataHtml = "";
            	queryIntentOrder(); // 模拟查询接口数据操作
            },
            pullUpHandler: function(){
            	queryIntentOrder();
            }
            
        };
        if(!myScroller){
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if(scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight)
            {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        }
        else
        {
            myScroller.refresh();
        }
    }
    
    /**
     * 初始化滑动组件
     */
//    function initVIScroll(){
//        if(!vIscroll._init){
//            var config = {
//                "isPagingType": false,//false表示是微博那种累加形式，true表示分页形式
//                "visibleHeight": $(window).height() - $(_pageId+".top_title").height()- 6  ,//显示内容区域的高度，当isPaingType为false时传
//                "container": $(_pageId+"#v_container_funds_jj"),
//                "wrapper":$(_pageId+"#v_wrapper_funds_jj"),
//                "downHandle": function() {
////                	queryIntentOrder();//下拉获取上一页数据方法
//                },
//                "upHandle": function() {
//                	queryIntentOrder();//上拉获取下一页数据方法
//                },
//                "wrapperObj": null
//            };
//            vIscroll.scroll = new VIscroll(config); 	//初始化，需要做if(!hIscroll._init)判断
//            vIscroll._init = true;
//        } else {
//            vIscroll.scroll.refresh();
//        }
//        $(_pageId+ ".visc_pullDown").hide();
//    }

    /**
     * 销毁
     */
    function destroy(){
        $(_pageId+".fund_list2").html("");
        _voteDataList={};
        if(vIscroll._init){
            vIscroll.scroll.refresh();
        }
    }
	
	
	/**
	 * 销毁
	 * */
	function destroy(){
		
	}
	
	/**
	 * 重写框架里面的pageBack方法
	 */
	function pageBack(){
		appUtils.pageBack();
	}
	
	var base = {
		"init" : init,
        "load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy,
		"pageBack": pageBack
	};
	module.exports = base;
});