/**
 * 股转系统查询交割单
 */
define('trade/scripts/third/query/queryDeliveryOrder.js', function(require, exports, module) {
	var gconfig = $.config; 
    var global = gconfig.global;
	var common = require("common");
    var _pageId = "#third_query_queryDeliveryOrder ";
    var publicQuery = require("publicQuery");
    var data = {
    	"funcNo" : "310735",
    	"param" : {},
    	"history":true,
    	"htmlData" : {
        	"topDiv":{
        		"entrust":"entrust_bs_name",
    	  		"name":"stock_name",
    	  		"code":"stock_code",
        		"time":"occur_date",
        	},
        	"liList":[],
    	}
    }
    if(global.serverConfig == "2"){//恒生
    	data.htmlData.liList=[
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["成交金额", "business_balance"],
    		["发生金额", "occur_balance"],
    		["资金余额", "post_balance"],
    		["股份余额", "post_amount"],
    		["费用合计", "total_fee"],
    		["币种", "money_type_name"],
    		["成交时间", "business_time","width:100%"]
    	];
    }else if(global.serverConfig == "1"){//金证win
    	data.htmlData.liList=[
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["成交金额", "business_balance"],
    		["发生金额", "occur_balance"],
    		["资金余额", "post_balance"],
    		["股份余额", "post_amount"],
    		["费用合计", "total_fee"],
    		["币种", "money_type_name"],
    		["成交时间", "business_time"]
    	];
    }else if(global.serverConfig == "3"){//顶点
    	data.htmlData.liList=[
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["成交金额", "business_balance"],
    		["发生金额", "occur_balance"],
    		["资金余额", "post_balance"],
    		["股份余额", "post_amount"],
    		["费用合计", "total_fee"],
    		["币种", "money_type_name"],
    		["成交时间", "business_time"]
    	];
    }
    
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102370");
		publicQuery.init(data);
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102371, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack("third/query/query", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		publicQuery.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicQuery.destroy();
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
