/**
 * 股转系统查询历史成交和历史委托
 */
define('trade/scripts/third/query/queryHistory.js', function(require, exports, module) {
	 var gconfig = $.config; 
    var global = gconfig.global;
    var _pageId = "#third_query_queryHistory ";
    var publicQuery = require("publicQuery");
    var common = require("common");
    var lineClass="white-space: nowrap";
    var data = {
    	"funcNo" : "301709",
    	"param" : {},
    	"history":true,
    	"htmlData" : {
        	"topDiv":{
        		"entrust":"entrust_name",
    	  		"name":"stock_name",
    	  		"code":"stock_code",
        		"time":"entrust_state_name",
        	},
        	"liList":[],
    	}
    }
    if(global.serverConfig == "2"){//恒生
    	data.htmlData.liList=[
    		["委托价格", "entrust_price"],
    		["委托数量", "entrust_amount"],
    		["委托编号", "entrust_no"],
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["委托时间",function(e){
    			return e.entrust_date + " " + e.entrust_time;
    		},lineClass],
    	];
    }else if(global.serverConfig == "1"){//金证win
    	data.htmlData.liList=[
    		["委托价格", "entrust_price"],
    		["成交价格", "business_price"],
    		["委托数量", "entrust_amount"],
    		["成交数量", "business_amount"],
    		["委托编号", "entrust_no"],
    		["委托时间",function(e){
    			return e.entrust_date + " " + e.entrust_time;
    		}],
    	];
    }else if(global.serverConfig == "3"){//顶点
    	data.htmlData.liList=[
    		["委托价格", "entrust_price"],
    		["成交价格", "business_price"],
    		["委托数量", "entrust_amount"],
    		["成交数量", "business_amount"],
    		["委托金额", "entrust_balance"],
    		["成交金额", "business_balance"],
    		["委托编号", "entrust_no"],
    		["委托时间",function(e){
    			return e.entrust_date + " " + e.entrust_time;
    		},lineClass],
    	];
    }
    
    var data1 = {
    	"funcNo" : "301710",
    	"param" : {},
    	"history":true,
    	"htmlData" : {
        	"topDiv":{
        		"entrust":"entrust_name",
    	  		"name":"stock_name",
    	  		"code":"stock_code",
        	},
        	"liList":[],
    	}
    }
    if(global.serverConfig == "2"){//恒生
    	data1.htmlData.liList=[
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["成交金额", "business_balance"],
    		["委托编号", "entrust_no"],
    		["成交编号", "business_no"],
    		["成交时间",function(e){
    			return e.business_date + " " + e.business_time;
    		},lineClass],
    	];
    }else if(global.serverConfig == "1"){//金证win
    	data1.htmlData.liList=[
    		["成交价格", "business_price"],
    		["委托价格", "entrust_price"],
    		["成交数量", "business_amount"],
    		["委托数量", "entrust_amount"],
    		["成交金额", "business_balance"],
    		["委托编号", "entrust_no"],
    		["成交编号", "business_no"],
    		["成交时间",function(e){
    			return e.business_date + " " + e.business_time;
    		}],
    	];
    }else if(global.serverConfig == "3"){//顶点
    	data1.htmlData.liList=[
    		["成交价格", "business_price"],
    		["成交数量", "business_amount"],
    		["成交金额", "business_balance"],
    		["委托编号", "entrust_no"],
    		["成交编号", "business_no"],
    		["成交时间",function(e){
    			return e.business_date + " " + e.business_time;
    		},lineClass],
    	];
    }
    
    /**
     * 初始化
     */
	function init(){
		queryType = $.getPageParam("param");
		if(queryType=="entrust"){
			common.pageBuryingPoint("102300");
			$(_pageId+".toggle_nav ul li").eq(0).addClass("active").siblings().removeClass("active");
			$(_pageId+"#wrapper").attr("objectId","102303"); 
			$(_pageId+"#wrapper").attr("actionId","102");
			$(_pageId+".date_filter .btn").attr("objectId","102306");
			$(_pageId+".date_filter .btn").attr("actionId","104");
			$(_pageId+".date_filter .btn").attr("name","历史委托查询");
			//埋点数据
			$(_pageId+" .date_filter").attr("startObjectId","102304");
			$(_pageId+" .date_filter").attr("endObjectId","102305");
			$(_pageId+" .date_filter").attr("actionId","104");
			publicQuery.init(data);
		}else{
			common.pageBuryingPoint("102320");
			$(_pageId+"#wrapper").attr("objectId","102323"); 
			$(_pageId+"#wrapper").attr("actionId","102");
			$(_pageId+".date_filter .btn").attr("objectId","102326");
			$(_pageId+".date_filter .btn").attr("actionId","104");
			$(_pageId+".date_filter .btn").attr("name","历史成交查询");
			//埋点数据
			$(_pageId+" .date_filter").attr("startObjectId","102324");
			$(_pageId+" .date_filter").attr("endObjectId","102325");
			$(_pageId+" .date_filter").attr("actionId","104");
			$(_pageId+".toggle_nav ul li").eq(1).addClass("active").siblings().removeClass("active");
			publicQuery.init(data1);
		}
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){	//埋点
			setTimeout(function () {
				var objectId = "";
				if ($(_pageId + ".toggle_nav ul li.active").index() == 0) {
					objectId = "102301";
				} else {
					objectId = "102321";
				}
				common.comStat(objectId, 2, 103, true, {"i_group_name": "返回"});

				$.pageBack("third/query/query", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".toggle_nav ul li"), function(e){
			$.clearRequest();
			$(this).addClass("active").siblings().removeClass("active");
			$(_pageId+" .cancel_order").html("");
			$(_pageId+" .cancel_order").attr("style","");
			common.pageBuryingPoint();
			if($(this).index() == 0){
				common.pageBuryingPoint("102300");
				$(_pageId+"#wrapper").attr("objectId","102303"); 
				$(_pageId+"#wrapper").attr("actionId","102");
				$(_pageId+".date_filter .btn").attr("objectId","102306");
				$(_pageId+".date_filter .btn").attr("actionId","104");
				$(_pageId+".date_filter .btn").attr("name","历史委托查询");
				publicQuery.againQuery(data.param,data.funcNo,data.htmlData,data.history);
			}
			else{
				common.pageBuryingPoint("102320");
				$(_pageId+"#wrapper").attr("objectId","102323"); 
				$(_pageId+"#wrapper").attr("actionId","102");
				$(_pageId+".date_filter .btn").attr("objectId","102326");
				$(_pageId+".date_filter .btn").attr("actionId","104");
				$(_pageId+".date_filter .btn").attr("name","历史成交查询");
				publicQuery.againQuery(data1.param,data1.funcNo,data1.htmlData,data1.history);
			}
			//埋点
			var objectId=$(this).attr("objectId");
			var actionId=$(this).attr("actionId");
			var name=$(this).attr("name");
			common.comStat(objectId,2,actionId,true,{"i_group_name":name});
		});
		
		publicQuery.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicQuery.destroy();
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
