/**
 * 股转系统-定价申报行情查询
 */
define('trade/scripts/third/query/queryMakePriceHq.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var keyboard = require("keyboard");
	var service_third=require("service_third");
    var _pageId = "#third_query_queryMakePriceHq ";
    var userInfo = null;//保存的客户信息
	var _stock_code="";

    /**
     * 初始化
     */
	function init(){
		userInfo = common.getCurUserInfo();
		if(keyboard){
			keyboard.keyInit();
		}
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	
	function load(){
		common.setMainHeight(_pageId, false);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	function backgroundInterface(){
		
	}
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$.pageBack("third/query/query", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//类别选择
		$.bindEvent($(_pageId+".toggle_nav ul li"),function (e) {
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			$(this).addClass("active").siblings().removeClass();
			e.stopPropagation();
		});
		//查询按钮绑定事件
		$.bindEvent($(_pageId+"#query_button"),function (e) {
			if(keyboard){
				keyboard.closeKeyPanel();
			}
			//验证股票代码的正确性
			var regex=/^[0-9]{6}$/;
			_stock_code=$(_pageId+"#stockCode").val();
			if(!regex.test(_stock_code)){
				$.alert("输入的股票代码不正确");
				return false;
			}
			queryHqInfo();
			e.stopPropagation();
		})
		//股票输入
		$.bindEvent($(_pageId + "#stockCode"), function(e){ // 该监听方法是为了适配浏览器
			if(keyboard){
				keyboard.popUpKeyboard($(this),e);
			}
			e.stopPropagation();
		},"input");
	}

	/**
	 * 查询
	 *
	 */
	function queryHqInfo() {
//		var entrust_way= global.entrust_way;
//		var branch_no = userInfo.branch_no;
//		var fund_account = userInfo.fund_account;
//		var cust_code = userInfo.cust_code;
//		var session_id=userInfo.session_id;
		var stock_code = _stock_code;
		var bsflag = $(_pageId+".toggle_nav ul li.active").attr("id");
		var param={
//			"entrust_way":entrust_way,
//			"branch_no":branch_no,
//			"fund_account":fund_account,
//			"cust_code":cust_code,
//			"session_id":session_id,
			"stock_code":stock_code,
			"bsflag":bsflag
		};
		$.pageInit("third/query/queryMakePriceHq","third/query/queryMoreInfor",param,"",true);
//		$(_pageId+ ".no_data").hide();
//		service_third.queryConfirmOrder(param,queryQhCallBack,
//			{
//				"isLastReq":true,
//				"isShowWait":true,
//				"isShowOverLay":false
//			});
	}
	
	/**
	 * 销毁
	 */
	function destroy(){
		if(keyboard){
			keyboard.keyDestroy();
		}
		$(_pageId+" #stockCode").quzhi("");
	}
	

	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});