/**
 * 股转系统查询受限明细
 */
define('trade/scripts/third/query/queryRestricted.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_third = require("service_third");
	var downslide = new (require("downslide")).Downslide();
    var _pageId = "#third_query_queryRestricted ";
	var userInfo=null;
	
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102360");
		downslide.addSlide();
		userInfo = common.getCurUserInfo();
		if(global.requestLocation == 0){
			backgroundInterface();
		}
    }
	
	function load(){
		var mainHeight = common.setMainHeight(_pageId, false);
		var height = mainHeight - $(_pageId+".tab_nav").height()-11;
		$(_pageId+".search_nav").height(height).css({"overflow":"auto"});
		downslide.slideInit(mainHeight,backgroundInterface);
		if(global.requestLocation == 1){
			backgroundInterface();
		}
	}
	
	function backgroundInterface(){
		queryRestricted();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				common.comStat(102361, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//右上角刷新
		$.bindEvent($(_pageId+".top_title .icon_refresh"), function(e){
			common.comStat(102362,2,103,true,{"i_group_name":"刷新"});
			$.showRightTopPreloaders();
			queryRestricted();
			e.stopPropagation();
		});
	}
	
	/**
	 * 受限明细查询
	 */
	function queryRestricted(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
			};
		service_third.queryRestricted(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					if(results && results.length >0){
						common.setNoData(false);
						var html = "<tr><th>代码</th><th>股东账号</th><th>资金账号</th></tr>";
						if(global.serverConfig!="2"){
							html = "<tr><th>代码</th><th>股东账号</th><th>客户号</th></tr>";
						}
						for(var i = 0; i < results.length; i++){
							html += queryRestrictedHTML(results[i]);
						}
						$(_pageId+".resticed table").html(html);
					}else{
						$(_pageId+".resticed table").html("");
						common.setNoData(true);
					}
				}
				else{
					$(_pageId+".resticed table").html("");
					common.setQueryFail(true);
				}
			}
			downslide.slideRefresh();
		},{
			"isLastReq":true,
			"isShowWait":true,
//			"timeout": global.newsharesTimeout,
			"errorFunc":function(){
				$(_pageId+".resticed table").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			},
			"timeOutFunc":function(){
				$(_pageId+".resticed table").html("");
				common.setQueryFail(true);
				downslide.slideRefresh();
			}
		});
	}
    
	/**
	 * HTML生成
	 */
	function queryRestrictedHTML(element){
		var eleHtml = "<tr>";
		eleHtml += "<td>"+element.stock_code+"</td>";
		eleHtml += "<td>"+element.stock_account+"</td>";
		if(global.serverConfig!="2"){
			eleHtml += "<td>"+element.cust_code+"</td>";
		}else{
			eleHtml += "<td>"+element.fund_account+"</td>";
		}
		eleHtml += "</tr>";
		return eleHtml;
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});