/**
 * 股转系统查询股东账号
 */
define('trade/scripts/third/query/queryThirdStockAccount.js',function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var service_third = require("service_third");
    var _pageId = "#third_query_queryThirdStockAccount ";
	var userInfo=null;
	var downslide = new (require("downslide")).Downslide();
    /**
     * 初始化
     */
	function init(){
		common.pageBuryingPoint("102380");
		userInfo = common.getCurUserInfo();
		downslide.addSlide();
    }
	
	function load(){
		var slideHeight = $(window).height()- $(_pageId + " .top_title").height() - $(_pageId + " .row_01").height();
		downslide.slideInit(slideHeight,backgroundInterface);
		backgroundInterface();
	}
	
	function backgroundInterface(){
		queryThirdStockAccount();
	}
	
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				common.comStat(102381, 2, 103, true, {"i_group_name": "返回"});
				$.pageBack();
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		// 刷新
		$.bindEvent($(_pageId + ".header .icon_refresh"), function(e){
			//埋点
			common.comStat(102382,2,103,true,{"i_group_name":"点击刷新"});
			$.showRightTopPreloaders();
			queryThirdStockAccount();
			e.stopPropagation();
		});
	}
	
	/**
	 * 股东账号查询
	 */
	function queryThirdStockAccount(){
		var entrust_way= global.entrust_way; // 委托方式  在configuration配置
		var branch_no  = userInfo.branch_no;	 //分支机构
		var fund_account = userInfo.fund_account;//资产账户
		var cust_code = userInfo.cust_code;  	 //客户代码
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		$(_pageId+".row_01").html("客户号："+cust_code);
		var param = {
				"entrust_way":entrust_way,
				"branch_no":branch_no,
				"fund_account":fund_account,
				"cust_code":cust_code,
				"password":password,
				"session_id":session_id,
				"cust_name":userInfo.cust_name,
			};
		service_third.queryThirdStockAccount(param,function(data){
			if (data && data!= "undefined"){
				if(data.error_no == 0){
					var results = data.results;
					var html = "<tr><th>股东账号</th><th>席位</th><th>类型</th></tr>";
					if(results && results.length >0){
						for(var i = 0; i < results.length; i++){
							var main_flag_name = "辅";
							if(results[i].main_flag=="1"){
								main_flag_name = "主";
							}
							html += "<tr><td>"+results[i].stock_account+"("+main_flag_name+")</td><td>"+results[i].seat_no+"</td><td>"+results[i].exchange_type_name+"</td></tr>"
						}
						$(_pageId+".resticed table").html(html);
					}else{
						$(_pageId+".resticed table").html(html);
						common.setNoData(true,"暂无数据");
					}
				}
				else{
					$.alert(data.error_info);
					$(_pageId+".resticed table").html("");
				}
			}
			downslide.slideRefresh();
		},{
			"isLastReq":true,
			"isShowWait":true,
			"errorFunc":function(){
				$(_pageId+".resticed table").html("");
				common.setQueryFail(true)
				downslide.slideRefresh();
			},
			"timeOutFunc":function(){
				$(_pageId+".resticed table").html("");
				common.setQueryFail(true)
				downslide.slideRefresh();
			}
		});
	}
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		$(_pageId+".resticed table").html("");
	}
	

	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});