/**
 * 股转系统查询今日成交和今日委托
 */
define('trade/scripts/third/query/queryToday.js', function(require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var _pageId = "#third_query_queryToday ";
    var publicQuery = require("publicQuery");
    var common = require("common");
    var data = {
    	"funcNo" : "301706",
    	"param" : {},
    	"history":false,
    	"htmlData" : {
        	"topDiv":{
        		"entrust":"entrust_name",
    	  		"name":"stock_name",
    	  		"code":"stock_code",
        		"time":"entrust_state_name",
        	},
        	"liList":[],
    	}
    }
    if(global.serverConfig == "2"){//恒生
    	data.htmlData.liList=[
    		["委托价格","entrust_price"],
    		["委托数量","entrust_amount"],
    		["成交价格","business_price"],
    		["成交数量","business_amount"],
    		["委托时间","entrust_time"],
    		["委托编号","entrust_no"],
    		["备注", "cancel_info","width:100%;"]
    	];
    }else if(global.serverConfig == "1"){//金证win
    	data.htmlData.liList=[
    		["委托价格","entrust_price"],
    		["委托编号","entrust_no"],
    		["委托数量","entrust_amount"],
    		["成交数量","business_amount"],
    		["委托时间","entrust_time"],
    		["备注", "cancel_info"]
    	];
    }else if(global.serverConfig == "3"){//顶点
    	data.htmlData.liList=[
    		["委托价格","entrust_price"],
    		["成交价格","business_price"],
    		["委托数量","entrust_amount"],
    		["成交数量","business_amount"],
    		["委托金额","entrust_balance"],
    		["成交金额","business_balance"],
    		["委托时间","entrust_time"],
    		["委托编号","entrust_no"],
    		["备注", "cancel_info"]
    	];
    }
    
    
    var data1 = {
    	"funcNo" : "301708",
    	"param" : {},
    	"history":false,
    	"htmlData" : {
        	"topDiv":{
        		"entrust":"entrust_name",
    	  		"name":"stock_name",
    	  		"code":"stock_code",
        	},
        	"liList":[],
    	}
    }
    if(global.serverConfig == "2"){//恒生
    	data1.htmlData.liList=[
    		["成交价格","business_price"],
    		["成交数量","business_amount"],
    		["成交金额","business_balance"],
    		["成交时间","business_time"],
    		["委托编号","entrust_no"],
    		["成交编号","business_no"],
    	];
    }else if(global.serverConfig == "1"){//金证win
    	data1.htmlData.liList=[
    		["成交价格","business_price"],
    		["委托价格","entrust_price"],
    		["成交数量","business_amount"],
    		["委托数量","entrust_amount"],
    		["成交编号","business_no"],
    		["委托编号","entrust_no"],
    		["成交时间","business_time"],
    	];
    }else if(global.serverConfig == "3"){//顶点
    	data1.htmlData.liList=[
    		["成交价格","business_price"],
    		["成交数量","business_amount"],
    		["成交金额","business_balance"],
    		["成交时间","business_time"],
    		["委托编号","entrust_no"],
    		["成交编号","business_no"],
    	];
    }
    
    /**
     * 初始化
     */
	function init(){
		queryType = $.getPageParam("param");
		if(queryType=="entrust"){
			common.pageBuryingPoint("102280");
			$(_pageId+"#wrapper").attr("objectId","102283");
			$(_pageId+"#wrapper").attr("actionId","102");
			$(_pageId+".icon_refresh").attr("name","手动刷新");
			$(_pageId+".icon_refresh").attr("objectId","102282");
			$(_pageId+".icon_refresh").attr("actionId","102");
			$(_pageId+".tab_list ul li").eq(0).addClass("current").siblings().removeClass("current");
			publicQuery.init(data);
		}else{
			common.pageBuryingPoint("102290");
			$(_pageId+"#wrapper").attr("objectId","102293");
			$(_pageId+"#wrapper").attr("actionId","102");
			$(_pageId+".icon_refresh").attr("name","手动刷新");
			$(_pageId+".icon_refresh").attr("objectId","102292");
			$(_pageId+".icon_refresh").attr("actionId","102");
			$(_pageId+".tab_list ul li").eq(1).addClass("current").siblings().removeClass("current");
			publicQuery.init(data1);
		}
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				//埋点
				var objectId = "";
				if ($(_pageId + ".tab_list ul li.current").index() == 0) {
					objectId = "102281";
				} else {
					objectId = "102291";
				}
				common.comStat(objectId, 2, 103, true, {"i_group_name": "返回"});

				$.pageBack("third/query/query", "left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		//页面切换
		$.bindEvent($(_pageId + ".tab_list ul li"), function(e){
			$.clearRequest();
			$(this).addClass("current").siblings().removeClass("current");
			$(_pageId+" .cancel_order").html("");
			$(_pageId+" .cancel_order").attr("style","");
			common.pageBuryingPoint();
			if($(this).index() == 0){
				common.pageBuryingPoint("102280");
				$(_pageId+"#wrapper").attr("objectId","102283");
				$(_pageId+"#wrapper").attr("actionId","102");
				$(_pageId+".icon_refresh").attr("name","手动刷新");
				$(_pageId+".icon_refresh").attr("objectId","102282");
				$(_pageId+".icon_refresh").attr("actionId","102");
				publicQuery.againQuery(data.param,data.funcNo,data.htmlData,data.history);
			}
			else{
				common.pageBuryingPoint("102290");
				$(_pageId+"#wrapper").attr("objectId","102293");
				$(_pageId+"#wrapper").attr("actionId","102");
				$(_pageId+".icon_refresh").attr("name","手动刷新");
				$(_pageId+".icon_refresh").attr("objectId","102292");
				$(_pageId+".icon_refresh").attr("actionId","102");
				publicQuery.againQuery(data1.param,data1.funcNo,data1.htmlData,data1.history);
			}
			// //埋点
			// var objectId=$(this).attr("objectId");
			// var actionId=$(this).attr("actionId");
			// var name=$(this).attr("name");
			// common.comStat(objectId,2,actionId,true,{"i_group_name":name});
		});
		
		publicQuery.bindPageEvent();
	}
	
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		publicQuery.destroy();
		common.pageBuryingPoint();
	}
	
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});
