/**
 * 股转系统查询今日成交和今日委托
 */
define('trade/scripts/third/query/queryTodayNew.js', function (require, exports, module) {
    var common = require("common");
    var gconfig = $.config;
    var global = gconfig.global;
    var service_third = require("service_third");
    var _pageId = "#third_query_queryTodayNew ";
    var userInfo = null;
    var queryType = null; //查询内容
    var iscrollUtils = require("iscrollUtils");
    var myScroller = null; // 滑动组件对象
    var pageCode = "third/query/queryTodayNew";

    /**
     * 初始化
     */
    function init() {
        common.switchingCurUser("0");
        userInfo = common.getCurUserInfo();
        var paramMap = $.getPageParam("param");
        if (paramMap && typeof (paramMap) == "object") {
            if (Object.keys(paramMap).length > 0) {
                queryType = paramMap.param;
            }
        } else {
            queryType = paramMap;
        }

        if (queryType == "deal") {
            common.pageBuryingPoint("100205");
            $(_pageId + ".tab_list li").eq(1).addClass("current").siblings().removeClass("current");
            $(_pageId + ".btnSub3").html("更多历史成交记录");
            $(_pageId + ".btnSub4").html("更多历史成交记录");
        } else {
            common.pageBuryingPoint("100198");
            $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
            $(_pageId + ".btnSub3").html("更多历史委托记录");
            $(_pageId + ".btnSub4").html("更多历史委托记录");
        }
        if (global.requestLocation == 0) {
            backgroundInterface();
        }
    }

    function load() {
        var mianHeight = common.setMainHeightNew(_pageId, false);
        if (global.requestLocation == 1) {
            backgroundInterface();
        }
    }

    function backgroundInterface() {
        callsQuery();
    }

    /**
     * 事件绑定
     */
    function bindPageEvent() {
        //返回按钮
        $.bindEvent($(_pageId + ".header_inner .back_btn"), function (e) {
            setTimeout(function () {
                //埋点
                if ($(_pageId + ".tab_list ul li.current").index() == 0) {
                    common.comStat(100201, 2, 103, true, { "i_group_name": "返回" });
                } else {
                    common.comStat(100206, 2, 103, true, { "i_group_name": "返回" });
                }
                $.pageBack("stock/stockQuery", "left");
                e.preventDefault();
                e.stopPropagation();
            }, 300);
        });

        //页面切换
        $.bindEvent($(_pageId + ".tab_list ul li"), function (e) {
            //在页面切换时清掉请求
            $.clearRequest();
            //埋点
            var objectId = $(this).attr("objectId");
            var actionId = $(this).attr("actionId");
            var name = $(this).attr("name");
            common.comStat(objectId, 2, actionId, true, { "i_group_name": name });
            $(this).addClass("current").siblings().removeClass("current");
            $(_pageId + ".j-position-table table").html("");
            callsQuery();
            //页面埋点
            var index = $(_pageId + ".tab_list ul li.current").index();
            common.pageBuryingPoint();
            if (index == 0) {//当日委托
                common.pageBuryingPoint("100198");
            } else {//当日成交
                common.pageBuryingPoint("100205");
            }
        });

        //更多按钮
        $.bindEvent($(_pageId + ".nsb_sel_fixed_box"), function (e) {
            if ($(_pageId + ".tab_list ul li").eq(0).hasClass("current")) {//委托
                $.pageInit(pageCode, "stock/stockWTQueryHistory", { "param": "entrust" });
            } else {//成交
                $.pageInit(pageCode, "stock/stockCJQueryHistory", { "param": "deal" });
            }
        });
    }

    /**
     * 调用查询
     */
    function callsQuery() {
        if ($(_pageId + ".tab_list ul li").eq(0).hasClass("current")) {
            $(_pageId + ".btnSub3").html("更多历史委托记录");
            $(_pageId + ".btnSub4").html("更多历史委托记录");
            $(_pageId + ".hasdatamore").hide();
            queryEntrust();
        } else {
            $(_pageId + ".hasdatamore").hide();
            $(_pageId + ".btnSub3").html("更多历史成交记录");
            $(_pageId + ".btnSub4").html("更多历史成交记录");
            queryDeal();
        }
    }

    /**
     * 委托查询
     */
    function queryEntrust() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;
        var cust_code = userInfo.cust_code;
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_third.querythirdTodayEntrust(param, queryEntrustCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });
    }

    /**
     * 委托查询回调
     */
    function queryEntrustCallback(data) {
        if (typeof (data) != "undefined" && data) {
            $(_pageId + ".hasdatamore").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results.length > 0 && results != "undefined") {
                    var html = "<thead><tr><th>证券/时间</th><th>委托/成交价</th><th>委托/成交量</th><th>类型/状态</th></tr></thead><tbody>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryEntrustHTML(results[i], i);
                    }
                    $(_pageId + ".j-position-table table").html(html + "</tbody>");
                    $(_pageId + ".hasdatamore").show();
                    $.bindEvent($(_pageId + ".j-position-table table tbody tr"), function (e) {
                        var cancel_flag = $(this).attr("cancel_flag");
                        if (cancel_flag == "0") {
                            var tipStrArray = [];
                            tipStrArray.push(["证券名称 ", $(this).attr("stock_name")]);
                            tipStrArray.push(["证券代码 ", $(this).attr("stock_code")]);
                            tipStrArray.push(["买卖方向 ", $(this).attr("entrust_name")]);
                            tipStrArray.push(["委托价格 ", $(this).attr("entrust_price")]);
                            tipStrArray.push(["委托数量 ", $(this).attr("entrust_amount")]);
                            tipStrArray.push(["成交数量 ", $(this).attr("business_amount")]);
                            var tipStr = "<div>";
                            tipStr += common.generatePrompt(tipStrArray);
                            tipStr += "</div>";
                            var entrust_no = $(this).attr("id");
                            var exchange_type = $(this).attr("exchange_type");
                            common.iConfirm("确认撤单", tipStr, function () {
                                cancellation(entrust_no, exchange_type); // 确认撤单
                            }, null, "确定", "取消");
                        }
                        e.stopPropagation();
                    });
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 确定撤单
     */
    function cancellation(entrustNo, exchangeType) {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code; // 关联资产账户标志
        var sessionid = userInfo.session_id;
        var batch_flag = "0";
        var entrust_no = entrustNo;
        var exchange_type = exchangeType;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid,
            "entrust_no": entrust_no,
            "batch_flag": batch_flag,
            "exchange_type": exchange_type
        };
        service_third.postCancelOrder(param, postCancelOrderCallback, {
            "isLastReq": false, "isShowWait": false,
            "timeOutFunc": function () {
                $.hidePreloader();
            }, "errorFunc": function () {
                $.hidePreloader();
            }
        });
        $.showPreloaders("请等待...");
    }

    /**
     * 委托撤单回调方法
     * @param {Object} data 返回数据
     */
    function postCancelOrderCallback(data) {
        $.hidePreloader();
        if (data.error_no == "0") {
            $.alert(data.error_info, function () {
                queryEntrust();
            });
        } else {
            $.alert(data.error_info);
        }
    }

    /**
     * 委托查询HTML生成
     */
    function queryEntrustHTML(element, i) {
        var price_digit = 3;
        var css = "";
        var css1 = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            entrust_name = "买入";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_red"
            }
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            entrust_name = "卖出";
            if (element.cancel_flag == "0") {//可撤
                css1 = "transparent_blue"
            }
        } else {
            css = "";
        }
        if (element.entrust_type_name == "撤单") {
            entrust_name = "撤单";
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "' class='" + css1 + "' id='" + element.entrust_no + "' stock_name='" + element.stock_name + "' stock_code='" + element.stock_code + "' entrust_price='" + Number(element.entrust_price).toFixed(price_digit) + "' entrust_amount='" + element.entrust_amount + "' business_amount='" + element.business_amount + "' cancel_flag='" + element.cancel_flag + "' entrust_name='" + entrust_name + "' exchange_type='" + element.exchange_type + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 14, $(window).width() / 4 - 25)+")'>" + element.stock_name + "</p>";
        eleHtml += "<p  style='font-size: 0.12rem!important;'>" + element.entrust_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.entrust_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + element.entrust_amount + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + common.getShowStr((element.entrust_name_new || entrust_name), '--', 1, 4) + "</p>";
        eleHtml += "<p>" + element.entrust_state_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    /**
     * 成交查询
     */
    function queryDeal() {
        var entrust_way = global.entrust_way; // 委托方式  在configuration配置
        var branch_no = userInfo.branch_no;
        var fund_account = userInfo.fund_account;//
        var cust_code = userInfo.cust_code;//关联资产账户标志
        var sessionid = userInfo.session_id;
        var param = {
            "entrust_way": entrust_way,
            "branch_no": branch_no,
            "fund_account": fund_account,
            "cust_code": cust_code,
            "sessionid": sessionid
        };
        $(_pageId + ".no_data_box").hide();
        service_third.queryTodayTrade(param, queryDealCallback,
            {
                "isLastReq": true,
                "isShowWait": true,
                "isShowOverLay": false,
                "timeOutFunc": function () { // 超时调用方法
                    if (!myScroller) {
                        initScroller();
                    } else {
                        myScroller.refresh();
                    }
                }
            });

    }

    /**
     * 成交查询回调
     */
    function queryDealCallback(data) {
        if (typeof (data) != "undefined" && data != null) {
            $(_pageId + ".hasdatamore").hide();
            if (data.error_no == 0) {
                $(_pageId + ".no_data_box").hide();
                var results = data.results;
                if (results != "undefined" && results.length > 0) {
                    var html = "<tr><th>证券/时间</th><th>成交价/成交量</th><th>成交金额</th><th>类型/状态</th></tr>";
                    for (var i = 0; i < results.length; i++) {
                        if ($.isValue(results[i].stock_name_long)) results[i].stock_name = results[i].stock_name_long;
                        html += queryDealHTML(results[i], i);
                    }
                    $(_pageId + ".j-position-table table").html(html);
                    $(_pageId + ".hasdatamore").show();
                } else {
                    $(_pageId + ".j-position-table table").html("");
                    $(_pageId + ".no_data_box").show();
                }
                if (!myScroller) {
                    initScroller();
                } else {
                    myScroller.refresh();
                }
            } else {
                $.alert(data.error_info);
            }
        } else {
            $.alert("查询失败");
        }
    }

    /**
     * 成交查询HTML生成
     */
    function queryDealHTML(element, i) {
        var price_digit = 3;
        var css = "";
        // var css1 = "";
        var entrust_name = element.entrust_type_name;
        if (element.entrust_name && element.entrust_name !== " " && element.entrust_name !== "") {
            entrust_name = element.entrust_name;
        }
        if ($.inArray(element.entrust_bs, ["0", "4", "62", "64", "66", "68", "70"]) != -1) {
            css = "trans_color_02";
            entrust_name = "买入";
        } else if ($.inArray(element.entrust_bs, ["1", "5", "63", "65", "67", "69", "71"]) != -1) {
            css = "trans_color_01";
            entrust_name = "卖出";
        } else {
            css = "";
        }
        // if (element.real_status_name == "成交") {
        //     css1 = "color:green;";
        // } else if (element.real_status_name == "确认") {
        //     css1 = "color:black;";
        // } else if (element.real_status_name == "废单") {
        //     css1 = "color:gray;";
        // }
        if (element.real_type_name == "撤单") {
            entrust_name = "撤单";
            css = "";
        }
        var eleHtml = "";
        eleHtml += "<tr data-index='" + i + "'>";
        eleHtml += "<td>";
        eleHtml += "<p style='transform-origin: left;transform:scale("+$.getTransformScale(element.stock_name, 14, $(window).width() / 4 - 25)+")'>" + element.stock_name + "</p>";
        eleHtml += "<p>" + element.business_time + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_price).toFixed(price_digit) + "</p>";
        eleHtml += "<p>" + element.business_amount + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p>" + Number(element.business_balance).toFixed(price_digit) + "</p>";
        eleHtml += "</td>";
        eleHtml += "<td>";
        eleHtml += "<p class=\"" + css + "\">" + entrust_name + "</p>";
        eleHtml += "<p>" + element.real_status_name + "</p>";
        eleHtml += "</td>";
        eleHtml += "</tr>";
        return eleHtml;
    }

    function initScroller() {
        var scrollOptions = {
            scrollerHeight: $(window).height() - $(_pageId + "header").height() + 2, // 滚动组件的高度
            pullThreshold: 5, // 拖动刷新或者加载的阀值，默认 5 像素
            $wrapper: $(_pageId + " #wrapper"),
            hasPullDown: true, // 是否显示下拉提示，默认 true
            hasPullUp: false, // 是否显示上拉提示，默认 true
            isAlwaysShowPullUp: false, // 是否一直显示上拉提示，true 一直显示上拉加载的提示，false 仅在上拉的时候显示提示，默认 true
            pullDownHandler: function () {
                callsQuery();//下拉获取上一页数据方法
            },
            pullUpHandler: function () {
            }
        };
        if (!myScroller) {
            // 内容的高度比滚动区域高度小时
            // iscrollUtils 已有相同判断的代码，此处这样写的目的是为了解决 Android UC、微信等浏览器滚动失效的问题，在 iscrollUtils 设置高度，在初始化组件时，取到的值不准确
            if (scrollOptions.$wrapper.find("[data-is-content='true']").height() <= scrollOptions.scrollerHeight) {
                scrollOptions.$wrapper.children().height(scrollOptions.scrollerHeight + 1);
            }
            myScroller = iscrollUtils.vScroller(scrollOptions);
        } else {
            myScroller.refresh();
        }
    }

    /**
     * 销毁
     */
    function destroy() {
        common.pageBuryingPoint();
        $(_pageId + ".j-position-table table").html("");
        $(_pageId + ".hasdatamore").hide();
        $(_pageId + ".no_data_box").hide();
        $(_pageId + ".tab_list li").eq(0).addClass("current").siblings().removeClass("current");
        if (myScroller) {
            myScroller.destroy();
            myScroller = null;
        }
    }

    var base = {
        "init": init,
        "load": load,
        "bindPageEvent": bindPageEvent,
        "destroy": destroy
    };
    module.exports = base;
});
