/**
 * 场外基金-定投查询
 */
define('trade/scripts/ysyy/ysyyList.js', function(require, exports, module) {
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var _pageId = "#ysyy_ysyyList ";
	var service_ysyy = require("service_ysyy");
    var toPage = "";
    var downslide = new (require("downslide")).Downslide();
    var hqStocks = {};
	/**
	 * 初始化
	 */
	function init() {
		downslide.addSlide();
		userInfo = common.getCurUserInfo();
		toPage = $.getPageParam("toPage");
	}

	function load() {
		var mainHeight = common.setMainHeight(_pageId, false);
		var slideHeight = mainHeight - $(_pageId + " .tab_nav").height() ;
		downslide.slideInit(slideHeight,queryData);
		queryData();
	}
	
	function queryData(){
		var entrust_way = global.entrust_way; // 委托方式  在configuration配置 
		var branch_no = userInfo.branch_no;	
		var fund_account = userInfo.fund_account;
		var cust_code = userInfo.cust_code;//关联资产账户标志
		var session_id = userInfo.session_id;
		var password = userInfo.password;
		var param={				
			"entrust_way":entrust_way,
		    "branch_no":branch_no,
		    "fund_account":fund_account,
		    "cust_code":cust_code,
		    "session_id":session_id,
		    "password":password
		};
		service_ysyy.queryYsyyList(param,queryDataCallback,{
			"isLastReq":true,
			"isShowWait":true,
			"isShowOverLay":false,
			"errorFunc":function(){
			},
			"timeOutFunc":function(){ 
				//超时调用方法
				common.setNoData(true,"暂无持仓记录");
				downslide.slideRefresh();
			}
		});
	}
	
	function queryDataCallback(data){
		if (data && data != "undefined") {
			if(data.error_no == 0){
				var results = data.results;
				if(results && results.length>0){
					
					var htmlTop = "";
					htmlTop += '<tr class="trTop"><th scope="col">代码/名称</th><th scope="col">价格/转股比</th><th scope="col">收购人代码/名称</th><th scope="col">开始/结束日期</th></tr>';
					for (var i=0;i<results.length;i++){ 
						var type = results[i].stock_code + "——" + results[i].purchase_id;
						hqStocks[type] = results[i];
						htmlTop += queryPositionHTML_stock(results[i],type);
					}
					$(_pageId+".fund_table .ce_table").html(htmlTop);
					common.setNoData(false);
					//卖出事件
					$.bindEvent($(_pageId+'.fund_table .ce_table tr.add'), function(e){
						var type = $(this).attr("id") + "——" + $(this).attr("purchase_id");
						var stock_info = hqStocks[type];
						$.pageInit("ysyy/ysyyApply", toPage, {"stockInfo":stock_info});
						e.stopPropagation();
					}, downslide.clickType());
					
				}
				else{
					common.setNoData(true,"暂无预受要约信息记录");
				}
			}else{
				$.alert(data.error_info);
			}
		}
		downslide.aboutInit();
		downslide.slideRefresh();
	}

	/**
	 * 证券持仓HTML生成
	 */
	function queryPositionHTML_stock(element,type){
		var eleHtml = "";
        eleHtml+="<tr class='add' id='"+element.stock_code +"' purchase_id='"+element.purchase_id+"'>";
        eleHtml+="<td><span>"+element.stock_name +"</span><span>"+element.stock_code +"</span></td>";
        eleHtml+="<td><span>"+element.purchase_price+"</span><span>"+element.purchase_ratio+"</span></td>";
        eleHtml+="<td><span>"+element.purchase_id+"</span><span>"+element.purchase_name+"</span></td>";
        eleHtml+="<td><span>"+element.begin_date+"</span><span>"+element.end_date+"</span></td>";
        eleHtml+="</tr>";
		return eleHtml;
	}

	/**
	 * 事件绑定
	 */
	function bindPageEvent() {
		$.bindEvent($(_pageId + ".top_title .icon_back"), function(e) {
			setTimeout(function () {
				$.pageBack();
//			$.pageInit("fund/outside/fundListQuery",toPage,null,"left");
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		
		$.preBindEvent($(_pageId + "#cancel_order_data"), ".part", function(e) {
			var param = {
				"fund_code":$(this).find(".title").find("small").text()
			};
			$.pageInit("fund/outside/fixedFundQuery",toPage,param,"left");
			e.stopPropagation();
		});
	}

	function clearMsg() {
		$(_pageId+'.fund_table .ce_table tr.add').remove();
	}

	/**
	 * 数据重置
	 */
	function destroy() {
		hqStocks = {};
		toPage = "";
		clearMsg();
		downslide.slideDestroy();
	}

	var base = {
		"init": init,
		"load": load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});