/**
 * 预受要约查询
 */
define('trade/scripts/ysyy/ysyySearch.js', function(require,exports,module){
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var	_pageId = "#ysyy_ysyySearch ";
	var service_stock = require("service_stock");
    var publicQuery = require("publicQuery");
    var userInfo = null;//保存的客户信息
    var data = {
    	"funcNo" : "301564", // 301564 301508
    	"param" : {},
    	"history":false,
    	"htmlData" : {
	    	"topDiv":{
	    		"entrust":"entrust_name",
		  		"name":"stock_name",
		  		"code":"stock_code",
	    		"time":function(e){
	    				if(e.cancel_flag == "0") {
	    					return '<a href="javascript:void(0);" class="remove_btn cancelBtn" style="right: 0;">撤单</a>';
	    				}else{
	    					return '<a href="javascript:void(0);" class="remove_btn" style="right: 0;background:#999999">撤单</a>';
	    				}
	    			},
	    	},
	    	"liList":[
	    			["交易市场","exchange_type_name"],
	    			["委托数量","entrust_amount"],
	    			["委托编号","entrust_no"],
	    			["委托时间","entrust_date"],
	    			["状态","entrust_state_name"],
	    		],
    	},
    	"clickEvent" : {
    		"id" : ".cancelBtn",
    		"event" : function(value , $this) {
//  			console.log('click remove_btn');
//  			if(value.cancel_flag == "0") {
    				cancelOrder(value);
//  			}
    		}
    	}
    }
    
    /**
     * 初始化
     */
	function init(){
		common.pageChangeHeight();
		common.pageBuryingPoint("100440");
		common.bindStockEvent($(_pageId+".tab_nav ul li a"),true);
		publicQuery.init(data);
		userInfo = common.getCurUserInfo();
		var toPage = $.getPageParam("param");
		if(toPage == "ysyy_ysyyApplyOther") {
			$(_pageId+".tab_nav ul li a").eq(0).attr("to-page", toPage);
		}else if(toPage == "ysyy_ysyyRemoveOther") {
			$(_pageId+".tab_nav ul li a").eq(1).attr("to-page", toPage);
		}
    }
		
	function load(){
		publicQuery.load();
	}
    
	/**
	 * 事件绑定
	 */
	function bindPageEvent(){
		//返回按钮
		$.bindEvent($(_pageId + " .top_title .icon_back"), function(e){
			setTimeout(function () {
				$.pageInit("ysyy/ysyySearch", "account/index");
				//埋点
				common.comStat(100442,2,103,true,{"i_group_name":"返回"});
				e.preventDefault();
				e.stopPropagation();
			},300);
		});
		//查看更多历史记录
		$.bindEvent($(_pageId + " .smorehisy"), function(e){
			//埋点
			common.comStat(100443,2,103,true,{"i_group_name":"查看更多历史记录"});
			$.pageInit("ysyy/ysyySearch", "ysyy/ysyySearchHistory");
			e.stopPropagation();
		});
		
		publicQuery.bindPageEvent();
	}
	
	function cancelOrder(data) {
		var tipStrArray = [];
		tipStrArray.push(["股票名称", data.stock_name]);
		tipStrArray.push(["股票代码 ", data.stock_code]);
		tipStrArray.push(["业务类型 ", data.entrust_name]);
		tipStrArray.push(["委托数量 ", data.entrust_amount]);
		var tipStr = "<div >";
		tipStr += common.generatePrompt(tipStrArray);
		tipStr += "</div>";
		common.iConfirm("要约撤单确认",tipStr,function success(){
			$.showPreloaders("请等待...");
			var entrust_way= global.entrust_way; // 委托方式  在configuration配置
			var param = {
				"entrust_way":entrust_way,
				"exchange_type":data.exchange_type,
				"fund_account":userInfo.fund_account,
				"branch_no":userInfo.branch_no,
				"cust_code":userInfo.cust_code,
				"session_id":userInfo.session_id,
				"entrust_no":data.entrust_no,
				"batch_flag":"0",
				"entrust_date":data.entrust_date
			};
			
			service_stock.postCancelOrder(param,orderCallback,{
				"isLastReq":true,
				"isShowWait":true,
				"isShowOverLay":false,
				"errorFunc":function(){
				},
				"timeOutFunc":function(){ 
					
				}
			});
			},function fail(){
		});
	}
	
	function orderCallback(data) {
		$.hidePreloader();
		if(data.error_no == 0){
			var results = data.results;
				if(results){
					$.alert("委托已提交，委托编号为"+data.results[0].entrust_no, function() {
						$.pageRefresh();
					});
				}
		}else{
			$.alert(data.error_info);
		}
	}
	
    
	/**
	 * 销毁
	 */
	function destroy(){
		common.pageBuryingPoint();
		publicQuery.destroy();
	}
	
	var base = {
		"init" : init,
		"load" : load,
		"bindPageEvent": bindPageEvent,
		"destroy": destroy
	};
	module.exports = base;
});