/**
 * 普通交易service层调用接口
 */
define('trade/service/scripts/trade/service.js',function(require,exports,module){
	var gconfig = $.config;
	var global = gconfig.global;
	var common = require("common");
	var nativePluginService = require("nativePluginService");
	var reqFlowNo = 0;

	//用于存储h5提交请求给原生所有请求对象
	var flowNoMap = {};
	//暴露方法供原生调用H5方法(传回服务器返回数据结果集)
	var nativeRequestCallback  = function (flowNo,resultVo){
		$.hidePreloader();
		if(resultVo.error_no == '-999' || resultVo.errorNo == '-999' || resultVo.error_no == '-919')//未登录
		{
		 	common.filterLoginOut();
			return false;
		}
		if(!resultVo.error_info){
			resultVo.error_info = "服务异常";
		}
		if(0 > Number(resultVo.error_no) &&  Number(resultVo.error_no) > -10000){
			$.callMessage({"moduleName":"sso","funcNo": "50106","content": resultVo.error_info});
			delete flowNoMap[flowNo];
			return;
		}
		if(flowNoMap[flowNo]) flowNoMap[flowNo](resultVo);
        delete flowNoMap[flowNo];
	};

	var clearNativeRequestCallback  = function (flowNo){
        delete flowNoMap[flowNo];
	};

	$.clearRequest = function(){
		flowNoMap = {};
	}

	//此方法由原生定义
	window.clearNativeRequestCallback = clearNativeRequestCallback;
    window.httpsCallback  = nativeRequestCallback;

	/********************************公共代码部分********************************/
	service.prototype.commonInvoke = function(paraMap, rewriteCallback, ctrlParam, reqParamVo){
    	if(window.isEnterBackground){//进入后台之后，不查询接口
    		return;
    	}
		var reqParamVo = this.service.reqParamVo;
	 	if(paraMap._url){
	 		reqParamVo.setUrl(paraMap._url);
	 	}
	    if(!paraMap.no_op_station){
			addOpStation(paraMap);
	    }
		var rewriteFuncNo = paraMap.funcNo;
		var callback = function(d){
			d["funcNo"] = rewriteFuncNo;
			rewriteCallback(d);
		}
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeout(ctrlParam.timeout);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
		var errorFunc =  function(){
			$.alert('服务器错误，或者网络异常!');
			if(ctrlParam.errorFunc){
				ctrlParam.errorFunc();
			}
		}
		reqParamVo.setErrorFunc(errorFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
		if(gconfig.isFordHttpReq && global.callNative)//页面将请求发送给原生app(平台为0情况下)
		{
			var flowNo = (Math.random()+"").substring(2,11) + reqFlowNo;
			reqFlowNo ++;
			if(reqFlowNo == 10000000){
				reqFlowNo = 0;
			}
			flowNoMap[flowNo] = callback;
			if(reqParamVo.obj.isShowWait){
	            $.showPreloader("请等待...");
	        }
	        var reqParamList=reqParamVo.obj.reqParam;
	        //因为有的接口没传密码，所以在这里默认加上，普通、两融、期权密码都一样，所以哪个有密码就传哪个
            if(!reqParamList.password){
                var stockUserInfo = common.getCurUserInfo(0) || {};
                var creditUserInfo = common.getCurUserInfo(1) || {};
                var optionUserInfo = common.getCurUserInfo(2) || {}
                reqParamList.password=stockUserInfo.password || creditUserInfo.password || optionUserInfo.password ;
            }
	        var timeOutNum;//设置超时时间
			if(ctrlParam.timeout){
				timeOutNum = Number(ctrlParam.timeout)/1000;
			}
			var ac = {
				'moduleName':'trade',
				'protocol':"7",
				'funcNo': '50118',
				"url": "SOCKET_TRADE_URL",
				"headerMap":{"companyId":"THINKIVE","systemId":"TRADE"},
				'paramMap': reqParamList,
				'flowNo': flowNo,
				'isPost': reqParamVo.reqType ? reqParamVo.reqType : 1,
				'timeOut': timeOutNum || 30,
				'mode': global.isTradeSign || ""
			};
			$.callMessage(ac);
		}else
		{
			//加密加签
			if (global.isSign == "3") {
				var param = reqParamVo.getReqParam();
				var bizcode = param['funcNo'];
				var funcs = global.fileterFuncs;
				if (funcs.indexOf(bizcode) == -1) {
					delete param['funcNo'];
					var signStr = $.ssoUtils.ssoSignFunc(bizcode, param);
					param = parseQueryString(signStr);
					reqParamVo.setReqParam(param);
				}
				this.service.invoke(reqParamVo, callback);
			} else {//不加密加签
				this.service.invoke(reqParamVo, callback);
			}
		}
	}

	/**
	 * 把URL参数解析为一个对象
	 * @url地址
	 * */
	function parseQueryString(url) {
		var items = url.split("&");
		var result = {};
		for (var i = 0, len = items.length; i < len; i++) {
			var obj = items[i];
			var startIndex = obj.indexOf('=');
			var key = obj.substring(0, startIndex);
			var value = obj.substring(startIndex + 1);
			result[key] = value;
		}
		return result;
	}

	//行情
	service.prototype.commonInvokeHq = function(paraMap, callback, ctrlParam, reqParamVo){
    	if(window.isEnterBackground){//进入后台之后，不查询接口
    		return;
    	}
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeout(ctrlParam.timeout);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
		reqParamVo.setErrorFunc(ctrlParam.errorFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
		if(gconfig.isHQFordHttpReq&& global.callNative)//页面将请求发送给原生app(平台为0情况下)
		{
			var flowNo = (Math.random()+"").substring(2,11) + reqFlowNo;
			reqFlowNo ++;
			if(reqFlowNo == 10000000){
				reqFlowNo = 0;
			}
			flowNoMap[flowNo] = callback;
			var URL="HQ_URL_SOCKET";
			if(reqParamVo.obj.reqParam.isOption){
				URL="HQ_OP_URL_SOCKET";
				delete eval(reqParamVo.obj.reqParam).isOption;
			}
			var timeOutNum;//设置超时时间
			if(ctrlParam.timeout){
				timeOutNum = Number(ctrlParam.timeout)/1000;
			}
			var ac = {
				'moduleName':'trade',
				'protocol':"5",//行情长连接
				'funcNo': '50118',
				"url": URL,//网络地址 (URL地址或站点名称)
//				"headerMap":{"companyId":"THINKIVE","systemId":"TRADE","loginFlag":"0"},//请求头
				'paramMap': reqParamVo.obj.reqParam,//参数
				'flowNo': flowNo,//流水号
				'isPost': reqParamVo.reqType ? reqParamVo.reqType : 1,//是否POST提交（1：是，0：否）
				'timeOut': timeOutNum || 30,//超时时间（单位是秒）
				"isJsCallBack":"1",
				'mode':  global.isSign || "0"//请求加密模式(0:正常，1:Http加签，2：Http加密，3：Http加密加签，4:Socket加密，5：Socket压缩，6：Socket压缩加密)
			};
//			console.log(ac);
			nativePluginService.function50118(ac);
			return flowNo;
		}else
		{
			this.service.invoke(reqParamVo, callback);
		}
	}

	//综合业务
	service.prototype.commonInvokeZHYW = function(paraMap, callback, ctrlParam, reqParamVo){
    	if(window.isEnterBackground){//进入后台之后，不查询接口
    		return;
    	}
		reqParamVo.setReqParam(paraMap);
		ctrlParam = ctrlParam?ctrlParam:{};
		reqParamVo.setIsLastReq(ctrlParam.isLastReq);
		reqParamVo.setIsAsync(ctrlParam.isAsync);
		reqParamVo.setIsShowWait(ctrlParam.isShowWait);
		reqParamVo.setTimeout(ctrlParam.timeout);
		reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
		reqParamVo.setErrorFunc(ctrlParam.errorFunc);
		reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
		reqParamVo.setTipsWords(ctrlParam.tipsWords);
		reqParamVo.setDataType(ctrlParam.dataType);
		reqParamVo.setIsGlobal(ctrlParam.isGlobal);
		reqParamVo.setProtocol(ctrlParam.protocol);
	    if(paraMap.has_op_station){
			addOpStation(paraMap);
            delete paraMap.has_op_station;
	    }
		if(gconfig.isHQFordHttpReq&& global.callNative)//页面将请求发送给原生app(平台为0情况下)
		{
			var flowNo = (Math.random()+"").substring(2,11) + reqFlowNo;
			reqFlowNo ++;
			if(reqFlowNo == 10000000){
				reqFlowNo = 0;
			}
			flowNoMap[flowNo] = callback;
			var URL="TK_SSO_SOCKET";
			var _systemId="YDSZHYW";//综合业务
			if(reqParamVo.obj.reqParam.isTYZH){
				_systemId="BASECIF";//综合业务
				delete eval(reqParamVo.obj.reqParam).isTYZH;
			}
			var ac = {
				'moduleName':'trade',
				'protocol':"1",//行情长连接
				'funcNo': '50118',
				"url": URL,//网络地址 (URL地址或站点名称)
				"headerMap":{"companyId":"THINKIVE","systemId":_systemId},
//				"headerMap":{"companyId":"THINKIVE","systemId":"TRADE","loginFlag":"0"},//请求头
				'paramMap': reqParamVo.obj.reqParam,//参数
				'flowNo': flowNo,//流水号
				'isPost': reqParamVo.reqType ? reqParamVo.reqType : 1,//是否POST提交（1：是，0：否）
				'timeOut': 30,//超时时间（单位是秒）
				'mode':  global.isSign || ""//请求加密模式(0:正常，1:Http加签，2：Http加密，3：Http加密加签，4:Socket加密，5：Socket压缩，6：Socket压缩加密)
			};
//			console.log(ac);
			$.callMessage(ac);
		}else
		{
			this.service.invoke(reqParamVo, callback);
		}
	}
  //新框架接口
  service.prototype.commonInvokeXKJ = function (paraMap, callback, ctrlParam, reqParamVo) {
    if (window.isEnterBackground) {//进入后台之后，不查询接口
      return;
    }
	if(!paraMap.no_op_station){
		addOpStation(paraMap);
	}
    reqParamVo.setReqParam(paraMap);
    ctrlParam = ctrlParam ? ctrlParam : {};
    reqParamVo.setIsLastReq(ctrlParam.isLastReq);
    reqParamVo.setIsAsync(ctrlParam.isAsync);
    reqParamVo.setIsShowWait(ctrlParam.isShowWait);
    reqParamVo.setTimeout(ctrlParam.timeout);
    reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
    reqParamVo.setErrorFunc(ctrlParam.errorFunc);
    reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
    reqParamVo.setTipsWords(ctrlParam.tipsWords);
    reqParamVo.setDataType(ctrlParam.dataType);
    reqParamVo.setIsGlobal(ctrlParam.isGlobal);
    reqParamVo.setProtocol(ctrlParam.protocol);
    var reqParamList=reqParamVo.obj.reqParam;
    //因为有的接口没传密码，所以在这里默认加上，普通、两融、期权密码都一样，所以哪个有密码就传哪个
    if(!reqParamList.password){
        var stockUserInfo = common.getCurUserInfo(0) || {};
        var creditUserInfo = common.getCurUserInfo(1) || {};
        var optionUserInfo = common.getCurUserInfo(2) || {}
        reqParamList.password=stockUserInfo.password || creditUserInfo.password || optionUserInfo.password ;
    }
    if (gconfig.isHQFordHttpReq && global.callNative)//页面将请求发送给原生app(平台为0情况下)
    {
      var flowNo = (Math.random() + "").substring(2, 11) + reqFlowNo;
      reqFlowNo++;
      if (reqFlowNo == 10000000) {
        reqFlowNo = 0;
      }
      flowNoMap[flowNo] = function (res) {
        if (res.results && res.results[0] && res.results[0].result) {
          res.results = JSON.parse(res.results[0].result);
        }
        callback(res);
      };
      var URL = "HJSC_SOCKET";
      var ac = {
        'moduleName': 'trade',
        'protocol': "7",//行情长连接
        'funcNo': '50118',
        "url": URL,//网络地址 (URL地址或站点名称)
        "headerMap": { "companyId": "HJSC", "systemId": "FINTECH" },
        'paramMap': reqParamVo.obj.reqParam,//参数
        'flowNo': flowNo,//流水号
        'isPost': reqParamVo.reqType ? reqParamVo.reqType : 1,//是否POST提交（1：是，0：否）
        'timeOut': 30,//超时时间（单位是秒）
        'mode': global.isTradeSign || ""//请求加密模式(0:正常，1:Http加签，2：Http加密，3：Http加密加签，4:Socket加密，5：Socket压缩，6：Socket压缩加密)
      };
      $.callMessage(ac);
    } else {
      this.service.invoke(reqParamVo, callback);
    }
  }


    //账单
    service.prototype.commonInvokeZD = function(paraMap, callback, ctrlParam, reqParamVo){
        if(window.isEnterBackground){//进入后台之后，不查询接口
            return;
        }
        reqParamVo.setReqParam(paraMap);
        ctrlParam = ctrlParam?ctrlParam:{};
        reqParamVo.setIsLastReq(ctrlParam.isLastReq);
        reqParamVo.setIsAsync(ctrlParam.isAsync);
        reqParamVo.setIsShowWait(ctrlParam.isShowWait);
        reqParamVo.setTimeout(ctrlParam.timeout);
        reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
        reqParamVo.setErrorFunc(ctrlParam.errorFunc);
        reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
        reqParamVo.setTipsWords(ctrlParam.tipsWords);
        reqParamVo.setDataType(ctrlParam.dataType);
        reqParamVo.setIsGlobal(ctrlParam.isGlobal);
        reqParamVo.setProtocol(ctrlParam.protocol);
        if(gconfig.isHQFordHttpReq&& global.callNative)//页面将请求发送给原生app(平台为0情况下)
        {
            var flowNo = (Math.random()+"").substring(2,11) + reqFlowNo;
            reqFlowNo ++;
            if(reqFlowNo == 10000000){
                reqFlowNo = 0;
            }
            flowNoMap[flowNo] = callback;
            var URL="TK_SSO_SOCKET";
            var ac = {
                'moduleName':'trade',
                'protocol':"1",//行情长连接
                'funcNo': '50118',
                "url": URL,//网络地址 (URL地址或站点名称)
                "headerMap":{"companyId":"THINKIVE","systemId":"TIIIA"},
                'paramMap': reqParamVo.obj.reqParam,//参数
                'flowNo': flowNo,//流水号
                'isPost': reqParamVo.reqType ? reqParamVo.reqType : 1,//是否POST提交（1：是，0：否）
                'timeOut': 30,//超时时间（单位是秒）
                'mode':  global.isSign || ""//请求加密模式(0:正常，1:Http加签，2：Http加密，3：Http加密加签，4:Socket加密，5：Socket压缩，6：Socket压缩加密)
            };
//			console.log(ac);
            $.callMessage(ac);
        }else
        {
            this.service.invoke(reqParamVo, callback);
        }
    }

    //新股新债
    service.prototype.commonInvokeNsb = function(paraMap, callback, ctrlParam, reqParamVo){
        if(window.isEnterBackground){//进入后台之后，不查询接口
            return;
        }
        reqParamVo.setReqParam(paraMap);
        ctrlParam = ctrlParam?ctrlParam:{};
        reqParamVo.setIsLastReq(ctrlParam.isLastReq);
        reqParamVo.setIsAsync(ctrlParam.isAsync);
        reqParamVo.setIsShowWait(ctrlParam.isShowWait);
        reqParamVo.setTimeout(ctrlParam.timeout);
        reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
        reqParamVo.setErrorFunc(ctrlParam.errorFunc);
        reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
        reqParamVo.setTipsWords(ctrlParam.tipsWords);
        reqParamVo.setDataType(ctrlParam.dataType);
        reqParamVo.setIsGlobal(ctrlParam.isGlobal);
        reqParamVo.setProtocol(ctrlParam.protocol);
        this.service.invoke(reqParamVo, callback);
    }
    //原生异步回调方法
    service.prototype.commonInvokeNativeSync = function(paraMap, callback, ctrlParam, reqParamVo){
        if(window.isEnterBackground){//进入后台之后，不查询接口
            return;
        }
        reqParamVo.setReqParam(paraMap);
        ctrlParam = ctrlParam?ctrlParam:{};
        reqParamVo.setIsLastReq(ctrlParam.isLastReq);
        reqParamVo.setIsAsync(ctrlParam.isAsync);
        reqParamVo.setIsShowWait(ctrlParam.isShowWait);
        reqParamVo.setTimeout(ctrlParam.timeout);
        reqParamVo.setTimeOutFunc(ctrlParam.timeOutFunc);
        reqParamVo.setErrorFunc(ctrlParam.errorFunc);
        reqParamVo.setIsShowOverLay(ctrlParam.isShowOverLay);
        reqParamVo.setTipsWords(ctrlParam.tipsWords);
        reqParamVo.setDataType(ctrlParam.dataType);
        reqParamVo.setIsGlobal(ctrlParam.isGlobal);
        reqParamVo.setProtocol(ctrlParam.protocol);
        if(gconfig.isHQFordHttpReq&& global.callNative)//页面将请求发送给原生app(平台为0情况下)
        {
            var flowNo = (Math.random()+"").substring(2,11) + reqFlowNo;
            reqFlowNo ++;
            if(reqFlowNo == 10000000){
                reqFlowNo = 0;
            }
            flowNoMap[flowNo] = callback;
            var URL="TK_SSO_SOCKET";
            var ac = {
                'moduleName':'trade',
                'protocol':"1",//行情长连接
				"isJsCallBack":"1",
                "url": URL,//网络地址 (URL地址或站点名称)
                "headerMap":{"companyId":"THINKIVE","systemId":"TIIIA"},
                'flowNo': flowNo,//流水号
            };
            $.callMessage($.extend(ac,paraMap));
        }else
        {
            this.service.invoke(reqParamVo, callback);
        }
    }

	/**
	 * 添加OpStation
	 * */
	function addOpStation(param){
		var channelNo = " "; // 通道编号    0： pc网页,  1： PC客户端   ，2： 安卓  ，3： IOS ，9：其他
		var ipAddr = " "; // ip
		var macAddr = " "; // mac
		var hardId = " "; // 硬盘序列号（硬件id）
		var cpuId = " "; // cpu 序列号
		var mobileNo = " "; // 手机号
		var hardIdentifier = " "; //硬件特征码
		var source = " "; // 来源
		var other = " "; // 其他
		var native_op_station = ""; // 原生获取op_station

		if($.device.android){   //通道编号   0： pc网页,  1： PC客户端   ，2： 安卓  ，3： IOS ，9：其他
			channelNo = "2";
		}else if($.device.iPad || $.device.iPhone || $.device.ios){
			channelNo = "3";
		}else if($.device.pc){
			channelNo = "0";
		}
//		channelNo = global.channel || " "; //渠道
		hardIdentifier = global.hardId || " ";//硬件特征码
		source = global.opStationInfo || " "; //来源
		mobileNo = global.activePhone || " ";//手机号
        var op_station = '';
        var nativeOpStationInfo = '';
		if(global.callNative){
			nativeOpStationInfo = $.callMessage({"funcNo": "80033"}); //获取原生op_station
			if(nativeOpStationInfo.error_no ==  "0"){
				native_op_station = nativeOpStationInfo.results[0].op_station;
			}else{
                var mobileNoInfo = $.callMessage({"funcNo":"50043","key":"activePhone"}); // 电话号码
                if(mobileNoInfo.error_no == "0"){//手机号
                    mobileNo = mobileNoInfo.results[0].value||" ";
                }
                var applicationInfo = $.callMessage({"funcNo": "50001"});
                //设备唯一码
                if($.device.iPad || $.device.iPhone || $.device.ios){
                    var hardIdInfo = $.callMessage({"funcNo": "50022"});
                    if(hardIdInfo.error_no ==  "0"){
                        hardId = hardIdInfo.results[0].deviceToken||" ";
                    }
                }else{//安卓跟ios区分开
                    if(applicationInfo.error_no ==  "0"){
                        hardId = applicationInfo.results[0].deviceMEID||" ";
                    }
                }
                //获取应用IMSI
                if(applicationInfo.error_no ==  "0"){
                    cpuId = applicationInfo.results[0].deviceIMSI||" ";
                }
                var ipAddrInfo = $.callMessage({"funcNo": "50023"}); //设备IP地址
                if(ipAddrInfo.error_no ==  "0"){
                    ipAddr = ipAddrInfo.results[0].ip||" ";
                }
                var macAddrInfo = $.callMessage({"funcNo": "50024"}); //设备MAC地址
                if(macAddrInfo.error_no ==  "0"){
                    macAddr = macAddrInfo.results[0].mac||" ";
                }
                var versionInfo = $.callMessage({"funcNo": "50010"}); //app应用版本号
                if(versionInfo.error_no ==  "0"){
                    other = versionInfo.results[0].version||" ";
                }
                var aOpStation = [];
                aOpStation.push(channelNo);
                aOpStation.push("|");
                aOpStation.push(ipAddr);
                aOpStation.push("|");
                aOpStation.push(macAddr);
                aOpStation.push("|");
                aOpStation.push(hardId);
                aOpStation.push("|");
                aOpStation.push(cpuId);
                aOpStation.push("|");
                aOpStation.push(mobileNo);
                aOpStation.push("|");
                aOpStation.push(hardIdentifier);
                aOpStation.push("|");
                aOpStation.push(source);
                aOpStation.push("|");
                aOpStation.push(other);
                op_station = aOpStation.join("");
            }
		}
        if(param){
            param.op_station = native_op_station || op_station; // 通道编号|IP地址|MAC地址|硬盘序列号|CPU序列号|手机号码|硬件特征码|来源|其他
        }
		return native_op_station || op_station;
	}


	//暴露方法供原生调用H5方法(传回服务器返回数据结果集)
	var messageRequestCallback  = function (flowNo,resultVo){
		$.hidePreloader();
		if(flowNoMap[flowNo]) flowNoMap[flowNo](resultVo);
        delete flowNoMap[flowNo];
	};
    window.callMessageByFlowNo  = messageRequestCallback;

	//更改首页登录提示
	service.prototype.callBackFun = function(_callBack){
		var flowNo = (Math.random()+"").substring(2,10);
		flowNoMap[flowNo] = _callBack;
		$.callMessage({
				"funcNo": "50500",
				"msgNo": "919",
				"sourceModule":"trade",
				"targetModule":"sso",
				"action":"4",
				"isJsCallBack":"1",
				'flowNo': flowNo,
				"param":{
					"login_type" : "2",
					"account_type" :
					"C",
					"net_channel" : ""
					}
			});
	}

	function service(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service();
});
