/**
 * 适当性service层调用接口
 */
define('trade/service/scripts/trade/service_appropr.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
	
	function service_appropr(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	
	module.exports = new service_appropr();
    
    /**
	 * 释放操作
	 */
	service_appropr.prototype.destroy = function(){
		this.service.destroy();
	};
	/********************************公共代码部分********************************/
	service_appropr.prototype.commonInvoke = service.commonInvoke;
    /********************************业务范围--股份转让********************************/

  	/**
	 * 客户准入权限查询及是否存在适当性不匹配持仓查询
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} password                	交易密码
  	 * @param {Object} sessionid                会话号
   	 * @param {Object} entrust_bs               买卖方向
	 * @param {Object} callback	回调方法
	 * */
  	service_appropr.prototype.accessAuthority=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "399800";
	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] = param.password;
	    paraMap["sessionid"] =  param.sessionid;
	    paraMap["client_right"] = param.client_right;
	    paraMap["business_type"] = param.client_right;
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
  	 * 交易适当性查询
  	 *
  	 */
	service_appropr.prototype.queryAppropria=function(param,callback,ctrlParam){
  		var paraMap = {};
  		paraMap["funcNo"] = "399801";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["sessionid"] =  param.sessionid;
	    paraMap["password"] =  param.password;
	    paraMap["entrust_bs"] = param.entrust_bs;  
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["stock_account"] = param.stock_account;
 		paraMap["business_type"] = param.business_type;
	    paraMap["exchange_type"] = param.exchange_type;
	    paraMap["fund_company"] = param.fund_company;
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
  	 * 用户确认购买适当性不匹配产品的留痕
  	 *
  	 */
	service_appropr.prototype.mismatchingMark=function(param,callback,ctrlParam){
  		var paraMap = {};
  		paraMap["funcNo"] = "399803";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["sessionid"] =  param.sessionid;
	    paraMap["password"] =  param.password;
	    paraMap["entrust_bs"] = param.entrust_bs;  
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["stock_account"] = param.stock_account;
 		paraMap["business_type"] = param.business_type;
	    paraMap["exchange_type"] = param.exchange_type;
	    paraMap["instr_batch_no"] = param.instr_batch_no;
	    paraMap["instr_type"] = param.instr_type;
	    paraMap["text_content_no"] = param.text_content_no;
	    paraMap["time_limit"] = param.time_limit;
	    paraMap["busi_risk_level"] = param.busi_risk_level;
	    paraMap["revenue_type"] = param.revenue_type;
	    paraMap["invest_type"] = param.invest_type;

	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
  	 * 风险揭示书查询
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} sessionid                会话号
  	 * */
  	service_appropr.prototype.queryRiskDisclosure = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "399802";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] =  param.password;
	    paraMap["flag_num"] = param.flag_num;
	    paraMap["sessionid"] =  param.sessionid;
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
  	 * 持仓适当性匹配详情
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} sessionid                会话号
  	 * */
  	service_appropr.prototype.positionAdequacy=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "399804";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] =  param.password;
	    paraMap["sessionid"] =  param.sessionid;
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
	

	/***应用接口......................................................结束*/

});