/**
 * 基金service层调用接口
 */
define('trade/service/scripts/trade/service_creditKcb.js',function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
    
	/********************************公共代码部分********************************/
    service_creditKcb.prototype.commonInvoke = service.commonInvoke;

	service_creditKcb.prototype.destroy = function(){
		this.service.destroy();
	};
	function service_creditKcb(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service_creditKcb();
	
	/********************************应用接口开始********************************/
	
	/********************************业务范围--融资融券********************************/
	  /**
 	 * 融资融券信用买卖股票联动
 	 * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
 	 * @param {Object} password                 交易密码
     * @param {Object} session_id                会话号
     * @param {Object} entrust_bs            	委托标志
     * @param {Object} entrust_type             委托类别（见数据字典)
     * @param {Object} stock_code               股票代码
     * @param {Object} entrust_price            委托价格
     * @param {Object} newstock_flag            是否新股(0:否，1：是)
     * @param {Object} stock_account            股东账户
     * @param {Object} stock_accounts  证券账户集合   市场代码:账户类别:证券账户,市场代码:账户类别:证券账户,….
 	 * @param callback 回调函数
 	 */
	 service_creditKcb.prototype.stock_link = function(param,callback,ctrlParam){
		 var paraMap = {};
		 paraMap["funcNo"] = "303000";
		 paraMap["entrust_way"] = param.entrust_way;
		 paraMap["branch_no"] = param.branch_no;
		 paraMap["fund_account"] = param.fund_account;
		 paraMap["cust_code"] = param.cust_code;
		 paraMap["password"] = param.password;
		 paraMap["session_id"] = param.session_id;
		 paraMap["entrust_bs"] = param.entrust_bs;
		 paraMap["entrust_type"] = param.entrust_type; 
		 paraMap["stock_code"] = param.stock_code;
		 paraMap["entrust_price"] = param.entrust_price;
		 paraMap["stock_account"] = param.stock_account;
		 paraMap["stock_accounts"] = param.stock_accounts;
		 paraMap["newstock_flag"] = param.newstock_flag;
		 paraMap["exchange_type"]=param.exchange_type;
		  // 添加 op_station 到接口请求参数中
		 var reqParamVo = this.service.reqParamVo;
	  	 reqParamVo.setUrl(global.serverPathTrade);
	  	 this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      };
      
	/**
	* 融资融券委托交易
	* @param {Object} entrust_way              委托方式
	* @param {Object} branch_no                分支机构
	* @param {Object} fund_account             资金账号
	* @param {Object} cust_code                客户编号
	* @param {Object} password                 交易密码
	* @param {Object} session_id                会话号
	* @param {Object} entrust_bs               委托标志
	* @param {Object} entrust_type             委托类别
	* @param {Object} exchange_type            交易市场类别	  
	* @param {Object} stock_account            证券账号
	* @param {Object} stock_code               股票代码
	* @param {Object} entrust_price            委托价格
	* @param {Object} entrust_amount           委托数量
	* @param {Object} batch_no                 委托批号
	* @param callback 回调函数
	*/
	service_creditKcb.prototype.entrust_trade = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303001";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_type"] = param.entrust_type;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["compact_id"] = param.compact_id;
		paraMap["batch_no"] = param.batch_no;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户担保证券信息查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易市场类别	  
	 * @param {Object} stock_code               股票代码
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.db_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303002";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange`_type"] = param.exchange_type;
		paraMap["stock_code"] = param.stock_code;
		paraMap["position_str"] = param.position_str;
		paraMap["request_num"] = param.request_num;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户证券持仓查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票代码
	 * @param {Object} exchange_type            交易市场类别	  
	 * @param {Object} query_flag            	科创板标识	  
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.cc_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303003";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["query_flag"] = param.query_flag;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 资金账户查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} money_type            	币种类别
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.zjzh_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303004";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["query_flag"] = param.query_flag;
		paraMap["flag"] = "0";
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
      
    /**
	 * 融资证券资格信息查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_code            	证券代码
	 * @param {Object} exchange_type            交易市场类别（见数据字典)
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.qualificationInquiry = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303005";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["position_str"] = param.position_str;
		paraMap["request_num"] = param.request_num;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
      
    /**
	 * 客户可融券信息查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_code            	证券代码
	 * @param {Object} exchange_type            交易市场类别（见数据字典)
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.queryCanBeMargin = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303006";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["position_str"] = param.position_str;
		paraMap["request_num"] = param.request_num;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};   
	
	/**
	 * 客户融资融券合约查询【汇总模式】
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code            	证券代码
	 * @param {Object} exchange_type            交易市场类别（见数据字典)
	 * @param {Object} begin_date               起始开仓日期
	 * @param {Object} end_date                 到期开仓日期
	 * @param {Object} compact_type 			合约类型(0-融资，1-融券)
	 * @param {Object} query_type               交易市场类别（见数据字典)查询模式(0-未了结，1-当日已了结)
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.contractInquiry = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303007";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		paraMap["compact_type"] = param.compact_type;
		paraMap["query_type"] = param.query_type;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券实时合约查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code            	证券代码
	 * @param {Object} exchange_type            交易市场类别（见数据字典)
	 * @param {Object} compact_id               合约编号
	 * @param {Object} compact_type             合约类型
	 * @param {Object} query_type               交易市场类别（见数据字典)查询模式(0-未了结，1-当日已了结)
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.curcontractquery = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303008";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["compact_id"] = param.compact_id;
		paraMap["compact_type"] = param.compact_type;
		paraMap["query_type"] = param.query_type;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券资产负债查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} money_type               币种类别
	 * @param {Object} query_flag               科创板标识
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.zcfz_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303009";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["query_flag"] = param.query_flag;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券直接还款
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} money_type               币种类别
	 * @param {Object} pay_type                 还款方式（0：按金额还，1：按笔还）
	 * @param {Object} occur_balance            还款金额
	 * @param {Object} compact_id               还款合约编号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.repayment = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303010";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["pay_type"] = param.pay_type;
		paraMap["occur_balance"] = param.occur_balance;
		paraMap["compact_id"] = param.compact_id;
		paraMap["jzwin_debtdate"] = param.jzwin_debtdate;
		paraMap["jzwin_debtsno"] = param.jzwin_debtsno;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券直接还券
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易市场类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} entrust_amount           还券数量
	 * @param {Object} compact_id               还款合约编号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.repaystock = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303011";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["compact_id"] = param.compact_id;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券直接还款联动
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.remoney_link = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303012";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户融资融券直接还券联动
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_code               股票代码
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.restock_link = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303013";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_code"] = param.stock_code;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 担保品划转联动
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} password_crdt            信用账户交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} branch_no_crdt           信用账户分支机构
	 * @param {Object} fund_account_crdt        信用账户资金账号
	 * @param {Object} client_id_crdt           信用客户编号
	 * @param {Object} password_crdt            信用账户交易密码
	 * @param {Object} stock_code               股票代码
	 * @param {Object} cost_price               持仓成本价
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} entrust_bs               买卖方向（0：买入--普转信，1：卖出--信转普）
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.dbin_link = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303014";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		
		paraMap["branch_no_nor"] = param.branch_no_nor;
		paraMap["cust_code_nor"] = param.cust_code_nor;
		paraMap["fund_account_nor"] = param.fund_account_nor;
		paraMap["password_nor"] = param.password_nor;
		
		paraMap["stock_code"] = param.stock_code;
		paraMap["cost_price"] = param.cost_price;
		paraMap["last_price"] = param.last_price;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 担保品划转提交
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} password_crdt            信用账户交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} seat_no                  席位编号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_code               股票代码
	 * @param {Object} entrust_amount           过户数量
	 * @param {Object} branch_no_crdt           信用账户分支机构
	 * @param {Object} client_id_crdt           信用客户编号
	 * @param {Object} fund_account_crdt        信用账户资金账号
	 * @param {Object} stock_account_crdt       证券账号
	 * @param {Object} seat_no_crdt             席位编号
	 * @param {Object} cost_price               持仓成本价
	 * @param {Object} entrust_bs               买卖方向（0：买入--普转信，1：卖出--信转普）
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.dbin_sub = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303015";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;	
		paraMap["stock_account"] = param.stock_account;
		paraMap["seat_no"] = param.seat_no;
		paraMap["branch_no_nor"] = param.branch_no_nor;
//		paraMap["cust_code_crdt"] = param.cust_code_nor;
		paraMap["cust_code_nor"] = param.cust_code_nor;
		paraMap["fund_account_nor"] = param.fund_account_nor;
		paraMap["stock_account_nor"] = param.stock_account_nor;
		paraMap["password_nor"] = param.password_nor;	
		paraMap["seat_no_nor"] = param.seat_no_nor;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["cost_price"] = param.cost_price;
		paraMap["last_price"] = param.last_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 融资融券当日委托查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               席位编号
	 * @param {Object} entrust_bs               买卖方向（0：买入--普转信，1：卖出--信转普）
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.todaywt_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303016";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 融资融券当日可撤委托查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               席位编号
	 * @param {Object} entrust_bs               买卖方向（0：买入--普转信，1：卖出--信转普）
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.todaykcwt_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303017";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/** 
	 * 融资融券撤单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} entrust_no               委托编号
	 * @param {Object} batch_flag               批量撤单标志（0:不是，1：是）
	 * @param {Object} exchange_type            交易市场类别
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.credit_cancel = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303018";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["batch_flag"] = param.batch_flag;
		paraMap["exchange_type"] = param.exchange_type;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/** 
	 * 融资融券当日成交查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易市场类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} entrust_bs               委托标志
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.todaycj_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303019";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/** 
	 * 融资融券历史委托查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易市场类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                 截止日期
	 * @param {Object} entrust_bs               委托标志
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.historywt_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303020";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["begin_time"] = param.begin_time;
		paraMap["end_time"] = param.end_time;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/** 
	 * 客户融资融券合约查询【明细模式】
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} exchange_type            交易市场类别
	 * @param {Object} begin_date               开始日期
	 * @param {Object} end_date                 截止日期
	 * @param {Object} compact_type             合约类型(0-融资，1-融券)
	 * @param {Object} query_type               查询模式(0-未了结，1-当日已了结)
	 * @param {Object} compact_id               合约编号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.contractmx_query = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303021";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		paraMap["compact_type"] = param.compact_type;
		paraMap["query_type"] = param.query_type;
		paraMap["compact_id"] = param.compact_id;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/** 
	 * 客户融资融券负债变动流水
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} begin_date               开始日期
	 * @param {Object} end_date                 截止日期
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.credit_bdls = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303022";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	 /**
     * 融资融券担保品划转委托查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param op_station	varchar(50)	操作站点（见数据字典)
     * @param session_id	varchar(32)	会话号
     * @param exchange_type	varchar(1)	交易市场类别（见数据字典)
     * @param stock_account	varchar(20)	证券账号
     * @param stock_code	varchar(6)	证券代码
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)

     * @param callback 回调函数
     * */
    service_creditKcb.prototype.queryGh = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303023";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["entrust_bs"] = param.entrust_bs;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
	
	 /**
     * 融资融券担保品划转可撤委托查询
     * @param entrust_way varchar(1)	委托方式（见数据字典)	Y	
     * @param branch_no varchar(10)	分支机构	Y
     * @param fund_account varchar(20)	资金账号	Y	
     * @param cust_code varchar(32)	客户编号	Y	
     * @param password varchar(32)	交易密码	N	恒生版本不能为空
     * @param op_station varchar(50)	操作站点（见数据字典)	Y	
     * @param session_id varchar(32)	会话号	N	MID版本不能为空
     * @param exchange_type varchar(1)	交易市场类别（见数据字典)
     * @param stock_account varchar(20)	证券账号
     * @param stock_code varchar(6)	证券代码
     * @param entrust_bs varchar(2)	委托标志（见数据字典)
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.queryTransCanCancel = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303024";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["op_station"] = param.op_station;
    	paraMap["session_id"] = param.session_id;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["entrust_bs"] = param.entrust_bs;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    
    /**
     * 融资融券担保品划转委托查询(历史)
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param op_station	varchar(50)	操作站点（见数据字典)
     * @param session_id	varchar(32)	会话号
     * @param exchange_type	varchar(1)	交易市场类别（见数据字典)
     * @param stock_account	varchar(20)	证券账号
     * @param stock_code	varchar(6)	证券代码
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)

     * @param callback 回调函数
     * */
    service_creditKcb.prototype.queryGhHistory = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303025";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["begin_time"] = param.begin_time;
    	paraMap["end_time"] = param.end_time;
    	paraMap["entrust_bs"] = param.entrust_bs;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 融资融券资产负债综合查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param op_station	varchar(50)	操作站点（见数据字典)
     * @param session_id	varchar(32)	会话号
     * @param session_id	varchar(32)	币种类别（见数据字典)
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.rzrq_liabilitiesQuery = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303026";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["money_type"] = param.money_type;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 融资融券交割单查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号
     * @param money_type	varchar(20)	币种类别
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)
	 * @param begin_time	varchar(2)	开始时间
	 * @param end time 	varchar(2)	结束时间
	 * @param exchange_type 	varchar(1)	交易市场类别（见数据字典)
	 * @param stock_account	varchar(20)	证券账号
	 * @param stock_code 	varchar(6)	证券代码
	 * @param money_type 	varchar(1)	币种类别（见数据字典)
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.deliveryOrder_Query = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303027";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["money_type"] = param.money_type;
    	paraMap["begin_time"] = param.begin_time;
    	paraMap["end_time"] = param.end_time;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["money_type"] = param.money_type;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 融资融券新股申购额度查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param op_station	varchar(50)	操作站点（见数据字典)
     * @param session_id	varchar(32)	会话号
     * @param exchange_type	varchar(1)	交易市场类别（见数据字典)
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.newAmount_Query = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303028";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["exchange_type"] = param.exchange_type;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
     /**
     * 配号查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号
     * @param money_type	varchar(20)	币种类别
     * @param exchange_type 	varchar(1)	交易市场类别（见数据字典)
	 * @param stock_account	varchar(20)	证券账号
	 * @param stock_code 	varchar(6)	证券代码
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)
	 * @param begin_date	varchar(2)	开始时间
	 * @param end_date 	varchar(2)	结束时间
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.distribution_query = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303029";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["begin_date"] = param.begin_date;
    	paraMap["end_date"] = param.end_date;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 中签查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号
     * @param money_type	varchar(20)	币种类别
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)
	 * @param begin_date	varchar(2)	开始时间
	 * @param end_date 	varchar(2)	结束时间
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.success_Query = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303030";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
    	paraMap["begin_date"] = param.begin_date;
    	paraMap["end_date"] = param.end_date;
    	paraMap["entrust_bs"] = param.entrust_bs;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
 	 * 融资融券授信额度调整申请
 	 * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
 	 * @param {Object} password                 交易密码
     * @param {Object} session_id                会话号
     * @param {Object} money_type        		币种类别（见数据字典）
     * @param {Object} valid_date        		有效日期
     * @param {Object} fin_apply_quota        	融资申请额度
     * @param {Object} slo_apply_quota        	融券申请额度
     * @param {Object} total_apply_quota        申请总额度
 	 * @param callback 回调函数
 	 */
	 service_creditKcb.prototype.submitApplication = function(param,callback,ctrlParam){
		 var paraMap = {};
		 paraMap["funcNo"] = "303031";
		 paraMap["entrust_way"] = param.entrust_way;
		 paraMap["branch_no"] = param.branch_no;
		 paraMap["fund_account"] = param.fund_account;
		 paraMap["cust_code"] = param.cust_code;
		 paraMap["password"] = param.password;
		 paraMap["session_id"] = param.session_id;
		 paraMap["money_type"] = param.money_type;
		 paraMap["valid_date"] = param.valid_date;
		 paraMap["fin_apply_quota"] = param.fin_apply_quota;
		 paraMap["slo_apply_quota"] = param.slo_apply_quota;
		 paraMap["total_apply_quota"] = param.total_apply_quota;
		  // 添加 op_station 到接口请求参数中
		 var reqParamVo = this.service.reqParamVo;
	  	 reqParamVo.setUrl( global.serverPathTrade);
	  	 this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      };
      
    /**
 	 * 客户信用额度调整申请查询
 	 * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
 	 * @param {Object} password                 交易密码
     * @param {Object} session_id                会话号
     * @param {Object} money_type        		币种类别（见数据字典）
     * @param {Object} valid_date        		有效日期
     * @param {Object} fin_apply_quota        	融资申请额度
     * @param {Object} slo_apply_quota        	融券申请额度
     * @param {Object} total_apply_quota        申请总额度
 	 * @param callback 回调函数
 	 */
	 service_creditKcb.prototype.custApplyQuery = function(param,callback,ctrlParam){
		 var paraMap = {};
		 paraMap["funcNo"] = "303032";
		 paraMap["entrust_way"] = param.entrust_way;
		 paraMap["branch_no"] = param.branch_no;
		 paraMap["fund_account"] = param.fund_account;
		 paraMap["cust_code"] = param.cust_code;
		 paraMap["password"] = param.password;
		 paraMap["session_id"] = param.session_id;
		 paraMap["money_type"] = param.money_type;
		  // 添加 op_station 到接口请求参数中
		 var reqParamVo = this.service.reqParamVo;
	  	 reqParamVo.setUrl( global.serverPathTrade);
	  	 this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      };
      
    
    
    /**
     * 未平仓合约查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号
     * @param money_type	varchar(20)	币种类别
	 * @param begin_date	varchar(2)	开始时间
	 * @param end_date	varchar(2)	结束时间
	 * * @param stock_account	varchar(20)	证券账号
	 * @param stock_code 	varchar(6)	证券代码
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)
     * @param {Object} compact_type             合约类型(0-融资，1-融券)
	 * @param {Object} query_type               查询模式(0-未了结，1-当日已了结)
	 * @param {Object} compact_id               合约编号
	 * @param {Object} query_mode               查询模式 0/空格-查明细，1-按照合约类型和证券代码
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.openInterest_Query = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303007";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["jzwin_status"] = param.jzwin_status;
    	paraMap["session_id"] = param.session_id;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["begin_date"] = param.begin_date;
    	paraMap["end_date"] = param.end_date;
    	paraMap["compact_type"] = param.compact_type;
		paraMap["query_type"] = param.query_type;
		paraMap["compact_id"] = param.compact_id;
		paraMap["compact_postpone_flag"] = param.compact_postpone_flag;
		paraMap["query_mode"] = param.query_mode;
		 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
   
    /**
     * 融资融担保品转入查询
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号
     * @param money_type	varchar(20)	币种类别
	 * @param begin_date	varchar(2)	开始时间
	 * @param end_date	varchar(2)	结束时间
	 * * @param stock_account	varchar(20)	证券账号
	 * @param stock_code 	varchar(6)	证券代码
     * @param entrust_bs	varchar(2)	委托标志（见数据字典)
     * @param {Object} compact_type             合约类型(0-融资，1-融券)
	 * @param {Object} query_type               查询模式(0-未了结，1-当日已了结)
	 * @param {Object} compact_id               合约编号
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.transferInPostion = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303046";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["password"] = param.password;
    	paraMap["branch_no_nor"] = param.branch_no_nor;
    	paraMap["cust_code_nor"] = param.cust_code_nor;
    	paraMap["fund_account_nor"] = param.fund_account_nor;
    	paraMap["password_nor"] = param.password_nor;
    	paraMap["session_id"] = param.session_id;
    	paraMap["stock_account_nor"] = param.stock_account_nor;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["exchange_type"] = param.exchange_type;
    	paraMap["query_margin_flag"] = param.query_margin_flag;
		 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 查询普通资金账号
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号  
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.queryStockAccount = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303047";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
		 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
	/**
	 * 获取密钥对
	 * @param callback 回调函数
	 * */
	service_creditKcb.prototype.getKey = function(param,callback,ctrlParam){
 	    var paraMap = {};
		paraMap["funcNo"] = "1000000";
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
     };
     /**
     * 融资融券卖券还款按笔还款
     * @param entrust_way	varchar(1)	委托方式（见数据字典)
     * @param branch_no	varchar(10)	分支机构
     * @param fund_account	varchar(20)	资金账号
     * @param cust_code	varchar(32)	客户编号
     * @param password	varchar(32)	交易密码
     * @param session_id	varchar(32)	会话号  
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.repayCash = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "303049";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["password"] = param.password;
    	paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["init_date"] = param.init_date;
		paraMap["debit_type"] = param.debit_type;
		paraMap["serial_no"] = param.serial_no;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
    
    /**
     * 交易证券持仓查询
     * @param entrust_way varchar(1)	委托方式（见数据字典)	Y	
     * @param branch_no varchar(10)	分支机构	Y
     * @param fund_account varchar(20)	资金账号	Y	
     * @param cust_code varchar(32)	客户编号	Y	
     * @param password varchar(32)	交易密码	N	恒生版本不能为空
     * @param op_station varchar(50)	操作站点（见数据字典)	Y	
     * @param session_id varchar(32)	会话号	N	MID版本不能为空
     * @param stock_account varchar(20)	证券账号	N	
     * @param stock_code varchar(6)	证券代码	N	
     * @param exchange_type varchar(4)	交易市场类别（见数据字典)	N	
     * @param callback 回调函数
     * */
    service_creditKcb.prototype.queryTradePosition = function(param,callback,ctrlParam){

    	var paraMap = {};
    	paraMap["funcNo"] = "301503";
    	paraMap["entrust_way"] = param.entrust_way;
    	paraMap["branch_no"] = param.branch_no;
    	paraMap["fund_account"] = param.fund_account;
    	paraMap["cust_code"] = param.cust_code;
    	paraMap["password"] = param.password;
    	paraMap["op_station"] = param.op_station;
    	paraMap["session_id"] = param.session_id;
    	paraMap["stock_account"] = param.stock_account;
    	paraMap["stock_code"] = param.stock_code;
    	paraMap["exchange_type"] = param.exchange_type;
    	 // 添加 op_station 到接口请求参数中
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
   
   
	
	/**
  	 * 获取开通转账银行账号
  	 * @param {Object} entrust_way     委托方式
  	 * @param {Object} branch_no       分支机构
  	 * @param {Object} fund_account    资金账号
  	 * @param {Object} cust_code       客户编号
  	 * @param {Object} session_id       会话号
   	 * @param {Object} bank_code       银行代码
  	 * @param {Object} money_type      币种
  	 * */
      service_creditKcb.prototype.queryAccounts = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300200";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["bank_code"] = param.bank_code;
  	    paraMap["money_type"] = param.money_type;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	}; 	
  	
  	/**
  	 * 查询转账银行业务信息
  	 * @param {Object} entrust_way     委托方式
  	 * @param {Object} branch_no       分支机构
  	 * @param {Object} fund_account    资金账号
  	 * @param {Object} cust_code       客户编号
  	 * @param {Object} session_id       会话号
  	 * @param {Object} password       交易密码
  	 * @param {Object} transfer_direction 转账方向
   	 * @param {Object} bank_code       银行代码
  	 * @param {Object} money_type      币种
  	 * */
      service_creditKcb.prototype.queryBankInfo = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300201";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["password"] = param.password;
  	    paraMap["transfer_direction"] = param.transfer_direction;
  	    paraMap["bank_code"] = param.bank_code;
  	    paraMap["money_type"] = param.money_type;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	}; 
  	
  	
	/**
  	 * 银证转账
  	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
   	 * @param {Object} bank_code                银行代码
  	 * @param {Object} money_type               币种
  	 * @param {Object} transfer_direction       转账方向
  	 * @param {Object} tranamt                  发生金额
   	 * @param {Object} fund_password            资金密码
  	 * @param {Object} bank_password            银行密码
  	 * @param {Object} client_account           存管资金账号
  	 * */
      service_creditKcb.prototype.transfer = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300202";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["bank_code"] = param.bank_code;
  	    paraMap["money_type"] = param.money_type;
  	    paraMap["transfer_direction"] = param.transfer_direction;
       	paraMap["tranamt"] = param.tranamt;	
  	    paraMap["fund_password"] = param.fund_password;
  	    paraMap["bank_password"] = param.bank_password;
  	    paraMap["client_account"] = param.client_account;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	
/**
  	 * 银证转账查询
  	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
   	 * @param {Object} money_type               币种
  	 * */
      service_creditKcb.prototype.transferQuery = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300203";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["money_type"] = param.money_type;
  	    paraMap["begin_time"] = param.begin_time;
  	    paraMap["end_time"] = param.end_time;
  	    paraMap["transfer_direction"] = param.transfer_direction;
		 // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	}; 	
  	
  	/**
  	 * 银证转账银行余额
  	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} bank_code				银行代码
   	 * @param {Object} money_type               币种
   	 * @param {Object} bank_password			银行密码
  	 * */
      service_creditKcb.prototype.bankBalance = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300204";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["bank_code"] = param.bank_code;
  	    paraMap["money_type"] = param.money_type;
  	    paraMap["bank_password"] = param.bank_password;
		 // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	}; 	
  	
  	/**
  	 * 验证原密码
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} password_type            密码类型
  	 * @param {Object} password                 校验的密码
  	 * @param {Object} mac                		mac地址
  	 * @param {Object} hddsn             		硬盘序列号
  	 * @param {Object} ip               		ip地址
  	 * @param {Object} callback	回调方法
  	 */
      service_creditKcb.prototype.validatePassword = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "300107";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["password"] =  param.password;
	    paraMap["password_type"] = param.password_type;
		 // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	
	/**
  	 * 修改密码
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} passowrd_type            密码类型
  	 * @param {Object} password_new             旧密码
  	 * @param {Object} password_new             新密码
  	 * @param {Object} mac                		mac地址
  	 * @param {Object} hddsn             		硬盘序列号
  	 * @param {Object} ip               		ip地址
  	 * @param {Object} callback	回调方法
  	 */
    service_creditKcb.prototype.updatePassword = function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "300101";
	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] = param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] = param.cust_code;
	    paraMap["session_id"] = param.session_id;
	    paraMap["passowrd_type"] = param.passowrd_type;
	    paraMap["password_old"] = param.password_old;
	    paraMap["password_new"] = param.password_new;
		 // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
  	
  	/**
  	 * 资金流水查询
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} begin_time               开始日期
  	 * @param {Object} end_time                	截止日期
  	 * @param {Object} callback	回调方法
  	*/
    service_creditKcb.prototype.queryAccountFlow = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "301505";
  	    paraMap["entrust_way"] =  param.entrust_way;
  	    paraMap["branch_no"] =  param.branch_no;
  	    paraMap["fund_account"] =  param.fund_account;
  	    paraMap["cust_code"] =  param.cust_code;
  	    paraMap["money_type"] =  param.money_type;
  	    paraMap["session_id"] =  param.session_id;
  	    paraMap["begin_date"] =  param.begin_date;
  	    paraMap["end_date"] =  param.end_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
     * 获取指定日期向前(向后)第N个交易日
     * @param {Object} trade_date varchar(30)	查询日期	Y	yyyy-MM-dd
     * @param {Object} sort varchar(1)	查询方向(0:向前,1向后)	N	默认取1
     * @param {Object} days	int	第几个交易日	N	默认取1
     * @param callback 回调函数
     */
    service_creditKcb.prototype.queryDiffTardeDate = function(param,callback,ctrlParam){
  		var paraMap = {};
    	paraMap["funcNo"] = "901902";
    	paraMap["trade_date"] = param.trade_date;
    	paraMap["sort"] = param.sort;
    	paraMap["days"] = param.days;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	
      /**
     * 获取服务器上当前日期
     * @param callback 回调函数
     */
    service_creditKcb.prototype.getCurTime = function(param,callback,ctrlParam){
    	var paraMap = {};
    	paraMap["funcNo"] = "1000002";
    	var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
 	 * 用户登录
 	 * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
 	 * @param {Object} input_type               登录类别（见数据字典）
     * @param {Object} input_content            登录账号
     * @param {Object} op_station            	操作站点（见数据字典）
     * @param {Object} password                 密码
     * @param {Object} content_type             客户标识类型
 	 * @param {Object} auth_type              	认证方式 （见数据字典）
     * @param {Object} auth_source          	认证原文相关信息
     * @param {Object} auth_key             	认证串
     * @param {Object} auth_bind_station        硬件绑定地址(硬件机器码)
     * @param {Object} ticket        图片验证码
     * @param {Object} mobileKey        验证码的 key
     * @param {Object} ticketFlag        0 不需要验证码 1 需要验证码
 	 * @param callback 回调函数
 	 */
    service_creditKcb.prototype.login = function(param,callback,ctrlParam){
  	    var paraMap = {};
 		paraMap["funcNo"] = "300100";
 		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["input_type"] = param.input_type;
 		paraMap["input_content"] = param.input_content;
 		paraMap["op_station"] = param.op_station;
 		paraMap["password"] = param.password;
 		paraMap["content_type"] = param.content_type;
 		paraMap["auth_type"] = param.auth_type;
 		paraMap["auth_source"] = param.auth_source;
 		paraMap["auth_key"] = param.auth_key;
 		paraMap["auth_bind_station"] = param.auth_bind_station;
 		paraMap["ticket"] = param.ticket;
 		paraMap["mobileKey"] = param.mobileKey;
 		paraMap["ticketFlag"] = param.ticketFlag;
		 // 添加 op_station 到接口请求参数中
 		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
  	 * 历史成交查询
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} begin_time               开始日期
  	 * @param {Object} end_time                	截止日期
  	 * @param {Object} callback	回调方法
  	 */
      service_creditKcb.prototype.queryHistoryTrade = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "303036";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["begin_time"] =  param.begin_time;
	    paraMap["end_time"] =  param.end_time;
		paraMap["entrust_bs"] = param.entrust_bs;
		 // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
   
    /**
  	 * 资金股份流水
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} begin_time               开始日期
  	 * @param {Object} end_time                	截止日期
  	 * @param {Object} callback	回调方法
  	 */
      service_creditKcb.prototype.queryAssetFlow = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "303043";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["password"] =  param.password;
	    paraMap["begin_time"] =  param.begin_time;
	    paraMap["end_time"] =  param.end_time;
		 // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	/**
  	 * 查询融券卖出
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} begin_time               开始日期
  	 * @param {Object} end_time                	截止日期
  	 * @param {Object} callback	回调方法
  	 */
      service_creditKcb.prototype.queryFinacingToSell = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "303044";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
   /** 
	 * 物资划转交易登录
	 * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
 	 * @param {Object} input_type               登录类别（见数据字典）
     * @param {Object} input_content            登录账号
     * @param {Object} op_station            	操作站点（见数据字典）
     * @param {Object} password                 密码
     * @param {Object} content_type             客户标识类型
 	 * @param {Object} auth_type              	认证方式 （见数据字典）
     * @param {Object} auth_source          	认证原文相关信息
     * @param {Object} auth_key             	认证串
     * @param {Object} auth_bind_station        硬件绑定地址(硬件机器码)
     * @param {Object} ticket        图片验证码
     * @param {Object} mobileKey        验证码的 key
     * @param {Object} ticketFlag        0 不需要验证码 1 需要验证码
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.goodsSwitchTradeLogin = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "1000008";
 		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
 		paraMap["input_type"] = param.input_type;
 		paraMap["input_content"] = param.input_content;
 		paraMap["password"] = param.password;
 		paraMap["ticketFlag"] = param.ticketFlag;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
  	/**
  	 * 查询融券负债
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * @param {Object} begin_time               开始日期
  	 * @param {Object} end_time                	截止日期
  	 * @param {Object} callback	回调方法
  	 */
      service_creditKcb.prototype.queryRqLiabilities = function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "303048";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["password"] =  param.password;
	    paraMap["entrust_price"] =  param.entrust_price;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_code"] =  param.stock_code;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
  	
  	/**
	 * 客户证券持仓查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票代码
	 * @param {Object} exchange_type            交易市场类别	  
	 * @param {Object} query_nor_flag           是否查询普通股东账号（1，查询，其他：不查询）
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.queryTransferPositions = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303003";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["query_nor_flag"] = param.query_nor_flag;
		
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户证券持仓查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票代码
	 * @param {Object} exchange_type            交易市场类别	  
	 * 	open_date	varchar(20)	合约开仓日期
		end_date	varchar(32)	到期日期
		compact_id	varchar(32)	合约合同号

	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.contractExtension = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303055";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["compact_id"] = param.compact_id;
		paraMap["compact_id_str"] = param.compact_id_str;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 客户证券持仓查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票代码
	 * @param {Object} exchange_type            交易市场类别	  
	 * 	open_date	varchar(20)	合约开仓日期
		end_date	varchar(32)	到期日期
		compact_id	varchar(32)	合约合同号

	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.queryContractExtension = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303054";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		paraMap["extend_status"] = param.extend_status;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 授信额度调整取消
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.creditGrantingCancel = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303033";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_no"] = param.entrust_no;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 授信额度调整查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.creditGrantingQuery = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303032";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 授信额度调整申请
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                 交易密码
	 * @param {Object} session_id                会话号
	 * @param callback 回调函数
	 */
	service_creditKcb.prototype.creditGrantingApply = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "303031";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["slo_apply_quota"] = param.slo_apply_quota;//融券申请额度
		paraMap["fin_apply_quota"] = param.fin_apply_quota;//融资申请额度
		paraMap["total_apply_quota"] = param.total_apply_quota;//申请总额度
		paraMap["valid_date"] = param.valid_date;//有效日期
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
	  	reqParamVo.setUrl( global.serverPathTrade);
	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/***应用接口......................................................结束*/

});