/**
 * 网络投票service层调用接口
 */
define('trade/service/scripts/trade/service_debt.js',function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	
	/********************************公共代码部分********************************/
    service_debt.prototype.commonInvoke = service.commonInvoke;

	service_debt.prototype.destroy = function(){
		this.service.destroy();
	};
	function service_debt(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service_debt();
	
	/********************************应用接口开始********************************/
	/********************************业务范围--网络投票等功能********************************/
	/**
	 * 新债列表查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码	
	 * @param {Object} op_station				操作站点	
	 * @param {Object} session_id				会话号
	 * */
	service_debt.prototype.queryNewDebtList = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301550";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["issue_date"] = param.issue_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 新债列表查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码	
	 * @param {Object} op_station				操作站点	
	 * @param {Object} session_id				会话号
	 * */
	service_debt.prototype.debtListquery = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "3015501";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["issue_date"] = param.issue_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 新债列表查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码	
	 * @param {Object} op_station				操作站点	
	 * @param {Object} session_id				会话号
	 * */
	service_debt.prototype.queryNewDebtListN = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301557";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["session_id"] = param.session_id;
		paraMap["issue_date"] = param.issue_date;
		paraMap["password"] = param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 一键申购
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.netBebtPurchase = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301551";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["entrustcodes"] = param.entrustcodes;
		paraMap["password"] = param.password;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 历史新债中签信息查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.historyDebtSigningQuery = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301552";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
  	    paraMap["stock_account"] =  param.stock_account;
  	    paraMap["stock_code"] = param.stock_code;
  	    paraMap["begin_time"] = param.begin_time;
  	    paraMap["end_time"] = param.end_time;
  	    paraMap["begin_date"] = param.begin_time;
  	    paraMap["end_date"] = param.end_time;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 新债历史配号查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.debtHistoryDistribution = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301553";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
  	    paraMap["stock_account"] =  param.stock_account;
  	    paraMap["stock_code"] = param.stock_code;
  	    paraMap["begin_time"] = param.begin_time;
  	    paraMap["end_time"] = param.end_time;
  	    paraMap["begin_date"] = param.begin_time;
  	    paraMap["end_date"] = param.end_time;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 新股认购信息查询（新债中签查询）
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.debtSigningQuery = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301554";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["password"] = param.password;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 新债配售列表查询(新债配售/回售/转股列表查询)
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.queryNewDebtDistribution = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301555";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["password"] = param.password;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_codes"] = param.stock_codes;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["entrustcodes"] = param.entrustcodes;
		paraMap["query_type"] = param.query_type;   // （0：配售、1：转股、2：回售）

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 新债配售(新债配售/回售/转股)
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.newDebtDistribution = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301556";
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["stock_account"] = param.stock_account;
		paraMap["branch_no"] = param.branch_no;
		paraMap["batch_no"] = param.batch_no;
		paraMap["cust_code"] = param.cust_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["password"] = param.password;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs; // 11转股，12回售，14配售
		paraMap["stock_code"] = param.stock_code;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 新债列表查询（不需登录）
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_debt.prototype.placingResaleConversion = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301557";
		paraMap["branch_no"] = param.branch_no;
		paraMap["cust_code"] = param.cust_code;
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["password"] = param.password;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/***应用接口......................................................结束*/

});