/**
 * 基金service层调用接口
 */
define('trade/service/scripts/trade/service_fund.js', function (require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;

	/********************************公共代码部分********************************/
	service_fund.prototype.commonInvoke = service.commonInvoke;
	service_fund.prototype.commonInvokeZHYW = service.commonInvokeZHYW;
    service_fund.prototype.commonInvokeZD = service.commonInvokeZD;



	service_fund.prototype.destroy = function () {
		this.service.destroy();
	};

	function service_fund() { //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};

	module.exports = new service_fund();

	/********************************应用接口开始********************************/


	/********************************业务范围--基金********************************/
	/**
	 * 资产查询
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_fund.prototype.queryFundSelect = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301504";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["money_type"] = param.money_type;
		paraMap["is_homepage"] = param.is_homepage;
		paraMap["income_balance"] = param.is_homepage;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 风险测评结果查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param fund_company   基金公司
	 * */
	service_fund.prototype.queryRiskLevel = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "300104";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["risk_kind"] = param.risk_kind;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 基金账户信息查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param fund_company   基金公司
	 * */
	service_fund.prototype.getCustMsg = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302001";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金客户可购买基金查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param fund_company   基金公司
	 * */
	service_fund.prototype.queryCanSubscribe = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302002";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["fund_status"] = param.fund_status;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金公司查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param fund_company   基金公司
	 * */
	service_fund.prototype.getFundCompany = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302004";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金详情查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param op_station    操作站点
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * */
	service_fund.prototype.getFundInfo = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302005";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["sessionid"] = param.sessionid;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["fund_status"] = param.fund_status;
		paraMap["password"] = param.password;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;

		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金认购
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param amount        认购数量
	 * @param balance       认购金额
	 * @param flag          强制下单标志（0：否，1：是）
	 * */
	service_fund.prototype.getSubScriptionBuy = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302006";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["amount"] = param.amount;
		paraMap["balance"] = param.balance;
		paraMap["flag"] = param.flag;
		paraMap["prof_flag"] = param.prof_flag; //1是否为专业投资者
		paraMap["instr_batch_no"] = param.instr_batch_no;

		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金申购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param sessionid      会话号
	 * @param fund_company   基金公司
	 * @param fund_code      基金代码
	 * @param auto_buy       分红方式
	 * @param balance        认购金额
	 * @param flag           强制下单标志（0：否，1：是）
	 * */
	service_fund.prototype.getpurchaseBuy = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302007";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["auto_buy"] = param.auto_buy;
		paraMap["balance"] = param.balance;
		paraMap["prof_flag"] = param.prof_flag;
		paraMap["flag"] = param.flag;
		paraMap["instr_batch_no"] = param.instr_batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 提交下单基金  基金赎回
	 * @param funcNo              302008
	 * @param entrust_way         委托方式
	 * @param branch_no           分支机构
	 * @param fund_account        资金账号
	 * @param cust_code           客户编号
	 * @param password            密码
	 * @param op_station          操作站点
	 * @param sessionid           会话号
	 * @param fund_company        基金公司
	 * @param fund_code           基金代码
	 * @param amount              发生数量
	 * @param exceedflag          巨额赎回标志('0':取消，'1':顺延)
	 * */
	service_fund.prototype.submitOrder = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302008";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["amount"] = param.amount;
		paraMap["exceedflag"] = param.exceedflag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金撤单
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param begin_date    起始日期
	 * @param end_date      截止日期
	 * @param business_flag 业务类别
	 * */
	service_fund.prototype.cancelOrder = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302009";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["allot_date"] = param.allot_date;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["fund_code"] = param.fund_code;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当日基金委托查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param business_flag 业务类别
	 * */
	service_fund.prototype.queryTodayTrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302011";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["business_flag"] = param.business_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金持仓查询,基金份额查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * */
	service_fund.prototype.queryFundData = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302012";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金当日成交查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * */
	service_fund.prototype.queryTodayTrade = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302013";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 历史基金委托查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param begin_date    起始日期
	 * @param end_date      截止日期
	 * @param business_flag 业务类别
	 * */
	service_fund.prototype.queryHistoryTrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302014";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		paraMap["begin_time"] = param.begin_time;
		paraMap["end_time"] = param.end_time;
		paraMap["business_flag"] = param.business_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 历史基金成交查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param begin_date    起始日期
	 * @param end_date      截止日期
	 * */
	service_fund.prototype.queryHistoryTrade = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302015";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		paraMap["begin_time"] = param.begin_time;
		paraMap["end_time"] = param.end_time;
		paraMap["business_flag"] = param.business_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金开户
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param flag          是否首次开户（0：否，1：是）
	 * */
	service_fund.prototype.openFundAccount = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302030";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["password"] = param.password;
		paraMap["fund_company"] = param.fund_company;
		paraMap["stock_account"] = param.stock_account;
		paraMap["flag"] = param.flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 风险测评问卷查询
	 * @param callback      回调函数
	 * @param entrust_way   委托方试
	 * @param branch_no     分支机构
	 * @param sessionid     会话号
	 * @param fund_company  基金公司
	 * @param fund_code     基金代码
	 * @param flag          是否首次开户（0：否，1：是）
	 * */
	service_fund.prototype.queryRiskQuestions = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "300105";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["password"] = param.password;
		paraMap["risk_kind"] = param.risk_kind;
		paraMap["organ_flag"] = param.organ_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 风险测评问卷提交
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * @param risk_kind   风险问卷类型（见数据字典）
	 * @param paper_answer   提交答案
	 * */
	service_fund.prototype.submitCustAnswer = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "300106";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["risk_kind"] = param.risk_kind;
		paraMap["paper_answer"] = param.paper_answer;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金当日可撤委托信息查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.queryTodayCancel = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302019";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["business_flag"] = param.business_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//10014242 123321
	/**
	 * 基金委托撤单
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.cancelFundEntrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302009";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["allot_date"] = param.allot_date;
		paraMap["fund_code"] = param.fund_code;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["fund_company"] = param.fund_company;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.fundOpenAccount = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302030";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["stock_account"] = param.stock_account;
		paraMap["flag"] = param.flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金转换
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.fundConversion = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302010";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["trans_code"] = param.trans_code;
		paraMap["trans_amount"] = param.trans_amount;
		paraMap["exceedflag"] = param.exceedflag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金分红方式设置
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.bonusModeSetting = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302016";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["dividendmethod"] = param.dividendmethod;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金定投查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.fundInvestmentQuery = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302051";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};



	/**
	 * 分级基金历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingHistoryTrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302072";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金历史成交查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingHistoryDeal = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302073";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金持仓
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingPosition = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301503";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["stock_code"] = param.fund_code;
		paraMap["isfund"] = param.isfund;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 场内货币基金申购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.venueMonetaryPurchase = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302064";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["instr_batch_no"] = param.instr_batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 场内货币基金赎回
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.venueMonetaryRedemption = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302065";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金申购认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingSubscription = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302066";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_prop"] = param.entrust_prop;
		paraMap["instr_batch_no"] = param.instr_batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金赎回
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingRedeem = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301501";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_prop"] = param.entrust_prop;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金撤单
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingChechan = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302068";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["batch_flag"] = param.batch_flag;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金当日成交查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingDayDeal = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302071";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金当日委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingDayCommission = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302070";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级子基金买卖
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.SubFundTrading = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302069";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_prop"] = param.entrust_prop;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 分级基金分拆合并
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.gradingSplitMerge = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302055";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["fund_code"] = param.fund_code;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_prop"] = param.entrust_prop;
		paraMap["fund_opertype"] = param.entrust_prop;
		paraMap["instr_batch_no"] = param.instr_batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 股票信息联动
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} sessionid       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_fund.prototype.queryStockMaxBuy = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301514";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["newstock_flag"] = param.newstock_flag;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_accounts"] = param.stock_accounts;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 分级基金可撤查询
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} sessionid       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_fund.prototype.gradingCanWithdraw = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302075";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 分级基金分拆合并查询
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} sessionid       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_fund.prototype.gradingSplitMergeQuery = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "3020561";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.fund_code;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	/**
	 * 场内货币基金当日委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.floorQueryToday = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302076";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["cancel_flag"] = param.cancel_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 场内货币基金历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.floorQueryHistory = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302077";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 场内货币基金历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.queryStockData = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301503";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = ""; //param.stock_account
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["isfund"] = param.isfund;
		paraMap["filt_flag"] = param.filt_flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 场内货币基金历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.getStockBuy = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301501";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["batch_no"] = param.batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	/**
	 * 场内货币基金历史委托查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.floorQueryStockMaxBuy = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301514";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["newstock_flag"] = param.newstock_flag;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_accounts"] = param.stock_accounts;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 查询当日可撤委托
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} sessionid       会话号
	 * */
	service_fund.prototype.floorQueryTrustData = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302075";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当日委托查询
	 *
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} sessionid                会话号
	 * */
	service_fund.prototype.floorQueryTodayTrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302059";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当日成交查询
	 *
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} sessionid                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_fund.prototype.floorQueryTodayTrade = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302060";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 历史委托查询
	 *
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} sessionid                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * */
	service_fund.prototype.floorQueryHistoryTrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302061";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_time"] = param.begin_time;
		paraMap["end_time"] = param.end_time;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 历史成交查询
	 *
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} sessionid                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_fund.prototype.floorQueryHistoryTrade = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302062";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_time"] = param.begin_time;
		paraMap["end_time"] = param.end_time;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 委托撤单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} sessionid                会话号
	 * @param {Object} entrust_no               委托编号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} batch_flag            	批量撤单标志
	 * @param {Object} callback	回调方法
	 * */
	service_fund.prototype.postCancelOrder = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302081";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["batch_flag"] = param.batch_flag;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投付款日查询
	/**
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} sessionid                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_fund.prototype.queryFundPayDate = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302057";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投下单
	service_fund.prototype.setDateEntrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302048";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["balance"] = param.balance;
		paraMap["start_date"] = param.start_date;
		paraMap["end_date"] = param.end_date;
		paraMap["en_fund_date"] = param.en_fund_date;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金转托管
	service_fund.prototype.fundTransferEntrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302058";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["balance"] = param.balance;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//深圳lof基金申购
	service_fund.prototype.insideLofFundPurchase = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302079";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_prop"] = param.entrust_prop || 'L';
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["instr_batch_no"] = param.instr_batch_no;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//赎回
	service_fund.prototype.insideLofFundRedeem = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302080";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	//货币基金撤单
	service_fund.prototype.currencyFundCancel = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "306102";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_no"] = param.entrust_no;
		// paraMap["batch_flag"] =  param.batch_flag;
		// paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//货币基金撤单
	service_fund.prototype.queryEableTransIntoFund = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "306000";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["fund_code"] = param.fund_code;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 沪市Lof当日委托
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.dayOrderSHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302084";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 沪市lof当日成交
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.dayDealSHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302082";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 302083沪市lof历史成交
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.historyDealSHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302083";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 沪市Lof当日委托
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.queryCancelSHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302085";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 沪市Lof当日委托
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param sessionid      会话号
	 * */
	service_fund.prototype.redeemSHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302067";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["sessionid"] = param.sessionid;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["entrust_prop"] = param.entrust_prop;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	/**
	 * 股票信息联动
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} sessionid       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_fund.prototype.queryStockMaxBuySHLOF = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302078";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["sessionid"] = param.sessionid;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.fund_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["newstock_flag"] = param.newstock_flag;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_accounts"] = param.stock_accounts;
		paraMap["exchange_type"] = param.exchange_type;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/***...............................基金定投接口.......................*/

	/**
	 * 资产查询
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_fund.prototype.queryFundSelect1 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302020";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["is_homepage"] = param.is_homepage;
		paraMap["income_balance"] = param.is_homepage;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投查询
	service_fund.prototype.queryFixFund = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302039";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["password"] = param.password;
		paraMap["request_num"] = param.request_num;
		paraMap["position_str"] = param.position_str;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投下单
	service_fund.prototype.setDateEntrust1 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302048";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["balance"] = param.balance;
		paraMap["start_date"] = param.start_date;
		paraMap["end_date"] = param.end_date;
		paraMap["en_fund_date"] = param.en_fund_date;
		paraMap["ration_type"] = param.ration_type;
		paraMap["max_ration_balance"] = param.max_ration_balance;
		paraMap["max_ration_times"] = param.max_ration_times;
		paraMap["pay_cycle_unit"] = param.pay_cycle_unit; //扣款周期单位
		paraMap["pay_cycle_rate"] = param.pay_cycle_rate; //扣款周期频率
		paraMap["password"] = param.password;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金开户
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.fundOpenAccount1 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302030";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company;
		paraMap["stock_account"] = param.stock_account;
		paraMap["flag"] = param.flag;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投终止
	service_fund.prototype.stopFundEntrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302050";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["en_fund_date"] = param.en_fund_date;
		paraMap["allotno"] = param.allotno;
		paraMap["stock_account"] = param.stock_account;
		paraMap["password"] = param.password;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金定投查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.fundInvestmentQuery1 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302051";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["session_id"] = param.session_id;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//基金定投修改
	service_fund.prototype.updateFixFundEntrust = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302049";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company;
		paraMap["fund_code"] = param.fund_code;
		paraMap["balance"] = param.balance;
		paraMap["start_date"] = param.start_date;
		paraMap["end_date"] = param.end_date;
		paraMap["en_fund_date"] = param.en_fund_date;
		paraMap["ration_type"] = param.ration_type;
		paraMap["max_ration_balance"] = param.max_ration_balance;
		paraMap["max_ration_times"] = param.max_ration_times;
		paraMap["allotno"] = param.allotno;
		paraMap["password"] = param.password;
		paraMap["pay_cycle_unit"] = param.pay_cycle_unit; //扣款周期
		paraMap["pay_cycle_rate"] = param.pay_cycle_rate; //扣款频率
		paraMap["en_fund_date"] = param.en_fund_date; //扣款日
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 协议查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.agreementQuery = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "302060";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["op_station"] = param.op_station;
		paraMap["session_id"] = param.session_id;
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金开户和协议状态查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399901 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399901";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["fund_company"] = param.fund_company; //基金公司
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 签署协议
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399902 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399902";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["sign_version"] = param.sign_version; //协议版本  399901返回agreement_version
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 查询基金标的池
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399930 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399930";
		paraMap["fund_code"] = param.fund_code;				//基金代码
		paraMap["isMallProduct"] = param.isMallProduct;		//是否场内基金,1为场外，其他场内
		paraMap["exchange_type"] = param.exchange_type;		//0深圳，2上海，场外传TA
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 基金协议签署-综合业务留痕
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399931 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399931";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;							//营业部代码
		paraMap["fund_account"] = param.fund_account;					//资金账号
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["client_name"] = param.client_name; 					//客户姓名
		paraMap["fund_code"] = param.fund_code;							//基金代码
		paraMap["fund_name"] = param.fund_name;							//基金名称
		paraMap["exchange_type"] = param.exchange_type;					//0深圳，2上海，场外传TA
		paraMap["match_state"] = param.match_state;						//适当性匹配状态
		paraMap["text_content"] = $.endecryptUtils.encoderBase64(param.text_content);					//适当性匹配文字描述
		paraMap["text_content2"] =  $.endecryptUtils.encoderBase64(param.text_content2);					//适当性协议
		paraMap["instr_batch_no"] = param.instr_batch_no;				//记录批次号
		paraMap["ann_name"] = param.ann_name;							//公告名称
		paraMap["ann_link"] = param.ann_link;							//公告链接（PDF链接）
		paraMap["ann_version"] = param.ann_version;						//公告版本
		paraMap["contract_name"] = param.contract_name;							//基金合同名称
		paraMap["contract_link"] = param.contract_link;							//基金合同链接（PDF链接）
		paraMap["contract_version"] = param.contract_version;						//基金合同版本
		paraMap["prospectus_name"] = param.prospectus_name;							//招募说明书名称
		paraMap["prospectus_link"] = param.prospectus_link;							//招募说明书（PDF链接）
		paraMap["prospectus_version"] = param.prospectus_version;						//招募说明书
		paraMap["risk_disclosure_id"] = param.risk_disclosure_id;		//风险揭示书ID
		paraMap["risk_disclosure_name"] = param.risk_disclosure_name;	//风险揭示书名称
		// paraMap["risk_disclosure_text"] = param.risk_disclosure_text;	//风险揭示书内容
		paraMap["risk_disclosure_ver"] = param.risk_disclosure_ver;		//风险揭示书版本号
		paraMap["id"] = param.id;										//协议签署留痕ID
		paraMap["contract_id"] = param.contract_id;										//协议签署留痕ID
		paraMap["prospectus_id"] = param.prospectus_id;										//协议签署留痕ID
		paraMap["serial_no"] = param.serial_no;							//委托单号
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 普通交易-综合业务留痕
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399932 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399932";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;			//营业部代码
		paraMap["fund_account"] = param.fund_account;	//资金账号
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["client_name"] = param.client_name; 	//客户姓名
		paraMap["stock_code"] = param.stock_code;		//证券代码，多个用,分割
		paraMap["text_content"] = param.text_content;	//提示内容
		paraMap["ann_name"] = param.ann_name;			//协议标题
		paraMap["entrust_no"] = param.entrust_no;		//委托号，多个用,分割
		paraMap["phone"] = param.phone;					//激活手机号
		paraMap["create_by"] = param.create_by;
		paraMap["channel"] = param.channel || '1';		//渠道名称
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 普通交易-一键申购首次查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
     service_fund.prototype.function399933 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399933";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;			//营业部代码
		paraMap["fund_account"] = param.fund_account;	//资金账号
		paraMap["client_id"] = param.client_id;
		paraMap["session_id"] = param.session_id;
        paraMap["has_op_station"] = "1";
        paraMap = $.extend(paraMap,param);
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};
    
	/**
	 * 普通交易-综合业务留痕
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fund.prototype.function399934 = function (param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "399934";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;			//营业部代码
		paraMap["fund_account"] = param.fund_account;	//资金账号
		paraMap["client_id"] = param.client_id;
		paraMap["session_id"] = param.session_id;
		paraMap["client_name"] = param.client_name; 	//客户姓名
		paraMap["stock_code"] = param.stock_code;		//证券代码，多个用,分割
		paraMap["text_content"] = param.text_content;	//提示内容
		paraMap["agree_type"] = param.agree_type;		//1-申购首次，2-申购，3-条件单非首次
		paraMap["entrust_no"] = param.entrust_no;		//agree_type=2传且第二次更新传
		paraMap["phone"] = param.phone;					//激活手机号
		paraMap["id"] = param.id;                       //agree_type=2传且第二次更新传 （由第一次请求返回）
		paraMap["channel"] = param.channel || '1';		//渠道名称
        paraMap["has_op_station"] = "1";
        paraMap = $.extend(paraMap,param);
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};

    /**
     * 交易首页——查询参考盈亏
     * @param callback       回调函数
     * @param entrust_way    委托方试
     * @param branch_no      分支机构
     * @param op_station     操作站点
     * @param session_id      会话号
     * */
    service_fund.prototype.function815400 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = "815400";
        paraMap["client_id"] = param.client_id;
        paraMap["fund_account"] = param.fund_account;			//营业部代码
        paraMap["money_type"] = param.money_type;	//资金账号
        paraMap["query_type"] = param.query_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.unifyUrl);
        this.commonInvokeZD(paraMap, callback, ctrlParam, reqParamVo);
    };
	/***应用接口......................................................结束*/

});
