/**
 * 基金service层调用接口
 */
define('trade/service/scripts/trade/service_fundETF.js',function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	
	/********************************公共代码部分********************************/
    service_fundETF.prototype.commonInvoke = service.commonInvoke;

	service_fundETF.prototype.destroy = function(){
		this.service.destroy();
	};
	function service_fundETF(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	
	module.exports = new service_fundETF();
	
	/********************************应用接口开始********************************/

	
	/********************************业务范围--基金********************************/
	/**
	 * etf联动查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfStockMaxBuyQuery=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "302110";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["entrust_bs"] = param.entrust_bs;
  	    paraMap["stock_code"] = param.stock_code;
  	    paraMap["newstock_flag"] = param.newstock_flag;
  	    paraMap["exchange_type"] = param.exchange_type;
  	    paraMap["organ_flag"] = param.organ_flag;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
	/**
	 * 	ETF网上现金认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.onlineCashSubscription = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302105";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["entrust_price"] = param.entrust_price;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
  	
	/**
	 * 	ETF网下现金认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.offlineCashSubscription = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302100";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["entrust_price"] = param.entrust_price;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	/**
	 * 	ETF网下股份认购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.offlineShareSubscription = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302101";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["entrust_price"] = param.entrust_price;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		paraMap["component_code"] = param.component_code;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	/**
	 * ETF成份股代码查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.componentStockCodeQuery=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "302103";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["stock_code"] = param.stock_code;
  	    paraMap["exchange_type"] = param.exchange_type;
  	    paraMap["component_code"] = param.component_code;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
	
	/**
	 * 	ETF申购
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfSubscribeOther = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302104";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		paraMap["stock_code"] = param.stock_code;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  	
	
	/**
	 * ETF赎回
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfRedeemOther = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302106";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		paraMap["entrust_price"] = param.entrust_price;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  	
	
	/**
	 * 	ETF申购（普通、跨境）
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfSubscribe = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302111";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["channel_type"] = param.channel_type;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	 	
	
	/**
	 * ETF赎回（普通、跨境）
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfRedeem = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302112";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["entrust_amount"] = param.entrust_amount;
 		paraMap["entrust_price"] = param.entrust_price;
 		paraMap["channel_type"] = param.channel_type;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	}; 
	
	/**
	 * ETF持仓查询
	 * @param callback       回调函数
	 * @param entrust_way    委托方试
	 * @param branch_no      分支机构
	 * @param op_station     操作站点
	 * @param session_id      会话号
	 * */
	service_fundETF.prototype.etfHoldPositionsQuery = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "302113";
		paraMap["entrust_way"] = param.entrust_way;
 		paraMap["branch_no"] = param.branch_no;
 		paraMap["fund_account"] = param.fund_account;
 		paraMap["cust_code"] = param.cust_code;
 		paraMap["password"] = param.password;
 		paraMap["op_station"] = param.op_station;
 		paraMap["session_id"] = param.session_id;
 		paraMap["stock_code"] = param.stock_code;
 		paraMap["exchange_type"] = param.exchange_type;
 		paraMap["stock_account"] = param.stock_account;
 		paraMap["request_num"] = param.request_num;
 		paraMap["position_str"] = param.position_str;
 		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl( global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	}; 
	/***应用接口......................................................结束*/

});
