/**
 * 创业板盘后service层调用接口
 */
define('trade/service/scripts/trade/service_gemAfter.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
    
    //构造方法
	function MobileService(){
		this.service = new $.service;
	}
    
    MobileService.prototype.commonInvoke = service.commonInvoke;
	
	/********************************公共代码部分********************************/
	
	/********************************应用接口开始********************************/
       
        /**
      	 * 创业板盘后-当日委托查询
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * */
         MobileService.prototype.today_entrust_ser=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = param.account_type == "1"?"313582":"310582";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
      	
        /**
      	 * 当日成交查询
      	 * 
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} callback	回调方法
      	 * */
         MobileService.prototype.today_deal_ser=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = param.account_type == "1"?"313583":"310583";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
      	
        /**
      	 * 历史委托查询
      	 * 
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} begin_time               开始日期
      	 * @param {Object} end_time                	截止日期
      	 * */
         MobileService.prototype.history_entrust_ser=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = param.account_type == "1"?"313584":"310584";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["begin_date"] =  param.begin_date;
    	    paraMap["end_date"] =  param.end_date;
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
		
		/**
		 * 撤单查询
		 * 
		 * @param {Object} entrust_way              委托方式
		 * @param {Object} branch_no                分支机构
		 * @param {Object} fund_account             资金账号
		 * @param {Object} cust_code                客户编号
		 * @param {Object} sessionid                会话号
		 * @param {Object} callback	回调方法
		 * */
		 MobileService.prototype.gemCancelQuery_ser=function(param,callback,ctrlParam){
			var paraMap = {};
		    paraMap["funcNo"] = param.account_type == "1"?"313581":"310581";
		    paraMap["entrust_way"] = param.entrust_way;
		    paraMap["branch_no"] =  param.branch_no;
		    paraMap["fund_account"] = param.fund_account;
		    paraMap["cust_code"] =  param.cust_code;
		    paraMap["password"] =  param.password;
		    paraMap["sessionid"] =  param.sessionid;
		    var reqParamVo = this.service.reqParamVo;
			reqParamVo.setUrl(global.serverPathTrade);
			this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		};
		
		/**
		 * 撤单委托
		 * 
		 * @param {Object} entrust_way              委托方式
		 * @param {Object} branch_no                分支机构
		 * @param {Object} fund_account             资金账号
		 * @param {Object} cust_code                客户编号
		 * @param {Object} sessionid                会话号
		 * @param {Object} callback	回调方法
		 * */
		 MobileService.prototype.gemCancelEntrust_ser=function(param,callback,ctrlParam){
			var paraMap = {};
		    paraMap["funcNo"] = param.account_type == "1"?"313588":"310588";
		    paraMap["entrust_way"] = param.entrust_way;
		    paraMap["branch_no"] =  param.branch_no;
		    paraMap["fund_account"] = param.fund_account;
		    paraMap["cust_code"] =  param.cust_code;
		    paraMap["password"] =  param.password;
		    paraMap["sessionid"] =  param.sessionid;
			paraMap["batch_flag"] = param.batch_flag;
			paraMap["entrust_date"] =  param.entrust_date;
			paraMap["entrust_no"] =  param.entrust_no;
			paraMap["exchange_type"] =  param.exchange_type;
		    var reqParamVo = this.service.reqParamVo;
			reqParamVo.setUrl(global.serverPathTrade);
			this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		};
		
		/**
		 * 持仓查询
		 * 
		 * @param {Object} entrust_way              委托方式
		 * @param {Object} branch_no                分支机构
		 * @param {Object} fund_account             资金账号
		 * @param {Object} cust_code                客户编号
		 * @param {Object} session_id                会话号
		 * @param {Object} exchange_type            交易类别
		 * @param {Object} stock_account            证券账号
		 * @param {Object} stock_code               股票号码
		 * @param {Object} callback	回调方法
		 * */
		MobileService.prototype.queryStockData = function(param, callback, ctrlParam) {
			var paraMap = {};
			paraMap["funcNo"] = param.account_type == "1"?"313589":"310589";
			paraMap["entrust_way"] = param.entrust_way;
			paraMap["branch_no"] = param.branch_no;
			paraMap["fund_account"] = param.fund_account;
			paraMap["cust_code"] = param.cust_code;
			paraMap["session_id"] = param.session_id;
			paraMap["password"] = param.password;
			paraMap["stock_account"] = ""; //param.stock_account
			paraMap["stock_code"] = param.stock_code;
			paraMap["exchange_type"] = param.exchange_type;
			paraMap["query_flag"] = param.query_flag;
			var reqParamVo = this.service.reqParamVo;
			reqParamVo.setUrl(global.serverPathTrade);
			this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		};
		
		/**
		 * 查询最大可买可卖
		 * @param {Object} entrust_way     委托方式
		 * @param {Object} branch_no       分支机构
		 * @param {Object} fund_account    资金账号
		 * @param {Object} cust_code       客户编号
		 * @param {Object} session_id       会话号
		 * @param {Object} session_id       业务类型
		 * 
		 * */
		MobileService.prototype.queryStockMaxAmount = function(param, callback, ctrlParam) {
			var paraMap = {};
			if(param.account_type == "1") {// 信用交易
				paraMap["funcNo"] = param.isMax?"313060":"313000";
			} else {// 普通交易
				if(!param.isMax) {// 联动
					paraMap["funcNo"] = "310514";
				} else if(param.isBuy) {// 买
					paraMap["funcNo"] = "310516";
				} else {// 卖
					paraMap["funcNo"] = "310513";
				}
			}
			paraMap["entrust_way"] = param.entrust_way;
			paraMap["branch_no"] = param.branch_no;
			paraMap["fund_account"] = param.fund_account;
			paraMap["cust_code"] = param.cust_code;
			paraMap["password"] = param.password;
			paraMap["session_id"] = param.session_id;
			paraMap["entrust_bs"] = param.entrust_bs;
			paraMap["stock_code"] = param.stock_code;
			paraMap["entrust_price"] = param.entrust_price;
			paraMap["stock_account"] = param.stock_account;
			paraMap["exchange_type"] = param.exchange_type;
			paraMap["stock_type"] = param.stock_type;
			paraMap["entrust_type"] = param.entrust_type;
			var reqParamVo = this.service.reqParamVo;
			reqParamVo.setUrl(global.serverPathTrade);
			this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		};
		
		/**
		 *  创业板盘后委托下单
		 * @param {Object} entrust_way              委托方式
		 * @param {Object} branch_no                分支机构
		 * @param {Object} fund_account             资金账号
		 * @param {Object} cust_code                客户编号
		 * @param {Object} password                	交易密码
		 * @param {Object} session_id                会话号
		 * @param {Object} entrust_bs               买卖方向
		 * @param {Object} exchange_type            交易类别
		 * @param {Object} stock_account            证券账号
		 * @param {Object} stock_code               股票号码
		 * @param {Object} entrust_price            委托价格
		 * @param {Object} entrust_amount           委托数量
		 * @param {Object} batch_no                 委托批号
		 * @param {Object} callback	回调方法
		 * */
		MobileService.prototype.getStockPHBuy = function(param, callback, ctrlParam) {
			var paraMap = {};
			paraMap["funcNo"] = param.account_type == "1"?"313580":"310580";
			paraMap["entrust_way"] = param.entrust_way;
			paraMap["branch_no"] = param.branch_no;
			paraMap["fund_account"] = param.fund_account;
			paraMap["cust_code"] = param.cust_code;
			paraMap["password"] = param.password;
			paraMap["session_id"] = param.session_id;
			paraMap["entrust_bs"] = param.entrust_bs;
			paraMap["exchange_type"] = param.exchange_type;
			paraMap["stock_account"] = param.stock_account;
			paraMap["stock_code"] = param.stock_code;
			paraMap["entrust_price"] = param.entrust_price;
			paraMap["entrust_amount"] = param.entrust_amount;
			paraMap["batch_no"] = param.batch_no;
		
			var reqParamVo = this.service.reqParamVo;
			reqParamVo.setUrl(global.serverPathTrade);
			this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		};

	/***应用接口......................................................结束*/
	
	MobileService.prototype.destroy = function(){
		this.service.destroy();
	};
	
	/**
	 * 实例化对象
	 */
	function getInstance(){
		return new MobileService();
	}
	
	var mobileService = {
		"getInstance" : getInstance
	};
	
	module.exports = mobileService;

});