/**
 * 获取行情service
 * */
define('trade/service/scripts/trade/service_hq.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;

	function service_hq(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	service_hq.prototype.destroy = function(){
		this.service.destroy();
	};
	module.exports = new service_hq();
	/********************************公共代码部分********************************/
    service_hq.prototype.commonInvoke = service.commonInvokeHq;
	/********************************应用接口开始********************************/

	/**
	 *  获取股票现价
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getStockNowPrice=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "26000";
	    paraMap["version"] = 1;
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["field"] ="22:24:2:10:11:9:12:14:6:23:21:3:1:45:46:48:68";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  获取国债逆回购列表行情 代码 名称
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getGZNowPrice=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcno"] = "60000";
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  获取行情五档
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getStockFiveStep=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "20003";
	    paraMap["version"] = 1;
	    paraMap["stock_list"] = param.stock_list;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
//	service_hq.prototype.getStockList=function(param,callback,ctrlParam){
//	    var paraMap = {};
//	    paraMap["funcno"] = "20007";
//	    paraMap["version"] = 1;
////	    paraMap["type"] = param.type?param.type:"0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
//		paraMap["type"] = param.type?param.type:"0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:43:44:45:46:64:65:66";
//	    paraMap["q"] = param.q;
//	    paraMap["count"] = "10";
//	    paraMap["field"] = "24:22:2:10:11:9:12:14:6:23:21:3:1:45:46:48";
//	    paraMap["is_start"] = param.is_start;
//	    var reqParamVo = this.service.reqParamVo;
//		reqParamVo.setUrl(global.HqUrl);
//		var flowNo = this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
//		return flowNo;
//	};

	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * @param {Object} field 股票代码：名称：股票类型：市场代码：现价：昨收：涨停价：跌停价：是否停牌：转让状态：是否为沪伦通:是否是科创板
	 * */
	//以前的20007以及21007都不能用了，因为不支持新的属性，查询不到是否为科创板，所以要改成26100
	service_hq.prototype.getStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "26100";
	    paraMap["version"] = 1;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
		    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
				paraMap["type"] = global.stockType.join(":");
			}
		    else{
		    	paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:43:44:45:46:64:65:66";
		    }
	    }
	    paraMap["q"] = param.q;
	    paraMap["count"] = "10";
//	    paraMap["field"] = "24:22:21:23:2:12:45:46:48:59:111:120";
	    paraMap["field"] = "24:22:2:10:11:9:12:14:6:23:21:3:1:45:46:48:59:111:120:139:68:148:146";
	    paraMap["is_start"] = "0";
	    paraMap["marketType"] = "1";
        // 判断行情源版本， 1 上证云行情 501159，2思迪行情 50118
		var is_trade_hq_use_by_szy = $.getSStorageInfo("is_trade_hq_use_by_szy");
        if(is_trade_hq_use_by_szy !== "0"){
            // 判断股票是否是退市整理期，上证云行情可以通过700判断
			paraMap["field"] = paraMap["field"] + ":700";
		}
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * @param {Object} field 股票代码：名称：股票类型：市场代码：现价：昨收：涨停价：跌停价：是否停牌：转让状态：是否为沪伦通：是否为科创板:交易状态
	 * */
	service_hq.prototype.getkcbStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "26100";
	    paraMap["version"] = 1;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
		    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
				paraMap["type"] = global.stockType.join(":");
			}
		    else{
		    	paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:43:44:45:46:64:65:66";
		    }
	    }
	    paraMap["q"] = param.q;
	    paraMap["count"] = param.count || "10";
	    paraMap["field"] = "24:22:21:23:2:12:45:46:48:59:111:120:127:139";
	    paraMap["is_start"] = "0";
	    paraMap["marketType"] = param.marketType || "8";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * @param {Object} field 股票代码：名称：股票类型：市场代码：现价：昨收：涨停价：跌停价：涨跌幅：最小价格变动单位：买卖数量单位：参考成交价：匹配量：未匹配量：转让类型：股转分层：最高：最低：盘后交易状态
	 * */
	service_hq.prototype.getNewThirdStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "26100";
	    paraMap["version"] = 1;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
		    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
				paraMap["type"] = global.stockType.join(":");
			}
		    else{
		    	paraMap["type"] = "17:31:32:33:34:35:36:37:38:39:40:41:42";
		    }
	    }
	    paraMap["q"] = param.q;
	    paraMap["count"] = "50";
	    paraMap["field"] = "24:22:21:23:2:12:45:46:1:133:134:34:35:36:60:68:10:11:37:148";
	    paraMap["is_start"] = "0";
	    paraMap["marketType"] = "1";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  获取个股行情
	 * @param {Object} stockStr 股票代码或者拼音
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getStockInfo=function(param,callback,ctrlParam){
		//填充机构代码
	    var paraMap = {};
	    paraMap["funcno"] = "20010";
	    paraMap["version"] = 1;
	    paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:64:65:66";
	    paraMap["code_list"] = param.code_list;
	    paraMap["field"] ="22:24:2:10:11:9:12:14:6:23:21:3:1:45:46:48";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  获取行情服务器状态
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getHqState=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "29999";
	    paraMap["version"] = 1;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 港股通个股行情
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getHqState_ggt=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "50000";
	    paraMap["version"] = 1;
	    paraMap["field"] = "22:24:2:10:11:9:12:14:6:1:16:3:4:5";
	    paraMap["stock_list"] = param.stock_list;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getStockList_ggt=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "21007";
	    paraMap["version"] = 1;
	    paraMap["type"] = param.type?param.type:"99";
//	    paraMap["type"] = param.type?param.type:"99:0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
	    paraMap["q"] = param.q;
	    paraMap["count"] = "5";
	    paraMap["field"] = "22:24:2:10:11:9:12:14:6:23:21:3:1:45:46:48";
	    paraMap["is_start"] = param.is_start;
	    paraMap['marketType'] = param.marketType;
	    paraMap['IsQueryHK'] = param.IsQueryHK;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		var flowNo = this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		return flowNo;
	};

	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.queryOptionsMarket=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "60005";
	    paraMap["version"] = 1;
	    paraMap["SecurityID"] = param.SecurityID;
	    paraMap["field"] = param.field;
//	    paraMap["type"] = param.type?param.type:"99:0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
//	    paraMap["field"] = "22:24:2:10:11:9:12:14:6:23:21:3:1:45:46:48";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 获取新股信息，未登入前
	 * @param param
	 * @param callback
	 * @param ctrlParam
	 */
	service_hq.prototype.getNewStockInfo = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "200020";
		paraMap["flag"]="5";
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.newshareUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};



	/**
	 *  获取个股行情
	 * @param {Object} stockStr 股票代码或者拼音
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getThirdStockInfo=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcno"] = "20010";
	    paraMap["version"] = 1;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
	    	paraMap["type"] = "17:31:32:33:34:35:36:37:38:39:40:41:42";
	    }
	    paraMap["code_list"] = param.code_list;
	    paraMap["field"] = "24:22:21:23:68:60";
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};



	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getThirdStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "20007";
	    paraMap["version"] = 1;
//	    paraMap["type"] = param.type?param.type:"0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
		paraMap["type"] = param.type?param.type:"0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:43:44:45:46:64:65:66";
	    paraMap["q"] = param.q;
	    paraMap["count"] = "10";
	    paraMap["field"] = "24:22:21:23:2:12:45:46:48";
	    paraMap["is_start"] = param.is_start;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		var flowNo = this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
		return flowNo;
	};


	/**
	 *  获取股票现价
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getThirdNowPrice=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "26000";
	    paraMap["version"] = 1;
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["field"] ="24:22:21:23:2:12:45:46:34:35:36:37:68:10:11:60:148";
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	/**
	 * 回购排序
	 * @param {Object} callback	回调方法
	 * http://183.57.43.58:8887/market/json?
	 * funcno=22000&
	 * version=1&
	 * sort=1&
	 * order=1&
	 * curpage=1&
	 * rowofpage=8&
	 * type=1&
	 * field=1:2:3:4
	 * */
	service_hq.prototype.getBuybackList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "22000";
	    paraMap["type"] = param.type;
	    paraMap["version"] = "1";
	    paraMap["sort"] = "22";
	    paraMap["order"] = "1";
	    paraMap["curpage"] = "1";//分页页数
	    paraMap["rowofpage"] = "1000";//每页条数
	    paraMap["field"] = "24:22:21:23:2:12:45:46:48:78:79";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 查询首页国债逆回购的天数
	 *
	 * */
	service_hq.prototype.getNationalDebtInfo=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "22000";
	    paraMap["version"] = "1";
	    paraMap["type"] = "3";
	    paraMap["rowOfPage"] = "50";
	    paraMap["field"] = "22:2";
	    paraMap["sort"] = "2";
	    paraMap["order"] = "0";
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 *  获取股票要约收购数量信息
	 * @param {Object} version 版本号
	 * @param {Object} stock_code 股票代码
	 * @param {Object} market 市场代码
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getReportAmount=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "20140";
	    paraMap["version"] =  param.version;
	    paraMap["dataType"] =  param.dataType;//业务标识  1：全部  2：收购业务  3：回购业务
	    paraMap["stock_list"] =  param.stock_list;//股票代码列表，以|分隔,例如SZ:000001|SZ:430001  传空代表请求全部股票信息
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

    /**
     *  买入查询-是否是ST风险警示的
     * @param {Object} stockStr 市场代码:股票代码
     * @param {Object} callback	回调方法
     * */
     service_hq.prototype.getIsST=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcno"] = "26100";
        paraMap["version"] = 1;
        paraMap["q"] =param.stock_code;
        paraMap["count"] ="1";
        paraMap["field"] ="146";
        paraMap["is_start"] ="0";
        paraMap["markettype"] ="3";
        paraMap["type"] ="0:1:2:3:4:5:6:7:8:9:10:11:12:13:14:15:16:17:18:19:20:21:22:23:24:25:26:27:30:31:32:33:34:35:36:37:38:39:40:41:42:64:65:66:98:99";
        var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     *  新股新债 -获取票市场
     * @param {Object} stockStr 市场代码:股票代码
     * @param {Object} callback	回调方法
     * */
     service_hq.prototype.getNSBStockType=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcno"] = "26000";
        paraMap["version"] = 1;
        paraMap["stock_list"] = param.stock_list;
        paraMap["field"] ="21";
        var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.HqUrl);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

	/**
	 *  获取ETF行情 (可用于查询五档)
	 * @param {Object} market		标的市场
	 * @param {Object} SecurityID		期权编码   例如：10000843（11000001）
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.getETFInfo = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcno"] = "26000";
		paraMap["version"] = 1;
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["field"] ="22:24:2:10:11:9:12:14:6:23:21:3:1:45:46:48:68:112:113:115";
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.optionHqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  通过上证云行情获取ETF
	 * @param {Object} market		标的市场
	 * @param {Object} callback	回调方法
	 * */
	service_hq.prototype.querySZYStock = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcno"] = "26000";
		paraMap["version"] = 1;
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["useSZY"] = true; // 强制使用上证云行情
	    paraMap["field"] ="22:24:23:2:3:1:112";	    
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.optionHqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
//	url:quote_v3|
	/***应用接口......................................................结束*/

});
