/**
 * 获取行情service
 * */
define('trade/service/scripts/trade/service_hqTrade.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var time = 5;
	var _inte_mode = "0";
    
	function service_hqTrade(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	service_hqTrade.prototype.destroy = function(){
		this.service.destroy();
	};
	module.exports = new service_hqTrade();
	/********************************公共代码部分********************************/
    service_hqTrade.prototype.commonInvoke = service.commonInvoke;
	/********************************应用接口开始********************************/
	
	function hqConverter(d){
		if(d){
			var data = {};
			data.errorNo = d.error_no;
			data.errorInfo = d.error_info;
			data.results = [];
			if(d.results && d.results.length > 0){
				for(var i = 0; i < d.results.length; i++){
					//股票代码：名称：股票类型：市场代码：现价：昨收：涨停价：跌停价：是否停牌：转让状态：是否为沪伦通：是否为科创板:交易状态
					//转让状态：是否为沪伦通：是否为科创板（这三个是联动返回的）：盘后交易状态
					var r = new Array(d.results[i].code, d.results[i].name, d.results[i].stktype, d.results[i].market, d.results[i].now, d.results[i].yesterday, d.results[i].limitUp, d.results[i].limitDown, d.results[i].suspendMark, "", "", d.results[i].chaIsKCB, d.results[i].chaHQTradeStatus);
					data.results.push(r);
				}
			}
			return data;
		}
		else{
			return d;
		}
	}
	
	function hqWDConverter(d){
		if(d){
			var data = {};
			data.errorNo = d.error_no;
			data.errorInfo = d.error_info;
			data.results = [];
			if(d.results && d.results.length > 0){
				for(var i = 0; i < d.results.length; i++){
					var r =	new Array(d.results[i].code, d.results[i].name, d.results[i].stktype, d.results[i].market, 0, 0, d.results[i].sellprice5, d.results[i].sellprice4, d.results[i].sellprice3, d.results[i].sellprice2, d.results[i].sellprice1, d.results[i].sellvol5, d.results[i].sellvol4, d.results[i].sellvol3, d.results[i].sellvol2, d.results[i].sellvol1, d.results[i].buyprice1, d.results[i].buyprice2, d.results[i].buyprice3, d.results[i].buyprice4, d.results[i].buyprice5, d.results[i].buyvol1, d.results[i].buyvol2, d.results[i].buyvol3, d.results[i].buyvol4, d.results[i].buyvol5, d.results[i].yesterday, 0, d.results[i].limitUp, d.results[i].limitDown, d.results[i].now);
					data.results.push(r);
				}
			}
			return data;
		}
		else{
			return d;
		}
	}
	
	function hqSJConverter(d){
		if(d){
			var data = {};
			data.errorNo = d.error_no;
			data.errorInfo = d.error_info;
			data.results = [];
			if(d.results && d.results.length > 0){
				for(var i = 0; i < d.results.length; i++){
					var r =	new Array(0, 0, 0, d.results[i].server_time_str.replace(/[^0-9]*/g,""), d.results[i].server_time);
					data.results.push(r);
				}
			}
			return data;
		}
		else{
			return d;
		}
	}
	
	function hqConverter2(d){
		if(d){
			var data = {};
			data.errorNo = d.error_no;
			data.errorInfo = d.error_info;
			data.results = [];
			if(d.results && d.results.length > 0){
				for(var i = 0; i < d.results.length; i++){
					var r =	new Array(d.results[i].code, d.results[i].name, d.results[i].stktype, d.results[i].market, d.results[i].now, d.results[i].yesterday, d.results[i].limitUp, d.results[i].limitDown, d.results[i].suspendMark, d.results[i].uppercent, d.results[i].up);
					data.results.push(r);
				}
			}
			return data;
		}
		else{
			return d;
		}
	}
	
	/**
	 *  获取股票现价
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getStockNowPrice=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380001";
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqConverter2(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  获取行情五档
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getStockFiveStep=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380001";
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["flag"] = 0;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqWDConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）（科创板）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getkcbStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380000";
	    paraMap["search_key"] = param.q;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
		    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
				paraMap["type"] = global.stockType.join(":");
			}
		    else{
		    	paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
		    }
		}
	    paraMap["request_num"] = param.count || "10";
	    paraMap["is_start"] = true;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    paraMap["query_type"] = "1";
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getStockList=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380000";
	    paraMap["search_key"] = param.q;
	    if(param.type){
	    	paraMap["type"] = param.type;
	    }
	    else{
		    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
				paraMap["type"] = global.stockType.join(":");
			}
		    else{
		    	paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:24:25:26:27:30:64:65:66";
		    }
		}
	    paraMap["request_num"] = "10";
	    paraMap["is_start"] = true;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  获取个股行情
	 * @param {Object} stockStr 股票代码或者拼音
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getStockInfo=function(param,callback,ctrlParam){
		//填充机构代码
	    var paraMap = {};
	    paraMap["funcNo"] = "380000";
	    paraMap["search_key"] = param.code_list;
	    if(global.stockType && global.stockType instanceof Array && global.stockType.length != 0){
			paraMap["type"] = global.stockType.join(":");
		}
	    else{
	    	paraMap["type"] = "0:1:2:3:4:5:6:8:9:10:11:12:13:14:16:17:18:19:20:21:22:23:23:24:25:26:27:30:64:65:66";
	    }
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  获取行情服务器状态与时间
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getHqState=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380002";
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqSJConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 * 港股通个股行情
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getHqState_ggt=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcno"] = "50000";
	    paraMap["version"] = 1;
	    paraMap["field"] = "22:24:2:10:11:9:12:14:6:1:16:3:4:5";
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.HqUrl);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 *  根据股票代码，拼音简称，中文名称查询股票（可用做码表查询）
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.getStockList_ggt=function(param,callback,ctrlParam){
	    var paraMap = {};
	    paraMap["funcNo"] = "380000";
	    paraMap["search_key"] = param.q;
	    if(param.type){
			paraMap["type"] = param.type;
		}
	    else{
	    	paraMap["type"] = "98:99";
	    }
	    paraMap["request_num"] = "10";
	    paraMap["is_start"] = "0";
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
	};
	
	/**
	 *  查询股票期权五档行情  柜台接口
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
	service_hqTrade.prototype.queryOptionsMarket=function(param,callback,ctrlParam){var paraMap = {};
		paraMap["funcNo"] = "305000";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["option_code"] = param.option_code;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 查询股票期权五档行情  接入转发行情接口
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_hqTrade.prototype.queryOptions = function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "380004";
	    paraMap["stock_list"] = param.stock_list;
	    paraMap["flag"] = 0;
	    paraMap["_inte_mode"] = _inte_mode;
	    paraMap["no_default"] = true;
	    var reqParamVo = this.service.reqParamVo;
	    reqParamVo.setTimeout(time);
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, function(d){
			var data = hqWDConverter(d);
			callback(data);
		}, ctrlParam, reqParamVo);
		
	}
	
	/***应用接口......................................................结束*/

});