/**
 * 原生插件 异步回调 方法调用统一封装
 */
define('trade/service/scripts/trade/service_native_sync.js', function (require, exports, module) {
    var service = require("service");
    var gconfig = $.config;
    var global = gconfig.global;

    /********************************公共代码部分********************************/
    service_native_sync.prototype.commonInvoke = service.commonInvokeNativeSync;

    service_native_sync.prototype.destroy = function () {
        this.service.destroy();
    };
    function service_native_sync() { //对应的接口方法需要在这里暴露出来
        this.service = new $.service;
    };
    module.exports = new service_native_sync();

    /********************************应用接口开始********************************/

    /********************************业务范围--原生异步控件********************************/

    /**
      * 查询系统是否允许消息通知
      * */
     service_native_sync.prototype.native5011516 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = "5011516";
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
      * 通用日期选择控件
      * title; //标题
      * formatStr; //返回时间格式                   默认"yyyy年MM月dd日";
      * startDateStr; //开始时间【格式同formatStr】 默认"19900101";
      * selectedDateStr; //选中时间【格式同formatStr】默认当前时间
      * endDateStr; //结束时间【格式同formatStr】     默认"21001231";
      * isShowTip;  //是否显示提示按钮 0不显示，1显示  默认"0";
    
      * 出参：
      * status; //0点击确定按钮 1点击取消按钮 2点击提示按钮 其他表示选择框消失
      * dateStr 选择的日期【按formatStr返回】只有点击确定按钮的时候会返回
      * */
    service_native_sync.prototype.native5011518 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = "5011518";
        paraMap["title"] = param.title;
        paraMap["formatStr"] = param.formatStr;
        paraMap["startDateStr"] = param.startDateStr;
        paraMap["selectedDateStr"] = param.selectedDateStr;
        paraMap["endDateStr"] = param.endDateStr;
        paraMap["isShowTip"] = param.isShowTip;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
      * 通用下拉选择框
      * title; //标题
      * selectIndex; //选中索引 默认0
      * isShowTip;  //是否显示提示按钮 0不显示，1显示  默认"0";
      * list; // 帅选列表【格式是json数组】
    
      * 出参：
      * status; //0点击确定按钮 1点击取消按钮 2点击提示按钮 其他表示选择框消失
      * selectIndex; //选中数据的索引
      * dateStr 选择的数据【只有点击确定按钮的时候会返回】
      * */
    service_native_sync.prototype.native5011519 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = "5011519";
        paraMap["title"] = param.title;
        paraMap["selectIndex"] = param.selectIndex;
        paraMap["isShowTip"] = param.isShowTip;
        paraMap["list"] = param.list;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
      * 获取可转债对应的 正股信息
      * codeMarket    100902.sz
    
      * 出参：
      * code        //股票代码
      * name        //股票名称
      * market      //市场
      * subtype     //子类别
      * lastPrice   //最新价
      * preClosePrice//昨收价
      * premium     //转股溢价率
      * upDownFlag  //涨跌标识
      * changeRate  //涨跌幅
      * change      //涨跌
      * transferPrice//转股价
      * */
    service_native_sync.prototype.native5011520 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = "5011520";
        paraMap["codeMarket"] = param.codeMarket;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
});
