/**
 * 基金service层调用接口
 */
define('trade/service/scripts/trade/service_otc.js',function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverPathTrade = global.serverPathTrade; //服务器URL
    
	/********************************公共代码部分********************************/
    service_otc.prototype.commonInvoke = service.commonInvoke;

	service_otc.prototype.destroy = function(){
		this.service.destroy();
	};
	function service_otc(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service_otc();
	
	/********************************应用接口开始********************************/
	
	/********************************业务范围--OTC********************************/
	 /**
	 * 获取不同期限产品的列表
	 * @param callback       回调函数
	 * @param prod_term_type    产品期限类型（1：1个月,2：2个月，3:3个月，6:6个月以上）
	 * */
	service_otc.prototype.getProductList = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301412";
//		paraMap["prod_term_type"] = param.prod_term_type;
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["cust_code"] = param.cust_code;
		paraMap["fund_account"] = param.fund_account;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	
	 /**
	 * 获取产品详情
	 * @param callback       回调函数
	 * */
	service_otc.prototype.getProDetail = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301414";
	    paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["passowrd"] = param.passowrd;
	    paraMap["inst_cod"] = param.inst_cod;
	    paraMap["prod_type"] = param.prod_type;
	    paraMap["prod_source"] = param.prod_source;
	     // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  

	 /**
	 * otc 持仓资产
	 * @param callback       回调函数
	 * @param 
	 * */
	service_otc.prototype.queryHolding = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301416";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	 /**
	 * otc 撤单查询
	 * @param callback       回调函数
	 * @param 
	 * */
	service_otc.prototype.queryCancelData = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301403";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	 /**
	 * otc 撤单确认
	 * @param callback       回调函数
	 * @param 
	 * */
	service_otc.prototype.subCancel = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301405";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["trans_acct"] = param.trans_acct;
		paraMap["ori_app_sno"] = param.ori_app_sno;
		paraMap["ori_app_date"] = param.ori_app_date;
		paraMap["type"] = param.type;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	 /**
	 * otc 认购
	 * @param callback       回调函数
	 * @param 
	 * */
	service_otc.prototype.subOtcBuy = function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301404";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["inst_cod"] = param.inst_cod;
		paraMap["inst_id"] = param.inst_id;
		paraMap["ta_code"] = param.ta_code;
		paraMap["trd_id"] = param.trd_id;
		paraMap["trans_acct"] = param.trans_acct;
		paraMap["trd_amt"] = param.trd_amt;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	 /**
	 * otc 查询产品相关协议
	 * @param callback       回调函数
	 * @param 
	 * */
	service_otc.prototype.productsAgreement= function(param, callback, ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301421";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["inst_cod"] = param.inst_cod;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};  
	
	
	
	
	
	/***应用接口......................................................结束*/

});