/**
 * 网络投票service层调用接口
 */
define('trade/service/scripts/trade/service_sso.js',function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
    
	/********************************公共代码部分********************************/
    service_sso.prototype.commonInvoke = service.commonInvoke;

	service_sso.prototype.destroy = function(){
		this.service.destroy();
	};
	function service_sso(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service_sso();
	
	/********************************应用接口开始********************************/
	/********************************业务范围--网络投票等功能********************************/
	
	/**
	 * 股东大会信息查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码
	 * @param {Object} op_station				操作站点	
	 * @param {Object} sessionid				会话号
	 * @param {Object} exchange_type			市场
	 * @param {Object} company_code				公司代码
	 * @param {Object} vote_code				产品代码
	 * */
	service_sso.prototype.verification = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "600002";
		paraMap["temp_token"] = param.temp_token;
		paraMap["merchant_id"] = param.merchant_id;
		paraMap["ip"] = param.ip;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 投票议案信息查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码
	 * @param {Object} op_station				操作站点	
	 * @param {Object} sessionid				会话号
	 * @param {Object} meeting_seq				股东大会编码
	 * @param {Object} v_id						议案编号
	 * @param {Object} vote_code				产品代码
	 * */
	service_sso.prototype.analogLogin = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "600004";
		paraMap["isShowWait"] = param.isShowWait;
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["acct_type"] = param.acct_type;
		paraMap["input_content"] = param.input_content;
		paraMap["ip"] = param.ip;
		paraMap["m_version"] = param.m_version;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 投票议案信息查询
	 * @param {Object} entrust_way				委托方式
	 * @param {Object} branch_no				分支机构
	 * @param {Object} fund_account				资金账号
	 * @param {Object} cust_code				客户编号	
	 * @param {Object} password					交易密码
	 * @param {Object} op_station				操作站点	
	 * @param {Object} sessionid				会话号
	 * @param {Object} meeting_seq				股东大会编码
	 * @param {Object} v_id						议案编号
	 * @param {Object} vote_code				产品代码
	 * */
	service_sso.prototype.optionAnalogLogin = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "600003";
		paraMap["isShowWait"] = param.isShowWait;
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["acct_type"] = param.acct_type;
		paraMap["input_content"] = param.input_content;
		paraMap["ip"] = param.ip;
		paraMap["m_version"] = param.m_version;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
 		reqParamVo.setUrl( global.serverPathTrade);
 		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/***应用接口......................................................结束*/

});