/**
 * 普通交易service层调用接口
 */
define('trade/service/scripts/trade/service_stock.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
	var global = gconfig.global;

	function service_stock(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};

	module.exports = new service_stock();

    /**
	 * 释放操作
	 */
	service_stock.prototype.destroy = function(){
		this.service.destroy();
	};
	/********************************公共代码部分********************************/
    service_stock.prototype.commonInvoke = service.commonInvoke;


	/********************************应用接口开始********************************/
    /********************************业务范围--股票********************************/
      /**
    	 *  委托
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} password                	交易密码
      	 * @param {Object} sessionid                会话号
       	 * @param {Object} entrust_bs               买卖方向
      	 * @param {Object} exchange_type            交易类别
       	 * @param {Object} stock_account            证券账号
      	 * @param {Object} stock_code               股票号码
       	 * @param {Object} entrust_price            委托价格
      	 * @param {Object} entrust_amount           委托数量
         * @param {Object} batch_no                 委托批号
    	 * @param {Object} callback	回调方法
    	 * */
         service_stock.prototype.getStockBuy=function(param,callback,ctrlParam){
    		var paraMap = {};
    	    paraMap["funcNo"] = "301501";
    	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] = param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["entrust_bs"] = param.entrust_bs;
    	    paraMap["exchange_type"] =  param.exchange_type;
    	    paraMap["stock_account"] = param.stock_account;
    	    paraMap["stock_code"] =  param.stock_code;
    	    paraMap["entrust_price"] = param.entrust_price;
    	    paraMap["entrust_amount"] =  param.entrust_amount;
    	    paraMap["batch_no"] =  param.batch_no;
    	    paraMap["instr_batch_no"] = param.instr_batch_no;
    	     // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    	    reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    	};

        /**
      	 * 委托撤单
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} password                	交易密码
      	 * @param {Object} sessionid                会话号
       	 * @param {Object} entrust_no               委托编号
      	 * @param {Object} exchange_type            交易类别
       	 * @param {Object} batch_flag            	批量撤单标志
      	 * @param {Object} callback	回调方法
      	 * */
         service_stock.prototype.postCancelOrder=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301502";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] = param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["entrust_no"] = param.entrust_no;
    	    paraMap["batch_flag"] =  param.batch_flag;
    	    paraMap["exchange_type"] = param.exchange_type;
    	     // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
      	/**
      	 * 持仓查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} exchange_type            交易类别
       	 * @param {Object} stock_account            证券账号
      	 * @param {Object} stock_code               股票号码
      	 * @param {Object} callback	回调方法
      	 * */
         service_stock.prototype.queryStockData=function(param,callback,ctrlParam){
      		var paraMap = {};
          paraMap["funcNo"] = "301503";
          paraMap["entrust_way"] = param.entrust_way;
          paraMap["branch_no"] =  param.branch_no;
          paraMap["fund_account"] = param.fund_account;
          paraMap["cust_code"] =  param.cust_code;
          paraMap["sessionid"] =  param.sessionid;
          paraMap["password"] =  param.password;
          paraMap["stock_account"] = "";  //param.stock_account
          paraMap["stock_code"] =  param.stock_code;
          paraMap["exchange_type"] = param.exchange_type;
		  paraMap["request_num"] = param.request_num;
          paraMap["filt_flag"] = param.filt_flag;
          paraMap["money_type"] = param.money_type;
          paraMap["include_ggt"] = param.include_ggt;
          paraMap["is_bjs"] = param.is_bjs
          // 添加 op_station 到接口请求参数中
          var reqParamVo = this.service.reqParamVo;
          reqParamVo.setUrl(global.serverPathTrade);
          this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
      	/**
      	 * 北交所持仓页面查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} exchange_type            交易类别
       	 * @param {Object} stock_account            证券账号
      	 * @param {Object} stock_code               股票号码
      	 * @param {Object} callback	回调方法
      	 * */
         service_stock.prototype.queryStockHoldingData=function(param,callback,ctrlParam){
      		var paraMap = {};
          paraMap["funcNo"] = "361545";
          paraMap["entrust_way"] = param.entrust_way;
          paraMap["branch_no"] =  param.branch_no;
          paraMap["fund_account"] = param.fund_account;
          paraMap["cust_code"] =  param.cust_code;
          paraMap["sessionid"] =  param.sessionid;
          paraMap["password"] =  param.password;
          paraMap["stock_account"] = "";  //param.stock_account
          paraMap["stock_code"] =  param.stock_code;
          paraMap["exchange_type"] = param.exchange_type;
          paraMap["filt_flag"] = param.filt_flag;
          paraMap["money_type"] = param.money_type;
          // 添加 op_station 到接口请求参数中
          var reqParamVo = this.service.reqParamVo;
          reqParamVo.setUrl(global.serverPathTrade);
          this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
      	/**
      	 * 资金查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} callback	回调方法
      	 * @param {Object} isLastReq	是否是最后一个请求，默认是true
      	 * */
         service_stock.prototype.queryFundSelect=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301504";
      	    paraMap["entrust_way"] =  param.entrust_way;
      	    paraMap["branch_no"] =  param.branch_no;
      	    paraMap["fund_account"] =  param.fund_account;
      	    paraMap["asset_account"] =  param.asset_account || param.fund_account;
      	    paraMap["cust_code"] =  param.cust_code;
      	    paraMap["password"] =  param.password;
      	    paraMap["sessionid"] =  param.sessionid;
      	    paraMap["money_type"] =  param.money_type;
      	    paraMap["is_homepage"] =  param.is_homepage;
      	    paraMap["income_balance"] = param.is_homepage;
      	     // 添加 op_station 到接口请求参数中
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

      	/**
      	 * 资金流水查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} begin_time               开始日期
      	 * @param {Object} end_time                	截止日期
      	 * @param {Object} business_flag            业务类型
      	 * @param {Object} callback	回调方法
      	 * */
         service_stock.prototype.queryAccountFlow=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301505";
      	    paraMap["entrust_way"] =  param.entrust_way;
      	    paraMap["branch_no"] =  param.branch_no;
      	    paraMap["fund_account"] =  param.fund_account;
      	    paraMap["cust_code"] =  param.cust_code;
      	    paraMap["password"] =  param.password;
      	    paraMap["sessionid"] =  param.sessionid;
      	    paraMap["money_type"] =  param.money_type;
      	    paraMap["begin_time"] =  param.begin_time;
      	    paraMap["end_time"] =  param.end_time;
      	    paraMap["business_flag"] =  param.business_flag;
      	     // 添加 op_station 到接口请求参数中
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

      	/**
      	 * 行情查询
      	 *
    	 * @param {Object} exchange_type             交易类型
      	 * @param {Object} stock_code                股票号码
      	 * @param {Object} callback	回调方法
      	 * */
        service_stock.prototype.queryStockhqInfo=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301506";
      	    paraMap["exchange_type"] =  param.exchange_type;
      	    paraMap["stock_code"] =  param.stock_code;
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

        /**
      	 * 当日委托查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * */
         service_stock.prototype.queryTodayTrust=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301508";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["exchange_type"] =  param.exchange_type;
    	    paraMap["stock_account"] =  param.stock_account;
    	    paraMap["stock_code"] =  param.stock_code;
    	    paraMap["entrust_bs"] =  param.entrust_bs;
          paraMap["is_bjs"] = param.is_bjs;
    	     // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

        /**
      	 * 当日成交查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} callback	回调方法
      	 * */
         service_stock.prototype.queryTodayTrade=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301509";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["exchange_type"] =  param.exchange_type;
    	    paraMap["stock_account"] =  param.stock_account;
    	    paraMap["stock_code"] =  param.stock_code;
    	    paraMap["entrust_bs"] =  param.entrust_bs;
          paraMap["is_bjs"] = param.is_bjs;
    	     // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

        /**
      	 * 历史委托查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} begin_time               开始日期
      	 * @param {Object} end_time                	截止日期
      	 * */
         service_stock.prototype.queryHistoryTrust=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301510";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["begin_time"] =  param.begin_time;
    	    paraMap["end_time"] =  param.end_time;
    	    paraMap["exchange_type"] =  param.exchange_type;
    	    paraMap["stock_account"] =  param.stock_account;
    	    paraMap["stock_code"] =  param.stock_code;
    	    paraMap["is_bjs"] =  param.is_bjs;
             paraMap["search_type"] =  param.search_type;
             paraMap["entrust_bs"] =  param.entrust_bs;
    		 // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

        /**
      	 * 历史成交查询
      	 *
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} sessionid                会话号
      	 * @param {Object} begin_time               开始日期
      	 * @param {Object} end_time                	截止日期
      	 * @param {Object} callback	回调方法
      	 */
         service_stock.prototype.queryHistoryTrade=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301511";
      	    paraMap["entrust_way"] = param.entrust_way;
    	    paraMap["branch_no"] =  param.branch_no;
    	    paraMap["fund_account"] = param.fund_account;
    	    paraMap["cust_code"] =  param.cust_code;
    	    paraMap["password"] =  param.password;
    	    paraMap["sessionid"] =  param.sessionid;
    	    paraMap["begin_time"] =  param.begin_time;
    	    paraMap["end_time"] =  param.end_time;
    	    paraMap["exchange_type"] =  param.exchange_type;
    	    paraMap["stock_account"] =  param.stock_account;
             paraMap["search_type"] =  param.search_type;
             paraMap["stock_code"] =  param.stock_code;
    	    paraMap["entrust_bs"] =  param.entrust_bs;
    	    paraMap["is_bjs"] =  param.is_bjs;
    		 // 添加 op_station 到接口请求参数中
    	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};
    /**
     * 历史委托查询-ETF委托查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryHistoryTrustNew=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361547";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 历史委托查询-ETF委托查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryHistoryTradeNew=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361548";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 交易查询详情
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
    service_stock.prototype.queryStockDetail=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo;
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["search_type"] =  param.search_type;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        paraMap["begin_date"] =  param.begin_time;
        paraMap["end_date"] =  param.end_time;
        paraMap["en_bondtrade_trans_status"] = param.en_bondtrade_trans_status;
        paraMap["cbpconfer_id"] = param.cbpconfer_id;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
      	/**
      	 * 查询股东列表
      	 * @param {Object} entrust_way     委托方式
      	 * @param {Object} branch_no       分支机构
      	 * @param {Object} fund_account    资金账号
      	 * @param {Object} cust_code       客户编号
      	 * @param {Object} sessionid       会话号
      	 * */
         service_stock.prototype.queryStockAccountList=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301512";
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
      	    paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["business_type"] = param.businessType;//0为激活 1为挂失
      	     // 添加 op_station 到接口请求参数中
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

    	/**
      	 * 机构信息查询
      	 * @param {Object} entrust_way     委托方式
      	 * @param {Object} query_branch_no 查询机构入参
      	 * */
         service_stock.prototype.queryBranchInfo=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301513";
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["query_branch_no"] = param.query_branch_no;
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

    	/**
      	 * 股票信息联动
      	 * @param {Object} entrust_way     委托方式
      	 * @param {Object} branch_no       分支机构
      	 * @param {Object} fund_account    资金账号
      	 * @param {Object} cust_code       客户编号
      	 * @param {Object} sessionid       会话号
      	 * @param {Object} entrust_bs      买卖方向
      	 * @param {Object} exchange_type   交易市场类别
      	 * @param {Object} stock_code      股票代码
      	 * @param {Object} entrust_price   委托价格
      	 * */
         service_stock.prototype.queryStockMaxBuy=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301514";
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
            paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["entrust_bs"] = param.entrust_bs;
      	    paraMap["stock_code"] = param.stock_code;
      	    paraMap["entrust_price"] = param.entrust_price;
      	    paraMap["newstock_flag"] = param.newstock_flag;
      	    paraMap["stock_account"] =  param.stock_account;
      	    paraMap["stock_accounts"] = param.stock_accounts;
      	    paraMap["exchange_type"] = param.exchange_type;
      	     // 添加 op_station 到接口请求参数中
      	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

    	/**
      	 * 查询当日可撤委托
      	 * @param {Object} entrust_way     委托方式
      	 * @param {Object} branch_no       分支机构
      	 * @param {Object} fund_account    资金账号
      	 * @param {Object} cust_code       客户编号
      	 * @param {Object} sessionid       会话号
      	 * */
         service_stock.prototype.queryTrustData=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301515";
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
            paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["entrust_bs"] = param.entrust_bs;
      	    paraMap["is_bjs"] = param.is_bjs;
      	     // 添加 op_station 到接口请求参数中
      	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

    	/**
      	 * 资金流水当日查询
      	 * @param {Object} entrust_way     委托方式
      	 * @param {Object} branch_no       分支机构
      	 * @param {Object} fund_account    资金账号
      	 * @param {Object} cust_code       客户编号
      	 * @param {Object} sessionid       会话号
      	 * @param {Object} sessionid       业务类型
      	 * */
         service_stock.prototype.querySameDayCapitalFlow=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301516";
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
            paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["money_type"] = param.money_type;
      	    paraMap["business_flag"] = param.business_flag;
      	     // 添加 op_station 到接口请求参数中
      	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

      	//**********新股*************************************
      	/**
      	 * 新股票配号查询
      	 * @param {Object} cust_code              客户编号
      	 * @param {Object} fund_account           资金账号
      	 * @param {Object} xjb_account            现金宝账户
      	 * @param {Object} star_page              起始页码
      	 * @param {Object} page_count             每页数量
      	 * */
        service_stock.prototype.queryDistributionData =function(param,callback,ctrlParam){
      		var paraMap = {};
      		if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "303029";
	    	}else{
	    		paraMap["funcNo"] = "301517";
	    	}
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
            paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["stock_account"] =  param.stock_account;
      	    paraMap["stock_code"] = param.stock_code;
      	    paraMap["begin_time"] = param.begin_time;
      	    paraMap["end_time"] = param.end_time;
      	    paraMap["begin_date"] = param.begin_time;
      	    paraMap["end_date"] = param.end_time;
      	     // 添加 op_station 到接口请求参数中
      	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

      	/**
      	 * 新股中签查询
      	 * @param {Object} cust_code              客户编号
      	 * @param {Object} fund_account           资金账号
      	 * @param {Object} xjb_account            现金宝账户
      	 * @param {Object} star_page              起始页码
      	 * @param {Object} page_count             每页数量
      	 * */
      	service_stock.prototype.querySuccessData =function(param,callback,ctrlParam){
      		var paraMap = {};
      		if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "303030";
	    	}else{
	    		paraMap["funcNo"] = "301518";
	    	}
      	    paraMap["entrust_way"] = param.entrust_way;
      	    paraMap["branch_no"] = param.branch_no;
           	paraMap["fund_account"] = param.fund_account;
      	    paraMap["cust_code"] = param.cust_code;
            paraMap["password"] =  param.password;
      	    paraMap["sessionid"] = param.sessionid;
      	    paraMap["stock_account"] =  param.stock_account;
      	    paraMap["stock_code"] = param.stock_code;
      	    paraMap["begin_time"] = param.begin_time;
      	    paraMap["end_time"] = param.end_time;
      	    paraMap["begin_date"] = param.begin_time;
      	    paraMap["end_date"] = param.end_time;
      	     // 添加 op_station 到接口请求参数中
      	    var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

        /**
         *
         * 新股日历--新股信息查询
         */
      	service_stock.prototype.queryMakeApp = function(param,callback,ctrlParam){
        	var paraMap = {};
        	paraMap["funcNo"] = "200200";
        	var reqParamVo = this.service.reqParamVo;
        	reqParamVo.setUrl(global.serverPathTrade);
        	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
        };

        /**
         *
         * 添加消息推送token信息
         * @param callback 回调函数
         */
        service_stock.prototype.sendMessages = function(param,callback,ctrlParam){
        	var paraMap = {};
        	paraMap["funcNo"] = "1000005";
        	paraMap["token"] = param.token;
        	paraMap["stockcode"] = param.stockcode;
        	paraMap["chancel"] = param.chancel;
        	paraMap["sendflag"] = param.sendflag;
        	paraMap["phone"] = param.phone;
        	var reqParamVo = this.service.reqParamVo;
        	reqParamVo.setUrl(global.serverPathTrade);
        	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
        };

        /**
         *
         * 今日新股查询
         * @param callback 回调函数
         */
        service_stock.prototype.queryTodayNewShare = function(param,callback,ctrlParam){
        	var paraMap = {};
        	paraMap["funcNo"] = "200020";
        	paraMap["flag"] = param.flag;
        	paraMap["list_date"] = param.list_date;
        	var reqParamVo = this.service.reqParamVo;
        	reqParamVo.setUrl(global.newshareUrl);
        	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
        };

        /**
         * 新股申购额度查询
         * @param entrust_way	varchar(1)	委托方式（见数据字典)
         * @param branch_no	varchar(10)	分支机构
         * @param fund_account	varchar(20)	资金账号
         * @param cust_code	varchar(32)	客户编号
         * @param password	varchar(32)	交易密码
         * @param op_station	varchar(50)	操作站点（见数据字典)
         * @param sessionid	varchar(32)	会话号
         * @param exchange_type	varchar(1)	交易市场类别（见数据字典)
         * @param callback 回调函数
         * */
        service_stock.prototype.newAmount_Query = function(param,callback,ctrlParam){
        	var paraMap = {};
        	if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "303028";
	    	}else{
	    		paraMap["funcNo"] = "301519";
	    	}
        	paraMap["entrust_way"] = param.entrust_way;
        	paraMap["branch_no"] = param.branch_no;
        	paraMap["fund_account"] = param.fund_account;
        	paraMap["cust_code"] = param.cust_code;
        	paraMap["password"] = param.password;
        	paraMap["sessionid"] = param.sessionid;
        	paraMap["exchange_type"] = param.exchange_type;
        	 // 添加 op_station 到接口请求参数中
        	var reqParamVo = this.service.reqParamVo;
    	  	reqParamVo.setUrl(global.serverPathTrade);
    	  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
        };
        /**
	  	 * 查询对账单
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.queryStatementOfAccount = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301520";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["money_type"] =  param.money_type;
	  	    paraMap["sessionid"] =  param.sessionid;
  	        paraMap["password"] =  param.password;
            paraMap["search_type"] =  param.search_type;
            paraMap["begin_date"] =  param.begin_date;
	  	    paraMap["end_date"] =  param.end_date;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

    service_stock.prototype.queryStatementOfAccountNew = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "301523";
        paraMap["entrust_way"] =  param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] =  param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["money_type"] =  param.money_type;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["password"] =  param.password;
        paraMap["search_type"] =  param.search_type;
        paraMap["begin_date"] =  param.begin_date;
        paraMap["end_date"] =  param.end_date;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

	  	 /**
	  	 * 查询新股数
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.queryListingShares = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "301535";
	    	}else{
	    		paraMap["funcNo"] = "301535";
	    	}
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["money_type"] =  param.money_type;
	  	    paraMap["sessionid"] =  param.sessionid;
	  	    paraMap["stock_code"] =  param.stock_code;
	  	    paraMap["issue_date"] =  param.issue_date;
	  	    paraMap["flag"] = param.flag || "1";
	  	    paraMap["is_login"] = param.is_login;//是否登录
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	 /**
	  	 * 查询新债条数
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.queryNumberNewDebts = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301557";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["money_type"] =  param.money_type;
	  	    paraMap["sessionid"] =  param.sessionid;
	  	    paraMap["stock_code"] =  param.stock_code;
	  	    paraMap["issue_date"] =  param.issue_date;
	  	    paraMap["flag"] = param.flag || "1";
	  	    paraMap["is_login"] = param.is_login;//是否登录
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 当前中签查询
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.theCurrentSuccess = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "301536";
	    	}else{
	    		paraMap["funcNo"] = "301536";
	    	}
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["sessionid"] =  param.sessionid;
	  	    paraMap["stock_account"] =  param.stock_account;
	  	    paraMap["begin_date"] =  param.begin_date;
	  	    paraMap["end_date"] =  param.end_date;
	  	    paraMap["begin_time"] =  param.begin_date;
	  	    paraMap["end_time"] =  param.end_date;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 当前中签查询
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.oneKeyPurchase = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    if(param.account_type=="1"){ //恒生
	    		paraMap["funcNo"] = "303052";
	    	}else{
	    		paraMap["funcNo"] = "301539";
	    	}
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["sessionid"] =  param.sessionid;
	  	    paraMap["entrustcodes"] =  param.entrustcodes;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 查询对账单
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} sessionid                会话号
	  	 * @param {Object} begin_time               开始日期
	  	 * @param {Object} end_time                	截止日期
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.deliveryQrder = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301547";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
	  	    paraMap["money_type"] =  param.money_type;
	  	    paraMap["sessionid"] =  param.sessionid;
  	        paraMap["password"] =  param.password;
	  	    paraMap["begin_date"] =  param.begin_time;
	  	    paraMap["end_date"] =  param.end_time;
            paraMap["search_type"] =  param.search_type;
	  	    paraMap["begin_time"] =  param.begin_time;
	  	    paraMap["end_time"] =  param.end_time;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

		/**
	  	 * 账户总览查询
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.getAccountOverview = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "900200";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
  	        paraMap["password"] =  param.password;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 股基总览查询
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.getStockOverview  = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "900201";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
  	        paraMap["password"] =  param.password;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 理财总览查询
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.getFinancialOverview  = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "900202";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;
	  	    paraMap["cust_code"] =  param.cust_code;
  	        paraMap["password"] =  param.password;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 成本价修改
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.costModification  = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301548";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;//资金账号
	  	    paraMap["cust_code"] =  param.cust_code;//客户号
	  	    paraMap["stock_account"] =  param.stock_account;//股东代码
	  	    paraMap["exchange_type"] =  param.exchange_type;//市场
	  	    paraMap["stock_code"] =  param.stock_code;//股票代码
	  	    paraMap["cost_price"] =  param.cost_price;//成本价
  	        paraMap["password"] =  param.password;
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 服务密码联动
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.servicePasswordLinkage = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301549";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;//资金账号
	  	    paraMap["cust_code"] =  param.cust_code;//客户号
	  	    paraMap["stock_account"] =  param.stock_account;//股东代码
	  	    paraMap["exchange_type"] =  param.exchange_type;//市场
	  	    paraMap["business_type"] =  param.businessType;//股票代码
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	  	/**
	  	 * 服务密码提交
		 * @param {Object} entrust_way              委托方式
	  	 * @param {Object} branch_no                分支机构
	  	 * @param {Object} fund_account             资金账号
	  	 * @param {Object} cust_code                客户编号
	  	 * @param {Object} callback	回调方法
	  	*/
	    service_stock.prototype.servicePasswordSumbit = function(param,callback,ctrlParam){
	  		var paraMap = {};
	  	    paraMap["funcNo"] = "301550";
	  	    paraMap["entrust_way"] =  param.entrust_way;
	  	    paraMap["branch_no"] =  param.branch_no;
	  	    paraMap["fund_account"] =  param.fund_account;//资金账号
	  	    paraMap["cust_code"] =  param.cust_code;//客户号
	  	    paraMap["stock_account"] =  param.stock_account;//股东代码
	  	    paraMap["exchange_type"] =  param.exchange_type;//市场
	  	    paraMap["entrust_amount"] =  param.entrust_amount;//激活码
	  	    paraMap["business_type"] =  param.businessType;
	  	    paraMap["stock_code"] =  param.stock_code;//代码
	  	    paraMap["entrust_price"] =  param.entrust_price;//价格
			 // 添加 op_station 到接口请求参数中
			var reqParamVo = this.service.reqParamVo;
		  	reqParamVo.setUrl(global.serverPathTrade);
		  	this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	  	};

	/**
	 * 存托凭证协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stock.prototype.signCDRrights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301558";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["remark"] = param.remark;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stock.prototype.signInnovateRights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301559";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["remark"] = param.remark;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 存托凭证、创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stock.prototype.signCDRInnovateRights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301560";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["accounts_list"] = param.accounts_list;
		paraMap["remark"] = param.remark;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 存托凭证、创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stock.prototype.queryCDRProtocol = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301561";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["query_type"] = param.query_type;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  获取行情服务器状态与时间
	 * @param {Object} stockStr 市场代码:股票代码
	 * @param {Object} callback	回调方法
	 * */
     service_stock.prototype.getHqState = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "361549";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 限售股份查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stock.prototype.limitedStockQuery = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301562";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/********************************新股新债开始************************************/

    /*********
     * 新股新债-首页列表
     * @param param
     * @param callback
     * @param ctrlParam
     */
    service_stock.prototype.queryMainInfo = function(param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo;
        paraMap["flag"] = param.flag;
        var reqParamVo = this.service.reqParamVo;
        if(global.nsb_isProd){
            reqParamVo.setUrl(global.nsbUrl);
        }else{
            reqParamVo.setUrl(global.nsbUrl_test);
        }
        service.commonInvokeNsb(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 新股新债-详情查询
     * funcNo 200022 新股 200027新债
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.getNewStockInfoNew = function(param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo;
        paraMap["stock_code"] = param.stock_code;
        paraMap["market"] = param.market;
        paraMap["bund_code"] = param.bund_code;
        paraMap["sgdm"] = param.sgdm;
        paraMap["sg_code"]=param.sg_code;
        paraMap["catalogid"] = param.catalogid;
        var reqParamVo = this.service.reqParamVo;
        if(global.nsb_isProd){
            reqParamVo.setUrl(global.nsbUrl);
        }else{
            reqParamVo.setUrl(global.nsbUrl_test);
        }
        service.commonInvokeNsb(paraMap, callback, ctrlParam, reqParamVo);
    };


    /***********
     * 新股新债-日历列表
     * funcNo 200028新股 200029新债
     * @param param
     * @param callback
     * @param ctrlParam
     */
    service_stock.prototype.getCalendarInfo = function(param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo;
        var reqParamVo = this.service.reqParamVo;
        if(global.nsb_isProd){
            reqParamVo.setUrl(global.nsbUrl);
        }else{
            reqParamVo.setUrl(global.nsbUrl_test);
        }
        service.commonInvokeNsb(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     *  新股新债 -获取票行情最新价
     * @param {Object} stockStr 市场代码:股票代码
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.getNSBStockNowPrice=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcno"] = "26000";
        paraMap["version"] = 1;
        paraMap["stock_list"] = param.stock_list;
        paraMap["field"] ="2:1";
        var reqParamVo = this.service.reqParamVo;
        if(global.nsb_isProd){
            reqParamVo.setUrl(global.nsbGGHQ);
        }else{
            reqParamVo.setUrl(global.nsbGGHQ_test);
        }
        service.commonInvokeNsb(paraMap, callback, ctrlParam, reqParamVo);
    };



    /*************
     * 新股新债-今日申购
     * @param param
     * @param callback
     * @param ctrlParam
     */
    service_stock.prototype.nsbJrsg = function(param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["stock_account"] = param.stock_account;
        paraMap["is_login"] = param.is_login;
        paraMap["password"] = param.password;
        paraMap["begin_time"] = param.begin_time;
        paraMap["end_time"] = param.end_time;
        paraMap["exchange_type"] = param.exchange_type;
        paraMap["op_station"] = param.op_station;
        paraMap["entrustcodes"] = param.entrustcodes;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /********************************新股新债结束************************************/


    /*************
     * 买入-查询是否开通ST风险权限
     * @param param
     * @param callback
     * @param ctrlParam
     */
    service_stock.prototype.queryST = function(param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = param.funcNo
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["cust_code"] = param.cust_code;
        paraMap["stock_account"] = param.stock_account;
        paraMap["exchange_type"] = param.exchange_type;
        paraMap["stock_code"] = param.stock_code;
        paraMap["fund_account"] = param.fund_account;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    // 债券现券专区接口
    
    /**
     * 债券现券-匹配成交-持仓查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} exchange_type            交易类别
     * @param {Object} stock_account            证券账号
     * @param {Object} stock_code               股票号码
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBondData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361553";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["password"] =  param.password;
        paraMap["stock_account"] = "";  //param.stock_account
        paraMap["stock_code"] =  param.stock_code;
        paraMap["exchange_type"] = param.exchange_type;
        paraMap["request_num"] = param.request_num;
        paraMap["filt_flag"] = param.filt_flag;
        paraMap["money_type"] = param.money_type;
        paraMap["include_ggt"] = param.include_ggt;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-匹配成交-股票信息联动
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * @param {Object} entrust_bs      买卖方向
     * @param {Object} exchange_type   交易市场类别
     * @param {Object} stock_code      股票代码
     * @param {Object} entrust_price   委托价格
     * */
    service_stock.prototype.queryBondMaxBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361552";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["stock_code"] = param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["newstock_flag"] = param.newstock_flag;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_accounts"] = param.stock_accounts;
        paraMap["exchange_type"] = param.exchange_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     *  债券现券-匹配成交-委托
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} password                	交易密码
     * @param {Object} sessionid                会话号
     * @param {Object} entrust_bs               买卖方向
     * @param {Object} exchange_type            交易类别
     * @param {Object} stock_account            证券账号
     * @param {Object} stock_code               股票号码
     * @param {Object} entrust_price            委托价格
     * @param {Object} entrust_amount           委托数量
     * @param {Object} batch_no                 委托批号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.getBondBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361551";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["entrust_amount"] =  param.entrust_amount;
        paraMap["batch_no"] =  param.batch_no;
        paraMap["instr_batch_no"] = param.instr_batch_no;
            // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所持仓页面查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} exchange_type            交易类别
     * @param {Object} stock_account            证券账号
     * @param {Object} stock_code               股票号码
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBandHoldingData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361569";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["password"] =  param.password;
        paraMap["stock_account"] = "";  //param.stock_account
        paraMap["stock_code"] =  param.stock_code;
        paraMap["exchange_type"] = param.exchange_type;
        paraMap["filt_flag"] = param.filt_flag;
        paraMap["money_type"] = param.money_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-匹配成交-当日委托查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * */
    service_stock.prototype.queryBondTodayTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361555";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-匹配成交-当日成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBondTodayTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361556";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-匹配成交-查询当日可撤委托
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryBondTrustData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361554";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-匹配成交-历史委托查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryBondHistoryTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361557";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-匹配成交-历史成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
    service_stock.prototype.queryBondHistoryTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361558";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["search_type"] =  param.search_type;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-协商成交-代码联动
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
     service_stock.prototype.queryBondConsultMax=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361559";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["stock_code"] = param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["newstock_flag"] = param.newstock_flag;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_accounts"] = param.stock_accounts;
        paraMap["exchange_type"] = param.exchange_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-协商成交-交易商/交易员信息查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
     service_stock.prototype.queryBondInvestor=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361560";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /*
    *  债券现券-协商成交-委托
    * @param {Object} entrust_way              委托方式
    * @param {Object} branch_no                分支机构
    * @param {Object} fund_account             资金账号
    * @param {Object} cust_code                客户编号
    * @param {Object} password                	交易密码
    * @param {Object} sessionid                会话号
    * @param {Object} entrust_bs               买卖方向
    * @param {Object} exchange_type            交易类别
    * @param {Object} stock_account            证券账号
    * @param {Object} stock_code               股票号码
    * @param {Object} entrust_price            委托价格
    * @param {Object} entrust_amount           委托数量
    * @param {Object} batch_no                 委托批号
    * @param {Object} callback	回调方法
    * */
    service_stock.prototype.getBondConsultBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361561";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["entrust_amount"] =  param.entrust_amount;
        paraMap["batch_trader_idno"] =  param.trader_id;
        paraMap["bond_investor_id"] = param.bond_investor_id;
        paraMap["oppo_trader_id"] = param.oppo_trader_id;
        paraMap["oppo_bond_investor_id"] = param.oppo_bond_investor_id;
        paraMap["cbpconfer_id"] = param.cbpconfer_id;
        paraMap["settle_type"] = param.settle_type;
        paraMap["remark"] = param.remark;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-协商成交-申报信息查询
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryBondReply=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361562";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["en_bondtrade_trans_status"] = param.en_bondtrade_trans_status;
        paraMap["cbpconfer_id"] = param.cbpconfer_id;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-协商成交-协商确认委托
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.bondReplyEntrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361563";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["stock_account"] = param.stock_account;
        paraMap["trader_id"] = param.trader_id;
        paraMap["exec_id"] = param.exec_id;
        paraMap["tradereport_type"] = param.tradereport_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-协商成交-深圳债券现券可撤委托查询
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryConsultTrustData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361564";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["en_entrust_prop"] = param.en_entrust_prop;
        paraMap["stock_account"] = param.stock_account;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-协商成交-深圳债券现券委托撤单
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} password                	交易密码
     * @param {Object} sessionid                会话号
     * @param {Object} entrust_no               委托编号
     * @param {Object} exchange_type            交易类别
     * @param {Object} batch_flag            	批量撤单标志
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.postConsultCancelOrder=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361565";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_no"] = param.entrust_no;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-协商成交-当日委托查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * */
    service_stock.prototype.queryConsultTodayTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361566";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-协商成交-当日成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryConsultTodayTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361567";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 债券现券-匹配成交-历史委托查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryConsultHistoryTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361568";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["en_entrust_prop"] =  param.en_entrust_prop;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 债券现券-匹配成交-历史成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
    service_stock.prototype.queryConsultHistoryTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361570";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["search_type"] =  param.search_type;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * 北交所-债券现券-协商成交-代码联动
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
     service_stock.prototype.queryBjBondConsultMax=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361579";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["stock_code"] = param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["newstock_flag"] = param.newstock_flag;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_accounts"] = param.stock_accounts;
        paraMap["exchange_type"] = param.exchange_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /*
     * 北交所-债券现券-协商成交-委托
    * @param {Object} entrust_way              委托方式
    * @param {Object} branch_no                分支机构
    * @param {Object} fund_account             资金账号
    * @param {Object} cust_code                客户编号
    * @param {Object} password                	交易密码
    * @param {Object} sessionid                会话号
    * @param {Object} entrust_bs               买卖方向
    * @param {Object} exchange_type            交易类别
    * @param {Object} stock_account            证券账号
    * @param {Object} stock_code               股票号码
    * @param {Object} entrust_price            委托价格
    * @param {Object} entrust_amount           委托数量
    * @param {Object} batch_no                 委托批号
    * @param {Object} callback	回调方法
    * */
    service_stock.prototype.getBJBondConsultBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361580";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["entrust_amount"] =  param.entrust_amount;
        paraMap["oppo_trader_id"] = param.oppo_trader_id;
        paraMap["confer_no"] = param.confer_no;
        paraMap["oppo_seat_no"] = param.oppo_seat_no;
        paraMap["oppo_stock_account"] = param.oppo_stock_account;
        paraMap["oppo_agency"] = param.oppo_agency;
        paraMap["remark"] = param.remark;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-债券现券-协商成交-可撤委托查询
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryBJConsultTrustData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361581";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["en_entrust_prop"] = param.en_entrust_prop;
        paraMap["stock_account"] = param.stock_account;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-债券现券-协商成交-撤单委托
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} password                	交易密码
     * @param {Object} sessionid                会话号
     * @param {Object} entrust_no               委托编号
     * @param {Object} exchange_type            交易类别
     * @param {Object} batch_flag            	批量撤单标志
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.postBJConsultCancelOrder=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361582";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_no"] = param.entrust_no;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-债券现券-协商成交-当日委托查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * */
     service_stock.prototype.queryBJConsultTodayTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361583";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 北交所-债券现券-协商成交-当日成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBJConsultTodayTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361584";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-债券现券-匹配成交-历史委托查询
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryBJConsultHistoryTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361585";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["en_entrust_prop"] =  param.en_entrust_prop;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 北交所-债券现券-匹配成交-历史成交查询
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * @param {Object} callback	回调方法
     */
    service_stock.prototype.queryBJConsultHistoryTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361586";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["search_type"] =  param.search_type;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    // 大宗交易接口

    /**
     * 沪深大宗交易-代码联动
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * @param {Object} entrust_bs      买卖方向
     * @param {Object} exchange_type   交易市场类别
     * @param {Object} stock_code      股票代码
     * @param {Object} entrust_price   委托价格
     * */
    service_stock.prototype.queryBlockMaxBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361571";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["entrust_prop"] = param.entrust_prop;
        paraMap["stock_code"] = param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["newstock_flag"] = param.newstock_flag;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_accounts"] = param.stock_accounts;
        paraMap["exchange_type"] = param.exchange_type;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /*
    *  沪深大宗交易-委托
    * @param {Object} entrust_way              委托方式
    * @param {Object} branch_no                分支机构
    * @param {Object} fund_account             资金账号
    * @param {Object} cust_code                客户编号
    * @param {Object} password                	交易密码
    * @param {Object} sessionid                会话号
    * @param {Object} entrust_bs               买卖方向
    * @param {Object} exchange_type            交易类别
    * @param {Object} stock_account            证券账号
    * @param {Object} stock_code               股票号码
    * @param {Object} entrust_price            委托价格
    * @param {Object} entrust_amount           委托数量
    * @param {Object} batch_no                 委托批号
    * @param {Object} callback	回调方法
    * */
    service_stock.prototype.blockTradeBuy=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361572";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_prop"] = param.entrust_prop;
        paraMap["entrust_bs"] = param.entrust_bs;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_price"] = param.entrust_price;
        paraMap["entrust_amount"] =  param.entrust_amount;
        paraMap["relation_name"] = param.relation_name,
        paraMap["relation_tel"] = param.relation_tel,
        paraMap["prop_seat_no"] = param.prop_seat_no,
        paraMap["cbpconfer_id"] = param.cbpconfer_id,
        paraMap["reduction_type"] = param.reduction_type,
        paraMap["remark"] = param.remark;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 沪深大宗交易-当日可撤单列表查询
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryBlockTrustData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361573";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] = param.stock_account;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 沪深大宗交易-撤单
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} password                	交易密码
     * @param {Object} sessionid                会话号
     * @param {Object} entrust_no               委托编号
     * @param {Object} exchange_type            交易类别
     * @param {Object} batch_flag            	批量撤单标志
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.postBlockCancelOrder=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361574";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] = param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["entrust_no"] = param.entrust_no;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 沪深大宗交易-当日委托
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * */
    service_stock.prototype.queryBlockTodayTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361575";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 沪深大宗交易-当日成交
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBlockTodayTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361576";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 沪深大宗交易-历史委托
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryBlockHistoryTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361577";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["en_entrust_prop"] =  param.en_entrust_prop;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-大宗交易-当日可撤单列表查询
     * @param {Object} entrust_way     委托方式
     * @param {Object} branch_no       分支机构
     * @param {Object} fund_account    资金账号
     * @param {Object} cust_code       客户编号
     * @param {Object} sessionid       会话号
     * */
    service_stock.prototype.queryBJBlockTrustData=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361587";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] = param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] = param.sessionid;
        paraMap["stock_account"] = param.stock_account;
        paraMap["stock_code"] = param.stock_account;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-大宗交易-当日委托
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * */
    service_stock.prototype.queryBJBlockTodayTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361588";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * 北交所-大宗交易-当日成交
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} callback	回调方法
     * */
    service_stock.prototype.queryBJBlockTodayTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361589";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-大宗交易-历史委托
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryBJBlockHistoryTrust=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361590";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["search_type"] =  param.search_type;
        paraMap["en_entrust_prop"] =  param.en_entrust_prop;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 北交所-大宗交易-历史成交
     *
     * @param {Object} entrust_way              委托方式
     * @param {Object} branch_no                分支机构
     * @param {Object} fund_account             资金账号
     * @param {Object} cust_code                客户编号
     * @param {Object} sessionid                会话号
     * @param {Object} begin_time               开始日期
     * @param {Object} end_time                	截止日期
     * */
    service_stock.prototype.queryBJBlockHistoryTrade=function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "361591";
        paraMap["entrust_way"] = param.entrust_way;
        paraMap["branch_no"] =  param.branch_no;
        paraMap["fund_account"] = param.fund_account;
        paraMap["cust_code"] =  param.cust_code;
        paraMap["password"] =  param.password;
        paraMap["sessionid"] =  param.sessionid;
        paraMap["begin_time"] =  param.begin_time;
        paraMap["end_time"] =  param.end_time;
        paraMap["exchange_type"] =  param.exchange_type;
        paraMap["stock_account"] =  param.stock_account;
        paraMap["search_type"] =  param.search_type;
        paraMap["stock_code"] =  param.stock_code;
        paraMap["entrust_bs"] =  param.entrust_bs;
        // 添加 op_station 到接口请求参数中
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.serverPathTrade);
        this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
    };

	/***应用接口......................................................结束*/

});
