/**
 * 普通交易科创板service层调用接口
 */
define('trade/service/scripts/trade/service_stockKcb.js', function(require, exports, module) {
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
	var global = gconfig.global;

	function service_stockKcb() { //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};

	module.exports = new service_stockKcb();

	/**
	 * 释放操作
	 */
	service_stockKcb.prototype.destroy = function() {
		this.service.destroy();
	};
	/********************************公共代码部分********************************/
	service_stockKcb.prototype.commonInvoke = service.commonInvoke;

	/********************************应用接口开始********************************/
	/********************************业务范围--股票********************************/
	/**
	 *  科创板委托下单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} entrust_bs               买卖方向
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票号码
	 * @param {Object} entrust_price            委托价格
	 * @param {Object} entrust_amount           委托数量
	 * @param {Object} batch_no                 委托批号
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.getStockBuy = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301501";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["batch_no"] = param.batch_no;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  科创板盘后委托下单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} entrust_bs               买卖方向
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票号码
	 * @param {Object} entrust_price            委托价格
	 * @param {Object} entrust_amount           委托数量
	 * @param {Object} batch_no                 委托批号
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.getStockPHBuy = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301570";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["batch_no"] = param.batch_no;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 委托撤单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} entrust_no               委托编号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} batch_flag            	批量撤单标志
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.postCancelOrder = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301502";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_no"] = param.entrust_no;
		paraMap["batch_flag"] = param.batch_flag;
		paraMap["exchange_type"] = param.exchange_type;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 持仓查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票号码
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.queryStockData = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301503";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = ""; //param.stock_account
		paraMap["stock_code"] = param.stock_code;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["query_flag"] = param.query_flag;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 资金查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 * @param {Object} isLastReq	是否是最后一个请求，默认是true	
	 * */
	service_stockKcb.prototype.queryFundSelect = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301504";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["appoint_fund_account"] = param.asset_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["flag"] = param.flag;
		paraMap["query_flag"] = param.query_flag;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 资金流水查询
	 *  
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} business_flag            业务类型
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.queryAccountFlow = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301505";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["money_type"] = param.money_type;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
		paraMap["business_flag"] = param.business_flag;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 行情查询
	 * 
	 * @param {Object} exchange_type             交易类型
	 * @param {Object} stock_code                股票号码
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.queryStockhqInfo = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301506";
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_code"] = param.stock_code;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当日委托查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stockKcb.prototype.queryTodayTrust = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301508";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当日成交查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_stockKcb.prototype.queryTodayTrade = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301509";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 历史委托查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * */
	service_stockKcb.prototype.queryHistoryTrust = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301510";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 历史成交查询
	 * 
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.queryHistoryTrade = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301511";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_bs"] = param.entrust_bs;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 查询股东列表
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} session_id       会话号
	 * */
	service_stockKcb.prototype.queryStockAccountList = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301512";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 机构信息查询
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} query_branch_no 查询机构入参
	 * */
	service_stockKcb.prototype.queryBranchInfo = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301513";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["query_branch_no"] = param.query_branch_no;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 股票信息联动
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} session_id       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_stockKcb.prototype.queryStockMaxBuy = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301514";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["newstock_flag"] = param.newstock_flag;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_accounts"] = param.stock_accounts;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_type"] = param.stock_type;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 查询当日可撤委托
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} session_id       会话号
	 * */
	service_stockKcb.prototype.queryTrustData = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301515";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	//**********新股*************************************
	/**
	 * 新股票配号查询		
	 * @param {Object} cust_code              客户编号	
	 * @param {Object} fund_account           资金账号
	 * @param {Object} xjb_account            现金宝账户
	 * @param {Object} star_page              起始页码
	 * @param {Object} page_count             每页数量
	 * */
	service_stockKcb.prototype.queryDistributionData = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "303029";
		} else {
			paraMap["funcNo"] = "301517";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 新股中签查询		
	 * @param {Object} cust_code              客户编号	
	 * @param {Object} fund_account           资金账号
	 * @param {Object} xjb_account            现金宝账户
	 * @param {Object} star_page              起始页码
	 * @param {Object} page_count             每页数量
	 * */
	service_stockKcb.prototype.querySuccessData = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "303030";
		} else {
			paraMap["funcNo"] = "301518";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stock_code"] = param.stock_code;
		paraMap["begin_date"] = param.begin_time;
		paraMap["end_date"] = param.end_time;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 新股申购额度查询
	 * @param entrust_way	varchar(1)	委托方式（见数据字典)
	 * @param branch_no	varchar(10)	分支机构
	 * @param fund_account	varchar(20)	资金账号
	 * @param cust_code	varchar(32)	客户编号
	 * @param password	varchar(32)	交易密码
	 * @param op_station	varchar(50)	操作站点（见数据字典)
	 * @param session_id	varchar(32)	会话号
	 * @param exchange_type	varchar(1)	交易市场类别（见数据字典)
	 * @param callback 回调函数
	 * */
	service_stockKcb.prototype.newAmount_Query = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "303028";
		} else {
			paraMap["funcNo"] = "301519";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["exchange_type"] = param.exchange_type;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 查询对账单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.queryStatementOfAccount = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301520";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["money_type"] = param.money_type;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 修改成本价
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.amendCostPrice = function(param, callback, ctrlParam) {
		var paraMap = {};
  	    paraMap["funcNo"] = "301548";
  	    paraMap["entrust_way"] =  param.entrust_way;
  	    paraMap["branch_no"] =  param.branch_no;
  	    paraMap["fund_account"] =  param.fund_account;//资金账号
  	    paraMap["cust_code"] =  param.cust_code;//客户号
  	    paraMap["stock_account"] =  param.stock_account;//股东代码
  	    paraMap["exchange_type"] =  param.exchange_type;//市场
  	    paraMap["stock_code"] =  param.stock_code;//股票代码
  	    paraMap["cost_price"] =  param.cost_price;//成本价
        paraMap["password"] =  param.password;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 查询新股数
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.queryListingShares = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "303535";
		} else {
			paraMap["funcNo"] = "301535";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["money_type"] = param.money_type;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_code"] = param.stock_code;
		paraMap["issue_date"] = param.issue_date;
		paraMap["flag"] = param.flag || "1";

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当前中签查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.theCurrentSuccess = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "301536";
		} else {
			paraMap["funcNo"] = "301536";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["stock_account"] = param.stock_account;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 当前中签查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.oneKeyPurchase = function(param, callback, ctrlParam) {
		var paraMap = {};
		if(param.account_type == "1") { //恒生
			paraMap["funcNo"] = "303052";
		} else {
			paraMap["funcNo"] = "301539";
		}

		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["entrustcodes"] = param.entrustcodes;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 交割单
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} begin_time               开始日期
	 * @param {Object} end_time                	截止日期
	 * @param {Object} callback	回调方法
	 */
	service_stockKcb.prototype.orderDelivery = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "303047";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;

		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
	 * 查询可取金额
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} bank_code				银行代码
	 * @param {Object} money_type               币种
	 * @param {Object} bank_password			银行密码
	 * */
	service_stockKcb.prototype.queryDesirableAmount = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "300205";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["appoint_fund_account"] = param.asset_account;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["money_type"] = param.money_type;
		paraMap["query_flag"] = param.query_flag;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 存托凭证协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stockKcb.prototype.signCDRrights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301558";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["remark"] = param.remark;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stockKcb.prototype.signInnovateRights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301559";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["remark"] = param.remark;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 存托凭证、创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stockKcb.prototype.signCDRInnovateRights = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301560";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["accounts_list"] = param.accounts_list;
		paraMap["remark"] = param.remark;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 存托凭证、创新企业股票协议签署
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_stockKcb.prototype.queryCDRProtocol = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301561";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["query_type"] = param.query_type;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/***应用接口......................................................结束*/

});