/**
 * 股转系统交易service层调用接口
 */
define('trade/service/scripts/trade/service_third.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
	
	function service_third(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	
	module.exports = new service_third();
    
    /**
	 * 释放操作
	 */
	service_third.prototype.destroy = function(){
		this.service.destroy();
	};
	/********************************公共代码部分********************************/
	service_third.prototype.commonInvoke = service.commonInvoke;

    /********************************业务范围--股转系统********************************/

   //查询当日委托的
   /**
    * @param {Object} entrust_way              委托方式
  	* @param {Object} branch_no                分支机构
  	* @param {Object} fund_account             资金账号
  	* @param {Object} cust_code                客户编号
  	* @param {Object} session_id                会话号
    */
   
   service_third.prototype.querythirdTodayEntrust=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "301706";
  	    paraMap["entrust_way"] =  param.entrust_way;
  	    paraMap["branch_no"] =  param.branch_no;
  	    paraMap["fund_account"] =  param.fund_account;
  	    paraMap["cust_code"] =  param.cust_code;
  	    paraMap["session_id"] =  param.session_id;
  	    paraMap["request_num"] =  param.request_num;
	    paraMap["position_str"] =  param.position_str;
  	   
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};

	//今日成交
	service_third.prototype.queryTodayTrade=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301708";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["session_id"] =  param.session_id;
		paraMap["exchange_type"] =  param.exchange_type;
		paraMap["stock_account"] =  param.stock_account;
		paraMap["stock_code"] =  param.stock_code;
		paraMap["entrust_bs"] =  param.entrust_bs;
  	    paraMap["request_num"] =  param.request_num;
	    paraMap["position_str"] =  param.position_str;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};

	service_third.prototype.queryHistoryTrade=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "301709";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["session_id"] =  param.session_id;
		paraMap["exchange_type"] =  param.exchange_type;
		paraMap["stock_account"] =  param.stock_account;
		paraMap["stock_code"] =  param.stock_code;
		paraMap["entrust_bs"] =  param.entrust_bs;
		paraMap["begin_time"]=param.begin_time;
		paraMap["end_time"]=param.end_time;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};


	
  	/**
  	 * 股票信息联动
  	 * @param {Object} entrust_way     委托方式
  	 * @param {Object} branch_no       分支机构
  	 * @param {Object} fund_account    资金账号
  	 * @param {Object} cust_code       客户编号
  	 * @param {Object} session_id       会话号
  	 * @param {Object} entrust_bs      买卖方向
  	 * @param {Object} exchange_type   交易市场类别
  	 * @param {Object} stock_code      股票代码
  	 * @param {Object} entrust_price   委托价格
  	 * */
  	service_third.prototype.querythirdMaxBuy=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "301700";
  	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] = param.branch_no;
       	paraMap["fund_account"] = param.fund_account;	
  	    paraMap["cust_code"] = param.cust_code;
        paraMap["password"] =  param.password;
  	    paraMap["session_id"] = param.session_id;
  	    paraMap["entrust_bs"] = param.entrust_bs;
  	    paraMap["stock_code"] = param.stock_code;
  	    paraMap["entrust_price"] = param.entrust_price;
  	    paraMap["newstock_flag"] = param.newstock_flag;
  	    paraMap["stock_account"] =  param.stock_account;
  	    paraMap["stock_accounts"] = param.stock_accounts;
  	    paraMap["exchange_type"] = param.exchange_type;
  	    paraMap["entrust_prop"] = param.entrust_prop;
  	    paraMap["bjs_flag"] = param.bjs_flag;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
	 *  委托
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} password                	交易密码
  	 * @param {Object} session_id                会话号
   	 * @param {Object} entrust_bs               买卖方向
  	 * @param {Object} exchange_type            交易类别
   	 * @param {Object} stock_account            证券账号
  	 * @param {Object} stock_code               股票号码
   	 * @param {Object} entrust_price            委托价格
  	 * @param {Object} entrust_amount           委托数量
     * @param {Object} batch_no                 委托批号
     * @param {Object} confer_no                双方约定号
	 * @param {Object} oppo_seatno              双方席位
	 * @param {Object} oppo_stkaccount          双方股东账号
	 * @param {Object} entrust_prop             委托属性
	 * @param {Object} callback	回调方法
	 * */
  	service_third.prototype.getthirdBuy=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "301701";
	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] = param.password;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["entrust_bs"] = param.entrust_bs;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_account"] = param.stock_account;
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["entrust_price"] = param.entrust_price;
	    paraMap["entrust_amount"] =  param.entrust_amount;
	    paraMap["confer_no"] = param.confer_no;
		paraMap["oppo_seatno"] = param.oppo_seatno;
		paraMap["oppo_stkaccount"] = param.oppo_stkaccount;
		paraMap["entrust_prop"] = param.entrust_prop;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
  	 * 持仓查询
  	 *
  	 */
	service_third.prototype.querythirdData=function(param,callback,ctrlParam){
  		var paraMap = {};
  		paraMap["funcNo"] = "301702";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["password"] =  param.password;
	    paraMap["stock_account"] = param.stock_account;  
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["position_str"] = param.position_str;
 		paraMap["request_num"] = param.request_num;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["money_type"] = param.money_type;
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
  	/**
  	 * 意向单查询
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * */
  	service_third.prototype.queryConfirmOrder=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "301703";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] =  param.password;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["bsflag"] = param.bsflag;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
  	
	/**
     * 可撤委托查询
	     * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} exchange_type            交易市场类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               证券代码
	 * @param {Object} entrust_bs               委托标志
	 * */
	service_third.prototype.queryTrustsCance=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "301704";
	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] =  param.branch_no;
  	    paraMap["fund_account"] = param.fund_account;
  	    paraMap["cust_code"] =  param.cust_code;
  	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] = param.password;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_account"] = param.stock_account;
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["entrust_bs"] = param.entrust_bs;
	    paraMap["request_num"] =  param.request_num;
	    paraMap["position_str"] = param.position_str;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
  		reqParamVo.setUrl( global.serverPathTrade);
  		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 新三板委托撤单
	     * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
 	 * @param {Object} entrust_no               委托编号
	 * @param {Object} exchange_type            交易类别
 	 * @param {Object} batch_flag            	批量撤单标志
	 * @param {Object} callback	回调方法
	 * */
	service_third.prototype.postCancelOrder=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "301705";
	    paraMap["entrust_way"] = param.entrust_way;
  	    paraMap["branch_no"] =  param.branch_no;
  	    paraMap["fund_account"] = param.fund_account;
  	    paraMap["cust_code"] =  param.cust_code;
  	    paraMap["password"] = param.password;
  	    paraMap["session_id"] =  param.session_id;
  	    paraMap["entrust_no"] = param.entrust_no;
  	    paraMap["exchange_type"] =  param.exchange_type;
  	     // 添加 op_station 到接口请求参数中
  	    var reqParamVo = this.service.reqParamVo;
  		reqParamVo.setUrl( global.serverPathTrade);
  		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
      	 * 资金查询
      	 * 
    	 * @param {Object} entrust_way              委托方式
      	 * @param {Object} branch_no                分支机构
      	 * @param {Object} fund_account             资金账号
      	 * @param {Object} cust_code                客户编号
      	 * @param {Object} session_id                会话号
      	 * @param {Object} callback	回调方法
      	 * @param {Object} isLastReq	是否是最后一个请求，默认是true	
      	 * */
         service_third.prototype.queryFundSelect=function(param,callback,ctrlParam){
      		var paraMap = {};
      	    paraMap["funcNo"] = "301707";
      	    paraMap["entrust_way"] =  param.entrust_way;
      	    paraMap["branch_no"] =  param.branch_no;
      	    paraMap["fund_account"] =  param.fund_account;
      	    paraMap["appoint_fund_account"] =  param.asset_account;
      	    paraMap["cust_code"] =  param.cust_code;
      	    paraMap["password"] =  param.password;
      	    paraMap["session_id"] =  param.session_id;
      	    paraMap["money_type"] =  param.money_type;
      	    paraMap["is_homepage"] =  param.is_homepage;
      	    paraMap["income_balance"] = param.is_homepage;
      	    paraMap["flag"] = param.flag;
      	     // 添加 op_station 到接口请求参数中
    		var reqParamVo = this.service.reqParamVo;
    		reqParamVo.setUrl(global.serverPathTrade);
    		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
      	};

	/**
	 * 查询可取金额
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} bank_code				银行代码
	 * @param {Object} money_type               币种
	 * @param {Object} bank_password			银行密码
	 * */
	service_third.prototype.queryDesirableAmount = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "300205";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["appoint_fund_account"] = param.asset_account;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["money_type"] = param.money_type;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 股转权限查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * @param {Object} bank_code				银行代码
	 * @param {Object} money_type               币种
	 * @param {Object} bank_password			银行密码
	 * */
	service_third.prototype.permissionCheck = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "301713";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	
	/**
	 * 查询股转要约收购列表（股转预售要约信息查询）
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_third.prototype.queryYysgList = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "310715";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["purchase_id"] = param.purchase_id;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 股转要约收购申报/解除
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_third.prototype.yysgOrder = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "310716";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_code"] = param.stock_code;
		paraMap["stock_account"] = param.stock_account;
		paraMap["stb_stock_property"] = param.stb_stock_property;
		paraMap["entrust_amount"] = param.entrust_amount;
		paraMap["entrust_bs"] = param.entrust_bs;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//要约收购最大数查询
	service_third.prototype.queryYysgMaxBuy=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310719";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["session_id"] =  param.session_id;
		paraMap["exchange_type"] =  param.exchange_type;
		paraMap["stock_code"] =  param.stock_code;
		paraMap["entrust_bs"] =  param.entrust_bs;
	    paraMap["stb_stock_property"] =  param.stb_stock_property;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-近日询价查询
	service_third.prototype.queryRecentEnquiry=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310720";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-今日申购查询
	service_third.prototype.queryTodayPurchase=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310721";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		paraMap["is_login"] =  param.is_login;//今日申购 is_login  0表示非登陆，，1表示登陆
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-我的申报查询
	service_third.prototype.queryMyDeclare=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310722";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-询价确认查询
	service_third.prototype.queryEnquiryConfirm=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310723";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-历史申报查询
	service_third.prototype.queryHistoryDeclare=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310724";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		paraMap["begin_date"] =  param.begin_date;
		paraMap["end_date"] =  param.end_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//公开发行-历史确认查询
	service_third.prototype.queryHistoryConfirm=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310725";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		paraMap["begin_date"] =  param.begin_date;
		paraMap["end_date"] =  param.end_date;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//适当性类别查询
	service_third.prototype.queryAppropriateness=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310726";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	//受限明细查询
	service_third.prototype.queryRestricted=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310727";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 股份转让-询价申购委托
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_third.prototype.enquiry=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310738";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["password"] =  param.password;
		paraMap["batch_flag"] =  param.batch_flag;
		paraMap["batch_data"] =  param.batch_data;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 * 证券基础信息查询接口
	 * @param {Object} entrust_way     委托方式
	 * @param {Object} branch_no       分支机构
	 * @param {Object} fund_account    资金账号
	 * @param {Object} cust_code       客户编号
	 * @param {Object} session_id       会话号
	 * @param {Object} entrust_bs      买卖方向
	 * @param {Object} exchange_type   交易市场类别
	 * @param {Object} stock_code      股票代码
	 * @param {Object} entrust_price   委托价格
	 * */
	service_third.prototype.querythirdNewMaxBuy=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "310700";
	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] = param.branch_no;
	   	paraMap["fund_account"] = param.fund_account;	
	    paraMap["cust_code"] = param.cust_code;
	    paraMap["password"] =  param.password;
	    paraMap["session_id"] = param.session_id;
	    paraMap["entrust_bs"] = param.entrust_bs;
	    paraMap["stock_code"] = param.stock_code;
	    paraMap["entrust_price"] = param.entrust_price;
	    paraMap["exchange_type"] = param.exchange_type;
  	    paraMap["sysnode_id"] = param.sysnode_id;//系统节点编号
	     // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  最大可买查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_third.prototype.queryThirdMaxAmountBuy=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "310732";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_type"] = param.stock_type;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  最大可卖出查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_third.prototype.queryThirdMaxAmountSell=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "310733";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["entrust_bs"] = param.entrust_bs;
		paraMap["stock_code"] = param.stock_code;
		paraMap["entrust_price"] = param.entrust_price;
		paraMap["stock_account"] = param.stock_account;
		paraMap["exchange_type"] = param.exchange_type;
		paraMap["stock_type"] = param.stock_type;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 *  交割单查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} callback	回调方法
	 * */
	service_third.prototype.queryDeliveryOrder=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "310735";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_code"] = param.cust_code;
		paraMap["password"] = param.password;
		paraMap["session_id"] = param.session_id;
		paraMap["begin_date"] = param.begin_date;
		paraMap["end_date"] = param.end_date;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 股份转让-今日申购委托
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_third.prototype.purchase=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310737";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["password"] =  param.password;
		paraMap["batch_flag"] =  param.batch_flag;
		paraMap["batch_data"] =  param.batch_data;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/**
	 *  委托
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} password                	交易密码
	 * @param {Object} session_id                会话号
	 * @param {Object} entrust_bs               买卖方向
	 * @param {Object} exchange_type            交易类别
	 * @param {Object} stock_account            证券账号
	 * @param {Object} stock_code               股票号码
	 * @param {Object} entrust_price            委托价格
	 * @param {Object} entrust_amount           委托数量
	 * @param {Object} batch_no                 委托批号
	 * @param {Object} confer_no                双方约定号
	 * @param {Object} oppo_seatno              双方席位
	 * @param {Object} oppo_stkaccount          双方股东账号
	 * @param {Object} entrust_prop             委托属性
	 * @param {Object} callback	回调方法
	 * */
	service_third.prototype.getthirdNewBuy=function(param,callback,ctrlParam){
		var paraMap = {};
	    paraMap["funcNo"] = "310701";
	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] = param.password;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["entrust_bs"] = param.entrust_bs;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_account"] = param.stock_account;
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["entrust_price"] = param.entrust_price;
	    paraMap["entrust_amount"] =  param.entrust_amount;
	    // paraMap["confer_no"] = param.confer_no;
		// paraMap["oppo_seatno"] = param.oppo_seatno;
		// paraMap["oppo_stkaccount"] = param.oppo_stkaccount;
		// paraMap["entrust_prop"] = param.entrust_prop;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
  	/**
  	 * 盘后协议当日委托查询
  	 * 
	 * @param {Object} entrust_way              委托方式
  	 * @param {Object} branch_no                分支机构
  	 * @param {Object} fund_account             资金账号
  	 * @param {Object} cust_code                客户编号
  	 * @param {Object} session_id                会话号
  	 * */
  	service_third.prototype.queryConfirmEntrust=function(param,callback,ctrlParam){
  		var paraMap = {};
  	    paraMap["funcNo"] = "310730";
  	    paraMap["entrust_way"] = param.entrust_way;
	    paraMap["branch_no"] =  param.branch_no;
	    paraMap["fund_account"] = param.fund_account;
	    paraMap["cust_code"] =  param.cust_code;
	    paraMap["password"] =  param.password;
	    paraMap["session_id"] =  param.session_id;
	    paraMap["exchange_type"] =  param.exchange_type;
	    paraMap["stock_code"] =  param.stock_code;
	    paraMap["bsflag"] = param.bsflag;
	    paraMap["bjs_flag"] = param.bjs_flag;
	    // 添加 op_station 到接口请求参数中
	    var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
  	};
	
	/**
	 * 询价确认提醒查询
	 * @param {Object} entrust_way              委托方式
	 * @param {Object} branch_no                分支机构
	 * @param {Object} fund_account             资金账号
	 * @param {Object} cust_code                客户编号
	 * @param {Object} session_id                会话号
	 * */
	service_third.prototype.inquiryRemind = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "310731";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] = param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["cust_name"] = param.cust_name;//客户名称
		paraMap["cust_code"] = param.cust_code;
		paraMap["session_id"] = param.session_id;
		paraMap["password"] = param.password;
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 股份转让-股东账号查询
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_third.prototype.queryThirdStockAccount=function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "310714";
		paraMap["entrust_way"] = param.entrust_way;
		paraMap["branch_no"] =  param.branch_no;
		paraMap["fund_account"] = param.fund_account;
		paraMap["session_id"] =  param.session_id;
		paraMap["cust_code"] =  param.cust_code;
		paraMap["cust_name"] =  param.cust_name;
		paraMap["password"] =  param.password;
		 // 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.serverPathTrade);
		this.commonInvoke(paraMap, callback, ctrlParam, reqParamVo);
	};
	/***应用接口......................................................结束*/

});
