/**
 * 普通交易service层调用接口
 */
define('trade/service/scripts/trade/service_xkj.js', function (require, exports, module) {
  var service = require("service");
  var gconfig = $.config;
  var global = gconfig.global;
  /********************************公共代码部分********************************/
  service_xkj.prototype.commonInvokeXKJ = service.commonInvokeXKJ;

  service_xkj.prototype.destroy = function () {
    this.service.destroy();
  };

  function service_xkj() { //对应的接口方法需要在这里暴露出来
    this.service = new $.service;
  };
  module.exports = new service_xkj();

  /********************************应用接口开始********************************/


  /********************************业务范围--账户********************************/

  /**
   * @description 新股基本信息日历查询   
   * @author cfx   
   * @date 2021-07-13 16:00:50   
   * @modifyContent 修改点描述...   
   */
  service_xkj.prototype.require1001004 = function (param, callback, ctrlParam) {
    var paraMap = {};
    paraMap["funcNo"] = 9000000;
    paraMap["system_id"] = "1";
    paraMap["trade_code"] = "1001004";
    paraMap["market"] = param.market;
    paraMap["flag"] = param.flag;//	筛选标志  0:查询全部,1:今日中签,2:今日上市,3:未上市,4:即将发行,5:今日申购；6新股申购，7.已上市
    var reqParamVo = this.service.reqParamVo;
    reqParamVo.setUrl(global.xkjUrl);
    this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };
  /**
   * @description 新债基本信息日历查询   
   * @author cfx   
   * @date 2021-07-13 16:00:50   
   * @modifyContent 修改点描述...   
   */
  service_xkj.prototype.require1001005 = function (param, callback, ctrlParam) {
    var paraMap = {};
    paraMap["funcNo"] = 9000000;
    paraMap["system_id"] = "1";
    paraMap["trade_code"] = "1001005";
    paraMap["flag"] = param.flag;//	筛选标志  0:查询全部,1:今日中签,2:今日上市,3:未上市,4:即将发行,5:今日申购；6新股申购，7.已上市
    var reqParamVo = this.service.reqParamVo;
    reqParamVo.setUrl(global.xkjUrl);
    this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };
  service_xkj.prototype.getNewStockInfoNew = function (param, callback, ctrlParam) {
    var paraMap = {};
    paraMap["funcNo"] = 9000000;
    paraMap["system_id"] = "1";
    paraMap["trade_code"] = param.trade_code;
    paraMap["stockCode"] = param.stockCode;
    paraMap["bondCode"] = param.bondCode;
    paraMap["sgdm"] = param.sgdm;
    paraMap["market"] = param.market;
    paraMap["subcribeCode"] = param.subcribeCode;
    paraMap["catalogid"] = param.catalogid;
    var reqParamVo = this.service.reqParamVo;
    reqParamVo.setUrl(global.xkjUrl);
    this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };
  /**
   * @description 新债日历列表（新）   
   * @author cfx   
   * @date 2021-07-13 16:00:50   
   * @modifyContent 修改点描述...   
   */
  service_xkj.prototype.require1001009 = function (param, callback, ctrlParam) {
    var paraMap = {};
    paraMap["funcNo"] = 9000000;
    paraMap["system_id"] = "1";
    paraMap["trade_code"] = "1001009";
    paraMap["sort"] = param.sort;//	默认为升序，0为升序，1为降序（按照字段pubdate排序）   
    var reqParamVo = this.service.reqParamVo;
    reqParamVo.setUrl(global.xkjUrl);
    this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };
  /**
   * @description 新股日历列表（新）  
   * @author cfx   
   * @date 2021-07-13 16:00:50   
   * @modifyContent 修改点描述...   
   */
  service_xkj.prototype.require1001010 = function (param, callback, ctrlParam) {
    var paraMap = {};
    paraMap["funcNo"] = 9000000;
    paraMap["system_id"] = "1";
    paraMap["trade_code"] = "1001010";
    paraMap["sort"] = param.sort;//	默认为升序，0为升序，1为降序（按照字段pubdate排序）   
    var reqParamVo = this.service.reqParamVo;
    reqParamVo.setUrl(global.xkjUrl);
    this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };

    /**
     * @description 根据债券代码查询正股信息
     * @author lbx
     * @date 2021-11-22 13:57:50   
     * @modifyContent 修改点描述...   
     */
    service_xkj.prototype.require2001011 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001011";
        paraMap["sort"] = param.sort; //	默认为升序，0为升序，1为降序（按照字段pubdate排序）   
        // 债券代码
        paraMap["bond_code"] = param.bond_code;
        paraMap["market"] = param.market;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
    
	/**
    * 理财接口-基金详情
    */
     service_xkj.prototype.getFundBaseInfo = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "3";
        paraMap["trade_code"] = "3001004";
        paraMap["productId"] = param.productId;
        paraMap["productCode"] = param.productCode;
        paraMap["finaBelongs"] = param.finaBelongs || '15';
        paraMap["registerCorpCode"] = param.registerCorpCode;
        paraMap["subscribeCode"] = param.subscribeCode;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
    
    /**
     * @description 查询pdf链接
     * @author lbx
     * @date 2021-11-22 13:57:50   
     * @modifyContent 修改点描述...   
     */
     service_xkj.prototype.require2001029 = function (param, callback, ctrlParam) {
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001029";
        paraMap["file_key"] = param.file_key; 
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };

    /**
     * @description 获取开户断点数据
     * @author lbx
     * @date 2022-11-22 13:57:50   
     * @modifyContent 修改点描述...   
     */
     service_xkj.prototype.require4001103 = function (param, callback, ctrlParam) {
      var paraMap = {};
      paraMap["funcNo"] = 9000000;
      paraMap["system_id"] = "4";
      paraMap["trade_code"] = "4001103";
      paraMap["mobile_no"] = param.mobile_no      ; 
      var reqParamVo = this.service.reqParamVo;
      reqParamVo.setUrl(global.xkjUrl);
      this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
  };
	/**
    * 理财接口-持营ETF基金折线图查询
    */
     service_xkj.prototype.require3001038 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "3";
        paraMap["trade_code"] = "3001038";
        paraMap["queryType"] = param.queryType;
        paraMap["productCode"] = param.productCode;
        paraMap["exchangeType"] = param.exchangeType;
        paraMap["etfcodeType"] = param.etfcodeType;
        paraMap["timeType"] = param.timeType;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 理财接口-基金实时估值接口
    */
     service_xkj.prototype.require3001039 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "3";
        paraMap["trade_code"] = "3001039";
        paraMap["productCode"] = param.productCode;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 查询用户是否签署自定义协议
    */
     service_xkj.prototype.require2001033 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001033";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 查询协议详情信息
    */
     service_xkj.prototype.require2001034 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001034";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 查询详情信息
    */
     service_xkj.prototype.queryStockDetail = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 自定义协议留痕
    */
     service_xkj.prototype.require2001035 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001035";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * 新发ETF数量查询 
    */
     service_xkj.prototype.require3001044 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "3";
        paraMap["trade_code"] = "3001044";
        paraMap["subscribeStatus"] = param.subscribeStatus;
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
	/**
    * app公告查询
    */
     service_xkj.prototype.require2001041 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001041";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
  	/**
    * 条件单数据统计
    */
    service_xkj.prototype.require1001014 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "1";
        paraMap["trade_code"] = "1001014";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 条件单数据统计
     */
    service_xkj.prototype.require2001045 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "2";
        paraMap["trade_code"] = "2001045";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
     * 上海减持控制信息查询
     */
    service_xkj.prototype.require1001018 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "1";
        paraMap["trade_code"] = "1001018";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
    /**
    * 深圳减持控制信息查询
    */
    service_xkj.prototype.require1001019 = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = 9000000;
        paraMap["system_id"] = "1";
        paraMap["trade_code"] = "1001019";
        paraMap = $.extend(paraMap,param);
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.xkjUrl);
        this.commonInvokeXKJ(paraMap, callback, ctrlParam, reqParamVo);
    };
/***应用接口......................................................结束*/
});
