/**
 * 普通交易service层调用接口
 */
define('trade/service/scripts/trade/service_zhyw.js',function(require,exports,module){
	var service = require("service");
	var gconfig = $.config;
	var global = gconfig.global;
	var serverConfig = global.serverConfig; // 柜台选择   1. 金证win  2. 恒生T2   3. 顶点 （可拓展）
	var phoneActive = global.phoneActive; //服务器URL

	/********************************公共代码部分********************************/
	service_zhyw.prototype.commonInvokeZHYW = service.commonInvokeZHYW;
	
	service_zhyw.prototype.destroy = function(){
		this.service.destroy();
	};
	
	function service_zhyw(){ //对应的接口方法需要在这里暴露出来
		this.service = new $.service;
	};
	module.exports = new service_zhyw();

	/********************************应用接口开始********************************/


	/********************************业务范围--账户********************************/

	/**
    * 查询两融权限提示语
    */
	service_zhyw.prototype.queryPermissionPrompt = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "1108016";
		paraMap["product_id"] = param.product_id;//	产品ID
		paraMap["soft_no"] = param.soft_no;//	所属应用
		paraMap["version_code"] = param.version_code;//	App内部版本号
		paraMap["channel"] = param.channel;//	渠道（见数据字典），区分发起请求的前端设备。
		paraMap["group_no"] = param.group_no;//	广告组标识
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
    * 查询期权权限提示语
    */
	service_zhyw.prototype.queryOptionPermissionPrompt = function(param,callback,ctrlParam){
		var paraMap = {};
		paraMap["funcNo"] = "1108017";
		paraMap["soft_no"] = param.soft_no;//	所属应用
		paraMap["version_code"] = param.version_code;//	App内部版本号
		paraMap["channel"] = param.channel;//	渠道（见数据字典），区分发起请求的前端设备。
		paraMap["problem_column_no"] = param.problem_column_no;//	问题栏目标识
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};
	
	/**
	 * 找回账号
	 * @param {Object} param
	 * @param {Object} callback
	 * @param {Object} ctrlParam
	 */
	service_zhyw.prototype.accountSubmit = function(param, callback, ctrlParam) {
		var paraMap = {};
		paraMap["funcNo"] = "3336";
		paraMap["client_name"] = param.client_name;//姓名
		paraMap["id_kind"] = param.id_kind;//证件类别
		paraMap["id_no"] = param.id_no;//证件号码
		paraMap["isTYZH"] = true;//是否是统一账户
		// 添加 op_station 到接口请求参数中
		var reqParamVo = this.service.reqParamVo;
		reqParamVo.setUrl(global.unifyUrl);
		this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
	};

	/**
    * 获取广告图片信息
    */
   service_zhyw.prototype.getAdPicData = function(param,callback,ctrlParam){
        var paraMap = {};
        paraMap["funcNo"] = "1108003";
        paraMap["channel"] = param.channel;//	渠道（见数据字典），区分发起请求的前端设备。
        paraMap["group_no"] = param.group_no; //广告组标识，要查询哪个组下的广告，多个用“|”分隔
        paraMap["ad_version_code"] = param.ad_version_code;//	App内部版本号
        var reqParamVo = this.service.reqParamVo;
        reqParamVo.setUrl(global.unifyUrl);
        this.commonInvokeZHYW(paraMap, callback, ctrlParam, reqParamVo);
    };
	/***应用接口......................................................结束*/
});
