/**
 * 这里写模块内部的消息处理函数，供原生回调H5
 */
define("trade/shellFunction/msgFunction.js", function (require, exports, module) {
    var gconfig = $.config;
    var global = gconfig.global;
    var oMyMsgFunction = {}; // 暴露给外部的对象
    var oMyMsgFunction = $.msgFunction; // 暴露给外部的对象
    var common = require('common');
    var commonFunc = require('commonFunc');
    var tradeSsoLogin = require('tradeSsoLogin');
    var backBtnMarkTime = 0;
    /**
     * 公用
     * 弹出通讯录，用于选择联系人的信息，选择完毕后回调H5
     * 说明：通讯录插件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
     * @param funcNo 50223
     * @param name String 名称 Y
     * @param phone String 手机号码 Y
     */
    oMyMsgFunction.function50223 = function (paramMap) {
        var selPhoneCallback = window.selPhoneCallback; // 选择电话联系人的回调函数
        if (selPhoneCallback) {
            selPhoneCallback(paramMap);
        }
    }

    /**
     * 公用
     * 日期控件回调H5
     * 说明：日期控件的调用必须要写在页面UI的事件处理函数中，否则多模块开发原生无法获取到当前激活的模块从而导致无法回调H5
     * @param funcNo 50251
     * @param date String 日期 Y
     * @param selector String H5的元素选择器 N
     */
    oMyMsgFunction.function50251 = function (paramMap) {
        paramMap = paramMap || {};
        var selDateCallback = window.selDateCallback; // 选择日期的回调函数
        if (selDateCallback) {
            selDateCallback(paramMap);
        }
    }

    /**
     * 公用
     * 设置系统软件的主题风格
     * @param funcNo 50104
     * @param theme String 主题颜色(见数据字典) Y 0：红色，1：蓝色，2：黑色，3：黄色，9：绿色
     */
    oMyMsgFunction.function50104 = function (paramMap) {
        if (paramMap) {
//			var $appCss = $("head>link[href*='" + gconfig.firstLoadCss[0] + "']");
//			var skinMap = {0: "red", 1: "blue", 2: "black", 3: "yellow", 9: "green"};
//			var href = gconfig.cssPath + "style_" + skinMap[paramMap.theme] + ".css";
//			gconfig.firstLoadCss[0] = href; // 修改当前皮肤对应的 css
//			$appCss.attr("href", href);
//			var originalOverflow = $("body").css("overflow");
//			$("body").css("overflow", "auto"); // 强制浏览器重绘
//			$("body").css("overflow", originalOverflow);
        }
    }

    /**
     * 公用
     * 原生的信息提示框回调H5
     * @param funcNo 50111
     * @param flag    String    业务标志    N
     */
    oMyMsgFunction.function50111 = function (paramMap) {
        if (paramMap) {
            $.alert(paramMap.flag);
        }
    }

    /**
     * 公用
     * 通知H5分享后的状态
     * @param funcNo 50232
     * @param shareType    String    分享平台（数据字典）    Y
     * @param flag    String    分享状态（0：失败，1：成功)    Y
     * @param info    String    备注信息    N
     */
    oMyMsgFunction.function50232 = function (paramMap) {
        if (paramMap) {
            $.alert("通知H5分享后的状态50232" + JSON.stringify(paramMap));
        }
    }

    /**
     * 公用
     * 验证手势密码中忘记密码，修改账号回调H5
     * @param funcNo 50262
     * @param type    String    类型(0：忘记密码，1：修改账号）    N
     */
    oMyMsgFunction.function50262 = function (paramMap) {
        if (paramMap) {
            $.alert("验证手势密码中忘记密码，修改账号回调H550262" + JSON.stringify(paramMap));
        }
    }

    /**
     * 公用
     * 扫描图片二维码的内容回调给H5页面
     * @param funcNo 50272
     * @param content    String    内容    Y
     */
    oMyMsgFunction.function50272 = function (paramMap) {
        if (paramMap) {
            $.alert("扫描图片二维码的内容回调给H5页面	50272" + JSON.stringify(paramMap));
        }
    }
    
    /**
     * H5调用原生获取获取登录用户未读数回调H5
     * @param funcNo 70016
     * @param content    String    内容    Y
     */
     oMyMsgFunction.function70016 = function (paramMap) {
        msgNumCallBack(paramMap)
    }

    /**
     * 行情跳转买卖
     * @param funcNo 50272
     * @param content    String    内容    Y
     */
    oMyMsgFunction.function60250 = function (paramMap) {
//		console.log("function60250");
        try {
            paramMap.isFromApp = "";//因为安卓和ios不支持，他们不是新开的一个webview，是直接切换的页面
            var type = paramMap.type;//买卖类型
            var param = paramMap;
            var chaIsKCB = param.chaIsKCB;
            var chaHQTradeStatus = param.chaHQTradeStatus;
            param.source = "appHq";
            param.market = paramMap.market || paramMap.stockMarket;
            param.code = paramMap.code || paramMap.stockCode;
            var userInfo = null, isTradeLogin = null;
            if (!param.param) {
                param.param = {};
            }
            //判断是否登入普通
            var judgeLogin = function (login_type) {
                common.switchingCurUser(login_type);
                isTradeLogin = common.isTradeLogin(login_type);
                userInfo = common.getCurUserInfo();
            }
            //普通买入
            window.setTimeout(function () {
                if (type == "buy") {
                    judgeLogin(0);
                    //华金不需要跳转盘后，因为行情没有买入卖出的按钮，只有去交易下单的按钮
                    // if(chaIsKCB == "K" && chaHQTradeStatus == "I"){
                    // 	$.pageInit('account/index',"kcb/stock/kcbPHStockBuy",param);
                    // }else{
                    $.pageInit('account/index', "stock/stockBuy", param);
                    // }
                }//普通卖出
                else if (type == "sell") {
                    judgeLogin(0);
                    // if(chaIsKCB == "K" && chaHQTradeStatus == "I"){
                    // 	$.pageInit('account/index',"kcb/stock/kcbPHStockSell",param);
                    // }else{
                    $.pageInit('account/index', "stock/stockSell", param);
                    // }
                }//普通持仓
                else if (type == "position") {
                    judgeLogin(0);
                    $.pageInit('account/index', "stock/stockHolding");
                }//撤单
                else if (type == "cancel") {
                    judgeLogin(0);
                    $.pageInit('account/index', "stock/stockCancel", param);
                } else if (type == "QueryToday") {//当日委托、当日成交
                    judgeLogin(0);
                    $.pageInit('account/index', "stock/stockQueryToday", param);
                }
                //港股通
                else if (type == "ggtHolding") {
                    judgeLogin(0);
                    if (isTradeLogin) {
                        //检查港股权限
                        if (!common.checkGgtPermission(userInfo.fund_account)) {
                            $.pageInit("account/index", 'ggt/noRight');
                        } else {
                            $.pageInit('account/index', "ggt/ggtHolding", param);
                        }
                    } else {
                        $.pageInit('account/index', "ggt/ggtHolding", param);
                    }
                }//港股买入
                else if (type == "ggtBuy") {
                    judgeLogin(0);
                    if (isTradeLogin) {
                        //检查港股权限
                        if (!common.checkGgtPermission(userInfo.fund_account)) {
                            $.pageInit("account/index", 'ggt/noRight');
                        } else {
                            $.pageInit('account/index', "ggt/ggtBuy", param);
                        }
                    } else {
                        $.pageInit('account/index', "ggt/ggtBuy", param);
                    }
                }//港股卖出
                else if (type == "ggtSell") {
                    judgeLogin(0);
                    if (isTradeLogin) {
                        //检查港股权限
                        if (!common.checkGgtPermission(userInfo.fund_account)) {
                            $.pageInit("account/index", 'ggt/noRight');
                        } else {
                            $.pageInit('account/index', "ggt/ggtSell", param);
                        }
                    } else {
                        $.pageInit('account/index', "ggt/ggtSell", param);
                    }
                }//港股撤单
                else if (type == "ggtCancel") {
                    judgeLogin(0);
                    if (isTradeLogin) {
                        //检查港股权限
                        if (!common.checkGgtPermission(userInfo.fund_account)) {
                            $.pageInit("account/index", 'ggt/noRight');
                        } else {
                            $.pageInit('account/index', "ggt/ggtCancel", param);
                        }
                    } else {
                        $.pageInit('account/index', "ggt/ggtCancel", param);
                    }
                } else if (type == "transferBuy") {//限价买入  thirdXJBuy
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/limitPriceBuy", param);
                    }, param, "third/order/limitPriceBuy")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/limitPriceBuy",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/limitPriceBuy",param);
                    // }
                } else if (type == "transferSell") {//限价卖出  thirdXJSell
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/limitPriceSell", param);
                    }, param, "third/order/limitPriceSell")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/limitPriceSell",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/limitPriceSell",param);
                    // }
                } else if (type == "thirdDJBuy") {//定价买入
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/makePriceBuy", param);
                    }, param, "third/order/makePriceBuy")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/makePriceBuy",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/makePriceBuy",param);
                    // }
                } else if (type == "thirdDJSell") {//定价卖出
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/makePriceSell", param);
                    }, param, "third/order/makePriceSell")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/makePriceSell",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/makePriceSell",param);
                    // }
                } else if (type == "thirdCJQRBuy") {//成交确认买入
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/tradeConfirmBuy", param);
                    }, param, "third/order/tradeConfirmBuy")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/tradeConfirmBuy",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/tradeConfirmBuy",param);
                    // }
                } else if (type == "thirdCJQRSell") {//成交确认卖出
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/tradeConfirmSell", param);
                    }, param, "third/order/tradeConfirmSell")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/tradeConfirmSell",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/tradeConfirmSell",param);
                    // }
                } else if (type == "thirdHBCJBuy") {//互报成交确认买入
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/eachBuy", param);
                    }, param, "third/order/eachBuy")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/eachBuy",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/eachBuy",param);
                    // }
                } else if (type == "thirdHBCJSell") {//互报成交确认卖出
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/eachSell", param);
                    }, param, "third/order/eachSell")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/eachSell",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/eachSell",param);
                    // }
                } else if (type == "thirdCancel") {//撤单
                    judgeLogin(0);
                    ThreeBoardQx(function () {
                        $.pageInit('account/index', "third/order/cancel", param);
                    }, param, "third/order/cancel")
                    // if(isTradeLogin){
                    // 	//检查港股权限
                    // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                    // 		$.pageInit('account/index','account/index');
                    // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                    // 	}else {
                    // 		$.pageInit('account/index',"third/order/cancel",param);
                    // 	}
                    // }else{
                    // $.pageInit('account/index',"third/order/cancel",param);
                    // }
                } else if (type == "shares") {//新股申购
                    var currentMainAccount = sessionStorage.getItem("currentMainAccount") || "0";
                    judgeLogin(currentMainAccount);
                    param.param.switchUserInfo = currentMainAccount;
                    $.setSStorageInfo("stockFlag", "", true);
                    $.setSStorageInfo("bjsFlag", "", true);
                    $.pageInit('account/index', "nsb/index", param);
                } else if (type == "transfer") {//银证转账
                    var currentMainAccount = sessionStorage.getItem("currentMainAccount") || "0";
                    judgeLogin(currentMainAccount);
                    param.param.switchUserInfo = currentMainAccount;
                    $.pageInit('account/index', "banking/transfer", param);
                } else if(type == "transferNew") {
                    var currentMainAccount = sessionStorage.getItem("currentMainAccount") || "0";
                    judgeLogin(currentMainAccount);
                    param.param.switchUserInfo = currentMainAccount;
                    $.pageInit('account/index', "banking/transferNew", param);
                } else if (type == "outside") {//场外基金
                    judgeLogin(0);
                    $.pageInit('account/index', "fund/outside/position", param);
                } else if (type == "inside") {//场内基金
                    judgeLogin(0);
                    $.pageInit('account/index', "fund/inside/index", param);
                } else if (type == "rzbuy") {//融资买入
                    judgeLogin(1);
                    $.pageInit('account/index', "credit/order/financingToBuy", param);
                } else if (type == "dbbuy") {//担保买入
                    judgeLogin(1);
                    $.pageInit('account/index', "credit/order/ordinaryToBuy", param);
                } else if (type == "dbsell") {//担保卖出
                    judgeLogin(1);
                    $.pageInit('account/index', "credit/order/ordinaryToSell", param);
                } else if (type == "quansell") {//卖券还款
                    judgeLogin(1);
                    $.pageInit('account/index', "credit/order/sellTicketsRepayment", param);
                } else if (type == "creditCancel") {//两融撤单
                    judgeLogin(1);
                    $.pageInit('account/index', "credit/order/tradeCancellation", param);
                } else if (type == "optionHomePage") {//期权下单
                    judgeLogin(2);
                    $.pageInit('account/index', "option/order/homePage", param);
                } else if (type == "optionCancellation") {//期权撤单
                    judgeLogin(2);
                    $.pageInit('account/index', "option/order/cancellation", param);
                } else if (type == "optionHoldingsQuery") {//期权持仓
                    judgeLogin(2);
                    $.pageInit('account/index', "option/position/holdingsQuery", param);
                } else if (type == "homePage") {//期权买入卖出（之前就有，没删除，容错处理）
                    judgeLogin(2);
                    $.pageInit('account/index', "option/order/homePage", param);
                } else if (type == "gemStockBuy" || type == "lrGemStockBuy") {//创业板盘后买入
                    judgeLogin(type == "gemStockBuy" ? 0 : 1);
                    $.pageInit('account/index', "gemAfter/gemStockBuy", param);
                } else if (type == "gemStockSell" || type == "lrGemStockSell") {//创业板盘后卖出
                    judgeLogin(type == "gemStockSell" ? 0 : 1);
                    $.pageInit('account/index', "gemAfter/gemStockSell", param);
                } else if (type == "topage") {
                    if (param.topage.indexOf("credit/") == 0) {
                        judgeLogin(1);
                    } else if (param.topage.indexOf("option/") == 0) {
                        judgeLogin(2);
                    } else {
                        //新股申购、银证转账
                        if (param.topage.indexOf("nsb/index") == 0 || ['banking/transfer','banking/transferNew'].indexOf(param.topage) > -1) {
                            var currentMainAccount = sessionStorage.getItem("currentMainAccount") || "0";
                            judgeLogin(currentMainAccount);
                            param.param.switchUserInfo = currentMainAccount;
                        } else {
                            judgeLogin(0);
                        }
                    }
                    if (param.topage.indexOf("ggt/") == 0) {
                        if (isTradeLogin) {
                            //检查港股权限
                            if (!common.checkGgtPermission(userInfo.fund_account)) {
                                $.pageInit("account/index", 'ggt/noRight');
                            } else {
                                $.pageInit('account/index', param.topage, param);
                            }
                        } else {
                            $.pageInit('account/index', param.topage, param);
                        }
                    } else if (param.topage.indexOf("third/") == 0) {//撤单
                        if (isTradeLogin) {
                            ThreeBoardQx(function () {
                                $.pageInit('account/index', param.topage, param);
                            }, param, param.topage)
                        } else {
                            $.pageInit('account/index', param.topage, param);
                        }
                        // if(isTradeLogin){
                        // 	//检查港股权限
                        // 	if(!common.checkThirdPermission(userInfo.fund_account)){
                        // 		$.pageInit('account/index','account/index');
                        // 		$.alert("您没有开通股转转让账户，无法进行股转委托，如需股转交易请开通股转账户权限。");
                        // 	}else {
                        // 		$.pageInit('account/index',param.topage,param);
                        // 	}
                        // }else{
                        // 	$.pageInit('account/index',param.topage,param);
                        // }
                    }
                    //普通科创板
                    else if (global.account_kcbJurisdiction && param.topage.indexOf("kcb/stock/") == 0) {
                        judgeLogin(0);
                        if (isTradeLogin) {
                            require.async("commonFunc", function (commonFunction) {
                                commonFunction.kcbJurisdiction(0, userInfo, function (_rights) {
                                    if (_rights != "0") {//科创板权限（1无权限，0有权限）
                                        param.topage = "kcb/kcbDistrict";
                                    }
                                    $.pageInit('account/index', param.topage, param);
                                });
                            });
                        } else {
                            $.pageInit('account/index', param.topage, param);
                        }
                    }
                    //两融科创板
                    else if (global.account_kcbJurisdiction && param.topage.indexOf("credit/kcb/") == 0) {
                        judgeLogin(1);
                        if (isTradeLogin) {
                            require.async("commonFunc", function (commonFunction) {
                                commonFunction.kcbJurisdiction(1, userInfo, function (_rights) {
                                    if (_rights != "0") {//科创板权限（1无权限，0有权限）
                                        param.topage = "kcb/kcbDistrict";
                                    }
                                    $.pageInit('account/index', param.topage, param);
                                });
                            });
                        } else {
                            $.pageInit('account/index', param.topage, param);
                        }
                    } else {
                        $.pageInit('account/index', param.topage, param);
                    }
                } else if (type == "login") {//交易登录
                    try {
                        var topage = paramMap.toPage;
                        if (topage && typeof (topage) == "string" && topage == "account/addIndex") {
                            topage = "account/index";
                        } else if (topage && typeof (topage) == "string") {
                            topage = JSON.parse(topage);
                        }
                        $.pageInit('account/index', "account/login", topage);
                    } catch (e) {
                        $.pageInit('account/index', "account/login", topage);
                    }
                }
            }, 50);
        } catch (e) {
            console.log("H5获取股票买卖传入数据解析JSON出错" + e.message);
        }
    }

    /**
     * 三板权限判断
     * @param successFun 有权限时的回调
     */
    function ThreeBoardQx(successFun, paramList, topage) {
        if (common.isTradeLogin(0)) {
            require.async("commonFunc", function (commonFunction) {
                var _jurisdiction = commonFunction.getJurisdiction();
                //本地没有缓存权限，则同步查询一次
                if (!_jurisdiction.IsQuerySuccess) {
                    commonFunction.setJurisdiction(null, function (data) {
                        if (data.IsQuerySuccess != false && data.three_board_rights != "1") {//有返回、无权限
                            $.pageInit("account/index", "third/thirdJurisdiction");
                        } else {
                            successFun();
                        }
                    })
                }
                //无权限
                else if (_jurisdiction.three_board_rights != "1") {
                    $.pageInit("account/index", "third/thirdJurisdiction");
                } else {
                    successFun();
                }
            });
        } else {//三板未登录的情况
            var paramMap = {};
            if (paramList) {
                paramMap.param = paramList || {};
            }
            if (paramMap.param) {
                paramMap.topage = topage;
                paramMap.param.switchUserInfo = "0";
            }
            commonFunc.login("", "", {}, paramMap, function () {
                $.pageInit('account/index', 'account/index', {"_loginClass": "0"});
            });
        }
    }

    /**
     * 原生跳转H5模块
     * @param paramMap json格式参数
     */
    oMyMsgFunction.function60251 = function (paramMap) {
//		console.log("function60251");
        try {
            var funcModules = {
                "0": "newshare/apply",
                "1": "credit/asset/asset",
                "2": "ggt/ggtBuy",
                "3": "fund/fundApply",
                "4": "otc/otcProducts",
                "5": "",
                "6": "banking/transfer",
                "7": "banking/collection",
                "8": "account/changePassword",
                "9": ""
            };
            var funcModule = paramMap.funcModule;//功能模块
            var userInfo = paramMap.userInfo;//用户信息
            var loginType = paramMap.loginType;//账户类别
            var topage = funcModules[funcModule];
            require.async("common", function (module) {
                module.setCurUserInfo(userInfo, loginType);
                if (loginType == "0") {//查询股转股东账号
                    require.async("commonFunc", function (commonFunc) {
                        commonFunc.setNewStockAccount(userInfo);
                    });
                }
                if (topage == "account/index") {
                    $.pageRefresh();
                } else {
                    $.pageInit('account/index', topage, {});
                }
                var tradeURL = $.callMessage({"moduleName": "trade", "serverName": "URL_TRADE", "funcNo": "50112"});
                if (tradeURL && (tradeURL.error_no == 0) && tradeURL.results[0].url) {
                    var result = tradeURL.results[0].url;
                    if (result.indexOf("/servlet/") != -1) {
                        result = result.substring(0, result.indexOf("/servlet/"));
                    }
                    global.serverPathTrade = result + "/servlet/json";//交易地址
                    global.serverPath = result + "/servlet/json";//统一登录
                    global.validateimg = result + "/servlet/NewImage";//验证码
//					global.HqUrl = result+"/servlet/MarketAction";//行情
                }
            });
        } catch (e) {
            console.log("原生跳转H5模块传入数据解析JSON出错" + e.message);
        }
    }

    /**
     *原生登录完成时回调通知h5
     */
    oMyMsgFunction.function60200 = function (param) {

    }

    /**
     *模块切换初始化
     * 点击点不导航栏切换模块
     */
    oMyMsgFunction.function50113 = function (param) {
//   	console.log("function50113");
            try {
                var pageCode = $.getCurrentPageObj().pageCode || '';
                commonFunc.isTradeSZYHQ();
                if (pageCode == "account/index" || $.getCurrentPageObj().url.indexOf("account/index") >= 0) {
                    // 如果当前页面处于前台，执行导航栏逻辑，否则不执行
                    if (common.isTradeTabbar()) {
                        $.callMessage({"moduleName": "trade", "funcNo": "50108", "flag": "1"});
                    }
                    require.async("common", function (module) {
                        module.changeTips();
                    });
                    //切换到交易首页自动重置滚动条
                    require.async("tradeIndex", function (module) {
                        module.initVIScroll && module.initVIScroll();
                        module.noLoginData && module.noLoginData();
                    });
                }else{
                    // 如果当前页面处于前台，执行导航栏逻辑，否则不执行
                    if (common.isTradeTabbar()) {
                        $.callMessage({"moduleName": "trade", "funcNo": "50108", "flag": "0"});
                    }
                }
                getNativeLoginStatus();
                //登录的状态才刷新页面，否则在其他模块超时后，点击确定立马返回到交易页面时，会出现发了退出消息，又立即发了50113刷新页面，出现分支机构不能为空的错误
                var _isLoginIn = $.getSStorageInfo("_isLoginIn");//是否登录的标志
                if (_isLoginIn && _isLoginIn != "false") {
                    //跳转行情返回不做刷新处理
                    if ($.getSStorageInfo("go_hq_" + pageCode)) {
                        $.clearSStorage("go_hq_" + pageCode);
                        require.async($.getCurrentPageObj().scriptUrl, function (module) {
                            module && module.goHqCallback && module.goHqCallback();
                        });
                    } else {
                        $.pageRefresh();    //点击底部导航栏切换到交易刷新页面
                    }
                }
            } catch (e) {
                console.log("原生跳转H5模块传入数据解析JSON出错" + e.message);
            }
    }
    // 判断用户登陆状态是否与原生一直，不一致，按原生调用99909或者904
    function getNativeLoginStatus(){
        try {
            var _isLoginIn = $.getSStorageInfo("_isLoginIn");//是否登录的标志
            var data = $.callMessage({"moduleName": "trade", "funcNo": "80039"}).results[0] || {};
            var stockCustCode = (data.Stock && data.Stock.cust_code) || "";
            var StockOptionCustCode = (data.StockOption && data.StockOption.cust_code) || "";
            var StockRZRQCustCode = (data.StockRZRQ && data.StockRZRQ.cust_code) || "";
            if(_isLoginIn.indexOf("_stock") != -1 && !stockCustCode){ // 普通账号 登录 但是原生未登录
                common.clearUserInfo();
            }else if(_isLoginIn.indexOf("_credit") != -1 && !StockRZRQCustCode){ // 信用账号 登录 但是原生未登录
                common.clearUserInfo();
            }else if(_isLoginIn.indexOf("_option") != -1 && !StockOptionCustCode){ // 期权账号 登录 但是原生未登录
                common.clearUserInfo();
            }else if(_isLoginIn.indexOf("_stock") == -1 && stockCustCode){ // 普通账号 未登录 但是原生登录
                oMyMsgFunction.function99909(data);
            }else if(_isLoginIn.indexOf("_credit") == -1 && StockRZRQCustCode){ // 信用账号 未登录 但是原生登录
                oMyMsgFunction.function99909(data);
            }else if(_isLoginIn.indexOf("_option") == -1 && StockOptionCustCode){ // 期权账号 未登录 但是原生登录
                oMyMsgFunction.function99909(data);
            }
        } catch (error) {
            console.log('getNativeLoginStatus ' + error);
        }
    }
    /**
     *激活成功/失败(原生手机号退出统一发这个)
     */
    oMyMsgFunction.function60201 = function (param) {
//   	console.log("60201");
        try {
            if (param.flag == 1) {
                require.async("common", function (module) {
                    module.clearUserInfo(null, null, true);
                    var pageCode = $.getCurrentPageObj().pageCode || '';
                    if (pageCode != "account/index") {
                        $.pageInit(pageCode, "account/index", {"history": true}, "left", true);
                    }
                });
            }
//	     	else if(param.flag == 0){
//	     		require.async("tradeSso",function(module){
//	              	module.function600002(param);
//	           	});
//	     	}
        } catch (e) {
            console.log("H5获取股票买卖传入数据解析JSON出错" + e.message);
        }
    }

    /**
     * 原生跳转H5模块
     * @param paramMap json格式参数
     */
    oMyMsgFunction.function50107 = function (param) {
//		var _pageId = $.getCurrentPageObj().pageId;
//		var click = gconfig.triggerEventName || "mousedown";
//		if($.device.android){
//			$("#"+_pageId+" .top_title .icon_back").triggerHandler("click");
//		}
//		else{
//			$("#"+_pageId+" .top_title .icon_back").triggerFastClick();
//		}
        var _pageId = $.getCurrentPageObj().pageId;
        var click = gconfig.triggerEventName || "mousedown";
//		var pageLevel=$.getCurPageDom().attr("data-pageLevel");
        var pageCode = $.getCurrentPageObj().pageCode || '';
        if ($.device.android) {
            if ($(".modal-overlay")) {
                $(".modal-overlay").triggerFastClick();
            }
            if (pageCode == "account/index") {
//				console.info("触发提示是否退出app");
                _exitApp();
            } else {
                $("#" + _pageId + " .top_title .icon_back").triggerHandler("click");
                $("#" + _pageId + " .top_title .icon_back").triggerHandler("tap");
                $("#" + _pageId + " header .header_inner .back_btn").triggerHandler("click");
                $("#" + _pageId + " header .header_inner .back_btn").triggerHandler("tap");
//			    console.info("自动触发H5页面的返回键事件成功");
            }
        } else {
            $("#" + _pageId + " .top_title .icon_back").triggerFastClick();
            $("#" + _pageId + " .top_title .icon_back").triggerFastTap();
            $("#" + _pageId + " header .header_inner .back_btn").triggerFastClick();
            $("#" + _pageId + " header .header_inner .back_btn").triggerFastTap();
        }
    }

    /**
     * 退出应用程序
     */
    function _exitApp() {
        // 短时间第二次点击返回键，则确认退出app
        if (new Date().getTime() - backBtnMarkTime < 2000) {
            backBtnMarkTime = 0;
            $.callMessage({"moduleName": "sso", "funcNo": "50105"});
        } else {
            $.hidePreloader();
//			console.log("关闭弹框");
            // 相隔时间大于2秒，则只提示是否退出app
            $.callMessage({"moduleName": "sso", "funcNo": "50106", "content": "再按一次退出应用程序"});// 提示是否退出app
            backBtnMarkTime = new Date().getTime();
        }
    }

    /**
     *统一退出回调（原生手机号退出会发这个）
     */
    oMyMsgFunction.function60401 = function (param) {

    }

    /**
     *统一登入时第二次回调h5（token失效后发送的）
     */
    oMyMsgFunction.function60405 = function (param) {

    }


    /**
     *  系统退出
     */
    oMyMsgFunction.function60403 = function (param) {

    }

    /**
     *  滑动触碰到头部和底部会发
     */
    oMyMsgFunction.function60781 = function (param) {
//   	var pageCode = $.getCurrentPageObj().pageCode || '';
//		if(pageCode == "account/index") {
//	     	if(window.touchBottomEvent){
//	     		window.touchBottomEvent();
//	     	}
//		}
    }

    /**
     *  查询持仓的成本价
     */
    oMyMsgFunction.function80514 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.getPosition(paramMap, callback);
        });
    }
    //   账户总览查询

    oMyMsgFunction.function80515 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.getAccountOverview(paramMap, callback);
        });
    }

    //股基总览查询

    oMyMsgFunction.function80516 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.getStockOverview(paramMap, callback);
        });
    }

    //理财总览查询

    oMyMsgFunction.function80517 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.getFinancialOverview(paramMap, callback);
        });
    }
    //普通资金账户查询

    oMyMsgFunction.function80518 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.getCapitalAccount(paramMap, callback);
        });
    }
    //两融资金账户查询

    oMyMsgFunction.function80519 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.queryCapital(paramMap, callback);
        });
    }

    //两融持仓查询

    oMyMsgFunction.function80520 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.queryPosition(paramMap, callback);
        });
    }

    //期权账户信息查询

    oMyMsgFunction.function80521 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.queryOptionAccount(paramMap, callback);
        });
    }

    //普通交易成交查询（行情需要展示到k线图）

    oMyMsgFunction.function80522 = function (paramMap, callback) {
        require.async("trade/scripts/common/commonPosition.js", function (module) {
            module.stockQueryDeal(paramMap, callback);
        });
    }

    //app重新进入前台时，进入前台重新唤醒APP的

    oMyMsgFunction.function40000 = function (paramMap, callback) {
        window.clearTimeout(window.backgroudReloadTastk);
        window.clearTimeout(window.backgroudTastk);
        if (window.isEnterBackground) {
            window.isEnterBackground = false;
            window.backgroudReloadTastk = null;
            window.backgroudTastk = null;
        } else {
            window.isEnterBackground = false;
        }
    }
    //app进去后台时，进入后台息屏的

    oMyMsgFunction.function40001 = function (paramMap, callback) {
        window.backgroudReloadTastk = window.setTimeout(function () {
            window.location.reload();
            window.backgroudTastk = window.setTimeout(function () {
                window.isEnterBackground = true;
            }, 10000);
        }, 60000);//一分钟刷新一次
    }

    //交易可见
    oMyMsgFunction.function40002 = function (paramMap, callback) {

    }

    //交易不可见
    oMyMsgFunction.function40003 = function (paramMap, callback) {
        $.clearRequest();
    }

    /**
     *原生登入输入时回调通知h5
     */
    oMyMsgFunction.function99909 = function (param) {
//   	console.log("function909");
        $.setSStorageInfo("_lastDoTime", new Date().getTime());
        $.showPreloaders("请等待...");
        var loginaccount = param && param.account;
        var _param = param && param.param;
        // 如果是安卓
        if(gconfig.platform === '1'){
            loginaccount = param && param.param && param.param.account;
            _param = param && param.param && param.param.param;
        }
        try {
            require.async("common", function (module) {
                module.changeTips();
            });
            if (param && global.isSso) {
                require.async("tradeSsoLogin", function (tradeSsoModule) {
                    tradeSsoModule.function909(param);
                });
            }
            require.async("tradeIndex", function (module) {
                module.getAccountCache && module.getAccountCache(loginaccount,_param);
            });
        } catch (e) {
            console.log("原生跳转H5模块传入数据解析JSON出错" + e.message);
        }
    }

    /**
     *原生登入输入时回调通知h5
     */
    oMyMsgFunction.function99903 = function (param) {
//   	console.log("function903");

    }

    /**
     *手机号  激活/登录  成功
     */
    oMyMsgFunction.function99902 = function (param) {
//   	console.log("function902");
        var _pageId = $.getCurrentPageObj().pageId;
        $("#" + _pageId + " .stock .n_not_login .n_box_con h3").html("您尚未登录普通账号");
        $("#" + _pageId + " .stock .n_not_login .n_box_con .n_btn_box").html("立即登录");
        $("#" + _pageId + " .credit .n_not_login .n_box_con h3").html("您尚未登录信用账号");
        $("#" + _pageId + " .credit .n_not_login .n_box_con .n_btn_box").html("立即登录");
        $("#" + _pageId + " .option .n_not_login .n_box_con h3").html("您尚未登录期权账号");
        $("#" + _pageId + " .option .n_not_login .n_box_con .n_btn_box").html("立即登录");
        $.pageRefresh();
    }
    /**
     *退出手机号登录（包含资金账号退出）
     */
    oMyMsgFunction.function99905 = function (param) {
//   	console.log("function905");
        require.async("common", function (module) {
            module.clearUserInfo(null, null, true);
        });
        // 原生强制退出时，清除交易首页弹框内容
        $("#newTradingTipsBox2").remove();
    }

    /**
     *PDF文件查看结果回调
     */
    oMyMsgFunction.function50241 = function (paramMap) {
        paramMap = paramMap || {};
        var selPDFCallback = window.selPDFCallback; // 选择日期的回调函数
        if (selPDFCallback) {
            selPDFCallback(paramMap);
        }
    }
    /**
     * 返回当前webview 触发
     */
    oMyMsgFunction.function50243 = function () {
        common.subscribeEmit("50243");
    }
    /**
     *模块切换初始化
     * 点击点不导航栏切换模块
     */
    oMyMsgFunction.function5011521 = function () {
        require.async($.getCurrentPageObj().scriptUrl, function (module) {
            module && module.takeScreenshot && module.takeScreenshot();
        });
    }

    /**
     * 返回交易首页
     */
    oMyMsgFunction.function50242 = function () {
      console.log('执行 msgFunction-function50242 方法，返回交易首页');
      var page = $.getCurrentPageObj();
      $.pageInit(page.pageCode,"account/index",{});
    }
    module.exports = oMyMsgFunction;
});
